/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


/* added this to do a test
 *
 * */

/*
 * Accommodate old non-Ansi compilers.
 */
#if defined(TRADITIONAL)
#define DECLARE_OBJ_FUN( fun )		void fun( )
#define DECLARE_ROOM_FUN( fun )		void fun( )
#define const
#define args( list )			( )
#define DECLARE_DO_FUN( fun )		void fun( )
#define DECLARE_SPEC_FUN( fun )		bool fun( )
#define DECLARE_SPELL_FUN( fun )	void fun( )
#else
#define args( list )			    list
#define DECLARE_DO_FUN( fun )		DO_FUN    fun
#define DECLARE_SPEC_FUN( fun )		SPEC_FUN  fun
#define DECLARE_SPELL_FUN( fun )	SPELL_FUN fun
#define DECLARE_OBJ_FUN( fun )		OBJ_FUN	  fun
#define DECLARE_ROOM_FUN( fun )		ROOM_FUN  fun
#endif

/* system calls */
int unlink();
int system();

#if	!defined(FALSE)
#define FALSE	 0
#endif

#if	!defined(TRUE)
#define TRUE	 1
#endif

#if	defined(_AIX)
#if	!defined(const)
#define const
#endif
typedef int				    sh_int;
typedef int				    bool;
#define unix
#else
typedef short   int			sh_int;
typedef unsigned char		bool;
#endif

/* Staff Functions
void fwrite_staff( CHAR_DATA *ch );
void fread_staff( CHAR_DATA *ch );*/

#include "list.h"
#include "stack.h"


extern  STACK       *   desc_free;       /* the socket free list               */
extern  LIST        *   desc_list;       /* the linked list of active sockets  */
extern  STACK       *   ch_free;     /* the mobile free list               */
extern  LIST        *   ch_list;     /* the mobile list of active mobiles  */

/*
 * Structure types.
 */
typedef struct  l_board             LEADER_BOARD;
typedef struct	affect_data		    AFFECT_DATA;
typedef struct	area_data		    AREA_DATA;
typedef struct	auction_data		AUCTION_DATA;
typedef struct	ban_data		    BAN_DATA;
typedef struct 	buf_type	 	    BUFFER;
typedef struct	char_data		    CHAR_DATA;
typedef struct  bond_data           BOND_DATA;
typedef struct	descriptor_data		DESCRIPTOR_DATA;
typedef struct  event_data          EVENT_DATA;  /* timed events */
typedef struct  events_data         EVENTS_DATA;  /* new timed events */
typedef struct  weave_data	    WEAVE_DATA; /* for delayed casting of multiple weaves */
typedef struct  war_data            WAR_DATA; /* for armies duking it out - Dalsor */
typedef struct  locker_data         LOCKER_DATA; /* locker.c */
typedef struct	exit_data		    EXIT_DATA;
typedef struct	extra_descr_data	EXTRA_DESCR_DATA;
typedef struct	help_data		    HELP_DATA;
typedef struct	help_area_data	    HELP_AREA;
typedef struct	kill_data		    KILL_DATA;
typedef struct	mem_data		    MEM_DATA;
typedef struct	mob_index_data	    MOB_INDEX_DATA;
typedef struct	pnote_data		    PNOTE_DATA;
typedef struct	note_data		    NOTE_DATA;
typedef struct  material_data       MATERIAL_DATA;
typedef struct	obj_data		    OBJ_DATA;
typedef struct	obj_index_data	    OBJ_INDEX_DATA;
typedef struct	pc_data			    PC_DATA;
typedef struct	rebirth_data	    REBIRTH_DATA;
typedef struct  gen_data		    GEN_DATA;
typedef struct	reset_data		    RESET_DATA;
typedef struct	room_index_data	    ROOM_INDEX_DATA;
typedef struct	shop_data		    SHOP_DATA;
typedef struct	time_info_data	    TIME_INFO_DATA;
typedef struct  tornado_data        TORNADO_DATA;
typedef struct	weather_data	    WEATHER_DATA;
/*typedef struct  mprog_list		    MPROG_LIST;*/
typedef struct  invade_vnums		INVADE_VNUMS;
/*typedef struct  mprog_code		    MPROG_CODE;*/
typedef struct  colour_data         COLOUR_DATA;
typedef struct  hate_data		    HATE_DATA;
typedef struct  wiz_data            WIZ_DATA;
typedef struct  grant_data          GRANT_DATA;
typedef struct  prog_list          	PROG_LIST;
typedef struct  prog_code           PROG_CODE;
typedef struct  gquest_data         GQUEST;
typedef struct         battle_data       BATTLE_DATA; /*battle struct*/
typedef struct tag_data TAG_DATA;
typedef struct  tourney_data         TOURNEY_DATA; /* tournies */
typedef struct  trivia_data         TRIVIA_DATA;
typedef struct  faire_data          FAIRE_DATA;
typedef struct  email_data EMAIL_DATA;
typedef struct  fighting_data        FIGHTING_DATA;
typedef struct  gevent_data          GEVENT_DATA;
typedef struct  invade_data          INVADE_DATA;
typedef struct  clan_type               CLAN_DATA;
typedef struct  raffle_data          RAFFLE_DATA;
typedef struct  last_data               LAST_DATA;

/*
 * Function types.
 */
typedef	void DO_FUN	args( ( CHAR_DATA *ch, char *argument ) );
typedef bool SPEC_FUN	args( ( CHAR_DATA *ch ) );
typedef void SPELL_FUN	args( ( int sn, int level, CHAR_DATA *ch, void *vo,
				int target ) );
typedef void OBJ_FUN	args( ( OBJ_DATA *obj, char *argument ) );
typedef void ROOM_FUN	args( ( ROOM_INDEX_DATA *room, char *argument ) );

extern  int mud_port;
extern  int build_port;
extern  int play_port;
extern  int ferry_timer;
extern  int REBIRTH_IN_PROGRESS;
extern  int MENTOR_SESSION;
extern  int OOC_OFF;
extern sh_int SEASON;

#define MAX_LAST_LENGTH            20 /*How long can the last list be?*/

extern          LAST_DATA         *     flast;
extern          LAST_DATA         *     last_list;
extern          LAST_DATA         *     flast_imm;
extern          LAST_DATA         *     last_imm;
extern          unsigned int            last_length;
extern          unsigned int            last_imm_length;

/* all basic defines */
#include "define.h"
/* inc def for notes */
#include "board.h"
/* inc def for telnet prot */
#include "telnet.h"
/* inc def for color codes */
#include "color.h"
/* inc def for skill gsns */
#include "skills.h"
/* inc def for function prototypes */
#include "prototypes.h"
/* include mysql db detail
#include "mysql.h"*/

/*
 * This structure is used for the
 * pathfinding algorithm.
 */
typedef struct heap_data
{
  sh_int             iVertice;
  ROOM_INDEX_DATA ** knude;
  int                size;
} HEAP;

/* Last Messages list */
struct last_data
{
   LAST_DATA *          next;
   char *               msg;    /* Text being stored. */
   sh_int               level;  /* Level of sender.   */
   bool                 hidden; /* Sender invis?      */
   char *               sender; /* Who sent it?       */
};

struct tag_data
{
  int status;
  int timer;
  int next;
  int playing;
  int bteam;
  int rteam;
};

struct gquest_data
{
    int mobs[MAX_GQUEST_MOB];
    char *who;
    int mob_count;
    int timer;
    int involved;
    int qpoints;
    int gold;
    int minlevel;
    int maxlevel;
    int running;
    int next;
};

/* Drunk code structure */
struct struckdrunk
{
	int	min_drunk_level;
	int	number_of_rep;
	char	*replacement[11];
};


/*
 * Site ban structure.
 */

struct	ban_data
{
    BAN_DATA *	next;
    bool	valid;
    sh_int	ban_flags;
    sh_int	level;
    char *	name;
};

struct  wiz_data
{
    WIZ_DATA *	next;
    bool	valid;
    sh_int	level;
    char *	name;
    char *      email;
    char *      job;
};

struct buf_type
{
    BUFFER *    next;
    bool        valid;
    sh_int      state;  /* error state of the buffer */
    int      size;   /* size in k */
    char *      string; /* buffer's string */
};

struct	time_info_data
{
    int		hour;
    int		day;
    int		month;
    int		year;
};

struct	weather_data
{
    int		mmhg;
    int		change;
    int		sky;
    int		sunlight;
};

struct  tornado_data
{
    TORNADO_DATA *next;
    TORNADO_DATA *prev;
    int direction;
    int x;
    int y;
    sh_int damage_per_shake;
    sh_int radius;
    sh_int time_left;
};

struct        fighting_data
{
       CHAR_DATA *fighter;
       FIGHTING_DATA *next;
};


/*
 * Descriptor (channel) structure.
 */
struct	descriptor_data
{
    DESCRIPTOR_DATA *	next;
    DESCRIPTOR_DATA *	snoop_by;
    CHAR_DATA *		    character;
    CHAR_DATA *		    original;
    LIST	*			events;
    bool		        valid;
    #ifdef THREADED_DNS
	char Host[4];
    #else
	char *host;
    #endif
    sh_int		        descriptor;
    sh_int		        connected;
    bool		        fcommand;
    char		        inbuf		[4 * MAX_INPUT_LENGTH];
    char		        incomm		[MAX_INPUT_LENGTH];
    char		        inlast		[MAX_INPUT_LENGTH];
    int			        repeat;
    char *		        outbuf;
    char *              multi_buf;
    int			        outsize;
    int			        outtop;
    char *		        showstr_head;
    char *		        showstr_point;
    void *              pEdit;		/* OLC */
    char **             pString;	/* OLC */
    int			        editor;		/* OLC */
    bool                ansi;
};



/*
 * Attribute bonus structures.
 */
struct	str_app_type
{
    sh_int	tohit;
    sh_int	todam;
    sh_int	carry;
    sh_int	wield;
};

struct	int_app_type
{
    sh_int	learn;
    sh_int  op_focus; /* One Power Focus - Dal */
};

struct	wis_app_type
{
    sh_int	practice;
    sh_int  op_will; /* One Power Will - Dal */
};

struct	dex_app_type
{
    sh_int	defensive;
};

struct	con_app_type
{
    sh_int	hitp;
    sh_int	shock;
    sh_int  op_stam; /* One Power Stamina */
};

struct	ref_app_type
{
    sh_int	lockpicking;
    sh_int	to_hit;
};

struct	ins_app_type
{
    sh_int	initiative;
    sh_int	surprise;
};

struct	cha_app_type
{
    sh_int	persuasion;
};

/*
 * Help table types.
 */
struct	help_data
{
    HELP_DATA *	next;
    HELP_DATA * next_area;
    sh_int	    level;
    char *	    keyword;
    char *      related; /* related keywords, SEE ALSO... */
    char *	    text;
};

struct help_area_data
{
	HELP_AREA *	next;
	HELP_DATA *	first;
	HELP_DATA *	last;
	AREA_DATA *	area;
	char *		filename;
	bool		changed;
};


/*
 * Shop types.
 */
#define MAX_TRADE	 5

struct	shop_data
{
    SHOP_DATA *	next;		 	        /* Next shop in list */
    long	    keeper;			        /* Vnum of shop keeper mob */
    sh_int	    buy_type [MAX_TRADE];	/* Item types shop will buy	*/
    sh_int	    profit_buy;		        /* Cost multiplier for buying */
    sh_int	    profit_sell;		    /* Cost multiplier for selling	*/
    sh_int	    open_hour;		        /* First opening hour */
    sh_int	    close_hour;		        /* First closing hour */
};

struct	class_type
{
    char *	name;			    /* the full name of the class */
    char 	who_name	[4];	/* Three-letter name for 'who'	*/
    sh_int	attr_prime;		    /* Prime attribute */
    sh_int	weapon;			    /* First weapon	*/
    sh_int	guild[MAX_GUILD];	/* Vnum of guild rooms */
    sh_int	skill_adept;		/* Maximum skill level */
    /* THAC0 needs to go */
    sh_int	thac0_00;		    /* Thac0 for level  0 */
    sh_int	thac0_32;		    /* Thac0 for level 32 */
    sh_int	hp_min;			    /* Min hp gained on leveling */
    sh_int	hp_max;			    /* Max hp gained on leveling */
    bool	fMana;			    /* Class gains mana on level */
    char *	base_group;		    /* base skills gained */
    char *	default_group;		/* default skills gained */
};

struct item_type
{
    int		type;
    char *	name;
};

struct weapon_type
{
    char *	name;
    int	vnum;
    sh_int	type;
    sh_int	*gsn;
    sh_int  damtype;
};

struct wiznet_type
{
    char *	name;
    long 	flag;
    int		level;
};

struct attack_type
{
    char *	name;			/* name */
    char *	noun;			/* message */
    int   	damage;			/* damage class */
};

struct race_type
{
    char *	name;			/* call name of the race */
    bool	pc_race;		/* can be chosen by pcs */
    long	act;			/* act bits for the race */
    long	aff;			/* aff bits for the race */
    long	off;			/* off bits for the race */
    long	imm;			/* imm bits for the race */
    long    res;			/* res bits for the race */
    long	vuln;			/* vuln bits for the race */
    long	form;			/* default form flag for the race */
    long	parts;			/* default parts for the race */
    int     remort;         /* num of remorts needed to be chosen, 0 for any */
    char *  descr;
};


struct pc_race_type                 /* additional data for pc races */
{
    char *	name;			        /* MUST be in race_type */
    char 	who_name[12];
    sh_int	points;			        /* cost in points of the race */
    sh_int	class_mult[MAX_CLASS];	/* exp multiplier for class, * 100 */
    char *	skills[5];		        /* bonus skills for the race */
    sh_int 	stats[MAX_STATS];	    /* starting stats */
    sh_int	max_stats[MAX_STATS];	/* maximum stats */
    sh_int	size;			        /* aff bits for the race */
    int     hometown;
    bool   lifer;
};

struct remort_race_sort_struct   /* for sorting races by remorts and name (do_immortal) */
{
    char *name;
    int  remorts;
};


struct spec_type
{
    char * 	name;			    /* special function name */
    SPEC_FUN *	function;		/* the function */
};

struct	pnote_data
{
    PNOTE_DATA *	next;
    bool 	    valid;
    sh_int	    type;
    char *	    sender;
    char *	    date;
    char *	    to_list;
    char *	    subject;
    char *	    text;
    time_t      date_stamp;
};

struct	note_data
{
    NOTE_DATA *	next;
    bool 	    valid;
    sh_int	    type;
    char *	    sender;
    char *	    date;
    char *	    to_list;
    char *	    subject;
    char *	    text;
    time_t      date_stamp;
    time_t      expire;
};


/*
 * An affect.
 */
struct	affect_data
{
    AFFECT_DATA *	next;
    bool		    valid;
    sh_int		    where;
    sh_int		    type;
    sh_int		    level;
    sh_int		    duration;
    sh_int		    location;
    sh_int		    modifier;
    int			    bitvector;
};

/*
 * A kill structure (indexed by level).
 */
struct	kill_data
{
    sh_int		number;
    sh_int		killed;
};

/* timed events from kyndig.com */
struct event_data
{
   int        delay;
   CHAR_DATA    *to;
   int       action;
   DO_FUN   *do_fun;
   char    *args[5];
   void    *argv[5];
   int      argi[5];
   EVENT_DATA *next;
   bool       valid;
};

struct weave_data
{
  WEAVE_DATA	*next;
  sh_int	action[2];
  sh_int	spell_vars[7];
  int		power[6];
  void		* vo;
  char		* target_name;
};

struct war_data
{
  WAR_DATA      *next;
  char          *ch_name;
};

extern EVENT_DATA *events;

struct locker_data
{
	/*LOCKER_DATA *locker;*/
	int   capacity;
	int   holding;
	int   flags;
	int   room;
};

/* grant code */
struct grant_data
{
    GRANT_DATA *        next;
    DO_FUN *            do_fun;
    char *              name;
    int                 duration;
    int                 level;
};

typedef struct guild_rank       rankdata;

struct guild_rank
{
  char *rankname;               /* name of rank                         */
  char *skillname;              /* name of skill earned at this rank    */
};

/* mortal leader rights are as follows;
 ml[0] = can_guild
 ml[1] = can_deguild
 ml[2] = can_promote
 ml[3] = can_demote
*/

struct clan_type
{
  long flags;                   /* flags for guild                      */
  char *name;			/* name of guild                        */
  char *who_name;		/* name sent for "who" command		*/
  char *tag;
  long room[3];                  /* hall/morgue/temple rooms             */
  rankdata rank[MAX_RANK];	/* guilds rank system                   */
  int ml[4];			/* mortal leader rights 		*/
  char *related[MAX_GUILD_RELATIONS]; /* for wearing subguild eq, etc */
  char *chats[MAX_GUILD_RELATIONS]; /* for chatting with subguilds, etc */
  char *lists[MAX_GUILD_RELATIONS]; /* for listing other members/sub-guilds, etc */
  char *gcom; /* special command for channel for guilds with multiple subs, ie towertalk */
  char *gcomooc; /* special command for channel for guilds with multiple subs, ie towertalk */
  char *lefty;
  char *righty;
};

/*
 * Prototype for a mob.
 * This is the in-memory version of #MOBILES.
 */
struct	mob_index_data
{
    MOB_INDEX_DATA *	next;
    SPEC_FUN *		spec_fun;
    SHOP_DATA *		pShop;
    PROG_LIST *        mprogs;
    AREA_DATA *		area;		/* OLC */
    long		vnum;
    sh_int		group;
    bool		new_format;
    sh_int		count;
    sh_int		killed;
    char *		player_name;
    char *		short_descr;
    char *		long_descr;
    char *		description;
    char *      die_mess;
    char *      kill_mess;
    long		act;
    long                act2;
    long		affected_by;
	long        affected2_by;
    sh_int		alignment;
    sh_int		level;
    sh_int		hitroll;
    sh_int		hit[3];
    sh_int		mana[3];
    sh_int		damage[3];
    sh_int		ac[4];
    sh_int 		dam_type;
    long		off_flags;
    long		imm_flags;
    long		res_flags;
    long		vuln_flags;
    sh_int		start_pos;
    sh_int		default_pos;
    sh_int		sex;
    sh_int		race;
    long		wealth;
    long		form;
    long		parts;
    sh_int		size;
    sh_int      timer;
    char *		material;
    long		mprog_flags;
};

/* memory for mobs */
struct mem_data
{
    MEM_DATA 	*next;
    bool	valid;
    int		id;
    int 	reaction;
    time_t 	when;
};


#define PARSE_FORMAT		0
#define PARSE_REPLACE		1
#define PARSE_HELP		2
#define PARSE_DELETE		3
#define PARSE_INSERT		4
#define PARSE_LIST_NORM		5
#define PARSE_SHOW		6
#define PARSE_EDIT		7

struct email_data
{
    EMAIL_DATA *next;
    bool valid;
    char *to;
    char *subject;
    char *body;
};


/*
 * One character (PC or NPC).
 */
struct	char_data
{
    CHAR_DATA *         next;
    CHAR_DATA *         next_in_room;
    CHAR_DATA *         master;
    CHAR_DATA *         leader;
    /*CHAR_DATA *		fighting;*/
    FIGHTING_DATA *     fight_data;
    CHAR_DATA *         reply;
    CHAR_DATA *         pet;
    CHAR_DATA *         mprog_target;
    CHAR_DATA *         challenged;
    MEM_DATA *          memory;
    SPEC_FUN *          spec_fun;
    MOB_INDEX_DATA *	pIndexData;
    DESCRIPTOR_DATA *	desc;
    AFFECT_DATA *       affected;
    PNOTE_DATA *         pnote;
    OBJ_DATA *          carrying;
    OBJ_DATA *          on;
    ROOM_INDEX_DATA *	in_room;
    ROOM_INDEX_DATA *	was_in_room;
    ROOM_INDEX_DATA *	camp_room;
    AREA_DATA *         zone;
    PC_DATA *           pcdata;
    GEN_DATA *          gen_data;
	HATE_DATA *         hate;
    LIST      *			events;
    CHAR_DATA *         questgiver; /* Vassago */
    int                 questpoints;  /* Vassago */
    sh_int              nextquest; /* Vassago */
    sh_int              countdown; /* Vassago */
    sh_int              questobj; /* Vassago */
    sh_int              questmob; /* Vassago */
    sh_int              qtype; /* not Vassago */
    bool                qcomp; /* not Vassago */
    CHAR_DATA *         qmob;
    CHAR_DATA *         questor;
    int                 mdeath;
    int                 mkill;
    int                 pkill;
    int                 battles;
    int                 bwins;
    int                 pdeath;
    /*
    sh_int	       action[2];
    sh_int	       spell_vars[5];
    void	      * vo;
    */
    WEAVE_DATA		*weaves;
    /*int             bounty_timer;*/
    sh_int              camp_timer;
    bool		        valid;
    char *		        name;
    char *              eye;
    char *              hair1;
    char *              hair2;
    char *              hair3;
    char *              hair4;
    char *              misc1;
    char *              misc2;
    long		        id;
    sh_int		        version;
    char *		        short_descr;
    char *		        long_descr;
    char *		        description;
    char *		        prompt;
    char *		        prefix;
    CHAR_DATA *         advancing_on;
    sh_int              range;
    bool                advancing;
    char *              run_buf; /*Jogging*/
    char *              run_head;
    sh_int		        group;
    sh_int		        clan;
    sh_int              rank;   /* clan rank/status */
    sh_int		        sex;
    sh_int		        class;
    sh_int		        race;
    sh_int		        level;
    sh_int		        trust;
    int			        played;
    int			        lines;  /* for the pager */
    time_t		        logon;
    sh_int		        timer;
    sh_int		        wait;
    sh_int		        daze;
/*    sh_int		        hit;
    sh_int		        max_hit;
    sh_int		        mana;
    sh_int		        max_mana;
    sh_int		        move;
    sh_int		        max_move; */
    int			        hit;
    int			        max_hit;
    int			        mana;
    int			        max_mana;
    int			        move;
    int			        max_move;
    long			money[5][2];
    int				number_of_fights;
    int			        exp;
    long		        act;
    long                act2;
    long		        comm;
    long		        wiznet;
    long                talent_flags;
    long		        imm_flags;
    long		        res_flags;
    long		        vuln_flags;
    long                auto_flags;     /* Autolist stuff - Dalsor */
    long                ajah_flags;     /* Aes Sedai Ajah flags - Dalsor */
    long                op_flags;       /* General One Power flags - Dalsor */
    long                custom_flags;   /* Added for Get_BACKG */
    long                stance_flags;          /* Added for blademaster */
    long                off_forms_flags;       /* added for blademaster */
    long                off_sub_forms_flags;   /* added for blademaster */
    long                def_forms_flags;       /* added for blademaster */
    long                def_sub_forms_flags;   /* added for blademaster */
    long                off_sforms_flags;       /* added for blademaster */
    long                off_sub_sforms_flags;   /* added for blademaster */
    long                def_sforms_flags;       /* added for blademaster */
    long                def_sub_sforms_flags;   /* added for blademaster */
    long                spec_flags;     /* Added for Wolfkin, Dreamer, Taveren */
    long                hist_flags;     /* History flags */
    long                tabac_flags;    /* Tabac flags */
    long                war_flags;      /* War flags */
    long                penalty_flags;  /* Penalty flags for bad people */
    sh_int		        invis_level;
    sh_int		        incog_level;
    long		        affected_by;
	long                affected2_by;
    sh_int		        position;
    sh_int		        practice;
    sh_int		        train;
    /* Carrying */
    sh_int		        carry_weight;
    sh_int		        carry_number;
    sh_int		        saving_throw;
    sh_int		        alignment;
    sh_int		        hitroll;
    sh_int		        damroll;
    sh_int		        armor[4];
    long		        wimpy;
    /* stats */
    sh_int		        perm_stat[MAX_STATS];
    sh_int		        mod_stat[MAX_STATS];
    /* parts stuff */
    long		        form;
    long		        parts;
    sh_int		        size;
    char*		        material;
    /* mobile stuff */
    long		        off_flags;
    sh_int		        damage[3];
    sh_int		        dam_type;
    sh_int		        start_pos;
    sh_int		        default_pos;
    CHAR_DATA *         mount;
    bool		        riding;
    sh_int		        mprog_delay;
    char * warring_with;
};



/*
 * Data which only PC's have.
 */
struct	pc_data
{
    PC_DATA *		next;
    BUFFER * 		buffer;
    COLOUR_DATA *	code;		/* Data for coloUr configuration	*/
	TIME_INFO_DATA  birthday;
    int pfile_size;
    bool		valid;
    bool        rebirthing;
    bool        pk_able; /* Added for PKing */
    bool        addict;
    sh_int      addict_hours;
    sh_int      ticket_number; /* gevent raffle -- Dalsor */
    sh_int      happiness; /* gevent Happy Hour -- Dalsor */
    bool        accept_follower;
    CHAR_DATA * accept_follower_name;

	/* Markanth's email system - Dalsor */
    EMAIL_DATA *email_data;
    char * email;
    char * last_tell_to;
    /* end email */

	/* profile data - Dalsor */
	char * ooc_real_name;
	char * ooc_sex;
	char * ooc_age;
	char * ooc_birthplace;
	char * ooc_marital_status;
	char * ooc_residence;
	char * ooc_occupation;
	char * ooc_activities;
	char * ooc_fav_book;
	char * ooc_fav_tv_show;
	char * ooc_fav_actor;
	char * ooc_fav_actress;
	char * ooc_fav_movie;

    /* summary data - Resets on login, evers save in pfile - Dalsor */
    int summary[MAX_SUMMARY + 1]; /* this needs to be 1 more than max summary if max summary is end point of array */

    bool has_vault;
    bool in_vault;
    ROOM_INDEX_DATA *prior_to_vault;

    CHAR_DATA * dance_partner;
    sh_int      dance_points;
    long        dance_last;
    CHAR_DATA * link_leader;
    int         pk_timer; /* Added for PKing */
    int         jail_timer;
    int         warning;
    int         questsrun;
    char *      questinfo_data;
    int         bugsreported;
    int         lastbug;
	long tag_flags;
	int			dfhunt_player_info[7];
    sh_int      concentration;
    sh_int      stat_rolls;
    sh_int	touch_tries;
    int         grasped;
	long        gq_mobs[MAX_GQUEST_MOB];
    GRANT_DATA *        granted;
    ROOM_INDEX_DATA * jail_room;
    char *		pwd;
    char *		bamfin;
    char *		bamfout;
    char *      wkin;  /* Added for WalkIn - Dal */
    char *      wout;  /* Added for WalkOut - Dal */
    char *      rdesc;  /* Added for Roomdesc - Dal */
    char *      afkmsg; /* message sent if afk and a tell is received */
    char *      bonded_to;
    char *      bonded_by;
    char *      aiel_clan;
    char *      spouse;
    char *      proposal;
    char *      last_name;
    char * last_command; /* for rplogging -- Dalsor */
    int      subguild;
    sh_int      eye;
    sh_int      hair;
    sh_int      hair1;
    sh_int      hair2;
    sh_int      hair3;
    sh_int      hair4;
    long         shop_vnum; /* Virtual number of player owned shop */
    long         shopmob_vnum; /* Virtual number of player's shop handler */
    char        explored[4096];
    int         explore_exp[10];
    int         explored_pcnt;
    bool	new_room; /* for prompt */
	sh_int      gamble_type;
    sh_int      gamble_coin;
    sh_int      gamble_sides;
    sh_int      gamble_dice;
    sh_int      deguilded; /* if has been deguilded or not, reset at rebirth */
    long        bounty;
    int         rebirth;
    int         companion_prior;
    int         allowed;
    sh_int      newbie;
    ROOM_INDEX_DATA * virtual_room;
    sh_int      insanity;
    sh_int      burnout;
    bool        can_channel;   /* Added for OP - Dal */
    sh_int      op_air;
    sh_int      op_fire;
    sh_int      op_earth;
    sh_int      op_water;
    sh_int      op_spirit;
    int         char_barrier;
    char *		title;
    int         beard;
  	BOARD_DATA *			board; /* The current board */
  	time_t				last_note[MAX_BOARD]; /* last note for the boards */
 	NOTE_DATA *			in_progress;
    time_t              last_pnote;
    time_t              last_idea;
    time_t              last_penalty;
    time_t              last_news;
    time_t              last_changes;
    time_t              last_roleplay;
    time_t              last_restring;
    time_t              last_event;
    int		perm_hit;
    int		perm_mana;
    int		perm_move;
    sh_int		true_sex;
    int			last_level;
    /*int         int_beacons[MAX_BEACONS];*/ /* max num of beacons by int, up to max_beacons */
    long        beacons[MAX_BEACONS]; /* memorized rooms char's int/10 do_study */ /* needs to be long since these are vnums */
	char       *buddies[MAX_BUDDY];
    sh_int		condition	[4];
    CHAR_DATA * learning_from;
    CHAR_DATA * teaching;
    sh_int      learning_skill;
    sh_int      learnStart;
    sh_int		learned		[MAX_SKILL];
    bool		group_known	[MAX_GROUP];
    sh_int		prompt_skill;		/* for tracking proficiency in a skill in prompt */
    sh_int		points;
    bool              	confirm_delete;
    bool              	confirm_rebirth;
    bool                confirm_life_race;
    char *	    ignore[MAX_IGNORE];
    char *		alias[MAX_ALIAS];
    char * 		alias_sub[MAX_ALIAS];
    int 		security;	/* OLC */ /* Builder security */
    long      home_vnum;
    long      locker_room; /* locker.c */
/*
    char *            rank;
    char *            guild_tag;
*/
    /* Companions */
    sh_int              companion_timer; /* timer for getting new companions */
    MOB_INDEX_DATA *    companion;
     int                       text[3];                /* {t */
     int                       auction[3];             /* {a */
     int                       auction_text[3];        /* {A */
     int                       gossip[3];              /* {d */
     int                       gossip_text[3];         /* {9 */
     int                       music[3];               /* {e */
     int                       music_text[3];          /* {E */
     int                       question[3];            /* {q */
     int                       question_text[3];       /* {Q */
     int                       answer[3];              /* {f */
     int                       answer_text[3];         /* {F */
     int                       quote[3];               /* {h */
     int                       quote_text[3];          /* {H */
     int                       immtalk_text[3];        /* {i */
     int                       immtalk_type[3];        /* {I */
     int                       info[3];                /* {j */
     int                       say[3];                 /* {6 */
     int                       say_text[3];            /* {7 */
     int                       tell[3];                /* {k */
     int                       tell_text[3];           /* {K */
     int                       reply[3];               /* {l */
     int                       reply_text[3];          /* {L */
     int                       gtell_text[3];          /* {n */
     int                       gtell_type[3];          /* {N */
     int                       wiznet[3];              /* {B */
     int                       room_title[3];          /* {s */
     int                       room_text[3];           /* {S */
     int                       room_exits[3];          /* {o */
     int                       room_things[3];         /* {O */
     int                       prompt[3];              /* {p */
     int                       fight_death[3];         /* {1 */
     int                       fight_yhit[3];          /* {2 */
     int                       fight_ohit[3];          /* {3 */
     int                       fight_thit[3];          /* {4 */
     int                       fight_skill[3];         /* {5 */

     /*Temp Stuff for Staff*/
     long last_in;
     long last_gold;
     long last_qp;
     long last_xp;
     long last_items;
     int staff_points;
     int mod_warnings;
     int mod_freezings;
     int mod_disconnects;
     int verifications;
     int rewards_gold;
     int total_gold;
     int rewards_qp;
     int total_qp;
     int rewards_xp;
     int total_xp;
     int rewards_items;
     int total_items;

};

/* Data for generating characters -- only used during generation */
struct gen_data
{
    GEN_DATA	*next;
    bool	valid;
    bool	skill_chosen[MAX_SKILL];
    bool	group_chosen[MAX_GROUP];
    int		points_chosen;
};

struct bond_data
{
	BOND_DATA  *next;
	char *bonded_by;
	char *bonded_to;
};

/*
 * Invasion structure(s)
 */
struct  invade_vnums
{
  char *name;
  long  vnum;
  int  total;
};

struct	liq_type
{
    char *	liq_name;
    char *	liq_color;
    sh_int	liq_affect[5];
};

/*For tailoring -Hortin*/

extern const struct stitch_items_type stitch_items_table[];
extern const struct cloth_colors_type cloth_colors_table[];
extern const struct stitch_patterns_type stitch_patterns_table[];

struct stitch_patterns_type
{
	char *aname;
	char *bname;
	int difficulty;
	int beats;
};

struct cloth_colors_type
{
	int number;
	char *aname;
	char *bname;
	char *cname;
};

struct stitch_items_type
{
	char *name;
	float length;
	int   weight;
	int   difficulty;
	int   beats;
	int   wear_flags;
	int   base_pierce;
	int   base_bash;
	int   base_slash;
	int   base_exotic;
};


/*
 * Extra description data for a room or object.
 */
struct	extra_descr_data
{
    EXTRA_DESCR_DATA *next;	/* Next in list                     */
    bool valid;
    char *keyword;              /* Keyword in look/examine          */
    char *description;          /* What to see                      */
};



/*
 * Prototype for an object.
 */
struct	obj_index_data
{
    OBJ_INDEX_DATA *	next;
    EXTRA_DESCR_DATA *	extra_descr;
    AFFECT_DATA *	affected;
    AREA_DATA *		area;		/* OLC */
	PROG_LIST *		oprogs;
	long		oprog_flags;
    bool		new_format;
    char *		name;
    char *		short_descr;
    char *		description;
    long		vnum;
    sh_int		reset_num;
    char *		material;
    char *		guild;
    sh_int		item_type;
    int			extra_flags;
    int         construct_flags;
    int			wear_flags;
    sh_int		level;
    sh_int 		condition;
    sh_int		count;
    sh_int		weight;
    int			cost;
    int			value[5];
};

/*
 * One object.
 */
struct	obj_data
{
    OBJ_DATA *		next;
    OBJ_DATA *		next_content;
    OBJ_DATA *		contains;
    OBJ_DATA *		in_obj;
    OBJ_DATA *		on;
    CHAR_DATA *		carried_by;
    CHAR_DATA *		oprog_target;
    sh_int		oprog_delay;
    EXTRA_DESCR_DATA *	extra_descr;
    AFFECT_DATA *	affected;
    OBJ_INDEX_DATA *	pIndexData;
    ROOM_INDEX_DATA *	in_room;
    //KEY_DATA *		keys;
    bool		valid;
    bool		enchanted;
    char *	        owner;
    char *		name;
    char *		short_descr;
    char *		description;
    sh_int		item_type;
    int			extra_flags;
    int         construct_flags;
    int			wear_flags;
    sh_int		wear_loc;
    sh_int		weight;
    int			cost;
    sh_int		level;
    sh_int 		condition;
    char *		material;
    char *		guild;
    sh_int		timer;
    /* Dalsor includes for treasure chest traps */
    bool        trapped;
    /* end Dalsor */
    bool		is_stitched;
    bool		is_tailored;
    int			value	[5];
};



/*
 * Exit data.
 */
struct	exit_data
{
    union
    {
	ROOM_INDEX_DATA *	to_room;
	long			vnum;
    } u1;
    sh_int		exit_info;
    long		key;
    char *		keyword;
    char *		description;
    EXIT_DATA * next;       /* OLC */
    int			rs_flags;   /* OLC */
    int			orig_door;  /* OLC */
    bool        color;      /* pathfinding */
};



/*
 * Reset commands:
 *   '*': comment
 *   'M': read a mobile
 *   'O': read an object
 *   'P': put object in object
 *   'G': give object to mobile
 *   'E': equip object to mobile
 *   'D': set state of door
 *   'R': randomize room exits
 *   'S': stop (end of list)
 */

/*
 * Area-reset definition.
 */
struct	reset_data
{
    RESET_DATA *	next;
    char		command;
    long  		arg1;
    sh_int		arg2;
    long  		arg3;
    sh_int		arg4;
};



/*
 * Area definition.
 */
struct	area_data
{
    AREA_DATA *		next;
    HELP_AREA *		helps;
    AREA_DATA * next_sort;
    char *		file_name;
    char *		name;
    char *		credits;
    char *      owner;
    sh_int		age;
    sh_int		nplayer;
    int			low_range;
    int			high_range;
    long 		min_vnum;
    long		max_vnum;
    bool		empty;
    char *		builders;	/* OLC */ /* Listing of */
    int			vnum;		/* OLC */ /* Area vnum  */
    int			area_flags;	/* OLC */
    int			security;	/* OLC */ /* Value 1-9  */
    int         filename;   /* WIZUTIL */
    int         avg_mobiles;
    int         num_mobiles;
    /* weather and atmospheric data
     * mix all this up and make weather in assign_weather in db
     * change it according to the vars in update
     */
    sh_int      temperature;     /* measured in degrees celcius */
    sh_int      wind_direction;  /* direction wind is blowing from */
    sh_int      wind_speed;      /* measured in kph */
    sh_int      cloud_cover;     /* percentage of the sky covered in clouds */
    char *      cloud_type;      /* cumulus, cumulonimbus, stratus, cirrus */
    sh_int      precipitation;   /* measured in inches per 24 hours */
    sh_int      weather_pattern; /* 1 high pressure (more sunny) 2 low pressure (more clouds) */
};



/*
 * Room type.
 */
struct	room_index_data
{
    ROOM_INDEX_DATA *	next;
    CHAR_DATA *		people;
    OBJ_DATA *		contents;
    EXTRA_DESCR_DATA *	extra_descr;
    AREA_DATA *		area;
    EXIT_DATA *		exit	[10];
    RESET_DATA *	reset_first;	/* OLC */
    RESET_DATA *	reset_last;	/* OLC */
    AFFECT_DATA *affected;
    PROG_LIST *		rprogs;
    CHAR_DATA *		rprog_target;
    long		rprog_flags;
    sh_int		rprog_delay;
    long        affected_by;
    char *		name;
    char *		description;
    char *		owner;
    long		vnum;
    int			room_flags;
    sh_int		light;
    sh_int      grade;
    sh_int		sector_type;
    sh_int		heal_rate;
    sh_int 		mana_rate;
    /* RoAClient support
    char *      url;*/
    sh_int		clan;
    sh_int      rec_room;
    char *      msp;
	sh_int      heap_index; /* pathfinding */
	sh_int      steps;      /* pathfinding */
	bool        visited;    /* pathfinding */
    int ore_quantity;	/* mining */
    bool mine;		/* mining */
};

struct weave_talents_type
{
	int talent;
	char *name;
};

/*
 * Skills include spells as a particular case.
 */
struct	skill_type
{
    char       * name;			/* Name of skill		*/
    sh_int	     skill_level[MAX_CLASS];	/* Level needed by class	*/
    sh_int	     rating[MAX_CLASS];	/* How hard it is to learn - trains	*/
    SPELL_FUN  * spell_fun;		/* Spell pointer (for spells)	*/
    sh_int	     target;			/* Legal targets		*/
    sh_int	     minimum_position;	/* Position for caster / user	*/
    sh_int     * pgsn;			/* Pointer to associated gsn	*/
    sh_int	     slot;			/* Slot for #OBJECT loading	*/
    sh_int	     min_mana;		/* Minimum mana used		*/
    sh_int	     beats;			/* Waiting time after use	*/
    char       * noun_damage;		/* Damage message		*/
    char       * msg_off;		/* Wear off message		*/
    char       * msg_obj;		/* Wear off message for obects	*/
    sh_int       sphere;
    sh_int       remort_only;    /* num remorts required */
    sh_int     * guild_num;      /* if 0, all guilds, otherwise number of from tables */
    char       * req_skill;
    SPELL_FUN  * req_weave;
    sh_int       sphere_earth; /* earth, air, fire, water, spirit - min sphere str to use */
    sh_int       sphere_air; /* earth, air, fire, water, spirit - min sphere str to use */
    sh_int       sphere_fire; /* earth, air, fire, water, spirit - min sphere str to use */
    sh_int       sphere_water; /* earth, air, fire, water, spirit - min sphere str to use */
    sh_int       sphere_spirit; /* earth, air, fire, water, spirit - min sphere str to use */
    bool         offensive;
    int          talent; /* affecting talent */
    int          base_dmg;
    char       * descr;
};




/* Splitting weaves off from skills. They will be in their own table similar to skills
 * but with different requirements that make it easier to keep the seperate.
 * 11-21-03 -- Dalsor
 */

struct	weave_type
{
    char       * name;               /* Name of weave */
    sh_int	     trains;             /* How many trains to learn */
    SPELL_FUN  * spell_fun;          /* Spell pointer */
    sh_int	     target;             /* Legal targets */
    sh_int	     minimum_position;   /* Position for caster / user */
    sh_int	     min_mana;           /* Minimum mana used */
    sh_int	     beats;              /* Waiting time before firing */
    char       * noun_damage;        /* Damage message */
    char       * msg_off;            /* Wear off message */
    char       * msg_obj;            /* Wear off message for obects */
    sh_int       sphere;             /* when checking for sphere increase */
    sh_int       remort;             /* remorts required to learn */
    char       * descr;              /* for help weave blah */
};

struct sort_skill_struct
{
	char *name;
	int learned;
	bool weave;
	sh_int remort_only;
	sh_int rating;
    	char * req_skill;
	sh_int can_learn;	/* 0 no {c   1 after skill gets up a bit {y   2 yes {g */

};

struct  group_type
{
    char *	name;
    sh_int	rating[MAX_CLASS];
    char *	spells[MAX_IN_GROUP];
};

struct prog_list
{
    int                 trig_type;
    char *              trig_phrase;
    long              vnum;
    char *              code;
    PROG_LIST *         next;
    bool                valid;
};

struct prog_code
{
    long              vnum;
    char *              code;
    PROG_CODE *         next;
};


/* begin rebirth data */

/* pcdata stuff */
extern  bool              r_rebirthing;
extern  bool              r_has_vault;
extern  bool              r_in_vault;
extern  GRANT_DATA      * r_granted;
extern  char            * r_email;
extern  char            * r_pwd;
extern  char            * r_wkin;
extern  char            * r_wout;
extern  char            * r_rdesc;
extern  char            * r_afkmsg;
extern  char            * r_bonded_to;
extern  char            * r_bonded_by;
extern  char            * r_aiel_clan;
extern  char            * r_spouse;
extern  char            * r_proposal;
extern  char            * r_last_name;
extern  char            * r_title;
extern  char            * r_guild_tag;
extern  char            * r_description;
extern  char            * r_prompt;
extern  char            * r_buddies[MAX_BUDDY];
/*extern  sh_int            r_precision;
extern  sh_int            r_gifted;
extern  sh_int            r_windfall;
extern  sh_int            r_anticipate;
extern  sh_int            r_efficient;
extern  sh_int            r_evaluate;
extern  sh_int            r_bribery;
extern  sh_int            r_angrealstudy;
extern  sh_int            r_feint;
extern  sh_int            r_lunge;
extern  sh_int            r_stagger;
extern  sh_int            r_chop;
extern  sh_int            r_draw;
extern  sh_int            r_focus;
extern  sh_int            r_precision;*/
extern  sh_int			  r_skill[MAX_SKILL];
extern  sh_int            r_prac;
extern  sh_int            r_train;
extern  sh_int            r_subguild;
extern  sh_int            r_eye;
extern  sh_int            r_hair;
extern  sh_int            r_hair1;
extern  sh_int            r_hair2;
extern  sh_int            r_hair3;
extern  sh_int            r_hair4;
extern  sh_int            r_true_sex;
extern  int               r_last_note[MAX_BOARD];
extern  int               r_played;
extern  int               r_lines;
extern  int               r_warning;
extern  int               r_qp;
extern  long              r_shop_vnum;
extern  long              r_shopmob_vnum;
extern  int               r_rebirth;
extern  int               r_allowed;
/* char_data stuff */
extern  int		  r_rank;
extern  sh_int            r_version;
extern  sh_int            r_clan;
extern  sh_int            r_sex;
extern  sh_int            r_race;
extern  time_t            r_logon;
extern  long              r_bounty;
extern  long              r_money[5][2];
extern  long              r_act;
extern  long              r_act2;
extern  long              r_comm;
extern  long              r_vuln_flags;
extern  long              r_auto_flags;
extern  long              r_ajah_flags;
extern  long              r_op_flags;
extern  long              r_spec_flags;
extern  long              r_hist_flags;
extern  long              r_war_flags;
extern  long              r_penalty_flags;
extern	int		  r_dfhunt_games_won;
extern	int		  r_dfhunt_games_lost;
/* end rebirth data */


/*
 * Description macros.
 */
#define PERS(ch, looker)	( can_see( looker, (ch) ) ?		\
				( IS_NPC(ch) ? (ch)->short_descr	\
				: (ch)->name ) : IS_IMMORTAL(ch) ? "Immortal" : "someone" )

typedef struct  key_data		KEY_DATA;

struct key_data
{
    KEY_DATA *		next;
    bool		valid;
    OBJ_INDEX_DATA *	index;
    sh_int		item_type;
};
/*
 * Structure for a social in the socials table.
 */
struct	social_type
{
    char      name[20];
    char *    char_no_arg;
    char *    others_no_arg;
    char *    char_found;
    char *    others_found;
    char *    vict_found;
    char *    char_not_found;
    char *      char_auto;
    char *      others_auto;
};

struct hate_data
{
	char *		name;
	CHAR_DATA *	who;
};

struct auction_data
{
	AUCTION_DATA *next;
	OBJ_DATA *	item;
	CHAR_DATA *	owner;
	CHAR_DATA *	high_bidder;
	sh_int		status;
	long		current_bid;
	long		gold_held;
	long		min_bid;
	bool		valid;
};

LEADER_BOARD leader_board;

struct l_board
{
   char *pk_name;
   int pk_number;
   char *pd_name;
   int pd_number;
   char *tt_name;
   int tt_number;
   char *qc_name;
   int qc_number;
   char *mk_name;
   int mk_number;
   char *md_name;
   int md_number;
   char *bestpk_name;
   int bestpk_number;
   char *rb_name;
   int rb_number;
};

struct   battle_data
  {
  int  level1;
  int   level2;
  bool  open;
  bool running;
  };
struct   tourney_data
{
	int   level1;
	int   level2;
	bool  open;
	bool  running;
	int   timer;
	sh_int status; /* 1 = idle, 2 = waiting, 3 = running */
	char *tclass; /* Beginner, Warrior, Veteran, Champion, Destroyer, Slayer, N'Dore Mordero */
	sh_int lastclass; /* 1 = Beginner, 2 = Warrior, 3 = Veteran, 4 = Champion, 5 = Destroyer, 6 = Slayer, 7 = N'Dore Mordero */
};
struct  trivia_data
{
	bool   running;
	char  *question;
	char  *answer;
	sh_int reward;
	sh_int qnumber;
	sh_int timer;
};
struct  faire_data
{
	bool open;
	char *location;
};
struct raffle_data
{
	bool running;
	OBJ_DATA *obj;
	sh_int ticket_cost;
	sh_int ticket_number;
	sh_int total_tickets;
};
struct  invade_data
{
	bool running;
	char *location;
	char *invader;
};
struct gevent_data
{
	bool running;     /* is the event running? */
	char * name;      /* name of the gevent */
	char * cname;     /* color name of the gevent */
	long loc;          /* vnum location of event set when started */
	sh_int num;       /* number of event for easy identifying */
	sh_int power;     /* 1 2 3 for shadows embrace gevent */
	sh_int timer;     /* how long is/has it been running */
	sh_int runtime;   /* the time it is supposed to run for */
};

void do_trivia args(( CHAR_DATA *ch, char*argument ));
void talk_trivia args(( char*argument ));
void trivia_update args(( void ));

/* tourney voids */
void talk_tourney      args( (char *argument) );
void do_tourney          args( (CHAR_DATA *ch, char * argument ) );
void do_topen          args( (CHAR_DATA *ch, char * argument ) );
void do_tclose          args( (CHAR_DATA *ch, char * argument ) );
void do_tstop          args( (CHAR_DATA *ch, char * argument ) );
void do_tchat          args( (CHAR_DATA *ch, char * argument ) );

/* battle voids */
void talk_battle      args( (char *argument) );
void do_battle          args( (CHAR_DATA *ch, char * argument ) );
void do_bopen          args( (CHAR_DATA *ch, char * argument ) );
void do_bclose          args( (CHAR_DATA *ch, char * argument ) );
void do_bstop          args( (CHAR_DATA *ch, char * argument ) );
void do_bchat          args( (CHAR_DATA *ch, char * argument ) );

int		dfhunt_game_info[7];
char		dfhunt_creator_name[MAX_STRING_LENGTH];

void tag_update args ((void));
void end_tag args ((void));
void start_tag args ((void));
void check_team_frozen args ((CHAR_DATA * ch));
void auto_tag args ((void));
bool is_tagging args ((CHAR_DATA * ch));
void tag_channel args((CHAR_DATA *ch, char *message));

/* email stuff */
bool emailf args ( ( CHAR_DATA * ch ) );
void handle_email_to args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_subject args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_body args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_finish args ( ( DESCRIPTOR_DATA * d, char *argument ) );
bool valid_email args ( ( char *argument ) );
void parse_email_text args ( ( int command, char *string, CHAR_DATA * ch ) );

void free_multibuf args( ( DESCRIPTOR_DATA *d ) );
void     free_runbuf     args( ( CHAR_DATA *d ) ); /*Jogging -Anthony*/

/*
 * Global constants.
 */
extern	const	struct	str_app_type	str_app		[201];
extern	const	struct	int_app_type	int_app		[201];
extern	const	struct	wis_app_type	wis_app		[201];
extern	const	struct	dex_app_type	dex_app		[201];
extern	const	struct	con_app_type	con_app		[201];
extern	const	struct	ref_app_type	ref_app		[201];
extern	const	struct	ins_app_type	ins_app		[201];
extern	const	struct	cha_app_type	cha_app		[201];

extern	const	struct	class_type	class_table	[MAX_CLASS];
extern	const	struct	weapon_type	weapon_table	[];
extern  const   struct  item_type	item_table	[];
extern	const	struct	wiznet_type	wiznet_table	[];
extern	const	struct	attack_type	attack_table	[];
extern  const	struct  race_type	race_table	[];
extern  const	struct  trolloc_face_type	trolloc_face_table	[];
extern  const	struct  hair_color_type	hair_color_table	[];
extern  const	struct  eye_color_type	eye_color_table	[];
extern  const	struct  background_type	background_table	[];
extern	const	struct	pc_race_type	pc_race_table	[];
extern  const	struct	spec_type	spec_table	[];
extern	const	struct	liq_type	liq_table	[];
extern	const	struct	skill_type	skill_table	[MAX_SKILL];
extern  const   struct  weave_type  weave_table[MAX_WEAVES];
extern  const   struct  group_type      group_table	[MAX_GROUP];
extern          struct social_type      social_table	[MAX_SOCIALS];
extern	char *	const			title_table	[MAX_CLASS]
							[MAX_LEVEL+1]
							[2];



/*
 * Global variables.
 */
extern		AUCTION_DATA  * auction_list;

extern		HELP_DATA	  *	help_first;
extern		SHOP_DATA	  *	shop_first;

extern		CHAR_DATA	  *	char_list;
extern		DESCRIPTOR_DATA   *	descriptor_list;
extern		OBJ_DATA	  *	object_list;

extern      PROG_CODE         *     mprog_list;
extern      PROG_CODE         *     rprog_list;
extern      PROG_CODE         *     oprog_list;

extern		char			bug_buf		[];
extern		time_t			current_time;
extern		bool			fLogAll;
extern		bool			fLogAllQuiet;
extern		FILE *			fpReserve;
extern		KILL_DATA		kill_table	[];
extern		char			log_buf		[];
extern		TIME_INFO_DATA	time_info;
extern		WEATHER_DATA	weather_info;
extern      TORNADO_DATA *  first_tornado;
extern      TORNADO_DATA *  last_tornado;
extern		bool			MOBtrigger;
extern      AREA_DATA *     area_first_sorted;
extern      GQUEST          gquest_info;
extern                 BATTLE_DATA *  battle;
extern          NOTE_DATA         *     note_free;
extern          OBJ_DATA          *     obj_free;
extern TAG_DATA tag_game;
extern      TOURNEY_DATA *  tourney;
extern TRIVIA_DATA *trivia;
extern FAIRE_DATA *faire;
extern RAFFLE_DATA *raffle;
extern GEVENT_DATA *gevent;
extern INVADE_DATA *invasion;

#if defined(KEY)
#undef KEY
#endif

#define KEY( literal, field, value )					\
				if ( !str_cmp( word, literal ) )	\
				{					\
				    field  = value;			\
				    fMatch = TRUE;			\
				    break;				\
				}

/* provided to free strings */
#if defined(KEYS)
#undef KEYS
#endif

#define KEYS( literal, field, value )					\
				if ( !str_cmp( word, literal ) )	\
				{					\
				    free_string(field);			\
				    field  = value;			\
				    fMatch = TRUE;			\
				    break;				\
				}

/*
 * OS-dependent declarations.
 * These are all very standard library functions,
 *   but some systems have incomplete or non-ansi header files.
 */
#if	defined(_AIX)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(apollo)
int	atoi		args( ( const char *string ) );
void *	calloc		args( ( unsigned nelem, size_t size ) );
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(hpux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(linux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(macintosh)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(MIPS_OS)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(MSDOS)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(NeXT)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(sequent)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(sun)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
#if	defined(SYSV)
siz_t	fread		args( ( void *ptr, size_t size, size_t n,
			    FILE *stream) );
#elif !defined(__SVR4)
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
#endif
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(ultrix)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif


/*
 * The crypt(3) function is not available on some operating systems.
 * In particular, the U.S. Government prohibits its export from the
 *   United States to foreign countries.
 * Turn on NOCRYPT to keep passwords in plain text.
 */
#if	defined(NOCRYPT)
#define crypt(s1, s2)	(s1)
#endif



/*
 * Data files used by the server.
 *
 * AREA_LIST contains a list of areas to boot.
 * All files are read in completely at bootup.
 * Most output files (bug, idea, typo, shutdown) are append-only.
 *
 * The NULL_FILE is held open so that we have a stream handle in reserve,
 *   so players can go ahead and telnet to all the other descriptors.
 * Then we close it whenever we need to open a file (e.g. a save file).
 */
#if defined(macintosh)
#define PLAYER_DIR	    ""			/* Player files	*/
#define TEMP_FILE	    "romtmp"
#define NULL_FILE	    "proto.are"		/* To reserve one stream */
#endif

#if defined(MSDOS)
#define PLAYER_DIR	    ""			/* Player files */
#define TEMP_FILE	    "romtmp"
#define NULL_FILE	    "nul"			/* To reserve one stream */
#endif

#if defined(unix)
#define PLAYER_DIR      "../player/"        	/* Player files */
#define SHOPS_DIR       "../shops/"
#define GOD_DIR         "../gods/"  		/* list of gods */
#define TEMP_FILE	    "../player/aww_tmp"
#define NULL_FILE	    "/dev/null"		/* To reserve one stream */
#define VAULTS_DIR      "../locker/"
#define GUILD_HTML      "../../pub/guilds/index.html" /* location of guild index.html page */
#endif

#define AREA_LIST       "area.lst"  /* List of areas*/
#define BUG_FILE        "../data/bugs.txt" /* For 'bug' and bug()*/
#define TYPO_FILE       "../data/typos.txt" /* For 'typo'*/
#define PNOTE_FILE      "../data/notes.not"/* For 'notes'*/
#define IDEA_FILE	    "../data/ideas.not"
#define PENALTY_FILE	"../data/penal.not"
#define RESTRING_FILE	"../data/restring.not"
#define EVENT_FILE	    "../data/event.not"
#define ROLEPLAY_FILE   "../data/roleplay.not" /* for roleplay in-game notes -Dalsor */
#define NEWS_FILE	    "../data/news.not"
#define CHANGES_FILE	"../data/chang.not"
#define SHUTDOWN_FILE   "../data/shutdown.txt"/* For 'shutdown'*/
#define BAN_FILE	    "../data/ban.txt"
#define BACKUP_DIR      "../pbackup/"
#define MUSIC_FILE	    "../data/music.txt"
#define HELP_FILE       "../data/help.txt"
#define WIZ_FILE        "../data/wizlist.txt"
#define MAX_WHO_FILE    "../data/maxwho.txt"
#define NSTRING_FILE    "../data/nstring.dat"
#define NEW_BUG_FILE	"../data/newbugs.txt"
#define IMM_FILE	    "../data/immfile.txt"
#define	GQUEST_FILE		"../data/gquest.dat"
#define TIME_FILE       "../data/mudtime.txt"
#define WARN_FILE       "../data/warn.txt"
#define REPORT_FILE     "../data/report.txt"
#define PIT_FILE        "../data/pit.txt"
#define QUIET           "../data/.log"
#define DATA_DIR        "../data/"
/*
 * Our function prototypes.
 * One big lump ... this is every function in Merc.
 */
#define CD	CHAR_DATA
#define MID	MOB_INDEX_DATA
#define OD	OBJ_DATA
#define OID	OBJ_INDEX_DATA
#define RID	ROOM_INDEX_DATA
#define SF	SPEC_FUN
#define AD	AFFECT_DATA
#define PC	PROG_CODE

char *dns_gethostname args((char *s));
char *one_argument_with_caps args(( char *argument, char *arg_first ));

void load_leaderboard   args( ( void ) );
void save_leaderboard   args( ( void ) );
void check_leaderboard  args( ( CHAR_DATA *ch ) );
int  get_ratio          args( ( CHAR_DATA *ch ) );

/* auction.c */
void do_auction      args((CHAR_DATA *ch, char *argument));
void identify_obj    args(( CHAR_DATA *ch, OBJ_DATA *obj ));
int count_auc        args((CHAR_DATA *ch));
void reset_auc       args((AUCTION_DATA *auc));
void auction_channel args(( char * msg ));
void auction_update  args((void));

/* act_comm.c */
#define logf logprintf
void  	check_sex	args( ( CHAR_DATA *ch) );
void	add_follower	args( ( CHAR_DATA *ch, CHAR_DATA *master ) );
void	stop_follower	args( ( CHAR_DATA *ch ) );
void 	nuke_pets	args( ( CHAR_DATA *ch ) );
void	die_follower	args( ( CHAR_DATA *ch ) );
bool	is_same_group	args( ( CHAR_DATA *ach, CHAR_DATA *bch ) );
void 	logprintf 			args((char * fmt, ...));


/* act_enter.c */
RID  *get_random_room   args ( (CHAR_DATA *ch) );

/*gcom.c*/
void	compose_title	args((CHAR_DATA *ch));

/* act_info.c */
void	set_title	args( ( CHAR_DATA *ch, char *title ) );

/* act_misc.c */
/*void do_rebirth args( ( CHAR_DATA *ch, char *argument, int rbi ) );*/

/* act_move.c */
void	move_char	args( ( CHAR_DATA *ch, int door, bool follow ) );
char  *walkdir        args(( char *argument, char *dir ));

/* act_obj.c */
bool can_loot		args( (CHAR_DATA *ch, OBJ_DATA *obj) );
void	wear_obj	args( (CHAR_DATA *ch, OBJ_DATA *obj, bool fReplace) );
void    get_obj         args( ( CHAR_DATA *ch, OBJ_DATA *obj,
                            OBJ_DATA *container ) );

/* act_wiz.c */
void wiznet		args( (char *string, CHAR_DATA *ch, OBJ_DATA *obj,
			       long flag, long flag_skip, int min_level ) );
void copyover_recover args((void));

/* alias.c */
void 	substitute_alias args( (DESCRIPTOR_DATA *d, char *input) );

/* auction.c */
void    auction_update  args( ( void ) );
void    auction_channel args( ( char *msg ) );

/* ban.c */
bool	check_ban	args( ( char *site, int type) );

/* comm.c */
void	show_string	args( ( struct descriptor_data *d, char *input) );
void	close_socket	args( ( DESCRIPTOR_DATA *dclose ) );
void	write_to_buffer	args( ( DESCRIPTOR_DATA *d, const char *txt,
			    int length ) );
/* added for new char gen - Dalsor */
void do_quoter   args((CHAR_DATA *ch));
void display_races args((CHAR_DATA *ch));
void display_eye_color args((CHAR_DATA *ch));
void display_aiel_societies args((CHAR_DATA *ch));
void display_trollocs args((CHAR_DATA *ch));
void display_illegal_name args((CHAR_DATA *ch));
void display_denied_char args((CHAR_DATA *ch));
void display_banned_site args((CHAR_DATA *ch));
void display_game_wizlocked args((CHAR_DATA *ch));
void display_game_newlocked args((CHAR_DATA *ch));
void display_game_wizlocked_descriptor args((DESCRIPTOR_DATA *d));
void display_new_name args((CHAR_DATA *ch));
void display_invalid_password args((CHAR_DATA *ch));
void display_cust_head args((CHAR_DATA *ch));

void	send_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
void	stc	args( ( const char *txt, CHAR_DATA *ch ) );
void	page_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
void	act		args( ( const char *format, CHAR_DATA *ch,
			    const void *arg1, const void *arg2, int type ) );
void	act_new		args( ( const char *format, CHAR_DATA *ch,
			    const void *arg1, const void *arg2, int type,
			    int min_pos) );
void	printf_to_char	args( ( CHAR_DATA *, char *, ... ) );
void    ptc args( ( CHAR_DATA *, char *, ... ) );
void	bugf		args( ( char *, ... ) );

/* db.c */
void	reset_area      args( ( AREA_DATA * pArea ) );		/* OLC */
void	reset_room	args( ( ROOM_INDEX_DATA *pRoom ) );	/* OLC */
char *	print_flags	args( ( int flag ));
void	boot_db		args( ( void ) );
void	area_update	args( ( void ) );
void    ferry_update args( ( void ) );
CD *	create_mobile	args( ( MOB_INDEX_DATA *pMobIndex ) );
void	clone_mobile	args( ( CHAR_DATA *parent, CHAR_DATA *clone) );
OD *	create_object	args( ( OBJ_INDEX_DATA *pObjIndex, int level ) );
void	clone_object	args( ( OBJ_DATA *parent, OBJ_DATA *clone ) );
void	clear_char	args( ( CHAR_DATA *ch ) );
char *	get_extra_descr	args( ( const char *name, EXTRA_DESCR_DATA *ed ) );
MID *	get_mob_index	args( ( long vnum ) );
OID *	get_obj_index	args( ( long vnum ) );
RID *	get_room_index	args( ( long vnum ) );
PC *	get_prog_index args( ( long vnum, int type ) );
char	fread_letter	args( ( FILE *fp ) );
int	fread_number	args( ( FILE *fp ) );
long	fread_vnum	args( ( FILE *fp ) );
long 	fread_flag	args( ( FILE *fp ) );
char *	fread_string	args( ( FILE *fp ) );
char *  fread_string_eol args(( FILE *fp ) );
void	fread_to_eol	args( ( FILE *fp ) );
//char *	fread_word	args( ( FILE *fp ) );
#define fread_word( fp ) _fread_word( fp, __FILE__, __LINE__ )
long	flag_convert	args( ( char letter) );
void *	alloc_mem	args( ( int sMem ) );
void *	alloc_perm	args( ( int sMem ) );

void _free_mem args ((void *pMem, int sMem, char *file, int line));
void _free_string args ((char *pstr, char *file, int line));
bool _str_cmp args ((const char *astr, const char *bstr, char *file, int line));
char * _fread_word args(( FILE *fp, char *file, int line ));

/*void	free_mem	args( ( void *pMem, int sMem ) );*/
char *	str_dup		args( ( const char *str ) );
/*void	free_string	args( ( char *pstr ) );*/
int	number_fuzzy	args( ( int number ) );
int	number_range	args( ( int from, int to ) );
int	number_percent	args( ( void ) );
int	number_door	args( ( void ) );
int	number_bits	args( ( int width ) );
long     number_mm       args( ( void ) );
int	dice		args( ( int number, int size ) );
int	interpolate	args( ( int level, int value_00, int value_32 ) );
void	smash_tilde	args( ( char *str ) );
bool	str_cmp		args( ( const char *astr, const char *bstr ) );
bool	str_prefix	args( ( const char *astr, const char *bstr ) );
bool	str_infix	args( ( const char *astr, const char *bstr ) );
bool	str_suffix	args( ( const char *astr, const char *bstr ) );
char *	capitalize	args( ( const char *str ) );
char *  capit2      args( ( const char *str ) );
char *  capit_colorsafe args( ( const char *str ) );
void	append_file	args( ( CHAR_DATA *ch, char *file, char *str ) );
void	bug		args( ( const char *str, int param ) );
void	log_string	args( ( const char *str ) );
void	tail_chain	args( ( void ) );

 /*
  * Colour stuff by Lope
  */
 int   colour          args( ( char type, CHAR_DATA *ch, char *string ) );
 void  colourconv      args( ( char *buffer, const char *txt,
CHAR_DATA*ch));
 void  send_to_char_bw args( ( const char *txt, CHAR_DATA *ch ) );
 void  page_to_char_bw args( ( const char *txt, CHAR_DATA *ch ) );

/* tabac.c for drunk code */
char	*makedrunk	args( (char *string, CHAR_DATA *ch) );

/* disable.c */
void	load_disabled	args( ( void ) );

/* effect.c */
void	acid_effect	args( (void *vo, int level, int dam, int target) );
void	cold_effect	args( (void *vo, int level, int dam, int target) );
void	fire_effect	args( (void *vo, int level, int dam, int target) );
void	poison_effect	args( (void *vo, int level, int dam, int target) );
void	shock_effect	args( (void *vo, int level, int dam, int target) );


/* fight.c */
bool 	is_safe		args( (CHAR_DATA *ch, CHAR_DATA *victim ) );
bool 	is_safe_spell	args( (CHAR_DATA *ch, CHAR_DATA *victim, bool area ) );
void	violence_update	args( ( void ) );
void	multi_hit	args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt ) );
bool	damage		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
			        int dt, int class, bool show ) );
bool    damage_old      args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
                                int dt, int class, bool show ) );
void	update_pos	args( ( CHAR_DATA *victim ) );
/*void	stop_fighting	args( ( CHAR_DATA *ch, bool fBoth ) );*/
void	check_killer	args( ( CHAR_DATA *ch, CHAR_DATA *victim) );

bool    is_hating       args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void    stop_hating     args( ( CHAR_DATA *ch ) );
/*void    stop_fighting   args( ( CHAR_DATA *ch, bool fBoth ) );*/
void	start_hating	args( (CHAR_DATA *ch, CHAR_DATA *victim) );
/*void	set_fighting	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );*/
bool start_first_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool start_extra_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool check_fighting_groupie args((CHAR_DATA *ch, CHAR_DATA *victim));
bool check_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_all_fighting args((CHAR_DATA *ch));
bool is_fighting args((CHAR_DATA *ch));


/* handler.c */
AD  	*affect_find args( (AFFECT_DATA *paf, int sn));
void	affect_check	args( (CHAR_DATA *ch, int where, int vector) );
void    affect_to_room  args( (ROOM_INDEX_DATA *room, AFFECT_DATA *paf ) );
void	affect_remove_room args((ROOM_INDEX_DATA *room, AFFECT_DATA *paf) );
int	count_users	args( (OBJ_DATA *obj) );
void 	deduct_cost	args( (CHAR_DATA *ch, int cost, int account) );
bool is_same_sex args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool check_coins args( ( CHAR_DATA *ch, int cost, int start, int stop ) );
void	affect_enchant	args( (OBJ_DATA *obj) );
int 	check_immune	args( (CHAR_DATA *ch, int dam_type) );
int 	material_lookup args( ( const char *name) );
int	weapon_lookup	args( ( const char *name) );
int	weapon_type	args( ( const char *name) );
char 	*weapon_name	args( ( int weapon_Type) );
char	*item_name	args( ( int item_type) );
int	attack_lookup	args( ( const char *name) );
long	wiznet_lookup	args( ( const char *name) );
int	class_lookup	args( ( const char *name) );
/*
bool	is_clan		args( (CHAR_DATA *ch) );
bool	is_same_clan	args( (CHAR_DATA *ch, CHAR_DATA *victim));
*/
bool	is_old_mob	args ( (CHAR_DATA *ch) );
int	get_skill	args( ( CHAR_DATA *ch, int sn ) );
int	get_weapon_sn	args( ( CHAR_DATA *ch ) );
int	get_weapon_skill args(( CHAR_DATA *ch, int sn ) );
int     get_age         args( ( CHAR_DATA *ch ) );
void	reset_char	args( ( CHAR_DATA *ch )  );
int	get_trust	args( ( CHAR_DATA *ch ) );
int	get_curr_stat	args( ( CHAR_DATA *ch, int stat ) );
int 	get_max_train	args( ( CHAR_DATA *ch, int stat ) );
int	can_carry_n	args( ( CHAR_DATA *ch ) );
int	can_carry_w	args( ( CHAR_DATA *ch ) );
bool	is_name		args( ( char *str, char *namelist ) );
bool	is_exact_name	args( ( char *str, char *namelist ) );
/* grant code */
bool is_granted_name    args( ( CHAR_DATA *ch, char *argument ) );
bool    is_granted      args( ( CHAR_DATA *ch, DO_FUN *do_fun ) );

/* global questing */
bool load_gquest_data args((void));
bool save_gquest_data args((void));
void auto_gquest args((void));
bool start_gquest args((CHAR_DATA * ch, char *argument));
void end_gquest args((void));
void gquest_update args((void));
void gquest_wait args((void));
bool generate_gquest args((CHAR_DATA * who));
int count_gqmobs args((CHAR_DATA * ch));
int is_gqmob args((CHAR_DATA * ch, int vnum));
void reset_gqmob args((CHAR_DATA * ch, int value));
bool is_random_gqmob args((int vnum));

/* reg stuff */
void	affect_to_char	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	affect_to_obj	args( ( OBJ_DATA *obj, AFFECT_DATA *paf ) );
void	affect_remove	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	affect_remove_obj args( (OBJ_DATA *obj, AFFECT_DATA *paf ) );
void	affect_strip	args( ( CHAR_DATA *ch, int sn ) );
bool	is_affected	args( ( CHAR_DATA *ch, int sn ) );
void	affect_join	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	char_from_room	args( ( CHAR_DATA *ch ) );
void	char_to_room	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex ) );
void	obj_to_char	args( ( OBJ_DATA *obj, CHAR_DATA *ch ) );
void	obj_from_char	args( ( OBJ_DATA *obj ) );


bool is_shadow args(( CHAR_DATA *ch ));
int	apply_ac	args( ( OBJ_DATA *obj, int iWear, int type ) );
OD *	get_eq_char	args( ( CHAR_DATA *ch, int iWear ) );
void	equip_char	args( ( CHAR_DATA *ch, OBJ_DATA *obj, int iWear ) );
void	unequip_char	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
int	count_obj_list	args( ( OBJ_INDEX_DATA *obj, OBJ_DATA *list ) );
/*void	obj_from_room	args( ( OBJ_DATA *obj ) );*/
void _obj_from_room args ((OBJ_DATA *obj, char *file, int line));

void	obj_to_room	args( ( OBJ_DATA *obj, ROOM_INDEX_DATA *pRoomIndex ) );
void	obj_to_obj	args( ( OBJ_DATA *obj, OBJ_DATA *obj_to ) );
void	obj_from_obj	args( ( OBJ_DATA *obj ) );
void	extract_obj	args( ( OBJ_DATA *obj ) );
void	extract_char	args( ( CHAR_DATA *ch, bool fPull ) );
CD *	get_char_room		args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room, char *argument ) );
CD *	get_char_world	args( ( CHAR_DATA *ch, char *argument ) );
CD *    get_mob_world   args( ( CHAR_DATA *ch, char*argument ) );
CD *	get_pc_world	args( ( CHAR_DATA *ch, char *argument ) );
CD *	get_char_area	args( ( CHAR_DATA *ch, char *argument ) );
CD *    get_mob_by_vnum args( ( CHAR_DATA *ch, char *argument ) );
OD *	get_obj_type	args( ( OBJ_INDEX_DATA *pObjIndexData ) );
OD *	get_obj_list	args( ( CHAR_DATA *ch, char *argument,
			    OBJ_DATA *list ) );
OD *	get_obj_carry	args( ( CHAR_DATA *ch, char *argument,
			    CHAR_DATA *viewer ) );
OD *    get_obj_wear	args( ( CHAR_DATA *ch, char *argument, bool character ));
OD *	get_obj_here	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room, char *argument ) );
OD *	get_obj_world	args( ( CHAR_DATA *ch, char *argument ) );
OD *    get_obj_by_vnum args( ( CHAR_DATA *ch, char *argument ) );
OD *	create_money	args( ( int copper, int silver, int mark, int gold ) );
int	get_obj_number	args( ( OBJ_DATA *obj ) );
int	get_obj_weight	args( ( OBJ_DATA *obj ) );
int	get_true_weight	args( ( OBJ_DATA *obj ) );
bool	room_is_dark	args( ( ROOM_INDEX_DATA *pRoomIndex ) );
bool	is_room_owner	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room) );
bool	room_is_private	args( ( ROOM_INDEX_DATA *pRoomIndex ) );
bool	can_see		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	can_see_obj	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
bool	can_see_room	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex) );
bool	can_drop_obj	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
char *	affect_loc_name	args( ( int location ) );
char *	affect_bit_name	args( ( int vector ) );
char *  affect2_bit_name args( ( int vector ) );
char *	extra_bit_name	args( ( int extra_flags ) );
char * 	wear_bit_name	args( ( int wear_flags ) );
char *	act_bit_name	args( ( int act_flags ) );
char *	act2_bit_name	args( ( int act2_flags, CHAR_DATA *ch ) );
char *	off_bit_name	args( ( int off_flags ) );
char *  imm_bit_name	args( ( int imm_flags ) );
char *  imm_bit_name	args( ( int imm_flags ) );
char * 	form_bit_name	args( ( int form_flags ) );
char *	part_bit_name	args( ( int part_flags ) );
char *	weapon_bit_name	args( ( int weapon_flags ) );
char *  comm_bit_name	args( ( int comm_flags ) );
char *	cont_bit_name	args( ( int cont_flags) );
char *  item_type_name  args( ( OBJ_DATA *obj ) );
/*int  random_stat        args( ( CHAR_DATA *ch ) );  For random stats - Dalsor */
/*
 * Colour Config
 */
void	default_colour	args( ( CHAR_DATA *ch ) );
void	all_colour	args( ( CHAR_DATA *ch, char *argument ) );

/* interp.c */
void	interpret	args( ( CHAR_DATA *ch, char *argument ) );
bool	is_number	args( ( char *arg ) );
int	number_argument	args( ( char *argument, char *arg ) );
int	mult_argument	args( ( char *argument, char *arg) );
char *	one_argument	args( ( char *argument, char *arg_first ) );
char *  one_comma_argument args( ( char *argument, char *arg_first ) );

/* invade.c */
void	check_invade();
int	racei_amount(int race);
bool	invade(int town, int invader, int force, int amount);
/* magic.c */
int	find_spell	args( ( CHAR_DATA *ch, const char *name) );
int 	mana_cost 	(CHAR_DATA *ch, int min_mana, int level);
int	skill_lookup	args( ( const char *name ) );
int	slot_lookup	args( ( int slot ) );
bool	saves_spell	args( ( int level, CHAR_DATA *victim, int dam_type ) );
void	obj_cast_spell	args( ( int sn, int level, CHAR_DATA *ch,
				    CHAR_DATA *victim, OBJ_DATA *obj ) );

/* locker.c */
LOCKER_DATA * load_locker args( ( CHAR_DATA *ch ) );
void fread_locker args( ( CHAR_DATA *ch, LOCKER_DATA *locker, FILE *fp ) );
void fwrite_locker args( ( CHAR_DATA *ch ) );

/* mob_prog.c
void	program_flow	args( ( long vnum, char *source, CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2 ) );
void	mp_act_trigger	args( ( char *argument, CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
bool	mp_percent_trigger args( ( CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
void	mp_bribe_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch, int amount ) );
bool	mp_exit_trigger   args( ( CHAR_DATA *ch, int dir ) );
void	mp_give_trigger   args( ( CHAR_DATA *mob, CHAR_DATA *ch, OBJ_DATA *obj ) );
void 	mp_greet_trigger  args( ( CHAR_DATA *ch ) );
void	mp_hprct_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch ) );
*/
void	program_flow	args( ( long vnum, char *source, CHAR_DATA *mob,
				OBJ_DATA *obj, ROOM_INDEX_DATA *room,
				CHAR_DATA *ch, const void *arg1,
				const void *arg2 ) );
void	p_act_trigger	args( ( char *argument, CHAR_DATA *mob,
				OBJ_DATA *obj, ROOM_INDEX_DATA *room,
				CHAR_DATA *ch, const void *arg1,
				const void *arg2, int type ) );
bool	p_percent_trigger args( ( CHAR_DATA *mob, OBJ_DATA *obj,
				ROOM_INDEX_DATA *room, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
void	p_bribe_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch, int amount ) );
bool	p_exit_trigger   args( ( CHAR_DATA *ch, int dir, int type ) );
void	p_give_trigger   args( ( CHAR_DATA *mob, OBJ_DATA *obj,
				ROOM_INDEX_DATA *room, CHAR_DATA *ch,
				OBJ_DATA *dropped, int type ) );
void 	p_greet_trigger  args( ( CHAR_DATA *ch, int type ) );
void	p_hprct_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch ) );

/* mob_cmds.c */
void	mob_interpret	args( ( CHAR_DATA *ch, char *argument ) );
void	obj_interpret	args( ( OBJ_DATA *obj, char *argument ) );
void room_interpret	args( ( ROOM_INDEX_DATA *room, char *argument ) );

/* mount.c */
int     mount_success	args( ( CHAR_DATA *ch, CHAR_DATA *mount, int canattack ) );
void    do_mount        args( ( CHAR_DATA *ch, char *argument ) );
void    do_dismount     args( ( CHAR_DATA *ch, char *argument ) );
void	do_buy_mount	args( ( CHAR_DATA *ch, char *argument ) );

/* save.c */
//void	save_char_obj	args( ( CHAR_DATA *ch ) );
void    save_char_obj   args((CHAR_DATA * ch, bool backup, bool save_other));
bool	load_char_obj	args( ( DESCRIPTOR_DATA *d, char *name ) );
void	fwrite_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fwrite_obj	args( ( CHAR_DATA *ch,  OBJ_DATA  *obj, FILE *fp, int iNest ) );
void	fwrite_pet	args( ( CHAR_DATA *pet, FILE *fp) );
void	fwrite_mount	args( ( CHAR_DATA *pet, FILE *fp) );
void	fread_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_pet	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_mount	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fread_obj	args( ( CHAR_DATA *ch,  FILE *fp ) );

/*send.c*/
 char *color_strip args(( const char *txt ));

/* skills.c */
bool 	parse_gen_groups args( ( CHAR_DATA *ch,char *argument ) );
void 	list_group_costs args( ( CHAR_DATA *ch ) );
void    list_group_known args( ( CHAR_DATA *ch ) );
int 	exp_per_level	args( ( CHAR_DATA *ch, int points ) );
void 	check_improve	args( ( CHAR_DATA *ch, int sn, bool success,
				    int multiplier ) );
int 	group_lookup	args( (const char *name) );
void	gn_add		args( ( CHAR_DATA *ch, int gn) );
void 	gn_remove	args( ( CHAR_DATA *ch, int gn) );
void 	group_add	args( ( CHAR_DATA *ch, const char *name, bool deduct) );
void	group_remove	args( ( CHAR_DATA *ch, const char *name) );

/* special.c */
SF *	spec_lookup	args( ( const char *name ) );
char *	spec_name	args( ( SPEC_FUN *function ) );

/* talents.c */
void check_talents( CHAR_DATA *ch );

/* teleport.c */
RID *	room_by_name	args( ( char *target, int level, bool error) );

/* timer.c */
char *   nsprintf       args( (char *, char *, ...) );
void  wait_wait         args( (CHAR_DATA *, int, int) );
void  wait_printf       args( (CHAR_DATA *, int, char *, ...) );
void  wait_act          args( (int, char *, void *, void *, void *, int) );
void  wait_function     args( (CHAR_DATA *ch,int delay, DO_FUN *do_fun, char *argument) );
EVENT_DATA *create_event(int, char *);

/* update.c */
void	advance_level	args( ( CHAR_DATA *ch, bool hide ) );
void	gain_exp	args( ( CHAR_DATA *ch, int gain ) );
void	gain_condition	args( ( CHAR_DATA *ch, int iCond, int value ) );
void	update_handler	args( ( void ) );

/* staff.c */
void    fread_staff	args( ( CHAR_DATA *ch ) );
//void    fwrite_staff	args( ( CHAR_DATA *ch ) );

/* staff_mysql.c */
void    update_staff args( ( CHAR_DATA *ch, char *argument ) );
void    read_mysql_staff args( ( CHAR_DATA *ch ) );

/* string.c */
void	string_edit	args( ( CHAR_DATA *ch, char **pString ) );
void    string_append   args( ( CHAR_DATA *ch, char **pString ) );
char *	string_replace	args( ( char * orig, char * old, char * new ) );
void    string_add      args( ( CHAR_DATA *ch, char *argument ) );
char *  format_string   args( ( char *oldstring /*, bool fSpace */ ) );
char *  first_arg       args( ( char *argument, char *arg_first, bool fCase ) );
char *	string_unpad	args( ( char * argument ) );
char *	string_proper	args( ( char * argument ) );
int strlen_color args( ( const char *string ) );

/* olc.c */
bool	run_olc_editor	args( ( DESCRIPTOR_DATA *d ) );
char	*olc_ed_name	args( ( CHAR_DATA *ch ) );
char	*olc_ed_vnum	args( ( CHAR_DATA *ch ) );

/* lookup.c */
int	race_lookup	args( ( const char *name) );
int	item_lookup	args( ( const char *name) );
int	liq_lookup	args( ( const char *name) );

/* misc crap */
int check_angreal_bonus args((CHAR_DATA *ch));
bool check_windfall args(( CHAR_DATA *ch ));
bool check_angrealstudy args(( CHAR_DATA *ch ));
bool is_char_char_clan args((CHAR_DATA *ch, CHAR_DATA *victim));
/*
int clan_lookup args(( const char *name ));
*/
void check_healing args(( CHAR_DATA *ch, CHAR_DATA *victim ));
void ship_advance args( ( void ) );
void caravan_advance args( (void) );
void dfhunt_update args( ( void ) );
void dfhunt_recount args( ( void ) );
void	dfhunt_talk		args((CHAR_DATA *ch, char *argument, int notice));
bool chance args(( int num ));
void	raw_kill	args( ( CHAR_DATA *victim ) );
void smash_forwardslash args(( char *str ));
void smash_space args(( char *str ));
void smash_tics args(( char *str ));
void smash_percent args(( char *str ));
char * double_percent args(( char *str ));
char * double_left_curly_brace args(( char *str ));
bool is_human args(( CHAR_DATA *ch ));
bool ip_group_allow args(( CHAR_DATA *ch, CHAR_DATA *victim ));
bool is_alt_of		args(( CHAR_DATA *ch, CHAR_DATA *ach));
void trap_damage args(( CHAR_DATA *ch, OBJ_DATA *obj ));
void group_char args(( CHAR_DATA *ch ));

/* added for intro quotes - Dalsor */
void do_quoter   args((CHAR_DATA *ch));
void display_races args((CHAR_DATA *ch));
void display_eye_color args((CHAR_DATA *ch));
void display_aiel_societies args((CHAR_DATA *ch));
void display_aiel_clans args((CHAR_DATA *ch));
void display_trollocs args((CHAR_DATA *ch));
void display_char_ogier args((CHAR_DATA *ch));
void display_char_trolloc args((CHAR_DATA *ch));
void display_char_aielman args((CHAR_DATA *ch));
void display_char_seafolk args((CHAR_DATA *ch));
void display_char_channeler args((CHAR_DATA *ch));
void display_random_chance args((CHAR_DATA *ch));
void display_hair_cut args((CHAR_DATA *ch));
void display_prime_hair args((CHAR_DATA *ch));
void display_secondary_hair args((CHAR_DATA *ch));
void display_tertiary_hair args((CHAR_DATA *ch));
void display_backgrounds args((CHAR_DATA *ch));
void accept_rules args((CHAR_DATA *ch));
void confirm_new_name args((CHAR_DATA *ch));
bool		    wizlock;		/* Game is wizlocked		*/
bool		    newlock;		/* Game is newlocked		*/
int		    wizlock_timer;	/* Countdown timer until game is auto-unwizlocked */

bool check_anticipate args(( CHAR_DATA *ch ));
bool check_precision args(( CHAR_DATA *ch ));
bool check_efficient args(( CHAR_DATA *ch ));
bool check_gifted args(( CHAR_DATA *ch ));
bool check_windfall args(( CHAR_DATA *ch ));
bool check_angrealstudy args(( CHAR_DATA *ch ));
void show_evaluation args(( CHAR_DATA *ch, OBJ_DATA *obj ));
void do_evaluate args(( CHAR_DATA *ch, char *argument ));
void do_bribe args(( CHAR_DATA *ch, char *argument ));
bool check_intimidate args(( CHAR_DATA *ch ));
bool check_truesense args(( CHAR_DATA *ch ));
void quest_engrave args(( CHAR_DATA *ch, char *argument ));
void quest_balance args(( CHAR_DATA *ch, char *argument ));
void quest_disguise args(( CHAR_DATA *ch, char *argument ));
void quest_bloodlust args(( CHAR_DATA *ch, char *argument ));
bool check_feint args(( CHAR_DATA *ch ));
bool check_lunge args(( CHAR_DATA *ch ));
bool check_stagger args(( CHAR_DATA *ch ));
bool check_shieldbash args(( CHAR_DATA *ch ));
bool check_swordbreak args(( CHAR_DATA *ch ));
bool check_chop args(( CHAR_DATA *ch ));
bool check_draw args(( CHAR_DATA *ch ));
bool check_sweep args(( CHAR_DATA *ch ));
bool check_dismember args(( CHAR_DATA *ch ));
bool check_ravage args(( CHAR_DATA *ch ));
void skin args(( CHAR_DATA *ch, char *argument, char *race ));
int true_op_average args((CHAR_DATA *ch));
int true_angreal_bonus args((CHAR_DATA *ch));
int op_average args((CHAR_DATA *ch));

void stop_spell args ((CHAR_DATA *ch));

int roomcount args((CHAR_DATA *ch));
int count_skills args((CHAR_DATA *ch));
int count_weaves args((CHAR_DATA *ch));
bool can_remort args((CHAR_DATA *ch));
void ship_init args(( void ));
bool blademaster args(( CHAR_DATA *ch ));
bool spearmaster args(( CHAR_DATA *ch ));
int get_secondary_sn args((CHAR_DATA *ch));

bool weaponless args(( CHAR_DATA *ch ));
FILE *file_open args((const char *file, const char *mode));

/* Programs */
PROG_LIST	*new_oprog		args ( ( void ) );
void		free_oprog		args ( ( PROG_LIST *op ) );
PROG_LIST	*new_rprog		args ( ( void ) );
void		free_rprog		args ( ( PROG_LIST *rp ) );
PROG_CODE	*new_opcode		args ( ( void ) );
void		free_opcode		args ( ( PROG_CODE *pOcode ) );
PROG_CODE	*new_rpcode		args ( ( void ) );
void		free_rpcode		args ( ( PROG_CODE *pRcode ) );

#undef	CD
#undef	MID
#undef	OD
#undef	OID
#undef	RID
#undef	SF
#undef AD

/*****************************************************************************
 *                                    OLC                                    *
 *****************************************************************************/

/*
 * Object defined in limbo.are
 * Used in save.c to load objects that don't exist.
 */
#define OBJ_VNUM_DUMMY	30

/*
 * Area flags.
 */
#define         AREA_NONE       0
#define         AREA_CHANGED    1	/* Area has been modified. */
#define         AREA_ADDED      2	/* Area has been added to. */
#define         AREA_LOADING    4	/* Used for counting in db.c */

#define MAX_DIR	10
#define NO_FLAG -99	/* Must not be used in flags or stats. */

/*
 * Global Constants
 */
extern	char *	const	dir_name        [];
extern	const	sh_int	rev_dir         [];          /* sh_int - ROM OLC */
extern	const	struct	spec_type	spec_table	[];

/*
 * Global variables
 */
extern		AREA_DATA *		area_first;
extern		AREA_DATA *		area_last;
extern		SHOP_DATA *		shop_last;

extern		int			top_affect;
extern		int			top_area;
extern		int			top_ed;
extern		int			top_exit;
extern		int			top_help;
extern		int			top_mob_index;
extern		int			top_obj_index;
extern		int			top_reset;
extern		int			top_room;
extern		int			top_shop;

extern		long			top_vnum_mob;
extern		long			top_vnum_obj;
extern		long			top_vnum_room;

extern		char			str_empty       [1];

extern		MOB_INDEX_DATA *	mob_index_hash  [MAX_KEY_HASH];
extern		OBJ_INDEX_DATA *	obj_index_hash  [MAX_KEY_HASH];
extern		ROOM_INDEX_DATA *	room_index_hash [MAX_KEY_HASH];

