/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "mysql5_interface.h"

int calc_op_avg( CHAR_DATA *ch )
{
	int avg;
	if ( !ch->pcdata || !IS_SET( ch->op_flags, OP_CHANNELER))
		return 0;
	avg = ch->pcdata->op_air+ch->pcdata->op_earth+ch->pcdata->op_fire+ch->pcdata->op_spirit+ch->pcdata->op_water;
	avg /= 5;

	return avg;
}
int calc_mastery( CHAR_DATA *ch )
{
	int mastery =
   	(get_skill(ch,gsn_heron)+get_skill(ch,gsn_bird)+get_skill(ch,gsn_wind)
   	+get_skill(ch,gsn_water)+get_skill(ch,gsn_lizard)+get_skill(ch,gsn_earth)
   	+get_skill(ch,gsn_sky)+get_skill(ch,gsn_cat)) / 8;
        if(!IS_SET( ch->op_flags, OP_CHANNELER))
		return mastery;
	else
		return 0;
}
void did_you_know( CHAR_DATA *ch )
{
	int counter;

	char * strings[] = {
	"You can save treasure chests by putting them in a sack?",
	"With the Gifted quest skill you can train skills to 85%?",
	"You can appraise an item you are wearing with 'appraise my item'?",
	"You can use the 'junk' command to set which chest items to sell?",
	"You can use the 'tree' command to see which skills are required by others?",
	"The Quest Lady is located in any bank across the world? Type 'quest request' for a list.",
	"East and north of Caemlyn recall you can 'go marketplace' to reach player owned shops?",
	"RPrecall is a great place to Roleplay?",
	"You can often escape a room with no exits by typing RECALL?",
	"You can appraise items in shops by typing 'examine <item>'?",
	"Dual wielding will increase your backstab damage exponentially?",
	"The Ambush skill allows for two more backstabs?",
	"Players who channel must use the 'grasp' command to touch the True Source?",
	"You can see a list of weaves and ailments affecting you by typing AFFECT?",
	"You can see various stats about your character by typing SUMMARY?",
	"Damage and Experience caps are raised with each remort tier?",
	"Grouping allows an experience bonus for each additional group member, starting at three?",
	"You can view a list of the MUD's built-in quickaliases by typing QA?",
	"You can exchange all of your currency into gold coins by typing XAG(or 'exchange all to gold') while in a bank?",
	"You can make a backup of your pfile at any time by typing BACKUP ALL? This is not the same as save!",
	"Aiel have a racial skill called Veil which raises hit and damage rolls?",
	"Players can choose to be subguilded as Darkfriends if they already have a primary guild?",
	"Myrddraal can teleport via the SHADOWWALK command similar to the way channelers travel with gateways.",
	"Myrddraal have a skill called Fear which lowers an enemy's stat cap by 10?",
	"Gray Men are almost always hidden?",
	"You have a chance of rolling the OOC benefits of Talents such as Ta'veren, etc. through remorts, and can earn the IC benefits through roleplaying?",
	"Not everyone can just ICly claim to be a Blademaster? The rank must be earned through a universal RP requirement.",
	"The Heron skill is the first form group? It raises damage and accuracy while increasing damage resistance.",
	"The Focus quest skill allows a player to focus the Hurricane skill down to a single specific target?",
	"The first remort is generally the most difficult for a player to obtain?",
	"All forms are clumsy until you have used them for one remort?",
	"You can remort your character by typeing REBIRTH twice once you have reached the required level? The first time will show how many skills you may lose.",
	"The first time you type rebirth will show you how many skills you might lose?",
	"The Portal weave creates a free-standing gateway, while the Gateway weave transports you and everyone following?",
	"Weaving Gateway or Portal at a strength of less than 10 will tear you in half, killing you instantly?",
	"You can keep skills over 75% until you have been reborn 10 times? Afterwards you keep skill greater than 100%.",
	"You can increase skills higher than 100%.",
	"The toggle command can be used to turn various game features on and off.",
	"You can clear previously stacked commands by pressing the ` key.",
	"Sneaking will sometimes help you get past an aggressive enemy without having to fight them.",
	"Non-channelers have a skill called RUSH that closes to melee immediately for a bit of stamina.",
	"Picking the chests you find while levelling is a good way to accumulate a lot of wealth -- and clutter.",
	"Treasure boxes dropped by enemies are usually trapped and must be unarmed.",
	"The RAGE and BATTLECRY skills grant you a damage roll bonus based on skill percentage.",
	"The BERSERK and VOID skills grant you bonuses to damage and hit rolls respectively, based on level.",
	"You can challenge another player to a duel by typing CHALLENGE <player>. The other player may then ACCEPT or DECLINE.",
	"You can purchase certain global events with quest points in the bank. Use QUEST LIST to see them.",
	"You can compete in PK Tournaments for Quest Points. TOGGLE TOURNEY to see tournament messages.",
	"The Whirlwind, Tornado, and Hurricane skills can strike up to three Mobs, pulling them into combat.",
	"Use the CONSIDER command to determine your odds of killing something. The harder the Mob, the higher the XP.",
	"You gain a bonus to skill increase, XP cap, and damage cap with each new remort tier. However, your remort level increases by 25.",
	"TOGGLE DFHUNT to play an addictive game of spite and suspicion.",
	"Dreamwalkers can step into Tel'aran'rhiod by typing DREAM ENTER. DREAM LEAVE will exit the World of Dreams. DREAM WALK # will step to a previously memorized location.",
	"Wolfkin can see in the dark, and bite their enemies in combat.",
	"Seers can see Talents on other players.",
	"Ta'veren get a bonus to money found in boxes and critical strikes in combat.",
	"Players can use the Global channel by typing OOC, Global, or the '.' key, followed by the message they wish to send.",
	"GCOM LIST will show you all online players in your guild.",
	"Typing WHEN <player> will show you the last time that player has been online.",
	"Typing LAST will show you the last twenty log-ins.",
	"There is an entire list of X-rated socials that can be toggled. Not for the faint of heart!",
	"You can view your character's stats by typing SCORE.",
	"The Windfall quest skill grants a bonus to XP gained from both kills and skill increases.",
	"You can see the last ten posts on any channel by typing <channel name> LAST.",
	"Some Mobs are considered Aggressive or 'aggro' -- that is, they attack players on sight.",
	"Players can restring items at the shop 2 west, 1 south of Caemlyn's recall point.",
	"Certain materials found in chests or on Mobs can be crafted into powerful items.",
	"An angreal allows a channeler to weave at a higher strength than they normally could, so long as it matches their gender. The maximum fold on an angreal is 20.",
	"You can use the LAST command to see the last twenty players to log on.",
	"You can use the REMORTS command to see the last twenty players to remort, and even their title.",
        };

        counter = number_range(1, sizeof(strings) / sizeof(char *) );
        ptc( ch, "\n\r{W Did you know?\n\r{r -------------{x\n\r{w%s{x\n\r", strings[counter-1] );
}
void do_last( CHAR_DATA *ch, char *argument )
{
	MYSQL_RES *result;
	MYSQL_ROW row;
	char mysql_buf[MSL];
	int total = 0, max = 20;

        sprintf(mysql_buf, "select count(id) from last_login");
        result = query_db(mysql_buf, result_db, FALSE);

	if ( result == NULL )
	{
		stc("A MySQL error was encountered.\n\r", ch);
		bug("MySQL Error, result NULL in query_db from do_last",0);
		return;
	}

        row = mysql_fetch_row(result);
        total = UMAX(max, atoi(row[0]));
        mysql_free_result(result);

        if (total <= 0) return;
        if (max > total) max = total;

	sprintf(mysql_buf, "select id, ch_name, login_time, host from last_login order by id asc limit %d, %d", total - max, max);
	result = query_db(mysql_buf, result_db, FALSE);

	if (result == NULL)     return;

	stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
	ptc( ch, " {cShowing the last {C%d{c logins.\n\r", max );
	while ((row = mysql_fetch_row(result)) != NULL)
	{
		if ( !IS_IMMORTAL( ch ) )
	                ptc( ch, " {C%s{c connected at {C%s{x\n\r", row[1], short_date(atoi(row[2])) );
		else
			ptc( ch, " {C%s{c connected at {C%s{c from {C%s{x\n\r", row[1], short_date(atoi(row[2])), row[3] );
        }
	stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
        if (result != NULL)
        mysql_free_result(result);
}

void do_remorts( CHAR_DATA *ch, char *argument )
{
        MYSQL_RES *result;
        MYSQL_ROW row;
        char mysql_buf[MSL];
        int total = 0, max = 20;

        sprintf(mysql_buf, "select count(id) from remort_history");
        result = query_db(mysql_buf, result_db, FALSE);

        if ( result == NULL )
        {
                stc("A MySQL error was encountered.\n\r", ch);
                bug("MySQL Error, result NULL in query_db from do_last",0);
                return;
        }

        row = mysql_fetch_row(result);
        total = UMAX(max, atoi(row[0]));
        mysql_free_result(result);

        if (total <= 0) return;
        if (max > total) max = total;

        sprintf(mysql_buf, "select id, ch_name, remort_time, host, ch_title from remort_history order by id asc limit %d, %d", total - max, max);
        result = query_db(mysql_buf, result_db, FALSE);

        if (result == NULL)     return;

        stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
        ptc( ch, " {cShowing the last {C%d{c remorts.\n\r", max );
        while ((row = mysql_fetch_row(result)) != NULL)
        {
                if ( !IS_IMMORTAL( ch ) )
                        ptc( ch, " %s {C%s{c was reborn at {C%s{x\n\r", row[4], row[1], short_date(atoi(row[2])) );
                else
                        ptc( ch, " %s {C%s{c was reborn at {C%s{c from {C%s{x\n\r", row[4], row[1], short_date(atoi(row[2])), row[3] );
        }
        stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
        if (result != NULL)
        mysql_free_result(result);
}

void do_deaths( CHAR_DATA *ch, char *argument )
{
        MYSQL_RES *result;
        MYSQL_ROW row;
        char mysql_buf[MSL];
        int total = 0, max = 20;

        sprintf(mysql_buf, "select count(id) from death_history");
        result = query_db(mysql_buf, result_db, FALSE);

        if ( result == NULL )
        {
                stc("A MySQL error was encountered. Attempting reconnection...\n\r", ch);
		stc("Please try again. If it continues to fail, notify an Immortal.\n\r", ch);
		connect_db();
                bug("MySQL Error, result NULL in query_db from do_deaths. Attempting reconnect.",0);
                return;
        }

        row = mysql_fetch_row(result);
        total = UMAX(max, atoi(row[0]));
        mysql_free_result(result);

        if (total <= 0) return;
        if (max > total) max = total;

        sprintf(mysql_buf, "select id, ch_name, death_time, ch_host, ch_killer, ch_killer_host, ch_roomv from death_history order by id asc limit %d, %d", total - max, max);
        result = query_db(mysql_buf, result_db, FALSE);

        if (result == NULL)     return;

        stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
        ptc( ch, " {cShowing the last {C%d{c remorts.\n\r", max );
        while ((row = mysql_fetch_row(result)) != NULL)
        {
                if ( !IS_IMMORTAL( ch ) )
                        ptc( ch, " %s was killed by %s at %s :: %s\n\r", row[1], row[4], row[6], short_date(atoi(row[2])) );
                else
                        ptc( ch, " %s was killed by %s at %s :: %s from %s\n\r", row[1], row[4], row[0], short_date(atoi(row[2])), row[5] );
        }
        stc("{C+{c----------------------------------------------------------------{C+{x\n\r", ch);
        if (result != NULL)
        mysql_free_result(result);
}

void do_leaders( CHAR_DATA *ch, char *argument )
{
	DESCRIPTOR_DATA *d;
	CHAR_DATA *leader;
	int highlevel = 0, highrebirths = 0, highopavg = 0, highmastery = 0, highskills = 0, highweaves = 0, highmotes = 0;
	struct curr_leader
	{
		char *highlevel;
		int  n_high_level;
		char *rebirths;
		int  n_rebirths;
		char *opavg;
		int  n_opavg;
		char *mastery;
		int  n_mastery;
		char *skillperc;
		int  n_skillperc;
		char *weaveperc;
		int  n_weaveperc;
		char *num_motes;
		long n_num_motes;
	} cleader;

	/* get the
	 * highest level
	 * most rebirths
	 * highest OP
	 * highest mastery
	 * most skill perc
	 * most weave perc
	 */

	cleader.n_high_level = 0;
	cleader.n_rebirths = 0;
	cleader.n_opavg = 0;
	cleader.n_mastery = 0;
	cleader.n_skillperc = 0;
	cleader.n_weaveperc = 0;
	cleader.n_num_motes = 0;

	cleader.highlevel = str_dup("");
	cleader.rebirths = str_dup("");
	cleader.opavg = str_dup("");
	cleader.mastery = str_dup("");
	cleader.skillperc = str_dup("");
	cleader.weaveperc = str_dup("");
	cleader.num_motes = str_dup("");

	stc("Current Leaders:\n\r", ch);
	for( d = descriptor_list; d != NULL; d = d->next )
	{
		if ( d->connected != CON_PLAYING )
			continue;
		if ( d->character == NULL )
			continue;
		if (IS_IMMORTAL(d->character))
			continue;
		
		leader = d->character;
		highlevel = leader->level;
		highrebirths = leader->pcdata->rebirth;
		highopavg = calc_op_avg( leader );
		highmastery = calc_mastery( leader );
		highskills = count_skills( leader );
		highweaves = count_weaves( leader );
		highmotes = leader->pcdata->summary[SUM_MOTES_EVER];

		if ( highlevel > cleader.n_high_level )
		{
			cleader.n_high_level = highlevel;
			free_string(cleader.highlevel);
			cleader.highlevel = str_dup( leader->name );
		}
		if ( highrebirths > cleader.n_rebirths )
		{
			cleader.n_rebirths = highrebirths;
			free_string(cleader.rebirths);
			cleader.rebirths = str_dup( leader->name );
		}
		if ( highopavg > cleader.n_opavg )
		{
			cleader.n_opavg = highopavg;
			free_string(cleader.opavg);
			cleader.opavg = str_dup( leader->name );
		}
		if ( highmastery > cleader.n_mastery )
		{
			cleader.n_mastery = highmastery;
			free_string(cleader.mastery);
			cleader.mastery = str_dup( leader->name );
		}
		if ( highskills > cleader.n_skillperc )
		{
			cleader.n_skillperc = highskills;
			free_string(cleader.skillperc);
			cleader.skillperc = str_dup( leader->name );
		}
		if ( highweaves > cleader.n_weaveperc )
		{
			cleader.n_weaveperc = highweaves;
			free_string(cleader.weaveperc);
			cleader.weaveperc = str_dup( leader->name );
		}
		if( highmotes > cleader.n_num_motes )
		{
			cleader.n_num_motes = highmotes;
			free_string(cleader.num_motes);
			cleader.num_motes = str_dup( leader->name );
		}
	}
	ptc( ch, "Highest Level:   %s\n\r", cleader.highlevel );
	ptc( ch, "Highest Rebirth: %s\n\r", cleader.rebirths );
	ptc( ch, "Highest OP:      %s\n\r", cleader.opavg );
	ptc( ch, "Highest Mastery: %s\n\r", cleader.mastery );
	ptc( ch, "Highest Skills:  %s\n\r", cleader.skillperc );
	ptc( ch, "Highest Weaves:  %s\n\r", cleader.weaveperc );
	ptc( ch, "Highest Motes:   %s\n\r", cleader.num_motes );
			free_string(cleader.highlevel);
			free_string(cleader.rebirths);
			free_string(cleader.opavg);
			free_string(cleader.mastery);
			free_string(cleader.skillperc);
			free_string(cleader.weaveperc);
			free_string(cleader.num_motes);
}
void show_summary( CHAR_DATA *ch, CHAR_DATA *viewer )
{
	if ( viewer == NULL )
		viewer = ch;

	if ( viewer != ch )
	{
		ptc( ch, "      You show %s your summary.\n\r", viewer->name );
		ptc( viewer, "      %s shows you %s summary.\n\r", ch->name, ch->sex == SEX_FEMALE ? "her" : "his" );
	}
	stc( "      Not all items are recorded in the Ever section.\n\r", viewer );
	stc(         " +---------------------+-----------------+-----------------+\n\r", viewer );
	stc(         " | Stat                | This Session    | Ever            |\n\r", viewer );
	stc(         " +---------------------+-----------------+-----------------+\n\r", viewer );
	ptc( viewer, "   XP Earned             %-17d N/A\n\r",
		ch->pcdata->summary[SUM_XP_EARNED] );
	ptc( viewer, "   Levels Gained         %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_LEVELS_GAINED], ch->pcdata->summary[SUM_LEVELS_GAINED_EVER] );
	ptc( viewer, "   Criticals Inflicted   %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_CRITICALS_INFLICTED], ch->pcdata->summary[SUM_CRITICALS_INFLICTED_EVER] );
	ptc( viewer, "   Criticals Taken       %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_CRITICALS_TAKEN], ch->pcdata->summary[SUM_CRITICALS_TAKEN_EVER] );
	ptc( viewer, "   Mob Kills             %-17d N/A\n\r",
		ch->pcdata->summary[SUM_MOB_KILLS] );
	ptc( viewer, "   PC Kills              %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_PC_KILLS], ch->pcdata->summary[SUM_PC_KILLS_EVER] );
	ptc( viewer, "   Deaths                %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_DEATHS], ch->pcdata->summary[SUM_DEATHS_EVER] );
	ptc( viewer, "   Tournies Won          %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_TOURNIES_WON], ch->pcdata->summary[SUM_TOURNIES_WON_EVER] );
	ptc( viewer, "   Trivia Answered       %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_TRIVIA_ANSWERED], ch->pcdata->summary[SUM_TRIVIA_ANSWERED_EVER]  );
	ptc( viewer, "   Motes                 %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_MOTES], ch->pcdata->summary[SUM_MOTES_EVER] );
	ptc( viewer, "   Auctions Won          %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_AUCTIONS_WON], ch->pcdata->summary[SUM_AUCTIONS_WON_EVER] );
	ptc( viewer, "   Rebirths              %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_REBIRTHS], ch->pcdata->rebirth );
	ptc( viewer, "   Quests Done           %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_QUESTS_DONE], ch->pcdata->summary[SUM_QUESTS_DONE_EVER] );
	ptc( viewer, "   QPs Earned            %-17d %-17d\n\r",
		ch->pcdata->summary[SUM_QPS_EARNED], ch->pcdata->summary[SUM_QPS_EARNED_EVER] );

	if ( viewer != ch )
	{
		viewer = ch;

		stc( "      Not all items are recorded in the Ever section.\n\r", viewer );
		stc(         " +---------------------+-----------------+-----------------+\n\r", viewer );
		stc(         " | {wStat{x                | {wThis Session{x    | {wEver{x            |\n\r", viewer );
		stc(         " +---------------------+-----------------+-----------------+\n\r", viewer );
		ptc( viewer, "   XP Earned             %-17d N/A\n\r",
			ch->pcdata->summary[SUM_XP_EARNED] );
		ptc( viewer, "   Levels Gained         %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_LEVELS_GAINED], ch->pcdata->summary[SUM_LEVELS_GAINED_EVER] );
		ptc( viewer, "   Criticals Inflicted   %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_CRITICALS_INFLICTED], ch->pcdata->summary[SUM_CRITICALS_INFLICTED_EVER] );
		ptc( viewer, "   Criticals Taken       %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_CRITICALS_TAKEN], ch->pcdata->summary[SUM_CRITICALS_TAKEN_EVER] );
		ptc( viewer, "   Mob Kills             %-17d N/A\n\r",
			ch->pcdata->summary[SUM_MOB_KILLS] );
		ptc( viewer, "   PC Kills              %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_PC_KILLS], ch->pcdata->summary[SUM_PC_KILLS_EVER] );
		ptc( viewer, "   Deaths                %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_DEATHS], ch->pcdata->summary[SUM_DEATHS_EVER] );
		ptc( viewer, "   Tournies Won          %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_TOURNIES_WON], ch->pcdata->summary[SUM_TOURNIES_WON_EVER] );
		ptc( viewer, "   Trivia Answered       %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_TRIVIA_ANSWERED], ch->pcdata->summary[SUM_TRIVIA_ANSWERED_EVER]  );
		ptc( viewer, "   Motes                 %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_MOTES], ch->pcdata->summary[SUM_MOTES_EVER] );
		ptc( viewer, "   Auctions Won          %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_AUCTIONS_WON], ch->pcdata->summary[SUM_AUCTIONS_WON_EVER] );
		ptc( viewer, "   Rebirths              %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_REBIRTHS], ch->pcdata->rebirth );
		ptc( viewer, "   Quests Done           %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_QUESTS_DONE], ch->pcdata->summary[SUM_QUESTS_DONE_EVER] );
		ptc( viewer, "   QPs Earned            %-17d %-17d\n\r",
			ch->pcdata->summary[SUM_QPS_EARNED], ch->pcdata->summary[SUM_QPS_EARNED_EVER] );
	}
}
void do_summary( CHAR_DATA *ch , char *argument )
{
	char arg[MIL];
	CHAR_DATA *viewer;
	argument = one_argument( argument, arg );

	if ( arg == NULL || arg[0] == '\0' )
		show_summary( ch, NULL );
	else
	{
		viewer = get_exactchar_world( ch, arg );
		if ( viewer == NULL || ! viewer->desc || viewer->desc->connected != CON_PLAYING || (viewer->invis_level>0 && !IS_IMMORTAL(ch)) )
		{
			stc("Show your summary to who?\n\r", ch);
			return;
		}
		show_summary( ch, viewer );
	}
	return;
}
void do_repeat( CHAR_DATA *ch, char * argument )
{
	char arg1[MIL];
	char arg2[MIL];
    int count = 0;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( arg2[0] == '\0' )
    {
        stc( "Command can't be NULL. Make sure to include '' around the command\r\n", ch );
        stc( "Example: repeat 3 'train hp 10'\n\r", ch );
        return;
	}
    if ( strlen( arg1 ) < 1
    || ( count = atoi( arg1 ) ) < 1 )
    {
        stc( "Syntax:  Repeat <count> <command>\r\n", ch );
        return;
    }
	if ( count > 10 )
    {
        stc( "That's a little overkill.\r\n", ch );
        return;
    }
    for ( ; count > 0; count-- )
        interpret( ch, arg2 );
	return;
}

#define PTO_CHAR		    0
#define PTO_NOTCHAR_WORLD	    1
#define PTO_NOTVICT_WORLD		    2
#define PTO_VICT		    3

void p(CHAR_DATA *ch, void *vo, int to_flag, char *fmt, ... )
{
	CHAR_DATA *victim = (CHAR_DATA *) vo;
 	DESCRIPTOR_DATA *d;
	va_list ap; /* points to each unnamed arg in turn */
	char *p, *sval;
	int ival;
	char buf[MSL], buf2[MSL];
	char *string;

	buf[0] = '\0';
	string = buf;

	va_start(ap, fmt); /* make ap point to 1st unnamed arg */

	if(!ch)
		return;

	for(p = fmt; *p; p++)
	{	sval = NULL;
		if(*p != '%')
        {	*string++ = *p;
            continue;
		}

		switch (*++p)
        {	case 'd':
				ival = va_arg(ap, int);
				sval = buf2;
				sprintf(sval, "%d", ival);
				break;
			case 's':
				sval = va_arg(ap, char *);
				break;
			case 'n':
				sval = buf2;
				sprintf(sval, "%s", ch->name );
                break;
			case 'N':
				sval = buf2;
                if(!victim)
					sprintf(sval, "%c", *p);
				else
					sprintf(sval, "%s", victim->name);
					break;
			case 'h':
				sval = buf2;
				sprintf(buf2, "%s", ch->short_descr );
				break;
			case 'H':
				sval = buf2;
				if(!victim)
					sprintf(sval, "%c", *p );
				else
					sprintf(sval, "%s", victim->short_descr );
				break;
			default:
				*string++ = *p;
				break;
		}
		while(*sval && sval)
		*string++ = *sval++;
	}
	*string = '\0';
    switch(to_flag )
    {	case PTO_CHAR:
			if(!ch)
				return;
			send_to_char(buf, ch);
            break;
		case PTO_NOTCHAR_WORLD:
			for( d = descriptor_list; d; d = d->next )
			{	CHAR_DATA *wch;
				if(d->connected != CON_PLAYING )
					continue;
                wch = d->character ? d->character : d->original;
                if(wch == ch )
					continue;
                send_to_char(buf, wch);
            }
            break;
		case PTO_NOTVICT_WORLD:
				for( d= descriptor_list;d; d = d->next )
                {	CHAR_DATA *wch;
                    if( d->connected != CON_PLAYING )
						continue;
                    wch = d->character ? d->character : d->original;
                    if( wch == victim )
						continue;
                    send_to_char(buf,wch);
                }
                break;
		case PTO_VICT:
                if(!victim)
                     return;
                send_to_char(buf,victim);
                break;
      }
      va_end(ap); /* clean up when done */
      return;
}

void mentor_alert ( char *msg, ... )
{
	DESCRIPTOR_DATA *d_mentor;
	char buf[MSL], buf2[MSL];
	va_list args;

	va_start( args, msg );
	vsprintf(buf, msg, args );
	va_end( args );

	sprintf( buf2, "{w({GMentor Alert{w){W::{x {G%s{x\n\r", buf );
	for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
	{
		if ( d_mentor->connected == CON_PLAYING
		&& IS_SET( d_mentor->character->spec_flags, SPEC_MENTOR ) )
			stc( buf2, d_mentor->character );
    }
}
void mentor_send ( CHAR_DATA *ch, char *msg, ... )
{
	DESCRIPTOR_DATA *d_mentor;
	char buf[MSL], buf2[MSL];
	va_list args;

	va_start( args, msg );
	vsprintf(buf, msg, args );
	va_end( args );

	sprintf( buf2, "{w({GMentor %s{w){W::{x {G%s{x\n\r", ch->name, buf );
	for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
	{
		if ( d_mentor->connected == CON_PLAYING
		&& IS_SET( d_mentor->character->spec_flags, SPEC_MENTOR ) )
			stc( buf2, d_mentor->character );
    }
}
void do_version(CHAR_DATA *ch, char *argument)
{
	char buf[MSL];

	if (is_exact_name(ch->name, MUD_OWNER))
	{
	sprintf(buf, "%s, owned by YOU!\n\r", MUD_VERSION);
	stc(buf, ch);
	sprintf(buf, "Running on port %d\n\r", mud_port);
	stc(buf, ch);
	return;
	}
	sprintf(buf, "%s, owned by %s\n\r", MUD_VERSION, MUD_OWNER);
	stc(buf, ch);
	sprintf(buf, "Running on port %d\n\r", mud_port);
	stc(buf, ch);
	return;
}

bool mob_level_diff(int clevel, int mlevel)
{
    int levtmp;

    levtmp = clevel - mlevel ;
    if ( levtmp >= -1 && levtmp <= 9) return TRUE;
    else return FALSE;
}

void do_helpme( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char buf[MSL];
    char buf2[MSL];
    bool found = FALSE;
    int count = 0;

    buf2[0] = '\0';

    stc("Potential Victim     What Room?               What Area?\n\r", ch );
    for (victim = char_list; victim != NULL; victim = victim->next)
    {
		if (!IS_NPC(victim))
		{
		continue;
		}
        if (mob_level_diff(ch->level, victim->level) == TRUE )
		{
		sprintf(buf,"%-20s %-26s %-26s{x\n\r",
		victim->short_descr,
		victim->in_room == NULL ? "Unknown" : victim->in_room->name,
		victim->in_room->area->name == NULL ? "Unknown" : victim->in_room->area->name );
		stc( buf, ch );
		found = TRUE;
		}
		if ( found )
		{
			count += 1;
			if ( count > 99 )
			{
			stc("More than 100 mobiles were found.\n\r",ch);
			return;
			}
		}
    }
    if ( !found )
        stc("Sorry, couldn't find anything.\n\r", ch );
	return;
}

void display_races( CHAR_DATA *ch )
{
    int i = 0;
	stc( "The more times you have been Reborn, the more races available.\n\r",ch);
	stc( "The following races are available for You:\n\r\n\r",ch);
    for ( i = 0; race_table[i].name != NULL; i++ )
    {
        if ( !str_cmp( race_table[i].name, "unique" ) )
            continue;
        if ( !race_table[i].pc_race )
            continue;
        if ( ch->pcdata->rebirthing )
        {
            if ( ch->pcdata->rebirth >= race_table[i].remort
            && race_table[i].name != NULL )
                ptc( ch, " {w[{W%10s{w], {w%-69s {x\n\r", capit2( race_table[i].name ), race_table[i].descr );
            if ( race_table[i].name == NULL || race_table[i].name[0] == '\0' )
            {
                ptc( ch, "An error occured processing races at position %d.\n\r", i );
                break;
            }
        }
        else
        {
            if ( race_table[i].remort )
                continue;
            if ( race_table[i].name != NULL )
                ptc( ch, " {w[{W%10s{w], {w%-69s {x\n\r", capit2( race_table[i].name ), race_table[i].descr );
            if ( race_table[i].name == NULL || race_table[i].name[0] == '\0' )
            {
                ptc( ch, "An error occured processing races at position %d.\n\r", i );
                break;
            }
        }
    }
    return;
}

void display_illegal_name( CHAR_DATA *ch )
{
	stc( "\n\r", ch );
	stc(" {C+{c------------------------------------------------------------------{C+{x \n\r", ch);
	stc(" {c|{w WARNING! Illegal name!                                           {c| {x\n\r", ch);
	stc(" {c|{w This is likely a name that the Immortals have denied usage       {c| {x\n\r", ch);
	stc(" {c|{w to, because it does not fit into a Wheel of Time theme, or       {c| {x\n\r", ch);
	stc(" {c|{w is not being used appropriately here.                            {c| {x\n\r", ch);
	stc(" {c|{w Try another name.                                                {c| {x\n\r", ch);
	stc(" {C+{c------------------------------------------------------------------{C+{x \n\r", ch);
	stc( "\n\r", ch );
	return;
}
void display_denied_char( CHAR_DATA *ch )
{
	stc( "\n\r", ch );
	stc( " {C+{c------------------------------------------------------------------{C+{x \n\r", ch );
	stc( " {c|{w WARNING! Denied Character!                                       {c|{x \n\r", ch );
	stc( " {c|{w Your character is denied access to TSE.                          {c|{x \n\r", ch );
	stc( " {C+{c------------------------------------------------------------------{C+{x \n\r", ch );
	stc( "\n\r", ch );
	return;
}
void display_banned_site( CHAR_DATA *ch )
{
	stc( "\n\r", ch );
	stc( " {C+{c------------------------------------------------------------------{C+{x \n\r", ch );
	stc( " {c|{w WARNING! Banned Site!                                            {c|{x \n\r", ch );
	stc( " {c|{w Your site has been banned from TSE.                              {c|{x \n\r", ch );
	stc( " {c|{w Someone logging into the game from this site has given the       {c|{x \n\r", ch );
	stc( " {c|{w Immortals cause to deny access from this site. If you have not   {c|{x \n\r", ch );
	stc( " {c|{w been to the game before, we apologize for the inconvenience.     {c|{x \n\r", ch );
	stc( " {C+{c------------------------------------------------------------------{C+{x \n\r", ch );
	stc( "\n\r", ch );
	return;
}
void display_game_wizlocked( CHAR_DATA *ch )
{
	stc(  "\n\r", ch );
	stc(  "  +------------------------------------------------------------------+ \n\r", ch );
	stc(  "  | WARNING! Game locked!                                            | \n\r", ch );
	stc(  "  | TSE is currently locked. Non-Immortal players are currently      | \n\r", ch );
	stc(  "  | not allowed access to the game. This may be for maintenance or   | \n\r", ch );
	stc(  "  | other reasons. Please try back again later.                      | \n\r", ch );
	stc(  "  +------------------------------------------------------------------+ \n\r", ch );
	stc(  "\n\r", ch );
	return;
}
void display_game_wizlocked_descriptor( DESCRIPTOR_DATA *d)
{
	write_to_buffer( d, "\n\r", 0 );
	write_to_buffer( d, "  +------------------------------------------------------------------+ \n\r", 0 );
	write_to_buffer( d, "  | WARNING! Game locked!                                            | \n\r", 0 );
	write_to_buffer( d, "  | TSE is currently locked. Non-Immortal players are currently      | \n\r", 0 );
	write_to_buffer( d, "  | not allowed access to the game. This may be for maintenance or   | \n\r", 0 );
	write_to_buffer( d, "  | other reasons. Please try back again later.                      | \n\r", 0 );
	write_to_buffer( d, "  +------------------------------------------------------------------+ \n\r", 0 );
	write_to_buffer( d, "\n\r", 0 );
	return;
}
void display_game_newlocked( CHAR_DATA *ch )
{
	stc(  "\n\r", ch );
	stc(  "  +------------------------------------------------------------------+ \n\r", ch );
	stc(  "  | WARNING! Game locked!                                            | \n\r", ch );
	stc(  "  | TSE is currently locked. Newly created players are currently     | \n\r", ch );
	stc(  "  | not allowed access to the game. This may be for maintenance or   | \n\r", ch );
	stc(  "  | other reasons. Please try back again later.                      | \n\r", ch );
	stc(  "  +------------------------------------------------------------------+ \n\r", ch );
	stc(  "\n\r", ch );
	return;
}
void display_new_name( CHAR_DATA *ch )
{
	stc(  "\n\r", ch );
	stc( "  {C+{c------------------------------------------------------------------{C+{x \n\r",ch);
	stc( "  {c|{w Your name was not found in our databases.                        {c|{x \n\r",ch);
	stc( "  {c|{w Welcome to TSE!                                                  {c|{x \n\r",ch);
	stc( "  {c|{w                                                                  {c|{x \n\r",ch);
	stc( "  {c|{w Please verify your name for us...                                {c|{x \n\r",ch);
	stc( "  {c|{w                                                                  {c|{x \n\r",ch);
	stc( "  {c|{w Your name should be one that fits with a Wheel of Time theme.    {c|{x \n\r",ch);
	stc( "  {c|{w If the Immortals find that your name is not acceptable, you      {c|{x \n\r",ch);
	stc( "  {c|{w may be asked to change it.                                       {c|{x \n\r",ch);
	stc( "  {C+{C------------------------------------------------------------------{C+{x \n\r",ch);
	stc(  "\n\r", ch );
	return;
}
void confirm_new_name( CHAR_DATA *ch )
{
	stc(  "\n\r", ch );
	stc( "  {C+{c------------------------------------------------------------------{C+{x \n\r",ch);
	stc( "  {c|{w Names in TSE must not be comprised of dictionary words. They     {c|{x \n\r",ch);
	stc( "  {c|{w must not have meaning in another language, must not contain      {c|{x \n\r",ch);
	stc( "  {c|{w profanities, and must not be a character from the Wheel of       {c|{x \n\r",ch);
	stc( "  {c|{w Time books. Names should be able to be pronounced in the English {c|{x \n\r",ch);
	stc( "  {c|{w Language. Examples of bad names are Deathbringer, Smurfette,     {c|{x \n\r",ch);
	stc( "  {c|{w LordRand. If an existing character creates an 'alt' character    {c|{x \n\r",ch);
	stc( "  {c|{w with a bad name, that name is likely to be denied on the spot    {c|{x \n\r",ch);
	stc( "  {c|{w with no questions asked, and may cause the existing character to {c|{x \n\r",ch);
	stc( "  {c|{w suffer penalties within TSE. This policy is strictly enforced.   {c|{x \n\r",ch);
	stc( "  {C+{c------------------------------------------------------------------{C+{x \n\r",ch);
	stc(  "\n\r", ch );
	return;
}
void display_invalid_password( CHAR_DATA *ch )
{
	stc(  "\n\r", ch );
	stc(  "  {C+{c------------------------------------------------------------------{C+{x\n\r", ch );
	stc(  "  {c|{w An invalid password for this player was entered.                 {c|{x\n\r", ch );
	stc(  "  {c|{w                                                                  {c|{x\n\r", ch );
	stc(  "  {c|{w Goodbye.                                                         {c|{x\n\r", ch );
	stc(  "  {C+{c------------------------------------------------------------------{C+{x \n\r", ch );
	stc(  "\n\r", ch );
	return;
}

void do_quoter(CHAR_DATA *ch)
{
  int num;

  num = number_range(1,19);

  switch(num)
  {
    case 1:
    stc("\n\r{wKneel or you will be knelt.{x\n\r\n\r",ch);
        break;
    case 2:
    stc("\n\r{w      And it came to pass in those days, as it had come before and.\n\r",ch);
    stc("      would come again, that the Dark lay heavy on the land and\n\r",ch);
    stc("      weighed down the hearts of men, and the green things failed,\n\r",ch);
    stc("      and hope died. And men cried out to the Creator, saying, O\n\r",ch);
    stc("      Light of the Heavens, Light of the World, let the Promised One\n\r",ch);
    stc("      be born again on the mountain, according to the prophecies, as he\n\r",ch);
    stc("      was in ages past, and will be in ages to come. Let the Prince of\n\r",ch);
    stc("      the Morning sing to the land that green things will grow and the\n\r",ch);
    stc("      valleys give forth lambs. Let the arm of the Lord of the Dawn\n\r",ch);
    stc("      shelter us from the Dark, and the great sword of justice defend\n\r",ch);
    stc("      us. Let the dragon ride again on the winds of time.\n\r\n\r{x",ch);
	stc("                 --From the Prophecies of the Dragon\n\r\n\r",ch);
            break;
    case 3:
    stc("\n\r{w      And his paths shall be many, and who shall know his name,\n\r",ch);
    stc("      for he shall be born among us many times, as he has been\n\r",ch);
    stc("      and ever will be, time without end. His coming shall be like\n\r",ch);
    stc("      the sharp edge of the plow, turning our lives in furrows\n\r",ch);
    stc("      from out of the places where we lie in our silence. The\n\r",ch);
    stc("      breaker of bonds, the forger of chains. The maker of futures,\n\r",ch);
    stc("      the unshaper of destinies.\n\r\n\r{x",ch);
	stc("                 --From the Prophecies of the Dragon\n\r\n\r",ch);
        break;
    case 4:
    stc("\n\r{w      The lions sing and the hills take flight.\n\r",ch);
    stc("      The moon by day and the sun by night.\n\r",ch);
    stc("      Blind woman, deaf man, jackdaw fool.\n\r",ch);
    stc("      Let the Lord of Chaos rule.\n\r\n\r{x",ch);
	stc("                 --From a childrens game\n\r\n\r",ch);
        break;
    case 5:
    stc("\n\r{w      And it shall come to pass that what men made shall be shattered,\n\r",ch);
    stc("      and the Shadow shall lie across the Pattern of the Age, and the\n\r",ch);
    stc("      Dark One shall once again lay his hand upon the world of man.\n\r",ch);
    stc("      Women shall weep and men quail as the nations of the earth are\n\r",ch);
    stc("      rent like rotting cloth. Neither shall anything stand or abide.\n\r",ch);
	stc("                 --From the Prophecies of the Dragon\n\r\n\r",ch);
    stc("\n\r{x",ch);
        break;
    case 6:
    stc("\n\r{w      With his coming are the dread fires born again. The hills burn and\n\r",ch);
    stc("      the land turns sere. The tides of men run and out and the hours\n\r",ch);
    stc("      dwindle. The wall is pierced and the veil of parting raised. Storms\n\r",ch);
    stc("      rumble beyond the horizon, and the fires of heaven purge the earth.\n\r",ch);
    stc("      There is no salvation without destruction, no hope this side of\n\r",ch);
    stc("      death.\n\r",ch);
    stc("\n\r{x",ch);
	stc("                 --From the Prophecies of the Dragon\n\r\n\r",ch);
        break;
    case 7:
    stc("\n\r{w      Dovie'andi se tovya sagain.\n\r\n\r",ch);
    stc("{x{Y      From the Old Tongue, meaning:\n\r\n\r",ch);
    stc("{x{w      Time to roll the dice...\n\r\n\r{x",ch);
	stc("                 --Matrim Cauthon\n\r\n\r",ch);
        break;
    case 8:
    stc("\n\r{w      Believe nothing you hear, and only half of what you see.\n\r\n\r{x",ch);
    stc("\n\r\n\r",ch);
        break;
    case 9:
    stc("\n\r{w      May you shelter in the palm of the Creator's hand.\n\r{x",ch);
        break;
	case 10:
	stc("\n\r{w      Death is lighter than a feather,\n\r",ch);
	stc("          Duty heavier than a mountain.\n\r\n\r{x",ch);
    stc("                    --A saying in the Borderlands\n\r\n\r",ch);
		break;
    case 11:
    stc("\n\r{w      Dance with her and she will forgive much,\n\r",ch);
    stc("      Dance well and she will forgive anything.\n\r\n\r,{x",ch);
        break;
    case 12:
    stc("\n\r{w      Daughter of the Night, she walks again.\n\r",ch);
    stc("      The ancient war, she yet fights.\n\r",ch);
	stc("      The ancient war, she yet fights.\n\r",ch);
	stc("      Her new lover she seeks, who shall serve her and die, yet serve her still.\n\r",ch);
	stc("      Who shall stand against her coming?\n\r",ch);
	stc("      The Shining Walls shall kneel.\n\r",ch);
	stc("      Blood feeds blood.\n\r",ch);
	stc("      Blood calls blood.\n\r",ch);
	stc("      Blood is, and blood was, and blood shall ever be.\n\r\n\r{x",ch);
	stc("                 (Scrawled in blood on a dungeon\n\r",ch);
	stc("                  wall in Fal Dara.)\n\r\n\r",ch);
        break;
	case 13:
	stc("\n\r{w      The man who channels stands alone.\n\r",ch);
	stc("      He gives his friends for sacrifice.\n\r",ch);
	stc("      Two roads before him, one death beyond dying, one to life eternal.\n\r",ch);
	stc("      Which will he choose? Which will he choose?\n\r",ch);
	stc("      What hand shelters? What hand slays?\n\r",ch);
	stc("      Blood feeds blood.\n\r",ch);
	stc("      Blood calls blood.\n\r",ch);
	stc("      Blood is, and blood was, and blood shall ever be.\n\r\n\r{x",ch);
	stc("                 (Scrawled in blood on a dungeon\n\r",ch);
	stc("                  wall in Fal Dara.)\n\r\n\r",ch);
		break;
	case 14:
	stc("\n\r{w      Five will ride forth, and four return. Above the watchers shall he proclaim\n\r",ch);
	stc("      himself, bannered cross the sky. . . . \n\r\n\r{x",ch);
		break;
	case 15:
	stc("\n\r{w      Twice and twice shall he be marked, twice to live, and twice to die.\n\r",ch);
	stc("      Once the heron, to set his path. Twice the heron, to name him true.\n\r",ch);
	stc("      Once the Dragon, for rememberance lost. Twice the Dragon, for the\n\r",ch);
	stc("      Price he must pay.\n\r",ch);
	stc("      Twice dawns the day when his blood is shed.\n\r",ch);
	stc("      Once for mourning, once for birth.\n\r",ch);
	stc("      Red on black, the Dragon's blood stains the rock of Shayol Ghul.\n\r",ch);
	stc("      In the Pit of Doom shall his blood free men from the Shadow.{x\n\r\n\r",ch);
		break;
	case 16:
	stc("\n\r{w      Power of the Shadow made flesh, wakened to turmoil, strife and ruin.\n\r",ch);
	stc("      The Reborn One, marked and bleeding, dances the sword in dreams and mist,\n\r",ch);
	stc("      chains the Shadowsworn to his will, from the city, lost and forsaken,\n\r",ch);
	stc("      leads the spears to war once more, breaks the spears and makes them see,\n\r",ch);
	stc("      truth long hidden in the ancient dream.\n\r\n\r{x",ch);
		break;
	case 17:
	stc("\n\r{w      As the plow breaks the earth shall he break the lives of men,\n\r",ch);
	stc("      and all that was shall be consumed in the fire of his eyes.\n\r",ch);
	stc("      The trumpets of war shall sound at his footsteps,\n\r",ch);
	stc("      the ravens feed at his voice, and he shall wear a Crown of Swords.\n\r{x",ch);
		break;
	case 18:
	stc("\n\r      (sung to 'The Ballad of Jed Clampett', aka\n\r{x",ch);
	stc("           The Beverly Hillbillies theme) \n\r{x",ch);
	stc("      Come an' listen to a story 'bout a man named Mik, \n\r{x",ch);
	stc("      big time quester and a magnet to the chicks!\n\r{x",ch);
	stc("      Then one day he was asking for the clerk,\n\r{x",ch);
	stc("      'Sorry my friend,' (she said) 'we now only sell the dirks!'\n\r{x",ch);
	stc("      Emerald that is.  Small.  Green.  Mean.'\n\r{x",ch);
	stc("      'First thing you know ol' Mik's a millionaire.\n\r{x",ch);
	stc("      Ailek says 'Mikell I'll pull out your hair!', said\n\r{x",ch);
	stc("      'Gimme emerald stuff is what you oughta do!'\n\r{x",ch);
	stc("      So Mikell got his good buddy some nice QEQ.\n\r{x",ch);
	stc("      Cuendillar, that is.  Emerald blades.  Staves.\n\r{x",ch);
	stc("      'Y'all go questing now, 'hear?'\n\r{x",ch);
		break;
	default:
	stc("\n\r      (sung to 'The Ballad of Jed Clampett', aka\n\r{x",ch);
	stc("           The Beverly Hillbillies theme) \n\r{x",ch);
	stc("      Come and listen to a story bout a man named Taim\n\r{x",ch);
	stc("      Just another False Dragon, was his only claim to fame.\n\r{x",ch);
	stc("      And then one day, he heard voices in his head\n\r{x",ch);
	stc("      Saying 'Youre not Taim - your names Demandred!'\n\r{x",ch);
	stc("      Chosen, that is. Wouldst thou be Naeblis? \n\r{x",ch);
	stc("      Well, the next thing you know, ol Mazrims at the Bore.\n\r{x",ch);
	stc("      The Great Lord says, 'Boy, you gotta watch AlThor!'\n\r{x",ch);
	stc("      'That so-called Black Towers the place I want you in!\n\r{x",ch);
	stc("      So Demandred-slash-Taim becomes an Ashaman.\n\r{x",ch);
	stc("      Mhael, that is. Number two guy -- again! \n\r{x",ch);
	stc("      So Taimandred runs Rands Ashaman school\n\r{x",ch);
	stc("      By the Great Lords word, lets the Lord of Chaos rule.\n\r{x",ch);
	stc("      And Rand doesnt know that a Chosen is his aide,\n\r{x",ch);
	stc("      Or that he will soon by Mazrim be betrayed.\n\r{x",ch);
	stc("      Sold up the river, that is. Ratted out. \n\r{x",ch);
	stc("      See, the Great Lord wants the Dragon as Naeblis\n\r{x",ch);
	stc("      But Demandred really doesnt like the sound of this.\n\r{x",ch);
	stc("      'Damn!' he thinks, 'Ill *still* be number two!\n\r{x",ch);
	stc("      'I cant get past Lews Therin, no matter *what* I do!\n\r{x",ch);
	stc("      Jealous, he is. Positively green. \n\r{x",ch);
	stc("      Come and listen to a story bout a man named Taim \n\r{x",ch);
	stc("      Once he was a Chosen of wide and dreadful fame\n\r{x",ch);
	stc("      But then one day the Dark One he defied\n\r{x",ch);
	stc("      So He dropped him in the Pit of Doom until he fried.\n\r{x",ch);
	stc("      Well done, that is. Thou art Naecrisp.\n\r{x",ch);
	stc("      \n\r",ch);
	stc("                  -By Ariella, Great Mistress of the Dark .\n\r\n\r",ch);
    }

  return;
}
