/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"
#include "mysql5_interface.h"

char * show_rbi_letter args((CHAR_DATA *ch));
/* for  keeping track of the player count */
int max_on = 0;
int seeing args(( CHAR_DATA *ch, CHAR_DATA *victim ));
void show_seer args(( CHAR_DATA *ch, CHAR_DATA *victim ));
int true_angreal_bonus args(( CHAR_DATA *ch ));
void draw_map args(( CHAR_DATA *ch, char *desc ));
bool    blademaster args( ( CHAR_DATA *ch ) );
bool can_remort args(( CHAR_DATA *ch ));

OBJ_DATA *  get_obj_keeper  args( (CHAR_DATA *ch,CHAR_DATA *keeper,char *argument));
CHAR_DATA *find_keeper args(( CHAR_DATA *ch ));
void keeper_say args(( CHAR_DATA *ch, char *argument ));
void appraise_object args((CHAR_DATA *ch, OBJ_DATA *obj, bool plrmarket));
char * format_str_len args((char * string, int length, int align));
bool in_safe_room args(( CHAR_DATA *victim ));


#define ALIGN_LEFT           1
#define ALIGN_RIGHT          2
#define ALIGN_CENTER         3

/*
 * Local functions.
 */
char *	format_obj_to_char	args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    bool fShort ) );
void	show_list_to_char	args( ( OBJ_DATA *list, CHAR_DATA *ch,
				    bool fShort, bool fShowNothing, bool inCont ) );
void	show_char_to_char_0	args( ( CHAR_DATA *victim, CHAR_DATA *ch ) );
void	show_char_to_char_1	args( ( CHAR_DATA *victim, CHAR_DATA *ch ) );
void	show_char_to_char	args( ( CHAR_DATA *list, CHAR_DATA *ch ) );
void     peek_char              args( ( CHAR_DATA *ch, CHAR_DATA *victim));
bool	check_blind		args( ( CHAR_DATA *ch ) );
void    look_sky args(( CHAR_DATA *ch ));

/* Remort stuff */
int calc_remort_tier( CHAR_DATA *ch);
char * get_remort_title (CHAR_DATA *ch);

#define NUM_DAYS 28
#define NUM_MONTHS 13
#define MAP_WIDTH 72
#define SHOW_WIDTH MAP_WIDTH/2
#define MAP_HEIGHT 9
/* Should be the string length and number of the constants below.*/
const char * star_map[] =
{
"   W.N     ' .     :. M,N     :  y:.,N    `  ,       B,N      .      .  ",
" W. :.N .      G,N  :M.: .N  :` y.N    .      :     B:   .N       :     ",
"    W:N    G.N:       M:.,N:.:   y`N      ,    c.N           .:    `    ",
"   W.`:N       '. G.N  `  : ::.      y.N      c'N      B.N R., ,N       ",
" W:'  `:N .  G. N    `  :    .y.N:.          ,     B.N      :  R:   . .N",
":' '.   .    G:.N      .'   '   :::.  ,  c.N   :c.N    `        R`.N    ",
"      :       `        `        :. ::. :     '  :        ,   , R.`:N    ",
"  ,       G:.N              `y.N :. ::.c`N      c`.N   '        `      .",
"     ..        G.:N :           .:   c.N:.    .              .          "
};

const char * sun_map[] =
{
"\\'|'/",
"- O -",
"/.|.\\"
};
const char * moon_map[] =
{
" @@@ ",
"@@@@@",
" @@@ "
};

const char * blood_table [] =
{
	" is in perfect shape.",
	" has a few nicks and scrapes.",
	" is bruised and cut.",
	" is bruised and bleeding.",
	" is bleeding from some nasty wounds.",
	" is in pretty bad shape.",
	" is bleeding from several open wounds.",
	" looks like a walking corpse.",
	" is bleeding to death.",
	" is knocking on death's door."
};

char *	const	where_name	[] =
{
    "{c<{was a light{c>{x        ",
    "{c<{wover the eyes{c>{x     ",
    "{c<{win the nose{c>{x       ",
    "{c<{waround the neck{c>{x   ",
    "{c<{waround the neck{c>{x   ",
    "{c<{won the head{c>{x       ",
	"{c<{win left ear{c>{x       ",
	"{c<{win right ear{c>{x      ",
    "{c<{won the hands{c>{x      ",
    "{c<{won left wrist{c>{x     ",
    "{c<{won right wrist{c>{x    ",
    "{c<{wleft ring finger{c>{x  ",
    "{c<{wright ring finger{c>{x ",
    "{c<{won the arms{c>{x       ",
    "{c<{won left forearm{c>{x   ",
    "{c<{won right forearm{c>{x  ",
    "{c<{won the body{c>{x       ",
    "{c<{wabout the body{c>{x    ",
    "{c<{waround the waist{c>{x  ",
    "{c<{won the legs{c>{x       ",
    "{c<{won the feet{c>{x       ",
    "{c<{won left calf{c>{x      ",
    "{c<{won right calf{c>{x     ",
    "{c<{won left thigh{c>{x     ",
    "{c<{won right thigh{c>{x    ",
	"{c<{won left ankle{c>{x     ",
	"{c<{won right ankle{c>{x    ",
    "{c<{won the shoulders{c>{x  ",
    "{c<{won the back{c>{x       ",
    "{c<{was a sheath{c>{x       (not used yet)",   /* 29 */  /* if these become used, fix do_equipment */
	"{c<{was a pouch{c>{x        (not used yet)",
	"{c<{was underclothes{c>{x   (not used yet)",
    "{c<{was a shield{c>{x       ",
    "{c<{wheld in hands{c>{x     ",
    "{c<{wright hand weapon{c>{x ",
    "{c<{wleft hand weapon{c>{x  ",
    "{c<{wfloating nearby{c>{x   ",
    "{c<{wnear the mind{c>{x     ",
    "{c<{wover the face{c>{x     ",
    "{c<{was an angreal{c>{x     ",
};

const struct weave_talents_type weave_talents_table [] =
{
	{   TALENT_NONE,           "none" },
	{   TALENT_WARDING,        "warding" },
	{   TALENT_ELEMENTALISM,   "elementalism" },
	{   TALENT_HEALING,        "healing" },
	{   TALENT_CLOUD_DANCING,  "cloud dancing" },
	{   TALENT_EARTH_SINGING,  "earth singing" },
};

void strip_dye_colors(char *buf)
{
	int i, x = 0;
	char *buf2 = str_dup(buf);

	for (i = 0; i < strlen(buf2); i++)
	{
		if (buf2[i] == '{')
		{
			if (buf2[i+1] == '1')	{	i++; continue;	}
			if (buf2[i+1] == '2')	{	i++; continue;	}
			if (buf2[i+1] == '3')	{	i++; continue;	}
			if (buf2[i+1] == '4')	{	i++; continue;	}
		}

		buf[x] = buf2[i];
		x++;
	}

	buf[x] = '\0';

	free_string(buf2);
	return;
}

bool check_vowell args((const char *str));

char *check_dye(OBJ_DATA *obj, char *string, int dye_vnum)
{
	static char buf[MAX_STRING_LENGTH];
	OBJ_INDEX_DATA *dye;
	int i;

	buf[0] = '\0';

	if (obj != NULL)
	{
		if (obj->item_type == ITEM_CRAFTING_MATERIAL)
		{
			if (obj->value[0] == 4)
			{
				if (check_vowell(obj->short_descr))	strcat(buf, "an ");
				else					strcat(buf, "a ");
			}
			else			strcat(buf, "some ");
		}

		if (obj->item_type == ITEM_DYE)
			strcat(buf, "a vial of ");

		if (obj->item_type == ITEM_ADORNMENT)
		{
			if (check_vowell(obj->short_descr))	strcat(buf, "an ");
			else					strcat(buf, "a ");
		}

		strcat (buf, obj->short_descr);

		if (obj->item_type == ITEM_DYE)
			strcat(buf, " {xdye");

		if (obj->item_type == ITEM_CRAFTING_MATERIAL && obj->value[0] == 4)
			strcat(buf, " {xgem");

		if (obj->item_type == ITEM_ADORNMENT)
		{
			if (!str_cmp(craftadorn_table[obj->value[0]].name, "with")
			|| !str_cmp(craftadorn_table[obj->value[0]].name, "bearing")
			|| !str_cmp(craftadorn_table[obj->value[0]].name, "tooling")
			|| !str_cmp(craftadorn_table[obj->value[0]].name, "affixment")
			|| !str_cmp(craftadorn_table[obj->value[0]].name, "fashioning"))
				strcat(buf, " {xadornment");
			else
			{
				strcat(buf, " {x");
				strcat(buf, craftadorn_table[obj->value[0]].name);
			}
		}

	}
	else strcat (buf, string);


	if ((dye = get_obj_index(dye_vnum)) != NULL)
	{
		for (i = 0; i < strlen(buf); i++)
		{
			if (buf[i] != '{')	continue;
			if (buf[i+1] == '1')	buf[i+1] = craftcolors_table[dye->value[0]].name[0];
			if (buf[i+1] == '2')	buf[i+1] = craftcolors_table[dye->value[1]].name[0];
			if (buf[i+1] == '3')	buf[i+1] = craftcolors_table[dye->value[2]].name[0];
			if (buf[i+1] == '4')	buf[i+1] = craftcolors_table[dye->value[3]].name[0];
		}
	}
	else strip_dye_colors(buf);

	return buf;
}

char *format_obj_to_char( OBJ_DATA *obj, CHAR_DATA *ch, bool fShort )
{
    static char buf[MAX_STRING_LENGTH];
//	OBJ_INDEX_DATA *dye;
//	int i;

    buf[0] = '\0';

    if ((fShort && (obj->short_descr == NULL || obj->short_descr[0] == '\0'))
    ||  (obj->description == NULL || obj->description[0] == '\0'))
	return buf;
	if (obj->item_type == ITEM_PORTAL)        strcat( buf, "{w({WPortal{w){x "     );
	if (obj->item_type == ITEM_WINDOW)        strcat( buf, "{w({WWindow{w){x "     );
    if ( IS_OBJ_STAT(obj, ITEM_INVIS)     )   strcat( buf, "{w({WInvis{w){x "     );

    if ( IS_AFFECTED(ch, AFF_DETECT_EVIL)
         && IS_OBJ_STAT(obj, ITEM_EVIL)   )   strcat( buf, "{R({rRed Aura{R){x "  );

    if ( IS_AFFECTED(ch, AFF_DETECT_MAGIC)
         && IS_OBJ_STAT(obj, ITEM_MAGIC)  )   strcat( buf, "{m({MMagical{m){x "   );
    if ( obj->item_type == ITEM_FIREOIL
        && obj->value[1] == 1 )               strcat( buf, "{R({rB{Rurnin{rg{R){x " );
    if ( IS_OBJ_STAT(obj, ITEM_GLOW)      )   strcat( buf, "{w({WGlowing{w){x "   );
    if ( IS_OBJ_STAT(obj, ITEM_HUM)       )   strcat( buf, "{y({YHumming{y){x "   );
    if ( IS_OBJ_STAT(obj, ITEM_SHIMMER)       )   strcat( buf, "{w({WSh{wi{Dm{wm{De{wri{Wng{w){x "   );
    if ( IS_OBJ_STAT(obj, ITEM_SPIKED)       )   strcat( buf, "{r({RS{wp{Dik{we{Rd{r){x "   );
    if ( IS_OBJ_STAT(obj, ITEM_BALANCED)       )   strcat( buf, "{y({YBalanced{y){x "   );

    if ( fShort )
    {
	strcat(buf, check_dye(obj, NULL, obj->dye_vnum));
/*
	if (obj->item_type == ITEM_CRAFTING_MATERIAL)
	{
		if (obj->value[0] == 4)	strcat(buf, "a ");
		else			strcat(buf, "some ");
	}

	if (obj->item_type == ITEM_DYE)
		strcat(buf, "a vial of ");

	if ( obj->short_descr != NULL )
	    strcat( buf, obj->short_descr );

	if (obj->item_type == ITEM_DYE)
		strcat(buf, " {xdye");

	if (obj->item_type == ITEM_CRAFTING_MATERIAL && obj->value[0] == 4)	strcat(buf, " {xgem");
*/
    }
    else
    {
	if ( obj->description != NULL)
	    strcat( buf, obj->description );
    }

/*
	if ((dye = get_obj_index(obj->dye_vnum)) != NULL)
	{
		for (i = 0; i < strlen(buf); i++)
		{
			if (buf[i] != '{')	continue;
			if (buf[i+1] == '1')	buf[i+1] = craftcolors_table[dye->value[0]].name[0];
			if (buf[i+1] == '2')	buf[i+1] = craftcolors_table[dye->value[1]].name[0];
			if (buf[i+1] == '3')	buf[i+1] = craftcolors_table[dye->value[2]].name[0];
			if (buf[i+1] == '4')	buf[i+1] = craftcolors_table[dye->value[3]].name[0];
		}
	}
	else strip_dye_colors(buf);
*/
    return check_dye(NULL, buf, obj->dye_vnum);
}



/*
 * Show a list to a character.
 * Can coalesce duplicated items.
 */
void show_list_to_char( OBJ_DATA *list, CHAR_DATA *ch, bool fShort, bool fShowNothing, bool inCont )
{
    char buf[MAX_STRING_LENGTH];
    BUFFER *output;
    char **prgpstrShow;
    int *prgnShow;
    char *pstrShow;
    OBJ_DATA *obj;
    int nShow;
    int iShow;
    int count, oCount = 0;
    bool fCombine;

    if ( ch->desc == NULL )
	return;

    /*
     * Alloc space for output lines.
     */
    output = new_buf();

    count = 0;
    for ( obj = list; obj != NULL; obj = obj->next_content )
    {
		count++;
	}

    prgpstrShow	= alloc_mem( count * sizeof(char *) );
    prgnShow    = alloc_mem( count * sizeof(int)    );
    nShow	= 0;

    /*
     * Format the list of objects.
     */
    for ( obj = list; obj != NULL; obj = obj->next_content )
    {
		if ( obj->wear_loc == WEAR_NONE && can_see_obj( ch, obj ))
		{

			if ( inCont && obj->in_obj )
				oCount++;

			if ( ( obj->item_type == ITEM_PORTAL )
			&& !IS_SET( ch->act,PLR_HOLYLIGHT ) )
				continue;

			if ( ( obj->item_type == ITEM_WINDOW )
			&& !IS_SET( ch->act,PLR_HOLYLIGHT ) )
				continue;

		    pstrShow = format_obj_to_char( obj, ch, fShort );

		    fCombine = FALSE;

		    if ( IS_NPC(ch) || IS_SET(ch->comm, COMM_COMBINE) )
		    {
				/*
				 * Look for duplicates, case sensitive.
				 * Matches tend to be near end so run loop backwords.
				 */
				for ( iShow = nShow - 1; iShow >= 0; iShow-- )
				{
				    if ( !strcmp( prgpstrShow[iShow], pstrShow ) )
				    {
						prgnShow[iShow]++;
						fCombine = TRUE;
						break;
				    }
				}
		    }

		    /*
		     * Couldn't combine, or didn't want to.
		     */
		    if ( !fCombine )
		    {
				prgpstrShow [nShow] = str_dup( pstrShow );
				prgnShow    [nShow] = 1;
				nShow++;
		    }
		}
    }

    /*
     * Output the formatted list.
     */
    for ( iShow = 0; iShow < nShow; iShow++ )
    {
		if (prgpstrShow[iShow][0] == '\0')
		{
		    free_string(prgpstrShow[iShow]);
		    continue;
		}

		if ( IS_NPC(ch) || IS_SET(ch->comm, COMM_COMBINE) )
		{
		    if ( prgnShow[iShow] != 1 )
		    {
				sprintf( buf, "{c({w%2d{c){c ", prgnShow[iShow] );
				add_buf(output,buf);
		    }
		    else
		    {
				add_buf(output,"     ");
		    }
		}

		add_buf(output,prgpstrShow[iShow]);
		add_buf(output,"\n\r");
		free_string( prgpstrShow[iShow] );
    }

    if ( fShowNothing && nShow == 0 )
    {
		if ( IS_NPC(ch) || IS_SET(ch->comm, COMM_COMBINE) )
		    stc( "{c     ", ch );
		stc( "{cNothing.{c\n\r", ch );
    }
    if ( inCont && oCount > 0 )
	    ptc( ch, "You count %d items in the container.\n\r", oCount );

    page_to_char(buf_string(output),ch);

    /*
     * Clean up.
     */
    free_buf(output);
    free_mem( prgpstrShow, count * sizeof(char *) );
    free_mem( prgnShow,    count * sizeof(int)    );

    return;
}



void show_char_to_char_0( CHAR_DATA *victim, CHAR_DATA *ch )
{
    char buf[MAX_STRING_LENGTH],message[MAX_STRING_LENGTH];
    int i = 0;

    buf[0] = '\0';

    if ( RIDDEN(victim) )
    {
	if ( ch != RIDDEN(victim) )
	    strcat( buf, "{c({wRidden{c){x " );
	else
	    strcat( buf, "{c({wYour mount{c){x " );
	}
    if (IS_SET(victim->comm,COMM_AFK))           strcat(buf, "{c[{wAFK{c]{x ");
    if (IS_SET(victim->penalty_flags,PENAL_NOCHANNELS)
    && !IS_NPC(victim))                          strcat(buf, "{c[{wSilenced{c]{x ");
    if (IS_SET(victim->penalty_flags,PENAL_JAILED)
    && !IS_NPC(victim))
    {
	    strcat(buf, "At the the stockades is:{x\n\r" );
    	strcat(buf, "{c[{wJailed{c]{x ");
    }
    if ( !IS_NPC( victim ) && IS_SET( victim->war_flags, WAR_BATTLE ) )
    	strcat( buf, "{w[{RW{ra{RR{w]{x " );

    if ( !IS_NPC( victim ) && IS_SET( victim->war_flags, WAR_TOURNEY ) )
    	strcat( buf, "{w[{rTo{Ru{wrn{rey{w]{x " );

	if (!IS_NPC (victim) && IS_SET (victim->pcdata->tag_flags, TAG_FROZEN)
	&& IS_SET (victim->pcdata->tag_flags, TAG_PLAYING))
	{
		strcat( buf, "{y[{YTagged{y]{x " );
	}
	if ( !IS_NPC( victim ) )
	{
	    if ( IS_SET (victim->pcdata->tag_flags, TAG_RED) ) strcat( buf, "{R[RED] {x" );
	    if ( IS_SET (victim->pcdata->tag_flags, TAG_BLUE) ) strcat( buf, "{B[BLUE] {x" );
	}

/*
	if (!IS_NPC(victim)
	&& !IS_NPC(ch)
	&& is_gqmob(ch, victim->pIndexData->vnum) != -1)
	{
	    strcat(buf, "(Quest) ");
	}
*/
    if (IS_SET(victim->war_flags,WAR_HELD))      strcat(buf, "{r[{RHeld{r]{x ");

    if (IS_AFFECTED(victim, AFF_INVISIBLE))      strcat(buf, "{c({wInvis{c){x ");

    if (victim->invis_level >= LEVEL_HERO)       strcat(buf, "{c({wWizi{c){x ");

    if (IS_AFFECTED(victim, AFF_HIDE))           strcat(buf, "{c({wHide{c){x ");

    if ( (IS_NPC(victim) && ch->questmob > 0
    && victim->pIndexData->vnum == ch->questmob)
    || ( IS_NPC( victim ) &&ch->qmob != NULL
    && victim->questor != NULL
    && victim->questor == ch ) )
	    strcat(buf, "{R[{rTA{RRG{rET{R]{x ");

    if ( IS_NPC(victim) && IS_IMMORTAL(ch) && IS_SET(victim->act,ACT_UNDEAD))
	   strcat(buf, "{R[{rQUE{RST{rMOB{R]{x ");

/*
    if (IS_NPC(victim) && ch->qmob != NULL
    && victim->questor != NULL
    && victim->questor == ch) strcat(buf, "{R[{rTA{RRG{rET{R]{x ");
*/
    if ( IS_NPC(victim) && victim->position == victim->start_pos && victim->long_descr[0] != '\0' )
    {
		strcat( buf, victim->long_descr );
		strcat( buf, "{x");
		stc( buf, ch );
		return;
    }
    if ( IS_NPC(victim) && victim->position != POS_STANDING && victim->long_descr[0] != '\0' )
    {
    	if ( victim->position == POS_DEAD )
    		strcat( buf, "{b({BDead{b){x " );
    	else if ( victim->position == POS_MORTAL )
    		strcat( buf, "{r({RMortally Wounded{r){x " );
    	else if ( victim->position == POS_INCAP )
    		strcat( buf, "{y({rIncapacitated{r){x " );
    	else if ( victim->position == POS_STUNNED )
    		strcat( buf, "{Y({yStunned{Y){x " );
    	else if ( victim->position == POS_SLEEPING )
    		strcat( buf, "{W({wSleeping{W){x " );
    	else if ( victim->position == POS_RESTING )
    		strcat( buf, "{W({wResting{W){x " );
    	else if ( victim->position == POS_SITTING )
    		strcat( buf, "{W({wSitting{W){x " );
    	else if ( victim->position == POS_FIGHTING )
    		strcat( buf, "{g({GFighting{g){x " );
    	else
    		strcat( buf, "" );
		strcat( buf, victim->long_descr );


		stc( buf, ch );
		return;
    }
	if (!IS_NPC(victim) && victim->desc == NULL)
	{
		i = number_range(1,8);
		switch(i)
		{
		default: sprintf(buf,"The remains of %s, left behind by the Net Beast.{x\n\r",victim->name);                break;
	    case 1: sprintf(buf,"A pool of slime, the only thing that remains of %s.{x\n\r",victim->name);              break;
	    case 2: sprintf(buf,"A statue perfectly resembling %s stands here.{x\n\r",victim->name);                    break;
	    case 3: sprintf(buf,"A screaming %s, trapped inside Real Life stands here.{x\n\r",victim->name);            break;
		case 4: sprintf(buf,"%s slowly turns into a piece of painted parchment.{x\n\r",victim->name);               break;
		case 5: sprintf(buf,"Dissolving into dust, %s is blown apart by the slightest breeze.{x\n\r",victim->name); break;
		case 6: sprintf(buf,"A ray of hot light bursts from the sky and turns %s into vapor.{x\n\r",victim->name);  break;
		case 7: sprintf(buf,"Bits and pieces of %s, left behind by the Medom.{x\n\r",victim->name);                 break;
		}
	    stc(buf, ch);
	    return;
	}

    strcat( buf, PERS( victim, ch ) );
    if ( !IS_NPC(victim) && !IS_SET(ch->comm, COMM_BRIEF)
    &&   victim->position == POS_STANDING && ch->on == NULL )
    {
    	strcat( buf, " " );
    	if ( victim->pcdata->rdesc != NULL && victim->pcdata->rdesc[0] != '\0')
    	{
    		strcat( buf, victim->pcdata->rdesc );
    	}
    	else
    	{
		strcat( buf, victim->pcdata->last_name);
	}
    }
    if ( IS_NPC( victim ) && victim->position != POS_STANDING )
    {
	strcat( buf, victim->name );
    }
    strcat(buf, "{x");

    switch ( victim->position )
    {
    case POS_DEAD:     strcat( buf, "{R is {rDEAD{R!!{c" );          break;
    case POS_MORTAL:   strcat( buf, "{r is mortally wounded.{c" );   break;
    case POS_INCAP:    strcat( buf, "{y is incapacitated.{c" );      break;
    case POS_STUNNED:  strcat( buf, "{Y is lying here stunned.{c" ); break;
    case POS_SLEEPING:
	if (victim->on != NULL)
	{
	    if (IS_SET(victim->on->value[2],SLEEP_AT))
  	    {
		sprintf(message," {cis sleeping at %s.{x",
		    victim->on->short_descr);
		strcat(buf,message);
	    }
	    else if (IS_SET(victim->on->value[2],SLEEP_ON))
	    {
		sprintf(message," {cis sleeping on %s.{x",
		    victim->on->short_descr);
		strcat(buf,message);
	    }
	    else
	    {
		sprintf(message, "{c is sleeping in %s.{x",
		    victim->on->short_descr);
		strcat(buf,message);
	    }
	}
	else
	    strcat(buf,"{c is sleeping here.{x");
	break;
    case POS_RESTING:
        if (victim->on != NULL)
		{
            if (IS_SET(victim->on->value[2],REST_AT))
            {
                sprintf(message,"{c is resting at %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
            else if (IS_SET(victim->on->value[2],REST_ON))
            {
                sprintf(message,"{c is resting on %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
            else
            {
                sprintf(message, "{c is resting in %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
		}
        else
	    strcat( buf, "{c is resting here.{x" );
	break;
    case POS_SITTING:
        if (victim->on != NULL)
        {
            if (IS_SET(victim->on->value[2],SIT_AT))
            {
                sprintf(message,"{c is sitting at %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
            else if (IS_SET(victim->on->value[2],SIT_ON))
            {
                sprintf(message,"{c is sitting on %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
            else
            {
                sprintf(message, "{c is sitting in %s.{x",
                    victim->on->short_descr);
                strcat(buf,message);
            }
        }
        else
	    strcat(buf, "{c is sitting here.{x");
	break;
    case POS_STANDING:
	if (victim->on != NULL)
	{
	    if (IS_SET(victim->on->value[2],STAND_AT))
	    {
		sprintf(message,"{c is standing at %s.{x",
		    victim->on->short_descr);
		strcat(buf,message);
	    }
	    else if (IS_SET(victim->on->value[2],STAND_ON))
	    {
		sprintf(message,"{c is standing on %s.{x",
		   victim->on->short_descr);
		strcat(buf,message);
	    }
	    else
	    {
		sprintf(message,"{c is standing in %s.{x",
		    victim->on->short_descr);
		strcat(buf,message);
	    }
	}
	else if ( MOUNTED(victim) )
	{
	    strcat( buf, " is here, riding " );
	    strcat( buf, MOUNTED(victim)->short_descr );
	    strcat( buf, ".{x");
	}
 	else if ( !IS_NPC( victim ) )
 	{
	 	if ( victim->pcdata->rdesc != NULL && victim->pcdata->rdesc[0] != '\0')
		{
		    strcat( buf, "{x" );
		}
	 	else
		{
		    strcat( buf, " is here.{x" );
		}
	}
 	else
	{
	    strcat( buf, " is here.{x" );
	}
	break;
    case POS_FIGHTING:
	strcat( buf, "{c is here, fighting " );
	if ( !is_fighting(victim) )
	    strcat( buf, "{cthin air??{x" );
	else if ( check_fighting(victim,ch) )
	    strcat( buf, "{cYOU!{x" );
	else if ( victim->in_room == victim->advancing_on->in_room )
	{
	    strcat( buf, PERS( victim->advancing_on, ch ) );
	    strcat( buf, ".{x" );
	}
	else
	    strcat( buf, "{csomeone who left??{x" );
	break;
    }

    strcat( buf, "{x\n\r" );
    buf[0] = UPPER(buf[0]);
    stc( buf, ch );
    return;
}



void show_char_to_char_1( CHAR_DATA *victim, CHAR_DATA *ch )
{
    char buf[MAX_STRING_LENGTH];
    int percent;

    if ( can_see( victim, ch ) )
    {
		if (ch == victim)
		{
		if (IS_SET(ch->spec_flags,SPEC_WOLFBROTHER))
			act("{cYou have {Yglowing {yyellow {Yeyes{c!\n\r",ch,0,victim,TO_CHAR);
		if (IS_SET(ch->spec_flags,SPEC_AGELESS))
			act("{cYou have an {wageless look{c about yourself.{x\n\r",ch,0,victim,TO_CHAR);
/*		if (IS_SET(ch->hist_flags,HIST_MYRDRAAL))
			act("{cYou have a pale white, eyeless face.{x\n\r",ch,0,victim,TO_CHAR);
	*/	if ( ch->clan == clan_lookup("dreadlord")
		&& ch->pcdata->rebirth >= 9
		&& IS_SET( ch->op_flags,OP_CHANNELER )
		&& IS_SET(ch->op_flags,OP_GRASPED ) )
			act("{cThe whirring frenzy of saa floats in front of your eyes.{x\n\r",ch,NULL,victim,TO_CHAR);
		}
		else
		{
		if (!IS_NPC( victim ) )
		{
			ptc( ch, "%s%s{x\n\r", victim->name, victim->pcdata->title[0] != '\0' ? victim->pcdata->title : "" );
		}
	    act( "{c$n looks at you.", ch, 0, victim, TO_VICT    );
	    act( "{c$n looks at $N.",  ch, 0, victim, TO_NOTVICT );
		if (IS_SET(victim->spec_flags,SPEC_WOLFBROTHER))
			act("{c$N has {Yglowing {yyellow {Yeyes{c!\n\r",ch,0,victim,TO_CHAR);
		if (IS_SET(victim->spec_flags,SPEC_AGELESS))
			act("{c$N has an {wageless look{c about $M.{x\n\r",ch,0,victim,TO_CHAR);
	/*	if (IS_SET(victim->hist_flags,HIST_MYRDRAAL))
			act("{c$N has a pale white, eyeless face.{x\n\r",ch,0,victim,TO_CHAR);
	*/	if ( !IS_NPC( victim ) && victim->clan == clan_lookup("dreadlord")
		&& victim->pcdata->rebirth >= 9
		&& IS_SET( victim->op_flags,OP_CHANNELER )
		&& IS_SET( victim->op_flags,OP_GRASPED ) )
			act("{cWhirring black dots flicker and float across $N's eyes.{x\n\r",ch,NULL,victim,TO_CHAR);
		}
/*	    if ( !IS_NPC(victim) && victim->pcdata->beard > 0 && victim->pcdata->true_sex == SEX_MALE )
	    {
		switch ( victim->pcdata->beard )
		{
			default:
				ptc(ch,"%s's face is shaved clean and smooth.\n\r", victim->name);
				break;
			case 1:
				ptc(ch,"%s has a thin shadow of a beard beginning to grow on his chin.\n\r", victim->name);
				break;
			case 2:
				ptc(ch,"%s has a small bristle of a beard growing on his chin.\n\r", victim->name);
				break;
			case 3:
				ptc(ch,"%s has a day's growth of a beard covering his chin and cheeks.\n\r", victim->name);
				break;
			case 4:
				ptc(ch,"%s has a heavy growth of a beard covering his face.\n\r", victim->name);
				break;
			case 5:
				ptc(ch,"%s has a full-length beard covering his face.\n\r", victim->name);
				break;
			case 6:
				ptc(ch,"%s's face and neck are covered by a long, flowing beard.\n\r", victim->name);
				break;
			case 7:
				break;
		}
		}
	    if ( !IS_NPC(victim) && victim->pcdata->hair > 0 && victim->pcdata->true_sex == SEX_FEMALE )
	    {
		switch ( victim->pcdata->hair )
		{
			default:
				ptc(ch,"%s's hair is all in place.\n\r", victim->name);
				break;
			case 1:
				ptc(ch,"A few strands of %s's hair fly away.\n\r", victim->name);
				break;
			case 2:
				ptc(ch,"A few knots have grown in %s's hair.\n\r", victim->name);
				break;
			case 3:
				ptc(ch,"Some knots and tangles have formed in %s's hair.\n\r", victim->name);
				break;
			case 4:
				ptc(ch,"%s's hair is in a state of disarray.\n\r", victim->name);
				break;
			case 5:
				ptc(ch,"Thick mats have begun to form in %s's hair.\n\r", victim->name);
				break;
			case 6:
				ptc(ch,"%s's hair resembles something like a rat's nest.\n\r", victim->name);
				break;
			case 7:
				break;
		}
	    }
*/

    }


    if ( victim->description[0] != '\0' )
    {
	stc( victim->description, ch );
    }
    else
    {
	act( "{cYou see nothing special about $M.{x", ch, NULL, victim, TO_CHAR );
    }

    if ( MOUNTED(victim) )
    {
	sprintf( buf, "%s is riding %s.{x\n\r", victim->name, MOUNTED(victim)->short_descr);
	send_to_char( buf, ch);
    }
    if ( RIDDEN(victim) )
    {
        sprintf( buf, "%s is being ridden by %s.{x\n\r", victim->short_descr, RIDDEN(victim)->name );
        send_to_char( buf, ch);
    }


    if ( victim->max_hit > 0 )
	percent = ( 100 * victim->hit ) / victim->max_hit;
    else
	percent = -1;

    strcpy( buf, PERS(victim, ch) );

    if ( percent >= 100 )
    	strcat( buf, blood_table[0] );
    else if ( percent >= 90 )
    	strcat( buf, blood_table[1] );
    else if ( percent >= 80 )
    	strcat( buf, blood_table[2] );
    else if ( percent >= 70 )
    	strcat( buf, blood_table[3] );
    else if ( percent >= 60 )
    	strcat( buf, blood_table[4] );
    else if ( percent >= 50 )
    	strcat( buf, blood_table[5] );
    else if ( percent >= 40 )
    	strcat( buf, blood_table[6] );
    else if ( percent >= 30 )
    	strcat( buf, blood_table[7] );
    else if ( percent >= 20 )
    	strcat( buf, blood_table[8] );
    else if ( percent >= 10 )
    	strcat( buf, blood_table[9] );
    else
		strcat(buf, " is bleeding to death.");
    strcat(buf, "{c\n\r");

    buf[0] = UPPER(buf[0]);
    stc( buf, ch );

	if ( IS_SET(ch->auto_flags,AUTO_PEEK) )
		/*do_function( ch, &do_peek, victim->name );  */ /* This looks at wrong person when duplicat names exist */
		peek_char(ch, victim);

    return;
}

void do_age(CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;

	if ( argument[0] == '\0' )
	{
		ptc( ch, "You are %d years old, played %d hours.\n\r", get_age(ch), (int)(ch->played + (int) (current_time - ch->logon))/3600);
	    return;
	}
	else
	{
		if ( (( victim = get_pc_world( ch, argument ) ) != NULL) && !(victim->invis_level>0 && !IS_IMMORTAL(ch)) )
		{
			ptc( ch, "You report your age to %s.\n\r", capit2(victim->name) );
			ptc( victim, "%s reports %s age to you.\n\r", capit2( ch->name ), ch->sex == SEX_MALE ? "his" : ch->sex == SEX_FEMALE ? "her" : "it's" );
			ptc( victim, "%s is %d years old, played %d hours.\n\r", capit2(ch->name), get_age(ch), (int)(ch->played + (int) (current_time - ch->logon))/3600);
		    return;
		}
		else
		{
			stc("Who?\n\r", ch);
			return;
		}
	}
}
void do_peek( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
    char arg[MIL];

    argument = one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	stc( "Peek at who?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, NULL, arg ) ) == NULL )
    {
	stc( "They aren't here in the room.\n\r", ch );
	return;
    }
    peek_char(ch, victim);
}

void peek_char( CHAR_DATA *ch, CHAR_DATA *victim)
{
	bool found;
    int iWear;
    OBJ_DATA *obj;

    found = FALSE;
    for ( iWear = 0; iWear < MAX_WEAR; iWear++ )
    {
	if ( ( obj = get_eq_char( victim, iWear ) ) != NULL
	&&   can_see_obj( ch, obj ) )
	{
	    if ( !found )
	    {
		stc( "\n\r", ch );
		act( "{w$N is using:\n\r{w.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.::.{c", ch, NULL, victim, TO_CHAR );
		found = TRUE;
	    }
	    stc( where_name[iWear], ch );
	    stc( format_obj_to_char( obj, ch, TRUE ), ch );
	    stc( "\n\r", ch );
	}
    }

    if ( victim != ch
    &&   !IS_NPC(ch)
    &&   number_percent( ) < get_skill(ch,gsn_peek))
    {
	stc( "\n\rYou peek at the inventory:\n\r\n\r", ch );
	check_improve(ch,gsn_peek,TRUE,4);
	show_list_to_char( victim->carrying, ch, TRUE, TRUE, FALSE );
    }
}

void show_char_to_char( CHAR_DATA *list, CHAR_DATA *ch )
{
    CHAR_DATA *rch;

    for ( rch = list; rch != NULL; rch = rch->next_in_room )
    {
		if ( rch == ch
	    || ( RIDDEN(rch) && rch->in_room == RIDDEN(rch)->in_room && RIDDEN(rch) != ch ) )
		    continue;

		if ( get_trust(ch) < rch->invis_level)
		    continue;

	    if ( IS_NPC( rch ) && IS_SET(rch->act,ACT_UNDEAD) && !IS_IMMORTAL(ch))
	    {
		    if ( rch->pIndexData->vnum != ch->questmob )
		    {
		    	if ( rch->questor != NULL && rch->questor == ch )
			    ;
			    else
			    	continue;
			}
		}

		if ( can_see( ch, rch ) )
		{
		    show_char_to_char_0( rch, ch );
	        if( MOUNTED(rch) && (rch->in_room == MOUNTED(rch)->in_room) )
	            show_char_to_char_0( MOUNTED(rch), ch );
		}
		else if ( room_is_dark( ch->in_room )
		&&        IS_AFFECTED(rch, AFF_INFRARED ) )
		{
		    stc( "{cYou see {rglowing red eyes{c watching YOU!\n\r", ch );
		}
    }

    return;
}



bool check_blind( CHAR_DATA *ch )
{

    if (!IS_NPC(ch) && IS_SET(ch->act,PLR_HOLYLIGHT))
	return TRUE;

    if ( IS_AFFECTED(ch, AFF_BLIND) )
    {
	stc( "{cYou can't see a thing!{x\n\r", ch );
	return FALSE;
    }

    return TRUE;
}

const char * rps_line = "--------------------------------------------------------------\n\r";
/* Show walkins, walkouts, stuff like that */
void do_rpscore( CHAR_DATA *ch, char *argument )
{
	char buf[MSL];
	buf[0] = '\0';

	if ( ch && !IS_NPC( ch ) )
	{

		stc( rps_line, ch );
		ptc( ch, "Walkin: %s{x\n\r", ch->pcdata->wkin[0] != '\0' ? ch->pcdata->wkin : "None" );
		ptc( ch, "Walkout: %s{x\n\r", ch->pcdata->wout[0] != '\0' ? ch->pcdata->wout : "None" );
		stc( rps_line, ch );


/*		ptc( ch, "Walkin: %s{x\n\r", ch->pcdata->wkin[0] != '\0' ? walkdir(ch->pcdata->wkin, "<dir>") : "None" );
		ptc( ch, "Walkout: %s{x\n\r", ch->pcdata->wout[0] != '\0' ? walkdir(ch->pcdata->wout, "<dir>") : "None" );
*/
		ptc( ch, "Room Desc: %s{x\n\r", (ch->pcdata->rdesc != NULL && ch->pcdata->rdesc[0] != '\0') ? ch->pcdata->rdesc : "None" );
		stc( rps_line, ch );
		ptc( ch, "Title: %s{x\n\r", ch->pcdata->title[0] != '\0' ? ch->pcdata->title : "None" );
		stc( rps_line, ch );
		if ( ch->pcdata->true_sex == SEX_MALE )
		{
			switch ( ch->pcdata->beard )
			{
			default:
				stc("Your face is clean and smooth.\n\r", ch);
				break;
			case 1:
				stc("You have a thin shadow of a beard beginning to grow on your chin.\n\r", ch);
				break;
			case 2:
				stc("You have a small bristle of a beard growing on your chin.\n\r", ch);
				break;
			case 3:
				stc("You have a day's growth of a beard covering your chin and cheeks.\n\r", ch);
				break;
			case 4:
				stc("You have a heavy growth of a beard covering your face.\n\r", ch);
				break;
			case 5:
				stc("You have a full-length beard covering your face.\n\r", ch);
				break;
			case 6:
				stc("Your face and neck are covered by a long, flowing beard.\n\r", ch);
				break;
			case 7:
				break;
			}
			stc( rps_line, ch );
		}
		if ( ch->pcdata->true_sex == SEX_FEMALE )
		{
			switch ( ch->pcdata->hair )
			{
				default:
					stc("Your hair is all in place.\n\r", ch);
					break;
				case 1:
					stc("A few strands of your hair fly away.\n\r", ch);
					break;
				case 2:
					stc("A few knots have grown in your hair.\n\r", ch);
					break;
				case 3:
					stc("Some knots and tangles have formed in your hair.\n\r", ch);
					break;
				case 4:
					stc("Your hair is in a state of disarray.\n\r", ch);
					break;
				case 5:
					stc("Thick mats have begun to form in your hair.\n\r", ch);
					break;
				case 6:
					stc("Your hair resembles something like a rat's nest.\n\r", ch);
					break;
				case 7:
					break;
			}
			stc( rps_line, ch );
		}
		ptc( ch, "Description:\n\r%s{x\n\r", ch->description[0] != '\0' ? ch->description : "None" );
		stc( rps_line, ch );
		show_talents(ch);
		if (WOLF(ch) || SEER(ch) || TAV(ch) || DREAM(ch))
		stc( rps_line, ch );
		stc( "\n\r", ch );
		stc( "See also: Score{x\n\r", ch );
	}
}

/* changes your scroll */
void do_scroll(CHAR_DATA *ch, char *argument)
{
    char arg[MAX_INPUT_LENGTH];
    char buf[100];
    int lines;

    one_argument(argument,arg);

    if (arg[0] == '\0')
    {
	if (ch->lines == 0)
	    stc("{cYou do not page long messages.{c\n\r",ch);
	else
	{
	    sprintf(buf,"{cYou currently display %d lines per page.{c\n\r",
		    ch->lines + 2);
	    stc(buf,ch);
	}
	return;
    }

    if (!is_number(arg))
    {
	stc("{cYou must provide a number.{c\n\r",ch);
	return;
    }

    lines = atoi(arg);

    if (lines == 0)
    {
        stc("{cPaging disabled.{c\n\r",ch);
        ch->lines = 0;
        return;
    }

    if (lines < 10 || lines > 100)
    {
	stc("{cYou must provide a reasonable number.{c\n\r",ch);
	return;
    }

    sprintf(buf,"{cScroll set to %d lines.{c\n\r",lines);
    stc(buf,ch);
    ch->lines = lines - 2;
}

/* RT does socials */
void do_socials(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    int iSocial;
    int col;

    col = 0;

    for (iSocial = 0; social_table[iSocial].name[0] != '\0'; iSocial++)
    {
	sprintf(buf,"{c%-12s",social_table[iSocial].name);
	stc(buf,ch);
	if (++col % 6 == 0)
	    stc("{c\n\r",ch);
    }

    if ( col % 6 != 0)
	stc("{c\n\r",ch);
    return;
}



/* RT Commands to replace news, motd, imotd, etc from ROM */

void do_motd(CHAR_DATA *ch, char *argument)
{
	int chance;
	chance = number_range( 1, 12 );
	if ( chance == 1 || chance == 2 )
	{
    	do_function(ch, &do_help, "motd");
	}
	else if ( chance == 3 || chance == 4 )
	{
    	do_function(ch, &do_help, "greeting1");
	}
	else if ( chance == 5 || chance == 6 )
	{
    	do_function(ch, &do_help, "greeting2");
	}
	else if ( chance == 7 || chance == 8 )
	{
    	do_function(ch, &do_help, "greeting3");
	}
	else if ( chance == 9 || chance == 10 )
	{
    	do_function(ch, &do_help, "greeting4");
	}
	else
	{
    	do_function(ch, &do_help, "greeting5");
	}
}

void do_imotd(CHAR_DATA *ch, char *argument)
{
    do_function(ch, &do_help, "imotd");
}

void do_rules(CHAR_DATA *ch, char *argument)
{
    do_function(ch, &do_help, "policy");
}

void do_story(CHAR_DATA *ch, char *argument)
{
    do_function(ch, &do_help, "story");
}
struct prompt_type
{
	char *prompt;
};
const struct prompt_type prompt_table [] =
{
	/* plain */
	{ "[hp:%h]" },
	{ "[HP:%h]" },
	{ "[hp:%h sp:%m]" },
	{ "[H:%h S:%m]" },
	{ "[hp:%h/sp:%m]" },
	{ "[hp:%h][sp:%m]" },
	{ "[hp:%h][sp:%m][Battle:%b]" },
	{ "[hp:%h][sp:%m][Battle:%B]" },
	{ "[hp:%h/%H sp:%m/%M]%c[%x (%B) %X]%c" },

	{ "<hp:%h>" },
	{ "<HP:%h>" },
	{ "<hp:%h sp:%m>" },
	{ "<H:%h S:%m>" },
	{ "<hp:%h/sp:%m>" },
	{ "<hp:%h><sp:%m>" },
	{ "<hp:%h><sp:%m><Battle:%b>" },
	{ "<hp:%h><sp:%m><Battle:%B>" },
	{ "<hp:%h/%H sp:%m/%M>%c<%x (%B) %X>%c" },

	/* whites */
	{ "{w[{Whp:{Y%h{w]{x" },
	{ "{w[{WHP:{Y%h{w]{x" },
	{ "{w[{Whp:{Y%h {Wsp:{Y%m{w]{x" },
	{ "{w[{WH:{Y%h {WS:{Y%m{w]{x" },
	{ "{w[{Whp:{Y%h{D/{Wsp:{Y%m{w]{x" },
	{ "{w[{Whp:{Y%h{w][{Wsp:{Y%m{w]{x" },
	{ "{w[{Whp:{Y%h{w][{Wsp:{Y%m{w][{WBattle:%b{w]{x" },
	{ "{w[{Whp:{Y%h{w][{Wsp:{Y%m{w][{WBattle:%B{w]{x" },
	{ "{w[{Whp:{Y%h{y/{Y%H {Wsp:{Y%m{y/{Y%M{w]%c{w[{Y%x {w(%B{w) {Y%X{w]{x%c" },

	{ "{w<{Whp:{Y%h{w>{x" },
	{ "{w<{WHP:{Y%h{w>{x" },
	{ "{w<{Whp:{Y%h {Wsp:{Y%m{w>{x" },
	{ "{w<{WH:{Y%h {WS:{Y%m{w>{x" },
	{ "{w<{Whp:{R%h{D/{Wsp:{R%m{w>{x" },
	{ "{w<{Whp:{Y%h{w><{Wsp:{Y%m{w>{x" },
	{ "{w<{Whp:{Y%h{w><{Wsp:{Y%m{w><{WBattle:%b{w>{x" },
	{ "{w<{Whp:{Y%h{w><{Wsp:{Y%m{w><{WBattle:%B{w>{x" },
	{ "{w<{Whp:{Y%h{y/{Y%H {Wsp:{Y%m{y/{Y%M{w>%c{w<{Y%x {w(%B{w) {Y%X{w>{x%c" },

	/* blues */
	{ "{b[{Bhp:{w%h{b]{x" },
	{ "{b[{BHP:{w%h{b]{x" },
	{ "{b[{Bhp:{w%h {Bsp:{w%m{b]{x" },
	{ "{b[{BH:{w%h {BS:{w%m{b]{x" },
	{ "{b[{Bhp:{w%h{D/{Bsp:{w%m{b]{x" },
	{ "{b[{Bhp:{w%h{b][{Bsp:{w%m{b]{x" },
	{ "{b[{Bhp:{w%h{b][{Bsp:{w%m{b][{BBattle:%b{b]{x" },
	{ "{b[{Bhp:{w%h{b][{Bsp:{w%m{b][{BBattle:%B{b]{x" },
	{ "{b[{Bhp:{w%h{B/{w%H {Bsp:{w%m{B/{w%M{b]%c{b[{w%x {B(%B{B) {w%X{b]{x%c" },

	{ "{b<{Bhp:{w%h{b>{x" },
	{ "{b<{BHP:{w%h{b>{x" },
	{ "{b<{Bhp:{w%h {Bsp:{w%m{b>{x" },
	{ "{b<{BH:{w%h {BS:{w%m{b>{x" },
	{ "{b<{Bhp:{w%h{D/{Bsp:{w%m{b>{x" },
	{ "{b<{Bhp:{w%h{b><{Bsp:{w%m{b>{x" },
	{ "{b<{Bhp:{w%h{b><{Bsp:{w%m{b><{BBattle:%b{b>{x" },
	{ "{b<{Bhp:{w%h{b><{Bsp:{w%m{b><{BBattle:%B{b>{x" },
	{ "{b<{Bhp:{w%h{B/{w%H {Bsp:{w%m{B/{w%M{w>%c{w<{w%x {B(%B{B) {w%X{w>{x%c" },

	/* greens */
	{ "{g[{Ghp:{w%h{g]{x" },
	{ "{g[{GHP:{w%h{g]{x" },
	{ "{g[{Ghp:{w%h {Gsp:{w%m{g]{x" },
	{ "{g[{GH:{w%h {GS:{w%m{g]{x" },
	{ "{g[{Ghp:{w%h{D/{Gsp:{w%m{g]{x" },
	{ "{g[{Ghp:{w%h{g][{Gsp:{w%m{g]{x" },
	{ "{g[{Ghp:{w%h{g][{Gsp:{w%m{g][{GBattle:%b{g]{x" },
	{ "{g[{Ghp:{w%h{g][{Gsp:{w%m{g][{GBattle:%B{g]{x" },
	{ "{g[{Ghp:{w%h{g/{w%H {Gsp:{w%m{g/{w%M{g]%c{g[{w%x {G(%B{G) {w%X{g]{x%c" },

	{ "{g<{Ghp:{w%h{g>{x" },
	{ "{g<{GHP:{w%h{g>{x" },
	{ "{g<{Ghp:{w%h {Gsp:{w%m{g>{x" },
	{ "{g<{GH:{w%h {GS:{w%m{g>{x" },
	{ "{g<{Ghp:{w%h{D/{Gsp:{w%m{g>{x" },
	{ "{g<{Ghp:{w%h{g><{Gsp:{w%m{g>{x" },
	{ "{g<{Ghp:{w%h{g><{Gsp:{w%m{g><{GBattle:%b{g>{x" },
	{ "{g<{Ghp:{w%h{g><{Gsp:{w%m{g><{GBattle:%B{g>{x" },
	{ "{g<{Ghp:{w%h{g/{w%H {Gsp:{w%m{g/{w%M{g>%c{g<{w%x {G(%B{G) {w%X{g>{x%c" },

	/* reds */
	{ "{r[{Rhp:{w%h{r]{x" },
	{ "{r[{RHP:{w%h{r]{x" },
	{ "{r[{Rhp:{w%h {Rsp:{w%m{r]{x" },
	{ "{r[{RH:{w%h {RS:{w%m{r]{x" },
	{ "{r[{Rhp:{w%h{D/{Rsp:{w%m{r]{x" },
	{ "{r[{Rhp:{w%h{r][{Rsp:{w%m{r]{x" },
	{ "{r[{Rhp:{w%h{r][{Rsp:{w%m{r][{RBattle:%b{r]{x" },
	{ "{r[{Rhp:{w%h{r][{Rsp:{w%m{r][{RBattle:%B{r]{x" },
	{ "{r[{Rhp:{w%h{r/{w%H {Rsp:{w%m{r/{w%M{w]%c{r[{w%x {R(%B{R) {w%X{r]{x%c" },

	{ "{r<{Rhp:{w%h{r>{x" },
	{ "{r<{RHP:{w%h{r>{x" },
	{ "{r<{Rhp:{w%h {Rsp:{w%m{r>{x" },
	{ "{r<{RH:{w%h {RS:{w%m{r>{x" },
	{ "{r<{Rhp:{w%h{D/{Rsp:{w%m{r>{x" },
	{ "{r<{Rhp:{w%h{r><{Rsp:{w%m{r>{x" },
	{ "{r<{Rhp:{w%h{r><{Rsp:{w%m{r><{RBattle:%b{r>{x" },
	{ "{r<{Rhp:{w%h{r><{Rsp:{w%m{r><{RBattle:%B{r>{x" },
	{ "{r<{Rhp:{w%h{r/{w%H {Rsp:{w%m{r/{w%M{r>%c{r<{w%x {R(%B{R) {w%X{r>{x%c" },
	{ NULL }
};
void do_prompt(CHAR_DATA *ch, char *argument)
{
	char buf[MAX_STRING_LENGTH];
   	char arg1 [MAX_INPUT_LENGTH];

	if ( argument[0] == '\0' )
	{
		if (IS_SET(ch->comm,COMM_PROMPT))
		{
			stc("{cPrompt syntyax: prompt {C<{call{C|{cview{C|{clist{C|{cproficiency{C|{coption{C>{x\n\r\n\r", ch );
			stc("{cYou will no longer see prompts.{c\n\r",ch);
			REMOVE_BIT(ch->comm,COMM_PROMPT);
		}
		else
		{
			stc("{cPrompt syntyax: prompt {C<{call{C|{cview{C|{clist{C|{cproficiency{C|{coption{C>{x\n\r\n\r", ch );
			stc("{cYou will now see prompts.{c\n\r",ch);
			SET_BIT(ch->comm,COMM_PROMPT);
		}
		return;
	}

	if( !strcmp( argument, "all" ) )
	{
		free_string( ch->prompt );
		ch->prompt = str_dup( "{c<{w%hhp %mm %vmv{c>%c");
		sprintf( buf,"Prompt set to %s\n\r",ch->prompt );
		stc( buf,ch );
		return;
	}
	else if( !str_cmp( argument, "view" ) )
	{
		char *view_prompt = double_left_curly_brace(ch->prompt);
		sprintf(buf,"{cPrompt is '%s'\n\r",view_prompt);
		stc(buf,ch);
		free_string(view_prompt);
		return;
	}
	else if ( !str_cmp( argument, "list" ) )
	{
		int i;
		BUFFER *buffer;
		char buf[MSL];
		buffer = new_buf();
		for ( i = 0; prompt_table[i].prompt != NULL; i++ )
		{
			sprintf( buf, "{w[{W%2d{w]{x  %s{x\n\r", i, prompt_table[i].prompt );
			add_buf(buffer, buf);
		}
		page_to_char( buf_string(buffer), ch );
		free_buf(buffer);
		return;
	}
    	one_argument( argument, arg1 ); /* note: we do not want to update argument here. it might not match */
	if ( (!str_prefix( arg1, "proficiency")) && !IS_NPC(ch) )
	{
		int sn;
    		char arg2 [MAX_INPUT_LENGTH];
    		argument = one_argument( argument, arg1 );
    		argument = one_argument( argument, arg2 );
		if(arg2[0] == '\0')
		{
		    stc("Usage: prompt proficiency [skill]   The profeciency in [skill] is shown with %%P.\n\r", ch);
		    return;
		}
		if(!str_cmp(arg2,"clear") )
		{
		    stc("Prompt option %P cleared.\n\r", ch);
		    ch->pcdata->prompt_skill = 0;
		    return;
		}
		sn = skill_lookup(arg2);
		if(sn > 0)
		{
		    ch->pcdata->prompt_skill = sn;
		    ptc(ch, "Prompt option %%P now points to %s.\n\r", skill_table[sn].name);
		}
		else
		    ptc(ch, "There is no skill called %s.\n\r",arg2);
		return;

	}
	else if ( is_number( argument ) )
	{
		int prom;
		prom = atoi( argument );
		free_string( ch->prompt );
		ch->prompt = str_dup( prompt_table[prom].prompt );
		sprintf( buf,"Prompt set to %s\n\r",ch->prompt );
		stc( buf,ch );
		return;
	}
	else
	{
		if ( strlen_color(argument) > 100 )
			argument[100] = '\0';
		strcpy( buf, argument );
		smash_tilde( buf );
		if (str_suffix("%c",buf) && str_suffix("{c",buf))
			strcat(buf,"{c");
	}

	free_string( ch->prompt );
	ch->prompt = str_dup( buf );
	sprintf(buf,"{cPrompt set to %s\n\r",ch->prompt );
	stc(buf,ch);
	return;
}

void do_observe( CHAR_DATA *ch, char *argument )
{
	stc( "{cYou casually observe the room.{c\n\r", ch );
	act( "{c$n casually observes the room.{c", ch, NULL, NULL, TO_ROOM );
	do_function ( ch, &do_look, "");
	return;
}

bool has_light( CHAR_DATA *ch )
{
	OBJ_DATA *obj, *obj_next, *lamp;
	bool gotlight = FALSE;
	bool isWolf = FALSE;

	if ( IS_SET( ch->spec_flags, SPEC_WOLFBROTHER ) )
		return TRUE;

	if ( ch->in_room->sector_type == SECT_CITY )
		return TRUE;

	for ( lamp = ch->in_room->contents; lamp; lamp = lamp->next_content )
	{
		if ( lamp->item_type == ITEM_LAMPPOST )
			return TRUE;
	}

	if ( IS_SET(ch->act, PLR_HOLYLIGHT)
	||   IS_AFFECTED(ch, AFF_DARK_VISION)
	||   isWolf )
		return TRUE;

	if ( ( obj = get_eq_char( ch, WEAR_LIGHT ) ) != NULL )
		return TRUE;

	for ( obj = ch->carrying; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type == ITEM_LIGHT || IS_OBJ_STAT( obj,ITEM_GLOW ) )
		{
			gotlight = TRUE;
			break;
		}
		else continue;
	}

	if ( gotlight )
		return TRUE;

	return FALSE;
}

void do_look( CHAR_DATA *ch, char *argument )
{
    char buf  [MAX_STRING_LENGTH];
    char arg1 [MAX_INPUT_LENGTH];
    char arg2 [MAX_INPUT_LENGTH];
    char arg3 [MAX_INPUT_LENGTH];
    EXIT_DATA *pexit;
    CHAR_DATA *victim;
    OBJ_DATA *obj;
    char *pdesc;
    int door;
    int number,count;
    bool isWolf = FALSE;

    if ( ch->desc == NULL )
	return;

    if ( ch->position < POS_SLEEPING )
    {
	stc( "{cYou can't see anything but stars!\n\r", ch );
	return;
    }

    if ( ch->position == POS_SLEEPING )
    {
	stc( "{cYou can't see anything, you're sleeping!\n\r", ch );
	return;
    }

    if ( !check_blind( ch ) )
	return;

	if ( IS_SET( ch->spec_flags, SPEC_WOLFBROTHER ) )
		isWolf = TRUE;

    if ( !IS_NPC(ch)
    &&   !IS_SET(ch->act, PLR_HOLYLIGHT)
    &&   !IS_AFFECTED(ch, AFF_DARK_VISION)
    &&   !isWolf
    &&   !has_light( ch )
    &&   room_is_dark( ch->in_room ) )
    {
	stc( "{cIt is pitch black ... \n\r", ch );
	show_char_to_char( ch->in_room->people, ch );
	return;
    }

    if ( weather_info.sunlight == SUN_DARK && !has_light( ch ) && ch->pcdata->newbie != 0 /* newbs can always see -d */ )
    {
        stc("It is too dark to see.\n\r", ch);
        return;
    }

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );
    number = number_argument(arg1,arg3);
    count = 0;

    if ( !str_cmp( arg1, "sky" ) )
    {
    	do_function( ch, &do_weather, "" );
    	return;
    }

    /*if ( ch->in_room != NULL
    && !IS_NPC( ch )
    && !IS_NULLSTR( ch->in_room->url )
    && IS_SET( ch->auto_flags, AUTO_ROA ) )
	{
		ptc( ch, "<!RoA! %s>", ch->in_room->url );
	}*/

	/* check for jogging, and if so, only send portions of the room -- Dalsor 01/24/2013 
	   the silent check is passed from move_char
	 */
	if ( arg1[0] != '\0' && !str_cmp( arg1, "silent" ) )
	{
		stc( ch->in_room->name, ch );
		/*
                if ( !IS_NPC(ch) && IS_SET( ch->auto_flags, AUTO_AUTOMAP ) )                
		{                        
			stc("{c\n\r",ch);
			draw_map( ch, NULL );
			stc("{c\n\r",ch);
		}
		*/
                if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_AUTOEXIT) )
		{
			stc("{c\n\r",ch);
			do_function(ch, &do_exits, "auto" );
		}
		show_char_to_char( ch->in_room->people, ch );
		stc( "{c", ch );
		return;
	}
	/* end check for jogging */

    if ( arg1[0] == '\0' || !str_cmp( arg1, "auto" ) )
    {
			stc( ch->in_room->name, ch );

		if ( !IS_NPC(ch) && IS_SET( ch->auto_flags, AUTO_AUTOMAP ) )
		{
			stc("{c\n\r",ch);
			draw_map( ch, ch->in_room->description );
			stc("{c\n\r",ch);
	    	    	if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_AUTOEXIT) )
		    	{
			    stc("{c\n\r",ch);
        		    do_function(ch, &do_exits, "auto" );
		    	}
			stc("{c",ch);

			show_list_to_char( ch->in_room->contents, ch, FALSE, FALSE, FALSE );
			show_char_to_char( ch->in_room->people,   ch );
			stc("{c",ch);
			return;
		}
		else
		{
			if ( IS_SET( ch->act,PLR_HOLYLIGHT )
			|| (IS_BUILDER(ch, ch->in_room->area) && (mud_port != play_port)))
			{
			    sprintf(buf,"{c [{wRoom %ld{c]{w",ch->in_room->vnum);
		    	stc(buf,ch);
			}

			stc( "{x\n\r", ch );

			if ( arg1[0] == '\0'
			|| ( !IS_NPC(ch) && !IS_SET(ch->comm, COMM_BRIEF) ) )
			{
			    stc( "{w  ",ch);
			    stc( ch->in_room->description, ch );
			}

	    		if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_AUTOEXIT) )
			{
			    stc("{c\n\r",ch);
        		    do_function(ch, &do_exits, "auto" );
			}
			stc("{c",ch);

			show_list_to_char( ch->in_room->contents, ch, FALSE, FALSE, FALSE );
			show_char_to_char( ch->in_room->people,   ch );
			stc("{c",ch);
			return;
		}
    }

    if ( !str_cmp( arg1, "i" ) || !str_cmp(arg1, "in")  || !str_cmp(arg1,"on"))
    {
		/* 'look in' */
		if ( arg2[0] == '\0' )
		{
	    stc( "{cLook in what?\n\r", ch );
	    return;
		}
		if ( ( obj = get_obj_here( ch, NULL, arg2 ) ) == NULL )
		{
	    stc( "{cYou do not see that here.{c\n\r", ch );
	    return;
		}
		switch ( obj->item_type )
		{
		default:
	    stc( "{cThat is not a container.{c\n\r", ch );
	    break;
		case ITEM_DRINK_CON:
	    if ( obj->value[1] <= 0 )
	    {
		stc( "{cIt is empty.{c\n\r", ch );
		break;
	    }
	    sprintf( buf, "{cIt's %sfilled with a %s liquid.{c\n\r",
		obj->value[1] <     obj->value[0] / 4
		    ? "{cless than half-" :
		obj->value[1] < 3 * obj->value[0] / 4
		    ? "{cabout half-"     : "{cmore than half-",
		liq_table[obj->value[2]].liq_color
		);

	    stc( buf, ch );
	    break;

		case ITEM_QUIVER:
		if ( obj->value[0] <= 0 )
		{
		stc( "{cThe quiver is out of arrows.\n\r", ch );
		break;
		}

		if (obj->value[0] == 1 )
		{
		stc( "{cThe quiver has 1 arrow remaining in it.\n\r", ch );
		break;
		}

		if (obj->value[0] > 1 )
		{
		sprintf( buf, "{cThe quiver has %d arrows in it.\n\r", obj->value[0]);
		}
		stc( buf, ch);
		break;
		case ITEM_TREASURECHEST:
	    if ( IS_SET(obj->value[1], CONT_CLOSED) )
	    {
		stc( "It is closed.\n\r", ch );
		break;
	    }
	    act( "{c$p holds:", ch, obj, NULL, TO_CHAR );
	    show_list_to_char( obj->contains, ch, TRUE, TRUE, TRUE );
		break;

		case ITEM_CONTAINER:
		case ITEM_CORPSE_NPC:
		case ITEM_CORPSE_PC:
	    if ( IS_SET(obj->value[1], CONT_CLOSED) )
	    {
		stc( "{cIt is closed.{c\n\r", ch );
		break;
	    }

	    act( "{c$p holds:", ch, obj, NULL, TO_CHAR );
	    show_list_to_char( obj->contains, ch, TRUE, TRUE, TRUE );
	    break;
		}
		return;
    }

    if ( ( victim = get_char_room( ch, NULL, arg1 ) ) != NULL )
    {
		if ( seeing( ch, victim ) > 0)
		{
			show_seer( ch, victim );
		}

		show_char_to_char_1( victim, ch );
		if ( IS_NPC( victim ) && victim->pIndexData && victim->pIndexData->vnum == 3259 )
		{
			act( "{g$n growls, {G'{gWhat are you looking at $N?{G'{x", victim, NULL, ch, TO_ROOM );
		}
		return;
    }

    for ( obj = ch->carrying; obj != NULL; obj = obj->next_content )
    {
		if ( can_see_obj( ch, obj ) )
		{  /* player can see object */
		    pdesc = get_extra_descr( arg3, obj->extra_descr );
		    if ( pdesc != NULL )
		    {
		    	if (++count == number)
		    	{
			    stc( pdesc, ch );
			    return;
		    	}
		    	else continue;
			}

	 	    pdesc = get_extra_descr( arg3, obj->pIndexData->extra_descr );
	 	    if ( pdesc != NULL )
	 	    {
	 	    	if (++count == number)
	 	    	{
			    stc( pdesc, ch );
			    return;
		     	}
			else continue;
			}

		    if ( is_name( arg3, obj->name ) )
		    {
		    	if (++count == number)
		    	{
	    	    stc( obj->description, ch );
	    	    stc( "{c\n\r",ch);
			    return;
	  		    }
		    }
	    }
	}

    for ( obj = ch->in_room->contents; obj != NULL; obj = obj->next_content )
    {
	if ( obj->item_type == ITEM_WINDOW )
	{
		ROOM_INDEX_DATA *loc;
		if ( obj->value[0] > 0 )
		{
			if ( ( loc = get_room_index( obj->value[0] ) ) != NULL )
			{
				ptc( ch, "You look through %s and see...\n\r", obj->short_descr );
				act( "$n peers through $t.", ch, obj->short_descr, NULL, TO_ROOM );
				stc( "{x\n\r", ch );
				stc( loc->name, ch );
				stc( "{w\n\r", ch );
			    stc( "{w  ",ch);
				stc( loc->description, ch );
				show_list_to_char( loc->contents, ch, FALSE, FALSE, FALSE );
				show_char_to_char( loc->people,   ch );
				stc( "{x\n\r", ch );
			}
		}
		return;
	}
	if ( can_see_obj( ch, obj ) )
	{
		if ( obj->item_type == ITEM_MIRROR )
		{
			stc("Reflected in the mirror, you see yourself!\n\r",ch);
			stc( ch->description, ch );
		}
	    pdesc = get_extra_descr( arg3, obj->extra_descr );
	    if ( pdesc != NULL )
	    	if (++count == number)
	    	{
		    stc( pdesc, ch );
		    return;
	    	}

	    pdesc = get_extra_descr( arg3, obj->pIndexData->extra_descr );
	    if ( pdesc != NULL )
	    	if (++count == number)
	    	{
		    stc( pdesc, ch );
		    return;
	    	}

	    if ( is_name( arg3, obj->name ) )
		if (++count == number)
		{
		    stc( obj->description, ch );
		    stc("{c\n\r",ch);
		    return;
		}
	}
    }

    pdesc = get_extra_descr(arg3,ch->in_room->extra_descr);
    if (pdesc != NULL)
    {
	if (++count == number)
	{
	    stc(pdesc,ch);
	    return;
	}
    }

    if (count > 0 && count != number)
    {
    	if (count == 1)
    	    sprintf(buf,"{cYou only see one %s here.{c\n\r",arg3);
    	else
    	    sprintf(buf,"{cYou only see %d of those here.{c\n\r",count);

    	stc(buf,ch);
    	return;
    }

         if ( !str_cmp( arg1, "n" ) || !str_cmp( arg1, "north" ) ) door = 0;
    else if ( !str_cmp( arg1, "e" ) || !str_cmp( arg1, "east"  ) ) door = 1;
    else if ( !str_cmp( arg1, "s" ) || !str_cmp( arg1, "south" ) ) door = 2;
    else if ( !str_cmp( arg1, "w" ) || !str_cmp( arg1, "west"  ) ) door = 3;
    else if ( !str_cmp( arg1, "u" ) || !str_cmp( arg1, "up"    ) ) door = 4;
    else if ( !str_cmp( arg1, "d" ) || !str_cmp( arg1, "down"  ) ) door = 5;
	else if ( !str_cmp( arg1, "ne" ) || !str_cmp( arg1, "northeast" ) ) door = 6;
	else if ( !str_cmp( arg1, "se" ) || !str_cmp( arg1, "southeast" ) ) door = 7;
	else if ( !str_cmp( arg1, "sw" ) || !str_cmp( arg1, "southwest" ) ) door= 8;
	else if ( !str_cmp( arg1, "nw" ) || !str_cmp( arg1, "northwest" ) ) door = 9;
    else
    {
	stc( "{cYou do not see that here.{c\n\r", ch );
	return;
    }

    /* 'look direction' */
    if ( ( pexit = ch->in_room->exit[door] ) == NULL )
    {
	stc( "{cNothing special there.{c\n\r", ch );
	return;
    }

    if ( pexit->description != NULL && pexit->description[0] != '\0' )
	stc( pexit->description, ch );
    else
	stc( "{cNothing special there.{c\n\r", ch );

    if ( pexit->keyword    != NULL
    &&   pexit->keyword[0] != '\0'
    &&   pexit->keyword[0] != ' ' )
    {
	stc("Try scan...\n\r",ch);
	/*
	if ( IS_SET(pexit->exit_info, EX_CLOSED) )
	{
	ptc( ch, "The %s %s is closed.\n\r, pexit->keyword, dir_name[door]" );
	}
	else if ( IS_SET(pexit->exit_info, EX_ISDOOR) )
	{
	ptc( ch, "The %s %s is open.\n\r, pexit->keyword, dir_name[door]" );
	}
	*/
    }

    return;
}

void do_examine( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	char arg[MAX_INPUT_LENGTH];
	OBJ_DATA *obj;
//	OBJ_DATA *obj2;
	CHAR_DATA *keeper = find_keeper(ch);

	if (keeper == NULL)
	{
		stc ("To examine an item you are carrying, use 'look' or 'appraise'.\n\r", ch);
		return;
	}

	one_argument (argument, arg);

	if (arg[0] == '\0')
	{
		stc ("{cExamine what?\n\r", ch );
		return;
	}

	if (IS_NPC(keeper) && keeper->pIndexData->vnum == 15901)
	{
		sprintf(buf, "%s How about you buy it, and then I'll let you look at it all you want.", ch->name);
		keeper_say(keeper, buf);
		return;
	}

	if ((obj = get_obj_keeper(ch, keeper, arg)) == NULL)
	{
		sprintf(buf, "%s I don't have that in my shop.", ch->name);
		keeper_say(keeper, buf);
		return;
	}

	act("$N lets you get a better look at $p.\n\r", ch, obj, keeper, TO_CHAR);
//	obj2 = create_object(obj->pIndexData, 0);
	appraise_object(ch, obj, FALSE);
//	extract_obj(obj2);
	return;
}

/*
void do_examine( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    OBJ_DATA *obj;
    CHAR_DATA *victim;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	stc( "{cExamine what?\n\r", ch );
	return;
    }

	if ( !IS_NPC( ch ) && ( victim = get_char_room( NULL, ch->in_room, arg ) ) != NULL )
	{
		if ( !IS_NPC( victim ) )
		{
			if ( ( IS_SET( ch->hist_flags, HIST_GUILDLEADER ) || IS_SET( ch->hist_flags, HIST_RECRUITER ) )
			&& IS_SET( victim->op_flags, OP_CHANNELER ) )
			{
				act("You feel a power lurking deep within $N",ch,NULL,victim,TO_CHAR);
			}
		}
	}

    do_function(ch, &do_look, arg );

    if ( ( obj = get_obj_here( ch, NULL, arg ) ) != NULL )
    {
	switch ( obj->item_type )
	{
	default:
	    break;

	case ITEM_JUKEBOX:
	    do_function(ch, &do_play, "list");
	    break;

	case ITEM_MONEY:
	    if (obj->value[0] == 0)
	    {
	        if (obj->value[1] == 0)
		    sprintf(buf,"{cOdd...there's no coins in the pile.{c\n\r");
		else if (obj->value[1] == 1)
		    sprintf(buf,"You see one copper penny.{c\n\r");
		else
		    sprintf(buf,"{cThere are %d copper pennies in the pile.{c\n\r",
			obj->value[1]);
	    }

	    else if (obj->value[1] == 0)
	    {
		if (obj->value[0] == 1)
		    sprintf(buf,"You see one silver penny.{c\n\r");
		else
		    sprintf(buf,"{cThere are %d silver pennies in the pile.{c\n\r",
			obj->value[0]);
	    }

	    else
		sprintf(buf,
		    "{cThere are %d copper pennies and %d silver pennies in the pile.{c\n\r",
		    obj->value[1],obj->value[0]);
	    stc(buf,ch);
	    break;

	case ITEM_COMM_DEV:
		if ( obj->value[0] == 50 )
			sprintf( buf, "It is in immaculate condition.\n\r" );
		else if ( obj->value[0] >= 45 )
			sprintf( buf, "A tiny crack has appeared in the surface.\n\r" );
		else if ( obj->value[0] >= 40 )
			sprintf( buf, "A very small crack can be seen on the surface.\n\r" );
		else if ( obj->value[0] >= 35 )
			sprintf( buf, "A small crack has begun to stretch across the surface.\n\r" );
		else if ( obj->value[0] >= 30 )
			sprintf( buf, "A crack slowly works its way across the surface.\n\r" );
		else if ( obj->value[0] >= 25 )
			sprintf( buf, "A small crack has forked in two, slowly widening.\n\r" );
		else if ( obj->value[0] >= 20 )
			sprintf( buf, "A small crack begins to spiderweb its way across the surface.\n\r" );
		else if ( obj->value[0] >= 15 )
			sprintf( buf, "A small crack reaches almost halfway across the surface.\n\r" );
		else if ( obj->value[0] >= 12 )
			sprintf( buf, "A few small cracks work their way across the surface.\n\r" );
		else if ( obj->value[0] >= 10 )
			sprintf( buf, "A few small cracks mar the surface.\n\r" );
		else if ( obj->value[0] >= 5 )
			sprintf( buf, "Several small cracks have marred the surface.\n\r" );
		else if ( obj->value[0] >= 2 )
			sprintf( buf, "It will break at any time.\n\r" );
		else
			sprintf( buf, "Makes you wonder how its still any use at all.\n\r" );
		stc( buf, ch );
		break;
	case ITEM_DRINK_CON:
	case ITEM_CONTAINER:
	case ITEM_CORPSE_NPC:
	case ITEM_CORPSE_PC:
	    sprintf(buf,"{cin %s",argument);
	    do_function(ch, &do_look, buf );
	}
    }

    return;
}

*/

/*
 * Thanks to Zrin for auto-exit part.
 */
void do_exits( CHAR_DATA *ch, char *argument )
{
	extern char * const dir_name[];
	char buf[MAX_STRING_LENGTH];
	EXIT_DATA *pexit;
	bool found;
	bool fAuto;
	int door;
	OBJ_DATA *obj, *obj_next;

	buf[0] = '\0';

	fAuto  = !str_cmp( argument, "auto" );

	if ( !check_blind( ch ) )
		return;

        if (fAuto)
        {
                if ( in_safe_room( ch ) )
                        sprintf(buf,"{c[{wObvious Exits{w:");
                else
                        sprintf(buf,"{c[{RObvious Exits:");
        }
        else if (IS_IMMORTAL(ch))
                sprintf(buf,"{cObvious exits from room{w %ld\n\r",ch->in_room->vnum);
        else
                sprintf(buf,"{cObvious exits:\n\r");

    found = FALSE;
    if ( fAuto )
    {
		for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
		{
			obj_next = obj->next_content;
			if ( obj->item_type == ITEM_PORTAL && obj->value[4] == 1 )
			{
				strcat( buf, " \t<send href='" );
				strcat( buf, obj->name );
				strcat( buf, "'>{w" );
				strcat( buf, obj->name );
				strcat( buf, "\t</send>" );
				found = TRUE;
			}
		}
	}
    else
    {
		for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
		{
			obj_next = obj->next_content;
			if ( obj->item_type == ITEM_PORTAL && obj->value[4] == 1 )
			{
				strcat( buf, " [\t<send href='enter " );
				strcat( buf, obj->name );
				strcat( buf, "'>Portal" );
				strcat( buf, "\t</send>] " );

				strcat( buf, capit2( obj->short_descr ) );
				strcat( buf, "\n\r" );
				found = TRUE;
			}
		}
	}
    for ( door = 0; door < MAX_DIR; door++ )
    {
		if ( ( pexit = ch->in_room->exit[door] ) != NULL
		&&   pexit->u1.to_room != NULL
		&&   can_see_room(ch,pexit->u1.to_room) )
		{
		    found = TRUE;
		    if (( fAuto ) && (!IS_SET(pexit->exit_info,EX_CLOSED)))
		    {
				strcat( buf, " \t<send href='" );
				strcat( buf, dir_name[door] );
				strcat( buf, "'>{w" );
				strcat( buf, dir_name[door] );
				strcat( buf, "\t</send>" );
		    }
		    else if (( fAuto ) && (IS_SET(pexit->exit_info,EX_CLOSED)))
			{
				strcat( buf, " {c(\t<send href='open " );
				strcat( buf, dir_name[door] );
				strcat( buf, "'>{w" );
				strcat( buf, dir_name[door] );
				strcat( buf, "\t</send>{c)" );
			}
			else
		    {
				sprintf( buf + strlen(buf), "{w%-5s - %s{c",
					capitalize( dir_name[door] ),
				    room_is_dark( pexit->u1.to_room )
					?  "{cToo dark to tell{c"
					: pexit->u1.to_room->name );
				if (IS_IMMORTAL(ch))
				    sprintf(buf + strlen(buf),
					" {c({wroom %ld{c){c\n\r",pexit->u1.to_room->vnum);
				else
				    sprintf(buf + strlen(buf), "\n\r");
		    }
		}
    }

    if ( !found )
		strcat( buf, fAuto ? " {cnone{c" : "{cNone.{c\n\r" );

    if ( fAuto )
		strcat( buf, "{c]{c\n\r" );

    stc( buf, ch );
    buf[0] = '\0';
    return;
}


int true_op_average args((CHAR_DATA *ch));
int roomcount args((CHAR_DATA * ch));

int count_skills( CHAR_DATA *ch )
{
	int skills = 0, sn;
	for ( sn = 0; sn < MAX_SKILL; sn++ )
	{
		if ( skill_table[sn].name == NULL )
			break;
		if ( ch->pcdata->learned[sn] < 1 )
			continue;
		if ( skill_table[sn].spell_fun == spell_null )
			skills += ch->pcdata->learned[sn];
	}
	return skills;
}
int count_weaves( CHAR_DATA *ch )
{
	int weaves = 0, sn;
	for ( sn = 0; sn < MAX_SKILL; sn++ )
	{
	    if ( skill_table[sn].name == NULL )
			break;
	    if ( ch->pcdata->learned[sn] < 1 )
			continue;
		if ( skill_table[sn].spell_fun != spell_null )
			weaves += ch->pcdata->learned[sn];
	}
	return weaves;
}

void show_score( CHAR_DATA *ch, CHAR_DATA *viewer);
void do_score( CHAR_DATA *ch, char *argument )
{
    char arg1[MIL];
    CHAR_DATA *viewer = NULL;

    argument = one_argument( argument, arg1 );

    if (IS_NPC(ch)) return;
    if(arg1[0] == '\0')
	    viewer = ch;
    else if(IS_IMMORTAL(ch) && !str_cmp(argument,"force") )
    {
	if ( (( viewer = get_pc_world( ch, arg1 ) ) == NULL) || (viewer->invis_level>0 && !IS_IMMORTAL(ch)) )
        {
	    stc("Show your score to who?\n",ch);
	    return;
	}
	show_score(viewer/* not viewer, but the victim */, ch /* the real immortal viewer */);
	return;
    }
    else
    {
	if ( (( viewer = get_pc_world( ch, arg1 ) ) == NULL) || (viewer->invis_level>0 && !IS_IMMORTAL(ch)) )
        {
	    stc("Show your score to who?\n",ch);
	    return;
	}
	else
		ptc(ch,"You show your score to %s.\n\r", viewer->name);
    }
    show_score(ch, viewer);
}

int master_perc (CHAR_DATA *ch)
{
	int total = 0;

	if (IS_NPC(ch))	return total;

	if (IS_SET(ch->op_flags, OP_CHANNELER))
		return total;

	if (ch->race == race_lookup("ogier"))	return 0;
	if (ch->race == race_lookup("trolloc"))	return 0;

	if (ch->race == race_lookup("aiel"))
	{
		total += UMIN(100, get_skill(ch, gsn_eagle));
		total += UMIN(100, get_skill(ch, gsn_capar));
		total += UMIN(100, get_skill(ch, gsn_gara));
		total += UMIN(100, get_skill(ch, gsn_hare));
		total += UMIN(100, get_skill(ch, gsn_snake));
		total += UMIN(100, get_skill(ch, gsn_ji));
		total += UMIN(100, get_skill(ch, gsn_sand));
		total += UMIN(100, get_skill(ch, gsn_ridgecat));
		total += UMIN(100, get_skill(ch, gsn_lion));
		total += UMIN(100, get_skill(ch, gsn_dream));
		total += UMIN(100, get_skill(ch, gsn_shadow));
		total += UMIN(100, get_skill(ch, gsn_wrath));
		total += UMIN(100, get_skill(ch, gsn_mystic));
		total += UMIN(100, get_skill(ch, gsn_ring));
		total += UMIN(100, get_skill(ch, gsn_earth));
		total += UMIN(100, get_skill(ch, gsn_balance));
		total /= 16;
	}
	else
	{
		total += UMIN(100, get_skill(ch, gsn_heron));
		total += UMIN(100, get_skill(ch, gsn_wind));
		total += UMIN(100, get_skill(ch, gsn_water));
		total += UMIN(100, get_skill(ch, gsn_sky));
		total += UMIN(100, get_skill(ch, gsn_stone));
		total += UMIN(100, get_skill(ch, gsn_storm));
		total += UMIN(100, get_skill(ch, gsn_lizard));
		total += UMIN(100, get_skill(ch, gsn_boar));
		total += UMIN(100, get_skill(ch, gsn_bird));
		total += UMIN(100, get_skill(ch, gsn_cat));
		total += UMIN(100, get_skill(ch, gsn_elemental));
		total += UMIN(100, get_skill(ch, gsn_will));
		total += UMIN(100, get_skill(ch, gsn_fire));
		total += UMIN(100, get_skill(ch, gsn_ice));
		total += UMIN(100, get_skill(ch, gsn_spirit));
		total += UMIN(100, get_skill(ch, gsn_circle));
		total /= 16;
	}

	return total;
}


void show_score( CHAR_DATA *ch, CHAR_DATA *viewer)
{
    char buf[MAX_STRING_LENGTH];
    ptc( viewer, " {cYou are %s", ch->colorname);

	if (!IS_NPC(ch)
	&& ch->race != race_lookup("aiel")
	&& ch->race != race_lookup("trolloc")
	&& ch->race != race_lookup("fade"))
		ptc(viewer, " %s", ch->pcdata->last_name);

    ptc( viewer, ", %d year old %s %s", get_age( ch ),
       IS_NPC(ch)  ? "n/a" : pc_race_table[ch->race].who_name,
       IS_NPC(ch)  ? "n/a" : clan_table[ch->clan].name != NULL ? capit2(clan_table[ch->clan].name) : "Loner");

    if( ch->sub_clan > 1)
	    ptc(viewer, " (%s)", capit2(clan_table[ch->sub_clan].name));
    stc( ".\n\r", viewer);

	ptc(viewer," {cLvL: {C%-6d {c({C%-6d{c) {cQP: {C%-6d{c QT: {C%-2d{x\n\r",
    ch->level, exp_per_level( ch, ch->pcdata->points ),
    ch->questpoints, ch->nextquest );
    /*if ( !IS_NPC( ch ) )
    {
		ptc( viewer, " {cSkP: {C%-7d {cWvP: {C%-7d {cRbiP: {C%-7d{x\n\r",
			count_skills( ch ), count_weaves( ch ), ( count_weaves( ch ) + count_skills( ch ) ) );
	}
	stc("\n\r",viewer);*/
	if ( can_remort( ch ) )
		stc(" {cYou are now ready to be REBORN.{x\n\r",viewer);
	/*else
		stc("\n\r",viewer);*/
	ptc(viewer," {cYou have been reborn %3d times.{x\n\r",
		ch->pcdata->rebirth);
	ptc(viewer," {cYou are on Remort Tier {w%2d{x [%s]{x\n\r",
		calc_remort_tier(ch),
		get_remort_title(ch));
	stc("{w.{B----------------------------------------------------------------{w.{x\n\r",viewer);

	stc("{B){w COMBAT STATS{x                                                   {B({x\n\r",viewer);
    ptc(viewer,"{B| {cSTR: {C%3d{x(%3d)   INT: {C%3d{x(%3d)    Health: {C%6d{c({C%6d{c){x        {B|{x\n\r",
	    get_curr_stat(ch,STAT_STR),ch->perm_stat[STAT_STR],
		get_curr_stat(ch, STAT_INT), ch->perm_stat[STAT_INT],
		ch->hit, get_maxhit(ch));
	ptc(viewer,"{B| {cDEX: {C%3d{x(%3d)   WIS: {C%3d{x(%3d)   Stamina: {C%6d{c({C%6d{c){x        {B|{x\n\r",
		get_curr_stat(ch, STAT_DEX), ch->perm_stat[STAT_DEX],
		get_curr_stat(ch, STAT_WIS), ch->perm_stat[STAT_WIS],
		ch->stam, get_maxstam(ch));
	ptc(viewer,"{B| {cCON: {C%3d{x(%3d)   INS: {C%3d{x(%3d)                                  {B|{x\n\r",
		get_curr_stat(ch, STAT_CON), ch->perm_stat[STAT_CON],
		get_curr_stat(ch, STAT_INS), ch->perm_stat[STAT_INS]);
	ptc(viewer,"{B| {cREF: {C%3d{x(%3d)   CHA: {C%3d{x(%3d)        CONC: {C%d                   {B|{x\n\r",
		get_curr_stat(ch, STAT_REF), ch->perm_stat[STAT_REF],
		get_curr_stat(ch, STAT_CHA), ch->perm_stat[STAT_CHA], ch->pcdata->concentration);

	if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
	{
    ptc(viewer,"{B|{c Air:     {C%3d    {cFire:  {C%3d  {cHR: {C%5d  {cPracs:  {C%6d          {B|{x\n\r",
    	ch->pcdata->op_air, ch->pcdata->op_fire,
    	GET_HITROLL(ch), ch->practice);
    ptc(viewer,"{B|{c Earth:   {C%3d    {cWater: {C%3d  {cDR: {C%5d  {cTrains: {C%6d          {B|{x\n\r",
    	ch->pcdata->op_earth, ch->pcdata->op_water,
    	 GET_DAMROLL(ch), ch->train);
    ptc(viewer,"{B|{c Spirit:  {C%3d                                                   {B|{x\n\r",
    	ch->pcdata->op_spirit);
	}
	else
	{
    ptc(viewer,"{B|{c Precise:    {C%3d% {cMaster:   {C%3d%   {cHR: {C%5d  {cPracs:  {C%6d      {B|{x\n\r",
    	get_skill(ch,gsn_precision), master_perc(ch), GET_HITROLL(ch), ch->practice);
    ptc(viewer,"{B|{c Efficient:  {C%3d% {cReaction: {C%3d%   {cDR: {C%5d  {cTrains: {C%6d      {B|{x\n\r",
    	get_skill(ch,gsn_efficient), get_skill(ch, gsn_anticipate),
    	 GET_DAMROLL(ch), ch->train);
	}

    if ( IS_SET ( ch->op_flags, OP_CHANNELER ) )
		ptc(viewer,"{B| {cYou are a channeler. Average OP score is %3d (%3d).            {B|{x\n\r",
		true_op_average(ch), true_op_average(ch)+true_angreal_bonus(ch));

	stc("{B| {wARMOR STATS{x                                                    {B|{x\n\r",viewer);
	sprintf( buf,"{B| {cPierce: {C%6d  {cBash: {C%6d  {cSlash: {C%6d  {cWeaves: {C%6d{x    {B|{x\n\r",
    GET_AC(ch,AC_PIERCE),
    GET_AC(ch,AC_BASH),
    GET_AC(ch,AC_SLASH),
    GET_AC(ch,AC_EXOTIC));
   	stc(buf,viewer);

	stc("{B| {wINFORMATIONAL STATS{x                                            {B|{x\n\r",viewer);

	sprintf( buf, "{B| {cCP: {C%8ld {cSP: {C%8ld {cSM: {C%8ld {cGM: {C%8ld{x            {B|{x{x\n\r",
	ch->money[0][0], ch->money[1][0], ch->money[2][0], ch->money[3][0] );
	stc( buf, viewer );

    sprintf( buf,
	"{B| {cYou are carrying %4d items, of a possible {C({c%4d{C){x              {B|{x\n\r{B|{x {cYour total weight is %7d stones{x                            {B|{x\n\r",
	ch->carry_number, can_carry_n(ch),
	get_carry_weight(ch) / 10 );
    stc( buf, viewer );

    sprintf( buf, "{B| {cWimpy set to {C%5ld{c HP  Scroll Length is {C%3d{c lines.             {B|{x\n\r",
	ch->wimpy, ch->lines );
	stc(buf,viewer);

    if ( !IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK]   > 10 )
	stc("{B| {cYou are drunk.{x                                                 {B|{x\n\r",   viewer );
    if ( !IS_NPC(ch) && ch->pcdata->condition[COND_THIRST] ==  0 )
	stc("{B| {cYou are thirsty.{x                                               {B|{x\n\r", viewer );
    if ( !IS_NPC(ch) && ch->pcdata->condition[COND_HUNGER]   ==  0 )
	stc("{B| {cYou are hungry.{x                                                {B|{x\n\r",  viewer );

   if ( !IS_NPC( ch ) && ch->pcdata->addict )
        ptc( viewer, "{B| {cYou're an {yaddict{c. (%3d time left)                              {B|{x\n\r",
        ch->pcdata->addict_hours );

    switch ( ch->position )
    {
	default:
	sprintf( buf, "{B| {cYou are quite normal at the moment.                            {B|{x\n\r" );
	break;
    case POS_DEAD:
	sprintf( buf, "{B| {cYou are DEAD!!                                                 {B|{x\n\r" );
	break;
    case POS_MORTAL:
	sprintf( buf, "{B| {cYou are mortally wounded.                                      {B|{x\n\r" );
	break;
    case POS_INCAP:
	sprintf( buf, "{B| {cYou are incapacitated.                                         {B|{x\n\r" );
	break;
    case POS_STUNNED:
	sprintf( buf, "{B| {cYou are stunned.                                               {B|{x\n\r" );
	break;
    case POS_SLEEPING:
	sprintf( buf, "{B| {cYou are sleeping.                                              {B|{x\n\r" );
	break;
    case POS_RESTING:
	sprintf( buf, "{B| {cYou are resting.                                               {B|{x\n\r" );
	break;
    case POS_STANDING:
	sprintf( buf, "{B| {cYou are standing.                                              {B|{x\n\r" );
	break;
    case POS_FIGHTING:
	sprintf( buf, "{B| {cYou are fighting.                                              {B|{x\n\r" );
	break;
    }
    stc( buf, viewer );
	stc("{B)                                                                ({x\n\r",viewer);
    if (!IS_NPC(ch))
    {
		int    rcnt    = roomcount(ch);
		double rooms   = top_room,
		       percent = (double)rcnt / (rooms / 100);
		ptc(viewer,"{w.{B------------------------ {cExplored [{W%-6d {cof {W%-6d {w({W%.2f%%{w){c]{B---{w.{x\n\r",
			rcnt,top_room,percent);
	}
	else
		stc("{w.{B----------------------------------------------------------------{w.{x\n\r",viewer);

    if (IS_SET(ch->comm,COMM_SHOW_AFFECTS) && viewer == ch)
	do_function(ch, &do_affects, "");

	stc( "See also: RPScore\n\r", viewer );

    return;
}

void do_affects(CHAR_DATA *ch, char *argument )
{
    AFFECT_DATA *paf, *paf_last = NULL;
    char buf[MAX_STRING_LENGTH];

	if ( IS_NPC( ch ) )
	return;

    if ( ch->affected != NULL )
    {
	stc( "{cYou are affected by the following:{c\n\r", ch );
	if ( ch->pcdata->char_barrier > 0 )
	{
    	if ( IS_SET(ch->op_flags, OP_BARRIER) && ch->pcdata->char_barrier > 0 )
			ptc( ch, "Affect: {wbarrier{c       : modifies damage by %d\n\r", ch->pcdata->char_barrier );
	}
	for ( paf = ch->affected; paf != NULL; paf = paf->next )
	{
	    if (paf_last != NULL && paf->type == paf_last->type)
		if (ch->level >= 1)
		    sprintf( buf, "{w                      {c");
		else
		    continue;
	    else
	    	sprintf( buf, "{cAffect:{w %-15s{c", skill_table[paf->type].name );

	    stc( buf, ch );

	    if ( ch->level >= 1 )
	    {
		sprintf( buf,
		    "{c: modifies %s by %d{c ",
		    affect_loc_name( paf->location ),
		    paf->modifier);
		stc( buf, ch );
		if ( paf->duration == -1 )
		    sprintf( buf, "{cpermanently{c" );
		else
		    sprintf( buf, "{cfor %d hours{c", paf->duration );
		stc( buf, ch );
	    }

	    stc( "{c\n\r", ch );
	    paf_last = paf;


	}

    }

   	else
	stc("{cYou are not affected by any weaves.{c\n\r",ch);

    return;
}



char *	const	day_name	[] =
{
    "{wMoon's Day{c", "{wFeastday{c", "{wKing's Day{c", "{wFreeday{c", "{wBell's Day{c",
    "{wQueen's Day{c", "{wSun's Day{c", "{wHunter's Day{c", "{wWind's Day{c", "{wSong's day{c"
};

char *	const	month_name	[] =
{
	"Taisham", "Jumara", "Saban", "Aine", "Adar", "Saven", "Amadaine",
	"Tammaz", "Maigdhal", "Choren", "Shaldine", "Nesan", "Danu"
};

void look_sky ( CHAR_DATA * ch )
{
    static char buf[MAX_STRING_LENGTH];
    static char buf2[4];
    int starpos, sunpos, moonpos, moonphase, i, linenum;
#ifdef DEBUG
        Debug ("look_sky");
#endif

   send_to_char("You gaze up towards the heavens and see:\n\r",ch);

   sunpos  = (MAP_WIDTH * (24 - time_info.hour) / 24);
   moonpos = (sunpos + time_info.day * MAP_WIDTH / NUM_DAYS) % MAP_WIDTH;
   if ((moonphase = ((((MAP_WIDTH + moonpos - sunpos ) % MAP_WIDTH ) +
                      (MAP_WIDTH/16)) * 8 ) / MAP_WIDTH)
		         > 4) moonphase -= 8;
   starpos = (sunpos + MAP_WIDTH * time_info.month / NUM_MONTHS) % MAP_WIDTH;
   /* The left end of the star_map will be straight overhead at midnight during
      month 0 */

   for ( linenum = 0; linenum < MAP_HEIGHT; linenum++ )
   {
     if ((time_info.hour >= 6 && time_info.hour <= 18) &&
         (linenum < 3 || linenum >= 6))
       continue;
     sprintf(buf,"{W|{x");
     for ( i = MAP_WIDTH/4; i <= 3*MAP_WIDTH/4; i++)
     {
       /* plot moon on top of anything else...unless new moon & no eclipse */
       if ((time_info.hour >= 6 && time_info.hour <= 18)  /* daytime? */
        && (moonpos >= MAP_WIDTH/4 - 2) && (moonpos <= 3*MAP_WIDTH/4 + 2) /* in sky? */
        && ( i >= moonpos - 2 ) && (i <= moonpos + 2) /* is this pixel near moon? */
        && ((sunpos == moonpos && time_info.hour == 12) || moonphase != 0  ) /*no eclipse*/
        && (moon_map[linenum-3][i+2-moonpos] == '@'))
       {
         if ((moonphase < 0 && i - 2 - moonpos >= moonphase) ||
             (moonphase > 0 && i + 2 - moonpos <= moonphase))
           strcat(buf,"{W@");
         else
           strcat(buf," ");
       }
       else
       if ((linenum >= 3) && (linenum < 6) && /* nighttime */
           (moonpos >= MAP_WIDTH/4 - 2) && (moonpos <= 3*MAP_WIDTH/4 + 2) /* in sky? */
        && ( i >= moonpos - 2 ) && (i <= moonpos + 2) /* is this pixel near moon? */
        && (moon_map[linenum-3][i+2-moonpos] == '@'))
       {
         if ((moonphase < 0 && i - 2 - moonpos >= moonphase) ||
             (moonphase > 0 && i + 2 - moonpos <= moonphase))
           strcat(buf,"{W@");
         else
           strcat(buf," ");
       }
       else /* plot sun or stars */
       {
         if (time_info.hour>=6 && time_info.hour<=18) /* daytime */
         {
           if ( i >= sunpos - 2 && i <= sunpos + 2 )
           {
             sprintf(buf2,"{y%c",sun_map[linenum-3][i+2-sunpos]);
             strcat(buf,buf2);
           }
           else
             strcat(buf," ");
         }
         else
         {
           switch (star_map[linenum][(MAP_WIDTH + i - starpos)%MAP_WIDTH])
           {
             default     : strcat(buf," ");    break;
             case '.'    : strcat(buf,".");    break;
             case ','    : strcat(buf,",");    break;
             case ':'    : strcat(buf,":");    break;
             case '`'    : strcat(buf,"`");    break;
             case 'R'    : strcat(buf,"{R ");  break;
             case 'G'    : strcat(buf,"{G ");  break;
             case 'B'    : strcat(buf,"{B ");  break;
             case 'W'    : strcat(buf,"{W ");  break;
             case 'M'    : strcat(buf,"{M ");  break;
             case 'N'    : strcat(buf,"{x ");  break;
             case 'y'    : strcat(buf,"{y ");  break;
             case 'c'    : strcat(buf,"{c ");  break;
           }
         }
       }
     }
     strcat(buf,"{W|{x\n\r");
     send_to_char(buf,ch);
   }
}

void do_system( CHAR_DATA *ch, char *argument )
{
//    int count;
    DESCRIPTOR_DATA *d;
    CHAR_DATA *dc;

    if ( IS_NPC(ch) || ch->desc == NULL )
    	return;

/*    count = 0;

    for ( d = descriptor_list; d != NULL; d = d->next )
    {
        if ( d->connected == CON_PLAYING && can_see( ch, d->character ) )
	    count++;
    }
*/
	stc("{WCurrent Staff Members Online:{x\n\r", ch);

/*
	stc("{R+{r--------------{R+{r--------{R+{r---------{R+{x\n\r", ch);
	stc("{R| {wName         {R| {wMentor {R| {wLeader  {R|{x\n\r", ch);
	stc("{R+{r--------------{R+{r--------{R+{r---------{R+{x\n\r", ch);
*/
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if (d == NULL)			continue;
		if (d->character == NULL)	continue;
		if (d->connected != CON_PLAYING || !can_see( ch, d->character ))
			continue;

		dc = d->character;

		if (!IS_SET(dc->war_flags, WAR_IMMORTAL)
		&& !IS_SET(dc->war_flags, WAR_MENTOR)
		&& !IS_SET(dc->war_flags, WAR_CODER)
		&& !IS_SET(dc->war_flags, WAR_MODERATOR)
		&& !IS_SET(dc->hist_flags, HIST_GUILDLEADER)
		&& !IS_SET(dc->hist_flags, HIST_RECRUITER))
			continue;

		ptc (ch, "{W%12s {D- {w", dc->name);

		if (IS_SET(dc->war_flags, WAR_IMMORTAL))	stc("They are an Immortal. ", ch);
		if (IS_SET(dc->war_flags, WAR_MENTOR))		stc("They are a Mentor. ", ch);
		if (IS_SET(dc->war_flags, WAR_CODER))		stc("They are a Coder. ", ch);
		if (IS_SET(dc->war_flags, WAR_MODERATOR))	stc("They are a Moderator. ", ch);
		if (IS_SET(dc->hist_flags, HIST_GUILDLEADER))	ptc(ch, "They are the guild leader of %s. ", clan_table[dc->clan].name);
		if (IS_SET(dc->hist_flags, HIST_RECRUITER))	ptc(ch, "They are a recruiter for %s. ", clan_table[dc->clan].name);
		stc("\n\r", ch);
	}
//	stc("{R+{r--------------{R+{r--------{R+{r---------{R+{x\n\r", ch);
	return;
}

char *shorter_date (time_t time)
{          
	static char buf[20];
	char *date;
	if (time < 0)
	{
		//bugf( "Invalid integer time: (%d)", time );
		time = current_time;
	}
	date = ctime (&time);
	if (date[8] == ' ')
		buf[0] = '0';
	else
                buf[0] = date[8];
  
	buf[1] = date[9];
	buf[2] = '-';
	buf[3] = date[4];
        buf[4] = date[5];
        buf[5] = date[6];
   
        return buf;
}

char *short_date (time_t time)
{   
	static char buf[20];
	char *date;
   
	if (time < 0)
	{
		//bugf( "Invalid integer time: (%d)", time );
		time = current_time;
	}
   
	date = ctime (&time);
	if (date[8] == ' ')
		buf[0] = '0';  
	else
		buf[0] = date[8];
   
	buf[1] = date[9];
	buf[2] = '-';
	buf[3] = date[4];  
	buf[4] = date[5];  
	buf[5] = date[6];  
	buf[6] = '-';
	buf[7] = date[20]; 
	buf[8] = date[21];  
	buf[9] = date[22];  
	buf[10] = date[23];
	buf[11] = ' ';
	buf[12] = date[11];
	buf[13] = date[12];
	buf[14] = date[13];
	buf[15] = date[14];
	buf[16] = date[15];
	buf[17] = date[16];  
	buf[18] = date[17];
	buf[19] = date[18];
	buf[20] = '\0';
    
	return buf;
}

void do_time( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char *suf;
    int day;

    day     = time_info.day + 1;

         if ( day > 4 && day <  20 ) suf = "th";
    else if ( day % 10 ==  1       ) suf = "st";
    else if ( day % 10 ==  2       ) suf = "nd";
    else if ( day % 10 ==  3       ) suf = "rd";
    else                             suf = "th";

    sprintf( buf,
        "{cIt is {w%d {co'clock {w%s.{c\n\r {cToday is %s{c, the {w%d%s{c day of the Month of {w%s{c, in the %s{c.{c\n\r",
	(time_info.hour % 12 == 0) ? 12 : time_info.hour %12,
        time_info.hour >= 12 ? "{win the evening{c" : "{wbefore noon{c",
	day_name[day % 10],
	day, suf,
	time_info.month <= 0 ? "Taisham" :
	time_info.month <= 13 ? month_name[time_info.month -1] :
	"unknown",
	SEASON == 1 ? "Spring" : SEASON == 2 ? "Summer" : SEASON == 3 ? "Autumn" : "Winter" );
    stc( buf, ch );
    if ( time_info.month == 13 && day == 28 )
    {
    	stc("Today is the Feast of Lights!\n\r",ch);
    	stc("This is the last day of Danu, and the end of the year.\n\r",ch);
    	stc("It is a time to give and receive charitably among all.\n\r",ch);
    }
    else if ( time_info.month == 1 && day == 12 )
    {
    	stc("Today is High Chasaline!\n\r",ch);
    	stc("Also called the Day of Reflection, during which the day\n\r",ch);
    	stc("is spent feasting and reflecting on good fortunes. It\n\r",ch);
    	stc("is considered bad form to make complaints on this day.\n\r",ch);
    }
    else if ( time_info.month == 2 && day == 3 )
    {
    	stc("Today is Chansein!\n\r",ch);
    	stc("This is a day of wild indulgence in food, where common\n\r",ch);
    	stc("practice is to encourage other people to eat as much as\n\r",ch);
    	stc("they can and more.\n\r",ch);
    }
    else if ( time_info.month == 2 && day == 9 )
    {
    	stc("Today is the Feast of Abram!\n\r",ch);
    }
    else if ( time_info.month == 3 && day == 12 )
    {
    	stc("Today is Lamma Sor!\n\r",ch);
    	stc("Celebrated in the Borderlands, it is a day where prayers\n\r",ch);
    	stc("are offered for those who have fallen defending against\n\r",ch);
    	stc("the Great Blight.\n\r",ch);
    }
    else if ( time_info.month == 8 && day == 10 )
    {
    	stc("Today is the Feast of Fools!\n\r",ch);
    	stc("This is a day where all order is deliberately inverted.\n\r",ch);
    	stc("The high perform lowly tasks, and the low do no work and\n\r",ch);
    	stc("give orders to those who would normally be superiors. The\n\r",ch);
    	stc("most foolish person is given the title of Lord or Lady of\n\r",ch);
    	stc("Chaos and Unreason, or the King or Queen of Fools.\n\r",ch);
    }
    else if ( time_info.month == 3 && day == 21 )
    {
    	stc("Today is Winternight!\n\r",ch);
    	stc("It is the night before Bel Tine, and is spent visiting\n\r",ch);
    	stc("and exchanging gifts.\n\r",ch);
    }
    else if ( time_info.month == 3 && day == 22 )
    {
    	stc("Today is Bel Tine!\n\r",ch);
    	stc("It is the last day of winter, celebrating the sprouting\n\r",ch);
    	stc("of crops and the births of the first lambs.\n\r",ch);
    }
    else if ( time_info.month == 5 && day == 5 )
    {
    	stc("Today is Trish Adar!\n\r",ch);
    	stc("It is the rise of the first full moon in Adar.\n\r",ch);
    }
    else if ( time_info.month == 5 && day == 9 )
    {
    	stc("Today is the Feast of Neman!\n\r",ch);
    }
    else if ( time_info.month == 5 && day == 21 )
    {
    	stc("Today is the Feast of Freia!\n\r",ch);
    }
    else if ( time_info.month == 6 && day == 9 )
    {
    	stc("Today is Dahan!\n\r",ch);
    	stc("Today celebrates the final victory of the Trolloc Wars.\n\r",ch);
    }
    else if ( time_info.month == 6 && day == 23 )
    {
    	stc("Today is the day the High King, Artur Hawkwing, died.\n\r",ch);
    }
    else if ( time_info.month == 7 && day == 12 )
    {
    	stc("Today is Asadine!\n\r",ch);
    	stc("It is ten days until midsummer.\n\r",ch);
    }
    else if ( time_info.month == 7 && day == 22 )
    {
    	stc("Today begins midsummer!\n\r",ch);
    }
    else if ( time_info.month == 7 && day == 6 )
    {
    	stc("Today is the Feast of Maia!\n\r",ch);
    }
    else if ( time_info.month == 7 && day == 9 )
    {
    	stc("Today is Bailene!\n\r",ch);
    }
    else if ( time_info.month == 8 && day == 3 )
    {
    	stc("Today is Genshai!\n\r",ch);
    	stc("On this day men and women wear brightly colored ribbons\n\r",ch);
    	stc("in their hair.\n\r",ch);
    }
    else if ( time_info.month == 8 && day == 18 )
    {
    	stc("Today is Mabriam's Day!\n\r",ch);
    	stc("On this day, any sort of labor is avoided. Young women\n\r",ch);
    	stc("play tricks on young men to show their interest, and if\n\r",ch);
    	stc("the woman responsible for playing the trick is guessed\n\r",ch);
    	stc("by the young man, a kiss must be given.\n\r",ch);
    }
    else if ( time_info.month == 9 && day == 9 )
    {
    	stc("Today is Tandar!\n\r",ch);
    	stc("This day should not be ended with anyone holding a grudge.\n\r",ch);
    }
    else if ( time_info.month == 9 && day == 18 )
    {
    	stc("Today is Low Chasaline!\n\r",ch);
    	stc("This is a day of fasting.\n\r",ch);
    }
    else if ( time_info.month == 10 && day == 1 )
    {
    	stc("Today is the Festival of Lanterns!\n\r",ch);
    	stc("Paper lanterns, brightly colored and fancifully colored\n\r",ch);
    	stc("are hung everywhere from windows to trees.\n\r",ch);
    }
    else if ( time_info.month == 10 && day == 3 )
    {
    	stc("On this day in history, in the year 976, thousands of Aiel\n\r",ch);
    	stc("swept down from the Dragonwall upon Cairhien.\n\r",ch);
    }
    else if ( time_info.month == 9 && day == 22 )
    {
    	stc("Today is Bel Arvina!\n\r",ch);
    	stc("This is the first day of autumn.\n\r",ch);
    }
    else if ( time_info.month == 11 && day == 6 )
    {
    	stc("Today is Amaetheon!\n\r",ch);
    	stc("This day is celebrated everywhere except the Borderlands,\n\r",ch);
    	stc("and the dead are remembered in a joyous manner.\n\r",ch);
    }
    else if ( time_info.month == 11 && day == 12 )
    {
    	stc("Today is Shaoman!\n\r",ch);
    	stc("Today is a day to celebrate children.\n\r",ch);
    }
    else if ( time_info.month == 12 && day == 27 )
    {
    	stc("On this day in history, in the Year of Grace 978, began\n\r",ch);
    	stc("the Battle of Tar Valon.\n\r",ch);
    }
    else if ( time_info.month == 1 && day == 1 )
    {
    	stc("On this day in history, in the Year of Grace 978, Laman\n\r",ch);
    	stc("of Cairhien died at the Battle of Tar Valon.\n\r",ch);
    }
    else if ( time_info.month == 12 && day == 28 )
    {
    	stc("Today is Danshu!\n\r",ch);
    }
    else if ( time_info.month == 8 && day == 25 )
    {
    	stc("Today is Sunday!\n\r",ch);
    }

    printf_to_char (ch, "[System Time: %s]\n\r", short_date (current_time));
    return;
}



void do_weather( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    const char *msg;
    const char *dir;
    int dirNum = weather_info.sky;
    int type = 0;

    static char * const sky_look[4] =
    {
	"cloudless",
	"cloudy",
	"rainy",
	"lit by flashes of lightning"
    };

    dirNum = number_range(dirNum,dirNum+1);
    switch( dirNum )
    {
    	default: dir = "northerly"; break;
	    case 1:  dir = "northerly"; break;
	    case 2:  dir = "north-easterly"; break;
	    case 3:  dir = "easterly"; break;
	    case 4:  dir = "south-easterly"; break;
	    case 5:  dir = "southerly"; break;
	    case 6:  dir = "south-westerly"; break;
	    case 7:  dir = "westerly"; break;
	    case 8:  dir = "north-westerly"; break;
    }

    if ( !IS_OUTSIDE(ch) )
    {
	stc( "{cYou can't see the weather indoors.{c\n\r", ch );
	return;
    }

	look_sky( ch );
    switch( ch->in_room->sector_type )
    {
    	default: type = 0; msg = "through"; break;
		case(SECT_INSIDE): type = 0; msg = "through"; break;
		case(SECT_CITY): type = 0; msg = "between the buildings"; break;
		case(SECT_FIELD): type = 0; msg = "across the fields"; break;
		case(SECT_FOREST): type = 0; msg = "through the trees"; break;
		case(SECT_HILLS): type = 0; msg = "over the hills"; break;
		case(SECT_MOUNTAIN): type = 0; msg = "over the mountain peaks"; break;
		case(SECT_WATER_SWIM): type = 0; msg = "across the water"; break;
		case(SECT_WATER_NOSWIM): type = 0; msg = "over the water"; break;
		case(SECT_AIR): type = 0; msg = "through"; break;
	    case(SECT_TUNDRA): type = 0; msg = "over the tundra"; break;
	    case(SECT_BLIGHT): type = 1; msg = "through the blight"; break;
	    case(SECT_COASTAL): type = 0; msg = "across the coast"; break;
	    case(SECT_ROAD): type = 0; msg = "over the road"; break;
	    case(SECT_MARSH): type = 0; msg = "across the marsh"; break;
		case(SECT_DESERT): type = 1; msg = "over the sands"; break;
    }

    sprintf( buf, "The sky is %s, and %s %s %s %s.\n\r",
    type == 0 ? sky_look[weather_info.sky] : "clear and cloudless",
    weather_info.change >= 0
    ? "a warm" : "a cold",
    dir,
    weather_info.change >= 0
    ? "breeze blows" : "gust blows",
    msg );

    if ( weather_info.sky == SKY_CLOUDY )
	{
	    strcat( buf, "Dark purple and black clouds have gathered in the sky.\n\r" );
	}

    stc( buf, ch );
    return;
}

char * talent_string( int sn )
{
	int i = 0;
	bool found = FALSE;

	for ( i = 0; i < TALENT_MAX; i++ )
	{
		if ( skill_table[sn].talent == weave_talents_table[i].talent )
		{
			found = TRUE;
			return capit2(weave_talents_table[i].name);
		}
	}
	return str_dup("Unknown");
}

void do_help( CHAR_DATA *ch, char *argument )
{
	HELP_DATA *pHelp;
	BUFFER *output;
	bool found = FALSE;
	char skarg[MSL];
	char *skarg_p; /* FIXME skarg is a little screwy */
	char argall[MIL],argone[MIL];
	char nohelp[MIL], arg1[MIL];
	int level;
	char arg2[MIL];

	strcpy( skarg, argument );
	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( !str_cmp( arg1, "skill" ) )
 	{
		int sn, skReq;
		if ( arg2[0] == '\0' )
		{
			stc( "Syntax error getting lookup type.\n\r", ch );
			stc( "Syntax: Help Skill <skill name>\n\r", ch );
			return;
		}
		if ( ( sn = skill_lookup( arg2 ) ) < 0 )
		{
			stc("What skill?\n\r",ch);
			return;
		}

		ptc( ch, "Name:         %s\n\r", skill_table[sn].name );
		ptc( ch, "Train Cost:   %d\n\r", skill_table[sn].rating[ch->class] );
		if ( skill_table[sn].remort_only )
			ptc( ch, "Remort:       %d\n\r", skill_table[sn].remort_only);
		if ( skill_table[sn].spell_fun != spell_null )
			ptc( ch, "Mana Cost:    %d\n\r", skill_table[sn].min_mana );
		ptc( ch, "Lag Time:     %d\n\r", skill_table[sn].beats );
		ptc( ch, "Wear Off Msg: %s\n\r", skill_table[sn].msg_off );
		if ( skill_table[sn].req_skill != NULL )
		{
			skReq = skill_lookup(skill_table[sn].req_skill);
			ptc( ch, "Requirement:  %s at 85%\n\r", skill_table[skReq].name );
		}
		ptc( ch, "Description:  %s\n\r", skill_table[sn].descr );
		return;
	}
	else if ( !str_cmp( arg1, "guild" ) )
 	{
		int clan;
		if ( arg2[0] == '\0' )
		{
			stc( "Syntax error getting lookup type.\n\r", ch );
			stc( "Syntax: Help Guild <guild name>\n\rFor general information on guilds, see 'help guilds'\n\r", ch );
			return;
		}
		if ( ( clan = clan_lookup( arg2 ) ) <= 0 )
		{
			stc("Which guild?\n\r",ch);
			return;
		}

		ptc(ch, "%s %s\n\rChannels: [IC - %s, OOC - %s]\n\r\n\r%s\n\r\n\rLeaders: %s\n\r\n\r",
		clan_table[clan].who_name, clan_table[clan].tag, clan_table[clan].gcom, clan_table[clan].gcomooc, clan_table[clan].help, clan_table[clan].gl);

		return;
	}
	else if ( !str_cmp( arg1, "weave" ) )
 	{
		int sn;
		if ( arg2[0] == '\0' )
		{
			stc( "Syntax error getting lookup type.\n\r", ch );
			stc( "Syntax: Help Weave <skill name>\n\r", ch );
			return;
		}
		if ( ( sn = skill_lookup( arg2 ) ) < 0 )
		{
			stc("Which weave?\n\r",ch);
			return;
		}
		ptc( ch, "Name:         %s\n\r", skill_table[sn].name );
		ptc( ch, "Train Cost:   %d\n\r", skill_table[sn].rating[ch->class] );
		if ( skill_table[sn].remort_only )
			ptc( ch, "Remort:       %d\n\r", skill_table[sn].remort_only);
		if ( skill_table[sn].spell_fun != spell_null )
			ptc( ch, "Mana Cost:    %d\n\r", skill_table[sn].min_mana );
		ptc( ch, "Timer:        %d\n\r", skill_table[sn].beats );
		ptc( ch, "Wear Off Msg: %s\n\r", skill_table[sn].msg_off );
		ptc( ch, "Requires:     E: %d  A: %d  F: %d  W: %d  S: %d\n\r",
			skill_table[sn].sphere_earth,
			skill_table[sn].sphere_air,
			skill_table[sn].sphere_fire,
			skill_table[sn].sphere_water,
			skill_table[sn].sphere_spirit );
		if ( skill_table[sn].base_dmg > 0 )
			ptc( ch, "Base Dmg:     %d\n\r", skill_table[sn].base_dmg );
		ptc( ch, "Talent:       %s\n\r", talent_string( sn ) );
		ptc( ch, "Description:  %s\n\r", skill_table[sn].descr );
		return;
	}

	output = new_buf();
 	strcpy(nohelp, skarg);

 	if ( skarg[0] == '\0' )
		strcpy(skarg ,  "summary");

 	argall[0] = '\0';

	skarg_p = skarg;
    while (skarg_p[0] != '\0' )
    {
		skarg_p = one_argument(skarg_p,argone);
		if (argall[0] != '\0')
		    strcat(argall," ");
		strcat(argall,argone);
    }

    for ( pHelp = help_first; pHelp != NULL; pHelp = pHelp->next )
    {
    	level = (pHelp->level < 0) ? -1 * pHelp->level - 1 : pHelp->level;

		if (level > get_trust( ch ) )
		    continue;

		if ( is_name( argall, pHelp->keyword ) )
		{
		    if (found)
			add_buf(output,
		    "\n\r{w============================================================{c\n\r\n\r");
		    if ( pHelp->level >= -1 && str_cmp( argall, "imotd" ) )
		    {
				add_buf(output,pHelp->keyword);
				add_buf(output,"\n\r");
		    }

		    if ( pHelp->text[0] == '.' )
				add_buf(output,pHelp->text+1);
		    else
		    {
				add_buf(output,pHelp->text);
				if ( !str_cmp(pHelp->related, "NONE") )
				;
				else
				{
					add_buf(output,"\n\r");
					add_buf(output,"SEE ALSO:\n\r");
					add_buf(output,pHelp->related);
					add_buf(output,"\n\r");
				}
			}
		    found = TRUE;
		    if (ch->desc != NULL && ch->desc->connected != CON_PLAYING)
				break;
		}
    }

    if(!found)
    {
	if ( skill_lookup( arg1 ) >= 0 )
	{
		char skill_buf[MSL];
		sprintf(skill_buf,"skill %s",arg1);
		do_function( ch, &do_help, skill_buf);
    		free_buf(output);
		return;
	}
    	stc("\n\rNo help on that word.\n\rA message to the Immortals has been left concerning the problem.\n\r", ch);
    	stc("Check your spelling for typos, and also try using similar words to describe the help function\n\r", ch);
    	stc("you are looking for.\n\r",ch);
        append_file( ch, HELP_FILE, nohelp );
    }
    else
	page_to_char(buf_string(output),ch);
    free_buf(output);
}

void do_oldhelp( CHAR_DATA *ch, char *argument )
{
    HELP_DATA *pHelp;
    BUFFER *output;
    bool found = FALSE;
    char argall[MAX_INPUT_LENGTH],argone[MAX_INPUT_LENGTH];
    char nohelp[MAX_STRING_LENGTH];
    int level;

    if ( !str_cmp( argument, "skill" ) )
    {
		char arg2[MIL], arg3[MIL];
		int sn, skReq;
		argument = one_argument( argument, arg2 );
		argument = one_argument( argument, arg3 );
		ptc(ch,"Arg2 %s Arg3 %s\n\r", arg2, arg3);
		if ( arg2[0] == '\0' || arg3[0] != '\0' )
		{
			stc( "Syntax: Help Skill <skill name>\n\r", ch );
			return;
		}
		if ( ( sn = skill_lookup( arg3 ) ) < 0 )
		{
			stc("What skill?\n\r",ch);
			return;
		}
		ptc( ch, "Name:         %s\n\r", skill_table[sn].name );
		ptc( ch, "Train Cost:   %d\n\r", skill_table[sn].rating );
		ptc( ch, "Lag Time:     %d\n\r", skill_table[sn].beats );
		ptc( ch, "Wear Off Msg: %s\n\r", skill_table[sn].msg_off );
		if ( skill_table[sn].req_skill != NULL )
		{
			skReq = skill_lookup(skill_table[sn].req_skill);
			ptc( ch, "Requirement:  %s at 85%\n\r", skill_table[skReq].name );
		}
		ptc( ch, "Description:  %s\n\r", skill_table[sn].descr );
		return;
	}

	stc("Not looking for a skill anymore...\n\r", ch);

    output = new_buf();
    strcpy(nohelp, argument);

    if ( argument[0] == '\0' )
		argument = "summary";

    argall[0] = '\0';

    while (argument[0] != '\0' )
    {
		argument = one_argument(argument,argone);
		if (argall[0] != '\0')
		    strcat(argall," ");
		strcat(argall,argone);
    }

    for ( pHelp = help_first; pHelp != NULL; pHelp = pHelp->next )
    {
    	level = (pHelp->level < 0) ? -1 * pHelp->level - 1 : pHelp->level;

		if (level > get_trust( ch ) )
		    continue;

		if ( is_name( argall, pHelp->keyword ) )
		{
		    if (found)
			add_buf(output,
		    "\n\r{w============================================================{c\n\r\n\r");
		    if ( pHelp->level >= -1 && str_cmp( argall, "imotd" ) )
		    {
				add_buf(output,pHelp->keyword);
				add_buf(output,"\n\r");
		    }

		    if ( pHelp->text[0] == '.' )
				add_buf(output,pHelp->text+1);
		    else
		    {
				add_buf(output,pHelp->text);
				if ( !str_cmp(pHelp->related, "NONE") )
				;
				else
				{
					add_buf(output,"\n\r");
					add_buf(output,"SEE ALSO:\n\r");
					add_buf(output,pHelp->related);
					add_buf(output,"\n\r");
				}
			}
		    found = TRUE;
		    if (ch->desc != NULL && ch->desc->connected != CON_PLAYING)
				break;
		}
    }

    if(!found)
    {
    	stc("\n\rNo help on that word.\n\rA message to the Immortals has been left concerning the problem.\n\r", ch);
    	stc("Check your spelling for typos, and also try using similar words to describe the help function\n\r", ch);
    	stc("you are looking for.\n\r",ch);
        append_file( ch, HELP_FILE, nohelp );
    }
    else
	page_to_char(buf_string(output),ch);
    free_buf(output);
}
/*
void do_help( CHAR_DATA *ch, char *argument )
{
    char buf[MSL];
    HELP_DATA *pHelp;
    BUFFER *output;
    char nohelp[MSL];
    bool found = FALSE;
    char argall[MIL],argone[MIL];
    int level;
    int count = 0;

    output = new_buf();

    if ( argument[0] == '\0' )
	argument = "summary";

    argall[0] = '\0';
    while (argument[0] != '\0' )
    {
	argument = one_argument(argument,argone);
	if (argall[0] != '\0')
	    strcat(argall," ");
	strcat(argall,argone);
    }

    for ( pHelp = help_first; pHelp != NULL; pHelp = pHelp->next )
    {
    	level = (pHelp->level < 0) ? -1 * pHelp->level - 1 : pHelp->level;
		if (level > get_trust( ch ) )
		    continue;
		if ( is_name( argall, pHelp->keyword ) )
		{
	    	if ( pHelp->level >= 0 && str_cmp( argall, "imotd" ) )
	    	{
				add_buf(output,pHelp->keyword);
	    	}
			if ( strlen( argall ) == 1 )
				;
			else if ( pHelp->text[0] == '.' )
				add_buf(output,pHelp->text+1);
			else
				add_buf(output,pHelp->text);
			found = TRUE;
		    if (ch->desc != NULL && ch->desc->connected != CON_PLAYING)
				break;
		    if (found)
		    {
				stc("\n\r", ch);
				stc("List of keywords found:\n\r", ch);
				stc("============================================================{x\n\r\n\r",ch);
				for ( pHelp = help_first; pHelp != NULL; pHelp = pHelp->next )
				{
					level = (pHelp->level < 0) ? -1 * pHelp->level - 1 : pHelp->level;
					if (level > get_trust( ch ) )
						continue;
					if ( is_name( argall, pHelp->keyword ) )
					{
						if ( pHelp->level >= 0 && str_cmp( argall, "imotd" ) )
		    			{
							count++;
							sprintf( buf,"{w<{W%-2d{R:{x ", count);
		   					stc( buf, ch );
							stc(pHelp->keyword, ch);
							stc(" {w>{x\n\r", ch);
		    			}
					}
				}
				sprintf( buf, "\n\rThere %s {R%d{x keywords found for what you where looking for",
					count == 0 || count > 1 ? "were" : "was", count);
		   		stc( buf, ch );
		        return;
		    }
		}
    }

    if (!found)
    {
    	stc("\n\rNo help on that word.\n\rA message to the Immortals has been left\n\r",ch);
    	stc("concerning the problem.\n\r", ch);
    	stc("Check your spelling for typos, and also try using similar words to\n\r",ch);
    	stc("describe the help function you are looking for.\n\r",ch);
        append_file( ch, HELP_FILE, nohelp );
    }
    else
	page_to_char(buf_string(output),ch);
    free_buf(output);
}
*/
/* whois command */
void do_whois (CHAR_DATA *ch, char *argument)
{
    char arg[MAX_INPUT_LENGTH];
    BUFFER *output;
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
    bool found = FALSE;
    char            s[100];
    int count = 0;

    one_argument(argument,arg);

    if (arg[0] == '\0')
    {
		stc("{cYou must provide a name.{c\n\r",ch);
		return;
    }

    output = new_buf();

    stc("{b----------------------------------------------------------------------{x\n\r", ch);
    for (d = descriptor_list; d != NULL; d = d->next)
    {
		CHAR_DATA *wch;
		char const *class;

	 	if (d->connected != CON_PLAYING || !can_see(ch,d->character))
		    continue;

		wch = ( d->original != NULL ) ? d->original : d->character;

	 	if (!can_see(ch,wch))
		    continue;

		if (!str_prefix(arg,wch->name))
		{
		    found = TRUE;

		    /* work out the printing */
		    class = class_table[wch->class].who_name;
		    switch(wch->level)
		    {
				case MAX_LEVEL - 0 : class = "IMP";	break;
				case MAX_LEVEL - 1 : class = "CRE";	break;
				case MAX_LEVEL - 2 : class = "SUP";	break;
				case MAX_LEVEL - 3 : class = "DEI";	break;
				case MAX_LEVEL - 4 : class = "GOD";	break;
				case MAX_LEVEL - 5 : class = "IMM";	break;
				case MAX_LEVEL - 6 : class = "DEM";	break;
				case MAX_LEVEL - 7 : class = "ANG";	break;
				case MAX_LEVEL - 8 : class = "AVA";	break;
		    }

		    /* a little formatting
		    sprintf(buf, "[%2d{x %6s{x %s{x]\n\r%s{x%s{x%s{x%s{x%s{x%s{x%s{x %s{x%s{x\n\r(%d){x %s{x %s{x\n\r",
			wch->level,
			wch->race < MAX_PC_RACE ? pc_race_table[wch->race].who_name	: "     ",	class,
			wch->incog_level >= LEVEL_HERO ? "(Incog) ": "",
			wch->invis_level >= LEVEL_HERO ? "(Wizi) " : "",
			clan_table[wch->clan].who_name,
			IS_SET(wch->comm, COMM_AFK) ? "[AFK] " : "",
			IS_SET(wch->comm, COMM_RP) ? "{Y(RolePlay){c " : "",
			IS_SET(wch->act,PLR_KILLER) ? "(KILLER) " : "",
			IS_SET(wch->act,PLR_THIEF) ? "(THIEF) " : "",
			wch->name, IS_NPC(wch) ? "" : wch->pcdata->title,
			( wch->played + (int) (current_time - wch->logon) ) / 3600,
			is_exact_name(wch->name, "Caedd") ? "193.129.14.24" : wch->desc->host,
			wch->pcdata->allowed == 0 ? "Not Verified" : "Verified" );
			*/

			count++;
			strftime( s, 100, "%I:%M%p", localtime( &wch->logon ) );

			sprintf( buf, "{w%d{W) {C%s %s %s{c, {C%s %s %s %s{c, level {C%d{x\n\r" \
				"{c   Connected from {C%s {cat {C%s{c, {CIdle for: %d{x\n\r" \
				"{C   Verified{c? {C%s{c, {CWarns{c: {C%d{x\n\r",
				count,
				IS_IMMORTAL( wch ) ? "Immortal" :
				MODERATOR( wch ) ? "Moderator" :
				MENTOR( wch ) ? "Mentor" :
				"Mortal",
				wch->colorname,
				wch->pcdata ? wch->pcdata->last_name : "Unknown",
				wch->race < MAX_PC_RACE ? pc_race_table[wch->race].who_name : "",
				capit2( clan_table[wch->clan].name ), player_rank( wch, TRUE ), player_rank (wch, FALSE), wch->level,
				wch->desc ? wch->desc->host : "Unknown", s, wch->timer,
				wch->pcdata->allowed ? "Yes" : "No", wch->pcdata->warning
				);

			add_buf(output,buf);
/*
		    for (d2 = descriptor_list; d2 != NULL; d2 = d2->next)
		    {
				if ( d2->connected != CON_PLAYING )
					continue;
				if ( !can_see(ch,wch) )
					continue;
				if ( !can_see(ch,d2->character) )
					continue;
				if ( !str_cmp( d2->character->name, wch->name ) )
					continue;
				if ( d2->character == wch )
					continue;
				if ( !str_cmp( d2->host, wch->desc->host ) )
				{
					sprintf( multibuf, "%s ", d2->character->name );
				}
			}
*/
		}

    }

    if (!found)
    {
		stc("{cNo one of that name is playing.{c\n\r",ch);
		return;
    }

    page_to_char(buf_string(output),ch);
    free_buf(output);
    stc("{b----------------------------------------------------------------------{x\n\r",ch);

	sprintf(buf, "Client: %s (Version: %s).\n\r", 
	ch->desc->pProtocol->pVariables[eMSDP_CLIENT_ID]->pValueString,
	ch->desc->pProtocol->pVariables[eMSDP_CLIENT_VERSION]->pValueString);
	send_to_char(buf, ch);
	if (str_cmp(ch->desc->pProtocol->pVariables[eMSDP_PLUGIN_ID]->pValueString, "Unknown"))
	{
	sprintf(buf, "Plugin: %s\n\r", ch->desc->pProtocol->pVariables[eMSDP_PLUGIN_ID]->pValueString);
	send_to_char(buf, ch);
	}
	send_to_char("Protocols: ", ch);

	if (ch->desc->pProtocol->bNAWS )
	send_to_char("NAWS", ch);
	if (ch->desc->pProtocol->bMSP )
	send_to_char(", MSP", ch);
	if (ch->desc->pProtocol->bATCP )
	send_to_char(", ATCP", ch);
	if (ch->desc->pProtocol->b256Support )
	send_to_char(", 256 Colours", ch);
	if (ch->desc->pProtocol->bMXP )
	{
	sprintf(buf, ", MXP (%s)", ch->desc->pProtocol->pMXPVersion);
	send_to_char(buf, ch);
	}
	if (ch->desc->pProtocol->bMCCP)
	send_to_char(", MCCP2", ch);
	if (ch->desc->pProtocol->bMSDP )
	send_to_char(", MSDP", ch);
	if (ch->desc->pProtocol->bNAWS )
	{
	sprintf(buf, ".\n\rScreen Size: %d characters wide and %d characters high.\n\r", 
	ch->desc->pProtocol->ScreenWidth,
	ch->desc->pProtocol->ScreenHeight );
	send_to_char(buf, ch);
	}
	else
	send_to_char("\n\r", ch);
}

struct sort_char_struct
{
	int is_buddy;
	sh_int is_immortal;
	sh_int incog;
	sh_int wizi;
	sh_int afk;
	char *name;
};
int sort_char_by_name(const void *aname, const void *bname )
{
	struct sort_char_struct aaname;
	struct sort_char_struct bbname;
	aaname = *(struct sort_char_struct *) aname;
	bbname = *(struct sort_char_struct *) bname;
	return strcmp(aaname.name,bbname.name);
}

void do_who( CHAR_DATA *ch, char *argument )
{
    char buf[MSL];
    char arg[MIL], arg2[MIL];
    BUFFER *output;
    DESCRIPTOR_DATA *d;
    bool bm = FALSE;
    int nMatch;

    int count = 0,i;
    struct sort_char_struct *short_chars;

    buf[0] = '\0';
    argument = one_argument( argument, arg );
    argument = one_argument( argument, arg2 );

    output = new_buf();

	if ( arg[0] == '\0' )
	{
		do_function( ch, &do_who, "long" );
		return;
	}

	stc( "                  {wWho is currently playing:{c\n\r\n\r",ch);
    do_function( ch, &do_count, "" );

    if ( !str_cmp( arg, "short" ) )
    {
		int col = 0;
		stc( " {G~{g------------------------------------------------------------{G~{x\n\r     ", ch );
	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch   = ( d->original != NULL ) ? d->original : d->character;

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}
			count++;
	    }
	    i=0;
	    short_chars = malloc(sizeof(struct sort_char_struct) * count);
	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch   = ( d->original != NULL ) ? d->original : d->character;

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}
			short_chars[i].is_buddy = check_buddy( ch, wch ) >= 0 ? 1 : 0;
			short_chars[i].is_immortal = IS_IMMORTAL( wch ) ? 1 : 0;
			//short_chars[i].name = str_dup(format_str_len(wch->colorname, 15, ALIGN_LEFT));
			short_chars[i].name = str_dup(wch->colorname);
			short_chars[i].wizi = wch->invis_level >= LEVEL_HERO ? 1 : 0;
			short_chars[i].incog = wch->incog_level >= LEVEL_HERO ? 1 : 0;
			short_chars[i].afk = IS_SET(wch->comm,COMM_AFK) ? 1 : 0;
			i++;
	    }
		qsort(short_chars,count,sizeof(struct sort_char_struct),sort_char_by_name);
		for(i = 0; i<count; i++)
		{
			if ( col > 3 )
			{
				sprintf( buf, "\n\r     " );
				add_buf(output,buf);
				col = 0;
			}
			sprintf( buf, "%s%s{x",
					short_chars[i].wizi && short_chars[i].incog ? "{B" :
					short_chars[i].wizi ? "{r" :
					short_chars[i].incog ? "{R" :
					short_chars[i].is_immortal ? "{W" :
					short_chars[i].is_buddy && short_chars[i].afk ? "{c" :
					short_chars[i].is_buddy ? "{C" :
					short_chars[i].afk ? "{g" : "{w",
					short_chars[i].name);
			add_buf(output,buf);
			col++;
	    }
	    page_to_char( buf_string(output), ch );
	    free_buf(output);
		stc( "\n\r", ch );
		stc( " {G~{g------------------------------------------------------------{G~{x\n\r", ch );
		if(IS_IMMORTAL( ch) )
		    stc( "               {rwiz{g | {Cbud{g/{cafk-bud{g | {gafk{g | {Rinc{g | {Wimm{x\n\r", ch );
		else
		    stc( "                     {Cbud{g/{cafk-bud{g | {gafk{g | {Wimm{x\n\r", ch );
		col = 0;
		free(short_chars);
	    return;
	}

	else if ( !str_cmp( arg, "is" ) )
	{
		char *rbi_holder = NULL;
		char s[100];
		ptc( ch, "Trying to find all visible %s.\n\r", arg2);

		stc( " {G~{g-----------{G~{x\n\r", ch );

	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch = ( d->original != NULL ) ? d->original : d->character;

			if ( str_prefix(arg2,wch->name)  )
				continue;
			strftime( s, 100, "%I:%M%p", localtime( &wch->logon ) );

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}

		    nMatch++;
		    rbi_holder = show_rbi_letter( wch );

			sprintf( buf, "{w%12s %s%s{x%s%s%s {w%s{w%s\n\r{w%12s {D---{w Idle Time: {W%2d %s%s%s{x\n\r",

			/* line one */

		    wch->race < MAX_PC_RACE ? pc_race_table[wch->race].who_name : "",

		    check_buddy( wch, ch ) >= 0 ? "{M" : "{B",

		    IS_SET( wch->comm, COMM_AFK ) ? "{r<{x" :
		    wch->incog_level >= LEVEL_HERO && wch->invis_level >= LEVEL_HERO ? "{r*{x" :
		    wch->incog_level >= LEVEL_HERO ? "{r({x" :
		    wch->invis_level >= LEVEL_HERO ? "{r{{{x" : "[",

			IS_IMMORTAL(wch) ? "{WI{w" : rbi_holder,

		    check_buddy( wch, ch ) >= 0 ? "{M" : "{B",

		    IS_SET( wch->comm, COMM_AFK ) ? "{r>{x" :
		    wch->incog_level >= LEVEL_HERO && wch->invis_level >= LEVEL_HERO ? "{r*{x" :
		    wch->incog_level >= LEVEL_HERO ? "{r){x" :
		    wch->invis_level >= LEVEL_HERO ? "{r}{x" : "]",

		    is_exact_name( wch->name, "shaitan" ) ? "Shai'tan" : wch->name,
		    IS_NPC(wch) ? "" : wch->pcdata->title,

		    /* line two */

		    blademaster(wch) ? "Blademaster" : spearmaster( wch ) ? "Spearmaster" : "",
		    wch->timer,

		    IS_SET( wch->comm, COMM_RP ) ? "{w[{WRP{w]{x" : "",
		    IS_SET( wch->comm, COMM_QUIET ) ? "{w[{WQuiet{w]{x" : "",
		    IS_SET( wch->comm, COMM_DEAF ) ? "{w[{WDeaf{w]{x" : "" );

			free_string(rbi_holder);

		    bm = FALSE;

			add_buf(output,buf);

	    }
	    page_to_char( buf_string(output), ch );
	    free_buf(output);
		stc( " {G~{g-----------{G~{x\n\r", ch );
	    return;
	}

	else if ( !str_cmp( arg, "guild" ) )
	{
		int guild;
		if ( ( guild = clan_lookup( arg2 ) ) == 0 )
		{
			stc( "Sorry, but you can't do that.\n\r", ch );
			return;
		}
		else
			ptc( ch, "Trying to find all visible %s.\n\r", clan_table[guild].name );

		stc( " {G~{g-----------{G~{x\n\r", ch );

	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch = ( d->original != NULL ) ? d->original : d->character;

			if ( wch->clan != guild )
				continue;

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}
			sprintf( buf, "{x   %s%-13s\n\r{x",
					wch->name, check_buddy( wch, ch ) >= 0 ? "{y" : "{w" );
			add_buf(output,buf);
	    }
	    page_to_char( buf_string(output), ch );
	    free_buf(output);
		stc( " {G~{g-----------{G~{x\n\r", ch );
	    return;
	}

	else if ( !str_cmp( arg, "race" ) )
	{
		int race;
		if ( ( race = race_lookup( arg2 ) ) == 0 )
		{
			stc( "Sorry, but you can't do that.\n\r", ch );
			return;
		}
		else
			ptc( ch, "Trying to find all visible %s.\n\r", race_table[race].name );

		stc( " {G~{g-----------{G~{x\n\r", ch );

	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch = ( d->original != NULL ) ? d->original : d->character;

			if ( wch->race != race )
				continue;

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}
			sprintf( buf, "{x   %s%-13s\n\r{x",
					wch->name, check_buddy( wch, ch ) >= 0 ? "{y" : "{w" );
			add_buf(output,buf);
	    }
	    page_to_char( buf_string(output), ch );
	    free_buf(output);
		stc( " {G~{g-----------{G~{x\n\r", ch );
	    return;
	}

	else if ( !str_cmp( arg, "long" ) || !str_cmp( arg, "full" ) )
	{
		char *rbi_holder = NULL;
		char s[100];
	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
	        CHAR_DATA *wch;

	        s[0] = '\0';

	        if ( d->connected != CON_PLAYING )
	            continue;

	        wch = ( d->original != NULL ) ? d->original : d->character;

			strftime( s, 100, "%I:%M%p", localtime( &wch->logon ) );

			if (IS_IMMORTAL(wch))
			{
				if ( wch->incog_level > 0 && !IS_IMMORTAL(ch) )
					continue;
				if ( wch->invis_level > 0 && !IS_IMMORTAL(ch) )
					continue;
			}

		    nMatch++;
		    rbi_holder = show_rbi_letter( wch );

			sprintf( buf, "{w%12s %s%s{x%s%s%s {w%s{w%s\n\r{w%12s {D---{w %s%s%s%s%s{x\n\r",

			/* line one */

		    wch->race < MAX_PC_RACE ? pc_race_table[wch->race].who_name : "",

		    check_buddy( wch, ch ) >= 0 ? "{B" : "{B",

		    wch->incog_level >= LEVEL_HERO && wch->invis_level >= LEVEL_HERO ? "{r*{x" :
		    wch->incog_level >= LEVEL_HERO ? "{r({x" :
		    wch->invis_level >= LEVEL_HERO ? "{r{{{x" : "[",

			IS_IMMORTAL(wch) ? "{WI{w" : rbi_holder,

		    check_buddy( wch, ch ) >= 0 ? "{B" : "{B",

		    wch->incog_level >= LEVEL_HERO && wch->invis_level >= LEVEL_HERO ? "{r*{x" :
		    wch->incog_level >= LEVEL_HERO ? "{r){x" :
		    wch->invis_level >= LEVEL_HERO ? "{r}{x" : "]",

		    is_exact_name( wch->name, "shaitan" ) ? "Shai'tan" : wch->colorname,
		    IS_NPC(wch) ? "" : wch->pcdata->title,

		    /* line two */

		    blademaster(wch) ?   "Blademaster" : spearmaster( wch ) ? "Spearmaster" : "",

		    wch->timer > 3 && IS_IMMORTAL(ch) ? "{w[{cIdle{w]{x " : "",
		    IS_SET( wch->comm, COMM_AFK ) ? "{w[{gAFK{w]{x " : "",
		    IS_SET( wch->comm, COMM_RP ) ? "{w[{WRP{w]{x " : "",
		    IS_SET( wch->comm, COMM_QUIET ) ? "{w[{WQuiet{w]{x " : "",
		    IS_SET( wch->comm, COMM_DEAF ) ? "{w[{WDeaf{w]{x " : "" );

			free_string(rbi_holder);

		    bm = FALSE;

			add_buf(output,buf);
	    }

	    page_to_char( buf_string(output), ch );
	    free_buf(output);

	}
	else if ( !str_cmp( arg, "help" ) || !str_cmp( arg, "?" ) )
	{
		stc( "Try who short or who long.\n\r", ch );
		stc( "Or who guild [guild].\n\r", ch );
		stc( "Or who race  [race].\n\r", ch );
		stc( "Or who is    [person].\n\r", ch );
		return;
	}
	else
	{
		stc( "Try who short or who long.\n\r", ch );
		stc( "Or who guild [guild].\n\r", ch );
		stc( "Or who race [race].\n\r", ch );
		stc( "Or who is [person].\n\r", ch );
		return;
	}

	return;

}

void do_count ( CHAR_DATA *ch, char *argument )
{
    int count, max, total = 0;
    DESCRIPTOR_DATA *d;
	FILE *fp;

    count = 0;

    if ( IS_NPC(ch) || ch->desc == NULL )
    	return;

    for ( d = descriptor_list; d != NULL; d = d->next )
        if ( d->connected == CON_PLAYING && can_see( ch, d->character ) )
	    count++;
    for ( d = descriptor_list; d != NULL; d = d->next )
        if ( d->connected == CON_PLAYING )
	    total++;

    max_on = UMAX(count,max_on);

	if ( ( fp = fopen( MAX_WHO_FILE,"r" ) ) == NULL )
	{
	    log_string("Error reading from maxwho.txt");
	    return;
	}
	max = fread_number( fp );
	fclose( fp );

	if ( max_on > max )
	{
		if ( ( fp = fopen( MAX_WHO_FILE,"w" ) ) == NULL )
		{
		    log_string("Error writing to maxwho.txt");
		    return;
		}
		fprintf( fp, "%d\n", max_on );
		fclose( fp );
	}

	ptc(ch,"          {gLargest number of players today: %d; Ever: %d.\n\r", max_on, max );
	ptc(ch,"       	        {gYou can see %d character%s\n\r",
		count, count == 1 ? "" : "s");
}

void do_inventory( CHAR_DATA *ch, char *argument )
{
    stc( "{cYou are carrying:\n\r", ch );
    show_list_to_char( ch->carrying, ch, TRUE, TRUE, TRUE );
    return;
}


void do_eqstats( CHAR_DATA *ch, char *argument )
{
        OBJ_DATA *obj;
        AFFECT_DATA *paf;
        int wear_slot;
        char buf[MSL];

        buf[0] = '\0';

        for ( wear_slot = 0; wear_slot < MAX_WEAR; wear_slot++ )
        {
                if ( ( obj = get_eq_char( ch, wear_slot ) ) == NULL )
                        continue;
                else
                {
                        stc( where_name[wear_slot], ch );
                        for ( paf = obj->affected; paf != NULL; paf = paf->next )
                        {
                                if (paf->location == APPLY_MANA || paf->location == APPLY_MOVE)
                                        ptc( ch, "Stam: %d ", paf->modifier );
                                ptc( ch, "%s: %d ", affect_loc_name( paf->location ), paf->modifier );
                        }
                        for ( paf = obj->pIndexData->affected; paf != NULL; paf = paf->next )
                        {
                                ptc(ch, "%s: %d ", affect_loc_name( paf->location ), paf->modifier );
                        }
                        nlcr(ch);
                }
        }
}

void do_equipment( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;
    int iWear;
    bool found;

    stc( "You are using:{x\n\r", ch );
    found = FALSE;
    for ( iWear = 0; iWear < MAX_WEAR; iWear++ )
    {

		if ( ( obj = get_eq_char( ch, iWear ) ) == NULL )
		{
			if(iWear==29 || iWear == 30 || iWear == 31 ) /* sheath pounch underclothes remove when implemented */
				continue;
			stc( where_name[iWear], ch );
		    stc( "{x\n\r", ch );
		    continue;
		}
		else
		{
			stc( where_name[iWear], ch );

			if ( can_see_obj( ch, obj ) )
			{
			    stc( format_obj_to_char( obj, ch, TRUE ), ch );
			    stc( "{x\n\r", ch );
			}
			else
			{
			    stc( "Something.{x\n\r", ch );
			}
			found = TRUE;
		}
    }

    if ( !found )
        stc( "{cYou're naked!\n\r", ch );

    return;
}



void do_compare( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    OBJ_DATA *obj1;
    OBJ_DATA *obj2;
    int value1;
    int value2;
    char *msg;

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );
    if ( arg1[0] == '\0' )
    {
	stc( "{cCompare what to what?\n\r", ch );
	return;
    }

    if ( ( obj1 = get_obj_carry( ch, arg1, ch ) ) == NULL )
    {
	stc( "{cYou do not have that item.{c\n\r", ch );
	return;
    }

    if (arg2[0] == '\0')
    {
	for (obj2 = ch->carrying; obj2 != NULL; obj2 = obj2->next_content)
	{
	    if (obj2->wear_loc != WEAR_NONE
	    &&  can_see_obj(ch,obj2)
	    &&  obj1->item_type == obj2->item_type
	    &&  (obj1->wear_flags & obj2->wear_flags & ~ITEM_TAKE) != 0 )
		break;
	}

	if (obj2 == NULL)
	{
	    stc("{cYou aren't wearing anything comparable.{c\n\r",ch);
	    return;
	}
    }

    else if ( (obj2 = get_obj_carry(ch,arg2,ch) ) == NULL )
    {
	stc("{cYou do not have that item.{c\n\r",ch);
	return;
    }

    msg		= NULL;
    value1	= 0;
    value2	= 0;

    if ( obj1 == obj2 )
    {
	msg = "{cYou compare $p to itself.  It looks about the same.";
    }
    else if ( obj1->item_type != obj2->item_type )
    {
	msg = "{cYou can't compare $p and $P.";
    }
    else
    {
	switch ( obj1->item_type )
	{
	default:
	    msg = "{cYou can't compare $p and $P.";
	    break;

	case ITEM_ARMOR:
	    value1 = obj1->value[0] + obj1->value[1] + obj1->value[2];
	    value2 = obj2->value[0] + obj2->value[1] + obj2->value[2];
	    break;

	case ITEM_WEAPON:
		/*
	    if (obj1->pIndexData->new_format)
		value1 = (1 + obj1->value[2]) * obj1->value[1];
	    else
	    	value1 = obj1->value[1] + obj1->value[2];

	    if (obj2->pIndexData->new_format)
		value2 = (1 + obj2->value[2]) * obj2->value[1];
	    else
	    	value2 = obj2->value[1] + obj2->value[2];
		*/

		value1 = obj1->value[2];
		value2 = obj2->value[2];
	    break;
	}
    }

    if ( msg == NULL )
    {
	     if ( value1 == value2 ) msg = "{c$p and $P look about the same.";
	else if ( value1  > value2 ) msg = "{c$p looks better than $P.";
	else                         msg = "{c$p looks worse than $P.";
    }

    act( msg, ch, obj1, obj2, TO_CHAR );
    return;
}



void do_credits( CHAR_DATA *ch, char *argument )
{
    do_function(ch, &do_help, "diku" );
    return;
}



void do_where( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    DESCRIPTOR_DATA *d;
    bool found;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	stc( "{cPlayers near you:\n\r", ch );
	found = FALSE;
	for ( d = descriptor_list; d; d = d->next )
	{
	    if ( d->connected == CON_PLAYING
	    && ( victim = d->character ) != NULL
	    &&   !IS_NPC(victim)
	    &&   victim->in_room != NULL
	    &&   !IS_SET(victim->in_room->room_flags,ROOM_NOWHERE)
 	    &&   (is_room_owner(ch,victim->in_room)
	    ||    !room_is_private(victim->in_room))
	    &&   victim->in_room->area == ch->in_room->area
	    &&   can_see( ch, victim ) )
	    {
		found = TRUE;
		sprintf( buf, "%-28s %s\n\r",
		    victim->name, victim->in_room->name );
		stc( buf, ch );
	    }
	}
	if ( !found )
	    stc( "{cNone\n\r", ch );
    }
    else
    {
	found = FALSE;
	for ( victim = char_list; victim != NULL; victim = victim->next )
	{
	    if ( victim->in_room != NULL
	    &&   victim->in_room->area == ch->in_room->area
	    &&   !IS_AFFECTED(victim, AFF_HIDE)
	    &&   !IS_AFFECTED(victim, AFF_SNEAK)
	    &&   can_see( ch, victim )
	    &&   is_name( arg, victim->name ) )
	    {
		found = TRUE;
		sprintf( buf, "%-28s %s\n\r",
		    PERS(victim, ch), victim->in_room->name );
		stc( buf, ch );
		break;
	    }
	}
	if ( !found )
	    act( "{cYou didn't find any $T.", ch, NULL, arg, TO_CHAR );
    }

    return;
}

void alter_invader args((CHAR_DATA *ch, int level));

void advanced_consider( CHAR_DATA *ch, CHAR_DATA *mob )
{
	stc("Sorry, this doesn't work yet.\n\r",ch);
	return;
}
void do_consider( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    char *msg, *exp;
    int diff;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	stc( "{cConsider killing whom?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, NULL, arg ) ) == NULL )
    {
	stc( "{cThey're not here.{c\n\r", ch );
	return;
    }

    if (is_safe(ch,victim))
    {
	stc("{cDon't even think about it.{c\n\r",ch);
	return;
    }

	if (IS_NPC(victim) && IS_SET(victim->act2, ACT2_INVADE))
		alter_invader(victim, ch->level);

	stc("THIS IS ONLY A BASIC VIEW OF YOU vs YOUR POTENTIAL OPPONENT!\n\r",ch);

	if (get_curr_stat(ch,STAT_STR) > get_curr_stat(victim,STAT_STR))
		act("You are physically stronger than $N.",ch,0,victim,TO_CHAR);
	else
		act("$N is physically stronger than you.",ch,0,victim,TO_CHAR);

	if (get_curr_stat(ch,STAT_DEX) > get_curr_stat(victim,STAT_DEX))
		act("You are faster than $N.",ch,0,victim,TO_CHAR);
	else
		act("$N is faster than you.",ch,0,victim,TO_CHAR);

	if (GET_AC(victim,AC_PIERCE) >= 90)
	act("$N is poorly defended against piercing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_PIERCE) >= 60)
	act("$N is moderately well defended against piercing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_PIERCE) >= 30)
	act("$N is fairly well defended against piercing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_PIERCE) >= 1)
	act("$N is well defended against piercing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_PIERCE) < 1)
	act("$N is superbly defended against piercing attacks.",ch,NULL,victim,TO_CHAR);

	if (GET_AC(victim,AC_BASH) >= 90)
	act("$N is poorly defended against bashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_BASH) >= 60)
	act("$N is moderately well defended against bashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_BASH) >= 30)
	act("$N is fairly well defended against bashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_BASH) >= 1)
	act("$N is well defended against bashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_BASH) < 1)
	act("$N is superbly defended against bashing attacks.",ch,NULL,victim,TO_CHAR);

	if (GET_AC(victim,AC_SLASH) >= 90)
	act("$N is poorly defended against slashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_SLASH) >= 60)
	act("$N is moderately well defended against slashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_SLASH) >= 30)
	act("$N is fairly well defended against slashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_SLASH) >= 1)
	act("$N is well defended against slashing attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_SLASH) < 1)
	act("$N is superbly defended against slashing attacks.",ch,NULL,victim,TO_CHAR);

	if (GET_AC(victim,AC_EXOTIC) >= 90)
	act("$N is poorly defended against One Power attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_EXOTIC) >= 60)
	act("$N is moderately well defended against One Power attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_EXOTIC) >= 30)
	act("$N is fairly well defended against One Power attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_EXOTIC) >= 1)
	act("$N is well defended against One Power attacks.",ch,NULL,victim,TO_CHAR);
	else if (GET_AC(victim,AC_EXOTIC) < 1)
	act("$N is superbly defended against One Power attacks.",ch,NULL,victim,TO_CHAR);

	if (GET_AC(ch,AC_PIERCE)+GET_AC(ch,AC_BASH)+GET_AC(ch,AC_SLASH)+GET_AC(ch,AC_EXOTIC) <
	 GET_AC(victim,AC_PIERCE)+GET_AC(victim,AC_BASH)+GET_AC(victim,AC_SLASH)+GET_AC(victim,AC_EXOTIC))
		act("You are overall more well-defended than $N.",ch,0,victim,TO_CHAR);
	else
		act("$N is overall more well-defended than you.",ch,0,victim,TO_CHAR);

    if ( !IS_NPC(ch) && !IS_NPC(victim) )
    {
		if ( IS_SET(ch->op_flags,OP_CHANNELER) && IS_SET(victim->op_flags,OP_CHANNELER) )
		{
			if ( true_op_average(ch) > true_op_average(victim) )
			{
				act("You feel confident you are stronger than $N in the One Power.",ch,NULL,victim,TO_CHAR);
			}
			else if ( true_op_average(victim) > true_op_average(ch) )
			{
				act("You feel that $N is stronger in the One Power.",ch,NULL,victim,TO_CHAR);
			}
			else if ( true_op_average(victim) == true_op_average(ch) )
			{
				act("You feel that you and $N are nearly equal in the One Power.",ch,NULL,victim,TO_CHAR);
			}
		}
	}

    diff = victim->level - ch->level;

         if ( diff <=  -18 ) exp = "{cYou are much more experienced than $N.";
    else if ( diff <=  -8  ) exp = "{cYou are quite a bit more experienced than $N.";
    else if ( diff <=  -2  ) exp = "{cYou are a bit more experienced than $N.";
    else if ( diff <=   3  ) exp = "{cYou and $N appear to be closely matched.";
    else if ( diff <=   8  ) exp = "{c$N may be more experienced than you.";
    else if ( diff <=   12 ) exp = "{c$N is a bit more experienced that you.";
    else if ( diff <=   19 ) exp = "{c$N knows the trials of combat quite a bit more then you.";
    else if ( diff <=   23 ) exp = "{c$N is learned and practiced as far as you are concerned.";
    else if ( diff <=   30 ) exp = "{c$N knows tricks you've never dreamed of.";
    else                     exp = "{c$N makes you look like a lamb ready for slaughter .";
    act( exp, ch, NULL, victim, TO_CHAR );

         if ( diff <=  -15 ) msg = "{cYou can kill $N with both hands tied behind your back.";
    else if ( diff <=  -12 ) msg = "{c$N is a real pushover as far as you're concerned.";
    else if ( diff <=  -10 ) msg = "{c$N looks like a real wimp.";
    else if ( diff <=  -7  ) msg = "{cIt might be fun to taunt $N for a while.";
    else if ( diff <=  -5  ) msg = "{c$N isn't worth your time.";
    else if ( diff <=  -2  ) msg = "{c$N wouldn't be much of a fight.";
    else if ( diff <=   1  ) msg = "{cThis looks like a pretty fair match.";
    else if ( diff <=   5  ) msg = "{c$N looks a bit more experienced than you, but you should be ok.";
    else if ( diff <=   8  ) msg = "{cGo for it!";
    else if ( diff <=   10 ) msg = "{cThis should be a good match.";
    else if ( diff <=   12 ) msg = "{cFinally! A Challenge!";
    else if ( diff <=   15 ) msg = "{cYou might want to bring some backup.";
    else if ( diff <=   17 ) msg = "{cIf you can take $N, it will be worth your time.";
    else if ( diff <=   19 ) msg = "{cMake sure your will is up to date.";
    else if ( diff <=   22 ) msg = "{cHave you given blood lately? You're about to...";
    else if ( diff <=   25 ) msg = "{cYou really want to die, dont you?";
    else if ( diff <=   27 ) msg = "{cYou're kidding, right?";
    else if ( diff <=   30 ) msg = "{c$N poses a dire threat to your continued good health.";
    else                     msg = "{cYou must have a death wish.";
    act( msg, ch, NULL, victim, TO_CHAR );

    return;
}



void set_title( CHAR_DATA *ch, char *title )
{
    char buf[MAX_STRING_LENGTH];

    if ( IS_NPC(ch) )
    {
	bug( "Set_title: NPC.", 0 );
	return;
    }

    if ( title[0] != '.' && title[0] != ',' && title[0] != '!' && title[0] != '?' )
    {
	buf[0] = ' ';
	strcpy( buf+1, title );
    }
    else
    {
	strcpy( buf, title );
    }

    free_string( ch->pcdata->title );
    ch->pcdata->title = str_dup( buf );
    return;
}



void do_title( CHAR_DATA *ch, char *argument )
{
	int played;

    if ( IS_NPC(ch) )
	return;

	played = ( ch->played + (int) (current_time - ch->logon) ) / 3600;
	if ( played < 4 && ch->pcdata->rebirth <= 0 )
	{
		stc("You must have 4 hours of playing time to set your Title.\n\r",ch);
		return;
	}
    if ( argument[0] == '\0' )
    {
	stc( "{cChange your title to what?\n\r", ch );
	return;
    }

    if ( strlen(argument) > 45 )
	argument[45] = '\0';

    smash_tilde( argument );
    set_title( ch, argument );
    stc( "{cOk.{c\n\r", ch );
}



void do_description( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
	char old[MSL];

	if ( IS_NPC( ch ) )
		return;

	sprintf(old,"%s %s has %s eyes. %s wears %s %s-%s hair %s and %s.\n\r",
		ch->name, ch->pcdata->last_name, ch->eye,
		(ch->sex == 2) ? "She" : "He",
		(ch->sex == 2) ? "her" : "his",
		ch->hair2, ch->hair1, ch->hair3, ch->hair4);

    if ( argument[0] != '\0' )
    {
		buf[0] = '\0';
		smash_tilde( argument );

	   	if (argument[0] == '-')
	   	{
		    int len;
		    bool found = FALSE;

		    if (ch->description == NULL || ch->description[0] == '\0')
		    {
			    stc("{cNo lines left to remove.{c\n\r",ch);
			    return;
		    }

		    strcpy(buf,ch->description);

		    for (len = strlen(buf); len > 0; len--)
		    {
			    if (buf[len] == '\r')
			    {
				    if (!found)  /* back it up */
				    {
					    if (len > 0)
						    len--;
					    found = TRUE;
				    }
				    else /* found the second one */
				    {
					    buf[len + 1] = '\0';
						strcat( old, buf );
						free_string(ch->description);
						ch->description = str_dup(old);
						stc( "{cYour description is:\n\r", ch );
						stc( ch->description ? ch->description :
						    "(None).{c\n\r", ch );
					    return;
				    }
			    }
		    }
		    buf[0] = '\0';
			strcat( old, buf );
		    free_string(ch->description);
		    ch->description = str_dup(old);
		    stc("{cDescription cleared.{c\n\r",ch);
		    return;
	    }
		if ( argument[0] == '+' )
		{
		    if ( ch->description != NULL )
				strcat( buf, ch->description );
		    argument++;
		    while ( isspace(*argument) )
				argument++;
		}

		if ( !strcmp(argument,"write")
		|| !strcmp(argument,"desc") )
		{
			stc( "Your features are pre-pended to your description so make sure you clear it if that is not what you want!\n\r", ch );
			string_append( ch, &ch->description );
		    if ( ch->description != NULL )
				strcat( buf, ch->description );
		    argument++;
		    while ( isspace(*argument) )
				argument++;
		}

	    if ( strlen(buf) >= 1024)
		{
		    stc( "{cDescription too long.{c\n\r", ch );
		    return;
		}

		strcat( buf, argument );
		strcat( buf, "\n\r" );
		strcat( old, buf );
		free_string( ch->description );
		ch->description = str_dup( old );
    }

    stc( "{cYour description is:\n\r", ch );
    stc( ch->description ? ch->description : "(None).{c\n\r", ch );
    return;
}



void do_report( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_INPUT_LENGTH*2];
    CHAR_DATA *victim;
    DESCRIPTOR_DATA *d;
    FILE *fp;
    char arg1[MIL*2];
    char arg2[MIL*2];

    argument = one_argument( argument, arg1 );
    if ( arg1[0] == '\0' )
    {
		stc( "Error! Missing victim.\n\r\n\r", ch );
		stc( "Syntax: Report <char> reason\n\r\n\r", ch );
		stc( "Report will send the Reason to all Immortals and Moderators\n\r", ch );
		stc( "that are currently logged on. Report should be used to report\n\r", ch );
		stc( "violations of policy or other offensive actions. Reports made\n\r", ch );
		stc( "will be kept entirely confidential.\n\r", ch );
		return;
	}
	if ( ( victim = get_char_world( ch, arg1 ) ) == NULL )
	{
		stc("Could not find that person.\n\r",ch);
		return;
	}
	if ( IS_NPC( victim ) || IS_NPC( ch ) || !victim->desc || !victim->pcdata )
	{
		stc("Not on NPCs, linkdead folk, or those without pcdata.\n\r",ch);
		return;
	}

	strcpy( arg2, argument );
	sprintf( buf, "{Y%s{x is reporting {Y%s{x for:\n\r{W%s{x\n\r", ch->name, victim->name, arg2 );
	stc( "{WYour report has been made to all Immortals and Moderators.{x\n\r", ch );

	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if ( d->connected == CON_PLAYING
		&& ( IS_SET( d->character->war_flags, WAR_MODERATOR ) || IS_IMMORTAL( d->character ) ) )
		{
			stc( buf, d->character );
		}
	}

    if ( ( fp = fopen( REPORT_FILE, "a" ) ) == NULL )
    {
        perror( REPORT_FILE );
	return;
    }
    fprintf( fp, buf );
    fclose(fp);
    return;
}


/*
 * 'Wimpy' originally by Dionysos.
 */
void do_wimpy( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    long wimpy;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
	wimpy = ch->max_hit / 5;
    else
	wimpy = atoi( arg );

    if ( wimpy < 0 )
    {
	stc( "{cYour courage exceeds your wisdom.{c\n\r", ch );
	return;
    }

    if ( wimpy > ch->max_hit/2 )
    {
	stc( "{cSuch cowardice ill becomes you.{c\n\r", ch );
	return;
    }

    ch->wimpy	= wimpy;
    sprintf( buf, "{cWimpy set to %ld hit points.{c\n\r", wimpy );
    stc( buf, ch );
    return;
}



void do_password( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char *pArg;
    char *pwdnew;
    char *p;
    char cEnd;

    if ( IS_NPC(ch) )
	return;

    /*
     * Can't use one_argument here because it smashes case.
     * So we just steal all its code.  Bleagh.
     */
    pArg = arg1;
    while ( isspace(*argument) )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"' )
	cEnd = *argument++;

    while ( *argument != '\0' )
    {
	if ( *argument == cEnd )
	{
	    argument++;
	    break;
	}
	*pArg++ = *argument++;
    }
    *pArg = '\0';

    pArg = arg2;
    while ( isspace(*argument) )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"' )
	cEnd = *argument++;

    while ( *argument != '\0' )
    {
	if ( *argument == cEnd )
	{
	    argument++;
	    break;
	}
	*pArg++ = *argument++;
    }
    *pArg = '\0';

    if ( arg1[0] == '\0' || arg2[0] == '\0' )
    {
	stc( "{cSyntax: password <old> <new>.{c\n\r", ch );
	return;
    }

    if ( strcmp( crypt( arg1, ch->pcdata->pwd ), ch->pcdata->pwd ) )
    {
	WAIT_STATE( ch, 40 );
	stc( "{cWrong password.  Wait 10 seconds.{c\n\r", ch );
	return;
    }

    if ( strlen(arg2) < 5 )
    {
	stc(
	    "{cNew password must be at least five characters long.{c\n\r", ch );
	return;
    }

    /*
     * No tilde allowed because of player file format.
     */
    pwdnew = crypt( arg2, ch->name );
    for ( p = pwdnew; *p != '\0'; p++ )
    {
	if ( *p == '~' )
	{
	    stc(
		"{cNew password not acceptable, try again.{c\n\r", ch );
	    return;
	}
    }

    free_string( ch->pcdata->pwd );
    ch->pcdata->pwd = str_dup( pwdnew );
    //save_char_obj( ch );
    save_char_obj(ch, FALSE, FALSE);
    stc( "{cOk.{c\n\r", ch );
    return;
}


/* Finger command, by Wench. */

void do_finger( CHAR_DATA *ch, char *argument ) {
    FILE *fp;
    char strsave[MIL];
    char buf[MSL], dash[MSL], pbuf[MSL];
    char arg[MSL], arg2[MSL];
    char *word;
    CHAR_DATA *victim;
    bool fMatch = FALSE;
    bool offline = FALSE;
    bool drop_out = FALSE;
    int d=0, h=0, m=0, s=0;

    char	*f_name	= capitalize(argument);
    char	*f_lname	= "";
    char	*f_title	= "";
    char	*f_host		= "";
    char    *f_email    = "";
    int		f_race		= 0;
    int		f_level		= 0;
    int		f_sex		= 0;
    int		f_played	= 0;
    int		f_rebirt	= 0;
    long	f_laston	= 0;

    if(argument[0] == '\0' || argument[0] == '/' || argument[0] == '\\')
    {
		send_to_char("Finger who?\n\r", ch);
		return;
    }

    smash_tilde(argument);
    argument = one_argument(argument, arg);
    strcpy(arg2, argument);

    if ( ( victim = get_pc_world(ch, arg)) != NULL)
    {
		if ( IS_IMMORTAL( victim ) )
			offline = TRUE;
		f_name		= victim->name;
		f_lname		= victim->pcdata->last_name;
		f_title		= victim->pcdata->title;
		f_rebirt	= victim->pcdata->rebirth;
		f_level 	= victim->level;

		if ( victim->desc != NULL )
			f_host		= victim->desc->host;
		else
			f_host		= str_dup("unknown");;

		f_sex		= victim->sex;
		f_race		= victim->race;
		f_played	= victim->played;
		f_laston 	= victim->logon;
    }
    else
    {
		sprintf(strsave, "%s%s", PLAYER_DIR, capitalize(arg));
		if ((fp = fopen(strsave, "r")) == NULL)
		{
		    sprintf(buf, "No such player: %s.\n\r", capitalize(arg));
		    send_to_char(buf, ch);
		    return;
		}
		else if (fp != NULL)
		{
		    offline = TRUE;
		    fread_to_eol( fp );
		    while (!drop_out)
			{
				word = feof(fp) ? (char *)"End" : fread_word(fp);
				fMatch = FALSE;

				switch(UPPER(word[0]))
				{
				  default:
				  case '*':
					fMatch = TRUE;
					fread_to_eol(fp);
				    break;
				  case 'E':
				    KEYS( "Email", f_email, fread_string( fp ) );
					if (!str_cmp(word, "End")) drop_out = TRUE;
				    break;
				  case 'H':
					KEYS("Host", f_host, fread_string(fp) );
				    break;
				  case 'L':
					KEYS("Host", f_host, fread_string(fp) );
					KEY("Levl", f_level, fread_number(fp) );
					KEY("LogO", f_laston, fread_number(fp) );
					if (!str_cmp(word, "LastName"))
					{
						f_lname = fread_string( fp );
						sprintf( buf, " %s", f_lname );
						free_string( f_lname );
						f_lname = str_dup( buf );
						fMatch = TRUE;
						break;
					}
				    break;
				  case 'N':
					KEYS("Name", f_name, fread_string(fp) );
				    break;
				  case 'P':
					KEY("Plyd", f_played, fread_number(fp) );
				    break;
				  case 'R':
					if ( !str_cmp( word, "Race" ) )
					{
					     char *tmp = fread_string(fp);
					     f_race = race_lookup(tmp);
					     free_string(tmp);
					     fMatch = TRUE;
					     break;
					}
					KEY( "Rebi", f_rebirt, fread_number ( fp ) );
				    break;
				  case 'S':
					KEY("Sex", f_sex, fread_number(fp) );
				    break;
				  case 'T':
				    if (!str_cmp(word, "Title") || !str_cmp(word, "Titl"))
				    {
						f_title = fread_string( fp );
						if (f_title[0] != '.' && f_title[0] != ','
						&&  f_title[0] != '!' && f_title[0] != '?')
						{
						    sprintf(buf, " %s", f_title);
						    free_string(f_title);
						    f_title = str_dup(buf);
						}
						fMatch = TRUE;
						break;
				    }
				   break;
				}
				if (!fMatch)
					fread_to_eol( fp );
		    }
		}
		fclose(fp);
		s = current_time - f_laston;
		d = s/86400;
		s -=d*86400;
		h = s/3600;
		s -= h*3600;
		m = s/60;
		s -= m*60;
    }
    sprintf(dash,
	"--------------------------------------------------------------------------------\r\n");

    sprintf(pbuf, "%s", capitalize(race_table[f_race].name));

	if ( victim && !IS_IMMORTAL( victim ) )
		ptc( ch, "Playing Now\n\r" );
	else
		ptc( ch, "Offline\n\r" );

    ptc( ch,	"%s"
		"%s%s [Race: %s][Rbi: %d]\r\n",
		dash, f_name, f_title, pbuf, f_rebirt);

	ptc( ch, "Email: %s\n\r", f_email );

    ptc( ch,
	"Sex: %s\n\rPlayed for %d hours.\n\r",
	f_sex == 2 ? "Female" : f_sex == 1 ? "Male" : "Sexless",
	( f_played + (int) (current_time - f_laston) ) / 3600);

    ptc( ch,dash);

    if (IS_IMMORTAL(ch)) {
	ptc( ch,"Host: %s\n\r",
	f_host[0] != '\0' ? f_host : "###.###.###.###");
    }

    ptc( ch,"Last: %24.24s\n\r",
	f_laston ? ctime(&f_laston) : "### ### ## ##:##:## ####");

    if (offline)
	ptc( ch,
	"That was %d days, %d hours, %d minutes and %d seconds ago.\n\r",
	d, h, m, s);

    send_to_char(dash, ch);
}

void do_backup(CHAR_DATA * ch, char *argument)
{
	char buf[MSL], arg[MIL];
	//int cost = 0, base_cost = 1, full_cost = 3;
	int cost = 0, base_cost = 0, full_cost = 0;
	bool save_eq = FALSE;

	if (IS_NPC(ch) || IS_SWITCHED(ch) || IS_AFFECTED(ch, AFF_CHARM))
	{
		send_to_char("NPCs, switched immortals, or being charmed prevent backups from occuring.\n\r", ch);
		return;
	}

	one_argument(argument, arg);

	/*
	 *     * noeq = 50 cost and save_eq = FALSE
	 *     * all = 250 cost and save_eq = TRUE
	 *     * other = print usage and bail
	 */

	if (!str_cmp(arg, "noeq"))
	{
		cost = base_cost;
		save_eq = FALSE;
	}
       	else if (!str_cmp(arg, "all"))
	{
	        cost = full_cost;
	        save_eq = TRUE;
	}
       	else
       	{
	        send_to_char("Usage: backup all/noeq\n\r", ch);
	        send_to_char("Understand that if a backup exists, it will be overwritten.\n\r", ch);
		send_to_char("Backups cost 3 gold for adding equipment in the backups.\n\r", ch);
		send_to_char("Backups just to include character information and stats is 1 gold.\n\r", ch);
		return;
	}
	if ( !check_coins( ch, cost*1000, 0, 0 ) && !IS_IMMORTAL(ch))
	{
	        stc( "You need more gold to backup your pfile.\n\r", ch );
		return;
	}

	/*
	 *      * At this point, gold is taken out, flags are set, and the backup occurs.
	 *      * No cost for immortals.
	 */

	if (!IS_IMMORTAL(ch))
	{
		deduct_cost(ch,cost*1000,0);
		sprintf(buf, "Checks successful, removing %d gold for cost.\n\r", cost);
		send_to_char(buf, ch);
		WAIT_STATE(ch, PULSE_PER_SECOND * 5);
	}

	/*
	 *      * Save the char through save_char_obj with the flags set
	 */

	save_char_obj(ch, TRUE, save_eq);
	send_to_char("Backed up.\n\r", ch);
	return;
}

