/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "olc.h"
#include "lookup.h"

#define WEBHELP_FILE "../help"
#define WEBCMD_FILE  "../commands/index.html"

/* Help URL that points to your webhelp pages
 * Leave off a trailing '/'
 * example:  http://www.yoursite.com/"~mymud/links/help"
 * The code will put in: http://www.yoursite.com/ automatically
 */
#define WEBHELP_URL   "/help"

// by prool:
extern bool wizlock;
extern bool newlock;

void	group_gain	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void	death_cry	args( ( CHAR_DATA *ch ) );
bool	remove_obj	args( (CHAR_DATA *ch, int iWear, bool fReplace ) );
void	one_hit		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt, bool secondary ) );
bool	check_dodge	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	check_parry	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    check_shield_block     args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool can_recruit args((CHAR_DATA *ch, CHAR_DATA *victim, char *argument));
char * show_rbi_title args((CHAR_DATA *ch));

void nf_strings args(( CHAR_DATA *ch ));

void buddy_offline args((CHAR_DATA * ch, char *arg));

void buddy_offline(CHAR_DATA * ch, char *arg)
{
	stc("You can't add an offline character to your buddy list.\n\r",ch);
	return;
}

int check_buddy(CHAR_DATA * ch, CHAR_DATA * fch)
{
	BUDDY_DATA *buddy;

	if (!ch || !fch)
		return -1;

	if (IS_NPC(ch) || IS_NPC(fch))
		return -1;

	for (buddy = ch->pcdata->buddies; buddy != NULL; buddy = buddy->next)
	{
		if (buddy == NULL)	break;
		if (is_name(fch->name, buddy->name))
			return 1;
	}
	return -1;
}

void do_buddy( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *fch;
	DESCRIPTOR_DATA *dfch;
	char arg[MIL], buf[MSL];
	bool found = FALSE;
	BUDDY_DATA *buddy, *buddy_next;
	int cnt = 0;

	if (IS_NPC(ch))
	{
		stc("Mobs don't have buddies.\n\r", ch);
		return;
	}

	argument = one_argument(argument, arg);

	if (IS_NULLSTR(arg))
	{
		if (ch->pcdata->buddies == NULL)
		{
			stc("You have no buddies!\n\r", ch);
			return;
		}
		stc("{W+{B---------------------------------{W+{x\n\r", ch);
		stc("{B| {YYour Buddies:                   {B|{x\n\r", ch);
		for (buddy = ch->pcdata->buddies; buddy != NULL; buddy = buddy->next)
		{
			if (buddy == NULL)	break;
			if (!str_cmp(buddy->name, "deleted"))	continue;
			cnt++;
			fch = get_char_world(NULL, buddy->name);
			ptc(ch, "{B| {w(%02d) {w%-12s %-12s    {B|{x\n\r", cnt, capitalize(buddy->name), (!fch || !can_see(ch, fch)) ? "{R(Offline) {x" : check_buddy(fch, ch) == -1 ? "{M(Wannabe) {x" : !fch->desc ? "{C(LinkDead){x" : "{G(Online){x  ");
		}
		stc("{W+{B---------------------------------{W+{x\n\r", ch);
		stc("{WSee Buddy Help for syntax options.{x\n\r", ch);
		return;
	}
/*
	else if (!str_cmp(arg, "last"))
	{
		show_channel_logs(ch, "buddy");
		return;
	}
*/
    else if ( !str_prefix( arg, "send" ) || !str_prefix( arg, "chat" ) )
    {
	    char arg2[MIL];
	    one_argument( argument, arg2 );
	    if ( arg2 == NULL || arg2[0] == '\0' )
	    {
        	stc("Say what to your buddies?:\n\r",ch);
    	    return;
	    }
        ptc( ch, "{r({wBuddy %s{r) {w%s{x\n\r", ch->name, argument );

		sprintf(buf, "{r({wBuddy %s{r) {w%s{x", ch->name, argument);
		add_channel_log("buddy", ch->name, ch->name, buf);

		for (buddy = ch->pcdata->buddies; buddy != NULL; buddy = buddy->next)
		{
			if (buddy == NULL)
				break;
			fch = get_char_world( NULL, buddy->name );
			if ( fch != NULL
			&& fch->desc != NULL
			&& fch->desc->connected == CON_PLAYING
			&& check_buddy( ch, fch ) != -1
			&& check_buddy( fch, ch ) != -1 )
		        ptc( fch, "{r({wBuddy %s{r) {w%s{x\n\r", ch->name, argument );
		}
	    return;
    }
	else if (!str_prefix(arg, "help"))
	{
		stc("Buddy Syntax:\n\r", ch);
		stc("Buddy         - shows current buddy status\n\r", ch);
		stc("Buddy Help    - shows this screen\n\r", ch);
		stc("Buddy Clear   - clear list\n\r", ch);
		stc("Buddy Wannabe - shows waiting buddies\n\r", ch);
		stc("Buddy Name    - Add or remove 'name' from buddy list.\n\r", ch);
		stc("Buddy Chat    - Sends a messages to all online buddies.\n\r", ch);
		return;
	}
	else if (!str_prefix(arg, "clear"))
	{
		while (ch->pcdata->buddies)
			free_buddy(ch->pcdata->buddies);

		stc("No one is your buddy!\n\r", ch);
		return;
	}
	else if (!str_prefix(arg, "wannabe"))
	{
		stc("People online who want to be your buddy:{x\n\r", ch);
		for (dfch = descriptor_list; dfch != NULL; dfch = dfch->next)
		{
			if ( dfch->connected != CON_PLAYING || !dfch->character )
				continue;
			if (check_buddy(dfch->character, ch) != -1 && check_buddy(ch, dfch->character) == -1)
			{
				ptc(ch, "- %-12s{x", dfch->character->name);
				found = TRUE;
			}
		}
		if (!found)
			stc("- No one.{x\n\r", ch);
		else
			stc("\n\r", ch);
		return;
	}
	else
	{
		/* First, search through all buddies for a match to the argument. If found, remove it. */
		for (buddy = ch->pcdata->buddies; buddy != NULL; buddy = buddy_next)
		{
			if (buddy == NULL)	break;
			buddy_next = buddy->next;

			if (!str_cmp(buddy->name, "deleted"))	continue;

			if (!str_cmp(arg, buddy->name))
			{
				if ((fch = get_char_world(ch, arg)) != NULL)
				{
					if (check_buddy(fch, ch) != -1)
						ptc(fch, "%s is no longer your buddy.\n\r", ch->name);
					else
						ptc(fch, "%s no longer wants to be your buddy.\n\r", ch->name);
				}

				ptc(ch, "You are no longer buddies with %s.\n\r", buddy->name);
				free_string(buddy->name);
				buddy->name = str_dup("deleted");
				return;
			}
		}

		/* Okay, it wasn't already in the buddy list, so add it. */

		if ((fch = get_char_world(ch, arg)) == NULL)
		{
			buddy_offline(ch, arg);
			return;
		}
		if (fch == ch)
		{
			stc("Are you that lonely?\n\r", ch);
			return;
		}
		if (IS_NPC(fch))
		{
			stc("Not on NPCs.\n\r", ch);
			return;
		}

		buddy = new_buddy(fch->name);

		buddy->next = ch->pcdata->buddies;
		ch->pcdata->buddies = buddy;

		if (check_buddy(fch, ch) == -1)
			ptc(ch, "You are now a wannabe buddy of %s.\n\r", capitalize(buddy->name));
		else
			ptc(ch, "You are now buddies with %s.\n\r", capitalize(buddy->name));
		if (check_buddy(fch, ch) == -1)
			ptc(fch, "%s wants to be your buddy. (see 'buddy wannabe')\n\r", ch->name);
		else
			ptc(fch, "%s is now your buddy.\n\r", ch->name);
		return;
	}
}

void do_proficiency( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	char buf2[MIL];
	int sn;

	argument = one_argument( argument, arg );

	if ( IS_NPC(ch) || !ch->desc || !ch->pcdata )
		return;

	if ( ( sn = skill_lookup( arg ) ) < 0 )
	{
		stc("You have no proficiency with that skill.\n\r",ch);
		return;
	}
	if ( skill_table[sn].name == NULL
	|| !str_cmp( skill_table[sn].name, "reserved" ) )
		return;
	    if (ch->pcdata->learned[sn] < 75)
			sprintf( buf2, "{x");/*x*/
	    else if (ch->pcdata->learned[sn] < 85)
			sprintf( buf2, "{y");
	    else if (ch->pcdata->learned[sn] < 100)
			sprintf( buf2, "{g");/*g*/
	    else
	    	sprintf( buf2, "{w");

	ptc( ch, "Your proficiency with %s %s is %s%d{x.\n\r", is_qskill(sn) ? "quest skill" : "", skill_table[sn].name, buf2, ch->pcdata->learned[sn] );
	return;
}
void accept_rules( CHAR_DATA *ch )
{
	if ( IS_NPC( ch ) )
	return;

	if ( !ch->desc || ch->desc == NULL )
	return;

	stc("These are the rules of TSE. You must agree to the rules before you will\n\r", ch);
	stc("be allowed to connect to the game. TSE has a no tolerance policy for\n\r", ch);
	stc("failure to adhere to these rules. If you do not agree to them, or you\n\r", ch);
	stc("fail to follow the rules, you will be removed from the game with no\n\r", ch);
	stc("questions asked.\n\r", ch);

}

void load_leaderboard()
{
  FILE *fp;

  if ((fp = fopen("../data/leader.txt", "r")) == NULL)
  {
    log_string("Error: leader.txt not found!");
    exit(1);
  }
  leader_board.bestpk_name = fread_string(fp);
  leader_board.bestpk_number = fread_number(fp);
  leader_board.pk_name = fread_string(fp);
  leader_board.pk_number = fread_number(fp);
  leader_board.pd_name = fread_string(fp);
  leader_board.pd_number = fread_number(fp);
  leader_board.mk_name = fread_string(fp);
  leader_board.mk_number = fread_number(fp);
  leader_board.md_name = fread_string(fp);
  leader_board.md_number = fread_number(fp);
  leader_board.tt_name = fread_string(fp);
  leader_board.tt_number = fread_number(fp);
  leader_board.qc_name = fread_string(fp);
  leader_board.qc_number = fread_number(fp);
/*
  leader_board.rb_name = fread_string(fp);
  leader_board.rb_number = fread_number(fp);
*/
  fclose(fp);
}

void save_leaderboard()
{
  FILE *fp;

  if ((fp = fopen("../area/leader.txt","w")) == NULL)
  {
    log_string("Error writing to leader.txt");
    return;
  }
  fprintf(fp, "%s~\n", leader_board.bestpk_name);
  fprintf(fp, "%d\n", leader_board.bestpk_number);
  fprintf(fp, "%s~\n", leader_board.pk_name);
  fprintf(fp, "%d\n", leader_board.pk_number);
  fprintf(fp, "%s~\n", leader_board.pd_name);
  fprintf(fp, "%d\n", leader_board.pd_number);
  fprintf(fp, "%s~\n", leader_board.mk_name);
  fprintf(fp, "%d\n", leader_board.mk_number);
  fprintf(fp, "%s~\n", leader_board.md_name);
  fprintf(fp, "%d\n", leader_board.md_number);
  fprintf(fp, "%s~\n", leader_board.tt_name);
  fprintf(fp, "%d\n", leader_board.tt_number);
  fprintf(fp, "%s~\n", leader_board.qc_name);
  fprintf(fp, "%d\n", leader_board.qc_number);
/*
  fprintf(fp, "%s~\n", leader_board.rb_name);
  fprintf(fp, "%d\n", leader_board.rb_number);
*/
  fclose (fp);
}

void do_leader( CHAR_DATA *ch, char *argument )
{
  char buf[MAX_STRING_LENGTH];

  if (IS_NPC(ch)) return;

  stc("-==--==**==--==**==--==**== LEADER BOARD ==**==--==**==--==**==--==**==-\n\r\n\r",ch);

  send_to_char("   The Best PK'er   --->    ",ch);
  sprintf(buf, "%-13s",leader_board.bestpk_name);
  send_to_char(buf,ch);
  sprintf(buf, " with a %d PK score\n\r",leader_board.bestpk_number);
  send_to_char(buf,ch);

  send_to_char("   The Deadly       --->    ",ch);
  sprintf(buf, "%-13s",leader_board.pk_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d pkills\n\r",leader_board.pk_number);
  send_to_char(buf,ch);

  /*send_to_char("   The Pathetic     --->    ",ch);
  sprintf(buf, "%-13s",leader_board.pd_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d pdeaths\n\r",leader_board.pd_number);
  send_to_char(buf,ch);

  send_to_char("   Mr. Slayer       --->    ",ch);
  sprintf(buf, "%-13s",leader_board.mk_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d mkills\n\r",leader_board.mk_number);
  send_to_char(buf,ch);

  send_to_char("   Mr. Wimpy        --->    ",ch);
  sprintf(buf, "%-13s",leader_board.md_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d mdeaths\n\r",leader_board.md_number);
  send_to_char(buf,ch);*/

  send_to_char("   The No life      --->    ",ch);
  sprintf(buf, "%-13s",leader_board.tt_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d Hours played\n\r",leader_board.tt_number);
  send_to_char(buf,ch);

  send_to_char("   The Questor      --->    ",ch);
  sprintf(buf, "%-13s",leader_board.qc_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d Quests completed\n\r",leader_board.qc_number);
  send_to_char(buf,ch);
/*
  send_to_char("   The Dedicated    --->    ",ch);
  sprintf(buf, "%-13s",leader_board.rb_name);
  send_to_char(buf,ch);
  sprintf(buf, " with %d Rebirths completed\n\r",leader_board.rb_number);
  send_to_char(buf,ch);
*/
  stc("\n\r-==**==--==**==--==**==--==**==--==**==--==**==--==**==--==**==--==**==-\n\r",ch);
  return;
}

void check_leaderboard( CHAR_DATA *ch )
{
  bool changed = FALSE;

  if (IS_NPC(ch)) return;
  if (get_ratio(ch) > leader_board.bestpk_number || !str_cmp(leader_board.bestpk_name , ch->name))
  {
    leader_board.bestpk_number = get_ratio(ch);
    free_string(leader_board.bestpk_name);
    leader_board.bestpk_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->mdeath > leader_board.md_number)
  {
    leader_board.md_number = ch->mdeath;
    free_string(leader_board.md_name);
    leader_board.md_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->mkill > leader_board.mk_number)
  {
    leader_board.mk_number = ch->mkill;
    free_string(leader_board.mk_name);
    leader_board.mk_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->pkill > leader_board.pk_number)
  {
    leader_board.pk_number = ch->pkill;
    free_string(leader_board.pk_name);
    leader_board.pk_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->pdeath > leader_board.pd_number)
  {
    leader_board.pd_number = ch->pdeath;
    free_string(leader_board.pd_name);
    leader_board.pd_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->pcdata->questsrun > leader_board.qc_number)
  {
    leader_board.qc_number = ch->pcdata->questsrun;
    free_string(leader_board.qc_name);
    leader_board.qc_name = str_dup(ch->name);
    changed = TRUE;
  }
  if ((get_age(ch)-17)*2 > leader_board.tt_number)
  {
    leader_board.tt_number = (get_age(ch)-17)*2;
    free_string(leader_board.tt_name);
    leader_board.tt_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (ch->pcdata->rebirth > leader_board.rb_number)
  {
    leader_board.rb_number = ch->pcdata->rebirth;
    free_string(leader_board.rb_name);
    leader_board.rb_name = str_dup(ch->name);
    changed = TRUE;
  }
  if (changed) save_leaderboard();
  return;
}

int get_ratio(CHAR_DATA *ch)
{
  int ratio;

  if (IS_NPC(ch)) return 0;
  if (ch->pkill == 0) ratio = 0;
  else ratio = ch->pkill * 100 * ((ch->pkill * ch->pkill) - (ch->pdeath * ch->pdeath))/((ch->pkill + ch->pdeath) * (ch->pkill + ch->pdeath));
  return ratio;
}

void do_leaderclear(CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if (ch->level < 7) return;
  free_string(leader_board.bestpk_name);
  leader_board.bestpk_name = str_dup("Noone");
  leader_board.bestpk_number = 0;
  free_string(leader_board.pk_name);
  leader_board.pk_name = str_dup("Noone");
  leader_board.pk_number = 0;
  free_string(leader_board.pd_name);
  leader_board.pd_name = str_dup("Noone");
  leader_board.pd_number = 0;
  free_string(leader_board.md_name);
  leader_board.md_name = str_dup("Noone");
  leader_board.md_number = 0;
  free_string(leader_board.mk_name);
  leader_board.mk_name = str_dup("Noone");
  leader_board.mk_number = 0;
  free_string(leader_board.qc_name);
  leader_board.qc_name = str_dup("Noone");
  leader_board.qc_number = 0;
  free_string(leader_board.tt_name);
  leader_board.tt_name = str_dup("Noone");
  leader_board.tt_number = 0;
  save_leaderboard();
  send_to_char("Leader board cleared.\n\r",ch);
  return;
}

void do_challenge(CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char buf[MIL];

	if ( argument[0] == '\0' )
	{
		stc("Syntax: Challenge <person>\n\r\n\r",ch);
		return;
	}
	if ( ( victim = get_pc_world( ch, argument ) ) == NULL)
	{
		stc("No one by that name to be found!\n\r\n\r",ch);
		return;
	}

	/* should not be needed, but JIC - Dalsor */
	if (IS_NPC(victim))
	{
		stc("You cannot challenge mobiles!\n\r\n\r",ch);
		return;
	}
	if ( IS_SET(ch->in_room->room_flags,ROOM_NO_RECALL) ||
	     IS_SET(victim->in_room->room_flags,ROOM_NO_RECALL))
	{
		stc("You cannot challenge them!\n\r\n\r",ch);
                return;
	}
	if (victim == ch)
	{
		stc("You cannot challenge yourself!\n\r\n\r",ch);
		return;
	}
	if(is_alt_of(ch,victim) && (mud_port == play_port))
	{
		stc("You cannot challenge your alts!\n\r\n\r", ch);
		return;
	}
	/*changed a typo duAl to duEl*/
	ptc( ch, "You challenge %s to a duel!\n\r\n\r", victim->name );
	sprintf(buf,"%s has challenged you to a duel!\n\r",ch->name);
	stc(buf,victim);
	stc("Please either accept or decline the challenge.\n\r\n\r",victim);
	sprintf(buf,"%s has challenged %s to a duel!\n\r",ch->name,victim->name);
	act(buf,ch,NULL,victim,TO_ROOM);
	victim->challenged = ch;
}

void do_accept(CHAR_DATA *ch, char *argument )
{
	char buf[MIL];

	if (!(ch->challenged))
	{
		stc("You have not been challenged!\n\r\n\r",ch);
		return;
	}
	else
	{
	    CHAR_DATA *dch;
    	dch = ch->challenged;
		ptc( ch, "You accept %s's challenge to a duel!\n\r\n\r", dch->name );
	    sprintf(buf,"%s has accepted %s's challenge!\n\r",ch->name,dch->name);
	    act(buf,ch,NULL,dch,TO_NOTVICT);
	    ptc(dch, "%s has accepted your challenge!\n\r", ch->name);
    	ch->challenged = NULL;
	    char_from_room(ch);
    	char_to_room( ch, get_room_index(ROOM_VNUM_ARENA) );
    	char_from_room(dch);
    	char_to_room( dch, get_room_index(ROOM_VNUM_ARENA) );
	    do_function( ch, &do_look, "auto" );
	    do_function( dch, &do_look, "auto" );
		if ( !IS_SET( dch->war_flags, WAR_PK ) )
			SET_BIT( dch->war_flags, WAR_PK );
		if ( !IS_SET( ch->war_flags, WAR_PK ) )
			SET_BIT( ch->war_flags, WAR_PK );
	    if ( get_curr_stat( ch, STAT_REF ) > get_curr_stat( dch, STAT_REF ) )
	    {
	    	do_function( ch, &do_kill, dch->name );
	    }
	    else if ( get_curr_stat( ch, STAT_REF ) < get_curr_stat( dch, STAT_REF ) )
	    {
	    	do_function( dch, &do_kill, ch->name );
	    }
	    else
	    if ( number_percent() >= number_percent() )
	    {
	    	do_function( dch, &do_kill, ch->name );
	    }
	    return;
	}
}

void do_decline(CHAR_DATA *ch, char *argument )
{
	char buf[MIL];

	if (ch->challenged)
	{
		ptc( ch, "You decline %s's challenge to a duel!\n\r\n\r", ch->challenged->name );
		sprintf(buf,"%s has DECLINED %s's challenge!\n\r",ch->name,ch->challenged->name);
		act(buf,ch,NULL,ch->challenged,TO_NOTVICT);
		ptc(ch->challenged, "%s has DECLINED your challenge!\n\r", ch->name);
		ch->challenged=NULL;
		return;
	}
	else
	{
		stc("You have not been challenged!\n\r\n\r",ch);
		return;
	}
}


/* do_when command - used by players to see when another player logged on */
/* Original function by Thoric */

void do_when( CHAR_DATA *ch, char *argument )
{
    char buf [MAX_STRING_LENGTH];
    char arg [MAX_INPUT_LENGTH];
    char name[MAX_INPUT_LENGTH];
    struct stat fst;
    CHAR_DATA *victim;

    one_argument( argument, arg );
    if ( arg[0] == '\0' )
    {
        stc( "{cUsage: when (name)\n\r", ch );
        return;
    }
    if ( ( victim = get_char_world( ch, arg ) ) != NULL && victim->desc != NULL && !IS_NPC(victim) )
    {
        stc("{cWhen{w:{c Playing now.\n\r", ch);
        return;
    }
    strcpy( name, capitalize(arg) );
    sprintf( buf, "%s%s", PLAYER_DIR, name );
    if ( stat( buf, &fst ) != -1 )
        sprintf( buf, "{cWhen{w:{c %s %s\n\r", name, ctime( &fst.st_mtime ) );
    else
        sprintf( buf, "{cWhen{w:{c Could not find %s.\n\r", name );
    stc( buf, ch );
}

bool is_figurine (OBJ_DATA *obj)
{
	if (obj->pIndexData->vnum != 6)
		return FALSE;

	if (obj->item_type != ITEM_GEM)
		return FALSE;

	if (!str_infix("perfect onyx hawk", obj->name))				return TRUE;
	if (!str_infix("replica of a", obj->name))				return TRUE;
	if (!str_infix("miniature copper horn", obj->name))			return TRUE;
	if (!str_infix("moonstone obelisk", obj->name))				return TRUE;
	if (!str_infix("handful of brilliant red fire", obj->name))		return TRUE;
	if (!str_infix("miniature jade wagon", obj->name))			return TRUE;
	if (!str_infix("etched with a", obj->name))				return TRUE;
	if (!str_infix("seafolk porcelain", obj->name))				return TRUE;
	if (!str_infix("small ruby lion", obj->name))				return TRUE;
	if (!str_infix("made from mother-of-pearl", obj->name))			return TRUE;
	if (!str_infix("white quartz seagull", obj->name))			return TRUE;
	if (!str_infix("petrified wood", obj->name))				return TRUE;
	if (!str_infix("silverpike, fashioned from", obj->name))		return TRUE;
	if (!str_infix("figurine", obj->name))					return TRUE;

	return FALSE;
}

void do_junk (CHAR_DATA *ch, char *argument)
{
	char arg[MIL];

	one_argument (argument, arg);

	if (arg[0] == '\0')
	{
		stc(    "   {WJunk Filters            On/Off  Keyword{x\n\r", ch);
		stc(    " =----------------------------------------------=\n\r", ch);
		ptc(ch, "   Treasure Chests           %s   CHESTS\n\r", IS_SET(ch->junk, JUNK_CH_BOXES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Jewels and Gems           %s   JEWELS\n\r", IS_SET(ch->junk, JUNK_CH_JEWELS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Rare Figurines            %s   FIGURINES\n\r", IS_SET(ch->junk, JUNK_CH_FIGURINES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Scrolls/Potions/Pills     %s   SCRLPOTSPILL\n\r", IS_SET(ch->junk, JUNK_CH_SCRLPOTSPILL) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Weapons                   %s   WEAPONS\n\r", IS_SET(ch->junk, JUNK_CH_WEAPONS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Armor and Lights          %s   EQUIPMENT\n\r", IS_SET(ch->junk, JUNK_CH_EQUIPMENT) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Lockpicks                 %s   LOCKPICKS\n\r", IS_SET(ch->junk, JUNK_CH_LOCKPICKS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Angreals                  %s   ANGREALS\n\r", IS_SET(ch->junk, JUNK_CH_ANGREALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Food                      %s   FOOD\n\r", IS_SET(ch->junk, JUNK_CH_FOOD) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Mirrors and Tabac Pipes   %s   ACCESSORIES\n\r", IS_SET(ch->junk, JUNK_CH_ACCESSORIES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Manuals          %s   MANUALS\n\r", IS_SET(ch->junk, JUNK_CH_MANUALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Materials        %s   MATERIALS\n\r", IS_SET(ch->junk, JUNK_CH_MATERIALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Dyes             %s   DYES\n\r", IS_SET(ch->junk, JUNK_CH_DYES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Adornments       %s   ADORNMENTS\n\r", IS_SET(ch->junk, JUNK_CH_ADORNMENTS) ? "{GOn{x " : "{ROff{x");
		stc(    " =----------------------------------------------=\n\r\n\r", ch);
		stc(    "   Syntax: {WJunk <keyword>{x\n\r", ch);
		stc(    "   Typing '{WPawn Junk{x' will sell all chest\n\r", ch);
		stc(    "   treasures with junk filters turned {GOn{x.\n\r", ch);
		return;
	}

	if (!str_prefix(arg, "chests"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_BOXES);
		if (IS_SET(ch->junk, JUNK_CH_JEWELS))   stc("Treasure Chests have been added to your junk list.\n\r", ch);
		else                                    stc("Treasure Chests have been removed to your junk list.\n\r", ch);
	}

	if (!str_prefix(arg, "jewels"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_JEWELS);
		if (IS_SET(ch->junk, JUNK_CH_JEWELS))	stc("Chest jewels have been added to your junk list.\n\r", ch);
		else					stc("Chest jewels have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "figurines"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_FIGURINES);
		if (IS_SET(ch->junk, JUNK_CH_FIGURINES))	stc("Chest figurines have been added to your junk list.\n\r", ch);
		else						stc("Chest figurines have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "scrlpotspill"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_SCRLPOTSPILL);
		if (IS_SET(ch->junk, JUNK_CH_SCRLPOTSPILL))	stc("Chest scrolls, potions and pills have been added to your junk list.\n\r", ch);
		else						stc("Chest scrolls, potions and pills have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "weapons"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_WEAPONS);
		if (IS_SET(ch->junk, JUNK_CH_WEAPONS))	stc("Chest weapons have been added to your junk list.\n\r", ch);
		else					stc("Chest weapons have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "equipment"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_EQUIPMENT);
		if (IS_SET(ch->junk, JUNK_CH_EQUIPMENT))	stc("Chest armor and lights have been added to your junk list.\n\r", ch);
		else					stc("Chest armor and lights have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "lockpicks"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_LOCKPICKS);
		if (IS_SET(ch->junk, JUNK_CH_LOCKPICKS))	stc("Chest lockpicks have been added to your junk list.\n\r", ch);
		else					stc("Chest lockpicks have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "angreals"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_ANGREALS);
		if (IS_SET(ch->junk, JUNK_CH_ANGREALS))	stc("Chest angreals have been added to your junk list.\n\r", ch);
		else					stc("Chest angreals have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "food"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_FOOD);
		if (IS_SET(ch->junk, JUNK_CH_FOOD))	stc("Chest food has been added to your junk list.\n\r", ch);
		else					stc("Chest food has been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "accessories"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_ACCESSORIES);
		if (IS_SET(ch->junk, JUNK_CH_ACCESSORIES))	stc("Chest accessories have been added to your junk list.\n\r", ch);
		else						stc("Chest accessories have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "manuals"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_MANUALS);
		if (IS_SET(ch->junk, JUNK_CH_MANUALS))		stc("Crafting manuals have been added to your junk list.\n\r", ch);
		else						stc("Crafting manuals have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "materials"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_MATERIALS);
		if (IS_SET(ch->junk, JUNK_CH_MATERIALS))	stc("Crafting materials have been added to your junk list.\n\r", ch);
		else						stc("Crafting materials have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "dyes"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_DYES);
		if (IS_SET(ch->junk, JUNK_CH_DYES))		stc("Crafting dyes have been added to your junk list.\n\r", ch);
		else						stc("Crafting dyes have been removed to your junk list.\n\r", ch);
	}
	else if (!str_prefix(arg, "adornments"))
	{
		TOGGLE_BIT(ch->junk, JUNK_CH_ADORNMENTS);
		if (IS_SET(ch->junk, JUNK_CH_ADORNMENTS))	stc("Crafting adornments have been added to your junk list.\n\r", ch);
		else						stc("Crafting adornments have been removed to your junk list.\n\r", ch);
	}
	else /* Show the list and syntax */
	{
		stc(    "   {WJunk Filters            On/Off  Keyword{x\n\r", ch);
		stc(    " =----------------------------------------------=\n\r", ch);
		ptc(ch, "   Treasure Chests           %s   CHESTS\n\r", IS_SET(ch->junk, JUNK_CH_BOXES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Jewels and Gems           %s   JEWELS\n\r", IS_SET(ch->junk, JUNK_CH_JEWELS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Rare Figurines            %s   FIGURINES\n\r", IS_SET(ch->junk, JUNK_CH_FIGURINES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Scrolls/Potions/Pills     %s   SCRLPOTSPILL\n\r", IS_SET(ch->junk, JUNK_CH_SCRLPOTSPILL) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Weapons                   %s   WEAPONS\n\r", IS_SET(ch->junk, JUNK_CH_WEAPONS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Armor and Lights          %s   EQUIPMENT\n\r", IS_SET(ch->junk, JUNK_CH_EQUIPMENT) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Lockpicks                 %s   LOCKPICKS\n\r", IS_SET(ch->junk, JUNK_CH_LOCKPICKS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Angreals                  %s   ANGREALS\n\r", IS_SET(ch->junk, JUNK_CH_ANGREALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Food                      %s   FOOD\n\r", IS_SET(ch->junk, JUNK_CH_FOOD) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Mirrors and Tabac Pipes   %s   ACCESSORIES\n\r", IS_SET(ch->junk, JUNK_CH_ACCESSORIES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Manuals          %s   MANUALS\n\r", IS_SET(ch->junk, JUNK_CH_MANUALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Materials        %s   MATERIALS\n\r", IS_SET(ch->junk, JUNK_CH_MATERIALS) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Dyes             %s   DYES\n\r", IS_SET(ch->junk, JUNK_CH_DYES) ? "{GOn{x " : "{ROff{x");
		ptc(ch, "   Crafting Adornments       %s   ADORNMENTS\n\r", IS_SET(ch->junk, JUNK_CH_ADORNMENTS) ? "{GOn{x " : "{ROff{x");
		stc(    " =----------------------------------------------=\n\r\n\r", ch);
		stc(    "   Syntax: {WJunk <keyword>{x\n\r", ch);
		stc(    "   Typing '{WPawn Junk{x' will sell all chest\n\r", ch);
		stc(    "   treasures with junk filters turned {GOn{x.\n\r", ch);
	}

	return;
}

bool can_pawn_obj( CHAR_DATA *ch, OBJ_DATA *obj )
{
	OBJ_DATA *obj_next;

	if ( obj->item_type == ITEM_CORPSE_PC || !CAN_WEAR(obj, ITEM_TAKE) || CAN_WEAR(obj, ITEM_NO_SAC) )
	{
		stc("{cThe {WP{wawnmonger doesn't look interested in that.\n\r",ch);
		return FALSE;
	}

	if ( !CAN_WEAR(obj, ITEM_TAKE) || CAN_WEAR(obj, ITEM_NO_SAC))
	{
		act( "{cThe {WP{wawnmonger doesn't look interested in $p.", ch, obj, 0, TO_CHAR );
		return FALSE;
	}

	if (obj->in_room != NULL)
	{
		CHAR_DATA *gch;
		for (gch = obj->in_room->people; gch != NULL; gch = gch->next_in_room)
			if (gch->on == obj)
			{
				act( "{c$N appears to be using $p.", ch,obj,gch,TO_CHAR);
				return FALSE;
			}
	}

	if ( IS_SET( obj->extra_flags,ITEM_NOSELL ) )
	{
		stc("That item has been flagged nosell. Type unkeep <item> to toggle this off.\n\r",ch);
		return FALSE;
	}

	if ( !can_drop_obj( ch, obj ) )
	{
		ptc( ch, "{cYou can't let go of %s.\n\r", obj->short_descr );
		return FALSE;
	}

	if ( obj->contains )
	{
		OBJ_DATA *obj_content;
		for ( obj_content = obj->contains; obj_content; obj_content = obj_next )
		{
			obj_next = obj_content->next_content;
			if ( IS_SET( obj_content->extra_flags,ITEM_NOSELL ) )
			{
				stc("That item contains a kept item.\n\r",ch);
				return FALSE;
			}
		}
		stc("That item contains an item.\n\r",ch);
		return FALSE;
	}
	return TRUE;
}

void calc_pawn_value( CHAR_DATA *ch, OBJ_DATA *obj )
{
	#define BIG_PAWN_COST 4000

	int silver, chance, members;
	char buffer[100];

	silver = 1;
	silver = UMAX(1,(obj->cost/4));

	if (obj->item_type != ITEM_CORPSE_NPC && obj->item_type != ITEM_CORPSE_PC)
		silver = UMIN(silver,(obj->cost/4));

	chance = number_percent();

	if (chance < (ch->pcdata->learned[gsn_haggle]+get_curr_stat(ch,STAT_CHA)/2) )
	{
		silver += silver / 2 * chance / 100;
		stc("{cYou attempt to haggle.\n\r",ch);
		check_improve(ch,gsn_haggle,TRUE,4);
	}

	if (obj->pIndexData->vnum == OBJ_VNUM_GEM && obj->item_type == ITEM_GEM)
		silver = obj->cost * 2;

	if (silver == 1)
		ptc(ch, "{cThe {WP{wawnmonger gives you one copper penny for %s.\n\r", obj->short_descr );
	else
		ptc(ch,"{cThe {WP{wawnmonger gives you %d copper pennies for %s.\n\r",silver, obj->short_descr);

	ch->money[0][0] += silver;

	if ( obj->cost > BIG_PAWN_COST )
	{
		char big_pawn[MSL];
		sprintf(big_pawn,"{c%s pawned %s{x for %d copper.",ch->name,obj->short_descr,silver);
		wiznet(big_pawn,ch,NULL,WIZ_BPAWNS,0,0);
	}

	if (IS_SET(ch->act,PLR_AUTOSPLIT) )
	{ /* AUTOSPLIT code */
		CHAR_DATA *gch;
		members = 0;
		for (gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
		{
			if ( is_same_group( gch, ch ) )
				members++;
		}
		if ( members > 1 && silver > 1)
		{
			sprintf(buffer,"%d",silver);
			do_function(ch, &do_split, buffer);
		}
	}
	#undef BIG_PAWN_COST
}

void do_pawn( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;
	bool found;
	bool junk = FALSE;

	found = FALSE;

	one_argument( argument, arg );
	smash_tilde(argument);
	smash_tilde(arg);

	if (!IS_SET(ch->in_room->room_flags, ROOM_PAWNSHOP))
	{
		stc("You are not in a pawnshop.\n\r",ch);
		return;
	}

	if ( arg[0] == '\0' || !str_cmp( arg, ch->name ) )
	{
		act( "{c$n tries to pawn $mself off - without much luck.", ch, NULL, NULL, TO_ROOM );
		stc("{cThe {WP{wawnmonger laughs mercilessly at you.\n\r", ch );
		return;
	}

	if ( !str_cmp ( arg, "all" ) || !str_cmp (arg, "junk"))
	{
		int iCnt = 0;

		for ( obj = ch->carrying; obj != NULL; obj = obj_next )
		{
			obj_next = obj->next_content;

			if (obj->wear_loc != WEAR_NONE)
				continue;

			if (!str_cmp(arg, "junk"))
			{
				junk = FALSE;

				if (obj->pIndexData->vnum == 6 && obj->item_type == ITEM_GEM)
				{
					if (is_figurine(obj))
					{
						if (IS_SET(ch->junk, JUNK_CH_FIGURINES))
							junk = TRUE;
					}
					else if (IS_SET(ch->junk, JUNK_CH_JEWELS))
						junk = TRUE;
				}

	                        if (obj->pIndexData->vnum == 1002
        	                && obj->item_type == ITEM_TREASURECHEST
                	        && IS_SET(ch->junk, JUNK_CH_BOXES))
                        	        junk = TRUE;


				if (obj->pIndexData->vnum == 6
				&& (obj->item_type == ITEM_SCROLL || obj->item_type == ITEM_POTION || obj->item_type == ITEM_PILL)
				&& IS_SET(ch->junk, JUNK_CH_SCRLPOTSPILL))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& obj->item_type == ITEM_WEAPON
				&& IS_SET(ch->junk, JUNK_CH_WEAPONS))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& (obj->item_type == ITEM_LIGHT || obj->item_type == ITEM_ARMOR)
				&& IS_SET(ch->junk, JUNK_CH_EQUIPMENT))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& obj->item_type == ITEM_LOCKPICK
				&& IS_SET(ch->junk, JUNK_CH_LOCKPICKS))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& (obj->item_type == ITEM_ANGREAL_MALE || obj->item_type == ITEM_ANGREAL_FEMALE)
				&& IS_SET(ch->junk, JUNK_CH_ANGREALS))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& obj->item_type == ITEM_FOOD
				&& IS_SET(ch->junk, JUNK_CH_FOOD))
					junk = TRUE;

				if (obj->item_type == ITEM_DYE
				&& IS_SET(ch->junk, JUNK_CH_DYES))
					junk = TRUE;

				if (obj->item_type == ITEM_CRAFTING_MATERIAL
				&& IS_SET(ch->junk, JUNK_CH_MATERIALS))
					junk = TRUE;

				if (obj->item_type == ITEM_CRAFTING_MANUAL
				&& IS_SET(ch->junk, JUNK_CH_MANUALS))
					junk = TRUE;

				if (obj->item_type == ITEM_ADORNMENT
				&& IS_SET(ch->junk, JUNK_CH_ADORNMENTS))
					junk = TRUE;

				if (obj->pIndexData->vnum == 6
				&& (obj->item_type == ITEM_MIRROR || obj->item_type == ITEM_PIPE_TABAC)
				&& IS_SET(ch->junk, JUNK_CH_ACCESSORIES))
					junk = TRUE;

				if (!junk)	continue;
			}

			if ( !can_pawn_obj( ch, obj ) )
				continue;

			found = TRUE;
			iCnt++;

			if ( iCnt > 20 )
			{
				stc( "You've reached the spam limit. Wait a moment to spam more.\n\r", ch );
				return;
			}

			calc_pawn_value( ch, obj );

			act( "{c$n pawns off $p.", ch, obj, NULL, TO_ROOM );
			extract_obj( obj );
			found = FALSE;
		}
		if (!found)
		{
			stc("You dont have anything left to sell.\n\r",ch);
			return;
		}
	}
	else
	{
		if ( ( obj = get_obj_carry( ch, argument, ch ) ) == NULL )
		{
			stc( "You do not have that item.\n\r", ch );
			return;
		}

		if ( !can_pawn_obj( ch, obj ) )
			return;

		calc_pawn_value( ch, obj );

		act( "{c$n pawns off $p.", ch, obj, NULL, TO_ROOM );
		extract_obj( obj );
		return;
	}
}

void do_letgo ( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	AFFECT_DATA *paf, *paf_next;

	one_argument( argument, arg );

        if ( arg[0] == '\0' )
        {
            stc("Letgo what?\n\r",ch);
            return;
        }
        if ( !str_prefix( arg, "addict" ) )
        {
            if ( !ch->pcdata->addict )
            {
                stc("You're not an addict.\n\r", ch);
                return;
            }
            stc("You're no longer an addict.\n\r", ch);
            ch->pcdata->addict = FALSE;
            ch->pcdata->addict_hours = 0;
            return;
        }
        if ( !str_prefix ( arg, "void" ) )
	    {
	    if (is_affected(ch, gsn_void))
	    {
			stc("You push the Void away.\n\r",ch);
			affect_strip( ch, gsn_void );
			REMOVE_BIT(ch->affected_by,AFF_VOID);
			return;
		}
	}
	if ( !str_prefix ( arg, "rage" ) )
	{
	    if (is_affected(ch, gsn_rage))
	    {
			stc("You bring your rage under control.\n\r",ch);
			affect_strip( ch, gsn_rage );
			REMOVE_BIT(ch->affected_by,AFF_RAGE);
			return;
		}
	}
	if ( !str_prefix ( arg, "berserk" ) )
	{
	    if (is_affected(ch, gsn_berserk))
	    {
			stc("You bring your anger under control.\n\r",ch);
			affect_strip( ch, gsn_berserk );
			REMOVE_BIT(ch->affected_by,AFF_BERSERK);
			return;
		}
	}
	if ( !str_prefix ( arg, "invisible" ) )
	{
	    if (is_affected(ch, gsn_invis))
	    {
			stc("You come out of hiding.\n\r",ch);
			affect_strip( ch, gsn_invis );
			affect_strip( ch, gsn_hide );
			affect_strip( ch, gsn_sneak );
			REMOVE_BIT(ch->affected_by,AFF_INVISIBLE);
			return;
		}
	}
	if ( !str_prefix ( arg, "veil" ) )
	{
	    if (is_affected(ch, gsn_veil))
	    {
			stc("You lower your veil.\n\r",ch);
			affect_strip( ch, gsn_veil );
			REMOVE_BIT(ch->affected2_by,WAR_VEILED);
			return;
		}
	}
	if ( !str_prefix( arg, "all" ) )
	{
		for (paf = ch->affected; paf != NULL; paf = paf_next)
		{
			paf_next = paf->next;

			if (paf->type == skill_lookup("plague")
			|| paf->type == skill_lookup("sicken")
			|| paf->type == skill_lookup("blindness")
			|| paf->type == skill_lookup("poison")
			|| paf->type == skill_lookup("plague")
			|| paf->type == skill_lookup("bandage")
			|| paf->type == skill_lookup("reserved")
			|| paf->type == skill_lookup("treat"))
				continue;

			affect_remove(ch, paf);
		}
		if ( ch->pcdata->char_barrier > 0 && IS_SET( ch->op_flags,OP_BARRIER ) )
		{
			REMOVE_BIT( ch->op_flags, OP_BARRIER );
			ch->pcdata->char_barrier = 0;
		}
		return;
	}
}

/* Commands to find certain mobs and objs of a specified level */

void do_olevel(CHAR_DATA *ch, char *argument)
{
	extern int top_obj_index;
	char buf[MAX_STRING_LENGTH];
	char arg[MAX_INPUT_LENGTH];
	BUFFER *buffer;
	OBJ_INDEX_DATA *pIndexData;
	int vnum, level;
	int nMatch;
	bool found;

	argument=one_argument(argument, arg);
	if (!is_number(arg) )
	{
	    stc("Syntax: olevel # (level to search for)\n\r",ch);
	    return;
	}
	level=atoi(arg);
	buffer=new_buf();
	found=FALSE;
	nMatch=0;

 	for(vnum=0;nMatch<top_obj_index;vnum++)
	{
		if ( (pIndexData=get_obj_index(vnum)) )
		{
			nMatch++;
			if (level == pIndexData->level)
			{
				found=TRUE;
				sprintf(buf, "%5ld] %s\n\r",pIndexData->vnum,
					pIndexData->short_descr);
				add_buf(buffer,buf);
			}
		}
	}
	if (!found)
       stc("No objects found at that level.\n\r",ch);
    else
       page_to_char(buf_string(buffer),ch);
    free_buf(buffer);
    return;
}

void do_mlevel( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_INPUT_LENGTH];
    BUFFER *buffer;
    CHAR_DATA *victim;
    bool found;
    int count = 0;

    if ( argument[0] == '\0' )
    {
	stc("Syntax: mlevel <level>\n\r",ch);
	return;
    }

    found = FALSE;
    buffer = new_buf();
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if ( victim->in_room != NULL
        &&   atoi(argument) == victim->level )
        {
            found = TRUE;
            count++;
            sprintf( buf, "%3d) [%5ld] %-28s [%5ld] %s\n\r",
		count,
                IS_NPC(victim) ? victim->pIndexData->vnum : 0,
                IS_NPC(victim) ? victim->short_descr : victim->name,
                victim->in_room->vnum,
                victim->in_room->name );
            add_buf(buffer,buf);
        }
    }

    if ( !found )
        act( "You didn't find any mob of level $T.", ch, NULL, argument, TO_CHAR );
    else
        page_to_char(buf_string(buffer),ch);

    free_buf(buffer);

    return;
}

int strlen_color args(( const char *string ));

void do_restring( CHAR_DATA *ch, char *argument )
{
	char buf  [MAX_INPUT_LENGTH];
	char note_buf[MSL];
	char log_buf[MSL];
	char arg  [MAX_INPUT_LENGTH];
	char arg1 [MAX_INPUT_LENGTH];
	char arg2 [MAX_INPUT_LENGTH];
	CHAR_DATA *mob;
	OBJ_DATA *obj;
	int cost;
	FILE *fp;

	note_buf[0] = '\0';

	if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
	{
		stc("{cYou cannot restring while NoChanneled.{c\n\r",ch);
		return;
	}

	for ( mob = ch->in_room->people; mob; mob = mob->next_in_room )
	{
		if ( IS_NPC(mob) && IS_SET(mob->act, ACT_IS_STRINGER) )
			break;
	}

	if ( mob == NULL )
	{
		stc( "{wYou can't do that here.{c\n\r", ch );
		return;
	}

	smash_tilde( argument );
	argument = one_argument( argument, arg );
	argument = one_argument( argument, arg1 );
	strcpy( arg2, argument );
	ptc( ch, "Arg: %s :: Arg1: %s :: Arg2: %s\n\r", arg, arg1, arg2 );
	if ( arg[0] == '\0' || arg1[0] == '\0' )
	{
		stc("{wIt costs 100 gold marks to restring an item.\n\r",ch);
		stc("{wIt costs 50 gold marks to restring your battlecry.\n\r", ch);
		stc("{wSyntax:\n\r",ch);
		stc("  restring <obj> <field> <string>\n\r",ch);
		stc("    fields: name short long{c\n\r",ch);
		stc("  restring battlecry <string>",ch);
		return;
	}

	if (ch->pnote != NULL)
	{
		stc("{wFinish your existing notes first.\n\r",ch);
		return;
	}

	if ( !str_cmp( arg, "battlecry" ) )
	{
		stc("Striging battlecry.\n\r", ch);
		cost = 50;
		if (cost > ch->money[3][0])
                {
                        act("{w$N says 'You do not have enough gold for my services.'{c", ch,NULL,mob,TO_CHAR);
                        return;
                }
		if (strlen_color(arg1) > 64)
		{
			stc("Line too long.\n\r",ch);
			return;
		}
		act("$N instructs $n in the strength of voice.",ch,NULL,mob,TO_ROOM);
		free_string(ch->pcdata->battle_cry)
		ch->pcdata->battle_cry = str_dup(arg2);
		deduct_cost(ch,1000* cost,0);
		return;
	}
	else
	{
		if ((obj = (get_obj_carry(ch, arg, ch))) == NULL)
		{
			act("$N tells you, 'You do not have that item.'",ch,NULL,mob,TO_CHAR);
			return;
		}

		cost = 100;

		if (cost > ch->money[3][0])
		{
			act("{w$N says 'You do not have enough gold for my services.'{c", ch,NULL,mob,TO_CHAR);
			return;
		}

		if ( !str_prefix( arg1, "name" ) )
		{
			if (strlen_color(arg2) > 64)
			{
				stc("Line too long.\n\r",ch);
				return;
			}
			act("$N takes $n's $p and tinkers with it.",ch,obj,mob,TO_ROOM);
			free_string( obj->name );
			obj->name = str_dup( arg2 );
		}
		else if ( !str_prefix( arg1, "short" ) )
		{
			if (strlen_color(arg2) > 80)
			{
				stc("Line too long.\n\r",ch);
				return;
			}
			act("$N takes $n's $p and tinkers with it.",ch,obj,mob,TO_ROOM);
			free_string( obj->short_descr );
			obj->short_descr = str_dup(arg2);
		}
		else if ( !str_prefix( arg1, "long" ) )
		{
			if (strlen_color(arg2) > 128)
			{
				stc("Line too long.\n\r",ch);
				return;
			}
			act("$N takes $n's $p and tinkers with it.",ch,obj,mob,TO_ROOM);
			free_string( obj->description );
			obj->description = str_dup( arg2 );
		}
		else
		{
			stc("{wThat's not a valid Field.{c\n\r",ch);
			stc("{wSyntax:\n\r",ch);
			stc("  restring <obj> <field> <string>\n\r",ch);
			stc("    fields: name short long{c\n\r",ch);
			return;
		}

		deduct_cost(ch,1000* cost,0);
		sprintf(buf, "{w$N returns $p to $n.{c");
		act(buf,ch,obj,mob,TO_ROOM);
		sprintf(buf,"{w%s takes your item, tinkers with it, and returns %s to you.{c\n\r", mob->short_descr, obj->short_descr);
		stc(buf,ch);
		stc("{w\n\rA ghostly voice fills your head.\n\r",ch);
		stc("{W  {B+============================================================{B+{x\n\r",ch);
		stc("{B  | {WRemember, if the Immortals find your new string offensive, {B|{x\n\r", ch);
		stc("{B  | {Wthey will not be happy, and you will find the item removed {B|{x\n\r",ch);
		stc("{B  | {Wand the money you spent gone.                              {B|{x\n\r",ch);
		stc("{B  | {WThis is your ONE AND ONLY Warning.                         {B|{x\n\r", ch);
		stc("{W  {B+============================================================{B+{x\n\r",ch);

		if ( ( fp = fopen( NSTRING_FILE,"a" ) ) == NULL )
		{
			log_string("Error writing to nstring.dat");
			return;
		}
		fprintf( fp, "NSTR %s: (%s) %s\n", ch->name, arg1, arg2 );
		fclose( fp );

		sprintf( log_buf, "NSTRING:: [%s] (%s) %s", ch->name, arg1, arg2 );

		wiznet(log_buf,ch,NULL,WIZ_STRING,0,0);

		stc("\n\r{wYou have posted a note to the Immortals containing information on this restring.{c\n\r", ch);
	}
}

void do_beep( CHAR_DATA *ch, char *argument )
{
   int pos;
   char arg1[MAX_INPUT_LENGTH];
   CHAR_DATA *victim;

   one_argument( argument, arg1 );

   if ( arg1[0] =='\0' )
   {
      stc( "Usage: BEEP <victim>\n\r", ch );
      return;
   }

   if ( ( victim = get_char_world( ch, arg1 ) ) == NULL )
   {
      stc( "Couldn't find the victim.\n\r", ch );
      return;
   }
   if ( IS_NPC( victim ) )
   {
      stc( "{cCan only beep players...\n\r", ch );
      return;
   }

   if ( ch == victim )
   {
      stc( "{cBeep yourself?  Sure, ok... beep! beep! beep!\n\r", ch );
      stc( "{cYou will now be lagged to prevent spamming of this function.\n\r",ch);
      WAIT_STATE( ch, 12 );
      return;
   }

   pos = victim->position;
   victim->position = POS_STANDING;

   act( "{cYou beep $N...",         ch, NULL, victim, TO_CHAR );
   stc( "{cYou will now be lagged to prevent spamming of this function.\n\r",ch);
   act( "{*{c$n is beeping you...", ch, NULL, victim, TO_VICT );
   stc( "{cHINT: Turn color off to avoid being beeped.\n\r",victim);
   WAIT_STATE( ch, 60 );

   victim->position = pos;
   return;
}
void do_fights( CHAR_DATA *ch, char *argument )
{
   CHAR_DATA *vch;
   char buf[MAX_STRING_LENGTH];
   char buf2[MAX_STRING_LENGTH];
   int  count;

   count = 0;
   buf2[0] = '\0';

   for ( vch = char_list; vch != NULL; vch = vch->next )
   {
      if ( !IS_NPC( vch ) && ( is_fighting(vch) ) && can_see( ch, vch ) )
      {
	 count++;
	 sprintf( buf, "%s Vs. %s  [Room:%5ld]\n\r", vch->name, IS_NPC( vch->fight_data->fighter ) ?
	    vch->fight_data->fighter->short_descr : vch->fight_data->fighter->name,
            vch->in_room->vnum );
	 strcat( buf2, buf );
      }
   }

   if ( count == 0 )
      strcat( buf2, "No Players are currently fighting!\n\r" );
   else
   {
      sprintf( buf, "%d fight%s\n\r", count, ( count > 1 ) ? "s." : "." );
      strcat( buf2, buf );
   }

   strcat( buf2, "\n\r" );
   stc( buf2, ch );
   return;
}

void do_iwhere( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *vch;
	CHAR_DATA *mob;
	char arg[MIL];
	char buf[MSL];
	char buf2[MSL];
	int count = 0;
	bool found = FALSE;

	buf2[0] = '\0';
	argument = one_argument ( argument, arg );

	if ( !str_cmp (arg, "quest" ) )
	{
		BUFFER *buffer;
		buffer = new_buf();

		stc("VNUM   LVL  WHERE  SHORT\n\r",ch);
		stc("-----  ---  -----  -----\n\r",ch);
		for (mob = char_list; mob != NULL; mob = mob->next)
		{
			if (IS_SET(mob->act,ACT_UNDEAD))
			{
				sprintf(buf,"%5ld  %3d  %5ld  %-30s\n\r",
				mob->pIndexData->vnum,
				mob->level,
				mob->in_room == NULL ? 0 : mob->in_room->vnum,
				mob->short_descr);
				found = TRUE;
		        add_buf(buffer,buf);
			}
		}
		if ( !found )
			stc("{cNothing like that in heaven or earth.\n\r", ch );
		else
			page_to_char(buf_string(buffer),ch);
		free_buf(buffer);
	}
	else
	{
		stc( "Levl Rmt Name          VNUM  Guild        Area\n\r", ch );
		stc( "---- --- ----          ----  -----        ----\n\r", ch );

		for ( vch = char_list; vch != NULL; vch = vch->next )
		{
			if ( !IS_NPC( vch ) && can_see( ch, vch ) )
			{
				count++;
				sprintf( buf, "%4d %3d %-12s %5ld  %-12s %-30s\n\r",
					vch->level, vch->pcdata->rebirth, vch->name,
					vch->in_room == NULL ? 0 : vch->in_room->vnum,
					clan_table[vch->clan].name,
					vch->in_room->area->name );
				strcat( buf2, buf );
			}
		}

		if ( count == 0 )
			strcat( buf2, "No Players found!\n\r" );
		else
		{
			sprintf( buf, "%d Player%s found.\n\r", count, (count > 1) ? "s" : "");
			strcat( buf2, buf );
		}

		strcat( buf2, "\n\r" );
		stc( buf2, ch );
	}
	return;
}

int html_colour args (( char type, char *string ));
void html_colourconv args (( char *buffer, const char *txt, CHAR_DATA *ch ));
char * show_rbi_letter args((CHAR_DATA *ch));

void who_html_update ( int port )
{

  FILE *fp;
  DESCRIPTOR_DATA *d;
  char buf[2*MAX_INPUT_LENGTH];
  char buf2[2*MAX_INPUT_LENGTH];
  char buf3[MSL];
  int count = 0;


#ifdef DEBUG
        Debug ("who_html_update");
#endif

  buf[0] = '\0';
  buf2[0] = '\0';
  buf3[0] = '\0';

  sprintf( buf3, "../../public_html/online%d.php", port );
  if ( (fp = fopen( buf3, "w") ) == NULL)
  {
     bugf( "online%d.php: fopen", port );
     perror( "online.php generation" );
     return;
  }
  else
  {
/*	  logf( "Writing online data for %d.", port );*/
  fprintf(fp, "<html>\n");
  fprintf(fp, "<head>\n");
  fprintf(fp, "<title>\n");
  fprintf(fp, "Players currently on The Shadow's Embrace\n");
  fprintf(fp, "</title>\n");
  fprintf(fp, "<link rel=""stylesheet"" href=""include.style.css"">" );
  fprintf(fp, "<BODY TEXT=""#000000"" LINK=""#00FFFF""\n");
  fprintf(fp, "VLINK=""#FFFFFF"" ALINK=""#008080"">\n");
  fprintf(fp, "<p align=""left""><font size=""-1"">" );
  fprintf(fp, "<center>Who's on The Shadow's Embrace?</center></h1>\n");
  fprintf(fp, "<center>(Hidden players and Immortals are not shown here)</center>\n");

  fprintf(fp, "<CENTER><TABLE BORDER=0 class=content>\n");
  fprintf(fp, "<TR ALIGN=LEFT VALIGN=CENTER>\n");
  /*fprintf(fp, "<TD>Who</TD></TR>\n");*/

  for ( d = descriptor_list; d != NULL ; d = d->next )
  {
    CHAR_DATA *wch;
    char class[5];

    if ( d->connected != CON_PLAYING)
        continue;
    count++;
    wch   = ( d->original != NULL ) ? d->original : d->character;
    class[0] = '\0';

	if ( !wch || !d || !d->character || wch->incog_level > 0 )
		continue;
    if (!(wch->invis_level > LEVEL_HERO))
    {
	fprintf(fp, "<TR ALIGN=LEFT VALIGN=CENTER>\n");
	/*fprintf(fp, "<TD>%s</TD>\n", capit2(race_table[wch->race].name));*/
	/*fprintf(fp, "<TD>%s</TD>\n", IS_IMMORTAL(wch) ? html_colourconv("I") : html_colourconv(show_rbi_letter(wch) ));*/
	fprintf(fp, "<TD>%s", wch->name);

      buf2[0] = '\0';
      sprintf(buf2, "%s", (IS_NPC(wch)? "" : capit2(wch->pcdata->title)));
	html_colourconv( buf, buf2, wch );
      fprintf(fp, buf);
      fprintf(fp, "</TD></TR>\n");

    }  /*end if */
  }    /*end for */

  fprintf(fp, "</TABLE></CENTER>\n");
  fprintf(fp, "<font color =""#000000"" face=""Times New Roman""><center>\n");
  sprintf(buf, "This file last updated at %s Eastern Time.\n\n\n", ((char *) ctime( &current_time )));
  fprintf(fp, buf);

	fprintf( fp,   "<p align=""left"">       Currently Running Events:      <br>\n");
	fprintf( fp,   "======== =======================<br>\n");
	fprintf( fp,"Trivia:  %s                           <br>\n",
	   trivia->running ? "Yes" : "No");
	fprintf( fp,"Tourney: %s Range: %4d %4d         <br>\n",
	   tourney->status == 1 ? "Idle" : tourney->status == 2 ? "Waiting" : "Running",
	   tourney->status == 2 || tourney->status == 3 || tourney->status == 4 ? tourney->level1 : 0,
	   tourney->status == 2 || tourney->status == 3 || tourney->status == 4 ? tourney->level2 : 0 );
	fprintf( fp,"War:     %s Range: %4d %4d             <br>\n",
	   battle->open ? "Yes" : "No", battle->open ? battle->level1 : 0, battle->open ? battle->level2 : 0 );
	fprintf( fp,"DFHunt:  %s<br>                         \n",
	   dfhunt_game_info[0] == 0 ? "No" : dfhunt_game_info[0] == 1 ? "Prelim" : dfhunt_game_info[0] > 1 ? "Running" : "Unknown" );
	fprintf( fp,"FTag:    %s<br>                          \n",
	   tag_game.status == TAG_ISWAIT ? "Waiting" : tag_game.status == TAG_ISPLAY ? "Running" : "No" );
	fprintf( fp,"Faire:   %s%s%s%s<br>\n",
	   faire->open ? "Yes" : "No", faire->open ? "," : "", faire->open ? " in " : "", faire->open ? faire->location : "" );
	if ( wizlock || newlock )
	fprintf( fp,"Game Status: %s%s<br>\n", wizlock ? "Wizlocked " : "", newlock ? "Newlocked" : "" );
	else
	fprintf( fp,"Game Status: OPEN<br></p>\n" );

	fprintf( fp, "Total visible players: %d\n", count );
  fprintf(fp, "</center></font>\n");

  fprintf(fp, "<br><br>\n");
  fprintf(fp, "<CENTER><P><A HREF=""http://www.theshadowsembrace.com"" TARGET=""_top"">\n");
  fprintf(fp, "Back to the TSE home page</A> </P></CENTER>\n");
  fprintf(fp, "</font>");
  fprintf(fp, "</body>\n");
  fprintf(fp, "</html>\n");
  fclose( fp );
  } /*end if */

  if ( (fp = fopen("../../httpdocs/online.cnt", "w") ) == NULL)
  {
     bug( "online.cnt: fopen", 0 );
     perror( "online.cnt" );
  }
  else
  {
	  fprintf(fp, "%d", count);
	  fclose( fp );
  }

  return;
}/* end function */


int html_colour( char type, char *string )
{
    char	code[ 25 ];
    char	*p = '\0';

#ifdef DEBUG
        Debug ("html_colour");
#endif

sprintf( code, "<font color=""#000000"">" );

/*
    switch( type )
    {
	default:
	case '\0':
	    code[0] = '\0';
	    break;
	case ' ':
	    sprintf( code, " " );
	    break;
	case 'x':
	    sprintf( code, "<font color=""#006400"">" );
	    break;
	case 'b':
	    sprintf( code, "<font color=""#00008B"">" );
	    break;
	case 'c':
	    sprintf( code, "<font color=""#008B8B"">" );
	    break;
	case 'g':
	    sprintf( code, "<font color=""#006400"">" );
	    break;
	case 'm':
	    sprintf( code, "<font color=""#8B008B"">" );
	    break;
	case 'r':
	    sprintf( code, "<font color=""#8B0000"">" );
	    break;
	case 'w':
	    sprintf( code, "<font color=""#808080"">" );
	    break;
	case 'y':
	    sprintf( code, "<font color=""#808000"">" );
	    break;
	case 'B':
	    sprintf( code, "<font color=""#0000FF"">" );
	    break;
	case 'C':
	    sprintf( code, "<font color=""#OOFFFF"">" );
	    break;
	case 'G':
	    sprintf( code, "<font color=""#00FF00"">" );
	    break;
	case 'M':
	    sprintf( code, "<font color=""#FF00FF"">" );
	    break;
	case 'R':
	    sprintf( code, "<font color=""#FF0000"">" );
	    break;
	case 'W':
	    sprintf( code, "<font color=""#FFFFFF"">" );
	    break;
	case 'Y':
	    sprintf( code, "<font color=""#FFFF00"">" );
	    break;
	case 'D':
	    sprintf( code, "<font color=""#636363"">" );
	    break;
	case '{':
	    sprintf( code, "{" );
	    break;
    }
*/
    p = code;
    while( *p != '\0' )
    {
	*string = *p++;
	*++string = '\0';
    }

    return( strlen( code ) );
}

void html_colourconv( char *buffer, const char *txt, CHAR_DATA *ch )
{
    const	char	*point;
		int	skip = 0;

#ifdef DEBUG
        Debug ("html_colourconv");
#endif

    for( point = txt ; *point ; point++ )
    {
	if( *point == '{' )
	{
	    point++;
	    if( *point == '\0' )
		point--;
	    else
	      skip = html_colour( *point, buffer );
	    while( skip-- > 0 )
		++buffer;
	    continue;
	}
	if( (*point == '<') && (!IS_IMMORTAL(ch)) )
	{
	    *buffer = '[';
	    *++buffer = '\0';
	    continue;
	}
	if( (*point == '>') && (!IS_IMMORTAL(ch)) )
	{
	    *buffer = ']';
	    *++buffer = '\0';
	    continue;
	}
	*buffer = *point;
	*++buffer = '\0';
    }
    *buffer = '\0';
    return;
}


/*********************************************************
 * If a helpfile has the ' character in it or has a      *
 * space somewhere within the helpfile keyword the       *
 * below function will strip it out. If you use a color  *
 * code in your 'keywords' (ONLY) then use the following *
 * function to remove those escape characters            *
 *********************************************************/
char *keydump( const char *str )
{
    static char strcap[MAX_STRING_LENGTH];
    int i;

    for ( i = 0; str[i] != '\0'; i++ )
    {
        /* do we have a ' in the keyword? Then put a . instead */
        strcap[i] = LOWER(str[i]);
        if(strcap[i] == '\'' )
        {
           strcap[i] = '.';
           continue;
        }
        /* do we have a space in the keyword? Then put a - instead */
        if(strcap[i] == ' ' )
        {
           strcap[i] = '_';
           continue;
        }
    }
    strcap[1] = UPPER(strcap[1]);
    strcap[i] = '\0';
    return strcap;
}

char * under_line(char *under_lined)
{
  char * point;

#ifdef DEBUG
        Debug ("under_line");
#endif
  for (point = under_lined; *point; point++)
  {
	if (*point == ' ')
	{
	  *point = '_';
	}
	else
	{
	  *point = UPPER(*point);
	}
  }
  return point;
}

/* Make it nice and purdy...The first letter of the word is capped */
char *cmdlookup( const char *str )
{
    static char strcap[MSL];

    strcap[1] = UPPER(strcap[1]);
    strcap[2] = '\0';
    return strcap;

}


/******************************************************
 * The below function is called from the command      *
 * further down called: web_helpdump. The purpose     *
 * of help_dump is to output a table format style     *
 * for each of the helpfiles. Each helpfile is saved  *
 * within its appropriate directory. Such as:         *
 * help/A  help/B help/C etc...                       *
 ******************************************************/

void help_dump( HELP_DATA *pHelp, CHAR_DATA *ch )
{
    FILE *fp;
    char strsave[MAX_STRING_LENGTH*10];
    char buf1[MAX_STRING_LENGTH*10];
    char buf[MAX_STRING_LENGTH*10];
    char * keywd;

    buf[0] = '\0';
    buf1[0] = '\0';

    keywd = under_line( pHelp->keyword );

    /*****************************************************
     * The following line takes your input from the      *
     * WEBHELP_FILE you specified earlier. It will place *
     * the helpfile keyword in the appropriate directory *
     * according to the first letter of the keyword      *
     * NOTE: My helpfile system is greatly altered, I    *
     * have made a function to load helpfiles/text       *
     * according to a specific string input..if your     *
     * helpfile keywords look something like:            *
     * 'Acid Blast Acid Blasting'  and such..this code   *
     * may not be for you...                             *
     *****************************************************/

                                      /*file*/     /*first letter*/ /*colorstring keyword*/
    sprintf( strsave, "%s/%c/%s.html",WEBHELP_FILE,pHelp->keyword[0],keywd);

    if ( ( fp = fopen( TEMP_FILE, "w" ) ) == NULL )
    {
        bug( "help_dump: fopen", 0 );
        perror( strsave );
    }

  buf[0] = '\0';
  buf1[0] = '\0';
  fprintf(fp, "<html>\n");
  fprintf(fp, "<head>\n");
  fprintf(fp, "<title>\n");
  /**************************************************************************
   * send the keyword through the keylookup function, stripping out spaces   *
   * and if you have it..color code (COLOR CODE NOT IMPLEMENTED IN KEYWORDS) *
   ***************************************************************************/
  sprintf(buf1, "%s\n", pHelp->keyword);
  fprintf(fp,buf1);
  fprintf(fp, "</title>\n");
  fprintf(fp, "<BODY TEXT=\"WHITE\" BGCOLOR=\"BLACK\" LINK=\"BLUE\"\n");
  fprintf(fp, "VLINK=\"PURPLE\" ALINK=\"BLUE\">\n");
                            /* YOUR NAME BELOW */
  fprintf(fp, "<h1><center>The Shadow's embrace</center></h1>\n");
  fprintf(fp, "<TABLE  WIDTH=\"90\" BORDER=0> <TR ALIGN=\"left\" valign=\"top\"\n");
  fprintf(fp, ">");
  fprintf(fp, "<TD bgcolor=\"#404040\"  VALIGN=\"top\" WIDTH=\"10\"> ");
  fprintf(fp, "<B>Keyword:</B> </TD> <TD bgcolor=\"#202020\"> ");
   /**************************************************************************
   * send the keyword through the keylookup function, stripping out spaces   *
   * and if you have it..color code (COLOR CODE NOT IMPLEMENTED IN KEYWORDS) *
   ***************************************************************************/
  sprintf(buf,"%s", keywd );
  fprintf(fp,buf);
  fprintf(fp,"</TR>\n<TR>\n<TD bgcolor=\"#404040\" VALIGN=\"top\" WIDTH=\"80\">\n<B>Text:</B> </TD> <TD bgcolor=\"#202020\">\n ");
  fprintf(fp,"<PRE>");
  buf[0] = '\0';
  buf1[0] = '\0';
  sprintf(buf1,"{G%s</FONT>",pHelp->text);
  /*****************************************************************
   * Send the text of the helpfile through the color processor     *
   * for LOPE's colour code. -=Thankyou Clandestine for the code-= *
   *****************************************************************/
  html_colourconv(buf,buf1,ch);
  fprintf(fp,buf);
  fprintf(fp,"</PRE>");
  fprintf(fp,"</TR>\n</TABLE>\n</BODY></HTML>");
  fclose( fp );
  rename(TEMP_FILE,strsave);
}

/***********
 * Locals   *
 ************/

void web_helpdump         (CHAR_DATA *ch);
void web_commanddump      (CHAR_DATA *ch);

/******************************************************
 *The following is the interface function for calling *
 *the web_* commands.                                 *
 ******************************************************/

void do_web(CHAR_DATA *ch, char *argument)
{
      char buf[MAX_STRING_LENGTH];
      char arg1[MAX_INPUT_LENGTH];

      argument=one_argument(argument, arg1);

      if (arg1[0]=='\0') /*no argument, kick out list of web commands*/
      {
                send_to_char ("\r\nCommands for WEB:\r\n",ch);
                send_to_char ("------------  ------------------------\r\n",ch);
                sprintf(buf,"{rweb helpdump{x  :  Dump helpfiles to the net\r\n"
                            "{rweb commanddump{x: Dump commands to the net\r\n");
               send_to_char(buf,ch);
         return;
      }

        if      (!str_cmp(arg1, "helpdump"))       web_helpdump(ch);
        else if (!str_cmp(arg1, "commanddump"))    web_commanddump(ch);
     else
           send_to_char ("No such command. See HELP WEBDUMP or type in WEB.\r\n",ch);
     return;

}

void web_helpdump(CHAR_DATA *ch)
{
   HELP_DATA *pHelp;

    /***********************************************************
    * Find all the helpfiles loaded within the game.           *
    * I have 100 levels on my game, and any helpfile that      *
    * I do not want listed, I put the level of that helpfile   *
    * to 0 or 1. Thus I only want to print out helfpiles that  *
    * are level 2 - 99, since my Immortal helpfiles start      *
    * at level 100. Adjust as needed.                          *
    ************************************************************/
   for ( pHelp = help_first; pHelp != NULL; pHelp = pHelp->next )
   {
	   if ( !str_cmp( pHelp->keyword, "PROMPT" )
	   || !str_cmp( pHelp->keyword, "PROMPTS" )
	   || !str_cmp( pHelp->keyword, "PROMPT_PROMPTS" ) )
	   	 continue;
         help_dump( pHelp, ch );
   }
 if(ch)
   send_to_char("Help files dumped to the web.\r\n",ch);
 return;
}

void web_commanddump(CHAR_DATA *ch)
{
    FILE *fp;
    char buf[MAX_STRING_LENGTH * 5];
    char buf1[MAX_STRING_LENGTH * 5];
    int cmd;
    int col;
    col = 0;

    buf[0] = '\0';
    buf1[0] = '\0';

    if ( ( fp = fopen( WEBCMD_FILE, "w" ) ) == NULL )
    {
        bug( "command_dump: fopen", 0 );
        perror( WEBCMD_FILE );
    }

    for ( cmd = 0; cmd_table[cmd].name != NULL ; cmd++ )
    {
        if ( cmd_table[cmd].level <  LEVEL_HERO
        &&   cmd_table[cmd].show )
        {
             sprintf( buf,"<TD bgcolor=\"#404040\"  VALIGN=\"top\" WIDTH=\"20\">\r\n" \
                            "<A HREF=\"%s/%c/%s.html\"\r\n" \
          "onMouseover=\"window.status=\'View the help file for %s\';return true\"\r\n" \
          "onMouseout=\"window.status=\' \';return true\"> %s </A></TD>\r\n",
               WEBHELP_URL,
               UPPER(cmd_table[cmd].name[0]),
               capitalize(cmd_table[cmd].name),
               cmd_table[cmd].name,
               cmd_table[cmd].name);
               if ( ++col % 9 == 0)
                 strcat(buf,"</TR>\r\n<TR ALIGN=\"LEFT\" VALIGN=\"TOP\">\r\n");
          }

    }

    if(ch)
    {
       send_to_char("Commands on the net dumped.\r\n",ch);
    }

    if ( col % 9 != 0)
        strcat(buf1,"</TR>\r\n<TR ALIGN=\"LEFT\" VALIGN=\"TOP\">");
    sprintf( buf1, "<HTML><HEAD><TITLE>TSE Command Table</TITLE></HEAD>\r\n" \
                   "<BODY BGCOLOR=\"BLACK\" TEXT=\"WHITE\" LINK=\"BLUE\" VLINK=\"PURPLE\">\r\n" \
                   "<CENTER><img src=\"../../public_html/images/banner1.jpg align=\"center\" width=\"400\" height=\"60\"\">\r\n" \
                   "%s</TABLE><BR>\r\n</CENTER></BODY></HTML>\r\n",
                    buf);
    fprintf(fp,buf1);
    fclose( fp );
    return;
}

void do_fear(CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	AFFECT_DATA *paf;
	int duration = number_range(3, 5);

	if ( ch->race != race_lookup("fade") )
	{
		nf_strings( ch );
    		stc( "{wCheck your spelling and check the help files.{x\n\r", ch );
		return;
	}

	if (ch->fight_data == NULL || (victim = ch->fight_data->fighter) == NULL)
	{
		stc("You're not fighting anyone.\n\r", ch);
		return;
	}

	if (IS_NPC(victim))
	{
		if (victim->pIndexData->pShop != NULL)
		{
		stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
		return;
		}
		if (IS_SET(victim->act,ACT_PET))
		{
		stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
		return;
		}
		if ( IS_SET(ch->in_room->room_flags, ROOM_MOUNT_SHOP)
		|| IS_SET(ch->in_room->room_flags, ROOM_PET_SHOP) )
		{
		stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
		return;
		}
	}

	if (IS_AFFECTED(victim, AFF_FEAR))
	{
		stc("They're already terrified!\n\r", ch);
		return;
	}

	if (victim->level - 10 > ch->level)
	{
		act("$N laughs at you.",ch,0,victim,TO_CHAR);
		act("$n tries to instill fear in $N, but $N laughs mercilessly at $m.",ch,0,victim,TO_ROOM);
		act("$n tries to instill fear in you. You laugh at $n.",ch,0,victim,TO_VICT);
		return;
	}
	act("$n gazes upon you with a pale, eyeless face.",ch,0,0,TO_VICT);
	if ( saves_spell( ch->level, victim, DAM_MENTAL) )
	{
		act("$N laughs at you.",ch,0,victim,TO_CHAR);
		act("$n tries to instill fear in $N, but $N laughs mercilessly at $m.",ch,0,victim,TO_ROOM);
		act("$n tries to instill fear in you. You laugh at $n.",ch,0,victim,TO_VICT);
		WAIT_STATE(ch, 2 * PULSE_VIOLENCE);
		return;
	}
	act("$n gazes upon $N with a pale, eyeless face.",ch,0,victim,TO_NOTVICT);
	act("$N is scared stiff!",ch,0,victim,TO_NOTVICT);
	act("You gaze upon $N with a pale, eyeless face.",ch,0,victim,TO_CHAR);
	act("$N is scared stiff!",ch,0,victim,TO_CHAR);
	stc("You are scared stiff!\n\r", victim);
	WAIT_STATE(ch, 2 * PULSE_VIOLENCE);

	paf = new_affect();
	paf->type = gsn_fear;
	paf->duration = duration;
	paf->bitvector = AFF_FEAR;
	affect_to_char(victim, paf);	




	return;


/*	This is what it use to do..


    ROOM_INDEX_DATA *was_in;
    ROOM_INDEX_DATA *now_in;
    int attempt;

	if ( ch->race != race_lookup("fade") )
	{
		stc("People would laugh at you.\n\r",ch);
		return;
	}

	if ( ch->pcdata->rebirth < 1 )
	{
		stc("People would laugh at you.\n\r",ch);
		return;
	}

    if ( ( victim = get_char_room( ch, NULL, argument ) ) == NULL )
    {
	stc( "{cThey aren't here.{c\n\r", ch );
	return;
    }
	if (victim == ch)
    {
	stc( "{cAck! You scared yourself!{c\n\r", ch );
	return;
    }
	if ( is_safe(ch, victim) )
    {
	stc( "{cYour victim is safe at the moment.{c\n\r", ch );
	return;
    }
    if (victim->pIndexData->pShop != NULL)
    {
	stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
	return;
    }
	if (IS_SET(victim->act,ACT_PET))
    {
	stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
	return;
    }
    if ( IS_SET(ch->in_room->room_flags, ROOM_MOUNT_SHOP)
    || IS_SET(ch->in_room->room_flags, ROOM_PET_SHOP) )
    {
	stc( "{cThe Creator wouldn't like that.{c\n\r", ch );
	return;
    }

	if (victim->level - 10 > ch->level)
	{
		act("$N laughs at you.",ch,0,victim,TO_CHAR);
		act("$n tries to instill fear in $N, but $N laughs mercilessly at $m.",ch,0,victim,TO_ROOM);
		act("$n tries to instill fear in you. You laugh at $n.",ch,0,victim,TO_VICT);
		return;
	}
	act("$n gazes upon you with a pale, eyeless face.",ch,0,0,TO_VICT);
	if ( saves_spell( ch->level, victim, DAM_MENTAL) )
	{
		act("$N laughs at you.",ch,0,victim,TO_CHAR);
		act("$n tries to instill fear in $N, but $N laughs mercilessly at $m.",ch,0,victim,TO_ROOM);
		act("$n tries to instill fear in you. You laugh at $n.",ch,0,victim,TO_VICT);
		WAIT_STATE(ch, 2 * PULSE_VIOLENCE);
		return;
	}
    act("$n gazes upon $N with a pale, eyeless face.",ch,0,victim,TO_ROOM);
    act("$N runs screaming from the room!",ch,0,victim,TO_ROOM);
    act("You gaze upon $N with a pale, eyeless face.",ch,0,victim,TO_CHAR);
    act("$N runs screaming from the room!",ch,0,victim,TO_CHAR);
	WAIT_STATE(ch, 2 * PULSE_VIOLENCE);

    was_in = victim->in_room;
    for ( attempt = 0; attempt < 6; attempt++ )
    {
	EXIT_DATA *pexit;
	int door;

	door = number_door( );
	if ( ( pexit = was_in->exit[door] ) == 0
	||   pexit->u1.to_room == NULL
	||   IS_SET(pexit->exit_info, EX_CLOSED)
	||   number_range(0,victim->daze) != 0
	|| ( IS_NPC(victim)
	&&   IS_SET(pexit->u1.to_room->room_flags, ROOM_NO_MOB) ) )
	    continue;

	move_char( victim, door, FALSE);
	if ( ( now_in = victim->in_room ) == was_in )
	    continue;

	victim->in_room = was_in;
	act( "{c$n has fled!", victim, NULL, NULL, TO_ROOM );
	victim->in_room = now_in;

    if (!is_fighting(ch) || ( ch = victim->fight_data->fighter ) == NULL )
    {
        if ( victim->position == POS_FIGHTING )
            victim->position = POS_STANDING;
	stc( "{cYou aren't fighting anyone.\n\r", victim );
	return;
    }

	stop_all_fighting( victim );
	return;
    }

    stc( "{wPANIC!{c You couldn't escape!\n\r", victim );
    return;
*/
}

void do_new_shadowwalk( CHAR_DATA *ch, char *argument )
{
	ROOM_INDEX_DATA *pRoomIndex = NULL;
	bool can_gate = FALSE;
	int a;

	CHAR_DATA *fch, *fch_next;
	ROOM_INDEX_DATA *old_room;
	bool gate_pet;

	//argument = one_argument( argument, arg2 );

	if ( ch->race != race_lookup("fade") )
	{
		act("You make funny little shadow figures on the walls with your hands... heh.",ch,0,0,TO_CHAR);
		act("$n makes funny little shadow figures on the walls with $s hands... heh.",ch,0,0,TO_ROOM);
		return;
	}

	if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
	{
		stc("You're currently in a battle.\n\r",ch);
		return;
	}
	if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
	{
		stc("You're currently in a tourney.\n\r",ch);
		return;
	}
	if (IS_SET (ch->pcdata->tag_flags, TAG_PLAYING | TAG_WAITING))
	{
		stc("Wait till the tag game is over.\n\r", ch);
		return;
	}
	if ( argument[0] == '\0' )
	{
		stc("You must specify a memorized room as the location.\n\r",ch);
		return;
	}
	if ( !is_number(argument) )
	{
		stc("You must specify a memorized location.\n\r",ch);
		return;
	}

	if ( is_fighting(ch) )
	{
		stc( "You struggle, but you're too close to your enemy to enter the shadows.\n\r", ch );
		return;
	}

	a = atoi(argument);

	if( a < 0 || a >= MAX_BEACONS )
	{
		stc("That number is out of range.\n\r", ch );
		return;
	}
	if ( ch->pcdata->in_vault )
	{
		do_function( ch, &do_locker, "close" );
	}

	for( a = 0; a < MAX_BEACONS; a++ )
	{
		pRoomIndex = get_room_index( ch->pcdata->beacons[a] );
		if ( a == atoi(argument) )
		{
			can_gate = TRUE;
			break;
		}
	}
	if (!can_gate || pRoomIndex == NULL)
	{
		stc("You can't shadowwalk there.\n\r",ch);
		return;
	}

	old_room = ch->in_room;

	if (ch->pet != NULL && ch->in_room == ch->pet->in_room)
		gate_pet = TRUE;
	else
		gate_pet = FALSE;

	char_from_room(ch);
	char_to_room(ch,pRoomIndex);
	do_function(ch, &do_look, "auto" );

	stc( "You project yourself through the shadows.\n\r", ch );


	for ( fch = old_room->people; fch != NULL; fch = fch_next )
	{
		fch_next = fch->next_in_room;

		if ( fch == ch )
			continue;

		if ( fch->master == ch && IS_AFFECTED(fch,AFF_CHARM)
		&& fch->position < POS_STANDING)
			do_function(fch, &do_stand, "");

		if ( fch->master == ch && fch->position == POS_STANDING)
		{
			act( "{cYou follow $N{c through the shadows.{c", fch, NULL, ch, TO_CHAR );
			char_from_room(fch);
			char_to_room(fch,pRoomIndex);
		}
	}

	if( MOUNTED(ch) )
	{
		stc("You step into the shadows.\n\r",MOUNTED(ch));
		char_from_room(MOUNTED(ch));
		char_to_room(MOUNTED(ch),pRoomIndex);
		do_look(MOUNTED(ch),"auto");
	}

	if (gate_pet)
	{
		stc( "{cYou into the shadows.\n\r",ch->pet);
		char_from_room(ch->pet);
		char_to_room(ch->pet,pRoomIndex);
		do_function(ch->pet, &do_look, "auto");
	}

        return;
}
void do_shadowwalk( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
	CHAR_DATA *fch, *fch_next;
	bool gate_pet;
    ROOM_INDEX_DATA *old_room;

	if ( ch->race != race_lookup("fade") )
	{
		act("You make funny little shadow figures on the walls with your hands... heh.",ch,0,0,TO_CHAR);
		act("$n makes funny little shadow figures on the walls with $s hands... heh.",ch,0,0,TO_ROOM);
		return;
	}
	if ( ch->pcdata->rebirth < 1 )
	{
		act("You make funny little shadow figures on the walls with your hands... heh.",ch,0,0,TO_CHAR);
		act("$n makes funny little shadow figures on the walls with $s hands... heh.",ch,0,0,TO_ROOM);
		return;
	}
	if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
	{
		stc("You're currently in a battle.\n\r",ch);
		return;
	}
	if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
	{
		stc("You're currently in a tourney.\n\r",ch);
		return;
	}
    if ( ( victim = get_char_world( ch, argument ) ) == NULL
    ||   victim == ch
    ||   victim->in_room == NULL
    ||   IS_SET(victim->in_room->room_flags, ROOM_SAFE)
	||   IS_SET(victim->in_room->room_flags, ROOM_WELL_LIT)
    ||   IS_SET(victim->in_room->room_flags, ROOM_PRIVATE)
    ||   IS_SET(victim->in_room->room_flags, ROOM_SOLITARY)
    ||   IS_SET(victim->in_room->room_flags, ROOM_NO_RECALL)
	||   ( IS_IMMORTAL(victim) && !IS_IMMORTAL(ch) )
    ||   IS_SET(ch->in_room->room_flags, ROOM_NO_RECALL)
    ||   (victim->in_room->clan > 1 && ch->clan != victim->in_room->clan))
    {
        stc( "You can't shadowwalk to them at their current location.\n\r", ch );
        return;
    }
    old_room = ch->in_room;
    if (ch->pet != NULL && ch->in_room == ch->pet->in_room)
		gate_pet = TRUE;
    else
		gate_pet = FALSE;
		stc("{cYou step into the shadows, emerging elsewhere.\n\r",ch);
	    char_from_room(ch);
	    char_to_room(ch,victim->in_room);
		ch->stam /= 2;
	    act("{c$n emerges from the shadows.",ch,NULL,NULL,TO_ROOM);
		/* Shadowwalk Followers - Dal */
		if (old_room == victim->in_room)
	    return;

    	for ( fch = old_room->people; fch != NULL; fch = fch_next )
    	{
            fch_next = fch->next_in_room;

            if ( fch->master == ch && IS_AFFECTED(fch,AFF_CHARM)
            &&   fch->position < POS_STANDING)
            	do_function(fch, &do_stand, "");

            if ( fch->master == ch && fch->position == POS_STANDING)
            {

                if (IS_SET(ch->in_room->room_flags,ROOM_LAW)
                &&  (IS_NPC(fch) && IS_SET(fch->act,ACT_AGGRESSIVE)))
                {
                    act("{cYou can't take $N there.{c",ch,NULL,fch,TO_CHAR);
                    continue;
            	}
            	act( "{cYou follow $N.{c", fch, NULL, ch, TO_CHAR );
				char_from_room(fch);
				char_to_room(fch,victim->in_room);
            }
    	}
    if (gate_pet)
    {
        act("{c$n steps into the shadows.",ch->pet,NULL,NULL,TO_ROOM);
        stc( "{cYou step into the shadows.\n\r",ch->pet);
		char_from_room(ch->pet);
		char_to_room(ch->pet,victim->in_room);
        act("{c$n emerges from the shadows.",ch->pet,NULL,NULL,TO_ROOM);
		do_function(ch->pet, &do_look, "auto");
    }

	do_function(ch, &do_look, "auto");
	return;
}

void do_bounty ( CHAR_DATA *ch , char *argument)
{
	char arg1[MAX_INPUT_LENGTH];
	char arg2[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;
	CHAR_DATA *wch;
	char buf[MAX_STRING_LENGTH];
	int cost, amount = 0;
	bool found;
	DESCRIPTOR_DATA *d;

	argument = one_argument( argument, arg1);
	argument = one_argument( argument, arg2);
	found = FALSE;

	if ( arg1[0] == '\0' )
	{
		stc("Bounty who?\n\r",ch);
		stc("Syntax: Bounty <person|list <amount>>\n\r",ch);
		stc("See also Unbounty.\n\r",ch);
		return;
	}

	if ( !str_cmp( arg1, "list" ) )
	{
		stc("        {CName{c | {CReward{x\n\r",ch);
		stc("{c-------------{C+{c--------{x\n\r", ch);
		for ( wch = char_list; wch != NULL ; wch = wch->next )
		{
			if (IS_NPC(wch)) continue;
			if (IS_SET(wch->war_flags,WAR_BOUNTY))
			{
				found = TRUE;
				ptc(ch,"{C%12s {c| {C%d gold marks\n\r",wch->name,wch->pcdata->bounty);
			}
		}
		if (!found)
			stc("No one currently playing has a bounty on them.\n\r",ch);
		return;
	}


	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
		stc("You must be in a bank to do this.\n\r",ch);
		return;
	}

	if ( ( victim = get_char_world(ch,arg1) ) == NULL )
	{
		stc("Unable to locate that person online.\n\r",ch);
		return;
	}

	if (IS_NPC(victim))
	{
		stc("Not on mobs.\n\r",ch);
		return;
	}

	cost = victim->level * calc_remort_tier(victim);
	amount = atoi(arg2);

	if ( amount <= 0 )
	{
		stc("You must provide a value greater than zero for the bounty to be placed.\n\r",ch);
		return;
	}

	if (amount < cost)
	{
		ptc(ch,"That's kind of cheap considering %s esteem, but okay.\n\r", victim->sex == SEX_FEMALE ? "her" : "his");
	}

	if ( !check_coins(ch,1000*amount,0,0) )
	{
		stc( "You can't afford it.\n\r", ch );
		return;
	}

	if (IS_SET(victim->war_flags,WAR_BOUNTY))
	{
		ptc( ch, "%s has a bounty of %d marks on %s head, so it will be increased.\n\r", 
			victim->sex == SEX_FEMALE ? "She" : "He", victim->pcdata->bounty, victim->sex == SEX_FEMALE ? "her" : "his");
	}

	deduct_cost(ch,1000*amount,0);
	SET_BIT(victim->war_flags,WAR_BOUNTY);

	if ( victim->pcdata->bounty >= 1 )
		victim->pcdata->bounty += amount;
	else
		victim->pcdata->bounty = amount;

	stc( "{R**** {wA bounty has been levied on your head! {R****{x\n\r", victim );
	stc( "The bounty has been placed.\n\r",ch);

	for ( d = descriptor_list; d; d = d->next )
	{
		if ( d->connected == CON_PLAYING )
		{
			sprintf( buf, "{R**** {wA bounty has been placed on %s for %d gold marks! {R****{x\n\r",victim->name,amount);
			stc(buf,d->character);
		}
	}
	return;
}

void do_bounties( CHAR_DATA *ch, char *argument )
{
	do_bounty( ch, "list" );
	return;
}

void do_unbounty ( CHAR_DATA *ch , char *argument)
{
	char arg1[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;
	int cost;
	char buf[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	argument = one_argument( argument, arg1);

	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
		stc("You cannot do that here.\n\r",ch);
		return;
	}

	if ( ( victim = get_char_world(ch,arg1) ) == NULL )
	{
        stc("That person is not playing.\n\r",ch);
        return;
	}

	if (IS_NPC(victim))
	{
        stc("Not on mobs dummy.\n\r",ch);
		return;
	}

	cost = 2 * (victim->level * calc_remort_tier(victim));

	if (!check_coins(ch,1000* cost,0,0) )
	{
        stc( "You can't afford it.\n\r", ch );
        return;
	}
	if (!IS_SET(victim->war_flags,WAR_BOUNTY))
	{
		stc("That person is not bountied.\n\r",ch);
		return;
	}
	else
	{
	    REMOVE_BIT( victim->war_flags, WAR_BOUNTY );
	    victim->pcdata->bounty = 0;
	    stc( "Bounty flag removed.\n\r", ch );
	    stc( "{R[{rINFO{R] You are no longer bountied.\n\r", victim );
		deduct_cost(ch,1000*cost,0);
	    for ( d = descriptor_list; d; d = d->next )
	    {
	        if ( d->connected == CON_PLAYING )
	        {
	        sprintf( buf, "{R[{rINFO{R]: The bounty on %s has been removed.\n\r", victim->name);
	        stc(buf,d->character);
	        }
	    }
	}
	return;
}
void do_recruit(CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *victim;
    char arg1[MIL],arg2[MIL];
    char buf[MSL];
    int clan;

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

	if ( IS_NPC( ch ) )
		return;

	if (!IS_SET(ch->hist_flags,HIST_RECRUITER))
	{
		stc("You are not a recruiter for your Guild.\n\r",ch);
		return;
	}

    if ( arg1[0] == '\0' || arg2[0] == '\0' )
    {
        stc("{cSyntax: recruit <player name> <guild name>\n\r",ch);
        return;
    }

    if ( ( victim = get_char_room( ch, NULL, arg1 ) ) == NULL )
    {
        stc("{cThey aren't playing, or not in the same room as you.\n\r", ch );
        return;
    }

	if ( victim->pcdata && victim->pcdata->deguilded )
	{
		stc("That person has been deguilded without remorting.\n\r", ch);
		return;
	}

    if ( ( clan = clan_lookup( arg2 ) ) == 0 )
    {
		stc("{cNo such Guild exists.\n\r",ch);
		return;
    }

	if (IS_IMMORTAL(victim) && ch->level < victim->level)
	{
		stc("Yeah, right.\n\r",ch);
		act("Hey, $N, $n just tried to make you a $t!",ch,arg2,victim,TO_ROOM);
		return;
	}

    if (!str_cmp(arg2,"loner") || !str_cmp(arg2,"rom"))
    {
		stc("You can only Guild, not un-guild.\n\r",ch);
		return;
	}
	if (!can_recruit(ch, victim, arg2))
    {
		stc("You may not recruit this person. \n\r",ch);
		return;
	}
/*
    if (clan_table[clan].independent)
    {
		sprintf(buf,"{cThey are now a %s.\n\r",clan_table[clan].name);
		stc(buf,ch);
		sprintf(buf,"{cYou are now a %s.\n\r",clan_table[clan].name);
		stc(buf,victim);
    }
*/
	sprintf(buf,"{cThey are now a member of the %s Guild.\n\r",capitalize(clan_table[clan].name));
	stc(buf,ch);
	sprintf(buf,"{cYou are now a member of the %s Guild.\n\r",capitalize(clan_table[clan].name));
	stc(buf,victim);

    victim->clan = clan;
    victim->rank = 0;
}

void do_study( CHAR_DATA *ch, char *argument ) /* study by Absalom */
{
    char arg[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char buf[MSL];
    OBJ_DATA *obj;
    int sn = 0, num, lvl = 0;
    char *objBuf;

    argument = one_argument( argument, arg );
    argument = one_argument( argument, arg2 );

    if ( arg[0] == '\0')
    {
		stc( "Study what?\n\r", ch );
		return;
    }
    if ( arg2[0] == '\0')
    {
		stc( "Study what weave on the scroll?\n\r", ch );
		stc( "You must supply the correct number of the weave on the scroll.\n\r", ch );
		stc( "Appraise the scroll and count from 1 from the left.\n\r", ch );
		stc( "Level 10 weaves of: 'defense' 'vigor' 'reserved' 'reserved'\n\r", ch );
		stc( "To learn defense, type study scroll 1.\n\r", ch );
		stc( "To learn vigor, type study scroll 2.\n\r", ch );
/*	        do_function( ch, &do_appraise, arg ); */
		stc( "Type appraise [item] to see which weaves are on your scroll.\n\r", ch);
		return;
    }

    if ( ( obj = get_obj_carry( ch, arg, ch ) ) == NULL )
    {
		stc( "You do not have that item.\n\r", ch );
		return;
    }

    if (obj->item_type != ITEM_SCROLL )
    {
		stc( "You can only study tomes of knowledge.\n\r", ch );
		return;
    }

	if (!IS_SET(ch->op_flags, OP_CHANNELER))
    {
		stc( "It would do you no good to study this.\n\r", ch );
		return;
    }
    if ( !is_number(arg2) || atoi(arg2) < 1 || atoi(arg2) > 4 )
    {
		stc( "You must supply the correct number of the weave on the scroll.\n\r", ch );
		stc( "dAppraise the scroll and count from 0 from the left.\n\r", ch );
		stc( "Level 10 weaves of: 'defense' 'vigor' 'reserved' 'reserved'\n\r", ch );
		stc( "To learn defense, type study scroll 1.\n\r", ch );
		stc( "To learn vigor, type study scroll 2.\n\r", ch );
		return;
    }
    num = atoi(arg2);
    if (obj->value[num] < 0)
    {

	    while(num < 5 && obj->value[num] < 0)
	    {
		    num++;
	    }
	    if(num > 4)
	    {
	    	stc("There is no weave there for you to learn.\n\r",ch);
	    	return;
	    }
    }
    objBuf = str_dup( obj->short_descr );
    lvl = obj->level;
    if (obj->item_type == ITEM_SCROLL)
	{
		sn = skill_lookup( skill_table[obj->value[num]].name );
		ptc( ch, "Skill is %s.\n\r", skill_table[sn].name );
	}
	else if (obj->item_type != ITEM_SCROLL)
    {
	    stc("That's not a scroll!\n\r",ch);
	    return;
    }
	if ( sn < 0 || sn >= MAX_SKILL || skill_table[sn].spell_fun == 0 )
    {
	    bug( "Do_study: bad sn %d.", sn );
	    if ( sn == 0)
		    stc("You can not learn reserved.\n\r",ch);
	    else
	    {
	      ptc( ch, "Arg2 is equal to %d\n\r", atoi(arg2) );
	      ptc( ch, "An error occured processing number %d in the weave table.\n\r", sn );
	    }
	    return;
    }

	if ( ch->pcdata->learned[sn] )
    {
	    stc("You already know that!\n\r",ch);
	    return;
    }

	if ( skill_table[sn].remort_only > ch->pcdata->rebirth )
    {
	    stc("You are not ready to learn that!\n\r",ch);
	    return;
    }

    sprintf( buf, "You study %s, attempting to learn %s.", obj->short_descr, skill_table[sn].name );

    act( "$n studies $t.", ch, objBuf, NULL, TO_ROOM );
    act( buf, ch, NULL, NULL, TO_CHAR );

    if (ch->level < lvl)
	{
/*		wait_printf(ch,15,"You fail to learn anything from %s.\n\r",objBuf);
		wait_act(15,"$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_CHAR);
*/		obj_from_char( obj );
		extract_obj( obj );
		return;
	}
    /* all these wait_* are causing mem leaks */

	if ( number_percent() >= 20 + get_skill(ch,gsn_scrolls) * 4/5)
    {
/*		wait_printf(ch,15,"You fail to learn anything from %s.\n\r",objBuf);
		wait_act(15,"$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_ROOM);
		wait_act(15,"$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_CHAR); */
		ptc(ch,"You fail to learn anything from %s.\n\r",objBuf);
		act("$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_ROOM);
		act("$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_CHAR);
		stc("You sit and contemplate your failure.\n\r",ch);
	    check_improve(ch,gsn_scrolls,FALSE,2);
		obj_from_char( obj );
	    extract_obj( obj );
            WAIT_STATE(ch, PULSE_EVENT * 5 );
	    return;
    }

    WAIT_STATE(ch, PULSE_EVENT * 15 );

/*	wait_printf(ch,5,"You continue to study %s.\n\r",objBuf);
	wait_act(5,"$n continues to study $t.",ch,objBuf,NULL,TO_ROOM);

	wait_act(8,"You concentrate intently on the text within $t.",ch,objBuf,0,TO_CHAR);
	wait_act(8,"$n concentrates intently on the text within $t.",ch,objBuf,0,TO_ROOM);

	wait_act(11,"You become totally engrossed in $t.",ch,objBuf,0,TO_CHAR);
	wait_act(11,"$n becomes totally engrossed in $t.",ch,objBuf,0,TO_ROOM); */

    if (obj->item_type == ITEM_SCROLL)
	{
		if ( sn < 0 || sn >= MAX_SKILL || skill_table[sn].spell_fun == 0 )
	    {
		    bug( "Do_study: bad sn %d.", sn );
		    return;
	    }
		if ( ch->pcdata->learned[sn] > 0 )
	    {
		    stc("You already know that!\n\r",ch);
		    return;
	    }
		ch->pcdata->learned[sn] = 1;
/*		wait_printf(ch,15,"You learned the art of %s!\n\r",skill_table[sn].name);
		wait_act(15,"$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_ROOM);
		wait_act(15,"$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_CHAR);
*/		ptc(ch,"You learned the art of %s!\n\r",skill_table[sn].name);
		act("$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_ROOM);
		act("$t glows brightly and bursts into flames!",ch,objBuf,NULL,TO_CHAR);
		stc("You sit and contemplate your success.\n\r",ch);
		check_improve(ch,gsn_scrolls,TRUE,9);
		extract_obj( obj );
		return;
	}
}

bool can_gate_to ( CHAR_DATA *ch, char *target_name )
{
   char arg[MIL];
   int  a;
   ROOM_INDEX_DATA *pRoomIndex = NULL;

	/* Can go to a beacon location? */
	target_name = one_argument( target_name, arg );

	if( arg[0] == '\0' )
	{
		stc("To call a memorized location, a valid room number is required.\n\r",ch);
		return FALSE;
	}

	a = atoi( arg );
	if( a < 0 || a >= MAX_BEACONS )
	{
		stc("Number of memorized rooms exceeds the maximum your mind can handle.\n\r", ch );
		return FALSE;
	}

	else
	{
		pRoomIndex = get_room_index( ch->pcdata->beacons[a] );

		if( IS_SET( ch->in_room->room_flags, ROOM_NO_RECALL )
		|| IS_SET( ch->in_room->room_flags, ROOM_NOGATE ) )
		{
		stc("The room glows for a moment, then the sudden light fades.\n\r", ch);
		act("The room glows for a moment, then the sudden light fades.", ch,NULL,NULL,TO_ROOM);
		return FALSE;
		}
		if( pRoomIndex == NULL )
		{
		stc("You remember no such location.\n\r", ch );
		ch->pcdata->beacons[a] = 0;
		return FALSE;
		}

		return TRUE;
	}
}

void do_beacon( CHAR_DATA *ch, char *target_name )
{
   char arg[MIL];
   char buf[MSL];
   int  a;
   ROOM_INDEX_DATA *pRoomIndex = NULL;
   int slots = 5;

	

    if( ch->in_room == NULL ) {
        return;
    }
	if (IS_NPC(ch)) {
		return;
	}
	if ( IS_SET(ch->op_flags,OP_CHANNELER) || IS_SET(ch->spec_flags,SPEC_DREAMWALKER) )
		slots += 5;

	if (slots > MAX_BEACONS)	slots = MAX_BEACONS;

    target_name = one_argument( target_name, arg );

    /* List beacons. */
    if( arg[0] == '\0' ) {
	    send_to_char( " {wNm {R| {wLocation name{x\n\r" , ch );
	    send_to_char( "{W-{w==={R+{w==============={W-{x\n\r" , ch );

	    for( a = 0; a < slots; a++ )
	    {
	        pRoomIndex = get_room_index(ch->pcdata->beacons[a]);
	        sprintf( buf, " {w%2d {R| %s{x\n\r", a, (pRoomIndex == NULL ? "{w({Runused{w){x" : pRoomIndex->name ) );
	        send_to_char( buf, ch );
	    }
	    return;
	}

   /* Set a beacon. */
   if( !str_cmp( "set", arg ) ) {
	  if ( IS_SET(ch->in_room->room_flags, ROOM_HOME )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_NOWHERE )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_LAW )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_NOGATE )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_NO_RECALL )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_SAFE )
	  ||   IS_SET(ch->in_room->room_flags, ROOM_STEDDING ) )
	  {
		  stc("You cannot seem to remember this room.\n\r",ch);
		  return;
	  }
      target_name = one_argument( target_name, arg );
      if( arg[0] == '\0' ) {
         send_to_char("Memorize a room like this: 'remember set #'\n\r", ch );
         return;
      }
      a = atoi(arg);
      if( a < 0 || a >= slots ) {
         send_to_char("Slot number out of range.\n\r", ch );
         return;
      }
      else {
         ch->pcdata->beacons[a] = ch->in_room->vnum;
         send_to_char("You memorize your current location.\n\r", ch );
         return;
      }
   }
   return;
}

void do_shave ( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *razor;
    OBJ_DATA *razor_next;
    bool found = FALSE;

	if ( IS_NPC(ch) || ch->pcdata->true_sex == SEX_FEMALE || ch->pcdata->beard < 1 )
	{
		stc("You aren't in need of a shave.\n\r",ch);
		return;
	}
	for ( razor = ch->carrying; razor != NULL; razor = razor_next )
	{
	    razor_next = razor->next_content;
		if ( razor->item_type == ITEM_RAZOR )
		{
			found = TRUE;
			break;
		}
		else continue;
    }
	if ( !found )
	{
        stc( "How do you propose to shave without a razor?\n\r", ch );
        stc( "You will need to hold a razor.\n\r", ch );
        return;
	}
	if ( found )
	{
		if ( razor->wear_loc == WEAR_NONE )
		{
        stc( "You will need to hold your razor.\n\r", ch );
        return;
		}
	}

	act("You shave your face with $t.",ch,razor->short_descr,NULL,TO_CHAR);
	act("$n shaves his face with $t.",ch,razor->short_descr,NULL,TO_ROOM);

	if ( ch->pcdata->beard == 6 )
	{
		act("Long strands of your scraggly beard begin to fall away.",ch,NULL,NULL,TO_CHAR);
		act("Long strands of $n's scraggly beard begin to fall away.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->beard == 5 )
	{
		act("Your rough beard is quickly shaved down to only a heavy growth.",ch,NULL,NULL,TO_CHAR);
		act("$n's rough beard is quickly shaved down to only a heavy growth.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->beard == 4 )
	{
		act("Your thick beard is reduced to a mere day's growth.",ch,NULL,NULL,TO_CHAR);
		act("$n's thick beard is reduced to a mere day's growth.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->beard == 3 )
	{
		act("You trim your mere day's growth of beard to rough bristles.",ch,NULL,NULL,TO_CHAR);
		act("$n's trims his thick beard down to rough bristles.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->beard == 2 )
	{
		act("Only a shadow is left of your beard.",ch,NULL,NULL,TO_CHAR);
		act("Only a shadow is left of $n's beard.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->beard == 1 )
	{
		act("You shave your face clean and smooth.",ch,NULL,NULL,TO_CHAR);
		act("$n shaves his face clean and smooth.",ch,NULL,NULL,TO_ROOM);
	}

	WAIT_STATE( ch, PULSE_VIOLENCE );
	ch->pcdata->beard -= 1;
	return;
}

void do_brush ( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *brush;
    OBJ_DATA *brush_next;
    bool found = FALSE;

	if ( IS_NPC(ch) || ch->pcdata->true_sex == SEX_MALE || ch->pcdata->hair < 1 )
	{
		stc("Your hair doesn't need brushing right now.\n\r",ch);
		return;
	}
	for ( brush = ch->carrying; brush != NULL; brush = brush_next )
	{
	    brush_next = brush->next_content;
		if ( brush->item_type == ITEM_BRUSH )
		{
			found = TRUE;
			break;
		}
		else continue;
    }
	if ( !found )
	{
        stc( "How do you propose to brush your hair without a hair brush?\n\r", ch );
        stc( "You will need to hold a brush.\n\r", ch );
        return;
	}
	if ( found )
	{
		if ( brush->wear_loc == WEAR_NONE )
		{
        stc( "You will need to hold your brush.\n\r", ch );
        return;
		}
	}

	act("You brush your hair with $t.",ch,brush->short_descr,NULL,TO_CHAR);
	act("$n brushes $s hair with $t.",ch,brush->short_descr,NULL,TO_ROOM);

	if ( ch->pcdata->hair == 6 )
	{
		act("Your hair begins to resemble less of a rat's nest as you brush your hair out.",ch,NULL,NULL,TO_CHAR);
		act("$n's hair begins tor esemble less of a rat's nest as $e brushes $s hair out.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->hair == 5 )
	{
		act("The knots and tangles begin to pull free as you brush your hair out.",ch,NULL,NULL,TO_CHAR);
		act("The knots and tangles begin to pull free as $n brushes $s hair out.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->hair == 4 )
	{
		act("The tangles slowly smooth away as you brush your hair out.",ch,NULL,NULL,TO_CHAR);
		act("The tangles slowly smooth away as $n brushes $s hair out.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->hair == 3 )
	{
		act("Only a few tangles are left as you brushes your hair out.",ch,NULL,NULL,TO_CHAR);
		act("Only a few tangles are left as $n brushes $s hair out.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->hair == 2 )
	{
		act("You brush your hair with smooth even strokes.",ch,NULL,NULL,TO_CHAR);
		act("$n brushes $s hair with smooth even strokes.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( ch->pcdata->hair == 1 )
	{
		act("You brush your until it is left smooth and soft.",ch,NULL,NULL,TO_CHAR);
		act("$n brushes $s hair until it is smooth and soft.",ch,NULL,NULL,TO_ROOM);
	}

	WAIT_STATE( ch, PULSE_VIOLENCE );
	ch->pcdata->hair -= 1;
	return;
}

/* toggle options to turn stuff on and off - Dalsor */
void do_toggle ( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	char buf[MSL];
	argument = one_argument ( argument,arg );

	if (IS_NPC(ch))
	return;
	if ( arg[0] == '\0' )
	{
		stc("-*- Communications and Configuration Status -*-\n\r",ch);
		ptc(ch,"IC       %7s   Shouts     %7s   Quotes     %7s   AutoBox    %7s\n\r",
		IS_SET(ch->comm,COMM_NOIC) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_SHOUTSOFF) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_NOQUOTE) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags, AUTO_AUTOBOX) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Global   %7s   Tells      %7s   GLTALK     %7s   ShowSaves  %7s\n\r",
		IS_SET(ch->comm,COMM_NOOOC) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_DEAF) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_NOGL) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags, AUTO_SAVEMESSAGE) ? "{ROFF{x" : "{GON{x" ) ;

		ptc(ch,"MSP      %7s   Quiet      %7s   QandA      %7s   AutoH2H    %7s\n\r",
		!IS_SET(ch->war_flags,WAR_MSP) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_QUIET) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_NOQUESTION) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTOH2H) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Auction  %7s   Deaths     %7s   Logins     %7s   Rebirths   %7s\n\r",
		IS_SET(ch->comm,COMM_NOAUCTION) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_PDEATH) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_PENTER) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_PREBIRTH)?"{ROFF{X" : "{GON{x" );

		ptc(ch,"Music    %7s   Clantalk   %7s   Autoassist %7s   NoTeach    %7s\n\r",
		IS_SET(ch->comm,COMM_NOMUSIC) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_NOCLAN) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_AUTOASSIST) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->spec_flags,SPEC_NOTEACH) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Autoexit %7s   Autogold   %7s   Autoloot   %7s   AutoSearch  %7s\n\r",
		!IS_SET(ch->act,PLR_AUTOEXIT) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_AUTOGOLD) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_AUTOLOOT) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTOSEARCH) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Autosac  %7s   Autosplit  %7s   Autodamage %7s\n\r",
		!IS_SET(ch->act,PLR_AUTOSAC) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_AUTOSPLIT) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTODAMAGE) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"AButcher %7s   Autoslay   %7s   Compact    %7s\n\r",
		!IS_SET(ch->auto_flags,AUTO_AUTOBUTCHER) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTOSLAY) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_COMPACT) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Prompt   %7s   Combine    %7s   Canloot    %7s\n\r",
		!IS_SET(ch->comm,COMM_PROMPT) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_COMBINE) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_CANLOOT) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Nosummon %7s   Nofollow   %7s   Brief      %7s\n\r",
		!IS_SET(ch->act,PLR_NOSUMMON) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->act,PLR_NOFOLLOW) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->comm,COMM_BRIEF) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Show     %7s   Autolog    %7s   AutoSkin   %7s\n\r",
		!IS_SET(ch->comm,COMM_SHOW_AFFECTS) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTOLOG) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTOSKIN) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Hints    %7s   Autofight  %7s   AutoRecall %7s\n\r",
		!IS_SET(ch->auto_flags,AUTO_HINTS) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->war_flags,WAR_AUTOFIGHT) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_AUTORECALL)  ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Automap  %7s   Counter    %7s   Parry      %7s\n\r",
		!IS_SET(ch->auto_flags,AUTO_AUTOMAP) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_COUNTER) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_PARRY) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Dodge    %7s   War        %7s   Peek       %7s\n\r",
		!IS_SET(ch->auto_flags,AUTO_DODGE) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_WAR) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_PEEK) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"RoA      %7s   Tag        %7s   Tourney    %7s\n\r",
		!IS_SET(ch->auto_flags,AUTO_ROA) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_FTAG) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_TOURNEY) ? "{ROFF{x" : "{GON{x" );

		ptc(ch,"Staff    %7s   DFHunt     %7s   Trivia     %7s\n\r",
		IS_SET(ch->comm,COMM_NOSTAFF) ? "{ROFF{x" : "{GON{x",
		IS_SET(ch->comm,COMM_NODFH) ? "{ROFF{x" : "{GON{x",
		!IS_SET(ch->auto_flags,AUTO_TRIVIA) ? "{ROFF{x" : "{GON{x" );

		if (IS_IMMORTAL(ch))
	        ptc(ch,"Immtalk  %7s\n\r",
        	IS_SET(ch->comm,COMM_NOWIZ) ? "{ROFF{x" : "{GON{x" );

               sprintf(buf, "Client: %s (Version: %s).\n\r", ch->desc->pProtocol->pVariables[eMSDP_CLIENT_ID]->pValueString,
ch->desc->pProtocol->pVariables[eMSDP_CLIENT_VERSION]->pValueString);
                send_to_char(buf, ch);
                if (str_cmp(ch->desc->pProtocol->pVariables[eMSDP_PLUGIN_ID]->pValueString, "Unknown"))
                {
                sprintf(buf, "Plugin: %s\n\r", ch->desc->pProtocol->pVariables[eMSDP_PLUGIN_ID]->pValueString);
                send_to_char(buf, ch);
                }
                send_to_char("Protocols: ", ch);

                if (ch->desc->pProtocol->bNAWS )
                 send_to_char("NAWS", ch);
                if (ch->desc->pProtocol->bMSP )
                 send_to_char(", MSP", ch);
                if (ch->desc->pProtocol->bATCP )
                 send_to_char(", ATCP", ch);
                if (ch->desc->pProtocol->b256Support )
                 send_to_char(", 256 Colours", ch);
                if (ch->desc->pProtocol->bMXP )
                {
                 sprintf(buf, ", MXP (%s)", ch->desc->pProtocol->pMXPVersion);
                 send_to_char(buf, ch);
                }
                if (ch->desc->pProtocol->bMCCP)
                 send_to_char(", MCCP2", ch);
                if (ch->desc->pProtocol->bMSDP )
                 send_to_char(", MSDP", ch);
                if (ch->desc->pProtocol->bNAWS )
                {
                sprintf(buf, ".\n\rScreen Size: %d characters wide and %d characters high.\n\r", ch->desc->pProtocol->ScreenWidth,
ch->desc->pProtocol->ScreenHeight );
                 send_to_char(buf, ch);
                }
                else
                  send_to_char("\n\r", ch);


		return;
	}
	else if ( !str_cmp ( arg, "SHOW" ) || !str_cmp ( arg, "AFFECTS" ) )
	{
	    if (IS_SET(ch->comm,COMM_SHOW_AFFECTS))
	    {
		    stc("Affects will no longer be shown in your score.\n\r",ch);
		    stc("Typing Affects will show them.\n\r",ch);
		    REMOVE_BIT(ch->comm,COMM_SHOW_AFFECTS);
	    }
	    else
	    {
		    stc("Affects will now be shown in your score.\n\r",ch);
		    SET_BIT(ch->comm,COMM_SHOW_AFFECTS);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "BRIEF" ) )
	{
	    if (IS_SET(ch->comm,COMM_BRIEF))
	    {
		    stc("Full room descriptions activated.\n\r",ch);
		    REMOVE_BIT(ch->comm,COMM_BRIEF);
	    }
	    else
	    {
		    stc("Short room descriptions activated.\n\r",ch);
		    SET_BIT(ch->comm,COMM_BRIEF);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "FOLLOW" ) || !str_cmp ( arg, "NOFOLLOW" ) )
	{
	    if (IS_SET(ch->act,PLR_NOFOLLOW))
	    {
		    stc("You now accept followers.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_NOFOLLOW);
	    }
	    else
	    {
		    stc("You no longer accept followers.\n\r",ch);
		    SET_BIT(ch->act,PLR_NOFOLLOW);
		    die_follower( ch );
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "SUMMON" ) || !str_cmp ( arg, "NOSUMMON" ) )
	{
	    if (IS_SET(ch->act,PLR_NOSUMMON))
	    {
		    stc("You are no longer immune to summon.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_NOSUMMON);
	    }
	    else
	    {
		    stc("You are now immune to summoning.\n\r",ch);
		    SET_BIT(ch->act,PLR_NOSUMMON);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "CANLOOT" ) || !str_cmp ( arg, "NOLOOT" ) )
	{
	    if (IS_SET(ch->act,PLR_CANLOOT))
	    {
		    stc("Your corpse is now safe from thieves.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_CANLOOT);
	    }
	    else
	    {
		    stc("Your corpse may now be looted.\n\r",ch);
		    SET_BIT(ch->act,PLR_CANLOOT);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "COMBINE" ) )
	{
	    if (IS_SET(ch->comm,COMM_COMBINE))
	    {
		    stc("Long inventory selected.\n\r",ch);
		    REMOVE_BIT(ch->comm,COMM_COMBINE);
	    }
	    else
	    {
		    stc("Combined inventory selected.\n\r",ch);
		    SET_BIT(ch->comm,COMM_COMBINE);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "PROMPT" ) )
	{
		if (IS_SET(ch->comm,COMM_PROMPT))
	   	{
      	    stc("You will no longer see prompts.\n\r",ch);
      	    stc("See Help Prompt for other options.\n\r",ch);
      	    REMOVE_BIT(ch->comm,COMM_PROMPT);
    	}
    	else
    	{
      	    stc("You will now see prompts.\n\r",ch);
      	    stc("See Help Prompt for other options.\n\r",ch);
      	    SET_BIT(ch->comm,COMM_PROMPT);
    	}
        return;
	}
	else if ( !str_cmp ( arg, "COMPACT" ) )
	{
	    if (IS_SET(ch->comm,COMM_COMPACT))
	    {
		    stc("Compact mode removed.\n\r",ch);
		    REMOVE_BIT(ch->comm,COMM_COMPACT);
	    }
	    else
		{
		    stc("Compact mode set.\n\r",ch);
		    SET_BIT(ch->comm,COMM_COMPACT);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOSLAY" ) || !str_cmp ( arg, "SLAY" ) )
	{
		if (!IS_IMMORTAL(ch))
	    {
		    stc("This function is only available to Immortals.\n\r",ch);
		    return;
	    }
	    if (IS_SET(ch->auto_flags,AUTO_AUTOSLAY))
	    {
		    stc("AutoSlay removed.\n\r",ch);
		    REMOVE_BIT(ch->auto_flags,AUTO_AUTOSLAY);
	    }
	    else
	    {
		    stc("You will now automatically slay anyone who attacks you.\n\r",ch);
		    SET_BIT(ch->auto_flags,AUTO_AUTOSLAY);
	    }
	    return;
	}

        else if ( !str_cmp ( arg, "AUTOSEARCH" ) || !str_cmp ( arg, "SEARCH" ) )
        {           
            if (IS_SET(ch->auto_flags,AUTO_AUTOSEARCH))
            {
                    stc("AutoSearch removed.\n\r",ch);
                    REMOVE_BIT(ch->auto_flags,AUTO_AUTOSEARCH);
            }
            else
            {
                    stc("You will now automatically search when you walk into a room.\n\r",ch);
                    SET_BIT(ch->auto_flags,AUTO_AUTOSEARCH);
            }
            return;
        }

	else if ( !str_cmp ( arg, "AUTOBUTCHER" ) || !str_cmp ( arg, "BUTCHER" ) || !str_cmp ( arg, "ABUTCHER" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTOBUTCHER))
	    {
		    stc("AutoButcher removed.\n\r",ch);
		    REMOVE_BIT(ch->auto_flags,AUTO_AUTOBUTCHER);
	    }
	    else
	    {
	           if (get_skill(ch,gsn_butcher) == 0)
	           {
			stc("You are not skilled at butchering.\n\r",ch);
			return;
		    }
		    stc("AutoButchering is now active.\n\r",ch);
		    SET_BIT(ch->auto_flags,AUTO_AUTOBUTCHER);
	            if (IS_SET(ch->auto_flags,AUTO_AUTOSKIN))
	            {
	    	       stc("WARNING! You currently have AutoSkin toggled on.\n\r",ch);
	    	       stc("AutoSkin will take precedence over AutoButcher.\n\r",ch);
		    }
			if (IS_SET(ch->act,PLR_AUTOSAC))
			{
		    stc("{RWARNING{x AutoSacrifice is ON.\n\rYou should turn Autosac off to avoid seeing error messages when you kill.\n\r",ch);
			}
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTODAMAGE" ) || !str_cmp ( arg, "DAMAGE" ) || !str_cmp ( arg, "AUTODAM" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTODAMAGE))
	    {
		    stc("AutoDamage removed.\n\r",ch);
		    REMOVE_BIT(ch->auto_flags,AUTO_AUTODAMAGE);
	    }
	    else
	    {
		    stc("Damage messages will now be shown.\n\r",ch);
		    SET_BIT(ch->auto_flags,AUTO_AUTODAMAGE);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOLOG" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTOLOG))
	    {
		    stc("AutoLog removed.\n\r",ch);
		    stc("You will no longer see reminders of waiting messages.\n\r",ch);
		    REMOVE_BIT(ch->auto_flags,AUTO_AUTOLOG);
	    }
	    else
	    {
		    stc("AutoLog active.\n\r",ch);
		    stc("You will now see a reminder when you have messages waiting.\n\r",ch);
		    stc("You will not receive tells or whispers while fighting until.\n\r",ch);
		    stc("you replay.\n\r",ch);
		    SET_BIT(ch->auto_flags,AUTO_AUTOLOG);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOSPLIT" ) || !str_cmp ( arg, "SPLIT" ) )
	{
	    if (IS_SET(ch->act,PLR_AUTOSPLIT))
	    {
		    stc("Autosplitting removed.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_AUTOSPLIT);
	    }
	    else
	    {
		    stc("Automatic gold splitting set.\n\r",ch);
		    stc("{RWarning!{x Pets do not sacrifice corpses if they get the kill.\n\r",ch);
		    SET_BIT(ch->act,PLR_AUTOSPLIT);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOSAC" ) || !str_cmp ( arg, "SACRIFICE" ) )
	{
	    if (IS_SET(ch->act,PLR_AUTOSAC))
	    {
		    stc("Autosacrificing removed.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_AUTOSAC);
	    }
	    else
	    {
		    stc("Automatic corpse sacrificing set.\n\r",ch);
		    SET_BIT(ch->act,PLR_AUTOSAC);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOLOOT" ) || !str_cmp ( arg, "LOOT" ) )
	{
	    if (IS_SET(ch->act,PLR_AUTOLOOT))
	    {
		    stc("Autolooting removed.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_AUTOLOOT);
	    }
	    else
	    {
		    stc("Automatic corpse looting set.\n\r",ch);
		    SET_BIT(ch->act,PLR_AUTOLOOT);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOGOLD" ) || !str_cmp ( arg, "GOLD" ) )
	{
	    if (IS_SET(ch->act,PLR_AUTOGOLD))
	    {
		    stc("Autogold removed.\n\r",ch);
		    REMOVE_BIT(ch->act,PLR_AUTOGOLD);
	    }
	    else
	    {
		    stc("Automatic gold looting set.\n\r",ch);
		    SET_BIT(ch->act,PLR_AUTOGOLD);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOEXIT" ) || !str_cmp ( arg, "EXIT" ) )
	{
    	if (IS_SET(ch->act,PLR_AUTOEXIT))
    	{
    		stc("Exits will no longer be displayed.\n\r",ch);
    		REMOVE_BIT(ch->act,PLR_AUTOEXIT);
    	}
    	else
    	{
    		stc("Exits will now be displayed.\n\r",ch);
    		SET_BIT(ch->act,PLR_AUTOEXIT);
    	}
    	return;
	}
	else if ( !str_cmp ( arg, "AUTOASSIST" ) || !str_cmp ( arg, "ASSIST" ) )
	{
	    if (IS_SET(ch->act,PLR_AUTOASSIST))
	    {
	    	stc("Autoassist removed.\n\r",ch);
	    	REMOVE_BIT(ch->act,PLR_AUTOASSIST);
	    }
	    else
	    {
	    	stc("You will now assist when needed.\n\r",ch);
	    	SET_BIT(ch->act,PLR_AUTOASSIST);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOSKIN" ) || !str_cmp ( arg, "SKIN" ) )
	{
		if (IS_SET(ch->auto_flags,AUTO_AUTOSKIN))
	    {
	    	stc("AutoSkin removed.\n\r",ch);
	    	REMOVE_BIT(ch->auto_flags,AUTO_AUTOSKIN);
	    }
	    else
	    {
	    	stc("You will now AutoSkin corpses.\n\r",ch);
	    	SET_BIT(ch->auto_flags,AUTO_AUTOSKIN);
	        if (IS_SET(ch->auto_flags,AUTO_AUTOBUTCHER))
	        {
	    	   stc("WARNING! You currently have AutoButcher toggled on.\n\r",ch);
	    	   stc("AutoSkin will take precedence over AutoButcher.\n\r",ch);
		}
		if (IS_SET(ch->act,PLR_AUTOSAC))
		{
	            stc("{RWARNING{x AutoSacrifice is ON.\n\rYou should turn Autosac off to avoid seeing error messages when you kill.\n\r",ch);
		}
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "IC" ) || !str_cmp ( arg, "INCHAR" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOIC))
        {
	        stc("In Character channel is now ON.\n\r",ch);
	        stc("Out of Character talk on this channel is cause for ",ch);
	        stc("this channel to be removed from you.\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NOIC);
	    }
        else
        {
	        stc("In Character channel is now OFF.\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOIC);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "SHOUTS" ) )
	{
      	if (IS_SET(ch->comm,COMM_SHOUTSOFF))
      	{
            stc("You can hear shouts again.\n\r",ch);
            REMOVE_BIT(ch->comm,COMM_SHOUTSOFF);
      	}
      	else
      	{
            stc("You will no longer hear shouts.\n\r",ch);
            SET_BIT(ch->comm,COMM_SHOUTSOFF);
      	}
      	return;
	}
	else if ( !str_cmp ( arg, "QUOTES" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOQUOTE))
	    {
		    stc("Quote channel is now ON.\n\r",ch);
		    REMOVE_BIT(ch->comm,COMM_NOQUOTE);
	    }
	    else
	    {
	        stc("Quote channel is now OFF.\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOQUOTE);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "GLOBAL" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOOOC))
	    {
	        stc("Global channel is now ON.\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NOOOC);
	    }
	    else
	    {
	        stc("Global channel is now OFF.\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOOOC);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "TELLS" ) )
	{
		if (IS_SET(ch->comm, COMM_DEAF))
		{
			stc("You will now hear tells again.\n\r",ch);
			REMOVE_BIT(ch->comm,COMM_DEAF);
		}
		else
		{
			stc("You will no longer hear tells.\n\r",ch);
			SET_BIT(ch->comm,COMM_DEAF);
		}
		return;
	}
	else if ( !str_cmp ( arg, "GRATS" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOGRATS))
	    {
	        stc("Grats channel is now ON.\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NOGRATS);
	    }
	    else
	    {
	        stc("Grats channel is now OFF.\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOGRATS);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "MSP" ) )
	{
	    if (IS_SET(ch->war_flags,WAR_MSP))
	    {
	    	stc("You will no longer hear MUD sounds.\n\r",ch);
	    	REMOVE_BIT(ch->war_flags,WAR_MSP);
	    }
	    else
	    {
	    	stc("From now on, you will hear MUD sounds.\n\r",ch);
	   		SET_BIT(ch->war_flags,WAR_MSP);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "QUIET" ) )
	{
	    if (IS_SET(ch->comm,COMM_QUIET))
	    {
      	  	stc("Quiet mode removed.\n\r",ch);
        	REMOVE_BIT(ch->comm,COMM_QUIET);
    	}
   		else
   		{
   			stc("From now on, you will only hear says and emotes.\n\r",ch);
   			SET_BIT(ch->comm,COMM_QUIET);
   		}
   		return;
	}
	else if ( !str_cmp ( arg, "QANDA" ) || !str_cmp ( arg, "QUESTION" ) || !str_cmp ( arg, "ANSWER" ) )
	{
      	if (IS_SET(ch->comm,COMM_NOQUESTION))
      	{
      		stc("Q & A channel is now ON.\n\r",ch);
      		REMOVE_BIT(ch->comm,COMM_NOQUESTION);
    	}
    	else
    	{
        	stc("Q & A channel is now OFF.\n\r",ch);
        	SET_BIT(ch->comm,COMM_NOQUESTION);
    	}
    	return;
	}
	else if ( !str_cmp ( arg, "AUCTION" ) )
	{
		if ( IS_SET(ch->comm,COMM_NOAUCTION) )
		{
		    REMOVE_BIT(ch->comm,COMM_NOAUCTION );
		    stc("Auction channel is now ON.\n\r",ch);
		}
		else
		{
			SET_BIT(ch->comm,COMM_NOAUCTION);
			stc("Auction channel is now OFF.\n\r",ch);
		}
		return;
	}
	else if ( !str_cmp ( arg, "DEATHS" ) || !str_cmp ( arg, "PDEATH" ) )
	{
    	if (IS_SET(ch->comm,COMM_PDEATH))
    	{
        	stc("Player Death message removed.\n\r",ch);
        	REMOVE_BIT(ch->comm,COMM_PDEATH);
    	}
    	else
    	{
        	stc("From now on, you will see Player Deaths.\n\r",ch);
        	SET_BIT(ch->comm,COMM_PDEATH);
    	}
		return;

	}
	else if ( !str_cmp ( arg, "LOGINS" ) || !str_cmp ( arg, "PENTER" ) )
	{
    	if (IS_SET(ch->comm,COMM_PENTER))
    	{
        	stc("Player Login message removed.\n\r",ch);
        	REMOVE_BIT(ch->comm,COMM_PENTER);
    	}
    	else
    	{
        	stc("From now on, you will see Player Logins.\n\r",ch);
        	SET_BIT(ch->comm,COMM_PENTER);
    	}
		return;
	}
	else if ( !str_cmp ( arg, "REBIRTHS" ) || !str_cmp ( arg, "PREBIRTH" ) )
	{
    	  if (IS_SET(ch->comm,COMM_PREBIRTH))
    	  {
        	stc("Player Rebirth message removed.\n\r",ch);
        	REMOVE_BIT(ch->comm,COMM_PREBIRTH);
    	  }
    	  else
    	  {
        	stc("From now on, you will see Player Rebirths.\n\r",ch);
        	SET_BIT(ch->comm,COMM_PREBIRTH);
    	  }
		return;
	}
	else if ( !str_cmp ( arg, "GLTALK" ) )
	{
      	if (IS_SET(ch->comm,COMM_NOGL))
      	{
            stc("You can hear Gltalk again.\n\r",ch);
            REMOVE_BIT(ch->comm,COMM_NOGL);
      	}
      	else
      	{
            stc("You will no longer hear GLtalk.\n\r",ch);
            SET_BIT(ch->comm,COMM_NOGL);
      	}
      	return;
	}
	else if ( !str_cmp ( arg, "MUSIC" ) )
	{
    	if (IS_SET(ch->comm,COMM_NOMUSIC))
    	{
    	    stc("Music channel is now ON.\n\r",ch);
    	    REMOVE_BIT(ch->comm,COMM_NOMUSIC);
    	}
    	else
    	{
    	    stc("Music channel is now OFF.\n\r",ch);
    	    SET_BIT(ch->comm,COMM_NOMUSIC);
    	}
    	return;
	}
	else if ( !str_cmp ( arg, "IMMTALK" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOWIZ))
	    {
			stc("Immortal channel is now ON\n\r",ch);
			REMOVE_BIT(ch->comm,COMM_NOWIZ);
	    }
	    else
	    {
			stc("Immortal channel is now OFF\n\r",ch);
			SET_BIT(ch->comm,COMM_NOWIZ);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "CLANTALK" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOCLAN))
	    {
	        stc("Clan channel is now ON\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NOCLAN);
	    }
	    else
	    {
	        stc("Clan channel is now OFF\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOCLAN);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "HINTS" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_HINTS))
	    {
	        stc("Hints channel is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_HINTS);
	    }
	    else
	    {
	        stc("Hints channel is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_HINTS);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "FIGHT" ) || !str_cmp( arg, "AUTOFIGHT" ) )
	{
	    if (IS_SET(ch->war_flags,WAR_AUTOFIGHT))
	    {
	        stc("Auto Fight is now OFF\n\r",ch);
	        REMOVE_BIT(ch->war_flags,WAR_AUTOFIGHT);
	    }
	    else
	    {
	        stc("Auto Fight is now ON\n\r",ch);
	        SET_BIT(ch->war_flags,WAR_AUTOFIGHT);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "RECALL" ) || !str_cmp( arg, "AUTORECALL" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTORECALL))
	    {
	        stc("Auto Recall is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_AUTORECALL);
	    }
	    else
	    {
	        stc("Auto Recall is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_AUTORECALL);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "MAP" ) || !str_cmp( arg, "AUTOMAP" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTOMAP))
	    {
	        stc("Auto Map is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_AUTOMAP);
	    }
	    else
	    {
	        stc("Auto Mapping is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_AUTOMAP);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "COUNTER" ) || !str_cmp( arg, "AUTOCOUNTER" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_COUNTER))
	    {
	        stc("Auto Counterattack is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_COUNTER);
	    }
	    else
	    {
	        stc("Auto Counterattack is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_COUNTER);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "PARRY" ) || !str_cmp( arg, "AUTOPARRY" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_PARRY))
	    {
	        stc("Auto PARRY is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_PARRY);
	    }
	    else
	    {
	        stc("Auto PARRY is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_PARRY);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "DODGE" ) || !str_cmp( arg, "AUTODODGE" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_DODGE))
	    {
	        stc("Auto DODGE is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_DODGE);
	    }
	    else
	    {
	        stc("Auto DODGE is now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_DODGE);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "WAR" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_WAR))
	    {
	        stc("War Messages are now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_WAR);
	    }
	    else
	    {
	        stc("War Messages are now ON\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_WAR);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "PEEK" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_PEEK))
	    {
	        stc("Auto Peek is now OFF\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_PEEK);
	    }
	    else
	    {
	        stc("You will now try to PEEK when looking at someone.\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_PEEK);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "ROA" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_ROA))
	    {
	        stc("RoA Enhanced features are now OFF.\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_ROA);
	    }
	    else
	    {
	        stc("RoA Enhanced features are now ON!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_ROA);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "TAG" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_FTAG))
	    {
	        stc("Freeze Tag messages are now OFF.\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_FTAG);
	    }
	    else
	    {
	        stc("Freeze Tag messages are now ON!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_FTAG);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "TOURNEY" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_TOURNEY))
	    {
	        stc("Tourney messages are now OFF.\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_TOURNEY);
	    }
	    else
	    {
	        stc("Tourney messages are now ON!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_TOURNEY);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "STAFF" ) )
	{
	    if (IS_SET(ch->comm,COMM_NOSTAFF))
	    {
	        stc("Staff Talk messages are now ON!\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NOSTAFF);
	    }
	    else
	    {
	        stc("Staff Talk messages are now OFF!\n\r",ch);
	        SET_BIT(ch->comm,COMM_NOSTAFF);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "DFHUNT" ) )
	{
	    if (IS_SET(ch->comm,COMM_NODFH))
	    {
	        stc("Darkfriend Hunt messages are now ON!\n\r",ch);
	        REMOVE_BIT(ch->comm,COMM_NODFH);
	    }
	    else
	    {
	        stc("Darkfriend Hunt messages are now OFF!\n\r",ch);
	        SET_BIT(ch->comm,COMM_NODFH);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "TRIVIA" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_TRIVIA))
	    {
	        stc("Trivia messages are now OFF!\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_TRIVIA);
	    }
	    else
	    {
	        stc("Trivia messages are now ON!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_TRIVIA);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOBOX" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTOBOX))
	    {
	        stc("You will no longer automatically pick up treasure chests!\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_AUTOBOX);
	    }
	    else
	    {
	        stc("You will now automatically pick up treasure chests!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_AUTOBOX);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "SHOWSAVES" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_SAVEMESSAGE))
	    {
	        stc("You will no longer see autosave messages!\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_SAVEMESSAGE);
	    }
	    else
	    {
	        stc("You will now see autosave messages!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_SAVEMESSAGE);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "AUTOH2H" ) )
	{
	    if (IS_SET(ch->auto_flags,AUTO_AUTOH2H))
	    {
	        stc("You will no longer automatically use hand to hand fighting styles!\n\r",ch);
	        REMOVE_BIT(ch->auto_flags,AUTO_AUTOH2H);
	    }
	    else
	    {
	        stc("You will now automatically use hand to hand fighting styles!\n\r",ch);
	        SET_BIT(ch->auto_flags,AUTO_AUTOH2H);
	    }
	    return;
	}
	else if ( !str_cmp ( arg, "NOTEACH" ) )
	{
	    if (!IS_SET(ch->spec_flags,SPEC_NOTEACH))
	    {
	        stc("You will no longer automatically listen to people who try to teach you!\n\r",ch);
	        SET_BIT(ch->spec_flags,SPEC_NOTEACH);
	    }
	    else
	    {
	        stc("You will now automatically listen to people who try to teach you!\n\r",ch);
	        REMOVE_BIT(ch->spec_flags,SPEC_NOTEACH);
	    }
	    return;
	}
	else
	{
		stc("You must specify an option to toggle. Type toggle alone to see a list.\n\r",ch);
		return;
	}

}

void keep_obj( CHAR_DATA *ch, OBJ_DATA *obj )
{
	SET_BIT( obj->extra_flags, ITEM_NOSELL );
	free_string( obj->owner );
	obj->owner = str_dup( ch->name );
	ptc( ch, "%s flagged as a keeper.{x\n\r", obj->short_descr );
	return;
}
void do_keep( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	OBJ_DATA *obj;

	one_argument( argument, arg );

	if ( IS_NPC( ch ) )
		return;


	if ( !str_cmp( arg, "all" ) )
	{
		OBJ_DATA *obj_next;

		for ( obj = ch->carrying; obj != NULL; obj = obj_next )
		{
			obj_next = obj->next_content;

			if ( IS_SET( obj->extra_flags, ITEM_NOSELL ) )
				continue;
			else
				keep_obj(ch,obj);
		}
		return;
	}

	if ( ( obj = get_obj_carry( ch, arg, ch ) ) == NULL )
	{
		stc("Keep which item? The item must be in your inventory.\n\r",ch);
		return;
	}
	else if ( IS_SET( obj->extra_flags, ITEM_NOSELL ) )
	{
		stc("This item has already been flagged as a keeper.\n\r",ch);
		return;
	}
	else
	{
		keep_obj(ch,obj);
		return;
	}
}
void do_unkeep( CHAR_DATA *ch, char *argument )
{
    char arg[MIL];
    OBJ_DATA *obj;

	one_argument( argument, arg );

	if ( IS_NPC( ch ) )
	return;

    if ( ( obj = get_obj_carry( ch, arg, ch ) ) == NULL )
    {
		stc("Unkeep which item? The item must be in your inventory.\n\r",ch);
		return;
	}
	else if ( !IS_SET( obj->extra_flags, ITEM_NOSELL ) )
    {
		stc("This item has has not been flagged as a keeper.\n\r",ch);
		return;
	}
	else if (obj->pIndexData->vnum == 9)
	{
		stc("You cannot unkeep this item.\n\r", ch);
		return;
	}
	else
	{
		if ( obj->owner != NULL && obj->owner[0] != '\0' && strcmp( obj->owner, ch->name ) )
		{
			ptc( ch, "This item belongs to %s. Only they can unkeep it.\n\r", obj->owner );
			return;
		}
		REMOVE_BIT( obj->extra_flags, ITEM_NOSELL );
		free_string( obj->owner );
		obj->owner = NULL;
		ptc( ch, "%s is no longer flagged as a keeper.{x\n\r", obj->short_descr );
		return;
	}
}
