/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"

void do_use( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *obj;
	CHAR_DATA *victim;
 
	if ( ( obj = get_obj_carry( ch, argument, ch ) ) == NULL )
	{
		stc( "{cYou do not seem to have that item.{x\n\r", ch );
		return;
    }

    if ( argument[0] == '\0' )
    {
		victim = ch;
    }

	switch( obj->item_type )
	{
		case ITEM_POTION:
			do_function (victim, &do_quaff, argument);
		return;
		case ITEM_PILL:
			do_function (victim, &do_eat, argument);
		return;
		case ITEM_SCROLL:
			do_function (victim, &do_recite, argument);
		return;
	}
}
void do_turn( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *obj;
	char buf[MSL];
	int door;

	if ( ( obj = get_obj_here( ch, NULL, argument ) ) == NULL )
	{
		stc( "Turn what? You don't see that here.\n\r", ch );
		return;
	}
	if ( obj->item_type != ITEM_TRIGGER )
	{
		stc( "You struggle to turn it, but it doesn't budge.\n\r", ch );
		return;
	}
	/*ptc( ch, "Obj value 0 is %d which is %s.\n\r", obj->value[0], flag_string( trigger_flags, obj->value[0] ) );*/
	if ( obj->value[0] != OBJ_TRIGGER_TURN )
	{
		ptc( ch, "You struggle to turn %s, but it doesn't budge.\n\r", obj->short_descr );
		return;
	}
	if ( obj->value[1] == OBJ_TRIGGER_TURN_DOOR_OPEN )
	{
	    if ( ( door =find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( !IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d opens.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You turn %s and %s opens.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n turns %s and %s opens.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_TURN_DOOR_CLOSE )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR ) && IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    SET_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d closes.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You turn %s and %s closes.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n turns %s and %s closes.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_TURN_DOOR_LOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    if ( !IS_SET( pexit_rev->exit_info, EX_CLOSED ) )
				    SET_BIT( pexit_rev->exit_info, EX_CLOSED );

			    SET_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d locks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You turn %s and %s locks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n turns %s and %s locks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_TURN_DOOR_UNLOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& !IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d unlocks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You turn %s and %s unlocks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n turns %s and %s unlocks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}

}
void do_push( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *obj;
	char buf[MSL];
	int door;

	if ( ( obj = get_obj_here( ch, NULL, argument ) ) == NULL )
	{
		stc( "Push what? You don't see that here.\n\r", ch );
		return;
	}
	if ( obj->item_type != ITEM_TRIGGER )
	{
		stc( "You struggle to push it, but it doesn't budge.\n\r", ch );
		return;
	}
	/*ptc( ch, "Obj value 0 is %d which is %s.\n\r", obj->value[0], flag_string( trigger_flags, obj->value[0] ) );*/
	if ( obj->value[0] != OBJ_TRIGGER_PUSH )
	{
		ptc( ch, "You struggle to push %s, but it doesn't budge.\n\r", obj->short_descr );
		return;
	}
	if ( obj->value[1] == OBJ_TRIGGER_PUSH_DOOR_OPEN )
	{
	    if ( ( door =find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( !IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d opens.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You push %s and %s opens.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pushes %s and %s opens.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PUSH_DOOR_CLOSE )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR ) && IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    SET_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d closes.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You push %s and %s closes.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pushes %s and %s closes.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PUSH_DOOR_LOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    if ( !IS_SET( pexit_rev->exit_info, EX_CLOSED ) )
				    SET_BIT( pexit_rev->exit_info, EX_CLOSED );

			    SET_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d locks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You push %s and %s locks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pushes %s and %s locks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PUSH_DOOR_UNLOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& !IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d unlocks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You push %s and %s unlocks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pushes %s and %s unlocks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
}
void do_pull( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *obj;
	char buf[MSL];
	int door;

	if ( ( obj = get_obj_here( ch, NULL, argument ) ) == NULL )
	{
		stc( "Pull what? You don't see that here.\n\r", ch );
		return;
	}
	if ( obj->item_type != ITEM_TRIGGER )
	{
		stc( "You struggle to pull it, but it doesn't budge.\n\r", ch );
		return;
	}
	/*ptc( ch, "Obj value 0 is %d which is %s.\n\r", obj->value[0], flag_string( trigger_flags, obj->value[0] ) );*/
	if ( obj->value[0] != OBJ_TRIGGER_PULL )
	{
		ptc( ch, "You struggle to pull %s, but it doesn't budge.\n\r", obj->short_descr );
		return;
	}
	if ( obj->value[1] == OBJ_TRIGGER_PULL_DOOR_OPEN )
	{
	    if ( ( door =find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( !IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d opens.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You pull %s and %s opens.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pull %s and %s opens.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PULL_DOOR_CLOSE )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR ) && IS_SET(pexit->exit_info, EX_CLOSED) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if (  IS_SET(pexit->exit_info, EX_LOCKED) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT(pexit->exit_info, EX_CLOSED);
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    SET_BIT( pexit_rev->exit_info, EX_CLOSED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d closes.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You pull %s and %s closes.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pulls %s and %s closes.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PULL_DOOR_LOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			SET_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    if ( !IS_SET( pexit_rev->exit_info, EX_CLOSED ) )
				    SET_BIT( pexit_rev->exit_info, EX_CLOSED );

			    SET_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d locks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You pull %s and %s locks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pulls %s and %s locks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
	else if ( obj->value[1] == OBJ_TRIGGER_PULL_DOOR_UNLOCK )
	{
	    if ( ( door = find_door( ch, dir_name[obj->value[2]], TRUE ) ) >= 0 )
	    {
			ROOM_INDEX_DATA *to_room;
			EXIT_DATA *pexit;
			EXIT_DATA *pexit_rev;
			pexit = obj->in_room->exit[door];
			if ( IS_SET( pexit->exit_info, EX_ISDOOR )
			&& IS_SET( pexit->exit_info, EX_CLOSED )
			&& !IS_SET( pexit->exit_info, EX_LOCKED ) )
			{
				ptc( ch, "The %s has already activated.\n\r{c", obj->short_descr );
				return;
			}
			if ( !IS_SET( pexit->exit_info, EX_CLOSED ) )
			{
				ptc( ch, "The %s sticks as it is activated.\n\r{c", obj->short_descr );
				return;
			}
			REMOVE_BIT( pexit->exit_info, EX_LOCKED );
			if ( ( to_room   = pexit->u1.to_room            ) != NULL
			&&   ( pexit_rev = to_room->exit[rev_dir[door]] ) != NULL
			&&   pexit_rev->u1.to_room == obj->in_room )
			{
			    CHAR_DATA *rch;

			    REMOVE_BIT( pexit_rev->exit_info, EX_LOCKED );
			    for ( rch = to_room->people; rch != NULL; rch = rch->next_in_room )
					act( "The $d unlocks.", rch, NULL, pexit_rev->keyword, TO_CHAR );
			}
			ptc( ch, "You pull %s and %s unlocks.\n\r", obj->short_descr, dir_name[obj->value[2]] );
			sprintf( buf, "$n pulls %s and %s unlocks.", obj->short_descr, dir_name[obj->value[2]] );
			act( buf, ch, NULL, NULL, TO_ROOM );
		}
		return;
	}
}
