/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright
    (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <time.h>
#include "aww.h"
#include "interp.h"

/*
 * Attribute bonus tables.
 * Stats are
 * STR REF DEX CON INT WIS INS CHA
 * Max is 200
 */



const	struct	str_app_type	str_app		[201]		=
{
    { -5, -4,   0,  0 },  /* 0  */
    { -5, -4,   3,  1 },  /* 1  */
    { -3, -2,   3,  2 },
    { -3, -1,  10,  3 },  /* 3  */
    { -2, -1,  25,  4 },
    { -2, -1,  55,  5 },  /* 5  */
    { -1,  0,  80,  6 },
    { -1,  0,  90,  7 },
    {  0,  0, 100,  8 },
    {  0,  0, 100,  9 },
    {  0,  0, 115, 10 }, /* 10  */
    {  0,  0, 115, 11 },
    {  0,  0, 130, 12 },
    {  0,  0, 130, 13 }, /* 13  */
    {  0,  1, 140, 14 },
    {  1,  1, 150, 15 }, /* 15  */
    {  1,  2, 165, 16 },
    {  2,  3, 180, 22 },
    {  2,  3, 200, 25 }, /* 18  */
    {  3,  4, 225, 30 },
    {  3,  5, 250, 35 }, /* 20  */
    {  4,  6, 300, 40 },
    {  4,  6, 350, 45 },
    {  5,  7, 400, 50 },
    {  5,  8, 450, 55 },
    {  6,  9, 525, 60 },  /* 25   */
    {  6,  9, 550, 65 },
    {  7,  10, 575, 70 },
    {  7,  10, 600, 75 },
    {  8,  11, 625, 80 },
    {  8,  11, 650, 85 },  /* 30 */
    {  9,  12, 625, 86 }, /*31*/
    {  9,  12, 630, 87 }, /*32*/
    {  9,  13, 635, 88 }, /*33*/
    {  10, 13, 640, 89 }, /*34*/
    {  10, 14, 645, 90 }, /*35*/
    {  10, 14, 650, 91 }, /*36*/
    {  11, 14, 655, 92 }, /*37*/
    {  11, 15, 660, 93 }, /*38*/
    {  11, 15, 665, 94 }, /*39*/
    {  12, 15, 670, 95 }, /*40*/
    {  12, 16, 675, 95 }, /*41*/
    {  12, 16, 680, 96 }, /*42*/
    {  13, 16, 685, 96 }, /*43*/
    {  13, 17, 690, 97 }, /*44*/
    {  13, 17, 695, 97 }, /*45*/
    {  14, 17, 700, 98 }, /*46*/
    {  14, 18, 705, 98 }, /*47*/
    {  14, 18, 710, 99 }, /*48*/
    {  14, 18, 715, 99 }, /*49*/
    {  15, 19, 720, 100}, /*50*/
    {  15, 19, 720, 100}, /*51*/
    {  15, 19, 725, 101}, /*52*/
    {  15, 19, 725, 101}, /*53*/
    {  16, 20, 725, 102}, /*54*/
    {  16, 20, 730, 102}, /*55*/
    {  16, 20, 730, 103}, /*56*/
    {  16, 20, 730, 103}, /*57*/
    {  17, 21, 735, 104}, /*58*/
    {  17, 21, 735, 104}, /*59*/
    {  17, 21, 735, 104}, /*60*/
    {  18, 19, 740, 105}, /*61*/
    {  18, 19, 740, 105}, /*62*/
    {  18, 19, 740, 105}, /*63*/
    {  18, 19, 740, 106}, /*64*/
    {  19, 20, 745, 106}, /*65*/
    {  19, 20, 745, 106}, /*66*/
    {  19, 20, 745, 107}, /*67*/
    {  19, 20, 745, 107}, /*68*/
    {  19, 21, 750, 107}, /*69*/
    {  20, 21, 750, 108}, /*70*/
    {  20, 21, 750, 108}, /*71*/
    {  20, 21, 750, 108}, /*72*/
    {  20, 22, 755, 109}, /*73*/
    {  20, 22, 755, 109}, /*74*/
    {  21, 22, 755, 109}, /*75*/
    {  21, 22, 755, 110}, /*76*/
    {  21, 23, 760, 110}, /*77*/
    {  21, 23, 760, 110}, /*78*/
    {  21, 23, 760, 110}, /*79*/
    {  22, 23, 760, 111}, /*80*/
    {  22, 24, 770, 111}, /*81*/
    {  22, 24, 770, 111}, /*82*/
    {  22, 24, 770, 112}, /*83*/
    {  22, 24, 770, 112}, /*84*/
    {  23, 25, 775, 112}, /*85*/
    {  23, 26, 775, 113}, /*86*/
    {  23, 27, 775, 113}, /*87*/
    {  23, 28, 775, 113}, /*88*/
    {  23, 29, 780, 114}, /*89*/
    {  24, 30, 780, 114}, /*90*/
    {  24, 31, 780, 115}, /*91*/
    {  25, 32, 780, 115}, /*92*/
    {  25, 33, 785, 116}, /*93*/
    {  26, 34, 785, 116}, /*94*/
    {  26, 35, 785, 117}, /*95*/
    {  27, 36, 785, 117}, /*96*/
    {  27, 37, 790, 118}, /*97*/
    {  28, 38, 790, 118}, /*98*/
    {  29, 39, 795, 119}, /*99*/
    {  30, 40, 800, 120}, /*100*/
    {  30, 40, 801, 120}, /*101*/
    {  30, 40, 802, 121}, /*102*/
    {  31, 41, 803, 121}, /*103*/
    {  31, 41, 804, 122}, /*104*/
    {  31, 41, 805, 122}, /*105*/
    {  32, 42, 806, 123}, /*106*/
    {  32, 42, 807, 123}, /*107*/
    {  32, 42, 808, 124}, /*108*/
    {  33, 43, 809, 124}, /*109*/
    {  33, 43, 810, 125}, /*110*/
    {  33, 43, 811, 125}, /*111*/
    {  34, 44, 812, 126}, /*112*/
    {  34, 44, 813, 126}, /*113*/
    {  34, 44, 814, 127}, /*114*/
    {  35, 45, 815, 127}, /*115*/
    {  35, 45, 816, 128}, /*116*/
    {  35, 45, 817, 128}, /*117*/
    {  36, 46, 818, 129}, /*118*/
    {  36, 46, 819, 129}, /*119*/
    {  36, 47, 820, 130}, /*120*/
    {  36, 47, 820, 130}, /*121*/
    {  37, 47, 820, 130}, /*122*/
    {  37, 47, 820, 130}, /*123*/
    {  37, 48, 821, 131}, /*124*/
    {  37, 48, 821, 131}, /*125*/
    {  38, 48, 821, 131}, /*126*/
    {  38, 48, 822, 131}, /*127*/
    {  38, 49, 822, 132}, /*128*/
    {  38, 49, 822, 132}, /*129*/
    {  39, 49, 822, 132}, /*130*/
    {  39, 49, 823, 132}, /*131*/
    {  39, 50, 823, 133}, /*132*/
    {  39, 50, 823, 133}, /*133*/
    {  40, 50, 823, 133}, /*134*/
    {  40, 50, 824, 133}, /*135*/
    {  40, 51, 824, 134}, /*136*/
    {  40, 51, 824, 134}, /*137*/
    {  40, 51, 824, 134}, /*138*/
    {  41, 51, 825, 134}, /*139*/
    {  41, 52, 825, 135}, /*140*/
    {  41, 52, 825, 135}, /*141*/
    {  41, 52, 825, 135}, /*142*/
    {  42, 52, 826, 135}, /*143*/
    {  42, 53, 826, 136}, /*144*/
    {  42, 53, 826, 136}, /*145*/
    {  42, 53, 826, 136}, /*146*/
    {  43, 53, 827, 136}, /*147*/
    {  43, 54, 827, 137}, /*148*/
    {  43, 54, 827, 137}, /*149*/
    {  43, 54, 827, 137}, /*150*/
    {  43, 54, 828, 137}, /*151*/
    {  44, 55, 828, 138}, /*152*/
    {  44, 55, 828, 138}, /*153*/
    {  44, 55, 828, 138}, /*154*/
    {  44, 55, 829, 138}, /*155*/
    {  44, 55, 829, 139}, /*156*/
    {  45, 56, 829, 139}, /*157*/
    {  45, 56, 829, 139}, /*158*/
    {  45, 56, 829, 139}, /*159*/
    {  45, 56, 830, 140}, /*160*/
    {  45, 56, 830, 140}, /*161*/
    {  46, 57, 830, 140}, /*162*/
    {  46, 57, 830, 140}, /*163*/
    {  46, 57, 830, 140}, /*164*/
    {  46, 57, 831, 141}, /*165*/
    {  46, 57, 831, 141}, /*166*/
    {  47, 58, 831, 141}, /*167*/
    {  47, 58, 831, 141}, /*168*/
    {  47, 58, 831, 141}, /*169*/
    {  47, 58, 832, 142}, /*170*/
    {  47, 58, 832, 142}, /*171*/ 
    {  47, 58, 832, 142}, /*172*/ 
    {  48, 59, 832, 142}, /*173*/
    {  48, 59, 832, 142}, /*174*/
    {  48, 59, 832, 142}, /*175*/
    {  48, 59, 833, 143}, /*176*/
    {  48, 59, 833, 143}, /*177*/
    {  49, 60, 833, 143}, /*178*/
    {  49, 60, 833, 143}, /*179*/
    {  49, 60, 833, 143}, /*180*/
    {  49, 60, 834, 144}, /*181*/
    {  49, 60, 834, 144}, /*182*/
    {  50, 61, 834, 144}, /*183*/
    {  50, 61, 834, 144}, /*184*/
    {  50, 61, 834, 144}, /*185*/
    {  50, 61, 835, 145}, /*186*/
    {  50, 61, 835, 145}, /*187*/
    {  50, 61, 835, 145}, /*188*/
    {  51, 62, 835, 145}, /*189*/
    {  51, 62, 835, 145}, /*190*/
    {  51, 62, 835, 145}, /*191*/
    {  51, 62, 836, 146}, /*192*/
    {  51, 62, 836, 146}, /*193*/
    {  51, 62, 836, 146}, /*194*/
    {  52, 63, 836, 146}, /*195*/
    {  52, 63, 836, 146}, /*196*/
    {  52, 63, 836, 146}, /*197*/
    {  52, 63, 837, 147}, /*198*/
    {  52, 63, 837, 147}, /*199*/
    {  52, 63, 837, 147} /*200*/

};


const	struct	int_app_type	int_app		[201]		=
{
    {  3, -5 },	/*  0 */ /* OP Focus = Adjustment for strengthening, tying, */
    {  5, -5 },	/*  1 */ /* recognizing, and learning from recognizing weaves */
    {  7, -5 },
    {  8, -5 },	/*  3 */
    {  9, -5 },
    { 10, -4 },	/*  5 */
    { 11, -4 },
    { 12, -4 },
    { 13, -4 },
    { 15, -4 },
    { 17, -3 },	/* 10 */
    { 19, -3 },
    { 22, -3 },
    { 25, -3 },
    { 28, -2 },
    { 31, -2 },	/* 15 */
    { 34,  0 },
    { 37,  1 },
    { 40,  2 },	/* 18 */
    { 44,  3 },
    { 49,  4 },	/* 20 */
    { 55,  5 },
    { 60,  6 },
    { 70,  7 },
    { 80,  8 },
    { 85,  9 },	/* 25 */
    { 86,  9 },
    { 87,  10},
    { 88,  10},
    { 89,  11},
    { 90,  12}, /* 30 */
    { 91,  12}, /* 31 */
    { 91,  12}, /* 32 */
    { 92,  13}, /* 33 */
    { 92,  13}, /* 34 */
    { 93,  13}, /* 35 */
    { 93,  14}, /* 36 */
    { 93,  14}, /* 37 */
    { 94,  14}, /* 38 */
    { 94,  15}, /* 39 */
    { 94,  15}, /* 40 */
    { 95,  15}, /* 41 */
    { 95,  16}, /* 42 */
    { 95,  16}, /* 43 */
    { 96,  16}, /* 44 */
    { 96,  17}, /* 45 */
    { 96,  17}, /* 46 */
    { 97,  17}, /* 47 */
    { 97,  18}, /* 48 */
    { 97,  18}, /* 49 */
    { 98,  18}, /* 50 */
    { 98,  19}, /* 51 */
    { 98,  19}, /* 52 */
    { 99,  19}, /* 53 */
    { 99,  19}, /* 54 */
    { 99,  20}, /* 55 */
    {100,  20}, /* 56 */
    {100,  20}, /* 57 */
    {100,  20}, /* 58 */
    {100,  21}, /* 59 */
    {101,  21}, /* 60 */
    {101,  21}, /* 61 */
    {101,  21}, /* 62 */
    {101,  22}, /* 63 */
    {102,  22}, /* 64 */
    {102,  22}, /* 65 */
    {102,  22}, /* 66 */
    {102,  23}, /* 67 */
    {103,  23}, /* 68 */
    {103,  23}, /* 69 */
    {103,  23}, /* 70 */
    {103,  24}, /* 71 */
    {104,  24}, /* 72 */
    {104,  24}, /* 73 */
    {104,  24}, /* 74 */
    {104,  25}, /* 75 */
    {105,  25}, /* 76 */
    {105,  25}, /* 77 */
    {105,  25}, /* 78 */
    {105,  26}, /* 79 */
    {105,  26}, /* 80 */
    {106,  26}, /* 81 */
    {106,  26}, /* 82 */
    {106,  27}, /* 83 */
    {106,  27}, /* 84 */
    {106,  27}, /* 85 */
    {107,  27}, /* 86 */
    {107,  27}, /* 87 */
    {107,  28}, /* 88 */
    {107,  28}, /* 89 */
    {107,  28}, /* 90 */
    {107,  28}, /* 91 */
    {108,  28}, /* 92 */
    {108,  28}, /* 93 */
    {108,  29}, /* 94 */
    {108,  29}, /* 95 */
    {108,  29}, /* 96 */
    {109,  29}, /* 97 */
    {109,  29}, /* 98 */
    {109,  29}, /* 99 */
    {110,  30}, /* 100 */
    {110,  30}, /* 101 */
    {111,  30}, /* 102 */
    {111,  31}, /* 103 */
    {111,  31}, /* 104 */
    {112,  31}, /* 105 */
    {112,  32}, /* 106 */
    {112,  32}, /* 107 */
    {113,  32}, /* 108 */
    {113,  33}, /* 109 */
    {113,  33}, /* 110 */
    {114,  33}, /* 111 */
    {114,  34}, /* 112 */
    {114,  34}, /* 113 */
    {115,  34}, /* 114 */
    {115,  35}, /* 115 */
    {115,  35}, /* 116 */
    {116,  35}, /* 117 */
    {116,  36}, /* 118 */
    {116,  36}, /* 119 */
    {117,  37}, /* 120 */
    {117,  37}, /* 121 */
    {117,  37}, /* 122 */
    {117,  38}, /* 123 */
    {118,  38}, /* 124 */
    {118,  38}, /* 125 */
    {118,  39}, /* 126 */
    {118,  39}, /* 127 */
    {119,  39}, /* 128 */
    {119,  40}, /* 129 */
    {119,  40}, /* 130 */
    {119,  40}, /* 131 */
    {120,  40}, /* 132 */
    {120,  41}, /* 133 */
    {120,  41}, /* 134 */
    {120,  41}, /* 135 */
    {121,  41}, /* 136 */
    {121,  42}, /* 137 */
    {121,  42}, /* 138 */
    {121,  42}, /* 139 */
    {122,  42}, /* 140 */
    {122,  43}, /* 141 */
    {122,  43}, /* 142 */
    {122,  43}, /* 143 */
    {123,  43}, /* 144 */
    {123,  44}, /* 145 */
    {123,  44}, /* 146 */
    {123,  44}, /* 147 */
    {124,  44}, /* 148 */
    {124,  45}, /* 149 */
    {124,  45}, /* 150 */
	{125,  45}, /* 151 */
	{125,  46}, /* 152 */
	{125,  46}, /* 153 */
	{126,  46}, /* 154 */
	{126,  47}, /* 155 */
	{126,  47}, /* 156 */
	{127,  47}, /* 157 */
	{127,  48}, /* 158 */
	{127,  48}, /* 159 */
	{128,  48}, /* 160 */
	{128,  49}, /* 161 */
	{128,  49}, /* 162 */
	{129,  49}, /* 163 */
	{129,  50}, /* 164 */
	{129,  50}, /* 165 */
	{130,  50}, /* 166 */
	{130,  51}, /* 167 */
	{130,  51}, /* 168 */
	{131,  51}, /* 169 */
	{131,  52}, /* 170 */
	{131,  52}, /* 171 */
	{132,  52}, /* 172 */
	{132,  53}, /* 173 */
	{132,  53}, /* 174 */
	{133,  53}, /* 175 */
	{133,  54}, /* 176 */
	{133,  54}, /* 177 */
	{134,  54}, /* 178 */
	{134,  55}, /* 179 */
	{134,  55}, /* 180 */
	{135,  55}, /* 181 */
	{135,  56}, /* 182 */
	{135,  56}, /* 183 */
	{136,  56}, /* 184 */
	{136,  57}, /* 185 */
	{136,  57}, /* 186 */
	{137,  57}, /* 187 */
	{137,  58}, /* 188 */
	{137,  58}, /* 189 */
	{138,  58}, /* 190 */
	{138,  59}, /* 191 */
	{138,  59}, /* 192 */
	{139,  59}, /* 193 */
	{139,  60}, /* 194 */
	{139,  60}, /* 195 */
	{140,  60}, /* 196 */
	{140,  61}, /* 197 */
	{140,  61}, /* 198 */
	{141,  61}, /* 199 */
	{141,  62} /* 200 */
};
const	struct	ref_app_type	ref_app		[201]		=
{
    { -5, -5 },	/*  0 */
    { -5, -5 },	/*  1 */
    { -4, -5 },
    { -4, -5 },	/*  3 */
    { -3, -5 },
    { -3, -4 },	/*  5 */
    { -2, -4 },
    { -2, -4 },
    { -1, -4 },
    { -1, -4 },
    { 0, -3 },	/* 10 */
    { 1, -3 },
    { 1, -3 },
    { 2, -3 },
    { 2, -2 },
    { 2, -2 },	/* 15 */
    { 3,  0 },
    { 3,  1 },
    { 4,  1 },	/* 18 */
    { 5,  2 },
    { 5,  2 },	/* 20 */
    { 5,  3 },
    { 6,  3 },
    { 7,  3 },
    { 7,  4 },
    { 7,  4 },	/* 25 */
    { 8,  4 },
    { 9,  5},
    { 9,  5},
    { 9,  5},
    { 10,  5}, /* 30 */
    { 10,  6}, /* 31 */
    { 11,  6}, /* 32 */
    { 11,  6}, /* 33 */
    { 12,  6}, /* 34 */
    { 12,  7}, /* 35 */
    { 13,  7}, /* 36 */
    { 13,  7}, /* 37 */
    { 14,  7}, /* 38 */
    { 14,  7}, /* 39 */
    { 15,  8}, /* 40 */
    { 15,  8}, /* 41 */
    { 16,  8}, /* 42 */
    { 16,  8}, /* 43 */
    { 17,  8}, /* 44 */
    { 17,  9}, /* 45 */
    { 18,  9}, /* 46 */
    { 18,  9}, /* 47 */
    { 19,  9}, /* 48 */
    { 19,  9}, /* 49 */
    { 20,  10}, /* 50 */
    { 20,  10}, /* 51 */
    { 21,  10}, /* 52 */
    { 21,  10}, /* 53 */
    { 22,  10}, /* 54 */
    { 22,  10}, /* 55 */
    { 23,  11}, /* 56 */
    { 23,  11}, /* 57 */
    { 24,  11}, /* 58 */
    { 24,  11}, /* 59 */
    { 25,  11}, /* 60 */
    { 25,  11}, /* 61 */
    { 26,  12}, /* 62 */
    { 26,  12}, /* 63 */
    { 27,  12}, /* 64 */
    { 27,  12}, /* 65 */
    { 28,  12}, /* 66 */
    { 28,  13}, /* 67 */
    { 29,  13}, /* 68 */
    { 29,  13}, /* 69 */
    { 30,  13}, /* 70 */
    { 30,  14}, /* 71 */
    { 31,  14}, /* 72 */
    { 31,  14}, /* 73 */
    { 32,  14}, /* 74 */
    { 32,  14}, /* 75 */
    { 33,  15}, /* 76 */
    { 33,  15}, /* 77 */
    { 34,  15}, /* 78 */
    { 34,  15}, /* 79 */
    { 35,  15}, /* 80 */
    { 35,  15}, /* 81 */
    { 36,  16}, /* 82 */
    { 36,  16}, /* 83 */
    { 37,  16}, /* 84 */
    { 37,  16}, /* 85 */
    { 38,  16}, /* 86 */
    { 38,  16}, /* 87 */
    { 39,  17}, /* 88 */
    { 39,  17}, /* 89 */
    { 40,  17}, /* 90 */
    { 40,  17}, /* 91 */
    { 41,  18}, /* 92 */
    { 41,  18}, /* 93 */
    { 42,  18}, /* 94 */
    { 42,  18}, /* 95 */
    { 43,  19}, /* 96 */
    { 43,  19}, /* 97 */
    { 44,  19}, /* 98 */
    { 44,  19}, /* 99 */
    { 45,  20}, /* 100 */
    { 45,  20}, /* 101 */
    { 46,  20}, /* 102 */
    { 46,  21}, /* 103 */
    { 47,  21}, /* 104 */
    { 47,  21}, /* 105 */
    { 48,  22}, /* 106 */
    { 48,  22}, /* 107 */
    { 49,  22}, /* 108 */
    { 49,  23}, /* 109 */
    { 50,  23}, /* 110 */
    { 50,  23}, /* 111 */
    { 51,  24}, /* 112 */
    { 51,  24}, /* 113 */
    { 51,  24}, /* 114 */
    { 52,  25}, /* 115 */
    { 52,  25}, /* 116 */
    { 52,  25}, /* 117 */
    { 53,  26}, /* 118 */
    { 53,  26}, /* 119 */
    { 54,  27}, /* 120 */
    { 54,  27}, /* 121 */
    { 54,  27}, /* 122 */
    { 55,  28}, /* 123 */
    { 55,  28}, /* 124 */
    { 55,  28}, /* 125 */
    { 55,  28}, /* 126 */
    { 56,  29}, /* 127 */
    { 56,  29}, /* 128 */
    { 56,  29}, /* 129 */
    { 56,  29}, /* 130 */
    { 57,  30}, /* 131 */
    { 57,  30}, /* 132 */
    { 57,  30}, /* 133 */
    { 57,  30}, /* 134 */
    { 58,  31}, /* 135 */
    { 58,  31}, /* 136 */
    { 58,  31}, /* 137 */
    { 58,  31}, /* 138 */
    { 59,  32}, /* 139 */
    { 59,  32}, /* 140 */
    { 59,  32}, /* 141 */
    { 59,  32}, /* 142 */
    { 60,  33}, /* 143 */
    { 60,  33}, /* 144 */
    { 60,  33}, /* 145 */
    { 60,  33}, /* 146 */
    { 61,  34}, /* 147 */
    { 61,  34}, /* 148 */
    { 61,  34}, /* 149 */
    { 61,  34}, /* 150 */
    { 62,  35}, /* 151 */
    { 62,  35}, /* 152 */
    { 62,  35}, /* 153 */
    { 62,  35}, /* 154 */
    { 63,  36}, /* 155 */
    { 63,  36}, /* 156 */
    { 63,  36}, /* 157 */
    { 64,  37}, /* 158 */
    { 64,  37}, /* 159 */
    { 64,  37}, /* 160 */
    { 65,  38}, /* 161 */
    { 65,  38}, /* 162 */
    { 65,  38}, /* 163 */
    { 66,  39}, /* 164 */
    { 66,  39}, /* 165 */
    { 66,  39}, /* 166 */
    { 67,  40}, /* 167 */
    { 67,  40}, /* 168 */
    { 67,  40}, /* 169 */
    { 68,  41}, /* 170 */
    { 68,  41}, /* 171 */
    { 68,  41}, /* 172 */
    { 69,  42}, /* 173 */
    { 69,  42}, /* 174 */
    { 69,  42}, /* 175 */
    { 70,  43}, /* 176 */
    { 70,  43}, /* 177 */
    { 70,  43}, /* 178 */
    { 71,  44}, /* 179 */
    { 71,  44}, /* 180 */
    { 71,  44}, /* 181 */
    { 72,  45}, /* 182 */
    { 72,  45}, /* 183 */
    { 72,  45}, /* 184 */
    { 73,  46}, /* 185 */
    { 73,  46}, /* 186 */
    { 73,  46}, /* 187 */
    { 74,  47}, /* 188 */
    { 74,  47}, /* 189 */
    { 74,  47}, /* 190 */
    { 75,  48}, /* 191 */
    { 75,  48}, /* 192 */
    { 75,  48}, /* 193 */
    { 76,  49}, /* 194 */
    { 76,  49}, /* 195 */
    { 76,  49}, /* 196 */
    { 77,  50}, /* 197 */
    { 77,  50}, /* 198 */
    { 77,  50}, /* 199 */
    { 77,  50} /* 200 */

};
const	struct	cha_app_type	cha_app		[201]		=
{
    { -5 },	/*  0 */
    { -5 },	/*  1 */
    { -5 },
    { -5 },	/*  3 */
    { -5 },
    { -4 },	/*  5 */
    { -4 },
    { -4 },
    { -4 },
    { -4 },
    { -3 },	/* 10 */
    { -3 },
    { -3 },
    { -3 },
    { -2 },
    { -2 },	/* 15 */
    {  0 },
    {  1 },
    {  1 },	/* 18 */
    {  2 },
    {  2 },	/* 20 */
    {  3 },
    {  3 },
    {  3 },
    {  4 },
    {  4 },	/* 25 */
    {  4 },
    {  5},
    {  5},
    {  5},
    {  5}, /* 30 */
    {  6}, /* 31 */
    {  6}, /* 32 */
    {  6}, /* 33 */
    {  6}, /* 34 */
    {  7}, /* 35 */
    {  7}, /* 36 */
    {  7}, /* 37 */
    {  7}, /* 38 */
    {  7}, /* 39 */
    {  8}, /* 40 */
    {  8}, /* 41 */
    {  8}, /* 42 */
    {  8}, /* 43 */
    {  8}, /* 44 */
    {  9}, /* 45 */
    {  9}, /* 46 */
    {  9}, /* 47 */
    {  9}, /* 48 */
    {  9}, /* 49 */
    {  10}, /* 50 */
    {  10}, /* 51 */
    {  10}, /* 52 */
    {  10}, /* 53 */
    {  10}, /* 54 */
    {  10}, /* 55 */
    {  11}, /* 56 */
    {  11}, /* 57 */
    {  11}, /* 58 */
    {  11}, /* 59 */
    {  11}, /* 60 */
    {  11}, /* 61 */
    {  12}, /* 62 */
    {  12}, /* 63 */
    {  12}, /* 64 */
    {  12}, /* 65 */
    {  12}, /* 66 */
    {  13}, /* 67 */
    {  13}, /* 68 */
    {  13}, /* 69 */
    {  13}, /* 70 */
    {  14}, /* 71 */
    {  14}, /* 72 */
    {  14}, /* 73 */
    {  14}, /* 74 */
    {  14}, /* 75 */
    {  15}, /* 76 */
    {  15}, /* 77 */
    {  15}, /* 78 */
    {  15}, /* 79 */
    {  15}, /* 80 */
    {  15}, /* 81 */
    {  16}, /* 82 */
    {  16}, /* 83 */
    {  16}, /* 84 */
    {  16}, /* 85 */
    {  16}, /* 86 */
    {  16}, /* 87 */
    {  17}, /* 88 */
    {  17}, /* 89 */
    {  17}, /* 90 */
    {  17}, /* 91 */
    {  18}, /* 92 */
    {  18}, /* 93 */
    {  18}, /* 94 */
    {  18}, /* 95 */
    {  19}, /* 96 */
    {  19}, /* 97 */
    {  19}, /* 98 */
    {  19}, /* 99 */
    {  20}, /* 100 */
    {  20}, /* 101 */
    {  20}, /* 102 */
    {  21}, /* 103 */
    {  21}, /* 104 */
    {  21}, /* 105 */
    {  22}, /* 106 */
    {  22}, /* 107 */
    {  22}, /* 108 */
    {  23}, /* 109 */
    {  23}, /* 110 */
    {  23}, /* 111 */
    {  24}, /* 112 */
    {  24}, /* 113 */
    {  24}, /* 114 */
    {  25}, /* 115 */
    {  25}, /* 116 */
    {  25}, /* 117 */
    {  26}, /* 118 */
    {  26}, /* 119 */
    {  27}, /* 120 */
    {  27}, /* 121 */
    {  27}, /* 122 */
    {  27}, /* 123 */
    {  28}, /* 124 */
    {  28}, /* 125 */
    {  28}, /* 126 */
    {  28}, /* 127 */
    {  29}, /* 128 */
    {  29}, /* 129 */
    {  29}, /* 130 */
    {  29}, /* 131 */
    {  30}, /* 132 */
    {  30}, /* 133 */
    {  30}, /* 134 */
    {  30}, /* 135 */
    {  31}, /* 136 */
    {  31}, /* 137 */
    {  31}, /* 138 */
    {  31}, /* 139 */
    {  32}, /* 140 */
    {  32}, /* 141 */
    {  32}, /* 142 */
    {  32}, /* 143 */
    {  33}, /* 144 */
    {  33}, /* 145 */
    {  33}, /* 146 */
    {  33}, /* 147 */
    {  34}, /* 148 */
    {  34}, /* 149 */
    {  34}, /* 150 */
    {  35}, /* 151 */
    {  35}, /* 152 */
    {  35}, /* 153 */
    {  36}, /* 154 */
    {  36}, /* 155 */
    {  36}, /* 156 */
    {  37}, /* 157 */
    {  37}, /* 158 */
    {  37}, /* 159 */
    {  38}, /* 160 */
    {  38}, /* 161 */
    {  38}, /* 162 */
    {  39}, /* 163 */
    {  39}, /* 164 */
    {  39}, /* 165 */
    {  40}, /* 166 */
    {  40}, /* 167 */
    {  40}, /* 168 */
    {  41}, /* 169 */
    {  41}, /* 170 */
    {  41}, /* 171 */
    {  42}, /* 172 */
    {  42}, /* 173 */
    {  42}, /* 174 */
    {  43}, /* 175 */
    {  43}, /* 176 */
    {  43}, /* 177 */
    {  44}, /* 178 */
    {  44}, /* 179 */
    {  44}, /* 180 */
    {  45}, /* 181 */
    {  45}, /* 182 */
    {  45}, /* 183 */
    {  46}, /* 184 */
    {  46}, /* 185 */
    {  46}, /* 186 */
    {  47}, /* 187 */
    {  47}, /* 188 */
    {  47}, /* 189 */
    {  48}, /* 190 */
    {  48}, /* 191 */
    {  48}, /* 192 */
    {  49}, /* 193 */
    {  49}, /* 194 */
    {  49}, /* 195 */
    {  50}, /* 196 */
    {  50}, /* 197 */
    {  50}, /* 198 */
    {  51}, /* 199 */
    {  51} /* 200 */
};



const	struct	ins_app_type	ins_app		[201]		=
{
    { -5, -5 },	/*  0 */
    { -5, -5 },	/*  1 */
    { -5, -5 },
    { -5, -5 },	/*  3 */
    { -5, -5 },
    { -4, -4 },	/*  5 */
    { -4, -4 },
    { -4, -4 },
    { -4, -4 },
    { -4, -4 },
    { -3, -3 },	/* 10 */
    { -3, -3 },
    { -3, -3 },
    { -3, -3 },
    { -2, -2 },
    { -2, -2 },	/* 15 */
    { -1,  0 },
    { -1,  1 },
    {  0,  1 },	/* 18 */
    {  0,  2 },
    {  1,  2 },	/* 20 */
    {  1,  3 },
    {  2,  3 },
    {  2,  3 },
    {  3,  4 },
    {  3,  4 },	/* 25 */
    {  3,  4 },
    {  4,  5},
    {  4,  5},
    {  4,  5},
    {  4,  5}, /* 30 */
    {  5,  6}, /* 31 */
    {  5,  6}, /* 32 */
    {  5,  6}, /* 33 */
    {  5,  6}, /* 34 */
    {  5,  7}, /* 35 */
    {  6,  7}, /* 36 */
    {  6,  7}, /* 37 */
    {  6,  7}, /* 38 */
    {  6,  7}, /* 39 */
    {  6,  8}, /* 40 */
    {  6,  8}, /* 41 */
    {  7,  8}, /* 42 */
    {  7,  8}, /* 43 */
    {  7,  8}, /* 44 */
    {  7,  9}, /* 45 */
    {  7,  9}, /* 46 */
    {  7,  9}, /* 47 */
    {  7,  9}, /* 48 */
    {  8,  9}, /* 49 */
    {  8,  10}, /* 50 */
    {  8,  10}, /* 51 */
    {  8,  10}, /* 52 */
    {  8,  10}, /* 53 */
    {  8,  10}, /* 54 */
    {  8,  10}, /* 55 */
    {  8,  11}, /* 56 */
    {  9,  11}, /* 57 */
    { 10,  11}, /* 58 */
    { 10,  11}, /* 59 */
    { 10,  11}, /* 60 */
    { 10,  11}, /* 61 */
    { 10,  12}, /* 62 */
    { 10,  12}, /* 63 */
    { 10,  12}, /* 64 */
    { 10,  12}, /* 65 */
    { 10,  12}, /* 66 */
    { 10,  13}, /* 67 */
    { 11,  13}, /* 68 */
    { 11,  13}, /* 69 */
    { 11,  13}, /* 70 */
    { 11,  14}, /* 71 */
    { 11,  14}, /* 72 */
    { 11,  14}, /* 73 */
    { 11,  14}, /* 74 */
    { 11,  14}, /* 75 */
    { 11,  15}, /* 76 */
    { 11,  15}, /* 77 */
    { 12,  15}, /* 78 */
    { 12,  15}, /* 79 */
    { 12,  15}, /* 80 */
    { 12,  15}, /* 81 */
    { 12,  16}, /* 82 */
    { 12,  16}, /* 83 */
    { 12,  16}, /* 84 */
    { 12,  16}, /* 85 */
    { 12,  16}, /* 86 */
    { 13,  16}, /* 87 */
    { 13,  17}, /* 88 */
    { 13,  17}, /* 89 */
    { 13,  17}, /* 90 */
    { 13,  17}, /* 91 */
    { 13,  18}, /* 92 */
    { 14,  18}, /* 93 */
    { 14,  18}, /* 94 */
    { 14,  18}, /* 95 */
    { 14,  19}, /* 96 */
    { 14,  19}, /* 97 */
    { 14,  19}, /* 98 */
    { 14,  19}, /* 99 */
    { 15,  20}, /* 100 */
    { 15,  20}, /* 101 */
    { 15,  20}, /* 102 */
    { 16,  21}, /* 103 */
    { 16,  21}, /* 104 */
    { 16,  21}, /* 105 */
    { 17,  22}, /* 106 */
    { 17,  22}, /* 107 */
    { 17,  22}, /* 108 */
    { 18,  23}, /* 109 */
    { 18,  23}, /* 110 */
    { 18,  23}, /* 111 */
    { 19,  24}, /* 112 */
    { 19,  24}, /* 113 */
    { 19,  24}, /* 114 */
    { 20,  25}, /* 115 */
    { 20,  25}, /* 116 */
    { 20,  25}, /* 117 */
    { 21,  26}, /* 118 */
    { 21,  26}, /* 119 */
    { 22,  27}, /* 120 */
    { 22,  27}, /* 121 */
    { 22,  27}, /* 122 */
    { 23,  28}, /* 123 */
    { 23,  28}, /* 124 */
    { 23,  28}, /* 125 */
    { 23,  28}, /* 126 */
    { 24,  29}, /* 127 */
    { 24,  29}, /* 128 */
    { 24,  29}, /* 129 */
    { 24,  29}, /* 130 */
    { 25,  30}, /* 131 */
    { 25,  30}, /* 132 */
    { 25,  30}, /* 133 */
    { 25,  30}, /* 134 */
    { 26,  31}, /* 135 */
    { 26,  31}, /* 136 */
    { 26,  31}, /* 137 */
    { 26,  31}, /* 138 */
    { 27,  32}, /* 139 */
    { 27,  32}, /* 140 */
    { 27,  32}, /* 141 */
    { 27,  32}, /* 142 */
    { 28,  33}, /* 143 */
    { 28,  33}, /* 144 */
    { 28,  33}, /* 145 */
    { 28,  33}, /* 146 */
    { 29,  34}, /* 147 */
    { 29,  34}, /* 148 */
    { 29,  34}, /* 149 */
    { 30,  35}, /* 150 */
    { 30,  35}, /* 151 */
    { 30,  35}, /* 152 */
    { 31,  36}, /* 153 */
    { 31,  36}, /* 154 */
    { 31,  36}, /* 155 */
    { 32,  37}, /* 156 */
    { 32,  37}, /* 157 */
    { 32,  37}, /* 158 */
    { 33,  38}, /* 159 */
    { 33,  38}, /* 160 */
    { 33,  38}, /* 161 */
    { 34,  39}, /* 162 */
    { 34,  39}, /* 163 */
    { 34,  39}, /* 164 */
    { 35,  40}, /* 165 */
    { 35,  40}, /* 166 */
    { 35,  40}, /* 167 */
    { 36,  41}, /* 168 */
    { 36,  41}, /* 169 */
    { 36,  41}, /* 170 */
    { 37,  42}, /* 171 */
    { 37,  42}, /* 172 */
    { 37,  42}, /* 173 */
    { 38,  43}, /* 174 */
    { 38,  43}, /* 175 */
    { 38,  43}, /* 176 */
    { 39,  44}, /* 177 */
    { 39,  44}, /* 178 */
    { 39,  44}, /* 179 */
    { 40,  45}, /* 180 */
    { 40,  45}, /* 181 */
    { 40,  45}, /* 182 */
    { 41,  46}, /* 183 */
    { 41,  46}, /* 184 */
    { 41,  46}, /* 185 */
    { 42,  47}, /* 186 */
    { 42,  47}, /* 187 */
    { 42,  47}, /* 188 */
    { 43,  48}, /* 189 */
    { 43,  48}, /* 190 */
    { 43,  48}, /* 191 */
    { 44,  49}, /* 192 */
    { 44,  49}, /* 193 */
    { 44,  49}, /* 194 */
    { 45,  50}, /* 195 */
    { 45,  50}, /* 196 */
    { 45,  50}, /* 197 */
    { 46,  51}, /* 198 */
    { 46,  51}, /* 199 */
    { 46,  51} /* 200 */
};



const	struct	wis_app_type	wis_app		[201]		=
{
    { 0, 0 },	/*  0 */ /* OP Will = resistance factor vs weaves */
    { 0, 0 },	/*  1 */ /* Channelers get an added bonus to OP Will */
    { 0, 0 },
    { 0, 0 },	/*  3 */
    { 0, 0 },
    { 1, 0 },	/*  5 */
    { 1, 1 },
    { 1, 1 },
    { 1, 1 },
    { 1, 1 },
    { 1, 2 },	/* 10 */
    { 1, 2 },
    { 1, 2 },
    { 1, 3 },
    { 1, 3 },
    { 2, 3 },	/* 15 */
    { 2, 4 },
    { 2, 4 },
    { 3, 4 },	/* 18 */
    { 3, 5 },
    { 3, 5 },	/* 20 */
    { 3, 5 },
    { 4, 6 },
    { 4, 6 },
    { 4, 6 },
    { 5, 7 },	/* 25 */
    { 5, 7 },
    { 5, 8 },
    { 6, 8 },
    { 6, 9 },
    { 6, 9 },	/* 30 */
    { 7, 9 },	/* 31 */
    { 7, 10},	/* 32 */
    { 7, 10},	/* 33 */
    { 7, 10},	/* 34 */
    { 8, 11},	/* 35 */
    { 8, 11},	/* 36 */
    { 8, 11},	/* 37 */
    { 8, 11},	/* 38 */
    { 8, 12},	/* 39 */
    { 9, 13},	/* 40 */
    { 9, 14},	/* 41 */
    { 9, 15},	/* 42 */
    { 9, 16},	/* 43 */
    { 9, 17},	/* 44 */
    { 9, 18},	/* 45 */
    { 9, 19},	/* 46 */
    {10, 20},	/* 47 */
    {10, 21},	/* 48 */
    {10, 22},	/* 49 */
    {10, 23},	/* 50 */
    {10, 24},	/* 51 */
    {11, 24},	/* 52 */
    {11, 24},	/* 53 */
    {11, 25},	/* 54 */
    {11, 25},	/* 55 */
    {11, 25},	/* 56 */
    {12, 26},	/* 57 */
    {12, 26},	/* 58 */
    {12, 26},	/* 59 */
    {12, 26},	/* 60 */
    {12, 27},	/* 61 */
    {13, 27},	/* 62 */
    {13, 27},	/* 63 */
    {13, 27},	/* 64 */
    {13, 29},	/* 65 */
    {13, 29},	/* 66 */
    {14, 29},	/* 67 */
    {14, 29},	/* 68 */
    {14, 30},	/* 69 */
    {14, 30},	/* 70 */
    {14, 30},	/* 71 */
    {15, 30},	/* 72 */
    {15, 31},	/* 73 */
    {15, 31},	/* 74 */
    {15, 31},	/* 75 */
    {15, 31},	/* 76 */
    {16, 32},	/* 77 */
    {16, 32},	/* 78 */
    {16, 32},	/* 79 */
    {16, 32},	/* 80 */
    {16, 32},	/* 81 */
    {17, 33},	/* 82 */
    {17, 33},	/* 83 */
    {17, 33},	/* 84 */
    {17, 33},	/* 85 */
    {17, 33},	/* 86 */
    {18, 33},	/* 87 */
    {18, 34},	/* 88 */
    {18, 34},	/* 89 */
    {18, 34},	/* 90 */
    {18, 34},	/* 91 */
    {18, 34},	/* 92 */
    {18, 34},	/* 93 */
    {18, 34},	/* 94 */
    {19, 35},	/* 95 */
    {19, 35},	/* 96 */
    {19, 35},	/* 97 */
    {19, 35},	/* 98 */
    {19, 35},	/* 99 */
    {20, 40},	/*100 */
    {20, 41},	/*101 */
    {20, 42},	/*102 */
    {21, 43},	/*103 */
    {21, 44},	/*104 */
    {21, 45},	/*105 */
    {22, 46},	/*106 */
    {22, 47},	/*107 */
    {22, 48},	/*108 */
    {23, 49},	/*109 */
    {23, 50},	/*110 */
    {23, 51},	/*111 */
    {24, 52},	/*112 */
    {24, 53},	/*113 */
    {24, 54},	/*114 */
    {25, 55},	/*115 */
    {25, 56},	/*116 */
    {25, 57},	/*117 */
    {26, 58},	/*118 */
    {26, 59},	/*119 */
    {27, 60},	/*120 */
    {27, 60},	/*121 */
    {27, 60},	/*122 */
    {28, 60},	/*123 */
    {28, 61},	/*124 */
    {28, 61},	/*125 */
    {28, 61},	/*126 */
    {29, 61},	/*127 */
    {29, 62},	/*128 */
    {29, 62},	/*129 */
    {29, 62},	/*130 */
    {30, 62},	/*131 */
    {30, 63},	/*132 */
    {30, 63},	/*133 */
    {30, 63},	/*134 */
    {31, 63},	/*135 */
    {31, 64},	/*136 */
    {31, 64},	/*137 */
    {31, 64},	/*138 */
    {32, 64},	/*139 */
    {32, 65},	/*140 */
    {32, 65},	/*141 */
    {32, 65},	/*142 */
    {33, 65},	/*143 */
    {33, 66},	/*144 */
    {33, 66},	/*145 */
    {33, 66},	/*146 */
    {34, 66},	/*147 */
    {34, 67},	/*148 */
    {34, 67},	/*149 */
    {35, 67},	/*150 */
    {35, 68},   /*151 */
    {35, 68},   /*152 */
    {36, 68},   /*153 */
    {36, 69},   /*154 */
    {36, 69},   /*155 */
    {37, 69},   /*156 */
    {37, 70},   /*157 */
    {37, 70},   /*158 */
    {38, 70},   /*159 */
    {38, 71},   /*160 */
    {38, 71},   /*161 */
    {39, 71},   /*162 */
    {39, 72},   /*163 */
    {39, 72},   /*164 */
    {40, 72},   /*165 */
    {40, 73},   /*166 */
    {40, 73},   /*167 */
    {41, 73},   /*168 */
    {41, 74},   /*169 */
    {41, 74},   /*170 */
    {42, 74},   /*171 */
    {42, 75},   /*172 */
    {42, 75},   /*173 */
    {43, 75},   /*174 */
    {43, 76},   /*175 */
    {43, 76},   /*176 */
    {44, 76},   /*177 */
    {44, 77},   /*178 */
    {44, 77},   /*179 */
    {45, 77},   /*180 */
    {45, 78},   /*181 */
    {45, 78},   /*182 */
    {46, 78},   /*183 */
    {46, 79},   /*184 */
    {46, 79},   /*185 */
    {47, 79},   /*186 */
    {47, 80},   /*187 */
    {47, 80},   /*188 */
    {48, 80},   /*189 */
    {48, 81},   /*190 */
    {48, 81},   /*191 */
    {49, 81},   /*192 */
    {49, 82},   /*193 */
    {49, 82},   /*194 */
    {50, 82},   /*195 */
    {50, 83},   /*196 */
    {50, 83},   /*197 */
    {51, 83},   /*198 */
    {51, 84},   /*199 */
    {51, 84}   /*200 */
};




const	struct	dex_app_type	dex_app		[201]		=
{
    {   60 },   /* 0 */
    {   50 },   /* 1 */
    {   50 },
    {   40 },
    {   30 },
    {   20 },   /* 5 */
    {   10 },
    {    0 },
    {    0 },
    {    0 },
    {    0 },   /* 10 */
    {    0 },
    {    0 },
    {    0 },
    {    0 },
    { - 10 },   /* 15 */
    { - 15 },
    { - 20 },
    { - 30 },
    { - 40 },
    { - 50 },   /* 20 */
    { - 60 },
    { - 75 },
    { - 90 },
    { -105 },
    { -120 },   /* 25 */
    { -125 },
    { -130 },
    { -135 },
    { -140 },
    { -145 },  /* 30 */
    { -150 },  /* 31 */
    { -155 },  /* 32 */
    { -160 },  /* 33 */
    { -165 },  /* 34 */
    { -170 },  /* 35 */
    { -175 },  /* 36 */
    { -180 },  /* 37 */
    { -185 },  /* 38 */
    { -187 },  /* 39 */
    { -190 },  /* 40 */
    { -191 },  /* 41 */
    { -192 },  /* 42 */
    { -193 },  /* 43 */
    { -194 },  /* 44 */
    { -195 },  /* 45 */
    { -196 },  /* 46 */
    { -197 },  /* 47 */
    { -198 },  /* 48 */
    { -199 },  /* 49 */
    { -200 },  /* 50 */
    { -200 },  /* 51 */
    { -200 },  /* 52 */
    { -201 },  /* 53 */
    { -201 },  /* 54 */
    { -201 },  /* 55 */
    { -202 },  /* 56 */
    { -202 },  /* 57 */
    { -202 },  /* 58 */
    { -203 },  /* 59 */
    { -203 },  /* 60 */
    { -203 },  /* 61 */
    { -204 },  /* 62 */
    { -204 },  /* 63 */
    { -204 },  /* 64 */
    { -205 },  /* 65 */
    { -205 },  /* 66 */
    { -205 },  /* 67 */
    { -206 },  /* 68 */
    { -206 },  /* 69 */
    { -206 },  /* 70 */
    { -206 },  /* 71 */
    { -207 },  /* 72 */
    { -207 },  /* 73 */
    { -207 },  /* 74 */
    { -207 },  /* 75 */
    { -208 },  /* 76 */
    { -208 },  /* 77 */
    { -208 },  /* 78 */
    { -208 },  /* 79 */
    { -209 },  /* 80 */
    { -209 },  /* 81 */
    { -209 },  /* 82 */
    { -209 },  /* 83 */
    { -210 },  /* 84 */
    { -210 },  /* 85 */
    { -210 },  /* 86 */
    { -210 },  /* 87 */
    { -211 },  /* 88 */
    { -211 },  /* 89 */
    { -211 },  /* 90 */
    { -211 },  /* 91 */
    { -212 },  /* 92 */
    { -212 },  /* 93 */
    { -212 },  /* 94 */
    { -212 },  /* 95 */
    { -213 },  /* 96 */
    { -213 },  /* 97 */
    { -214 },  /* 98 */
    { -214 },  /* 99 */
    { -215 },   /*100 */
    { -215 },   /*101 */
    { -216 },   /*102 */
    { -216 },   /*103 */
    { -217 },   /*104 */
    { -217 },   /*105 */
    { -218 },   /*106 */
    { -218 },   /*107 */
    { -219 },   /*108 */
    { -219 },   /*109 */
    { -220 },   /*110 */
    { -221 },   /*111 */
    { -222 },   /*112 */
    { -223 },   /*113 */
    { -224 },   /*114 */
    { -225 },   /*115 */
    { -226 },   /*116 */
    { -227 },   /*117 */
    { -228 },   /*118 */
    { -229 },   /*119 */
    { -230 },   /*120 */
    { -231 },   /*121 */
    { -231 },   /*122 */
    { -232 },   /*123 */
    { -232 },   /*124 */
    { -233 },   /*125 */
    { -233 },   /*126 */
    { -234 },   /*127 */
    { -234 },   /*128 */
    { -235 },   /*129 */
    { -235 },   /*130 */
    { -236 },   /*131 */
    { -236 },   /*132 */
    { -236 },   /*133 */
    { -237 },   /*134 */
    { -237 },   /*135 */
    { -237 },   /*136 */
    { -238 },   /*137 */
    { -238 },   /*138 */
    { -238 },   /*139 */
    { -239 },   /*140 */
    { -239 },   /*141 */
    { -239 },   /*142 */
    { -240 },   /*143 */
    { -240 },   /*144 */
    { -240 },   /*145 */
    { -241 },   /*146 */
    { -241 },   /*147 */
    { -241 },   /*148 */
    { -242 },   /*149 */
    { -242 },   /*150 */
    { -242 },   /*151 */
    { -243 },   /*152 */
    { -243 },   /*153 */
    { -243 },   /*154 */
    { -244 },   /*155 */
    { -244 },   /*156 */
    { -244 },   /*157 */
    { -245 },   /*158 */
    { -245 },   /*159 */
    { -245 },   /*160 */
    { -246 },   /*161 */
    { -246 },   /*162 */
    { -246 },   /*163 */
    { -247 },   /*164 */
    { -247 },   /*165 */
    { -247 },   /*166 */
    { -248 },   /*167 */
    { -248 },   /*168 */
    { -248 },   /*169 */
    { -249 },   /*170 */
    { -249 },   /*171 */
    { -249 },   /*172 */
    { -250 },   /*173 */
    { -250 },   /*174 */
    { -250 },   /*175 */
    { -251 },   /*176 */
    { -251 },   /*177 */
    { -251 },   /*178 */
    { -252 },   /*179 */
    { -252 },   /*180 */
    { -252 },   /*181 */
    { -253 },   /*182 */
    { -253 },   /*183 */
    { -253 },   /*184 */
    { -254 },   /*185 */
    { -254 },   /*186 */
    { -254 },   /*187 */
    { -255 },   /*188 */
    { -255 },   /*189 */
    { -255 },   /*190 */
    { -256 },   /*191 */
    { -256 },   /*192 */
    { -256 },   /*193 */
    { -257 },   /*194 */
    { -257 },   /*195 */
    { -257 },   /*196 */
    { -258 },   /*197 */
    { -258 },   /*198 */
    { -258 },   /*199 */
    { -259 }   /*200 */
};

const	struct	con_app_type	con_app		[201]		=
{
    { -4, 20, 0  },   /*  0 */ /* OP Stam = Rounds can hold the source */
    { -3, 25, 1  },   /*  1 */
    { -2, 30, 2  },
    { -2, 35, 4  },	  /*  3 */
    { -1, 40, 6  },
    { -1, 45, 8  },   /*  5 */
    { -1, 50, 10 },
    {  0, 55, 12 },
    {  0, 60, 14 },
    {  0, 65, 16 },
    {  0, 70, 18 },   /* 10 */
    {  0, 75, 20 },
    {  0, 80, 22 },
    {  0, 85, 24 },
    {  0, 88, 26 },
    {  1, 90, 28 },   /* 15 */
    {  2, 95, 30 },
    {  2, 97, 32 },
    {  3, 99, 34 },   /* 18 */
    {  3, 99, 36 },
    {  4, 99, 38 },   /* 20 */
    {  4, 99, 40 },
    {  5, 99, 42 },
    {  6, 99, 44 },
    {  7, 99, 46 },
    {  8, 99, 48 },    /* 25 */
    {  9, 99, 50 },
    {  9, 99, 52 },
    {  10, 99, 54 },
    {  10, 99, 56 },
    {  11, 99, 58 }, /* 30 */
    {  11, 99, 59 }, /* 31 */
    {  11, 99, 60 }, /* 32 */
    {  12, 99, 61 }, /* 33 */
    {  12, 99, 62 }, /* 34 */
    {  12, 99, 63 }, /* 35 */
    {  13, 99, 64 }, /* 36 */
    {  13, 99, 65 }, /* 37 */
    {  13, 99, 66 }, /* 38 */
    {  13, 99, 67 }, /* 39 */
    {  14, 99, 68 }, /* 40 */
    {  14, 99, 69 }, /* 41 */
    {  14, 99, 70 }, /* 42 */
    {  14, 99, 71 }, /* 43 */
    {  14, 99, 72 }, /* 44 */
    {  15, 99, 73 }, /* 45 */
    {  15, 99, 74 }, /* 46 */
    {  15, 99, 75 }, /* 47 */
    {  15, 99, 76 }, /* 48 */
    {  15, 99, 77 }, /* 49 */
    {  16, 99, 78 }, /* 50 */
    {  16,100, 78 }, /* 51 */
    {  16,100, 78 }, /* 52 */
    {  16,100, 79 }, /* 53 */
    {  16,100, 79 }, /* 54 */
    {  17,100, 79 }, /* 55 */
    {  17,100, 79 }, /* 56 */
    {  17,100, 80 }, /* 57 */
    {  17,100, 80 }, /* 58 */
    {  18,100, 80 }, /* 59 */
    {  18,100, 80 }, /* 60 */
    {  18,101, 81 }, /* 61 */
    {  18,101, 81 }, /* 62 */
    {  18,101, 81 }, /* 63 */
    {  19,101, 81 }, /* 64 */
    {  19,101, 82 }, /* 65 */
    {  19,101, 82 }, /* 66 */
    {  19,101, 82 }, /* 67 */
    {  19,101, 82 }, /* 68 */
    {  20,101, 83 }, /* 69 */
    {  20,101, 83 }, /* 70 */
    {  20,102, 83 }, /* 71 */
    {  20,102, 83 }, /* 72 */
    {  20,102, 84 }, /* 73 */
    {  21,102, 84 }, /* 74 */
    {  21,102, 84 }, /* 75 */
    {  21,102, 84 }, /* 76 */
    {  21,102, 85 }, /* 77 */
    {  21,102, 85 }, /* 78 */
    {  21,102, 85 }, /* 79 */
    {  22,102, 85 }, /* 80 */
    {  22,103, 85 }, /* 81 */
    {  22,103, 86 }, /* 82 */
    {  22,103, 86 }, /* 83 */
    {  22,103, 86 }, /* 84 */
    {  22,103, 86 }, /* 85 */
    {  23,103, 86 }, /* 86 */
    {  23,103, 87 }, /* 87 */
    {  23,103, 87 }, /* 88 */
    {  23,103, 87 }, /* 89 */
    {  23,104, 87 }, /* 90 */
    {  23,104, 87 }, /* 91 */
    {  23,104, 88 }, /* 92 */
    {  24,104, 88 }, /* 93 */
    {  24,104, 88 }, /* 94 */
    {  24,104, 88 }, /* 95 */
    {  24,104, 88 }, /* 96 */
    {  24,104, 89 }, /* 97 */
    {  24,104, 89 }, /* 98 */
    {  24,104, 89 }, /* 99 */
    {  25,105, 90 },  /*100 */
    {  25,105, 90 },  /*101 */
    {  25,105, 90 },  /*102 */
    {  26,106, 90 },  /*103 */
    {  26,106, 91 },  /*104 */
    {  26,106, 91 },  /*105 */
    {  27,107, 91 },  /*106 */
    {  27,107, 91 },  /*107 */
    {  27,107, 92 },  /*108 */
    {  28,108, 92 },  /*109 */
    {  28,108, 92 },  /*110 */
    {  28,108, 92 },  /*111 */
    {  29,109, 93 },  /*112 */
    {  29,109, 93 },  /*113 */
    {  29,109, 93 },  /*114 */
    {  29,110, 93 },  /*115 */
    {  30,110, 94 },  /*116 */
    {  30,110, 94 },  /*117 */
    {  30,111, 94 },  /*118 */
    {  30,111, 94 },  /*119 */
    {  31,112, 95 },  /*120 */
    {  31,112, 95 },  /*121 */
    {  31,112, 95 },  /*122 */
    {  31,113, 95 },  /*123 */
    {  31,113, 95 },  /*124 */
    {  32,113, 96 },  /*125 */
    {  32,114, 96 },  /*126 */
    {  32,114, 96 },  /*127 */
    {  32,114, 96 },  /*128 */
    {  32,114, 96 },  /*129 */
    {  33,115, 96 },  /*130 */
    {  33,115, 97 },  /*131 */
    {  33,115, 97 },  /*132 */
    {  33,115, 97 },  /*133 */
    {  33,116, 97 },  /*134 */
    {  34,116, 97 },  /*135 */
    {  34,116, 97 },  /*136 */
    {  34,116, 98 },  /*137 */
    {  34,117, 98 },  /*138 */
    {  34,117, 98 },  /*139 */
    {  35,117, 98 },  /*140 */
    {  35,117, 98 },  /*141 */
    {  35,118, 98 },  /*142 */
    {  35,118, 99 },  /*143 */
    {  35,118, 99 },  /*144 */
    {  36,118, 99 },  /*145 */
    {  36,119, 99 },  /*146 */
    {  36,119, 99 },  /*147 */
    {  36,119, 99 },  /*148 */
    {  36,119, 99 },  /*149 */
    {  37,120, 100 }, /*150 */
	{  37,120, 100 }, /*151 */
	{  37,120, 100 }, /*152 */
	{  37,120, 100 }, /*153 */
	{  38,121, 101 }, /*154 */
	{  38,121, 101 }, /*155 */
	{  38,121, 101 }, /*156 */
	{  38,121, 101 }, /*157 */
	{  39,122, 102 }, /*158 */
	{  39,122, 102 }, /*159 */
	{  39,122, 102 }, /*160 */
	{  39,122, 102 }, /*161 */
	{  40,123, 103 }, /*162 */
	{  40,123, 103 }, /*163 */
	{  40,123, 103 }, /*164 */
	{  40,123, 103 }, /*165 */
	{  41,124, 104 }, /*166 */
	{  41,124, 104 }, /*167 */
	{  41.124, 104 }, /*168 */
	{  41,124, 104 }, /*169 */
	{  42,125, 105 }, /*170 */
	{  42,125, 105 }, /*171 */
	{  42,125, 105 }, /*172 */
	{  42,125, 105 }, /*173 */
	{  43,126, 106 }, /*174 */
	{  43,126, 106 }, /*175 */
	{  43,126, 106 }, /*176 */
	{  43,126, 106 }, /*177 */
	{  44,127, 107 }, /*178 */
	{  44,127, 107 }, /*179 */
	{  44,127, 107 }, /*180 */
	{  44,127, 107 }, /*181 */
	{  45,128, 108 }, /*182 */
	{  45,128, 108 }, /*183 */
	{  45,128, 108 }, /*184 */
	{  45,128, 108 }, /*185 */
	{  46,129, 109 }, /*186 */
	{  46,129, 109 }, /*187 */
	{  46,129, 109 }, /*188 */
	{  46,129, 109 }, /*189 */
	{  47,130, 110 }, /*190 */
	{  47,130, 110 }, /*191 */
	{  47,130, 110 }, /*192 */
	{  47,130, 110 }, /*193 */
	{  48,131, 111 }, /*194 */
	{  48,131, 111 }, /*195 */
	{  48,131, 111 }, /*196 */
	{  48,131, 111 }, /*197 */
	{  49,132, 112 }, /*198 */
	{  49,132, 112 }, /*199 */
	{  49,132, 112 } /*200 */
};
