#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "aww.h"

char moneytypes[4][6]		=	{"copper", "silver", "marks", "gold"};
char MT_long[4][15]	=	{"copper pennies", "silver pennies", "silver marks", "gold marks"};
int moneyvalues[4] = {1,10,100,1000};

void do_exchange( CHAR_DATA *ch, char *argument )
{
	int  moneyvalues[4]	=	{1,10,100,1000};
	char arg1[MIL];
	char arg2[MIL];
	char arg3[MIL];
	long amount=0, change=0;
	int arg2i = -1, arg3i = -1, remainder,i;

	if (IS_NPC(ch))
	{
		stc("Dont use banks when playing a mob!\n\r",ch);
		return;
	}
	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
		stc("You are not in a bank.\n\r",ch);
		return;
	}

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );

	if ( arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0' )
	{
		stc("Invalid Syntax:\n\r",ch);
		stc("Exchange <amount> <coin type> <coin type>\n\r",ch);
		stc("Coin types are: 'copper', 'silver', 'marks' and 'gold'.\n\r",ch);
		stc("Example:\n\r",ch);
		stc("Exchange 100 silver mark\n\r",ch);
		stc("This would exchange 100 silver pennies into 10 silver marks.\n\r",ch);
		return;
	}
/* Can't this case be added by the errors above? Or do you first have to know whether arg1
exist before you can test it? Also Is it possible that arg1 = '\0' while arg3 has a value,
or would testing arg3 be enough?*/
	if ( !is_number(arg1))
	{
		if (!str_prefix(arg1, "all") && !str_prefix(arg2, "to"))
		{
			if (!str_prefix(arg3, "gold"))
			{
				stc("You have",ch);
				for(i=0;i<3;i++)
				{
					ch->money[i+1][0] += ch->money[i][0]/10;
					ch->money[i][0] = ch->money[i][0]%10;
					ptc(ch, " %d %s,", ch->money[i][0], MT_long[i]);
				}
				ptc(ch, " and %d %s.\n\r", ch->money[3][0], MT_long[3]);
				return;
			}
			else if (!str_prefix(arg3, "copper"))
			{
				for(i=3;i>0;i--)
				{
					ch->money[i-1][0] += ch->money[i][0]*10;
					ch->money[i][0] = 0;
				}
				ptc(ch, "You have %d %s.\n\r", ch->money[0][0], MT_long[0]);
				return;
			}
		}
		stc("Invalid Syntax:\n\r",ch);
		stc("Exchange <amount> <coin type> <coin type>\n\r",ch);
		stc("Coin types are: 'copper', 'silver', 'marks' and 'gold'.\n\r",ch);
		stc("Example:\n\r",ch);
		stc("Exchange 100 silver mark\n\r",ch);
		stc("This would exchange 100 silver pennies into 10 silver marks.\n\r",ch);
		stc("You can also use <{Cexc{xhange {Ca{xll {Ct{xo {Cg{xold> or...\n\r",ch);
		stc("<{Cexc{xhange {Ca{xll {Ct{xo {Cc{xopper> or...\n\r",ch);
		return;
	}

	amount = atoi(arg1);

	for(i=0;i<4;i++)
	{
		if ( !str_prefix( arg2, moneytypes[i]) )
		{
			arg2i = i;
		}
		if ( !str_prefix( arg3, moneytypes[i]) )
		{
			arg3i = i;
		}
	}
/* Now you can point to the correct cointypes by arg2i and arg3i */
	if (arg2i == -1 || arg3i == -1)
	{
		stc("Invalid Syntax, invalid moneytype:\n\r",ch);
		stc("Exchange <amount> <coin type> <coin type>\n\r",ch);
		stc("Coin types are: 'copper', 'silver', 'marks' and 'gold'.\n\r",ch);
		stc("Example:\n\r",ch);
		stc("Exchange 100 silver mark\n\r",ch);
		stc("This would exchange 100 silver pennies into 10 silver marks.\n\r",ch);
		stc("You can also use <{Cexc{xhange {Ca{xll {Ct{xo {Cg{xold> or...\n\r",ch);
		stc("<{Cexc{xhange {Ca{xll {Ct{xo {Cc{xopper> or...\n\r",ch);
		return;
	}

	if (arg2i == arg3i)
	{
		stc("That would be pointless.\n\r",ch);
		return;
	}
	else
	{
		if (ch->money[arg2i][0] < amount)
		{
			ptc(ch, "You dont have %ld %s, you only have %ld.\n\r", amount, MT_long[arg2i], ch->money[arg2i][0]);
			return;
		}
		if (arg3i < arg2i)
		{
			change = (amount * moneyvalues[arg2i])/moneyvalues[arg3i];
			ch->money[arg3i][0] += change;
			ch->money[arg2i][0] -= amount;
			ptc(ch, "Change from %ld %s is %ld %s.\n\r", amount, MT_long[arg2i], change, MT_long[arg3i]);
			return;
		}
		if (arg3i > arg2i)
		{
			change = (amount * moneyvalues[arg2i]) / moneyvalues[arg3i];
			remainder = amount % (moneyvalues[arg3i] / moneyvalues[arg2i]);
			ptc(ch, "Change from %ld %s is %ld %s.\n\r", amount, MT_long[arg2i], change, MT_long[arg3i]);
			ch->money[arg3i][0] +=change;
			ch->money[arg2i][0] -= (amount-remainder);
			if (remainder > 0)
			{
				ptc(ch, "You get %d %s back.\n\r", remainder, MT_long[arg2i]);
			}
			return;
		}
	}
}


void do_balance(CHAR_DATA *ch, char *argument)
{
	if (IS_NPC(ch))
	{
	stc("Only players have bank accounts.\n\r",ch);
	return;
	}

	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
	stc("You are not in a bank.\n\r",ch);
	return;
	}
	affect_strip( ch, gsn_sneak );
	affect_strip( ch, gsn_hide );
	affect_strip( ch, gsn_invis );
	stc( "Coins in the bank:\n\r", ch );
	ptc( ch, "{cCopper Pennies: {C%7ld{x\n\r", ch->money[0][1] );
	ptc( ch, "{cSilver Pennies: {C%7ld{x\n\r", ch->money[1][1] );
	ptc( ch, "{cSilver Marks:   {C%7ld{x\n\r", ch->money[2][1] );
	ptc( ch, "{cGold Marks:     {C%7ld{x\n\r", ch->money[3][1] );
	/*stc( "Coins in the bank		and on person:\n\r", ch );
	ptc( ch, "{cCopper Pennies: {C%7ld{x	{C%7ld{x\n\r", ch->money[0][1], ch->money[0][0] );
	ptc( ch, "{cSilver Pennies: {C%7ld{x	{C%7ld{x\n\r", ch->money[1][1], ch->money[1][0] );
	ptc( ch, "{cSilver Marks:   {C%7ld{x	{C%7ld{x\n\r", ch->money[2][1], ch->money[2][0] );
	ptc( ch, "{cGold Marks:     {C%7ld{x	{C%7ld{x\n\r", ch->money[3][1], ch->money[3][0] );*/
	return;
}

void do_withdraw(CHAR_DATA *ch, char *argument)
{
	long amount;
	int arg2i = -1,i;
	char arg[MIL];
	char arg2[MIL];

	if (IS_NPC(ch))
	{
		stc("You don't have a bank account.\n\r",ch);
		return;
	}

	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
		stc("Maybe you should find a bank to withdraw from.\n\r",ch);
		return;
	}

	argument = one_argument( argument, arg );
	argument = one_argument( argument, arg2 );

	if (!str_prefix(arg,"all"))
	{
		for(i=0;i<4;i++)
		{
			ch->money[i][0] += ch->money[i][1];
			ch->money[i][1] = 0;
		}
		stc("You drain your bankaccount.\n\r",ch);
		act("A pretty bank clerk looks shocked when $n asks for all $s money back and looks glum when the money is returned.",ch,NULL,NULL,TO_ROOM);
		return;
	}

	if ( arg[0] == '\0' || arg2[0] == '\0' )
	{
		stc( "Withdraw how much?\n\r", ch );
		stc( "Withdraw # copper\n\r", ch );
		stc( "Withdraw # silver\n\r", ch );
		stc( "Withdraw # mark\n\r", ch );
		stc( "Withdraw # gold\n\r", ch );
		stc("Or withdraw all\n\r",ch);
		return;
	}

	if ( !is_number(arg) )
	{
		stc( "Withdraw how much?\n\r", ch );
		stc( "Withdraw # copper\n\r", ch );
		stc( "Withdraw # silver\n\r", ch );
		stc( "Withdraw # mark\n\r", ch );
		stc( "Withdraw # gold\n\r", ch );
		stc("Or withdraw all\n\r",ch);
		return;
	}

	affect_strip( ch, gsn_sneak );
	affect_strip( ch, gsn_hide );
	affect_strip( ch, gsn_invis );

	amount = labs(atol(arg));

	for(i=0;i<4;i++)
	{
		if ( !str_prefix( arg2, moneytypes[i]) )
		{
			arg2i = i;
		}
	}

	if (arg2i == -1)
	{
		stc( "Withdraw how much?\n\r", ch );
		stc( "Withdraw # copper\n\r", ch );
		stc( "Withdraw # silver\n\r", ch );
		stc( "Withdraw # mark\n\r", ch );
		stc( "Withdraw # gold\n\r", ch );
		return;
	}
	if ( ch->money[arg2i][1] < amount )
	{
		ptc(ch,"You dont have %ld %s in the bank.\n\r",amount,MT_long[arg2i]);
		act("$n steps up to the clerk but realizes, $s bankaccount has dried up.", ch, NULL, NULL, TO_ROOM);
		return;
	}

	ch->money[arg2i][1] -= amount;
	ch->money[arg2i][0] += amount;

    ptc(ch, "Here are your %ld %s, have a nice day.\n\r", amount, MT_long[arg2i]);
	act("$n gets some coin from the clerk, who writes something down on her papers.",ch,NULL,NULL,TO_ROOM);
}

void do_deposit(CHAR_DATA *ch, char *argument)
{
	long amount;
	int arg2i = -1, i=0;
	char arg[MIL];
	char arg2[MIL];

	if (IS_NPC(ch))
	{
	stc("You don't have a bank account.\n\r",ch);
	return;
	}

	if (!IS_SET(ch->in_room->room_flags, ROOM_BANK))
	{
	stc("Maybe you should find a bank to deposit money into.\n\r",ch);
	return;
	}

	argument = one_argument( argument, arg );
	argument = one_argument( argument, arg2 );

	if (!str_prefix(arg,"all"))
	{
		for(i=0;i<4;i++)
		{
			ch->money[i][1] += ch->money[i][0];
			ch->money[i][0] = 0;
		}
		stc("You bank all your savings.\n\r",ch);
		act("$n hands the clerk all $s money. Oh wait, yes, there, $e nearly forgot a copper penny.",ch,NULL,NULL,TO_ROOM);
		return;
	}

	if ( arg[0] == '\0' || arg2[0] == '\0' )
	{
		stc( "Deposit how much?\n\r", ch );
		stc( "Deposit # copper\n\r", ch );
		stc( "Deposit # silver\n\r", ch );
		stc( "Deposit # mark\n\r", ch );
		stc( "Deposit # gold\n\r", ch );
		stc( "Or use deposit all\n\r",ch);
		return;
	}

	if ( !is_number(arg) )
	{
		stc( "Deposit how much?\n\r", ch );
		stc( "Deposit # copper\n\r", ch );
		stc( "Deposit # silver\n\r", ch );
		stc( "Deposit # mark\n\r", ch );
		stc( "Deposit # gold\n\r", ch );
		stc( "Or use deposit all\n\r",ch);
		return;
	}

	affect_strip( ch, gsn_sneak );
	affect_strip( ch, gsn_hide );
	affect_strip( ch, gsn_invis );

	amount = labs(atol(arg));

	for(i=0;i<4;i++)
	{
		if ( !str_prefix( arg2, moneytypes[i]) )
		{
			arg2i = i;
		}
	}

	if (arg2i == -1)
	{
		stc( "Deposit how much?\n\r", ch );
		stc( "Deposit # copper\n\r", ch );
		stc( "Deposit # silver\n\r", ch );
		stc( "Deposit # mark\n\r", ch );
		stc( "Deposit # gold\n\r", ch );
		return;
	}
	if ( ch->money[arg2i][0] < amount )
	{
		ptc(ch,"You have only %d %s.\n\r",ch->money[arg2i][0],MT_long[arg2i]);
		act("$n tries to cheat on the bank clerk, but is spotted. Shame you, $n!",ch,NULL,NULL,TO_ROOM);
		return;
	}

	ch->money[arg2i][0] -= amount;
	ch->money[arg2i][1] += amount;

    ptc(ch, "%ld %s deposited, please come again.\n\r", amount, MT_long[arg2i]);
	/*act("$n steps up to the teller window.",ch,NULL,NULL,TO_ROOM);*/
	act("$n hands the clerk some money and looks happy when checking $s balance.",ch,NULL,NULL,TO_ROOM);
}
