/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"

int BATTLE_AREA = 0;
int BATTLE_FIRST;

void talk_battle (char *argument)
{
    DESCRIPTOR_DATA *d;
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *original;

    sprintf (buf,"{w[{RW{ra{RR{w]:: %s{x\n\r", argument);

    for (d = descriptor_list; d != NULL; d = d->next)
    {
        original = d->original ? d->original : d->character; /* if switched */
        if ( d->connected == CON_PLAYING && IS_SET(d->character->auto_flags,AUTO_WAR) )
        send_to_char( buf , original );

    }
}

/*Now we need a way to let imms talk on it */
void do_bchat( CHAR_DATA *ch, char *argument )
{
    talk_battle( argument );
    return;
}

void do_bopen(CHAR_DATA *ch, char* argument )
{
	int   upper;
	int   lower;
	char  buf[MAX_STRING_LENGTH];
	char arg1[MIL];
	char arg2[MIL];
	int   number;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( IS_NPC( ch ) ) /*mobs can't open battles */
	return;

	lower = 0;
	upper = 0;
	number = 0;

	if ( arg1[0] == '\0' || arg2[0] == '\0' )
	{
		stc("Syntax:\n\r",ch);
		stc("BOpen <Lower Level> <Upper Level>\n\r",ch);
		stc("BOpen 1 250 will start a campain in Lugard for levels 1 to 250.\n\r",ch);
		return;
	}

/*
	if ( !is_number( arg1 ) )
	{
		stc("Arg1 must be the area vnum.\n\r",ch);
		return;
	}

	vnum = atoi( arg1 );

	if ( vnum == 17 || vnum == 8 || vnum == 22 || vnum == 39
	|| vnum == 21 || vnum == 30 || vnum == 43 || vnum == 49
	|| vnum == 19 )
	;
	else
	{
		stc("Invalid area vnum.\n\r",ch);
		stc("Only: 17 8 22 39 21 30 43 49 19\n\r",ch);
		return;
	}
    for ( pArea = area_first; pArea; pArea = pArea->next )
    {
		if ( pArea->vnum == vnum )
		{
			ptc( ch, "%s has been readied for the campaign.\n\r", pArea->name );
			found_area = TRUE;
			break;
		}
    }

    if ( !found_area )
    {
	    stc( "No such area!\n\r", ch );
	    return;
	}
*/
	if ( is_number( arg1 ) && is_number( arg2 ) )
	{
		lower = atoi( arg1 );
		upper = atoi( arg2 );
	}
	else
	{
		stc("Syntax is: bopen <level 1> <level 2>.", ch );
		return;
	}

	BATTLE_AREA = 135;
	BATTLE_FIRST = 30000;
	ptc( ch, "BATTLE_FIRST set to %d, %d.\n\r", BATTLE_AREA, BATTLE_FIRST );
	battle->open = TRUE;
	battle->level1 = lower;
	battle->level2 = upper;
	sprintf( buf,"{wA campaign is now open for levels {R%d {r- {R%d{w in the Battleground.{x\n\r",lower,upper);
	talk_battle( buf );
	return;
}

/*Now that we've opened a battle , we need a way to close it */
void do_bclose (CHAR_DATA *ch, char *argument)
{
	char            buf[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;
	AREA_DATA       *pArea;
	int             place;
	int             lvnum;
	int             uvnum;
	int             avnum = BATTLE_AREA;
	bool            found_area = FALSE;

	if ( IS_NPC( ch ) ) /*Since mobs can't open battles, let's not let them close battles*/
	return;

	avnum = BATTLE_AREA;

	if ( avnum == 0 )
	{
		bugf( "BATTLE:: Battle vnum is 0.", 0 );
		return;
	}
   /*actual closing of battle and scattering of players */

	battle->open = FALSE;
	sprintf( buf,"The gathering of the armies is done!\n\r" );
	talk_battle( buf );

    for ( pArea = area_first; pArea; pArea = pArea->next )
    {
		if ( pArea->vnum == avnum )
		{
			found_area = TRUE;
			break;
		}
	}
	if ( !found_area )
	{
		bugf( "BATTLE:: Battle Area Not Found.", 0 );
		return;
	}
	/*
	lvnum = pArea->min_vnum;
	uvnum = pArea->max_vnum;
	*/
	lvnum = 30000;
	uvnum = 30250;

	BATTLE_FIRST = lvnum;

	for( ch = char_list; ch; ch = ch->next)
	{
		if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
		{
		if( !IS_SET( ch->war_flags, WAR_PK ) )
			SET_BIT( ch->war_flags, WAR_PK );
		place = number_range(lvnum, uvnum);
		/*location = get_room_index( place );*/
		if ( ( location = get_room_index( place ) ) == NULL )
		{
			bugf( "BATTLE:: Place (%d) is NULL", place );
			return;
		}
		char_from_room( ch );                   /*Randomly drop players about*/
		char_to_room( ch, location );           /*the battle field, the numbers*/
		}                                        /*can be changed to suit your*/
	}                                          /*battle area.*/

	battle->running = TRUE;
	return;
}

/*Just in case we need it*/
void do_bstop(CHAR_DATA *ch, char * argument)
{
	char            buf[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;
	int             place;

	if(IS_NPC( ch ) )
	return;
	place = 3001;
	location = get_room_index( place );

	if( !battle->running && !battle->open )
	{
	send_to_char( "There is no battle going on that you can stop", ch );
	return;
	}

	sprintf( buf,"{wThe campaign has been stopped!{x\n\r" );
	talk_battle( buf );

	for(ch = char_list; ch; ch = ch->next )
	{
		if(IS_SET( ch->war_flags, WAR_BATTLE ) )
		{
	        /* Ahapin - added this check to stop fights in progress */
			if ( is_fighting(ch))
			stop_all_fighting( ch);

			REMOVE_BIT( ch->war_flags, WAR_BATTLE );
			char_from_room( ch );
			char_to_room( ch, location );
		}
	}
	battle->running = FALSE;
	battle->open = FALSE;
	return;
}
/*Here's a little tidbit just for fun
 *Add players to battle regardless of level */
void do_badd( CHAR_DATA * ch, char * argument )
{
	CHAR_DATA        *victim;
	CHAR_DATA        *rch;
	ROOM_INDEX_DATA  *location;
	int               place;
	char              arg1[MAX_INPUT_LENGTH];
	char              buf[MAX_STRING_LENGTH];

	argument = one_argument(argument, arg1 );

	rch = get_char_world( ch, arg1 );

	if(!battle->running && !battle->open )
	{
		send_to_char( "There is no battle going on at the moment", ch );
		return;
	}

	if (arg1[0] == '\0')
	{
		send_to_char( "Add who to the battle?", ch );
		return;
	}

	if ( !( victim = get_char_world( ch, arg1 ) ) )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	place = 30000;
	location = get_room_index( place );

	if ( IS_NPC( victim ) )
	{
		send_to_char( "Not on mobs.\n\r", ch );
		return;
	}
	else
	{
		act( "$n has gone to seek glory on the battlefield.", victim, NULL, NULL, TO_ROOM );
		char_from_room( victim );
		char_to_room( victim, location );
		act( "$n has arrived on the battlefield.", victim, NULL, NULL, TO_ROOM );
		do_look( victim, "auto" );
		SET_BIT ( victim->war_flags, WAR_BATTLE );
		victim->battles++;
		sprintf( buf,"{w%s has joined the battle!.{x\n\r",victim->name );
		talk_battle( buf );
		victim->stam = get_maxstam(victim);
		victim->hit = get_maxhit(victim);
		sprintf( buf, "%s added to the battle.\n\r", victim->name );
		send_to_char( buf, ch );
	}
	return;
}
/*Since we can add players...let's be able to remove them
  as well. */
void do_bremove( CHAR_DATA * ch, char * argument )
{
	CHAR_DATA         *victim;
	CHAR_DATA         *rch;
	ROOM_INDEX_DATA   *location;
	int                place = 3001;
	char               buf[MAX_STRING_LENGTH];
	char               arg1[MAX_STRING_LENGTH];


	argument = one_argument( argument, arg1 );

	rch = get_char_world( ch, arg1 );

	if(!battle->running && !battle->open )
	{
		send_to_char( "There is no battle going on at the moment", ch );
		return;
	}

	if (arg1[0] == '\0')
	{
		send_to_char( "Remove who from the battle?", ch );
		return;
	}

	if ( !( victim = get_char_world( ch, arg1 ) ) )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if (IS_NPC( victim ) )
	{
		send_to_char( "Not on mobs.\n\r", ch );
		return;
	}
	else
	{
		REMOVE_BIT( victim->war_flags, WAR_BATTLE );
		place = ROOM_VNUM_PLAZA;
		location = get_room_index( place );
		sprintf( buf, "%s has removed you from battle.\n\r", ch->name );
		send_to_char( buf, victim );
		char_from_room( victim );
		char_to_room( victim, location );
		do_look( victim, "auto" );
		sprintf( buf, "%s has been removed from battle.\n\r", victim->name );
		send_to_char( buf, ch );
	}
	return;
}

/*Battle code stuff by Theodryck */
void do_battle (CHAR_DATA *ch, char * argument)
{
	ROOM_INDEX_DATA             *location;
	char            buf[MAX_STRING_LENGTH];
	char arg[MIL];
	int             place = BATTLE_FIRST;

	argument = one_argument( argument, arg );

   /*can't let mobs in battles :P*/
	if (IS_NPC( ch ) )
	return;

	if ( arg[0] != '\0' && ( !str_prefix( arg, "who" ) || !str_prefix( arg, "list" ) ) )
	{
	    DESCRIPTOR_DATA *d;
		stc("{W+- {RCurrent Campaign Participants{W -+{x\n\r",ch);
	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
			if ( d == NULL || !d || d->connected != CON_PLAYING )
				continue;
			if ( !IS_SET( d->character->war_flags, WAR_BATTLE ) )
				continue;
			ptc(ch,"{W|{R  %-15s                {W|{x\n\r", d->character->name);
		}
		stc("{W+-                               -+{x\n\r",ch);
		return;

	}

   /*There's no battle going on dummy */
	if(!battle->open)
	{
		send_to_char("There is no battle currently open",ch );
		return;
	}

	else
	{
	if( IS_SET( ch->war_flags, WAR_BATTLE ) )
	return;

/*	ptc( ch, "Attempting to send you to %d.\n\r", place );*/
	place = BATTLE_FIRST;
	location = get_room_index( place );
  /*
   *Here we check to see if the player is in the
   *proper level range
   */
	if( battle->open && ( ch->level >= battle->level1 && ch->level <= battle->level2 ) )
	{
		act( "$n has gone to seek glory on the battlefield.", ch, NULL, NULL, TO_ROOM );
		char_from_room( ch);
		char_to_room( ch, location );
		act( "$n has arrived on the battlefield.", ch, NULL, NULL, TO_ROOM );
		do_look(ch, "auto" );
		SET_BIT (ch->war_flags, WAR_BATTLE );
		ch->battles++;
		sprintf(buf,"{w%s has joined the battle!.{x\n\r",ch->name);
		talk_battle( buf );
		ch->stam = get_maxstam(ch);
		ch->hit = get_maxhit(ch);
	}
	else
	{
		send_to_char("You are not in the correct level range", ch);
		return;
	}
	}
	return;
}

