/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"


bool    is_char_char_clan   args( (CHAR_DATA *ch, CHAR_DATA *victim) );
bool is_white_tower args((CHAR_DATA *ch));
bool is_shadow args((CHAR_DATA *ch));
bool is_aiel_clan args((CHAR_DATA *ch));
bool is_ogier_clan args((CHAR_DATA *ch));
bool is_seanchan_clan args((CHAR_DATA *ch));
bool is_seafolk args((CHAR_DATA *ch));
bool can_recruit args((CHAR_DATA *ch, CHAR_DATA *victim, char *argument));
int	clan_lookup	args( (const char *name) );

const struct flag_type guild_flags[] =
{
   {    "Independent",		GUILD_INDEPENDENT,	TRUE 	},
   {	"Modified",		GUILD_CHANGED,		FALSE	},
   {	"Delete",		GUILD_DELETED,		TRUE	},
   {    "Immortal",		GUILD_IMMORTAL,		TRUE	},
   {	NULL,			0,			FALSE   }
};

void do_towertalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

    if (!is_white_tower(ch))
    {
		stc("{cYou aren't in a White Tower guild.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to your Guild members?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Creator has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{b[{WWhite Tower{b] {w'{W%s{w'{x\n\r", argument );

    sprintf(buf,"{b[{WWhite Tower{b] {w({W%s{w) {W'{w%s{W'{x\n\r", ch->name,argument );
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
        && is_white_tower(victim)
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}
void do_darktalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_shadow(ch))
    {
		stc("{cYou aren't in a Friend of the Dark.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to other Friends of the Dark?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Great Lord has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{b[{BThe Shadow{b] {D'{w%s{D'{x\n\r", argument );

    sprintf(buf,"{b[{BThe Shadow{b] {B({D%s{B) {D'{w%s{D'{x", ch->name,argument );
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
    	&& is_shadow(victim)
/*        && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}
void do_darkooc(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_shadow(ch))
    {
		stc("{cYou aren't in a Friend of the Dark.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to other Friends of the Dark?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Great Lord has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{b[{BThe Shadow {ROOC{b] {D'{w%s{D'{x\n\r", argument );

    sprintf(buf,"{b[{BThe Shadow {ROOC{b] {B({D%s{B) {D'{w%s{D'{x", ch->name,argument );
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
    	&& is_shadow(victim)
     /*   && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}

void do_handtalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_aiel_clan(ch))
    {
		stc("{cYou aren't in an Aiel Warrior Society.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to Aiel Warrior Society members?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Car'a'carn has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{G[{gHand Talk{G] {D'{g%s{D'{x\n\r", argument );

    sprintf(buf,"{G[{gHand Talk{G] {G({g%s{G) {D'{g%s{D'{x\n\r", ch->name,argument );
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
        && is_aiel_clan(victim)
/*        && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}

void do_treetalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_ogier_clan(ch))
    {
		stc("{cYou aren't in an Ogier Guild.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to other Ogier?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Stump has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{G[{gTree Talk{G] {D'{g%s{D'{x\n\r", argument );

    sprintf(buf,"{G[{gTree Talk{G] {G({g%s{G) {D'{g%s{D'{x\n\r", ch->name,argument );
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
        && is_ogier_clan(victim)
/*        && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}
/* should be gcomOOC */
void do_seantalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_seanchan_clan(ch))
    {
		stc("{cYou aren't in a Seanchan Guild.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to other Seanchan?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Empress has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{B[{WSeanchan{B] {W'{w%s{W'{x\n\r", argument );

    sprintf(buf,"{B[{WSeanchan{B] {W({Y%s{W) {B'{w%s{B'{x\n\r", ch->name,argument );
/*    sprintf(buf,"{R[{rSeanchan{R] {D({B%s{D) {D'{w%s{D'{x\n\r", ch->name,argument );*/
    for ( victim = char_list; victim != NULL; victim = victim->next )
    {
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
        && is_seanchan_clan(victim)
/*        && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}
void do_shiptalk(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
    CHAR_DATA *victim;

/*
    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
		stc("{cYou aren't in a guild.{c\n\r",ch);
		return;
    }
*/
    if (!is_seafolk(ch))
    {
		stc("{cYou aren't a Seafolk.{c\n\r",ch);
		return;
    }
    if ( argument[0] == '\0' )
    {
        stc("Say what to your Ship members?\n\r",ch);
	    return;
    }

    if (IS_SET(ch->penalty_flags,PENAL_NOCHANNELS))
    {
	    stc("{cThe Creator has revoked your channel priviliges.{c\n\r",ch);
	    return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
    argument = makedrunk(argument,ch);

	ptc(ch,"{W[{GS{ghip {GT{galk{W] {w'{W%s{w'{x\n\r", argument );

    sprintf(buf,"{W[{GS{ghip {GT{galk{W] {B({W%s{B) {W'{w%s{W'{x\n\r", ch->name,argument );
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
		if ( !d || !d->character || d->connected != CON_PLAYING )
		continue;
		victim = d->character;
        if (victim != ch
        && !IS_NPC(victim)
        && !IS_SET(victim->comm,COMM_NOCLAN)
        && is_seafolk(victim)
/*        && is_char_char_clan(ch,victim) */
        && !IS_SET(victim->comm,COMM_QUIET))
        {
	        act_new( buf, ch, argument, victim, TO_VICT, POS_DEAD );
        }
    }
    return;
}

bool is_obj_clan args((OBJ_DATA *obj));

bool is_obj_char_clan(CHAR_DATA *ch, OBJ_DATA *obj, int guild)
{
	int i, gnum;

	if ( !obj )
		return FALSE;

	if ( !is_obj_clan(obj) )
		return TRUE;

	gnum = clan_lookup( obj->guild );

	if ( IS_SET( clan_table[gnum].flags, GUILD_INDEPENDENT ) )
		return TRUE;

	if (gnum == ch->clan)
		return TRUE;

	for ( i = 0; i < MAX_GUILD_RELATIONS; i++ )
	{
		if ( clan_table[ch->clan].related[i] == NULL
		|| clan_table[ch->clan].related[i][0] == '\0' )
			continue;
		if ( !str_cmp( clan_table[ch->clan].name, obj->guild ) )
			return TRUE;
		if ( !str_cmp( clan_table[ch->clan].related[i], obj->guild ) )
			return TRUE;
	}

	for ( i = 0; i < MAX_GUILD_RELATIONS; i++ )
	{
		if ( clan_table[ch->sub_clan].related[i] == NULL
		|| clan_table[ch->sub_clan].related[i][0] == '\0' )
			continue;
		if ( !str_cmp( clan_table[ch->sub_clan].name, obj->guild ) )
			return TRUE;
		if ( !str_cmp( clan_table[ch->sub_clan].related[i], obj->guild ) )
			return TRUE;
	}

	return FALSE;
}

bool is_char_char_clan(CHAR_DATA *ch, CHAR_DATA *victim)
{
	int i;

	for ( i = 0; i < MAX_GUILD_RELATIONS; i++ )
	{
		if ( !str_cmp( clan_table[ch->clan].name, clan_table[victim->clan].name ) )
			return TRUE;
		if ( !str_cmp( clan_table[ch->clan].related[i], clan_table[victim->clan].name ) )
			return TRUE;
	}
	return FALSE;
}


bool can_recruit (CHAR_DATA *ch, CHAR_DATA *victim, char *argument)
{


	if ( ch->clan == clan_lookup("Dreadlord") && 
clan_lookup(argument) == clan_lookup("DarkFriend"))
	{
		stc("You are a Dreadlord, and trying to recruit into Darkfriend.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("Darkwarder") && 
clan_lookup(argument) == clan_lookup("DarkFriend"))
	{
		stc("You are a Dark Warder, and trying to recruit into Darkfriend.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("BlackAjah") && 
clan_lookup(argument) == clan_lookup("DarkFriend"))
	{
		stc("You are a Black Ajah, and trying to recruit into Darkfriend.\n\r",ch);
		return TRUE;
	}

	if ( ch->clan == clan_lookup("BlackAjah") && clan_lookup(argument) == clan_lookup("BlackAjah"))
	{
		stc("Only the Nae'blis may make Black ajah.\n\r",ch);
		return FALSE;
	}
	if ( ch->clan == clan_lookup("DarkWarder") && 
clan_lookup(argument) == clan_lookup("DarkWarder"))
	{
		stc("Only the Nae'blis may make Dark Warder.\n\r",ch);
		return FALSE;
	}
	if ( ch->clan == clan_lookup("Dreadlord") && 
clan_lookup(argument) == clan_lookup("Dreadlord"))
	{
		stc("Only the Nae'blis may make Dreadlords.\n\r",ch);
		return FALSE;
	}
	if ( clan_lookup(argument) == clan_lookup("Dreadlord"))
	{
		stc("Only the Nae'blis may make Dreadlords.\n\r",ch);
		return FALSE;
	}
	if ( ch->clan == clan_lookup("warder") && clan_lookup(argument) == clan_lookup("warder"))
	{
		stc("Only the Dai Shan or the Amyrlin may make Warders.\n\r",ch);
		return FALSE;
	}
	if ( ch->clan == clan_lookup("warder") && clan_lookup(argument) == clan_lookup("towerguard"))
	{
		stc("You are a Warder trying to make a Tower Guard.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("aessedai") && clan_lookup(argument) == clan_lookup("novice"))
	{
		stc("You are an Aes Sedai trying to make a Novice.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("youngling") && clan_lookup(argument) == clan_lookup("towerguard"))
	{
		stc("You are a Youngling trying to make a Tower Guard.\n\r",ch);
		return TRUE;
	}

	if ( ch->clan == clan_lookup("warder") && clan_lookup(argument) == clan_lookup("youngling"))
	{
		stc("You are a Warder trying to make a Youngling.\n\r",ch);
		return TRUE;
	}
	/*
	 * if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("deathwatch"))
	{
		stc("Only the Empress, may she live forever, may guild Deathwatch.\n\r",ch);
		return FALSE;
	}
	 */
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("deathwatch"))
	{
		stc("You are a Deathwatch trying to make a Deathwatch.\n\r",ch);
		return TRUE;
	}
	if ( clan_lookup(argument) == clan_lookup("empress"))
	{
		stc("There may be only one Empress, may she live forever.\n\r",ch);
		return FALSE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("blood"))
	{
		stc("You are Deathwatch trying to make Blood.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("sojhin"))
	{
		stc("You are Deathwatch trying to make a So'jhin.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("moratraken"))
	{
		stc("You are Deathwatch trying to make a Morat'raken.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("moratgrolm"))
	{
		stc("You are Deathwatch trying to make a Morat'grolm.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("moratsredit"))
	{
		stc("You are Deathwatch trying to make a Morat'sredit.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("morattorm"))
	{
		stc("You are Deathwatch trying to make a Morat'torm.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("moratlopar"))
	{
		stc("You are Deathwatch trying to make Morat'lopar.\n\r",ch);
		return TRUE;
	}
	if ( ch->clan == clan_lookup("deathwatch")	&& clan_lookup(argument) == clan_lookup("moratcorlm"))
	{
		stc("You are Deathwatch trying to make a Morat'corlm.\n\r",ch);
		return TRUE;
	}

	if ( victim->clan != clan_lookup("loner") && victim->clan != clan_lookup("aiel"))
    {
		stc("You may not recruit into your own Guild unless the initiate is a Loner or Aiel.\n\r",ch);
		return FALSE;
	}
    if ( clan_lookup(argument) == ch->clan )
    {
		stc("You may recruit into your own Guild if the initiate is a Loner.\n\r",ch);
		return TRUE;
	}

    if ( clan_lookup(argument) != ch->clan )
    {
		stc("You may only recruit into your own Guild.\n\r",ch);
		return FALSE;
	}
	/*if (is_clan(victim))
	{
		if (!clan_table[victim->clan].independent)
		{
			return;
		}
	}*/
	else
	{
		stc("You are trying to recruit into guild you cannot.\n\r",ch);
		return FALSE;
	}
}

bool is_aiel_clan (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("blackeye")
	|| ch->clan == clan_lookup("spearmaiden")
	|| ch->clan == clan_lookup("eaglebrother")
	|| ch->clan == clan_lookup("dawnrunner")
	|| ch->clan == clan_lookup("knifehand")
	|| ch->clan == clan_lookup("mountaindancer")
	|| ch->clan == clan_lookup("NightSpear")
	|| ch->clan == clan_lookup("redshield")
	|| ch->clan == clan_lookup("stonedog")
	|| ch->clan == clan_lookup("thunderwalker")
	|| ch->clan == clan_lookup("trueblood")
	|| ch->clan == clan_lookup("waterseeker")
	|| ch->clan == clan_lookup("wiseone")
	|| ch->clan == clan_lookup("clanchief")
	|| ch->clan == clan_lookup("aiel")
	|| ch->clan == clan_lookup("crafters"))
	return TRUE;
	else
	return FALSE;
}

bool is_ogier_clan (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("elder")
	|| ch->clan == clan_lookup("ogier"))
	return TRUE;
	else
	return FALSE;
}

bool is_seanchan_clan (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("Seanchan")
	|| ch->clan == clan_lookup("Blood")
	|| ch->clan == clan_lookup("deathwatch")
	|| ch->clan == clan_lookup("Suldam")
	|| ch->clan == clan_lookup("Sojhin")
	|| ch->clan == clan_lookup("Hailene")
	|| ch->clan == clan_lookup("Seeker")
	|| ch->clan == clan_lookup("morat"))
	return TRUE;
	else
	return FALSE;
}
bool is_white_tower (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("gaidin")
	|| ch->clan == clan_lookup("towerguard")
	|| ch->clan == clan_lookup("youngling")
	|| ch->clan == clan_lookup("aessedai")
	|| ch->clan == clan_lookup("novice"))
	return TRUE;

	if (ch->sub_clan == clan_lookup("gaidin")
	|| ch->sub_clan == clan_lookup("towerguard")
	|| ch->sub_clan == clan_lookup("youngling")
	|| ch->sub_clan == clan_lookup("aessedai")
	|| ch->sub_clan == clan_lookup("novice"))
	return TRUE;


	return FALSE;
}

bool is_shadow (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("darkfriend")
	|| ch->clan == clan_lookup("dreadlord")
	|| ch->clan == clan_lookup("chosen")
	|| ch->clan == clan_lookup("shadowspawn")
	)
	return TRUE;
	else
	return FALSE;
}

bool is_seafolk (CHAR_DATA *ch)
{
	if (ch->clan == clan_lookup("athaanmiere")
	|| ch->clan == clan_lookup("sailmistress")
	|| ch->clan == clan_lookup("windfinder")
	|| ch->clan == clan_lookup("cargomaster"))
	return TRUE;
	else
	return FALSE;
}

