/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "company.h"
#include "recycle.h"

int MaxCompanion = 37;

/* Begin company.c */
char * get_terrain_type( ROOM_INDEX_DATA *terrain )
{
	char *terrain_type;
	if ( terrain->sector_type == SECT_INSIDE)				terrain_type = "surroundings";
	else if ( terrain->sector_type == SECT_CITY)				terrain_type = "surroundings";
	else if ( terrain->sector_type == SECT_FIELD)				terrain_type = "grasses";
	else if ( terrain->sector_type == SECT_FOREST)				terrain_type = "trees";
	else if ( terrain->sector_type == SECT_HILLS)				terrain_type = "hills";
	else if ( terrain->sector_type == SECT_MOUNTAIN)			terrain_type = "mountains";
	else if ( terrain->sector_type == SECT_WATER_SWIM)			terrain_type = "reeds";
	else if ( terrain->sector_type == SECT_WATER_NOSWIM)		terrain_type = "water";
	else if ( terrain->sector_type == SECT_AIR)					terrain_type = "air";
    else if ( terrain->sector_type == SECT_TUNDRA)              terrain_type = "snow";
    else if ( terrain->sector_type == SECT_BLIGHT)              terrain_type = "blight";
    else if ( terrain->sector_type == SECT_COASTAL)             terrain_type = "sands";
    else if ( terrain->sector_type == SECT_ROAD)                terrain_type = "road side";
    else if ( terrain->sector_type == SECT_MARSH)               terrain_type = "reeds";
	else if ( terrain->sector_type == SECT_DESERT)				terrain_type = "sands";
	else if ( terrain->sector_type == SECT_WASTE)				terrain_type = "sands";
	else terrain_type = "brush";
	return str_dup( terrain_type );
}
char * get_companion_sound( CHAR_DATA *ch, int comp )
{
	char *sound;
	sound = "bleep";
	return str_dup( sound );
}
bool check_companion_location( CHAR_DATA *ch, ROOM_INDEX_DATA *terrain )
{
	int chance = 0, i = 0;
	if ( terrain == NULL )
		return FALSE;
	for ( i = 0; i <= MaxCompanion; i++ )
	{
		if ( terrain->sector_type == SECT_INSIDE)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_CITY)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_FIELD)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_FOREST)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_HILLS)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_MOUNTAIN)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_WATER_SWIM)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_WATER_NOSWIM)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_AIR)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

	    if ( terrain->sector_type == SECT_TUNDRA)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

	    if ( terrain->sector_type == SECT_BLIGHT)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

	    if ( terrain->sector_type == SECT_COASTAL)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

	    if ( terrain->sector_type == SECT_ROAD)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

	    if ( terrain->sector_type == SECT_MARSH)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );

		if ( terrain->sector_type == SECT_DESERT)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );
		if ( terrain->sector_type == SECT_WASTE)
			if ( companion_table[i].sector == terrain->sector_type )
			ptc( ch, "Found a valid sector type for a %s", companion_table[i].type );
	}
	if ( chance <= 0 )
		return FALSE;
	else
		return TRUE;
}
void get_companion_type( CHAR_DATA *ch, int comp )
{
	int chance = 0, check = 0, i = 0, x = 0, guild;

	chance = get_curr_stat( ch, STAT_CHA );
	check = number_percent();

	for ( i = 0; i <= MAX_CLAN; i++ )
	{
		for ( i = 0; i <= 3; i++ )
		{
			guild = clan_lookup( companion_table[i].guilds[x] );
		if ( comp == guild && chance > check )
		ptc(ch, "You got a %s!\n\r", companion_table[i].type);
		}
	}
	return;
}

void update_companions ( CHAR_DATA *ch )
{
	int chance = 100;
	int prior = 0;
	int comp;
	char sound_type[MSL];
	char terrain_type[MSL];
	ROOM_INDEX_DATA *terrain;

	return; /* failsafe */
	if ( IS_NPC( ch ) || ch->desc == NULL || !ch->pcdata )
		return;

	if ( ( terrain = ch->in_room ) == NULL )
		return;

	prior = ch->pcdata->companion_prior;
	comp = ch->clan;
	stc( "Got a valid terrain type.\n\r", ch );

	if ( prior > 1 )
		chance -= prior * 3;

	get_companion_type( ch, comp );
	if ( !check_companion_location( ch, terrain ) )
		return;
	strcat( sound_type, get_companion_sound( ch, comp ) );
	strcat( terrain_type,  get_terrain_type( terrain ) );
	ptc( ch, "You hear a %s in the %s", sound_type, terrain_type );
	return;
}
