/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif

#include <sys/wait.h>

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/resource.h>
#include <ulimit.h>
#include <unistd.h> /* OLC -- for close read write etc */
#include <stdarg.h> /* printf_to_char */
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>

#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "mysql5_interface.h"


#define MAX_BAD_NAMES 205


#if    defined(unix)
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
extern const char echo_off_str[];
extern const char echo_on_str[];
extern const char go_ahead_str[];
#endif

void nlcr args(( CHAR_DATA *ch ));
int unread_notes args((CHAR_DATA *ch, BOARD_DATA *board));
int port;

// prool:
bool		    wizlock;		/* Game is wizlocked		*/
extern bool		    newlock;		/* Game is newlocked		*/

/*
 * Parse a name for acceptability.
 */
bool check_parse_name( char *name )
{
    int clan, i;
    /*char name_chk[MIL];*/
    const char *more_bad_names[MAX_BAD_NAMES] =
    {
		"auto","immortal","self","someone","something","you","loner","none",

		"abraxus","archangel","azrael","azreal","baphomet","banshee","beelzebub",
		"baalzabub","bokkor","cambion","cherub","messiah","mesiah","diabolic",
		"dracula","buffy","druid","prophet","faust",

		"moiraine","dragon","thom","egwene","nynaeve","aginor","asmodean","balthamel",
		"demandred","graendal","ishmael","lanfear","messana","moghedien","rahvin",
		"sammael","semirhage","aemon","eldrene","ilyena","illyena","lews",
		"therin","telamon","saidin","saidar","mordeth","tigraine","logain","padan",
		"fain","artur","hawkwing","mary","jane","davram","bashere",

		"dick","shit","pussy","cunt","fuck","damn","ass","hole","fart","mutha","mother",
		"cock","twat","moridin","hate","fear","fucker","fucka","fuka","bitch","bite",
		"blow","suck","hymen","jesus","diablo","devil","demon","daemon","cruel","spite",

		"ouija","vampire","suicide","anger","rage","strife","hatred","envy","sex",
		"fool","chronic","whore","prostitute","prostitution","fornicate","fornication",
		"asmodeus","satan","natas","funk","hexebus","incest","homo","jezebel","osmodeus",
		"christ","anti","sucubus","incubus","warlock","witch","voodoo","wicked","wycked",

		"black","knight","night","beer","eat","suck","who","evil","dumb","lord","lady",
		"god","fire","silver","gold","juana","dark","death","noble","rock","hard","hell",
		"zombie","ghost","anarch","cool","cold","sword","dagger","knife","axe",
		"dead","pain","hurt","wolfkin","under","zero","shadow","destroy","draco","dread",
		"fantasy","friend","might","magic","abuse","dungeon","master","mistress","hate",
		"blood","cigar","laugh","booze","monster","roach","unix","wannabe","joke",
		"angreal","dhoom","shadar","logoth","king","queen","prince","princess",
		"callandor","dream","gold","silver","osama","binladen","president", "blade"
	};

    const char bad_names[MSL*4] =
    {
		"auto immortal self someone something you loner none" \

		"abraxus archangel azrael azreal baphomet banshee beelzebub baalzebub bokkor" \
		"cambion cherub messiah mesiah diabolic dracula buffy druid prophet faust" \

		"moiraine dragon thom egwene nynaeve aginor asmodean balthamel" \
		"demandred graendal ishmael lanfear messana moghedien rahvin" \
		"sammael semirhage aemon eldrene ilyena illyena lews" \
		"therin telamon saidin saidar mordeth tigraine logain padan" \
		"fain artur hawkwing mary jane davram bashere" \

		"dick shit pussy cunt fuck damn ass hole fart mutha mother" \
		"cock twat moridin hate fear fucker fucka fuka bitch bite" \
		"blow suck hymen jesus diablo devil demon daemon cruel spite" \

		"ouija vampire suicide anger rage strife hatred envy sex" \
		"fool chronic whore prostitute prostitution fornicate fornication" \
		"asmodeus satan natas funk hexebus incest homo jezebel osmodeus" \
		"christ anti sucubus incubus warlock witch voodoo wicked wycked" \


		"black knight night beer eat suck who evil dumb lord lady" \
		"god fire silver gold juana dark death noble rock hard hell" \
		"zombie ghost anarch cool cold sword dagger knife axe" \
		"dead pain hurt wolfkin under zero shadow destroy draco dread" \
		"fantasy friend might magic abuse dungeon master mistress hate" \
		"blood cigar laugh booze monster roach unix wannabe joke" \
		"angreal dhoom shadar logoth king queen prince princess" \
		"callandor dream gold silver osama binladen president blade"
	};

    /*
     * Reserved words.
     */
    if (is_exact_name(name,
	"he she it are all auto immortal self someone something the you loner none evil moiraine dragon lan bela thom tam egwene nynaeve aginor asmodean balthamel demandred graendal ishmael lanfear messana moghedien rahvin sammael semirhage aemon eldrene ilyena illyena lews therin telamon saidin saidar mordeth tigraine logain padan fain artur hawkwing dick shit pussy cunt fuck damn ass hole fart mutha mother cock twat moridin hate fear death fucker fucka fuka dis dat sin callandor"))
    {
		return FALSE;
    }

    /* check clans */
    for (clan = 0; clan < MAX_CLAN; clan++)
    {
		if (LOWER(name[0]) == LOWER(clan_table[clan].name[0])
		&&  !str_cmp(name,clan_table[clan].name))
		   return FALSE;
    }

    if (str_cmp(capitalize(name),"Alander") && (!str_prefix("Alan",name)
    || !str_suffix("Alander",name)))
		return FALSE;

	for ( i = 0; i < MAX_BAD_NAMES; i++ )
	{
		if ( strstr( name, bad_names ) != NULL )
			return FALSE;
	}

	for ( i = 1; i < MAX_BAD_NAMES; i++ )
	{
		/*if ( str_infix(capitalize(name)),more_bad_names[i-1] )
		return FALSE;
		bug( "Counter %d.", i );*/
		if ( !str_cmp(name, more_bad_names[i-1] ) )
			return FALSE;
	    if ( !str_prefix( more_bad_names[i-1], name ) )
	    	return FALSE;
	    if ( !str_suffix( more_bad_names[i-1], name ) )
	    	return FALSE;
	}

    /*
     * Length restrictions.
     */

    if ( strlen(name) <  4 )
	return FALSE;

#if defined(MSDOS)
    if ( strlen(name) >  8 )
	return FALSE;
#endif

#if defined(macintosh) || defined(unix)
    if ( strlen(name) > 12 )
	return FALSE;
#endif

    /*
     * Alphanumerics only.
     * Lock out IllIll twits.
     */
    {
	char *pc;
	bool fIll,adjcaps = FALSE,cleancaps = FALSE;
 	int total_caps = 0;

	fIll = TRUE;
	for ( pc = name; *pc != '\0'; pc++ )
	{
	    if ( !isalpha(*pc) )
		return FALSE;

	    if ( isupper(*pc)) /* ugly anti-caps hack */
	    {
		if (adjcaps)
		    cleancaps = TRUE;
		total_caps++;
		adjcaps = TRUE;
	    }
	    else
		adjcaps = FALSE;

	    if ( LOWER(*pc) != 'i' && LOWER(*pc) != 'l' )
		fIll = FALSE;
	}

	if ( fIll )
	    return FALSE;

	if (cleancaps || (total_caps > (strlen(name)) / 2 && strlen(name) < 3))
	    return FALSE;
    }

    return TRUE;
}

void describe_char( CHAR_DATA * ch )
{
	string_append( ch, &ch->description );
	return;
}

bool is_wizlock_allowed( char *argument )
{
	if ( is_exact_name( argument, "Dalsor" ) )
		return TRUE;
	if ( is_exact_name( argument, "Avryel" ) )
		return TRUE;
	if ( is_exact_name( argument, "Cerdwyn" ) )
		return TRUE;
	return FALSE;
}

/*
 * Look for link-dead player to reconnect.
 */
bool check_reconnect( DESCRIPTOR_DATA *d, char *name, bool fConn )
{
    CHAR_DATA *ch;

    for ( ch = char_list; ch != NULL; ch = ch->next )
    {
	if ( !IS_NPC(ch)
	&&   (!fConn || ch->desc == NULL)
	&&   !str_cmp( d->character->name, ch->name ) )
	{
	    if ( fConn == FALSE )
	    {
		free_string( d->character->pcdata->pwd );
		d->character->pcdata->pwd = str_dup( ch->pcdata->pwd );
	    }
	    else
	    {
		free_char( d->character );
		d->character = ch;
		ch->desc	 = d;
		ch->timer	 = 0;
		stc("{cReconnecting. Type replay to see missed tells.\n\r", ch );
		act( "{c$n gasps as life is breathed into $s lungs.", ch, NULL, NULL, TO_ROOM );

		sprintf( log_buf, "%s@%s reconnected.", ch->name, d->host );
		log_string( log_buf );
		wiznet("{c$N struggles free from the maw of the Net Beast.",
		    ch,NULL,WIZ_LINKS,0,0);
		d->connected = CON_PLAYING;

		if(ch->pcdata->dfhunt_player_info[0] != 0)
		{
			int i;

			for(i=0; i<7; i++)
			{
				if(i==1 || i==2)
					continue;

				ch->pcdata->dfhunt_player_info[i] = 0;
			}

			send_to_char("Since you were linkdead, you were removed from the {Rh{runt{x.\n\r", ch);
		}

		/* Inform the character of a note in progress and the possbility
		 * of continuation! -- No, let's dont.
		if (ch->pcdata->in_progress)
		    send_to_char ("You have a note in progress. Type NWRITE to continue it.\n\r", ch);
		 */
	    }

		MXPSendTag( d, "<VERSION>" );  /* <--- Add this line */
		return TRUE;
	}
    }

    return FALSE;
}



/*
 * Check if already playing.
 */
bool check_playing( DESCRIPTOR_DATA *d, char *name )
{
    DESCRIPTOR_DATA *dold;

    for ( dold = descriptor_list; dold; dold = dold->next )
    {
	if ( dold != d
	&&   dold->character != NULL
	&&   dold->connected != CON_GET_NAME
	&&   dold->connected != CON_GET_OLD_PASSWORD
	&&   !str_cmp( name, dold->original
	         ? dold->original->name : dold->character->name ) )
	{
	    write_to_buffer( d, "That character is already playing.\n\r",0);
	    write_to_buffer( d, "Do you wish to connect anyway (Y/N)?",0);
	    d->connected = CON_BREAK_CONNECT;
	    return TRUE;
	}
    }

    return FALSE;
}

void vote_message( CHAR_DATA *ch )
{
	stc("{YVote for TSE on These Sites{Y!{x\n\r",ch);

        stc("{y http://www.topmudsites.com/vote-theshadowsembrace.html{x\n\r", ch);
        stc("{y http://www.mudconnect.com/mud-bin/vote_rank.cgi?mud=The+Shadow's+Embrace{x\n\r\n\r", ch);
	//stc("\t<a href=\"http://www.topmudsites.com/vote-theshadowsembrace.html\">http://www.topmudsites.com/vote-theshadowsembrace.html\t", ch );
	//nlcr(ch);
	//stc("\t<a href=\"http://www.mudconnect.com/mud-bin/vote_rank.cgi?mud=The+Shadow\'s+Embrace\">http://www.mudconnect.com/mud-bin/vote_rank.cgi?mud=The+Shadow\'s+Embrace\t", ch );
	//nlcr(ch);

	//stc("{y \t<a href=\"http://www.topmudsites.com/vote-theshadowsembrace.html\">Top MUD Sites</a>\t{x\n\r", ch);
	//stc("{y \t<a href=\"http://www.mudconnect.com/mud-bin/vote_rank.cgi?mud=The+Shadow's+Embrace\">The MUD Connector</a>\t{x\n\r\n\r", ch);

}
void do_events( CHAR_DATA *ch, char *argument )
{
	stc(   "{REvent Type   {RRunning Event Status:      {x\n\r",ch);
	stc(   "{r==========   ========================={x\n\r",ch);
	ptc(ch,"{WTrivia{w:      %-9s                           \n\r",
	   trivia->running ? "{GYes" : "{RNo");
	ptc(ch,"{WTourney{w:     %-9s{w Range: %4d %4d         \n\r",
	   tourney->status == 1 ? "{GIdle" : tourney->status == 2 ? "{GWaiting" : "{RRunning",
	   tourney->status == 2 || tourney->status == 3 || tourney->status == 4 ? tourney->level1 : 0,
	   tourney->status == 2 || tourney->status == 3 || tourney->status == 4 ? tourney->level2 : 0 );
	ptc(ch,"{WWar{w:         %-9s{w Range: %4d %4d             \n\r",
	   battle->open ? "{GYes" : "{RNo",
	   battle->open ? battle->level1 : 0,
	   battle->open ? battle->level2 : 0 );
	ptc(ch,"{WDFHunt{w:      %-9s                         \n\r",
	   dfhunt_game_info[0] == 0 ? "{RNo" :
	   dfhunt_game_info[0] == 1 ? "{YPrelim" :
	   dfhunt_game_info[0] > 1 ? "{GRunning" : "{RUnknown" );
	ptc(ch,"{WFTag{w:        %-9s                          \n\r",
	   tag_game.status == TAG_ISWAIT ? "{YWaiting" : tag_game.status == TAG_ISPLAY ? "{GRunning" : "{RNo" );
	ptc(ch,"{WFaire{w:       %-9s %s\n\r",
	   faire->open ? "{GYes" : "{RNo",
	   faire->open ? capit2(faire->location) : "" );
	ptc(ch,"{WInvasion{w:    %-9s {w[{W%s{w]{x\n\r",
		invasion->running ? "{GYes" : "{RNo",
		invasion->running ? capit2(invasion->location) : "{RNone" );
	ptc(ch,"{WGEvent{w:      %-9s%s {w[{W%d{w/{W%d{w]{x\n\r",
		gevent != NULL && gevent->running ? "{GRunning " : "{RNo",
		gevent != NULL && gevent->running ? gevent->cname : "",
		gevent != NULL && gevent->running ? gevent->timer : 0,
		gevent != NULL && gevent->running ? gevent->runtime : 0 );
	if ( wizlock || newlock )
	ptc(ch,"{WGame Status{w: %s%s{x\n\r", wizlock ? "{RWizlocked " : "", newlock ? "{RNewlocked" : "" );
	else
	stc("{WGame Status{w: {GOPEN{x\n\r", ch );
	if ( bootcount > 3600 )
		ptc(ch, "{WNext Reboot{w: {w[{W%-4d{w] hours\n\r", bootcount / (60*60));
	else
		ptc(ch, "{WNext Reboot{w: {w[{W%-4d{w] minutes\n\r", bootcount / 60);
}

void create_forum_account( CHAR_DATA *ch )
{
        char mysql_buf[MSL];
	char clean_name[MIL];
	MYSQL_RES *result;
	MYSQL_ROW row;

	if (mud_port != play_port)
		return;

	sprintf( mysql_buf, "select user_email from forum_users where user_email = '%s'", ch->pcdata->email );
	result = query_db(mysql_buf, result_db, FALSE); 
	if ( result != NULL )
	{
		while ( (row = mysql_fetch_row(result)) != NULL )
		{
			stc( "{CA forum account already exists with this email address. A new one will not be created.{x\n\r", ch );
			return;
		}
	}
	mysql_free_result(result);

	sprintf( clean_name, "%s", ch->name );
	clean_name[0] = tolower( ch->name[0] );
	sprintf(mysql_buf, "insert into forum_users values (\"\", \"%s\", \"%s\", \"%s\", \"%s\", \"%s\");", 
		ch->name, clean_name, ch->pcdata->tmp, ch->pcdata->email, "FALSE" );
	//ptc( ch, mysql_buf );
	mysql_real_query(result_db, mysql_buf, strlen(mysql_buf));

	if( mysql_affected_rows(result_db) < 1)
	{
		log_string("MYSQL: Error creating forum account.");
		stc("We're sorry, but we were unable to automatically create your forum account.\n\r", ch);
	}
	else
	{
		system("/usr/bin/php /home/tsemud/public_html/alts/makeuser.php");
	}
	stc("\n\r{CA forum account has been created for you using your name, password, and email address.{x\n\r", ch);
	stc("{CYou may log onto the forums at{c: {Chttp://www.theshadowsembrace.com/phpBB3{x\n\r\n\r", ch);
	ch->pcdata->tmp = NULL;
	return;
}
int count_unread_notes( CHAR_DATA *ch )
{
	int i, unread, count = 0;  
	for (i = 0; i < MAX_BOARD; i++)                                                                                                                                              
	{                                                                                                                                                                            
		unread = unread_notes (ch,&boards[i]); /* how many unread notes? */                                                                                                  
		count += unread;                                                                                                                                                     
	}
	return count;
}
bool twit_stopper( DESCRIPTOR_DATA *d, char * argument )
{
	int i = 0;
	char *swear_words[] =
	{
		"shit",
		"fuck",
		"damn",
		"pussy",
		"mother",
		"dick",
		"cunt",
		"asshole",
		"bastard",
		"bitch",
		"cunt",
		"goddamn",
		"hell",
		"holy",
		"jesus",
		"shitass",
		"whore",
		"butt",
		"cum",
		"douche",
		"finger",
		"fudge",
		"jizz",
		"poop",
		"balls",
		"arse",
		"cock",
		"faggot",
		"flamer",
		"twat",
		"twit",
		"fudge",
		"witch",
		"gobble",
		"orgasm",
		"orgazm",
		"vagina",
		"penis",
		"slag",
		"suck",
		"titty",
		"boob",
		"breast",
		"wack",
		"whack",
		"wank",
		"piss",
		"cream",
		NULL,
	};
	if ( !d->character )
		return TRUE;
	/* careful here so we dont kick out accidental mistypes */
	if ( argument[0] != '\0' )
	{
		for ( i = 0; swear_words[i] != NULL; i++ )
		{
			if ( strstr( argument, swear_words[i] ) != NULL )
			{
				ptc( d->character, "The word %s is no allowed. Disconnecting.\n\r", swear_words[i] );
				return TRUE;
			}
		}
	}
	return FALSE;
}
void nanny( DESCRIPTOR_DATA *d, char *argument)
{
	DESCRIPTOR_DATA *d_old, *d_next;
	DESCRIPTOR_DATA *d_mentor;
	char mysql_buf[MIL];
	char arg[MIL];
	char *pwdnew;
	char *p;
	bool fOld;
	bool fail;
	CHAR_DATA *ch;
	int sk;

	ch = d->original ? d->original : d->character;

	if (check_ban(d->host, BAN_ALL))
	{
		display_banned_site(d->character);
		close_socket(d);
		return;
	}
	/*
	if ( twit_stopper( d, argument ) )
	{
		write_to_buffer( d, "The voice states, 'That will not be accepted.'\n\r", 0 );
		close_socket(d);
		return;
	}
	*/
	/* Delete leading spaces UNLESS character is writing a note */
	if (d->connected != CON_NOTE_TEXT)
	{
		while ( isspace(*argument) )
			argument++;
	}

	switch ( d->connected )
	{
		default:
			bug( "Nanny: bad d->connected %d.", d->connected );
			close_socket( d );
		return;


		/* states for progress of sending email */
		case CON_EMAIL_TO:
			handle_email_to( d, argument );
		break;

		case CON_EMAIL_SUBJECT:
			handle_email_subject( d, argument );
		break;

		case CON_EMAIL_BODY:
			handle_email_body( d, argument );
		break;

		case CON_EMAIL_FINISH:
			handle_email_finish( d, argument );
		break;

		/* states for new note system, (c)1995-96 erwin@andreasen.org */
		/* ch MUST be PC here; have nwrite check for PC status! */

		case CON_NOTE_TO:
			handle_con_note_to( d, argument );
		break;

		case CON_NOTE_SUBJECT:
			handle_con_note_subject( d, argument );
		break; /* subject */

		case CON_NOTE_EXPIRE:
			handle_con_note_expire (d, argument);
		break;

		case CON_NOTE_TEXT:
			handle_con_note_text (d, argument);
		break;

		case CON_NOTE_FINISH:
			handle_con_note_finish (d, argument);
		break;

		/* GET THE CHARACTER'S NAME */

		case CON_GET_NAME:
			if ( argument[0] == '\0' )
			{
				close_socket( d );
				return;
			}
			argument[0] = UPPER(argument[0]);
			if ( wizlock && !is_wizlock_allowed( argument ) )
			{
				display_game_wizlocked_descriptor(d);
				close_socket( d );
				return;
			}
			if ( !check_parse_name( argument ) )
			{
				write_to_buffer(d,"\n\r", 0 );
				write_to_buffer(d,"  +------------------------------------------------------------------+ \n\r", 0);
				write_to_buffer(d,"  | WARNING! Illegal name!                                           | \n\r", 0);
				write_to_buffer(d,"  | This is likely a name that the Creator has denied usage          | \n\r", 0);
				write_to_buffer(d,"  | to, because it does not fit into a Wheel of Time theme, or       | \n\r", 0);
				write_to_buffer(d,"  | is not being used appropriately here.                            | \n\r", 0);
				write_to_buffer(d,"  | Try another name.                                                | \n\r", 0);
				write_to_buffer(d,"  +------------------------------------------------------------------+ \n\r", 0);
				write_to_buffer(d," Received: ",0);
				write_to_buffer(d, argument, 0 );
				write_to_buffer(d, "\n\r", 0 );
				write_to_buffer(d,"\n\r", 0 );
				//display_illegal_name( ch );
				return;
			}
			fOld = load_char_obj( d, argument );
			ch   = d->character;
			SET_BIT(ch->act,PLR_COLOUR);
			if (IS_SET(ch->act, PLR_DENY))
			{
				sprintf( log_buf, "Denying access to Host %s@%s.", argument, d->host );
				log_string( log_buf );
				display_denied_char(d->character);
				close_socket( d );
				return;
			}
			if (check_ban(d->host,BAN_PERMIT) && !IS_SET(ch->act,PLR_PERMIT))
			{
				display_banned_site(d->character);
				close_socket(d);
				return;
			}
			if (check_ban(d->host, BAN_ALL))
			{
				display_banned_site(d->character);
				close_socket(d);
				return;
			}
			if ( wizlock && !IS_IMMORTAL(ch))
			{
				display_game_wizlocked(d->character);
				close_socket( d );
				return;
			}
			if ( fOld )
			{
				stc( "{cA voice intones: '{CWhisper to me your password.{c'{x ", ch );
				stc(  echo_off_str, ch );
				d->connected = CON_GET_OLD_PASSWORD;
				return;
			}
			else
			{
				if (newlock)
				{
					display_game_newlocked(d->character);
					close_socket( d );
					return;
				}
				if (check_ban(d->host,BAN_NEWBIES))
				{
					stc("{cThe voice says, '{CNew players are not allowed from your site.{c'{x\n\r",ch);
					close_socket(d);
					return;
				}
				argument[0] = UPPER(argument[0]);
				display_new_name(d->character);
				confirm_new_name(d->character);
				ptc( ch, "{cThe voice whispers, '{CDid I get that right, %s?{c' {c({CY{c/{CN{c){x\n\r{C->{x ", argument );
				d->connected = CON_CONFIRM_NEW_NAME;
				return;
			}
		break;

	/* GET THE OLD PASSWORD */

	case CON_GET_OLD_PASSWORD:
		#if defined(unix)
			stc(  "\n\r", ch );
		#endif

		if ( strcmp( crypt( argument, ch->pcdata->pwd ), ch->pcdata->pwd ))
		{
			display_invalid_password(d->character);
			logf("Invalid password for %s from %s", d->character->name, d->host);
			close_socket( d );
			return;
		}
		stc(  echo_on_str, ch );

		/* Set alt IP addresses here. */
		if ( !str_cmp( d->character->name, "Aeryn" ) )
		{
			free_string( d->host );
			d->host = str_dup( "170.235.0.117" );
		}
		if ( !str_cmp( d->character->name, "Danther" ) )
		{
			free_string( d->host );
			d->host = str_dup( "72.240.46.244" );
		}
		if ( !str_cmp( d->character->name, "Tealk" ) )
		{
			free_string( d->host );
			d->host = str_dup( "70.150.177.72" );
		}
		if ( !str_cmp( d->character->name, "Tatius" ) )
		{
			free_string( d->host );
			d->host = str_dup("173.224.119.188");
		}

		if (check_playing(d,ch->name))
			return;
		if ( check_reconnect( d, ch->name, TRUE ) )
			return;

		sprintf( log_buf, "%s@%s has connected.", ch->name, d->host );
		log_string( log_buf );
		wiznet(log_buf,NULL,NULL,WIZ_SITES,0,get_trust(ch));

		stc( "\n\r{CRemember to have fun!{x\n\r{c[Hit Return to continue]{x\n\r", ch );
		d->connected = CON_CONNECT_CHAR;
		break;

	/* GET THE GENDER */
	case CON_SELECT_GENDER:
		switch ( *argument )
		{
			default:
				stc("{cThe voice says, '{CPlease select either (M)ale or (F)emale.{c'\n\r{C-> {x" ,ch);
				d->connected = CON_SELECT_GENDER;
				return;
			break;
			case 'f': case 'F':
				stc("{cThe voice asks, '{CWould like to start quickly or use more detailed creation?{c'{x\n\r", ch);
				stc(" {C+{c-----------------------------------------------------------------------{C+{x\n\r", ch);
				stc(" {c|{w If you chose quick start, you will begin as a normal Andoran          {c|{x\n\r", ch);
				stc(" {c|{w human character in Caemlyn. Choosing more detailed creation           {c|{x\n\r", ch);
				stc(" {c|{w gives you a choice of races, nationality, and options such as         {c|{x\n\r", ch);
				stc(" {c|{w the ability to channel and a guided tour on how to play The Shadow's  {c|{x\n\r", ch);
				stc(" {c|{w Embrace MUD, but takes significantly longer to get started.           {c|{x\n\r", ch);
				stc(" {c|{w You can also choose the tour after you have chosen the quick start.   {c|{x\n\r", ch);
				stc(" {C+{c-----------------------------------------------------------------------{C+{x\n\r", ch);
				stc("{cThe voice says, '{CPlease choose {c({CQ{c){Cuick or {c({CD{c){Cetailed.{c'{x\n\r{C-> {x",ch);
				ch->sex = SEX_FEMALE;
				ch->pcdata->true_sex = SEX_FEMALE;
				d->connected = CON_SELECT_DETAIL;
				return;
			break;
			case 'm': case 'M':
				stc("{cThe voice asks, '{CWould like to start quickly or use more detailed creation?{c'{x\n\r", ch);
                                stc(" {C+{c-----------------------------------------------------------------------{C+{x\n\r", ch);
                                stc(" {c|{w If you chose quick start, you will begin as a normal Andoran          {c|{x\n\r", ch);
                                stc(" {c|{w human character in Caemlyn. Choosing more detailed creation           {c|{x\n\r", ch);
                                stc(" {c|{w gives you a choice of races, nationality, and options such as         {c|{x\n\r", ch);
                                stc(" {c|{w the ability to channel and a guided tour on how to play The Shadow's  {c|{x\n\r", ch);
                                stc(" {c|{w Embrace MUD, but takes significantly longer to get started.           {c|{x\n\r", ch);
                                stc(" {c|{w You can also choose the tour after you have chosen the quick start.   {c|{x\n\r", ch);
                                stc(" {C+{c-----------------------------------------------------------------------{C+{x\n\r", ch);
                                stc("{cThe voice says, '{CPlease choose {c({CQ{c){Cuick or {c({CD{c){Cetailed.{c'{x\n\r{C-> {x",ch);
				ch->sex = SEX_MALE;
				ch->pcdata->true_sex = SEX_MALE;
				d->connected = CON_SELECT_DETAIL;
				return;
			break;
		}
		break;

	/* DETAILED CREATION OR NO */
	case CON_SELECT_DETAIL:
		switch ( *argument )
		{
			default:
				stc("{cThe voice says, '{CPlease choose {c({CQ{c){Cuick or {c({CD{c){Cetailed.{c'\n\r{C-> {x",ch);
				d->connected = CON_SELECT_DETAIL;
				return;
			break;
			case 'q': case 'Q':
				set_features( ch );
				ch->pcdata->true_race = TRUE_RACE_HUMAN;
				ch->race = race_lookup("andor");
				ch->pcdata->eye = 7; /* brown */
				ch->pcdata->hair1 = 0; /* brown */
				ch->pcdata->hair2 = 0; /* dark */
				ch->pcdata->hair3 = 0; /* straight */
				ch->pcdata->hair4 = 2; /* cropped */
				roll_abilityscores( ch );
				if (ch->pcdata->learned[gsn_hand_to_hand] < 50)
					ch->pcdata->learned[gsn_hand_to_hand] = 50;
				if (ch->pcdata->learned[gsn_punch] < 50)
					ch->pcdata->learned[gsn_punch] = 50;
				stc( "{yYou have now learned the {YHAND TO HAND{y skill!{x\n\r", ch );
				stc( "{yYou have now learned the {YPUNCH{y skill!{x\n\r", ch );
				switch ( number_range( 0, 8 ) )
				{
					case 0:  SET_BIT( ch->hist_flags, HIST_SOLDIER ); break;
					case 1:  SET_BIT( ch->hist_flags, HIST_MERCHANT ); break;
					case 2:  SET_BIT( ch->hist_flags, HIST_BEGGAR ); break;
					case 3:  SET_BIT( ch->hist_flags, HIST_ARTIST ); break;
					case 4:  SET_BIT( ch->hist_flags, HIST_FARMER ); break;
					case 5:  SET_BIT( ch->hist_flags, HIST_CHILD ); break;
					case 6:  SET_BIT( ch->hist_flags, HIST_MUSICIAN ); break;
					case 7:  SET_BIT( ch->hist_flags, HIST_SAILOR ); break;
					case 8:  SET_BIT( ch->hist_flags, HIST_NOBLE ); break;
				}
				SET_BIT(ch->act,PLR_AUTOEXIT);
				SET_BIT(ch->act,PLR_AUTOGOLD);
				SET_BIT(ch->act,PLR_AUTOLOOT);
				SET_BIT(ch->act,PLR_AUTOASSIST);
				SET_BIT(ch->act,PLR_AUTOSPLIT);
				SET_BIT(ch->act,PLR_AUTOSAC);
				SET_BIT(ch->act,PLR_COLOUR);
				SET_BIT(ch->comm,COMM_PDEATH);
				SET_BIT(ch->comm,COMM_PENTER);
				SET_BIT(ch->comm,COMM_PREBIRTH);
				SET_BIT(ch->war_flags,WAR_AUTOFIGHT);
				SET_BIT(ch->auto_flags,AUTO_AUTORECALL);
				SET_BIT(ch->auto_flags,AUTO_COUNTER);
				SET_BIT(ch->auto_flags,AUTO_DODGE);
				SET_BIT(ch->auto_flags,AUTO_PARRY);
				SET_BIT(ch->auto_flags,AUTO_WAR);
				SET_BIT(ch->auto_flags,AUTO_AUTOH2H);
				stc(" {C+{c----------------------------------------------------------------------------{C+\n\r",ch);
				stc(" {c|{w Most Andorans are dark-haired and dark-eyed people of medium height with a {c|\n\r",ch);
				stc(" {c|{w medium skin tone. Blondes and light-eyed people are rare, although red     {c|\n\r",ch);
				stc(" {c|{w hair and blue eyes are common in the Andoran noble lines. Andoran men wear {c|\n\r",ch);
				stc(" {c|{w trousers, shirts and coats with turned-back cuffs and upstanding collars.  {c|\n\r",ch);
				stc(" {c|{w Women wear long dresses with modest square-cut  necks and fitted sleeves.  {c|\n\r",ch);
				stc(" {C+{c----------------------------------------------------------------------------{C+{x\n\r",ch);
				stc( "\n\r{CRemember to have fun!{x\n\r{c[Hit Return to continue]{x\n\r", ch );
				compose_title( ch );
				ch->pcdata->newbie = 0;
				ch->pcdata->allowed = 1;
				d->connected = CON_CONNECT_CHAR;
				return;
			break;
			case 'd': case 'D':
				ch->pcdata->newbie = 1;
				/*
				stc(" {C+{c------------------------------------------------------------------------{C+{c{x\n\r",ch);
				stc(" {c|{w Races                                                                  {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{w{x\n\r",ch);
				stc(" {c|{w Human                                                                  {c|{w{x\n\r",ch);
				stc(" {c|{w Trolloc                                                                {c|{w{x\n\r",ch);
				stc(" {c|{w Ogier                                                                  {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{w{x\n\r",ch);
				stc(" {c|{w You may see information about each race by typing HELP <name of race>. {c|{w{x\n\r",ch);
				stc(" {c|{w For example: HELP Trolloc                                              {c|{w{x\n\r",ch);
				stc(" {c|{w To choose a race, simply type the name of that race.                   {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{c{x\n\r",ch);
				*/
				stc( "\n\r{CYou will now be sent on the detailed creation tour.{x\n\r{c[Hit Return to continue]{x\n\r", ch );
				d->connected = CON_CONNECT_CHAR;
				return;
			break;
		}
		break;



	case CON_SELECT_RACE:
		one_argument( argument, arg );
		if ( !str_cmp( arg, "help" ) )
		{
			argument = one_argument( argument, arg );
			if ( argument[0] == '\0' )
			{
				stc(" {C+{c------------------------------------------------------------------------{C+{c{x\n\r",ch);
				stc(" {c|{w Races                                                                  {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{w{x\n\r",ch);
				stc(" {c|{w Human                                                                  {c|{w{x\n\r",ch);
				stc(" {c|{w Trolloc                                                                {c|{w{x\n\r",ch);
				stc(" {c|{w Ogier                                                                  {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{w{x\n\r",ch);
				stc(" {c|{w You may see information about each race by typing HELP <name of race>. {c|{w{x\n\r",ch);
				stc(" {c|{w For example: HELP Trolloc                                              {c|{w{x\n\r",ch);
				stc(" {c|{w To choose a race, simply type the name of that race.                   {c|{w{x\n\r",ch);
				stc(" {C+{c------------------------------------------------------------------------{C+{c{x\n\r",ch);
			}
			else
			{
				do_function(ch, &do_help, argument);
			}
			stc( "{cThe voice asks, '{CWhat is %s's race?{c'{x\{Cn\r-> {x", ch );
			break;
		}
		/*
		race = true_pc_race_lookup( argument );
		if ( race == 0 || true_pc_race_table[race].name == NULL )
		{
			stc("{cThe voice states, '{CThat is not a vlid race. What is your race?{c'{x\n\r{C-> {x", ch);
			return;
		}
		*/
			
	case CON_SELECT_CLAN:
	case CON_SELECT_NATION:
		stc("{wA voice intones: {C'{cPlease select a Nationality for your character.{C'{x\n\r", ch );
		stc("  {C+{c-------------------------------------------------------------{C+{x\n\r", ch );
		stc("  {c|{w The People      Region                   Nation             {c|{x\n\r", ch );
		stc("  {C+{c-------------------------------------------------------------{C+{x\n\r", ch );
		stc("  {c|{w Aiel            The Three Fold Land      Aiel               {c|{x\n\r", ch );
		stc("  {c|{w Altaran         Midlanders               Altara             {c|{x\n\r", ch );
		stc("  {c|{w Amadician       Midlanders               Amador             {c|{x\n\r", ch );
		stc("  {c|{w Andoran         Midlanders               Andor              {c|{x\n\r", ch );
		stc("  {c|{w Atha'an Miere   Sea faring people        The Seafolk Isles  {c|{x\n\r", ch );
		stc("  {c|{w Arafellin       Borderlanders            Arafel             {c|{x\n\r", ch );
		stc("  {c|{w Cairhienin      Midlanders               Cairhien           {c|{x\n\r", ch );
		stc("  {c|{w Domani          Midlanders               Arad Doman         {c|{x\n\r", ch );
		stc("  {c|{w Ghealdanin      Midlanders               Ghealdanin         {c|{x\n\r", ch );
		stc("  {c|{w Illianer        Southlanders             Illian             {c|{x\n\r", ch );
		stc("  {c|{w Kandori         Borderlanders            Kandor             {c|{x\n\r", ch );
		stc("  {c|{w Mayener         City State, Southlands   Mayene             {c|{x\n\r", ch );
		stc("  {c|{w Murandian       Midlanders               Murandy            {c|{x\n\r", ch );
		stc("  {c|{w Saldaean        Borderlanders            Saldaea            {c|{x\n\r", ch );
		stc("  {c|{w Seanchan        From Seandar             Seanchan           {c|{x\n\r", ch );
		stc("  {c|{w Shienaran       Borderlanders            Shienar            {c|{x\n\r", ch );
		stc("  {c|{w Taraboner       Midlanders               Tarabon            {c|{x\n\r", ch );
		stc("  {c|{w Tar Valoner     City State, Midlands     Tar Valon          {c|{x\n\r", ch );
		stc("  {c|{w Tairen          Southlanders             Tear               {c|{x\n\r", ch );
		stc("  {c|{w Tuatha'an       The Travelling People    N/A                {c|{x\n\r", ch );
		stc("  {C+{c-------------------------------------------------------------{C+{x\n\r", ch );
		stc("  {c|{w For information on a nationality type 'HELP <nationality>'. {c|{x\n\r", ch );
		stc("  {c|{w For example: HELP Andoran                                   {c|{x\n\r", ch );
		stc("  {c|{w To select a nationality, simply type that nationality.      {c|{x\n\r", ch );
		stc("  {C+{c-------------------------------------------------------------{C+{x{x\n\r", ch );
	case CON_TOUR_PARTIAL:
	case CON_TOUR_FULL:

/* BREAK THE LINK */

    case CON_BREAK_CONNECT:
		switch( *argument )
		{
		case 'y' : case 'Y':
		    for ( d_old = descriptor_list; d_old != NULL; d_old = d_next )
		    {
			d_next = d_old->next;

			if (d_old == d || d_old->character == NULL)
			    continue;

			if (str_cmp(ch->name,d_old->original ?
			    d_old->original->name : d_old->character->name))
			    continue;
			close_socket(d_old);
		    }

		    if (check_reconnect(d,ch->name,TRUE))
		   	return;
		    write_to_buffer(d,"Reconnect attempt failed.\n\rName: ",0);

		    if ( d->character != NULL )
		    {
			    free_char( d->character );
			    d->character = NULL;
		    }
		    d->connected = CON_GET_NAME;
		    break;

		case 'n' : case 'N':
		    write_to_buffer(d,"Name: ",0);
		    if ( d->character != NULL )
		    {
			    free_char( d->character );
			    d->character = NULL;
		    }
		    d->connected = CON_GET_NAME;
		    break;

		default:
		    stc("{cThe voice urges, '{CPlease type Y or N{c'\n\r{C-> {x",ch);
		    break;
		}
		break;

/* CONFIRM THE PLAYER'S NAME, ONLY IF IT'S A NEW PLAYER */

    case CON_CONFIRM_NEW_NAME:
	    SET_BIT(ch->act,PLR_COLOUR);
		switch ( *argument )
		{
			case 'y': case 'Y':
			    stc( "{cThe voice says, '{CYou are new. Please give me a password.{c'\n\r{C-> {x", ch );
			    ch->pcdata->newbie = 1;
			    init_newbie( ch );
			    d->connected = CON_GET_NEW_PASSWORD;
			    break;

			case 'n': case 'N':
			    stc(  "{cThe voice asks, '{CWhat is it, then?{c'\n\r{C-> {x", ch );
			    free_char( d->character );
			    d->character = NULL;
			    d->connected = CON_GET_NAME;
			    break;

			default:
			    stc(  "{cThe voice urges, '{CPlease type Yes or No.{c'\n\r{C-> {x", ch );
			    break;
		}
		break;

/* GET A NEW PASSWORD, ONLY IF THE CHARACTER IS NEW */

    case CON_GET_NEW_PASSWORD:
	    #if defined(unix)
		stc(  "\n\r", ch );
	    #endif

		if ( strlen(argument) < 5 )
		{
		    stc("{cThe voice states, '{CThe password must be at least five characters long.{c'{x\n\r{cIt continues, '{CWhat is the password?{c'\n\r{C-> {x",ch );
		    return;
		}

		pwdnew = crypt( argument, ch->name );
		for ( p = pwdnew; *p != '\0'; p++ )
		{
		    if ( *p == '~' )
		    {
			stc( "{cThe voice states, '{CThe new password is not acceptable. Try again.{c'{x\n\r{CIt continues, '{cWhat is the password?{c'\n\r{C-> {x", ch );
			return;
		    }
		}
		free_string( ch->pcdata->tmp );
		ch->pcdata->tmp = str_dup( argument );
		free_string( ch->pcdata->pwd );
		ch->pcdata->pwd	= str_dup( pwdnew );
		stc("{cThe voice says, '{CPlease retype password.{c'\n\r{C-> {x", ch );
		d->connected = CON_CONFIRM_NEW_PASSWORD;
		break;

/* CONFIRM THE NEW PASSWORD, FOR NEW CHARACTER'S ONLY */

    case CON_CONFIRM_NEW_PASSWORD:
	    #if defined(unix)
		stc(  "\n\r", ch );
	    #endif

		if ( strcmp( crypt( argument, ch->pcdata->pwd ), ch->pcdata->pwd ) )
		{
		    stc("{cThe voice intones, '{CThe passwords do not match.{c'\n\r{cIt continues, '{CRetype the password.{c'\n\r{C-> {x", ch );
		    d->connected = CON_GET_NEW_PASSWORD;
		    return;
		}

		stc(  echo_on_str, ch );
		sprintf( log_buf, "%s@%s new player.", ch->name, d->host );
		log_string( log_buf );
		wiznet("{RNewbie alert{g!  $N sighted.",ch,NULL,WIZ_NEWBIE,0,0);
	    wiznet(log_buf,NULL,NULL,WIZ_SITES,0,get_trust(ch));

		for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
		{
			if ( d_mentor->connected == CON_PLAYING && IS_SET( d_mentor->character->spec_flags,SPEC_MENTOR ) )
			{
				act_new("{w({WMentor Alert{w){W::{x $N. A new player sighted!{x", d_mentor->character,NULL,ch,TO_CHAR,POS_DEAD);
			}
		}
		stc( " {C+{c------------------------------------------------------------------{C+{x\n\r",ch);
		stc( " {c| {wTSE uses last names for characters. Some races, such as seanchan,{c|{x\n\r", ch );
		stc( " {c| {wogier, aiel, and seafolk will use the last name as a family name {c|\n\r", ch );
		stc( " {c| {w(such as 'Son of' for ogier) or not use them at all. Due to the  {c|{x\n\r", ch );
		stc( " {c| {wthat last names are used for other purposes, though, you must    {c|{x\n\r", ch );
		stc( " {c| {wspecify one here.                                                {c|{x\n\r", ch );
		stc( " {C+{c------------------------------------------------------------------{C+{x\n\r",ch);
		ptc( ch, "{cThe voice asks, '{CWhat is %s's last name?{c'{x\n\r{C-> {x", ch->name );
		d->connected = CON_GET_LAST_NAME;
		break;

/* GET THE NEW CHARACTER'S LAST NAME */
	case CON_GET_LAST_NAME:

	    if ( strlen(argument) < 2 )
	    {
			stc( "{cThe voice mutters, '{CThat is not suitable. What is your last name?{c'\n\r{C-> {x", ch );
			d->connected = CON_GET_LAST_NAME;
			break;
		}
	    if ( strstr(argument, "'") != NULL )
	    {
			stc( "{cThe voice mutters, '{CYour name must have only letters. What is your last name?{c'\n\r{C-> {x", ch );
			d->connected = CON_GET_LAST_NAME;
			break;
		}
		if ( !check_parse_name( argument ) )
		{
			display_illegal_name( ch );
			ptc( ch, "{cThe voice says quietly, '{CWhat is %s's last name?{c'\n\r{C-> {x",ch->name );
			d->connected = CON_GET_LAST_NAME;
			break;
		}
		else
		{
			free_string( ch->pcdata->last_name );
			ch->pcdata->last_name = str_dup( capit2(argument) );

			stc( " {C+{c---------------------------------------------------------------------{C+{x\n\r",ch);
			stc( " {c|{w TSE uses email addresses to keep in touch with the players and for  {c|{x\n\r",ch);
			stc( " {c|{w other purposes, such as linking your forum account to your in-game  {c|{x\n\r",ch);
			stc( " {c|{w characters. We will never give out your email address and it will   {c|{x\n\r",ch);
			stc( " {c|{w not be listed within the mud. A new forum account using the same    {c|{x\n\r",ch);
			stc( " {c|{w name as your character will be created automatically.               {c|{x\n\r",ch);
			stc( " {C+{c---------------------------------------------------------------------{C+{x\n\r",ch);

			stc( "{cThe voice whispers, '{CWhat is your email address?{c'\n\r{C-> {x", ch);
			d->connected = CON_GET_EMAIL;
			break;
		}

	case CON_GET_EMAIL:
		fail = FALSE;

		if (strlen(argument) < 5)
		{
			fail = TRUE;
		}

		if (str_infix("@", argument))
		{
			fail = TRUE;
		}

		if (str_infix(".", argument))
		{
			fail = TRUE;
		}

		if (!isalpha(argument[0]))
		{
			fail = TRUE;
		}

		if (!isalpha(argument[strlen(argument) - 1]))
		{
			fail = TRUE;
		}

		/* validate the email address hostname 
		 * this must pick the hostname out of the supplied email
		 * address before it will actually work
		 * - Dalsor 08/29/2013
		 */

		struct hostent *host;
		int at = 0, ei = 0;
		char email_host[MIL];

		for ( at = 0; at < strlen(argument); at++ )
		{
			if (argument[at] == '@' )
			{
				strcpy(&email_host[ei],&argument[at+1]);
				ei++;
			}
		}

		//ptc( ch, "{CPlease wait while we do a quick DNS lookup on {c%s{x.\n\r", email_host );

		host = gethostbyname(email_host);
		if ( !host  )
		{
			fail = TRUE;
		}

		if (!fail)
		{
			if (ch->pcdata && ch->pcdata->email)	
			free_string(ch->pcdata->email);
			ch->pcdata->email = str_dup(argument);
			//stc("We will now create a forum account for you.\n\r", ch);
			create_forum_account( ch );
			stc("{cThe voice says, '{CWelcome, adventurer. Tell me, are you (m)ale or (f)emale?{c'\n\r{C-> {x",ch);
			d->connected = CON_SELECT_GENDER;
			break;
		}
		else
		{
			stc("{cThe voice says, '{CSorry, your email address does not appear to be valid.{c'\n\r",ch);
			stc("{cThe voice whispers, '{CWhat is your email address?{c'\n\r{C-> {x", ch);
			d->connected = CON_GET_EMAIL;
			break;

		}
		break;


	/* FINALLY! */

	case CON_CONNECT_CHAR:
		if ( ch->pcdata != NULL && ch->pcdata->pwd[0] == '\0')
		{
			stc("{RWarning! Null password!{x\n\r",ch );
			stc("{RType 'password null <new password>' to fix this problem.{x\n\r",ch);
		}
		if (d->character->pcdata->rebirthing == FALSE)
		{
			ch->next = char_list;
			char_list = ch;
		}

		/* Should probably do this in load_char, but for now, here it is. */
		if ( !IS_IMMORTAL( ch ) && ch->level >= MAX_LEVEL )
			ch->level = MAX_LEVEL-1;

		reset_char(ch);
		d->connected	 = CON_PLAYING;

		if (is_shadow(ch))	ch->alignment = -500;
		else			ch->alignment = 500;

		if (d->character->pcdata->rebirthing == TRUE)
		{		
			/* Lower skills or remove them if necessary */
			for ( sk = 0; sk < MAX_SKILL; sk++ )
			{
				if (ch->pcdata->learned[sk] <= 0)
					continue;

				if (!str_cmp(skill_table[sk].name, "reserved"))
					continue;

				if ( is_qskill(sk) ) /* All quest skill stick now, but they also cap at 100 -- Dalsor 06/26/2013 */
				{
					if ( ch->pcdata->learned[sk] > QSKILL_CAP )
						ch->pcdata->learned[sk] = QSKILL_CAP;
					continue;
				}

				if (calc_remort_tier(ch) == 1)	/* Newbie */
				{
					ch->pcdata->learned[sk] -= 75;
					if (ch->pcdata->learned[sk] < 0)
						ch->pcdata->learned[sk] = 0;
				}
				else
				{
					ch->pcdata->learned[sk] -= 100;
					if (ch->pcdata->learned[sk] < 0)
						ch->pcdata->learned[sk] = 0;
				}
			}
			ch->pcdata->rebirth += 1;
			ch->level  	 = 1;
			ch->exp	     = exp_per_level(ch,ch->pcdata->points);
			ch->max_hit	= 250;
			ch->max_stam	= 250;
			ch->pcdata->perm_hit	= 250;
			ch->pcdata->perm_mana	= 250;
			ch->hit	   	= get_maxhit(ch);
			ch->stam	= get_maxstam(ch);
			ch->train	= ch->train * .75;
		    	compose_title(ch);
			char_from_room (ch);
	    	        char_to_room( ch, get_room_index( ROOM_VNUM_SCHOOL ) );
		   	ch->pcdata->rebirthing = FALSE;
			init_newbie( ch );
		}
		else if ( ch->level == 0 || ch->pcdata->perm_hit == 0 || ch->pcdata->perm_mana == 0)
		{
			ch->perm_stat[class_table[ch->class].attr_prime] += 3;
			ch->level = 1;
			ch->exp = exp_per_level(ch,ch->pcdata->points);
			ch->max_hit	= 250;
			ch->max_stam	= 250;
			ch->pcdata->perm_hit	= 50;
			ch->pcdata->perm_mana	= 50;
			ch->hit	= get_maxhit(ch);
			ch->stam = get_maxstam(ch);
			ch->train = 150;
			ch->version = 6;
			compose_title(ch);
			char_to_room( ch, get_room_index( ROOM_VNUM_SCHOOL ) );
		}
		else if ( ch->was_in_room != NULL )
		{
		    char_to_room( ch, ch->was_in_room );
		}
		else if ( ch->in_room != NULL )
		{
			if ( ch->pcdata && ch->pcdata->allowed == 0 )
			{
				char_to_room(ch,get_room_index(ROOM_VNUM_SCHOOL));
			}
			else
			    char_to_room( ch, ch->in_room );
		}
		else if ( IS_IMMORTAL(ch) )
		{
		    char_to_room( ch, get_room_index( ROOM_VNUM_BETWEEN ) );
		}
		else if ( ch->version <= 11 )
		{
			char_to_room(ch,get_room_index(ROOM_VNUM_SCHOOL));
		}
		else
		{
		    char_to_room( ch, get_room_index( ROOM_VNUM_PLAZA ) );
		}

		/* do some mysql logging so players can see who logged in last -- Dalsor 4.11.2013 */
		if ( mud_port == play_port )
		{
			mysql_buf[0] = '\0';
			sprintf(mysql_buf, "insert into last_login values (\"\", \"%s\", \"%ld\", \"%s\")",
				ch->name, current_time, ch->desc->host);

			mysql_real_query(result_db, mysql_buf, strlen(mysql_buf));

			if( mysql_affected_rows(result_db) < 1)
			{
				stc("Error writing login to database.\n\r", ch);
				log_string("MYSQL: Error saving channel log.");
			}
		}
		/* end mysql logging */

		wiznet("{c$N busts in on the party.",ch,NULL,WIZ_LOGINS,WIZ_SITES,get_trust(ch));
		act( "{c$n joins in, looking for some adventure.",ch,NULL,NULL,TO_ROOM );

		if (ch->pet != NULL)
		{
		    char_to_room(ch->pet,ch->in_room);
		    act("{c$n joins in, looking for some adventure.",ch->pet,NULL,NULL,TO_ROOM);
		}
		if (ch->mount != NULL)
		{
			char_to_room(ch->mount,ch->in_room);
			act("$n has entered the game.",ch->mount,NULL,NULL,TO_ROOM);
			add_follower(ch->mount, ch);
			do_mount(ch, ch->mount->name);
		}

		// Tweak to set players in a clan that no longer exists to Loner
		if (ch->clan < 1 || clan_table[ch->clan].name == NULL)	ch->clan = 1;

		if ( d && d->character != NULL && d->connected == CON_PLAYING )
		{
			DESCRIPTOR_DATA *vch;
			for ( vch = descriptor_list; vch != NULL; vch = vch->next )
			{
				if ( !vch || vch == NULL )
					continue;
				if ( !vch->character || vch->connected != CON_PLAYING )
					continue;
				if ( IS_IMMORTAL( d->character ) )
					continue;
				else if ( IS_SET( vch->character->comm, COMM_PENTER) && (!IS_SET(vch->character->comm,COMM_QUIET)) )
				{
					act_new("\n\r{w*** {c$n joins in, looking for some adventure.\n\r",
					d->character,NULL,vch->character,TO_VICT,POS_DEAD);
				}
			}
			if ( d->character->pcdata && d->character->pcdata->allowed != 1 && d->character->pcdata->newbie != 1)
				for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
				{
					if ( d_mentor->connected == CON_PLAYING	&& IS_SET( d_mentor->character->spec_flags,SPEC_MENTOR ) )
					{
						act_new("{w({WMentor Alert{w){W::{x $N. An unverified player sighted!{x", d_mentor->character,NULL,ch,TO_CHAR,POS_DEAD);
					}
				}
		}
		sprintf( log_buf, "%s busts in on the party.", ch->name );
		log_string( log_buf );
		wiznet(log_buf,NULL,NULL,WIZ_SITES,0,get_trust(ch));
		stc("\n\r",ch);

		MXPSendTag( d, "<VERSION>" );  /* <--- Add this line */

		save_db_character(ch);


		if ( ch->pcdata->newbie != 1 )
		{
			do_function( ch, &do_events, "" );
			nlcr(ch);
			vote_message( ch );

			if ( count_unread_notes( ch ) > 0 )
				ptc(ch, "{wYou have {R%d unread note%s{w.{w Type {r'{Runread{r'{w to see them.{x\n\r", 
					count_unread_notes(ch), count_unread_notes(ch) > 1 ? "s" : "");

			did_you_know( ch );
                                     
			if ( ch->pcdata->pfile_size > 500000 )
			{
				stc("{RWARNING{r!!! {WYour pfile size is VERY LARGE! Clean out your inventory!{x\n\r", ch);
			}
		}
		else
		{
	    		compose_title(ch);
			SET_BIT(ch->comm, COMM_NODFH);
			do_function( ch, &do_tour, "" );
		}


		//read_mysql_staff( ch );
		ch->pcdata->last_in = current_time;

		break;
    }

    return;

}
