/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include "aww.h"
#include "interp.h"
#include "dance.h"

void dance_print( CHAR_DATA *ch, CHAR_DATA *partner, char *string )
{
}
void do_step( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *partner;
	char arg1[MIL];
	char arg2[MIL];

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( arg1[0] == '\0' || arg2[0] == '\0' )
	{
		stc("Syntax error:\n\r",ch);
		stc("Step into <partner>:\n\r",ch);
		return;
	}
	if ( strcmp( arg1, "into" ) )
	{
		stc("Syntax error:\n\r",ch);
		stc("Missing 'into'\n\r",ch);
		stc("Step into <partner>:\n\r",ch);
		return;
	}
	if ( ( partner = get_char_room( ch, NULL, arg2 ) ) == NULL )
	{
		stc("Syntax error:\n\r", ch);
		stc("Invalid partner:\n\r", ch);
		stc("Step into <partner name>\n\r",ch);
		return;
	}
	if ( IS_NPC( partner )
	|| !partner->desc
	|| !partner->pcdata )
	{
		stc("You can't dance with them right now.\n\r",ch);
		return;
	}
	if ( partner->pcdata->dance_partner != NULL )
	{
		ptc( ch, "%s already has an offer to dance.\n\r", partner->name );
		return;
	}
	if ( partner->pcdata->dance_partner == NULL )
	{
		ptc( ch, "You accept %s's offer to dance.\n\r", partner->name );
		ptc( partner, "%s accepts your offer to dance.\n\r", ch->name );
		partner->pcdata->dance_partner = ch;
		partner->pcdata->dance_last = DanceStepNone;
		return;
	}
}
void do_dance( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *partner;
	char arg1[MIL];
	char arg2[MIL];
	int x;
	bool step = FALSE;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( arg1[0] == '\0' )
	{
		stc("There was a syntax error:\n\r", ch);
		stc("Dance <partner> <step name>\n\r",ch);
		for ( x = 0; x < 9; x++ )
			ptc(ch,"Step %s.\n\r",
				DanceTable[x].danceName);
		return;
	}
	if ( ( partner = get_char_room( ch, NULL, arg1 ) ) == NULL )
	{
		stc("Syntax error:\n\r", ch);
		stc("Dance <partner name> <step name>\n\r",ch);
		for ( x = 0; x < 9; x++ )
			ptc(ch,"Step %s.\n\r",
				DanceTable[x].danceName);
		return;
	}
	if ( IS_NPC( partner )
	|| !partner->desc
	|| !partner->pcdata )
	{
		stc("You can't dance with them right now.\n\r",ch);
		return;
	}
	if ( partner == ch )
	{
		stc("You end your dance.\n\r",ch);
		ch->pcdata->dance_partner = NULL;
		ch->pcdata->dance_last = DanceStepNone;
		ch->pcdata->dance_points = 0;
		return;
	}
	if ( partner->pcdata->dance_partner == NULL )
	{
		ptc(ch,"You entreat %s to dance.\n\r",partner->name);
		ptc(partner,"%s entreats you to dance.\n\r", ch->name);
		partner->pcdata->dance_partner = ch;
		partner->pcdata->dance_last = DanceStepNone;
		return;
	}
	if ( ch->pcdata->dance_partner == NULL )
	{
		stc("You need a dance partner.\n\r",ch);
		return;
	}
	if ( arg2[0] == '\0' )
	{
		stc("There was a syntax error:\n\r", ch);
		stc("Dance <partner> <step name>\n\r",ch);
		for ( x = 0; x < 9; x++ )
			ptc(ch,"Step %s.\n\r",
				DanceTable[x].danceName);
		return;
	}
	for ( x = 0; x < 9; x++ )
	{
		if ( !str_cmp( arg2, DanceTable[x].danceName ) )
		{
			ch->pcdata->dance_last = DanceTable[x].step;

			if ( ch->pcdata->dance_last > DanceStepRight )
			{
				/*if ( ch->pcdata->dance_points < DanceTable[x].points )
				{
					stc("You haven't built up enough momentum.\n\r",ch);
					return;
				}
				if ( partner->pcdata->dance_points < DanceTable[x].points )
				{
					stc("Your partner hasn't built up enough momentum.",ch);
					return;
				}
				ch->pcdata->dance_points -= DanceTable[x].points;*/
			}
			/*
			if ( ch->pcdata->dance_last < DanceStepRight )
			{
				ch->pcdata->dance_points += DanceTable[x].points;
				partner->pcdata->dance_points += DanceTable[x].points;
			}*/

			act(DanceTable[x].danceChar, ch, NULL, partner, TO_CHAR);
			act(DanceTable[x].dancePartner, ch, NULL, partner, TO_VICT);
			act(DanceTable[x].danceRoom, ch, NULL, partner, TO_NOTVICT);
			WAIT_STATE( ch, PULSE_VIOLENCE );
			WAIT_STATE( partner, PULSE_VIOLENCE / 2 );
			step = TRUE;
			break;
		}
	}
	if ( !step )
	{
		stc("Syntax error:\n\r", ch);
		stc("Dance <partner> <step name>\n\r",ch);
		stc("Step was not valid.\n\r",ch);
		stc("Valid steps are:\n\r",ch);
		for ( x = 0; x < 9; x++ )
			ptc(ch,"Step %s.\n\r",
				DanceTable[x].danceName);
	}
	return;
}
