/* The Darkfriend Hunt was coded by Scott Rothrock,
* who can be contacted at TickTocks@hotmail.com,
* for As the Wheel Weaves (www.aww-mud.org:6500).
*/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"
#include "dfhunt.h"

/* cirion:
   assumed this:

   dfhunt_game_info[]:
   [0] = game status, 0 = NO HUNT, 1 = PREL, 2 = UNUSED?, 3 = DAY, 4 = 
NIGHT
   [1] = num of players left in game
   [2] = num of AS left
   [3] = num of W left
   [4] = num of DF left
   [5] = total actions this round
   [6] = 

   dfhunt_player_info[]:
   [0] = role, 0 = not in DFH, 2 = AS, 3 = W, 4 = DF, rest are 
villagers
   [1] = survived
   [2] = died
   [3] = creator of this DFH
   [4] = votes
   [5] = action (voted/killed/protected/identified)
   [6] = protected

*/



/*
void do_dfhstat(CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	char buf[MAX_STRING_LENGTH];

	buf[0] = '\0';

	if(!IS_IMMORTAL(ch) || strcmp(ch->name, "Scott"))
	{
		send_to_char("I could not find that command.\n\rCheck your spelling and check the help files.\n\r", ch);
		return;
	}

	if(argument[0] == '\0')
	{
		send_to_char("DFHstat whom?\n\r", ch);
		return;
	}

	if((victim = get_char_world(ch, argument)) == NULL)
	{
		send_to_char("They aren't here.\n\r", ch);
		return;
	}

	if(IS_NPC(victim))
	{
		send_to_char("Not on a mob.\n\r", ch);
		return;
	}

	sprintf(buf, "%i - darkfriends left\n\r"
	             "%i - role  %i - survived  "
                     "%i - died\n\r%i - created?  "
                     "%i - votes  %i - action?\n\r"
                     "%i - protected?\n\r", 
		     dfhunt_game_info[4], 
		     victim->pcdata->dfhunt_player_info[0], 
victim->pcdata->dfhunt_player_info[1], 
		     victim->pcdata->dfhunt_player_info[2], 
victim->pcdata->dfhunt_player_info[3], 
		     victim->pcdata->dfhunt_player_info[4], 
victim->pcdata->dfhunt_player_info[5], 
		     victim->pcdata->dfhunt_player_info[6]);
	send_to_char(buf, ch);

	return;
}
*/

int night_timer = 0;
int day_timer = 0;
int num_ties = 0;

bool check_victory(void)
{
	char buf[MAX_STRING_LENGTH];
	CHAR_DATA *ach;
	DESCRIPTOR_DATA *d;
	bool vict = FALSE;
	int i;
#if DFHUNT_JOIN_COST > 0
	int goldprize;
#endif


	/* Check Shadow Victory */
	/* cirion: added check so this has to have atleast 1 DF left */
	if(dfhunt_game_info[PLAYER_LEFT] == 0)
	{
		sprintf(buf, "{WNo one has won {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r");
		dfhunt_talk(NULL, buf, 0);
		vict = TRUE;
	}
	else if ((dfhunt_game_info[PLAYER_LEFT] - dfhunt_game_info[DF_LEFT]) <= dfhunt_game_info[DF_LEFT]  && dfhunt_game_info[DF_LEFT] && (dfhunt_game_info[W_LEFT] == 0 || dfhunt_game_info[PLAYER_LEFT] <= 2) )
	{
		/* this condidtion needs work. Maybe not win if the warder is still in existence */
#if DFHUNT_JOIN_COST > 0
		goldprize = (DFHUNT_JOIN_COST * dfhunt_game_info[TOTAL_PLAYERS]) / dfhunt_game_info[DF_LEFT] ;

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] == P_DF)
			{
				ach->pcdata->dfhunt_player_info[P_SURVIVED]++;

				sprintf(buf, "You have won %i {ygold{x!\n\r", goldprize);
				send_to_char(buf, ach);

				/*ach->gold = ach->gold + goldprize; */
				ach->money[3][0] = ach->money[3][0] + goldprize;
			}

			if (ach->pcdata->dfhunt_player_info[P_ROLE] != P_DF 
				 && ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
				ach->pcdata->dfhunt_player_info[P_DIED]++;
		}
#else 
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] == P_DF)
			{
				ach->pcdata->dfhunt_player_info[P_SURVIVED]++;
				sprintf(buf, "You have won!\n\r");
				send_to_char(buf, ach);
			}
			else if ( ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
				ach->pcdata->dfhunt_player_info[P_DIED]++;
		}
#endif

		sprintf(buf, "{WThe {DS{whadow{W has won {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r");
		dfhunt_talk(NULL, buf, 0);
		vict = TRUE;
	}

	/* Check Light Victory */
	else if (dfhunt_game_info[DF_LEFT] == 0)
	{
#if DFHUNT_JOIN_COST > 0
		goldprize = 0;
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
				goldprize++;
		}

		/*goldprize = (DFHUNT_JOIN_COST / 2) * goldprize; */ /* this is a little wack */
		goldprize = (DFHUNT_JOIN_COST * dfhunt_game_info[TOTAL_PLAYERS] ) / goldprize; /* this is a little wack */

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
			{
				ach->pcdata->dfhunt_player_info[P_SURVIVED]++;

				sprintf(buf, "You have won %i {ygold{x!\n\r", goldprize);
				ach->money[3][0] = ach->money[3][0] + goldprize;
				send_to_char(buf, ach);
			}
		}
#else
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
			{
				ach->pcdata->dfhunt_player_info[P_SURVIVED]++;

				sprintf(buf, "You have won!\n\r");
				send_to_char(buf, ach);
			}
		}
#endif

		sprintf(buf, "The {YL{yi{Wg{yh{Yt{W has won {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r");
		dfhunt_talk(NULL, buf, 0);
		vict = TRUE;

	} /* end check for light victory */
	if (vict)
	{
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			for (i = 0; i < 7; i++)
			{
				if (i == P_SURVIVED || i == P_DIED) /* 1 and 2 */
					continue;

				ach->pcdata->dfhunt_player_info[i] = 0;
			}
		}
		day_timer = 0;
		night_timer = 0;
		for (i = 0; i < 7; i++)
			dfhunt_game_info[i] = 0;
		return TRUE;
	}
        return FALSE;
}
void dfhunt_update()
{
	CHAR_DATA *ach;
	char buf[MAX_STRING_LENGTH];
	char buf2[MSL];
	DESCRIPTOR_DATA *d;
	char name[MAX_STRING_LENGTH];
	char sex[MAX_STRING_LENGTH];
	/*
	CHAR_DATA *bch;
	DESCRIPTOR_DATA *c;
	bool tie = FALSE;
	*/
	//char testname[100];
	int i;

	//int x;

	if (dfhunt_game_info[GAME_STAT] <= PREL)	/* Game running? */
		return;

	dfhunt_recount();
	if (dfhunt_game_info[GAME_STAT] == DAY)	/* Is it day? */
	{
		CHAR_DATA *lynch_victim = NULL;
		/* well what if someone voted then dropped link??????   */
		if (dfhunt_game_info[ACTIONS] >= dfhunt_game_info[PLAYER_LEFT] || day_timer >= 5)	/* Everyone has voted */
		{
			char role[MAX_STRING_LENGTH];
			int same_votes = 0;
			int maxvotes= 0;
			for (d = descriptor_list; d != NULL ; d = d->next)
			{
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;
			 	if (ach->pcdata->dfhunt_player_info[P_VOTES] > maxvotes)
			 	{
			  	    maxvotes = ach->pcdata->dfhunt_player_info[P_VOTES];
			  	    same_votes = 0;
				    lynch_victim = ach;
			 	}
			 	else if (ach->pcdata->dfhunt_player_info[P_VOTES] == maxvotes)
			  	    same_votes++;
			}
			if ( same_votes > 0 )
			/* cirion: uncommented, should work i think after added check for countvotes */
			{
			    num_ties++;
			    sprintf(buf2, "There is a tie with %d votes. Votes have been reset.\n\r", maxvotes);
			    dfhunt_talk(NULL, buf2, 0);
			    dfhunt_game_info[ACTIONS] = 0;
			    for (d = descriptor_list; d != NULL; d = d->next)
			    {
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;
				ach->pcdata->dfhunt_player_info[P_VOTES] = 0;
				ach->pcdata->dfhunt_player_info[P_ACTION] = 0;
			    }
			    day_timer = 0;
			    if(num_ties < 5)
			    {
			        if(num_ties > 2 ) 
				{
			            sprintf(buf2, "Night is drawing near, only %d chance%s left.\n\r", 5 - num_ties,num_ties==4?"":"s");
			    	    dfhunt_talk(NULL, buf2, 0);
				}
				return;
			    } else
				lynch_victim = NULL;
			}
			num_ties = 0;
			if(lynch_victim)
			{
			    sprintf(name, "%s", lynch_victim->name);
/*			    countvotes = lynch_victim->pcdata->dfhunt_player_info[P_VOTES]; */
			    if (lynch_victim->sex == 1)
				sprintf(sex, "him");
			    else if (lynch_victim->sex == 2)
				sprintf(sex, "her");
			    else 
				sprintf(sex, "it");

			    switch (lynch_victim->pcdata->dfhunt_player_info[P_ROLE])
			    {
				case 4:	  /* Darkfriend */
					sprintf(role, "{BD{bark{Bf{briend{x");
					dfhunt_game_info[DF_LEFT]--;
					break;

				case 3:	  /* Warder */
					sprintf(role, "{WW{wa{Wrd{we{Wr{x");
					dfhunt_game_info[W_LEFT]--;
					break;

				case 2:	  /* Aes Sedai */
					sprintf(role, "{yAe{ws {WSe{wd{yai{x");
					dfhunt_game_info[AS_LEFT]--;
					break;

				default:  /* Villager */
					sprintf(role, "{Yt{yowns{Yp{yerson{x");
					break;
			    }
						
				


			    buf[0] = '\0';
			    sprintf(buf, "%s has been accused of being a {BD{bark{Bf{briend{W!\n\r", name);
			    dfhunt_talk(NULL, buf, 0);
			    sprintf(buf, "An angry mob converges on %s and brutally lynches %s!\n\r", name, sex);
			    dfhunt_talk(NULL, buf, 0);

			    /* Tell the player they're out of the game, tell mob who player was. */
			    for (d = descriptor_list; d != NULL ; d = d->next)
			    {
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				ach->pcdata->dfhunt_player_info[P_ACTION] = 0;
				
/*				if (!str_prefix(ach->name, name)
					 && ach->pcdata->dfhunt_player_info[0] > 0)
					 */
			    }

			    for (i = 0; i < 7; i++)
			    {
				if (i == P_SURVIVED || i == P_DIED )  /* 1 and 2 */
					continue;

				lynch_victim->pcdata->dfhunt_player_info[i] = 0;
			    }
			    lynch_victim->pcdata->dfhunt_player_info[P_DIED]++;
			    sprintf(buf, "{D[{RH{runters{D]{W You die. Rest in pieces.\n\r");
			    send_to_char(buf, lynch_victim);
			    sprintf(buf, "%s{W was really a %s{W!{x\n\r", name, role);
			    dfhunt_talk(NULL, buf, 0);
			    dfhunt_game_info[PLAYER_LEFT]--;
			    day_timer = 0;
			}
			else
			{
			    sprintf(buf, "After much debate, the {Ysun{W sets, and no one gets lynched.\n\r");
			    dfhunt_talk(NULL, buf, 0);
			}


			if(check_victory())
				return;

			/* Make it night */
			dfhunt_game_info[GAME_STAT] = NIGHT;
			dfhunt_game_info[ACTIONS] = 0;

			for (d = descriptor_list; d != NULL; d = d->next)
			{
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				if (ach->pcdata->dfhunt_player_info[P_ROLE] > 0)
				{
					for (i = 4; i < 7; i++)
						ach->pcdata->dfhunt_player_info[i] = 0;
				}
			}
			sprintf(buf, "{DN{wight{W falls on the town, and you sleep in fear of the {DShadow{W.{x\n\r");
			dfhunt_talk(NULL, buf, 0);
		}
		else 
		/*if (dfhunt_game_info[ACTIONS] < dfhunt_game_info[PLAYER_LEFT])*/	/* Not everyone has voted */
		{
			CHAR_DATA *ach;
			sprintf(buf, "{D[{RH{runters{D] {WYou glance at your fellow townspeople, trying to find a {BD{bark{Bf{briend{W.{x\n\r");
			if(day_timer < 3)
			    sprintf(buf2, "{D[{RH{runters{D] {WYou wait patiently for your fellow townspeople to decide who is the {BD{bark{Bf{briend{W.{x\n\r");
			else
			    sprintf(buf2, "{D[{RH{runters{D] {WYou grow increasingly impatient waiting for your fellow townspeople to decide who is the {BD{bark{Bf{briend{W.{x\n\r");
			for (d = descriptor_list; d != NULL ; d = d->next)
			{
				

				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				if (ach->pcdata->dfhunt_player_info[P_ROLE] != P_NOT_IN_HUNT)
				{
				    if( ach->pcdata->dfhunt_player_info[P_ACTION] == FALSE)
				        send_to_char(buf, ach);
				    else
					stc(buf2, ach);
				}
			}
			day_timer++;
			return;
		}
	}

	if (dfhunt_game_info[GAME_STAT] == NIGHT)
	{
			/* Daytime! */
		if ( (dfhunt_game_info[ACTIONS] >= (dfhunt_game_info[DF_LEFT] + dfhunt_game_info[W_LEFT] + dfhunt_game_info[AS_LEFT]) ) || (night_timer > 5) )
		{
			sprintf(buf, "The {Ysun{W rises to another, uneasy day...{x\n\r");
			dfhunt_talk(NULL, buf, 0);
			if(check_victory())
				return;
			dfhunt_game_info[GAME_STAT] = DAY;
			dfhunt_game_info[ACTIONS] = 0;
			night_timer = 0;
			
			for (d = descriptor_list; d != NULL; d = d->next)
			{
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
				{
					for (i = 4; i < 7; i++)
						ach->pcdata->dfhunt_player_info[i] = 0;
				}
			}

		} else
/*		if (dfhunt_game_info[ACTIONS] < (dfhunt_game_info[DF_LEFT] + dfhunt_game_info[W_LEFT] + dfhunt_game_info[AS_LEFT])) */
		{
			sprintf(buf, "The silence of the {Dn{wight{W permeates the village.{x\n\r");
			dfhunt_talk(NULL, buf, 0);

			/* Look for Warder, Sedai, and DFs */
			for (d = descriptor_list; d != NULL; d = d->next)
			{
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				switch (ach->pcdata->dfhunt_player_info[P_ROLE])
				{
				case P_DF:		  /* Darkfriend */
					if (ach->pcdata->dfhunt_player_info[P_ACTION] == 0)
					{
						sprintf(buf, "{D[{RH{runters{D] {WTime to kill...{x\n\r");
						send_to_char(buf, ach);
					}
					else
					{
						sprintf(buf, "{D[{RH{runters{D] {WYou wait anxiously for morning.{x\n\r");
						send_to_char(buf, ach);
					}
					break;

				case P_W:		  /* Warder */
					if (ach->pcdata->dfhunt_player_info[P_ACTION] == 0)
					{
						sprintf(buf, "{D[{RH{runters{D] {WTime to find someone to protect for the night...{x\n\r");
						send_to_char(buf, ach);
					}
					else
					{
						sprintf(buf, "{D[{RH{runters{D] {WYou wonder if you protected the right person.{x\n\r");
						send_to_char(buf, ach);
					}
					break;

				case P_AS:		  /* Aes Sedai */
					if (ach->pcdata->dfhunt_player_info[P_ACTION] == 0)
					{
						sprintf(buf, "{D[{RH{runters{D] {WTime to examine someone's past...{x\n\r");
						send_to_char(buf, ach);
					}
					else
					{
						sprintf(buf, "{D[{RH{runters{D] {WYou wonder if you should have examined someone else.{x\n\r");
						send_to_char(buf, ach);
					}
					break;
				}

				if (ach->pcdata->dfhunt_player_info[P_PROTECTED] == 1)
				{
					sprintf(buf, "{D[{RH{runters{D] {WYou feel a bit safer in the night...{x\n\r");
					send_to_char(buf, ach);
				}
				if(night_timer > 3 && ach->pcdata->dfhunt_player_info[P_ROLE] != P_NOT_IN_HUNT)
					stc("{D[{RH{runters{D] {WThe sky is starting to lighten...{x\n\r",ach);
			}
			night_timer++;
		}

	}
}

void dfhunt_recount()
{
	CHAR_DATA *ach;
	DESCRIPTOR_DATA *d;
	int i = 0;
	int actions=0;

	int role;

	dfhunt_game_info[AS_LEFT] = 0;
	dfhunt_game_info[W_LEFT] = 0;
	dfhunt_game_info[DF_LEFT] = 0;

	/* Recalculate total DFH players, taking account LD people */
	for (d = descriptor_list; d != NULL; d = d->next)
	{
		if( d->connected != CON_PLAYING )
			continue;
		ach = (d->original != NULL) ? d->original : d->character;
		if( ach == NULL )
			continue;

		if ( ( role = ach->pcdata->dfhunt_player_info[P_ROLE]) > P_NOT_IN_HUNT)
		{
			if (role > P_T)
				dfhunt_game_info[role]++; /* don't change role ordering */
			i++;
			if(ach->pcdata->dfhunt_player_info[P_ACTION])
			    actions++;
		}
	}
	/* debugging
	{
		char buf[MSL];
		sprintf(buf,"%d actions, %d chars %d %d %d",dfhunt_game_info[ACTIONS], dfhunt_game_info[PLAYER_LEFT], dfhunt_game_info[2], dfhunt_game_info[3], dfhunt_game_info[4]);
	dfhunt_talk(NULL, buf, 0);
	}
	*/

	dfhunt_game_info[PLAYER_LEFT] = i;
	dfhunt_game_info[ACTIONS] = actions;

	return;
}

void do_dfhunt(CHAR_DATA * ch, char *argument)
{
	char buf[MAX_STRING_LENGTH];
	char arg1[MAX_STRING_LENGTH];
	char arg2[MAX_STRING_LENGTH];
	int i;							  /* Temporary storage for some things */
	char name[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	CHAR_DATA *victim;

	buf[0] = '\0';

	argument = one_argument(argument, arg1);

	if (IS_NPC(ch))
	{
		send_to_char("Mobs cannot participate in the {BD{bark{Bf{briend {RH{runt{x!\n\r", ch);
		return;
	}

	if (arg1[0] == '\0' || (str_prefix(arg1, "create") 
		 && str_prefix(arg1, "join")
		 && str_prefix(arg1, "start")
		 && str_prefix(arg1, "accuse")
		 && str_prefix(arg1, "talk")
		 && str_prefix(arg1, "leave")
		 && str_prefix(arg1, "status")
		 && str_prefix(arg1, "kill")
		 && str_prefix(arg1, "protect")
		 && str_prefix(arg1, "identify")
		 && str_prefix(arg1, "end")
		 && str_prefix(arg1, "who")
		 && str_prefix(arg1, "remove"))
		 || (!str_prefix(arg1, "accuse") && argument[0] == '\0')
		 || (!str_prefix(arg1, "kill") && argument[0] == '\0')
		 || (!str_prefix(arg1, "identify") && argument[0] == '\0')
		 || (!str_prefix(arg1, "protect") && argument[0] == '\0'))
	{
		for (i = 0; i < 19; i++)
			send_to_char(dfhunt_syntax[i].line, ch);

		return;
	}

	if (!str_prefix(arg1, "create"))
	{
		/*if(ch->gold < DFHUNT_CREATE_COST) */
		if (ch->money[3][0] < DFHUNT_CREATE_COST)
		{
			/*
			i = DFHUNT_CREATE_COST;

			sprintf(buf, "You don't have %i {Ygold{x on hand.\n\r", i);  */
			sprintf(buf, "You don't have %d {Ygold{x on hand.\n\r", DFHUNT_CREATE_COST ); 
			send_to_char(buf, ch);
			return;
		}

		if (dfhunt_game_info[GAME_STAT] > 0)
		{
			if (dfhunt_game_info[GAME_STAT] == PREL)
				sprintf(buf, "The {RH{runt{x is already in its preliminary stages.\n\r");
			if (dfhunt_game_info[GAME_STAT] > PREL)
				sprintf(buf, "The {RH{runt{x is already underway!\n\r");

			send_to_char(buf, ch);

			return;
		}

		dfhunt_create(ch, DFHUNT_CREATE_COST);
		day_timer = 0;
		night_timer = 0;
		num_ties = 0;

		return;
	}

	if (!str_prefix(arg1, "join"))
	{
		CHAR_DATA *ach; 
		if (ch->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
		{
			send_to_char("You are already in the {RH{runt{x!\n\r", ch);
			return;
		}
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;
			if ( ( ach->pcdata->dfhunt_player_info[P_ROLE]) > P_NOT_IN_HUNT)
			{
				if(is_alt_of(ch,ach))
				{
			    		stc("You already have an alt in the {RH{runt{x!\n\r", ch);
			    		return;
				}
			}
		}
#if DFHUNT_JOIN_COST > 0
		/*if(ch->gold < DFHUNT_JOIN_COST) */
		if (ch->money[3][0] < DFHUNT_JOIN_COST)
		{
			i = DFHUNT_JOIN_COST;

			sprintf(buf, "You don't have %i {Ygold{x on hand.\n\r", i);
			send_to_char(buf, ch);

			return;
		}
#endif

		switch (dfhunt_game_info[GAME_STAT])
		{
		case NO_HUNT:
			send_to_char("There is no {RH{runt{x for you to join!\n\r", ch);
			return;

		case PREL:
			dfhunt_join(ch, DFHUNT_JOIN_COST);
			return;

		default:
			send_to_char("The {Rh{runt{x is already underway!\n\r", ch);
			return;
		}

		/* And just in case something odd happens... */
		send_to_char("{RBUG{x: Note Scott.\n\r", ch);
		return;
	}

	if (!str_prefix(arg1, "talk"))
	{
		one_argument(argument, arg1);

		dfhunt_talk(ch, argument, 1);
		return;
	}

	if (!str_prefix(arg1, "start"))
	{
		CHAR_DATA *dch;
		int tracker[4] = { 0, 0, 0, 0 };	/* cirion: was not initialized */
		int person_number = 1;
		/*
		for (i = 0; i < 4; i++)
			tracker[i] = 0;
			*/

		if (dfhunt_game_info[GAME_STAT] == NO_HUNT)
		{
			send_to_char("There is no {Rh{runt{x to start!\n\rYou must create one first!\n\r", ch);
			return;
		}
		if (dfhunt_game_info[GAME_STAT] != PREL )
		{
			stc("The {Rh{runt{x has already started, silly.\n\r", ch);
			return;
		}
		if (ch->pcdata->dfhunt_player_info[P_ROLE] == P_NOT_IN_HUNT)
		{
			stc("You are not in the {Rh{runt{x!\n\r", ch);
			return;
		}
		if (ch->pcdata->dfhunt_player_info[P_CREATOR] != 1)
		{
			CHAR_DATA *ach;

			send_to_char("You did not create this {Rh{runt{x!\n\r", ch);
			for (d = descriptor_list; d != NULL; d = d->next)
			{
				if( d->connected != CON_PLAYING )
					continue;
				ach = (d->original != NULL) ? d->original : d->character;
				if( ach == NULL )
					continue;

				if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT && ach->pcdata->dfhunt_player_info[P_CREATOR])
					return;
					
			}
			stc("But the creator left so, why not!\n\r", ch);
		}

		if (dfhunt_game_info[PLAYER_LEFT] < 10)
		{
			send_to_char("You need at least 10 players before you can start the {Rh{runt{x.\n\r", ch);
			return;
		}


		sprintf(buf, "%s has started {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ch->name);
		dfhunt_talk(ch, buf, 0);

		sprintf(buf, "{BD{bark{Bf{briends{W have been killing in your idyllic village... it's up to YOU to find them!{x\n\r");
		dfhunt_talk(ch, buf, 0);
		dfhunt_game_info[GAME_STAT] = DAY;
		dfhunt_game_info[TOTAL_PLAYERS] = dfhunt_game_info[PLAYER_LEFT];

		tracker[0] = number_range(1, dfhunt_game_info[1]);	/* DF 1 */

		while ((tracker[1] == tracker[0]) || (tracker[1] == 0))	/* DF 2 */
			tracker[1] = number_range(1, dfhunt_game_info[1]);

		while ((tracker[2] == tracker[1]) || (tracker[2] == tracker[0])	/* AS */
				 || (tracker[2] == 0))
			tracker[2] = number_range(1, dfhunt_game_info[1]);

		while ((tracker[3] == tracker[2]) || (tracker[3] == tracker[1])	/* 
Warder */
				 || (tracker[3] == tracker[0]) || (tracker[3] == 0))	/* cirion was 
bug: tracker[3] == tracker[1] twice */
			tracker[3] = number_range(1, dfhunt_game_info[1]);

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			dch = (d->original != NULL) ? d->original : d->character;
			if( dch == NULL )
				continue;

			if (dch->pcdata->dfhunt_player_info[P_ROLE] == P_T)
			{
				if (person_number == tracker[0] || person_number == tracker[1])
				{
					dch->pcdata->dfhunt_player_info[P_ROLE] = P_DF;
					dfhunt_game_info[DF_LEFT]++;
					send_to_char("You are a {BD{bark{Bf{briend{W!{x\n\r", dch);
				}

				else if (person_number == tracker[2])
				{
					dch->pcdata->dfhunt_player_info[P_ROLE] = P_AS;
					dfhunt_game_info[AS_LEFT] = 1;
					send_to_char("You are an {yAe{ws {WSe{wd{yai{W!{x\n\r",
									 dch);
				}

				else if (person_number == tracker[3])
				{
					dch->pcdata->dfhunt_player_info[P_ROLE] = P_W;
					dfhunt_game_info[W_LEFT] = 1;
					send_to_char("You are a {WW{wa{Wrd{we{Wr{W!{x\n\r", dch);
				}

				else 
					send_to_char("You are a {Yt{yowns{Yp{yerson{W.{x\n\r", dch);

				for (i = 4; i < 7; i++)
				{
/*					if (i == 1 || i == 2 || i == 3 || i == 0)
						continue;
*/
					dch->pcdata->dfhunt_player_info[i] = 0;
				}
				person_number++;
			}
		}

		return;
	}

	if (!str_prefix(arg1, "who"))
	{
		CHAR_DATA *dch;
		int countplayers = 0;
		/*
		bool found = FALSE;
		bool lb = FALSE;
*/
		if (dfhunt_game_info[GAME_STAT] == NO_HUNT)
		{
			send_to_char("There is currently no {Rh{runt{x.\n\r", ch);
			return;
		}

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			dch = (d->original != NULL) ? d->original : d->character;
			if( dch == NULL )
				continue;

			if (dch->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
			{
				sprintf(buf, "%s ", dch->name);
				strcat(buf, "is in {wThe {BD{bark{Bf{briend {RH{runt{x.");

				if (dfhunt_game_info[GAME_STAT] == DAY)
				{
					switch (dch->pcdata->dfhunt_player_info[P_ACTION])
					{
					case 0:
						strcat(buf, " {R[{rNO{R]{x");
						break;

					case 1:
						strcat(buf, " {G[{gYES{G]{x");
						break;

					default:
						strcat(buf, " [BUG]");
						break;
					}
				}

				countplayers++;
				strcat(buf, "\n\r");
				send_to_char(buf, ch);
			}
		}

		sprintf(buf, "\n\rTotal players: %i\n\r", countplayers);
		send_to_char(buf, ch);

		return;
	}

	if (!str_prefix(arg1, "end"))
	{
		CHAR_DATA *ach;

		if (dfhunt_game_info[GAME_STAT] == NO_HUNT)
		{
			send_to_char("There is no {Rh{runt{x to end!\n\r", ch);
			return;
		}

		if (ch->pcdata->dfhunt_player_info[P_CREATOR] != 1 && !IS_IMMORTAL(ch))
		{
			send_to_char("Only the person who started the {Rh{runt{x can end it.\n\r", ch);
			return;
		}

		sprintf(buf, "%s has ended {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ch->name);
		dfhunt_talk(ch, buf, 0);

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
			{
				if (ach->pcdata->dfhunt_player_info[P_CREATOR] == 1)
					/*ach->gold += DFHUNT_CREATE_COST; */
					ach->money[3][0] += DFHUNT_CREATE_COST;
				else
					/*ach->gold += DFHUNT_JOIN_COST; */
					ach->money[3][0] += DFHUNT_JOIN_COST;

				for (i = 0; i < 7; i++)
				{
					if (i == P_SURVIVED || i == P_DIED)
						continue;

					ach->pcdata->dfhunt_player_info[i] = 0;
				}
			}
		}

		for (i = 0; i < 7; i++)
			dfhunt_game_info[i] = 0;

		return;
	}

	if (!str_prefix(arg1, "status"))
	{
		if (dfhunt_game_info[0] > 0)
		{
			sprintf(buf, "{wThe {BD{bark{Bf{briend {RH{runt{x was started by %s.\n\r", dfhunt_creator_name);
			send_to_char(buf, ch);
		}
		else
			send_to_char("{wThe {BD{bark{Bf{briend {RH{runt{x is currently not running.\n\r", ch);

		switch (dfhunt_game_info[0])
		{
		case 0:
			sprintf(name, "{RN{rot {RR{running{x");
			break;

		case 1:
			sprintf(name, "{MA{mccepting {MP{mlayers{x");
			break;

		case 3:
			sprintf(name, "{YD{yay{x");
			break;

		case 4:
			sprintf(name, "{DN{wight{x");
			break;
		}

		sprintf(buf, "{WG{wame {WS{wtatus{D: %-17s Players: %i\n\r", name, dfhunt_game_info[1]);
		send_to_char(buf, ch);

		sprintf(buf, "{RH{runts {GS{gurvived{W: {y%3i   {RH{runts {DD{wied{W:{y%3i{x\n\r", ch->pcdata->dfhunt_player_info[1], ch->pcdata->dfhunt_player_info[2]);
		send_to_char(buf, ch);

		return;
	}
	if (dfhunt_game_info[0] == 0)
	{
		send_to_char("There is no {Rh{runt{x running.\n\r", ch);
		return;
	}
	argument = one_argument(argument, arg2);
	if (!str_prefix(arg1, "leave"))
	{
		char buf2[MAX_STRING_LENGTH];
/*
		if (ch->pcdata->dfhunt_player_info[P_CREATOR] == 1 && dfhunt_game_info[GAME_STAT] <= PREL)
		{
			stc("Since you are the creator, you can't leave the hunt until it has been started.\n\r", ch);
			return;
		}
		*/
		
		if (ch->pcdata->dfhunt_player_info[P_ROLE] == P_NOT_IN_HUNT)
		{
			send_to_char("You cannot leave the {Rh{runt{x because you are not in it!\n\r", ch);
			return;
		}

		if (dfhunt_game_info[GAME_STAT] != PREL )
		{
			
			if( dfhunt_game_info[GAME_STAT] != NIGHT && str_cmp(arg2,"quit_force") )
			{
			    send_to_char("You can only leave the {Rh{runt{x in the preliminary stages or at night!\n\r", ch);
			    return;
			}
			

			switch (ch->pcdata->dfhunt_player_info[P_ROLE])
			{
			case P_AS:
				sprintf(buf2, "{yAe{ws {WSe{wd{yai{x");
				dfhunt_game_info[AS_LEFT] = 0;
				break;

			case P_W:
				sprintf(buf2, "{WW{wa{Wrd{we{Wr{x");
				dfhunt_game_info[W_LEFT] = 0;
				break;

			case P_DF:
				sprintf(buf2, "{BD{bark{Bf{briend{x");
				dfhunt_game_info[DF_LEFT]--;
				break;
			default:
				sprintf(buf2, "{Yt{yowns{Yp{yerson{x");
				break;
			}
			sprintf(buf, "%s the %s has left {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ch->name, buf2);
		}
		else
			sprintf(buf, "%s has left {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ch->name);


		dfhunt_talk(ch, buf, 0);

		dfhunt_game_info[PLAYER_LEFT]--;
		dfhunt_game_info[TOTAL_PLAYERS]--;

		for (i = 0; i < 7; i++)
		{
			if (i == 1 || i == 2)
				continue;

			ch->pcdata->dfhunt_player_info[i] = 0;
		}

#if DFHUNT_JOIN_COST > 0
		i = DFHUNT_JOIN_COST / 2;

		sprintf(buf, "You have been given back %i {Ygold{x.\n\r", i);
		send_to_char(buf, ch);
		/*ch->gold += i; */
		ch->money[3][0] += i;
#endif
		return;
	}
	victim = get_char_dfhunt(ch,arg2);
	if(!victim)
	{
		sprintf(buf, "There is no one like %s playing DFHunt.\n\r", arg2);
		send_to_char(buf, ch);
		return;
	}
	/* begin targetted commands */
	if (!str_prefix(arg1, "remove"))
	{
		if (!IS_IMMORTAL(ch))
		{
			send_to_char("Only an immortal can remove a player from the {Rh{runt{x.\n\r", ch);
			return;
		}

/*		if (dfhunt_game_info[0] == 1)
		{
			send_to_char("The {Rh{runt{x has not started!\n\r", ch);
			return;
		}
*/
		if (dfhunt_game_info[0] != 1 && dfhunt_game_info[0] != 4)
		{
			send_to_char("You can only remove someone in the preliminary stages or at night!\n\r", ch);
			return;
		}
/*
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			CHAR_DATA *ach;
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[0] == 0)
			{
				sprintf(buf, "%s is not in {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ach->name);
				send_to_char(buf, ch);

				return;
			}

			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[0] > 0)
			{
			*/
		if (dfhunt_game_info[GAME_STAT] <= PREL)
			sprintf(buf, "%s{W has been removed from the game by an immortal.{x\n\r", victim->name);
		else
		{
			switch (victim->pcdata->dfhunt_player_info[0])
			{
			case 4:			  /* Darkfriend */
				sprintf(name, "{BD{bark{Bf{briend{x");
				dfhunt_game_info[4] = dfhunt_game_info[4] - 1;
				break;

			case 3:			  /* Warder */
				sprintf(name, "{WW{wa{Wrd{we{Wr{x");
				dfhunt_game_info[3] = 0;
				break;

			case 2:			  /* Aes Sedai */
				sprintf(name, "{yAe{ws {WSe{wd{yai{x");
				dfhunt_game_info[2] = 0;
				break;

			case 1:			  /* Villager */
				sprintf(name, "{Yt{yowns{Yp{yerson{x");
				break;
			}
			sprintf(buf, "%s{W the %s{W has been removed from the game by an immortal.{x\n\r", victim->name, name);
		}
		dfhunt_talk(ch, buf, 0);

		dfhunt_game_info[PLAYER_LEFT]--;	/* Decrement total */

		victim->pcdata->dfhunt_player_info[P_ROLE] = P_NOT_IN_HUNT;
		for (i = 3; i < 7; i++)
			victim->pcdata->dfhunt_player_info[i] = 0;

		return;
				/*
			}
		}
*/
	}
	/* all that follow require the hunt to be started */
	if (dfhunt_game_info[GAME_STAT] == PREL)
	{
		send_to_char("The {Rh{runt{x has not started!\n\r", ch);
		return;
	}
	/* and in the hunt */
	if (ch->pcdata->dfhunt_player_info[P_ROLE] == P_NOT_IN_HUNT)
	{
		send_to_char("You are not in the {Rh{runt{x!\n\r", ch);
		return;
	}
	if(ch == victim)
	{
		stc("You can't do that to yourself.\n\r", ch);
		return;
	}

	if (!str_prefix(arg1, "accuse"))
	{
		if (ch->pcdata->dfhunt_player_info[P_ACTION] == 1)
		{
			send_to_char("You have already accused someone!\n\rYou can only accuse one person a day.\n\r", ch);
			return;
		}

		if (dfhunt_game_info[GAME_STAT] != DAY)
		{
			send_to_char("You can only accuse people during the {Yday{x.\n\r", ch);
			return;
		}
/*
		if (!str_prefix(argument, ch->name))
		{
			send_to_char("You cannot accuse yourself!\n\r", ch);
			return;
		}

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			CHAR_DATA *ach;
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[P_ROLE] == P_NOT_IN_HUNT)
			{
				sprintf(buf, "%s is not in {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ach->name);
				send_to_char(buf, ch);

				return;
			}

			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[P_ROLE] > P_NOT_IN_HUNT)
			{
	*/
		sprintf(buf, "%s accuses %s of being a {BD{bark{Bf{briend{W!{x\n\r", ch->name, victim->name);
		dfhunt_talk(ch, buf, 0);

		victim->pcdata->dfhunt_player_info[P_VOTES]++;
		dfhunt_game_info[ACTIONS]++;
		ch->pcdata->dfhunt_player_info[P_ACTION] = 1;
		return;
		
	}

	if (!str_prefix(arg1, "kill"))
	{
		if (ch->pcdata->dfhunt_player_info[0] != 4)
		{
			send_to_char("Only {BD{bark{Bf{briends{x can kill in the {Rh{runt{x.\n\r", ch);
			return;
		}

		if (ch->pcdata->dfhunt_player_info[5] == 1)
		{
			send_to_char("You have already killed someone this {Dn{wight{x.\n\rKill any more and people might get suspicious.\n\r", ch);
			return;
		}

		if (dfhunt_game_info[0] != 4)
		{
			send_to_char ("You can only kill people during the {Dn{wight{x.\n\r", ch);
			return;
		}
		/*

		if (!str_prefix(argument, ch->name))
		{
			send_to_char("You cannot kill yourself!\n\r", ch);
			return;
		}

		for (d = descriptor_list; d != NULL; d = d->next)
		{
			CHAR_DATA *ach;
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;


			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[0] == 0)
			{
				sprintf(buf, "%s is not in {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r",
						  ach->name);
				send_to_char(buf, ch);

				return;
			}
			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[6] == 1)
			*/
		if(victim->pcdata->dfhunt_player_info[6] == 1)
		{
			sprintf(buf, "%s has been protected!\n\rYou lose your kill for the night.\n\r", victim->name);
			send_to_char(buf, ch);
			sprintf(buf, "A {Ww{wa{Wrd{we{Wr{x prevented a murder!\n\r");
			dfhunt_talk(NULL, buf, 0);
			dfhunt_game_info[5] = dfhunt_game_info[5] + 1;
			ch->pcdata->dfhunt_player_info[5] = 1;

			return;
		}

		switch (victim->pcdata->dfhunt_player_info[0])
		{
		case 4:			  /* Darkfriend */
			sprintf(name, "{BD{bark{Bf{briend{x");
			dfhunt_game_info[4] = dfhunt_game_info[4] - 1;
			break;

		case 3:			  /* Warder */
			sprintf(name, "{WW{wa{Wrd{we{Wr{x");
			dfhunt_game_info[3] = 0;
			break;

		case 2:			  /* Aes Sedai */
			sprintf(name, "{yAe{ws {WSe{wd{yai{x");
			dfhunt_game_info[2] = 0;
			break;

		case 1:			  /* Villager */
			sprintf(name, "{Yt{yowns{Yp{yerson{x");
			break;
		}

		sprintf(buf, "%s{W the %s{W is {Rbr{ru{Dta{rl{Rly{W killed in the {Dn{wight{W by a {BD{bark{Bf{briend{W!{x\n\r", victim->name, name);
		dfhunt_talk(ch, buf, 0);

		dfhunt_game_info[1] = dfhunt_game_info[1] - 1;	/* Decrement total */
		dfhunt_game_info[5]++;	/* Increment action total */
				
		ch->pcdata->dfhunt_player_info[5]++;
				
		for (i = 0; i < 7; i++)
		{
			if (i == 1 || i == 2)
				continue;

			victim->pcdata->dfhunt_player_info[i] = 0;
		}

		victim->pcdata->dfhunt_player_info[2]++;

		return;

	}

	if (!str_prefix(arg1, "identify"))
	{
		if (ch->pcdata->dfhunt_player_info[0] != 2)
		{
			send_to_char("Only {yAe{ws {WSe{wd{yai{x can identify players in the {Rh{runt{x.\n\r", ch);
			return;
		}

		if (ch->pcdata->dfhunt_player_info[5] == 1)
		{
			send_to_char("You are too tired to identify anyone else.\n\r", ch);
			return;
		}

		if (dfhunt_game_info[0] != 4)
		{
			send_to_char
				("You can only identify people during the {Dn{wight{x.\n\r", ch);
			return;
		}
/*
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			CHAR_DATA *ach;
			if( d->connected != CON_PLAYING )
				continue;
			ach = (d->original != NULL) ? d->original : d->character;
			if( ach == NULL )
				continue;

			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[0] == 0)
			{
				sprintf(buf, "%s is not in {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ach->name);
				send_to_char(buf, ch);

				return;
			}
			if (!str_prefix(argument, ach->name)
				 && ach->pcdata->dfhunt_player_info[0] > 0)
			{
				ach->pcdata->dfhunt_player_info[6] = 1;  */ /* why protected ? */


		sprintf(buf, "You sneak up to %s's house and weave flows of the {DO{wne {DP{wower{x.\n\r", victim->name);
		send_to_char(buf, ch);

		switch (victim->pcdata->dfhunt_player_info[0])
		{
		case 4:			  /* Darkfriend */
			sprintf(name, "a {BD{bark{Bf{briend{x");
			break;

		case 3:			  /* Warder */
			sprintf(name, "a {WW{wa{Wrd{we{Wr{x");
			break;

		case 2:			  /* Aes Sedai */
			sprintf(name, "an {yAe{ws {WSe{wd{yai{x");
			break;

		case 1:			  /* Villager */
			sprintf(name, "a {Yt{yowns{Yp{yerson{x");
			break;
		}

		sprintf(buf, "After spending half of the night in concentration, you discover that %s is %s!\n\r", victim->name, name);
		send_to_char(buf, ch);

		dfhunt_game_info[5]++;
		ch->pcdata->dfhunt_player_info[5]++;

		return;
	}

	if (!str_prefix(arg1, "protect"))
	{
		if (ch->pcdata->dfhunt_player_info[0] != 3)
		{
			send_to_char
				("Only {WW{wa{Wrd{we{Wr{xs can protect in the {Rh{runt{x.\n\r", ch);
			return;
		}

		if (ch->pcdata->dfhunt_player_info[5] == 1)
		{
			send_to_char("You are already protecting someone.\n\r", ch);
			return;
		}

		if (dfhunt_game_info[0] != 4)
		{
			send_to_char
				("You can only protect people during the {Dn{wight{x.\n\r", ch);
			return;
		}
/*
		for (d = descriptor_list; d != NULL; d = d->next)
		{
			CHAR_DATA *victim;
			if( d->connected != CON_PLAYING )
				continue;
			victim = (d->original != NULL) ? d->original : d->character;
			if( victim == NULL )
				continue;

			if (!str_prefix(argument, victim->name)
				 && victim->pcdata->dfhunt_player_info[0] == 0)
			{
				sprintf(buf, "%s is not in {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", victim->name);
				send_to_char(buf, ch);

				return;
			}
			if (!str_prefix(argument, victim->name)
				 && victim->pcdata->dfhunt_player_info[0] > 0)
			{
			*/

		victim->pcdata->dfhunt_player_info[6] = 1;

		sprintf(buf, "You are now protecting %s for the {Dn{wight{x.\n\r", victim->name);
		send_to_char(buf, ch);

		dfhunt_game_info[5]++;
		ch->pcdata->dfhunt_player_info[5]++;

		return;
	}




	return;
}

void dfhunt_create(CHAR_DATA * ch, int cost)
{
	char buf[MAX_STRING_LENGTH];
	int i;

	/* ch->gold -= cost; */
	ch->money[3][0] -= cost;

	dfhunt_game_info[GAME_STAT] = PREL;

	for (i = 1; i < 7; i++)
		dfhunt_game_info[i] = 0;


	ch->pcdata->dfhunt_player_info[P_CREATOR] = 1;
	sprintf(dfhunt_creator_name, "%s", ch->name);

	sprintf(buf, "%s calls the people of all nations to {wThe {BD{bark{Bf{briend {RH{runt{W!{x\n\r", ch->name);
	dfhunt_talk(ch, buf, 0);

	dfhunt_join(ch, 0);

	return;
}

void dfhunt_join(CHAR_DATA * ch, int cost)
{
	char buf[MAX_STRING_LENGTH];

	/* ch->gold -= cost; */
	ch->money[3][0] -= cost;

	sprintf(buf, "%s has joined {wThe {BD{bark{Bf{briend {RH{runt{w!{x\n\r", ch->name);
	dfhunt_talk(ch, buf, 0);

	dfhunt_game_info[PLAYER_LEFT]++;		  /* Add 1 to total players */
	ch->pcdata->dfhunt_player_info[P_ROLE] = P_T;

	return;
}

void dfhunt_talk(CHAR_DATA * ch, char *argument, int notice)
{
	char buf[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	CHAR_DATA *dch;

	if (argument[0] == '\0')
	{
		send_to_char("You must type something before you can say it to your fellow {Rh{runters{x!\n\r", ch);
		return;
	}

	if (notice == 0)
		sprintf(buf, "{D[{RH{runters{D] {W%s{x", argument);
	else
		sprintf(buf, "{D[{RH{runters{D] {Y%s{y: {w%s{x\n\r", ch->name, argument);
	for (d = descriptor_list; d != NULL; d = d->next)
	{
		if( d->connected != CON_PLAYING )
			continue;
		dch = (d->original != NULL) ? d->original : d->character;
		if( dch == NULL )
			continue;

		if (!IS_SET(dch->comm, COMM_NODFH) && !IS_SET(dch->comm,COMM_QUIET) )
			send_to_char(buf, dch);
	}
	return;
}

CHAR_DATA * get_char_dfhunt(CHAR_DATA *ch, char *argument)
{
    char arg[MAX_INPUT_LENGTH];
    DESCRIPTOR_DATA *d;
    int number;
    int count;
    number = number_argument( argument, arg );
    count  = 0;
    if(!str_cmp(argument,"self"))
		return ch;
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( !d || !d->character || d->connected != CON_PLAYING )
		continue;
	if ( d->character->in_room == NULL || ( d->character->pcdata->dfhunt_player_info[P_ROLE] == P_NOT_IN_HUNT )
	||   !is_name( arg, d->character->name ) )
	    continue;
	if ( ++count == number )
	    return d->character;
    }
    return NULL;
}
