/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "recycle.h"
#include "dreams.h"

void send_dream( CHAR_DATA *ch )
{
	char *dreamText;
	/*char *buf;*/
	int count = 0, total = 0, hRange = 0, dream;

	for ( count = 0; DreamTable[count].dName != NULL; count++ )
		total++;

	hRange = total;
	dream = number_range( 1, hRange );

	/* proper way to work format_string - 10.17.2002 Dalsor */
	dreamText = str_dup( DreamTable[dream-1].dText );
	dreamText = format_string( dreamText );

	switch ( DreamTable[dream-1].dType )
	{
		case 1:
			stc( "The dream turns quickly into a nightmare...\n\r", ch );
		break;

		default:
			stc( "\n\r", ch );
		break;

		case 3:
			stc( "The dream pleasently drifts through your mind...\n\r", ch );
		break;
	}
	stc( dreamText, ch );
	free_string( dreamText );
	return;
}

void dream_update( void )
{
	DESCRIPTOR_DATA *d;

	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if ( d->connected == CON_PLAYING && d->character && d->character->position == POS_SLEEPING )
		{
			stc( "You begin to dream...\n\r", d->character );
			send_dream( d->character );
		}
	}
	return;
}
