#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

/* include main header file */
#include "aww.h"
#include "event.h"
#include "list.h"
#include "stack.h"

/* event_game_tick is just to show how to make global events
 * which can be used to update the game.
 */

int gen_rp_reward(CHAR_DATA *ch);

bool event_game_tick(EVENTS_DATA *event)
{
  // ITERATOR Iter;
  // CHAR_DATA *ch;

 /*send a tick message to everyone
  AttachToList(ch, ch_list);
  AttachIterator(&Iter, ch_list);
  while ((ch = (CHAR_DATA *) NextInList(&Iter)) != NULL)
  {
   ptc(ch, "Tick!\n\r");
  }
  DetachIterator(&Iter);
  DetachFromList(ch, ch_list);

  enqueue another game tick in 10 minutes*/
  event = alloc_event();
  event->fun = &event_game_tick;
  event->type = EVENT_GAME_TICK;
  add_event_game(event, 60 * PULSE_PER_SECOND);
  return FALSE;
}

bool event_mobile_save(EVENTS_DATA *event)
{
  CHAR_DATA *ch;

  /* Check to see if there is an owner of this event.
   * If there is no owner, we return TRUE, because
   * it's the safest - and post a bug message.
   */
  if ((ch = event->owner.ch) == NULL)
  {
    log_string("event_mobile_save: no owner.");
    return TRUE;
  }

  /* save the actual player file */
  if (!IS_NPC(ch))
  save_char_obj(ch, FALSE, FALSE);

  /* enqueue a new event to save the pfile in 2 minutes */
  event = alloc_event();
  event->fun = &event_mobile_save;
  event->type = EVENT_MOBILE_SAVE;
  add_event_mobile(event, ch, 2 * 60 * PULSE_PER_SECOND);

  return FALSE;
}

bool event_socket_idle(EVENTS_DATA *event)
{
  DESCRIPTOR_DATA *desc;

  /* Check to see if there is an owner of this event.
   * If there is no owner, we return TRUE, because
   * it's the safest - and post a bug message.
   */
  if ((desc = event->owner.desc) == NULL)
  {
    log_string("event_socket_idle: no owner.");
    return TRUE;
  }

  /* tell the socket that it has idled out, and close it */
  write_to_buffer(desc, "You have idled out...\n\n\r",0);
  close_socket(desc);

  /* since we closed the socket, all events owned
   * by that socket has been dequeued, and we need
   * to return TRUE, so the caller knows this.
   */
  return TRUE;
}

/*bool event_rpreward(EVENTS_DATA *event)
{
	CHAR_DATA *ch;

*/
