/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

/*School mobs should only leave stuff, no corpse, no butchering, no skins, they're to the medic!!*/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "msp.h"
#include "recycle.h"

/*
 * Qskill functions
 */

/*
 * Local functions.
 */
OBJ_DATA *    make_treasure_chest args( ( int level ) );
void	check_assist	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	check_dodge	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    check_counter   args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam, int dt ) );
void	check_killer	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	check_parry	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    check_shield_block     args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    blademaster args( ( CHAR_DATA *ch ) );
void    dam_message 	args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
                            int dt, bool immune ) );
void	death_cry	args( ( CHAR_DATA *ch ) );
void	group_gain	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
int		xp_compute	args( ( CHAR_DATA *gch, CHAR_DATA *victim,
			    int total_levels ) );
/*bool	is_safe		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );*/
OBJ_DATA *make_corpse	args( ( CHAR_DATA *ch ) );
void	fake_corpse	args( ( CHAR_DATA *ch ) );
void	one_hit		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt, bool secondary ) );
void    mob_hit		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt ) );
void	raw_kill	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void	soft_kill	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
/*void	set_fighting	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );*/
void	disarm		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool 	form_is_set args(( CHAR_DATA *ch, bool offensive ));
char * 	stance_lookup args(( CHAR_DATA *ch, bool offensive ));
int 	forms_bonus args(( CHAR_DATA *ch, bool offensive ));
bool 	sform_is_set args(( CHAR_DATA *ch, bool offensive ));
char * 	sstance_lookup args(( CHAR_DATA *ch, bool offensive ));
int 	sforms_bonus args(( CHAR_DATA *ch, bool offensive ));
void update_casting args((CHAR_DATA *ch ));

OBJ_DATA *random_adornment args((void));

/* Rebirth affects combat */
int calc_remort_tier( CHAR_DATA *ch);
int avg_tier (CHAR_DATA *ch, int members);

void fuzzy_obj_bonuses args((OBJ_DATA *obj, CHAR_DATA *mob));

/*New stuff Anthony all in aww.h*/
/*bool start_first_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool start_extra_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool check_fighting_groupie args((CHAR_DATA *ch, CHAR_DATA *victim));
bool check_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_all_fighting args((CHAR_DATA *ch));*/
bool is_safe args((CHAR_DATA *ch, CHAR_DATA *victim));

FIGHTING_DATA *get_fight_mem args((FIGHTING_DATA *fight, CHAR_DATA *victim));
FIGHTING_DATA *free_fight_mem args((FIGHTING_DATA *fight));
bool find_next_victim args((CHAR_DATA *ch));		/*Anthony*/

char *check_dye args((OBJ_DATA *obj, char *string, int dye_vnum));

#define mobtaunts = 55;
const char * taunts[] = {
	/* 1-5 */
	"$n yells, 'I'm going to tear you to pieces, $N!'",
	"$n taunts, 'This is going to be the most fun I've had all day!'",
	"$n grins evilly, 'I think I'll make this quick and just snap your neck, $N.'",
	"$n laughs at $N mercilessly!",
	"$n jeers, 'I'll make this as painful as possible for you, $N.'",
	/* 6-10 */
	"$n taunts, 'Is this the best you can do, $N?!'",
	"$n chides, 'No, no! Now's not the time to panic! Now's the time to DIE!'",
	"$n shouts, 'What? You aren't dead yet, $N!?'",
	"$n taunts, 'I thought we were going to fight, $N!'",
	"$n jeers, 'You aren't listening, $N! I said DIE!'",
	/* 11-15 */
	"$n yells, 'Get over here and fight already, $N!'",
	"$n teases, 'Don't worry, $N, it will all be over soon.'",
	"$n chides, 'I'll make this quick and painless, $N.'",
	"$n teases, 'Your sister's dowry would not buy moldy bread, $N!'",
	"$n teases, 'Your brother flees from milkmaids, $N!'",
	/* 16-20 */
	"$n yells, 'If $N isn't back in five minutes, wait longer!'",
	"$n yells, 'If $N isn't back in five minutes, $E's dead!'",
	"$n yells, 'Do you mind keeping your fleas to yourself, $N!?'",
	"$n taunts, 'You should try wearing something under your helm, $N, like a brain!'",
	"$n sneers, 'Sorry I mistook your codpiece for a thimble, $N, but is that a reason to fight?'",
	/* 21-25 */
	"$n jeers, 'So what crime did your parents commit to get you, $N?'",
	"$n taunts, 'I'd insult you $N, but I don't have time to wait for you to get it.'",
	"$n taunts, 'Bend over and let me see the cute end, $N!'",
	"$n teases, 'I feel sorry for that little brain in that big fat head, $N!'",
	"$n taunts, 'When you were born, $N, the midwife tried to put you back!",
	/* 26-30 */
	"$n taunts, 'When you were born, $N, the midwife saved the bath water and threw you out!",
	"$n taunts, '$N, when you were born your father killed the stork!",
	"$n taunts, 'Your parents tried to throw you to the wolves but the wolves threw you back!'",
	"$n taunts, 'When you were born the midwife slapped your mother!'",
	"$n taunts, 'I bet your first trip was from the midwife's hands to the floor!'",
	/* 31-35 */
	"$n sneers, 'You have a striking face, $N. How many times have you been struck there anyway?'",
	"$n jeers, 'When you have an idea, $N, it's in solitary confinement!'",
	"$n taunts, 'If you had a little bit more sense, $N, you'd be a half-wit!'",
	"$n taunts, 'Is that a nose or a disease on your face, $N?'",
	"$n taunts, 'You haven't been yourself lately, $N and we're glad for the improvement!'",
	/* 36-40 */
	"$n jeers, 'People like you don't grow on trees, $N. They hang from them!'",
	"$n sneers, 'You have all the characteristics of a dog, $N, except the loyalty!'",
	"$n laughs, '$N, you're so weak you can't even break wind!'",
	"$n jeers, '$N, you're slow slow you'll have to speed up to stop!'",
	"$n taunts, '$N, if your mother and father divorced would they still be brother and sister!?'",
	/* 41-45 */
	"$n sneers, '$N, you have the right to be ugly, but don't abuse it so much!'",
	"$n taunts, '$N, I see you have set this time aside to humiliate yourself.'",
	"$n taunts, '$N if I had a dog like you I'd shave his arse and walk him backwards!'",
	"$n jeers, '$N when I want your opinion I'll rattle your cage!'",
	"$n taunts, 'Don't let your mind wander, $N! It's too small to be let out alone!'",
	/* 46-50 */
	"$n laughs, '$N! What foul mess did your neck step in!?'",
	"$n jeers, '$N, if I throw you a stick will you go away?'",
	"$n taunts, '$N, your parent met in a trolloc cookpot!'",
	"$n taunts, '$N, the trollocs kicked your parents out of the cookpot for spoiling the meal!'",
	"$n taunts, '$N your breath is so foul I look forward to you breaking wind!'",
	/* 51-55 */
	"$n taunts, '$N, when you were born your mother did not know which end to tie the diaper on!'",
	"$n taunts, '$N, when you were born your mother was charged for littering!'",
	"$n taunts, '$N, did you stop to think then forget to start again!?'",
	"$n taunts, '$N, the trollocs kicked you out of the cookpot for ruining the meal!'",
	"$n taunts, '$N, I would insult you, but with your intelligence you would not get offended!'",
};
bool weaponless( CHAR_DATA *ch )
{
	OBJ_DATA *obj, *obj2;

	obj = get_eq_char( ch, WEAR_WIELD );
	obj2 = get_eq_char( ch, WEAR_SECONDARY );

	if ( obj == NULL && obj2 == NULL )
		return TRUE;
	return FALSE;
}
bool is_fighting(CHAR_DATA *ch)
{
	if (ch->fight_data == NULL)
	{
		return FALSE;
	}
	if (ch->fight_data->fighter == NULL)
	{
		return FALSE;
	}
	return TRUE;
}

bool start_first_fight(CHAR_DATA *ch, CHAR_DATA *victim, int range)
{
	bool fdragon = FALSE;

	if ( gevent->running && gevent->num == 1 ) /* False Dragon */
		fdragon = TRUE;

	/*Can't fight yourself*/
	if ( victim == ch )
	{
		multi_hit( ch, ch, TYPE_UNDEFINED );
		return FALSE;
	}
	/*no group members*/
	if (is_same_group(ch, victim))
		return FALSE;
	/* no safe victims*/
/*	bugf("First_fight - check safety. %s", ch->name ); */

	if ( is_safe( ch, victim ) )
		return FALSE;

	/*no death victims*/
	if (victim->position == 0 || ch->position == 0)
		return FALSE;
/*	bugf("First_fight - check kill stealing. %s", ch->name ); */

	/*For players*/
	if ( !IS_NPC( ch ) )
	{
		if ( is_fighting(victim) && !is_same_group(ch,victim->advancing_on))
		{
			stc("{cKill stealing is not permitted.\n\r",ch);
			return FALSE;
		}
		if ( is_fighting(victim) && victim->advancing == TRUE && victim->range != RANGE_NONE && !is_same_group(ch,victim->advancing_on))
		{
			stc("{cKill stealing is not permitted.\n\r",ch);
			return FALSE;
		}
	}
	/*bugf("First_fight - check PK. %s", ch->name );*/

	/* Commented out to allow for PK -- Dalsor 09.25.2013 */
	/*
	if ( !IS_NPC(victim) && !IS_NPC(ch) )
	{
		if ( !fdragon )
		{
			if (!IS_SET(victim->war_flags,WAR_PK))
			{
				stc("Your victim is safe from attack at the moment.\n\r",ch);
				return FALSE;
			}
			if (!IS_SET(ch->in_room->room_flags,ROOM_PK)
			&& !IS_SET(victim->in_room->room_flags,ROOM_PK)
			&& !IS_SET(victim->war_flags, WAR_BATTLE)
			&& !IS_SET(victim->war_flags, WAR_TOURNEY)
			&& !IS_IMMORTAL(ch))
			{
				stc("{cGo to the Arena if you want to PK.\n\r",ch);
				return FALSE;
			}
		}
	}
	*/

	/*bugf("First_fight - charmed. %s", ch->name );*/
	if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master == victim )
	{
		act( "{c$N is your beloved master.", ch, NULL, victim, TO_CHAR );
		return FALSE;
	}
	/*bugf("First_fight - fighting. %s", ch->name );*/
	if ( ch->position == POS_FIGHTING )
	{
		stc( "{cYou do the best you can!\n\r", ch );
		return FALSE;
	}
	if ( ch->advancing == TRUE )
	{
		ptc( ch, "You are already advancing on %s.\n\r", PERS(ch->advancing_on, ch) );
		return FALSE;
	}
	/*bugf("First_fight - finally the fight. %s", ch->name );*/
	if (!IS_NPC(victim))
		SET_BIT(ch->war_flags,WAR_PK);
	WAIT_STATE( ch, 1 * PULSE_VIOLENCE );
	/*bugf("First_fight - check killer. %s", ch->name );*/
	check_killer( ch, victim );
	victim->on = 0;

	/* mobs will wear any equip they might have on them. */
	if ( IS_NPC( victim ) )
	{
		do_function( victim, &do_wear, "all" );
	}

	/* RANGE code - Dalsor */
	affect_strip( ch, gsn_sneak );
	affect_strip( ch, gsn_hide );
	affect_strip( ch, gsn_invis );
	affect_strip( ch, gsn_mass_invis );

	/*bugf("First_fight - get fightmem. %s", ch->name );*/
	ch->fight_data = get_fight_mem(ch->fight_data, victim);
	victim->fight_data = get_fight_mem(victim->fight_data, ch);

	ch->advancing = TRUE;
	ch->advancing_on = victim;
	if (ch->range < range)
		ch->range = range;
	ch->number_of_fights = 1;
	if (range == RANGE_MELEE)
	{
		if ( IS_AFFECTED(ch, AFF_SLEEP) )
		affect_strip( ch, gsn_sleep );
		ch->position = POS_FIGHTING;
	}

	if (victim->advancing == FALSE)
	{
	    victim->advancing = TRUE;
		if (victim->advancing_on == NULL)
    			victim->advancing_on = ch;
		if (victim->range < range)
			victim->range = range;
		victim->number_of_fights = 1;
		if (range == RANGE_MELEE)
		{
			if ( IS_AFFECTED(victim, AFF_SLEEP) )
			affect_strip( victim, gsn_sleep );
			victim->position = POS_FIGHTING;
		}
	}
	else
		victim->number_of_fights++;

	if ( !IS_NPC(ch) )
	{
		ptc( ch, "You begin to advance on %s!\n\r", PERS( ch->advancing_on, ch ) );
	}
	act( "$n begins advancing on $N!", ch, NULL, victim, TO_ROOM );

        if ( IS_NPC( victim ) && HAS_TRIGGER_MOB( victim, TRIG_KILL ) )
                p_percent_trigger( victim, NULL, NULL, ch, NULL, NULL, TRIG_KILL );

        if ( victim->in_room == ch->in_room && IS_NPC(victim) && strcmp(victim->pIndexData->kill_mess,"(null)") )
        {
                act(victim->pIndexData->kill_mess,ch,NULL,NULL,TO_ROOM);
                act(victim->pIndexData->kill_mess,ch,NULL,NULL,TO_CHAR);
        }
	return TRUE;
}

bool start_extra_fight(CHAR_DATA *ch, CHAR_DATA *victim, int range)
{
	/*Can't fight yourself*/
	if ( victim == ch )
		return FALSE;
	/*no group members*/
	if (is_same_group(ch, victim))
		return FALSE;
	/* no safe victims*/
	if ( is_safe( ch, victim ) )
		return FALSE;
	/*no death victims*/
	if (victim->position == 0 || ch->position == 0)
		return FALSE;

	/*For players*/
	if ( !IS_NPC( ch ) )
	{
		if ( is_fighting(victim) && !is_same_group(ch,victim->advancing_on))
			return FALSE;
		if ( is_fighting(victim) && victim->advancing == TRUE && victim->range != RANGE_NONE && !is_same_group(ch,victim->advancing_on))
			return FALSE;
	}
	/*For PK*/
	if ( !IS_NPC(victim) && !IS_NPC(ch) )
	{
		if (!IS_SET(victim->war_flags,WAR_PK))
		{
			return FALSE;
		}
		if (!IS_SET(ch->in_room->room_flags,ROOM_PK)
			&& !IS_SET(victim->in_room->room_flags,ROOM_PK)
			&& !IS_SET(victim->war_flags, WAR_BATTLE)
			&& !IS_SET(victim->war_flags, WAR_TOURNEY)
			&& !IS_IMMORTAL(ch))
			{
				return FALSE;
			}
	}

	if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master == victim )
	{
		return FALSE;
	}

	if (!IS_NPC(victim))
		SET_BIT(ch->war_flags,WAR_PK);
	/*WAIT_STATE( ch, 1 * PULSE_VIOLENCE );*/
	check_killer( ch, victim );
	victim->on = 0;

	/* RANGE code - Dalsor */
	affect_strip( ch, gsn_sneak );
	affect_strip( ch, gsn_hide );
	affect_strip( ch, gsn_invis );
	affect_strip( ch, gsn_mass_invis );

	if ( !IS_NPC(ch) && !check_fighting(ch, victim))
	{
		ptc( ch, "You attack %s!\n\r", PERS( victim, ch ) );
	}
	if (!check_fighting(ch, victim))
	{
		/* mobs will wear any equip they might have on them. */
		if ( IS_NPC( victim ) )
		{
			do_function( victim, &do_wear, "all" );
		}
		act( "$n begins advancing on $N!", ch, NULL, victim, TO_ROOM );
		ch->fight_data = get_fight_mem(ch->fight_data, victim);
		victim->fight_data = get_fight_mem(victim->fight_data, ch);

		if (ch->advancing == FALSE)
		{
			ch->advancing = TRUE;
			ch->advancing_on = victim;
			if (ch->range < range)
				ch->range = range;
			ch->number_of_fights = 1;
			if (range == RANGE_MELEE)
			{
				if ( IS_AFFECTED(ch, AFF_SLEEP) )
				affect_strip( ch, gsn_sleep );
				ch->position = POS_FIGHTING;
			}
		}
		else
			ch->number_of_fights++;

		if (victim->advancing == FALSE)
		{
			victim->advancing = TRUE;
			if (victim->advancing_on == NULL)
				victim->advancing_on = ch;
			if (victim->range < range)
				victim->range = range;
			victim->number_of_fights = 1;
			if (range == RANGE_MELEE)
			{
				if ( IS_AFFECTED(victim, AFF_SLEEP) )
				affect_strip( victim, gsn_sleep );
				victim->position = POS_FIGHTING;
			}
		}
		else
			victim->number_of_fights++;
	}
	return TRUE;
}

/*Checks if the victim is in a fight with a groupie of ch*/
bool check_fighting_groupie (CHAR_DATA *ch, CHAR_DATA *victim)
{
	FIGHTING_DATA *target;

	target = victim->fight_data;
	if (target != NULL)
	while ((target != NULL) && !is_same_group(target->fighter, ch))
		target = target->next;

	if (target != NULL)
		return TRUE;

	return FALSE;
}

/*Checks if ch is fighting victim*/
bool check_fighting (CHAR_DATA *ch, CHAR_DATA *victim)
{
	FIGHTING_DATA *target;
	/*bugf("check_fighting - start. %s", ch->name );*/
	target = victim->fight_data;
	/*bugf("check_fighting - got target. %s", ch->name );*/
	if (target != NULL)
	{
		/*bugf("check_fighting - loop through targets - start. %s", ch->name );*/

	while ((target != NULL) && (target->fighter != ch))
		target = target->next;
	}
	if (target != NULL && target->fighter == ch)
		return TRUE;

	/*bugf("check_fighting - not fighting. %s", ch->name );*/
	return FALSE;
}



void set_range_null(CHAR_DATA *ch) /*Clears range and advance stuff, called by stop_fighting*/
{
	ch->range = RANGE_NONE;
	ch->advancing = FALSE;
	ch->advancing_on = NULL;
	ch->position = IS_NPC ( ch ) ? ch->default_pos : POS_STANDING;
	update_pos ( ch );
	ch->number_of_fights = 0;
}

/*Stops fighting between ch and victim*/
void stop_all_fighting(CHAR_DATA *ch)
{
	FIGHTING_DATA *target;
	CHAR_DATA *victim;

	/*bugf("Stop fighting %s Start", ch->name);*/
	while(is_fighting(ch))
	{
		victim = ch->fight_data->fighter;
		target = victim->fight_data;
		/*bugf("Stop fighting removing %s", victim->name);*/

		ch->fight_data = free_fight_mem(ch->fight_data);
		ch->number_of_fights--;
		/*bugf("Stop fighting %s removed", victim->name);*/

/*		ptc(ch, "{MYou stop fighting {G%s{M and are in {G%d{M fights{x\n\r", victim->name, ch->number_of_fights);
		ptc(victim, "{MYou stop fighting {G%s{M and are in {G%d{M fights{x\n\r", ch->name, victim->number_of_fights);
*/
		if (target == NULL)
			continue;

		/*bugf("Stop fighting no NULL target");*/

		if (target->fighter == ch)
		{
			/*bugf("Stop fighting target is first");*/
			victim->fight_data = free_fight_mem(victim->fight_data);
			victim->number_of_fights--;
			/*bugf("Stop fighting removed first target");*/

			if (victim->number_of_fights <= 0)
				set_range_null(victim);
			continue;
		}

		/*bugf("Stop fighting target-loop start");*/

		while ((target->next != NULL) && (target->next->fighter != ch))
		{
			target = target->next;
			if (target->next->fighter == NULL)
			{
				bugf("Stop fighting clean NULL target");
				target->next = free_fight_mem(target->next);
			}
		}


		if (target->next != NULL && target->next->fighter == ch)
		{
			/*bugf("Stop fighting removing target %s", ch->name);*/
			target->next = free_fight_mem(target->next);
			victim->number_of_fights--;

			if (victim->number_of_fights <= 0)
				set_range_null(victim);
			else if (victim->advancing_on == ch)
				find_next_victim(victim);
		}
	}
	if (ch->number_of_fights != 0)
	{
		ptc(ch, "{MDAMN, you were still in %d fights{x\n\r", ch->number_of_fights);
		ch->number_of_fights = 0;
	}
	set_range_null(ch);
	/*bugf("Stop fighting %s DONE", ch->name);*/
}


void stop_fighting(CHAR_DATA *ch, CHAR_DATA *victim)
{
	FIGHTING_DATA *target;
	if (!check_fighting(ch, victim))
	{
		bugf("Stop fighting - Who coded this stuff, stop-fighting called for characters not in fight *mutter*");
		return;
	}
	/*FIXME  this needs some serious work --Sil */

	ptc(ch, "{M(1 fight) You stop fighting {G%s{M and are in {G%d{M fights{x\n\r", victim->name, (ch->number_of_fights - 1));
	ptc(victim, "{M(1 fight) You stop fighting {G%s{M and are in {G%d{M fights{x\n\r", ch->name, (victim->number_of_fights - 1));
	bugf("Stop fighting called: %s %s", ch->name, victim->name);
	target = victim->fight_data;
	if (target != NULL)
	{
		if (target->fighter == ch)
		{
			victim->fight_data = free_fight_mem(victim->fight_data);
			victim->number_of_fights--;

			if (victim->number_of_fights <= 0)
				set_range_null(victim);
			else if (victim->advancing_on == ch)
				find_next_victim(victim);
		}
		else
		{
		   if ((target->next != NULL) && (target->next->fighter != ch))
		   {
			target = target->next;
			while ((target->next != NULL) && (target->next->fighter != ch))
			{

				if (target->next && target->next->fighter == NULL)
				{
					target->next = free_fight_mem(target->next);
				}
				target = target->next;
			}


			if (target->next != NULL)
			{
				target->next = free_fight_mem(target->next);
				victim->number_of_fights--;

				if (victim->number_of_fights <= 0)
					set_range_null(victim);
				else if (victim->advancing_on == ch)
					find_next_victim(victim);
			}
		   }
		}
	}

	target = ch->fight_data;
	if (target != NULL)
	{
		if (target->fighter == victim)
		{
			ch->fight_data = free_fight_mem(ch->fight_data);
			ch->number_of_fights--;

			if (ch->number_of_fights <= 0)
				set_range_null(ch);
			else if (victim->advancing_on == ch)
				find_next_victim(victim);
		}
		else
		{
			while ((target->next != NULL) && (target->next->fighter != victim))
			{
				target = target->next;
				if (target->next->fighter == NULL)
				{
					target->next = free_fight_mem(target->next);
				}
			}


			if (target->next != NULL)
			{
				target->next = free_fight_mem(target->next);
				ch->number_of_fights--;

				if (ch->number_of_fights <= 0)
					set_range_null(ch);
				else if (victim->advancing_on == ch)
					find_next_victim(victim);
			}
		}
	}
}

FIGHTING_DATA *free_fight_mem(FIGHTING_DATA *fight)
{
	FIGHTING_DATA *nextfight;

	if (fight == NULL)
		return NULL;

	nextfight = fight->next;

	fight->next = NULL;
/*	fight->fighter = NULL; done in free_fight */
	free_fight(fight);

	return nextfight;

}

FIGHTING_DATA *get_fight_mem(FIGHTING_DATA *fight, CHAR_DATA *victim)
{
	FIGHTING_DATA *target;
	FIGHTING_DATA *newtarget;

	newtarget = new_fight();
	newtarget->fighter = victim;
	newtarget->next = fight;
	fight = newtarget;
	target = fight;

	while (target != NULL && target->fighter != NULL)
	{
		target = target->next;
	}

	if (target != NULL && target->fighter == NULL)
	{
		bugf("get_fight_mem - clearing bad fighter %s", victim->name );
		free_fight(target);
	}
	/*bugf("get_fight_mem - DONE :) %s", fight->fighter->name );*/
	return fight;
}


DECLARE_DO_FUN(	do_tail	);
DECLARE_DO_FUN(do_charge);
DECLARE_DO_FUN(do_circle);
DECLARE_DO_FUN(do_mobforms);
DECLARE_SPELL_FUN(spell_null);
DECLARE_SPELL_FUN(weave_fire_shield);


// Also handles spearmasters
bool blademaster( CHAR_DATA *ch )
{
	if ( IS_NPC( ch ) )
		return FALSE;

	if (ch->race == race_lookup("aiel"))
		return FALSE;

	if (ch->race == race_lookup("ogier"))
		return FALSE;

	if (ch->race == race_lookup("trolloc"))
		return FALSE;

	if (ch->race == race_lookup("fade"))
		return FALSE;

	if (get_skill(ch, gsn_heron) < 100)	return FALSE;
	if (get_skill(ch, gsn_wind) < 100)	return FALSE;
	if (get_skill(ch, gsn_water) < 100)	return FALSE;
	if (get_skill(ch, gsn_sky) < 100)	return FALSE;
	if (get_skill(ch, gsn_stone) < 100)	return FALSE;
	if (get_skill(ch, gsn_storm) < 100)	return FALSE;
	if (get_skill(ch, gsn_lizard) < 100)	return FALSE;
	if (get_skill(ch, gsn_boar) < 100)	return FALSE;
	if (get_skill(ch, gsn_bird) < 100)	return FALSE;
	if (get_skill(ch, gsn_cat) < 100)	return FALSE;
	if (get_skill(ch, gsn_elemental) < 100)	return FALSE;
	if (get_skill(ch, gsn_will) < 100)	return FALSE;
	if (get_skill(ch, gsn_fire) < 100)	return FALSE;
	if (get_skill(ch, gsn_ice) < 100)	return FALSE;
	if (get_skill(ch, gsn_spirit) < 100)	return FALSE;
	if (get_skill(ch, gsn_circle) < 100)	return FALSE;

	return TRUE;
}

bool spearmaster( CHAR_DATA *ch )
{
	if ( IS_NPC( ch ) )
		return FALSE;

	if (IS_SET(ch->op_flags,OP_CHANNELER))
		return FALSE;

	if (ch->race == race_lookup("aiel"))
	{
		if (get_skill(ch, gsn_eagle) < 100)	return FALSE;
		if (get_skill(ch, gsn_capar) < 100)	return FALSE;
		if (get_skill(ch, gsn_gara) < 100)	return FALSE;
		if (get_skill(ch, gsn_hare) < 100)	return FALSE;
		if (get_skill(ch, gsn_snake) < 100)	return FALSE;
		if (get_skill(ch, gsn_ji) < 100)	return FALSE;
		if (get_skill(ch, gsn_sand) < 100)	return FALSE;
		if (get_skill(ch, gsn_ridgecat) < 100)	return FALSE;
		if (get_skill(ch, gsn_lion) < 100)	return FALSE;
		if (get_skill(ch, gsn_dream) < 100)	return FALSE;
		if (get_skill(ch, gsn_shadow) < 100)	return FALSE;
		if (get_skill(ch, gsn_wrath) < 100)	return FALSE;
		if (get_skill(ch, gsn_mystic) < 100)	return FALSE;
		if (get_skill(ch, gsn_ring) < 100)	return FALSE;
		if (get_skill(ch, gsn_earth) < 100)	return FALSE;
		if (get_skill(ch, gsn_balance) < 100)	return FALSE;
		return TRUE;
	}

	return FALSE;
}

void jail_char ( CHAR_DATA *ch )
{
	if ( IS_IMMORTAL( ch ) )
		return;
	SET_BIT( ch->penalty_flags,PENAL_JAILED );
	SET_BIT( ch->act,PLR_FREEZE );
	act("The local constables drag $n to the stocks and shackle $m there.",ch,NULL,NULL,TO_ROOM);
	act("The local constables drag you to the stocks and shackle you there.",ch,NULL,NULL,TO_CHAR);
	char_from_room( ch );
	char_to_room( ch, get_room_index( ROOM_VNUM_JAIL ) );
	act("The local constables drag $n to the stocks and shackle $m there.",ch,NULL,NULL,TO_ROOM);
	return;
}

bool is_human( CHAR_DATA *ch )
{
	if (!IS_NPC(ch)) return FALSE;
	if (ch->race == race_lookup("andor")
	|| ch->race == race_lookup("amador")
	|| ch->race == race_lookup("illian")
	|| ch->race == race_lookup("shienar")
	|| ch->race == race_lookup("domani")
	|| ch->race == race_lookup("aiel")
	|| ch->race == race_lookup("ogier")
	|| ch->race == race_lookup("tairen")
	|| ch->race == race_lookup("cairhien")
	|| ch->race == race_lookup("seanchan")
	|| ch->race == race_lookup("altara")
	|| ch->race == race_lookup("trolloc")
	|| ch->race == race_lookup("fade")
	|| ch->race == race_lookup("arafel")
	|| ch->race == race_lookup("tarabon")
	|| ch->race == race_lookup("kandor")
	|| ch->race == race_lookup("mayene")
	|| ch->race == race_lookup("tworiver")
	|| ch->race == race_lookup("seafolk")
	|| ch->race == race_lookup("falman")
	|| ch->race == race_lookup("maddinger")
	|| ch->race == race_lookup("murandy")
	|| ch->race == race_lookup("ghealdan")
	|| ch->race == race_lookup("saldaean")
	|| ch->race == race_lookup("malkier"))
	return TRUE;
	else return FALSE;
}
void get_special_stat( CHAR_DATA *ch, OBJ_DATA *wield, CHAR_DATA *victim)
{
	int dam;
	/*Only in fights*/
	if (!check_fighting(victim, ch))
		return;

	if (IS_WEAPON_STAT(wield,WEAPON_POISON))
	{
	    int level;
	    AFFECT_DATA *poison, af;
	    if ((poison = affect_find(wield->affected,gsn_poison)) == NULL)
		level = ch->level / 10;
	    else
		level = poison->level;
	    if (!saves_spell(level / 2,victim,DAM_POISON))
	    {
			stc("{RYou feel poison coursing through your veins.{c\n\r",victim);
			act("{R$n is poisoned by the venom on $p.{c",victim,wield,NULL,TO_ROOM);
    		af.where     = TO_AFFECTS;
    		af.type      = gsn_poison;
    		af.level     = level * 3/4;
    		af.duration  = level / 2;
    		af.location  = APPLY_STR;
    		af.modifier  = -1;
    		af.bitvector = AFF_POISON;
    		affect_join( victim, &af );
	    }
	    if (poison != NULL)
	    {
	    	poison->level = UMAX(0,poison->level - 2);
	    	poison->duration = UMAX(0,poison->duration - 1);
	    	if (poison->level == 0 || poison->duration == 0)
		    act("{cThe poison on $p has worn off.",ch,wield,NULL,TO_CHAR);
	    }
	    return;
 	}
	else if (IS_WEAPON_STAT(wield,WEAPON_FLAMING))
	{
	    dam = number_range(1, ch->level / 8 + 1);
	    act("{R$n is burned by $p.{c",victim,wield,NULL,TO_ROOM);
	    act("{R$p sears your flesh.{c",victim,wield,NULL,TO_CHAR);
	    /*fire_effect( (void *) victim,wield->level/2,dam,TARGET_CHAR);*/
	    damage(ch,victim,dam,0,DAM_FIRE,FALSE);
	    return;
	}
	else if (IS_WEAPON_STAT(wield,WEAPON_FROST))
	{
	    dam = number_range(1, ch->level / 6 + 2);
	    act("{W$p freezes $n.{c",victim,wield,NULL,TO_ROOM);
	    act("{WThe cold touch of $p surrounds you with ice.{c",
		victim,wield,NULL,TO_CHAR);
	    /*cold_effect(victim,wield->level/2,dam,TARGET_CHAR);*/
	    damage(ch,victim,dam,0,DAM_COLD,FALSE);
	    return;
	}
	else if (IS_WEAPON_STAT(wield,WEAPON_SHOCKING))
	{
	    dam = number_range(1, ch->level / 6 + 2);
	    act("{B$n is struck by lightning from $p.{c",victim,wield,NULL,TO_ROOM);
	    act("{BYou are shocked by $p.{c",victim,wield,NULL,TO_CHAR);
	    /*shock_effect(victim,wield->level/2,dam,TARGET_CHAR);*/
	    damage(ch,victim,dam,0,DAM_LIGHTNING,FALSE);
	    return;
	}
}

char *check_stance(CHAR_DATA *ch)
{
	return "";
}

int get_stance_bonus(CHAR_DATA *ch)
{
	return 0;
}

int check_init( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int bonus = 50;
	if ( get_curr_stat(ch,STAT_INS) > get_curr_stat(victim,STAT_INS) )
		bonus += get_curr_stat(ch,STAT_INS) - get_curr_stat(victim,STAT_INS);
	if ( get_curr_stat(ch,STAT_DEX) > get_curr_stat(victim,STAT_DEX) )
		bonus += get_curr_stat(ch,STAT_DEX) - get_curr_stat(victim,STAT_DEX);
	if ( get_curr_stat(ch,STAT_REF) > get_curr_stat(victim,STAT_REF) )
		bonus += get_curr_stat(ch,STAT_REF) - get_curr_stat(victim,STAT_REF);
	if ( ch->level > victim->level )
		bonus += ch->level - victim->level;
	return bonus;
}
/*
 * Control the fights going on.
 * Called periodically by update_handler.
 */
void violence_update( void )
{
	CHAR_DATA *ch;
	CHAR_DATA *ch_next;
	CHAR_DATA *victim;
	OBJ_DATA *obj, *obj_next;
	bool room_trig = FALSE;

	for ( ch = char_list; ch != NULL; ch = ch_next )
	{
		ch_next	= ch->next;

		if ( ch->weaves && ch->weaves->action[0] == ACTION_CASTING )
			update_casting(ch);

		/*Clear the bugged non-fighting ones*/
		if ( !is_fighting(ch) || ch->in_room == NULL)
		{
			/*This case should not be possible*/
			if (ch->advancing_on != NULL || ch->advancing == TRUE)
			{
				if (ch->in_room != NULL)
					bugf("Violence update - problem with non-fighting char. %s", ch->name );
				else
					bugf("Violence update - problem NULL room with %s", ch->name);
				stop_all_fighting(ch);
			}
			continue;
		}

		victim = ch->advancing_on;
		if (victim == NULL)	/*Case should be impossible*/
		{
			bugf("Violence update - NULL victim of %s", ch->name);
			stop_all_fighting(ch);
			continue;
		}

		/*Can't fight when held in wars*/
		if (IS_SET(ch->war_flags,WAR_HELD))
		{
			if (saves_spell(ch->level, ch, DAM_ENERGY))
			{
				stc( "You manage to break free!\n\r", ch );
				act("$n manages to escape from $s bonds!",ch,NULL,NULL,TO_ROOM);
				REMOVE_BIT(ch->war_flags,WAR_HELD);
			}
			else
			{
				if (!IS_NPC(ch))
				{
					stc( "{cBut you can't move!\n\r", ch );
				}
				WAIT_STATE(ch, PULSE_VIOLENCE * 2);
				continue;
			}
		}

		/*Advancing the range*/
		if ( ch->advancing == TRUE && ch->advancing_on != NULL && ch->in_room == ch->advancing_on->in_room )
		{
			if ( ch->range == RANGE_NONE )
			{
				bugf("Violence update - RANGE NONE %s", ch->name);
				ch->range = RANGE_MELEE;
				ch->advancing_on->range = RANGE_MELEE;
			}
			if ( ch->range == RANGE_MISSLE )
			{
				act( "You close to long range on $N!", ch, NULL, ch->advancing_on, TO_CHAR );
				act( "$n closes to long range on $N!", ch, NULL, ch->advancing_on, TO_NOTVICT );
				if ( !IS_NPC( ch->advancing_on ) && IS_AWAKE( ch->advancing_on ) )
				{
					act( "$n closes to long range on you!", ch, NULL, ch->advancing_on, TO_VICT );
				}
				ch->range += 1;
				continue;
			}
			else if ( ch->range == RANGE_LONG )
			{
				act( "You close to melee range on $N!", ch, NULL, ch->advancing_on, TO_CHAR );
				act( "$n closes to melee range on $N!", ch, NULL, ch->advancing_on, TO_NOTVICT );
				if ( !IS_NPC( ch->advancing_on ) && IS_AWAKE( ch->advancing_on ) )
				{
					act( "$n closes to melee range on you!", ch, NULL, ch->advancing_on, TO_VICT );
				}
				ch->range += 1;
				if ( IS_AFFECTED(ch, AFF_SLEEP) )
				affect_strip( ch, gsn_sleep );
				ch->position = POS_FIGHTING;
			}

			/*At melee range:*/
			if ( ch->range == RANGE_MELEE )
			{
				victim = ch->advancing_on;
				victim->range = RANGE_MELEE;
				ch->position = POS_FIGHTING;
				victim->position = POS_FIGHTING;

				/*and another bug check*/
				if ( !check_fighting(ch, victim) )
				{
					bugf("Violence update - no fight while in MELEE %s", ch->name);
					stop_all_fighting(ch);
					stop_all_fighting(victim);
					continue;
				}

				if (IS_NPC(victim))
					start_hating( victim, ch );
			}
		}

		if ( victim == NULL )
			continue;
		if ( ch == NULL )
			continue;

		/*Seems like this has been checked a dozen times already, but what the heck*/
		if ( victim->in_room == NULL ||   ch->in_room == NULL
			||   victim->in_room != ch->in_room )
		{
			bugf("Violence update - frigging roomerror after a zillion checks %s", ch->name);
				stop_all_fighting(victim);  /* FIXME   maybe this will help? */
				stop_all_fighting(ch);  /* FIXME   maybe this will help? */
			continue;
		}

		if ( victim == ch->advancing_on )
		{
			if ( check_init( ch, victim) >= number_percent() && ch->position > POS_STUNNED )
			{
				/* removed for spam reduction - Dalsor */

/*				act("$n ch gets the first strike on $N!",ch,NULL,victim,TO_NOTVICT);
				act("$n ch gets the first strike on you!",ch,NULL,victim,TO_VICT);
				act("You ch get the first strike on $N!",ch,NULL,victim,TO_CHAR);
				act("{GCH gets first strike",ch,NULL,victim,TO_ROOM);
*/
				multi_hit( ch, victim, TYPE_UNDEFINED );
			}
			else
			{
/*
				act("$n gets the first strike on $N!",victim,NULL,ch,TO_NOTVICT);
				act("$n gets the first strike on you!",victim,NULL,ch,TO_VICT);
				act("You get the first strike on $N!",victim,NULL,ch,TO_CHAR);
				act("{BVictim gets first strike",ch,NULL,victim,TO_ROOM);

*/				multi_hit( victim, ch, TYPE_UNDEFINED );
			}
		}
		else
		{
			ptc(ch, "{RYou are in a fight with %d others{x\n\r", ch->number_of_fights);
			if (!find_next_victim(ch))
			{
				stop_all_fighting( ch );
				stc("{WNO VICTIMS{x\n\r", ch);
			}
			else
				stc("{WGOT HIM/HER{x\n\r", ch);
		}

		if ( !is_fighting(ch) || ( victim = ch->advancing_on ) == NULL )
			continue;
		/*
		* Fun for the whole family!
		*/

		if ( !IS_NPC( ch ) && IS_SET( ch->auto_flags, AUTO_AUTOH2H ) )
			do_function( ch, &do_punch, "" );

		check_assist(ch,victim);

		if ( IS_NPC( ch ) )
		{
			if ( HAS_TRIGGER_MOB( ch, TRIG_FIGHT ) )
				p_percent_trigger( ch, NULL, NULL, victim, NULL, NULL, TRIG_FIGHT );
			if ( HAS_TRIGGER_MOB( ch, TRIG_HPCNT ) )
				p_hprct_trigger( ch, victim );
		}
		for ( obj = ch->carrying; obj; obj = obj_next )
		{
			obj_next = obj->next_content;
			if ( obj->wear_loc != WEAR_NONE && HAS_TRIGGER_OBJ( obj, TRIG_FIGHT ) )
				p_percent_trigger( NULL, obj, NULL, victim, NULL, NULL, TRIG_FIGHT );
		}
		if ( HAS_TRIGGER_ROOM( ch->in_room, TRIG_FIGHT ) && room_trig == FALSE )
		{
			room_trig = TRUE;
			p_percent_trigger( NULL, NULL, ch->in_room, victim, NULL, NULL, TRIG_FIGHT );
		}
	}
	return;
}

/* for auto assisting */
void check_assist(CHAR_DATA *ch,CHAR_DATA *victim)
{
	CHAR_DATA *rch, *rch_next;

	for (rch = ch->in_room->people; rch != NULL; rch = rch_next)
	{
		rch_next = rch->next_in_room;
		if (IS_AWAKE(rch) && !is_fighting(rch))
		{
			if (RIDDEN(rch) == ch || MOUNTED(rch) == ch)
				multi_hit(rch,victim,TYPE_UNDEFINED);

				/* quick check for ASSIST_PLAYER */
			if (!IS_NPC(ch) && IS_NPC(rch) && IS_SET(rch->off_flags,ASSIST_PLAYERS)
				&&  rch->level + 6 > victim->level)
			{
				do_function(rch, &do_emote, "{ccharges forward and attacks!");
				start_extra_fight(rch, victim, RANGE_LONG);
				multi_hit(rch,victim,TYPE_UNDEFINED);
				continue;
			}

				/* PCs next */
			if (!IS_NPC(ch) || IS_AFFECTED(ch,AFF_CHARM))
			{
				if ( ((!IS_NPC(rch) && IS_SET(rch->act,PLR_AUTOASSIST)) || IS_AFFECTED(rch,AFF_CHARM))
					&& is_same_group(ch,rch) && !is_safe(rch, victim))
				{
					start_extra_fight(rch, victim, RANGE_MELEE);
					multi_hit (rch,victim,TYPE_UNDEFINED);
				}
				continue;
			}


			/* now check the NPC cases */
			if (IS_NPC(ch) && !IS_AFFECTED(ch,AFF_CHARM))
			{
				if ( (IS_NPC(rch) && IS_SET(rch->off_flags,ASSIST_ALL)) /*Asist all*/
					|| (IS_NPC(rch) && rch->group && rch->group == ch->group) /*same group*/
					|| (IS_NPC(rch) && rch->race == ch->race && IS_SET(rch->off_flags,ASSIST_RACE)) /*race assist*/
					|| (IS_NPC(rch) && IS_SET(rch->off_flags,ASSIST_ALIGN) /*align assist*/
						&& ((IS_GOOD(rch)    && IS_GOOD(ch))
						|| (IS_EVIL(rch)    && IS_EVIL(ch))
						|| (IS_NEUTRAL(rch) && IS_NEUTRAL(ch))))
					|| (rch->pIndexData == ch->pIndexData && IS_SET(rch->off_flags,ASSIST_VNUM))) /*vnum assist*/
				{
					CHAR_DATA *vch;
					CHAR_DATA *target = NULL;
					int number = 0;
					if (number_bits(1) == 0)
						continue;

					/*Grab random victim from victim's group*/
					for (vch = ch->in_room->people; vch; vch = vch->next)
					{
						if (can_see(rch,vch) &&  is_same_group(vch,victim)
							&&  number_range(0,number) == 0)
						{
							target = vch;
							number++;
						}
					}
					if (target != NULL)
					{
						do_function(rch, &do_emote, "{ccharges forward and attacks!");
						start_extra_fight(rch, target, RANGE_MELEE);
						multi_hit(rch,target,TYPE_UNDEFINED);
					}
				}
			}
		}
	}
}

/*
* Do one group of attacks.
*/
void multi_hit( CHAR_DATA *ch, CHAR_DATA *victim, int dt )
{
	int     chance;
	/* decrement the wait */
	if (ch->desc == NULL)
		ch->wait = UMAX(0,ch->wait - PULSE_VIOLENCE);
	if (ch->desc == NULL)
		ch->daze = UMAX(0,ch->daze - PULSE_VIOLENCE);

	/* no attacks for stunnies -- just a check */
	if (ch->position < POS_RESTING)
		return;

	/* RANGE code - Dalsor */
	if ( ch->advancing == FALSE )
	{
		return;
	}
	if ( ch->advancing_on == NULL )
	{
		return;
	}
	if ( ch->range < RANGE_MISSLE )
	{
		return;
	}
	/* end RANGE code - Dalsor */

	if ( !IS_NPC( ch ) )
	{
		if ( !IS_SET( ch->war_flags, WAR_AUTOFIGHT ) )
		{
			stc("You are set to not autofight, so you will not attack.\n\r",ch);
			return;
		}
		if ( weaponless( ch ) )
		{
			stc("You focus on your unarmed combat skills.\n\r",ch);
			return;
		}
	}
	if (IS_NPC(ch))
	{
		mob_hit(ch,victim,dt);
		return;
	}
	if (MOUNTED(ch))
	{
		if (!mount_success(ch, MOUNTED(ch), FALSE))
		stc("You fall off your mount as you start your attacks!\n\r", ch);
	}

	one_hit( ch, victim, dt, FALSE );
	if (get_eq_char (ch, WEAR_SECONDARY))
	{
		one_hit( ch, victim, dt, TRUE);
		check_improve(ch,gsn_dual,TRUE,5);
	}
	if (!check_fighting(ch, victim))
		return;

	if (IS_AFFECTED(ch,AFF_HASTE))
		one_hit(ch,victim,dt, FALSE);
	if ( !check_fighting(ch, victim) || dt == gsn_backstab )
		return;

	/*Second attack*/
	chance = get_skill(ch,gsn_second_attack);
	if (IS_AFFECTED(ch,AFF_SLOW))
		chance /= 2;
	if ( number_percent( ) < chance )
	{
		one_hit( ch, victim, dt, FALSE );
		check_improve(ch,gsn_second_attack,TRUE,6);
		/*  Secondary has already been checked, don't give 6 attacks, only 4
		if (get_eq_char (ch, WEAR_SECONDARY))
		{
			one_hit( ch, victim, dt, TRUE);
			check_improve(ch,gsn_dual,TRUE,5);
		}
		*/
		if (!check_fighting(ch, victim))
			return;
	}

	chance = get_skill(ch,gsn_third_attack)/2;
	if (IS_AFFECTED(ch,AFF_SLOW))
		chance /= 4;
	if ( number_percent( ) < chance )
	{
		one_hit( ch, victim, dt, FALSE );
		check_improve(ch,gsn_third_attack,TRUE,6);
		/*
		if (get_eq_char (ch, WEAR_SECONDARY))
		{
			one_hit( ch, victim, dt, TRUE);
			check_improve(ch,gsn_dual,TRUE,5);
		}
		*/
		if (!check_fighting(ch, victim))
			return;
	}

	chance = ( get_skill(ch,gsn_hand_to_hand) );
	if ( number_percent( ) < chance && !get_eq_char(ch,WEAR_WIELD))
	{
		one_hit( ch, victim, dt, FALSE );
		check_improve(ch,gsn_hand_to_hand,TRUE,8);
		if (!check_fighting(ch, victim))
			return;
	}
	return;
}

/* procedure for all mobile attacks */
void mob_hit (CHAR_DATA *ch, CHAR_DATA *victim, int dt)
{
	int chance,number;
	CHAR_DATA *vch, *vch_next;

	one_hit(ch,victim,dt, FALSE);
	if (!check_fighting(ch, victim))
		return;

	/* Area attack -- BALLS nasty! */
	if (IS_SET(ch->off_flags,OFF_AREA_ATTACK))
	{
		for (vch = ch->in_room->people; vch != NULL; vch = vch_next)
		{
			vch_next = vch->next;
			if (vch != victim && check_fighting(ch, vch))
				one_hit(ch,vch,dt, FALSE);
		}
	}

	if (IS_AFFECTED(ch,AFF_HASTE) || (IS_SET(ch->off_flags,OFF_FAST) && !IS_AFFECTED(ch,AFF_SLOW)))
		one_hit(ch,victim,dt, FALSE);

	if (!check_fighting(ch, victim) || dt == gsn_backstab)
		return;

	/*QUESTION: can mobs have second or thrid attack??*/
	chance = get_skill(ch,gsn_second_attack)/2;
	if (IS_AFFECTED(ch,AFF_SLOW) && !IS_SET(ch->off_flags,OFF_FAST))
		chance /= 2;
	if (number_percent() < chance)
	{
		one_hit(ch,victim,dt, FALSE);
		if (!check_fighting(ch, victim))
		return;
	}

	chance = get_skill(ch,gsn_third_attack)/4;
	if (IS_AFFECTED(ch,AFF_SLOW) && !IS_SET(ch->off_flags,OFF_FAST))
		chance = 0;
	if (number_percent() < chance)
	{
		one_hit(ch,victim,dt, FALSE);
		if (!check_fighting(ch, victim))
		return;
	}

	/* oh boy!  Fun stuff! */
	if (ch->wait > 0)
		return;
	/*QUESTION: why bother with checks if the functions do nothing?*/
	/*number = number_range(0,2);
	if (number == 1 && IS_SET(ch->act,ACT_MAGE))
	{
	  { mob_cast_mage(ch,victim); return; }  ;
	}
	if (number == 2 && IS_SET(ch->act,ACT_CLERIC))
	{
	 { mob_cast_cleric(ch,victim); return; }  ;
	}*/

	/* now for the skills */
	number = number_range(0,10);
	switch(number)
	{
		case (0) :
			if (IS_SET(ch->off_flags,OFF_BASH))
				do_function(ch, &do_bash, "");
			break;
		case (1) :
			if (IS_SET(ch->off_flags,OFF_BERSERK) && !IS_AFFECTED(ch,AFF_BERSERK))
				do_function(ch, &do_berserk, "");
			break;
		case (2) :
			if (IS_SET(ch->off_flags,OFF_DISARM) || (get_weapon_sn(ch) != gsn_hand_to_hand
				&& (IS_SET(ch->act,ACT_WARRIOR) ||  IS_SET(ch->act,ACT_THIEF))))
				do_function(ch, &do_disarm, "");
			break;
		case (3) :
			if (IS_SET(ch->off_flags,OFF_KICK))
				do_function(ch, &do_kick, "");
			break;
		case (4) :
			if (IS_SET(ch->off_flags,OFF_KICK_DIRT))
				do_function(ch, &do_dirt, "");
			break;
		case (5) :
			if (IS_SET(ch->off_flags,OFF_TAIL))
				do_function(ch, &do_tail, "");
			break;
		case (6) :
			if (IS_SET(ch->off_flags,OFF_TRIP))
				do_function(ch, &do_trip, "");
			break;
		case (7) : /*was CIRCLE, now it's a lucky player ;)*/
			break;
		case (8) :
			if (IS_SET(ch->off_flags,OFF_BACKSTAB) && !check_fighting(ch, victim))
				do_function(ch, &do_backstab, "");
			break;
		case (9) :
			if (IS_SET(ch->off_flags,OFF_CHARGE))
				do_function(ch, &do_charge, "");
			break;
		case (10) :
			if (IS_SET(ch->off_flags,OFF_FORMS))
				do_function(ch, &do_mobforms, "");
			break;
	}
}

/*Imms get half damage*/
bool isInElList args( ( CHAR_DATA *ch ) );

/*
* Hit one guy once.
*/
void one_hit( CHAR_DATA *ch, CHAR_DATA *victim, int dt, bool secondary )
{
	OBJ_DATA *wield;
	OBJ_DATA *victWield;
	int victim_ac;
	int thac0;
	int thac0_00;
	int thac0_32;
	int dam;
	int diceroll;
	int sn = -1,skill;
	int dam_type;
	int precision_num;
	int formsMod;
	bool result;
	bool precision = FALSE;
	bool efficient = FALSE;
	bool critical = FALSE;


	/* just in case */
	if (victim == ch || ch == NULL || victim == NULL)
		return;

	/*
	* Can't beat a dead char!
	* Guard against weird room-leavings.
	*/
	if ( victim->position == POS_DEAD || ch->in_room != victim->in_room )
		return;

	if ( IS_SET( ch->war_flags, WAR_BATTLE )
		 && !IS_NPC( victim )
		 && !IS_SET( victim->war_flags, WAR_BATTLE ) )
		return;

	if ( IS_SET( ch->war_flags, WAR_TOURNEY )
		 && !IS_NPC( victim )
		 && !IS_SET( victim->war_flags, WAR_TOURNEY ) )
		return;

	/*
	* Figure out the type of damage message.
	*/
	if (!secondary)
		wield = get_eq_char( ch, WEAR_WIELD );
	else
		wield = get_eq_char( ch, WEAR_SECONDARY);

	if (victim)
		victWield = get_eq_char( victim, WEAR_WIELD );
	else
		victWield = NULL;

	if ( dt == TYPE_UNDEFINED )
	{
		dt = TYPE_HIT;
		if ( wield != NULL && wield->item_type == ITEM_WEAPON )
			dt += wield->value[3];
		else
			dt += ch->dam_type;
	}
	if (dt < TYPE_HIT)
		if (wield != NULL)
			dam_type = attack_table[wield->value[3]].damage;
		else
			dam_type = attack_table[ch->dam_type].damage;
	else
		dam_type = attack_table[dt - TYPE_HIT].damage;
	if (dam_type == -1)
		dam_type = DAM_BASH;

	/* get the weapon skill */
	sn = get_weapon_sn(ch);
	skill = 20 + get_weapon_skill(ch,sn);
	if ( !IS_NPC(ch) && !IS_SET(ch->op_flags,OP_CHANNELER) )
	skill += ( get_weapon_skill(ch,sn) / 2 );
	/*
	* Calculate to-hit-armor-class-0 versus armor.
	*/
	if ( IS_NPC(ch) )
	{
		thac0_00 = -20;
		thac0_32 = 10;
	}
	else
	{
		thac0_00 = class_table[ch->class].thac0_00;
		thac0_32 = class_table[ch->class].thac0_32;
	}

	thac0  = interpolate( ch->level, thac0_00, thac0_32 );

	if (thac0 < 0)
		thac0 = thac0/2;
	if (thac0 < -5)
		thac0 = -5 + (thac0 + 5) / 2;
	thac0 -= GET_HITROLL(ch) * skill/100;
	thac0 += 5 * (100 - skill) / 100;

	if ( check_precision( ch ) )
	{
		precision = TRUE;
		precision_num = number_range(0,get_skill(ch,gsn_precision));
		if ( precision_num / 10 > 0 )
			thac0 -= precision_num;
	}
	if ( check_efficient( ch ) )
		efficient = TRUE;

	if (dt == gsn_backstab)
		thac0 -= 10 * (100 - get_skill(ch,gsn_backstab));

	if ( IS_NPC(ch) )
	{
		if ( ch->level < 80 )
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 5;
			else thac0 -= ch->level / 12;
		}
		if ( ch->level >= 80 )
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 4.75;
			else thac0 -= ch->level / 9;
		}
		if (ch->level <= 100)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 4.5;
			else thac0 -= ch->level / 8.5;
		}
		if (ch->level <= 120)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 4.75;
			else thac0 -= ch->level / 8;
		}
		if (ch->level <= 150)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 4;
			else thac0 -= ch->level / 7.5;
		}
		if (ch->level <= 175)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 3.75;
			else thac0 -= ch->level / 7;
		}
		if (ch->level <= 200)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 3.5;
			else thac0 -= ch->level / 6.5;
		}
		if (ch->level <= 210)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 3.25;
			else thac0 -= ch->level / 6;
		}
		if (ch->level <= 220)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 3;
			else thac0 -= ch->level / 5.5;
		}
		if (ch->level <= 230)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 2.75;
			else thac0 -= ch->level / 5;
		}
		if (ch->level <= 250)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 2.5;
			else thac0 -= ch->level / 4.5;
		}
		if (ch->level <= 275)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level / 2.25;
			else thac0 -= ch->level / 4;
		}
		if (ch->level <= 300)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= ch->level;
			else thac0 -= ch->level / 3.5;
		}
		if ( ch->level > 300)
		{
			if (IS_SET(ch->act,ACT_WARRIOR)) thac0 -= (ch->level * 2);
			else thac0 -= ch->level;
		}
	}
	switch(dam_type)
	{
		case(DAM_PIERCE):
			victim_ac = GET_AC(victim,AC_PIERCE)/10;
			break;
		case(DAM_BASH):
			victim_ac = GET_AC(victim,AC_BASH)/10;
			break;
		case(DAM_SLASH):
			victim_ac = GET_AC(victim,AC_SLASH)/10;
			break;
		default:
			victim_ac = GET_AC(victim,AC_EXOTIC)/10;
			break;
	}
	if (victim_ac < -15)
		victim_ac = (victim_ac + 15) / 5 - 15;
	if ( !can_see( ch, victim ) )
		victim_ac -= 4;
	if ( victim->position < POS_FIGHTING)
		victim_ac += 4;
	if (victim->position < POS_RESTING)
		victim_ac += 6;

	/*
	* The moment of excitement!
	*/
	while ( ( diceroll = number_bits( 5 ) ) >= 20 )
		;

	if ( diceroll == 0 || ( diceroll != 19 && diceroll < thac0 - victim_ac ) )
	{
		/* Miss. */
		damage( ch, victim, 0, dt, dam_type, TRUE );
		if (dt == gsn_circle) /*QUESTION: does circle still exist??*/
			one_hit( victim, ch, gsn_circle, TRUE );
		if ( sn == gsn_hand_to_hand )
			check_improve(ch,sn,TRUE,10);
		tail_chain( );
		return;
	}
	/*
	* Hit.
	* Calc damage.
	*/
	if ( IS_NPC(ch) && (!ch->pIndexData->new_format || wield == NULL))
		if (!ch->pIndexData->new_format)
		{
			dam = number_range( ch->level / 2, ch->level * 3 / 2 );
			if ( wield != NULL )
				dam += dam / 2;
		}
		else
			dam = dice(ch->damage[DICE_NUMBER],ch->damage[DICE_TYPE]);
	else
	{
		if (sn != -1)
			check_improve(ch,sn,TRUE,5);
		if ( sn == gsn_hand_to_hand )
			check_improve(ch,sn,TRUE,8);
		if ( wield != NULL )
		{
			dam = dice(1,wield->value[2]) * skill/100;

			/* sharpness! 5% bonus */
			if (IS_WEAPON_STAT(wield,WEAPON_SHARP))
				dam += dam / 20;
			
			if (IS_WEAPON_STAT(wield,WEAPON_VORPAL))
			{
				int critchance = 17;
				if ( dice(1,20) >= critchance && dt != gsn_counter )
				{
					critical = TRUE;
					//sprintf(buf, "You critically damage $N! {G[{R%d{G]{x\n\r", dam);
				}
			}
		}
		else
			dam = number_range( 1 + 4 * skill/100, 2 * ch->level/3 * skill/100);
	}
	if ( IS_NPC( ch ) )
		dam += number_range( ch->level / 2, ch->level );

	/*
	* Bonuses. Add special effects here.
	*/

	/* the dt checks MUST stay in there else these races get way too strong - Dalsor */
	/* Also - modified the bonus so life races gain slowly in strength over time - but
	 * but not too much. - Kerrick */
	/* It seems to me that everyone should get a bonus to damage through remorts,
	   trollocs and such should have a higher bonus, due to the lack of forms - Radyth */

	if (number_percent() <=  get_skill(ch,gsn_enhanced_damage))
	{
		dam += get_skill(ch, gsn_enhanced_damage) / 2;
		check_improve(ch,gsn_enhanced_damage,TRUE,6);
	}

	if (!IS_NPC(ch) && dt != gsn_backstab && dt != gsn_assassinate)
	{
		if (ch->race == race_lookup("ogier") || ch->race == race_lookup("trolloc") || ch->race == race_lookup("fade"))
			dam += calc_remort_tier(ch) * 30 + ch->level / 3;

		if (ch->race == race_lookup("fade"))
			dam += ch->pcdata->rebirth / 2;

		dam += calc_remort_tier(ch) * 10 + ch->pcdata->rebirth;
	}

	/* fire shields - Dalsor*/
	if (IS_AFFECTED(victim, OP_FSHIELD) && !IS_NPC(victim))
	{
		damage(victim,ch,victim->level / 4,1,DAM_FIRE,TRUE);
		act("{rF{Rl{ra{Rm{re{Rs{x creep up your arm, licking at your face!",ch,0,victim,TO_CHAR);
		act("{rF{Rl{ra{Rm{re{Rs{x creep up $n's arm, licking at $s face!",ch,0,victim,TO_ROOM);
	}

	/* this group is for the offensive special forms check - Dalsor */
	if ( ch->race == race_lookup( "aiel" ) )
	{
		if ( wield != NULL )
		{
			if ( sform_is_set( ch, TRUE ) && dt >= TYPE_HIT )
			{
				formsMod = sforms_bonus( ch, TRUE );
				dam += formsMod;

			}
		}
	}
	else
	{
		if ( wield != NULL )
		{
			if ( form_is_set( ch, TRUE ) && dt >= TYPE_HIT )
			{
				formsMod = forms_bonus( ch, TRUE );
				dam += formsMod;
			}
		}
	}


	/* this group is for the defensive special forms check - Dalsor */
	if ( victim->race == race_lookup( "aiel" ) )/* ch -> victim*/
	{
		if ( victWield != NULL )
		{
			if ( sform_is_set( victim, FALSE ) && dt >= TYPE_HIT )
			{
				formsMod = sforms_bonus( victim, FALSE );/* changed ch to victim as I think the victim's
									defensive pos has to be checked, tho I'm not sure "QUESTION"*/
				dam -= formsMod;
			}
		}
	}
	else if ((victim->race == race_lookup("fade") || victim->race == race_lookup("ogier") || victim->race == race_lookup("trolloc")) && !IS_NPC(victim))
	{
		float soak = (calc_remort_tier(victim) * 0.002) + (victim->pcdata->rebirth * 0.004) + (get_curr_stat(victim, STAT_CON) * 0.0002);

		if (victim->race == race_lookup("fade"))
			soak += .05;

		//ptc(victim,"Damage before soak: %d\n\r", dam);
		dam -= (dam * soak);
		/*ptc(victim," T = %f, R = %f, C = %f, Base Soak = %f\n\r", t, r, c, soak);
		ptc(victim,"Damage After Soak = %d\n\r", dam);*/
	}
	else
	{
		if ( victWield != NULL )
		{
			if ( form_is_set( victim, FALSE ) && dt >= TYPE_HIT )
			{
				formsMod = forms_bonus( victim, FALSE );/*ch -> victim*/
				dam -= formsMod;
			}
		}
	}
	/* that's it for the specialf forms check for now - Dalsor */

	if ( !IS_AWAKE(victim) )
		dam *= 2;
	else if (victim->position < POS_FIGHTING)
		dam = dam * 3 / 2;

	if ( ( dt == gsn_backstab || dt == gsn_assassinate ) && wield != NULL)
	{
		if ( is_exact_name( ch->name, "Rand" ) )
			dam *= 5 + (ch->level / 8);
		else if ( wield->value[0] != 2 )
			dam *= 2 + (ch->level / 10);
		else
			dam *= 2 + (ch->level / 8);
	}
	/* circle is a mob special skill now, very nasty for mob blademaster - Dalsor */
	if ( dt == gsn_circle && wield != NULL && IS_NPC( ch ) ) /* QUESTION: is circle still in?*/
	{
		if ( wield->value[0] != 2 )
			dam *= 2+ (ch->level / 10);
		else
			dam *=2 + (ch->level / 8); /* pierce does more */
	}

	dam += GET_DAMROLL(ch) * UMIN(100,skill) / 125;

	/* Changed it so that efficient gives a higher bonus to damage than precision - Radyth */
	if ( efficient )
	{
		dam += get_skill(ch,gsn_efficient);
		check_improve( ch, gsn_efficient, TRUE, 8 );
	}
	
	if ( precision )
	{
		dam += get_skill(ch,gsn_precision) / 4;
		check_improve( ch, gsn_precision, TRUE, 8 );
	}

	if ( dam <= 0 )
		dam = 1;

	/* check for critical hits, Ta'veren, and Matrim's Luck gevent */
	{
		int critnumber=20;

		if ( TAV(ch) || TAV(victim)) /*the dice play odd for Taveren, in good and bad ways*/
			critnumber = 15;

		if ( gevent->running == 10 ) /* Matrim's Luck */
			critnumber -= 2;

		if ( dice(1,20) >= critnumber && dt != gsn_backstab && dt != gsn_assassinate && dt != gsn_counter )
		{
			critical = TRUE;

			if ( !IS_NPC( victim ) )
			{
				victim->pcdata->summary[SUM_CRITICALS_TAKEN] += 1;
				victim->pcdata->summary[SUM_CRITICALS_TAKEN_EVER] += 1;
			}

			if ( !IS_NPC( ch ) )
			{
				ch->pcdata->summary[SUM_CRITICALS_INFLICTED] += 1;
				ch->pcdata->summary[SUM_CRITICALS_INFLICTED_EVER] += 1;
			}
		}
	}

	if ( isInElList( victim ) ) /*Protect some Immies ;)*/
		dam /= 2;

	check_counter(ch, victim, dam, dt);

   	if (wield && IS_WEAPON_STAT(wield,WEAPON_VAMPIRIC))
	{
		int vamp = dam / 20;

		if ( number_percent() > 30 )
		{
			ptc(ch, "{c%s {cdraws life from %s. {c[{w%d{c]{x\n\r", wield->short_descr, PERS(victim, ch), vamp);
			act("{c$p {cdraws life from $N.{c",ch,wield,victim,TO_NOTVICT);
			act("{cYou feel $p {cdrawing your life away.{c", victim,wield,NULL,TO_CHAR);
			dam += vamp;
			ch->hit += vamp;

			if (ch->hit > get_maxhit(ch))	ch->hit = get_maxhit(ch);
		}
		else
		{
			ptc(ch, "{c%s {cdraws energy from %s. {c[{w%d{c]{x\n\r", wield->short_descr, PERS(victim, ch), vamp);
			act("{c$p {cdraws energy from $N.{c",ch,wield,victim,TO_NOTVICT);
			act("{cYou feel $p {cdrawing your energy away.{c", victim,wield,NULL,TO_CHAR);
			dam += vamp;
			ch->stam += vamp;
                
			if (ch->stam > get_maxstam(ch))   ch->stam = get_maxstam(ch);
		}
	}


	/* Weird workaround to make sure critical hits deal damage. For some reason the doubled damage isn't
	 * being passed properly into the damage function. Wtf.
	 */
	if (critical == TRUE)
	{
		dam = dam * 2;
		//sprintf(buf, "You critically strike $N!");
		result = damage( ch, victim, dam, dt, dam_type, TRUE );
		/*sprintf(log, "Crit true, should be %d damage", critdam);
		log_string(log);
		victim->hit -= dam;*/
	  	//act( buf, ch, NULL, victim, TO_CHAR );
		return;
	}
	else
	result = damage( ch, victim, dam, dt, dam_type, TRUE );

	/* but do we have a funky weapon? */
	if (result && wield != NULL)
		get_special_stat(ch,wield,victim);
	tail_chain( );
	return;
}



CHAR_DATA *random_group_member(CHAR_DATA *ch)
{
	CHAR_DATA *rch, *rch_next;
	CHAR_DATA *gch = NULL;
	int amt = 0;
	char buf[MSL], lbuf[MSL];

	for (rch = ch->in_room->people; rch != NULL; rch = rch_next)
	{
		rch_next = rch->next_in_room;
		if (!is_same_group(ch, rch))	continue;
		if (IS_NPC(rch))		continue;
		if (gch == NULL && rch != NULL) gch = rch;
		amt++;
		rch->lootroll = number_range(1, 100);
		if (rch->lootroll > gch->lootroll)	gch = rch;
	}

	if (amt > 1)
	{
		printf_to_char(gch, "You win the roll with %d. ", gch->lootroll);
		sprintf(buf, "%s wins the roll with %d. ", gch->name, gch->lootroll);

		for (rch = ch->in_room->people; rch != NULL; rch = rch_next)
		{
			rch_next = rch->next_in_room;
			if (!is_same_group(ch, rch))	continue;
			if (gch == rch)			continue;
			if (IS_NPC(rch))		continue;
			sprintf(lbuf, "%s rolls %d. ", rch->name, rch->lootroll);
			stc(lbuf, gch);
			strcat(buf, lbuf);
		}

		stc("\n\r", gch);
		act(buf, gch, NULL, NULL, TO_ROOM);
	}

	return gch;
}

OBJ_DATA *get_random_material (CHAR_DATA *mob, int type, bool nullallowed)
{
	OBJ_DATA *material;
	int roll = number_range(36500, 36699);
	int rarity = 1;
	char buf[MSL];
	const char *gem_quality[] = { "chipped", "flawed", "modest", "beautiful", "dazzling" };

	if (number_percent() <= 20)	rarity++;
	if (number_percent() <= 20)	rarity++;
	if (number_percent() <= 20)	rarity++;
	if (number_percent() <= 20)	rarity++;

	if ( gevent->running && gevent->num == 10 ) /* Matrim's Luck */
		rarity++;

	if (mob && number_percent() <= 80)
	rarity = UMIN(rarity, mob->level / 100);
	rarity = URANGE(1, rarity, 5);

	if (get_obj_index(roll) == NULL && nullallowed)	return NULL;

	while (get_obj_index(roll) == NULL
	|| get_obj_index(roll)->value[3] > rarity
	|| get_obj_index(roll)->item_type != ITEM_CRAFTING_MATERIAL
	|| (type > 0 && type != get_obj_index(roll)->value[0]))
	{
		rarity = number_range(1, 5);
		roll = number_range(36500, 36699);
	}

	material = create_object(get_obj_index(roll), 0);

	if (material->value[0] == CRAFT_JEWELCRAFT)
	{
		material->value[3] = 1;
		if (number_percent() <= 50)	material->value[3]++;
		if (number_percent() <= 50)	material->value[3]++;
		if (number_percent() <= 50)	material->value[3]++;
		if (number_percent() <= 50)	material->value[3]++;

		sprintf(buf, "%s %s gem", gem_quality[material->value[3] - 1], material->name);
		free_string(material->name);
		material->name = str_dup(buf);

		sprintf(buf, "%s %s", gem_quality[material->value[3] - 1], material->short_descr);
		free_string(material->short_descr);
		material->short_descr = str_dup(buf);

		sprintf(buf, "A %s %s gem is lying here.", gem_quality[material->value[3] - 1], material->short_descr);
		free_string(material->description);
		material->description = str_dup(buf);
	}

	return material;
}

OBJ_DATA *get_random_dye (CHAR_DATA *mob, bool nullallowed)
{
	OBJ_DATA *dye;
	int roll = number_range(36700, 36749);

	if (get_obj_index(roll) == NULL && nullallowed)	return NULL;

	while (get_obj_index(roll) == NULL || get_obj_index(roll)->item_type != ITEM_DYE)
	{
		roll = number_range(36700, 36749);
	}

	dye = create_object(get_obj_index(roll), 0);

	return dye;
}

int random_obj_stat( void )
{
	int i = number_range(1, 12);

	switch (i)
	{
		case 1:		return APPLY_STR;	break;
		case 2:		return APPLY_DEX;	break;
		case 3:		return APPLY_REF;	break;
		case 4:		return APPLY_CON;	break;
		case 5:		return APPLY_INT;	break;
		case 6:		return APPLY_WIS;	break;
		case 7:		return APPLY_INS;	break;
		case 8:		return APPLY_CHA;	break;
		case 9:		return APPLY_HITROLL;	break;
		case 10:	return APPLY_DAMROLL;	break;
		case 11:	return APPLY_HIT;	break;
		case 12:	return APPLY_MANA;	break;
	}

	return APPLY_NONE;
}

OBJ_DATA *get_random_manual (CHAR_DATA *mob, bool nullallowed)
{
	OBJ_DATA *manual;
	AFFECT_DATA *af;
//	int roll = number_range(36910, 36949);
	int roll = number_range(36750, 36949);
	int rarity = number_percent();
	int mod = 0;

	if (get_obj_index(roll) == NULL && nullallowed)	return NULL;

	while (get_obj_index(roll) == NULL
	|| get_obj_index(roll)->value[4] > rarity
	|| get_obj_index(roll)->item_type != ITEM_CRAFTING_MANUAL)
	{
		rarity = number_percent();
//		roll = number_range(36910, 36949);
		roll = number_range(36750, 36949);
	}

	manual = create_object(get_obj_index(roll), 0);

	if (number_percent() <= 75)	mod++;
	if (number_percent() <= 60)	mod++;
	if (number_percent() <= 45)	mod++;
	if (number_percent() <= 30)	mod++;
	if (number_percent() <= 15)	mod++;

	if ( gevent->running && gevent->num == 10 ) /* Matrim's Luck */
		mod++;

	if (mod > 0)
	{
		af			= new_affect();
		af->location		= random_obj_stat();

		if (af->location == APPLY_HIT || af->location == APPLY_MANA)
			mod *= 20;

		af->modifier		= mod;
		af->where		= TO_OBJECT;
		af->type		= -1;
		af->duration		= -1;
		af->bitvector		= 0;
		af->level		= 1;
		af->next		= manual->affected;
		manual->affected	= af;
	}
	return manual;
}



void loot_drops (CHAR_DATA *ch, CHAR_DATA *victim)
{
	DROP_DATA *drop;
	OBJ_DATA *obj;
	CHAR_DATA *to_char;

	if (!IS_NPC(victim)) return;

	for (drop = victim->pIndexData->drops; drop; drop = drop->next)
	{
		if (number_range(1, UMAX(drop->rarity, 1)) > 1)	continue;
		if (get_obj_index(drop->vnum) == NULL)		continue;
		obj = create_object(get_obj_index(drop->vnum), 0);
		to_char = random_group_member(ch);
		fuzzy_obj_bonuses(obj, victim);
		obj_to_char(obj, to_char);
		printf_to_char(to_char, "You get %s from the corpse of %s.\n\r", obj->short_descr, PERS(victim, to_char));
		act ("$n gets $p from the corpse of $N.", to_char, obj, victim, TO_NOTVICT);
	}

	if (number_range(1, 350) == 1 && (obj = get_random_material(victim, 0, FALSE)) != NULL)
	{
		to_char = random_group_member(ch);
		obj_to_char(obj, to_char);
		printf_to_char(to_char, "You get %s from the corpse of %s.\n\r",
		check_dye(obj, NULL, obj->dye_vnum), PERS(victim, to_char));
		act ("$n gets $p from the corpse of $N.", to_char, obj, victim, TO_NOTVICT);
	}

	if (number_range(1, 250) == 1 && (obj = random_adornment()) != NULL)
	{
		to_char = random_group_member(ch);
		obj_to_char(obj, to_char);
		printf_to_char(to_char, "You get %s from the corpse of %s.\n\r",
		check_dye(obj, NULL, obj->dye_vnum), PERS(victim, to_char));
		act ("$n gets $p from the corpse of $N.", to_char, obj, victim, TO_NOTVICT);
		
	}

	if (number_range(1, 250) == 1 && (obj = get_random_dye(victim, FALSE)) != NULL)
	{
		to_char = random_group_member(ch);
		obj_to_char(obj, to_char);
		printf_to_char(to_char, "You get %s from the corpse of %s.\n\r",
		check_dye(obj, NULL, obj->dye_vnum), PERS(victim, to_char));
		act ("$n gets $p from the corpse of $N.", to_char, obj, victim, TO_NOTVICT);
		
	}
/*	Manuals are found in chests
	if (number_percent() <= 1 && (obj = get_random_manual(victim, FALSE)) != NULL)
	{
		to_char = random_group_member(ch);
		obj_to_char(obj, to_char);
		printf_to_char(to_char, "You get %s from the corpse of %s.\n\r",
		check_dye(obj, NULL, obj->dye_vnum), PERS(victim, to_char));
		act ("$n gets $p from the corpse of $N.", to_char, obj, victim, TO_NOTVICT);
	}
*/
	return;
}

void add_drops (CHAR_DATA *ch)
{
	DROP_DATA *drop;
	OBJ_DATA *obj;

	if (!IS_NPC(ch)) return;

	for (drop = ch->pIndexData->drops; drop; drop = drop->next)
	{
		if (number_range(1, UMAX(drop->rarity, 1)) > 1)	continue;
		if (get_obj_index(drop->vnum) == NULL)		continue;
		obj = create_object(get_obj_index(drop->vnum), 0);
		fuzzy_obj_bonuses(obj, ch);
		obj_to_char(obj, ch);
	}

	return;
}

void alter_invader (CHAR_DATA *ch, int level)
{
	int hp_perc, i;

	if (ch->level == level)
		return;

	if (level > 150)	level += (level - 150) / 10;
	level += 10;

	hp_perc = 100 * ch->hit / get_maxhit(ch);
	hp_perc = URANGE(10, hp_perc + 10, 100);

	ch->max_hit = dice(level, 4 * level / 5) + (level * 15);
	ch->hit = hp_perc * get_maxhit(ch) / 100;

	ch->max_stam = 5000;
	ch->stam = get_maxstam(ch);

	for (i = 0; i < MAX_STATS; i ++)
		ch->perm_stat[i] = 2 * level / 3;

	for (i = 0; i < 4; i++)
		ch->armor[i] = -3 * level;

	ch->damage[DICE_NUMBER] = 1;
	ch->damage[DICE_TYPE] = level;
	ch->damage[DICE_BONUS] = 2 * level / 5;
	ch->hitroll = 8 * level / 5;
	ch->level = level;
	return;
}

/*
* Inflict damage from a hit.
*/
bool damage(CHAR_DATA *ch,CHAR_DATA *victim,int dam,int dt,int dam_type,bool show)
{
	CHAR_DATA *tank;
	int tank_skill;
	OBJ_DATA *corpse,*bow;
	bool immune, killem = FALSE;
	DESCRIPTOR_DATA *d;
	char buf[MSL];
	char tank_buf[MSL];
	int chance, chance_diff;
	bool tonochests = FALSE, fdragon = FALSE;

	if ( gevent->running && gevent->num == 1 )
		fdragon = TRUE;

	if ( gevent->running && gevent->num == 13 )
		tonochests = TRUE;

	if ( victim->position == POS_DEAD )
		return FALSE;
	if ( is_exact_name(ch->name,"Rand") )
		dam += ch->level*3;

	if ( !IS_NPC( victim ) )
	{
		if ( victim->leader != NULL )
		{
			for ( tank = victim->in_room->people; tank != NULL; tank = tank->next_in_room )
			{
				if ( tank == victim )
					continue;
				if ( victim->leader == tank )
				{
					tank_skill = get_skill( tank, gsn_tank );
					if ( number_percent() <= tank_skill )
					{
						sprintf( tank_buf, "$n steps in front of $N and absorbs the brunt of the attack.");
						act_new(tank_buf,tank,NULL,victim,TO_CHAR,POS_DEAD);
						act_new(tank_buf,tank,NULL,victim,TO_VICT,POS_DEAD);
						act_new(tank_buf,tank,NULL,victim,TO_NOTVICT,POS_DEAD);
						check_improve( tank, gsn_tank, TRUE, 6 );
						victim = tank;
					}
					else
						check_improve( tank, gsn_tank, FALSE, 6 );
				}
			}
		}
	}

	if ( victim != ch )
	{
	       /*
		* Certain attacks are forbidden.
		* Most other attacks are returned.
		*/
		if ( is_safe( ch, victim ) )
			return FALSE;

		check_killer( ch, victim );

		if ( victim->position > POS_STUNNED  )
		{
			if ( !check_fighting(victim, ch) )
			{
				start_extra_fight( victim, ch, RANGE_MELEE);
				if ( IS_NPC( victim ) && HAS_TRIGGER_MOB( victim, TRIG_KILL ) ) /*WARNING: change the place of this?*/
					p_percent_trigger( victim, NULL, NULL, ch, NULL, NULL, TRIG_KILL );
				if ( IS_NPC(victim) && strcmp(victim->pIndexData->kill_mess,"(null)") )
				{
					act(victim->pIndexData->kill_mess,ch,NULL,NULL,TO_ROOM);
					act(victim->pIndexData->kill_mess,ch,NULL,NULL,TO_CHAR);
				}
			}
			if (victim->timer <= 4)
				victim->position = POS_FIGHTING;
		}
		/*if ( victim->position > POS_STUNNED  )
		{
			if ( !is_fighting(ch) )
				start_extra_fight( victim, ch, RANGE_MELEE);
		}*/

		/*
		* More charm stuff.
		*/
		if ( victim->master == ch )
			stop_follower( victim );
	}

	/*
	* Inviso attacks ... not.
	*/
	if ( IS_AFFECTED(ch, AFF_INVISIBLE) )
	{
		affect_strip( ch, gsn_invis );
		affect_strip( ch, gsn_mass_invis );
		REMOVE_BIT( ch->affected_by, AFF_INVISIBLE );
		act( "{c$n fades into existence.", ch, NULL, NULL, TO_ROOM );
	}
	/* added for mob hate */
	if (victim->hate)
	{
		free_string(victim->hate->name);
		victim->hate->name = str_dup(ch->name);
		victim->hate->who = ch;
	}
	else
		start_hating(victim,ch);

	if (IS_NPC(victim) && IS_SET(victim->act2, ACT2_INVADE))
		alter_invader(victim, ch->level);

	/*
	* Damage modifiers.
	*/
	if ( dam > 1 && !IS_NPC(victim) && victim->pcdata->condition[COND_DRUNK]  > 10 )
		dam = 9 * dam / 10;

	if ( dam > 1 && IS_AFFECTED(victim, AFF_SANCTUARY) )
		dam /= 2;

	if ( dam > 1 && ((IS_AFFECTED(victim, AFF_PROTECT_EVIL) && IS_EVIL(ch) ) /*QUESTION: do we have this stuff?*/
		|| (IS_AFFECTED(victim, AFF_PROTECT_GOOD) && IS_GOOD(ch) )))
		dam -= dam / 4;

	/* Race, Guild, Quest Stuff starts here - Kerrick */

	immune = FALSE;
   /*
	* Check for parry, dodge, shield block, and holding bow.
	*/
	if ( dt >= TYPE_HIT && ch != victim)
	{
		if ( !IS_NPC( victim ) && IS_SET( victim->auto_flags, AUTO_DODGE ) )
		{
			if ( check_dodge( ch, victim ) )
			return FALSE;
		}
		bow = get_eq_char(ch, WEAR_WIELD);
		if (bow != NULL)
		{
			if (bow->value[0] == WEAPON_SHORTBOW
				|| bow->value[0] == WEAPON_LONGBOW
				|| bow->value[0] == WEAPON_RECURVEDBOW
				|| bow->value[0] == WEAPON_COMPOSITEBOW
				|| bow->value[0] == WEAPON_CROSSBOW )
				return FALSE;
		}

		/* shield block moved higher than dodge and parry so it gets checked firsti, better chance to increase */
		if ( check_shield_block(ch,victim))
			return FALSE;

		if ( !IS_NPC( victim ) && IS_SET( victim->auto_flags, AUTO_PARRY ) )
		{
			if ( check_parry( ch, victim ) )
				return FALSE;
		}
	}

	switch(check_immune(victim,dam_type))
	{
		case(IS_IMMUNE):
			immune = TRUE;
			dam = 0;
		break;
		case(IS_RESISTANT):
			dam -= dam/3;
			break;
		case(IS_VULNERABLE):
			dam += dam/2;
			break;
	}

	if (!IS_NPC(victim))
	{
		/* OP barriers*/
		if ( ch != victim && victim->pcdata->char_barrier > 0 && IS_SET( victim->op_flags,OP_BARRIER ) )
		{
			if ( dam > victim->pcdata->char_barrier )
			{
				ptc( victim,"{w%s shatters your {rba{Rr{Dr{Ri{rer!{x\n\r", IS_NPC(ch) ? ch->short_descr : ch->name );
				dam -= victim->pcdata->char_barrier;
				victim->pcdata->char_barrier = 0;
				REMOVE_BIT(victim->op_flags, OP_BARRIER);
			}
			else
			{
				ptc( victim,"{wYour {rba{Rr{Dr{Ri{rer{w absorbs %s's attack!{x\n\r",IS_NPC(ch) ? ch->short_descr : ch->name );
				victim->pcdata->char_barrier -= dam;
			}
		}
	}


	if (show)
		dam_message( ch, victim, dam, dt, immune );

	if (dam == 0)
		return FALSE;

	/*
	* Hurt the victim.
	* Inform the victim of his new state.
	*/
	victim->hit -= dam;

	if (ch != victim)
	{
		if ( victim->advancing == FALSE )
			victim->advancing = TRUE;
		if ( victim->advancing_on == NULL )
			victim->advancing_on = ch;
	}

	update_pos( victim );

	switch( victim->position )
	{
		case POS_MORTAL:
			act( "{c$n is mortally wounded, and will die soon, if not aided.", victim, NULL, NULL, TO_ROOM );
			stc( "{cYou are mortally wounded, and will die soon, if not aided.\n\r", victim );
			break;
		case POS_INCAP:
			act( "{c$n is incapacitated and will slowly die, if not aided.", victim, NULL, NULL, TO_ROOM );
			stc( "{cYou are incapacitated and will slowly die, if not aided.\n\r", victim );
			break;
		case POS_STUNNED:
			act( "{c$n is stunned, but will probably recover.", victim, NULL, NULL, TO_ROOM );
			stc("{cYou are stunned, but will probably recover.\n\r", victim );
			break;
		case POS_DEAD:
			if ( !IS_NPC( victim ) && IS_SET( victim->war_flags, WAR_BATTLE ) )
			{
				sprintf( buf, "{r%s has been slain by %s!{x\n\r",victim->name, ( IS_NPC( ch ) ? ch->short_descr : ch->name ) );
				talk_battle( buf );
				stc( "You have earned 10 Quest Points for your victory!\n\r", ch );
				ch->questpoints += 10;
				break;
			}

			if ( !IS_NPC( victim ) && IS_SET( victim->war_flags, WAR_TOURNEY ) )
			{
				sprintf( buf, "{rGladiator %s has been slain by %s!{x\n\r",victim->name, ( IS_NPC( ch ) ? ch->short_descr : ch->name ) );
				talk_tourney( buf );
				if( ch != victim)
				{
				    stc( "You have earned 25 Quest Points for your victory!\n\r", ch );
				    ch->questpoints += 25;
				}
				else
					stc( "I'm sorry, but we can not condone suicide.\n\r", ch );
				break;
			}

			/* school students dont really die, so a quick hack here (school vnums) */
			if ( IS_NPC( victim )
			&& victim->pIndexData->vnum >= 3700
			&& victim->pIndexData->vnum < 3799 )
			{
				act( "{g$N says, {G'{gWell done, $n! If we had truly been dueling, I would be dead now.{G'{x", ch, NULL, victim, TO_CHAR );
				//act( "{g$N says, {G'{gWell done, $n! If we had truly been dueling, I would be dead now.{G'{x", ch, NULL, victim, TO_ROOM );
				act( "{g$N mutters, {G'{gI'll have to go see the medic about these bruises now...{G'{x", ch, NULL, victim, TO_CHAR );
				//act( "{g$N mutters, {G'{gI'll have to go see the medic about these bruises now...{G'{x", ch, NULL, victim, TO_ROOM );
			}
			/* and hack this so if a student kills a char */
			else if ( IS_NPC( ch )
			&& ch->pIndexData->vnum >= 3700
			&& ch->pIndexData->vnum < 3799 )
			{
				ptc( victim, "{g%s says, {G'{gToo bad, %s! If we had truly been dueling, you would be dead now.{G'{x\n\r", ch->short_descr, victim->name );
				//act( "{g$N says, {G'{gToo bad, $n! If we had truly been dueling, you would be dead now.{G'{x", victim, NULL, ch, TO_ROOM );
				ptc( victim, "{g%s mutters, {G'{gYou'll have to go see the medic about these bruises now...{G'{x", ch->short_descr, victim->name );
				//act( "{g$N mutters, {G'{gYou'll have to go see the medic about these bruises now...{G'{x\n\r", victim, NULL, ch, TO_ROOM );
			}
			else if ( IS_NPC( victim )
			&& is_human( victim )
			&& !IS_SET( victim->act, ACT_WARRIOR )
			&& victim->pIndexData != NULL
			&& victim->pIndexData->die_mess != NULL
			&& victim->pIndexData->die_mess != '\0' )
			{
				if ( !str_cmp( victim->pIndexData->die_mess, "(null)") || !strcmp(victim->pIndexData->die_mess, "(null)\n\r"))
				{
					switch ( number_range( 1,4 ) )
					{
						case 1:
							act( "$N staggers away from the fight.'{x", ch, NULL, victim, TO_CHAR );
							act( "$N staggers away from the fight.'{x", ch, NULL, victim, TO_ROOM );
						break;
						case 2:
							act( "$N slumps to the ground, half-unconcious and dragging $Mself away.'{x", ch, NULL, victim, TO_CHAR );
							act( "$N slumps to the ground, half-unconcious and dragging $Mself away.'{x", ch, NULL, victim, TO_ROOM );
						break;
						case 3:
							act( "$N turns and flees from the fight!'{x", ch, NULL, victim, TO_CHAR );
							act( "$N turns and flees from the fight!'{x", ch, NULL, victim, TO_ROOM );
						break;
						case 4:
							act( "$N crawls shamefully from the fight on all fours.'{x", ch, NULL, victim, TO_CHAR );
							act( "$N crawls shamefully from the fight on all fours.'{x", ch, NULL, victim, TO_ROOM );
						break;
					}
				}
				else
					act( victim->pIndexData->die_mess, victim, NULL, NULL, TO_ROOM );
			}
			else
			{
				act( "{c$n is {RDEAD!!{x", victim, 0, 0, TO_ROOM );
				stc( "{cYou have been {RKILLED!!{x\n\r\n\r", victim );
			}
			/* record kills for do_summary -- Dalsor 03.14.04 */
			if ( !IS_NPC( ch ) && IS_NPC( victim ) )
			{
				ch->pcdata->summary[SUM_MOB_KILLS] += 1;
			}
			if ( !IS_NPC( ch ) && !IS_NPC( victim ) )
			{

				ch->pcdata->summary[SUM_PC_KILLS] += 1;
				ch->pcdata->summary[SUM_PC_KILLS_EVER] += 1;
			}
			if ( !IS_NPC( victim ) )
			{
				victim->pcdata->summary[SUM_DEATHS] += 1;
				victim->pcdata->summary[SUM_DEATHS_EVER] += 1;
			}
			stop_all_fighting(victim);
			find_next_victim(ch);
			break;
			default:
			if ( dam > victim->max_hit / 4 )
				stc( "{cThat really did {RHURT!{x\n\r", victim );
			if ( victim->hit < victim->max_hit / 4 )
				stc( "{cYou sure are {RB{rLEED{RING!{x\n\r", victim );
			break;
	}

	/*
	* Sleep spells and extremely wounded folks.
	*/
	/*if ( !IS_AWAKE(victim) )
	stop_fighting( victim, FALSE );*/

	/*
	* Payoff for killing things.
	*/
	if ( ch != victim && victim->position == POS_DEAD )
	{
		group_gain( ch, victim );

		if ( !IS_NPC(victim) && !IS_SET( victim->war_flags, WAR_BATTLE ) )
		{
			sprintf( log_buf, "%s killed by %s at %ld", victim->name,
				(IS_NPC(ch) ? ch->short_descr : ch->name), ch->in_room->vnum );
			log_string( log_buf );
		}
		sprintf( log_buf, "%s was murdered by %s at %s [room %ld]",
			(IS_NPC(victim) ? victim->short_descr : victim->name),
			(IS_NPC(ch) ? ch->short_descr : ch->name), ch->in_room->name, ch->in_room->vnum);

		if (IS_NPC(victim))
			wiznet(log_buf,NULL,NULL,WIZ_MOBDEATHS,0,0);
		else
			wiznet(log_buf,NULL,NULL,WIZ_DEATHS,0,0);

		if (!IS_NPC(victim))
		{
			for ( d = descriptor_list; d; d = d->next )
			{
				if ( d->connected == CON_PLAYING )
				{
					if (IS_SET(d->character->comm, COMM_PDEATH) && (!IS_SET(d->character->comm,COMM_QUIET)))
					{
						if ( !IS_NPC(ch) && !IS_NPC(victim) )
							sprintf(log_buf,"\n\r         {y<{Y*{y>{R %s{r was slain by {R%s! {y<{Y*{y>{x",victim->name, ch->name);
						else
							sprintf(log_buf,"\n\r         {Y*{R %s{r was struck down! {Y*{x",victim->name);
						act(log_buf,ch,0,d->character,TO_VICT);
					}
				}
			}
		}

		/*
		* Death trigger
		*/
		if ( IS_NPC( victim ) && HAS_TRIGGER_MOB( victim, TRIG_DEATH) )
		{
			victim->position = POS_STANDING;
			p_percent_trigger( victim, NULL, NULL, ch, NULL, NULL, TRIG_DEATH );
		}
		/* added for Bounty code */
		if (IS_SET(victim->war_flags, WAR_BOUNTY))
		{
			if ( !IS_NPC(ch) )
			{
				if ( victim->pcdata->bounty > 0 )
					ch->money[2][0] += victim->pcdata->bounty;

				victim->pcdata->bounty = 0;
				ptc(ch,"You have recieved payment for your good work and collected the bounty for %s.\n\r",victim->name);
				REMOVE_BIT(victim->war_flags, WAR_BOUNTY);
			}
		}
		/* added for treasure pchest code */
		chance = number_range(50,200);
		chance_diff = number_range(1,100);
		if (tonochests)	chance_diff *= 1.25;

		if ( chance < chance_diff && IS_NPC(victim) && victim->level >= 100 )
		{
			if ((is_human(victim) || tonochests) && !IS_NPC(ch))
			{
				OBJ_DATA *box;

				box = make_treasure_chest(victim->level);
				act("$N carried $t, which falls to the ground.", ch, capit2(box->short_descr), victim, TO_ROOM );
				act("$N carried $t, which falls to the ground.", ch, capit2(box->short_descr), victim, TO_CHAR );
				obj_to_room(box, ch->in_room);


				if ( !IS_NPC( ch ) && IS_SET( ch->auto_flags, AUTO_AUTOBOX ) )
				{
	    				char buf[MIL];
					    sprintf( buf, "get '%s'", box->name );
					    interpret( ch, buf );
				}
			}
		}

		/*
		if (IS_NPC(victim) && ch && !IS_NPC(ch))
			loot_drops(ch, victim);
		*/

		/* added for jailing folks */
		if ( !IS_NPC( ch ) && !IS_NPC( victim ) && ( ch != victim) )
		{
			if ( IS_SET( ch->in_room->sector_type,SECT_CITY )
				&& IS_SET( victim->in_room->sector_type,SECT_CITY )
				&& ch->in_room->vnum != ROOM_VNUM_ARENA
				&& victim->in_room->vnum != ROOM_VNUM_ARENA && !fdragon )
			{
				sprintf( buf, "The constabulary of the %s rush onto the scene!", ch->in_room->area->name );
				/*act( buf, ch,NULL,victim,TO_CHAR );
				sprintf( buf, "The constabulary of the %s rush onto the scene!", ch->in_room->area->name );
				act( buf, ch,NULL,victim,TO_VICT );*/
				act( buf, ch,NULL,victim,TO_ROOM );
				sprintf( buf, "They announce, '%s, you are under arrest for the murder of %s!", ch->name, victim->name );
				/*act( buf, ch,NULL,victim,TO_CHAR );
				sprintf( buf, "They announce, '%s, you are under arrest for the murder of %s!", ch->name, victim->name );
				act( buf, ch,NULL,victim,TO_VICT );*/
				act( buf, ch,NULL,victim,TO_ROOM );
				sprintf( buf, "The constables proceed to beat %s senseless and cart $m to the nearest prison.", ch->name );
				act( buf, ch,NULL,victim,TO_CHAR );
				sprintf( buf, "The constables proceed to beat %s senseless and cart $m to the nearest prison.", ch->name );
				act( buf, ch,NULL,victim,TO_VICT );
				act( buf, ch,NULL,victim,TO_ROOM );

				if ( ch->level <= victim->level )
					ch->pcdata->jail_timer = 30;
				else if ( ch->level > victim->level + 10 )
					ch->pcdata->jail_timer = 60;
				else if ( ch->level > victim->level + 20 )
					ch->pcdata->jail_timer = 90;
				else if ( ch->level > victim->level + 30 )
					ch->pcdata->jail_timer = 120;
				else
					ch->pcdata->jail_timer = 150;

				jail_char( ch );
			}
		}

		/* handle school mobs */
		if ( IS_NPC( victim )
		&& is_human( victim )
		&& !IS_SET( victim->act, ACT_WARRIOR )
		&& victim->pIndexData != NULL
		&& victim->pIndexData->die_mess != NULL
		&& victim->pIndexData->die_mess != '\0' )
		{
			if ( IS_NPC(victim) )
			{
				/* fake making a corpse */
/*				logf( "Killem True, fake_corpse call. School student...", 0 );  */
				killem = TRUE;
				fake_corpse( victim );
				if (!IS_NPC(ch) &&  (corpse = get_obj_list(ch,"corpse",ch->in_room->contents)) != NULL
					&&  corpse->item_type == ITEM_CORPSE_NPC && can_see_obj(ch,corpse))
				{
					OBJ_DATA *coins;
					corpse = get_obj_list( ch, "corpse", ch->in_room->contents );
					if ( IS_SET(ch->act, PLR_AUTOLOOT) && corpse && corpse->contains) /* exists and not empty */
					{
						do_function(ch, &do_get, "all corpse");
					}
					if (IS_SET(ch->act,PLR_AUTOGOLD) && corpse && corpse->contains && !IS_SET(ch->act,PLR_AUTOLOOT))
					{
						if ((coins = get_obj_list(ch,"gcash",corpse->contains)) != NULL)
						{
							do_function(ch, &do_get, "all.gcash corpse");
						}
					}
					if (IS_SET(ch->auto_flags, AUTO_AUTOSKIN))
						skin(ch, corpse, TRUE);
					if (IS_SET(ch->auto_flags, AUTO_AUTOBUTCHER) && corpse)
					{
						do_function(ch, &do_butcher, "corpse");
					}
					if (IS_SET(ch->act, PLR_AUTOSAC))
					{
#if 0
						if (IS_SET(ch->act,PLR_AUTOLOOT) && corpse && corpse->contains)
						{
/*							logf( "Return True, Student kill, autoloot, corpse, corpse contains.", 0 ); */
							return TRUE;  /* leave if corpse has treasure */
						}
						else
						{
							do_function(ch, &do_sacrifice, "corpse");
						}
#endif
						if (!(IS_SET(ch->act,PLR_AUTOLOOT) && corpse && corpse->contains))
							do_function(ch, &do_sacrifice, "corpse");
					}
				}
				/* this is all repeated in soft_kill */
				/*
				victim->pIndexData->killed++;
				kill_table[URANGE(0, victim->level, MAX_LEVEL-1)].killed++;
				extract_char( victim, TRUE );
				*/
			}
		}
		/* handle newbie world mobs -- special case -- Dalsor
		 * we now handle all human mobs this way. -- Dalsor 03.11.04 */
		/*else if ( IS_NPC( victim ) && victim->pIndexData->vnum >= 31000 && victim->pIndexData->vnum < 31199 )*/
		else if ( IS_NPC( victim )
		&& is_human( victim )
		&& !IS_SET( victim->act, ACT_WARRIOR )
		&& victim->pIndexData != NULL
		&& victim->pIndexData->die_mess != NULL
		&& victim->pIndexData->die_mess != '\0' )
		{
			if ( IS_NPC(victim) )
			{
				/* fake making a corpse */
/*				logf( "Killem True, fake_corpse call. Newbie world...", 0 ); */
				killem = TRUE;
				fake_corpse( victim );
				if ( !IS_NPC( ch )
				&& ( corpse = get_obj_list( ch,"corpse", ch->in_room->contents ) ) != NULL
				&& corpse->item_type == ITEM_CORPSE_NPC
				&& can_see_obj( ch,corpse ) )
				{
					corpse = get_obj_list( ch, "corpse", ch->in_room->contents );
					if ( corpse
					&& corpse->contains
					&& victim->pIndexData->vnum == 31001 )
					{
						stc( "{wGreat! You killed a rock! {Y*{ysnicker{Y*{x\n\r{wNow type {YGET ALL FROM CORPSE{w to claim your reward.{x\n\r", ch );
					}
					if ( corpse
					&& corpse->contains
					&& victim->pIndexData->vnum == 31000 )
					{
						stc( "{wGreat! You killed a trolloc!{x\n\r{wNow type {YGET ALL FROM CORPSE{w to claim your reward.{x\n\r", ch );
					}
				}
				victim->pIndexData->killed++;
				kill_table[URANGE(0, victim->level, MAX_LEVEL-1)].killed++;
				extract_char( victim, TRUE );
			}
		}
		/* and if the char gets killed by a student... */
		else if ( IS_NPC( ch ) && ch->pIndexData->vnum >= 3700 && ch->pIndexData->vnum < 3799 )
		{
			victim->position	= POS_RESTING;
			victim->hit		= UMAX( 1, victim->hit  );
			victim->stam		= UMAX( 1, victim->stam );

			if ( is_clan( victim ) )
			{
				char_from_room( victim );
				char_to_room( victim, get_room_index( clan_table[victim->clan].room[1] ) );
				ptc( victim, "Student kill: Sending you to %d.\n\r", clan_table[victim->clan].room[1] );
				do_look( victim, "auto" );
			}
			else
			{
				if ( victim->pcdata->newbie == 1 ) /* this should never happen Since this is school, not tour */
				{
					char_from_room( victim );
					char_to_room( victim, get_room_index( 31020 ) );
					do_look( victim, "auto" );
				}
				else
				{
					char_from_room( victim );
					char_to_room( victim, get_room_index( CAEMLYN_CEMETARY ) );
					do_look( victim, "auto" );
				}
			}
		}
		else /*no school stuff*/
		{
			raw_kill(ch, victim );
			/*find_next_victim(ch);*/

			if (ch->hate)
				stop_hating(ch);
			/* FIXME this stop hating only deals with one of the
			 * mobs that killed victim, if it was a group of mobs
			 * they are still hating */

			/* dump the flags */
			if (ch != victim && !IS_NPC(ch) && !is_same_clan(ch,victim))
			{
				if (IS_SET(victim->act,PLR_KILLER))
					REMOVE_BIT(victim->act,PLR_KILLER);
				else
					REMOVE_BIT(victim->act,PLR_THIEF);
			}

			/*stc( "You were killed normally.\n\r", victim );*/

			/* RT new auto commands */
			if (!IS_NPC(ch) &&  (corpse = get_obj_list(ch,"corpse",ch->in_room->contents)) != NULL
				&&  corpse->item_type == ITEM_CORPSE_NPC && can_see_obj(ch,corpse))
			{
				OBJ_DATA *coins;
				corpse = get_obj_list( ch, "corpse", ch->in_room->contents );
				if ( IS_SET(ch->act, PLR_AUTOLOOT) && corpse && corpse->contains) /* exists and not empty */
				{
					do_function(ch, &do_get, "all corpse");
				}
				if (IS_SET(ch->act,PLR_AUTOGOLD) && corpse && corpse->contains && !IS_SET(ch->act,PLR_AUTOLOOT))
				{
					if ((coins = get_obj_list(ch,"gcash",corpse->contains)) != NULL)
					{
						do_function(ch, &do_get, "all.gcash corpse");
					}
				}
				if (IS_SET(ch->auto_flags, AUTO_AUTOSKIN))
				{
					skin( ch, corpse, TRUE);
				}
				if (IS_SET(ch->auto_flags, AUTO_AUTOBUTCHER) && corpse)
				{
					do_function(ch, &do_butcher, "corpse");
				}
				if (IS_SET(ch->act, PLR_AUTOSAC))
				{
#if 0
					if (IS_SET(ch->act,PLR_AUTOLOOT) && corpse && corpse->contains)

					{
/*						logf( "Return True, Standard kill, autoloot, corpse, corpse contains.", 0 ); */
						return TRUE;  /* leave if corpse has treasure */
					}
					else
					{
						do_function(ch, &do_sacrifice, "corpse");
					}
#endif
					if (!(IS_SET(ch->act,PLR_AUTOLOOT) && corpse && corpse->contains))
						do_function(ch, &do_sacrifice, "corpse");
				}
			}
			return TRUE;
		}
		if ( killem )
		{
/*			logf( "Kill True, soft_kill call.", 0 );  */
			soft_kill( ch, victim );
			return TRUE;
		}
	}

	if ( victim == ch )
		return TRUE;
	/*
	* Take care of link dead people.
	*/
	if ( !IS_NPC(victim) && victim->desc == NULL )
	{
		if ( number_range( 0, victim->wait ) == 0 && IS_SET(victim->auto_flags,AUTO_AUTORECALL ) )
		{
			do_function(victim, &do_clanrecall, "" );
			return TRUE;
		}
	}
	/*
	* Wimp out?
	*/
	if ( IS_NPC(victim) && dam > 0 && victim->wait < PULSE_VIOLENCE / 2)
	{
		if ( ( IS_SET(victim->act, ACT_WIMPY) && number_bits( 2 ) == 0 && victim->hit < victim->max_hit / 5)
			|| ( IS_AFFECTED(victim, AFF_CHARM) && victim->master != NULL && victim->master->in_room != victim->in_room ) )
		{
			do_function(victim, &do_flee, "" );
		}
	}
	if ( !IS_NPC(victim) &&   victim->hit > 0 &&   victim->hit <= victim->wimpy
		&&   victim->wait < PULSE_VIOLENCE / 2 )
	{
		do_function (victim, &do_flee, "" );
	}

	tail_chain( );
	return TRUE;
}

bool find_next_victim(CHAR_DATA *ch)		/*Anthony*/
{
	FIGHTING_DATA *target;

	target = ch->fight_data;

	if (target == NULL || ch->number_of_fights == 0)
		return FALSE;
	while (target != NULL && target->fighter != NULL && target->fighter->position == POS_DEAD)
	{
		/*bugf("{GKill target: %s from %s{x\n\r", target->fighter->name, ch->name);*/
		/*stop_fighting(ch, target->fighter);*/
		/*target = ch->fight_data;*/
		target = target->next;
	}

	if (target != NULL && target->fighter != NULL)
	{
		ch->advancing_on = target->fighter;
		ch->advancing = TRUE;
		ch->range = target->fighter->range;
		ptc(ch, "{wYou start concentrating your fight on %s{x\n\r", target->fighter->name);
		return TRUE;
	}

	ptc(ch, "{GFind next calls Stop All fighting{x\n\r");
	stop_all_fighting(ch);
	return FALSE;
}

bool in_recall_room( CHAR_DATA *victim )
{
        int race, clan;
        //int recall_room_vnums[MAX_PC_RACE+MAX_CLAN];

        if ( victim->in_room->vnum == 3001 )
                return TRUE;

        for ( race = 0; pc_race_table[race].name[0] != '\0'; race++ )
        {
                if ( pc_race_table[race].hometown > 0 )
                {
                        if ( victim->in_room->vnum == pc_race_table[race].hometown && victim->race == race )
                                return TRUE;
                }
        }
        for ( clan = 0; clan_table[clan].name[0] != '\0'; clan++ )
        {
                if ( clan_table[clan].room[0] > 0 )
                {
                        if ( victim->in_room->vnum == clan_table[clan].room[0] && victim->clan == clan )
                                return TRUE;
                }
        }
        return FALSE;
}
bool in_safe_room( CHAR_DATA *victim )
{
        int i;
        //AREA_DATA *pArea;
        //bool found = FALSE;
/*
        for ( i = 0; non_safe_areas_table[i].filename != NULL; i++ )
        {
                for (pArea = area_first; pArea; pArea = pArea->next)
                {
                        if ( !str_cmp( pArea->file_name, non_safe_areas_table[i].filename ) )
                        {
                                found = TRUE;
                        }
                }
                if ( !found )
                        logf( "SAFETY CHECK FAIL:: %s did NOT match any pArea file name!", pArea->file_name, non_safe_areas_table[i].filename );
        }
*/
	//ptc( victim, "You are in %s.\n\r", victim->in_room->area->file_name );

        if ( !str_cmp( victim->in_room->area->file_name, "school.are" ) )
                return TRUE;
        if ( in_recall_room( victim ) )
                return TRUE;

        for ( i = 0; non_safe_areas_table[i].filename != NULL; i++ )
        {
		//ptc( victim, "Checking... %s\n\r", non_safe_areas_table[i].filename );
                if ( !str_cmp( victim->in_room->area->file_name, non_safe_areas_table[i].filename ) )
		{
			/*ptc( victim, "Matched you in %s with %s. You are not safe. Returning FALSE.\n\r", 
				victim->in_room->area->file_name, non_safe_areas_table[i].filename  );*/
                        return FALSE;
		}
        }
/*
        if ( !str_cmp( victim->in_room->area->file_name, "school.are" ) )
                return TRUE;
        if ( in_recall_room( victim ) )
                return TRUE;
*/
        return TRUE;
}

bool is_safe(CHAR_DATA *ch, CHAR_DATA *victim)
{
        if ((victim == NULL) || (ch==NULL) )
                return TRUE;

        if (victim->in_room == NULL || ch->in_room == NULL)
                return TRUE;

        if (check_fighting(victim, ch) || victim == ch)
                return FALSE;

        if (IS_IMMORTAL(ch) && ch->level > LEVEL_IMMORTAL)
                return FALSE;

        if ( !IS_NPC( victim ) && IS_SET( victim->war_flags, WAR_BATTLE ) )
                return FALSE;

        if (ch->level < 10 && !IS_NPC(victim))
        {
                stc("You should grow before you start picking fights.\n\r",ch);
                return TRUE;
        }

        if( ch->number_of_fights >5 || victim->number_of_fights > 5)
        {
                return TRUE;
        }
        if (IS_NPC(victim))
        {
                /* safe room? */
                if (IS_SET(victim->in_room->room_flags,ROOM_SAFE) || IS_SET(ch->in_room->room_flags,ROOM_SAFE))
                {
                        stc("{cNot in this room.\n\r",ch);
                        return TRUE;
                }

                /* quest mobs */
                if ( IS_SET( victim->act, ACT_UNDEAD ) )
                {
                        if ( ( victim->questor != NULL && victim->questor != ch ) && ( victim->pIndexData->vnum != ch->questmob ) )
                        {
                                stc("That is not your quest mob.\n\r",ch);
                                return TRUE;
                        }
                        if ((ch->questmob != victim->pIndexData->vnum) && (victim->questor != ch)) /* quest 2 mobs */
                        {
                                stc("That is not your quest mob.\n\r",ch);
                                return TRUE;
                        }

                }
                /* end quest mobs */
                if (victim->pIndexData->pShop != NULL)
                {
                        stc("{cThe shopkeeper wouldn't like that.\n\r",ch);
                        return TRUE;
                }
                /* no killing healers, trainers, etc */
                if (IS_SET(victim->act,ACT_TRAIN)
                || IS_SET(victim->act,ACT_PRACTICE)
                || (victim->pIndexData->pShop != NULL)
                || IS_SET(victim->act,ACT_IS_HEALER)
                || IS_SET(victim->act,ACT_IS_CHANGER))
                {
                        stc("{cI don't think the Creator would approve.\n\r",ch);
                        return TRUE;
                }
                if (!IS_NPC(ch))
                {
                        /* no pets */
                        if (IS_SET(victim->act,ACT_PET))
                        {
                                act("{cBut $N looks so cute and cuddly...", ch,NULL,victim,TO_CHAR);
                                return TRUE;
                        }
                        /* no charmed creatures unless owner */
                        if (IS_AFFECTED(victim,AFF_CHARM) && ch != victim->master)
                        {
                                stc("{cYou don't own that monster.\n\r",ch);
                                return TRUE;
                        }
                }
        }
        /* killing players */
        else
        {
                /* NPC doing the killing */
                if (IS_NPC(ch))
                {
                        /* safe room check */
                        if (IS_SET(victim->in_room->room_flags,ROOM_SAFE))
                        {
                                stc("{cNot in this room.\n\r",ch);
                                return TRUE;
                        }
                        /* charmed mobs and pets cannot attack players while owned */
                        if (IS_AFFECTED(ch,AFF_CHARM) && ch->master != NULL &&  !check_fighting(ch->master, victim))
                        {
                                stc("{cPlayers are your friends!\n\r",ch);
                                return TRUE;
                        }
                        return FALSE;
                }
                /* player doing the killing */
                else
                {
			if ( IS_SET( victim->war_flags, WAR_BOUNTY ) )
			{
				return FALSE;
			}
                        if (IS_SET(victim->in_room->room_flags,ROOM_SAFE))
                        {
                                stc("{cNot in this room.\n\r",ch);
                                return TRUE;
                        }

                        if ( calc_remort_tier( victim ) >= 10 && calc_remort_tier( ch ) >= 10 )
                                return FALSE;

                        if ( ch->pcdata && ch->pcdata->rebirth <= 0 )
                        {
                                stc("You must have been reborn at least once to kill other players.\n\r", ch);
                                return TRUE;
                        }

                        if ( victim->pcdata && victim->pcdata->rebirth <= 0 )
                        {
                                ptc( ch, "%s has yet to be reborn. Give them a chance to grow first.\n\r", victim->name );
                                return TRUE;
                        }

                        if ( calc_remort_tier( ch ) == 1 && calc_remort_tier( victim ) == 1 )
                                return FALSE;

                        if ( calc_remort_tier( ch ) -1 > calc_remort_tier( victim ) )
                        {
                                //ptc( ch, "Your tier: %d. Their tier %d.\n\r", calc_remort_tier( ch ), calc_remort_tier( victim ) );
                                return TRUE;
                        }

                        if ( in_safe_room( victim ) )
                        {
                                return TRUE;
                        }
                        if ( gevent->running && gevent->num == 1 ) /* False Dragon */
                                return FALSE;

                        if (IS_SET(victim->act,PLR_KILLER) || IS_SET(victim->act,PLR_THIEF))
                                return FALSE;

                        if (ON_GQUEST(ch))
                        {
                                stc("They are not on the target list of the Global Quest.\n\r", ch);
                                act("$n looks at you with muder in $s eyes!", ch, NULL, victim, TO_VICT );
                                return TRUE;
                        }
                        if (ON_GQUEST(victim))
                        {
                                stc("They are too closely involved in something right now.\n\r", ch);
                                act("$n looks at you with muder in $s eyes!", ch, NULL, victim, TO_VICT );
                                return TRUE;
                        }
                }
        }

        return FALSE;
}

bool is_safe_spell(CHAR_DATA *ch, CHAR_DATA *victim, bool area )
{
	if (victim->in_room == NULL || ch->in_room == NULL)
		return TRUE;
	if (victim == ch && area)
		return TRUE;
	if (is_fighting(victim) && (victim->advancing_on == ch || victim == ch))
		return FALSE;
	if (IS_IMMORTAL(ch) && ch->level > LEVEL_IMMORTAL && !area)
		return FALSE;
	if( ch->number_of_fights >5 || victim->number_of_fights > 5)
	{
		stc("That's enough at a time.\n\r",ch);
		return TRUE;
	}

	/* killing mobiles */
	if (IS_NPC(victim))
	{
		/* safe room? */
		if (IS_SET(victim->in_room->room_flags,ROOM_SAFE))
			return TRUE;
		if (victim->pIndexData->pShop != NULL)
			return TRUE;
		/* no killing healers, trainers, etc */
		if (IS_SET(victim->act,ACT_TRAIN)
			|| IS_SET(victim->act,ACT_PRACTICE)
			|| IS_SET(victim->act,ACT_IS_HEALER)
			|| IS_SET(victim->act,ACT_IS_CHANGER)
			|| (victim->pIndexData->pShop != NULL)) /*Anthony: added to make parallel with is_safe*/
			return TRUE;
		if (!IS_NPC(ch))
		{
			/* no pets */
			if (IS_SET(victim->act,ACT_PET))
				return TRUE;
			/* no charmed creatures unless owner */
			if (IS_AFFECTED(victim,AFF_CHARM) && (area || ch != victim->master))
				return TRUE;
			/* legal kill? -- cannot hit mob fighting non-group member */
			if (is_fighting(victim) && !is_same_group(ch,victim->advancing_on))
				return TRUE;
		}
		else
		{
			/* area effect spells do not hit other mobs */
			if (area && is_fighting(ch) && !is_same_group(victim,ch->advancing_on))
				return TRUE;
		}
	}
	/* killing players */
	else
	{
		if (area && IS_IMMORTAL(victim) && victim->level > LEVEL_IMMORTAL)
			return TRUE;

		/* NPC doing the killing */
		if (IS_NPC(ch))
		{
			/* charmed mobs and pets cannot attack players while owned */
			if (IS_AFFECTED(ch,AFF_CHARM) && ch->master != NULL && !check_fighting(ch->master, victim))
				return TRUE;
			/* safe room? */
			if (IS_SET(victim->in_room->room_flags,ROOM_SAFE))
				return TRUE;
			/* legal kill? -- mobs only hit players grouped with opponent*/
			if (is_fighting(ch) && !check_fighting_groupie(ch,victim))
				return TRUE;
		}
		/* player doing the killing */
		else
		{
			if (!is_clan(ch))
				return TRUE;
			if (IS_SET(victim->act,PLR_KILLER) || IS_SET(victim->act,PLR_THIEF))
				return FALSE;
			if (!is_clan(victim))
				return TRUE;
			if (ON_GQUEST(ch) || ON_GQUEST(victim))
				return TRUE;
			if (ch->level > victim->level + 8)
				return TRUE;
		}
	}
	return FALSE;
}

/*
* See if an attack justifies a KILLER flag.
*/
void check_killer( CHAR_DATA *ch, CHAR_DATA *victim )
{
	char buf[MAX_STRING_LENGTH];
	/*
	* Follow charm thread to responsible character.
	* Attacking someone's charmed char is hostile!
	*/
	while ( IS_AFFECTED(victim, AFF_CHARM) && victim->master != NULL )
		victim = victim->master;
	/*
	* NPC's are fair game.
	* So are killers and thieves.
	*/
	if ( IS_NPC(victim) || IS_SET(victim->act, PLR_KILLER) || IS_SET(victim->act, PLR_THIEF))
		return;
	if ( IS_SET(ch->affected_by, AFF_CHARM) )
	{
		if ( ch->master == NULL )
		{
			char buf[MSL];
			sprintf( buf, "Check_killer: %s bad AFF_CHARM", IS_NPC(ch) ? ch->short_descr : ch->name );
			bug( buf, 0 );
			affect_strip( ch, gsn_charm_person );
			REMOVE_BIT( ch->affected_by, AFF_CHARM );
			return;
		}
		stop_follower( ch );
		return;
	}
	/*
	* NPC's are cool of course (as long as not charmed).
	* Hitting yourself is cool too (bleeding).
	* So is being immortal (Alander's idea).
	* And current killers stay as they are.
	*/
	if ( IS_NPC(ch) || ch == victim || ch->level >= LEVEL_IMMORTAL || !is_clan(ch)
		|| IS_SET(ch->act, PLR_KILLER) || check_fighting(ch,victim))
		return;
	if (!IS_NPC(ch))
		SET_BIT(ch->war_flags,WAR_PK);
	sprintf(buf,"{c$N is attempting to murder %s",victim->name);
	wiznet(buf,ch,NULL,WIZ_FLAGS,0,0);
	//save_char_obj( ch );
	save_char_obj(ch, FALSE, FALSE);
	return;
}
/*
* Check for parry.
*/
bool check_parry( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int chance, num;

	if ( !IS_AWAKE(victim) )
		return FALSE;
	if (!IS_NPC(victim) && get_skill(victim,gsn_parry) < 1)
		return FALSE;
	chance = get_skill(victim,gsn_parry) / 2;
	/*PCs need weapons to parry*/
	if ( get_eq_char( victim, WEAR_WIELD ) == NULL )
	{
		if (IS_NPC(victim))
			chance /= 2;
		else
			return FALSE;
	}


	if (blademaster(victim) || victim->race == race_lookup("fade"))
		chance += 10;

	if (!can_see(ch,victim))
		chance /= 2;
	if ( number_percent( ) >= (UMIN(chance, chance) + victim->level - ch->level) )
	{
		check_improve(victim,gsn_parry,FALSE,6);
		return FALSE;
	}

	/*Parry checked, get a message*/
	num = number_range(1,8);
	check_improve(victim,gsn_parry,TRUE,12); /*check taken out of all individual cases*/
	switch(num)
	{
		case 1:
			act( "{cYou parry $n's attack with your weapon.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N parries your attack with $S weapon.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 2:
			act( "{cYou turn $n's attack aside.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N turns your attack aside.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 3:
			act( "{cYou deflect $n's blow.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N deflects your blow.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 4:
			act( "{cYou divert $n's attack, causing $m to stumble.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N diverts your attack, causing you to stumble.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 5:
			act( "{cYou sweep $n's attack aside with your weapon.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N sweeps your attack aside with $S weapon.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 6: /*QUESTION: this case had no check improve, while the parry was succesfull*/
			act( "{cYou repulse $n's attack.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N repulses your attack.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		case 7:
			act( "{cYou defend against $n's attack with your weapon.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N defends against your attack with $S weapon.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
		default:
			act( "{cYou parry $n's attack.",  ch, NULL, victim, TO_VICT    );
			act( "{c$N parries your attack.", ch, NULL, victim, TO_CHAR    );
			return TRUE;
	}
}

bool check_counter( CHAR_DATA *ch, CHAR_DATA *victim, int dam, int dt)
{
	int chance, dam_type, formsMod;
	OBJ_DATA *wield;
	if ( ( get_eq_char(victim, WEAR_WIELD) == NULL ) || !IS_AWAKE(victim) ||
		 !can_see(victim,ch) || (get_skill(victim,gsn_counter) < 1) ||
		 !IS_SET(victim->auto_flags,AUTO_COUNTER))
		return FALSE;

	wield = get_eq_char(victim,WEAR_WIELD);
	if (wield->value[0] == WEAPON_SHORTBOW || wield->value[0] == WEAPON_LONGBOW
		|| wield->value[0] == WEAPON_RECURVEDBOW || wield->value[0] == WEAPON_COMPOSITEBOW
		|| wield->value[0] == WEAPON_CROSSBOW )
		return FALSE;

	chance = get_skill(victim,gsn_counter) / 10;
	chance += ( victim->level - ch->level ) / 2;
	chance += 2 * (get_curr_stat(victim,STAT_DEX) - get_curr_stat(ch,STAT_DEX));
	if (!IS_NPC(victim))
	{
		chance += get_weapon_skill(victim,get_weapon_sn(victim)) - get_weapon_skill(ch,get_weapon_sn(ch));
	}
	else
	{
		chance += get_weapon_skill(victim,get_weapon_sn(victim)) -
		(ch->level / 10 + ((ch->mod_stat[STAT_STR] + ch->mod_stat[STAT_REF] + ch->mod_stat[STAT_DEX]) / 3));
	}
	chance += (get_curr_stat(victim,STAT_STR) - get_curr_stat(ch,STAT_STR) );

	/* limit the possibility of a counterattack to 75% -- Dalsor 03.11.04 */

	if ( number_percent( ) >= UMIN(chance, chance) )
		return FALSE;

	dt = gsn_counter;
	if ( dt == TYPE_UNDEFINED )
	{
		dt = TYPE_HIT;
		if ( wield != NULL && wield->item_type == ITEM_WEAPON )
			dt += wield->value[3];
		else
			dt += ch->dam_type;
	}
	if (dt < TYPE_HIT)
		if (wield != NULL)
			dam_type = attack_table[wield->value[3]].damage;
		else
			dam_type = attack_table[ch->dam_type].damage;
	else
		dam_type = attack_table[dt - TYPE_HIT].damage;

	if (dam_type == -1)
		dam_type = DAM_BASH;

	/* spam reduction - Dalsor */
	/*
	act( "You reverse $n's attack and counter with your own!", ch, NULL, victim, TO_VICT    );
	act( "$N reverses your attack!", ch, NULL, victim, TO_CHAR    );
	*/

	/* dunno why this was taken out but it makes counters too strong without this in place - Dalsor */
	if (dam > victim->level)
	dam = number_range( victim->level*10/9, victim->level*11/9);

	if ( ch->race == race_lookup( "aiel" ) )
	{
		if ( wield != NULL )
		{
			if ( sform_is_set( victim, TRUE ) && !IS_NPC(victim) && !IS_SET(victim->op_flags,OP_CHANNELER) )
			{
				formsMod = sforms_bonus( victim, TRUE );
				dam += formsMod;
			}
		}
	}
	else
	{
		if ( wield != NULL )
		{
			if ( form_is_set( victim, TRUE ) && !IS_NPC(victim) && !IS_SET(victim->op_flags,OP_CHANNELER) )
			{
				formsMod = forms_bonus( victim, TRUE );
				dam += formsMod;
			}
		}
	}

	damage(victim,ch,dam/2, gsn_counter , dam_type ,TRUE ); /* DAM MSG NUMBER!! */
	check_improve(victim,gsn_counter,TRUE,6);
	return TRUE;
}

/*
* Check for shield block.
*/
bool check_shield_block( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int chance;

	if ( !IS_AWAKE(victim) )
		return FALSE;
	if (!IS_NPC(victim) && get_skill(victim,gsn_shield_block) < 1)
		return FALSE;

	chance = 2 * get_skill(victim,gsn_shield_block) / 3;

	if ( get_eq_char( victim, WEAR_SHIELD ) == NULL )
		return FALSE;

	if ( number_percent( ) >= UMIN(chance, chance) + victim->level - ch->level )
		return FALSE;
	act( "{cYou block $n's attack with your shield.",ch,NULL,victim,TO_VICT);
	act( "{c$N blocks your attack with a shield.",ch,NULL,victim,TO_CHAR);
	check_improve(victim,gsn_shield_block,TRUE,6);
	return TRUE;
}

/*
* Check for dodge.
*/
bool check_dodge( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int chance;
	int num;
	bool anticipating = FALSE;
	if ( !IS_AWAKE(victim) )
		return FALSE;
	if (!IS_NPC(victim) && get_skill(victim,gsn_dodge) < 1)
		return FALSE;
	if ( MOUNTED(victim) )
		return FALSE;

	chance = get_skill(victim,gsn_dodge) / 2;
	if ( check_anticipate( victim ) )
	{
		anticipating = TRUE;
		chance += get_skill( victim,gsn_anticipate ) / 4;
		check_improve(victim,gsn_anticipate,TRUE,6);
	}
	if (!can_see(victim,ch))
		chance /= 2;
	if ( number_percent( ) >= UMIN(chance, chance) + victim->level - ch->level )
	{
		check_improve(victim,gsn_dodge,FALSE,6);
		return FALSE;
	}

	num = number_range(1,8);
	check_improve(victim,gsn_dodge,TRUE,6);

	switch(num)
	{
		case 1:
			if ( anticipating )
			{
				act( "{cYou anticipate $n's attack, nimbly dodging.", ch, NULL, victim, TO_VICT    );
				act( "{c$N nimbly dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cYou nimbly dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{c$N nimbly dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 2:
			if ( anticipating )
			{
				act( "{cYou anticipate $n's attack, leaping aside.", ch, NULL, victim, TO_VICT    );
				act( "{cLeaping aside, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cLeaping aside, you dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cLeaping aside, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 3:
			if ( anticipating )
			{
				act( "{cYou anticipate $n's attack and duck aside.", ch, NULL, victim, TO_VICT    );
				act( "{cDucking just in time, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cDucking just in time, you dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cDucking just in time, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 4:
			if ( anticipating )
			{
				act( "{cAnticipating $n's attack, you lean out of the way.", ch, NULL, victim, TO_VICT    );
				act( "{cLeaning out of harm's way, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cLeaning out of harm's way, you dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cLeaning out of harm's way, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 5:
			if ( anticipating )
			{
				act( "{cYou dance aside, anticipating $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cDancing aside, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cDancing aside, you dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cDancing aside, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 6:
			if ( anticipating )
			{
				act( "{cMoving cat-like, you anticipate $n's attack and dodge aside.", ch, NULL, victim, TO_VICT    );
				act( "{cMoving cat-like, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cMoving cat-like, you dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{cMoving cat-like, $N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		case 7:
			if ( anticipating )
			{
				act( "{cYou anticipate $n's attack and gracefully dodge it.", ch, NULL, victim, TO_VICT    );
				act( "{c$N gracefully dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cYou gracefully dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{c$N gracefully dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
		default:
			if ( anticipating )
			{
				act( "{cYou anticipate and dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{c$N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			else
			{
				act( "{cYou dodge $n's attack.", ch, NULL, victim, TO_VICT    );
				act( "{c$N dodges your attack.", ch, NULL, victim, TO_CHAR    );
			}
			return TRUE;
	}
}
/*
* Set position of a victim.
*/
void update_pos( CHAR_DATA *victim )
{
	if ( victim->hit > 0 )
	{
		if ( victim->position <= POS_STUNNED )
			victim->position = POS_STANDING;
		return;
	}
	if ( IS_NPC(victim) && victim->hit < 1 )
	{
		if ( gevent->running
		&& gevent->num == 0
		&& IS_NPC( victim )
		&& !IS_SET( victim->off_flags, OFF_SPIRIT ) ) /* gevent is shadows embrace */
		{
			SET_BIT( victim->off_flags, OFF_SPIRIT );
			act( "{c$n is {RDEAD!!{x", victim, 0, 0, TO_ROOM );
			act( "{R** {r$n rises from death as an avenging spirit! {R**{x\n\r", victim, NULL, NULL, TO_ROOM );
			gevent_makeghost( victim );
			return;
		}
		victim->position = POS_DEAD;
		return;
	}
	if ( victim->hit <= -10 )
	{
		victim->position = POS_DEAD;
		return;
	}
	if ( victim->hit <= -6 )
		victim->position = POS_MORTAL;
	else if ( victim->hit <= -3 )
		victim->position = POS_INCAP;
	else
		victim->position = POS_STUNNED;

	if ( victim->position == POS_DEAD && !IS_NPC( victim ) )
		raw_kill(victim, victim );
	return;
}

/*
* Fake a corpse out of a character.
*/
void fake_corpse( CHAR_DATA *ch )
{
	char buf[MSL];
	char *race;
	OBJ_DATA *corpse;
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;
	char *name;
	ROOM_INDEX_DATA *location;

	location = get_room_index(CAEMLYN_CEMETARY);

	if ( !IS_NPC(ch) )
	{
		bugf( "Creating fake_corpse from PC %s.", ch->name );
		return;
	}
/*	logf( "Faking a corpse.", 0 ); */
	name		= ch->short_descr;
	race        = race_table[ch->race].name;
	corpse		= create_object(get_obj_index(OBJ_VNUM_CORPSE_NPC), 0);
	corpse->timer	= number_range( 3, 6 );

	if (ch->money[0][0] > 1 || ch->money[1][0] > 1 || ch->money[2][0] > 1 || ch->money[3][0] > 1)
	{
		obj_to_obj(create_money(ch->money[0][0],ch->money[1][0],ch->money[2][0],ch->money[3][0]), corpse);
		ch->money[0][0] = 0;
		ch->money[1][0] = 0;
		ch->money[2][0] = 0;
		ch->money[3][0] = 0;
	}
	corpse->cost = 0;

	corpse->level = 1;
	sprintf( buf, "corpse sack" );
	free_string( corpse->name );
	corpse->name = str_dup( buf );

	sprintf( buf, "a sack left behind by %s", ch->short_descr );
	free_string( corpse->short_descr );
	corpse->short_descr = str_dup( buf );

	sprintf( buf, "A sack left behind by %s.", name );
	free_string( corpse->description );
	corpse->description = str_dup( buf );

	for ( obj = ch->carrying; obj != NULL; obj = obj_next )
	{
		bool floating = FALSE;
		obj_next = obj->next_content;
		if (obj->wear_loc == WEAR_FLOAT)
			floating = TRUE;
			obj_from_char( obj );
		if (obj->item_type == ITEM_POTION)
			obj->timer = number_range(500,1000);
		if (obj->item_type == ITEM_SCROLL)
			obj->timer = number_range(1000,2500);
		if (IS_SET(obj->extra_flags,ITEM_ROT_DEATH) && !floating)
		{
			obj->timer = number_range(5,10);
			REMOVE_BIT(obj->extra_flags,ITEM_ROT_DEATH);
		}
		REMOVE_BIT(obj->extra_flags,ITEM_VIS_DEATH);
		if ( IS_SET( obj->extra_flags, ITEM_INVENTORY ) )
			extract_obj( obj );
		else if (floating)
		{
			if (IS_OBJ_STAT(obj,ITEM_ROT_DEATH)) /* get rid of it! */
			{
				if (obj->contains != NULL)/*QUESTION: content in aura's??*/
				{
					OBJ_DATA *in, *in_next;
					act("{c$p evaporates, scattering its contents.", ch,obj,NULL,TO_ROOM);
					for (in = obj->contains; in != NULL; in = in_next)
					{
						in_next = in->next_content;
						obj_from_obj(in);
						obj_to_room(in,ch->in_room);
					}
				}
				else
					act("{c$p evaporates.", ch,obj,NULL,TO_ROOM);
				extract_obj(obj);
			}
			else
			{
				act("{c$p falls to the floor.",ch,obj,NULL,TO_ROOM);
				obj_to_room(obj,ch->in_room);
			}
		}
		else
			obj_to_obj( obj, corpse );
	}

/*	logf( "Faking a corpse. obj_to_obj", 0 ); */
	obj_to_room( corpse, ch->in_room );
	return;
}

/*
* Make a corpse out of a character.
*/
OBJ_DATA *make_corpse( CHAR_DATA *ch )
{
	char buf[MSL];
	char *race;
	OBJ_DATA *corpse;
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;
	char *name;
	ROOM_INDEX_DATA *location;

	location = get_room_index(CAEMLYN_CEMETARY);
	if ( IS_NPC(ch) )
	{
		name		= ch->short_descr;
		race        = race_table[ch->race].name;
		corpse		= create_object(get_obj_index(OBJ_VNUM_CORPSE_NPC), 0);
		corpse->timer	= number_range( 3, 6 );
		corpse->value[0] = ch->pIndexData->vnum;
		if (ch->money[0][0] > 1 || ch->money[1][0] > 1 || ch->money[2][0] > 1 || ch->money[3][0] > 1)
		{
			obj_to_obj(create_money(ch->money[0][0],ch->money[1][0],ch->money[2][0],ch->money[3][0]), corpse);
			ch->money[0][0] = 0;
			ch->money[1][0] = 0;
			ch->money[2][0] = 0;
			ch->money[3][0] = 0;
		}
		corpse->cost = 0;
	}
	else
	{
		name		= ch->name;
		corpse		= create_object(get_obj_index(OBJ_VNUM_CORPSE_PC), 0);
		corpse->timer	= number_range( 25, 40 );
		REMOVE_BIT(ch->act,PLR_CANLOOT);
		corpse->owner = str_dup(ch->name);
		if (ch->money[0][0] > 1 || ch->money[1][0] > 1 || ch->money[3][0] > 1 || ch->money[2][0] > 1)
		{
			obj_to_obj(create_money(ch->money[0][0],ch->money[1][0],ch->money[2][0],ch->money[3][0]), corpse);
			ch->money[0][0] = 0;
			ch->money[1][0] = 0;
			ch->money[2][0] = 0;
			ch->money[3][0] = 0;
		}
		corpse->cost = 0;
	}

	corpse->level = 1;
	sprintf( buf, corpse->short_descr, name );
	free_string( corpse->short_descr );
	corpse->short_descr = str_dup( buf );
	sprintf( buf, corpse->description, name );
	free_string( corpse->description );
	corpse->description = str_dup( buf );

	for ( obj = ch->carrying; obj != NULL; obj = obj_next )
	{
		bool floating = FALSE;
		obj_next = obj->next_content;
		if (obj->wear_loc == WEAR_FLOAT)
			floating = TRUE;
		obj_from_char( obj );
		if (obj->item_type == ITEM_POTION)
			obj->timer = number_range(500,1000);
		if (obj->item_type == ITEM_SCROLL)
			obj->timer = number_range(1000,2500);
		if (IS_SET(obj->extra_flags,ITEM_ROT_DEATH) && !floating)
		{
			obj->timer = number_range(5,10);
			REMOVE_BIT(obj->extra_flags,ITEM_ROT_DEATH);
		}
		REMOVE_BIT(obj->extra_flags,ITEM_VIS_DEATH);

		if ( IS_SET( obj->extra_flags, ITEM_INVENTORY ) )
			extract_obj( obj );
		else if (floating && !IS_SET(obj->extra_flags, ITEM_STAYDEATH))
		{
			if (IS_OBJ_STAT(obj,ITEM_ROT_DEATH))
			{
				if (obj->contains != NULL)
				{
					OBJ_DATA *in, *in_next;
					act("{c$p evaporates, scattering its contents.", ch,obj,NULL,TO_ROOM);
					for (in = obj->contains; in != NULL; in = in_next)
					{
						in_next = in->next_content;
						obj_from_obj(in);
						obj_to_room(in,ch->in_room);
					}
				}
				else
					act("{c$p evaporates.",	ch,obj,NULL,TO_ROOM);
				extract_obj(obj);
			}
			else
			{
				act("{c$p falls to the floor.",ch,obj,NULL,TO_ROOM);
				obj_to_room(obj,ch->in_room);
			}
		}
		else
			obj_to_obj( obj, corpse );
	}

	if (IS_NPC(ch))
	{
		obj_to_room( corpse, ch->in_room );
		return NULL;
	}
	else if (!is_clan(ch))
	{
		obj_to_room( corpse, location );
/*		do_function( ch, &do_get, corpse->name ); */
		return corpse;
	}
	else if (is_clan(ch))
	{
		obj_to_room( corpse, get_room_index(clan_table[ch->clan].room[1] ) );
/*		do_function( ch, &do_get, corpse->name ); */
		return corpse;
	}
	else
	{
		obj_to_room( corpse, ch->in_room );
		return corpse;
	}
}

/*
* Improved Death_cry contributed by Diavolo.
*/
void death_cry( CHAR_DATA *ch )
{
	ROOM_INDEX_DATA *was_in_room;
	char *msg;
	int door, vnum = 0;

	msg = "{cYou hear $n's death cry.";

	switch ( number_bits(4))
	{
		case  0:
			msg  = "{c$n hits the ground ... DEAD.";
			break;
		case  1:
			if (ch->material == 0)
			{
				msg  = "{c$n splatters blood on your armor.";
				break;
			}
		case  2:
			if (IS_SET(ch->parts,PART_GUTS))
			{
				msg = "{c$n spills $s guts all over the floor.";
				vnum = OBJ_VNUM_GUTS;
			}
			break;
		case  3:
			if (IS_SET(ch->parts,PART_HEAD))
			{
				msg  = "{c$n's severed head plops on the ground.";
				vnum = OBJ_VNUM_SEVERED_HEAD;
			}
			break;
		case  4:
			if (IS_SET(ch->parts,PART_HEART))
			{
				msg  = "{c$n's heart is torn from $s chest.";
				vnum = OBJ_VNUM_TORN_HEART;
			}
			break;
		case  5:
			if (IS_SET(ch->parts,PART_ARMS))
			{
				msg  = "{c$n's arm is sliced from $s dead body.";
				vnum = OBJ_VNUM_SLICED_ARM;
			}
			break;
		case  6:
			if (IS_SET(ch->parts,PART_LEGS))
			{
				msg  = "{c$n's leg is sliced from $s dead body.";
				vnum = OBJ_VNUM_SLICED_LEG;
			}
			break;
		case 7:
			if (IS_SET(ch->parts,PART_BRAINS))
			{
				msg = "{c$n's head is shattered, and $s brains splash all over you.";
				vnum = OBJ_VNUM_BRAINS;
			}
			break;
	}
	act( msg, ch, NULL, NULL, TO_ROOM );

	if ( vnum != 0 )
	{
		char buf[MSL];
		OBJ_DATA *obj;
		char *name;

		name		= IS_NPC(ch) ? ch->short_descr : ch->name;
		obj		= create_object( get_obj_index( vnum ), 0 );
		obj->timer	= number_range( 4, 7 );
		sprintf( buf, obj->short_descr, name );
		free_string( obj->short_descr );
		obj->short_descr = str_dup( buf );
		sprintf( buf, obj->description, name );
		free_string( obj->description );
		obj->description = str_dup( buf );

		if (obj->item_type == ITEM_FOOD)
		{
			if (IS_SET(ch->form,FORM_POISON))
				obj->value[3] = 1;
			else if (!IS_SET(ch->form,FORM_EDIBLE))
				obj->item_type = ITEM_TRASH;
		}
		obj_to_room( obj, ch->in_room );
	}

	if ( IS_NPC(ch) )
		msg = "{cYou hear something's death cry.";
	else
		msg = "{cYou hear someone's death cry.";
	was_in_room = ch->in_room;

	for ( door = 0; door < MAX_DIR; door++ ) /*Anthony: door 5 to 9 for diagonals*/
	{
		EXIT_DATA *pexit;
		if ( ( pexit = was_in_room->exit[door] ) != NULL
			 &&   pexit->u1.to_room != NULL
			&&   pexit->u1.to_room != was_in_room )
		{
			ch->in_room = pexit->u1.to_room;
			act( msg, ch, NULL, NULL, TO_ROOM );
		}
	}
	ch->in_room = was_in_room;
	return;
}

void soft_kill( CHAR_DATA *ch, CHAR_DATA *victim )
{
	if ( !IS_NPC( victim ) )
	{
		raw_kill(ch, victim );
		return;
	}

/*	logf( "Soft kill function in progress.", 0 );  */
	stop_all_fighting( victim );

	victim->pIndexData->killed++;
	kill_table[URANGE(0, victim->level, MAX_LEVEL-1)].killed++;
	extract_char( victim, TRUE );
	/*logf( "Soft kill function finished.", 0 ); */
	return;
}


void raw_kill( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int i;
	char *bond_data;
	CHAR_DATA *bond;
	char *bond_data2;
	CHAR_DATA *bond2;
	OBJ_DATA *corpse = NULL;

	/* redundancy? why? let's just force all fighting to stop when you die -- Dalsor
	if ( is_fighting(victim) )
		stop_all_fighting(victim); */
	stop_all_fighting( victim );
	death_cry( victim );

	if ( !IS_SET( victim->war_flags, WAR_BATTLE )
	&& !IS_SET( victim->war_flags, WAR_TOURNEY ) && (IS_NPC(victim) || victim->pcdata->newbie != 1))
	{
/*		if ( IS_NPC( victim )
 this means newbies that die lose all their stuff
  		|| victim->pcdata->newbie != 1 )
		*/

		corpse = make_corpse( victim );

		/* GM, transfer the corpse to the clan morgue... */
#if 0
		if ( !IS_NPC(victim)
		&& (is_clan(victim)
		&& clan_table[victim->clan].room[1] != ROOM_VNUM_ALTAR
		&& clan_table[victim->clan].room[1] > 0) )
		{
			OBJ_DATA *corpse;
			ROOM_INDEX_DATA *morgue;

			corpse = get_obj_list(victim, "corpse", victim->in_room->contents );
			morgue = get_room_index(clan_table[victim->clan].room[1]);

			if (corpse != NULL && morgue != NULL)
			{
				/* make corpse already puts it someplace */
				bugf( "Pulling corpse, stick it into clan morgue." );
				obj_from_room(corpse);
				obj_to_room(corpse, morgue);
				ptc( victim, "The corpse goes to %d.\n\r", clan_table[victim->clan].room[1] );
			}
		}
#endif

	}

	if ( !IS_NPC( victim ) )
	{
		if ( IS_SET( victim->hist_flags,HIST_BONDED ) || IS_SET( victim->hist_flags,HIST_BONDER ) )
		{
			bond_data = str_dup(victim->pcdata->bonded_to);
			if ( ( bond = get_char_world( victim, bond_data ) ) != NULL )
			{
				stc( "You feel the death of your bond.\n\r", bond );
			}
			bond_data2 = str_dup(victim->pcdata->bonded_by);
			if ( ( bond2 = get_char_world( victim, bond_data2 ) ) != NULL )
			{
				stc( "You feel the death of your bond.\n\r", bond2 );
			}
		}
	}

	if ( IS_NPC(victim) )
	{
		victim->pIndexData->killed++;
		kill_table[URANGE(0, victim->level, MAX_LEVEL-1)].killed++;
		extract_char( victim, TRUE );
		return;
	}

	if ( !IS_NPC( victim ) && victim->pcdata->newbie == 1 )
	{
		stc( "{wOh no!\n\r\n\r", victim );
		stc( "{wYou lost the fight but that's ok. Rest here for a bit then try again.\n\r", victim );
		char_from_room( victim );
		char_to_room( victim, get_room_index( 31020 ) );
		do_look(victim, "auto");
		victim->position   = POS_RESTING;
		victim->hit = victim->max_hit;
		victim->stam = victim->max_stam;

/*		extract_char( victim, FALSE );

		while ( victim->affected )
			affect_remove( victim, victim->affected );
		victim->affected_by	= race_table[victim->race].aff;

		for (i = 0; i < 4; i++)
			victim->armor[i]= 100;
*/
		if ( is_fighting(victim) )
			stop_all_fighting(victim);
		return;
	}
	if (!IS_NPC( victim ) && ( IS_SET(victim->war_flags, WAR_BATTLE) || IS_SET( victim->war_flags, WAR_TOURNEY ) ) )
	{
		ROOM_INDEX_DATA     *location;
		int                 place = 3001;
		place = ROOM_VNUM_PLAZA;
		location = get_room_index( place);

		if( IS_SET( victim->war_flags, WAR_BATTLE ) )
			REMOVE_BIT( victim->war_flags, WAR_BATTLE );
		if( IS_SET( victim->war_flags, WAR_TOURNEY ) )
			REMOVE_BIT( victim->war_flags, WAR_TOURNEY );

		do_clanrecall(victim, "");
		do_look(victim, "auto");
		victim->position   = POS_RESTING;
		victim->hit = get_maxhit(victim);
		victim->stam = get_maxstam(victim);
		return;
	}

	extract_char( victim, FALSE );
	while ( victim->affected )
		affect_remove( victim, victim->affected );
	victim->affected_by	= race_table[victim->race].aff;
	for (i = 0; i < 4; i++)
		victim->armor[i]= 100;

	victim->position	= POS_RESTING;
	victim->hit		= UMAX( 1, victim->hit  );
	victim->stam		= UMAX( 1, victim->stam );

	/* this was added (it didn't exist!) so we can stick corpses in the inv -- Dalsor */
	if ( !is_clan( victim ) )
	{
		char_from_room( victim );
		char_to_room( victim, get_room_index( CAEMLYN_CEMETARY ) );
	}
	else if ( is_clan( victim ) )
	{
		char_from_room( victim );
		char_to_room( victim, get_room_index(clan_table[victim->clan].room[1] ) );
	}
	else
	{
		char_from_room( victim );
		char_to_room( victim, get_room_index( CAEMLYN_CEMETARY ) );
	}
	obj_from_room(corpse);
	obj_to_char(corpse,victim);
        do_function( victim, &do_save, "" );

	return;
}

char *getname( CHAR_DATA *ch )
{
	if ( IS_NPC( ch ) )
	return ch->short_descr;
	else
	return ch->name;
}

int avg_tier (CHAR_DATA *ch, int members)
{
	int tier, tbonus;

	tier = calc_remort_tier(ch);

	tbonus = members /= tier;
	if (tbonus <= 1)
	{
		tbonus = 1;
	}
	return tbonus;

}

void group_gain( CHAR_DATA *ch, CHAR_DATA *victim )
{
	CHAR_DATA *gch;
	/*DESCRIPTOR_DATA *d;*/
	/*CHAR_DATA *lch;*/
	char buf[MSL];
	int xp, members, group_levels, highestlevel = 0, i, t, tbonus, hightier = 0;

	/*
	* Monsters don't get kill xp's or alignment changes.
	* P-killing doesn't help either.
	* Dying of mortal wounds or poison doesn't give xp to anyone!
	*/
	if ( victim == ch )
		return;

	if ( IS_SET( victim->war_flags, WAR_BATTLE ) || IS_SET( victim->war_flags, WAR_TOURNEY ) )
		return;

	members = 0;
	group_levels = 0;
	t = 0;
	tbonus = 0;

	for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
	{
		if ( is_same_group( gch, ch ) )
		{
			members++;
			group_levels += IS_NPC(gch) ? gch->level / 2 : gch->level;
			if (!IS_NPC (gch))
			{
				highestlevel = UMAX(highestlevel, gch->level);
				hightier = UMAX(hightier, calc_remort_tier(gch));
				t += calc_remort_tier(gch);
			}
		}

	}
	tbonus = (t /= members);

	if ( members == 0 )
	{
		bug( "Group_gain: members.", members );
		members = 1;
		group_levels = ch->level ;
	}

	if (IS_NPC(victim) && !IS_NPC(ch) && gquest_info.running == GQUEST_RUNNING
		&& ON_GQUEST(ch) && (i = is_gqmob(ch, victim->pIndexData->vnum)) != -1)
	{
		ch->pcdata->gq_mobs[i] = -1;
		stc("Congratulations, that mob was part of your global quest!\n\r",ch);
		stc("You receive an extra 3 Quest Points.", ch);
		ch->questpoints += 3;
		sprintf(buf, "$N has killed %s, a global questmob.", victim->short_descr);
		wiznet(buf, ch, NULL, 0, 0, 0);

		if (count_gqmobs(ch) == gquest_info.mob_count)
			stc("You are now ready to complete the global quest. Type 'GQUEST COMPLETE' to finish.\n\r", ch);
	}

	if (members == 1)
	{
		xp += tbonus * 75;
	}
	if (members > 1)
	{
		xp += tbonus * 50;
	}

	/*for (lch = ch->in_room->people; lch != NULL; lch = lch->next_in_room)
	{
		if ( !is_same_group( lch, ch ) || IS_NPC(lch))
			continue;
		if (lch->level > highestlevel)
			highestlevel = lch->level;
	}*/
	/*Anthony - moved up a few lines*/
	for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
	{
		/*OBJ_DATA *obj;
		OBJ_DATA *obj_next;*/
		if ( !is_same_group( gch, ch ) || IS_NPC(gch))
			continue;

		if ( gevent->running && gevent->num != 15 ) /* Lynch Mob */
		{
			if ( gch->level - highestlevel <= -50 )
			{
				stc("Your prowess is useless to such an advanced group.\n\r",gch);
				continue;
			}
		}
/*
		if ( !IS_NPC(gch) && calc_remort_tier(gch) > (hightier + 1))
		{
				stc("Stop grouping with such low Tiered people if you want experience.\n\r", gch);
				continue;
		}
		if ( !IS_NPC(gch) && calc_remort_tier(gch) < (hightier - 1))
		{
				stc("No free rides - group with people that are closer to your Tier.\n\r", gch);
				continue;
		}
*/

		xp = xp_compute( gch, victim, group_levels );
		/* xp_compute moved to here */

		if( gch && gch->pcdata && gch->pcdata->addict )
		{
			if ( is_shadow( gch ) )
				stc("{wThe {RG{rreat {RL{rord {whas granted you a bonus for your dedication!{x\n\r",gch);
			else
				stc("{wThe {WCreator {whas granted you a bonus for your dedication!{x\n\r",gch);
			xp = xp * 1.3;
		}
		if ( IS_SET( gch->act, WAR_QUESTOR ) && IS_NPC( victim ) )
		{
			if (gch->questmob == victim->pIndexData->vnum)
			{
				stc("You have almost completed your QUEST!\n\r",gch);
				stc("Return to the questmaster before your time runs out!\n\r",gch);
				gch->questmob = -1;
				xp = xp * 1.3;
			}
		}
		if ( victim->questor != NULL && gch->qmob != NULL && gch->qmob == victim )
		{
			stc("You have almost completed your QUEST!\n\r",gch);
			stc("Return to the questmaster before your time runs out!\n\r",gch);
			gch->qcomp = TRUE;
			xp = xp * 1.3;
		}
		if ( gevent->running && ( gevent->num == 3 || gevent->num == 14) ) /* free xps gevent */
		{
			ptc( gch, "You are awarded a bonus to your experience from the %s event!\n\r",
				gevent->cname);
			xp = xp * 1.5;
		}
		if ( gevent->running && gevent->num == 0 ) /* shadows embrace bonus xps */
		{
			if ( xp <= 0 ) /* always get something during this event */
				xp = 3;
			else
				xp = xp * 1.5;
		}

		gain_exp( gch, xp );
	}
	return;
}

/*
* Compute xp for a kill.
* Also adjust alignment of killer.
* Edit this function to change xp computations.
*/
int xp_compute( CHAR_DATA *gch, CHAR_DATA *victim, int total_levels )
{
	int xp,base_exp;
	int level_range;
	level_range = victim->level - gch->level;
	/* compute the base exp */
	switch (level_range)
	{
		default : 	base_exp =   0;		break;
		case -9 :	base_exp =   1;		break;
		case -8 :	base_exp =   2;		break;
		case -7 :	base_exp =   5;		break;
		case -6 : 	base_exp =   9;		break;
		case -5 :	base_exp =  11;		break;
		case -4 :	base_exp =  22;		break;
		case -3 :	base_exp =  33;		break;
		case -2 :	base_exp =  50;		break;
		case -1 :	base_exp =  66;		break;
		case  0 :	base_exp =  77;		break;
		case  1 :	base_exp =  88;		break;
		case  2 :	base_exp =  99;		break;
		case  3 :	base_exp = 110;		break;
		case  4 :	base_exp = 121;		break;
	}
	if (level_range > 4)
		base_exp = 132 + 20 * (level_range - 4);
	xp = base_exp;
	/* more exp at the low levels */
	/*QUESTION: this seems bugged, eg. level 9: xp = (10 * xp / 13)*/
	if (gch->level <= 10)
	{
		xp = 10 * xp / (gch->level + 4);
	}

	/* randomize the rewards */
	xp = number_range (xp * 3/4, xp * 5/4);
	/* adjust for grouping */
	//xp = xp * gch->level/( UMAX(1,total_levels -1) );

	if (xp > 2000)
	{
#if 0
		xp = 2000 * 9 / 10; /*QUESTION if you don't include xp here,
						you can just use a fixed number in the range below
						only matters a few multiplications tho ;)*/
		xp = number_range(xp * 9/10, xp * 10/9);
#endif
		xp = number_range( 405 , 1250 );
	}
	return xp;
}

void dam_message( CHAR_DATA *ch, CHAR_DATA *victim,int dam,int dt,bool immune )
{
	char buf1[512], buf2[512], buf3[512];
	const char *vs;
	const char *vp;
	const char *attack="";
	char punct;
	OBJ_DATA *wield;

	if (ch == NULL || victim == NULL)
		return;
	if ( dam ==   0 ) { vs = "{wmiss{x";	        vp = "{wmisses{x";		}
	else if ( dam <= 5   ) { vs = "{Wn{wic{wk{x";   vp = "{Wn{wick{ws{x";   }
	else if ( dam <= 10  ) { vs = "{Wg{wraz{we{x";  vp = "{Wg{wraze{ws{x";  }
	else if ( dam <= 15  ) { vs = "{ys{Ycrap{Ye{x"; vp = "{ys{Ycrape{Ys{x"; }
	else if ( dam <= 20  ) { vs = "{bb{Bruis{be{x"; vp = "{bb{Bruise{Bs{x"; }
	else if ( dam <= 25  ) { vs = "{whit{x";        vp = "{whits{x";        }
	else if ( dam <= 30  ) { vs = "{Cs{ctrik{ce{x"; vp = "{Cs{ctrike{cs{x"; }
	else if ( dam <= 40  ) { vs = "{Cscathe{x";     vp = "{Cscathes{x";     }
	else if ( dam <= 50  ) { vs = "{cinjure{x";	    vp = "{cinjures{x";		}
	else if ( dam <= 60  ) { vs = "{gwound{x";	    vp = "{gwounds{x";		}
	else if ( dam <= 75  ) { vs = "{mhurt{x";       vp = "{mhurts{x";		}
	else if ( dam <= 88  ) { vs = "{rb{Rlood{ry{x"; vp = "{rb{Rloodie{rs{x";}
	else if ( dam <= 100 ) { vs = "{bmaul{x";       vp = "{bmauls{x";       }
	else if ( dam <= 125 ) { vs = "{Ydecimate{x";	vp = "{Ydecimates{x";	}
	else if ( dam <= 150 ) { vs = "{cmaim{x";	    vp = "{cmaims{x";		}
	else if ( dam <= 175 ) { vs = "{Crend{x";       vp = "{Crends{x";      }
	else if ( dam <= 200 ) { vs = "{wwracks{x";     vp = "{wwracks{x";       }
	else if ( dam <= 250 ) { vs = "{Mdevastate{x";  vp = "{Mdevastates{x";	}
	else if ( dam <= 300 ) { vs = "{rRAVAGE{x";     vp = "{rRAVAGES{x";     }
	else if ( dam <= 350 ) { vs = "{wSMASH{x";      vp = "{wSMASHES{x"; }
	else if ( dam <= 400 ) { vs = "{wIMMOLATE{x";   vp = "{wIMMOLATES{x"; }
	else if ( dam <= 500 ) { vs = "{rSLAUGHTER{x";  vp = "{rSLAUGHTERS{x";  }
	else if ( dam <= 600 ) { vs = "{rDISMEMBER{x";  vp = "{rDISMEMBERS{x";	}
	else if ( dam <= 700 ) { vs = "{rMASSACRE{x";	vp = "{rMASSACRES{x";	}
	else if ( dam <= 800 ) { vs = "{rMANGLE{x";	    vp = "{rMANGLES{x";		}
	else if ( dam <= 900 ) { vs = "{RMUTILATE{x";   vp = "{RMUTILATES{x";   }
	else if ( dam <= 1000) { vs = "{RPULVERIZE{x";  vp = "{RPULVERIZES{x";  }
	else if ( dam <= 1250) { vs = "{GBUTCHER{x";    vp = "{GBUTCHERS{x";    }
	else if ( dam <= 1500) { vs = "{xDISFIGURE{x";      vp = "{xDISFIGURES{x"; }
	else if ( dam <= 1750) { vs = "{W-{w={W-{r DEMOLISH {W-{w={W-{x";
		vp = "{W-{w={W-{r DEMOLISHES {W-{w={W-{x";     }
	else if ( dam <= 2000) { vs = "{R*{r*{R*{r DEVASTATE {R*{r*{R*{x";
		vp = "{R*{r*{R*{r DEVASTATES {R*{r*{R*{x";     }
	else if ( dam <= 2250) { vs = "{gD{GES{WOLA{GTE{gS{x";
		vp = "{gD{GES{WOLA{GTE{gS{x"; }
	else if ( dam <= 2500) { vs = "{W-{B(){W- {bEVISCERATE {W-{B(){W-{x";
		vp = "{W-{B(){W- {bEVISCERATES {W-{B(){W-{x";    }
	else if ( dam <= 2750) { vs = "{R+{W={R+ {GRAZES {R+{W={R+{x";
		vp = "{R+{W={R+ {GRAZES {R+{W={R+{x"; }
	else if ( dam <= 3000) { vs = "{w-{W={w+{r OBLITERATE {w+{W={w-{x";
		vp = "{w-{W={w+{r OBLITERATES {w+{W={w-{x";    }
	else if ( dam <= 3250) { vs = "{Y<{G<{g+ {YSCOURGES {g+{G>{Y>{x";
		vp = "{Y<{G<{g+ {YSCOURGES {g+{G>{Y>{x"; }
	else if ( dam <= 3500) { vs = "{R>>>{r ANNIHILATE {R<<<{x";
		vp = "{R>>>{r ANNIHILATES {R<<<{x";		    }
	else if ( dam <= 4000) { vs = "{R<{r<{R<{r ERADICATE {R>{r>{R>{x";
		vp = "{R<{r<{R<{r ERADICATES {R>{r>{R>{x";		}
	else if ( dam <= 4500) { vs = "{w*{W*{w*{r ATOMIZE {w*{W*{w*{x";
		vp = "{w*{W*{w*{r ATOMIZES {w*{W*{w*{x"; }
	else if ( dam <= 5000) { vs = "do {g<{G<{W**{G>{g>{RBAD THINGS{g<{G<{W**{G>{g>{x to";
		vp = "does {g<{G<{W**{G>{g>{RBAD THINGS{g<{G<{W**{G>{g>{x to"; }
	else if ( dam <= 6000) { vs = "do {G<{g<{w**{g>{G>{rBIG NASTY THINGS{g<{G<{w**{G>{g>{x to";
		vp = "does {G<{g<{w**{g>{G>{rBIG NASTY THINGS{g<{G<{w**{G>{g>{x to"; }
	else if ( dam <= 7000) { vs = "{RL{rA{RY W{rA{RS{rT{RE{x to"; vp = "{RL{rA{RY{rS{R W{rA{RS{rT{RE{x to"; }
	else if ( dam <= 8000) { vs = "knock the {WCRAP{x out of{x"; vp = "knocks the {WCRAP{x out of{x"; }
	else if ( dam <= 8500) { vs = "{W<{w<{D<{CL{cI{RQU{rID{RAT{cE{CS{D>{w>{W>{x";
		vp = "{W<{w<{D<{CL{cI{RQU{rID{RAT{cE{CS{D>{w>{W>{x"; }
	else if ( dam <= 8750) { vs = "{xtears {DA{WSU{wN{WDE{DR{x"; vp = "{xtears {DA{WSU{wN{WDE{DR{x"; }
	else if ( dam <= 9000) { vs = "do {r<{W*{r<{RUNTHINKABLE{r>{W*{r>{x things to";
		vp = "does {r<{W*{r<{RUNTHINKABLE{r>{W*{r>{x things to"; }
	else if ( dam <= 10000) { vs = "do {r<>{R*{r<>{RINCONCEIVABLE{r<>{R*{r<>{x things to";
		vp = "does {r<>{R*{r<>{RINCONCEIVABLE{r<>{R*{r<>{x things to"; }
	else if ( dam <= 12500) { vs = "do {W*{wUNSPEAKABLE{W*{x things to{x";
		vp = "does {W*{wUNSPEAKABLE{W*{x things to{x";   }
	else if ( dam <= 15000) { vs = "{xdo {g){C<{W*{C>{g({CHORRIFIC{g){C<{W*{C>{g({x things to";
		vp = "{xdoes {g){C<{W*{C>{g({CHORRIFIC{g){C<{W*{C>{g({x things to"; }
	else if ( dam <= 16000) { vs = "{R<{D[{W*{D]{R> {wABOLISHES {R<{D[{W*{D]{R>{x";
		vp = "{R<{D[{W*{D]{R> {wABOLISHES {R<{D[{W*{D]{R>{x"; }
	else if ( dam <= 17500) { vs = "{Ctears the {y---{RF{y-{RL{y-{RE{y-{RS{y-{RH{y---{C from{x";
		vp = "{Ctears the {y---{RF{y-{RL{y-{RE{y-{RS{y-{RH{y---{C from{x"; }
	else if ( dam <= 20000) { vs = "Brings {R-{r+{R-{r+ {yV{DE{yN{DG{yE{DA{yN{DC{yE {r+{R-{r+{R-{x down on";
		vp = "Brings {R-{r+{R-{r+ {yV{DE{yN{DG{yE{DA{yN{DC{yE {r+{R-{r+{R-{x down on"; }
	else if ( dam <= 25000) { vs = "{R<{W*{R>{D-{R<{W*{R> {WVAPORIZES {R<{W*{R>{D-{R<{W*{R>{x";
		vp = "{R<{W*{R>{D-{R<{W*{R> {WVAPORIZES {R<{W*{R>{D-{R<{W*{R>{x"; }
	else if ( dam <= 30000) { vs = "{D({w-{W*{w-{D){YB{yl{Wo{yw{Ys{W to {yS{Ymi{wth{We{wre{Yen{ys{D({w-{W*{w-{D){x ";
		vp = "{D({w-{W*{w-{D){YB{yl{Wo{yw{Ys{W to {yS{Ymi{wth{We{wre{Yen{ys{D({w-{W*{w-{D){x "; }
	else if (dam <= 40000) { vs = "{Wbrings the {RW{rR{RA{rT{RH {Wof {CG{cO{CD {Wdown on{x";
		vp = "{Wbrings the {RW{rR{RA{rT{RH {Wof {CG{cO{CD {Wdown on{x"; }
	else
		{ vs = "{Wla{wys t{Whe {y*{Y*{W*{Y*{y* {DS{wM{WAC{DK {Y*{y*{W*{y*{Y* {Wdo{wwn {Won{x";
		vp = "{Wla{wys t{Whe {y*{Y*{W*{Y*{y* {DS{wM{WAC{DK {Y*{y*{W*{y*{Y* {Wdo{wwn {Won{x"; }

	punct   = (dam <= 100) ? '.' : '!';
	if ( dt == TYPE_HIT )
	{
		if (ch  == victim)
		{
			sprintf( buf1, "{c$n %s $melf%c", vp,punct);
			sprintf( buf2, "{cYou %s yourself%c", vs,punct);
		}
		else
		{
			sprintf( buf1, "{c$n %s $N%c",  vp, punct );
			sprintf( buf2, "{cYou %s $N%c", vs, punct );
			sprintf( buf3, "{c$n %s you%c", vp, punct );
		}
	}
	else
	{
		wield = get_eq_char( ch, WEAR_WIELD );

		if ( wield == NULL )
		attack = "pound";

		if ( wield != NULL && dt >= TYPE_HIT && ( sform_is_set( ch, TRUE ) || form_is_set( ch, TRUE ) ) )
		{
			if ( ch->race == race_lookup( "aiel" ) && sform_is_set( ch, TRUE ) )
			{
				attack = sstance_lookup( ch, TRUE );
			}
			else if ( form_is_set( ch, TRUE ) )
			{
				attack = stance_lookup( ch, TRUE );
			}
		}
		else
		{
			if ( dt >= 0 && dt < MAX_SKILL )
				attack	= skill_table[dt].noun_damage;
			else if ( dt >= TYPE_HIT && dt < TYPE_HIT + MAX_DAMAGE_MESSAGE)
				attack	= attack_table[dt - TYPE_HIT].noun;
			else
			{
				bug( "Dam_message: bad dt %d.", dt );
				dt  = TYPE_HIT;
				attack  = attack_table[0].name;
			}
		}

		if (immune)
		{
			if (ch == victim)
			{
				sprintf(buf1,"{c$n is unaffected by $s own %s.",attack);
				sprintf(buf2,"{cLuckily, you are immune to that.");
			}
			else
			{
				sprintf(buf1,"{c$N is unaffected by $n's %s!",attack);
				sprintf(buf2,"{c$N is unaffected by your %s!",attack);
				sprintf(buf3,"{c$n's %s is powerless against you.",attack);
			}
		}
		else
		{
			if (ch == victim)
			{
				sprintf( buf1, "{c$n's %s %s $m%c",attack,vp,punct);
				sprintf( buf2, "{cYour %s %s you%c",attack,vp,punct);
			}
			/*
			else
			{
			if ( wield != NULL )
			{
				if ( form_is_set( ch, TRUE ) )
				{
				sprintf( buf1, "%s strikes with %s %s $N%c {w[{R%d{w]{c",
				capit2(ch->name), attack, vp, punct, dam );
				sprintf( buf2, "You strike with %s %s $N%c {g[{R%d{g]{c",
				attack, vp, punct, dam );
				sprintf( buf3, "%s strikes with %s %s you%c {w[{R%d{w]{c",
				capit2(ch->name), attack, vp, punct, dam );
				}
			}
			*/


			/*NOTE: Here is where to change the code to show the forms.*/
			if (IS_SET(ch->auto_flags,AUTO_AUTODAMAGE))
			{
				sprintf( buf1, "$n's %s %s $N%c", attack, vp, punct );
				sprintf( buf2, "Your %s %s $N%c {g[{R%d{g]{c",  attack, vp, punct, dam );
				/*sprintf( buf3, "$n's %s %s you%c {w[{R%d{w]{c", attack, vp, punct, dam );*/
			}
			else
			{
				sprintf( buf1, "$n's %s %s $N%c",  attack, vp, punct );
				sprintf( buf2, "Your %s %s $N%c",  attack, vp, punct );
			}
			if (IS_SET(victim->auto_flags,AUTO_AUTODAMAGE))
			{
				sprintf( buf3, "$n's %s %s $N%c {R[{W%d{R]{x", attack, vp, punct, dam );
				/*sprintf( buf3, "$n's %s %s you%c {y[{R%d{y]{c", attack, vp, punct, dam );*/
			}
			else
			{
				sprintf( buf3, "$n's %s %s you%c", attack, vp, punct );
			}


		}
	}
	if (ch == victim)
	{
		act(buf1,ch,NULL,NULL,TO_ROOM);
		act(buf2,ch,NULL,NULL,TO_CHAR);
	}
	else
	{
		act( buf1, ch, NULL, victim, TO_NOTVICT );
		act( buf2, ch, NULL, victim, TO_CHAR );
		act( buf3, ch, NULL, victim, TO_VICT );

	}
	return;
}

void do_kill( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	CHAR_DATA *victim;

	one_argument( argument, arg );
	if ( arg[0] == '\0' )
	{
		stc( "{cKill whom?\n\r", ch );
		return;
	}
	if ( ( victim = get_char_room( ch, NULL, arg ) ) == NULL )
	{
		stc( "{cThey aren't here.\n\r", ch );
		return;
	}

	/* WTF is this? - Rokann
	if ( !str_cmp(arg,"self"))
	{
		for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room)
		{
			if (victim == ch)
			continue;
			if (!IS_NPC(victim))
			continue;
			else
			start_first_fight(ch, victim, RANGE_MISSLE);
			break;
		}
		return;
	}
	*/

	if (IS_SET(victim->auto_flags,AUTO_AUTOSLAY) && victim->level >= MAX_LEVEL - 2)
	{
		do_function(victim, &do_slay, ch->name);
		return;
	}
	start_first_fight(ch, victim, RANGE_LONG);
	return;
}

void do_pkill( CHAR_DATA *ch, char *argument )
{
	if (!IS_NPC(ch))
	{
		stc("Turning PK on.\n\r",ch);
		SET_BIT(ch->war_flags,WAR_PK);
		return;
	}
	else
		return;
}

/*Kill PCs - disabled*/
void do_murde( CHAR_DATA *ch, char *argument )
{
	stc( "{cIf you want to MURDER, spell it out.\n\r", ch );
	stc( "And actually, murder is disabled at the moment.\n\r", ch);
	return;
}
void do_murder( CHAR_DATA *ch, char *argument )
{
	/*char arg[MIL];
	CHAR_DATA *victim;*/
	stc( "Murder is disabled at the moment.\n\r", ch);
	return;
	/*one_argument( argument, arg );
	if ( arg[0] == '\0' )
	{
		stc( "{cMurder whom?\n\r", ch );
		return;
	}
	if (IS_AFFECTED(ch,AFF_CHARM) || (IS_NPC(ch) && IS_SET(ch->act,ACT_PET)))
		return;
	if ( ( victim = get_char_room( ch,NULL, arg ) ) == NULL )
	{
		stc( "{cThey aren't here.\n\r", ch );
		return;
	}
	if (!IS_NPC(ch))
	{
		if (!IS_NPC(victim))
		{
			if (!IS_SET(victim->war_flags,WAR_PK))
			{
				stc("Your victim is safe from attack at the moment.\n\r",ch);
				return;
			}
		}
	}
	if ( victim == ch )
	{
		stc( "{cSuicide is a mortal sin.\n\r", ch );
		return;
	}

	if ( is_safe( ch, victim ) )
		return;
	if (IS_NPC(victim) && victim->fight_data->fighter != NULL && !check_fighting_groupie(ch,victim))
	{
		stc("{cKill stealing is not permitted.\n\r",ch);
		return;
	}
	if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master == victim )
	{
		act( "{c$N is your beloved master.", ch, NULL, victim, TO_CHAR );
		return;
	}
	if ( victim->level < 10 )
	{
		stc( "{cYour victim is still a newbie. That would be a bad thing to do.\n\r", ch );
		return;
	}
	if ( ch->position == POS_FIGHTING )
	{
		stc( "{cYou do the best you can!\n\r", ch );
		return;
	}
	if (IS_SET(victim->auto_flags,AUTO_AUTOSLAY) && victim->level >= MAX_LEVEL - 2)
	{
		do_function(victim, &do_slay, ch->name);
		return;
	}
	if (!IS_NPC(ch))
		SET_BIT(ch->war_flags,WAR_PK);
	check_killer ( ch, victim );
	multi_hit (ch, victim, TYPE_UNDEFINED );*/
}

void do_tail( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];
	CHAR_DATA *victim = NULL;

	one_argument( argument, arg );
	if (!IS_SET(ch->parts,PART_TAIL)) /* Moved up so you can't trash a tail if you don't have one - Anthony*/
	{
		stc("Grow a tail first.\n\r",ch);
		return;
	}
	if (arg[0] == '\0')
	{
		if (is_fighting(ch))
			victim = ch->advancing_on;
		if (victim == NULL)
		{
			stc("{cBut you aren't in combat!\n\r",ch);
			act("$n thrashes $s tail!",ch,0,0,TO_ROOM);
			return;
		}
	}
	else if ((victim = get_char_room(ch,NULL,arg)) == NULL)
	{
		stc("{cThey aren't here.\n\r",ch);
		return;
	}
	if ( victim == ch )
	{
		stc( "{cHow can you whip yourself with your tail?\n\r", ch );
		return;
	}

	if ( is_safe( ch, victim ) )
		return;
	if (IS_NPC(victim) && is_fighting(victim) && !check_fighting_groupie(ch,victim))
	{
		stc("{cKill stealing is not permitted.\n\r",ch);
		return;
	}

	WAIT_STATE( ch, skill_table[gsn_tail].beats );
	if (!check_fighting(ch, victim))
		start_extra_fight(ch, victim, RANGE_MELEE);
	multi_hit( ch, victim, gsn_tail );
	stc("{cYou are whipped by a tail slap!\n\r",victim);
	return;
}

void do_flee( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;

	if ( !is_fighting(ch) || ( victim = ch->advancing_on ) == NULL )
	{
		stop_all_fighting(ch);
		if ( ch->position == POS_FIGHTING )
			ch->position = POS_STANDING;
		stc( "{cYou aren't fighting anyone.\n\r", ch );
		return;
	}

	while (ch->weaves && ch->weaves->action[0] == ACTION_CASTING)
		stop_spell( ch );

	stc( "You retreat back out of melee range.\n\r", ch );
	act( "$n retreats back out of melee range.", ch, NULL, NULL, TO_ROOM );
	stop_all_fighting( ch );
	return;
}

void do_surrender( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *mob = NULL;
	FIGHTING_DATA *target;
	if (!is_fighting(ch) || (mob = ch->advancing_on) == NULL )
	{
		stc( "{cBut you're not fighting!\n\r", ch );
		return;
	}

	target = ch->fight_data;

	act( "{cYou surrender!", ch, NULL, mob, TO_CHAR );
	if (target != NULL)
	while (target->fighter != NULL)
	{
		mob = target->fighter;
		act( "{c$n surrenders to you!", ch, NULL, mob, TO_VICT );
		act( "{c$n tries to surrender to $N!", ch, NULL, mob, TO_NOTVICT );
		if ( !IS_NPC( ch ) && IS_NPC( mob ) && ( !HAS_TRIGGER_MOB( mob, TRIG_SURR )
			 || !p_percent_trigger( mob, NULL, NULL, ch, NULL, NULL, TRIG_SURR ) ) )
		{
			act( "{c$N seems to ignore your cowardly act!", ch, NULL, mob, TO_CHAR );
			multi_hit( mob, ch, TYPE_UNDEFINED );
			return;
		}
		else
			stop_fighting(ch, mob);
		target = target->next;
	}
	return;
}

/*Our sympa Imm command*/
void do_sla( CHAR_DATA *ch, char *argument )
{
	stc( "{cIf you want to SLAY, spell it out.\n\r", ch );
	return;
}
void do_slay( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char arg[MIL];

	one_argument( argument, arg );
	if ( arg[0] == '\0' )
	{
		stc( "{cSlay whom?\n\r", ch );
		return;
	}
	if ( ( victim = get_char_room( ch,NULL, arg ) ) == NULL )
	{
		stc( "{cThey aren't here.\n\r", ch );
		return;
	}
	if ( ch == victim )
	{
		stc( "{cSuicide is a mortal sin.\n\r", ch );
		return;
	}
	if ( !IS_NPC(victim) && IS_IMMORTAL(victim) && victim->level >= get_trust(ch) )
	{
		stc( "{cYou failed.\n\r", ch );
		return;
	}
	act( "{cYou slay $M in cold blood!",  ch, NULL, victim, TO_CHAR    );
	act( "{c$n slays you in cold blood!", ch, NULL, victim, TO_VICT    );
	act( "{c$n slays $N in cold blood!",  ch, NULL, victim, TO_NOTVICT );
	raw_kill(ch, victim );
	return;
}

bool is_hating(CHAR_DATA *ch, CHAR_DATA *victim)
{
	if (!ch->hate || ch->hate->who != victim/* || strcmp(ch->hate->name,victim->name)*/)
		return FALSE;
	return TRUE;
}

void stop_hating(CHAR_DATA *ch)
{
	if (ch->hate)
	{
		free_string(ch->hate->name );
		free_mem(ch->hate, sizeof (HATE_DATA));
		ch->hate = NULL;
	}
	return;
}

void start_hating(CHAR_DATA *ch, CHAR_DATA *victim)
{
	if (ch->hate)
		stop_hating(ch);
	ch->hate = alloc_mem(sizeof( HATE_DATA));
	ch->hate->name = str_dup(victim->name);
	ch->hate->who = victim;
	return;
}
