/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined( macintosh )
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "gamble2.h"

#define BET_LIMIT		"5000"

/***************************************************************
**  roulette_columns()
**  test for the column selected (1,2, or 3) and returns 1 if bet matches
**  random generated number.  Increments by 3 to compensate for
**  numbers in the roulette tabel
****************************************************************/
int roulette_columns(int bet, int r)
	 {
		 int z,x=0;

		 switch (bet)
		 {
		 case (1):
			 for (z=4;z<29;z+=3){
				 if (r==z){
					 x=1;
					 break;
				 }
			 }
			 break;

		 case (2):
			 for (z=5;z<30;z+=3){
				 if (r==z){
					 x=1;
					 break;
				 }
			 }
			 break;

		case (3):
			 for (z=6;z<31;z+=3){
				 if (r==z){
					 x=1;
					 break;
				 }
			 }
			 break;
		 }
	return (x);
 }

void do_roulette( CHAR_DATA *ch, char *argument, int amount )
{
	CHAR_DATA *	gambler;
    char wager[MIL];
	char choice[MIL];
    int	i,bet;

	wager[0]  = '\0';
	choice[0] = '\0';

	for(gambler = ch->in_room->people; gambler !=NULL; gambler = gambler->next_in_room )
    {
	    if ( !IS_NPC(gambler) )
	    continue;
		if ( IS_SET(gambler->act,ACT_GAMBLER ) )
	    break;
    }

    if ( gambler == NULL)
    {
	stc( "You can't gamble here.\n\r", ch );
	return;
    }

    if (is_fighting(gambler) )
    {
    act( "$n tells you 'Can't you see i'm busy fighting!'",gambler,NULL,ch,TO_VICT);
    ch->reply = gambler;
	return;
    }

	stc("\t  {wROULETTE BOARD{x\n\r",ch);
	stc("\t  {y--------------{x\n\r",ch);
	stc("\n\t  1\t  2\t  3\n\r",ch);
	stc("\n\r",ch);
	stc("\t{b|{x {r4{x {b|{x\t{g|{x {w5{x {g|{x\t{w|{x {r6{x {w|{x\n\r",ch);
	stc("\t{b|{x {w7{x {b|{x\t{g|{x {r8{x {g|{x\t{w|{x {w9{x {w|{x\n\r",ch);
	stc("\t{b|{x{r10{x {b|{x\t{g|{x{w11{x {g|{x\t{w|{x{r12{x {w|{x\n\r",ch);
	stc("\t{b|{x{w13{x {b|{x\t{g|{x{r14{x {g|{x\t{w|{x{w15{x {w|{x\n\r",ch);
	stc("\t{b|{x{r16{x {b|{x\t{g|{x{w17{x {g|{x\t{w|{x{r18{x {w|{x\n\r",ch);
	stc("\t{b|{x{w19{x {b|{x\t{g|{x{r20{x {g|{x\t{w|{x{w21{x {w|{x\n\r",ch);
	stc("\t{b|{x{r22{x {b|{x\t{g|{x{w23{x {g|{x\t{w|{x{r24{x {w|{x\n\r",ch);
	stc("\t{b|{x{w25{x {b|{x\t{g|{x{r26{x {g|{x\t{w|{x{w27{x {w|{x\n\r",ch);
	stc("\t{b|{x{r28{x {b|{x\t{g|{x{w29{x {g|{x\t{w|{x{r30{x {w|{x\n\r",ch);
	stc("\t{wODD (31)  OR  EVEN (32)\n\r{x",ch);
	stc("Choosing an odd or even number returns 2 to 1 odds.\n\r",ch);
	stc("Choosing column 1, 2 or 3 returns 3 to 1 odds.\n\r",ch);
	stc("Choosing an individual number has 10 to 1 odds.\n\r",ch);

	argument = one_argument( argument, choice );
	if ( choice[0] == '\0' )
	{
	stc( "Make your selection\n\r" , ch);
	return;
	}

	argument = one_argument( argument, wager );
	bet = atoi( choice );
	if ( ( bet < 1 ) && ( bet >32 ) )
	{
	stc( "Invalid bet!  Choose one of the numbers from the roulette board.\n\r", ch);
	return;
	}

	if ( wager[0] == '\0' )
    {
	stc( "How much would you like to bet?\n\r", ch );
	return;
    }

    if ( !str_cmp( wager, "limit" ) )
	amount = atoi( BET_LIMIT );
    else
	amount = atoi( wager );

    if ( amount > ch->money[3][0] )
    {
	stc( "You don't have enough gold!\n\r", ch );
	return;
    }

    if ( amount <= 0 )
    {
	stc( "You are unable to wager imaginary gold.\n\r", ch );
	return;
    }

    if ( amount > atoi( BET_LIMIT ) )
    {
	act( "$n tells you 'Sorry, the house limit is $t.'",gambler,BET_LIMIT,ch,TO_VICT);
	ch->reply = gambler;
	return;
    }

	ptc( ch , "Your are betting{y %d gold{x on number %d\n\r" , amount , bet);
	/*****************************
	Begin processing roulette game
	*****************************/
	i = number_range( 4 , 30 );
	if( bet < 4 ){
		if( roulette_columns( bet,i ) ){
			amount *= 3;
			ptc( ch, "{wPlay again if you feel lucky.  You WON! %d coins.{x\n\r" , amount );
			ch->money[3][0] += amount;
		}
		else{
			ptc( ch , "{rOPPS!  You loose %d coins!{x\n\r" , amount );
			ptc(ch , "The number was %d\n\r" , i);
			ch->money[3][0] -= amount;
		}
	}
	if( ( bet > 3 ) && ( bet < 31 ) ){
		if ( i == bet ){
			amount *= 10;
			ptc( ch , "{wYou must be feeling lucky.  You WON! %d coins.{x\n\r" , amount );
			ch->money[3][0] += amount;
		}
		else{
			 ptc( ch , "{rTry again!  You Loose %d coins.{x\n\r" , amount );
			 ptc( ch, "The number was %d\n\r" , i );
			 ch->money[3][0] -= amount;
		}
	}
	if( bet == 31 ){
		if ( i%2 == 1 ){
			amount *= 2;
			ptc( ch , "{wYou're on a wining streak! You WON! %d coins.{x\n\r" , amount );
			ch->money[3][0] += amount;
		}
		else{
			ptc( ch , "{rNO GO!  You Loose %d coins!{x\n\r" , amount );
			ptc( ch , "The number was %d\n\r" , i );
			ch->money[3][0] -= amount;
		}
	}
	if( bet == 32 ){
		if( i%2 == 0 ){
			amount *= 2;
			ptc( ch , "{wCongrats you WON! %d coins.{x\n\r" , amount );
			ch->money[3][0] += amount;
		}
		else{
			ptc( ch , "{rYou have bad luck! You Loose %d coins.{x\n\r" , amount );
			ptc( ch , "The number was %d\n\r" , i );
			ch->money[3][0] -= amount;
		}
	}
}


void game_high_dice( CHAR_DATA *ch,CHAR_DATA *gambler,int amount,int cheat,char *argument )
{
    char msg    [ MAX_STRING_LENGTH ];
    char buf    [ MAX_STRING_LENGTH ];
    char wager  [ MAX_INPUT_LENGTH  ];
    int  die1;
    int  die2;
    int  die3;
    int  die4;
    int  total1;
    int  total2;

    sprintf ( wager, "%d", amount );

    switch ( number_range( 1, 5 ) )
    {
	case 1:
	   strcpy ( msg, "Roll some dice" );
	   break;
	case 2:
	   strcpy ( msg, "Lets see those dice" );
	   break;
	case 3:
	   strcpy ( msg, "You'd better let me win!" );
	   break;
	case 4:
	   strcpy ( msg, "Here's cash, now roll'em!" );
	   break;
	case 5:
 	   strcpy ( msg, "Today's my lucky day..." );
	   break;
    }
    act( "You place $t gold coins on the table, and say '$T'.",
        ch, wager, msg, TO_CHAR    );
    act( "$n places a bet with you.",
        ch, NULL,  gambler, TO_VICT    );
    act( "$n plays a dice game.",
        ch, NULL,  gambler, TO_NOTVICT );
    ch->money[3][0] -= amount;

    die1 = number_range( 1, 6 );
    die2 = number_range( 1, 6 );
    die3 = number_range( 1, 6 );
    die4 = number_range( 1, 6 );

    if ( cheat && !IS_SET( ch->spec_flags,SPEC_TAVEREN ))
    {
	if ( die3 == 1 )	/* cheating mobs never throw one's */
		die3++;
	if ( die4 == 1 )
		die4++;
	/* and half of the time cheat a bit... */
	if ( ( die3 < 6 ) && number_range( 0, 1 ) )
		die3++;
	if ( ( die4 < 6 ) && number_range( 0, 1 ) )
		die4++;
    }

    total1 = die1 + die2;
    total2 = die3 + die4;

	/* to the char */
    sprintf( msg, "$N rolls $S dice: they come up %d, and %d",
            die1, die2 );
    sprintf( buf, ", totalling %d.", total1 );
    strcat( msg, buf );
    act( msg, gambler, NULL, ch, TO_ROOM );

    sprintf( msg, "$n rolls $s dice: they come up %d, and %d",
            die3, die4 );
    sprintf( buf, ", totalling %d.", total2 );
    strcat( msg, buf );
    act( msg, gambler, NULL, ch, TO_ROOM );

    if ( total1 > total2 )
    {
	    char haul[MSL];
	    amount *= 2;
	    sprintf( haul, "%d", amount );
        act( "$n wins $t gold coins!", ch, haul, NULL, TO_CHAR );
        ch->money[3][0] += amount;
    }
    else
    {
	    char haul[MSL];
	    amount *= 2;
	    sprintf( haul, "%d", amount );
        stc( "Sorry, better luck next time!\n\r", ch );
        act( "$n looses $t gold coins!", ch, haul, NULL, TO_ROOM );
	}

    WAIT_STATE( ch, PULSE_VIOLENCE );

    return;
}

void do_bet( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *	gambler;
    char wager[MIL];
    int	amount;
    int cheat = TRUE;

    for(gambler = ch->in_room->people; gambler !=NULL; gambler = gambler->next_in_room )
    {
	    if ( !IS_NPC(gambler) )
	    continue;
		if ( IS_SET(gambler->act,ACT_GAMBLER ) )
	    break;
    }

    if ( gambler == NULL)
    {
	stc( "You can't gamble here.\n\r", ch );
	return;
    }

    if ( is_fighting(gambler))
    {
    act( "$n tells you 'Can't you see i'm busy fighting!'",gambler,NULL,ch,TO_VICT);
    ch->reply = gambler;
	return;
    }

    argument = one_argument( argument, wager );


    if ( wager[0] == '\0' )
    {
	stc( "How much would you like to bet?\n\r", ch );
	return;
    }

    if ( !str_cmp( wager, "limit" ) )
	amount = atoi( BET_LIMIT );
    else
	amount = atoi( wager );

    if ( amount > ch->money[3][0] )
    {
	stc( "You don't have enough gold!\n\r", ch );
	return;
    }

    if ( amount <= 0 )
    {
	stc( "You are unable to wager imaginary gold.\n\r", ch );
	return;
    }

    if ( amount > atoi( BET_LIMIT ) )
    {
	act( "$n tells you 'Sorry, the house limit is $t.'",gambler,BET_LIMIT,ch,TO_VICT);
	ch->reply = gambler;
	return;
    }

	game_high_dice( ch, gambler, amount, cheat, argument );

    return;
}

/************************************************/
/*  void do_gamble written by Scott Rothrock    */
/*  for As the World Weaves (www.aww-mud.org    */
/*  port 6500). Copyright 2001 Scott Rothrock   */
/*  Please do not use without permission.       */
/*                                              */
/*  void do_gamble goes into act_comm.c, add    */
/*  the command table listings for it in the    */
/*  interp files; add gamble_type, gamble_coin, */
/*  gamble_sides, and gamble_dice to PCDATA in  */
/*  merc.h and save.c.                          */
/************************************************/


void do_gamble(CHAR_DATA *ch, char *argument)
{
	char arg1[MAX_INPUT_LENGTH]; /* For 'dice' or 'coin' */
	char arg2[MAX_INPUT_LENGTH]; /* For opponent */
	char arg3[MAX_INPUT_LENGTH]; /* bid */
	char arg4[MAX_INPUT_LENGTH]; /* heads or tails? */
	char heads_msg[MAX_STRING_LENGTH]; /* For heads message */
	char tails_msg[MAX_STRING_LENGTH]; /* For tails message */
	char shazbot[MAX_INPUT_LENGTH]; /* acts as temp buf */
	char buf[MAX_STRING_LENGTH]; /* ... the buffer */
	CHAR_DATA *victim; /* opponent's char data */

	int dice_results; /* result of a die */
	int dice_total[2]; /* total of dice */
	int coin_result[2]; /* result for coin flip */
	int random, i; /* for loops */

	/* initialise the variables */

	buf[0] = '\0';
	shazbot[0] = '\0';
	heads_msg[0] = '\0';
	tails_msg[0] = '\0';
	dice_total[0] = 0;
	dice_total[1] = 0;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );
	argument = one_argument( argument, arg4 );

	if((str_infix(arg1, "coin") && str_infix(arg1, "dice") && str_infix(arg1, "set") && str_infix(arg1, "display") && str_infix(arg1, "show") && str_infix(arg1, "help")) || arg1[0] == '\0')
	{
		for(i=0; i<20; i++)
		{
			send_to_char(general_help[i].help, ch);
		}

		return;
	}

	if(!str_infix(arg1, "help"))
	{
		if(!str_infix(arg2, "set"))
		{
			for(i=0; i<13; i++)
			{
				send_to_char(set_help[i].help, ch);
			}
		}

		if(!str_infix(arg2, "nations"))
		{
			for(i=0; i<13; i++)
			{
				send_to_char(nations_help[i].help, ch);
			}
		}

		if(arg2[0] == '\0')
		{
			for(i=0; i<20; i++)
			{
				send_to_char(general_help[i].help, ch);
			}
		}

		return;
	}

	if(!str_infix(arg1, "display") || !str_infix(arg1, "show"))
	{
		char nation[50];
		char cointype[50];

		nation[0] = '\0';
		cointype[0] = '\0';

		if(ch->pcdata->gamble_coin == 0)
			strcat(cointype, "{wsilver{x");

		if(ch->pcdata->gamble_coin == 1)
			strcat(cointype, "{Ygold{x");

		if(ch->pcdata->gamble_type == 1) strcat(nation, "Amadicia");
		if(ch->pcdata->gamble_type == 2) strcat(nation, "Andor");
		if(ch->pcdata->gamble_type == 3) strcat(nation, "Malkier");
		if(ch->pcdata->gamble_type == 4) strcat(nation, "Shienar");
		if(ch->pcdata->gamble_type == 5) strcat(nation, "Arafel");
		if(ch->pcdata->gamble_type == 6) strcat(nation, "Kandor");
		if(ch->pcdata->gamble_type == 7) strcat(nation, "Saldaea");
		if(ch->pcdata->gamble_type == 8) strcat(nation, "Cairhien");
		if(ch->pcdata->gamble_type == 9) strcat(nation, "Altara");
		if(ch->pcdata->gamble_type == 10) strcat(nation, "Murandy");
		if(ch->pcdata->gamble_type == 11) strcat(nation, "Arad Doman");
		if(ch->pcdata->gamble_type == 12) strcat(nation, "Tarabon");
		if(ch->pcdata->gamble_type == 13) strcat(nation, "Ghealdan");
		if(ch->pcdata->gamble_type == 14) strcat(nation, "Illian");
		if(ch->pcdata->gamble_type == 15) strcat(nation, "Tear");
		if(ch->pcdata->gamble_type == 16) strcat(nation, "Mayene");
		if(ch->pcdata->gamble_type == 17) strcat(nation, "Seandar");
		if(ch->pcdata->gamble_type == 18) strcat(nation, "Tar Valon");

		sprintf(buf, "You flip %s coins from %s.\n\rYou roll %i dice with %i sides.\n\r", cointype, nation, ch->pcdata->gamble_dice, ch->pcdata->gamble_sides);
		send_to_char(buf, ch);
		return;
	}

	if(!str_infix(arg1, "set"))
	{
		if((str_infix(arg2, "coin") && str_infix(arg2, "nation") && str_infix(arg2, "dice") && str_infix(arg2, "sides")) || arg2[0] == '\0')
		{
			send_to_char("Valid choices for set are: coin, nation, dice, and sides.\n\rSee GAMBLE HELP SET.\n\r", ch);
			return;
		}

		if(!str_infix(arg2, "dice"))
		{
			if(!is_number(arg3) || atoi(arg3) < 1 || atoi(arg3) > 10)
			{
				send_to_char("You must specify a number from 1 to 10.\n\r", ch);
				return;
			}

			ch->pcdata->gamble_dice = atoi(arg3);
			sprintf(buf, "You now toss %i dice.\n\r", ch->pcdata->gamble_dice);
			send_to_char(buf, ch);
			return;
		}

		if(!str_infix(arg2, "sides"))
		{
			if(!is_number(arg3) || atoi(arg3) < 4 || atoi(arg3) > 20)
			{
				send_to_char("You must specify a number from 3 to 20.\n\r", ch);
				return;
			}

			ch->pcdata->gamble_sides = atoi(arg3);
			sprintf(buf, "You now toss dice with %i sides.\n\r", ch->pcdata->gamble_sides);
			send_to_char(buf, ch);
			return;
		}

		if(!str_infix(arg2, "coin")) /* 0 for silver, 1 for gold */
		{
			if((str_infix(arg3, "gold") && str_infix(arg3, "silver")) || arg3 == '\0')
			{
				send_to_char("Valid choices for coin type are {Ygold{x and {wsilver{x.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "gold"))
			{
				ch->pcdata->gamble_coin = 1;
				send_to_char("Coin type set to {Ygold{x.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "silver"))
			{
				ch->pcdata->gamble_coin = 0;
				send_to_char("Coin type set to {wsilver{x.\n\r", ch);
				return;
			}
		}

		if(!str_infix(arg2, "nation"))
		{
			if(str_infix(arg3, "amadicia") && str_infix(arg3, "andor")
			&& str_infix(arg3, "malkier") && str_infix(arg3, "shienar")
			&& str_infix(arg3, "arafel") && str_infix(arg3, "kandor")
			&& str_infix(arg3, "saldaea") && str_infix(arg3, "cairhien")
			&& str_infix(arg3, "altara") && str_infix(arg3, "murandy")
			&& str_infix(arg3, "araddoman") && str_infix(arg3, "tarabon")
			&& str_infix(arg3, "ghealdan") && str_infix(arg3, "illian")
			&& str_infix(arg3, "tear") && str_infix(arg3, "mayene")
			&& str_infix(arg3, "seandar") && str_infix(arg3, "tarvalon"))
			{
				send_to_char("That is not a valid nation.\n\rSee GAMBLE HELP NATION for nations.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "amadicia"))
			{
				ch->pcdata->gamble_type = 1;
				send_to_char("You will now flip Amadician coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "andor"))
			{
				ch->pcdata->gamble_type = 2;
				send_to_char("You will now flip Andoran coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "malkier"))
			{
				ch->pcdata->gamble_type = 3;
				send_to_char("You will now flip Malkieri coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "shienar"))
			{
				ch->pcdata->gamble_type = 4;
				send_to_char("You will now flip Shienaran coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Arafel"))
			{
				ch->pcdata->gamble_type = 5;
				send_to_char("You will now flip Arafellein coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Kandor"))
			{
				ch->pcdata->gamble_type = 6;
				send_to_char("You will now flip Kandori coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Saldaea"))
			{
				ch->pcdata->gamble_type = 7;
				send_to_char("You will now flip Saldaean coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Cairhien"))
			{
				ch->pcdata->gamble_type = 8;
				send_to_char("You will now flip Cairhienin coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Altara"))
			{
				ch->pcdata->gamble_type = 9;
				send_to_char("You will now flip Altaran coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Murandy"))
			{
				ch->pcdata->gamble_type = 10;
				send_to_char("You will now flip Murandian coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "AradDoman"))
			{
				ch->pcdata->gamble_type = 11;
				send_to_char("You will now flip Domani coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Tarabon"))
			{
				ch->pcdata->gamble_type = 12;
				send_to_char("You will now flip Taraboner coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Ghealdan"))
			{
				ch->pcdata->gamble_type = 13;
				send_to_char("You will now flip Ghealdanean coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Illian"))
			{
				ch->pcdata->gamble_type = 14;
				send_to_char("You will now flip Illianer coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Tear"))
			{
				ch->pcdata->gamble_type = 15;
				send_to_char("You will now flip Tairen coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Mayene"))
			{
				ch->pcdata->gamble_type = 16;
				send_to_char("You will now flip Mayener coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "Seandar"))
			{
				ch->pcdata->gamble_type = 17;
				send_to_char("You will now flip Seanchan coins.\n\r", ch);
				return;
			}

			if(!str_infix(arg3, "TarValon"))
			{
				ch->pcdata->gamble_type = 18;
				send_to_char("You will now flip Tar Valon marks.\n\r", ch);
				return;
			}

		}
	}

	if(!str_infix(arg1, "coin"))
	{
		victim = get_char_room(ch, NULL, arg2);

		if(ch->pcdata->gamble_coin == 1 && ch->money[3][0] == 0)
		{
			send_to_char("You have no gold coins to gamble!\n\r", ch);
			return;
		}

		if(ch->pcdata->gamble_coin == 0 && ch->money[2][0] == 0)
		{
			send_to_char("You have no silver coins to gamble!\n\r", ch);
			return;
		}

		if(arg2[0] == '\0')
		{
			send_to_char("Gamble with whom?\n\r", ch);
			return;
		}

		if(!str_infix(ch->name, arg2))
		{
			send_to_char( "You can't gamble with yourself!\n\r", ch);
			return;
		}

		if((victim = get_char_room(ch, NULL, arg2)) == NULL)
		{
		    send_to_char( "They aren't here.\n\r", ch);
		    return;
		}

		if(IS_NPC(victim))
		{
			send_to_char( "You can't gamble with a mob!\n\r", ch);
			return;
		}

		if(!is_number(arg3) || arg3[0] == '\0')
		{
			send_to_char("You must bid a number!\n\r", ch);
			return;
		}

		if(atoi(arg3) > ch->money[3][0])
		{
			send_to_char("You can't bid more gold than you have!\n\r", ch);
			return;
		}

		if(atoi(arg3) > victim->money[3][0])
		{
			send_to_char("Your opponent doesn't have that much gold!\n\r", ch);
			return;
		}

		if((str_infix(arg4, "heads") && str_infix(arg4, "tails")) || arg4[0] == '\0')
		{
			send_to_char("You must call heads or tails!\n\r", ch);
			return;
		}

		if(!str_infix(arg4, "heads"))
			coin_result[0] = 2;

		if(!str_infix(arg4, "tails"))
			coin_result[0] = 1;


		if(ch->pcdata->gamble_type == 1) /* Amadicia */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "{WLo{wt{Dh{wa{Wir {WMa{wnt{Del{war{W's profile");
					sprintf(tails_msg, "{Wa stylized sunburst etched in {ws{Di{wlv{De{wr{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the stern face of {YK{ying {YA{yi{wlr{yo{Yn{W");
					sprintf(tails_msg, "a stylized {Ygolden {Ds{wu{yn{Ybu{yr{ws{Dt{W");
				}
		}

		if(ch->pcdata->gamble_type == 2) /* Andor */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "{DE{wlayne {DT{wrakand{W, the {rDa{Ru{Wgh{Rt{rer{D-{RH{reir{W");
					sprintf(tails_msg, "the {Dke{wy{Wst{wo{Dne{W of {RH{rouse {RT{rrakand{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{DM{wo{yr{Yg{ya{ws{De {DT{wr{ya{Yk{ya{wn{Dd{W, {RQ{ru{We{re{Rn of {RA{rn{Wd{ro{Rr{W");
					sprintf(tails_msg, "the {YL{yion {YR{yampant{W of {RA{Wndor");
				}
		}

		if(ch->pcdata->gamble_type == 3) /* Malkier */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the smiling face of {Del{w'L{We{wan{Dna {WMa{wndr{Da{wgor{Wan");
					sprintf(tails_msg, "the {DS{weven {DT{wowers{W of {wM{Da{wl{Dk{wi{De{wr{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YK{ying{W of {YM{yalkier{W, {Yal{y'{wA{yk{Yir {wMa{yndr{Ya{ygor{wan{W");
					sprintf(tails_msg, "the {YG{yolden {YC{yrane{W in flight");
				}
		}

		if(ch->pcdata->gamble_type == 4) /* Shienar */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "a {Db{wa{Wtt{wl{De{W-{Dha{wr{Wde{wn{Ded{W portrait of {DL{word {DA{wgelmar{W");
					sprintf(tails_msg, "a {Df{wortres{Ds{W of the {DB{wl{Wig{wh{Dt{Wguard");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the stern visage of {YK{ying {YE{ya{ws{ya{Yr{W");
					sprintf(tails_msg, "the {YW{yhite {YH{yart{W");
				}
		}

		if(ch->pcdata->gamble_type == 5) /* Arafel */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "a {DBl{wig{Whtg{wua{Drd{W with {Db{well{Ds{W in his {Dt{wwin {Db{wraids{W");
					sprintf(tails_msg, "a {Dp{wair{W of {Dcr{wo{Ws{ws{Ded {Ws{ww{Dor{wd{Ws");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "a likeness of {YP{yaitar {YN{yachiman{W of {YA{yr{waf{ye{Yl{W");
					sprintf(tails_msg, "the {YT{yhree {YR{yoses{W of {YA{yr{waf{ye{Yl{W");
				}
		}

		if(ch->pcdata->gamble_type == 6) /* Kandor */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "a {Dbe{wje{Ww{wel{Ded {Dm{werchant{W with a {Dhard {Wface");
					sprintf(tails_msg, "a {Dfo{wr{Wtr{we{Dss{W of the {DB{wl{Wig{wh{Dtborder{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {Ysm{yi{wl{yi{Yng{W face of {YQ{yueen {YE{ythenielle{W");
					sprintf(tails_msg, "the {YKa{yn{wd{yo{Yri {YR{yearing {YH{yorse{W");
				}
		}

		if(ch->pcdata->gamble_type == 7) /* Saldaea */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DM{warshall{W-{DG{weneral{W, {DD{wa{Wvr{wa{Dm {DB{was{Wh{wer{De{W");
					sprintf(tails_msg, "a {Dch{wa{Wrg{wi{Dng {Dl{wancer{W mounted on a {Dh{wo{Wr{ws{De{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {Yi{ym{wa{yg{Ye{W of young {YQ{yueen {YT{yenobia{W");
					sprintf(tails_msg, "the {YS{yilver {YF{yish{W of {YSa{yl{wd{ya{Yea{W");
				}
		}

		if(ch->pcdata->gamble_type == 8) /* Cairhien */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {Dto{wp{Wl{we{Dss{W {Dt{wo{Wwe{wr{Ds{W of {DC{wairhien{W");
					sprintf(tails_msg, "the {Di{wnflexible{W and {Dm{wajestic{W {DS{wu{Dn {DT{wh{Wro{wn{De{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {Yen{yg{wra{yv{Yen{W portrait of {YK{ying {YG{yalldrian{W");
					sprintf(tails_msg, "the {YR{yising {YS{yun{W of {YCa{yi{wrh{yi{Yen{W");
				}
		}

		if(ch->pcdata->gamble_type == 9) /* Altara */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "{DPPwrince{W of {DA{wltara{W, {DB{we{Wsl{wa{Dn {DQu{wi{Wnt{wa{Dra{W");
					sprintf(tails_msg, "the {Dha{wr{Wbo{wu{Drs{W of {DE{wbou {DD{war{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YQ{yueen {YT{yylin {YQ{yuintara{W of {YH{yo{wu{ys{Ye {YMi{yt{wso{yb{Yar{W");
					sprintf(tails_msg, "{Yt{ywo {Yst{ya{wlk{yi{Yng {Yle{yo{wpa{yr{Yds{W");
				}
		}

		if(ch->pcdata->gamble_type == 10) /* Murandy */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "a {Dw{well{W-{Dd{wressed {Dme{wr{Wch{wa{Dnt{W");
					sprintf(tails_msg, "the {Dpr{wo{Wf{wi{Dle{W of {DL{wugard{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {Yun{ysm{wi{yli{Yng{W visage of {YK{ying {YR{yoedran{W");
					sprintf(tails_msg, "the {YMu{yra{wn{ydi{Yan {Yst{yo{wmp{yi{Yng {Yb{yull{W");
				}
		}

		if(ch->pcdata->gamble_type == 11) /* Arad Doman */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "a proud {DD{womani {Dmer{wch{Want{wwo{Dman{W");
					sprintf(tails_msg, "a {Dba{wl{Wan{wc{Ded {Ds{wcale{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {YK{ying{W of {YA{yrad {YD{yoman{W, {YAl{ys{wa{yl{Yam{W");
					sprintf(tails_msg, "the {ys{wi{Dlv{we{yr {Dsword{W and {Dhand{W of {YA{yrad {YD{yoman{W");
				}
		}

		if(ch->pcdata->gamble_type == 12) /* Tarabon */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "{DA{wndric{W, {DK{wing{W of {DT{war{Wa{wbo{Dn{W");
					sprintf(tails_msg, "the {DT{whrone {Wof L{wi{Dg{wh{Wt");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YP{yanarch {YA{ymathera{W of {YTa{yr{wa{yb{Yon{W");
					sprintf(tails_msg, "the spreading {Ybr{ya{wnc{yh{Yes{W of {YA{yvendesora{W");
				}
		}

		if(ch->pcdata->gamble_type == 13) /* Ghealdan */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DH{wigh {DC{wr{Wo{ww{Dn {DC{wouncil{W");
					sprintf(tails_msg, "the L{wi{Dg{wh{Wt {DB{wlessed {DT{whrone{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the calm {Yi{ym{wa{yg{Ye{W of {YQ{yueen {YA{ylliandre{W");
					sprintf(tails_msg, "three {Ds{wi{Wlv{we{Dr{W-{wover{W-{Yg{yold{W {Ys{yt{wa{yr{Ys{W");
				}
		}

		if(ch->pcdata->gamble_type == 14) /* Illian */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DC{wou{Wn{wci{Dl{W of {DN{wine{W");
					sprintf(tails_msg, "one of {DIl{wl{Wia{wn{D's {Df{wi{Wne{ws{Dt {Ds{whips{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YM{yattin {YS{ytepaneos {Yd{yi{Yn {YB{yelgar{W");
					sprintf(tails_msg, "the {Yn{yine {Yg{yo{wld{ye{Yn {Yb{yees{W of {YI{yl{wli{ya{Yn{W");
				}
		}

		if(ch->pcdata->gamble_type == 15) /* Tear */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DL{words{W of the {DL{wand{W");
					sprintf(tails_msg, "the {DS{wt{Wo{wn{De{W of {DT{wear{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {Yas{yse{wm{ybl{Yed {YH{yigh {YL{yords{W");
					sprintf(tails_msg, "the {Yt{yh{wr{ye{Ye {Ycr{ye{wsc{ye{Ynt{W moons of {YT{year{W");
				}
		}

		if(ch->pcdata->gamble_type == 16) /* Mayene */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "{DA{wnnoura {DL{warisen{W, {DA{wdv{Wi{wso{Dr{W to the {DF{wi{Wr{ws{Dt{W");
					sprintf(tails_msg, "a {Dle{wa{Wp{wi{Dng {Doi{wl{Wf{wi{Dsh{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YB{yerelain {Ys{yu{Yr {YP{yaendrag{W, {YF{yi{wr{ys{Yt{W {Wof {YM{yayene{W");
					sprintf(tails_msg, "a {Yg{yo{wld{ye{Yn h{yawk{W in {Yf{yl{wig{yh{Yt{W");
				}
		}

		if(ch->pcdata->gamble_type == 17) /* Seandar */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DD{waughter{W of the {DN{wine {DM{woons{W");
					sprintf(tails_msg, "the {Dc{wou{Wn{wtr{Dy{W of {DS{weandar{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "the {YC{yry{ws{yta{Yl {YT{yh{wro{yn{Ye{W");
					sprintf(tails_msg, "the {YE{ympress{W, may she rule {Yfo{yr{we{yv{Yer{W");
				}
		}

		if(ch->pcdata->gamble_type == 18) /* Tar Valon */
		{
				if(ch->pcdata->gamble_coin == 0)
				{
					sprintf(heads_msg, "the {DK{weeper{W of the {DC{whronicles{W, {DA{wnai {DJ{wo{Wg{wa{Dl{W");
					sprintf(tails_msg, "the {DW{white {DT{wower{W");
				}

				if(ch->pcdata->gamble_coin == 1)
				{
					sprintf(heads_msg, "{YC{yaxandra {YM{yolst{W, the {YAm{yy{wr{yl{Yin {YS{yeat{W");
					sprintf(tails_msg, "the {YF{yl{wa{ym{Ye{W of {YT{yar {YV{yalon{W");
				}
		}

		random = (number_range(1, 105));

		if(random > 49 && random < 101) /* Tails */
		{
			sprintf(buf, "{W%s tosses a coin high into the air, and it lands showing %s!{x", ch->name, tails_msg);
			sprintf(shazbot, "{WYou toss a coin into the air, and it lands showing %s!{x\n\r", tails_msg);
			coin_result[1] = 1;

			send_to_char(shazbot, ch);
			act("$T", ch, NULL, buf, TO_ROOM);
		}

		if(random > 0 && random < 50) /* Heads */
		{
			sprintf(buf, "{W%s tosses a coin high into the air, and it lands showing %s!{x", ch->name, heads_msg);
			sprintf(shazbot, "{WYou toss a coin into the air, and it lands showing %s!{x\n\r", heads_msg);
			coin_result[1] = 2;

			send_to_char(shazbot, ch);
			act("$T", ch, NULL, buf, TO_ROOM);
		}

		if(random > 100 && ch->pcdata->gamble_coin == 1) /* Side, lose gold */
		{
			act("{W$n tosses a coin high into the air, misses the catch, and gapes in horror as it rolls away!{x", ch, NULL, NULL, TO_ROOM);
			send_to_char("{WYou toss a coin up, fumble the catch, and gape in horror as a gold mark rolls away!\n\r{x", ch);
			coin_result[1] = 3;

			ch->money[3][0] = ch->money[3][0] - 1;
			return;
		}

		if(random > 100 && ch->pcdata->gamble_coin == 0) /* Side, lose silver */
		{
			act("{W$n tosses a coin high into the air, misses the catch, and gapes in horror as it rolls away!{x", ch, NULL, NULL, TO_ROOM);
			send_to_char("{WYou toss a coin up, fumble the catch, and gape in horror as a silver piece rolls away!\n\r{x", ch);
			coin_result[1] = 3;

			ch->money[2][0] = ch->money[2][0] - 1;
			return;
		}

		if(coin_result[0] == coin_result[1])
		{
			sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", victim->name, ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
			sprintf(buf, "{W%s pays you {Y%i{W gold.{x", victim->name, atoi(arg3));
			act("$T", ch, NULL, buf, TO_CHAR);
			sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
			victim->money[3][0] = victim->money[3][0] - atoi(arg3);
			ch->money[3][0] = ch->money[3][0] + atoi(arg3);
		}
		else
		{
			sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", ch->name, victim->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
			sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", victim->name, atoi(arg3));
			act("$T", ch, NULL, buf, TO_CHAR);
			sprintf(buf, "{W%s pays you {Y%i{W gold.{x", ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
			ch->money[3][0] = ch->money[3][0] - atoi(arg3);
			victim->money[3][0] = victim->money[3][0] + atoi(arg3);
		}

		return;
	}

	if(!str_infix(arg1, "dice"))
	{
		victim = get_char_room(ch, NULL, arg2);

		if(arg2[0] == '\0')
		{
			send_to_char("Gamble with whom?\n\r", ch);
			return;
		}

		if(!str_infix(ch->name, arg2))
		{
			send_to_char( "You can't gamble with yourself!\n\r", ch);
			return;
		}

		if((victim = get_char_room(ch, NULL, arg2)) == NULL)
		{
		    send_to_char( "They aren't here.\n\r", ch);
		    return;
		}

		if(IS_NPC(victim))
		{
			send_to_char( "You can't gamble with a mob!\n\r", ch);
			return;
		}

		if(ch->pcdata->gamble_dice == 0 || ch->pcdata->gamble_sides == 0)
		{
			send_to_char("You have to set the number of dice and sides!\n\r", ch);
			return;
		}

		if(!is_number(arg3) || arg3[0] == '\0')
		{
			send_to_char("You must bid a number!\n\r", ch);
			return;
		}

		if(atoi(arg3) > ch->money[3][0])
		{
			send_to_char("You can't bid more gold than you have!\n\r", ch);
			return;
		}

		if(atoi(arg3) > victim->money[3][0])
		{
			send_to_char("Your opponent doesn't have that much gold!\n\r", ch);
			return;
		}

		if(ch->pcdata->gamble_dice == 1)
		{
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, "a ");
			strcat(buf, shazbot);
			strcat(buf, ".");
			act("{W$n rolls some dice and gets $T{x", ch, NULL, buf, TO_ROOM);
			act("{WYou roll some dice and get $T{x", ch, NULL, buf, TO_CHAR);
			dice_total[0] = dice_results;

			buf[0] = '\0';
			shazbot[0] = '\0';

			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, "a ");
			strcat(buf, shazbot);
			strcat(buf, ".");
			act("{W$n rolls some dice and gets $T{x", victim, NULL, buf, TO_ROOM);
			act("{WYou roll some dice and get $T{x", victim, NULL, buf, TO_CHAR);
			dice_total[1] = dice_results;

			if(dice_total[0] == dice_total[1])
				return;

			if(dice_total[0] > dice_total[1])
			{
				sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", victim->name, ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
				sprintf(buf, "{W%s pays you {Y%i{W gold.{x", victim->name, atoi(arg3));
				act("$T", ch, NULL, buf, TO_CHAR);
				sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
				victim->money[3][0] = victim->money[3][0] - atoi(arg3);
				ch->money[3][0] = ch->money[3][0] + atoi(arg3);
			}
			else
			{
				sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", ch->name, victim->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
				sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", victim->name, atoi(arg3));
				act("$T", ch, NULL, buf, TO_CHAR);
				sprintf(buf, "{W%s pays you {Y%i{W gold.{x", ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
				ch->money[3][0] = ch->money[3][0] - atoi(arg3);
				victim->money[3][0] = victim->money[3][0] + atoi(arg3);
			}

			return;
		}

		if(ch->pcdata->gamble_dice == 2)
		{
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, "a ");
			strcat(buf, shazbot);
			strcat(buf, " and a ");
			dice_total[0] = dice_results;
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, shazbot);
			sprintf(shazbot, " for a total of {Y%i{W!", dice_total[1]);
			strcat(buf, shazbot);
			act("{W$n rolls some dice and gets $T{x", ch, NULL, buf, TO_ROOM);
			act("{WYou roll some dice and get $T{x", ch, NULL, buf, TO_CHAR);
			dice_total[0] = dice_results + dice_total[0];

			buf[0] = '\0';
			shazbot[0] = '\0';

			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, "a ");
			strcat(buf, shazbot);
			strcat(buf, " and a ");
			dice_total[1] = dice_results;
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			sprintf(shazbot, "%d", dice_results);
			strcat(buf, shazbot);
			sprintf(shazbot, " for a total of {Y%i{W!", dice_total[1]);
			strcat(buf, shazbot);
			act("{W$n rolls some dice and gets $T{x", victim, NULL, buf, TO_ROOM);
			act("{WYou roll some dice and get $T{x", victim, NULL, buf, TO_CHAR);
			dice_total[1] = dice_results + dice_total[1];

			if(dice_total[0] == dice_total[1])
				return;

			if(dice_total[0] > dice_total[1])
			{
				sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", victim->name, ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
				sprintf(buf, "{W%s pays you {Y%i{W gold.{x", victim->name, atoi(arg3));
				act("$T", ch, NULL, buf, TO_CHAR);
				sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
				victim->money[3][0] = victim->money[3][0] - atoi(arg3);
				ch->money[3][0] = ch->money[3][0] + atoi(arg3);
			}
			else
			{
				sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", ch->name, victim->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
				sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", victim->name, atoi(arg3));
				act("$T", ch, NULL, buf, TO_CHAR);
				sprintf(buf, "{W%s pays you {Y%i{W gold.{x", ch->name, atoi(arg3));
				act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
				ch->money[3][0] = ch->money[3][0] - atoi(arg3);
				victim->money[3][0] = victim->money[3][0] + atoi(arg3);
			}

			return;
		}

		for(i=1; i<=ch->pcdata->gamble_dice; i++)
		{
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			dice_total[0] = dice_total[0] + dice_results;
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, shazbot);
			if(i == (ch->pcdata->gamble_dice-1))
				strcat(buf, " and a ");
			if(i < (ch->pcdata->gamble_dice-1))
				strcat(buf, ", ");
		}

		sprintf(shazbot, " for a total of {Y%i{W!", dice_total[0]);
		strcat(buf, shazbot);

		act("{W$n rolls some dice and gets $T{x", ch, NULL, buf, TO_ROOM);
		act("{WYou roll some dice and get $T{x", ch, NULL, buf, TO_CHAR);

		buf[0] = '\0';
		shazbot[0] = '\0';

		for(i=1; i<=ch->pcdata->gamble_dice; i++)
		{
			dice_results = number_range(1, ch->pcdata->gamble_sides);
			dice_total[1] = dice_total[1] + dice_results;
			sprintf(shazbot, "{Y%d{W", dice_results);
			strcat(buf, shazbot);
			if(i == (ch->pcdata->gamble_dice-1))
				strcat(buf, " and a ");
			if(i < (ch->pcdata->gamble_dice-1))
				strcat(buf, ", ");
		}

		sprintf(shazbot, " for a total of {Y%i{W!", dice_total[1]);
		strcat(buf, shazbot);

		act("{W$n rolls some dice and gets $T{x", victim, NULL, buf, TO_ROOM);
		act("{WYou roll some dice and get $T{x", victim, NULL, buf, TO_CHAR);

		if(dice_total[0] == dice_total[1])
			return;

		if(dice_total[0] > dice_total[1])
		{
			sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", victim->name, ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
			sprintf(buf, "{W%s pays you {Y%i{W gold.{x", victim->name, atoi(arg3));
			act("$T", ch, NULL, buf, TO_CHAR);
			sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
			victim->money[3][0] = victim->money[3][0] - atoi(arg3);
			ch->money[3][0] = ch->money[3][0] + atoi(arg3);
		}
		else
		{
			sprintf(buf, "{W%s pays %s {Y%i{W gold.{x", ch->name, victim->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_NOTVICT, POS_RESTING);
			sprintf(buf, "{WYou pay %s {Y%i{W gold.{x", victim->name, atoi(arg3));
			act("$T", ch, NULL, buf, TO_CHAR);
			sprintf(buf, "{W%s pays you {Y%i{W gold.{x", ch->name, atoi(arg3));
			act_new("$t", ch, buf, victim, TO_VICT, POS_RESTING);
			ch->money[3][0] = ch->money[3][0] - atoi(arg3);
			victim->money[3][0] = victim->money[3][0] + atoi(arg3);
		}

		return;
	}
}
