/***************************************************************************
                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/
    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
        intact at the head of each function.
    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.
    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.
    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.
    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.
                ROM 2.4 is copyright 1993-1998 Russ Taylor
	        ROM has been brought to you by the ROM consortium
	            Russ Taylor (rtaylor@hypercube.org)
	            Gabrielle Taylor (gtaylor@hypercube.org)
	            Brian Moore (zump@rom.org)
	        By using this code, you have agreed to follow the terms of the
	        ROM license, in the file Rom24/doc/rom.license
 ***************************************************************************/
#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "recycle.h"
#include "lookup.h"

bool can_recruit args((CHAR_DATA *ch, CHAR_DATA *victim, char *argument));
bool is_aiel_clan args((CHAR_DATA *ch));
bool is_seafolk args((CHAR_DATA *ch));

void do_rank args(( CHAR_DATA * ch, char *argument ));
void compose_title args(( CHAR_DATA *ch));

#define MAXGUILDWIDTH 15

void show_guild_list (CHAR_DATA *ch, int clan)
{
	DESCRIPTOR_DATA *d;
	CHAR_DATA *vch;
	bool show, sub = FALSE;
	int i;
	char rankbuf[MSL];

	for (d = descriptor_list; d != NULL; d = d->next)
	{
		if (d->connected != CON_PLAYING || (vch = d->character) == NULL)	continue;
		if (IS_NPC(vch))					continue;

		show = FALSE;
		sub = FALSE;

		if (clan == vch->clan)					show = TRUE;
		else if (vch->sub_clan > 1 && clan == vch->sub_clan)	sub = show = TRUE;

		for (i = 0; i < MAX_GUILD_RELATIONS; i++)
		{
			if (clan_table[clan].lists[i] == NULL)		continue;
			if (clan_table[clan].lists[i][0] == '\0')	continue;

			if (!str_cmp(clan_table[clan].lists[i], clan_table[vch->clan].name))
			{
				show = TRUE;
				break;
			}

			if (vch->sub_clan > 1 && !str_cmp(clan_table[clan].lists[i], clan_table[vch->sub_clan].name))
			{
				sub = show = TRUE;
				break;
			}
		}

		if (show)
		{
			int count = strlen_color(clan_table[sub ? vch->sub_clan : vch->clan].who_name);

			ptc(ch, "{x[{w%s", clan_table[sub ? vch->sub_clan : vch->clan].who_name);

			while (count++ < MAXGUILDWIDTH)
				stc(" ",ch);

			if (!sub && vch->clan == clan_lookup("Aiel") && vch->rank == 0)
				sprintf(rankbuf, "%s", clan_table[vch->clan].tag);
			else if (sub && vch->sub_clan == clan_lookup("Aiel") && vch->sub_rank == 0)
				sprintf(rankbuf, "%s", clan_table[vch->sub_clan].tag);
			else if (!sub)
				sprintf(rankbuf, "%s %s", player_rank(vch, sub), clan_table[vch->clan].tag);
			else
				sprintf(rankbuf, "%s %s", player_rank(vch, sub), clan_table[vch->sub_clan].tag);

			ptc( ch, "{x] {w%s%s %s, %s\n\r{x",
			IS_SET(vch->comm, COMM_AFK) ? "{c[{wAFK{c]{w " : "",
			vch->name, vch->pcdata->last_name, rankbuf);
		}
	}

	return;
}

void do_gcom( CHAR_DATA *ch, char *argument )
{
	char arg1[MIL];
	char arg2[MIL];
	char buf1[MSL];

	buf1[0] = '\0';
    argument = one_argument( argument, arg1 );

    if (( arg1[0] == '\0') || (!str_prefix( arg1, "help" )) )
    {
        stc("Syntax:\n\r",ch);
        stc("Gcom list - Shows Guild Members online.\n\r",ch);
        stc("Gcom room  - Room only echo message (RP). {RGL Only{x\n\r",ch);
        stc("Gcom zone - Sends a zone wide message (RP).{RGL Only{x\n\r",ch);
        return;
    }
   	if ( !str_prefix( arg1, "list" ) )
	{
		int i = 0;
    		argument = one_argument( argument, arg2 );

		if ( !str_cmp(arg2, "full"))
		{
		    int j,count;
		    int k = 0;

			/* crashes -- Dalsor */
		    	/* Changed something. Hopefully that was it */
/*			stc("Buggy... Don't use this.\n\r", ch);
			return; */

  		    ptc(ch, "All guilds.\n\r-----------------------------------------------\n\r");

  		    for (j=1; j < MAX_CLAN; j++)
  		    {
    			if (clan_table[j].who_name != NULL && clan_table[j].who_name[0] != '\0')
    			{
      			    ptc(ch,"%s", clan_table[j].who_name);
			    count = strlen_color(clan_table[j].who_name);
			    while(count++<MAXGUILDWIDTH)
				    stc(" ",ch);
			    if(k++==2)
			    {
				k = 0;
				stc("\n\r",ch);
			    }
			    else
				stc("   ",ch);
    			}
  		    }
		    if(k!=0)
			stc("\n\r",ch);
		    return;
		}
				

		if ( IS_NPC( ch ) || ch->desc == NULL )
			return;

		stc("{wPrimary Member List:{x\n\r{b--------------------{x\n\r", ch);
		show_guild_list(ch, ch->clan);

		if(ch->sub_clan <= 1)
		    return;

		for( i = 0; i < MAX_GUILD_RELATIONS; i++)
		{
			if(!str_cmp( clan_table[ch->sub_clan].lists[i], clan_table[ch->clan].name) )
				return;
		}


		stc("\n\r{wSubguild Member List:{x\n\r{b--------------------{x\n\r", ch);
		show_guild_list(ch, ch->sub_clan);
	        return;
	        /* end of gcom list */
	}
	else if ( !str_prefix( arg1, "room" ) )
	{
	    DESCRIPTOR_DATA *d;
   		if ( argument[0] == '\0' )
   		{
			stc("{cSyntax:\n\r",ch);
			stc("{cGcom room <text>\n\r",ch);
			return;
   		}
		if (!IS_SET(ch->hist_flags,HIST_GUILDLEADER))
        {
			stc("You are not the guildleader for your Guild.\n\r",ch);
			return;
        }
		for ( d = descriptor_list; d; d = d->next )
		{
			if ( d->connected == CON_PLAYING
			&&   d->character->in_room == ch->in_room )
			{
				stc( argument, d->character );
				stc("{c\n\r",   d->character );
			}
	    }
	    return;
	}
	else if ( !str_prefix( arg1, "zone" ) )
	{
	    DESCRIPTOR_DATA *d;
	    if (argument[0] == '\0')
	    {
			stc("{cSyntax:\n\r",ch);
			stc("{cGcom zone <text>\n\r",ch);
			return;
	    }
	    if (!IS_SET(ch->hist_flags,HIST_GUILDLEADER))
        {
			stc("You are not the guildleader for your Guild.\n\r",ch);
			return;
        }
		for (d = descriptor_list; d; d = d->next)
		{
			if (d->connected == CON_PLAYING
			&&  d->character->in_room != NULL && ch->in_room != NULL
			&&  d->character->in_room->area == ch->in_room->area)
			{
				stc(argument,d->character);
				stc("{c\n\r",d->character);
			}
	    }
	    return;
	}
}

char *one_argument_with_caps( char *argument, char *arg_first )
{
    char cEnd;

    while ( isspace(*argument) )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"' )
	cEnd = *argument++;

    while ( *argument != '\0' )
    {
		if ( *argument == cEnd )
		{
			argument++;
			break;
		}
		*arg_first++ = *argument++;
    }
    *arg_first = '\0';

    while ( isspace(*argument) )
	argument++;

    return argument;
}

char *strip_string_from_CR_and_LF args((char *argument));
char *get_colour_name args((char *name, bool IS_SPOUSE));

void compose_title( CHAR_DATA *ch )
{
	char buf[MSL];
	char buf1[MSL];
	buf[0]='\0';
	buf1[0]='\0';

    if ( IS_NPC( ch ) )
	return;

	if( ch->race == race_lookup("seafolk"))
	{
		strcpy(buf, "din'");
    		strcat(buf,ch->pcdata->last_name);
	}
	else if (ch->race != race_lookup("trolloc") && ch->race != race_lookup("fade"))
    		strcpy( buf,ch->pcdata->last_name);

	if ( ch->race == race_lookup("aiel") )
		strcat( buf,"{w." );
	else if(ch->race == race_lookup("trolloc"))
	{
		strcat( buf,", " );
		strcat(buf, ch->pcdata->aiel_clan);
	}
	else if (ch->race == race_lookup("fade"))
		strcat(buf, ",");
	else if (ch->clan > 1)
		strcat( buf,"{w," );

	/*ptc( ch, "Clan table says you're clan %d (%s).\n\r", ch->clan, clan_table[ch->clan].name );*/
	if ( ch->clan > 1 && clan_table[ch->clan].rank[ch->rank].rankname != NULL )
	{
		if (ch->clan != clan_lookup("aiel") || ch->rank != 0)
		{
			strcat( buf, " ");
			strcat( buf, clan_table[ch->clan].rank[ch->rank].rankname );
		}

		if (clan_table[ch->clan].tag != NULL)
		{
			strcat(buf, " {w");
			strcat(buf, clan_table[ch->clan].tag);
		}
	}

	if ( ch->clan <= 1 )
	{
		strcat( buf, "." );
	}

	if ( ch->sub_clan > 1 && clan_table[ch->sub_clan].rank[ch->sub_rank].rankname != NULL )
	{
		strcat(buf, "{w,");
		if (ch->sub_clan != clan_lookup("aiel") || ch->sub_rank != 0)
		{
			strcat( buf, " ");
			strcat( buf, clan_table[ch->sub_clan].rank[ch->sub_rank].rankname );
		}

		if (clan_table[ch->sub_clan].tag != NULL)
		{
			strcat(buf, " {w");
			strcat(buf, clan_table[ch->sub_clan].tag);
		}
	}

    if(IS_MARRIED(ch) || ((ch->pcdata->spouse) && (!str_cmp(ch->pcdata->spouse, "cheat"))))
    {
	    char *pretty_spouse = get_colour_name(ch->name,1);
		strcpy(buf1, strip_string_from_CR_and_LF(pretty_spouse));
		free_string(pretty_spouse);
		if (str_cmp(buf1, "NULL"))
		{
			strcat(buf, " {w");
			strcat(buf, buf1);
		}
		else
		{
			strcat(buf," {W*{w");
			strcat(buf, ch->pcdata->spouse);
			strcat(buf,"{W*");
		}
	}

	if(IS_SET(ch->hist_flags,HIST_BONDED) || IS_SET(ch->hist_flags,HIST_BONDER))
	{
		if (!ch->pcdata->spouse || ch->pcdata->spouse[0] == '\0' || str_cmp(ch->pcdata->bonded_to , ch->pcdata->spouse))
		{
	    		char *pretty_bond = get_colour_name(ch->name,0);
			strcpy(buf1, strip_string_from_CR_and_LF(pretty_bond));
			free_string(pretty_bond);
			if (str_cmp(buf1, "NULL"))
			{
				strcat(buf, " {w");
				strcat(buf, buf1);
			}
			else
			{
				strcat(buf," {B[{w");
				strcat(buf, ch->pcdata->bonded_to);
				strcat(buf,"{B]");
			}
		}
	}
	strcat(buf,"{x");
    set_title( ch, buf );
    return;
}

char *strip_string_from_CR_and_LF(char *argument)
{
    char *point;
    int i=0;

    if ((point = strchr(argument, '\n'))==NULL)
    {
      return argument;
    }
    else
    {
		i = strlen(argument) - strlen(point);
		argument[i]='\0';
		return argument;
	}
}
