/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"

int clan_lookup args(( const char *name ));

void sing_song( CHAR_DATA *ch, char *buf )
{
	act( buf, ch, NULL, NULL, TO_ROOM );
	act( buf, ch, NULL, NULL, TO_CHAR );
	return;
}
void do_sing( CHAR_DATA *ch, char *argument )
{
	char arg1[MIL];
	char buf[MSL];
	char buf2[MSL];
	char buf3[MSL];
	char buf4[MSL];
	char buf5[MSL];
	char mfBuf[MSL];
	char mfBuf1[MSL];
	char mfBuf2[MSL];
    AFFECT_DATA af;
    CHAR_DATA *victim;
	int minMana = 50;
	buf[0] = '\0';
	buf2[0] = '\0';
	buf3[0] = '\0';
	buf4[0] = '\0';
	buf5[0] = '\0';
	mfBuf[0] = '\0';
	mfBuf1[0] = '\0';
	mfBuf2[0] = '\0';

	if ( IS_NPC( ch ) )
	return;

	if ( ch->in_room != NULL )
	{
		if ( ch->in_room->vnum == 3001 )
		{
			stc( "Use a room other than the Oval Plaza.\n\r", ch );
			return;
		}
	}

	if ( ch->clan != clan_lookup("gleeman") )
	{
		stc("You haven't been properly trained in singing.\n\r",ch);
		return;
	}

	if ( ch->stam < minMana )
	{
		stc("You're too tired right now. Rest for a bit.\n\r",ch);
		return;
	}

	argument = one_argument( argument, arg1 );

	if ( arg1[0] == '\0' )
	{
		stc( "Syntax; sing 'song name'\n\r", ch );
		stc( "             'The Battle'\n\r", ch );
		stc( "             'Your Prize'\n\r", ch );
		stc( "             'Darkness Host'\n\r", ch );
		stc( "             'The Shining Blade'\n\r", ch );
		stc( "             'Mideans Ford' (High Chant [Constitution])\n\r", ch );
		stc( "             'Thy Morning Dove' (High Chant [Charisma])\n\r", ch );
		stc( "             'Tarwins Gap'\n\r", ch );
		stc( "        sing new (create a new song)\n\r", ch );
		stc( "        sing sing (sing a newly created song)\n\r", ch );
		stc( "Remember to Include the '' around the song name.\n\r", ch );
		return;
	}

	if ( !str_cmp( arg1, "new" ) )
	{
		char buf[MSL];
	    PNOTE_DATA *pnote;

	    buf[0] = '\0';

	    if ( ch->pnote != NULL )
			return;

	    pnote = new_pnote();
	    pnote->next		= NULL;
	    pnote->sender	= str_dup( ch->name );
	    pnote->date		= str_dup( "" );
	    pnote->to_list	= str_dup( "" );
	    pnote->subject	= str_dup( "" );
	    pnote->text		= str_dup( "" );
	    pnote->type		= PNOTE_NOTE;
	    ch->pnote		= pnote;

	    sprintf( buf, "%s sings...", ch->name );
	    ch->pnote->subject = str_dup( buf );
		string_append( ch, &ch->pnote->text );
		return;
	}
	if ( !str_cmp( arg1, "sing" ) )
	{
		if ( ch->pnote == NULL )
		{
			stc( "You need to sing a new song first.", ch );
			do_function( ch, &do_sing, "" );
			return;
		}
		if ( ch->pnote->text == NULL || ch->pnote->text[0] == '\0' )
		{
			stc( "You need to sing a new song first.", ch );
			do_function( ch, &do_sing, "" );
			return;
		}

		act( ch->pnote->subject, ch, NULL, NULL, TO_CHAR );
		act( ch->pnote->subject, ch, NULL, NULL, TO_ROOM );
		act( ch->pnote->text, ch, NULL, NULL, TO_CHAR );
		act( ch->pnote->text, ch, NULL, NULL, TO_ROOM );
		ch->pnote = NULL;
		return;
	}
	if ( !str_cmp( arg1, "Tarwins Gap" ) )
	{
		sprintf( buf, "%s sings...\n\r\n\r", ch->name );
		strcat( buf, "My home is waiting there for me,\n\r" );
		strcat( buf, "and the girl I left behind.\n\r" );
		strcat( buf, "Of all the treasures that wait for me,\n\r" );
		strcat( buf, "that's what I want to find.\n\r" );
		strcat( buf2, "Her eyes so merry, and her smile so sweet,\n\r" );
		strcat( buf2, "her hugs so warm, and her ankle neat,\n\r" );
		strcat( buf2, "her kisses hot, now there's a treat.\n\r" );
		strcat( buf2, "If there's a treasure greater, it lies not in my mind.\n\r" );
		strcat( buf3, "Oh I have seen Tarwin's Gap,\n\r" );
		strcat( buf3, "and the Trolloc's raving horde.\n\r" );
		strcat( buf3, "I have stood 'fore the Halfman's charge,\n\r" );
		strcat( buf3, "and walked on death's cold borde.\n\r" );
		strcat( buf3, "But a winsome lass, she waits for me,\n\r" );
		strcat( buf3, "for a dance and kiss 'neath the apple tree.\n\r" );

		sing_song( ch, buf );
		WAIT_STATE( ch, 15 );
		wait_act( 5, buf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 5, buf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 10, buf3, ch, NULL, NULL, TO_ROOM );
		wait_act( 10, buf3, ch, NULL, NULL, TO_CHAR );
		ch->stam -= minMana;
		return;
	}

	if ( !str_cmp( arg1, "Mideans Ford" ) )
	{
		if ( ch->pcdata->rebirth <= 0 )
		{
			stc("Only a true Bard can sing in High Chant.\n\r",ch);
			return;
		}
		act("$n chants, 'This song and tale is called Midean's ford.'",ch,NULL,NULL,TO_ROOM);
		act("You chant, 'This song and tale is called Midean's ford.'",ch,NULL,NULL,TO_CHAR);
		strcat( mfBuf, "$n sings in High Chant:\n\r" );
		strcat( mfBuf, "Soft, the winds, like springtime's fingers.\n\r");
		strcat( mfBuf, "Soft, the years roll by in gladness,\n\r");
		strcat( mfBuf, "never hinting storms to come,\n\r");
		strcat( mfBuf, "never hinting whirlwinds' ravage,\n\r");
		strcat( mfBuf, "rain of steel and battle thunder,\n\r");
		strcat( mfBuf, "war to tear the heart asunder.\n\r");
		strcat( mfBuf1, "$n sings in High Chant:\n\r" );
		strcat( mfBuf1, "Villanous Aedomon led the Saferi down on unsuspecting Manetheren,\n\r" );
		strcat( mfBuf1, "pillaging and burning,\n\r" );
		strcat( mfBuf1, "Driving all before them until King Buiyn gathered Manetheren's strength,\n\r" );
		strcat( mfBuf1, "and the men of Manetheren met the Saferi at Midean's Ford,\n\r");
		strcat( mfBuf1, "Holding, though heavily outnumbered, through three days of unrelenting battle,\n\r" );
		strcat( mfBuf1, "while the river ran red and vultures blacked the sky.\n\r");
		strcat( mfBuf1, "On the third day, numbers dwindling, hope fading,\n\r" );
		strcat( mfBuf1, "Buiryn and his men fought their way across the ford in a desperate sortie,\n\r");
		strcat( mfBuf1, "driving deep into Aedomon's horde,\n\r" );
		strcat( mfBuf1, "seeking to turn the enemy back by killing Aedomon himself.\n\r");
		strcat( mfBuf1, "But forces to great to overpower swept in around them,\n\r" );
		strcat( mfBuf1, "trapping them, driving them ever in on themselves.\n\r");
		strcat( mfBuf1, "Surrounding their king and the Red Eagle banner, they fought on,\n\r" );
		strcat( mfBuf1, "refusing to surrender even when their doom became clear.\n\r");
		strcat( mfBuf1, "The Manetheren's courage touched even Aedomon's heart.\n\r" );
		strcat( mfBuf1, "He allowed the remnants to go free, turning his army away in honor of them.\n\r");
		strcat( mfBuf2, "$n sings in High Chant:\n\r" );
		strcat( mfBuf2, "back across the blood-red water,\n\r");
		strcat( mfBuf2, "marching back with heads held high.\n\r");
		strcat( mfBuf2, "No surrender, arm or sword,\n\r");
		strcat( mfBuf2, "no surrender, heart or soul.\n\r");
		strcat( mfBuf2, "Honor be theirs, ever after,\n\r");
		strcat( mfBuf2, "honor all the Age shall know\n\r");

		WAIT_STATE( ch, 18 );
		wait_act( 5, mfBuf, ch, NULL, NULL, TO_ROOM );
		wait_act( 5, mfBuf, ch, NULL, NULL, TO_CHAR );
		wait_act( 10, mfBuf1, ch, NULL, NULL, TO_ROOM );
		wait_act( 10, mfBuf1, ch, NULL, NULL, TO_CHAR );
		wait_act( 15, mfBuf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 15, mfBuf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 18, "$n concludes the tale with a bow.", ch, NULL, NULL, TO_ROOM );
		wait_act( 18, "You conclude the tale with a bow.", ch, NULL, NULL, TO_CHAR );

		for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
		{
	        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
	   		    continue;
	   		if ( is_affected( victim, gsn_music_confidence ) )
	   			continue;
	   		else
	   		{
			   	stc( "{cYou feel inspired by the song, and gain new confidence!{x\n\r", victim );
			    act( "$n looks inspired and more confident!{x",ch,0,0,TO_ROOM);
			    af.where	 = TO_AFFECTS2;
			    af.type      = skill_lookup("confidence");
			    af.level	 = get_curr_stat(ch, STAT_CHA);
			    af.duration  = get_curr_stat(ch, STAT_CHA);
			    af.modifier  = get_curr_stat(ch, STAT_CHA);
			    af.location  = APPLY_CON;
			    af.bitvector = AFF_ENDURANCE;
			    affect_to_char( victim, &af );
			}
		}
		ch->stam -= minMana;
		return;
	}
	if ( !str_cmp( arg1, "Thy Morning Dove" ) )
	{
		if ( ch->pcdata->rebirth <= 0 )
		{
			stc("Only a true Bard can sing in High Chant.\n\r",ch);
			return;
		}
		act("$n chants, 'This song is called Thy Morning Dove.'",ch,NULL,NULL,TO_ROOM);
		act("You chant, 'This song is called Thy Morning Dove.'",ch,NULL,NULL,TO_CHAR);
		strcat( mfBuf, "$n sings in High Chant:\n\r" );
		strcat( mfBuf, "eyes like windows into another land.\n\r");
		strcat( mfBuf, "thy dove of beauty, flying high,\n\r");
		strcat( mfBuf, "never in the world of man,\n\r");
		strcat( mfBuf, "has there been one so alive.\n\r");
		strcat( mfBuf1, "$n sings in High Chant:\n\r" );
		strcat( mfBuf1, "silken hair flowing like water,\n\r");
		strcat( mfBuf1, "thy dove of wonder, soaring free,\n\r");
		strcat( mfBuf1, "ever has there been a wonder,\n\r");
		strcat( mfBuf1, "only thee can ever be.\n\r");
		strcat( mfBuf2, "$n sings in High Chant:\n\r" );
		strcat( mfBuf2, "soul like burnished blazing gold,\n\r");
		strcat( mfBuf2, "thy dove of morning, light shining,\n\r");
		strcat( mfBuf2, "ever has thy breath been held,\n\r");
		strcat( mfBuf2, "for thy Dove of the Morning.\n\r");

		WAIT_STATE( ch, 18 );
		wait_act( 5, mfBuf, ch, NULL, NULL, TO_ROOM );
		wait_act( 5, mfBuf, ch, NULL, NULL, TO_CHAR );
		wait_act( 10, mfBuf1, ch, NULL, NULL, TO_ROOM );
		wait_act( 10, mfBuf1, ch, NULL, NULL, TO_CHAR );
		wait_act( 15, mfBuf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 15, mfBuf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 18, "$n concludes the tale with a bow.", ch, NULL, NULL, TO_ROOM );
		wait_act( 18, "You conclude the tale with a bow.", ch, NULL, NULL, TO_CHAR );

		for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
		{
	        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
	   		    continue;
	   		if ( is_affected( victim, gsn_music_serenade ) )
	   			continue;
	   		else
	   		{
			   	stc( "{cPeople sit forward, eager to hear your words!{x\n\r", ch );
			    act( "$n seems much more interesting to you.{x",ch,0,0,TO_ROOM);
			    af.where	 = TO_AFFECTS2;
			    af.type      = skill_lookup("serenade");
			    af.level	 = (ch->level / 2);
			    af.duration  = (ch->level / 10);
			    af.modifier  = (ch->level / 10);
			    af.location  = APPLY_CHA;
			    af.bitvector = AFF_MUSIC_SERENADE;
			    affect_to_char( victim, &af );
			}
		}
		ch->stam -= minMana;
		return;
	}

	if ( !str_cmp( arg1, "The Battle" ) )
	{
		sprintf( buf, "%s sings...\n\r\n\r", ch->name );
		strcat( buf, "I'll tell you story,\n\r" );
		strcat( buf, "I'll sing you a song...\n\r\n\r" );
		strcat( buf, "A moment in passing,\n\r" );
		strcat( buf, "Eternity long...\n\r\n\r" );
		strcat( buf, "A man cloaked in darkness,\n\r" );
		strcat( buf, "A man of the Light...\n\r\n\r" );
		strcat( buf, "And who will now triumph?\n\r" );
		strcat( buf, "And who holds the might?\n\r\n\r" );
		strcat( buf, "With sword upraised they,\n\r" );
		strcat( buf, "Came upon each in turn...\n\r\n\r" );
		strcat( buf, "The Light it was searing,\n\r" );
		strcat( buf, "The Shadow did burn...\n\r\n\r" );
		strcat( buf2, "I'll tell you story,\n\r" );
		strcat( buf2, "I'll sing you a song...\n\r\n\r" );
		strcat( buf2, "A moment in passing,\n\r" );
		strcat( buf2, "Eternity long...\n\r\n\r" );
		strcat( buf2, "Two and thrice hours,\n\r" );
		strcat( buf2, "The battle did rage...\n\r\n\r" );
		strcat( buf2, "And then it was over,\n\r" );
		strcat( buf2, "Like the turn of a page...\n\r\n\r" );
		strcat( buf2, "The Shadowspawn grinned,\n\r" );
		strcat( buf2, "With flames in his eyes...\n\r\n\r" );
		strcat( buf2, "'I am victor eternal!'\n\r" );
		strcat( buf2, "He screamed to the skies...\n\r\n\r" );
		strcat( buf3, "I'll tell you story,\n\r" );
		strcat( buf3, "I'll sing you a song...\n\r\n\r" );
		strcat( buf3, "A moment in passing,\n\r" );
		strcat( buf3, "Eternity long...\n\r\n\r" );
		strcat( buf3, "Then the hero roared,\n\r" );
		strcat( buf3, "With last ragged breath...\n\r\n\r" );
		strcat( buf3, "'I will never surrender,\n\r" );
		strcat( buf3, "not even in death.'\n\r\n\r" );
		strcat( buf3, "And then it was silent,\n\r" );
		strcat( buf3, "And then the Earth shook...\n\r\n\r" );
		strcat( buf3, "The mountains they quivered,\n\r" );
		strcat( buf3, "As the Pattern closed the book.\n\r\n\r" );
		strcat( buf4, "I'll tell you story,\n\r" );
		strcat( buf4, "I'll sing you a song...\n\r\n\r" );
		strcat( buf4, "A moment in passing,\n\r" );
		strcat( buf4, "Eternity long...\n\r\n\r" );
		strcat( buf4, "So who won that day?\n\r" );
		strcat( buf4, "So many suppose...\n\r\n\r" );
		strcat( buf4, "That though the flesh died,\n\r" );
		strcat( buf4, "Light's spirit arose...\n\r\n\r" );
		strcat( buf4, "And when the darkfriend,\n\r" );
		strcat( buf4, "Slept that last night...\n\r\n\r" );
		strcat( buf4, "He died in a dream...\n\r\n\r" );
		strcat( buf4, "As he fought blaze.. of pure light.\n\r\n\r" );
		sing_song( ch, buf );
		WAIT_STATE( ch, 15 );
		wait_act( 5, buf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 5, buf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 10, buf3, ch, NULL, NULL, TO_ROOM );
		wait_act( 10, buf3, ch, NULL, NULL, TO_CHAR );
		wait_act( 15, buf4, ch, NULL, NULL, TO_ROOM );
		wait_act( 15, buf4, ch, NULL, NULL, TO_CHAR );
		ch->stam -= minMana;
		return;
	}

	if ( !str_cmp( arg1, "Your Prize" ) )
	{
		sprintf( buf, "%s sings...\n\r\n\r", ch->name );

		strcat( buf, "The Shadow encroached,\n\r" );
		strcat( buf, "The dawn approached,\n\r" );
		strcat( buf, "I stood and held my blade.\n\r\n\r" );
		strcat( buf, "A fist of trollocs,\n\r" );
		strcat( buf, "Twelve darkhounds leashed,\n\r" );
		strcat( buf, "Commanded by a Fade.\n\r\n\r" );
		strcat( buf2, "The gaze of the Eyeless,\n\r" );
		strcat( buf2, "That is fear,\n\r" );
		strcat( buf2, "I stood as still as stone.\n\r\n\r" );
		strcat( buf2, "And then the scream,\n\r" );
		strcat( buf2, "Of dying men,\n\r" );
		strcat( buf2, "It chilled me to the bone.\n\r\n\r" );
		strcat( buf3, "A flame unleashed,\n\r" );
		strcat( buf3, "My roar was all,\n\r" );
		strcat( buf3, "Fire rushed through my veins.\n\r\n\r" );
		strcat( buf3, "I slashed the wounds,\n\r" );
		strcat( buf3, "I cleaved the limbs,\n\r" );
		strcat( buf3, "I caused a thousand pains.\n\r\n\r" );
		strcat( buf4, "My mind was burned,\n\r" );
		strcat( buf4, "My heart alight,\n\r" );
		strcat( buf4, "With death's own fiery blaze.\n\r\n\r" );
		strcat( buf4, "I rode titanic,\n\r" );
		strcat( buf4, "Waves of blood,\n\r" );
		strcat( buf4, "Shai'tan himself to raze.\n\r\n\r" );
		strcat( buf5, "And then I fell,\n\r" );
		strcat( buf5, "My blood soon drained,\n\r" );
		strcat( buf5, "From deeply sunken eyes.\n\r\n\r" );
		strcat( buf5, "I fought till death,\n\r" );
		strcat( buf5, "And life I gained,\n\r" );
		strcat( buf5, "Your freedom is the prize.\n\r\n\r" );
		strcat( buf5, "Your freedom. The prize.\n\r\n\r" );
		sing_song( ch, buf );
		WAIT_STATE( ch, 15 );
		wait_act( 3, buf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 3, buf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 6, buf3, ch, NULL, NULL, TO_ROOM );
		wait_act( 6, buf3, ch, NULL, NULL, TO_CHAR );
		wait_act( 12, buf4, ch, NULL, NULL, TO_ROOM );
		wait_act( 12, buf4, ch, NULL, NULL, TO_CHAR );
		wait_act( 15, buf5, ch, NULL, NULL, TO_ROOM );
		wait_act( 15, buf5, ch, NULL, NULL, TO_CHAR );
		ch->stam -= minMana;
		return;
	}

	if ( !str_cmp( arg1, "Darkness Host" ) )
	{
		sprintf( buf, "%s sings...\n\r\n\r", ch->name );
		strcat( buf, "Shadow falling,\n\r" );
		strcat( buf, "always calling,\n\r" );
		strcat( buf, "tempter rages in a tempest;\n\r" );
		strcat( buf, "Shadow coming,\n\r" );
		strcat( buf, "I am running,\n\r" );
		strcat( buf, "raging war from east to west.\n\r" );
		strcat( buf, "Shadow screaming,\n\r" );
		strcat( buf, "blades are gleaming,\n\r" );
		strcat( buf, "my cry unheard and yet resounds;\n\r" );
		strcat( buf, "Running fighting,\n\r" );
		strcat( buf, "thunder, lightning,\n\r" );
		strcat( buf, "howling snarling shadow's hounds.\n\r" );
		strcat( buf, "Weeping women,\n\r" );
		strcat( buf, "weeping children,\n\r" );
		strcat( buf, "my fear realized and come so close;\n\r" );
		strcat( buf, "Men are dying,\n\r" );
		strcat( buf, "some are crying,\n\r" );
		strcat( buf, "'We must face this darkness host!'\n\r\n\r" );
		strcat( buf, "'We must face this darkness host.'\n\r\n\r" );
		sing_song( ch, buf );
		WAIT_STATE( ch, 15 );
		ch->stam -= minMana;
		return;
	}
	if ( !str_cmp( arg1, "The Shining Blade") )
	{
		sprintf( buf, "%s sings...\n\r\n\r", ch->name );
		strcat( buf, "The shining blade,\n\r" );
		strcat( buf, "The glim'ring steel,\n\r" );
		strcat( buf, "Held by many men in zeal.\n\r\n\r" );
		strcat( buf, "The shining blade,\n\r" );
		strcat( buf, "Its power known,\n\r" );
		strcat( buf, "It breaks the Shadow's flesh and bone.\n\r\n\r" );
		strcat( buf, "The shining blade,\n\r" );
		strcat( buf, "Brings forth the dawn,\n\r" );
		strcat( buf, "And fields of peace I walk upon.\n\r\n\r" );
		strcat( buf, "The shining blade,\n\r" );
		strcat( buf, "Its word rings true,\n\r" );
		strcat( buf, "Things old and dead reborn anew.\n\r\n\r" );
		strcat( buf, "The shining blade,\n\r" );
		strcat( buf, "What is its name?\n\r" );
		strcat( buf, "From whence has come its terrible fame?\n\r\n\r" );
		strcat( buf2, "I ask;\n\r\n\r" );
		strcat( buf2, "'Thou shining blade,\n\r" );
		strcat( buf2, "Speak now to me,\n\r" );
		strcat( buf2, "Where and how and who are thee?'\n\r\n\r" );
		strcat( buf2, "It is answered;\n\r\n\r" );
		strcat( buf2, "'I am that blade,\n\r" );
		strcat( buf2, "Ringing always,\n\r" );
		strcat( buf2, "Death I rebuke and Shadow raze.\n\r\n\r" );
		strcat( buf2, "And thus I fly,\n\r" );
		strcat( buf2, "So swiftly true,\n\r" );
		strcat( buf2, "My name is ancient; Never new.\n\r\n\r" );
		strcat( buf2, "My name is honour,\n\r" );
		strcat( buf2, "My bite is truth,\n\r" );
		strcat( buf2, "I cleave the Shadow with razor tooth.'\n\r\n\r" );
		strcat( buf2, "And as I watch,\n\r" );
		strcat( buf2, "The blade it flies,\n\r" );
		strcat( buf2, "And evil shouts its final cries.\n\r" );
		strcat( buf2, "And then it dies.\n\r\n\r" );
		strcat( buf2, "The shining blade,\n\r" );
		strcat( buf2, "I know its name,\n\r" );
		strcat( buf2, "Forever will I bear its flame.\n\r\n\r" );
		strcat( buf3, "Strength marks the wise man,\n\r" );
		strcat( buf3, "Strength marks him true,\n\r" );
		strcat( buf3, "I'll tell you a story,\n\r" );
		strcat( buf3, "That's both old and new;\n\r\n\r" );
		strcat( buf3, "A man who fought the Shadow,\n\r" );
		strcat( buf3, "A woman held his love,\n\r" );
		strcat( buf3, "His trek was ne'er ending,\n\r" );
		strcat( buf3, "From ground to stars above;\n\r\n\r" );
		strcat( buf3, "Strength marks the wise man,\n\r" );
		strcat( buf3, "Strength marks him true,\n\r" );
		strcat( buf3, "The story long ago began,\n\r" );
		strcat( buf3, "And living here it grew;\n\r\n\r" );
		strcat( buf3, "The Dark One came to tempt him,\n\r" );
		strcat( buf3, "To choose between his fate,\n\r" );
		strcat( buf3, "'Power at my side eternal,\n\r" );
		strcat( buf3, "or death's eternal mate;'\n\r\n\r" );
		strcat( buf4, "Strength marks the wise man,\n\r" );
		strcat( buf4, "Strength marks him true,\n\r" );
		strcat( buf4, "This man was a wise man,\n\r" );
		strcat( buf4, "And in his heart he knew;\n\r\n\r" );
		strcat( buf4, "To die a thousand deaths to,\n\r" );
		strcat( buf4, "The master of deceit,\n\r" );
		strcat( buf4, "Could not be any worse than,\n\r" );
		strcat( buf4, "becoming bloodsworn meat;\n\r\n\r" );
		strcat( buf4, "So he denied Ba'alzamon,\n\r" );
		strcat( buf4, "The Creator blessed his choice,\n\r" );
		strcat( buf4, "Forever was his wisdom,\n\r" );
		strcat( buf4, "Given perfect voice;\n\r\n\r" );
		strcat( buf4, "And now as bitter wind blows,\n\r" );
		strcat( buf4, "Across this barren land,\n\r" );
		strcat( buf4, "A message comes forever,\n\r" );
		strcat( buf4, "By this hero's own hand;\n\r\n\r" );
		strcat( buf5, "'Strength marks the wise man,\n\r" );
		strcat( buf5, "Strength names him true,\n\r" );
		strcat( buf5, "Why is strength in wisdom?\n\r" );
		strcat( buf5, "This I tell to you;\n\r\n\r" );
		strcat( buf5, "In wise choice lies power,\n\r" );
		strcat( buf5, "For Darkness lies with fools,\n\r" );
		strcat( buf5, "So long as their is wisdom,\n\r" );
		strcat( buf5, "The Creator always rules.'\n\r\n\r" );
		strcat( buf5, "Strength marks the wise man,\n\r" );
		strcat( buf5, "Strength names him true,\n\r" );
		strcat( buf5, "With wisdom and honour,\n\r" );
		strcat( buf5, "The hero flares in you;\n\r\n\r" );
		strcat( buf5, "Strength marks the wise man,\n\r" );
		strcat( buf5, "Strength against the strife,\n\r" );
		strcat( buf5, "To follow one who rules the dead,\n\r" );
		strcat( buf5, "Or he who champions life!	\n\r\n\r" );
		sing_song( ch, buf );
		WAIT_STATE( ch, 15 );
		wait_act( 3, buf2, ch, NULL, NULL, TO_ROOM );
		wait_act( 3, buf2, ch, NULL, NULL, TO_CHAR );
		wait_act( 6, buf3, ch, NULL, NULL, TO_ROOM );
		wait_act( 6, buf3, ch, NULL, NULL, TO_CHAR );
		wait_act( 12, buf4, ch, NULL, NULL, TO_ROOM );
		wait_act( 12, buf4, ch, NULL, NULL, TO_CHAR );
		wait_act( 15, buf5, ch, NULL, NULL, TO_ROOM );
		wait_act( 15, buf5, ch, NULL, NULL, TO_CHAR );
		ch->stam -= minMana;
		return;
	}
}

void do_play(CHAR_DATA *ch, char *argument)
{
    OBJ_DATA *instrument;
    CHAR_DATA *victim;
    char arg[MAX_INPUT_LENGTH];
    char *play_affect = str_dup("none");
    char arg1[MIL];
    int difficulty = 0, play_type = 1, manaCost = 50, bonus = 0;
    bool botched = FALSE, will_affect = FALSE;
    AFFECT_DATA af;

    if ( IS_NPC( ch ) )
    return;

	if ( ch->clan != clan_lookup( "gleeman" ) )
	{
		stc( "You are not a gleeman.\n\r", ch );
		return;
	}
    	
    	if ( ch->in_room != NULL )
	{
		if ( ch->in_room->vnum == 3001 )
		{
			stc( "Use a room other than the Oval Plaza.\n\r", ch );
			return;
		}
	}

	argument = one_argument( argument, arg );
	argument = one_argument( argument, arg1 );

	if ( ch->pcdata->learned[gsn_instrument] > 0 )
		bonus = ch->pcdata->learned[gsn_instrument] / 10;

	if ( ( instrument = get_obj_carry( ch, arg, ch ) ) != NULL )
	{
		if ( arg1[0] == '\0' )
		{
			stc("Play instrument how? <slow|steady|brisk|fast|merry>\n\r" , ch );
			return;
		}
		if ( !str_prefix( arg1, "slow" ) )
		{
			play_type = 1;
			play_affect = str_dup("Soothing Rest");
			difficulty += 25;
		}
		else if ( !str_prefix( arg1, "steady" ) )
		{
			play_type = 2;
			play_affect = str_dup("Peace of Mind");
			difficulty += 50;
		}
		else if ( !str_prefix( arg1, "brisk" ) )
		{
			play_type = 3;
			play_affect = str_dup("Inspiration");
			difficulty += 75;
		}
		else if ( !str_prefix( arg1, "fast" ) )
		{
			play_type = 4;
			play_affect = str_dup("Courage");
			difficulty += 100;
		}
		else if ( !str_prefix( arg1, "merry") )
		{
			play_type = 5;
			play_affect = str_dup("Merriment");
			difficulty += 75;
		}
		else
		{
			stc("Play instrument how? <slow|steady|brisk|fast|merry>\n\r" , ch );
			return;
		}


		if ( ch->stam < manaCost )
		{
			stc("You're too tired right now. Rest for a bit.\n\r",ch);
			return;
		}

		ch->stam -= manaCost;

		if ( ch->clan == clan_lookup("gleeman") )
		{
			difficulty -= 10;
		}

		if ( instrument->item_type == ITEM_WIND_PIPES )
		{
			difficulty -= UMAX( 1, ( (get_curr_stat(ch,STAT_REF)/3)
			               +(get_curr_stat(ch,STAT_CHA)/3)
			               +(get_curr_stat(ch,STAT_DEX)/3) ) );
			difficulty += 20;
			difficulty -= bonus;
			if ( number_percent() < difficulty )
				botched = TRUE;
			if ( play_type == 1 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a slow rhythm on  $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 2 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a slow steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 3 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps $s foot as $e plays a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 4 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 5 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a merry tune on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}

		}
		else if ( instrument->item_type == ITEM_WIND_FLUTE )
		{
			difficulty -= UMAX( 1, ( (get_curr_stat(ch,STAT_REF)/3)
			               +(get_curr_stat(ch,STAT_CHA)/3)
			               +(get_curr_stat(ch,STAT_DEX)/3) ) );
			difficulty += 30;
			difficulty -= bonus;
			if ( number_percent() < difficulty )
				botched = TRUE;
			if ( play_type == 1 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a slow rhythm on  $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 2 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a slow steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 3 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps $s foot as $e plays a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 4 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 5 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you play $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to play a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You play a merry tune on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n plays a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}

		}
		else if ( instrument->item_type == ITEM_STRINGED_BITTERN )
		{
			difficulty -= UMAX( 1, ( (get_curr_stat(ch,STAT_REF)/3)
			               +(get_curr_stat(ch,STAT_CHA)/3)
			               +(get_curr_stat(ch,STAT_DEX)/3) ) );
			difficulty += 50;
			difficulty -= bonus;
			if ( number_percent() < difficulty )
				botched = TRUE;
			if ( play_type == 1 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you strum $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to strum a slow rhythm on  $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You strum a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n strums a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 2 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you strum $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to strum a slow steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You strum a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n strums a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 3 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you strum $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to strum a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You strum a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps $s foot as $e strums a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 4 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you strum $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to strum a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You strum a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n strums a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 5 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you strum $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to strum a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You strum a merry tune on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n strums a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}

		}
		else if ( instrument->item_type == ITEM_PERCUSSION_DRUMS )
		{
			difficulty -= UMAX( 1, ( (get_curr_stat(ch,STAT_REF)/3)
			               +(get_curr_stat(ch,STAT_CHA)/3)
			               +(get_curr_stat(ch,STAT_DEX)/3) ) );
			difficulty += 25;
			difficulty -= bonus;
			if ( number_percent() < difficulty )
				botched = TRUE;
			if ( play_type == 1 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you tap $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to tap a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You tap a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps a slow rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 2 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you tap $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to tap a slow steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You tap a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps a steady rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 3 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you tap $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to tap a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You tap a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n stamps $s foot as $e tap a brisk rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 4 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you tap $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to tap a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You tap a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps a fast rhythm on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}
			else if ( play_type == 5 )
			{
				if ( botched == TRUE )
				{
				act("You miss a note as you tap $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n misses a note as $e tries to tap a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				return;
				}
				else
				{
				act("You tap a merry tune on $T.",ch,NULL,instrument->short_descr,TO_CHAR);
				act("$n taps a merry tune on $T.",ch,NULL,instrument->short_descr,TO_ROOM);
				}
			}

		}
		if ( !str_cmp( play_affect, "none" ) )
		{
		return;
		}
		if ( !str_cmp( play_affect, "Soothing Rest" ) && ch->clan == clan_lookup( "gleeman" ) )
		{
			for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
			{
		        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
        		    continue;
				/*if ( victim->hit >= 25000 || victim->mana >= 25000 )
					continue;*/
				if ( victim->hit < get_maxhit(victim) )
				{
					victim->hit += UMIN( get_curr_stat(ch, STAT_CHA) + bonus * 3, get_maxhit(victim) );
					act("$n relaxes and looks more restful.",victim,NULL,NULL,TO_ROOM);
					act("You relax and feel more restful.",victim,NULL,NULL,TO_CHAR);
				}
			}
		}
		if ( !str_cmp( play_affect, "Peace of Mind" ) && ch->clan == clan_lookup( "gleeman" ) )
		{
			for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
			{
		        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
        		    continue;

				if ( victim->stam < get_maxstam(victim))
				{
					victim->stam += UMIN( get_curr_stat(ch, STAT_CHA) + bonus * 3, get_maxstam(victim) );
					act("$n relaxes and looks more at ease with $mself.",victim,NULL,NULL,TO_ROOM);
					act("You relax and feel more at ease with yourself.",victim,NULL,NULL,TO_CHAR);
				}
			}
		}
		if ( !str_cmp( play_affect, "Inspiration" ) && ch->clan == clan_lookup( "gleeman" ) )
		{
			for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
			{
		        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
        		    continue;
        		if ( IS_AFFECTED2( victim, AFF_MUSIC_INSPIRATION ) )
        			continue;
        		if ( is_affected( victim, gsn_music_inspiration ) )
        			continue;
        		will_affect = TRUE;
			    af.where	 = TO_AFFECTS2;
			    af.type      = gsn_music_inspiration;
			    af.level	 = ch->level/2;
			    af.duration  = (ch->level / 10) + bonus;
			    af.modifier  = (ch->level / 10) + bonus;
			    af.location  = APPLY_STR;
			    af.bitvector = AFF_MUSIC_INSPIRATION;
			    affect_to_char( victim, &af );
			    if ( will_affect == TRUE )
			    {
				act("$n looks inspired by $N's music!",victim,NULL,ch,TO_ROOM);
				act("You feel inspired by $N's music!",victim,NULL,ch,TO_CHAR);
				}
			}
		}
		if ( !str_cmp( play_affect, "Courage" ) && ch->clan == clan_lookup( "gleeman" ) )
		{
			for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
			{
		        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
        		    continue;
        		if ( IS_AFFECTED2( victim, AFF_MUSIC_COURAGE ) )
        			continue;
        		if ( is_affected( victim, gsn_music_courage ) )
        			continue;
        		will_affect = TRUE;
			    af.where	 = TO_AFFECTS2;
			    af.type      = gsn_music_courage;
			    af.level	 = ch->level/2;
			    af.duration  = (ch->level / 10) + bonus;
			    af.modifier  = (ch->level / 10) + bonus;
			    af.location  = APPLY_HITROLL;
			    af.bitvector = AFF_MUSIC_COURAGE;
			    affect_to_char( victim, &af );
			    af.location  = APPLY_DAMROLL;
			    affect_to_char( victim, &af );
			    if ( will_affect == TRUE )
			    {
				act("$n looks encouraged by $N's music!",victim,NULL,ch,TO_ROOM);
				act("You feel encouraged by $N's music!",victim,NULL,ch,TO_CHAR);
				}
			}
		}
		if ( !str_cmp( play_affect, "Merriment" ) && ch->clan == clan_lookup( "gleeman" ) )
		{
			for ( victim = ch->in_room->people; victim != NULL; victim = victim->next_in_room )
			{
		        if ( victim->desc == NULL || victim == ch || IS_NPC(victim) )
        		    continue;
        		if ( IS_AFFECTED2( victim, AFF_SPEED ) )
        			continue;
        		if ( is_affected( victim, gsn_music_merriment ) )
        			continue;
        		will_affect = TRUE;
			    af.where	 = TO_AFFECTS2;
			    af.type      = skill_lookup("merriment");
			    af.level	 = ch->level/2;
			    af.duration  = (ch->level / 10) + bonus;
			    af.modifier  = (ch->level / 10) + bonus;
			    af.location  = APPLY_DEX;
			    af.bitvector = AFF_SPEED;
			    affect_to_char( victim, &af );
			    if ( will_affect == TRUE )
			    {
				act("$n dances to $N's music!",victim,NULL,ch,TO_ROOM);
				act("You dance to $N's music!",victim,NULL,ch,TO_CHAR);
				}
			}
		}
	}
	else if (arg[0] != '\0')
	{
		stc("You don't have that instrument.\n\r", ch);
		return;
	}
	else
	{
		stc("Play instrument how? <slow|steady|brisk|fast|merry>\n\r" , ch );
		return;
	}

	WAIT_STATE( ch, PULSE_VIOLENCE / 2 );
	return;
}
