/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "aww.h"
#include "magic.h"

void do_heal(CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *mob;
    char arg[MAX_INPUT_LENGTH];
    int cost,sn,type;
    SPELL_FUN *spell;
    char *words;

    /* check for healer */
    for ( mob = ch->in_room->people; mob; mob = mob->next_in_room )
    {
        if ( IS_NPC(mob) && IS_SET(mob->act, ACT_IS_HEALER) )
            break;
    }

    if ( mob == NULL )
    {
        stc( "{cYou can't do that here.\n\r", ch );
        return;
    }

    one_argument(argument,arg);
    type = 0;

    if (arg[0] == '\0')
    {
        /* display price list */
	act("{c$N says {C'{cI offer the following services:{C'",ch,NULL,mob,TO_CHAR);
	stc( "{c  relieve light wounds    {w10  silver pennies{c\n\r",ch);
	stc( "{c  relieve serious wounds  {w50  silver pennies{c\n\r",ch);
	stc( "{c  relieve critical wounds {w100 silver pennies{c\n\r",ch);
	stc( "{c  major healing           {w500 silver pennies{c\n\r",ch);
	stc( "{c  relieve blindness       {w200 silver pennies{c\n\r",ch);
	stc( "{c  treat disease           {w200 silver pennies{c\n\r",ch);
	stc( "{c  treat poison            {w200 silver pennies{c\n\r",ch);
	stc( "{c  remove curse            {w999 silver pennies{c\n\r",ch);
	stc( "{c  refresh mana            {w250 silver pennies{c\n\r",ch);
    stc( "{c  everything              {w999  silver marks{x\n\r",ch);
	stc( "{c Type heal <type> to be healed.\n\r",ch);
	return;
    }

    if (!str_prefix(arg,"light"))
    {
        spell = weave_cure_light;
		sn    = skill_lookup("cure light");
		words = "herb packet";
		cost  = 100;
    }

    else if (!str_prefix(arg,"serious"))
    {
	spell = weave_cure_serious;
	sn    = skill_lookup("cure serious");
	words = "herb packet";
	cost  = 500;
    }

    else if (!str_prefix(arg,"critical"))
    {
	spell = weave_cure_critical;
	sn    = skill_lookup("cure critical");
	words = "herb poultice";
	cost  = 1000;
    }

    else if (!str_prefix(arg,"major"))
    {
	spell = weave_heal;
	sn = skill_lookup("heal");
	words = "herbal tea, bandages, and poultice";
	cost  = 5000;
    }

    else if (!str_prefix(arg,"blindness"))
    {
	spell = weave_cure_blinding;
	sn    = skill_lookup("cure blindness");
    words = "herbal tea";
    cost  = 2000;
    }

    else if (!str_prefix(arg,"disease"))
    {
	spell = weave_cure_disease;
	sn    = skill_lookup("cure disease");
	words = "herbal tea";
	cost = 2000;
    }

    else if (!str_prefix(arg,"poison"))
    {
	spell = weave_cure_poison;
	sn    = skill_lookup("cure poison");
	words = "herbal tea";
	cost  = 2000;
    }

    else if (!str_prefix(arg,"uncurse") || !str_prefix(arg,"curse") || !str_prefix(arg,"remove curse"))
    {
	spell = weave_remove_curse;
	sn    = skill_lookup("remove curse");
	words = "Oath to the Creator";
	cost  = 9990;
    }

    else if (!str_prefix(arg,"mana") || !str_prefix(arg,"energize"))
    {
        spell = NULL;
        sn = -1;
        words = "herbal tea";
        cost = 2500;
    }

    else if ( !str_prefix(arg,"everything") || !str_cmp(arg,"all" ) )
    {
    	spell = NULL;
    	sn = -1;
        type = 1;
        words = "effervescent elixir";
        cost = 99900;
    }

    else
    {
	act("{C$N says '{cType 'heal' for a list of remedies.{C'{c",
	    ch,NULL,mob,TO_CHAR);
	return;
    }

    if ( !check_coins( ch, cost,0,0 ) )
    {
	act("{C$N says '{cYou do not have enough gold for my services.{C'{c",
	    ch,NULL,mob,TO_CHAR);
	return;
    }

    WAIT_STATE(ch,PULSE_VIOLENCE);

    deduct_cost(ch,cost,0);
    act("{c$n fixes up an $T.",mob,NULL,words,TO_ROOM);

    if ( type == 1 )
    {
        affect_strip(ch,gsn_plague);
        affect_strip(ch,gsn_poison);
        affect_strip(ch,gsn_blindness);
        affect_strip(ch,gsn_sleep);
        affect_strip(ch,gsn_curse);
        ch->hit = get_maxhit(ch);
        ch->stam = get_maxstam(ch);
        update_pos( ch );
        return;
    }

    if (spell == NULL)  /* restore mana trap...kinda hackish */
    {
	ch->stam += dice(2,8) + mob->level / 2;
	ch->stam = UMIN(ch->stam,get_maxstam(ch));
	stc( "{cA warm feeling passes through your body.\n\r",ch);
	return;
    }

    if (sn == -1)
	return;

    spell(sn,mob->level,mob,ch,TARGET_CHAR);
}
