/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "tables.h"
#include "olc.h"
#include "recycle.h"
#include "lookup.h"
#include "interp.h"
#include "mysql5_interface.h"

int find_home (CHAR_DATA *ch)
{
        MYSQL_RES *result;
        MYSQL_ROW row;
        char sql_buf[MSL];

        sprintf(sql_buf, "select id from char_homes where name = '%s'", ch->name);
        result = query_db(sql_buf, result_db, FALSE);
        if (result == NULL)     return -1;
        row = mysql_fetch_row(result);

        if (row == NULL || row[0] == NULL)
                return -1;

	mysql_free_result(result);

        return atoi(row[0]);
}

int find_hrecall (CHAR_DATA *ch)
{
        MYSQL_RES *result;
        MYSQL_ROW row;
        char sql_buf[MSL];

        sprintf(sql_buf, "select vnum from char_homes where name = '%s'", ch->name);
        result = query_db(sql_buf, result_db, FALSE);
        if (result == NULL)     return -1;
        row = mysql_fetch_row(result);

        if (row == NULL || row[0] == NULL)
                return -1;

	mysql_free_result(result);

        return atoi(row[0]);
}

int home_location (CHAR_DATA *ch)
{
        MYSQL_RES *result;
        MYSQL_ROW row;
        char sql_buf[MSL];

        sprintf(sql_buf, "select location from char_homes where name = '%s'", ch->name);
        result = query_db(sql_buf, result_db, FALSE);
        if (result == NULL)     return -1;
        row = mysql_fetch_row(result);

        if (row == NULL || row[0] == NULL)
                return -1;

	mysql_free_result(result);

        return atoi(row[0]);
}


void hrecall( CHAR_DATA *ch )
{
	char buf[MAX_STRING_LENGTH];
	CHAR_DATA *victim;
	DESCRIPTOR_DATA *d_mentor;
	ROOM_INDEX_DATA *location;

	if (IS_NPC(ch) && !IS_SET(ch->act,ACT_PET) && !ch->mount )
	{
		stc("Only players can recall.\n\r",ch);
		return;
	}
	if ( ch->pcdata->in_vault )
	{
		do_function( ch, &do_locker, "close" );
	}

	if ( ch->pcdata->in_vault )
	{
		stc( "You can't recall here. Type vault close to leave.\n\r",ch);
		return;
	}

	if ( ch->pcdata && ch->pcdata->allowed == 0 )
	{
		stc( "{GYou are not allowed to leave the school until a Staff member\n\r",ch);
		stc( "has granted you access to the game. You should be approached\n\r",ch);
		stc( "soon by a Mentor. If you are not approached within an hour or\n\r",ch);
		stc( "two, you may ask over OOC, or by sending a Note to Staff.{x\n\r",ch);
		for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
		{
			if ( d_mentor->connected == CON_PLAYING && IS_SET( d_mentor->character->spec_flags,SPEC_MENTOR ) )
			{
				act("{w({GMentor Alert{w){W::{x {G$N needs verification!{x", d_mentor->character,NULL,ch,TO_CHAR);
			}
		}
		return;
	}
	if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
	{
		stc("Not from a war.\n\r",ch);
		return;
	}
	if (IS_SET (ch->pcdata->tag_flags, TAG_PLAYING | TAG_WAITING))
	{
		stc("Wait till the tag game is over.\n\r", ch);
		return;
	}

	act( "{c$n beseeches transportation and receives it.{c",ch, 0,0,TO_ROOM);
	ptc( ch, "{cYou beseech the %s for aid!{x\n\r", is_shadow(ch) ? "{RGreat Lord{c" : "{wCreator{c");

	if ( ( location = get_room_index( find_hrecall(ch) ) ) == NULL )
	{
		stc( "{cYou are completely lost.\n\r", ch );
		return;
	}

	if ( ch->in_room == location )
	{
		stc("{cBut you're already there!\n\r",ch);
		return;
	}

	if ( IS_SET(ch->in_room->room_flags, ROOM_NO_RECALL) || IS_AFFECTED(ch, AFF_CURSE))
	{
		ptc( ch, "{cThe %s has forsaken you!{x\n\r", is_shadow(ch) ? "{RGreat Lord{c" : "{wCreator{c");
		return;
	}

	if (is_fighting(ch) && ( victim = ch->advancing_on ) != NULL )
	{
		int lose;

		if ( number_percent() > 60 )
		{
			WAIT_STATE( ch, 4 );
			sprintf( buf, "{cYou failed!.\n\r");
			stc( buf, ch );
			return;
		}

		lose = (ch->desc != NULL) ? 25 : 50;
		gain_exp( ch, 0 - lose );
		sprintf( buf, "{cYou recall from combat!  You lose %d exps.\n\r{c", lose );
		stc( buf, ch );
		stop_all_fighting( ch);
	}

	act( "{c$n disappears.", ch, NULL, NULL, TO_ROOM );
	char_from_room( ch );
	char_to_room( ch, location );
	if( MOUNTED(ch) )
	{
		char_from_room( MOUNTED(ch) );
		char_to_room( MOUNTED(ch), location );
	}
	act( "$n stumbles into the room, trembling from some horrible experience.", ch, NULL, NULL, TO_ROOM );
	do_look( ch, "auto" );
	stc("You stumble into the room, exhausted from your trip through {wTel'aran'rhiod{c.\n\r",ch);

	if (ch->pet != NULL)
	{
		char_from_room( ch->pet );
		char_to_room( ch->pet, location );
	}
	return;
}

void clear_links args((ROOM_INDEX_DATA *room));
ROOM_INDEX_DATA *create_room args((AREA_DATA *area, int vnum));
void save_area args((AREA_DATA *area));
bool has_exits args((ROOM_INDEX_DATA *pRoom));
void link_rooms args((ROOM_INDEX_DATA *orig_room, ROOM_INDEX_DATA *to_room, int dir));

void clean_home (CHAR_DATA *ch)
{
	int vnum, i;
	ROOM_INDEX_DATA *room;

	vnum = find_hrecall(ch);

	for (i = vnum; i <= vnum + 4; i++)
	{
		room = get_room_index(i);

		if (room == NULL)
			room = create_room(get_vnum_area(vnum), i);

		SET_BIT(room->room_flags, ROOM_HOME);
		SET_BIT(room->room_flags, ROOM_SAFE);
		SET_BIT(room->room_flags, ROOM_PRIVATE);

		free_string(room->name);
		room->name = str_dup("A Small House");

		free_string(room->owner);
		room->owner = str_dup(ch->name);

		clear_links(room);
	}

        get_room_index(vnum)->exit[DIR_SOUTH] = new_exit();
        get_room_index(vnum)->exit[DIR_SOUTH]->u1.to_room = get_room_index(home_location(ch));;
        get_room_index(vnum)->exit[DIR_SOUTH]->orig_door = DIR_SOUTH;

	save_area(get_vnum_area(vnum));
	return;
}

void setup_homes()
{
	char buf[MSL];
	int i;

	for (i = 38000; i <= 39995; i += 5)
	{
		sprintf(buf, "insert into char_homes values ('', 'none', %d, -1, 1)", i);
		mysql_real_query(result_db, buf, strlen(buf));
	}
	
	return;
}

bool buy_home (CHAR_DATA *ch)
{
	char buf[MSL];

	sprintf(buf, "update char_homes set name='%s', location=%ld where name = 'none' order by vnum asc limit 1", ch->name, ch->in_room->vnum);
	mysql_real_query(result_db, buf, strlen(buf));

	if (mysql_affected_rows(result_db) < 1)
	{
		stc("There are no more houses for sale! Please let an immortal know.\n\r", ch);
		return FALSE;
	}

	clean_home(ch);
	return TRUE;
}

int next_home_room (CHAR_DATA *ch)
{
	ROOM_INDEX_DATA *room;
	int vnum = find_hrecall(ch);
	int i;
	
	for (i = vnum+1; i <= vnum + 4; i++)
	{
		room = get_room_index(i);
		if (has_exits(room))	continue;

		return i;
	}

	return -1;
}


void home_describe ( CHAR_DATA *ch )
{
	ROOM_INDEX_DATA *loc;

	loc = ch->in_room;

	stc("This command allows you to describe your home.\n\r",ch);
	stc("You should not describe items that are in the room,\n\r",ch);
	stc("rather allowing the furnishing of the home to do that.\n\r",ch);
	stc("If you currently own this room, you will be placed into.\n\r",ch);
	stc("the room editor. Be warned that while in the room editor,\n\r",ch);
	stc("you are only allowed to type the description. If you are\n\r",ch);
	stc("unsure or hesitant about this, please note the Immortals,\n\r",ch);
	stc("or better, discuss the how-to's with a Builder.\n\r",ch);
	stc("Syntax: Home (describe)\n\r",ch);
    	string_append( ch, &loc->description );
	return;
}

void home_toggle_lock (CHAR_DATA *ch, int dir)
{
	ROOM_INDEX_DATA *room, *to_room;
	EXIT_DATA *exit;
	int revdir = rev_dir[dir];

	room = ch->in_room;
	if (!room)	return;

	exit = room->exit[dir];
	if (!exit)
	{
		stc("There is no door to lock in that direction.\n\r", ch);
		return;
	}

	to_room = exit->u1.to_room;
	
	if (to_room == NULL || !IS_SET(exit->exit_info, EX_ISDOOR))
	{
		stc("There is no door to lock in that direction.\n\r", ch);
		return;
	}

	TOGGLE_BIT(exit->exit_info, EX_LOCKED);

	if (to_room->area == room->area && to_room->exit[revdir] != NULL)
		TOGGLE_BIT(to_room->exit[revdir]->exit_info, EX_LOCKED);

	if (IS_SET(exit->exit_info, EX_LOCKED))
	{
		SET_BIT(exit->exit_info, EX_CLOSED);

		printf_to_char(ch, "You have added a lock to the %s door.\n\r", dir_name[dir]);
		exit->key = find_hrecall(ch);

		if (to_room->area == room->area && to_room->exit[revdir] != NULL)
		{
			to_room->exit[revdir]->key = find_hrecall(ch);
			SET_BIT(to_room->exit[revdir]->exit_info, EX_CLOSED);
		}
	}
	else
	{
		printf_to_char(ch, "The lock on the door to the %s has been removed.\n\r", dir_name[dir]);
		exit->key = 0;

		if (to_room->area == room->area && to_room->exit[revdir] != NULL)
			to_room->exit[revdir]->key = 0;
	}

	return;
}

void home_toggle_door (CHAR_DATA *ch, int dir)
{
	ROOM_INDEX_DATA *room, *to_room;
	EXIT_DATA *exit;
	int revdir = rev_dir[dir];

	room = ch->in_room;
	if (!room)	return;

	exit = room->exit[dir];
	if (!exit)
	{
		stc("You cannot place a door in that direction.\n\r", ch);
		return;
	}

	to_room = exit->u1.to_room;

	TOGGLE_BIT(exit->exit_info, EX_ISDOOR);

	if (to_room->area == room->area && to_room->exit[revdir] != NULL)
		TOGGLE_BIT(to_room->exit[revdir]->exit_info, EX_ISDOOR);
	
	if (IS_SET(exit->exit_info, EX_ISDOOR))
	{
		printf_to_char(ch, "You have added a door to the %s exit.\n\r", dir_name[dir]);
		SET_BIT(exit->exit_info, EX_CLOSED);

		if (to_room->area == room->area && to_room->exit[revdir] != NULL)
			SET_BIT(to_room->exit[revdir]->exit_info, EX_CLOSED);
	}
	else
	{
		printf_to_char(ch, "The door to the %s has been removed.\n\r", dir_name[dir]);
		REMOVE_BIT(exit->exit_info, EX_CLOSED);

		if (to_room->area == room->area && to_room->exit[revdir] != NULL)
			REMOVE_BIT(to_room->exit[revdir]->exit_info, EX_CLOSED);
	}

	return;
}


void do_home (CHAR_DATA *ch, char *argument)
{
	int home;
	char arg1[MIL], arg2[MIL];
	char buf[MSL];
	int vnum, door, iHash;
	OBJ_DATA *obj;
	OBJ_INDEX_DATA *pObj;

	argument = one_argument(argument, arg1);
	home = find_home(ch);

//	setup_home();

	if (arg1[0] == '\0')
	{
		if (home > 0)
		{
			stc("Syntax:\n\r", ch);
			stc(" home <buy/recall/expand/reset/name/desc>\n\r", ch);
			stc("  buy            Used to buy items for your home.\n\r", ch);
			stc("  recall         Transports you to your home instantly.\n\r", ch);
			stc("  expand <dir>   Makes a room in the direction specified. (500 gold)\n\r", ch);
			stc("  door <dir>     Toggles the door flag on and off for an exit. (50 gold)\n\r", ch);
			stc("  lock <dir>     Toggles the locked flag on and off for an exit. (50 gold)\n\r", ch);
			stc("  key            Load a key that works for your locked doors. (50 gold)\n\r", ch);
			stc("  reset          Completely resets your house back to one room. {RNON-REFUNDABLE{x\n\r", ch);
			stc("  name <name>    Sets the name of the current room you are standing in.\n\r", ch);
			stc("  desc           Sets the description of the room you are in.\n\r", ch);
//			stc("\n\r  freeze         Freezes the room, making all current items on the ground unable to be picked up.\n\r", ch);
//			stc("\n\r  guest <names>  Allows you to make a guest list for your home. Players on your guest list\n\r"
//				"                 will be able to see your home and enter it. Please read '/t<send 'help homesecurity'>help HOMESECURITY/t</send>'.\n\r", ch);

			/* Show proper syntax for customizing your home */
			return;
		}

		if (!IS_SET(ch->in_room->room_flags, ROOM_BUILDHOME))
		{
			stc("If you want to buy a home, you need to find a suitable place to build it.\n\r", ch);
			stc(" {Y* {xThese areas are marked with an '{YH{x' on the map and are typically\n\r", ch);
			stc("   {xfound in guild halls, cities, and towns.\n\r", ch);
			return;
		}

		stc("Building a house here will cost you 2,000 gold coins. If you would like to build\n\r", ch);
		stc("here, type 'home buy'.\n\r", ch);
		return;
	}

	if (!str_cmp(arg1, "buy"))
	{
		argument = one_argument(argument, arg2);

		if (home > 0)
		{
			stc("This would normally be showing you stuff that you could buy for your house.\n\r", ch);
			/* Show stuff that you can buy for your home */
			return;
		}

		if (!IS_SET(ch->in_room->room_flags, ROOM_BUILDHOME))
		{
			stc("If you want to buy a home, you need to find a suitable place to build it.\n\r", ch);
			stc(" {Y* {xThese areas are marked with an '{YH{x' on the map and are typically\n\r", ch);
			stc("   {xfound in guild halls, cities, and towns.\n\r", ch);
			return;
		}

		if (!check_coins(ch, 2000000, 0, 0))
		{
			stc("You don't have the 2,000 gold it costs to buy a home.", ch);
			return;
		}

		deduct_cost(ch, 2000000, 0);

		if (buy_home(ch))
		{
			stc("You have purchased your house.\n\r", ch);
			stc("You can now type 'hrecall' or 'home recall' to go there at any time.\n\r", ch);
		}
		else
		{
			stc("Something went wrong.\n\r", ch);
			deduct_cost(ch, -2000000, 0);
		}

		return;
	}

	if (home <= 0)
	{
		do_home(ch, "");
		return;
	}

	if (!str_cmp(arg1, "expand"))
	{
		argument = one_argument(argument, arg2);

		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		if (arg2[0] == '\0')
		{
			stc("Syntax: home expand <direction>\n\r", ch);
			stc("Expansions cost 500 gold each.\n\r", ch);
			return;
		}

		if (!str_cmp(arg2, "n") || !str_cmp(arg2, "north")) door = 0;
		else if (!str_cmp(arg2, "e") || !str_cmp(arg2, "east"))  door = 1;
		else if (!str_cmp(arg2, "s") || !str_cmp(arg2, "south")) door = 2;
		else if (!str_cmp(arg2, "w") || !str_cmp(arg2, "west"))  door = 3;
		else if (!str_cmp(arg2, "u") || !str_cmp(arg2, "up" ))   door = 4;
		else if (!str_cmp(arg2, "d") || !str_cmp(arg2, "down"))  door = 5;
		else if (!str_cmp(arg2, "ne") || !str_cmp(arg2, "northeast"))  door = 6;
		else if (!str_cmp(arg2, "se") || !str_cmp(arg2, "southeast"))  door = 7;
		else if (!str_cmp(arg2, "sw") || !str_cmp(arg2, "southwest"))  door = 8;
		else if (!str_cmp(arg2, "nw") || !str_cmp(arg2, "northwest"))  door = 9;
		else
		{
			do_home(ch, "expand");
			return;
		}

		if (ch->in_room->exit[door] != NULL)
		{
			stc("You can't build in that direction.\n\r", ch);
			return;
		}

		vnum = next_home_room(ch);

		if (vnum > 0)
		{
			if (!check_coins(ch, 500000, 0, 0))
			{
				stc("You don't have the 500 gold it costs to expand your home.\n\r", ch);
				return;
			}

			deduct_cost(ch, 500000, 0);

			link_rooms(ch->in_room, get_room_index(vnum), door);
			save_area(get_vnum_area(vnum));
			stc("You have expanded your home.\n\r", ch);
		}
		else
		{
			stc("{RYou've reached the maximum rooms allowed.{x\n\r", ch);
			do_home(ch, "expand");
		}

		return;		
	}


	if (!str_cmp(arg1, "door"))
	{
		argument = one_argument(argument, arg2);

		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		if (arg2[0] == '\0')
		{
			stc("Syntax: home door <direction>\n\r", ch);
			stc("Toggling a door on or off will cost you 50 gold.\n\r", ch);
			return;
		}

		if (!str_cmp(arg2, "n") || !str_cmp(arg2, "north")) door = 0;
		else if (!str_cmp(arg2, "e") || !str_cmp(arg2, "east"))  door = 1;
		else if (!str_cmp(arg2, "s") || !str_cmp(arg2, "south")) door = 2;
		else if (!str_cmp(arg2, "w") || !str_cmp(arg2, "west"))  door = 3;
		else if (!str_cmp(arg2, "u") || !str_cmp(arg2, "up" ))   door = 4;
		else if (!str_cmp(arg2, "d") || !str_cmp(arg2, "down"))  door = 5;
		else if (!str_cmp(arg2, "ne") || !str_cmp(arg2, "northeast"))  door = 6;
		else if (!str_cmp(arg2, "se") || !str_cmp(arg2, "southeast"))  door = 7;
		else if (!str_cmp(arg2, "sw") || !str_cmp(arg2, "southwest"))  door = 8;
		else if (!str_cmp(arg2, "nw") || !str_cmp(arg2, "northwest"))  door = 9;
		else
		{
			do_home(ch, "door");
			return;
		}

		if (ch->in_room->exit[door] == NULL)
		{
			stc("You can't build a door in that direction.\n\r", ch);
			return;
		}

		if (!check_coins(ch, 50000, 0, 0))
		{
			stc("You don't have the 50 gold required.\n\r", ch);
			return;
		}

		deduct_cost(ch, 50000, 0);
		home_toggle_door(ch, door);
		save_area(get_vnum_area(ch->in_room->vnum));
		return;		
	}

	if (!str_cmp(arg1, "lock"))
	{
		argument = one_argument(argument, arg2);

		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		if (arg2[0] == '\0')
		{
			stc("Syntax: home lock <direction>\n\r", ch);
			stc("Toggling a lock on or off will cost you 50 gold.\n\r", ch);
			return;
		}

		if (!str_cmp(arg2, "n") || !str_cmp(arg2, "north")) door = 0;
		else if (!str_cmp(arg2, "e") || !str_cmp(arg2, "east"))  door = 1;
		else if (!str_cmp(arg2, "s") || !str_cmp(arg2, "south")) door = 2;
		else if (!str_cmp(arg2, "w") || !str_cmp(arg2, "west"))  door = 3;
		else if (!str_cmp(arg2, "u") || !str_cmp(arg2, "up" ))   door = 4;
		else if (!str_cmp(arg2, "d") || !str_cmp(arg2, "down"))  door = 5;
		else if (!str_cmp(arg2, "ne") || !str_cmp(arg2, "northeast"))  door = 6;
		else if (!str_cmp(arg2, "se") || !str_cmp(arg2, "southeast"))  door = 7;
		else if (!str_cmp(arg2, "sw") || !str_cmp(arg2, "southwest"))  door = 8;
		else if (!str_cmp(arg2, "nw") || !str_cmp(arg2, "northwest"))  door = 9;
		else
		{
			do_home(ch, "door");
			return;
		}

		if (ch->in_room->exit[door] == NULL)
		{
			stc("There is no door to lock in that direction.\n\r", ch);
			return;
		}

		if (!check_coins(ch, 50000, 0, 0))
		{
			stc("You don't have the 50 gold required.\n\r", ch);
			return;
		}

		deduct_cost(ch, 50000, 0);
		home_toggle_lock(ch, door);
		save_area(get_vnum_area(ch->in_room->vnum));
		return;		
	}

	if (!str_cmp(arg1, "key"))
	{
		if (!check_coins(ch, 50000, 0, 0))
		{
			stc("You don't have the 50 gold required.\n\r", ch);
			return;
		}

		deduct_cost(ch, 50000, 0);

		vnum = find_hrecall(ch);

		if (get_obj_index(vnum) == NULL)	// Make it
		{
			pObj                        = new_obj_index();
			pObj->vnum                  = vnum;
			pObj->area                  = get_room_index(vnum)->area;
			pObj->material		    = str_dup("steel");
			if ( vnum > top_vnum_obj ) top_vnum_obj = vnum;
			iHash                       = vnum % MAX_KEY_HASH;
			pObj->next                  = obj_index_hash[iHash];
			obj_index_hash[iHash]       = pObj;
			save_area(get_vnum_area(ch->in_room->vnum));
		}

		if ((obj = create_object(get_obj_index(vnum), 0)) == NULL)
		{
			stc("Something has gone wrong. Please write a note to immortal.\n\r", ch);
			return;
		}

		obj->level = 1;

		sprintf(buf, "house key %s", ch->name);
		free_string(obj->name);
		obj->name = str_dup(buf);

		sprintf(buf, "a house key [{w%s{x]", ch->colorname);
		free_string(obj->short_descr);
		obj->short_descr = str_dup(buf);

		sprintf(buf, "A house key is lying here. [{w%s{x]", ch->colorname);
		free_string(obj->description);
		obj->description = str_dup(buf);
		
		obj->wear_flags = ITEM_TAKE;
		obj->item_type = ITEM_KEY;
		obj->cost = 1;

		obj_to_char(obj, ch);
		act("$p appears in your hands!", ch, obj, NULL, TO_CHAR);
		act("$p appears in $n's hands!", ch, obj, NULL, TO_ROOM);
		return;
	}

	if (!str_cmp(arg1, "reset"))
	{
		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		clean_home(ch);
		hrecall(ch);
		return;
	}

	if (!str_cmp(arg1, "recall"))
	{
		hrecall(ch);
		return;
	}

	if (!str_cmp(arg1, "name"))
	{
		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		if (argument[0] == '\0')
		{
			stc("What do you want to change the name of this room to?\n\r", ch);
			return;
		}

		free_string(ch->in_room->name);
		ch->in_room->name = str_dup(argument);
		save_area(ch->in_room->area);
		stc("You have changed the name of this room.\n\r", ch);
		return;
	}

	if (!str_cmp(arg1, "desc"))
	{
		if (!is_room_owner(ch, ch->in_room))
		{
			stc("You can only do this in your home.\n\r", ch);
			return;
		}

		home_describe(ch);
		return;
	}

	do_home(ch, "");
	return;
}
