/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#include "protocol.h"

/* added this to do a test
 *
 * */

/*
 * Accommodate old non-Ansi compilers.
 */
#if defined(TRADITIONAL)
#define DECLARE_OBJ_FUN( fun )		void fun( )
#define DECLARE_ROOM_FUN( fun )		void fun( )
#define const
#define args( list )			( )
#define DECLARE_DO_FUN( fun )		void fun( )
#define DECLARE_SPEC_FUN( fun )		bool fun( )
#define DECLARE_SPELL_FUN( fun )	void fun( )
#else
#define args( list )			    list
#define DECLARE_DO_FUN( fun )		DO_FUN    fun
#define DECLARE_SPEC_FUN( fun )		SPEC_FUN  fun
#define DECLARE_SPELL_FUN( fun )	SPELL_FUN fun
#define DECLARE_OBJ_FUN( fun )		OBJ_FUN	  fun
#define DECLARE_ROOM_FUN( fun )		ROOM_FUN  fun
#endif

/* system calls */
int unlink();
int system();

#if	!defined(FALSE)
#define FALSE	 0
#endif

#if	!defined(TRUE)
#define TRUE	 1
#endif

#if	defined(_AIX)
#if	!defined(const)
#define const
#endif
typedef int				    sh_int;
typedef int				    bool;
#define unix
#else
typedef short   int			sh_int;
typedef unsigned char		bool;
#endif

/* Staff Functions
void fwrite_staff( CHAR_DATA *ch );
void fread_staff( CHAR_DATA *ch );*/

#include "list.h"
#include "stack.h"


extern  STACK       *   desc_free;       /* the socket free list               */
extern  LLIST        *   desc_list;       /* the linked list of active sockets  */
extern  STACK       *   ch_free;     /* the mobile free list               */
extern  LLIST        *   ch_list;     /* the mobile list of active mobiles  */

/*
 * Structure types.
 */
typedef struct  l_board             LEADER_BOARD;
typedef struct	affect_data		    AFFECT_DATA;
typedef struct	area_data		    AREA_DATA;
typedef struct	auction_data		AUCTION_DATA;
typedef struct	ban_data		    BAN_DATA;
typedef struct 	buf_type	 	    BUFFER;
typedef struct	char_data		    CHAR_DATA;
typedef struct  bond_data           BOND_DATA;
typedef struct	descriptor_data		DESCRIPTOR_DATA;
typedef struct	drop_data			DROP_DATA;	/* customizable loots - Radyth */
typedef struct  event_data          EVENT_DATA;  /* timed events */
typedef struct  events_data         EVENTS_DATA;  /* new timed events */
typedef struct  weave_data	    WEAVE_DATA; /* for delayed casting of multiple weaves */
typedef struct  war_data            WAR_DATA; /* for armies duking it out - Dalsor */
typedef struct  locker_data         LOCKER_DATA; /* locker.c */

typedef struct	quest_data		QUEST_DATA;		/* Story Quests - Rokann */
typedef struct	objective_data		OBJECTIVE_DATA;		/* Objectives for story quests */
typedef struct	buddy_data		BUDDY_DATA;

typedef struct	exit_data		    EXIT_DATA;
typedef struct	extra_descr_data	EXTRA_DESCR_DATA;
typedef struct	help_data		    HELP_DATA;
typedef struct	help_area_data	    HELP_AREA;
typedef struct	kill_data		    KILL_DATA;
typedef struct	mem_data		    MEM_DATA;
typedef struct	mob_index_data	    MOB_INDEX_DATA;
typedef struct	pnote_data		    PNOTE_DATA;
typedef struct	note_data		    NOTE_DATA;
typedef struct  material_data       MATERIAL_DATA;
typedef struct	obj_data		    OBJ_DATA;
typedef struct	obj_index_data	    OBJ_INDEX_DATA;
typedef struct	pc_data			    PC_DATA;
typedef struct	rebirth_data	    REBIRTH_DATA;
typedef struct  gen_data		    GEN_DATA;
typedef struct	reset_data		    RESET_DATA;
typedef struct	room_index_data	    ROOM_INDEX_DATA;
typedef struct	shop_data		    SHOP_DATA;
typedef struct	time_info_data	    TIME_INFO_DATA;
typedef struct  tornado_data        TORNADO_DATA;
typedef struct	weather_data	    WEATHER_DATA;
/*typedef struct  mprog_list		    MPROG_LIST;*/
typedef struct  invade_vnums		INVADE_VNUMS;
/*typedef struct  mprog_code		    MPROG_CODE;*/
typedef struct  colour_data         COLOUR_DATA;
typedef struct  hate_data		    HATE_DATA;
typedef struct  wiz_data            WIZ_DATA;
typedef struct  grant_data          GRANT_DATA;
typedef struct  prog_list          	PROG_LIST;
typedef struct  prog_code           PROG_CODE;
typedef struct  gquest_data         GQUEST;
typedef struct         battle_data       BATTLE_DATA; /*battle struct*/
typedef struct tag_data TAG_DATA;
typedef struct  tourney_data         TOURNEY_DATA; /* tournies */
typedef struct  trivia_data         TRIVIA_DATA;
typedef struct  faire_data          FAIRE_DATA;
typedef struct  email_data EMAIL_DATA;
typedef struct  fighting_data        FIGHTING_DATA;
typedef struct  gevent_data          GEVENT_DATA;
typedef struct  invade_data          INVADE_DATA;
typedef struct  clan_type               CLAN_DATA;
typedef struct  raffle_data          RAFFLE_DATA;
typedef struct  key_data		KEY_DATA;
typedef struct guild_rank       rankdata;


/*
 * Function types.
 */
typedef	void DO_FUN	args( ( CHAR_DATA *ch, char *argument ) );
typedef bool SPEC_FUN	args( ( CHAR_DATA *ch ) );
typedef void SPELL_FUN	args( ( int sn, int level, CHAR_DATA *ch, void *vo,
				int target ) );
typedef void OBJ_FUN	args( ( OBJ_DATA *obj, char *argument ) );
typedef void ROOM_FUN	args( ( ROOM_INDEX_DATA *room, char *argument ) );

extern  int mud_port;
extern  int build_port;
extern  int play_port;
extern  int ferry_timer;
extern  int REBIRTH_IN_PROGRESS;
extern  int MENTOR_SESSION;
extern  int OOC_OFF;
extern sh_int SEASON;

#define MAX_LAST_LENGTH            20 /*How long can the last list be?*/

/* all basic defines */
#include "define.h"
/* inc def for notes */
#include "board.h"
/* inc def for telnet prot */
#include "telnet.h"
/* inc def for color codes */
#include "color.h"
/* inc def for skill gsns */
#include "skills.h"
/* inc def for function prototypes */
//#include "prototypes.h" // prool: dirty hack
/* include mysql db detail
#include "mysql.h"*/
#include "struct.h"


extern EVENT_DATA *events;







#define PARSE_FORMAT		0
#define PARSE_REPLACE		1
#define PARSE_HELP		2
#define PARSE_DELETE		3
#define PARSE_INSERT		4
#define PARSE_LIST_NORM		5
#define PARSE_SHOW		6
#define PARSE_EDIT		7

/*
 * Description macros.
#define PERS(ch, looker)	( can_see( looker, (ch) ) ?		\
				( IS_NPC(ch) ? (ch)->short_descr	\
				: (ch)->name ) : IS_IMMORTAL(ch) ? "Immortal" : "someone" )
 */

#define PERS(ch, looker)	(can_see(looker, (ch)) ? ((ch)->colorname) :					\
				IS_IMMORTAL(ch) ? "Immortal" : "someone")


LEADER_BOARD leader_board;

void do_trivia args(( CHAR_DATA *ch, char*argument ));
void talk_trivia args(( char*argument ));
void trivia_update args(( void ));

/* tourney voids */
void talk_tourney      args( (char *argument) );
void do_tourney          args( (CHAR_DATA *ch, char * argument ) );
void do_topen          args( (CHAR_DATA *ch, char * argument ) );
void do_tclose          args( (CHAR_DATA *ch, char * argument ) );
void do_tstop          args( (CHAR_DATA *ch, char * argument ) );
void do_tchat          args( (CHAR_DATA *ch, char * argument ) );

/* battle voids */
void talk_battle      args( (char *argument) );
void do_battle          args( (CHAR_DATA *ch, char * argument ) );
void do_bopen          args( (CHAR_DATA *ch, char * argument ) );
void do_bclose          args( (CHAR_DATA *ch, char * argument ) );
void do_bstop          args( (CHAR_DATA *ch, char * argument ) );
void do_bchat          args( (CHAR_DATA *ch, char * argument ) );

int		dfhunt_game_info[7];
char		dfhunt_creator_name[MAX_STRING_LENGTH];

void tag_update args ((void));
void end_tag args ((void));
void start_tag args ((void));
void check_team_frozen args ((CHAR_DATA * ch));
void auto_tag args ((void));
void tag_channel args((CHAR_DATA *ch, char *message));

/* email stuff */
bool emailf args ( ( CHAR_DATA * ch ) );
void handle_email_to args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_subject args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_body args ( ( DESCRIPTOR_DATA * d, char *argument ) );
void handle_email_finish args ( ( DESCRIPTOR_DATA * d, char *argument ) );
bool valid_email args ( ( char *argument ) );
void parse_email_text args ( ( int command, char *string, CHAR_DATA * ch ) );

void free_multibuf args( ( DESCRIPTOR_DATA *d ) );
void     free_runbuf     args( ( CHAR_DATA *d ) ); /*Jogging -Anthony*/

/*
 * Global constants.
 */
extern	const	struct	str_app_type	str_app		[201];
extern	const	struct	int_app_type	int_app		[201];
extern	const	struct	wis_app_type	wis_app		[201];
extern	const	struct	dex_app_type	dex_app		[201];
extern	const	struct	con_app_type	con_app		[201];
extern	const	struct	ref_app_type	ref_app		[201];
extern	const	struct	ins_app_type	ins_app		[201];
extern	const	struct	cha_app_type	cha_app		[201];


/*
 * Global variables.
 */
extern		AUCTION_DATA  * auction_list;

extern		HELP_DATA	  *	help_first;
extern		SHOP_DATA	  *	shop_first;

extern		CHAR_DATA	  *	char_list;
extern		DESCRIPTOR_DATA   *	descriptor_list;
extern		OBJ_DATA	  *	object_list;

extern      PROG_CODE         *     mprog_list;
extern      PROG_CODE         *     rprog_list;
extern      PROG_CODE         *     oprog_list;

extern		char			bug_buf		[];
extern		time_t			current_time;
extern		bool			fLogAll;
extern		bool			fLogAllQuiet;
extern		KILL_DATA		kill_table	[];
extern		char			log_buf		[];
extern		TIME_INFO_DATA	time_info;
extern		WEATHER_DATA	weather_info;
extern      TORNADO_DATA *  first_tornado;
extern      TORNADO_DATA *  last_tornado;
extern		bool			MOBtrigger;
extern      AREA_DATA *     area_first_sorted;
extern      GQUEST          gquest_info;
extern                 BATTLE_DATA *  battle;
extern          NOTE_DATA         *     note_free;
extern          OBJ_DATA          *     obj_free;
extern TAG_DATA tag_game;
extern      TOURNEY_DATA *  tourney;
extern TRIVIA_DATA *trivia;
extern FAIRE_DATA *faire;
extern RAFFLE_DATA *raffle;
extern GEVENT_DATA *gevent;
extern INVADE_DATA *invasion;

#if defined(KEY)
#undef KEY
#endif

#define KEY( literal, field, value )					\
				if ( !str_cmp( word, literal ) )	\
				{					\
				    field  = value;			\
				    fMatch = TRUE;			\
				    break;				\
				}

/* provided to free strings */
#if defined(KEYS)
#undef KEYS
#endif

#define KEYS( literal, field, value )					\
				if ( !str_cmp( word, literal ) )	\
				{					\
				    free_string(field);			\
				    field  = value;			\
				    fMatch = TRUE;			\
				    break;				\
				}

/*
 * OS-dependent declarations.
 * These are all very standard library functions,
 *   but some systems have incomplete or non-ansi header files.
 */
#if	defined(_AIX)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(apollo)
int	atoi		args( ( const char *string ) );
void *	calloc		args( ( unsigned nelem, size_t size ) );
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(hpux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(linux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(macintosh)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(MIPS_OS)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(MSDOS)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(NeXT)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(sequent)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(sun)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
#if	defined(SYSV)
siz_t	fread		args( ( void *ptr, size_t size, size_t n,
			    FILE *stream) );
#elif !defined(__SVR4)
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
#endif
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(ultrix)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif


/*
 * The crypt(3) function is not available on some operating systems.
 * In particular, the U.S. Government prohibits its export from the
 *   United States to foreign countries.
 * Turn on NOCRYPT to keep passwords in plain text.
 */
#if	defined(NOCRYPT)
#define crypt(s1, s2)	(s1)
#endif



/*
 * Data files used by the server.
 *
 * AREA_LIST contains a list of areas to boot.
 * All files are read in completely at bootup.
 * Most output files (bug, idea, typo, shutdown) are append-only.
 *
 * The NULL_FILE is held open so that we have a stream handle in reserve,
 *   so players can go ahead and telnet to all the other descriptors.
 * Then we close it whenever we need to open a file (e.g. a save file).
 */
#if defined(macintosh)
#define PLAYER_DIR	    ""			/* Player files	*/
#define TEMP_FILE	    "romtmp"
#define NULL_FILE	    "proto.are"		/* To reserve one stream */
#endif

#if defined(MSDOS)
#define PLAYER_DIR	    ""			/* Player files */
#define TEMP_FILE	    "romtmp"
#define NULL_FILE	    "nul"			/* To reserve one stream */
#endif

#if defined(unix)
#define PLAYER_DIR      "../player/"        	/* Player files */
#define SHOPS_DIR       "../shops/"
#define GOD_DIR         "../gods/"  		/* list of gods */
#define TEMP_FILE	    "../player/aww_tmp"
#define NULL_FILE	    "/dev/null"		/* To reserve one stream */
#define VAULTS_DIR      "../locker/"
#define GUILD_HTML      "../../pub/guilds/index.html" /* location of guild index.html page */
#endif

#define AREA_LIST       "area.lst"  /* List of areas*/
#define BUG_FILE        "../data/bugs.txt" /* For 'bug' and bug()*/
#define TYPO_FILE       "../data/typos.txt" /* For 'typo'*/
#define PNOTE_FILE      "../data/notes.not"/* For 'notes'*/
#define IDEA_FILE	    "../data/ideas.not"
#define PENALTY_FILE	"../data/penal.not"
#define RESTRING_FILE	"../data/restring.not"
#define EVENT_FILE	    "../data/event.not"
#define ROLEPLAY_FILE   "../data/roleplay.not" /* for roleplay in-game notes -Dalsor */
#define NEWS_FILE	    "../data/news.not"
#define CHANGES_FILE	"../data/chang.not"
#define SHUTDOWN_FILE   "../data/shutdown.txt"/* For 'shutdown'*/
#define BAN_FILE	    "../data/ban.txt"
#define BACKUP_DIR      "../pbackup/"
#define MUSIC_FILE	    "../data/music.txt"
#define HELP_FILE       "../data/help.txt"
#define WIZ_FILE        "../data/wizlist.txt"
#define MAX_WHO_FILE    "../data/maxwho.txt"
#define NSTRING_FILE    "../data/nstring.dat"
#define NEW_BUG_FILE	"../data/newbugs.txt"
#define IMM_FILE	    "../data/immfile.txt"
#define	GQUEST_FILE		"../data/gquest.dat"
#define TIME_FILE       "../data/mudtime.txt"
#define WARN_FILE       "../data/warn.txt"
#define REPORT_FILE     "../data/report.txt"
#define PIT_FILE        "../data/pit.txt"
#define QUIET           "../data/.log"
#define DATA_DIR        "../data/"
/*
 * Our function prototypes.
 * One big lump ... this is every function in Merc.
 */
#define CD	CHAR_DATA
#define MID	MOB_INDEX_DATA
#define OD	OBJ_DATA
#define OID	OBJ_INDEX_DATA
#define RID	ROOM_INDEX_DATA
#define SF	SPEC_FUN
#define AD	AFFECT_DATA
#define PC	PROG_CODE

char *dns_gethostname args((char *s));
char *one_argument_with_caps args(( char *argument, char *arg_first ));

void load_leaderboard   args( ( void ) );
void save_leaderboard   args( ( void ) );
void check_leaderboard  args( ( CHAR_DATA *ch ) );
int  get_ratio          args( ( CHAR_DATA *ch ) );

/* auction.c */
void do_auction      args((CHAR_DATA *ch, char *argument));
void identify_obj    args(( CHAR_DATA *ch, OBJ_DATA *obj ));
int count_auc        args((CHAR_DATA *ch));
void reset_auc       args((AUCTION_DATA *auc));
void auction_channel args(( char * msg ));
void auction_update  args((void));

/* act_comm.c */
#define logf logprintf
void  	check_sex	args( ( CHAR_DATA *ch) );
void	add_follower	args( ( CHAR_DATA *ch, CHAR_DATA *master ) );
void	stop_follower	args( ( CHAR_DATA *ch ) );
void 	nuke_pets	args( ( CHAR_DATA *ch ) );
void	die_follower	args( ( CHAR_DATA *ch ) );
void 	logprintf 			args((char * fmt, ...));


/* act_enter.c */
RID  *get_random_room   args ( (CHAR_DATA *ch) );

/*gcom.c*/
void	compose_title	args((CHAR_DATA *ch));

/* act_info.c */
void	set_title	args( ( CHAR_DATA *ch, char *title ) );

/* act_misc.c */
/*void do_rebirth args( ( CHAR_DATA *ch, char *argument, int rbi ) );*/

/* act_move.c */
char  *walkdir        args(( char *argument, char *dir ));

/* act_obj.c */
void    get_obj         args( ( CHAR_DATA *ch, OBJ_DATA *obj,
                            OBJ_DATA *container ) );

/* act_wiz.c */
void wiznet		args( (char *string, CHAR_DATA *ch, OBJ_DATA *obj,
			       long flag, long flag_skip, int min_level ) );
void copyover args((void));
void copyover_recover args((void));

extern int bootcount;
extern		int			tmp_bootcount;
void sysmsg args ((char *argument));

/* alias.c */
void 	substitute_alias args( (DESCRIPTOR_DATA *d, char *input) );

/* auction.c */
void    auction_update  args( ( void ) );
void    auction_channel args( ( char *msg ) );

/* ban.c */
bool	check_ban	args( ( char *site, int type) );

void		free_buddy		args ( ( BUDDY_DATA *buddy ) );
BUDDY_DATA	*new_buddy		args ( ( char *name ) );


/* comm.c */
void	show_string	args( ( struct descriptor_data *d, char *input) );
void	close_socket	args( ( DESCRIPTOR_DATA *dclose ) );
void	write_to_buffer	args( ( DESCRIPTOR_DATA *d, const char *txt,
			    int length ) );
/* added for new char gen - Dalsor */
void do_quoter   args((CHAR_DATA *ch));
void display_races args((CHAR_DATA *ch));
void display_eye_color args((CHAR_DATA *ch));
void display_aiel_societies args((CHAR_DATA *ch));
void display_trollocs args((CHAR_DATA *ch));
void display_illegal_name args((CHAR_DATA *ch));
void display_denied_char args((CHAR_DATA *ch));
void display_banned_site args((CHAR_DATA *ch));
void display_game_wizlocked args((CHAR_DATA *ch));
void display_game_newlocked args((CHAR_DATA *ch));
void display_game_wizlocked_descriptor args((DESCRIPTOR_DATA *d));
void display_new_name args((CHAR_DATA *ch));
void display_invalid_password args((CHAR_DATA *ch));
void display_cust_head args((CHAR_DATA *ch));

void	send_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
void	stc	args( ( const char *txt, CHAR_DATA *ch ) );
void	page_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
void	act		args( ( const char *format, CHAR_DATA *ch,
			    const void *arg1, const void *arg2, int type ) );
void	act_new		args( ( const char *format, CHAR_DATA *ch,
			    const void *arg1, const void *arg2, int type,
			    int min_pos) );
void	printf_to_char	args( ( CHAR_DATA *, char *, ... ) );
void    ptc args( ( CHAR_DATA *, char *, ... ) );
void	bugf		args( ( char *, ... ) );

/* db.c */
void	reset_area      args( ( AREA_DATA * pArea ) );		/* OLC */
void	reset_room	args( ( ROOM_INDEX_DATA *pRoom ) );	/* OLC */
char *	print_flags	args( ( int flag ));
void	boot_db		args( ( void ) );
void	area_update	args( ( void ) );
void    ferry_update args( ( void ) );
CD *	create_mobile	args( ( MOB_INDEX_DATA *pMobIndex ) );
void	clone_mobile	args( ( CHAR_DATA *parent, CHAR_DATA *clone) );
OD *	create_object	args( ( OBJ_INDEX_DATA *pObjIndex, int level ) );
void	clone_object	args( ( OBJ_DATA *parent, OBJ_DATA *clone ) );
void	clear_char	args( ( CHAR_DATA *ch ) );
char *	get_extra_descr	args( ( const char *name, EXTRA_DESCR_DATA *ed ) );
MID *	get_mob_index	args( ( long vnum ) );
OID *	get_obj_index	args( ( long vnum ) );
RID *	get_room_index	args( ( long vnum ) );
PC *	get_prog_index args( ( long vnum, int type ) );
char	fread_letter	args( ( FILE *fp ) );
int	fread_number	args( ( FILE *fp ) );
long	fread_vnum	args( ( FILE *fp ) );
long 	fread_flag	args( ( FILE *fp ) );
char *	fread_string	args( ( FILE *fp ) );
char *  fread_string_eol args(( FILE *fp ) );
void	fread_to_eol	args( ( FILE *fp ) );
/* char *	fread_word	args( ( FILE *fp ) ); */
#define fread_word( fp ) _fread_word( fp, __FILE__, __LINE__ )
long	flag_convert	args( ( char letter) );
void *	alloc_mem	args( ( int sMem ) );
void *	alloc_perm	args( ( int sMem ) );

void show_talents args(( CHAR_DATA *ch ));
int calc_remort_tier args(( CHAR_DATA *ch));

//void _free_mem args ((void *pMem, int sMem, char *file, int line));
void _free_string args ((char *pstr, char *file, int line));
char * _fread_word args(( FILE *fp, char *file, int line ));

/*void	free_mem	args( ( void *pMem, int sMem ) );*/
char *	str_dup		args( ( const char *str ) );
/*void	free_string	args( ( char *pstr ) );*/
int	number_fuzzy	args( ( int number ) );
int	number_range	args( ( int from, int to ) );
int	number_percent	args( ( void ) );
int	number_door	args( ( void ) );
int	number_bits	args( ( int width ) );
long     number_mm       args( ( void ) );
int	dice		args( ( int number, int size ) );
int	interpolate	args( ( int level, int value_00, int value_32 ) );
void	smash_tilde	args( ( char *str ) );
char *	capitalize	args( ( const char *str ) );
char *  capit2      args( ( const char *str ) );
char *  capit_colorsafe args( ( const char *str ) );
void	append_file	args( ( CHAR_DATA *ch, char *file, char *str ) );
void	bug		args( ( const char *str, int param ) );
void	log_string	args( ( const char *str ) );
void	tail_chain	args( ( void ) );

 /*
  * Colour stuff by Lope
  */
 int   colour          args( ( char type, CHAR_DATA *ch, char *string ) );
 void  colourconv      args( ( char *buffer, const char *txt,
CHAR_DATA*ch));
 void  send_to_char_bw args( ( const char *txt, CHAR_DATA *ch ) );
 void  page_to_char_bw args( ( const char *txt, CHAR_DATA *ch ) );

/* tabac.c for drunk code */
char	*makedrunk	args( (char *string, CHAR_DATA *ch) );

/* disable.c */
void	load_disabled	args( ( void ) );

/* effect.c */
void	acid_effect	args( (void *vo, int level, int dam, int target) );
void	cold_effect	args( (void *vo, int level, int dam, int target) );
void	fire_effect	args( (void *vo, int level, int dam, int target) );
void	poison_effect	args( (void *vo, int level, int dam, int target) );
void	shock_effect	args( (void *vo, int level, int dam, int target) );


/* fight.c */
bool 	is_safe		args( (CHAR_DATA *ch, CHAR_DATA *victim ) );
bool 	is_safe_spell	args( (CHAR_DATA *ch, CHAR_DATA *victim, bool area ) );
void	violence_update	args( ( void ) );
void	multi_hit	args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt ) );
bool	damage		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
			        int dt, int class, bool show ) );
bool    damage_old      args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
                                int dt, int class, bool show ) );
void	update_pos	args( ( CHAR_DATA *victim ) );
/*void	stop_fighting	args( ( CHAR_DATA *ch, bool fBoth ) );*/
void	check_killer	args( ( CHAR_DATA *ch, CHAR_DATA *victim) );

bool    is_hating       args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void    stop_hating     args( ( CHAR_DATA *ch ) );
/*void    stop_fighting   args( ( CHAR_DATA *ch, bool fBoth ) );*/
void	start_hating	args( (CHAR_DATA *ch, CHAR_DATA *victim) );
/*void	set_fighting	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );*/
bool start_first_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool start_extra_fight args((CHAR_DATA *ch, CHAR_DATA *victim, int range));
bool check_fighting_groupie args((CHAR_DATA *ch, CHAR_DATA *victim));
bool check_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_fighting args((CHAR_DATA *ch, CHAR_DATA *victim));
void stop_all_fighting args((CHAR_DATA *ch));
bool is_fighting args((CHAR_DATA *ch));


/* handler.c */
AD  	*affect_find args( (AFFECT_DATA *paf, int sn));
void	affect_check	args( (CHAR_DATA *ch, int where, int vector) );
void    affect_to_room  args( (ROOM_INDEX_DATA *room, AFFECT_DATA *paf ) );
void	affect_remove_room args((ROOM_INDEX_DATA *room, AFFECT_DATA *paf) );
int	count_users	args( (OBJ_DATA *obj) );
void 	deduct_cost	args( (CHAR_DATA *ch, int cost, int account) );
void	affect_enchant	args( (OBJ_DATA *obj) );
int 	check_immune	args( (CHAR_DATA *ch, int dam_type) );
int 	material_lookup args( ( const char *name) );
int	weapon_lookup	args( ( const char *name) );
int	weapon_type	args( ( const char *name) );
char 	*weapon_name	args( ( int weapon_Type) );
char	*item_name	args( ( int item_type) );
int	attack_lookup	args( ( const char *name) );
long	wiznet_lookup	args( ( const char *name) );
int	class_lookup	args( ( const char *name) );
/*
bool	is_clan		args( (CHAR_DATA *ch) );
bool	is_same_clan	args( (CHAR_DATA *ch, CHAR_DATA *victim));
*/
int	get_skill	args( ( CHAR_DATA *ch, int sn ) );
int	get_weapon_sn	args( ( CHAR_DATA *ch ) );
int	get_weapon_skill args(( CHAR_DATA *ch, int sn ) );
int     get_age         args( ( CHAR_DATA *ch ) );
void	reset_char	args( ( CHAR_DATA *ch )  );
int	get_trust	args( ( CHAR_DATA *ch ) );
int	get_curr_stat	args( ( CHAR_DATA *ch, int stat ) );
int 	get_max_train	args( ( CHAR_DATA *ch, int stat ) );
int	can_carry_n	args( ( CHAR_DATA *ch ) );
int	can_carry_w	args( ( CHAR_DATA *ch ) );
/* grant code */



/* Story Quests */
void reset_qsteps args((CHAR_DATA *ch));
bool check_qstep_completed args((CHAR_DATA *ch, int step));
bool check_on_qstep args((CHAR_DATA *ch, int step));
void complete_qstep args((CHAR_DATA *ch, int step));


/* reg stuff */
void	affect_to_char	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	affect_to_obj	args( ( OBJ_DATA *obj, AFFECT_DATA *paf ) );
void	affect_remove	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	affect_remove_obj args( (OBJ_DATA *obj, AFFECT_DATA *paf ) );
void	affect_strip	args( ( CHAR_DATA *ch, int sn ) );
void	affect_join	args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void	char_from_room	args( ( CHAR_DATA *ch ) );
void	char_to_room	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex ) );
void	obj_to_char	args( ( OBJ_DATA *obj, CHAR_DATA *ch ) );
void	obj_from_char	args( ( OBJ_DATA *obj ) );


int	apply_ac	args( ( OBJ_DATA *obj, int iWear, int type ) );
OD *	get_eq_char	args( ( CHAR_DATA *ch, int iWear ) );
void	equip_char	args( ( CHAR_DATA *ch, OBJ_DATA *obj, int iWear ) );
void	unequip_char	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
int	count_obj_list	args( ( OBJ_INDEX_DATA *obj, OBJ_DATA *list ) );
/*void	obj_from_room	args( ( OBJ_DATA *obj ) );*/
void _obj_from_room args ((OBJ_DATA *obj, char *file, int line));

void	obj_to_room	args( ( OBJ_DATA *obj, ROOM_INDEX_DATA *pRoomIndex ) );
void	obj_to_obj	args( ( OBJ_DATA *obj, OBJ_DATA *obj_to ) );
void	obj_from_obj	args( ( OBJ_DATA *obj ) );
void	extract_obj	args( ( OBJ_DATA *obj ) );
CD *	get_char_room		args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room, char *argument ) );
CD *	get_char_world	args( ( CHAR_DATA *ch, char *argument ) );
CD *    get_mob_world   args( ( CHAR_DATA *ch, char*argument ) );
CD *	get_pc_world	args( ( CHAR_DATA *ch, char *argument ) );
CD *	get_char_area	args( ( CHAR_DATA *ch, char *argument ) );
CD *    get_mob_by_vnum args( ( CHAR_DATA *ch, char *argument ) );
OD *	get_obj_type	args( ( OBJ_INDEX_DATA *pObjIndexData ) );
OD *	get_obj_list	args( ( CHAR_DATA *ch, char *argument,
			    OBJ_DATA *list ) );
OD *	get_obj_carry	args( ( CHAR_DATA *ch, char *argument,
			    CHAR_DATA *viewer ) );
OD *	create_money	args( ( int copper, int silver, int mark, int gold ) );
int	get_obj_number	args( ( OBJ_DATA *obj ) );
int	get_obj_weight	args( ( OBJ_DATA *obj ) );
int	get_true_weight	args( ( OBJ_DATA *obj ) );
char *	affect_loc_name	args( ( int location ) );
char *	affect_bit_name	args( ( int vector ) );
char *  affect2_bit_name args( ( int vector ) );
char *	extra_bit_name	args( ( int extra_flags ) );
char * 	wear_bit_name	args( ( int wear_flags ) );
char *	act_bit_name	args( ( int act_flags ) );
char *	act2_bit_name	args( ( int act2_flags, CHAR_DATA *ch ) );
char *	off_bit_name	args( ( int off_flags ) );
char *  imm_bit_name	args( ( int imm_flags ) );
char *  imm_bit_name	args( ( int imm_flags ) );
char * 	form_bit_name	args( ( int form_flags ) );
char *	part_bit_name	args( ( int part_flags ) );
char *	weapon_bit_name	args( ( int weapon_flags ) );
char *  comm_bit_name	args( ( int comm_flags ) );
char *	cont_bit_name	args( ( int cont_flags) );
char *  item_type_name  args( ( OBJ_DATA *obj ) );
/*int  random_stat        args( ( CHAR_DATA *ch ) );  For random stats - Dalsor */
/*
 * Colour Config
 */
void	default_colour	args( ( CHAR_DATA *ch ) );
void	all_colour	args( ( CHAR_DATA *ch, char *argument ) );

/* interp.c */
void	interpret	args( ( CHAR_DATA *ch, char *argument ) );
bool	is_number	args( ( char *arg ) );
int	number_argument	args( ( char *argument, char *arg ) );
int	mult_argument	args( ( char *argument, char *arg) );
char *	one_argument	args( ( char *argument, char *arg_first ) );
char *  one_comma_argument args( ( char *argument, char *arg_first ) );

/* invade.c */
void	check_invade();
int	racei_amount(int race);
bool	invade(int town, int invader, int force, int amount);
/* magic.c */
int	find_spell	args( ( CHAR_DATA *ch, const char *name) );
int 	mana_cost 	(CHAR_DATA *ch, int min_mana, int level);
int	skill_lookup	args( ( const char *name ) );
int	slot_lookup	args( ( int slot ) );
bool	saves_spell	args( ( int level, CHAR_DATA *victim, int dam_type ) );
void	obj_cast_spell	args( ( int sn, int level, CHAR_DATA *ch,
				    CHAR_DATA *victim, OBJ_DATA *obj ) );

/* locker.c */
LOCKER_DATA * load_locker args( ( CHAR_DATA *ch ) );
void fread_locker args( ( CHAR_DATA *ch, LOCKER_DATA *locker, FILE *fp ) );
void fwrite_locker args( ( CHAR_DATA *ch ) );

/* mob_prog.c
void	program_flow	args( ( long vnum, char *source, CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2 ) );
void	mp_act_trigger	args( ( char *argument, CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
void	mp_bribe_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch, int amount ) );
bool	mp_exit_trigger   args( ( CHAR_DATA *ch, int dir ) );
void	mp_give_trigger   args( ( CHAR_DATA *mob, CHAR_DATA *ch, OBJ_DATA *obj ) );
void 	mp_greet_trigger  args( ( CHAR_DATA *ch ) );
void	mp_hprct_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch ) );
*/
void	program_flow	args( ( long vnum, char *source, CHAR_DATA *mob,
				OBJ_DATA *obj, ROOM_INDEX_DATA *room,
				CHAR_DATA *ch, const void *arg1,
				const void *arg2 ) );
void	p_act_trigger	args( ( char *argument, CHAR_DATA *mob,
				OBJ_DATA *obj, ROOM_INDEX_DATA *room,
				CHAR_DATA *ch, const void *arg1,
				const void *arg2, int type ) );
void	p_bribe_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch, int amount ) );
void	p_give_trigger   args( ( CHAR_DATA *mob, OBJ_DATA *obj,
				ROOM_INDEX_DATA *room, CHAR_DATA *ch,
				OBJ_DATA *dropped, int type ) );
void 	p_greet_trigger  args( ( CHAR_DATA *ch, int type ) );
void	p_hprct_trigger  args( ( CHAR_DATA *mob, CHAR_DATA *ch ) );

/* mob_cmds.c */
void	mob_interpret	args( ( CHAR_DATA *ch, char *argument ) );
void	obj_interpret	args( ( OBJ_DATA *obj, char *argument ) );
void room_interpret	args( ( ROOM_INDEX_DATA *room, char *argument ) );

/* mount.c */
int     mount_success	args( ( CHAR_DATA *ch, CHAR_DATA *mount, int canattack ) );
void    do_mount        args( ( CHAR_DATA *ch, char *argument ) );
void    do_dismount     args( ( CHAR_DATA *ch, char *argument ) );
void	do_buy_mount	args( ( CHAR_DATA *ch, char *argument ) );

/* save.c */
/*void	save_char_obj	args( ( CHAR_DATA *ch ) ); */
void    save_char_obj   args((CHAR_DATA * ch, bool backup, bool save_other));
bool	load_char_obj	args( ( DESCRIPTOR_DATA *d, char *name ) );
void	fwrite_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fwrite_obj	args( ( CHAR_DATA *ch,  OBJ_DATA  *obj, FILE *fp, int iNest ) );
void	fwrite_pet	args( ( CHAR_DATA *pet, FILE *fp) );
void	fwrite_mount	args( ( CHAR_DATA *pet, FILE *fp) );
void	fread_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_pet	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_mount	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fread_obj	args( ( CHAR_DATA *ch,  FILE *fp ) );

/*send.c*/
 char *color_strip args(( const char *txt ));

/* skills.c */
bool 	parse_gen_groups args( ( CHAR_DATA *ch,char *argument ) );
void 	list_group_costs args( ( CHAR_DATA *ch ) );
void    list_group_known args( ( CHAR_DATA *ch ) );
int 	exp_per_level	args( ( CHAR_DATA *ch, int points ) );
void 	check_improve	args( ( CHAR_DATA *ch, int sn, bool success,
				    int multiplier ) );
int 	group_lookup	args( (const char *name) );
void	gn_add		args( ( CHAR_DATA *ch, int gn) );
void 	gn_remove	args( ( CHAR_DATA *ch, int gn) );
void 	group_add	args( ( CHAR_DATA *ch, const char *name, bool deduct) );
void	group_remove	args( ( CHAR_DATA *ch, const char *name) );
bool can_gain_sk args((CHAR_DATA *ch, int sn));

/* special.c */
SF *	spec_lookup	args( ( const char *name ) );
char *	spec_name	args( ( SPEC_FUN *function ) );

/* talents.c */
void check_talents( CHAR_DATA *ch );

/* teleport.c */
RID *	room_by_name	args( ( char *target, int level, bool error) );

/* timer.c */
char *   nsprintf       args( (char *, char *, ...) );
void  wait_wait         args( (CHAR_DATA *, int, int) );
void  wait_printf       args( (CHAR_DATA *, int, char *, ...) );
void  wait_act          args( (int, char *, void *, void *, void *, int) );
void  wait_function     args( (CHAR_DATA *ch,int delay, DO_FUN *do_fun, char *argument) );
EVENT_DATA *create_event(int, char *);

/* update.c */
void	advance_level	args( ( CHAR_DATA *ch, bool hide ) );
void	gain_exp	args( ( CHAR_DATA *ch, int gain ) );
void	gain_condition	args( ( CHAR_DATA *ch, int iCond, int value ) );
void	update_handler	args( ( void ) );

/* staff.c */
void    fread_staff	args( ( CHAR_DATA *ch ) );
/*void    fwrite_staff	args( ( CHAR_DATA *ch ) ); */

/* staff_mysql.c */
void    update_staff args( ( CHAR_DATA *ch, char *argument ) );
void    read_mysql_staff args( ( CHAR_DATA *ch ) );

/* string.c */
void	string_edit	args( ( CHAR_DATA *ch, char **pString ) );
void    string_append   args( ( CHAR_DATA *ch, char **pString ) );
char *	string_replace	args( ( char * orig, char * old, char * new ) );
void    string_add      args( ( CHAR_DATA *ch, char *argument ) );
char *  format_string   args( ( char *oldstring /*, bool fSpace */ ) );
char *  first_arg       args( ( char *argument, char *arg_first, bool fCase ) );
char *	string_unpad	args( ( char * argument ) );
char *	string_proper	args( ( char * argument ) );
int strlen_color args( ( const char *string ) );

/* olc.c */
bool	run_olc_editor	args( ( DESCRIPTOR_DATA *d ) );
char	*olc_ed_name	args( ( CHAR_DATA *ch ) );
char	*olc_ed_vnum	args( ( CHAR_DATA *ch ) );

/* lookup.c */
int	race_lookup	args( ( const char *name) );
int	item_lookup	args( ( const char *name) );
int	liq_lookup	args( ( const char *name) );

/* misc crap */
int check_angreal_bonus args((CHAR_DATA *ch));
bool check_windfall args(( CHAR_DATA *ch ));
bool check_angrealstudy args(( CHAR_DATA *ch ));
bool is_char_char_clan args((CHAR_DATA *ch, CHAR_DATA *victim));
/*
int clan_lookup args(( const char *name ));
*/
void check_healing args(( CHAR_DATA *ch, CHAR_DATA *victim ));
void ship_advance args( ( void ) );
void caravan_advance args( (void) );
void dfhunt_update args( ( void ) );
void dfhunt_recount args( ( void ) );
void	dfhunt_talk		args((CHAR_DATA *ch, char *argument, int notice));
bool chance args(( int num ));
void	raw_kill	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void smash_forwardslash args(( char *str ));
void smash_space args(( char *str ));
void smash_tics args(( char *str ));
void smash_percent args(( char *str ));
char * double_percent args(( char *str ));
char * double_left_curly_brace args(( char *str ));
bool is_human args(( CHAR_DATA *ch ));
#if 0 // prool
bool ip_group_allow args(( CHAR_DATA *ch, CHAR_DATA *victim ));
bool is_alt_of		args(( CHAR_DATA *ch, CHAR_DATA *ach));
bool	is_same_group	args( ( CHAR_DATA *ach, CHAR_DATA *bch ) );
bool blademaster args(( CHAR_DATA *ch ));
bool can_remort args((CHAR_DATA *ch));
bool is_shadow args(( CHAR_DATA *ch ));
void	move_char	args( ( CHAR_DATA *ch, int door, bool follow) );
bool is_tagging args ((CHAR_DATA * ch));
void	wear_obj	args( (CHAR_DATA *ch, OBJ_DATA *obj, bool fReplace) );
bool can_loot		args( (CHAR_DATA *ch, OBJ_DATA *obj) );
bool    is_granted      args( ( CHAR_DATA *ch, DO_FUN *do_fun ) );
bool is_granted_name    args( ( CHAR_DATA *ch, char *argument ) );
bool		    wizlock;		/* Game is wizlocked		*/
bool		    newlock;		/* Game is newlocked		*/
bool _str_cmp args ((const char *astr, const char *bstr, char *file, int line));
bool	str_suffix	args( ( const char *astr, const char *bstr ) );
bool	str_cmp		args( ( const char *astr, const char *bstr ) );
bool	str_prefix	args( ( const char *astr, const char *bstr ) );
bool	str_infix	args( ( const char *astr, const char *bstr ) );

/* global questing */
bool generate_gquest args((CHAR_DATA * who));
bool is_random_gqmob args((int vnum));
bool start_gquest args((CHAR_DATA * ch, char *argument));
bool load_gquest_data args((void));
bool save_gquest_data args((void));
void auto_gquest args((void));
void end_gquest args((void));
void gquest_update args((void));
void gquest_wait args((void));
int count_gqmobs args((CHAR_DATA * ch));
int is_gqmob args((CHAR_DATA * ch, int vnum));
void reset_gqmob args((CHAR_DATA * ch, int value));

bool	can_drop_obj	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
bool	can_see_obj	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
bool	can_see		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	can_see_room	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex) );
bool	room_is_private	args( ( ROOM_INDEX_DATA *pRoomIndex ) );
bool is_same_sex args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	is_old_mob	args ( (CHAR_DATA *ch) );
bool	is_name		args( ( char *str, char *namelist ) );
bool	is_exact_name	args( ( char *str, char *namelist ) );
bool	is_affected	args( ( CHAR_DATA *ch, int sn ) );
void	extract_char	args( ( CHAR_DATA *ch, bool fPull ) );
OD *    get_obj_wear	args( ( CHAR_DATA *ch, char *argument, bool character ));
OD *	get_obj_here	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room, char *argument ) );
OD *	get_obj_world	args( ( CHAR_DATA *ch, char *argument ) );
OD *    get_obj_by_vnum args( ( CHAR_DATA *ch, char *argument ) );
bool check_coins args( ( CHAR_DATA *ch, int cost, int start, int stop ) );
bool	room_is_dark	args( ( ROOM_INDEX_DATA *pRoomIndex ) );
bool	is_room_owner	args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room) );
bool	p_exit_trigger   args( ( CHAR_DATA *ch, int dir, int type ) );
bool	mp_percent_trigger args( ( CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
bool	p_percent_trigger args( ( CHAR_DATA *mob, OBJ_DATA *obj,
				ROOM_INDEX_DATA *room, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
#endif // prool
void trap_damage args(( CHAR_DATA *ch, OBJ_DATA *obj ));
void group_char args(( CHAR_DATA *ch ));

/* added for intro quotes - Dalsor */
void do_quoter   args((CHAR_DATA *ch));
void display_races args((CHAR_DATA *ch));
void display_eye_color args((CHAR_DATA *ch));
void display_aiel_societies args((CHAR_DATA *ch));
void display_aiel_clans args((CHAR_DATA *ch));
void display_trollocs args((CHAR_DATA *ch));
void display_char_ogier args((CHAR_DATA *ch));
void display_char_trolloc args((CHAR_DATA *ch));
void display_char_aielman args((CHAR_DATA *ch));
void display_char_seafolk args((CHAR_DATA *ch));
void display_char_channeler args((CHAR_DATA *ch));
void display_random_chance args((CHAR_DATA *ch));
void display_hair_cut args((CHAR_DATA *ch));
void display_prime_hair args((CHAR_DATA *ch));
void display_secondary_hair args((CHAR_DATA *ch));
void display_tertiary_hair args((CHAR_DATA *ch));
void display_backgrounds args((CHAR_DATA *ch));
void accept_rules args((CHAR_DATA *ch));
void confirm_new_name args((CHAR_DATA *ch));
int		    wizlock_timer;	/* Countdown timer until game is auto-unwizlocked */

bool check_anticipate args(( CHAR_DATA *ch ));
bool check_precision args(( CHAR_DATA *ch ));
bool check_efficient args(( CHAR_DATA *ch ));
bool check_gifted args(( CHAR_DATA *ch ));
bool check_windfall args(( CHAR_DATA *ch ));
bool check_angrealstudy args(( CHAR_DATA *ch ));
void show_evaluation args(( CHAR_DATA *ch, OBJ_DATA *obj ));
void do_evaluate args(( CHAR_DATA *ch, char *argument ));
void do_bribe args(( CHAR_DATA *ch, char *argument ));
bool check_intimidate args(( CHAR_DATA *ch ));
bool check_truesense args(( CHAR_DATA *ch ));
void quest_engrave args(( CHAR_DATA *ch, char *argument ));
void quest_balance args(( CHAR_DATA *ch, char *argument ));
void quest_disguise args(( CHAR_DATA *ch, char *argument ));
void quest_bloodlust args(( CHAR_DATA *ch, char *argument ));
bool check_feint args(( CHAR_DATA *ch ));
bool check_lunge args(( CHAR_DATA *ch ));
bool check_stagger args(( CHAR_DATA *ch ));
bool check_shieldbash args(( CHAR_DATA *ch ));
bool check_swordbreak args(( CHAR_DATA *ch ));
bool check_chop args(( CHAR_DATA *ch ));
bool check_draw args(( CHAR_DATA *ch ));
bool check_sweep args(( CHAR_DATA *ch ));
bool check_dismember args(( CHAR_DATA *ch ));
bool check_ravage args(( CHAR_DATA *ch ));
void skin args(( CHAR_DATA *ch, OBJ_DATA *corpse, bool isAuto ));
int true_op_average args((CHAR_DATA *ch));
int true_angreal_bonus args((CHAR_DATA *ch));
int op_average args((CHAR_DATA *ch));

void stop_spell args ((CHAR_DATA *ch));

int roomcount args((CHAR_DATA *ch));
int count_skills args((CHAR_DATA *ch));
int count_weaves args((CHAR_DATA *ch));
void ship_init args(( void ));
bool spearmaster args(( CHAR_DATA *ch ));
int get_secondary_sn args((CHAR_DATA *ch));

bool weaponless args(( CHAR_DATA *ch ));
FILE *file_open args((const char *file, const char *mode));


void add_channel_log		args((char *channel, char *from, char *to, char *msg));
void show_channel_logs		args((CHAR_DATA *ch, char *channel));

/* Programs */
PROG_LIST	*new_oprog		args ( ( void ) );
void		free_oprog		args ( ( PROG_LIST *op ) );
PROG_LIST	*new_rprog		args ( ( void ) );
void		free_rprog		args ( ( PROG_LIST *rp ) );
PROG_CODE	*new_opcode		args ( ( void ) );
void		free_opcode		args ( ( PROG_CODE *pOcode ) );
PROG_CODE	*new_rpcode		args ( ( void ) );
void		free_rpcode		args ( ( PROG_CODE *pRcode ) );

#undef	CD
#undef	MID
#undef	OD
#undef	OID
#undef	RID
#undef	SF
#undef AD

/*****************************************************************************
 *                                    OLC                                    *
 *****************************************************************************/

/*
 * Object defined in limbo.are
 * Used in save.c to load objects that don't exist.
 */
#define OBJ_VNUM_DUMMY	30

/*
 * Area flags.
 */
#define         AREA_NONE       0
#define         AREA_CHANGED    1	/* Area has been modified. */
#define         AREA_ADDED      2	/* Area has been added to. */
#define         AREA_LOADING    4	/* Used for counting in db.c */

#define MAX_DIR	10
#define NO_FLAG -99	/* Must not be used in flags or stats. */

/*
 * Global Constants
 */
extern	char *	const	dir_name        [];
extern	const	sh_int	rev_dir         [];          /* sh_int - ROM OLC */
extern	const	struct	spec_type	spec_table	[];

/*
 * Global variables
 */
extern		AREA_DATA *		area_first;
extern		AREA_DATA *		area_last;
extern		SHOP_DATA *		shop_last;
extern		QUEST_DATA *		quest_last;
extern		QUEST_DATA *		quest_first;

extern		int			top_affect;
extern		int			top_area;
extern		int			top_ed;
extern		int			top_exit;
extern		int			top_help;
extern		int			top_mob_index;
extern		int			top_obj_index;
extern		int			top_reset;
extern		int			top_room;
extern		int			top_shop;

extern		long			top_vnum_mob;
extern		long			top_vnum_obj;
extern		long			top_vnum_room;

extern		char			str_empty       [1];

extern		MOB_INDEX_DATA *	mob_index_hash  [MAX_KEY_HASH];
extern		OBJ_INDEX_DATA *	obj_index_hash  [MAX_KEY_HASH];
extern		ROOM_INDEX_DATA *	room_index_hash [MAX_KEY_HASH];

struct	clan_type	clan_table[MAX_CLAN];
extern	const	struct	class_type	class_table	[MAX_CLASS];
extern	const	struct	weapon_type	weapon_table	[];
extern  const   struct  item_type	item_table	[];
extern	const	struct	wiznet_type	wiznet_table	[];
extern	const	struct	attack_type	attack_table	[];
extern  const	struct  race_type	race_table	[];
extern	const	struct	pc_race_type	pc_race_table	[];
extern  const	struct	spec_type	spec_table	[];
extern	const	struct	liq_type	liq_table	[];
extern	const	struct	skill_type	skill_table	[MAX_SKILL];
extern  const   struct  weave_type  weave_table[MAX_WEAVES];
extern  const   struct  group_type      group_table	[MAX_GROUP];
extern          struct social_type      social_table	[MAX_SOCIALS];
extern	char *	const			title_table	[MAX_CLASS]
							[MAX_LEVEL+1]
							[2];
