/***************************************************************************

                      ___  _      _  _      _
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \__|_  /\_/\  /    \_/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
        intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

        ROM 2.4 is copyright 1993-1998 Russ Taylor
        ROM has been brought to you by the ROM consortium
            Russ Taylor (rtaylor@hypercube.org)
            Gabrielle Taylor (gtaylor@hypercube.org)
            Brian Moore (zump@rom.org)
        By using this code, you have agreed to follow the terms of the
        ROM license, in the file Rom24/doc/rom.license


***************************************************************************/
/* rounds to wait at a check_point before departing */
#define CARAVAN_WAIT 2
#define CHECK_POINT_OBJ_VNUM 23031
#define CHECK_POINTOBJ
#define CARAVAN_COST 25
const int MAX_CARAVANS = 0; /* total number of caravans */

struct Check_point_struct
{
	int loc;
	int vnum;
	bool all_off;
	char *next_check_points;
};

struct CaravanType
{
        char *name;
        int lowVnum; /* lowVnum is the deck of the caravan */
        int highVnum; /* highVnum is the Casino */
	int motion_type;
        int hops;
        int num_check_points; /* this is the number of check_points */
	struct Check_point_struct check_points[6];
};

struct Caravan_struct
{
        int location;
	int next_check_point;
	int wait_at_check_point;
#ifdef CHECK_POINTOBJ
	OBJ_DATA *check_point_obj;
#endif
};
struct Caravan_struct CaravanActive [] =
{
        { /* 0 Dummy */
                0,
		0,
		0,
        },
        { /* 1 Caemlynn to Tarvalon */
                0,
		0,
		0,
        },
        { /* 2 Tear to Ebou Dar */
                2,
		1,
		0,
        },
        { /* 3 Caryford to Illian */
                0,
		0,
		0,
        },
        { /* 4 Tear to Ebou Dar */
                11,
		3,
		0,
        },
        { /* 5 Ebou Dar to Falme and Arad Doman */
                0,
		0,
		0,
        },
        { /* 6 TarValon to Tear */
                9,
		3,
		0,
        },
        { /* 7 Ebou Dar to Falme and Arad Doman */
                10,
		3,
		0,
        },
};




const   struct  CaravanType CaravanTable [] =
{

        { /* 0 This is a dummy entry, ie no caravan has number 0 */
                "",
                0,              /* lowVnum  Main Deck */
                0,              /* highVnum casino */
		0,		/* motion type */
                0,              /* hops, */
        	0,		/* this is the number of check_points */
		{
			{0,0,FALSE,""}, /* Loc Vnum AllOff nextCheck_points */
		},
        },
        { /* 1 TarValon to Tear (and back) */
                "Dumpy Wagon",
                23099,          /* lowVnum  Main Deck */
                23099,          /* highVnum casino */
		1,		/* motion type */
                17,              /* hops, */
        	4,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,3276,FALSE,"Tar Valon and Fal Dara"},
			{5,9992,FALSE,"Fal Dara"},
			{9,9500,FALSE,"Tar Valon and Caemlynn"},
			{13,9992,FALSE,"Caemlynn"},
		},
		 
        },
    
    	{ /* 2 Tear to Ebou Dar (and back) */
                "Stella Maris",
                23045,          /* lowVnum Main Deck */
                23050,          /* highVnum casino */
		2,		/* motion type */
                19,             /* hops, */
        	4,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,12076,FALSE,"Illian and Ebou Dar"},
			{5,5774,FALSE,"Ebou Dar"},
			{10,8129,FALSE,"Illian and Tear"},
			{15,5774,FALSE,"Tear"},
		},
        },
        { /* 3 Caryford to Illian  (and back) */
                "Maid of the Cary",
                23041,          /* lowVnum Main Deck */
                23044,          /* highVnum casino */
		3,		/* motion type */
                9,              /* hops, */
        	4,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,1126,FALSE,"Tamielle and Illian"},
			{1,15501,FALSE,"Illian"},
			{5,5774,FALSE,"Tamielle and Carysford"},
			{8,15501,FALSE,"Carysford"},
		},
        },
        { /* 4 */ /* Tear to Ebou Dar and back */
                "Waverider",
                23051,              /* lowVnum Main Deck */
                23056,              /* highVnum casino */
		2,		/* motion type */
                19,             /* hops, */
        	4,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,12076,FALSE,"Illian and Ebou Dar"},
			{5,5774,FALSE,"Ebou Dar"},
			{10,8129,FALSE,"Illian and Tear"},
			{15,5774,FALSE,"Tear"},
		},
        },
        { /* 5 Ebou to Arad Doman City (and back) *//*mostly Chris */
                "Ocean Dancer",
                23057,          /* lowVnum Main Deck */
                23062,          /* highVnum casino */
		5,		/* motion type */
                25,             /* hops, */
        	6,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,8129,FALSE,"Tanchico, Falme and Arad Doman City"},
			{6,5505,FALSE,"Falme and Arad Doman City"},
			{8,21399,FALSE,"Arad Doman City"},
			{13,19076,FALSE,"Tanchico, Falme and Ebou Dar"},
			{18,21399,FALSE,"Tanchico and Ebou Dar"},
			{23,5505,FALSE,"Ebou Dar"}
		},
        },
        { /* 6 TarValon to Tear (and back) */
                "Hardell's Folly",
                23036,          /* lowVnum  Main Deck */
                23040,          /* highVnum casino */
		1,		/* motion type */
                17,              /* hops, */
        	4,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,7233,FALSE,"Aringill and Tear"},
			{5,696,FALSE,"Tear"},
			{9,12070,FALSE,"Aringill and Tar Valon"},
			{13,696,FALSE,"Tar Valon"},
		},
        },
        { /* 7 Ebou to Arad Doman City (and back) *//* Cierin */
                "Wildrose",
                23064,          /* lowVnum Main Deck */
                23068,          /* highVnum casino */
		5,		/* motion type */
                25,             /* hops, */
        	6,		/* this is the number of check_points */
		{		/* Vnum AllOff nextCheck_points */
			{0,8129,FALSE,"Tanchico, Falme and Arad Doman City"},
			{6,5505,FALSE,"Falme and Arad Doman City"},
			{8,21399,FALSE,"Arad Doman City"},
			{13,19076,FALSE,"Tanchico, Falme and Ebou Dar"},
			{18,21399,FALSE,"Tanchico and Ebou Dar"},
			{23,5505,FALSE,"Ebou Dar"}
		},
        },
#if 0
        { /*  Ebou Dar to Isle of Mad Men(and back) */
                "skimmer",
                13407,          /* lowVnum Main Deck */
                13410,          /* highVnum casino */
                0,             /* hops, */
                0,              /* Mid Check_point Illian*/
                0,              /* Vnum of Check_point in first*/
                0,              /* Vnum of Check_point in mid */
                0,              /* Vnum of Check_point in last */
		{"",""}, 	/* Direction 0 Dest, Direction 1 Dest */
        },
        { /*  Ebou Dar to Tremalking (and back) */
                "raker",
                13417,
                13419,
        },

#endif 

};

const char *CaravanMotionTable[][26] = /* caravan, direction, location,
char in array */
{{
/* caravan 0 */
                "caravan 0, direction 0, location 0",
                "caravan 0, direction 1, location 0",
                },{
/* caravan 1 */ /* Tar Valon to Tear by way of Aringill */
                "The %s stops at the Transit Authority of Caemlynn.",
                "The %s departs Caemlynn, and heads north.",
                "The %s tries to pick up speed as it hits the main road, but is thwarted.",
                "Tar Valon and Dragonmount appear to the north.",
                "The southern gates of Tar Valon come into view.",
                "The %s stops on the south side of Tar Valon.",
                "The %s leaves the south gate of Tar Valon and departs north.",
                "The %s makes excellent progress, speeding along the sparely travelled road.",
                "The outskirts of Fal Dara appear towards the not so distant north.",
                "The %s stops just a fair distance from the gate of Fal Dara.",
                "The %s moves away from its stop, thankful to be leaving the Borderland.",
                "The driver steadily manuevers the %s down the road.",
                "Time passes slowly during the trip.",
                "The %s stops in Tar Valon.",
                "The %s leaves the south gate of Tar Valon and heads down the road toward Caemlynn.",
                "The smoking peak of Dragonmount disappears on the horizon.",
                "The road's traffic jostle against the %s.",
                "The %s nears the south gate of Caemlynn.",
                },{
/* caravan 2 */ /* Tear to Ebou Dar */
                "The %s ports in Tear and it's cargo is traded off onto a sailing caravan.",
                "The %s travels smoothly through the water, leaving Tear behind.",
                "The %s sails easily through smooth waters.",
                "A thin green line marks the shore in the distance.",
                "The %s approaches the check_points of Illian.",
                "The %s check_points at the port of Illian and readies for the trip to Ebou Dar.",
                "The %s leaves the port of Illian, bound for Ebou Dar.",
                "A thin green line marks the shore in the distance.",
                "A tall wave washes over the caravan's deck.",
                "The check_points of Ebou Dar appear on the horizon.",
                "The %s check_points in Ebou Dar and it's cargo is traded off onto a Seafolk raker.",
                "The %s leaves the check_points of Ebou Dar, speeding east towards Illian.",
                "The %s cuts through the choppy waves of the Sea of Storms.",
                "Spray splashes across the deck.",
                "The %s swiftly approaches the check_points of Illian, towards the east.",
                "The %s ports in Illian, and readies it's cargo for Tear.",
                "The %s leaves Illian behind, bound for Tear.",
                "A swift wind speeds the %s towards Tear.",
                "A flight of gulls pass overhead, heading north towards land.",
                "Tear becomes visible from a distance.",
/* caravan 3 */     },{  /* CarysFord to Illian */
                "The %s is pulled into the check_point at Carysford by two young boys.",
		"The %s check_points at Tamielle.",
/*                "The riverboat pulls slowly away from the check_point at Carysford.",a*/
                "The %s lurches as it moves into an area of rapids.",
                "The %s enters into a heavily forested area and the scent of pine fills the air.",
                "The city of Illian appears in the distance. Tall spires and great houses are easily seen.",
                "The %s check_points in Illian.",
                "The %s pulls away from the check_point at Illian, headed north.",
                "The %s moves through a thickly forested area.",
/*                "Water washes over the deck as the boat makes its way through the rapids.",*/
                "A pair of deckhands begin to squabble over a game of dice.",
		"Water splashes on the deck as the %s check_points at Tamielle.",
/* caravan 4 */ 	},{ /* Open */
                },{
/* caravan 5 */
                "The %s check_points in the port of Ebou Dar.",
                "The %s sails west, leaving Ebou Dar behind.",
                "Waves grow rough as the Shadow Coast comes into view.",
                "The %s turns in a southernly direction to pass around the rocky Windbiters Finger.",
                "The heights of Tremalking appear to the west, the sun sparkling off a large piece of crystal.",
                "The %s passes between Sea Folk Islands and the coast of Tanchico.",
		"The %s check_points in Tanchico at the Calpene Check_points.",
                "Leaving Tanchico behind, Toman Head appears to the North.",
                "The %s check_points in Falme, taking on new goods and passengers.",
                "Hugging close to shore, the %s leaves for Arad Doman.",
                "Bright lights from Bandar Eban twinkle on the horizon.",
                "A Sea Folk raker passes by.",
                "The %s approaches the check_points of Bandar Eban.",
                "The %s check_points in Arad Doman, and unloads its cargo.",
                "The %s sets sail south from Bandar Eban.",
                "The lights of Arad Doman fade as the %s enters deep water.",
                "Toman Head becomes visible to the south.",
                "The city of Falme rises over the horizon.",
                "The %s check_points in Falme, and goods are exchanged.",
                "Full of new goods the %s leaves the check_points.",
                "Toman Head quickly fades from view as the %s sails south.",
		"Winds and waves buffet the %s.",
                "The city of Tanchico stands out to the east.",
		"The %s check_points at the Calpene Check_points in Tanchico.",
                "Waves grow rough as the %s rounds the Shadow Coast.",
                "Ebou Dar appears close to the north.",
},};

extern const struct CaravanType CaravanTable[]; // moved to end of file by prool
