/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


struct companion_type
{
	char *  type;       /* generic name */
	char *  sound;      /* most commonly made sound */
	int     food_vnum;       /* vnum of specific food type */
	                         /* types are berries 100, fish 101, */
	                         /* steak 102, seed 103, sugar 104, */
	                         /* insects 105, nuts 106, worms 107, */
	                         /* mouse 108, fruit 109, veggies 110 */
	char *  adult_act1; /* random adult action */
	char *  adult_act2; /* random adult action */
	char *  adult_act3; /* random adult action */
	int     sector;     /* the three most common sector types */
	sh_int  alignment;       /* suggests what guild type it would go to */
	                         /* with -1 being Shadow type guilds */
	                         /* 0 being any neutral type guild */
	                         /* 1 being Light type guilds */
	char *  guilds[3];       /* names of the three guilds that can get this type */
};
const   struct  companion_type companion_table [] =
{
	{
		"bat", "squeak", 105,
		"%s squeaks and chitters, then settles down",
		"%s stretches its leathery wings",
		"%s closes its eyes and utters a soft churr",
		SECT_FIELD|SECT_FOREST|SECT_MOUNTAIN, -1,
		{ "", "", "" },
	},
	{
		"bear","grunt", 102,
		"%s yawns and licks its chops",
		"%s cleans its paws",
		"%s sniffs the air",
		SECT_FOREST|SECT_HILLS|SECT_MOUNTAIN, 0,
		{ "", "", "" },
	},
	{
		"cat", "meeow", 101,
		"%s curls into a ball and closes its eyes",
		"%s cleans its paws",
		"%s lifts its head and looks around curiously",
		SECT_CITY|SECT_FIELD|SECT_FOREST, 0,
		{ "", "", "" },
	},
	{
		"chipmunk", "chitter", 106,
		"%s chatters noisily for a moment",
		"%s poses with its head cocked to the side",
		"%s stands upright on its hind legs to peer around",
		SECT_FIELD|SECT_FOREST|SECT_HILLS, 0,
		{ "", "", "" },
	},
	{
		"cougar", "rumble", 102,
		"%s crouches with its ears perked forward",
		"%s twitches its tail back and forth",
		"%s bares its teeth in a drawn out yawn",
		SECT_MOUNTAIN|SECT_FOREST|SECT_HILLS, 0,
		{ "", "", "" },
	},
	{
		"crow", "caw", 100,
		"%s hops on one foot for a moment then stops and caws loudly",
		"%s's eyes take on a mischevious glimmer",
		"A glint of light flashes in %s's eyes",
		SECT_FIELD|SECT_FOREST|SECT_ROAD, -1,
		{ "", "", "" },
	},
	{
		"darkhound", "howl", 102,
		"%s paces around in a circle and growls low",
		"%s sits on its haunches and utters a resounding yowl",
		"%s growls and looks around itself suspiciously",
		SECT_BLIGHT|SECT_DESERT|SECT_WASTE, -1,
		{ "", "", "" },
	},
	{
		"dog", "bark", 102,
		"%s wags its tail and looks around expectantly",
		"%s stretches out and lies down on its belly",
		"%s barks and wags its tail",
		SECT_FIELD|SECT_HILLS|SECT_CITY, 0,
		{ "", "", "" },
	},
	{
		"dove", "coo", 103,
		"%s stretches out one wing at a time",
		"%s picks at its feathers with its beak",
		"%s softly coos",
		SECT_FIELD|SECT_CITY|SECT_HILLS, 1,
		{ "", "", "" },
	},
	{
		"eagle", "screech", 101,
		"%s closes its wings tightly and shifts from one foot to the other",
		"%s stretches its wings wide",
		"%s emits a long, piercing screech",
		SECT_MOUNTAIN|SECT_FOREST|SECT_WATER_SWIM, 1,
		{ "", "", "" },
	},
	{
		"falcon", "screech", 101,
		"%s cocks its head and peers at something in the distance",
		"%s cleans its feathers with its sharp beak",
		"%s stretches its wings and cries out a shrill screech",
		SECT_MOUNTAIN|SECT_FOREST|SECT_WATER_SWIM, 1,
		{ "", "", "" },
	},
	{
		"ferret", "chirp", 110,
		"%s wags its tail back and forth rapidly",
		"%s hops from side to side on all four feet",
		"%s's tail puffs up and it chirps noisily",
		SECT_FOREST|SECT_MOUNTAIN|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"fox", "yip", 101,
		"%s hangs its toungue from the side of its mouth and pants softly",
		"%s cocks its ears forward and listens intently",
		"%s swishes its bushy tail slowly from side to side",
		SECT_MARSH|SECT_TUNDRA|SECT_COASTAL, 0,
		{ "", "", "" },
	},
	{
		"frog", "ribbet", 105,
		"%s croaks",
		"%s hops then stops to taste the air",
		"%s ribbets",
		SECT_WATER_SWIM|SECT_FOREST|SECT_MARSH, 0,
		{ "", "", "" },
	},
	{
		"goshawk", "screech", 108,
		"%s uses its hook like talons to clean itself",
		"%s flutters its wings and bobs its head",
		"%s spreads its wings and takes a long hop forward",
		SECT_FOREST|SECT_FIELD|SECT_HILLS, 0,
		{ "", "", "" },
	},
	{
		"gull", "squall", 101,
		"%s slowly unfurls its wings and stretches luxuriously",
		"%s extends its wings and paces in a slow circle",
		"%s flutters its wings several times",
		SECT_COASTAL|SECT_RIVER_SALT|SECT_LAKE_SALT, 0,
		{ "", "", "" },
	},
	{
		"harrier", "screech", 108,
		"%s spreads its wings and furls its feathers in a proud show",
		"%s preens its feathers with its left foot",
		"The feathers covering %s's neck puff out",
		SECT_MARSH|SECT_FIELD|SECT_COASTAL, 0,
		{ "", "", "" },
	},
	{
		"hawk", "screech", 108,
		"",
		"",
		"",
		SECT_FIELD|SECT_FOREST|SECT_COASTAL, 0,
		{ "", "", "" },
	},
	{
		"horse", "neigh", 104,
		"%s snorts and paws the ground",
		"%s swishes its tail",
		"%s shakes its name",
		SECT_FIELD|SECT_PLAIN|SECT_STEPPE, 0,
		{ "", "", "" },
	},
	{
		"iguana", "hiss", 110,
		"%s flicks its tongue",
		"%s flicks its tail back and forth",
		"%s cranes its neck to look around",
		SECT_JUNGLE|SECT_LAKE_SALT|SECT_RIVER_SALT, 0,
		{ "", "", "" },
	},
	{
		"kestrel", "", 0,
		"",
		"",
		"",
		SECT_LAKE_FRESH|SECT_RIVER_FRESH|SECT_FOOTHILLS, 0,
		{ "", "", "" },
	},
	{
		"lizard", "", 0,
		"",
		"",
		"",
		SECT_CITY|SECT_FIELD|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"osprey", "", 0,
		"",
		"",
		"",
		SECT_LAKE_FRESH|SECT_PLAIN|SECT_STEPPE, 0,
		{ "", "", "" },
	},
	{
		"panther", "", 0,
		"",
		"",
		"",
		SECT_COASTAL|SECT_LAKE_FRESH|SECT_LAKE_SALT, 0,
		{ "", "", "" },
	},
	{
		"piglet", "", 0,
		"",
		"",
		"",
		SECT_FARMLAND|SECT_FIELD|SECT_MEADOW, 0,
		{ "", "", "" },
	},
	{
		"pigeon", "", 0,
		"",
		"",
		"",
		SECT_FIELD|SECT_PLAIN|SECT_MEADOW, 0,
		{ "", "", "" },
	},
	{
		"rabbit", "", 0,
		"",
		"",
		"",
		SECT_FARMLAND|SECT_MEADOW|SECT_FOREST, 0,
		{ "", "", "" }
	},
	{
		"raccoon", "", 0,
		"%s cleans its face with its paws",
		"%s chitters nervously",
		"%s takes a few steps and pauses to sniff the air",
		SECT_LAKE_FRESH|SECT_FOREST|SECT_MEADOW, 0,
		{ "", "", "" },
	},
	{
		"raven", "", 0,
		"",
		"",
		"",
		SECT_FIELD|SECT_PLAIN|SECT_STEPPE, -1,
		{ "", "", "" },
	},
	{
		"salamander", "", 0,
		"",
		"",
		"",
		SECT_RIVER_FRESH|SECT_LAKE_FRESH|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"snake", "", 0,
		"%s draws its body into a tight coil",
		"%s stretches its length and then curls around itself loosely",
		"%s tastes the air with its tongue",
		SECT_FIELD|SECT_FOREST|SECT_JUNGLE, 0,
		{ "", "", "" },
	},
	{
		"squirrel", "", 0,
		"",
		"",
		"",
		SECT_FOREST|SECT_MEADOW|SECT_FIELD, 0,
		{ "", "", "" },
	},
	{
		"toad", "", 0,
		"",
		"",
		"",
		SECT_RIVER_FRESH|SECT_LAKE_FRESH|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"turtle", "", 0,
		"",
		"",
		"",
		SECT_RIVER_FRESH|SECT_LAKE_FRESH|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"wildcat", "", 0,
		"",
		"",
		"",
		SECT_RIVER_FRESH|SECT_LAKE_FRESH|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{
		"wolf", "", 0,
		"",
		"",
		"",
		SECT_RIVER_FRESH|SECT_LAKE_FRESH|SECT_WATER_SWIM, 0,
		{ "", "", "" },
	},
	{ "", "", 0, "", "", "", SECT_INSIDE|SECT_INSIDE|SECT_INSIDE, 0, { "", "", "" },
},
};
extern const struct companion_type companion_table[]; // prool
