/***************************************************************************

                      ___  _      _  _      _
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \__|_  /\_/\  /    \_/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#define DanceStepNone               0
#define DanceStepLeft               1
#define DanceStepRight              2
#define DanceStepForward            3
#define DanceStepBackward           4
#define DanceStepClockwise          5
#define DanceStepCounterClockwise   6
#define DanceStepDip                7
#define DanceStepLean               8
#define DanceStepCheekToCheek       9

/* left, right, backwards, forwards, spin clockwise, spin counterclockwise,
 * dip, lean, cheek to cheek
 */
struct DanceType
{
	char    *danceName;
	char    *danceChar;
	char    *dancePartner;
	char    *danceRoom;
	sh_int   step;
	sh_int   stepReq;
	sh_int   stepPartnerReq;
	sh_int   points;
};
const   struct  DanceType DanceTable [] =
{
	{ /* 1 */
		"left",
		"You step left as $N steps right.",
		"$n steps left as you step right.",
		"$n steps left as $N steps right.",
		DanceStepLeft,
		DanceStepNone,
		DanceStepNone,
		1,
	},
	{ /* 2 */
		"right",
		"You step right as $N steps left.",
		"$n steps right as you step left.",
		"$n steps right as $N steps left.",
		DanceStepRight,
		DanceStepLeft,
		DanceStepRight,
		1,
	},
	{ /* 3 */
		"backward",
		"You step back as $N steps forward.",
		"$n steps back as you step forward.",
		"$n steps back as $N steps forward.",
		DanceStepBackward,
		DanceStepBackward,
		DanceStepForward,
		2,
	},
	{ /* 4 */
		"forward",
		"You step forward as $N steps back.",
		"$n steps forward as you step back.",
		"$n steps forward as $N steps back.",
		DanceStepForward,
		DanceStepForward,
		DanceStepBackward,
		2,
	},
	{ /* 5 */
		"clockwise",
		"You spin clockwise as $N spins counter clockwise.",
		"$n spins clockwise as you spin counter clockwise.",
		"$n spins clockwise as $N spins counter clockwise.",
		DanceStepClockwise,
		DanceStepCounterClockwise,
		DanceStepCounterClockwise,
		5,
	},
	{ /* 6 */
		"counter clockwise",
		"You spin counter clockwise as $N spins clockwise.",
		"$n spins counter clockwise as you spin clockwise.",
		"$n spins counter clockwise as $N spins clockwise.",
		DanceStepCounterClockwise,
		DanceStepClockwise,
		DanceStepClockwise,
		5,
	},
	{ /* 7 */
		"dip",
		"You dip $N as $E leans back.",
		"$n dips you as you lean back.",
		"$n dips $N as $E leans back.",
		DanceStepDip,
		DanceStepDip,
		DanceStepLean,
		10,
	},
	{ /* 8 */
		"lean",
		"You lean back as $N dips you.",
		"$n leans back as you dip $m.",
		"$n leans back as $N dips $m.",
		DanceStepLean,
		DanceStepLean,
		DanceStepDip,
		10,
	},
	{ /* 9 */
		"cheek to cheek",
		"You dance cheek to cheek with $N.",
		"$n dances cheek to cheek with you.",
		"$n dances cheek to cheek with $N.",
		DanceStepCheekToCheek,
		DanceStepCheekToCheek,
		DanceStepCheekToCheek,
		20,
	},
};
extern const struct DanceType DanceTable[]; // prool
