/*
 * String and memory management parameters.
 */
#define	MAX_KEY_HASH		 8192
//#define MAX_STRING_LENGTH	 9216
#define MAX_STRING_LENGTH	 16000
#define MAX_INPUT_LENGTH	  512 /* doubled */
#define PAGELEN			       22

#define MSL MAX_STRING_LENGTH
#define MIL MAX_INPUT_LENGTH
#define ptc printf_to_char
#define stc send_to_char
#define mlog add_mysql_log
#define strip_color color_strip

/*
 * Game parameters.
 * Increase the max'es if you add more of something.
 * Adjust the pulse numbers to suit yourself.
 */
#define MAX_SOCIALS		        450  /* Maximum number of socials allowed -1 */
#define MAX_SKILL               278  /* Maximum number of skills allowed */
#define MAX_WEAVES              259  /* Maximum number of weaves allowed */
#define MAX_FORM                45   /* Maximum number of skills allowed */
#define MAX_GROUP               31   /* Maximum number of groups allowed */
#define MAX_IN_GROUP		    15   /* Maxumum number of folks in the gorup */
#define MAX_ALIAS		        20   /* Maxmum number of alias a char may have */
#define MAX_BUDDY		        20   /* Maxmum number of buddies a char may have */
#define MAX_TRADE			 5
#define MAX_CLASS		        4    /* Maximum number of player classes */
#define MAX_PC_RACE		        36   /* Maximum number of player races */
#define MAX_CLAN		        50   /* Maximum number of clans/guilds allowed */
#define MAX_DAMAGE_MESSAGE	    59   /* Maximum number of damage messages allowed */
#define MAX_LEVEL		        1001 /* Maximum player/immortal levels in game */
#define MAX_IGNORE              10   /* Max number of people a character can ignore */
#define MAX_BEACONS             10   /* number of rooms that can be memorized */
#define MAX_GUILD_RELATIONS     17   /* number of relations for wearing guild eq, etc */
#define MAX_QSTEPS		25
#define MAX_UNITS               3
#define LEVEL_HERO		       ( 1000 ) /* Mortal remort level */
#define LEVEL_IMMORTAL		   ( 251 ) /* Used in IS_IMMORTAL checks */

#define PULSE_PER_SECOND	     4
#define PULSE_VIOLENCE		   ( 2 * PULSE_PER_SECOND )
#define PULSE_MOBILE		   ( 4 * PULSE_PER_SECOND )
#define PULSE_MUSIC		       ( 6 * PULSE_PER_SECOND )
#define PULSE_TICK		       ( 60 * PULSE_PER_SECOND )
#define PULSE_AREA		       ( 120 * PULSE_PER_SECOND )
#define PULSE_EVENT            ( 2 * PULSE_PER_SECOND)
#define PULSE_FERRY            ( 25 * PULSE_PER_SECOND )
#define PULSE_FIREOIL          ( 1 * PULSE_PER_SECOND )
#define PULSE_AUCTION          ( 10 * PULSE_PER_SECOND )
#define PULSE_HOUR             ( 7200 ) /* one MUD hour */
#define PULSE_MINUTE           ( 240 ) /* one real minute */
#define PULSE_DREAM		       ( 210 * PULSE_PER_SECOND )
#define PULSE_QUEST		       ( 60 * PULSE_PER_SECOND )

#define SKILL_CAP 999
#define QSKILL_CAP 400

#define MAX_TOWN_INVADE		10
#define MAX_VNUM            32768
#define MAX_ALLOWED_BUGS	200
#define	MAX_GQUEST_MOB      25
#define MAX_RANK            20 /* guild.c */

#define	MAX_EMAIL_TEXT         (4*MSL - 1000)

/*#define MINIMUM_BID			10*/
#define AUCTION_LENGTH       5

#define ADMINISTRATOR   (1000) /* 1000 Owner                        */
#define POWER           (500)  /* 500  The Powers That Be           */
#define	IMPLEMENTOR     (499)  /* 499  Coder                        */

#define	CREATOR			(450)
#define SUPREME			(400)
#define DEITY			(350)
#define GOD			    (300)
#define IMMORTAL		(251)
#define DEMI			(251)
#define ANGEL			(251)
#define AVATAR			(251)
#define HERO			(251)

#define MUD_OWNER "Avryel"
#define MUD_COIMP "Dalsor"
#define MUD_SIS "Avryel"
#define MUD_HB "Cerdwyn"
#define MUD_HC "Dalsor"
#define MUD_VERSION "TSE Open Beta. v4.11a"

#define TRUE_RACE_HUMAN 1
#define TRUE_RACE_TROLLOC 2
#define TRUE_RACE_OGIER 3

#define TALENT_NONE          1
#define TALENT_WARDING       2
#define TALENT_ELEMENTALISM  3
#define TALENT_HEALING       4
#define TALENT_CLOUD_DANCING 5
#define TALENT_EARTH_SINGING 6
#define TALENT_DELVING       7
#define TALENT_COMPULSION    8
#define TALENT_SHIELDING     9
#define TALENT_TRAVELLING    10
#define TALENT_MILKING_TEARS 11
#define TALENT_ILLUSION      12
#define TALENT_MATRIX_ALIGN  13
#define TALENT_EARTHFIRE     14
#define TALENT_UNRAVELLING   15
#define TALENT_MAX           16

#define W_TALENT_WARDING       (A)
#define W_TALENT_ELEMENTALISM  (B)
#define W_TALENT_HEALING       (C)
#define W_TALENT_CLOUD_DANCING (D)
#define W_TALENT_EARTH_SINGING (E)


#define JUNK_CH_JEWELS		(A)
#define JUNK_CH_FIGURINES	(B)
#define JUNK_CH_SCRLPOTSPILL	(C)
#define JUNK_CH_WEAPONS		(D)
#define JUNK_CH_EQUIPMENT	(E)
#define JUNK_CH_LOCKPICKS	(F)
#define JUNK_CH_ANGREALS	(G)
#define JUNK_CH_FOOD		(H)
#define JUNK_CH_ACCESSORIES	(I)
#define JUNK_CH_MANUALS		(J)
#define JUNK_CH_MATERIALS	(K)
#define JUNK_CH_DYES		(L)
#define JUNK_CH_ADORNMENTS	(M)
#define JUNK_CH_BOXES           (N)

/* spearform defines */
#define StanceEagleESW (A)
#define StanceEagleESC (B)
#define StanceEagleEDP (C)
#define StanceEagleESP (D)
#define StanceEagleTGE (E)

#define StanceCaparCRF (A)
#define StanceCaparCHG (B)
#define StanceCaparCWW (C)
#define StanceCaparCST (D)
#define StanceCaparTCC (E)

#define StanceGaraGTA (A)
#define StanceGaraGLT (B)
#define StanceGaraGST (C)
#define StanceGaraGDS (D)
#define StanceGaraTGB (E)

#define StanceHareHSB (A)
#define StanceHareHDH (B)
#define StanceHareHLS (C)
#define StanceHareHAM (D)
#define StanceHareTHW (E)

#define StanceSnakeMKS (A)
#define StanceSnakeRCD (B)
#define StanceSnakeBST (C)
#define StanceSnakeSSS (D)
#define StanceSnakeTTV (E)

#define StanceJiTDH (A)
#define StanceJiSAH (B)
#define StanceJiTWH (C)
#define StanceJiDAH (D)
#define StanceJiTOH (E)

#define StanceSandTSS (A)
#define StanceSandTBS (B)
#define StanceSandTES (C)
#define StanceSandIOW (D)
#define StanceSandSTH (E)

#define StanceRidgecatRSP (A)
#define StanceRidgecatRBC (B)
#define StanceRidgecatRPC (C)
#define StanceRidgecatRFL (D)
#define StanceRidgecatDTH (E)

#define StanceLionLSF (A)
#define StanceLionLAS (B)
#define StanceLionLOP (C)
#define StanceLionTLH (D)
#define StanceLionTPW (E)

#define StanceDreamLAD (A)
#define StanceDreamWFD (B)
#define StanceDreamWTD (C)
#define StanceDreamDTW (D)
#define StanceDreamDOH (E)

#define StanceShadowSIN (A)
#define StanceShadowSTN (B)
#define StanceShadowTIS (C)
#define StanceShadowAIN (D)
#define StanceShadowCTS (E)

#define StanceWrathARF (A)
#define StanceWrathVOW (B)
#define StanceWrathDOR (C)
#define StanceWrathALS (D)
#define StanceWrathWOS (E)

#define StanceMysticSTP (A)
#define StanceMysticWTP (B)
#define StanceMysticSOD (C)
#define StanceMysticCCC (D)
#define StanceMysticGOR (E)

#define StanceRingROS (A)
#define StanceRingROP (B)
#define StanceRingROA (C)
#define StanceRingROL (D)
#define StanceRingROD (E)

#define StanceEarthRTW (A)
#define StanceEarthTJC (B)
#define StanceEarthTDM (C)
#define StanceEarthTSM (D)
#define StanceEarthTRL (E)

#define StanceBalanceBTS (A)
#define StanceBalanceBOS (B)
#define StanceBalanceBOW (C)
#define StanceBalanceBOM (D)
#define StanceBalanceBOP (E)

#define StanceDanceDTS (A)
#define StanceDanceSOR (B)
#define StanceDanceDTD (C)
#define StanceDanceSOW (D)
#define StanceDanceDOD (E)

#define sStanceNone (A)
#define sStanceEagle (B)
#define sStanceCapar (C)
#define sStanceGara (D)
#define sStanceHare (E)
#define sStanceSnake (F)
#define sStanceJi (G)
#define sStanceSand (H)
#define sStanceRidgecat (I)
#define sStanceLion (J)
#define sStanceDream (K)
#define sStanceShadow (L)
#define sStanceWrath (M)
#define sStanceMystic (N)
#define sStanceRing (O)
#define sStanceEarth (P)
#define sStanceBalance (Q)
#define sStanceDance (R)

/* BLADEform definitions */
#define StanceHeronHOW (A)
#define StanceHeronHRW (B)
#define StanceHeronHSW (C)
#define StanceHeronHRA (D)
#define StanceHeronSTS (E)

#define StanceWindABW (A)
#define StanceWindCTF (B)
#define StanceWindFTF (C)
#define StanceWindLWR (D)
#define StanceWindWOM (E)

#define StanceWaterMOW (A)
#define StanceWaterMRW (B)
#define StanceWaterRUB (C)
#define StanceWaterWFD (D)
#define StanceWaterTWS (E)

#define StanceSkyAOM (A)
#define StanceSkyLLS (B)
#define StanceSkyRIA (C)
#define StanceSkyWAR (D)
#define StanceSkyLIS (E)

#define StanceStoneBTS (A)
#define StanceStoneTGT (B)
#define StanceStoneSFC (C)
#define StanceStoneSFM (D)
#define StanceStoneFOS (E)

#define StanceStormCAG (A)
#define StanceStormTSG (B)
#define StanceStormLOH (C)
#define StanceStormTSA (D)
#define StanceStormLSS (E)

#define StanceLizardTLL (A)
#define StanceLizardLIT (B)
#define StanceLizardLTA (C)
#define StanceLizardTLS (D)
#define StanceLizardLFT (E)

#define StanceBoarBIB (A)
#define StanceBoarHOB (B)
#define StanceBoarBRB (C)
#define StanceBoarBOH (D)
#define StanceBoarBRM (E)

#define StanceBirdHKH (A)
#define StanceBirdWGD (B)
#define StanceBirdSTF (C)
#define StanceBirdSRA (D)
#define StanceBirdSDW (E)

#define StanceCatCSP (A)
#define StanceCatCTP (B)
#define StanceCatCTC (C)
#define StanceCatCSA (D)
#define StanceCatTCP (E)

#define StanceElementalTFL (A)
#define StanceElementalTFW (B)
#define StanceElementalUTF (C)
#define StanceElementalGOE (D)
#define StanceElementalROR (E)

#define StanceWillTOW (A)
#define StanceWillSOW (B)
#define StanceWillPOS (C)
#define StanceWillSIS (D)
#define StanceWillFOW (E)

#define StanceFireBRM (A)
#define StanceFireFLS (B)
#define StanceFirePOF (C)
#define StanceFireSTB (D)
#define StanceFireSOM (E)

#define StanceIceSFO (A)
#define StanceIceITR (B)
#define StanceIceTCI (C)
#define StanceIceIOW (D)
#define StanceIceTFW (E)

#define StanceSpiritGIW (A)
#define StanceSpiritVOW (B)
#define StanceSpiritSDS (C)
#define StanceSpiritGIM (D)
#define StanceSpiritROS (E)

#define StanceCircleCOT (A)
#define StanceCircleCOF (B)
#define StanceCircleCOP (C)
#define StanceCircleCOI (D)
#define StanceCircleCOS (E)

#define StanceCrownTJC (A)
#define StanceCrownTCS (B)
#define StanceCrownTEC (C)
#define StanceCrownTCW (D)
#define StanceCrownTCU (E)

#define StanceNone        (A)
#define StanceHeron       (B)
#define StanceWind        (C)
#define StanceWater       (D)
#define StanceSky         (E)
#define StanceStone       (F)
#define StanceStorm       (G)
#define StanceLizard      (H)
#define StanceBoar        (I)
#define StanceBird        (J)
#define StanceCat         (K)
#define StanceElemental   (L)
#define StanceWill        (M)
#define StanceFire        (N)
#define StanceIce         (O)
#define StanceSpirit      (P)
#define StanceCircle      (Q)
#define StanceCrown       (R)

#define MasteryOneM       "Youth"
#define MasteryTwoM       "Hopeful"
#define MasteryThreeM     "Armsman"
#define MasteryFourM      "The Aspirant"
#define MasteryFiveM      "The Skilled"
#define MasterySixM       "The Warrior"
#define MasterySevenM     "The Exhalted"
#define MasteryEightM     "The Master"
#define MasteryNineM      "The Lord"
#define MasteryTenM       "Blademaster"

#define MasteryOneF       "Youth"
#define MasteryTwoF       "Hopeful"
#define MasteryThreeF     "Armswoman"
#define MasteryFourF      "The Aspirant"
#define MasteryFiveF      "The Skilled"
#define MasterySixF       "The Warrioress"
#define MasterySevenF     "The Exhalted"
#define MasteryEightF     "The Mistress"
#define MasteryNineF      "The Lady"
#define MasteryTenF       "Blademistress"

#define MaxStance         17
#define MaxStanceHelp     25

//extern bool LOGSILENT; // prool

#define ACTION_NONE	0
#define ACTION_CASTING	1

#define MAX_SUMMARY        25
#define SUM_XP_EARNED      0
#define SUM_XP_EARNED_EVER 1
#define SUM_LEVELS_GAINED  2
#define SUM_LEVELS_GAINED_EVER 3
#define SUM_CRITICALS_INFLICTED 4
#define SUM_CRITICALS_INFLICTED_EVER 5
#define SUM_CRITICALS_TAKEN 6
#define SUM_CRITICALS_TAKEN_EVER 7
#define SUM_MOB_KILLS 8
#define SUM_PC_KILLS 9
#define SUM_PC_KILLS_EVER 10
#define SUM_TOURNIES_WON 11
#define SUM_TOURNIES_WON_EVER 12
#define SUM_TRIVIA_ANSWERED 13
#define SUM_TRIVIA_ANSWERED_EVER 14
#define SUM_MOTES 15
#define SUM_MOTES_EVER 16
#define SUM_AUCTIONS_WON 17
#define SUM_AUCTIONS_WON_EVER 18
#define SUM_DEATHS 19
#define SUM_DEATHS_EVER 20
#define SUM_REBIRTHS 21
#define SUM_QUESTS_DONE 22
#define SUM_QUESTS_DONE_EVER 23
#define SUM_QPS_EARNED 24
#define SUM_QPS_EARNED_EVER 25

#define TAG_OFF 0
#define TAG_ISWAIT 1
#define TAG_ISPLAY 2

#define FTAG_WAIT_ROOM      1050
#define FTAG_MIN_VNUM		30251
#define FTAG_MAX_VNUM		30300

#define TAG_PLAYING		        (A)
#define TAG_FROZEN		        (B)
#define TAG_RED			        (C)
#define TAG_BLUE			    (D)
#define TAG_WAITING             (E)

#define		GQUEST_OFF			0
#define		GQUEST_WAITING		1
#define		GQUEST_RUNNING		2

#define BAN_SUFFIX		A
#define BAN_PREFIX		B
#define BAN_NEWBIES		C
#define BAN_ALL			D
#define BAN_PERMIT		E
#define BAN_PERMANENT	F

#define GUILD_DELETED		A
#define GUILD_CHANGED		B
#define GUILD_INDEPENDENT 	C /* a "loner" guild */
#define GUILD_IMMORTAL		E /* immortal only clan */

#define KR_OK			0
#define KR_NO_KEYRING		1
#define KR_NO_KEY		2
#define KR_NO_REMKEY		3
#define KR_INVALID_KEYRING	4
#define KR_INVALID_KEY		5
#define KR_INVALID_NAME		6
#define KR_KEY_DUP		7

/*
 * Time and weather stuff.
 */
#define SUN_DARK		    0
#define SUN_RISE		    1
#define SUN_LIGHT		    2
#define SUN_SET			    3
#define SKY_CLOUDLESS		0
#define SKY_CLOUDY		    1
#define SKY_RAINING		    2
#define SKY_LIGHTNING		3

#define WIND_NORTH          0
#define WIND_NORTHEAST      1
#define WIND_EAST           2
#define WIND_SOUTHEAST      3
#define WIND_SOUTH          4
#define WIND_SOUTHWEST      5
#define WIND_WEST           6
#define WIND_NORTHWEST      7
#define WIND_MAX            8


/* Herb Types */
#define	HERB_NONE		0
#define	HERB_ACEM		1
#define	HERB_ANDILAY		2
#define	HERB_ASPINGROT		3
#define	HERB_BLUEGOATFLOWER	4
#define	HERB_BLUEWORT		5
#define	HERB_CHAINLEAF		6
#define	HERB_CRIMSONTHORN	7
#define	HERB_DOGWORT		8
#define	HERB_FEVERBANE		9
#define	HERB_FIVEFINGER		10
#define	HERB_FLATWORT		11
#define	HERB_FORKROOT		12
#define	HERB_FOXTAIL		13
#define	HERB_GOATSTONGUE	14
#define	HERB_GOOSEMINT		15
#define	HERB_GREENWORT		16
#define	HERB_GREYFENNEL		17
#define	HERB_GROUNDIVY		18
#define	HERB_HEALALL		19
#define	HERB_HONEY		20
#define	HERB_LIONHEART		21
#define	HERB_MARDROOT		22
#define	HERB_MARISIN		23
#define	HERB_MARSHWHITE		24
#define	HERB_PEACHPIT		25
#define	HERB_REDFENNEL		26
#define	HERB_SILVERLEAF		27
#define	HERB_SLEEPWELL		28
#define	HERB_SUNBURSTROOT	29
#define	HERB_TARCHROTLEAF	30
#define	HERB_TIMSINROOT		31
#define	HERB_WILLOWBARK		32
#define	HERB_WORRYNOT		33
#define MAX_HERB		34








/*
 * Connected state for a channel.
 */
#define CON_PLAYING			             0 /* Character is logged in and playing */
#define CON_GET_NAME			         1 /* New character, get their name */
#define CON_GET_OLD_PASSWORD		     2 /* Old character, confirm password */
#define CON_CONFIRM_NEW_NAME		     3 /* New character, confirm name */
#define CON_GET_NEW_PASSWORD		     4 /* New character, get password */
#define CON_CONFIRM_NEW_PASSWORD	     5 /* New character, confirm password */
#define CON_GET_NEW_RACE		         6 /* New character, get race */
#define CON_GET_NEW_SEX			         7 /* New character, get sex */
#define CON_GET_NEW_CLASS		         8 /* New character, get class */
#define CON_BREAK_CONNECT                9 /* Kill the connection to the character */
#define CON_COPYOVER_RECOVER            10 /* Reconnect players and load data */
#define CON_CHANNELER                   11 /* New character, ask if they want to channel */
#define CON_CHAR_BACKG                  12 /* New character, get background */
#define CON_CHAR_EYE                    13 /* New character, get eye color */
#define CON_GET_HAIR1                   14 /* New character, get hair color */
#define CON_GET_HAIR2                   15 /* New character, get hair shade */
#define CON_GET_HAIR3                   16 /* New character, get hair length */
#define CON_GET_HAIR4                   17 /* New character, get hair cut */
#define CON_CONNECT_CHAR                18 /* New character, get female misc info */
#define CON_CHAR_RANDOM                 19 /* New character, check for wolf, tav, etc */
#define CON_GET_AIEL_SOCIETY            20 /* Got an Aiel, get the Clan */
#define CON_GET_TROLLOC_CLAN            21 /* Got a Trolloc, get the Type */
#define CON_CLEAN_UP                    22 /* Roll some random stats */
#define CON_KEEP_STATS                  23 /* Keep the random stats? */
#define CON_GET_AIEL_CLAN               24 /* aiel clan */
#define CON_ACCEPT_FOLLOWER             25 /* will accept follower? */
#define CON_SHOW_POLICY                 26 /* show the policy to chars */
#define CON_ACCEPT_RULES                27 /* accept the rules of AWW or else */
#define CON_AIEL_SOCIETY_NEW		    28 /* Selection of "loner" aiel */
#define CON_SEANCHAN			        29 /* Forced guild */
#define CON_BUGREPORTING_MSG	        30
#define CON_BUGREPORTING_IMMINFO        31
#define CON_BUGREPORTING_MORTINFO       32
#define CON_GET_LAST_NAME               33
#define CON_NOTE_TO						34
#define CON_NOTE_SUBJECT				35
#define CON_NOTE_EXPIRE					36
#define CON_NOTE_TEXT					37
#define CON_NOTE_FINISH					38
#define CON_CHAR_DESCRIPTION            39
#define CON_GET_FAMILY_NAME			    40
#define CON_EMAIL_TO                    41
#define CON_EMAIL_SUBJECT               42
#define CON_EMAIL_BODY                  43
#define CON_EMAIL_FINISH                44
#define CON_SEAFOLK                     45
#define CON_INIT_NEWBIE                 46
#define CON_GET_EMAIL	                 47
#define CON_SELECT_GENDER 48
#define CON_SELECT_RACE 49
#define CON_SELECT_CLAN 50
#define CON_SELECT_NATION 51
#define CON_TOUR_PARTIAL 52
#define CON_TOUR_FULL 53
#define CON_SELECT_DETAIL 54

/*
 * TO types for act.
 */
#define TO_ROOM		    0
#define TO_NOTVICT	    1
#define TO_VICT		    2
#define TO_CHAR		    3
#define TO_ALL		    4



/* OP Spheres */
#define MAX_SPHERES	5
#define SPHERE_SPIRIT	0
#define SPHERE_AIR	1
#define SPHERE_EARTH	2
#define SPHERE_FIRE	3
#define SPHERE_WATER	4

/*
 * Per-class stuff.
 */

#define MAX_GUILD 	2
#define MAX_STATS 	8
#define STAT_STR 	0
#define STAT_INT	1
#define STAT_WIS	2
#define STAT_DEX	3
#define STAT_CON	4
#define STAT_REF	5
#define STAT_INS	6
#define STAT_CHA	7

#define STAT_NONE   0
#define STAT_SPIRIT 1
#define STAT_AIR    2
#define STAT_EARTH  3
#define STAT_FIRE   4
#define STAT_WATER  5
#define STAT_ALL    6

/*
 * Data structure for notes.
 */

#define PNOTE_NOTE	    0
#define PNOTE_IDEA	    1
#define PNOTE_PENALTY	2
#define PNOTE_NEWS	    3
#define PNOTE_CHANGES	4
#define PNOTE_ROLEPLAY   5
#define PNOTE_JOURNAL    6
#define PNOTE_RESTRING    7
#define PNOTE_EVENT       8

/* where definitions */
#define TO_AFFECTS	0
#define TO_OBJECT	1
#define TO_IMMUNE	2
#define TO_RESIST	3
#define TO_VULN		4
#define TO_WEAPON	5
#define TO_AFFECTS2 6

/***************************************************************************
 *                                                                         *
 *                   VALUES OF INTEREST TO AREA BUILDERS                   *
 *                   (Start of section ... start here)                     *
 *                                                                         *
 ***************************************************************************/

/*
 * Well known mob virtual numbers.
 * Defined in #MOBILES.
 */
#define MOB_VNUM_FIDO		   3700
#define MOB_VNUM_CITYGUARD	   3700
#define MOB_VNUM_VAMPIRE	   3700
#define MOB_VNUM_BUBBLE        1000
#define MOB_VNUM_DARKHOUND     1001
#define MOB_VNUM_WIND	       1002
#define	MOB_VNUM_REGISTAR      1004

#define MOB_VNUM_PATROLMAN	   3700
#define GROUP_VNUM_TROLLS	   3700
#define GROUP_VNUM_OGRES	   3700


/* RT ASCII conversions -- used so we can have letters in this file */

#define A		  	1
#define B			2
#define C			4
#define D			8
#define E			16
#define F			32
#define G			64
#define H			128

#define I			256
#define J			512
#define K		    1024
#define L		 	2048
#define M			4096
#define N		 	8192
#define O			16384
#define P			32768

#define Q			65536
#define R			131072
#define S			262144
#define T			524288
#define U			1048576
#define V			2097152
#define W			4194304
#define X			8388608

#define Y			16777216
#define Z			33554432
#define aa			67108864 	/* doubled due to conflicts */
#define bb			134217728
#define cc			268435456
#define dd			536870912
#define ee			1073741824
#define ff          2147483684
#define gg          4294967296
#define hh          8589934592
#define ii         17179869184
#define jj         34359738368

/*
 * ACT bits for mobs.
 * Used in #MOBILES.
 */
#define ACT_IS_NPC		    (A)		/* Auto set for mobs	*/
#define ACT_SENTINEL	    (B)		/* Stays in one room	*/
#define ACT_SCAVENGER	    (C)		/* Picks up objects	*/
#define ACT_AGGRESSIVE		(F)		/* Attacks PC's		*/
#define ACT_MOUNT			(E)		/* Attacks PC's		*/
#define ACT_STAY_AREA		(G)		/* Won't leave area	*/
#define ACT_WIMPY		    (H)
#define ACT_PET			    (I)		/* Auto set for pets	*/
#define ACT_TRAIN		    (J)		/* Can train PC's	*/
#define ACT_PRACTICE		(K)		/* Can practice PC's	*/
#define ACT_GAMBLER         (L)     /* mob takes bets */
#define ACT_JEWELER         (M)
#define ACT_UNDEAD		    (O)
#define ACT_CLERIC		    (Q)
#define ACT_MAGE		    (R)
#define ACT_THIEF		    (S)
#define ACT_WARRIOR		    (T)
#define ACT_NOALIGN		    (U)
#define ACT_NOPURGE		    (V)
#define ACT_OUTDOORS		(W)
#define ACT_INDOORS		    (Y)
#define ACT_IS_HEALER		(aa)
#define ACT_GAIN		    (bb)
#define ACT_UPDATE_ALWAYS	(cc)
#define ACT_IS_CHANGER		(dd)
#define ACT_IS_STRINGER     (ee)

/*
 * 	ACT2 bits for mobs.
 * Used in #MOBILES.
 */
#define ACT2_INVADE		(A)	/* auto-set for invading mobs */
#define ACT2_SHOPMOB    (B)
#define ACT2_NONE		(C)


/* damage classes */
#define DAM_NONE                0
#define DAM_BASH                1
#define DAM_PIERCE              2
#define DAM_SLASH               3
#define DAM_FIRE                4
#define DAM_COLD                5
#define DAM_LIGHTNING           6
#define DAM_ACID                7
#define DAM_POISON              8
#define DAM_NEGATIVE            9
#define DAM_HOLY                10
#define DAM_ENERGY              11
#define DAM_MENTAL              12
#define DAM_DISEASE             13
#define DAM_DROWNING            14
#define DAM_LIGHT		        15
#define DAM_OTHER               16
#define DAM_HARM		        17
#define DAM_CHARM		        18
#define DAM_SOUND		        19

/* OFF bits for mobiles */
#define OFF_AREA_ATTACK         (A) /* Attacks all grouped chars */
#define OFF_BACKSTAB            (B) /* Can backstab chars */
#define OFF_BASH                (C) /* Can bash chars */
#define OFF_BERSERK             (D)
#define OFF_DISARM              (E)
#define OFF_DODGE               (F)
#define OFF_FADE                (G)
#define OFF_FAST                (H)
#define OFF_KICK                (I)
#define OFF_KICK_DIRT           (J)
#define OFF_PARRY               (K)
#define OFF_RESCUE              (L)
#define OFF_TAIL                (M)
#define OFF_TRIP                (N)
#define OFF_CRUSH		        (O)
#define ASSIST_ALL       	    (P)
#define ASSIST_ALIGN	        (Q)
#define ASSIST_RACE    	     	(R)
#define ASSIST_PLAYERS      	(S)
#define ASSIST_GUARD        	(T)
#define ASSIST_VNUM		        (U)
#define OFF_CHARGE              (V)
#define OFF_CIRCLE              (W)
#define OFF_FORMS               (X)
#define OFF_SPIRIT              (Y)
/* return values for check_imm */
#define IS_NORMAL		         0
#define IS_IMMUNE		         1
#define IS_RESISTANT		     2
#define IS_VULNERABLE		     3

/* IMM bits for mobs */
#define IMM_SUMMON              (A)
#define IMM_CHARM               (B)
#define IMM_MAGIC               (C)
#define IMM_WEAPON              (D)
#define IMM_BASH                (E)
#define IMM_PIERCE              (F)
#define IMM_SLASH               (G)
#define IMM_FIRE                (H)
#define IMM_COLD                (I)
#define IMM_LIGHTNING           (J)
#define IMM_ACID                (K)
#define IMM_POISON              (L)
#define IMM_NEGATIVE            (M)
#define IMM_HOLY                (N)
#define IMM_ENERGY              (O)
#define IMM_MENTAL              (P)
#define IMM_DISEASE             (Q)
#define IMM_DROWNING            (R)
#define IMM_LIGHT		        (S)
#define IMM_SOUND		        (T)
#define IMM_WOOD                (X)
#define IMM_SILVER              (Y)
#define IMM_IRON                (Z)

/* RES bits for mobs */
#define RES_SUMMON		        (A)
#define RES_CHARM		        (B)
#define RES_MAGIC               (C)
#define RES_WEAPON              (D)
#define RES_BASH                (E)
#define RES_PIERCE              (F)
#define RES_SLASH               (G)
#define RES_FIRE                (H)
#define RES_COLD                (I)
#define RES_LIGHTNING           (J)
#define RES_ACID                (K)
#define RES_POISON              (L)
#define RES_NEGATIVE            (M)
#define RES_HOLY                (N)
#define RES_ENERGY              (O)
#define RES_MENTAL              (P)
#define RES_DISEASE             (Q)
#define RES_DROWNING            (R)
#define RES_LIGHT		        (S)
#define RES_SOUND		        (T)
#define RES_WOOD                (X)
#define RES_SILVER              (Y)
#define RES_IRON                (Z)

/* VULN bits for mobs */
#define VULN_SUMMON		        (A)
#define VULN_CHARM		        (B)
#define VULN_MAGIC              (C)
#define VULN_WEAPON             (D)
#define VULN_BASH               (E)
#define VULN_PIERCE             (F)
#define VULN_SLASH              (G)
#define VULN_FIRE               (H)
#define VULN_COLD               (I)
#define VULN_LIGHTNING          (J)
#define VULN_ACID               (K)
#define VULN_POISON             (L)
#define VULN_NEGATIVE           (M)
#define VULN_HOLY               (N)
#define VULN_ENERGY             (O)
#define VULN_MENTAL             (P)
#define VULN_DISEASE            (Q)
#define VULN_DROWNING           (R)
#define VULN_LIGHT		        (S)
#define VULN_SOUND		        (T)
#define VULN_WOOD               (X)
#define VULN_SILVER             (Y)
#define VULN_IRON		        (Z)

/* OP flags */
#define OP_CHANNELER     (A)
#define OP_GRASPED       (B)
#define OP_FSHIELD       (E)
#define OP_LARGE         (F)
#define OP_BARRIER       (G)

/* Random Player Special Flags */
#define SPEC_WOLFBROTHER (A)
#define SPEC_TAVEREN     (B)
#define SPEC_AGELESS     (C) /* Set when guilded Aes Sedai */
#define SPEC_DREAMWALKER (D)
#define SPEC_DREAMING    (E) /* set only if a dreamer and enters dreamworld */
#define SPEC_MENTOR      (F)
#define SPEC_SEER        (G)
#define SPEC_MARRIED     (H)
#define SPEC_X           (I)
#define SPEC_NOTEACH     (J)
#define SPEC_SNIFFER     (K)

/* History and family flags */
#define HIST_MERCHANT    (A)
#define HIST_SOLDIER     (B)
#define HIST_BEGGAR      (C)
#define HIST_ARTIST      (D)
#define HIST_FARMER      (E)
#define HIST_CHILD       (F)
#define HIST_MUSICIAN    (G)
#define HIST_SAILOR      (H)
#define HIST_NOBLE       (I)
#define HIST_SHADOW   (J)
#define HIST_RECRUITER   (K)
#define HIST_GUILDLEADER (L)
#define HIST_SHADOWGIFT (M)
#define HIST_BONDER (N)
#define HIST_BONDED (O)

/* Tabac flags */
#define TABAC_SMOKING    (A)
#define TABAC_CHEWING    (B)

/* War Flags */
#define WAR_VEILED       (A)
#define WAR_QUESTOR      (B)
#define WAR_BOUNTY       (C)
#define WAR_PK           (D)
#define WAR_MSP          (E)
#define WAR_HELD         (F)
/* begin add for imm pre-titles in who */
#define WAR_MODERATOR    (G) /* game moderator */
#define WAR_DAISHAN      (H) /* highest ranking warder */
#define WAR_MHAEL        (I) /* m'hael of the asha'man */
#define WAR_NAEBLIS      (J) /* highest ranking chosen */
#define WAR_MASTBARD     (K) /* highest ranking gleeman */
#define WAR_QGUARD       (L) /* highest ranking queen's guard */
#define WAR_WISEST       (M) /* highest ranking wise one */
#define WAR_MENTOR       (N) /* Mentor */
#define WAR_PROPHET      (O) /* highest ranking dragonsworn */
#define WAR_AUTOFIGHT    (P) /* auto fight or manual fight */
#define WAR_IMMORTAL     (Q) /* auto fight or manual fight */
#define WAR_GQUEST       (R) /* is on a global quest */
#define WAR_BATTLE       (S)
#define WAR_TOURNEY      (T) /* is in a tourney */
#define WAR_CODER	 (U)

/* Penalty Flags */
#define PENAL_NOWALK     (A)
#define PENAL_NOMOVE     (B)
#define PENAL_NOCHANNELS (C)
#define PENAL_NOEMOTE    (D)
#define PENAL_NOSHOUT    (E)
#define PENAL_NOTELL     (F)
#define PENAL_JAILED     (G)
#define PENAL_NOCHATS    (H)

/* stance and form flags */
#define STANCE_HERON       (A)
#define STANCE_BIRD        (B)
#define STANCE_WIND        (C)
#define STANCE_WATER       (D)
#define STANCE_ANIMAL      (E)
#define STANCE_EARTH       (F)
#define STANCE_SKY         (G)
#define STANCE_CAT         (H)
#define STANCE_NONE        (Z)
/* body form */
#define FORM_EDIBLE             (A)
#define FORM_POISON             (B)
#define FORM_MAGICAL            (C)
#define FORM_INSTANT_DECAY      (D)
#define FORM_OTHER              (E)  /* defined by material bit */

/* actual form */
#define FORM_ANIMAL             (G)
#define FORM_SENTIENT           (H)
#define FORM_UNDEAD             (I)
#define FORM_CONSTRUCT          (J)
#define FORM_MIST               (K)
#define FORM_INTANGIBLE         (L)

#define FORM_BIPED              (M)
#define FORM_CENTAUR            (N)
#define FORM_INSECT             (O)
#define FORM_SPIDER             (P)
#define FORM_CRUSTACEAN         (Q)
#define FORM_WORM               (R)
#define FORM_BLOB		(S)

#define FORM_MAMMAL             (V)
#define FORM_BIRD               (W)
#define FORM_REPTILE            (X)
#define FORM_SNAKE              (Y)
#define FORM_DRAGON             (Z)
#define FORM_AMPHIBIAN          (aa)
#define FORM_FISH               (bb)
#define FORM_COLD_BLOOD		(cc)

/* body parts */
#define PART_HEAD               (A)
#define PART_ARMS               (B)
#define PART_LEGS               (C)
#define PART_HEART              (D)
#define PART_BRAINS             (E)
#define PART_GUTS               (F)
#define PART_HANDS              (G)
#define PART_FEET               (H)
#define PART_FINGERS            (I)
#define PART_EAR                (J)
#define PART_EYE		(K)
#define PART_LONG_TONGUE        (L)
#define PART_EYESTALKS          (M)
#define PART_TENTACLES          (N)
#define PART_FINS               (O)
#define PART_WINGS              (P)
#define PART_TAIL               (Q)
/* for combat */
#define PART_CLAWS              (U)
#define PART_FANGS              (V)
#define PART_HORNS              (W)
#define PART_SCALES             (X)
#define PART_TUSKS		(Y)


/*
 * Bits for 'affected_by'.
 * Used in #MOBILES.
 */
#define AFF_BLIND			(A)
#define AFF_INVISIBLE		(B)
#define AFF_DETECT_EVIL		(C)
#define AFF_DETECT_INVIS	(D)
#define AFF_DETECT_MAGIC	(E)
#define AFF_DETECT_HIDDEN	(F)
#define AFF_DETECT_GOOD		(G)
#define AFF_SANCTUARY		(H)
#define AFF_FAERIE_FIRE		(I)
#define AFF_INFRARED		(J)
#define AFF_CURSE			(K)
#define AFF_FEAR		(L)	/* unused */
#define AFF_POISON			(M)
#define AFF_PROTECT_EVIL	(N)
#define AFF_PROTECT_GOOD	(O)
#define AFF_SNEAK			(P)
#define AFF_HIDE			(Q)
#define AFF_SLEEP			(R)
#define AFF_CHARM			(S)
#define AFF_FLYING			(T)
#define AFF_PASS_DOOR		(U)
#define AFF_HASTE			(V)
#define AFF_CALM			(W)
#define AFF_PLAGUE			(X)
#define AFF_WEAKEN			(Y)
#define AFF_DARK_VISION		(Z)
#define AFF_BERSERK			(aa)
#define AFF_SWIM			(bb)
#define AFF_REGENERATION	(cc)
#define AFF_SLOW			(dd)
#define AFF_VOID        	(ee)

/*
 * Bits for 'affected2_by'.
 * Used in #MOBILES.
 */
#define AFF_SPEED			   (A)
#define AFF_ENDURANCE		   (B)
#define	AFF_PANTHER	   		   (C)
#define AFF_INSTINCT   		   (D)
#define AFF_BATTLECRY          (E)
#define AFF_RAGE               (F)
#define AFF_MUSIC_INSPIRATION  (G)
#define AFF_MUSIC_COURAGE      (H)
#define AFF_MUSIC_SERENADE     (I)
#define AFF_BANDAGE            (J)
#define AFF_VEILED             (K)
#define AFF_BIGGER             (L)
#define AFF_QUICKEN            (M)
#define AFF_INNERVATION        (N)
#define AFF_FORTITUDE          (O)
#define AFF_SIXTH_SENSE        (P)

/*
 * Sex.
 * Used in #MOBILES.
 */
#define SEX_NEUTRAL		      0
#define SEX_MALE		      1
#define SEX_FEMALE		      2

/* AC types */
#define AC_PIERCE			0
#define AC_BASH				1
#define AC_SLASH			2
#define AC_EXOTIC			3

/* dice */
#define DICE_NUMBER			0
#define DICE_TYPE			1
#define DICE_BONUS			2

/* size */
#define SIZE_TINY			0
#define SIZE_SMALL			1
#define SIZE_MEDIUM			2
#define SIZE_LARGE			3
#define SIZE_HUGE			4
#define SIZE_GIANT			5


/* Crafting skills */
#define CRAFT_NONE			0
#define CRAFT_SEW			1
#define CRAFT_FORGE			2
#define CRAFT_WOODCRAFT			3
#define CRAFT_JEWELCRAFT		4



/*
 * Well known object virtual numbers.
 * Defined in #OBJECTS.
 */
#define OBJ_VNUM_SILVER_ONE	      1
#define OBJ_VNUM_GOLD_ONE	      2
#define OBJ_VNUM_GOLD_SOME	      3
#define OBJ_VNUM_SILVER_SOME	  4
#define OBJ_VNUM_COINS		      5
#define OBJ_VNUM_GEM              6
#define OBJ_VNUM_CORPSE_NPC	     10
#define OBJ_VNUM_CORPSE_PC	     11
#define OBJ_VNUM_SEVERED_HEAD	 12
#define OBJ_VNUM_TORN_HEART	     13
#define OBJ_VNUM_SLICED_ARM	     14
#define OBJ_VNUM_SLICED_LEG	     15
#define OBJ_VNUM_GUTS		     16
#define OBJ_VNUM_BRAINS		     17
#define OBJ_VNUM_MUSHROOM	     20
#define OBJ_VNUM_LIGHT_BALL	     21
#define OBJ_VNUM_SPRING		     22
#define OBJ_VNUM_DISC		     23
#define OBJ_VNUM_PORTAL		     25
#define OBJ_VNUM_ROSE		   1001
#define OBJ_VNUM_TREESTAFF		   3750
#define OBJ_VNUM_SCHOOL_MACE	   3700
#define OBJ_VNUM_SCHOOL_DAGGER	   3701
#define OBJ_VNUM_SCHOOL_SWORD	   3702
#define OBJ_VNUM_SCHOOL_VEST	   3703
#define OBJ_VNUM_SCHOOL_SHIELD	   3704
#define OBJ_VNUM_SCHOOL_SPEAR	   3717
#define OBJ_VNUM_SCHOOL_STAFF	   3718
#define OBJ_VNUM_SCHOOL_AXE		   3719
#define OBJ_VNUM_SCHOOL_FLAIL	   3720
#define OBJ_VNUM_SCHOOL_WHIP	   3721
#define OBJ_VNUM_SCHOOL_POLEARM    3722
#define OBJ_VNUM_SCHOOL_BOW        3738
#define OBJ_VNUM_SCHOOL_BANNER     3716
#define OBJ_VNUM_SCHOOL_NET        3762
#define OBJ_VNUM_SCHOOL_SCTHESWORD 3763
#define OBJ_VNUM_SCHOOL_TRIDENT    3764
#define OBJ_VNUM_SCHOOL_SLING      3765
#define OBJ_VNUM_SCHOOL_SWORDBREAKER 3766
#define OBJ_VNUM_SCHOOL_SAP        3767
#define OBJ_VNUM_SCHOOL_SHORTSWORD 3768
#define OBJ_VNUM_SCHOOL_LANCE      3769
#define OBJ_VNUM_SCHOOL_ASHANDAREI 3770
#define OBJ_VNUM_SCHOOL_SCYTHESWORD 3771
#define OBJ_VNUM_SCHOOL_HAMMER     3772
#define OBJ_VNUM_STEAK             3739
#define OBJ_VNUM_SKIN              3740
#define OBJ_VNUM_SCHOOL_DRESS      3741
#define OBJ_VNUM_SCHOOL_CADINSOR   3742
#define OBJ_VNUM_SCHOOL_SHOUFA     3743
#define OBJ_VNUM_SCHOOL_BEDROLL    3746
#define OBJ_VNUM_MAP			   3162
#define OBJ_VNUM_WHISTLE		   2116
#define OBJ_VNUM_ARROW			   3737
#define OBJ_VNUM_HOME_ITEM         3751
#define OBJ_VNUM_PIT 3766
/*
 * Item types.
 * Used in #OBJECTS.
 */
#define ITEM_LIGHT		          1
#define ITEM_SCROLL		          2
#define ITEM_WAND		          3
#define ITEM_STAFF		          4
#define ITEM_WEAPON		          5
#define ITEM_HERB			6
#define ITEM_CRAFTING_MATERIAL		7
#define ITEM_TREASURE		      8
#define ITEM_ARMOR		          9
#define ITEM_POTION		         10
#define ITEM_CLOTHING		     11
#define ITEM_FURNITURE		     12
#define ITEM_TRASH		         13
#define ITEM_CRAFTING_MANUAL		14
#define ITEM_CONTAINER		     15
#define ITEM_DYE			16
#define ITEM_DRINK_CON		     17
#define ITEM_KEY		         18
#define ITEM_FOOD		         19
#define ITEM_MONEY		         20
#define ITEM_ADORNMENT		         21
#define ITEM_BOAT		         22
#define ITEM_CORPSE_NPC		     23
#define ITEM_CORPSE_PC		     24
#define ITEM_FOUNTAIN		     25
#define ITEM_PILL		         26
#define ITEM_PROTECT		     27
#define ITEM_MAP		         28
#define ITEM_PORTAL		         29
#define ITEM_WARP_STONE		     30
#define ITEM_ROOM_KEY		     31
#define ITEM_GEM		         32
#define ITEM_JEWELRY		     33
#define ITEM_JUKEBOX		     34
#define ITEM_QUIVER			 	 35
#define ITEM_ARROW				 36
#define ITEM_PIPE_TABAC          37 /* For tabac code - Dal */
#define ITEM_CHEW_TABAC          38 /* For tabac code - Dal */
#define ITEM_ANGREAL_MALE        39 /* for angreal code - Dal */
#define ITEM_ANGREAL_FEMALE      40 /* for angreal code - Dal */
#define ITEM_CLOTH_BOLT          41 /* for stitching -Dal */
#define ITEM_TREE_PC             42 /* for treesinging -Dal */
#define ITEM_NOTEPAPER           43
#define ITEM_TRIGGER             44 /* for items that can do stuff */
#define ITEM_TREASURECHEST       45 /* for treasure code -Dal */
#define ITEM_LOCKPICK            46 /* used for picking locks */
#define ITEM_MIRROR              47 /* so you can see yourself */
#define ITEM_RAZOR               48 /* so you can shave */
#define ITEM_TOKEN               49
#define ITEM_FIREOIL             50 /* burning oil flasks */
#define ITEM_INK				 51 /* added for journal code */
#define ITEM_QUILL				 52 /* for journals */
#define ITEM_JOURNAL			 53 /* yes, for journals */
#define ITEM_WIND_PIPES          54
#define ITEM_WIND_FLUTE          55
#define ITEM_STRINGED_BITTERN    56
#define ITEM_PERCUSSION_DRUMS    57
#define ITEM_SHAPE_KNIFE         58
#define ITEM_SHAPE_SHAPER        59
#define ITEM_SHAPE_STICK         60
#define ITEM_SHAPE_LIMB          61
#define ITEM_SHAPE_BRANCH        63
#define ITEM_SHAPE_BLOCK         64
#define ITEM_SHAPE_KEYBLANK      65
#define ITEM_SMITH_ORE           66
#define ITEM_SMITH_HAMMER        67
#define ITEM_SMITH_ANVIL         68
#define ITEM_SMITH_BARREL        69
#define ITEM_SMITH_FURNACE       70
#define ITEM_SMITH_GRINDER       71
#define ITEM_COMM_DEV            72
#define ITEM_WINDOW              73
#define ITEM_KEYRING             74
#define ITEM_SHAPE_MUSHROOM      75
#define ITEM_SHAPE_CLEMATIS      76
#define ITEM_SHAPE_HAWTHORN      77
#define ITEM_SHAPE_BONESET       78
#define ITEM_SHAPE_OBSIDION      79
#define ITEM_SHAPE_SNAKESKIN     80
#define ITEM_TOME                81
#define ITEM_CLOCK               82
#define ITEM_BRUSH               83
#define ITEM_LAMPPOST            84
#define ITEM_ROPE                85
#define ITEM_PITON               86


#define OBJ_TRIGGER_NULL (A)
#define OBJ_TRIGGER_TURN (B)
#define OBJ_TRIGGER_PUSH (C)
#define OBJ_TRIGGER_PULL (D)

#define OBJ_TRIGGER_TURN_DOOR_NULL   (A)
#define OBJ_TRIGGER_TURN_DOOR_OPEN   (B)
#define OBJ_TRIGGER_TURN_DOOR_CLOSE  (C)
#define OBJ_TRIGGER_TURN_DOOR_LOCK   (D)
#define OBJ_TRIGGER_TURN_DOOR_UNLOCK (E)

#define OBJ_TRIGGER_PUSH_DOOR_NULL   (A)
#define OBJ_TRIGGER_PUSH_DOOR_OPEN   (B)
#define OBJ_TRIGGER_PUSH_DOOR_CLOSE  (C)
#define OBJ_TRIGGER_PUSH_DOOR_LOCK   (D)
#define OBJ_TRIGGER_PUSH_DOOR_UNLOCK (E)

#define OBJ_TRIGGER_PULL_DOOR_NULL   (A)
#define OBJ_TRIGGER_PULL_DOOR_OPEN   (B)
#define OBJ_TRIGGER_PULL_DOOR_CLOSE  (C)
#define OBJ_TRIGGER_PULL_DOOR_LOCK   (D)
#define OBJ_TRIGGER_PULL_DOOR_UNLOCK (E)
/* end object triggers */

#define TRAP_NONE   0
#define TRAP_BOOMER 1
#define TRAP_GASSER 2
#define TRAP_BLADE  3
#define TRAP_NEEDLE 4
#define TRAP_MANA   5
#define TRAP_FIRE   6
#define TRAP_ACID   7

/*
 * Trigger flags, used in ITEM_TRIGGER objects
 */
#define TRIGGER_CAN_TURN    (A)
#define TRIGGER_CAN_PUSH    (B)
#define TRIGGER_CAN_PULL    (C)

/*
 * Extra flags.
 * Used in #OBJECTS.
 */
#define ITEM_GLOW		(A)
#define ITEM_HUM		(B)
#define ITEM_DARK		(C)
#define ITEM_LOCK		(D)
#define ITEM_EVIL		(E)
#define ITEM_INVIS		(F)
#define ITEM_MAGIC		(G)
#define ITEM_NODROP		(H)
#define ITEM_ADORNED		(I)
#define ITEM_ANTI_GOOD		(J)
#define ITEM_ANTI_EVIL		(K)
#define ITEM_CRAFTED		(L)
#define ITEM_NOREMOVE		(M)
#define ITEM_INVENTORY		(N)
#define ITEM_NOPURGE		(O)
#define ITEM_ROT_DEATH		(P)
#define ITEM_VIS_DEATH		(Q)
#define ITEM_SHIMMER		(R)
#define ITEM_REINFORCED		(S)
#define ITEM_NOLOCATE		(T)
#define ITEM_MELT_DROP		(U)
#define ITEM_HAD_TIMER		(V)
#define ITEM_SELL_EXTRACT	(W)
#define ITEM_SPIKED         (X)
#define ITEM_BURN_PROOF		(Y)
#define ITEM_NOUNCURSE		(Z)
#define ITEM_BALANCED       (aa)
#define ITEM_NOSELL			(bb)
#define ITEM_NOLOAD         (cc)
#define ITEM_REMORT         (dd)
#define ITEM_STAYDEATH		(ee)
/*
 * Wear flags.
 * Used in #OBJECTS.
 */
#define ITEM_TAKE		(A)
#define ITEM_WEAR_FINGER	(B)
#define ITEM_WEAR_NECK		(C)
#define ITEM_WEAR_BODY		(D)
#define ITEM_WEAR_HEAD		(E)
#define ITEM_WEAR_LEGS		(F)
#define ITEM_WEAR_FEET		(G)
#define ITEM_WEAR_HANDS		(H)
#define ITEM_WEAR_ARMS		(I)
#define ITEM_WEAR_SHIELD	(J)
#define ITEM_WEAR_ABOUT		(K)
#define ITEM_WEAR_WAIST		(L)
#define ITEM_WEAR_WRIST		(M)
#define ITEM_WIELD		(N)
#define ITEM_HOLD		(O)
#define ITEM_NO_SAC		(P)
#define ITEM_WEAR_FLOAT		(Q)
#define ITEM_WEAR_NOSE          (R)
#define ITEM_WEAR_SHOULDERS     (S)
#define ITEM_WEAR_BACK          (T)
#define ITEM_WEAR_EYES          (U)
#define ITEM_WEAR_CALF          (V)
#define ITEM_WEAR_THIGH         (W)
#define ITEM_WEAR_FOREARM       (X)
#define ITEM_WEAR_EAR           (Y)
#define ITEM_WEAR_ANKLE         (Z)
#define ITEM_WEAR_NEAR_MIND     (aa)
#define ITEM_WEAR_FACE          (bb)
#define ITEM_WEAR_ANGREAL       (cc)

/* weapon class */
#define WEAPON_EXOTIC		0
#define WEAPON_SWORD		1
#define WEAPON_DAGGER		2
#define WEAPON_SPEAR		3
#define WEAPON_MACE		4
#define WEAPON_AXE		5
#define WEAPON_FLAIL		6
#define WEAPON_WHIP		7
#define WEAPON_POLEARM		8
#define WEAPON_SHORTBOW     9
#define WEAPON_STAFF        10
#define WEAPON_LONGBOW      11
#define WEAPON_RECURVEDBOW  12
#define WEAPON_COMPOSITEBOW 13
#define WEAPON_CROSSBOW     14
#define WEAPON_NET          15
#define WEAPON_SCYTHESWORD  16
#define WEAPON_TRIDENT      17
#define WEAPON_HAMMER       18
#define WEAPON_SLING        19
#define WEAPON_SWORDBREAKER 20
#define WEAPON_SAP          21
#define WEAPON_SHORTSWORD   22
#define WEAPON_LANCE        23
#define WEAPON_ASHANDAREI   24
#define WEAPON_LIGHTCROSSBOW 25

/* weapon types */
#define WEAPON_FLAMING		(A)
#define WEAPON_FROST		(B)
#define WEAPON_VAMPIRIC		(C)
#define WEAPON_SHARP		(D)
#define WEAPON_VORPAL		(E)
#define WEAPON_TWO_HANDS	(F)
#define WEAPON_SHOCKING		(G)
#define WEAPON_POISON		(H)
#define WEAPON_LOADED       (I)
#define WEAPON_INFUSE_STR   (J)
#define WEAPON_INFUSE_CON   (K)
#define WEAPON_INFUSE_DEX   (L)
#define WEAPON_INFUSE_INT   (M)
#define WEAPON_INFUSE_WIS   (N)
#define WEAPON_INFUSE_REF   (O)
#define WEAPON_INFUSE_CHA   (P)
#define WEAPON_INFUSE_INS   (Q)
#define WEAPON_INFUSE_HR    (R)
#define WEAPON_INFUSE_DR    (S)

/* gate flags */
#define GATE_NORMAL_EXIT	(A)
#define GATE_NOCURSE		(B)
#define GATE_GOWITH			(C)
#define GATE_BUGGY			(D)
#define GATE_RANDOM			(E)

/* furniture flags */
#define STAND_AT		(A)
#define STAND_ON		(B)
#define STAND_IN		(C)
#define SIT_AT			(D)
#define SIT_ON			(E)
#define SIT_IN			(F)
#define REST_AT			(G)
#define REST_ON			(H)
#define REST_IN			(I)
#define SLEEP_AT		(J)
#define SLEEP_ON		(K)
#define SLEEP_IN		(L)
#define PUT_AT			(M)
#define PUT_ON			(N)
#define PUT_IN			(O)
#define PUT_INSIDE		(P)




/*
 * Apply types (for affects).
 * Used in #OBJECTS.
 */
#define APPLY_NONE		      0
#define APPLY_STR		      1
#define APPLY_DEX		      2
#define APPLY_INT		      3
#define APPLY_WIS		      4
#define APPLY_CON		      5
#define APPLY_SEX		      6
#define APPLY_CLASS		      7
#define APPLY_LEVEL		      8
#define APPLY_AGE		      9
#define APPLY_HEIGHT		     10
#define APPLY_WEIGHT		     11
#define APPLY_MANA		     12
#define APPLY_HIT		     13
#define APPLY_MOVE		     14
#define APPLY_GOLD		     15
#define APPLY_EXP		     16
#define APPLY_AC		     17
#define APPLY_HITROLL		     18
#define APPLY_DAMROLL		     19
#define APPLY_SAVES		     20
#define APPLY_SAVING_PARA	     20
#define APPLY_SAVING_ROD	     21
#define APPLY_SAVING_PETRI	     22
#define APPLY_SAVING_BREATH	     23
#define APPLY_SAVING_SPELL	     24
#define APPLY_SPELL_AFFECT	     25
#define APPLY_REF		      26
#define APPLY_INS		      27
#define APPLY_CHA		      28

#define APPLY_REGEN			29
#define APPLY_POISON			30


/*
 * Values for containers (value[1]).
 * Used in #OBJECTS.
 */
#define CONT_CLOSEABLE		      1
#define CONT_PICKPROOF		      2
#define CONT_CLOSED		      4
#define CONT_LOCKED		      8
#define CONT_PUT_ON		     16



/*
 * Well known room virtual numbers.
 * Defined in #ROOMS.
 */
#define ROOM_VNUM_LIMBO		      2
#define ROOM_VNUM_OOC		1050
#define ROOM_VNUM_ARENA        3726
#define CAEMLYN_CEMETARY       3721
#define SEAFOLK_CEMETARY       17805
#define LEGION_CEMETARY        31304
#define CAEMLYN_SEANCHAN	16042
#define TOWER_CEMETARY	       17719
#define CHAFAILE_CEMETARY	12862
#define MILITARY_CEMETARY      23132
#define SHADOW_CEMETARY	       24394
#define TROLLOC_CEMETARY	6510
#define KIN_CEMETARY		16660
#define COMPANION_CEMETARY	16455
#define QGUARD_CEMETARY         7649
#define AIEL_CEMETARY          9499
#define WHITECLOAK_CEMETARY	24002
#define BLIGHT_CEMETARY		25206
#define TT_CEMETARY 25301
#define BTOWER_CEMETARY       6000
#define ROOM_VNUM_JAIL         3279
#define ROOM_VNUM_DSWORN_CEMETARY 18089
#define ROOM_VNUM_BETWEEN	   1001
#define ROOM_VNUM_PLAZA 	   3001
#define ROOM_VNUM_ALTAR		   3001
#define ROOM_VNUM_SCHOOL	   3736
#define ROOM_VNUM_BANDCAIRN    275
#define ROOM_VNUM_LONER        3736
#define ROOM_VNUM_ROM          3736
#define ROOM_VNUM_TOWER        23110
#define ROOM_VNUM_SEDAI		17710
#define ROOM_VNUM_BLIGHTGUARD  25200
#define ROOM_VNUM_BANDHAND     99
#define ROOM_VNUM_THIEFTAKER   25300
#define ROOM_VNUM_GLEEMAN      5710
#define ROOM_VNUM_CHILDREN     24001
#define ROOM_VNUM_QUEENSGUARD  7503
#define ROOM_VNUM_MANETHEREN   10911
#define ROOM_VNUM_DEFENDER     13000
#define ROOM_VNUM_ASHAMAN      777
#define ROOM_VNUM_COMPANION    16400
#define ROOM_VNUM_KINDRED      16600
#define ROOM_VNUM_SHAYULGHUL   24377
#define ROOM_VNUM_DARKWARDER	24302
#define ROOM_VNUM_BLACKAJAH	24319
#define ROOM_VNUM_DREADLORD	24355
#define ROOM_VNUM_CAVE         6510
#define ROOM_VNUM_DRAGONSWORN  18002
#define ROOM_VNUM_AIELMAN      8797
#define ROOM_VNUM_CRAFTERS	22266
#define ROOM_VNUM_MOUNTAINDAN  13607
#define ROOM_VNUM_TRUEBLOOD		13784
#define ROOM_VNUM_THUNDERWALK   13554
#define ROOM_VNUM_REDSHIELD	13709
#define ROOM_VNUM_STONEDOG 		13621
#define ROOM_VNUM_EAGLEBRO		13681
#define ROOM_VNUM_DAWNRUNNER	13723
#define ROOM_VNUM_BLACKEYE		13733
#define ROOM_VNUM_NIGHTSPEAR	13594
#define ROOM_VNUM_SPEARMAID    13535
#define ROOM_VNUM_WATERSEAKER  13544
#define ROOM_VNUM_KNIFEHAND		13753
#define ROOM_VNUM_WISEONE      22240
#define ROOM_VNUM_DEATHWATCH   16012
#define ROOM_VNUM_TREES        1850
#define ROOM_VNUM_CHA_FAILE	   12836
#define ROOM_VNUM_SEAFOLK       17800
#define ROOM_VNUM_TINKER	6399
#define ROOM_VNUM_LEGION       31300
#define VAULT_ROOM 3

/* ferries and ships */
/* board ship in tear */
#define SHIP_ROOM_TEAR_PORT       12076 /* where the mob stands */
#define SHIP_ROOM_TEAR_DOCK       7800  /* boarding room for tear to illian */
#define SHIP_ROOM_TEAR_FIRST      7801
#define SHIP_ROOM_TEAR_SECOND     7802
#define SHIP_ROOM_TEAR_THIRD      7803
#define SHIP_ROOM_TEAR_LAST       7804 /* last room before landing in illian */

#define SHIP_ROOM_ILLIAN_PORT     5774 /* where mob stands */
#define SHIP_ROOM_ILLIAN_DOCK     7805 /* boarding room for illian to ebou dar */
#define SHIP_ROOM_ILLIAN_FIRST    7806 /* dock in illian */
#define SHIP_ROOM_ILLIAN_SECOND   7807
#define SHIP_ROOM_ILLIAN_THIRD    7808
#define SHIP_ROOM_ILLIAN_LAST     7809 /* last room before landing in ebou dar */

#define SHIP_ROOM_EBOU_PORT       8129 /* where mob stands */
#define SHIP_ROOM_EBOU_DOCK       7810 /* boarding room for ebou dar */
/* end ship, board raker */
#define RAKER_ROOM_EBOU_FIRST     7811
#define RAKER_ROOM_EBOU_SECOND    7812
#define RAKER_ROOM_EBOU_LAST      7813
#define RAKER_ROOM_EBOU_DOCK      7814

#define RAKER_ROOM_ILLIAN_FIRST   7815
#define RAKER_ROOM_ILLIAN_SECOND  7816
#define RAKER_ROOM_ILLIAN_LAST    7817

#define BARGE_ROOM_TEAR_PORT      12070
#define BARGE_ROOM_TEAR_DOCK      7818
#define BARGE_ROOM_TEAR_FIRST     7819
#define BARGE_ROOM_TEAR_SECOND    7820

#define BARGE_ROOM_ARIN_PORT      630
#define BARGE_ROOM_ARIN_DOCK      7821
#define BARGE_ROOM_ARIN_FIRST     7822
#define BARGE_ROOM_ARIN_SECOND    7823
#define BARGE_ROOM_ARIN_THIRD     7824
#define BARGE_ROOM_ARIN_LAST      7825

#define BARGE_ROOM_TV_PORT        7233
#define BARGE_ROOM_TV_DOCK        7826
#define BARGE_ROOM_TV_FIRST       7827
#define BARGE_ROOM_TV_SECOND      7828
#define BARGE_ROOM_TV_THIRD       7829
#define BARGE_ROOM_TV_FOURTH      7830

#define BARGE_ROOM_ARIN2_PORT     696
#define BARGE_ROOM_ARIN2_DOCK     7831
#define BARGE_ROOM_ARIN2_FIRST    7832
#define BARGE_ROOM_ARIN2_SECOND   7833
#define BARGE_ROOM_ARIN2_LAST     7834

/* BEARDS! */
#define BEARD_NONE            0
#define BEARD_SHADOW          1
#define BEARD_BRISTLES        2
#define BEARD_DAYS_GROWTH     3
#define BEARD_HEAVY_GROWTH    4
#define BEARD_FULL            5
#define BEARD_LONG            6
#define BEARD_MAX             7
#define HAIR_MAX              7

/*
 * Room flags.
 * Used in #ROOMS.
 */
#define ROOM_DARK		(A)
#define ROOM_JAIL           	(B)
#define ROOM_NO_MOB		(C)
#define ROOM_INDOORS		(D)
#define ROOM_STEDDING       	(E)
#define ROOM_CASINO         	(F)
#define ROOM_CAMP           	(G)
#define ROOM_BUILDHOME          (H)
#define ROOM_PRIVATE		(J)
#define ROOM_SAFE		(K)
#define ROOM_SOLITARY		(L)
#define ROOM_PET_SHOP		(M)
#define ROOM_NO_RECALL		(N)
#define ROOM_IMP_ONLY		(O)
#define ROOM_GODS_ONLY		(P)
#define ROOM_HEROES_ONLY	(Q)
#define ROOM_NEWBIES_ONLY	(R)
#define ROOM_LAW		(S)
#define ROOM_NOWHERE		(T)
#define ROOM_BANK           (U)
#define ROOM_PAWNSHOP       (V)
#define ROOM_PK             (W)
#define ROOM_NOGATE         (X)
#define ROOM_CLIMB          (Y)
#define ROOM_HOME           (Z)
#define ROOM_MSP            (aa)
#define ROOM_MOUNT_SHOP		(bb)
#define ROOM_LOCKER         (cc)
#define ROOM_WELL_LIT       (dd)

/*
 * Directions.
 * Used in #ROOMS.
 */
#define DIR_NORTH		      0
#define DIR_EAST		      1
#define DIR_SOUTH		      2
#define DIR_WEST		      3
#define DIR_UP			      4
#define DIR_DOWN		      5
#define DIR_NORTHEAST         6
#define DIR_SOUTHEAST         7
#define DIR_SOUTHWEST         8
#define DIR_NORTHWEST	      9



/*
 * Exit flags.
 * Used in #ROOMS.
 */
#define EX_ISDOOR		      (A)
#define EX_CLOSED		      (B)
#define EX_LOCKED		      (C)
#define EX_CLIMB              (D)
#define EX_PICKPROOF		  (F)
#define EX_NOPASS		      (G)
#define EX_EASY			      (H)
#define EX_HARD			      (I)
#define EX_INFURIATING		  (J)
#define EX_NOCLOSE		      (K)
#define EX_NOLOCK		      (L)
#define EX_PAINWARD			  (M)
#define EX_NOENTERWARD		  (N)
#define EX_ALARMWARD		  (O)


/*
 * Sector types.
 * Used in #ROOMS.
 */
#define SECT_INSIDE		      0
#define SECT_CITY		      1
#define SECT_FIELD		      2
#define SECT_FOREST		      3
#define SECT_HILLS		      4
#define SECT_MOUNTAIN		  5
#define SECT_WATER_SWIM		  6
#define SECT_WATER_NOSWIM	  7
#define SECT_UNUSED		      8
#define SECT_AIR		      9
#define SECT_DESERT		     10
#define SECT_TUNDRA          11
#define SECT_BLIGHT          12
#define SECT_COASTAL         13
#define SECT_ROAD            14
#define SECT_MARSH           15
#define SECT_WASTE           16
#define SECT_LAKE_FRESH      17
#define SECT_LAKE_SALT       18
#define SECT_RIVER_FRESH     19
#define SECT_RIVER_SALT      20
#define SECT_VOLCANIC        21
#define SECT_OCEAN           22
#define SECT_UNDERGROUND     23
#define SECT_UNDERWATER      24
#define SECT_FOOTHILLS       25
#define SECT_JUNGLE          26
#define SECT_FARMLAND        27
#define SECT_STEPPE          28
#define SECT_PLAIN           29
#define SECT_MEADOW          30
#define SECT_MAX		     30



/*
 * Equpiment wear locations.
 * Used in #RESETS.
 */
#define WEAR_NONE           -1
#define WEAR_LIGHT  	     0
#define WEAR_EYES            1
#define WEAR_NOSE            2
#define WEAR_NECK_1		     3
#define WEAR_NECK_2		     4
#define WEAR_HEAD		     5
#define WEAR_EAR_1           6
#define WEAR_EAR_2           7
#define WEAR_HANDS		     8
#define WEAR_WRIST_L	     9
#define WEAR_WRIST_R		 10
#define WEAR_FINGER_L		 11
#define WEAR_FINGER_R	     12
#define WEAR_ARMS		     13
#define WEAR_FOREARM_L       14
#define WEAR_FOREARM_R       15
#define WEAR_BODY		     16
#define WEAR_ABOUT		     17
#define WEAR_WAIST		     18
#define WEAR_LEGS		     19
#define WEAR_FEET		     20
#define WEAR_CALF_L          21
#define WEAR_CALF_R          22
#define WEAR_THIGH_L         23
#define WEAR_THIGH_R         24
#define WEAR_ANKLE_L         25
#define WEAR_ANKLE_R         26
#define WEAR_SHOULDERS       27
#define WEAR_BACK            28
#define WEAR_LODGE_LEG		 29
#define WEAR_LODGE_ARM		 30
#define WEAR_LODGE_RIB  	 31
#define WEAR_SHIELD		     32
#define WEAR_HOLD		     33
#define WEAR_WIELD		     34
#define WEAR_SECONDARY       35
#define WEAR_FLOAT		     36
#define WEAR_NEAR_MIND       37
#define WEAR_FACE            38
#define WEAR_ANGREAL         39
#define MAX_WEAR		     40

#define RANGE_NONE           0
#define RANGE_MISSLE         1
#define RANGE_LONG           2
#define RANGE_MELEE          3

/***************************************************************************
 *                                                                         *
 *                   VALUES OF INTEREST TO AREA BUILDERS                   *
 *                   (End of this section ... stop here)                   *
 *                                                                         *
 ***************************************************************************/

/*
 * Conditions.
 */
#define COND_DRUNK		      0
#define COND_FULL		      1
#define COND_THIRST		      2
#define COND_HUNGER		      3
/* #define COND_SMOKING          4 */



/*
 * Positions.
 */
#define POS_DEAD		      0
#define POS_MORTAL		      1
#define POS_INCAP		      2
#define POS_STUNNED		      3
#define POS_SLEEPING		      4
#define POS_KNEELING
#define POS_RESTING		      5
#define POS_SITTING		      6
#define POS_FIGHTING		      7
#define POS_STANDING		      8



/*
 * ACT bits for players.
 */
#define PLR_IS_NPC		(A)		/* Don't EVER set.	*/

/* RT auto flags */
#define PLR_AUTOASSIST		(C)
#define PLR_AUTOEXIT		(D)
#define PLR_AUTOLOOT		(E)
#define PLR_AUTOSAC      	(F)
#define PLR_AUTOGOLD		(G)
#define PLR_AUTOSPLIT		(H)
#define PLR_FORAGE		(I)


/* RT personal flags */
#define PLR_HOLYLIGHT		(N)
#define PLR_CANLOOT		(P)
#define PLR_NOSUMMON		(Q)
#define PLR_NOFOLLOW		(R)
#define PLR_COLOUR		(T)
/* 1 bit reserved, S */

/* penalty flags */
#define PLR_PERMIT		(U)
#define PLR_LOG			(W)
#define PLR_DENY		(X)
#define PLR_FREEZE		(Y)
#define PLR_THIEF		(Z)
#define PLR_KILLER		(aa)

/* RT comm flags -- may be used on both mobs and chars */
#define COMM_QUIET              (A)
#define COMM_DEAF            	(B)
#define COMM_NOWIZ              (C)
#define COMM_NOAUCTION          (D)
#define COMM_NOOOC              (E)
#define COMM_NOQUESTION         (F)
#define COMM_NOMUSIC            (G)
#define COMM_NOCLAN		(H)
#define COMM_NOQUOTE		(I)
#define COMM_SHOUTSOFF		(J)
#define COMM_NOIC               (K)
/* display flags */
#define COMM_COMPACT		(L)
#define COMM_BRIEF		(M)
#define COMM_PROMPT		(N)
#define COMM_COMBINE		(O)
#define COMM_TELNET_GA		(P)
#define COMM_SHOW_AFFECTS	(Q)
#define COMM_NOGRATS		(R)
#define COMM_NOGL		(S)
#define COMM_NOSTAFF            (T)
#define COMM_NODFH              (U)

/* penalties */
#define COMM_SNOOP_PROOF	    (Y)
#define COMM_AFK		        (Z)
/* misc - Dalsor */
#define COMM_PDEATH             (aa)
#define COMM_PENTER             (bb)
#define COMM_RP			(cc)
#define COMM_PREBIRTH		(dd)

/* WIZnet flags */
#define WIZ_ON			(A)
#define WIZ_TICKS		(B)
#define WIZ_LOGINS		(C)
#define WIZ_SITES		(D)
#define WIZ_LINKS		(E)
#define WIZ_DEATHS		(F)
#define WIZ_RESETS		(G)
#define WIZ_MOBDEATHS	(H)
#define WIZ_FLAGS		(I)
#define WIZ_PENALTIES	(J)
#define WIZ_SACCING		(K)
#define WIZ_LEVELS		(L)
#define WIZ_SECURE		(M)
#define WIZ_SWITCHES	(N)
#define WIZ_SNOOPS		(O)
#define WIZ_RESTORE		(P)
#define WIZ_LOAD		(Q)
#define WIZ_NEWBIE		(R)
#define WIZ_PREFIX		(S)
#define WIZ_SPAM		(T)
#define WIZ_INVADE		(U)
#define WIZ_MEMCHECK            (V)
#define WIZ_STRING      (W)
#define WIZ_QUESTS		(X)
#define WIZ_BPAWNS		(Y)
#define WIZ_LOG_STRING		(Z)

#define AUTO_AUTODAMAGE      (A) /* auto show numerical damage */
#define AUTO_AUTOBUTCHER     (B) /* auto butcher kills */
#define AUTO_AUTOSLAY        (C) /* auto slay for immort */
#define AUTO_AUTOLOG         (D) /* auto log reply messages while fighting */
#define AUTO_AUTOSKIN        (E) /* auto skin kills */
#define AUTO_HINTS           (F) /* send newbie hints to the player */
#define AUTO_AUTORECALL      (G) /* will auto recall from fights on discon */
#define AUTO_AUTOMAP         (H) /* will show map overhead do_look -> room  */
#define AUTO_COUNTER         (I) /* will counter or not if has skill */
#define AUTO_PARRY           (J) /* will attempt to parry if has skill */
#define AUTO_DODGE           (K) /* will attempt to dodge if has skill */
#define AUTO_WAR             (L) /* will war messages be shown? */
#define AUTO_PEEK            (M) /* will do_peek when look */
#define AUTO_ROA             (N) /* RoA client enhanced features */
#define AUTO_FTAG            (O) /* freeze tag toggle */
#define AUTO_TOURNEY         (P) /* tournies */
#define AUTO_TRIVIA          (Q) /* trivia channel */
#define AUTO_AUTOBOX         (R) /* automatically pick up boxes */
#define AUTO_SAVEMESSAGE     (S) /* show autosave messages */
#define AUTO_AUTOH2H         (T) /* automatically use punches */
#define AUTO_AUTOSEARCH      (U) /* automatically search when walking */

#define AJAH_RED      (A)
#define AJAH_BLUE     (B)
#define AJAH_GREEN    (C)
#define AJAH_GRAY     (D)
#define AJAH_WHITE    (E)
#define AJAH_YELLOW   (F)
#define AJAH_BROWN    (G)
#define AJAH_BLACK    (H)
#define AJAH_ALL      (I)

/* memory settings */
#define MEM_CUSTOMER	A
#define MEM_SELLER	B
#define MEM_HOSTILE	C
#define MEM_AFRAID	D

/*
 * Liquids.
 */
#define LIQ_WATER        0

#define MATERIAL_UNKNOWN        0
#define MATERIAL_SILK           1
#define MATERIAL_CLOTH          2
#define MATERIAL_ALGODE         3
#define MATERIAL_BURLAP         4
#define MATERIAL_WOOL           5
#define MATERIAL_PAPER          6
#define MATERIAL_VELLUM         7
#define MATERIAL_TWINE          8
#define MATERIAL_WIRE           9
#define MATERIAL_FEATHER        10
#define MATERIAL_FOOD           11
#define MATERIAL_FUR            12
#define MATERIAL_LEATHER_SOFT   13
#define MATERIAL_LEATHER_HARD   14
#define MATERIAL_WOOD_SOFT      15
#define MATERIAL_WOOD_HARD      16
#define MATERIAL_BONE           17
#define MATERIAL_WOOD_SUNG      18
#define MATERIAL_STONE_SOFT     19
#define MATERIAL_STONE_HARD     20
#define MATERIAL_METAL_PRECIOUS 21
#define MATERIAL_METAL_SOFT     22
#define MATERIAL_METAL_HARD     23
#define MATERIAL_STONE_GEM      24
#define MATERIAL_METAL_POWER    25
#define MATERIAL_CUENDILLAR     26
#define MATERIAL_HEMP           27
#define MATERIAL_BLACKSTEEL		28
#define MATERIAL_POWERWROUGHT	29

/*
 * Types of attacks.
 * Must be non-overlapping with spell/skill types,
 * but may be arbitrary beyond that.
 */
#define TYPE_UNDEFINED               -1
#define TYPE_HIT                     1000



/*
 *  Target types.
 */
#define TAR_IGNORE		    0
#define TAR_CHAR_OFFENSIVE	    1
#define TAR_CHAR_DEFENSIVE	    2
#define TAR_CHAR_SELF		    3
#define TAR_OBJ_INV		    4
#define TAR_OBJ_CHAR_DEF	    5
#define TAR_OBJ_CHAR_OFF	    6

#define TARGET_CHAR		    0
#define TARGET_OBJ		    1
#define TARGET_ROOM		    2
#define TARGET_NONE		    3

/* timed event action */
#define ACTION_PRINT      1
#define ACTION_FUNCTION   2
#define ACTION_WAIT       3
#define ACTION_ACT        4

/*
 * MOBprog definitions
 */
#define TRIG_ACT	(A)
#define TRIG_BRIBE	(B)
#define TRIG_DEATH	(C)
#define TRIG_ENTRY	(D)
#define TRIG_FIGHT	(E)
#define TRIG_GIVE	(F)
#define TRIG_GREET	(G)
#define TRIG_GRALL	(H)
#define TRIG_KILL	(I)
#define TRIG_HPCNT	(J)
#define TRIG_RANDOM	(K)
#define TRIG_SPEECH	(L)
#define TRIG_EXIT	(M)
#define TRIG_EXALL	(N)
#define TRIG_DELAY	(O)
#define TRIG_SURR	(P)
#define TRIG_GET	(Q)
#define TRIG_DROP	(R)
#define TRIG_SIT	(S)

#define PRG_MPROG	0
#define PRG_OPROG	1
#define PRG_RPROG	2
#define TRANSLATION_FILE "../data/translation.txt"

#define GSKILL_NONE       0
#define GSKILL_POWER      gsn_judgement
#define GSKILL_SPEARDANCE gsn_speardance

#define GUILD_NONE     0
#define GUILD_IMM      1
#define GUILD_WTOWER   2
#define GUILD_BGUARD   3
#define GUILD_BAND     4
#define GUILD_TTAKER   5
#define GUILD_GLEEMAN  6
#define GUILD_COTL     7
#define GUILD_QGUARD   8
#define GUILD_TEAR     9
#define GUILD_ASH      10
#define GUILD_COMP     11
#define GUILD_KIN      12
#define GUILD_DARK     13
#define GUILD_DSWORN   14
#define GUILD_AIEL     15
#define GUILD_OGIER    16
#define GUILD_SEAN     17
#define GUILD_SEA      18

/*
 * Bank Stuff
 */
#define MONEY_BLOCKED	4

/*
 * Utility macros.
 */
#define IS_VALID(data)		((data) != NULL && (data)->valid)
#define VALIDATE(data)		((data)->valid = TRUE)
#define INVALIDATE(data)	((data)->valid = FALSE)
#define UMIN(a, b)		((a) < (b) ? (a) : (b))
#define UMAX(a, b)		((a) > (b) ? (a) : (b))
#define URANGE(a, b, c)		((b) < (a) ? (a) : ((b) > (c) ? (c) : (b)))
#define LOWER(c)		((c) >= 'A' && (c) <= 'Z' ? (c)+'a'-'A' : (c))
#define UPPER(c)		((c) >= 'a' && (c) <= 'z' ? (c)+'A'-'a' : (c))
#define IS_SET(flag, bit)	((flag) & (bit))
#define SET_BIT(var, bit)	((var) |= (bit))
#define REMOVE_BIT(var, bit)	((var) &= ~(bit))
#define IS_NULLSTR(str)		((str) == NULL || (str)[0] == '\0')
#define ENTRE(min,num,max)	( ((min) < (num)) && ((num) < (max)) )
#define CHECK_POS(a, b, c)	{							\
					(a) = (b);					\
					if ( (a) < 0 )					\
					bug( "CHECK_POS : " c " == %d < 0", a );	\
				}							\

/*
#define replace_string( pstr, nstr )            \
{                                               \
  _free_string( (pstr), __FILE__, __LINE__ );   \
  pstr = str_dup( (nstr) );                     \
}
*/

/*
#define free_mem( pMem, sMem )  _free_mem(pMem, sMem, __FILE__, __LINE__)
#define free_string( pstr )  _free_string(pstr, __FILE__, __LINE__)
*/

#define free_mem( pMem, sMem )
#define free_string( pstr )


#define obj_from_room( obj ) _obj_from_room( obj, __FILE__, __LINE__ )

//#define str_cmp(astr, bstr) _str_cmp( astr, bstr, __FILE__, __LINE__ ) // prool
/*
 * Character macros.
 */
#define	ON_GQUEST(ch) (!IS_NPC(ch) && IS_SET((ch)->war_flags, WAR_GQUEST) && gquest_info.running != GQUEST_OFF)
#define IS_NPC(ch)		(IS_SET((ch)->act, ACT_IS_NPC))
/*#define IS_IMMORTAL(ch) (ch->desc ? is_granted(ch,"imortflag") : get_trust(ch) >= LEVEL_IMMORTAL)*/
/*#define IS_IMMORTAL(ch) (is_granted_name(ch,"imortflag")*/
/*#define IS_IMMORTAL(ch) (ch->level >= LEVEL_IMMORTAL)*/
#define IS_IMMORTAL(ch) (IS_SET((ch)->war_flags,WAR_IMMORTAL))
#define IS_MENTOR(ch)   (IS_SET((ch)->spec_flags,SPEC_MENTOR))
#define IS_MODERATOR(ch) (IS_SET((ch)->war_flags,WAR_MODERATOR))
#define IS_STAFF(ch)     (IS_SET((ch)->war_flags,WAR_MENTOR) || IS_SET((ch)->war_flags,WAR_MODERATOR));
#define IS_HERO(ch)		(get_trust(ch) >= LEVEL_HERO)
#define IS_TRUSTED(ch,level)	(get_trust((ch)) >= (level))
#define IS_AFFECTED(ch, sn)	(IS_SET((ch)->affected_by, (sn)))
#define IS_AFFECTED2(ch, sn)    (IS_SET((ch)->affected2_by, (sn)))
#define IS_QUESTOR(ch)     (IS_SET((ch)->act, WAR_QUESTOR))
#define GET_AGE(ch)		((int) (17 + ((ch)->played + current_time - (ch)->logon )/72000))
#define IS_MARRIED(ch) (!IS_NPC(ch) && IS_SET(ch->spec_flags, SPEC_MARRIED) && !IS_NULLSTR(ch->pcdata->spouse))
#define IS_GOOD(ch)		(ch->alignment >= 350)
#define IS_EVIL(ch)		(ch->alignment <= -350)
#define IS_NEUTRAL(ch)		(!IS_GOOD(ch) && !IS_EVIL(ch))

#define	CH(d)  (((d)->original != NULL) ? (d)->original : (d)->character)

#define IS_AWAKE(ch)		(ch->position > POS_SLEEPING)
#define GET_AC(ch,type)		((ch)->armor[type]			    \
		        + ( IS_AWAKE(ch)			    \
			? ( dex_app[get_curr_stat(ch,STAT_DEX)].defensive + 	\
			ref_app[get_curr_stat(ch,STAT_REF)].to_hit) / 2 	\
			: 0 ))
#define GET_HITROLL(ch)	\
		((ch)->hitroll+str_app[get_curr_stat(ch,STAT_STR)].tohit)
#define GET_DAMROLL(ch) \
		((ch)->damroll+str_app[get_curr_stat(ch,STAT_STR)].todam)

#define IS_OUTSIDE(ch)		(!IS_SET(				    \
				    (ch)->in_room->room_flags,		    \
				    ROOM_INDOORS))

/*#define WAIT_STATE(ch, npulse)	((ch)->wait = UMAX((ch)->wait, (npulse)))*/
#define WAIT_STATE(ch, npulse)	(IS_IMMORTAL(ch) ? 0 : ((ch)->wait = UMAX((ch)->wait, (npulse))))
#define DAZE_STATE(ch, npulse)  ((ch)->daze = UMAX((ch)->daze, (npulse)))
#define get_carry_weight(ch)  ((ch)->carry_weight)

#define MOUNTED(ch) \
		((!IS_NPC(ch) && ch->mount && ch->riding) ? ch->mount : NULL)
#define RIDDEN(ch) \
		((IS_NPC(ch) && ch->mount && ch->riding) ? ch->mount : NULL)
#define IS_DRUNK(ch)		((ch->pcdata->condition[COND_DRUNK] > 10))

#define act(format,ch,arg1,arg2,type)\
	act_new((format),(ch),(arg1),(arg2),(type),POS_RESTING)

#define HAS_TRIGGER_MOB(ch,trig)	(IS_SET((ch)->pIndexData->mprog_flags,(trig)))
#define HAS_TRIGGER_OBJ(obj,trig) (IS_SET((obj)->pIndexData->oprog_flags,(trig)))
#define HAS_TRIGGER_ROOM(room,trig) (IS_SET((room)->rprog_flags,(trig)))
#define IS_SWITCHED( ch )       ( ch->desc && ch->desc->original )
#define IS_BUILDER(ch, Area)    ( strstr( Area->builders, ch->name ) || ch->pcdata->security == 9 )

/*
 * Object macros.
 */
#define CAN_WEAR(obj, part)	(IS_SET((obj)->wear_flags,  (part)))
#define IS_OBJ_STAT(obj, stat)	(IS_SET((obj)->extra_flags, (stat)))
#define IS_WEAPON_STAT(obj,stat)(IS_SET((obj)->value[4],(stat)))
#define WEIGHT_MULT(obj)	((obj)->item_type == ITEM_CONTAINER ? (obj)->value[4] : 100)

/* spec macros */
#define WOLF(ch) (IS_SET((ch)->spec_flags,SPEC_WOLFBROTHER))
#define TAV(ch) (IS_SET((ch)->spec_flags,SPEC_TAVEREN))
#define DREAM(ch) (IS_SET((ch)->spec_flags,SPEC_DREAMWALKER))
#define DREAMING(ch) (IS_SET((ch)->spec_flags,SPEC_DREAMING))
#define MENTOR(ch) (IS_SET((ch)->spec_flags,SPEC_MENTOR))
#define MODERATOR(ch) (IS_SET((ch)->war_flags,WAR_MODERATOR))
#define SEER(ch) (IS_SET((ch)->spec_flags,SPEC_SEER))

#define EDIT_GUILD(Ch, Clan)    ( Clan = Ch->desc->pEdit )
