/* The Darkfriend Hunt was coded by Scott Rothrock,
* who can be contacted at TickTocks@hotmail.com,
* for As the Wheel Weaves (www.aww-mud.org:6500).
*/

void	dfhunt_create	args((CHAR_DATA *ch, int cost));
void	dfhunt_join		args((CHAR_DATA *ch, int cost));
void	dfhunt_talk		args((CHAR_DATA *ch, char *argument, int notice));
CHAR_DATA * get_char_dfhunt	args((CHAR_DATA *ch, char *argument));
void	dfhunt_update	();
void	dfhunt_recount	();

#define DFHUNT_CREATE_COST	1 /* Cost in gold to create a Hunt */
#define	DFHUNT_JOIN_COST	0 /* Cost in gold to join the Junt */

/* dfhunt_game_info specifications:
* Array 0: Game status: 0 = no game, 1 = preliminaries, 2 = running. 3 =
day, 4 = night, 5 = shadow vic, 6 = Light vic
* Array 1: Total players.
* Array 2: Aes Sedai counter: 0 = no Sedai selected, 1 = Sedai already
selected.
* Array 3: Warder counter: 0 = no Warder selected, 1 = Warder already
selected.
* Array 4: Darkfriend counter: 0 = no Darkfriend selected, 1 = One
Darkfriend, 2 = All selected.
* Array 5: Total accusations thus far.
* Array 6: Total players in game, unmod.
* int	dfhunt_game_info[7];
*/

#define GAME_STAT 0
	#define NO_HUNT 0
	#define PREL 1
	#define UNUSED 2
	#define DAY 3
	#define NIGHT 4
#define PLAYER_LEFT 1
#define AS_LEFT 2
#define W_LEFT 3
#define DF_LEFT 4
#define ACTIONS 5
#define TOTAL_PLAYERS 6

/* if you change the role ordering, you need to fix a bunch of stuff */
/* Don't do it */
#define P_ROLE 0    
	#define P_NOT_IN_HUNT 0
	#define P_T 1
	#define P_AS 2
	#define P_W 3
	#define P_DF 4
	#define P_LINKDEAD 5
#define P_SURVIVED 1
#define P_DIED 2
#define P_CREATOR 3
#define P_VOTES 4
#define P_ACTION 5
#define P_PROTECTED 6


struct dfhunt_help
{
	char *line;
};

const struct dfhunt_help dfhunt_syntax[] =
{

	{" {D/{W---------{D[ {wThe {BD{bark{Bf{briend {RH{runt {D]{W---------{D\\\n\r"},
	{"{w| {YC{yommands are{Y:                             {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y create {W-{y Creates a new hunt.     {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y join {W-{y Joins the current hunt.   {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y start {W-{y Starts the hunt!         {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y end {W-{y End the hunt.              {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y accuse {W-{y Accuse someone of being {w|\n\r"},
	{"{w|     {ya {BD{bark{Bf{briend{y!                         {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y kill {W-{y Kill someone!             {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y protect {W-{y Protect someone!       {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y identify {W-{y Identify someone!     {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y leave {W-{y Leave the hunt.          {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y status {W-{y Check on the status of  {w|\n\r"},
	{"{w|     {ythe current hunt.                     {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y talk {W-{y Talk to fellow hunters.   {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y who {W-{y See who is playing.        {w|\n\r"},
	{"{w|   {rdfh{Ru{rnt{Y remove {W-{y Immortals may remove a  {w|\n\r"},
	{"{w|     {yhunter from the game.                 {w|\n\r"},
	{" {D\\{W-----------------------------------------{D/{x\n\r"},
};


