/***************************************************************************

                      ___  _      _  _      _
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \__|_  /\_/\  /    \_/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


struct DreamType
{
	char    *dName;
	sh_int  dType; /* 1 = harmful, 2 = neutral, 3 = beneficial */
	bool    waker;
	char    *dText;
};

const   struct  DreamType DreamTable [] =
{
	/* 1 */
	{
		"DarkOne", 1, TRUE,
		"As you dream you see a pair of red dots in the black void. They grow bringing Smoldering heat and Freezing cold. A booming voice echoes in your head 'YOU! SHALL! BE! MINE!'. You wake up in cold sweat... ",
	},
	/* 2 */
	{
		"GreenJuggler", 2, FALSE,
		"As you dream you see a small green man with a large head juggling fireballs and mugs of ale.",
	},
	/* 3 */
	{
		"LionThrone", 3, FALSE,
		"As you dream you find yourself seated upon the Lion Throne of Andor and great masses of Caemlyners cheer you happily...",
	},
	/* 4 */
	{
		"Awaken", 1, TRUE,
		"A swirling mist clears revealing your prone form, asleep. With a start, you realize that it is your body and you are awake, looking down at yourself. Jolts of panic shoot through your veins as you futilely try to re-connect yourself with your sleeping body. You wake in a cold sweat...",
	},
	/* 5 */
	{
		"Fabhor", 2, FALSE,
		"A feminine shape snaps into view, causing an overwhelming feeling of dislike to fill your belly. Squinting to get a closer look, the only thing you can make out about her is that she has light colored eyes.",
	},
	/* 6 */
	{
		"Mabhor", 2, FALSE,
		"A masculine shape snaps into view, causing an overwhelming feeling of dislike to fill your belly. Squinting to get a closer look, the only thing you can make out about him is that he seems to have sharply chiseled facial features.",
	},
	/* 7 */
	{
		"FromAbove", 1, TRUE,
		"You glance upwards and spot a large chest, balanced precariously on a building's ledge. It appears as if it will fall at any moment and strike your body. Suddenly, it does, and you stand riveted as it falls on you, crushing you under it's weight. You wake in a cold sweat...",
	},
	/* 8 */
	{
		"Absence", 2, FALSE,
		"A hazy picture forms in your mind, showing a child-like body hunched over and wracked with grief. It appears as if the child is grieving the loss of a loved one. The child scrubs a hand over it's face, revealing furrowed lines along the brow and a thin-pressed look of determination about the lips.",
	},
	/* 9 */
	{
		"Abscess", 1, FALSE,
		"The sound of a door slamming resounds in your ears as you are quickly escorted out of the local Wisdom's house. A large wound covers the length of your forearm and a putrid smell fills the air as fresh pus bubbles freely out of the wound.",
	},
	/* 10 */
	{
		"Accepted", 3, FALSE,
		"Calm waves of pleasure fill your senses as a vision of someone you hold dear to your heart appears beside you, clutching your hand and returning your whispered words of adoration.",
	},
	/* 11 */
	{
		"Accuse", 2, FALSE,
		"You find yourself standing across from a man, your finger poking the man's chest accusingly of some wrongdoing. It seems as if he is trying to claim his innocence but his words fall on deaf ears as your shouts of his crimes fill the air.",
	},
	/* 12 */
	{
		"Acorn", 3, FALSE,
		"A thick forest spreads before you, willow trees and white oaks the most prominent. Brownish-green moss paints the ground as a refreshing breeze whistles through the leaves. A smattering of acorns are piled up at your feet, where it seems as if you have been gathering and separating the acorns into neat piles.",
	},
	/* 13 */
	{
		"Adder", 2, FALSE,
		"The appearance of a long dead friend rises in your sleep. A snake adder is poised dangerously close, coiled to strike. In what feels like mere heartbeats, the adder strikes and the animated body of your friend rises up to a sitting position. With one last smile, the images fade to blackness.",
	},
	/* 14 */
	{
		"Annoy", 2, FALSE,
		"A buzzing sound looms nearby as a cloud of bite-mes approach. You flail your arms wildly in front of you in a desperate attempt to keep the annoying insects away from you.",
	},
	/* 15 */
	{
		"Angling", 2, FALSE,
		"A calm stream catches the light and causes small shimmering pools of water to dance and dazzle before you. Several small fish can be seen in the depths of the waters, as the fish swim to and fro in a playful manner.",
	},
	/* 16 */
	{
		"ApparelW", 2, FALSE,
		"Volumious folds of white material clothes your body as you see your hands smoothing down non-existent wrinkles on your chest. The crisp starchness of the cloth feels rough against your skin.",
	},
	/* 17 */
	{
		"ApparelB", 1, FALSE,
		"You glance at a heavily polished silver pitcher as you walk past a long table, heavy with food. A hand strays to brush away a speck of dust from a pitch-black jacket. It seems as soon as you remove one blemish from your jacket, another appears to replace it.",
	},
	/* 18 */
	{
		"ApparelY", 3, FALSE,
		"A group of giggling children dance happily in circles around a tall pole that has been firmly secured into the ground. Bright yellow dyed ribbons ring the pole, the ends of the ribbons themselves are grasped in the children's closed fists.",
	},
	/* 19 */
	{
		"Apprentice", 2, FALSE,
		"An angry androgynous voice fills the air, turning your cheeks and ears crimson. The voice belongs to someone who has seemingly taken you on as their apprentice. Apparently, you have displeased your tutor judging by the inflections in the voice and the bulging vein that can be seen, pulsing from your instructor's forehead.",
	},
	/* 20 */
	{
		"Ashes", 1, FALSE,
		"Tiny sprouts of vegetation spread out in neat rows before your eyes. A welcome burn washes over your muscles after you have spent what appears to be a long day beneath the sun, tending to your crops. Upon closer inspection, tiny insects are devouring your hard work right before your eyes! In a flash, you find yourself gripping a torch in your hand, setting fire to all the crops to kill off the insects. Unfortunately, the fire reigns out of control and everything is turned to ash!",
	},
	/* 21 */
	{
		"Assassin", 1, TRUE,
		"The scents of a chilled melon wine fill your senses as you see yourself lifting the glass to your nose, swirling the liquid in slow lazy circles to release the dormant undertones of the wine. A sigh of pleasure escapes your lips as you drink a healthy swallow. Your enjoyment comes to an abrupt halt as the sound of raucous laughter echos from somewhere behind you. 'Fool! That wine that you so elegantly consumed is steeped with poisons!' The poison flows quickly through your veins and you wake in a cold sweat...",
	},
	/* 22 */
	{
		"GMemory", 2, FALSE,
		"You remember back to a time before battle, before you had to learn how to fight and were just a happy youth.",
	},
	/* 23 */
	{
		"BMemory", 2, FALSE,
		"From the recesses of your mind a painful memory returns to haunt you.",
	},
	/* 24 */
	{
		"Leadership", 3, FALSE,
		"All before you listen to everything you say, hang on each word, and you know that you are their leader, there is no one more powerful than you.",
	},
	/* 25 */
	{
		"Follower", 2, FALSE,
		"You listen as you are told what to do and you carry out the orders, knowing you were born to follow, never to lead...",
	},
	/* 26 */
	{
		"Punishment", 1, FALSE,
		"You know you have committed some great wrong and feel excruciating pain as you are punished by whips and brands of fire for your misdeeds.",
	},
	/* 27 */
	{
		"FeastDay", 3, FALSE,
		"A large feast is spread out before you and you are attended by the liveried servants of your court.",
	},
	/* 28 */
	{
		"Hunger", 1, FALSE,
		"You feel your belly trying to push against your spine, growling with hunger. Just out of arm's reach is a feast upon a gilded table, but as you step toward it, it moves again just beyond your reach.",
	},
	/* 29 */
	{
		"Nekkid", 2, FALSE,
		"You are walking through a crowd of people that appears to be having a good time. There is a pleasant breeze, and it cools your skin in the summer heat. They laugh and look at each other, and occasionally one looks at you as if to share the fun. You are unable to find what exactly is so amusing and put your hands on your hips in frustration. At this point, it dawns on you that your unclothed body is the source of amusement.",
	},
	/* 30 */
	{
		"PotionMaker", 2, FALSE,
		"A man stands behind a desk and grins at you. He turns around and cackles as he stirs a swirling cauldron. He turns around and with a cackle hands you a glowing vial.",
	},
	/* 31 */
	{
		"TheEyes", 2, FALSE,
		"You walk through a dark corridor with mist that swirls at your feet. In the darkness before you, you notice two glowing eyes staring back at you. You fumble to draw your weapon but realize that its not there. With a howl the eyes turn into a large creature that lunges at you!",
	},
	/* 32 */
	{
		"Falling", 2, FALSE,
		"You find yourself falling through complete darkness. You try to scream but find no breathe to do so. You seem to fall for hours. As you see the floor coming closer you awake with a scream.",
	},
	/* 33 */
	{
		"GrandFeast", 2, FALSE,
		"A sweet aroma fills the air as you make out a table fitted with a feast for at least twenty people. You reach for a turkey leg as the dream comes to a quick end.",
	},
	/* 34 */
	{
		"TheStorm", 2, FALSE,
		"The ship sways in the violent waves of the sea. A storm above rages as members of the crew rush to repair damage caused by the wind. You hear someone scream for you to get away from the side but its to late as you are swept off your feet by a huge wave and land in the sea without a hope to be rescued.",
	},
	/* 35 */
	{
		"Whisper", 2, FALSE,
		"Your vision is blanketed by the darkness that surrounds you. A soft whisper is heard that you can't quite make out. Although the voice does seem familiar...",
	},
	/* 36 */
	{
		"TheHelper", 2, FALSE,
		"You moan in pain and agony as your wounds seem to be on fire. Laying in wait for death to overcome you, a figure of a person appears in your distorted vision. A kind hand applies a salve to your wound and quickly wraps it in a bandage. You start to feel better as sleep overtakes you.",
	},
	/* 37 */
	{
		"TheBox", 2, FALSE,
		"The air is dark and close about you. Reaching out in front of you, a solid wall meets your fingertips. It runs smoothly, meeting another and another, until you realize you are trapped on all sides.",
	},
	/* 38 */
	{
		"ABaby", 1, FALSE,
		"The sounds of several screaming babes fills your ears. You try to retreat to a quieter place and find that a squealing infant is blocking your path.",
	},
	/* 39 */
	{
		"Baking", 2, FALSE,
		"The pleasing aromas of nutmeg and cinnamon waft in on a gentle breeze. Drops of saliva begin to form in the corners of your lips as you envision the wonderful foods that are being baked.",
	},
	/* 40 */
	{
		"Balcony", 2, FALSE,
		"A rushy click is heard, as a set of double paned glass doors close firmly behind you. A gentle breeze whispers across your face as you find yourself standing alone on a balcony. A lone cry from an indistinguishable bird disturbs the night air.",
	},
	/* 41 */
	{
		"BaldF", 2, FALSE,
		"After blinking rapidly for several seconds, you are startled to find your hands atop the head of a woman who has recently shaved her hair.",
	},
	/* 42 */
	{
		"BaldM", 2, FALSE,
		"You appear to be sitting in a high backed chair. A narrow rectangular shaped table is before you, sparsely loaded with platters of food. Sitting across from you, is a stout looking, bald man. He seems to be staring intently at you.",
	},
	/* 43 */
	{
		"Bankrupt", 2, FALSE,
		"The feeling of several bodies pressed tightly up against you begins to grate on your nerves. Turning your head from left to right, it appears as if you have stumbled into the middle of a market on one of its busier times. Deciding that you'll free yourself from the crowds and pick up a trinket, you reach deep into your pouch and find that all of your coins are gone!",
	},
	/* 44 */
	{
		"Barefoot", 1, FALSE,
		"Dew covered grass glistens beneath a crescent moon as the remnants of a dense fog disperse. A chilling breeze blows from the west, causing the shredded remains of your clothing to dance against your skin. Quickening your step in search of shelter, you notice that your feet are bare and beginning to trickle streams of blood.",
	},
	/* 45 */
	{
		"BarmaidM", 2, FALSE,
		"A hard wooden bench is beneath you and a mug of stale ale is clutched in your hand. A voluptuous blonde tavern maiden sashays over to where you are seated and whispers softly into your ear. The faint beginnings of a blush creep up to your cheeks as the innkeeper rushes to the table and grabs hold of the woman, dragging her back to the depths of the kitchen.",
	},
	/* 46 */
	{
		"BarmaidF", 2, FALSE,
		"A dull ache throbs in your lower back as you reach a hand behind to knuckle the soreness from your tired muscles. Worn fabric and lace meets your touch. A gasp escapes from your throat as you glance down and see that you are dressed in a form fitting corset and skirt. An ale stained apron is wrapped securely about your waist.",
	},
	/* 47 */
	{
		"ScreamF", 2, FALSE,
		"You glance around the inside of a wooden farm. You notice the smell of burning wood and you close your eyes against the invisible smoke. When you open them again, a fire roars through the building and you feel your skin burning off.",
	},
	/* 48 */
	{
		"Drowning", 1, FALSE,
		"You become slowly aware of having your head held down in a pool of water. As you struggle and scream, you only seem to go deeper.",
	},
	/* 49 */
	{
		"Lovingly", 3, FALSE,
		"A friendly face appears, and soothing hands caress your body as you are held in your lover's embrace.",
	},
	/* 50 */
	{
		"LightPattern", 2, FALSE,
		"Light streams in through the latticework, throwing elaborate patterns and patches of brightness and shadow onto the floor. Slowly, they begin to turn, to melt, to fade into each other and snap apart again. Faster and faster the motion swirls and beats, a pulsing of pure white blinking and interrupting the dance of shadows. Blink, blink, faster and faster, until you realize the light matches the pulse of your heartbeats.",
	},
	/* 51 */
	{
		"Orchard", 2, FALSE,
		"Warmth flows from the deep azure sky, embracing your form gently. Rich greens fill your vision as leaves softly dance in a faint breeze. Stark against the olive grass and emerald leaves, deep red apples bob and glisten in the sunlight.",
	},
	/* 52 */
	{
		"MockingFog", 2, FALSE,
		"A chill mist envelops your form, concealing anything beyond a step in every direction. Spinning and spinning, you search for a break in the fog, peering for a hidden danger. Immediately behind you, a throaty chuckle rides on the dampness, and you turn to face your opponent, only to find endless fog.",
	},
	/* 53 */
	{
		"BirdofHope", 3, FALSE,
		"Piercing eyes peer at you thoughtfully, the bird's entire form seeming both at ease and poised for sudden flight. With a sudden rush of movement, the bird soars away, the air rained with drifting feathers that cling to your garments. Above, a screeching cry of promise fills the air, endowing you with a sense of hope and future accomplishment.",
	},
	/* 54 */
	{
		"TheCloak", 2, FALSE,
		"Stout and thick, your cloak rips away from a firm grasp, flapping wildly in a sudden gust of wind. Robbed of your protection, cold air rushes in to creep beneath your garments, wrapping around your pebbled skin as the cloak pulls desperately against its clasp.",
	},
	/* 55 */
	{
		"Campfire", 1, FALSE,
		"Picking up your worn script, you turn to face the road with bleak determination. Approaching another day's worth of endless travel, you begin to walk away from the broken camp, only to find traces of smoke in the air. Turning towards the source, last night's campfire rages, despite having been stamped out. Flames lick greedily at the undergrowth, quickly spreading heat and destruction in your direction.",
	},
	/* 56 */
	{
		"FailureOrb", 1, FALSE,
		"Floating a hand's length above the heavy slab of table, a glass orb slowly revolves, light glinting off of its perfectly smooth surface. As the globe spins, a curious and soft light grows within, dim at first but growing brighter as the twirling accelerates. Abruptly, the spinning halts, the light quivering within it like liquid in a swirling glass. With impossible slowness, the beacon begins to melt, dripping liquid light onto the table. With every drop, one consuming word crashes through your mind: Failure.",
	},
	/* 57 */
	{
		"LovingEyes", 3, FALSE,
		"Shrouded by a thick brown hood and wisps of stray hair, two emerald green eyes dominate your thoughts, claiming your very soul. Like the color of a vast meadow of swaying grass, flecked with golds like the autumn's leaves, the eyes peer out at you with deep love and endless support.",
	},
	/* 58 */
	{
		"WoodedPath", 2, FALSE,
		"Soft mosses and grass blanket a path that stretches endlessly straight before you. Draped as if weeping, trees align either edge of the untrampled path, forming a lacey and green arch above. As you gaze about, gaps between the trees arise, giving glimpses of darker wood, gnarled and twisted limbs raking at a dismal sky.",
	},
	/* 59 */
	{
		"SmilingKitty", 2, FALSE,
		"With a graceful leap, a small kitten is found to be standing impassively in your lap. It seems to have bathed in dirt and grease, its fur matted and plastered to its skin in several places, a deep knick missing from its ear, dried blood marking several past wounds. Despite its injury, the kitten smiles up at you. Wait.. can kittens smile?",
	},
	/* 60 */
	{
		"AoLRuins", 2, FALSE,
		"Ruins of palaces long swallowed by time peek out from their wooded grave, the sunlight caressing stone walls and crumbling roofs. In a sweeping flow, the walls become whole, stones mounting and stretching towards the heavens. Glistening domes mark expansive palaces, gleaming white with fresh plaster. In the near distance, laughter of children can be heard, intertwining with the booming calls of merchants and hoofbeats through the bustling city.",
	},
	/* 61 */
	{
		"AoLStatue", 2, FALSE,
		"A crumbling figure of stone peers at you, forgotten since the Age of Legends. A crown of thorned blossoms circle curled and flowing hair, several petals broken and most thorns dulled to nubs. With infinite sadness, the past Queen observes you as intently as you observe her, eyes of dull stone suddenly glistening with tears.",
	},
	/* 61 */
	{
		"Scarves", 2, FALSE,
		"Winter-bare branches stretch futilely towards the grey sky, bare of leaves though covered with moving color. Upon closer inspection, you find countless strips of color tied to the branches, scarves of every design and hue flapping in the cold wind, performing a frenzied, rainbow dance.",
	},
	/* 62 */
	{
		"DarkHeart", 1, TRUE,
		"You are in a black place where you can only see yourself clearly and complete darkness all around you. You see the most revolting image you could ever imagine and scream, clutching the sides of your head and shutting your eyes. However, the image stays in your vision, even with your eyes closed, and you scream and cower, trying to look away, trying to run, trying to stop it, and can do no more that cry out horribly and quail in terror. You wake with a terrible shout of dismay and sit up, looking around you in shock. You are soaked in sweat and you flinch at the shadows.",
	},
	/* 63 */
	{
		"LightBurn", 1, TRUE,
		"You find yourself in a big, open space with bight sun and green trees. The sun suddenly becomes terribly warm and you wince as it hurts your eyes. Suddenly the grass catches fire and everything turns into a blazing light. Trying to shut out the lights, you stumble backwards and find yourself in a white space that hurts your eyes so badly. You try to cry out, but your eyes are in too much pain. The lights stream at you and are burning, and you tear at the air, trying to get it to stop. You wake gasping and clutching your face.",
	},
	/* 64 */
	{
		NULL, 2, FALSE,
		NULL,
	},
};
extern const struct DreamType DreamTable[]; // prool
