/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


struct FeastFoodType
{
	char *name;
	char *shortd;
	char *longd;
	int hours;
};

const   struct  FeastFoodType FeastFoodTable [] =
{
	{ /* 1 */
		"bread loaf",
		"a loaf of bread",
		"Here lies a loaf of bread.",
		1
	},
	{ /* 2 */
		"cheese slice",
		"a slice of cheese",
		"Here lies a slice of cheese.",
		2
	},
	{ /* 3 */
		"cheese wedge",
		"a wedge of cheese",
		"Here lies a wedge of cheese.",
		3
	},
	{ /* 4 */
		"cheese block",
		"a block of cheese",
		"Here lies a block of cheese.",
		4
	},
	{ /* 5 */
		"green apple",
		"a small green apple",
		"Here lies a small green apple.",
		2
	},
	{ /* 6 */
		"red apple",
		"a shiny red apple",
		"Here lies a shiny red apple.",
		2
	},
	{ /* 7 */
		"firm ripe pear",
		"a firm ripe pear",
		"Here lies a firm ripe pear.",
		2
	},
	{ /* 8 */
		"bunch green grapes",
		"a bunch of green grapes",
		"Here lies a bunch of green grapes.",
		2
	},
	{ /* 9 */
		"bunch purple grapes",
		"a bunch of purple grapes",
		"Here lies a bunch of purple grapes.",
		2
	},
	{ /* 10 */
		"handfull figs",
		"a handfull of figs",
		"Here lies a handfull of figs.",
		2
	},
	{ /* 11 */
		"toasted butter corn",
		"an ear of toasted corn, dripping with butter",
		"Here lies an ear of toasted corn, dripping with butter.",
		3
	},
	{ /* 12 */
		"thinly sliced beef steak",
		"a thinly sliced beef steak",
		"Here lies a thinly sliced beef steak.",
		4
	},
	{ /* 13 */
		"leg roasted lamb",
		"a leg of roasted lamb",
		"Here lies a leg of roasted lamb.",
		4
	},
	{ /* 14 */
		"gravy spattered beef steak",
		"a beef steak spattered with gravy",
		"Here lies a beef steak spattered with gravy.",
		4
	},
	{ /* 15 */
		"broccoli cheese",
		"a bowl of broccoli covered with melted cheese",
		"Here lies a bowl of broccoli covered with melted cheese.",
		3
	},
	{ /* 16 */
		"spiced chicken breast",
		"a heartily spiced chicken breast",
		"Here lies a heartily spiced chicken breast.",
		4
	},
	{ /* 17 */
		"boiled asparagus meat stuffing",
		"a plate of boiled asparagus with tender meat stuffing",
		"Here lies a plate of boiled asparagus with tender meat stuffing.",
		3
	},
	{ /* 18 */
		"dish cooked lentils",
		"a dish of cooked lentils",
		"Here lies a dish of cooked lentils.",
		3
	},
	{ /* 19 */
		"dish cress lent milk almonds",
		"a dish of cress in lent with milk and almonds",
		"Here lies a dish of cress in lent with milk and almonds.",
		3
	},
	{ /* 20 */
		"cake cheese flour",
		"a cake of cheese and flour",
		"Here lies a cake of cheese and flour.",
		3
	},
	{ /* 21 */
		"custard tart",
		"a custard tart",
		"Here lies a custard tart.",
		3
	},
	{ /* 22 */
		"beef chicken stew",
		"a platter of beef and chicken stewed with wine, herbs, and spices",
		"Here lies a platter of beef and chicken, stewed with wine, herbs, and spices.",
		4
	},
	{ /* 23 */
		"platter capons herbs wine",
		"a platter of capons stuffed with herbs, stewed in wine",
		"Here lies a platter of capons stuffed with herbs, stewed in wine.",
		3
	},
	{ /* 24 */
		"dish toasted bread",
		"a dish of toasted bread in a sweet golden almond milk sauce",
		"Here lies a dish of toasted bread in a sweet golden almond milk sauce.",
		3
	},
	{ /* 25 */
		"dish fish almond milk",
		"a dish of finely ground fish in thickened almond milk",
		"Here lies a dish of finely ground fish in thickened almond milk.",
		3
	},
	{ /* 26 */
		"platter grilled salmon",
		"a platter of grilled salmon in wine sauce",
		"Here lies a platter of grilled salmon in wine sauce.",
		3
	},
	{ /* 27 */
		"plate beef rolls",
		"a plate of beef rolls, stuff with onions and herbs",
		"Here lies a plate of beef rolls, stuff with onions and herbs.",
		4
	},
	{ /* 28 */
		"plate chicken herb stuffing",
		"a plate of chicken roasted with an herb stuffing",
		"Here lies a plate of chicken roasted with an herb stuffing.",
		3
	},
	{ /* 29 */
		"roasted venison red wine",
		"a plate of roasted venison basted in red wine",
		"Here lies a plate of roasted venison basted in red wine.",
		4
	},
	{ /* 30 */
		"rice beef broth",
		"a bowl of rice prepared in beef broth",
		"Here lies a bowl of rice prepared in beef broth.",
		2
	},
	{ /* 31 */
		"rice almond milk",
		"a bowl of rice prepared in almond milk",
		"Here lies a bowl of rice prepared in almond milk.",
		2
	},
	{ /* 32 */
		"toasted bread custard",
		"a toasted bread in a thin custard",
		"Here lies a toasted bread in a thin custard.",
		2
	},
	{ /* 33 */
		"buttered herbs diced bread",
		"a plate of buttered herbs served on diced bread",
		"Here lies a plate of buttered herbs served on diced bread.",
		2
	},
	{ /* 34 */
		"poached eggs milk cheese",
		"a plate of poached eggs simmered in milk and topped with cheese",
		"Here lies a plate of poached eggs simmered in milk and topped with cheese.",
		3
	},
	{ /* 35 */
		"plate lobster vinegar",
		"a plate of lobster served with a vinegar sauce",
		"Here lies a plate of lobster served with a vinegar sauce.",
		4
	},
	{ /* 36 */
		"plate peppered eels",
		"a plate of peppered eels served with an ale sauce",
		"Here lies a plate of peppered eels served with an ale sauce.",
		4
	},
	{ /* 37 */
		"dish fried eggplant",
		"a dish of fried eggplant",
		"Here lies a dish of fried eggplant.",
		3
	},
	{ /* 38 */
		"potage turnips",
		"a potage with turnips",
		"Here lies a potage with turnips.",
		3
	},
	{ /* 39 */
		"green broth eggs cheese",
		"a green broth of eggs and cheese",
		"Here lies a green broth of eggs and cheese.",
		3
	},
	{ /* 40 */
		"fricassee chicken",
		"a fricassee of tender chicken",
		"Here lies a fricassee of tender chicken.",
		4
	},
	{ /* 41 */
		"tart strawberries",
		"a tart of red strawberries",
		"Here lies a tart of red strawberries.",
		3
	},
	{ /* 42 */
		"mirause chicken cinnamon",
		"a mirause of chicken spiced with cinnamon",
		"Here lies a mirause of chicken spiced with cinnamon.",
		4
	},
    { /* 43 */
		"joint roast ox",
		"a sizzling joint of roast ox",
		"Here lies a sizzling joint of roast ox.",
		4
	},
    { /* 44 */
		"portion suckling pig",
		"a portion of tender suckling pig",
		"Here lies a portion of tender suckling pig.",
		4
	},
    { /* 45 */
		"plate sweet meats",
		"a small plate of sweet meats",
		"Here lies a small plate of sweet meats.",
		4
	},
    { /* 46 */
		"piping honey cakes",
		"a plate of piping hot honey cakes",
		"Here lies a plate of piping hot honey cakes.",
		4
	},
    { /* 47 */
		"ragout pork bell peppers",
		"a ragout of pork spiced with bell peppers",
		"Here lies a ragout of pork spiced with bell peppers.",
		4
	},
    { /* 48 */
		"dish green peas",
		"a dish of fresh green peas",
		"Here lies a dish of fresh green peas.",
		4
	},
    { /* 49 */
		"flank silverpike milk",
		"a flank of silverpike poached in milk",
		"Here lies a flank of silverpike poached in milk.",
		4
	},
    { /* 50 */
		"dish river perch",
		"a dish of colorful grilled river perch",
		"Here lies a dish of colorful grilled river perch.",
		4
	},
    { /* 51 */
		"tureen cabbage soup",
		"a tureen of cabbage soup",
		"Here lies a tureen of cabbage soup.",
		4
	},
    { /* 52 */
		"platter blueberry pies",
		"a platter of freshly-baked blueberry pies",
		"Here lies a platter of freshly-baked blueberry pies.",
		4
	},
    { /* 53 */
		"potted hare bayleaves",
		"a dish of potted hare cooked in bayleaves",
		"Here lies a dish of potted hare cooked in bayleaves.",
		4
	},
    { /* 54 */
		"dish flounders carrot turnip",
		"a dish of souchet flounders with carrot and turnip",
		"Here lies a dish of souchet flounders with carrot and turnip.",
		4
	},
    { /* 55 */
		"plate mackerel crab",
		"a plate of mackerel with a sweet crab sauce",
		"Here lies a plate of mackerel with a sweet crab sauce.",
		4
	},
    { /* 56 */
		"dish calf kidney egg",
		"a dish of calf kidneys on a bed of scrambled eggs",
		"Here lies a dish of calf kidneys on a bed of scambled eggs.",
		4
	},
    { /* 57 */
		"tureen tomato soup mint",
		"a tureen of tomato soup with fresh mint",
		"Here lies a tureen of tomato soup with fresh mint.",
		4
	},
    { /* 58 */
		"plate apple honey cinammon",
		"a plate of baked apples stuffed with honey and cinnamon",
		"Here lies a plate of baked apples stuffed with honey and cinammon.",
		4
	},
    { /* 59 */
		"dish pigs feet mushroom",
		"a dish of pigs feet garnished with mushrooms",
		"Here lies a dish of pigs feet garnished with mushrooms.",
		4
	},
    { /* 60 */
		"hotpot calf liver sauce",
		"a hotpot of calf liver with a piquant sauce",
		"Here lies a hotpot of calf liver with a piquant sauce.",
		4
	},
    { /* 61 */
		"dish chestnut butter",
		"a dish of chestnut pudding with butter sauce",
		"Here lies a dish of chestnut pudding with butter sauce.",
		4
	},
    { /* 62 */
		"plate cherry tartlets",
		"a plate of delicious cherry tartlets",
		"Here lies a plate of delicious cherry tartlets.",
		4
	},
    { /* 63 */
		"dish turnip greens",
		"a dish of boiled turnip greens",
		"Here lies a dish of boiled turnip greens.",
		4
	},
    { /* 64 */
		"plate spicy redstripe",
		"a plate of spicy redstripe",
		"Here lies a plate of spicy redstripe.",
		4
	},
    { /* 65 */
		"dish green leeks",
		"a dish of green leeks",
		"Here lies a dish of green leeks.",
		4
	},
    { /* 66 */
		"plate honey almonds",
		"a plate of honey almonds",
		"Here lies a plate of honey almonds.",
		4
	},
    { /* 67 */
		"plate meat turnip",
		"a plate of spiced meat wrapped in turnip tops",
		"Here lies a plate of spiced meat wrapped in turnip tops.",
		4
	},
    { /* 68 */
		"plate rabbit fricassee",
		"a plate of rabbit fricassee ",
		"Here lies a plate of rabbit fricassee.",
		4
	},
    { /* 69 */
		"dish pigeon pie",
		"a dish of pigeon pie",
		"Here lies a dish of pigeon pie.",
		4
	},
    { /* 70 */
		"plate quince jelly",
		"a plate of quince jelly",
		"Here lies a plate of quince jelly.",
		4
	},
};
extern const struct FeastFoodType FeastFoodTable[];
//extern const struct FeastDrinkType FeastDrinkTable[]; // by prool
