/*
-----------------------------------------------------------------------------------------------
                                 Original Code Created AMDG
                             Color codes on descs made by Hortin
                              Fish Created By Aldron and Hortin
-----------------------------------------------------------------------------------------------
Is something similar as:
extern const struct companion_type companion_table[];
needed?
*/
#define FISH_SECT_LAKE  1
#define FISH_SECT_RIVER  2
#define FISH_SECT_OCEAN  4
#define FISH_SECT_RESERVED  8

#define FISH_EXTRA_POISONOUS 1
#define FISH_EXTRA_ATTACKS 2
#define FISH_EXTRA_STINGS 4


struct fish_type
{
	int 	location;
	char *	name;
	char *  short_desc;
	char *	long_desc;
	int		minsize;
	int		maxsize;
	int		rarity;
	int		extraflags;
};
/*name:		Any sort of fish
short:		-
long:		-
minsize:	the fish's min size. differing from 1 to 30, 1 being UBER small, 20 large, 30 HUGE.
maxsize:	the fish's max size. differing from 1 to 30, 1 being UBER small, 20 large, 30 HUGE.
rarity:		1 to 10, 1 for *rare* 10 for common
extra:
-----------------------------------------------------------------------------------------------
			 Fresh Water Fish Table (Listed In Alphabetical Order By Fish)
-----------------------------------------------------------------------------------------------
*/
const   struct  fish_type fish_table [] =
{
	{
		FISH_SECT_LAKE, "small black crapppie",
		"A small {Dblack {ccrapppie",
		"A small {{Dblack {ccrapppie flops around trying to reach water",
		3, 7, 6, 0
	},
	{
		FISH_SECT_LAKE, "tiny bleak",
		"A tiny bleak",
		"A tiny bleak looks small enough to be bait",
		3, 5, 5, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "large blue catfish",
		"A large {Bblue {ccatfish",
		"A large {Bblue {ccatfish whips its whiskers wildly",
		10, 15, 4, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "small blue catfish",
		"A small {Bblue {ccatfish",
		"A small {Bblue {ccatfish whips its whiskers wildly",
		5, 9, 6, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "big bluegill",
		"A big {Bblue{c gill",
		"A big {Bblue{c gill exsposes the spines alone its back",
		8, 14, 6, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "small bluegill",
		"A small {Bblue{c gill",
		"A small {Bblue{c gill exsposes the spines alone its back",
		5, 9, 7, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_RIVER, "huge brook trout",
		"A huge brook trout",
		"A huge brook trout jumps around trying to find water",
		9, 15, 2, 0
	},
	{
		FISH_SECT_RIVER, "little brook trout",
		"A little brook trout",
		"A little brook trout jumps around trying to find water",
		5, 9, 6, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "large brown trout",
		"A large {ybrown {ctrout",
		"A large {ybrown {ctrout's eyes are beginning to cloud up",
		8, 13, 3, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "small brown trout",
		"A small {ybrown {ctrout",
		"A small {ybrown {ctrout's eyes are beginning to cloud up",
		5, 8, 5, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "huge bullhead",
		"A huge bullhead",
		"A huge bullhead tries to sting with its whiskers",
		10, 15, 5, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "small bullhead",
		"A small bullhead",
		"A small bullhead tries to sting with its whiskers",
		4, 8, 7, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "fat carp",
		"A fat carp",
		"A fat carp lays on the ground motionless",
		10, 15, 6, 0
	},
	{
		FISH_SECT_LAKE, "small carp",
		"A small carp",
		"A small carp lays on the ground motionless",
		6, 10, 6, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "chinook salmon",
		"A small chinook salmon",
		"A small chinook salmon jumps out of the water.",
		3, 19, 3, 0
	},
	{
		FISH_SECT_LAKE, "fat chub",
		"A fat chub",
		"A fat chub is too big to flop around",
		10, 16, 4, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "chum salmon",
		"A thick chum salmon",
		"A thick chum salmon",
		4, 15, 6, 0
	},
	{
		FISH_SECT_LAKE, "small dace",
		"A small dace",
		"A small dace looks a bit like a big minnow",
		5, 8, 4, 0
	},
	{
		FISH_SECT_LAKE, "fangfish",
		"A fangfish",
		"A fangfish flops its tale.",
		7, 13, 7, 0
	},
	{
		FISH_SECT_LAKE, "fat fangfish",
		"A fat fangfish",
		"A fat fangfish bounces around on the ground.",
		12, 16, 4, 0
	},
	{
		FISH_SECT_LAKE, "small fangfish",
		"A small fangfish",
		"A small fangfish has a broken fang.",
		3, 8, 6, 0
	},
	{
		FISH_SECT_LAKE, "big grunter",
		"A big grunter",
		"A big grunter makes noices while floping its tale about.",
		11, 18, 4, 0
	},
	{
		FISH_SECT_LAKE, "grunter",
		"A grunter",
		"A grunter makes soft noices.",
		5, 9, 6, 0
	},
	{
		FISH_SECT_LAKE, "large lake trout",
		"A large lake trout",
		"A large lake trout is gaping its gills from the air",
		10, 15, 2, 0
	},
	{
		FISH_SECT_LAKE, "small lake trout",
		"A small lake trout",
		"A small lake trout is gaping its gills from the air",
		8, 12, 4, 0
	},
	{
		FISH_SECT_LAKE, "small largemouth bass",
		"A small largemouth {gbass{c",
		"A small largemouth {gbass {cslaps its tale around.",
		8, 12, 8, 0
	},
	{
		FISH_SECT_LAKE, "fat largemouth bass",
		"A fat largemouth {gbass{c",
		"A fat largemouth {gbass {crolls its eyes around looking for water.",
		16, 22, 8, 0
	},
	{
		FISH_SECT_LAKE, "largemouth bass",
		"A largemouth {gbass{c",
		"A largemouth {gbass {cslaps its tale around.",
		12, 16, 8, 0
	},
	{
		FISH_SECT_RIVER, "big lionfish",
		"A big lionfish",
		"A big lionfish snaps at the air around it.",
		12, 17, 4, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_RIVER, "lionfish",
		"A lionfish",
		"A lionfish flops about on the ground.",
		7, 11, 6, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_RIVER, "small lionfish",
		"A small lionfish",
		"A small lionfish bends its body.",
		5, 8, 6, FISH_EXTRA_ATTACKS
	},
	{	FISH_SECT_LAKE||FISH_SECT_RIVER, "adult minnow",
		"An adult {Wm{wi{Wn{wn{Wo{ww{c",
		"An adult {Wm{wi{Wn{wn{Wo{ww {cflops about.",
		4, 16, 5, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "young minnow",
		"A young {Wm{wi{Wn{wn{Wo{ww {cfish",
		"A young {Wm{wi{Wn{wn{Wo{ww {cfish flops about.",
		4, 16, 5, 0
	},
	{
		FISH_SECT_RIVER, "mudfish",
		"A mudfish",
		"A mudfish blows bubbles through its gills.",
		3, 14, 8, 0
	},
	{
		FISH_SECT_LAKE, "large pickerel",
		"A large pickerel",
		"A large pickerel exsposes its sharp teeth",
		15, 20, 2, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_LAKE, "small pickerel",
		"A small pickerel",
		"A small pickerel exsposes its sharp teeth",
		7, 13, 2, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_LAKE, "long pike",
		"A long pike",
		"A long pike tries to bite the closest thing to it",
		15, 20, 2, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_LAKE, "small pike",
		"A small pike",
		"A small pike tries to bite the closest thing to it",
		6, 12, 4, FISH_EXTRA_ATTACKS
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "pink salmon",
		"A small {Mpink {csalmon",
		"A small salmon with {Mpink {cspots lies here.",
		5, 16, 6, 0
	},
	{
		FISH_SECT_OCEAN, "pipefish",
		"A pipefish",
		"A pipefish curls its body.",
		1, 8, 7, 0
	},
	{
		FISH_SECT_OCEAN||FISH_SECT_LAKE||FISH_SECT_RIVER, "long prickleback",
		"A long prickleback",
		"A long prickleback curls its body.",
		4, 19, 8, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "medium-sized rainbow trout",
		"A medium-sized {Rr{Ya{yi{Gn{Bb{Mo{Ww {ctrout",
		"A medium-sized {Rr{Ya{yi{Gn{Bb{Mo{Ww {ctrout's colors are starting to fade",
		15, 20, 3, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "large rainbow trout",
		"A large {Rr{Ya{yi{Gn{Bb{Mo{Ww {ctrout",
		"A large {Rr{Ya{yi{Gn{Bb{Mo{Ww {ctrout's colors are starting to fade",
		17, 25, 3, 0
	},
	{
		FISH_SECT_OCEAN, "red-stripe",
		"A {Rred{W-{Rst{Wri{Rpe{c",
		"A {Rred{W-{Rst{Wri{Rpe {cflops around slaping its tale.",
		9, 18, 6, 0
	},
	{
		FISH_SECT_LAKE, "big fat smallmouth {gbass{c",
		"A big fat smallmouth {gbass{c",
		"A big fat smallmouth {gbass {cflops around.",
		16, 20, 4, 0
	},
	{
		FISH_SECT_LAKE, "medium smallmouth bass",
		"A medium smallmouth {gbass{c",
		"A medium smallmouth {gbass {cflops around.",
		12, 15, 8, 0
	},
	{
		FISH_SECT_LAKE, "tiny smallmouth bass",
		"A tiny smallmouth {gbass{c",
		"A tiny smallmouth {gbass {cflops around.",
		8, 12, 8, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "soho salmon",
		"A soho salmon",
		"A soho salmon curls its body.",
		4, 15, 4, 0
	},
	{
		FISH_SECT_LAKE, "spotted bass",
		"A {gs{wp{go{wt{gt{we{gd bass{c",
		"A {gs{wp{go{wt{gt{we{gd bass {cflops its tale.",
		10, 14, 7, 0
	},
	{
		FISH_SECT_LAKE, "tiny spotted bass",
		"A tiny {gs{wp{go{wt{gt{we{gd bass{c",
		"A tiny {gs{wp{go{wt{gt{we{gd bass {cflops its tale.",
		6, 10, 6, 0
	},
	{
		FISH_SECT_LAKE, "big fat spotted bass",
		"A big fat {gs{wp{go{wt{gt{we{gd bass{c",
		"A big fat {gs{wp{go{wt{gt{we{gd bass {cflops its tale.",
		14, 18, 5, 0
	},
	{
		FISH_SECT_LAKE||FISH_SECT_RIVER, "sprat",
		"A sprat",
		"A sprat flops about, slaping its tale.",
		2, 14, 8, 0
	},
	{
		FISH_SECT_LAKE, "medium-sized sunfish",
		"A medium-sized {Ys{yu{Yn{c fish",
		"A medium-sized {Ys{yu{Yn{c fish exposes the spines on its back",
		7, 10, 8, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "tiny sunfish",
		"A tiny {Ys{yu{Yn{c fish",
		"A tiny {Ys{yu{Yn{c fish exposes the spines on its back",
		2, 6, 9, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "small vimba",
		"A small vimba",
		"A small vimba looks a bit boney",
		6, 8, 5, 0
	},
	{
		FISH_SECT_LAKE, "large walleye",
		"A large walleye",
		"A large walleye exsposes the spines on its back",
		7, 13, 3, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "small walleye",
		"A small walleye",
		"A small walleye exsposes the spines on its back",
		4, 6, 5, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "small white crapppie",
		"A small {Wwhite {ccrapppie",
		"A small {Wwhite {ccrapppie flops around trying to reach water",
		3, 7, 8, 0
	},
	{
		FISH_SECT_LAKE, "medium yellow perch",
		"A {Yyellow {cperch",
		"A {Yyellow {cperch flops around wildly",
		8, 12, 6, FISH_EXTRA_STINGS
	},
	{
		FISH_SECT_LAKE, "small yellow perch",
		"A small {Yyellow {cperch",
		"A small {Yyellow {cperch flops around wildly",
		3, 7, 8, FISH_EXTRA_STINGS
	},
	{ 0,"", "", "", 0, 0,0,0},
};

/*At this point in time there have been 67 fish composed of 33 species completed -Hortin
(How about making a desc char so that people know what it looks like. I found a good fish
website at http://www.fishbase.org/Search.cfm -Hortin)
-----------------------------------------------------------------------------------------------
					 Salt Water Fish Not Yet Completed
-----------------------------------------------------------------------------------------------
(I was thinking of adding in a small shark, but not sure -Hortin)
Stripped Bass,
Murray Cod, (sort of bass)
Greater Amberjack,
Almaco Jack,
Blue Runner,
Mackerel,
Steelhead (Sea-run trout)
Seaperch,
Blue Marlin (biggest fish catchable)
Turbot,
Thornback Ray,
Bluefin Tuna, Whahoo, Little Tunny
Puff-Fish
Eel
Silverpike (not sure if it's salt or not, but think so -Hortin)
-----------------------------------------------------------------------------------------------
			Fish That Have Been Completed (Listed In Alphabetical Order)
-----------------------------------------------------------------------------------------------
Black Crappie (Done by Hortin)
Bleak (Done by Hortin)
Blue Catfish (Done by Hortin)
Bluegill (Done by Hortin)
Brook trout (Done by Hortin)
Brown trout (Done by Hortin)
Bullhead (Done by Hortin)
Carp (Done by Hortin)
Chinook salmon (Done by Aldron)
Chub (Done by Hortin)
Chum salmon (Done by Aldron)
Dace (Done by Hortin)
Fangfish (Done by Aldron)
Grunter (Done by Aldron)
Lake trout (Done by Hortin)
Largemouth Bass (Done by Aldron)
Lionfish (Done by Aldron)
Minnow (Done by Aldron and Hortin)
Mudfish (Done by Aldron)
Pickerel (Cone by Hortin)
Pike (Done by Hortin)
Pink salmon (Done by Aldron)
Pipefish (Done by Aldron)
Prickleback (Done by Aldron)
Rainbow trout (Done by Hortin)
Red-Stripe (Done by Aldron)
Smallmouth bass (Done by Aldron)
Soho salmon (Done by Aldron)
Spotted bass (Done by Aldron)
Sprat (Done by Aldron)
Sunfish (Done by Hortin)
Sprat (Done by Aldron)
Vimba (Done by Hortin)
Walleye (Done by Hortin)
White Crappie (Done by Hortin)
Yellow Perch (Done by Hortin)
*/
