/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

/* this is a listing of all the commands and command related data */

/* wrapper function for safe command execution - The Condom */
void do_function args((CHAR_DATA *ch, DO_FUN *do_fun, char *argument));

/* for command types */
#define ML 	MAX_LEVEL	/* implementor */
#define L1	MAX_LEVEL - 1  	/* creator */
#define L2	MAX_LEVEL - 2	/* supreme being */
#define L3	MAX_LEVEL - 3	/* deity */
#define L4 	MAX_LEVEL - 4	/* god */
#define L5	MAX_LEVEL - 5	/* immortal */
#define L6	MAX_LEVEL - 6	/* demigod */
#define L7	MAX_LEVEL - 7	/* angel */
#define L8	MAX_LEVEL - 8	/* avatar */
#define IM	LEVEL_IMMORTAL 	/* avatar */
#define HE	LEVEL_HERO	/* hero */

#define COM_INGORE	1

extern char last_command[MAX_STRING_LENGTH];
extern char last_command2[MAX_INPUT_LENGTH];
extern int last_descriptor;

/* grant code */
struct pair_type
{
    char * const        first;
    char * const       second;
    bool              one_way;
};

/*
 * Structure for a command in the command lookup table.
 */

struct	cmd_type
{
    char * const	name;
    DO_FUN *		do_fun;
    sh_int		position;
    sh_int		level;
    sh_int		log;
    sh_int      show;
    sh_int      hours;
    sh_int      unarmed;
};



/* the command table itself */
extern	const	struct	cmd_type	cmd_table	[];

struct	newb_cmd_type
{
    char * const	name;
    DO_FUN *		do_fun;
    sh_int		position;
    sh_int		level;
    sh_int		log;
    sh_int      show;
    sh_int      hours;
    sh_int      unarmed;
};



/* the command table itself */
extern	const	struct	newb_cmd_type	newb_cmd_table	[];

/*
 * Command functions.
 * Defined in act_*.c (mostly).
 */

DECLARE_DO_FUN( do_question );
DECLARE_DO_FUN( do_snapgear );

/* grant code */
DECLARE_DO_FUN( do_grant    );
DECLARE_DO_FUN( do_gstat    );
DECLARE_DO_FUN( do_revoke   );
/* regular stuff */
DECLARE_DO_FUN(	do_advance	);
DECLARE_DO_FUN( do_affects	);
DECLARE_DO_FUN( do_afk		);
DECLARE_DO_FUN( do_age		);
/*
DECLARE_DO_FUN( do_alia		);
DECLARE_DO_FUN( do_alias	);
*/
DECLARE_DO_FUN(	do_allow	);
DECLARE_DO_FUN(	do_areas	);
DECLARE_DO_FUN(	do_at		);
DECLARE_DO_FUN(	do_auction	);
DECLARE_DO_FUN(	do_backstab	);
DECLARE_DO_FUN(   do_backup  );
DECLARE_DO_FUN(	do_bamfin	);
DECLARE_DO_FUN(	do_bamfout	);
DECLARE_DO_FUN(	do_ban		);
DECLARE_DO_FUN( do_bash		);
DECLARE_DO_FUN(   do_battle  );
DECLARE_DO_FUN(   do_bopen   );
DECLARE_DO_FUN(   do_bclose  );
DECLARE_DO_FUN(   do_bstop   );
DECLARE_DO_FUN(   do_bchat   );
DECLARE_DO_FUN(   do_badd    );
DECLARE_DO_FUN(   do_bremove );
DECLARE_DO_FUN(   do_brush );
DECLARE_DO_FUN(   do_buddy );
DECLARE_DO_FUN( do_trackbuffer );
DECLARE_DO_FUN(   do_continue );

DECLARE_DO_FUN(   do_tourney  );
DECLARE_DO_FUN(   do_topen   );
DECLARE_DO_FUN(   do_tclose  );
DECLARE_DO_FUN(   do_tstop   );
DECLARE_DO_FUN(   do_tchat   );
DECLARE_DO_FUN(   do_tadd    );
DECLARE_DO_FUN(   do_tremove );

DECLARE_DO_FUN (do_ftag);
DECLARE_DO_FUN (do_map);
DECLARE_DO_FUN (do_tag);
DECLARE_DO_FUN (do_red);
DECLARE_DO_FUN (do_blue);
DECLARE_DO_FUN( do_dfhunt );
DECLARE_DO_FUN( do_dfhstat );
DECLARE_DO_FUN ( do_sendmail );
DECLARE_DO_FUN ( do_email );
/*DECLARE_DO_FUN(   do_bonus );*/
DECLARE_DO_FUN( do_berserk	);
DECLARE_DO_FUN( do_bite 	);
DECLARE_DO_FUN( do_bondmote);
DECLARE_DO_FUN( do_bondtalk	);
DECLARE_DO_FUN( do_bondwhere);
DECLARE_DO_FUN(	do_brandish	);
DECLARE_DO_FUN( do_brew	);
DECLARE_DO_FUN(	do_new_bug		);
DECLARE_DO_FUN(	do_buy		);
DECLARE_DO_FUN(	do_weave	);
DECLARE_DO_FUN( do_changes	);
DECLARE_DO_FUN( do_circle   );
DECLARE_DO_FUN( do_claw 	);
DECLARE_DO_FUN( do_climb 	);
DECLARE_DO_FUN( do_clone	);
DECLARE_DO_FUN(	do_close	);
DECLARE_DO_FUN( do_coder	);
DECLARE_DO_FUN(	do_colour	);
DECLARE_DO_FUN( do_consent  );
DECLARE_DO_FUN(	do_commands	);
DECLARE_DO_FUN(	do_compare	);
DECLARE_DO_FUN(	do_consider	);
DECLARE_DO_FUN(	do_copyover	);
DECLARE_DO_FUN( do_count	);
DECLARE_DO_FUN(	do_credits	);
//DECLARE_DO_FUN( do_cut		);
DECLARE_DO_FUN( do_dance    );
DECLARE_DO_FUN( do_deaf		);
DECLARE_DO_FUN( do_delet	);
DECLARE_DO_FUN( do_delete	);
DECLARE_DO_FUN(	do_demand	);
DECLARE_DO_FUN(	do_deny		);
DECLARE_DO_FUN(	do_description	);
DECLARE_DO_FUN( do_dirt		);
DECLARE_DO_FUN(	do_disarm	);
DECLARE_DO_FUN(	do_disconnect	);
DECLARE_DO_FUN(	do_disable	);
DECLARE_DO_FUN( do_divorce  );
DECLARE_DO_FUN(	do_down		);
DECLARE_DO_FUN(	do_drag		);
DECLARE_DO_FUN(	do_drink	);
DECLARE_DO_FUN(	do_drop		);
DECLARE_DO_FUN( do_dump		);
DECLARE_DO_FUN(	do_east		);
DECLARE_DO_FUN(	do_eat		);
DECLARE_DO_FUN(	do_echo		);
DECLARE_DO_FUN(	do_emote	);
DECLARE_DO_FUN(	do_embark	);
DECLARE_DO_FUN(	do_join  	);
DECLARE_DO_FUN(	do_schedule	);
DECLARE_DO_FUN(	do_unjoin	);
DECLARE_DO_FUN( do_engage	);
DECLARE_DO_FUN( do_enter	);
DECLARE_DO_FUN( do_envenom	);
DECLARE_DO_FUN(	do_equipment	);
DECLARE_DO_FUN( do_eqstats );
DECLARE_DO_FUN(	do_examine	);
DECLARE_DO_FUN(	do_explored	);
DECLARE_DO_FUN(	do_exchange	);
DECLARE_DO_FUN(	do_exits	);
DECLARE_DO_FUN( do_helpcheck );
DECLARE_DO_FUN( do_mysql_help );
DECLARE_DO_FUN(	do_pload	);
DECLARE_DO_FUN(	do_punload	);
DECLARE_DO_FUN(	do_fill		);
//DECLARE_DO_FUN(	do_fletch	);
DECLARE_DO_FUN(	do_tickle	);
DECLARE_DO_FUN(	do_feed	);
DECLARE_DO_FUN( do_faire    );
DECLARE_DO_FUN( do_finger	);
DECLARE_DO_FUN( do_flag		);
DECLARE_DO_FUN(	do_flee		);
DECLARE_DO_FUN( do_finish	);
DECLARE_DO_FUN(	do_follow	);
DECLARE_DO_FUN(	do_force	);
DECLARE_DO_FUN(	do_freeze	);
DECLARE_DO_FUN( do_gain		);
DECLARE_DO_FUN( do_gmote	);
DECLARE_DO_FUN(	do_get		);
DECLARE_DO_FUN(	do_gevent	);
DECLARE_DO_FUN( do_gocial	);
DECLARE_DO_FUN( do_gquest   );
DECLARE_DO_FUN(	do_give		);
DECLARE_DO_FUN( do_ooc	    );
DECLARE_DO_FUN( do_gltalk	);
DECLARE_DO_FUN( do_gcom	);
DECLARE_DO_FUN( do_enlist	);
DECLARE_DO_FUN( do_stafftalk);
DECLARE_DO_FUN( do_go       );
DECLARE_DO_FUN(	do_new_goto		);
DECLARE_DO_FUN( do_grab 	);
DECLARE_DO_FUN( do_grats	);
DECLARE_DO_FUN(	do_group	);
DECLARE_DO_FUN( do_groups	);
DECLARE_DO_FUN(	do_gtell	);
DECLARE_DO_FUN( do_guild    );
DECLARE_DO_FUN( do_heal		);
DECLARE_DO_FUN(	do_help		);
//DECLARE_DO_FUN( do_hem		);
DECLARE_DO_FUN(	do_hide		);
DECLARE_DO_FUN(	do_holylight	);
DECLARE_DO_FUN(	do_idea		);
DECLARE_DO_FUN(	do_immtalk	);
DECLARE_DO_FUN( do_incognito	);
DECLARE_DO_FUN( do_clantalk	);
DECLARE_DO_FUN( do_immortal );
DECLARE_DO_FUN( do_imotd	);
DECLARE_DO_FUN(	do_inventory	);
DECLARE_DO_FUN(	do_invis	);
DECLARE_DO_FUN(	do_irc	);
/* DECLARE_DO_FUN( do_keyring      ); */
DECLARE_DO_FUN(	do_kick		);
DECLARE_DO_FUN(	do_punch	);
DECLARE_DO_FUN(	do_sidekick	);
DECLARE_DO_FUN(	do_jumpkick	);
DECLARE_DO_FUN(	do_leapkick	);
DECLARE_DO_FUN(	do_headbutt	);
DECLARE_DO_FUN(	do_elbow	);
DECLARE_DO_FUN(	do_knee		);
DECLARE_DO_FUN(	do_legsweep	);
DECLARE_DO_FUN(	do_hookkick	);
DECLARE_DO_FUN(	do_kill		);
DECLARE_DO_FUN(	do_knock	);
//DECLARE_DO_FUN( do_layout	);
DECLARE_DO_FUN(	do_learn	);
DECLARE_DO_FUN(	do_link		);
DECLARE_DO_FUN(	do_list		);
DECLARE_DO_FUN( do_last         );
DECLARE_DO_FUN( do_load		);
DECLARE_DO_FUN(	do_lock		);
DECLARE_DO_FUN(	do_log		);
DECLARE_DO_FUN(	do_look		);
DECLARE_DO_FUN( do_marry    );
DECLARE_DO_FUN(	do_memory	);
DECLARE_DO_FUN( do_mine         );
DECLARE_DO_FUN(	do_mfind	);
DECLARE_DO_FUN(	do_mload	);
DECLARE_DO_FUN(	do_mset		);
DECLARE_DO_FUN(	do_mstat	);
DECLARE_DO_FUN(	do_mwhere	);
DECLARE_DO_FUN( do_mob		);
DECLARE_DO_FUN( do_motd		);
DECLARE_DO_FUN( do_mpstat	);
DECLARE_DO_FUN( do_mpdump	);
DECLARE_DO_FUN(	do_murde	);
DECLARE_DO_FUN(	do_murder	);
DECLARE_DO_FUN( do_newlock	);
DECLARE_DO_FUN( do_news		);
DECLARE_DO_FUN( do_nibble	);
DECLARE_DO_FUN( do_nofollow	);
DECLARE_DO_FUN( do_noloot	);
DECLARE_DO_FUN(	do_north	);
DECLARE_DO_FUN( do_northeast);
DECLARE_DO_FUN( do_northwest);
DECLARE_DO_FUN( do_nosummon	);
DECLARE_DO_FUN(	do_pnote	);
DECLARE_DO_FUN(	do_note	);
DECLARE_DO_FUN(	do_ofind	);
DECLARE_DO_FUN(	do_oload	);
DECLARE_DO_FUN(	do_open		);
DECLARE_DO_FUN(	do_order	);
DECLARE_DO_FUN(	do_oset		);
DECLARE_DO_FUN(	do_ostat	);
DECLARE_DO_FUN( do_outfit	);
DECLARE_DO_FUN( do_owhere	);
DECLARE_DO_FUN(	do_pardon	);
DECLARE_DO_FUN(	do_password	);
DECLARE_DO_FUN(	do_peace	);
DECLARE_DO_FUN( do_pecho	);
DECLARE_DO_FUN( do_penalty	);
DECLARE_DO_FUN( do_permban	);
DECLARE_DO_FUN(	do_pick		);
DECLARE_DO_FUN( do_play		);
DECLARE_DO_FUN( do_sing		);
DECLARE_DO_FUN( do_sip		);
DECLARE_DO_FUN(	do_peek		);
DECLARE_DO_FUN( do_pmote	);
DECLARE_DO_FUN(	do_pose		);
DECLARE_DO_FUN(	do_shell		);
DECLARE_DO_FUN( do_pour		);
DECLARE_DO_FUN(	do_practice	);
DECLARE_DO_FUN( do_prefi	);
DECLARE_DO_FUN( do_prefix	);
DECLARE_DO_FUN( do_prompt	);
DECLARE_DO_FUN( do_proficiency	);
DECLARE_DO_FUN( do_profile	);
DECLARE_DO_FUN( do_promote	);
DECLARE_DO_FUN( do_propose  );
DECLARE_DO_FUN( do_protect	);
DECLARE_DO_FUN(	do_purge	);
DECLARE_DO_FUN(	do_put		);
DECLARE_DO_FUN(	do_qa	);
DECLARE_DO_FUN(	do_quaff	);
DECLARE_DO_FUN(	do_qui		);
DECLARE_DO_FUN(	do_quit		);
DECLARE_DO_FUN( do_quote	);
DECLARE_DO_FUN( do_read		);
DECLARE_DO_FUN(	do_reboo	);
DECLARE_DO_FUN(	do_reboot	);
DECLARE_DO_FUN(	do_recall	);
DECLARE_DO_FUN(	do_recho	);
DECLARE_DO_FUN(	do_recite	);
DECLARE_DO_FUN( do_recruit	);
DECLARE_DO_FUN( do_remorts      );
DECLARE_DO_FUN(	do_remove	);
DECLARE_DO_FUN(	do_rent		);
DECLARE_DO_FUN( do_replay	);
DECLARE_DO_FUN(	do_reply	);
DECLARE_DO_FUN(	do_report	);
DECLARE_DO_FUN(	do_rescue	);
DECLARE_DO_FUN(	do_rest		);
DECLARE_DO_FUN(	do_restore	);
DECLARE_DO_FUN(	do_retell	);
DECLARE_DO_FUN(	do_return	);
DECLARE_DO_FUN( do_reward       );
DECLARE_DO_FUN(	do_roleplay	);
DECLARE_DO_FUN(	do_rprecall	);
DECLARE_DO_FUN(	do_event	);
DECLARE_DO_FUN(	do_nstring	);
DECLARE_DO_FUN(	do_rset		);
DECLARE_DO_FUN(	do_rstat	);
DECLARE_DO_FUN( do_rush	);
DECLARE_DO_FUN( do_rules	);
DECLARE_DO_FUN(	do_sacrifice	);
DECLARE_DO_FUN(	do_save		);
DECLARE_DO_FUN(	do_say		);
DECLARE_DO_FUN(	do_sayto    );
DECLARE_DO_FUN( do_seantalk );
DECLARE_DO_FUN(	do_scan		);
DECLARE_DO_FUN(	do_score	);
DECLARE_DO_FUN( do_new_score        ); 
DECLARE_DO_FUN(	do_rpscore	);
DECLARE_DO_FUN(	do_rplog	);
DECLARE_DO_FUN( do_scroll	);
DECLARE_DO_FUN( do_second   );
DECLARE_DO_FUN(	do_seal		);
DECLARE_DO_FUN( do_seantalk );
DECLARE_DO_FUN(	do_sell		);
DECLARE_DO_FUN(	do_select	);
DECLARE_DO_FUN(	do_sendto	);
DECLARE_DO_FUN( do_set		);
DECLARE_DO_FUN( do_craft	);
DECLARE_DO_FUN( do_repair	);
DECLARE_DO_FUN( do_enhance	);
DECLARE_DO_FUN( do_reinforce	);
DECLARE_DO_FUN( do_dye		);
DECLARE_DO_FUN( do_adorn	);
DECLARE_DO_FUN( do_shop		);
DECLARE_DO_FUN(	do_summary	);
/*DECLARE_DO_FUN(	do_shout	);*/
DECLARE_DO_FUN( do_show		);
DECLARE_DO_FUN(	do_shutdow	);
DECLARE_DO_FUN(	do_shutdown	);
DECLARE_DO_FUN( do_sit		);
DECLARE_DO_FUN( do_skills	);
DECLARE_DO_FUN(	do_sla		);
DECLARE_DO_FUN(	do_slay		);
DECLARE_DO_FUN(	do_sleep	);
DECLARE_DO_FUN(	do_slookup	);
DECLARE_DO_FUN( do_smelt        );
DECLARE_DO_FUN( do_smote	);
DECLARE_DO_FUN( do_nmote	);
DECLARE_DO_FUN(	do_sneak	);
DECLARE_DO_FUN(	do_snoop	);
DECLARE_DO_FUN( do_socials	);
DECLARE_DO_FUN(	do_south	);
DECLARE_DO_FUN( do_southeast);
DECLARE_DO_FUN( do_southwest);
DECLARE_DO_FUN( do_sockets	);
DECLARE_DO_FUN( do_spearforms);
DECLARE_DO_FUN( do_spells	);
DECLARE_DO_FUN(	do_split	);
DECLARE_DO_FUN( do_spouse   );
DECLARE_DO_FUN(	do_sset		);
DECLARE_DO_FUN(	do_stand	);
DECLARE_DO_FUN( do_stance   );
DECLARE_DO_FUN( do_stat		);
DECLARE_DO_FUN(	do_steal	);
DECLARE_DO_FUN( do_step		);
DECLARE_DO_FUN( do_story	);
DECLARE_DO_FUN( do_string	);
DECLARE_DO_FUN(	do_style	);
DECLARE_DO_FUN(	do_surrender	);
DECLARE_DO_FUN(	do_switch	);
DECLARE_DO_FUN(	do_tell		);
DECLARE_DO_FUN(	do_time		);
/* remarked bellas 3-5-02
DECLARE_DO_FUN(	do_title	); */
DECLARE_DO_FUN(	do_tour		);
DECLARE_DO_FUN(	do_train	);
DECLARE_DO_FUN( do_trainerdump  );
DECLARE_DO_FUN(	do_transfer	);
DECLARE_DO_FUN( do_trip		);
DECLARE_DO_FUN( do_treesing	);
DECLARE_DO_FUN( do_tree	);
DECLARE_DO_FUN( do_treetalk );
DECLARE_DO_FUN(	do_turn		);
DECLARE_DO_FUN(	do_typo		);
DECLARE_DO_FUN( do_unalias	);
DECLARE_DO_FUN(	do_unlock	);
DECLARE_DO_FUN( do_unread	);
DECLARE_DO_FUN( do_unseal	);
DECLARE_DO_FUN(	do_up		);
DECLARE_DO_FUN(	do_value	);
DECLARE_DO_FUN(	do_veil	);
DECLARE_DO_FUN(	do_visible	);
DECLARE_DO_FUN( do_violate	);
DECLARE_DO_FUN( do_vnum		);
DECLARE_DO_FUN(	do_wake		);
DECLARE_DO_FUN(	do_wear		);
DECLARE_DO_FUN(	do_weather	);
DECLARE_DO_FUN(	do_west		);
DECLARE_DO_FUN(	do_where	);
DECLARE_DO_FUN(	do_who		);
DECLARE_DO_FUN( do_whois	);
DECLARE_DO_FUN(	do_wimpy	);
DECLARE_DO_FUN(	do_wizhelp	);
DECLARE_DO_FUN(	do_wizlock	);
DECLARE_DO_FUN( do_wizlist	);
DECLARE_DO_FUN( do_wiznet	);
DECLARE_DO_FUN( do_worth	);
DECLARE_DO_FUN( do_write	);
DECLARE_DO_FUN(	do_yell		);
DECLARE_DO_FUN(	do_zap		);
DECLARE_DO_FUN( do_zecho	);
DECLARE_DO_FUN( do_olc		);
DECLARE_DO_FUN( do_asave	);
DECLARE_DO_FUN( do_alist	);
DECLARE_DO_FUN( do_resets	);
DECLARE_DO_FUN( do_redit	);
DECLARE_DO_FUN( do_aedit	);
DECLARE_DO_FUN( do_gedit	);
DECLARE_DO_FUN( do_medit	);
DECLARE_DO_FUN( do_oedit	);
DECLARE_DO_FUN( do_mpedit	);
DECLARE_DO_FUN( do_hedit	);
DECLARE_DO_FUN( do_qedit	);
DECLARE_DO_FUN( do_draw	);
DECLARE_DO_FUN( do_dislodge	);
DECLARE_DO_FUN( do_fire	);
DECLARE_DO_FUN( do_walkin );
DECLARE_DO_FUN( do_walkout );
DECLARE_DO_FUN( do_teach );
DECLARE_DO_FUN( do_teach_old );
DECLARE_DO_FUN( do_appraise );
DECLARE_DO_FUN( do_observe );
DECLARE_DO_FUN( do_butcher );
DECLARE_DO_FUN( do_skin );
DECLARE_DO_FUN( do_spinkick );
DECLARE_DO_FUN( do_sweepkick );
DECLARE_DO_FUN( do_throw );
DECLARE_DO_FUN( do_strangle );
DECLARE_DO_FUN( do_blackjack );
DECLARE_DO_FUN( do_treat );
DECLARE_DO_FUN( do_grasp );
DECLARE_DO_FUN( do_rebirth );
DECLARE_DO_FUN( do_release );
DECLARE_DO_FUN( char_backg );
DECLARE_DO_FUN( do_withdraw );
DECLARE_DO_FUN( do_deposit );
DECLARE_DO_FUN( do_balance );
DECLARE_DO_FUN( do_clanrecall );
DECLARE_DO_FUN( do_subclanrecall );
/*DECLARE_DO_FUN( do_inchar );*/
DECLARE_DO_FUN( do_smoke );
DECLARE_DO_FUN( do_exhale );
DECLARE_DO_FUN( do_chew );
DECLARE_DO_FUN( do_spit );
DECLARE_DO_FUN( do_pawn );
DECLARE_DO_FUN( do_junk );
DECLARE_DO_FUN( do_when );
DECLARE_DO_FUN( do_void );
DECLARE_DO_FUN( do_letgo );
DECLARE_DO_FUN( do_mlevel );
DECLARE_DO_FUN( do_olevel );
DECLARE_DO_FUN( do_restring );
DECLARE_DO_FUN( do_beep );
DECLARE_DO_FUN( do_iwhere );
DECLARE_DO_FUN( do_fights );
DECLARE_DO_FUN( do_objcheck);
DECLARE_DO_FUN( do_osay);
DECLARE_DO_FUN( do_fear);
DECLARE_DO_FUN( do_feast);
DECLARE_DO_FUN( do_new_shadowwalk);
DECLARE_DO_FUN( do_rub );
/* DECLARE_DO_FUN( do_shadowpass); */
DECLARE_DO_FUN( do_dream);
DECLARE_DO_FUN( do_quest);
DECLARE_DO_FUN( do_version);
DECLARE_DO_FUN( do_bounty);
DECLARE_DO_FUN( do_bounties);
DECLARE_DO_FUN( do_unbounty);
DECLARE_DO_FUN( do_sharpen);
DECLARE_DO_FUN( do_pkill);
DECLARE_DO_FUN( do_search);
DECLARE_DO_FUN( do_speardance);
DECLARE_DO_FUN( do_whirlwind);
//DECLARE_DO_FUN( do_stitch);
DECLARE_DO_FUN( do_slice);
DECLARE_DO_FUN( do_touch);
DECLARE_DO_FUN( do_home);
DECLARE_DO_FUN( do_esay);
DECLARE_DO_FUN( do_rollop);
DECLARE_DO_FUN( do_qpgrant);
DECLARE_DO_FUN( do_bubble);
DECLARE_DO_FUN( do_toggle);
/*DECLARE_DO_FUN( do_attack );*/
DECLARE_DO_FUN( do_study);
DECLARE_DO_FUN( do_mount);
DECLARE_DO_FUN( do_dismount);
DECLARE_DO_FUN( do_pathfind);
DECLARE_DO_FUN( do_track);
DECLARE_DO_FUN( do_darkooc);
DECLARE_DO_FUN( do_darktalk);
DECLARE_DO_FUN( do_handtalk);
//DECLARE_DO_FUN( do_infuse);
DECLARE_DO_FUN( do_use);
DECLARE_DO_FUN( do_light);
DECLARE_DO_FUN( do_penalize);
DECLARE_DO_FUN( do_wrlist);
DECLARE_DO_FUN( do_bet);
DECLARE_DO_FUN( do_invade);
//DECLARE_DO_FUN( do_shape);
DECLARE_DO_FUN( do_roulette );
DECLARE_DO_FUN( do_disembark );
DECLARE_DO_FUN( do_shave );
DECLARE_DO_FUN( do_beacon );
DECLARE_DO_FUN( do_randroom );
DECLARE_DO_FUN( do_openvlist );
DECLARE_DO_FUN( do_x);
DECLARE_DO_FUN( do_xpgrant);
DECLARE_DO_FUN( do_rename );
DECLARE_DO_FUN( do_spellup );
DECLARE_DO_FUN( do_journal );
DECLARE_DO_FUN( do_battlecry );
DECLARE_DO_FUN( do_rage );
DECLARE_DO_FUN( do_forage );
//DECLARE_DO_FUN( do_smith );
DECLARE_DO_FUN( do_rdesc );
DECLARE_DO_FUN( do_repeat );
DECLARE_DO_FUN( do_global );
DECLARE_DO_FUN( do_gsocial );
DECLARE_DO_FUN( do_music  );
DECLARE_DO_FUN( do_inchar );
DECLARE_DO_FUN( do_mentor );
DECLARE_DO_FUN( do_challenge );
DECLARE_DO_FUN( do_accept );
DECLARE_DO_FUN( do_decline );
DECLARE_DO_FUN( do_leaders );
DECLARE_DO_FUN( do_leaderclear );
DECLARE_DO_FUN( do_locker );
DECLARE_DO_FUN( do_opedit );
DECLARE_DO_FUN( do_rpedit );
DECLARE_DO_FUN( do_opdump );
DECLARE_DO_FUN( do_opstat );
DECLARE_DO_FUN( do_rpdump );
DECLARE_DO_FUN( do_rpstat );
DECLARE_DO_FUN( do_evaluate );
DECLARE_DO_FUN( do_events );
DECLARE_DO_FUN( do_bribe );
DECLARE_DO_FUN( do_system );
DECLARE_DO_FUN( do_wvlist );
DECLARE_DO_FUN( do_sklist );
DECLARE_DO_FUN( do_weavehalt );
DECLARE_DO_FUN( do_imortflag );
DECLARE_DO_FUN(	do_combine	);
DECLARE_DO_FUN(	do_forms 	);
DECLARE_DO_FUN(	do_assassinate 	);
DECLARE_DO_FUN(	do_bandage 	);
DECLARE_DO_FUN(	do_keep 	);
DECLARE_DO_FUN(	do_hook 	);
DECLARE_DO_FUN(	do_unhook 	);
DECLARE_DO_FUN(	do_unkeep 	);
DECLARE_DO_FUN(	do_gamble 	);
DECLARE_DO_FUN(	do_verify 	);
DECLARE_DO_FUN( do_taint	);
DECLARE_DO_FUN( do_shadowtaint	);
DECLARE_DO_FUN( do_tornado	);
DECLARE_DO_FUN( do_trivia );
DECLARE_DO_FUN( do_hurricane);
DECLARE_DO_FUN( do_web);
DECLARE_DO_FUN( do_warn);
DECLARE_DO_FUN( do_unarm );
DECLARE_DO_FUN( do_jog );
DECLARE_DO_FUN (do_translate);
DECLARE_DO_FUN (do_war);
DECLARE_DO_FUN( do_bondmote);
