/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

/*
 * These globals are for weaves that want more stuff from command line.
 */
int truePwr;
int trueOverPwr;
int ovrPwr;
int pwrBonus;
int angBonus;
int wvDmg;
char *target_name;

/*
 * Spell functions.
 * Defined in magic.c.
 */
DECLARE_SPELL_FUN(  spell_null		);
DECLARE_SPELL_FUN(weave_defense);
DECLARE_SPELL_FUN(weave_vigor);
DECLARE_SPELL_FUN(weave_blinding);
DECLARE_SPELL_FUN(weave_burn);
DECLARE_SPELL_FUN(weave_calm);
DECLARE_SPELL_FUN(weave_sever);
DECLARE_SPELL_FUN(weave_flay);
DECLARE_SPELL_FUN(weave_lash);
DECLARE_SPELL_FUN(weave_flog);
DECLARE_SPELL_FUN(weave_glow);
DECLARE_SPELL_FUN(weave_darken);
DECLARE_SPELL_FUN(weave_cure_blinding);
DECLARE_SPELL_FUN(weave_cure_critical);
DECLARE_SPELL_FUN(weave_cure_disease);
DECLARE_SPELL_FUN(weave_cure_light);
DECLARE_SPELL_FUN(weave_cure_poison);
DECLARE_SPELL_FUN(weave_cure_serious);
DECLARE_SPELL_FUN(weave_see_shadow);
DECLARE_SPELL_FUN(weave_see_light);
DECLARE_SPELL_FUN(weave_see_hidden);
DECLARE_SPELL_FUN(weave_see_invis);
DECLARE_SPELL_FUN(weave_seeing);
DECLARE_SPELL_FUN(weave_smell_poison);
DECLARE_SPELL_FUN(weave_shielding);
DECLARE_SPELL_FUN(weave_earthquake);
DECLARE_SPELL_FUN(weave_firestorm);
DECLARE_SPELL_FUN(weave_fire_shield);
DECLARE_SPELL_FUN(weave_gateway);
DECLARE_SPELL_FUN(weave_heal);
DECLARE_SPELL_FUN(weave_invert);
DECLARE_SPELL_FUN(weave_lightning);
DECLARE_SPELL_FUN(weave_knit_flesh);
DECLARE_SPELL_FUN(weave_flameblade);
DECLARE_SPELL_FUN(weave_airclub);
DECLARE_SPELL_FUN(weave_shatter);
DECLARE_SPELL_FUN(weave_portal);
DECLARE_SPELL_FUN(weave_remove_curse);
DECLARE_SPELL_FUN(weave_shield);
DECLARE_SPELL_FUN(weave_bond);
DECLARE_SPELL_FUN(weave_teleport);
DECLARE_SPELL_FUN(weave_air_blast);
DECLARE_SPELL_FUN(weave_repair_flesh);
DECLARE_SPELL_FUN(weave_freeze_finger);
DECLARE_SPELL_FUN(weave_weaken);
DECLARE_SPELL_FUN(weave_hold);
DECLARE_SPELL_FUN(weave_sicken);
DECLARE_SPELL_FUN(weave_mirrormirror);
DECLARE_SPELL_FUN(weave_large);
DECLARE_SPELL_FUN(weave_spirit_fist);
DECLARE_SPELL_FUN(weave_spirit_hammer);
DECLARE_SPELL_FUN(weave_spirit_shatter);
DECLARE_SPELL_FUN(weave_mass_heal);
DECLARE_SPELL_FUN(weave_thunder_blast);
DECLARE_SPELL_FUN(weave_thunder_strike);
DECLARE_SPELL_FUN(weave_thunder_lance);
DECLARE_SPELL_FUN(weave_barrier);
DECLARE_SPELL_FUN(weave_speed);
DECLARE_SPELL_FUN(weave_endurance);
DECLARE_SPELL_FUN(weave_hunters_instinct);
DECLARE_SPELL_FUN(weave_panther_reflex);
DECLARE_SPELL_FUN(weave_geyser);
DECLARE_SPELL_FUN(weave_fire_bolt);
DECLARE_SPELL_FUN(weave_ice_storm);
DECLARE_SPELL_FUN(weave_fork_lightning);
DECLARE_SPELL_FUN(weave_advanced_shield);
DECLARE_SPELL_FUN(weave_greater_shield);
DECLARE_SPELL_FUN(weave_drown);
DECLARE_SPELL_FUN(weave_infuse);
DECLARE_SPELL_FUN(weave_hellfire);
DECLARE_SPELL_FUN(weave_purgatory);
DECLARE_SPELL_FUN(weave_crushing_blow);
DECLARE_SPELL_FUN(weave_mind_shatter);
DECLARE_SPELL_FUN(weave_reign_of_terror);
DECLARE_SPELL_FUN(weave_reign_of_justice);
DECLARE_SPELL_FUN(weave_reign_of_blood);
DECLARE_SPELL_FUN(weave_reign_of_power);
DECLARE_SPELL_FUN(weave_reign_of_death);
DECLARE_SPELL_FUN(weave_tower_of_defense);
DECLARE_SPELL_FUN(weave_tower_of_mind);
DECLARE_SPELL_FUN(weave_tower_of_war);
DECLARE_SPELL_FUN(weave_tower_of_justice);
DECLARE_SPELL_FUN(weave_tower_of_power);
DECLARE_SPELL_FUN(weave_spinning_the_wheel);
DECLARE_SPELL_FUN(weave_weavesight);
DECLARE_SPELL_FUN(weave_delve);
DECLARE_SPELL_FUN(weave_refresh);
DECLARE_SPELL_FUN(weave_bigger);
DECLARE_SPELL_FUN(weave_quicken);
DECLARE_SPELL_FUN(weave_fortitude);
DECLARE_SPELL_FUN(weave_sixth_sense);
DECLARE_SPELL_FUN(weave_innervation);
DECLARE_SPELL_FUN(weave_summon_darkhound);

/* Defunct Weaves
 *
DECLARE_SPELL_FUN(weave_spirit_of_wind);

 */
