/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

             ROM MSP [C] 1998 Dingo dingo@pdragon.inetsolve.com
          written for Purple Dragon MUD pdragon.inetsolve.com:5555

    You may freely copy and/or change this code any way you wish, as long
    this header remains unchanged.

    this file contains only some file names what was either used by msp_weapon
    or they used in various calls all over the code, i'm sure that this file
    wouldn't have to be here what so ever, i'm including is just so you can
    have some reference to parts of the code. there is 99% chance that this
    file won't exist in week or so ;)
 */

const MSP_TYPE msp_table []	=
{
    /*
    {   msp_type,	group_name,	default_file	}
    */

    {	MSP_FIGHT,	"fight",	"sword.wav"	},
    {	MSP_WEATHER,	"weather",	"sword.wav"	},
    {	MSP_TIME,	"music",	"sword.mid"	},
    {	MSP_EVENT,	"events",	"sword.wav"	},
    {	MSP_SPELL,	"spells",	"sword.wav"	},
    {	-1,		NULL,		NULL		}
};

const MSP_DATA msp_fight_table []	=
{
    /*
    {   msp_fight_type,		sound_file	}
    */

    {	MSP_FIGHT_EXOTIC,	"sword.wav"	},
    {	MSP_FIGHT_SWORD,	"sword.wav"	},
    {	MSP_FIGHT_DAGGER,	"sword.wav"	},
    {	MSP_FIGHT_SPEAR,	"sword.wav"	},
    {	MSP_FIGHT_MACE,		"sword.wav"	},
    {	MSP_FIGHT_AXE,		"sword.wav"	},
    {	MSP_FIGHT_FLAIL,	"sword.wav"	},
    {	MSP_FIGHT_WHIP,		"sword.wav"	},
    {	MSP_FIGHT_POLEARM,	"sword.wav"	},
    {	MSP_FIGHT_BOW,		"sword.wav"	},
    {	MSP_FIGHT_ARROW,	"sword.wav"	},

    {	MSP_FIGHT_HIT,		"sword.wav"	},
    {	MSP_FIGHT_DEFENSE,	"sword.wav"	},
    {	MSP_FIGHT_DEATHPC,	"sword.wav"	},
    {	MSP_FIGHT_DEATHMOB,	"sword.wav"	},
    {	MSP_FIGHT_DEFAULT,	"sword.wav"	},
    {	-1,			NULL		}
};

const MSP_DATA msp_time_table []	=
{
    /*
    {   msp_time_type,		sound_file	}
    */

    {	MSP_TIME_DARK,		"sword.wav"	},
    {	MSP_TIME_RISE,		"sword.wav"	},
    {	MSP_TIME_LIGHT,		"sword.wav"	},
    {	MSP_TIME_SET,		"sword.wav"	},
    {	MSP_TIME_NOON,		"sword.wav"	},
    {	-1,			NULL		}
};

const MSP_DATA msp_weather_table []	=
{
    /*
    {   msp_weather_type,	sound_file	}
    */

    {	MSP_WEATHER_CLOUDLESS,	"sword.wav"	},
    {	MSP_WEATHER_CLOUDY,	"sword.wav"	},
    {	MSP_WEATHER_RAINING,	"sword.wav"	},
    {	MSP_WEATHER_LIGHTNING,	"sword.wav"	},
    {	-1,			NULL		}
};

const MSP_DATA msp_event_table []	=
{
    /*
    {   msp_event_type,		sound_file	}
    */

    {	MSP_EVENT_LOGIN,	"sword.wav"	},
    {	MSP_EVENT_GOSSIP,	"sword.wav"	},
    {	MSP_EVENT_TELL,        	"sword.wav"	},
    {	MSP_EVENT_ROOM,        	""		},
    {	-1,			NULL		}
};

const MSP_DATA msp_spell_table []	=
{
    /*
    {   msp_spell_type,		sound_file	}
    */

    {	MSP_EVENT_LOGIN,	"sword.wav"	},
    {	MSP_EVENT_GOSSIP,	"sword.wav"	},
    {	MSP_EVENT_TELL,        	"sword.wav"	},
    {	MSP_EVENT_ROOM,        	""		},
    {	-1,			NULL		}
};
