/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

/* To add a new mob entry, copy and paste the elements from begin copy and paste
 * then paste them below begin paste. Edit the values for name, shortd, longd
 * sex, race, damtype, kill, and die. Leave the other values as they are.
 */


struct quest_rewards_type
{
        char * keyword;
        int cost;
        int quantity;
        char * description;
	int reward_num;
	bool is_stat;
	int stat;
};
struct quest_commands_type
{
        char * const cmd;
        void (* quest_cmd_func)(CHAR_DATA *ch, char *argument);
        bool log;
        bool immcmd;
	char * description;
};
struct quest_skills_type
{
	char * skill_name;
	int qp_cost;
};
void quest_cmd_list args((CHAR_DATA *ch, char *argument));
void quest_cmd_gevent args((CHAR_DATA *ch, char *argument));
void quest_cmd_buy args((CHAR_DATA *ch, char *argument));
void quest_cmd_staydeath args((CHAR_DATA *ch, char *argument));
void quest_cmd_capture args((CHAR_DATA *ch, char *argument));
void quest_cmd_request args((CHAR_DATA *ch, char *argument));
void quest_cmd_complete args((CHAR_DATA *ch, char *argument));
void quest_cmd_set args((CHAR_DATA *ch, char *argument));
void quest_cmd_bond args((CHAR_DATA *ch, char *argument));
void quest_cmd_colorname args((CHAR_DATA *ch, char *argument));
void quest_cmd_lastname args((CHAR_DATA *ch, char *argument));
void quest_cmd_spouse args((CHAR_DATA *ch, char *argument));
void quest_cmd_reset args((CHAR_DATA *ch, char *argument));
void quest_cmd_relocate args((CHAR_DATA *ch, char *argument));
void quest_cmd_increase args((CHAR_DATA *ch, char *argument));
void quest_cmd_info args((CHAR_DATA *ch, char *argument));
void quest_cmd_quit args((CHAR_DATA *ch, char *argument));
void quest_cmd_convert args((CHAR_DATA *ch, char *argument));
void quest_cmd_skill args((CHAR_DATA *ch, char *argument));

const struct quest_skills_type quest_skills_table [] =
{
	{ "focus", 2500 },
	{ "anticipate", 2500 },
	{ "farsight", 1500 },
	{ "precision", 2500 },
	{ "efficient", 2500 },
	{ "gifted", 9500 },
	{ "windfall", 7500 },
	{ "angrealstudy", 2500 },
	{ "bribery", 2500 },
	{ "engraving", 2500 },
	{ NULL, -1 },
};
const struct quest_commands_type quest_commands_table [] =
{
        { "list", quest_cmd_list, FALSE, FALSE, "List quest commands." },
	{ "skill", quest_cmd_skill, FALSE, FALSE, "List and purchase quest skills." },
        /*{ "gevent", quest_cmd_gevent, FALSE, FALSE, "Purchase a global event." },*/
        { "buy", quest_cmd_buy, FALSE, FALSE, "Purchase a quest reward or event." },
        { "staydeath", quest_cmd_staydeath, FALSE, FALSE, "Flag a floating object to stay upon death." },
        /*{ "capture", quest_cmd_capture, FALSE, FALSE, "Capture a quest target." },*/
        { "request", quest_cmd_request, FALSE, FALSE, "Request a new quest of <type>." },
        { "complete", quest_cmd_complete, FALSE, FALSE, "Complete the current quest." },
        { "set", quest_cmd_set, FALSE, TRUE, "Set target's quest timer." },
        { "bond", quest_cmd_bond, FALSE, FALSE, "Set the colored name of the character's bond." },
        { "colorname", quest_cmd_colorname, FALSE, FALSE, "Set the character's colored name." },
        { "lastname", quest_cmd_lastname, FALSE, FALSE, "Set the character's colored last name." },
        { "spouse", quest_cmd_spouse, FALSE, FALSE, "Set the colored name of the character's spouse." },
        { "reset", quest_cmd_reset, FALSE, TRUE, "Clear the character's current quest and timer." },
        /*{ "relocate", quest_cmd_relocate, FALSE, FALSE, "Set the character's hometown and recall location." },*/
        { "increase", quest_cmd_increase, FALSE, FALSE, "Increase a skill's learned percentage by one." },
        { "info", quest_cmd_info, FALSE, FALSE, "General quest information or the current quest." },
        { "quit", quest_cmd_quit, FALSE, FALSE, "Quit the current quest and reset the timer." },
        { "convert", quest_cmd_convert, FALSE, FALSE, "Converts quest tokens into quest points." },
        { NULL, NULL, FALSE },

};

#define QPR_TRAINS 0
#define QPR_HPS 1
#define QPR_STAM 2
#define QPR_STR 3
#define QPR_WIS 4
#define QPR_INS 5
#define QPR_REF 6
#define QPR_DEX 7
#define QPR_CHA 8
#define QPR_INT 9
#define QPR_CON 10
#define QPR_RESTRING 11
#define QPR_FIRE 12
#define QPR_AIR 13
#define QPR_WATER 14
#define QPR_EARTH 15
#define QPR_SPIRIT 16
#define QPR_WEAVIE 17
#define QPR_SHADOWS 18
#define QPR_RAFFLE 19
#define QPR_XPS 20
#define QPR_QPS 21
#define QPR_HEALS 22
#define QPR_HAPPY 23
#define QPR_LYNCH 24
#define QPR_FALSE 25

const struct quest_rewards_type quest_rewards_table [] =
{
        /* keyword        cost quantity desc */
        { "trains",       10,  10,  "Training Point", QPR_TRAINS, FALSE, 0 },
        { "hitpoints",    10,  10, "Hit Point", QPR_HPS, FALSE, 0 },
        { "stamina",      10,  10, "Stamina Point", QPR_STAM, FALSE, 0 },
        { "strength",     100, 1,  "Strength Point", QPR_STR, TRUE, STAT_STR },
        { "wisdom",       100, 1,  "Wisdom Point", QPR_WIS, TRUE, STAT_WIS },
        { "instinct",     100, 1,  "Instinct Point", QPR_INS, TRUE, STAT_INS },
        { "reflex",       100, 1,  "Reflex Point", QPR_REF, TRUE, STAT_REF },
        { "dexterity",    100, 1,  "Dexterity Point", QPR_DEX, TRUE, STAT_DEX },
        { "charisma",     100, 1,  "Charisma Point", QPR_CHA, TRUE, STAT_CHA },
        { "intelligence", 100, 1,  "Intelligence Point", QPR_INT, TRUE, STAT_INT },
        { "constitution", 100, 1,  "Constitution Point", QPR_CON, TRUE, STAT_CON },
        { "restring",     100, 1,  "Restring Ticket", QPR_RESTRING, FALSE, 0 },
        { "fire",         100, 1,  "Fire Sphere Point", QPR_FIRE, FALSE, 0 },
        { "air",          100, 1,  "Air Sphere Point", QPR_AIR, FALSE, 0 },
	{ "water",        100, 1,  "Water Sphere Point", QPR_WATER, FALSE, 0 },
        { "earth",        100, 1,  "Earth Sphere Point", QPR_EARTH, FALSE, 0 },
        { "spirit",       100, 1,  "Spirit Sphere Point", QPR_SPIRIT, FALSE, 0 },
        { "weaveup",      100, 1,  "Weaveup", QPR_WEAVIE, FALSE, 0 },
        { "shadows",      100, 1,  "Shadows Embrace Event", QPR_SHADOWS, FALSE, 0 },
        { "raffle",       100, 1,  "Raffle Event", QPR_RAFFLE, FALSE, 0 },
        { "xps",          100, 1,  "Free XP Event", QPR_XPS, FALSE, 0 },
        { "qps",          100, 1,  "Free QPs Event", QPR_QPS, FALSE, 0 },
        { "heals",        100, 1,  "Free Heals Event", QPR_HEALS, FALSE, 0 },
        { "happiness",    100, 1,  "Get Happy Event", QPR_HAPPY, FALSE, 0 },
        { "lynchmob",     100, 1,  "Lynch Mob Event", QPR_LYNCH, FALSE, 0 },
        { "dragon",       100, 1,  "False Dragon Event", QPR_FALSE, FALSE, 0  },
        { NULL,           -1, -1,  NULL, -1, -1 },
};

struct qmob_type
{
	char * name;
	char * shortd;
	char * longd;
	sh_int sex; /* 1 = male, 2 = female, 3 = random */
	char * race;
	char * damtype;
	char * kill;
	char * die;
	long act;
	long off;
	int vnum;
};

const   struct  qmob_type qmob_table [] =
{
	/* 1 */
	{
		"discord",
		"Discord",
		"Discord stands here, smiling as she thinks of destruction.",
		2,
		"andor",
		"wrath",
		"Discord faces you defiantly.",
		"The menace has been defeated.",
		ACT_UNDEAD|ACT_WARRIOR,
		OFF_FAST,
		5
	},
	/* 2 */
/* begin copy */
   {
      "enian man",
      "Enian",
      "A man stands here, curiously sniffing the air.",
      1,
      "andor",
      "lunge",
      "Enian settles his gaze on you, a scowl darkening his features.",
      "A cutpurse has been disposed of.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */

/* 3 */
   {
      "ildhin bundle",
      "Ildhin",
      "Hefting a tightly wrapped bundle to her hips, Ildhin continues walking.",
      2,
      "tarabon",
      "charge",
      "Caring more for her bundle then her life, Ildhin turns to face you.",
      "A runaway illuminator has been dealt with.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 4 */
   {
      "ridela",
      "Ridela",
      "A swaying woman stands here, clutching her head as if in pain.",
      2,
      "cairhien",
      "weave",
      "A spark of madness passes over Ridela's eyes.",
      "A woman suspected of setting deadly fires has been extinguished.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 5 */
   {
      "larard",
      "Larard",
      "A man stands here with an embroidered golden tree upon his chest.",
      1,
      "tarabon",
      "charge",
      "Larard pleads with you to take his coin and leave him be.",
      "A deserter of the King's Life guard has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 6 */
   {
      "tasadyn",
      "Tasadyn",
      "A wandering bard has paused here, glancing uneasily at his surroundings.",
      1,
      "altara",
      "lunge",
      "Ingash beseeches you, to spare his life.",
      "With his last breath, Ingash utters, 'My master will avenge me!'.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 7 */
   {
      "echald teeth",
      "Echald",
      "A scruffy looking vagabond stands here.",
      1,
      "tarvalon",
      "smash",
      "Echald turns to face you, yellowed teeth peeking out from his lips.",
      "The usurper to the local lord has been destroyed.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 8 */
   {
      "kelina woman",
      "Kelina",
      "A frowning woman intently examines her surroundings.",
      2,
      "andor",
      "wrath",
      "Kelina blinks at you innocently.",
      "A suspected darkfriend has been destroyed.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 9 */
   {
      "risryn man",
      "Risryn",
      "A man stands here, clutching a leg of chicken to his chest protectively.",
      1,
      "amador",
      "pierce",
      "Tucking his food into his cloak, Risryn faces you.",
      "A thief has met his justice.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 10 */
   {
      "sulilye aiel",
      "Sulilye",
      "A lone Aiel stands here, her veil hanging down her chest.",
      2,
      "aiel",
      "sunder",
      "Sulilye raises her veil and attacks.",
      "The threat to the Car'a'carn has been stamped out.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 11 */
   {
      "verend man",
      "Verend",
      "A man stands here, his face half concealed by a gauzy veil.",
      1,
      "domani",
      "pierce",
      "With a flash in his eyes, Verend draws his weapon and faces you.",
      "The menace has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 12 */
   {
      "ryard tabac",
      "Ryard",
      "Ryard stands here, noisily chewing on a wad of tabac.",
      1,
      "cairhien",
      "stab",
      "Ryard turns to face you and spits his tabac out at your feet.",
      "The vile tabac chewer has been destroyed.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 13 */
   {
      "leyet woman",
      "Leyet",
      "A woman stands here, licking her lips several times.",
      2,
      "domani",
      "slap",
      "Pursing her lips, Leyet looks hungrily at you.",
      "The kissing bandit has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 14 */
   {
      "delan figure",
      "Delan",
      "A figure is slowly walking here, hunched over by his age.",
      1,
      "cairhien",
      "punch",
      "Cursing under his breath, Delan faces you.",
      "A rogue gleeman has been silenced.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 15 */
   {
      "jarala woman",
      "Jarala",
      "A veiled woman stands her, gripping her spears tightly in her hands.",
      2,
      "aiel",
      "lunge",
      "A veiled woman jumps unexpectedly, swinging her spear point at you.",
      "An imposter has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 16 */
   {
      "radgar man",
      "Radgar",
      "A dark haired man stands here, his face covered with bruises.",
      1,
      "tairen",
      "uppercut",
      "Pushing his hair out of his eyes, Radgar cracks his knuckles in readiness.",
      "A cutpurse has been abolished.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 17 */
   {
      "bansul man",
      "Bansul",
      "A man stands here, strumming a small harp as he walks.",
      1,
      "andor",
      "charge",
      "Setting his harp down carefully, Bansul growls menacingly at you.",
      "An escaped prisoner of Andor has been destroyed.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 18 */
   {
      "elmara blonde",
      "Elmara",
      "A voluptuous blonde woman stands here, absorbed with a book.",
      2,
      "tarvalon",
      "weave",
      "Elmara turns and gazes haughtily at you.",
      "A suspected assassin against the Amyrlin has been thwarted.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 19 */
   {
      "agenaler man",
      "Agenaler",
      "A stench emmanates from this man, who has stopped to air his boots.",
      1,
      "cairhien",
      "flog",
      "Leaving his boots off, Agenaler faces you with a smirk on his face.",
      "A man suspected of peddling poisons has been expunged.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */
/* 20 */
   {
      "kaly woman",
      "Kaly",
      "Kaly stands here, one hand defiantly on her hip.",
      2,
      "andor",
      "lunge",
      "Rubbing her hands together in anticipation, Kaly faces you eagerly.",
      "An accused woman has been done away with.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */

/* 21 */
   {
      "isldra figure",
      "Isldra",
      "A bulky figure stands here, swathed in a dark woolen cloak.",
      2,
      "tairen",
      "stab",
      "Flicking her cloak open, Isldra grabs a gleaming dagger.",
      "A suspected murderer will occupy the streets no more.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 22 */
   {
      "dynard stocky",
      "Dynard",
      "A stocky youth stands here, mouth agape at the sights of the city.",
      1,
      "tarvalon",
      "scratch",
      "A look of terror passes over Dynard's eyes.",
      "With his last breath, Dynard plea's for you to spare him.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 23 */
   {
      "rakina woman",
      "Rakina",
      "A woman stands here, twitching nervously as she peers around.",
      2,
      "illian",
      "slap",
      "Rakina turns, a thin stream of spittle drips down as she moves.",
      "The madness has been expunged.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 24 */
   {
      "xesete man",
      "Xesete",
      "A man stands here, a black hawk emblazoned on his surcoat.",
      1,
      "shienar",
      "lunge",
      "Xesete thumps his chest, saying 'Peace favor your sword'.",
      "The imposter has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 25 */
   {
      "nytiro man",
      "Nytiro",
      "A haggard looking man is here, walking in aimless circles.",
      1,
      "domani",
      "pound",
      "Nytiro pauses mid-step and turns towards you.",
      "A man accused of thievery has met his fate.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 26 */
   {
      "tynys woman",
      "Tynys",
      "A woman stands here, an expectant look on her face.",
      2,
      "tarvalon",
      "weave",
      "Tynys folds her arms over her breasts, scowling at your disturbance.",
      "An ill-tempered woman has been destroyed.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 27 */
   {
      "jaylor man",
      "Jaylor",
      "A light haired man stands here, squinting in his surroundings.",
      1,
      "andor",
      "slash",
      "Blinking rapidly, Jaylor turns and strikes at you.",
      "A suspected thief has met his justice.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 28 */
   {
      "brevelan woman",
      "Brevelan",
      "A fiery haired woman stands here, kicking the dirt with her foot.",
      2,
      "aiel",
      "sunder",
      "Brevelan raises her veil and attacks.",
      "An oathbreaker has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 29 */
   {
      "zohez man",
      "Zohez",
      "A man stands here, his brow furrowed in concentration.",
      1,
      "tairen",
      "charge",
      "Spreading his arms, Zohez invites you to duel.",
      "A conniving merchant has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 30 */
   {
      "yerinn woman",
      "Yerinn",
      "A scantily clad woman stands here, shivering slightly.",
      2,
      "domani",
      "weave",
      "Yerinn turns and begins clawing your chest frantically.",
      "A frenzied woman has been put to rest.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 31 */
   {
      "ardenthis man",
      "Ardenthis",
      "A man stands here, dressed in an elaborate vest.",
      1,
      "altara",
      "stab",
      "Drawing a curved dagger from his sash, Ardenthis steps a pace back.",
      "An Altaran riot has been curbed with the defeat of this man.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 32 */
   {
      "morryn woman",
      "Morryn",
      "A travel weary woman limps along the road.",
      2,
      "tarvalon",
      "slap",
      "With an exasperated sigh, Morryn turns to glare at you.",
      "Rasping with her last breath, Morryn wheezes, 'I almost had it.'.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 33 */
   {
      "tasck man",
      "Tasck",
      "An earthen clad man stands here, fingering the long knife at his hip.",
      1,
      "aiel",
      "lunge",
      "Tasck spins on his heel, bringing the long knife to his hands.",
      "A suspected spy has paid for his toh with his life.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 34 */
   {
      "ghaero man",
      "Ghaero",
      "A brown haired man stands here, his face pockmarked with sores.",
      1,
      "cairhien",
      "sunder",
      "A foul stench assaults your nostrils as Ghaero closes in on you.",
      "An outbreak of the plague has been vanquished.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */

/* 35 */
   {
      "sulund wisdom",
      "Sulund",
      "A local wisdom stands here, glaring at the passerby's.",
      2,
      "tairen",
      "weave",
      "'You wish to harm Mother Sulund? Fool child!'.",
      "A wisdom accused of dispensing poisons, has been defeated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 36 */
   {
      "ranugh man",
      "Ranugh",
      "A coppery skinned man stands here, fingering his mustache.",
      1,
      "domani",
      "pierce",
      "Side-stepping gracefully, Ranugh pulls a curved dagger free.",
      "A boasting strategist has met his fate.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 37 */
   {
      "semila spear",
      "Semila",
      "Semila stands here, carrying a broken spear in her hands.",
      2,
      "aiel",
      "punch",
      "Dropping her burden, Semila spins on her heel and aims a punch at you.",
      "A woman suspected of bringing harm to the Car'a'carn has been stopped.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 38 */
   {
      "zhean sailor",
      "Zhean",
      "An Illian sailor stands here, spending his free time in the city.",
      1,
      "illian",
      "whack",
      "With a swagger to his hips, Zhean pushes a finger against your chest.",
      "A suspected river smuggler has been seized.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 39 */
   {
      "chreden woman",
      "Chreden",
      "A woman walks slowly here, a pair of sursa entwined in her hair.",
      2,
      "domani",
      "slap",
      "Pulling the wooden sursa free, Chreden turns to face you.",
      "A vile culprit has been put to a stop.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 40 */
   {
      "iahon man",
      "Iahon",
      "A man with a short grey beard stands here, holding a bottle of greenish fluid.",
      1,
      "illian",
      "disease",
      "Iahon uncorks his bottle and pours a thin stream over his weapon, eyeing you.",
      "A man accused of selling poisoned olive oil has been circumvented.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 41 */
   {
      "serdan woman",
      "Serdan",
      "A woman carrying a basket of fruit stands here.",
      2,
      "tarvalon",
      "fury",
      "Serdan turns to face you, her eyes questioning your intent.",
      "A pickpocket has been hindered in her efforts.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 42 */
   {
      "sulenth man",
      "Sulenth",
      "A man stands here, humming a haunting tune.",
      1,
      "murundy",
      "charge",
      "Freeing his sword, Sulenth turns and faces you.",
      "A threat to the Lord Luc has been assassinated.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 43 */
   {
      "tasyver man",
      "Tasyver",
      "A man stands here, his clothes threadbare and torn.",
      1,
      "cairhien",
      "weave",
      "Tasyver turns and scowls fiercely at you.",
      "'Take what you want, and pay for it!'.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */


/* 44 */
   {
      "laros man",
      "Laros",
      "A stench emmanates from this man, who has massive tangles in his oily hair.",
      1,
      "tarvalon",
      "weave",
      "With a chilling laugh, Laros begins to circle around you.",
      "A man suspected of consorting with darkfriends has been expunged.",
      ACT_UNDEAD|ACT_WARRIOR,
      OFF_FAST,
      5
   },
   /* end copy */
};
extern const struct qmob_type qmob_table[]; // prool
