/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

/* header for random rooms */


struct rr_insects_type
{
	char *name;
	char *dwelling;
	bool  stings;
	bool  poison;
	int   toxicity;
};

struct rr_flowers_type
{
	char *name;
	char *color;
	char *height;
	char *growth;
};

struct rr_weeds_type
{
	char *name;
	char *color;
	char *height;
	char *growth;
};

struct rr_rocks_type
{
	char *name;
	char *color;
	char *size;
	char *growth;
};

const struct rr_rocks_type rr_rocks_table[] =
{
	{ "granite", "white marbled", "Large", "boulders" },
	{ "quartz", "crystal clear", "Small", "deposits" },
	{ "granite", "gray streaked", "Small", "chunks" },
	{ "fool's gold", "glittering", "Small", "clumps" },
	{ "flint", "dark gray", "small", "Chunks" },
	{ "pebbles", "blue-gray", "tiny", "Patches" },
	{ "sandstone", "yellowish brown", "Medium", "beds" },
	{ "shale", "red", "Small", "thin beds" },
	{ "feldspar", "gray and blue flecked", "Large", "boulders" },
	{ "pumice", "white", "Small", "clumps" },
	/* 10 */
};

const struct rr_weeds_type rr_weeds_table[] =
{
	{ "yellow fox tail", "green and yellow streaked", "shin high", "Clusters" },
	{ "bluegrass", "blue and green", "ankle high", "Carpets" },
	{ "smooth crabgrass", "green and red streaked", "knee high", "Clusters" },
	{ "buttercups", "bright yellow", "ankle high", "Small clusters" },
	{ "liver wort", "light green and purple edged", "stunted", "Groups" },
	{ "lamb's quarters", "green and light blue flowered", "thigh high", "Stalks" },
	{ "creeping speedwell", "green and light blue flowered", "ankle high", "Clusters" },
	{ "thistle", "green and pink", "knee high", "Stalks" },
	/* 8 */
};

const struct rr_flowers_type rr_flowers_table[] =
{
	{ "fire thorns", "brightly colored", "medium", "Bunches" },
	{ "rhododendrons", "glossy pink and red colored", "tall", "Clusters" },
	{ "azalea", "intense colored", "medium", "A solitary" },
	{ "sweet alysums", "pale white colored", "low", "Clusters" },
	{ "red snapdragons", "scarlet red colored", "tall", "A group" },
	{ "blaze climber roses", "deep red colored", "bushy", "A stand" },
	{ "honeysuckle", "pale yellow colored", "bushy", "Vines" },
	{ "star jasmine", "deeply colored", "tall and climbing", "Vines" },
	{ "lilac", "various colored", "small", "Clusters" },
	{ "bittersweet", "greenish colored", "twining", "Vines" },
	{ "clematis", "pale pink and purple colored", "twining", "Vines" },
	{ "trumpet creeper", "bright red and orange colored", "climbing", "A vine" },
	{ "achillea", "mustard-yellow colored", "fernlike", "Loose clusters" },
	{ "monkshood", "deep violet colored", "upright", "Long stalks" },
	{ "lady's mantle", "fluffy yellow and gray colored", "rounded", "Sprays" },
	/* 15 */
};

const struct rr_insects_type rr_insects_table[] =
{
	{ "gnats",       "",       FALSE, FALSE, 0 },
	{ "biteme",      "",       TRUE,  FALSE, 0 },
	{ "fly",         "",       FALSE, FALSE, 0 },
	{ "hornet",      "nest",   TRUE,  TRUE,  2 },
	{ "spider",      "web",    TRUE,  TRUE,  5 },
	{ "wasp",        "nest",   TRUE,  TRUE,  3 },
	{ "bumble bee",  "hive",   TRUE,  FALSE, 2 },
	{ "honey bee",   "hive",   FALSE, FALSE, 0 },
	{ "butterfly",   "cocoon", FALSE, FALSE, 0 },
	{ "moths",       "cocoon", FALSE, FALSE, 0 },
	{ "beetles",     "cocoon", FALSE, FALSE, 0 },
	{ "crickets",    "cocoon", FALSE, FALSE, 0 },
	{ "grasshopper", "cocoon", FALSE, FALSE, 0 },
	/* 11 */
};
// prool:
extern const struct rr_insects_type rr_insects_table[];
extern const struct rr_flowers_type rr_flowers_table[];
extern const struct rr_weeds_type rr_weeds_table[];
extern const struct rr_rocks_type rr_rocks_table[];
