/***************************************************************************

                      ___  _      _  _      _
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \__|_  /\_/\  /    \_/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
        intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

        ROM 2.4 is copyright 1993-1998 Russ Taylor
        ROM has been brought to you by the ROM consortium
            Russ Taylor (rtaylor@hypercube.org)
            Gabrielle Taylor (gtaylor@hypercube.org)
            Brian Moore (zump@rom.org)
        By using this code, you have agreed to follow the terms of the
        ROM license, in the file Rom24/doc/rom.license


***************************************************************************/
/* rounds to wait at a dock before departing */
#define SHIP_WAIT 2
#define DOCK_OBJ_VNUM 23031
#define DOCKOBJ  
const int MAX_SHIPS = 10; /* total number of ships */

struct Dock_struct
{
	int loc;
	int vnum;
	bool all_off;
	char *next_docks;
};

struct ShipType
{
        char *name;
        int lowVnum; /* lowVnum is the deck of the ship */
        int highVnum; /* highVnum is the Casino */
	int motion_type;
        int hops;
        int num_docks; /* this is the number of docks */
	struct Dock_struct docks[6];
};

struct Ship_struct
{
        int location;
	int next_dock;
	int wait_at_dock;
#ifdef DOCKOBJ
	OBJ_DATA *dock_obj;
#endif
};
struct Ship_struct ShipActive [] =
{
        { /* 0 Dummy */
                0,
		0,
		0,
        },
        { /* 1 TarValon to Tear */
                0,
		0,
		0,
        },
        { /* 2 Tear to Ebou Dar */
                2,
		1,
		0,
        },
        { /* 3 Caryford to Illian */
                0,
		0,
		0,
        },
        { /* 4 Tear to Ebou Dar */
                11,
		3,
		0,
        },
        { /* 5 Ebou Dar to Falme and Arad Doman */
                0,
		0,
		0,
        },
        { /* 6 TarValon to Tear */
                9,
		3,
		0,
        },
        { /* 7 Ebou Dar to Falme and Arad Doman */
                10,
		3,
		0,
        },
	{ /* 8 Tremalking to Ebou Dar */
		0,
		0,
		0,
	},
	{ /* 9 Tear to Mayene */
		0,
		0,
		0,
	},
	{ /* 10 Tremalking to Bandar Eban */
		0,
		0,
		0,
	},
};




const   struct  ShipType ShipTable [] =
{

        { /* 0 This is a dummy entry, ie no ship has number 0 */
                "",
                0,              /* lowVnum  Main Deck */
                0,              /* highVnum casino */
		0,		/* motion type */
                0,              /* hops, */
        	0,		/* this is the number of docks */
		{
			{0,0,FALSE,""}, /* Loc Vnum AllOff nextDocks */
		},
        },
        { /* 1 TarValon to Tear (and back) */
                "Graceful",
                23031,          /* lowVnum  Main Deck */
                23035,          /* highVnum casino */
		1,		/* motion type */
                17,              /* hops, */
        	4,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,7233,FALSE,"Aringill and Tear"},
			{5,696,FALSE,"Tear"},
			{9,12076,FALSE,"Aringill and Tar Valon"},
			{13,696,FALSE,"Tar Valon"},
		},
		 
        },
    
    	{ /* 2 Tear to Ebou Dar (and back) */
                "Stella Maris",
                23045,          /* lowVnum Main Deck */
                23050,          /* highVnum casino */
		2,		/* motion type */
                19,             /* hops, */
        	4,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,12076,FALSE,"Illian and Ebou Dar"},
			{5,5774,FALSE,"Ebou Dar"},
			{10,8129,FALSE,"Illian and Tear"},
			{15,5774,FALSE,"Tear"},
		},
        },
        { /* 3 Caryford to Illian  (and back) */
                "Maid of the Cary",
                23041,          /* lowVnum Main Deck */
                23044,          /* highVnum casino */
		3,		/* motion type */
                9,              /* hops, */
        	4,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,1126,FALSE,"Tamielle and Illian"},
			{1,15501,FALSE,"Illian"},
			{5,5774,FALSE,"Tamielle and Carysford"},
			{8,15501,FALSE,"Carysford"},
		},
        },
        { /* 4 */ /* Tear to Ebou Dar and back */
                "Waverider",
                23051,              /* lowVnum Main Deck */
                23056,              /* highVnum casino */
		2,		/* motion type */
                19,             /* hops, */
        	4,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,12076,FALSE,"Illian and Ebou Dar"},
			{5,5774,FALSE,"Ebou Dar"},
			{10,8129,FALSE,"Illian and Tear"},
			{15,5774,FALSE,"Tear"},
		},
        },
        { /* 5 Ebou to Arad Doman City (and back) *//*mostly Chris */
                "Ocean Dancer",
                23057,          /* lowVnum Main Deck */
                23062,          /* highVnum casino */
		5,		/* motion type */
                25,             /* hops, */
        	6,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,8129,FALSE,"Tanchico, Falme and Arad Doman City"},
			{6,5505,FALSE,"Falme and Arad Doman City"},
			{8,21399,FALSE,"Arad Doman City"},
			{13,19076,FALSE,"Tanchico, Falme and Ebou Dar"},
			{18,21399,FALSE,"Tanchico and Ebou Dar"},
			{23,5505,FALSE,"Ebou Dar"}
		},
        },
        { /* 6 TarValon to Tear (and back) */
                "Hardell's Folly",
                23036,          /* lowVnum  Main Deck */
                23040,          /* highVnum casino */
		1,		/* motion type */
                17,              /* hops, */
        	4,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,7233,FALSE,"Aringill and Tear"},
			{5,696,FALSE,"Tear"},
			{9,12076,FALSE,"Aringill and Tar Valon"},
			{13,696,FALSE,"Tar Valon"},
		},
        },
        { /* 7 Ebou to Arad Doman City (and back) *//* Cierin */
                "Wildrose",
                23064,          /* lowVnum Main Deck */
                23068,          /* highVnum casino */
		5,		/* motion type */
                25,             /* hops, */
        	6,		/* this is the number of docks */
		{		/* Vnum AllOff nextDocks */
			{0,8129,FALSE,"Tanchico, Falme and Arad Doman City"},
			{6,5505,FALSE,"Falme and Arad Doman City"},
			{8,21399,FALSE,"Arad Doman City"},
			{13,19076,FALSE,"Tanchico, Falme and Ebou Dar"},
			{18,21399,FALSE,"Tanchico and Ebou Dar"},
			{23,5505,FALSE,"Ebou Dar"}
		},
        },
        { /* 8 Tremalking to Ebou Dar */ /* Talitha */
                "Windswept",
                23070,              /* lowVnum  Main Deck */
                23073,              /* highVnum casino */
		4,		/* motion type */
                15,              /* hops, */
        	2,		/* this is the number of docks */
		{
			{0,21139,FALSE,"Ebou Dar"}, /* Loc Vnum AllOff nextDocks */
			{8,8129,FALSE,"Tremalking"}, /* Loc Vnum AllOff nextDocks */
		},
        },
        { /* 9 Tear to Mayene */
                "Lionfish",
                23074,              /* lowVnum  Main Deck */
                23076,              /* highVnum casino */
		6,		/* motion type */
                23,              /* hops, */
        	2,		/* this is the number of docks */
		{
			{0,12076,FALSE,"Mayene"}, /* Loc Vnum AllOff nextDocks */
			{12,28089,FALSE,"Tear"}, /* Loc Vnum AllOff nextDocks */
		},
        },
        { /* 10 Calpene to Little Paradise */
                "Dancing Maid",
                23077,              /* lowVnum  Main Deck */
                23079,              /* highVnum casino */
		7,		/* motion type */
                15,              /* hops, */
        	2,		/* this is the number of docks */
		{
			{0,5506,FALSE,"Little Paradise"}, /* Loc Vnum AllOff nextDocks */
			{10,22048,FALSE,"Tanchico"}, /* Loc Vnum AllOff nextDocks */
		},
        },
        { /* 11 Tremalking to Bandar Eban */
                "Sea Folk Faller",
                0,              /* lowVnum  Main Deck */
                0,              /* highVnum casino */
		0,		/* motion type */
                15,              /* hops, */
        	2,		/* this is the number of docks */
		{
			{0,21139,FALSE,"Bander Eban"}, /* Loc Vnum AllOff nextDocks */
			{8,21139,FALSE,"Tremalking"}, /* Loc Vnum AllOff nextDocks */
		},
        },


#if 0
        { /*  Ebou Dar to Isle of Mad Men(and back) */
                "skimmer",
                13407,          /* lowVnum Main Deck */
                13410,          /* highVnum casino */
                0,             /* hops, */
                0,              /* Mid Dock Illian*/
                0,              /* Vnum of Dock in first*/
                0,              /* Vnum of Dock in mid */
                0,              /* Vnum of Dock in last */
		{"",""}, 	/* Direction 0 Dest, Direction 1 Dest */
        },
        { /*  Ebou Dar to Tremalking (and back) */
                "raker",
                13417,
                13419,
        },

#endif 

};

const char *ShipMotionTable[][26] = /* ship, direction, location,
char in array */
{{
/* ship 0 */
                "ship 0, direction 0, location 0",
                "Ship 0, direction 0, location 1"
                "ship 0, direction 1, location 0",
                "Ship 0, direction 1, location 1"
                },{
/* motion 1 */ /* Tar Valon to Tear by way of Aringill */
                "The %s docks in the South Harbor of Tar Valon.",
                "The %s pushes its way out into the currents of the river, leaving Tar Valon.",
                "Tar Valon and Dragonmount disappear in the north.",
                "The %s picks up speed as it enters the swift currents of the river.",
                "The northern docks of Aringill come into view.",
                "The %s docks on the north side of Aringill.",
                "The %s leaves the docks of Aringill and embarks south.",
                "The %s makes excellent progress, speeding along on the river's currents.",
                "The docks of Tear appear towards the not so distant south.",
                "The %s docks on one of the many piers in Tear.",
                "The %s moves away from the docks, the polesmen pushing it along.",
                "The polesmen steadily manuever the %s up the river.\n\rIt is only a short swim to the eastern bank,\n\rwhere a shadowed trail leads into the Mirk.",
                "Time passes slowly during the trip.",
                "The %s docks in Aringill.",
                "The %s leaves the docks of Aringill and heads upriver to Tar Valon.",
                "The river's currents push steadily against the %s.",
                "The smoking peak of Dragonmount appears on the horizon.",
                "The %s nears the South Harbor of Tar Valon.",
                },{
/* motion 2 */ /* Tear to Ebou Dar */
                "The %s ports in Tear and its cargo is traded off onto a sailing ship.",
                "The %s travels smoothly through the water, leaving Tear behind.",
                "The %s sails easily through smooth waters.",
                "A thin green line marks the shore in the distance.",
                "The %s approaches the docks of Illian.",
                "The %s docks at the port of Illian and readies for the trip to Ebou Dar.",
                "The %s leaves the port of Illian, bound for Ebou Dar.",
                "A thin green line marks the shore in the distance.",
                "A tall wave washes over the ship's deck.",
                "The docks of Ebou Dar appear on the horizon.",
                "The %s docks in Ebou Dar and its cargo is traded off onto a Seafolk raker.",
                "The %s leaves the docks of Ebou Dar, speeding east towards Illian.",
                "The %s cuts through the choppy waves of the Sea of Storms.",
                "Spray splashes across the deck.",
                "The %s swiftly approaches the docks of Illian, towards the east.",
                "The %s ports in Illian, and readies its cargo for Tear.",
                "The %s leaves Illian behind, bound for Tear.",
                "A swift wind speeds the %s towards Tear.",
                "A flight of gulls pass overhead, heading north towards land.",
                "Tear becomes visible from a distance.",
/* motion 3 */     },{  /* CarysFord to Illian */
                "The %s is pulled into the dock at Carysford by two young boys.",
		"The %s docks at Tamielle.",
/*                "The riverboat pulls slowly away from the dock at Carysford.",a*/
                "The %s lurches as it moves into an area of rapids.",
                "The %s enters into a heavily forested area and the scent of pine fills the air.",
                "The city of Illian appears in the distance. Tall spires and great houses are easily seen.",
                "The %s docks in Illian.",
                "The %s pulls away from the dock at Illian, headed north.",
                "The %s moves through a thickly forested area.",
/*                "Water washes over the deck as the boat makes its way through the rapids.",*/
                "A pair of deckhands begin to squabble over a game of dice.",
		"Water splashes on the deck as the %s docks at Tamielle.",
/* motion 4 */ 	},{ /* Masada (Tremalking) to Ebou Dar */ /* Talitha */
		"Slowing greatly, the %s docks at Masada Port, on the island Tremalking.",
		"Raising its sails, the %s leaves the docks of Masada, Port of Tremalking.",
		"The %s sails through the calm waters of the rounded Tremalking harbor.",
		"Waves buffet against the ship as it passes the triplet of Islands just outside the harbor.",
		"Salty water splashes onto the deck as waves crash against the side, the wind begins to pick up.",
		"Rocks of the Windbiter's Finger can be seen in the distance, as the %s skirts past them.",
		"After passing the Windbiter's Finger, the ocean calms, and sailing is smooth once again.",
		"The docks and piers of Ebou Dar become visible as the %s approaches.",
		"The %s glides gracefully into the docks of Ebou Dar, the capital of Altara.",
		"The %s lowers its sails and glides out of the docks of Ebou Dar.",
		"Ebou Dar is left far behind as the small soarer continues on its journey.",
		"The waves pick up as the %s continues, wind billowing in the sails.",
		"The %s sails carefully around the jagged rocks of Windbiter's Finger.",
		"The sails of the small soarer billow as the wind fills them, pushing the ship onward.",
		"Three small islands come into view, and the soarer quickly passes them as it sails on.",
		"Masada, and its docks, appear on the west side of the large harbor of Tremalking.",
                },{
/* motion 5 */  /* Ebou to Arad Doman City (and back) *//* Cierin */
                "The %s docks in the port of Ebou Dar.",
                "The %s sails west, leaving Ebou Dar behind.",
                "Waves grow rough as the Shadow Coast comes into view.",
                "The %s turns in a southernly direction to pass around the rocky Windbiters Finger.",
                "The heights of Tremalking appear to the west, the sun sparkling off a large piece of crystal.",
                "The %s passes between Sea Folk Islands and the coast of Tanchico.",
		"The %s docks in Tanchico at the Calpene Docks.",
                "Leaving Tanchico behind, Toman Head appears to the North.",
                "The %s docks in Falme, taking on new goods and passengers.",
                "Hugging close to shore, the %s leaves for Arad Doman.",
                "Bright lights from Bandar Eban twinkle on the horizon.",
                "A Sea Folk raker passes by.",
                "The %s approaches the docks of Bandar Eban.",
                "The %s docks in Arad Doman, and unloads its cargo.",
                "The %s sets sail south from Bandar Eban.",
                "The lights of Arad Doman fade as the %s enters deep water.",
                "Toman Head becomes visible to the south.",
                "The city of Falme rises over the horizon.",
                "The %s docks in Falme, and goods are exchanged.",
                "Full of new goods the %s leaves the docks.",
                "Toman Head quickly fades from view as the %s sails south.",
		"Winds and waves buffet the %s.",
                "The city of Tanchico stands out to the east.",
		"The %s docks at the Calpene Docks in Tanchico.",
                "Waves grow rough as the %s rounds the Shadow Coast.",
                "Ebou Dar appears close to the north.",
		},{
/* motion 6 */  /* Tear to Mayene (and back) *//* Cierin */
		"The %s docks in Tear, to change cargo before returning to Mayene.",
		"The %s leaves the docks in Tear, heading for the Fingers of the Dragon.",
		"A Tairen pilot takes the helm, guiding the vessel through the delta waters.",
		"At the mouth of the delta, the Tairen pilot leaves, taking a tiny boat back to the docks.",
		"The %s makes for the open waters of the Sea of Storms.",
		"A strong breeze fills the sails, and the ship makes good time.",
		"Schools of silverpike flash through the waves.",
		"The coastline is a dim green stripe on the starboard side.",
		"From the bow, the peninsula upon which Godan sits is visible.",
		"Entering the narrow channel, the %s passes between Godan and the isle of Cindaking.",
		"As the ship clears the channel, the city of Mayene appears.",
		"The %s approaches the Mayene city docks.",
		/* and back again */
		"The %s docks in Mayene to change cargo before heading back to Tear.",
		"The %s sets sail from Mayene towards Tear.",
		"The city of Mayene quickly fades from the view from the stern.",
		"Approaching a channel, the sailors make ready to pass between Godan and the isle of Cindaking.",
		"The features of the land are visible as the ship moves past, heading for open water.",
		"The waves grow choppy as the %s enters the Sea of Storms.",
		"Passing in the distance, a merchant vessel is visible off the port side.",
		"Clouds of salty spray wash over the deck, covering everything in a heavy mist.",
		"Sails are hauled in as the %s nears the Fingers of the Dragon.",
		"At the mouth of the delta, a Tairen pilot is taken aboard.",
		"Under the pilot's command, the %s eases its way through the Fingers of the Dragon.",
		"The docks of Tear grow larger as the ship moves in to dock.",
		},{
/* motion 7 */  /* Tanchico to Little Paradise (and back) *//* Cierin */
		"Docking in the harbor, the ship lets off passengers and cargo.",
		"The anchor is raised and the ship sets out through the Tanchico Bay.",
		"Passing between the last guard towers, the ship enters the open waters of the Aryth.",
		"The %s turns south, sailing along the coast of Tarabon.",
		"Large rocks jut out of the water as the ship begins to pass the Shadow Coast.",
		"The helmsman controls the wheel as the ship passes between Tremalking and the Windbiter's finger.",
		"A few sea birds wheel overhead before continuing by.",
		"A heavy wave causes the ship to list to the side, before it rights itself.",
		"A tiny speck of green becomes visible on the horizon.",
		"The crew prepares the ship to dock.",
		/* and back again */
		"A heavy rope is lashed to the dock as the %s lands at Little Paradise.",
		"The ship sets sail from the tiny island, heading northwest.",
		"Little Paradise fades away to a green speck in the stern.",
		"Heavy waves rock the %s as it takes to open waters.",
		"Larger land masses rise up on the horizon.",
		"The ship enters the narrow channel between Tremalking and the Shadow Coast.",
		"Something large resembling a statue is visible on a high peak of Tremalking.",
		"The ship clears the channel and re-enters open water.",
		"Turning northeast, the %s skims along the Shadow Coast, approaching Tarabon.",
		"The ship enters the Tanchico Bay and approaches the docks.",
},};

extern const struct ShipType ShipTable[];
