/*
 * This structure is used for the
 * pathfinding algorithm.
 */
typedef struct heap_data
{
  int	             iVertice;
  ROOM_INDEX_DATA ** knude;
  int                size;
} HEAP;


struct tag_data
{
  int status;
  int timer;
  int next;
  int playing;
  int bteam;
  int rteam;
};

struct gquest_data
{
    int mobs[MAX_GQUEST_MOB];
    char *who;
    int mob_count;
    int timer;
    int involved;
    int qpoints;
    int gold;
    int minlevel;
    int maxlevel;
    int running;
    int next;
};

/* Drunk code structure */
struct struckdrunk
{
	int	min_drunk_level;
	int	number_of_rep;
	char	*replacement[11];
};


/*
 * Site ban structure.
 */

struct	ban_data
{
    BAN_DATA *	next;
    bool	valid;
    int		ban_flags;
    int		level;
    char *	name;
};

struct  wiz_data
{
    WIZ_DATA *	next;
    bool	valid;
    int 	level;
    char *	name;
    char *      email;
    char *      job;
};

struct buf_type
{
    BUFFER *    next;
    bool        valid;
    int	      state;  /* error state of the buffer */
    int      size;   /* size in k */
    char *      string; /* buffer's string */
};

struct	time_info_data
{
    int		hour;
    int		day;
    int		month;
    int		year;
};

struct	weather_data
{
    int		mmhg;
    int		change;
    int		sky;
    int		sunlight;
};

struct  tornado_data
{
    TORNADO_DATA *next;
    TORNADO_DATA *prev;
    int direction;
    int x;
    int y;
    int damage_per_shake;
    int radius;
    int time_left;
};

struct        fighting_data
{
       CHAR_DATA *fighter;
       FIGHTING_DATA *next;
};

struct drop_data
{
	DROP_DATA		*next;
	long			vnum;
	int			rarity;
};


/* Story Quests - Rokann */

struct quest_data
{
	QUEST_DATA	*next;		/* next quest in the list */
	OBJECTIVE_DATA	*objectives;	/* list of objectives for the quest */
	int		vnum;		/* id number of the quest */
	char		*name;		/* title of the quest */
	char		*guild;		/* list of guilds that can attempt this quest */
	int		levelmin;	/* The lowest character level that can attempt this quest */
	int		levelmax;	/* The highest character level that can attempt this quest */
	char		*questsay;	/* What the questmaster says to introduce the quest */
	int		qcomplete;	/* Step # that they can complete the quest on */
	bool		changed;	/* Any need to save this? */
	bool		active;		/* Is this quest active? */
};

struct objective_data
{
	OBJECTIVE_DATA	*next;		/* next objective in the list */
	int		vnum;		/* id number of the objective */
	char		*objective;	/* says what they gotta do */
	int		requirement[4];	/* Step # required in order to be able to do this objective */
	char		*reward;	/* reward - 50 gold, 100 xp, 25 qp, <vnum> obj, <power> <weaveup>, etc */
};



/*
 * Descriptor (channel) structure.
 */
struct	descriptor_data
{
    DESCRIPTOR_DATA *	next;
    DESCRIPTOR_DATA *	snoop_by;
    CHAR_DATA *		    character;
    CHAR_DATA *		    original;
    LLIST	*			events;
    bool		        valid;
    #ifdef THREADED_DNS
	char Host[4];
    #else
	char *host;
    #endif
    int		        descriptor;
    int		        connected;
    bool		        fcommand;
    char		        inbuf		[4 * MAX_INPUT_LENGTH];
    char		        incomm		[MAX_INPUT_LENGTH];
    char		        inlast		[MAX_INPUT_LENGTH];
    int			        repeat;
    char *		        outbuf;
    char *              multi_buf;
    int			        outsize;
    int			        outtop;
    char *		        showstr_head;
    char *		        showstr_point;
    void *              pEdit;		/* OLC */
    char **             pString;	/* OLC */
    int			        editor;		/* OLC */
    bool                ansi;
    protocol_t *        pProtocol; /* <--- Add this line */
};



/*
 * Attribute bonus structures.
 */
struct	str_app_type
{
    int	tohit;
    int	todam;
    int	carry;
    int	wield;
};

struct	int_app_type
{
    int	learn;
    int  op_focus; /* One Power Focus - Dal */
};

struct	wis_app_type
{
    int	practice;
    int  op_will; /* One Power Will - Dal */
};

struct	dex_app_type
{
    int	defensive;
};

struct	con_app_type
{
    int	hitp;
    int	shock;
    int  op_stam; /* One Power Stamina */
};

struct	ref_app_type
{
    int	lockpicking;
    int	to_hit;
};

struct	ins_app_type
{
    int	initiative;
    int	surprise;
};

struct	cha_app_type
{
    int	persuasion;
};

/*
 * Help table types.
 */
struct	help_data
{
    HELP_DATA *	next;
    HELP_DATA * next_area;
    int	    level;
    char *	    keyword;
    char *      related; /* related keywords, SEE ALSO... */
    char *	    text;
};

struct help_area_data
{
	HELP_AREA *	next;
	HELP_DATA *	first;
	HELP_DATA *	last;
	AREA_DATA *	area;
	char *		filename;
	bool		changed;
};

struct	shop_data
{
    SHOP_DATA *	next;		 	        /* Next shop in list */
    long	    keeper;			        /* Vnum of shop keeper mob */
    int	    buy_type [MAX_TRADE];	/* Item types shop will buy	*/
    int	    profit_buy;		        /* Cost multiplier for buying */
    int	    profit_sell;		    /* Cost multiplier for selling	*/
    int	    open_hour;		        /* First opening hour */
    int	    close_hour;		        /* First closing hour */
};

struct	class_type
{
    char *	name;			    /* the full name of the class */
    char 	who_name	[4];	/* Three-letter name for 'who'	*/
    int	attr_prime;		    /* Prime attribute */
    int	weapon;			    /* First weapon	*/
    int	guild[MAX_GUILD];	/* Vnum of guild rooms */
    int	skill_adept;		/* Maximum skill level */
    /* THAC0 needs to go */
    int	thac0_00;		    /* Thac0 for level  0 */
    int	thac0_32;		    /* Thac0 for level 32 */
    int	hp_min;			    /* Min hp gained on leveling */
    int	hp_max;			    /* Max hp gained on leveling */
    bool	fMana;			    /* Class gains mana on level */
    char *	base_group;		    /* base skills gained */
    char *	default_group;		/* default skills gained */
};

struct item_type
{
    int		type;
    char *	name;
};

struct weapon_type
{
    char *	name;
    int	vnum;
    int	type;
    sh_int	*gsn;
    int  damtype;
};

struct wiznet_type
{
    char *	name;
    long 	flag;
    int		level;
};

struct attack_type
{
    char *	name;			/* name */
    char *	noun;			/* message */
    int   	damage;			/* damage class */
};

struct race_type
{
    char *	name;			/* call name of the race */
    bool	pc_race;		/* can be chosen by pcs */
    long	act;			/* act bits for the race */
    long	aff;			/* aff bits for the race */
    long	off;			/* off bits for the race */
    long	imm;			/* imm bits for the race */
    long    res;			/* res bits for the race */
    long	vuln;			/* vuln bits for the race */
    long	form;			/* default form flag for the race */
    long	parts;			/* default parts for the race */
    int     remort;         /* num of remorts needed to be chosen, 0 for any */
    char *  descr;
    int		type;			/* Signifies human (0), shadowspawn (1), or ogier (2)*/
};


struct pc_race_type                 /* additional data for pc races */
{
    char *	name;			        /* MUST be in race_type */
    char 	who_name[12];
    int	points;			        /* cost in points of the race */
    int	class_mult[MAX_CLASS];	/* exp multiplier for class, * 100 */
    char *	skills[5];		        /* bonus skills for the race */
    int 	stats[MAX_STATS];	    /* starting stats */
    int	max_stats[MAX_STATS];	/* maximum stats */
    int	size;			        /* aff bits for the race */
    int     hometown;
    bool   lifer;
};

struct remort_race_sort_struct   /* for sorting races by remorts and name (do_immortal) */
{
    char *name;
    int  remorts;
};


struct spec_type
{
    char * 	name;			    /* special function name */
    SPEC_FUN *	function;		/* the function */
};

struct	pnote_data
{
    PNOTE_DATA *	next;
    bool 	    valid;
    int	    type;
    char *	    sender;
    char *	    date;
    char *	    to_list;
    char *	    subject;
    char *	    text;
    time_t      date_stamp;
};

struct	note_data
{
	NOTE_DATA * next;
	bool    valid;
	int     type;
	char *  sender;
	char *  date;
	char *  to_list;
	char *  subject;
	char *  text;
	time_t  date_stamp;
	time_t  expire;
	int	likes;
	char * poster_host;
};


/*
 * An affect.
 */
struct	affect_data
{
    AFFECT_DATA *	next;
    bool		    valid;
    int		    where;
    int		    type;
    int		    level;
    int		    duration;
    int		    location;
    int		    modifier;
    int			    bitvector;
};

/*
 * A kill structure (indexed by level).
 */
struct	kill_data
{
    int		number;
    int		killed;
};

/* timed events from kyndig.com */
struct event_data
{
   int        delay;
   CHAR_DATA    *to;
   int       action;
   DO_FUN   *do_fun;
   char    *args[5];
   void    *argv[5];
   int      argi[5];
   EVENT_DATA *next;
   bool       valid;
};

struct weave_data
{
  WEAVE_DATA	*next;
  int	action[2];
  int	spell_vars[7];
  int		power[6];
  void		* vo;
  char		* target_name;
};

struct war_data
{
  WAR_DATA      *next;
  char          *ch_name;
};

struct locker_data
{
	/*LOCKER_DATA *locker;*/
	int   capacity;
	int   holding;
	int   flags;
	int   room;
};

/* grant code */
struct grant_data
{
    GRANT_DATA *        next;
    DO_FUN *            do_fun;
    char *              name;
    int                 duration;
    int                 level;
};

struct guild_rank
{
  char *rankname;               /* name of rank                         */
  char *skillname;              /* name of skill earned at this rank    */
};

/* mortal leader rights are as follows;
 ml[0] = can_guild
 ml[1] = can_deguild
 ml[2] = can_promote
 ml[3] = can_demote
*/

struct clan_type
{
  long flags;                   /* flags for guild                      */
  char *name;			/* name of guild                        */
  char *who_name;		/* name sent for "who" command		*/
  char *tag;
  long room[3];                  /* hall/morgue/temple rooms             */
  rankdata rank[MAX_RANK];	/* guilds rank system                   */
  int ml[4];			/* mortal leader rights 		*/
  char *related[MAX_GUILD_RELATIONS]; /* for wearing subguild eq, etc */
  char *chats[MAX_GUILD_RELATIONS]; /* for chatting with subguilds, etc */
  char *lists[MAX_GUILD_RELATIONS]; /* for listing other members/sub-guilds, etc */
  char *gcom; /* special command for channel for guilds with multiple subs, ie towertalk */
  char *gcomooc; /* special command for channel for guilds with multiple subs, ie towertalk */
  char *lefty;
  char *righty;
        char    * inner;
        char    * outer;
        char    * gl;
        char    * help;
        char    * seer;
};

/*
 * Prototype for a mob.
 * This is the in-memory version of #MOBILES.
 */
struct	mob_index_data
{
    MOB_INDEX_DATA *	next;
    SPEC_FUN *		spec_fun;
    SHOP_DATA *		pShop;
    PROG_LIST *        mprogs;
    AREA_DATA *		area;		/* OLC */
    long		vnum;
    int		group;
    bool		new_format;
    int		count;
    int		killed;
    char *		player_name;
    char *		short_descr;
    char *		long_descr;
    char *		description;
    char *      die_mess;
    char *      kill_mess;
    long		act;
    long                act2;
    long		affected_by;
	long        affected2_by;
    int		alignment;
    int		level;
    int		hitroll;
    int		hit[3];
    int		mana[3];
    int		damage[3];
    int		ac[4];
    int 		dam_type;
    long		off_flags;
    long		imm_flags;
    long		res_flags;
    long		vuln_flags;
    int		start_pos;
    int		default_pos;
    int		sex;
    int		race;
    long		wealth;
    long		form;
    long		parts;
    int		size;
    int      timer;
    char *		material;
    long		mprog_flags;
    DROP_DATA	*drops;
};

/* memory for mobs */
struct mem_data
{
    MEM_DATA 	*next;
    bool	valid;
    int		id;
    int 	reaction;
    time_t 	when;
};

struct email_data
{
    EMAIL_DATA *next;
    bool valid;
    char *to;
    char *subject;
    char *body;
};


/*
 * One character (PC or NPC).
 */
struct	char_data
{
    CHAR_DATA *         next;
    CHAR_DATA *         next_in_room;
    CHAR_DATA *         master;
    CHAR_DATA *         leader;
    /*CHAR_DATA *		fighting;*/
    FIGHTING_DATA *     fight_data;
    CHAR_DATA *         reply;
    CHAR_DATA *         pet;
    CHAR_DATA *         mprog_target;
    CHAR_DATA *         challenged;
    MEM_DATA *          memory;
    SPEC_FUN *          spec_fun;
    MOB_INDEX_DATA *	pIndexData;
    DESCRIPTOR_DATA *	desc;
    AFFECT_DATA *       affected;
    PNOTE_DATA *         pnote;
    OBJ_DATA *          carrying;
    OBJ_DATA *          on;
    ROOM_INDEX_DATA *	in_room;
    ROOM_INDEX_DATA *	was_in_room;
    ROOM_INDEX_DATA *	camp_room;
    AREA_DATA *         zone;
    PC_DATA *           pcdata;
    GEN_DATA *          gen_data;
	HATE_DATA *         hate;
    LLIST      *			events;
    int			curr_quest;	/* Rokann */
    int			qstep[MAX_QSTEPS];	/* Rokann */
    CHAR_DATA *         questgiver; /* Vassago */
    int                 questpoints;  /* Vassago */
    int              nextquest; /* Vassago */
    int              countdown; /* Vassago */
    int              questobj; /* Vassago */
    int              questmob; /* Vassago */
    bool                qcomp; /* not Vassago */
    CHAR_DATA *         qmob;
    CHAR_DATA *         questor;
    int                 mdeath;
    int                 mkill;
    int                 pkill;
    int                 battles;
    int                 bwins;
    int                 pdeath;
    int			junk;
    /*
    int	       action[2];
    int	       spell_vars[5];
    void	      * vo;
    */
    WEAVE_DATA		*weaves;
    /*int             bounty_timer;*/
    int              camp_timer;
    bool		        valid;
    char *		        name;
    char *              eye;
    char *              hair1;
    char *              hair2;
    char *              hair3;
    char *              hair4;
    char *              misc1;
    char *              misc2;
    long		        id;
    int		        version;
    char *		        short_descr;
    char *		        long_descr;
    char *		        description;
    char *		        prompt;
    char *		        prefix;
    CHAR_DATA *         advancing_on;
    int              range;
    bool                advancing;
    char *              run_buf; /*Jogging*/
    char *              run_head;
    bool		jog_full;
    int			jog_to;
    int		        group;
    int		        clan;
    int      	        rank;   /* clan rank/status */
    int		        sub_clan;
    int      	        sub_rank;   /* subclan rank/status */
    int		        sex;
    int		        class;
    int		        race;
    int		        level;
    int		        trust;
    int			        played;
    int			        lines;  /* for the pager */
    time_t		        logon;
    int		        timer;
    int		        wait;
    int		        daze;
    int			        hit;
    int			        max_hit;
    int			        stam;
    int			        max_stam;
    int				mod_hit;
    int				mod_stam;
    long			money[5][2];
    int				number_of_fights;
    int			        exp;
    long		        act;
    long                act2;
    long		        comm;
    long		        wiznet;
    long                talent_flags;
    long		        imm_flags;
    long		        res_flags;
    long		        vuln_flags;
    long                auto_flags;     /* Autolist stuff - Dalsor */
    long                ajah_flags;     /* Aes Sedai Ajah flags - Dalsor */
    long                op_flags;       /* General One Power flags - Dalsor */
    long                custom_flags;   /* Added for Get_BACKG */
    long                stance_flags;          /* Added for blademaster */
    long                off_forms_flags;       /* added for blademaster */
    long                off_sub_forms_flags;   /* added for blademaster */
    long                def_forms_flags;       /* added for blademaster */
    long                def_sub_forms_flags;   /* added for blademaster */
    long                off_sforms_flags;       /* added for blademaster */
    long                off_sub_sforms_flags;   /* added for blademaster */
    long                def_sforms_flags;       /* added for blademaster */
    long                def_sub_sforms_flags;   /* added for blademaster */
    long                spec_flags;     /* Added for Wolfkin, Dreamer, Taveren */
    long                hist_flags;     /* History flags */
    long                tabac_flags;    /* Tabac flags */
    long                war_flags;      /* War flags */
    long                penalty_flags;  /* Penalty flags for bad people */
    int		        invis_level;
    int		        incog_level;
    long		        affected_by;
	long                affected2_by;
    int		        position;
    int		        practice;
    int		        train;
    /* Carrying */
    int		        carry_weight;
    int		        carry_number;
    int		        saving_throw;
    int		        alignment;
    int		        hitroll;
    int		        damroll;
    int		        armor[4];
    long		        wimpy;
    /* stats */
    int		        perm_stat[MAX_STATS];
    int		        mod_stat[MAX_STATS];
    int			quest_stat[MAX_STATS];
    int			quest_op[MAX_SPHERES];
/*    int			perm_op[MAX_SPHERES];	FIXME Use this in place of how spheres are stored eventually. */
    /* parts stuff */
    long		        form;
    long		        parts;
    int		        size;
    char*		        material;
    /* mobile stuff */
    long		        off_flags;
    int		        damage[3];
    int		        dam_type;
    int		        start_pos;
    int		        default_pos;
    CHAR_DATA *         mount;
    bool		        riding;
    int		        mprog_delay;
    char * warring_with;
    int				lootroll;
	char *colorname;
};

/* Rokann */
struct buddy_data
{
	BUDDY_DATA	*next;
	char		*name;
	int		relationship;	/* Maybe? */
};

/*
 * Data which only PC's have.
 */
struct	pc_data
{
    PC_DATA *		next;
    BUFFER * 		buffer;
    COLOUR_DATA *	code;		/* Data for coloUr configuration	*/
	TIME_INFO_DATA  birthday;
    int pfile_size;
    bool		valid;
    bool        rebirthing;
    bool        pk_able; /* Added for PKing */
    bool        addict;
    int      addict_hours;
    int      ticket_number; /* gevent raffle -- Dalsor */
    int      happiness; /* gevent Happy Hour -- Dalsor */
    bool        accept_follower;
    CHAR_DATA * accept_follower_name;

	/* Markanth's email system - Dalsor */
    EMAIL_DATA *email_data;
    char * email;
    char * last_tell_to;
    /* end email */

	/* profile data - Dalsor */
	char * ooc_real_name;
	char * ooc_sex;
	char * ooc_age;
	char * ooc_birthplace;
	char * ooc_marital_status;
	char * ooc_residence;
	char * ooc_occupation;
	char * ooc_activities;
	char * ooc_fav_book;
	char * ooc_fav_tv_show;
	char * ooc_fav_actor;
	char * ooc_fav_actress;
	char * ooc_fav_movie;

    /* summary data - Resets on login, evers save in pfile - Dalsor */
    int summary[MAX_SUMMARY + 1]; /* this needs to be 1 more than max summary if max summary is end point of array */

    bool has_vault;
    bool in_vault;
    ROOM_INDEX_DATA *prior_to_vault;

    CHAR_DATA * dance_partner;
    int      dance_points;
    long        dance_last;
    CHAR_DATA * link_leader;
    int         pk_timer; /* Added for PKing */
    int         jail_timer;
    int         warning;
    int         questsrun;
    char *      questinfo_data;
	sh_int qtype;
    int         bugsreported;
    int         lastbug;
	long tag_flags;
	int			dfhunt_player_info[7];
    int      concentration;
    int      stat_rolls;
    int	touch_tries;
    int         grasped;
	long        gq_mobs[MAX_GQUEST_MOB];
    GRANT_DATA *        granted;
    ROOM_INDEX_DATA * jail_room;
    char *		pwd;
	char * tmp; /* this is a holder for tmp information, it should always be NULL'd after use -- Dalsor 06.18.2013 */
    char *		bamfin;
    char *		bamfout;
    char *      wkin;  /* Added for WalkIn - Dal */
    char *      wout;  /* Added for WalkOut - Dal */
    char *      rdesc;  /* Added for Roomdesc - Dal */
    char *      afkmsg; /* message sent if afk and a tell is received */
    char *      bonded_to;
    char *      bonded_by;
    char *      aiel_clan;
    char *      spouse;
    char *      proposal;
    char *      last_name;
    char * last_command; /* for rplogging -- Dalsor */
    int      eye;
    int      hair;
    int      hair1;
    int      hair2;
    int      hair3;
    int      hair4;
    long         shop_vnum; /* Virtual number of player owned shop */
    long         shopmob_vnum; /* Virtual number of player's shop handler */
    char        explored[4096];
    int         explore_exp[10];
    int         explored_pcnt;
    bool	new_room; /* for prompt */
	int      gamble_type;
    int      gamble_coin;
    int      gamble_sides;
    int      gamble_dice;
    int      deguilded; /* if has been deguilded or not, reset at rebirth */
    long        bounty;
    int         rebirth;
    int         companion_prior;
    int         allowed;
    int      newbie;
    ROOM_INDEX_DATA * virtual_room;
    int      insanity;
    int      burnout;
    bool        can_channel;   /* Added for OP - Dal */
    int      op_air;
    int      op_fire;
    int      op_earth;
    int      op_water;
    int      op_spirit;
    int         char_barrier;
    char *		title;
    int         beard;
  	BOARD_DATA *			board; /* The current board */
  	time_t				last_note[MAX_BOARD]; /* last note for the boards */
 	NOTE_DATA *			in_progress;
    time_t              last_pnote;
    time_t              last_idea;
    time_t              last_penalty;
    time_t              last_news;
    time_t              last_changes;
    time_t              last_roleplay;
    time_t              last_restring;
    time_t              last_event;
    int		perm_hit;
    int		perm_mana;
    int		true_sex;
    int		true_race;
    int			last_level;
    /*int         int_beacons[MAX_BEACONS];*/ /* max num of beacons by int, up to max_beacons */
    long        beacons[MAX_BEACONS]; /* memorized rooms char's int/10 do_study */ /* needs to be long since these are vnums */
	BUDDY_DATA *buddies;
    int		condition	[4];
    CHAR_DATA * learning_from;
    CHAR_DATA * teaching;
    int      learning_skill;
    int      teaching_skill;
    int      learnStart;
    int		learned		[MAX_SKILL];
    bool		group_known	[MAX_GROUP];
    int		prompt_skill;		/* for tracking proficiency in a skill in prompt */
    int		points;
    bool              	confirm_delete;
    bool              	confirm_rebirth;
    bool                confirm_life_race;
    char *	    ignore[MAX_IGNORE];
    char *		alias[MAX_ALIAS];
    char * 		alias_sub[MAX_ALIAS];
    int 		security;	/* OLC */ /* Builder security */
    long      home_vnum;
    long      locker_room; /* locker.c */
/*
    char *            rank;
    char *            guild_tag;
*/
    /* Companions */
    int              companion_timer; /* timer for getting new companions */
    MOB_INDEX_DATA *    companion;
     int                       text[3];                /* {t */
     int                       auction[3];             /* {a */
     int                       auction_text[3];        /* {A */
     int                       gossip[3];              /* {d */
     int                       gossip_text[3];         /* {9 */
     int                       music[3];               /* {e */
     int                       music_text[3];          /* {E */
     int                       question[3];            /* {q */
     int                       question_text[3];       /* {Q */
     int                       answer[3];              /* {f */
     int                       answer_text[3];         /* {F */
     int                       quote[3];               /* {h */
     int                       quote_text[3];          /* {H */
     int                       immtalk_text[3];        /* {i */
     int                       immtalk_type[3];        /* {I */
     int                       info[3];                /* {j */
     int                       say[3];                 /* {6 */
     int                       say_text[3];            /* {7 */
     int                       tell[3];                /* {k */
     int                       tell_text[3];           /* {K */
     int                       reply[3];               /* {l */
     int                       reply_text[3];          /* {L */
     int                       gtell_text[3];          /* {n */
     int                       gtell_type[3];          /* {N */
     int                       wiznet[3];              /* {B */
     int                       room_title[3];          /* {s */
     int                       room_text[3];           /* {S */
     int                       room_exits[3];          /* {o */
     int                       room_things[3];         /* {O */
     int                       prompt[3];              /* {p */
     int                       fight_death[3];         /* {1 */
     int                       fight_yhit[3];          /* {2 */
     int                       fight_ohit[3];          /* {3 */
     int                       fight_thit[3];          /* {4 */
     int                       fight_skill[3];         /* {5 */

     /*Temp Stuff for Staff*/
     long last_in;
     long last_gold;
     long last_qp;
     long last_xp;
     long last_items;
     int staff_points;
     int mod_warnings;
     int mod_freezings;
     int mod_disconnects;
     int verifications;
     int rewards_gold;
     int total_gold;
     int rewards_qp;
     int total_qp;
     int rewards_xp;
     int total_xp;
     int rewards_items;
     int total_items;

	/* War variables for army support */
	char            * war_footmen[MAX_UNITS]; /* up to 4 different unit names */
	char            * war_archers[MAX_UNITS];
	char            * war_pikemen[MAX_UNITS];
	char            * war_cavalry[MAX_UNITS];
	char            * war_channelers[MAX_UNITS];

	char            * war_footmen_fighting[MAX_UNITS]; /* what name is this unit fighting against */
	char            * war_archers_fighting[MAX_UNITS];
	char            * war_pikemen_fighting[MAX_UNITS];
	char            * war_cavalry_fighting[MAX_UNITS];
	char            * war_channelers_fighting[MAX_UNITS];

	/* 0 1 2 footmen,  3 4 5 archers,  6 7 8 pikemen, 9 10 11 cavalry, 12 13 14 channelers */
	int               war_unit_offense[15];
	int               war_unit_defense[15];

	int               war_footmen_num[MAX_UNITS]; /* how many units per division */
	int               war_archers_num[MAX_UNITS];
	int               war_pikemen_num[MAX_UNITS];
	int               war_cavalry_num[MAX_UNITS];
	int               war_channelers_num[MAX_UNITS];

	//Whether or not the player surrenders or retreats
	bool              war_quit;
	bool              war_sur;
	bool              ret_safe;

	/* END War variables for army support */

	char *battle_cry;

};

/* Data for generating characters -- only used during generation */
struct gen_data
{
    GEN_DATA	*next;
    bool	valid;
    bool	skill_chosen[MAX_SKILL];
    bool	group_chosen[MAX_GROUP];
    int		points_chosen;
};

struct bond_data
{
	BOND_DATA  *next;
	char *bonded_by;
	char *bonded_to;
};

/*
 * Invasion structure(s)
 */
struct  invade_vnums
{
  char *name;
  long  vnum;
  int  total;
};

struct	liq_type
{
    char *	liq_name;
    char *	liq_color;
    int	liq_affect[5];
};

struct stitch_patterns_type
{
	char *aname;
	char *bname;
	int difficulty;
	int beats;
};

struct cloth_colors_type
{
	int number;
	char *aname;
	char *bname;
	char *cname;
};

struct stitch_items_type
{
	char *name;
	float length;
	int   weight;
	int   difficulty;
	int   beats;
	int   wear_flags;
	int   base_pierce;
	int   base_bash;
	int   base_slash;
	int   base_exotic;
};

/*For tailoring -Hortin*/

extern const struct stitch_items_type stitch_items_table[];
extern const struct cloth_colors_type cloth_colors_table[];
extern const struct stitch_patterns_type stitch_patterns_table[];

/*
 * Extra description data for a room or object.
 */
struct	extra_descr_data
{
    EXTRA_DESCR_DATA *next;	/* Next in list                     */
    bool valid;
    char *keyword;              /* Keyword in look/examine          */
    char *description;          /* What to see                      */
};



/*
 * Prototype for an object.
 */
struct	obj_index_data
{
    OBJ_INDEX_DATA *	next;
    EXTRA_DESCR_DATA *	extra_descr;
    AFFECT_DATA *	affected;
    AREA_DATA *		area;		/* OLC */
	PROG_LIST *		oprogs;
	long		oprog_flags;
    bool		new_format;
    char *		name;
    char *		short_descr;
    char *		description;
    long		vnum;
    int		reset_num;
    char *		material;
    char *		guild;
    int		item_type;
    int			extra_flags;
    int         construct_flags;
    int			wear_flags;
    int		level;
    int 		condition;
    int		count;
    int		weight;
    int			cost;
    int			value[5];
};

/*
 * One object.
 */
struct	obj_data
{
    OBJ_DATA *		next;
    OBJ_DATA *		next_content;
    OBJ_DATA *		contains;
    OBJ_DATA *		in_obj;
    OBJ_DATA *		on;
    CHAR_DATA *		carried_by;
    CHAR_DATA *		oprog_target;
    int		oprog_delay;
    EXTRA_DESCR_DATA *	extra_descr;
    AFFECT_DATA *	affected;
    OBJ_INDEX_DATA *	pIndexData;
    ROOM_INDEX_DATA *	in_room;
/*    KEY_DATA *		keys;	*/

    long		stash_id;
    bool		valid;
    bool		enchanted;
    char *	        owner;
    char *		name;
    char *		short_descr;
    char *		description;
    int		item_type;
    int			extra_flags;
    int         construct_flags;
    int			wear_flags;
    int		wear_loc;
    int		weight;
    int			cost;
    int		level;
    int 		condition;
    char *		material;
    char *		guild;
    int		timer;
    /* Dalsor includes for treasure chest traps */
    bool        trapped;
    /* end Dalsor */
    bool		is_stitched;
    bool		is_tailored;
    int			value	[5];
    int			dye_vnum;
};



/*
 * Exit data.
 */
struct	exit_data
{
    union
    {
	ROOM_INDEX_DATA *	to_room;
	long			vnum;
    } u1;
    int		exit_info;
    long		key;
    char *		keyword;
    char *		description;
    EXIT_DATA * next;       /* OLC */
    int			rs_flags;   /* OLC */
    int			orig_door;  /* OLC */
    bool        color;      /* pathfinding */
};



/*
 * Reset commands:
 *   '*': comment
 *   'M': read a mobile
 *   'O': read an object
 *   'P': put object in object
 *   'G': give object to mobile
 *   'E': equip object to mobile
 *   'D': set state of door
 *   'R': randomize room exits
 *   'S': stop (end of list)
 */

/*
 * Area-reset definition.
 */
struct	reset_data
{
    RESET_DATA *	next;
    char		command;
    long  		arg1;
    int			arg2;
    long  		arg3;
    int			arg4;
};



/*
 * Area definition.
 */
struct	area_data
{
    AREA_DATA *		next;
    HELP_AREA *		helps;
    AREA_DATA * next_sort;
    char *		file_name;
    char *		name;
    char *		credits;
    char *      owner;
    int		age;
    int		nplayer;
    int			low_range;
    int			high_range;
    long 		min_vnum;
    long		max_vnum;
    bool		empty;
    char *		builders;	/* OLC */ /* Listing of */
    int			vnum;		/* OLC */ /* Area vnum  */
    int			area_flags;	/* OLC */
    int			security;	/* OLC */ /* Value 1-9  */
    int		clan;
    int         filename;   /* WIZUTIL */
    int         avg_mobiles;
    int         num_mobiles;
    /* weather and atmospheric data
     * mix all this up and make weather in assign_weather in db
     * change it according to the vars in update
     */
    int      temperature;     /* measured in degrees celcius */
    int      wind_direction;  /* direction wind is blowing from */
    int      wind_speed;      /* measured in kph */
    int      cloud_cover;     /* percentage of the sky covered in clouds */
    char *      cloud_type;      /* cumulus, cumulonimbus, stratus, cirrus */
    int      precipitation;   /* measured in inches per 24 hours */
    int      weather_pattern; /* 1 high pressure (more sunny) 2 low pressure (more clouds) */
};



/*
 * Room type.
 */
struct	room_index_data
{
    ROOM_INDEX_DATA *	next;
    CHAR_DATA *		people;
    OBJ_DATA *		contents;
    EXTRA_DESCR_DATA *	extra_descr;
    AREA_DATA *		area;
    EXIT_DATA *		exit	[10];
    RESET_DATA *	reset_first;	/* OLC */
    RESET_DATA *	reset_last;	/* OLC */
    AFFECT_DATA *affected;
    PROG_LIST *		rprogs;
    CHAR_DATA *		rprog_target;
    long		rprog_flags;
    int		rprog_delay;
    long        affected_by;
    char *		name;
    char *		description;
    char *		owner;
    long		vnum;
    int			room_flags;
    int		light;
    int      grade;
    int		sector_type;
    int		heal_rate;
    int 		mana_rate;
    /* RoAClient support
    char *      url;*/
    int		clan;
    int      rec_room;
    char *      msp;
	int      heap_index; /* pathfinding */
	int      steps;      /* pathfinding */
	bool        visited;    /* pathfinding */
    int ore_quantity;	/* mining */
    bool mine;		/* mining */
};

struct weave_talents_type
{
	int talent;
	char *name;
};

/*
 * Skills include spells as a particular case.
 */
struct	skill_type
{
    char       * name;			/* Name of skill		*/
    int	     skill_level[MAX_CLASS];	/* Level needed by class	*/
    int	     rating[MAX_CLASS];	/* How hard it is to learn - trains	*/
    SPELL_FUN  * spell_fun;		/* Spell pointer (for spells)	*/
    int	     target;			/* Legal targets		*/
    int	     minimum_position;	/* Position for caster / user	*/
    sh_int     * pgsn;			/* Pointer to associated gsn	*/
    int	     slot;			/* Slot for #OBJECT loading	*/
    int	     min_mana;		/* Minimum mana used		*/
    int	     beats;			/* Waiting time after use	*/
    char       * noun_damage;		/* Damage message		*/
    char       * msg_off;		/* Wear off message		*/
    char       * msg_obj;		/* Wear off message for obects	*/
    int       sphere;
    int       remort_only;    /* num remorts required */
    sh_int     * guild_num;      /* if 0, all guilds, otherwise number of from tables */
    char       * req_skill;
    SPELL_FUN  * req_weave;
    int       sphere_earth; /* earth, air, fire, water, spirit - min sphere str to use */
    int       sphere_air; /* earth, air, fire, water, spirit - min sphere str to use */
    int       sphere_fire; /* earth, air, fire, water, spirit - min sphere str to use */
    int       sphere_water; /* earth, air, fire, water, spirit - min sphere str to use */
    int       sphere_spirit; /* earth, air, fire, water, spirit - min sphere str to use */
    bool         offensive;
    int          talent; /* affecting talent */
    int          base_dmg;
    char       * descr;
};




/* Splitting weaves off from skills. They will be in their own table similar to skills
 * but with different requirements that make it easier to keep the seperate.
 * 11-21-03 -- Dalsor
 */

struct	weave_type
{
    char       * name;               /* Name of weave */
    int	     trains;             /* How many trains to learn */
    SPELL_FUN  * spell_fun;          /* Spell pointer */
    int	     target;             /* Legal targets */
    int	     minimum_position;   /* Position for caster / user */
    int	     min_mana;           /* Minimum mana used */
    int	     beats;              /* Waiting time before firing */
    char       * noun_damage;        /* Damage message */
    char       * msg_off;            /* Wear off message */
    char       * msg_obj;            /* Wear off message for obects */
    int       sphere;             /* when checking for sphere increase */
    int       remort;             /* remorts required to learn */
    char       * descr;              /* for help weave blah */
};

struct sort_skill_struct
{
	char *name;
	int learned;
	bool weave;
	int remort_only;
	int rating;
    	char * req_skill;
	int can_learn;	/* 0 no {c   1 after skill gets up a bit {y   2 yes {g */

};

struct  group_type
{
    char *	name;
    int	rating[MAX_CLASS];
    char *	spells[MAX_IN_GROUP];
};

struct prog_list
{
    int                 trig_type;
    char *              trig_phrase;
    long              vnum;
    char *              code;
    PROG_LIST *         next;
    bool                valid;
};

struct prog_code
{
    long              vnum;
    char *              code;
    PROG_CODE *         next;
};

struct key_data
{
    KEY_DATA *		next;
    bool		valid;
    OBJ_INDEX_DATA *	index;
    int		item_type;
};
/*
 * Structure for a social in the socials table.
 */
struct	social_type
{
    char      name[20];
    char *    char_no_arg;
    char *    others_no_arg;
    char *    char_found;
    char *    others_found;
    char *    vict_found;
    char *    char_not_found;
    char *      char_auto;
    char *      others_auto;
};

struct hate_data
{
	char *		name;
	CHAR_DATA *	who;
};

struct auction_data
{
	AUCTION_DATA *next;
	OBJ_DATA *	item;
	CHAR_DATA *	owner;
	CHAR_DATA *	high_bidder;
	int		status;
	long		current_bid;
	long		gold_held;
	long		min_bid;
	bool		valid;
};

struct l_board
{
   char *pk_name;
   int pk_number;
   char *pd_name;
   int pd_number;
   char *tt_name;
   int tt_number;
   char *qc_name;
   int qc_number;
   char *mk_name;
   int mk_number;
   char *md_name;
   int md_number;
   char *bestpk_name;
   int bestpk_number;
   char *rb_name;
   int rb_number;
};

struct   battle_data
  {
  int  level1;
  int   level2;
  bool  open;
  bool running;
  };
struct   tourney_data
{
	int   level1;
	int   level2;
	bool  open;
	bool  running;
	int   timer;
	int status; /* 1 = idle, 2 = waiting, 3 = running */
	char *tclass; /* Beginner, Warrior, Veteran, Champion, Destroyer, Slayer, N'Dore Mordero */
	int lastclass; /* 1 = Beginner, 2 = Warrior, 3 = Veteran, 4 = Champion, 5 = Destroyer, 6 = Slayer, 7 = N'Dore Mordero */
};
struct  trivia_data
{
	bool   running;
	char  *question;
	char  *answer;
	int reward;
	int qnumber;
	int timer;
};
struct  faire_data
{
	bool open;
	char *location;
};
struct raffle_data
{
	bool running;
	OBJ_DATA *obj;
	int ticket_cost;
	int ticket_number;
	int total_tickets;
};
struct  invade_data
{
	bool running;
	char *location;
	char *invader;
};
struct gevent_data
{
	bool running;     /* is the event running? */
	char * name;      /* name of the gevent */
	char * cname;     /* color name of the gevent */
	long loc;          /* vnum location of event set when started */
	int num;       /* number of event for easy identifying */
	int power;     /* 1 2 3 for shadows embrace gevent */
	int timer;     /* how long is/has it been running */
	int runtime;   /* the time it is supposed to run for */
};
