/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

struct non_safe_areas_type
{
        char * filename;
};

struct gevent_type
{
	sh_int num;       /* number of the gevent */
	char * name;      /* name of the gevent */
	char * cname;     /* color name of the gevent */
	sh_int deftime;   /* default run time */
	char * descr;     /* generic description of the event */
	char * longd;     /* long description, shown when event starts */
	char * immopt;    /* immortal options, shown in gevent help */
	bool   working;   /* if it doesn't work don't let it run. */
	int    cost;	  /* What's it cost for mortals to buy? */
	bool   morts;	  /* Can morts run this? */
};

struct  material_type
{
	char          * name;
	sh_int          definition;
	sh_int          density;
	int             value;
	sh_int          weapon;
	sh_int          pierce;
	sh_int          bash;
	sh_int          slash;
	sh_int          weaves;
	sh_int          maxAff;
};

struct flag_type
{
    char *name;
    int bit;
    bool settable;
};

struct craftcolors_type
{
	char *name;
	char *colorname;
};

struct craftadorn_type
{
	char *name;
	char *allowed;
	char *suffix;
};

#define ADORNRAND_NONE		0
#define ADORNRAND_ANY		1
#define ADORNRAND_FLOWER	2
#define ADORNRAND_TREASURE	3
#define ADORNRAND_GEM		4
#define ADORNRAND_BEAST		5
#define ADORNRAND_BIRD		6




struct randadorn_type
{
	char	*name;
	char	*color;
	int	type;
	int	dye;
};

/*
struct clan_type
{
    char 	*name;
    char 	*who_name;
    int 	hall;
    bool	independent;
    int  rec_room;
    sh_int  *guild_skill;
    int  related_to;
};
*/
struct position_type
{
    char *name;
    char *short_name;
};

/* For tabac - Dalsor
struct pipe_type
{
	bool    packed;
	bool    tamped;
	bool    lit;
};

struct tabac_type
{
	bool    burn;
	bool    chew;
}

End code for tabac */

struct sex_type
{
    char *name;
};

struct size_type
{
    char *name;
};

struct	bit_type
{
	const	struct	flag_type *	table;
	char *				help;
};

struct race_invade_type
{
    char *name;		/* Name of the invading group */
    int  min;		/* Min number of attackers group will field */
    int  max;		/* Max number of attackers group will field */
    char *log_name;     /* Name for log file and wiznet */
};

struct town_invade_type
{
    char *name;		/* Name of the town */
    int  min_vnum;	/* Min room VNUM in the town */
    int  max_vnum;	/* Max room VNUM in the town */
    char *enemy1;	/* name of the first enemy that can invade */
    char *enemy2;	/* name of second enemy that can invade that town */
    char *enemy3;	/* name of third enemy that can invade */
    char *enemy4;	/* name of fourth enemy that can invade */
    char *enemy5;	/* name of fifth enemy that can invade */
};

struct invader_type
{
    char *group;	/* Invasion group */
    int  vnum;		/* VNUM of mob */
    int  max;		/* maximum number of this mob allowed in invasion */
};

struct room_invade_type
{
    char *town;		/* Name of the town the room is in */
    int  vnum;		/* VNUM of the room that can't be invaded */
};

/* invade tables */
extern  const   struct  race_invade_type race_invade_table[];
extern  const   struct  town_invade_type town_invade_table[];
extern  const   struct  invader_type  invader_table[];
extern  const	struct	room_invade_type room_invade_table[];
extern const struct	craftcolors_type craftcolors_table[];
extern const struct	craftadorn_type craftadorn_table[];
extern const struct	randadorn_type adorn_prefix_table[];
extern const struct	randadorn_type adorn_suffix_table[];

/* game tables */
/*extern	const	struct	clan_type	clan_table[MAX_CLAN];*/
extern	const	struct	position_type	position_table[];
extern	const	struct	material_type	material_table[];
extern	const	struct	sex_type	sex_table[];
extern	const	struct	size_type	size_table[];
/* extern  const   struct  tabac_type  tabac_table[]; */
/* flag tables */
extern	const	struct	flag_type	act_flags[];
extern	const	struct	flag_type	op_flags[];
extern	const	struct	flag_type	auto_flags[];
extern	const	struct	flag_type	ajah_flags[];
extern	const	struct	flag_type	spec_flags[];
extern	const	struct	flag_type	hist_flags[];
extern	const	struct	flag_type	tabac_flags[];
extern	const	struct	flag_type	war_flags[];
extern	const	struct	flag_type	penalty_flags[];
extern	const	struct	flag_type	plr_flags[];
extern	const	struct	flag_type	affect_flags[];
extern	const	struct	flag_type	affect2_flags[];
extern	const	struct	flag_type	off_flags[];
extern	const	struct	flag_type	imm_flags[];
extern	const	struct	flag_type	form_flags[];
extern	const	struct	flag_type	part_flags[];
extern	const	struct	flag_type	comm_flags[];
extern	const	struct	flag_type	extra_flags[];
extern	const	struct	flag_type	wear_flags[];
extern	const	struct	flag_type	weapon_flags[];
extern	const	struct	flag_type	container_flags[];
extern	const	struct	flag_type	portal_flags[];
extern	const	struct	flag_type	room_flags[];
extern	const	struct	flag_type	exit_flags[];
extern 	const	struct  flag_type	mprog_flags[];
extern	const	struct	flag_type	area_flags[];
extern	const	struct	flag_type	sector_flags[];
extern	const	struct	flag_type	door_resets[];
extern	const	struct	flag_type	wear_loc_strings[];
extern	const	struct	flag_type	wear_loc_flags[];
extern	const	struct	flag_type	res_flags[];
extern	const	struct	flag_type	imm_flags[];
extern	const	struct	flag_type	vuln_flags[];
extern	const	struct	flag_type	type_flags[];
extern	const	struct	flag_type	apply_flags[];
extern	const	struct	flag_type	sex_flags[];
extern	const	struct	flag_type	furniture_flags[];
extern  const   struct  flag_type   trigger_flags[];
extern  const   struct  flag_type   trigger_action_flags[];
extern	const	struct	flag_type	weapon_class[];
extern	const	struct	flag_type	apply_types[];
extern	const	struct	flag_type	weapon_type2[];
extern	const	struct	flag_type	apply_types[];
extern	const	struct	flag_type	size_flags[];
extern	const	struct	flag_type	herb_flags[];
extern	const	struct	flag_type	craftskill_flags[];
extern	const	struct	flag_type	craftpadj_flags[];
extern	const	struct	flag_type	position_flags[];
extern	const	struct	flag_type	ac_type[];
extern	const	struct	bit_type	bitvector_type[];
extern	const	struct	flag_type	oprog_flags[];
extern	const	struct	flag_type	rprog_flags[];
extern  const   struct  flag_type	guild_flags[];
extern  const   struct  flag_type	talent_flags[];
extern  const   struct  weave_talents_type	weave_talents_table[];
extern  const   struct  gevent_type gevent_table[];
extern  const   struct  non_safe_areas_type non_safe_areas_table[];

