/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/
struct rbi_type
{
	char *letter; /* letter shown in who */
	char *mTitle; /* male title */
	char *fTitle; /* female title */
	char *tClr;   /* tier color */
};

struct seeing_guild_type
{
	char *gName; /*guild name */
	char *tName; /* true name */
	char *symbol;
	char *mlSymbol;
};

struct seeing_city_type
{
	char *name;
	char *symbol;
};



extern const struct seeing_guild_type seeing_guild_table[];
extern const struct seeing_city_type seeing_city_table[];
const struct rbi_type rbi_table[];

const   struct  rbi_type rbi_table [] =
{
    { NULL, NULL, NULL, NULL },

    { "Y", "{YYo{Wu{Yng{x", "{YYo{Wu{Yng{x", "{y"},
    { "A", "{GAd{yv{ge{Gn{Yt{gu{Gr{ye{Gr{x", "{GAd{yv{ge{Gn{Yt{gu{Gr{ye{Gr{x", "{G"},
    { "J", "{bJ{go{Bu{gr{bn{Be{gy{bm{Ba{gn{x", "{bJ{go{Bu{gr{bn{Be{gy{bw{Bo{gm{ba{gn{x", "{b"},
    { "V", "{YV{ye{Bt{Ye{Br{ya{Yn{x", "{YV{ye{Bt{Ye{Br{ya{Yn{x", "{Y"},
    { "M", "{rM{Ra{Ys{Rt{re{Rr{x", "{rM{Ri{Ys{Rt{rr{Ye{rs{Rs{x", "{r"},
    { "C", "{CC{rh{cam{rp{ci{ro{Cn{x", "{CC{rh{cam{rp{ci{ro{Cn{x", "{Y"},
    { "D", "{DD{re{Rs{Dtr{Ro{ry{Der{x", "{DD{re{Rs{Dtr{Ro{ry{Der{x", "{D"},
    { "G", "{RG{rr{Dan{Rd{rm{Das{rte{Rr{x", "{RG{rr{Dan{Rd{rm{Dis{rt{Rr{De{rs{Rs{x", "{R" },
    { "C", "{mCo{Dn{mqu{Der{mor{x ", "{mCo{Dn{mqu{Der{mes{Ds{x", "{m"},
    { "L", "{GL{De{gg{De{Gn{Dd{ga{Dr{gy{x", "{GL{De{gg{De{Gn{Dd{ga{Dr{gy{x", "{W" },
};


/* Old Rebirth Title Table - preserving it just in case - Kerrick
const   struct  rbi_type rbi_table [] =
{
	{ NULL, NULL, NULL,
		{ NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
	},
	{ "Y", "Young", "Young",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "A", "Adventurer", "Adventurer",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "J", "Journeyman", "Journeywoman",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "N", "Neophyte", "Neophyte",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "B", "Brave", "Brave",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "K", "Known", "Knowm",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "D", "Diligent", "Diligent",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "Z", "Zealous", "Zealous",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "V", "Veteran", "Veteran",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "E", "Enduring", "Enduring",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "F", "Fierce", "Fierce",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "P", "Prodigy", "Prodigy",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "R", "Revered", "Revered",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "M", "Master", "Mistress",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "Q", "Queller", "Queller",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "G", "Grandmaster", "Grandmistress",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "C", "Champion", "Champion",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "H", "Hero", "Heroine",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "W", "Wizened", "Wizened",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "X", "eXalted", "eXalted",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "L", "Legend", "Legend",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "S", "Supreme", "Supreme",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "O", "Overlord", "Overlord",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "U", "Ultimate", "Ultimate",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
	{ "T", "Taveren", "Taveren",
	  { "{y", "{Y", "{G", "{g", "{B", "{b", "{M", "{m", "{R", "{r" },
	},
};*/

const   struct  seeing_city_type seeing_city_table [] =
{
	{ "andor", "Rampant White Lion" },
	{ "amador", "Red Thistle over a Silver Six-Pointed Star" },
	{ "illian", "Nine Golden Bees Arranged in a Diamond" },
	{ "shienar", "Swooping Black Hawk" },
	{ "domani", "Silver Hand Grasping a Silver Sword" },
	{ "aiel", "Spear over a Blazing Sun" },
	{ "ogier", "Trefoil Leaf" },
	{ "tairen", "Three Silver Crescent Moons" },
	{ "cairhien", "Many Rayed Golden Sun Rising" },
	{ "tuathaan", "Multi-Colored Wagon" },
	{ "seanchan", "Golden Hawk Clutching Three Lightning Bolts" },
	{ "altara", "Two Golden Leopards" },
	{ "trolloc", "Fist Clenhing a Burning Spear" },
	{ "arafel", "Three Red Roses and Three White Roses" },
	{ "tarabon", "Golden Tree" },
	{ "kandor", "Rearing Red Horse" },
	{ "mayene", "Golden Hawk in Flight" },
	{ "tworiver", "Tabac Leaf" },
	{ "malkier", "Golden Crane" },
	{ "nym", "Climbing Vines" },
	{ "grayman", "Reaching Shadows" },
	{ "ghealdan", "Three Silver Stars" },
	{ "murandy", "Red Bull" },
	{ "saldaea", "Three Silver Fish" },
	{ "tarvalon", "Flame in a Swirl of Seven Colors" },
	{ "seafolk", "Ship Cresting a Tall Wave" },
	/* 26 */
};

const   struct  seeing_guild_type seeing_guild_table [] =
{
/*0 */{ "", "", NULL, NULL },

/*1 */{ "loner",        "{wLoner",
        NULL,
        NULL },

/*2 */{ "implementor",  "{rImplementor",
        NULL,
        NULL },

/*3 */{ "blackajah",    "{BB{black {WA{wjah{x",
        "Silver Raven with a Broken Rod at it's Crest",
        NULL },

/*4 */{ "darkwarder",   "{BD{bark {WW{warder{x",
        "Silver Raven with Two Swords above its Head",
        NULL },

/*5 */{ "seafolk",      "{GS{ge{Ba {GF{go{Bl{Gk{x",
        NULL, NULL },

/*6 */{ "warder",       "{WW{wa{Wrd{we{Wr",
        NULL, NULL },

/*7 */{ "towerguard",   "{wT{Wo{ww{We{wr {WG{Wu{wa{Wr{wd",
        NULL, NULL },

/*8 */{"aessedai",     "{yAe{ws {WSe{wd{yai",
       "Ivory Teardrop Flame",
       "Scroll Encircled by a Serpentine Ring" },

/*9 */{"youngling",    "{WY{wo{gungli{wn{Wg",
        NULL,
        NULL },

/*10*/{"blightguard",  "{yBl{Yig{WhtG{Yua{yrd",
        "Black Hawk with Three Red Slashes",
        "Shield Painted with a Wall" },

/*11*/{"band",         "{rBan{RdRedH{rand",
        NULL,
        NULL },

/*12*/{"thieftaker",   "{rTh{Rie{yf T{Rak{rer",
        NULL,
        NULL },

/*13*/{"gleeman",      "{aG{bl{ce{de{em{fa{gn",
        "Golden Horn on a Field of Purple",
        NULL },

/*14*/{"children",     "{WWhitecloak",
        "Bright Sunburst",
        "Gauntleted Fist over a Bright Sunburst" },

/*15*/{ "queensguard",  "{RQu{re{We{wnsG{Wu{ra{Rrd",
        "Eagle with a Sword in its Talons",
        NULL },

/*16*/{ "defender",     "{cD{Cef{wen{Cde{cr",
        NULL,
        NULL },

/*17*/{ "ashaman",      "{rAsha{R'{rman",
        "Sword and Serpent",
        "Sword over Two Twisted Flames" },

/*18*/{ "companion",    "{bCo{Bmp{Ca{Bni{bon   ",
        NULL,
        NULL },

/*19*/{ "kin",          "{yKi{Yndr{yed     ",
        "Hand Clutching a Sprig of Andilay",
        "Two Hands Clasped Encircled by a Golden Ring" },

/*20*/{ "darkfriend",   "{BDar{bkfri{Bend  ",
        "Black Serpent Wrapped around a Sword",
        NULL },

/*21*/{ "dreadlord",    "{BDre{badl{Bord   ",
        "Black Flame with Two Roses at the Base of the Fire",
        NULL },

/*22*/{ "dragonsworn",  "{yDr{Ya{wgonS{Ywo{yrn ",
        "Gold Serpent Perched on a Sword Hilt",
        NULL },

/*23*/{ "wiseone",      "{YWi{ys{we{Y O{yn{we",
        "Two Spears Crossed",
        NULL },

/*24*/{ "blackeye",     "{bBl{Bac{Ck{b Ey{Be{Cs  ",
        "Black Eyes Divided by a Spear",
        NULL },

/*25*/{ "spearmaiden",  "{bS{Bp{we{War{bM{Ba{wi{Wden ",
        "Veiled Woman with a Spear Uplifted",
        NULL },

/*26*/{ "eaglebrother", "{cE{Ca{Bg{ble{cBr{Co{Bt{bhr ",
        "Eagle with Wings Conjoined",
        NULL },

/*27*/{ "dawnrunner",   "{WDa{yw{Yn{W Ru{ynn{Yer ",
        "Winged Boot Crossed by Rays of Light",
        NULL },

/*28*/{ "knifehand",    "{WK{wni{Wfe H{wan{Wd  ",
        "Knife and Spear Crossing a Hand Palm Forward",
        NULL },

/*29*/{ "mountaindancer","{YMou{yntDan{Ycer ",
        "Mountain Peak Crossed by a Spear",
        NULL },

/*30*/{ "nightspears",  "{BNight{b Spear ",
        "Crescent Moon Crossed by a Spear",
        NULL },

/*31*/{ "redshield",    "{RRed{r Shield  ",
        "Red Shield Crossed with a Spear",
        NULL },

/*32*/{ "stonedog",     "{MStone{m Dog   ",
        "Veiled Man Riding a Fire Eyed Hound",
        NULL },

/*33*/{ "thunderwalker","{mThunder{MWalk ",
        "Thunder Bolt Crossed by a Spear",
        NULL },

/*34*/{ "trueblood",    "{rTru{Re Bl{rood  ",
        "Bleeding Fist Crossed by a Spear",
        NULL },

/*35*/{ "waterseeker",  "{wWat{Wer{wSeek{Wer ",
        "Circle of Water Ringing a Spear",
        NULL },

/*36*/{ "treebrother",  "{gTr{Gee{gBro{Gther ",
        NULL,
        NULL },

/*37*/{ "treesister",    "{gTr{Gee{gSis{Gter  ",
        NULL,
        NULL },

/*38*/{ "stump",         "{yThe{Y St{yump   ",
        NULL,
        NULL },

/*39*/{ "ahffrait",      "{rA{Rhf'frait   ",
        NULL,
        NULL },

/*40*/{ "alghol",        "{rA{Rl'ghol     ",
        NULL,
        NULL },

/*41*/{ "bahnsheen",     "{rB{Rahn'sheen  ",
        NULL,
        NULL },

/*42*/{ "dhavol",        "{rD{Rha'vol     ",
        NULL,
        NULL },

/*43*/{ "dhaimon",       "{rD{Rhai'mon    ",
        NULL,
        NULL },

/*44*/{ "dhjinnen",      "{rD{Rhjin'nen   ",
        NULL,
        NULL },

/*45*/{ "gharghael",     "{rG{Rhar'ghael  ",
        NULL,
        NULL },

/*46*/{ "ghobhlin",      "{rG{Rhob'hlin   ",
        NULL,
        NULL },

/*47*/{ "ghohlem",       "{rG{Rho'hlem    ",
        NULL,
        NULL },

/*48*/{ "ghraemlan",     "{rG{Rhraem'lan  ",
        NULL,
        NULL },

/*49*/{ "kobal",         "{rK{Ro'bal      ",
        NULL,
        NULL },

/*50*/{ "knomon",        "{rK{Rno'mon     ",
        NULL,
        NULL },

/*51*/{ "manetheren",    "Manetheren  ",
        "Red Eagle Soaring over a River",
        "Red Eagle Clutching Sword and Axe" },

/*52*/{ "empress",       "{gT{Gh{we {gE{Gmp{wress ",
        NULL,
        NULL },

/*53*/{ "blood",         "{RT{rh{Re {RBl{roo{Rd   ",
        NULL,
        NULL },

/*54*/{ "deathwatch",    "{rD{Rea{wt{Whw{wa{Rtc{rh  ",
        NULL,
        NULL },

/*55*/{ "highlord",      "High Lord   ",
        NULL,
        NULL },

/*56*/{ "highlady",      "High Lady   ",
        NULL,
        NULL },

/*57*/{ "sojhin",        "So'jhin     ",
        NULL,
        NULL },

/*58*/{ "moratraken",    "Morat'raken ",
        NULL,
        NULL },

/*59*/{ "moratgrolm",    "Morat'grolm ",
        NULL,
        NULL },

/*60*/{ "moratsredit",   "Morat'sredit",
        NULL,
        NULL },

/*61*/{ "morattorm",     "Morat'torm  ",
        NULL,
        NULL },

/*62*/{ "moratlopar",    "Morat'lopar ",
        NULL,
        NULL },

/*63*/{ "clanchief",     "{YC{ylan {YC{yhief  ",
        NULL,
        NULL },

/*64*/{ "chafaile",      "{MC{Ch{ca {WFa{ci{Cl{Me   ",
        "Golden Falcon",
        "Golden Falcon in Flight" },

/*65*/{ "forsaken", 	    "{CF{co{Br{bsa{Bk{ce{Cn{w    ",
        "A Broken Wheel with Seven Spokes on Fire",
        NULL },

/*66*/{ "oathtaker",     "{WO{wat{RhTa{wke{Wr{w   ",
        NULL,
        NULL },

/*67*/{ "hailene",       "{RHa{wi{Wl{we{Rne{w     ",
        NULL,
        NULL },

/*68*/{ "illuminator",   "{WIlluminator{w",
        "Bright Flashes of Light",
        "Fan of Colored Flashes of Light" },

/*69*/{ "wingedguard",   "{WWinged Guard{w",
        "Gold Hawk Clutching a Lance",
        "Gold Hawk over a Red Painted Breastplate" },

/*70*/{ "malkieriknight","{WMalkieri Knight{w",
        "Seven Towers",
        "Golden Crane in Flight over Seven Towers" },

/*71*/{ "tuathaan","{yT{Gi{Bn{Wk{Ge{yr{w",
        "Falling Leaf",
        "Leaf Falling into an Open Palm" },

/*72*/{ "aiel","{WThe Spear{w",
        "Upright Spear",
        "An Upright Spear Wrapped with a Black Veil" }
};
