/*This is Translation.h, which contains the table for do_translation
in act_comm.c*/

struct translation_type
{
	char *otword;
	char *engword;
};

/*Now I'm not claiming that the translations are perfectly correct,
but they should be pretty close. Used:

http://www.princeton.edu/~abergman/jordan/cot.html

For my reference.*/

/*This goes in translation.h*/
const struct translation_type translation_table [] =
{
	{"a'dam", "the leash"},
	{"a'vron", "watcher"},
	{"aan", "one"},
	{"aan'allein", "one man"},
	{"aes sedai", "servants to all"},
	{"aesdaishar", "glory to all"},
	{"aethan", "shield"},
	{"aiel", "dedicated"},
	{"ain", "is"},
	{"al'cair", "the golden"},
	{"algai'd'siswai", "the fighters of the spear"},
	{"alantin", "brother"},
	{"alcair", "the golden"},
	{"aldazar", "the eagle"},
	{"aldieb", "westwind"},
	{"algode", "cotton"},
	{"alin", "west"},
	{"allein", "man"},
	{"allen", "hill"},
	{"aman", "dragon"},
	{"asa", "you"},
	{"asha'man", "guardians (sword blade)"},
	{"ashan", "sword"},
	{"aso", "it"},
	{"atha", "person"},
	{"aven", "call"},
	{"avende", "tree"},
	{"avendesora", "the Tree of Life"},
	{"ayende", "freedom"},
	{"bekkar", "blood"},
	{"ca'lyet", "do come"},
	{"cab", "free"},
	{"caba", "horse"},
	{"caba'donde", "a horse to ride"},
	{"caba'drin", "horsemen or calvary"},
	{"caballein", "free man"},
	{"cadin", "clothes"},
	{"cadin'sor", "working clothes"},
	{"cair", "golden"},
	{"cal", "red"},
	{"caldazar", "red eagle"},
	{"calhar", "red hand"},
	{"calichniye", "welcome"},
	{"car", "chief"},
	{"car'a'carn", "Chief of Chiefs"},
	{"carai", "honor"},
	{"carn", "chiefs"},
	{"chalinda", "sweet girl"},
	{"con", "banner"},
	{"concion", "summons"},
	{"cour", "trap"},
	{"cour'souvra", "mindtrap"},
	{"cor", "night"},
	{"corenne", "return"},
	{"cova", "owner"},
	{"cue", "heart"},
	{"cuebiyar", "heart"},
	{"cuendillar", "heartstone"},
	{"d", "of"},
	{"da'covale", "one who is owned"},
	{"da'es", "great"},
	{"da'shain", "true peace"},
	{"da'tsang", "despised one"},
	{"daemar", "game"},
	{"daghain", "fear"},
	{"dai", "battle"},
	{"daishar", "glory"},
	{"dal", "bowl"},
	{"dam", "leash"},
	{"damane", "leashed one"},
	{"dar", "sister"},
	{"darei", "spear"},
	{"dareis", "spears"},
	{"dazar", "eagle"},
	{"deveniye", "majesty"},
	{"dieb", "wind"},
	{"din", "brother"},
	{"diynen", "sounder"},
	{"diynen'd'ma'purvene", "Sounder of the Horn"},
	{"do", "over"},
	{"domashita", "warms"},
	{"domorakoshi", "language"},
	{"donde", "to ride"},
	{"dor", "red"},
	{"dore", "dancer"},
	{"dovie'andi", "dice"},
	{"dovienya", "luck"},
	{"drelle", "river of"},
	{"drin", "soldier"},
	{"duadhe", "water"},
	{"duente", "holds"},
	{"dyo", "by"},
	{"e", "and"},
	{"ellisande", "rose of the sun"},
	{"faile", "falcon"},
	{"far", "of"},
	{"ga", "is"},
	{"gai", "battle"},
	{"gai'shain", "pledged to peace in battle"},
	{"gaidin", "battle brother (Warder)"},
	{"govane", "what"},
	{"hailene", "forerunners"},
	{"hame", "mountain"},
	{"har", "hand"},
	{"haran", "hand of"},
	{"hei", "always"},
	{"inde", "no/not"},
	{"iro", "we"},
	{"isain", "is"},
	{"isainde", "isn't"},
	{"isha", "betrayer"},
	{"ishamael", "betrayer of hope"},
	{"jeade'en", "true finder"},
	{"jenn", "true/truly"},
	{"ji", "honor"},
	{"kiserai", "glory"},
	{"kjasic", "expletive"},
	{"kodome", "here"},
	{"lanfear", "daughter of the night"},
	{"logoth", "waiting"},
	{"los", "forward"},
	{"m'hael", "leader"},
	{"m'taal", "dogs"},
	{"ma", "the"},
	{"ma'vron", "watchers over the sea"},
	{"machin shin", "black wind"},
	{"mael", "hope"},
	{"mahdi", "seeker"},
	{"mahdi'in", "seekers"},
	{"mai", "maidens"},
	{"mandarb", "blade"},
	{"manshima", "sword"},
	{"marath", "those who must"},
	{"marath'damane", "those who must be leashed"},
	{"mashiara", "a love lost"},
	{"mera", "nothing"},
	{"mera'din", "brotherless"},
	{"mi", "my"},
	{"mia", "my"},
	{"mia'cova", "my owner"},
	{"miere", "ocean"},
	{"misain", "am"},
	{"moghedien", "spider"},
	{"morat", "handler"},
	{"mordero", "death"},
	{"morridin", "grave"},
	{"m'taal", "stone"},
	{"muad", "foot"},
	{"muad'drin", "foot soldier"},
	{"muaghde", "meat"},
	{"n'dore", "dancers"},
	{"nar'baha", "fool box"},
	{"nei", "knife"},
	{"niende", "lost"},
	{"ninte", "your"},
	{"ninto", "your"},
	{"no", "me"},
	{"nosane", "speak"},
	{"nosandi", "advisor"},
	{"oosquai", "whiskey"},
	{"ordeith", "wormwod"},
	{"osen", "east"},
	{"pas", "none"},
	{"purvene", "horn"},
	{"rahien", "dawn"},
	{"rhyagelle", "those who come home"},
	{"sa", "in"},
	{"sa'sara", "dance"},
	{"sag", "time"},
	{"sagain", "it's time"},
	{"sai", "power"},
	{"saidar", "sister power"},
	{"saidin", "brother power"},
	{"sam", "destroyer"},
	{"sammael", "destroyer of hope"},
	{"sar", "she"},
	{"sara", "dance"},
	{"se", "themselves"},
	{"segade", "cactus"},
	{"serenla", "stubborn daughter"},
	{"shaidar", "dark"},
	{"shadar", "shadow"},
	{"shae", "dog"},
	{"shae'en", "dogs"},
	{"shaiel", "she who is dedicated"},
	{"shain", "peace"},
	{"shambayan", "chamberlain"},
	{"shan", "lord"},
	{"shar", "blood"},
	{"shari", "bloods"},
	{"shatayan", "chatelaine"},
	{"shen", "band"},
	{"shoufa", "dustveil"},
	{"sin", "he"},
	{"siswai", "spear"},
	{"siswai'aman", "spear of the dragon"},
	{"sora", "life"},
	{"sor", "working"},
	{"sorda", "rat"},
	{"sorei", "runners"},
	{"sovin", "hands"},
	{"souvra", "mind"},
	{"souvraya", "my own mind"},
	{"sovya", "another"},
	{"sul", "holder"},
	{"sul'dam", "leash holder"},
	{"sursa", "chopsticks"},
	{"t'mat", "tomato"},
	{"ta'maral'ailen", "web of destiny"},
	{"ta'veren", "focal point of patern"},
	{"tai", "true"},
	{"tai'shar", "true blood"},
	{"tarmon", "last"},
	{"tel'aran'rhiod", "world of dreams"},
	{"ti", "to"},
	{"tia", "to"},
	{"toh", "duty"},
	{"tovya", "roll"},
	{"tsag", "expletive"},
	{"tsang", "hated one"},
	{"tsorovan", "storm"},
	{"tuatha'an", "traveling people"},
	{"vadin", "barrier"},
	{"val", "guard"},
	{"valdon", "that guards"},
	{"vron", "watcher"},
	{"wansho", "builder"},
	{"ya", "my own"},
	{"ye", "I"},
	{"zemai", "corn"},
	{NULL, NULL}
};
