/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************
		   IRC Style Chat by Raelik
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <string.h>
#include "irc.h"
#include "recycle.h"
#include "tables.h"

IRC_DATA * first_irc;
IRC_DATA * last_irc;


/* I was still a little unclear if this was in or not, needed it anyway for testing */

/*bool IS_MODERATOR(CHAR_DATA *ch )
{
 if (IS_SET(ch->war_flags, WAR_MODERATOR))
   return TRUE;

 return FALSE;
}*/

/* I dont know if TSE has this or not, this rom i have only seems to have get_char_room and get_char_world
   which require a ch to check if can_see victim before returning victim's data.... what happens if you dont have a ch? */

CHAR_DATA *get_char( char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *wch;
    int number;
    int count;

    number = number_argument( argument, arg );
    count  = 0;
    for ( wch = char_list; wch != NULL ; wch = wch->next )
    {
	if ( !is_name( arg, wch->name ) )
	    continue;
	if ( ++count == number )
	    return wch;
    }
    return NULL;
}

IRC_DATA * get_irc_data_exact( char *argument)
{
  IRC_DATA *room;

  for( room = first_irc; room != NULL; room = room->next )
   if (is_exact_name( argument, room->name ))
    return room;

  return NULL;
}

IRC_DATA * get_irc_data( char *argument)
{
  IRC_DATA *room;

  for( room = first_irc; room != NULL; room = room->next )
   if (is_exact_name( argument, room->name ))
    return room;

  return NULL;
}

IRC_MEM_DATA * get_irc_member_data( CHAR_DATA *ch, IRC_DATA *room)
{
  IRC_MEM_DATA *member;

  for( member = room->first_member; member != NULL; member = member->next )
   if( !str_cmp( member->name, ch->name))
    return member;

 return NULL;
}
void rem_irc args(( IRC_MEM_DATA *member, IRC_DATA *room));

void clear_irc( CHAR_DATA *ch )
{
  IRC_DATA *room;
  IRC_MEM_DATA *member;

  for( room = first_irc; room != NULL; room = room->next )
   for( member = room->first_member; member != NULL; member = member->next )
    if( !str_cmp( ch->name, member->name))
     rem_irc( member, room );

  return;
}

void add_invite( CHAR_DATA *ch, IRC_DATA *room)
{
  IRC_INV_DATA *inv;

  inv 		     = alloc_perm( sizeof(*inv) );
  inv->name	     = str_dup(ch->name);

  if( room->first_inv == NULL )
   {
    room->first_inv = inv;
    room->first_inv->prev = NULL;
    }
  if( room->last_inv != NULL )
   {
    room->last_inv->next = inv;
    inv->prev = room->last_inv;
   }

  room->last_inv = inv;
  inv->next = NULL;
 return;
}

IRC_INV_DATA *	free_irc_inv;

void rem_inv( IRC_DATA *room, char *argument)
{
  IRC_INV_DATA *inv;

  for(inv = room->first_inv; inv != NULL; inv = inv->next)
   if (!str_cmp(inv->name, argument))
    break;

  if( !inv->prev )
   room->first_inv = inv->next;
  else
   inv->prev->next = inv->next;

  if( !inv->next )
   room->last_inv = inv->prev;
  else
   inv->next->prev = inv->prev;

  inv->next = free_irc_inv;
  inv->prev = free_irc_inv;
  free_string(inv->name);

 return;
}

void add_ban( IRC_DATA *room, char *argument)
{
  IRC_BAN_DATA *ban;

  ban 		     = alloc_perm( sizeof(*room) );
  ban->name	     = str_dup(argument);

  if( room->first_ban == NULL )
   {
    room->first_ban = ban;
    ban->prev = NULL;
    }
  if( room->last_ban != NULL )
   {
    room->last_ban->next = ban;
    ban->prev = room->last_ban;
   }

  room->last_ban = ban;
  ban->next = NULL;
 return;
}

IRC_BAN_DATA * free_irc_ban;

void rem_ban( IRC_DATA *room, char *argument)
{
  IRC_BAN_DATA *ban;

  for(ban = room->first_ban; ban != NULL; ban = ban->next)
   if (!str_cmp(ban->name, argument))
    break;

  if( !ban->prev )
   room->first_ban = ban->next;
  else
   ban->prev->next = ban->next;

  if( !ban->next )
   room->last_ban = ban->prev;
  else
   ban->next->prev = ban->prev;

  ban->next = free_irc_ban;
  ban->prev = free_irc_ban;
  free_string(ban->name);

 return;
}

void create_irc(CHAR_DATA *ch, char *argument)
{
  IRC_DATA *room;

  room 		     = alloc_perm( sizeof(*room) );
  room->name	     = str_dup( argument );
  room->creator      = str_dup( ch->name );
  room->topic        = str_dup( "Not Set");
  room->num	     = 0;
  room->privat      = FALSE;
  room->first_ban    = NULL;
  room->first_member = NULL;
  room->first_inv    = NULL;

  if( first_irc == NULL )
   {
    first_irc = room;
    room->prev = NULL;
    }
  if( last_irc != NULL )
   {
    last_irc->next = room;
    room->prev = last_irc;
   }

  last_irc = room;
  room->next = NULL;
  room->color = str_dup("w");
}

IRC_DATA *free_irc;

void close_irc( IRC_DATA *room )
{
  IRC_MEM_DATA *member;
  IRC_BAN_DATA *ban;
  IRC_INV_DATA *inv;

  for( ban = room->first_ban; ban != NULL; ban = ban->next)
   rem_ban( room, ban->name );
  for( member = room->first_member; member != NULL; member = member->next)
   rem_irc( member, room);
  for( inv = room->first_inv; inv != NULL; inv = inv->next)
   rem_inv( room, inv->name );

  if(!room->prev)
   first_irc = room->next;
  else
   room->prev->next = room->next;
  if(!room->next)
   last_irc = room->prev;
  else
   room->next->prev = room->prev;

   room->next = free_irc;
   room->prev = free_irc;
   room->privat = FALSE;
   room->num = 0;
   free_string(room->creator);
   free_string(room->topic);
   free_string(room->name);
   free_string(room->color);

  return;
}

void add_irc( CHAR_DATA *ch, IRC_DATA *room)
{

  IRC_MEM_DATA  *member;

  member 	     = alloc_perm( sizeof(*member) );   /* sizeof(*member) ??? ... looks like i wont be usin much memory :P */
  member->name	     = str_dup(ch->name);
  member->mod        = FALSE;

  if( room->first_member == NULL )
   {
    room->first_member = member;
    member->prev = NULL;
    }
  if( room->last_member != NULL )
   {
    room->last_member->next = member;
    member->prev = room->last_member;
   }

  room->last_member = member;
  member->next = NULL;
  room->num++;
 return;
}

IRC_MEM_DATA *free_member;

void rem_irc( IRC_MEM_DATA *member, IRC_DATA *room)
{
  if( !member->prev )
   room->first_member = member->next;
  else
   member->prev->next = member->next;

  if( !member->next )
   room->last_member = member->prev;
  else
   member->next->prev = member->prev;

  member->next = free_member;
  member->prev = free_member;
  member->mod = FALSE;
  free_string(member->name);

  room->num--;
  if (room->num <= 0)
   close_irc(room);
  return;
}

bool IS_IRC_MOD(IRC_MEM_DATA *member, IRC_DATA *room)
{

 if( !str_cmp(member->name, room->creator))
  return TRUE;

 if( member->mod )
  return TRUE;

 return FALSE;
}

bool IS_INVITED(CHAR_DATA *ch, IRC_DATA *room)
{
 IRC_INV_DATA *inv;

 if( IS_MODERATOR(ch))
  return TRUE;

 for( inv = room->first_inv; inv != NULL; inv = inv->next )
  if (inv && !str_cmp( inv->name, ch->name ))
   return TRUE;

 return FALSE;
}

bool IS_BANNED(CHAR_DATA *ch, IRC_DATA *room)
{
 IRC_BAN_DATA *ban;

 if( IS_MODERATOR(ch))
  return FALSE;

 for( ban = room->first_ban; ban != NULL; ban = ban->next )
  if (ban && !str_cmp( ban->name, ch->name ))
   return TRUE;

 return FALSE;
}

bool IS_IN_IRC(CHAR_DATA *ch, IRC_DATA *room)
{
 IRC_MEM_DATA *member;

  for( member = room->first_member; member != NULL ; member = member->next)
   if( member && !str_cmp( member->name, ch->name))
    return TRUE;

 return FALSE;
}

void send_to_irc(IRC_DATA *room, char *argument)
{
 IRC_MEM_DATA *member;
 CHAR_DATA *vict;

 for( member = room->first_member; member != NULL ; member = member->next)
  {
   if( (vict = get_char(member->name)) == NULL )
    rem_irc( member, room );
   else
    ptc(vict, "%s{x\n\r", argument);
   }

 return;
}

void do_irc( CHAR_DATA *ch, char *argument )
{
  IRC_DATA *room;
  char 	   arg[MSL];

  if(IS_NPC(ch))
   return;

  if ( IS_SET( ch->penalty_flags, PENAL_NOCHATS ) )
  {
    stc("You cannot use chats.\n\r", ch);
    return;
  }
  if( argument[0] == '\0' )
   {
    stc( "{wCHAT list                   {W-{w lists all active channels.{x\n\r", ch );
    stc( "{wCHAT info <name>            {W-{w shows information about channel <name>.{x\n\r", ch );
    stc( "{wCHAT create <name>          {W-{w create a chat channel called <name>.{x\n\r", ch );
    stc( "{wCHAT join <name>            {W-{w join channel <name>.{x\n\r", ch );
/*    stc( "{wCHAT close <name>           {W-{w close channel <name>.{x\n\r", ch );
    stc( "                              {w(Must be creator of channel to use.){x\n\r", ch );*/
    stc( "{wCHAT leave <name>           {W-{w leaves channel <name>.{x\n\r", ch );
    stc( "{wCHAT <name> <text>          {W-{w sends <text> to channel.{x\n\r", ch );
    stc( "{RChannel Moderator Commands{w:{x\n\r", ch);
    stc( "{wCHAT invite <player> <room> {W-{w invites <player> to channel.{x\n\r", ch );
    stc( "{wCHAT kick <player> <room>   {W-{w removes <player> from channel.{x\n\r", ch );
    stc( "{wCHAT ban <player> <room>    {W-{w will not allow <player> to join channel.{x\n\r", ch);
    stc( "{wCHAT unban <player> <room>  {W-{w allows <player> to re-enter channel.{x\n\r", ch);
    stc( "{wCHAT set <name> <arg>       {W-{w sets several flags on channel <name>.{x\n\r", ch);
    stc( "     {warg being one of:{x\n\r", ch );
    stc( "     {r* {wtopic <topic>        {W-{w sets description of channel.{x\n\r", ch );
    stc( "     {r* {wprivate              {W-{w sets room as private, only invited players may join.{x\n\r", ch );
    stc( "                              {wPrivate channels do not show on list.(toggle){x\n\r", ch );
    stc( "      {wmoderate <player>     {W-{w give <player> moderator status on channel.(toggle){x\n\r" , ch );
    stc( "      {wcolor <single letter> {W-{w Change the color of the text in room.{x\n\r" , ch );

    return;
   }

  argument = one_argument(argument, arg);

  if( !str_cmp( arg, "list" ))
   {
     stc( "{CCurrent active IRC Channels:\n\r", ch );
     stc( "{C    Name                Members{x\n\r", ch);
     for( room = first_irc; room != NULL ; room = room->next)
      {
       if( room->privat == TRUE)
        {
         if( IS_MODERATOR(ch))
          ptc( ch, "{RP{W %-20.20s       %-3d{x\n\r", room->name, room->num);
         else
          continue;
        }

       ptc( ch, "  {W%-20.20s     %-3d{x\n\r", room->name, room->num);
      }
     return;
    }

  if (argument[0] == '\0')
   {
    do_irc(ch, "");
    return;
    }

  if( !str_cmp( arg, "info" ))
   {
     char buf[MSL];

     room = get_irc_data(argument);

     if(!room || ((room && room->privat == TRUE) && !IS_MODERATOR(ch) && !IS_IN_IRC(ch, room)))
      {
       stc( "No such channel.\n\r", ch );
       return;
      }

     ptc( ch, "Channel: {C%s{x\n\r", room->name);
     ptc( ch, "Creator: {C%s{x\n\r", room->creator);
     ptc( ch, "Topic  : {C%s{x\n\r", room->topic);
     ptc( ch, "Members: {C%d{x\n\r", room->num);
     ptc( ch, "{%sColor  {x: {C%s{x\n\r", room->color,room->color);

     if( IS_IN_IRC(ch, room) || IS_MODERATOR(ch))
      {
       IRC_MEM_DATA *member;
       CHAR_DATA *vict;

       for ( member = room->first_member; member != NULL; member = member->next )
        {
          if( (vict = get_char(member->name)) == NULL )
           {
            rem_irc( member, room);
            continue;
           }

	  if( member == room->first_member)
           {
            if( IS_IRC_MOD(member, room))
             sprintf( buf, " {B@{C%s", room->first_member->name);
            else
	     sprintf( buf, " {C%s", room->first_member->name);
            }
          else
	  {
	   if( IS_IRC_MOD(member, room))
            strcat( buf, " {B@{C");
           else
            strcat( buf, " {C" );
           strcat( buf, member->name);
	  }
        }
       ptc( ch, "%s{x\n\r", buf );
      }

     if((IS_IN_IRC(ch, room) && IS_IRC_MOD(get_irc_member_data(ch, room),room) && room->first_ban) || (IS_MODERATOR(ch) && room->first_ban))
      {
       IRC_BAN_DATA *ban;

      for( ban = room->first_ban; ban != NULL; ban = ban->next )
       {
        if( ban == room->first_ban)
         sprintf( buf, "Bans:{C\n\r %s", room->first_ban->name);
        else
        {
         strcat( buf, " " );
         strcat( buf, ban->name);
        }
       }
       ptc( ch, "%s{x\n\r", buf );
      }
     return;
   }

  if( !str_cmp( arg, "create" ))
   {
     room = get_irc_data_exact(argument);

     if(!room)
      {
	smash_space( argument );
       create_irc( ch, capitalize( argument ) );
       room = get_irc_data_exact( argument );
       stc( "Channel created.\n\r", ch);
	room = get_irc_data( argument );
       add_irc(ch, room);
       add_invite( ch, room);
       return;
      }

     ptc( ch, "There is already a channel called %s\n\r", room->name );
     return;
   }

  if( !str_cmp( arg, "join" ))
   {
     char buf[MSL];

     room = get_irc_data_exact( argument );

     if (!room || (room && room->privat == TRUE && !IS_INVITED(ch, room)) )
      {
       stc("No such channel.\n\r", ch );
       return;
      }

     if ( IS_IN_IRC( ch, room ) )
	{
		stc("Er... You're already there.\n\r", ch);
		return;
	}

     if(IS_BANNED(ch, room))
      {
       stc("You can't join that channel.\n\r", ch );
       return;
       }

     add_irc( ch, room );
     sprintf( buf, "{B[{w%s{B]{C %s has joined %s", room->name, ch->name, room->name);
     send_to_irc( room, buf );
/*     free_string(buf);    don't free local variables */
    return;
   }

#if 0
  if( !str_cmp( arg, "close" ))
   {
     room = get_irc_data_exact( argument );

    if ( !room )
    {
     stc( "No such channel.\n\r", ch );
     return;
    }

    if ( !IS_IN_IRC(ch, room) || !IS_IRC_MOD(get_irc_member_data(ch, room), room) || !IS_IMMORTAL(ch))
     stc( "You can't do that!\n\r", ch );
    else
     {
      char buf[MSL];

      sprintf( buf, "{B[{w%s{B]{R %s has closed %s", room->name, ch->name, room->name);
      send_to_irc( room, buf );
      close_irc( room );
    /*  free_string(buf); don't free local variables */
     }
    return;
   }
#endif

  if( !str_cmp( arg, "leave" ))
   {
     room = get_irc_data(argument);

     if(!room)
      {
       stc( "No such channel.\n\r",ch );
       return;
      }

     if(!IS_IN_IRC(ch, room))
      stc( "Try joining the channel before leaving it.\n\r", ch );
     else
      {
        char buf[MSL];

        sprintf( buf, "{B[{w%s{B]{C %s has left %s{x", room->name, ch->name, room->name);
        send_to_irc( room, buf );
        rem_irc( get_irc_member_data(ch, room ), room);
      }
     return;
    }

   if( !str_cmp( arg, "invite" ))
   {
     char arg1[MSL];
     CHAR_DATA *vict;

     argument = one_argument( argument, arg1);
     room = get_irc_data(argument);

    if( !room || !IS_IN_IRC(ch, room) )
     {
      stc( "Try joining the channel first!\n\r", ch);
      return;
     }

    if(IS_IRC_MOD(get_irc_member_data(ch, room), room) && IS_IN_IRC(ch, room))
     {
      vict = get_pc_world(ch, arg1);
      if (!vict)
       {
        stc("They aren't here.\n\r", ch);
        return;
       }/*
      if (IS_NPC(vict) )
      {
	stc("You can't invite NPCs.\n\r", ch);
	return;
      }*/
      if (IS_IN_IRC(vict, room))
       {
        ptc(ch,"%s is already in the channel.\n\r", vict->name);
        return;
       }
      if (IS_INVITED(vict, room))
       ptc(ch, "%s is already been invited to %s.\n\r", vict->name, room->name);
      else
       {
        add_invite( vict, room);
        ptc(ch, "{G%s has been invited to %s.{x\n\r", vict->name, room->name);
	ptc(vict, "{G%s has invited you to join %s.{x\n\r", ch->name, room->name);
       }
      }
     else
      stc("You can't do that.\n\r", ch );
   return;
   }

   if( !str_cmp( arg, "kick" ))
   {
     char arg1[MSL];
     char buf[MSL];
     CHAR_DATA *vict;

     argument = one_argument( argument, arg1);
     room = get_irc_data(argument);

    if( !room || !IS_IN_IRC(ch, room) )
     {
      stc( "Try joining the channel first!\n\r", ch);
      return;
     }

     vict = get_pc_world(ch, arg1);
     if (!vict)
      {
       stc("They aren't here.\n\r", ch);
       return;
       }

     if(!IS_IRC_MOD(get_irc_member_data(ch, room), room) || (!str_cmp(room->creator, vict->name) && !IS_MODERATOR(ch)) || IS_MODERATOR(vict))
      {
        stc( "You can't do that!\n\r", ch);
        return;
      }
     if(!IS_IN_IRC(vict, room))
     {
	     stc("They aren't in that channel.\n\r",ch);
	     return;
     }

     rem_irc(get_irc_member_data(vict, room), room);
     ptc( vict, "{RYou have been kicked from %s.{x\n\r", room->name);
     sprintf(buf, "{B[{w%s{B] {C%s has been kicked by %s{x", room->name, vict->name, ch->name );
     send_to_irc(room, buf);
    return;
   }

   if( !str_cmp( arg, "set"))
   {
    char arg1[MSL];
    char arg2[MSL];
    char buf[MSL];

    argument = one_argument( argument, arg1);
    argument = one_argument( argument, arg2);

    if( arg1[0] == '\0' || arg2[0] == '\0')
     {
      do_irc(ch, "");
      return;
     }

    room = get_irc_data(arg1);

    if(!room || !IS_IN_IRC(ch, room))
     {
	stc( "Try joining the channel first!\n\r", ch);
        return;
     }

    if(!IS_IRC_MOD(get_irc_member_data(ch, room), room) && !IS_IMMORTAL(ch))
     {
	stc( "You can't do that!\n\r", ch);
	return;
     }

    if(!str_cmp(arg2, "private"))
     {
      if( room->privat == FALSE)
       {
        sprintf( buf,"{B[{w%s{B]{C Channel has been set to private by %s.\n\r", room->name, ch->name);
        room->privat = TRUE;
        }
      else
       {
        sprintf( buf,"{B[{w%s{B]{C Private status removed by %s.\n\r", room->name, ch->name);
        room->privat = FALSE;
        }
      send_to_irc( room, buf);
      return;
     }
    if(!str_cmp(arg2, "color"))
    {
      if(argument[0] == '\0')
       {
        do_irc(ch,"");
        return;
       }
      if(argument[1] != '\0' || argument[0] == '{')
      {
	      stc("Only one letter for a color. No need for a {{.\n\r",ch);
	      return;
      }

      free_string(room->color);
      room->color = str_dup(argument);
      sprintf(buf, "{B[{w%s{B]{%s Color has been set to %s by %s.\n\r", room->name, room->color, room->color, ch->name);
      send_to_irc( room, buf);
      return;
      
    }

    if(!str_cmp(arg2, "topic"))
     {

      if(argument[0] == '\0')
       {
        do_irc(ch,"");
        return;
       }

      free_string(room->topic);
      room->topic = str_dup(argument);
      sprintf( buf, "{B[{w%s{B]{C Channel topic changed to: {W%s {Cby %s{x\n\r", room->name, argument, ch->name);
      send_to_irc( room, buf);
      return;
     }

    if(!str_cmp(arg2, "moderate"))
     {
       IRC_MEM_DATA *member;
       CHAR_DATA *vict;

      if(argument[0] == '\0')
       {
        do_irc(ch,"");
	return;
       }

      vict = get_char(argument);

     if(!vict ||(vict && !IS_IN_IRC(vict, room)))
      {
       stc("They aren't here.\n\r", ch);
       return;
      }

      member = get_irc_member_data(vict, room);

     if(IS_IRC_MOD(get_irc_member_data(vict, room),room) && str_cmp( vict->name, room->creator))
      {
       member->mod = FALSE;
       sprintf( buf, "{B[{w%s{B]{C %s's moderator status removed by %s.{x\n\r", room->name, vict->name, ch->name);
      }
     else
      {
       member->mod = TRUE;
       sprintf( buf, "{B[{w%s{B]{C %s has been given moderator status by %s{x\n\r", room->name, vict->name, ch->name);
       }
       send_to_irc( room, buf);
       return;
      }
    do_irc(ch, "");
    return;
   }

   if( !str_cmp( arg, "ban" ))
   {
     char arg1[MSL];
     char buf[MSL];
     CHAR_DATA *vict;

     argument = one_argument( argument, arg1);
     room = get_irc_data(argument);

    if( !room || !IS_IN_IRC(ch, room) )
     {
      stc( "Try joining the channel first!\n\r", ch);
      return;
     }

    if(IS_IRC_MOD(get_irc_member_data(ch, room), room) && IS_IN_IRC(ch, room))
     {
      vict = get_pc_world(ch, arg1);
      if (!vict)
       {
        stc("They aren't here.\n\r", ch);
        return;
       }/*
      if (IS_NPC(vict))
      {
	      stc("Not on NPCs.\n\r", ch);
	      return;
      }*/
       if (IS_BANNED(vict, room))
       ptc(ch, "%s is already banned from %s.\n\r", vict->name, room->name);
      else
       {
        add_ban( room, vict->name);
        if( IS_IN_IRC( vict, room))
         {
          rem_irc(get_irc_member_data(vict, room), room);
          ptc( vict, "{RYou have been banned from %s.{x\n\r", room->name);
         }
        sprintf(buf, "{B[{w%s{B]{C %s has been banned from channel by %s.{x\n\r", room->name,vict->name, ch->name);
	send_to_irc( room, buf);
       }
      }
    else
     stc("You can't do that.\n\r", ch);
    return;
   }

   if( !str_cmp( arg, "unban" ))
   {char arg1[MSL];
     CHAR_DATA *vict;

     argument = one_argument( argument, arg1);
     room = get_irc_data(argument);

    if( !room || !IS_IN_IRC(ch, room) )
     {
      stc( "Try joining the channel first!\n\r", ch);
      return;
     }

    if(IS_IRC_MOD(get_irc_member_data(ch, room), room) && IS_IN_IRC(ch, room))
     {
      vict = get_pc_world(ch, arg1);
      if (!vict)
       {
        stc("They aren't here.\n\r", ch);
        return;
       }
       if (!IS_BANNED(vict, room))
       ptc(ch, "%s isn't banned from %s.\n\r", vict->name, room->name);
      else
       {
        /*rem_ban( room, capitalize(arg1));   no good if they abbreviate */
        rem_ban( room, capitalize(vict->name));
        ptc(ch, "{B[{w%s{B]{CBan on %s removed by %s{x\n\r", room->name, vict->name, ch->name);
       }
      }
    else
     stc("You can't do that.\n\r", ch);
   return;
   }

   if((room = get_irc_data(arg)) != NULL )
   {
     char arg1[MSL];
     char buf[MSL];
     char *old_arg = argument;

    if(!IS_IN_IRC(ch, room))
     {
      stc( "Try joining the channel first.\n\r", ch);
      return;
     }

     argument = one_argument(argument, arg1);

     if(!str_cmp( arg1, "emote" ))
      {
        if (argument[0] == '\0')
         {
          stc( "Emote what?\n\r", ch );
          return;
         }
        sprintf( buf, "{B[{%s%s{B]{%s %s %s{x\n\r", room->color, room->name, room->color, ch->name, argument );
	send_to_irc( room, buf );
        return;
       }
/*
     if (argument[0] == '\0')
      sprintf(buf, "{B[{w%s {b({w%s{b){B] {B'{w%s{B'{x", room->name, ch->name, arg1 );
     else
      sprintf(buf, "{B[{w%s {b({w%s{b){B] {B'{w%s %s{B'{x", room->name, ch->name, arg1, argument );
      */
      sprintf(buf, "{B[{%s%s {b({%s%s{b){B] {B'{%s%s{B'{x", room->color, room->name, room->color, ch->name, room->color, old_arg );
     send_to_irc( room, buf );

     return;
   }

   do_irc(ch, "" );
   return;
}

