#include <sys/types.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "tables.h"
#include "olc.h"
#include "interp.h"

bool change_exit args(( CHAR_DATA *ch, char *argument, int door, bool silent ));

void create_map_exits( CHAR_DATA *ch )
{
	AREA_DATA *pArea;
	ROOM_INDEX_DATA *pRoom;
	int value;
	int iHash;
	int inr;
	int i;
	char buf[MSL];

	for ( i = 0; i > 299; i++ )
	{

		value = ch->in_room->vnum+1;
		pArea = get_vnum_area( value );

		if ( value > ch->in_room->area->max_vnum )
		{
			ptc( ch, "Ran out of vnums at %d. Area max vnum is %d.\n\r", value, ch->in_room->area->max_vnum );
			return;
		}

		pRoom = new_room_index();
		pRoom->area = pArea;
		pRoom->vnum = value;

		if ( value > top_vnum_room )
			top_vnum_room = value;

		iHash = value % MAX_KEY_HASH;
		pRoom->next = room_index_hash[iHash];
		room_index_hash[iHash] = pRoom;
		ch->desc->pEdit = (void *)pRoom;

		sprintf( buf, "link %ld", ch->in_room->vnum+1 );
		change_exit( ch, buf, DIR_EAST, true );

		inr = ch->in_room->vnum;
		char_from_room( ch );
		char_to_room( ch, get_room_index( inr+1 ) );
	}
}
void draw_world_map( CHAR_DATA *ch )
{
	char buf[MSL];
	int i, inr;
	
	for ( i = 0; i < 299; i++ )
	{
		sprintf( buf, "link %ld", (ch->in_room->vnum - 600) );
		change_exit( ch, buf, DIR_NORTH, true );

		sprintf( buf, "link %ld", (ch->in_room->vnum - 599) );
		change_exit( ch, buf, DIR_NORTHEAST, true );

		inr = ch->in_room->vnum;
		char_from_room( ch );
		char_to_room( ch, get_room_index( inr+1 ) );
	}
}
