/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 **************************************************************************/

/***************************************************************************
*       ROM 2.4 is copyright 1993-1996 Russ Taylor                         *
*       ROM has been brought to you by the ROM consortium                  *
*           Russ Taylor (rtaylor@efn.org)                                  *
*           Gabrielle Taylor                                               *
*           Brian Moore (zump@rom.org)                                     *
*       By using this code, you have agreed to follow the terms of the     *
*       ROM license, in the file Rom24/doc/rom.license                     *
***************************************************************************/

/***************************************************************************
 *           ROM MSP [C] 1998 Dingo dingo@pdragon.inetsolve.com            *
 *        written for Purple Dragon MUD pdragon.inetsolve.com:5555         *
 *                                                                         *
 *  You may freely copy and/or change this code any way you wish, as long  *
 *  this header remains unchanged.                                         *
 **************************************************************************/

/*
 * Okay, this is the trick ;), i'm not very big in describing what the code
 * does, so this piece of is really not for begginers, one of the reasons
 * why not is because PD area files and data structures changed so much in
 * past year, that it makes nearly impossible to make snippet out of the code
 * this file is basically just file what i copied from src/ dir and added some
 * text to it, so it cannot be called a snippet, but you should be able to
 * dig out some pointers on how to implement MSP on your mud. There is also
 * ton of stuff what i didn't finished, i plan to do that in next few months.
 * the core works fine, we have players using it right now and we didn't have
 * problems with it yet. originally i implemented the U= variable for
 * the sounds URL, but i found out very soon that some of the zmuds have problem
 * with it, the zmud is probably fixed now, i just never bothered to put it
 * back in as the players preffer to download all the sounds at once in zip
 * file anyway.
 */

 /*
  * the code checks for WAR_MSP flag in ch->war_flags, that is the flag what makes
  * the mud to send the player msp trigger
  */

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "aww.h"
#include "msp.h"
#include "msp_const.h"

int tolower args((int c));

/*
 * Proc what looks up sound type for 'T=' so the players can turn certain
 * sound groups off, like fight sounds, and still hear doors open and close
 * etc. the msp_table is declared in msp_const.h
 */
char *msp_sndtype(sndtype)
{
    int i;
    for ( i=0; msp_table[i].type != -1; i++ )
	if ( msp_table[i].type == sndtype ) return msp_table[i].group;
    return "";
}

/*
 * This proc changes all spaces to underscores, that way we can just use spell
 * names declared in const.c for the filenames and stay nice and lazy :)
 * it is used in more procedures than just msp_spell, that way our builders
 * don't have to watch them selves.
 */
void spelltofile( char *str )
{
    for ( ; *str != '\0'; str++ ) if ( *str == ' ' ) *str = '_';
    return;
}

/*
 * This procedure makes all the weapon noises, there is some weapon types
 * unique to PD so just delete the appropriate case to get rid of the bug
 * i added the hook what calls it in one_hit in fight.c
 * people who aren't fighting and are in the same room, still get the
 * weapon noise at 50% volume
 */
void msp_weapon(CHAR_DATA *ch,OBJ_DATA * weapon)
{
    int  wpntype,i;
    char buf[MSL];
    CHAR_DATA *to;

    switch (weapon->value[0])
    {
        case WEAPON_EXOTIC:  wpntype = MSP_FIGHT_EXOTIC;  break;
        case WEAPON_SWORD:   wpntype = MSP_FIGHT_SWORD;   break;
        case WEAPON_DAGGER:  wpntype = MSP_FIGHT_DAGGER;  break;
        case WEAPON_SPEAR:   wpntype = MSP_FIGHT_SPEAR;   break;
        case WEAPON_MACE:    wpntype = MSP_FIGHT_MACE;    break;
        case WEAPON_AXE:     wpntype = MSP_FIGHT_AXE;     break;
        case WEAPON_FLAIL:   wpntype = MSP_FIGHT_FLAIL;   break;
        case WEAPON_WHIP:    wpntype = MSP_FIGHT_WHIP;    break;
        case WEAPON_POLEARM: wpntype = MSP_FIGHT_POLEARM; break;
        default:             wpntype = MSP_FIGHT_DEFAULT; break;
    }

    buf[0]='\0';

    for ( i=0; msp_fight_table[i].type != -1; i++ )
    if ( msp_fight_table[i].type == wpntype ) sprintf(buf,"%s",msp_fight_table[i].sound);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
	/*printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=97 T=%s)\n\r", buf, MSP_FIGHT_VOLUME, msp_sndtype(MSP_FIGHT));*/
	stc("!!SOUND(sword.wav)", ch);

    for(to = ch->in_room->people; to != NULL ; to = to->next_in_room )
        if (to != ch && !IS_NPC(to) && IS_SET(to->war_flags,WAR_MSP))
	    printf_to_char(to,"!!SOUND(%s V=50 R=1 P=50 T=%s)\n\r", buf, msp_sndtype(MSP_FIGHT));
    return;
}

/*
 * this one is called from do_cast in magic.c and it makes all the spell noises
 * the rest is the same as with msp_weapon
 */
void msp_spell(CHAR_DATA *ch,int spell)
{
    char buf[MSL];
    CHAR_DATA *to;

    if (IS_NPC(ch) || !IS_SET(ch->war_flags,WAR_MSP)) return;

    sprintf(buf,"%s*.wav",skill_table[spell].name);
    spelltofile(buf);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
        printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=98 T=%s)\n\r", buf, MSP_SPELL_VOLUME, msp_sndtype(MSP_SPELL));

    for(to = ch->in_room->people; to != NULL ; to = to->next_in_room )
        if (to != ch && !IS_NPC(ch) && IS_SET(to->war_flags,WAR_MSP))
	    printf_to_char(to,"!!SOUND(%s V=50 R=1 P=50 T=%s)\n\r", buf, msp_sndtype(MSP_SPELL));

    return;
}

/*
 * msp_sound is used for all the events and whenever you think that the sound
 * should be heard by every player in the room.
 */
void msp_sound(CHAR_DATA *ch, const char *sound)
{
    char buf[MSL];
    CHAR_DATA *to;

    sprintf(buf,"%s*.wav",sound);
    spelltofile(buf);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
	printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=100 T=%s)\n\r", buf, MSP_EVENT_VOLUME, msp_sndtype(MSP_EVENT));

    for(to = ch->in_room->people; to != NULL ; to = to->next_in_room )
        if (to != ch && !IS_NPC(ch) && IS_SET(to->war_flags,WAR_MSP))
	    printf_to_char(to,"!!SOUND(%s V=50 R=1 P=51 T=%s)\n\r", buf, msp_sndtype(MSP_EVENT));

    return;
}

/*
 * i wrote this one when i needed certain sounds to go just to the one specific
 * player and i didn't want to change msp_sound to check for it, because i would
 * have to change all the msp_sound all over the code, i use it just for
 * background noises like voices leaking in from different room and all the
 * other places where the msp_sound can't be used.
 */
void msp_surround(CHAR_DATA *ch, const char *sound)
{
    char buf[MSL];

    sprintf(buf,"%s.wav",sound);
    spelltofile(buf);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
	printf_to_char(ch,"!!SOUND(%s V=40 R=1 P=40 T=%s)\n\r", buf, msp_sndtype(MSP_EVENT));

    return;
}

/*
 * msp_room sends sound to the player when they enter the room, i added the call
 * to char_to_room. room->msp is a pointer to a string, the code assumes that
 * the file name what is hold in room->msp already have extension [i toke care
 * of that in OLC] if the file extension is '.m??' then !!MUSIC trigger is used
 * else !!SOUND is used, the trigger is sent only to the person who just entered
 * the room as the sounds could get annoying in places where is alot of traffic
 */
void msp_room(CHAR_DATA *ch, ROOM_INDEX_DATA *room)
{

    char buf[MSL];
    bool music = FALSE;

    if (IS_NPC(ch) || !IS_SET(ch->war_flags,WAR_MSP)) return;

    if (strlen(room->msp) < 5)
	music = FALSE;
    else if ( room->msp[strlen(room->msp)-4] == '.' && tolower(room->msp[strlen(room->msp)-3]) == 'm')
	music = TRUE;

    if (!music)
    {
	sprintf(buf,"%s",room->msp);
	spelltofile(buf);
	printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=50 T=%s)\n\r", buf, MSP_EVENT_VOLUME, msp_sndtype(MSP_EVENT));
    } else
    {
	sprintf(buf,"%s",room->msp);
	spelltofile(buf);
	printf_to_char(ch,"!!MUSIC(%s V=%d C=1 T=%s)\n\r", buf, MSP_EVENT_VOLUME, msp_sndtype(MSP_EVENT));
    }
    return;
}

/*
 * msp_hit replaced msp_weapon, i didn't removed msp_weapon yet as i will use it
 * for something else later on, you have your pick which one you want to use it,
 * this one is basically the same thing, except that it doesn't uses
 * msp_fight_table to get the right data, and rather uses the weapon type as a
 * filename.
 */
void msp_hit(CHAR_DATA *ch, const char *attack)
{
    char buf[MSL];
    CHAR_DATA *to;

    sprintf(buf,"%s.wav",attack);
    spelltofile(buf);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
	printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=99 T=%s)\n\r", buf, MSP_FIGHT_VOLUME, msp_sndtype(MSP_FIGHT));

    for(to = ch->in_room->people; to != NULL ; to = to->next_in_room )
        if (to != ch && !IS_NPC(ch) && IS_SET(to->war_flags,WAR_MSP))
	    printf_to_char(to,"!!SOUND(%s V=50 R=1 P=50 T=%s)\n\r", buf, msp_sndtype(MSP_FIGHT));

    return;
}

/*
 * msp_weather is called from act_move.c when the char moves out of the shelter
 * the sound goes just to the player.
 */
void msp_weather(CHAR_DATA *ch, const char *weather)
{
    char buf[MSL];

    sprintf(buf,"weather/%s*.wav",weather);
    spelltofile(buf);

    if (!IS_NPC(ch) && IS_SET(ch->war_flags,WAR_MSP))
	printf_to_char(ch,"!!SOUND(%s V=%d R=1 P=35 T=%s)\n\r", buf, MSP_WEATHER_VOLUME, msp_sndtype(MSP_WEATHER));

}

/*
 * well this is all for now, i'm sure that there is alot of things what could
 * be done differently and the code needs a cleanup, but that is now up to
 * you if you still actually reading my babbling :)
 *
 *                                  Have fun o===)===Dingo===-
 */
