/*
+=-------------------------------------------------------=+
| MYSQL Backend Wrapper  Copyright 2004 JCrenshaw        |
+=-------------------------------------------------------=+

+=-------------------------------------------------------=+
| MYSQL Support:                                          |
|    # connect_db        : Establish persistant connection|
|    # query_db          : Querys and Returns Result -    |
|                          Minor error handling only      |
|    # sql_escape_string : Escape sequence handler.       |
|                          Memory Allocation is standard. |
+=-------------------------------------------------------=+
*/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif

#include <sys/resource.h>       /* for RLIMIT_NOFILE */

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include "aww.h"
#include "recycle.h"
#include "mysql5_interface.h"
#include <mysql/mysql.h>

/* Establish Connection and Reset timeout flag */
void connect_db()
{
   if ((result_db = mysql_init(NULL)) == NULL)
   {
      bug("connect_db: error on initialize", 0);
      return;
   }

   if (!mysql_real_connect(result_db, 0, DB_USER, DB_PASS, DB_DB, 0, NULL, CLIENT_FOUND_ROWS))
   {
      bug("connect_db: error on connect result_db", 0);
      bug(mysql_error(result_db), 0);
      mysql_close(result_db);
      return;
   }

   db_connect = TRUE;

   return;
}


/*
 * Function:  query_db
 *      Sends the query to the database and returns the result set.
 *  Checks are still required past this function call.
 */
MYSQL_RES *query_db(char *query, MYSQL *m_db, bool sql_queue)
{
   char buf[MAX_INPUT_LENGTH];

   buf[0] = '\0';

	return NULL; // prool fool

   if (!db_connect)
      connect_db();

   if (m_db == NULL)
   {
      bug("SQL-QUERY: Both connections must be present.", 0);
      return NULL;
   }

   if (query == NULL || query[0] == '\0')
   {
      bug("Null query in query_db()", 0);
      return NULL;
   }

//   if (mysql_real_query(m_db, query, (long)strlen(query)))
   if (mysql_query(m_db, query))
   {
      bug("query_db(): error on query", 0);
      bug("-----------Error in MySQL------------", 0);
      bug(mysql_error(m_db), 0);
      return NULL;
   }

//	return mysql_use_result(m_db);

   return mysql_store_result(m_db);
}


char *sql_escape_string(char *source)
{
   static char buf[MSL*3];
   int len = strlen(source);
   mysql_real_escape_string(result_db, buf, source, len);
//	strcpy(buf,"***"); // prool fool!!!
   return buf;
}
