/***************************************************************************
                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/
    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.
    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.
    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.
    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.
    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.
	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "recycle.h"

void do_profile( CHAR_DATA *ch, char *argument )
{
	char arg[MIL];

	argument = one_argument( argument, arg );

	if ( arg[0] == '\0' )
	{
		stc( "In Character Information:\n\r", ch );
		stc( "-------------------------\n\r", ch );
		ptc( ch, "Full Name: %s %s\n\r", ch->name, ch->pcdata->last_name );
		ptc( ch, "Sex: %s\n\r", ch->sex == SEX_MALE ? "Male" : ch->sex == SEX_FEMALE ? "Female" : "Nueter" );
		ptc( ch, "Age: %d years old\n\r", get_age( ch ) );
		ptc( ch, "Height: Average\n\r" );
		ptc( ch, "Weight: 250 stones\n\r" );
		ptc( ch, "Birthplace: %s\n\r", pc_race_table[ch->race].who_name );
		ptc( ch, "Mother: Unknown\n\r" );
		ptc( ch, "Father: Unknown\n\r" );
		ptc( ch, "Siblings: None\n\r" );
		ptc( ch, "Children: None\n\r" );
		ptc( ch, "Marital Status: %s\n\r", IS_MARRIED( ch ) ? ch->pcdata->spouse : "Single" );
		ptc( ch, "Current Residence:\n\r", pc_race_table[ch->race].who_name );
		ptc( ch, "Occupation:\n\r", clan_table[ch->clan].who_name );
		stc( "\n\r", ch );
		stc( "Out of Character Information:\n\r", ch );
		stc( "-----------------------------\n\r", ch );
		ptc( ch, "Real Name:\n\r", ch->pcdata->ooc_real_name );
		ptc( ch, "Sex:\n\r", ch->pcdata->ooc_sex );
		ptc( ch, "Age:\n\r", ch->pcdata->ooc_age );
		ptc( ch, "Birthplace:\n\r", ch->pcdata->ooc_birthplace );
		ptc( ch, "Marital Status:\n\r", ch->pcdata->ooc_marital_status );
		ptc( ch, "Current Residence:\n\r", ch->pcdata->ooc_residence );
		ptc( ch, "Occupation:\n\r", ch->pcdata->ooc_occupation );
		ptc( ch, "Activities:\n\r", ch->pcdata->ooc_activities );
		ptc( ch, "Favorite Book:\n\r", ch->pcdata->ooc_fav_book );
		ptc( ch, "Favorite TV Show:\n\r", ch->pcdata->ooc_fav_tv_show );
		ptc( ch, "Favorite Actor:\n\r", ch->pcdata->ooc_fav_actor );
		ptc( ch, "Favorite Actress:\n\r", ch->pcdata->ooc_fav_actress );
		ptc( ch, "Favorite Movie:\n\r", ch->pcdata->ooc_fav_movie );
		return;
	}
	if ( !str_cmp( arg, "?" ) || !str_cmp( arg, "help" ) )
	{
		stc("Player Definable Fields\n\r\n\r", ch);
		stc("=======================\n\r", ch);
		stc("In Character Information\n\r", ch );
		stc("------------------------\n\r", ch );
		stc("1]  Height            (I)\n\r", ch);
		stc("2]  Weight            (I) (lbs)\n\r", ch);
		stc("3]  Mother            (S)\n\r", ch);
		stc("4]  Father            (S)\n\r", ch);
		stc("5]  Siblings          (I)\n\r", ch);
		stc("6]  Children          (I)\n\r", ch);
		stc( "\n\r", ch );
		stc("Out of Character Information\n\r", ch );
		stc("----------------------------\n\r", ch );
		stc("7]  Real Name         (S)\n\r", ch);
		stc("8]  Sex               (S) (Male or Female)\n\r", ch);
		stc("9]  Age               (I)\n\r", ch);
		stc("10] Birthplace        (S)\n\r", ch);
		stc("11] Marital Status    (S) (Single, Married, Divorced, Widowed, Widower)\n\r", ch);
		stc("12] Residence         (S)\n\r", ch);
		stc("13] Occupation        (S)\n\r", ch);
		stc("14] Activites         (S)\n\r", ch);
		stc("15] Favorite Book     (S)\n\r", ch );
		stc("16] Favorite TV Show  (S)\n\r", ch );
		stc("17] Favorite Actor    (S)\n\r", ch );
		stc("18] Favorite Actress  (S)\n\r", ch );
		stc("19] Favorite Movie    (S)\n\r", ch );
		stc("\n\rType the number corresponding to the field you wish to define followed by\n\rthe definition.\n\r",ch);
		stc("Fields marked (I) may only be numbers while fields marked (S) may be either\n\rnumbers or letters.\n\r",ch);
		stc("If a convention is specified (such as Sex, Male or Female), please use only\n\rthe designated conventions.\n\r",ch);
		return;
	}

}
