#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "tables.h"
#include "olc.h"
#include "interp.h"
#include "randroom.h"

void do_randroom ( CHAR_DATA *ch, char *argument )
{
    ROOM_INDEX_DATA *pRoom;
    bool haveSentence = TRUE;
    bool firstSentence = FALSE;
    bool needSentence = FALSE;
    /*bool insects = FALSE;*/
    int i = 0;
	char buf[MSL];
    char arg[MSL];

	/* seperator */
	char *forest_noun_array[] =	{
		" forest"," woodland"," wood"," timber"," thicket"," foilage"
	};
	char *forest_noun_array2[] =	{
		" forest"," woodland"," timberland"
	};
	char *growth_verb_array[] =	{
		" thickly"," thinly"," sparsely"," randomly"," chaotically"," wildly"," rampantly"
	};
	char *growth_verb_array2[] =	{
		" thrive in the"," grow in the"," grow around the"," spread throughout the",
		" overtake the"," overgrow the"
	};
	char *distance_desc_array[] =	{
		" through here"," around here"," nearby"," all around"," closely around"," all about"
	};
	char *distance_desc_array2[] =	{
		" into"," around"," through"," about"
	};
	char *distance_desc_array3[] =	{
		" around"," through"," throughout"," about"
	};
	char *distance_desc_array4[] =	{
		" here"," this place"," this area"," these parts"
	};
	char *distance_desc_array5[] = {
		" tossed around"," thrown about"," tossed down"," tossed about"," thrown around"
	};
	char *number_growths_array[] =	{
		" many"," more than a few"," some"," a good many"," several", " quite a few"
	};
	char *number_growths_array2[] =	{
		"Many","More than a few","Some", "A good many","Several","Quite a few","Numbers of"
	};
	char *number_growths_array3[] =	{
		"A few","Quite a few","A number of","A large amount of","Quite a number of",
		"Many","Several","Scores of","Countless","Countless numbers of","Numerous"
	};
	char *tree_type_array1[] =	{
		" oak"," pine"," leatherleaf"," fir"," spruce"," cedar"," rosewoods"," hollys",
		" poplars", " elms"
	};
	char *tree_type_array2[] =	{
		" hemlock"," cypress"," beech"," ash"," dogwoods"," maples"," walnut"," birch"
	};
	char *foilage_color_array[] = {
		" darkly"," dark"," russet"," reddish"," red-brown"," dark brown", " dark green"
	};
	char *foilage_type_array[] = {
		" leaves"," growths"," flowers"," needles"," cones"," soft leaves"," long needles",
		" bristling cones", " wide-leaves", " broad-leaves", " sharp needles", " small cones"
	};
	char *tree_height_array[] = {
		" great"," towering"," tall"," massive"," mighty"," large"," huge"
	};
	char *tree_evergreen_array[] = {
		" evergreens"," conifers"," carniferous trees"
	};
	char *water_desc_array[] = {
		" small"," meandering"," winding"," wandering"," crooked"," swiftly flowing",
		" shallow"," rocky"," twisting and turning"," rock-bottomed"," sandy-bottomed"
	};
	char *water_type_array[] = {
		" creek"," stream"," brook"," runnel of water"," body of water"," flow of water"," brooklet",
		" streamlet"," branch"," rivulet"," sike"," spring", " runnel"
	};
	char *water_move_array[] = {
		" flows"," runs"," leads"," splashes"," trickles"," courses"," babbles"," bubbles",
		" gushes"," murmers"," pours"," trills"," drains"," outlets"
	};
	char *undergrowth_type_array[] = {
		" creepers"," vines"," under brush"," under growth"," scrub"
	};
	char *undergrowth_move_array[] = {
		" crawls", " scrambles across", " covers", " coats", " crawls across"
	};
	char *growth_noun_desc[] = {
		"An outgrowth","A patch","A growth"
	};
	char *growth_stuff_array[] = {
		" moss"," lichens"," mushrooms"," toadstools"
	};
	char *growth_stuff_array2[] = {
		" rocks"," stones"," tree trunks"," ground"
	};
	char *growth_stuff_array3[] = {
		"Green mosses","Brown and green mosses","Wet mosses","Soft mosses","Beds of moss","Club mosses"
		"Branching growths of lichens","Lichens","Growths of lichens","Branches of lichens",
		"Green lichens","Green and brown lichens","Cup lichens","Beard lichens","Idle mosses",
		"Mushrooms","Umbrella-shaped mushrooms","Small round mushrooms","Bowl-shaped mushrooms",
		"Large round mushrooms","Club-like mushrooms","Trumpet-shaped",
		"Toadstools"
	};
	char *growth_stuff_array4[] = {
		"Wildflowers","Small blossoms","Leafy plants","Ferns","Flowering blooms","Bright blossoms",
		"Vibrant blooms","Floral blooms","Exotic flowers","Exotic plants","Thistles","Briars",
		"Briars and thorns","Thorns and thistles","Thistles and briars","Brambles"
	};
	char *growth_stuff_array5[] = {
		"Rocks","Leaves","Branches","Boughs","Limbs","Stones"
	};
	char *broke_desc_array[] = {
		"Fallen","Broken","Cracked","Rent"
	};
	char *broke_type_array[] = {
		" limbs"," branches"," debris"," twigs"," boughs"
	};
	char *broke_adverb_array[] = {
		" cover"," litter"," de-foil"
	};
	char *growth_desc_array[] = {
		" grow"," thrive"," flourish"," prosper"," grow wildly"," grow rampantly",
		" grow randomly"," grow chaotically"," grow manically", " grow like mad"
	};
	char *place_desc_array[] = {
		" the floor"," the ground"," the earth"," the earthen floor"," the earthen ground"
	};
	char *animals_array[] = {
		"A red bird", "A whippoorwhill", "A sparrow", "A dove", "A black bird", "A blue bird",
		"A wren", "An owl", "A jay bird", "A robin"
	};
	char *animal_act_array[] = {
		" twitters", " calls", " sings", " coos", " settles its wings", " screeches",
		" whistles", " hoots", " preens", " chirrups"
	};
	char *animal_noise_array[] = {
		" quietly", " hauntingly", " clearly", " soothingly", " noisily", " loudly",
		" musically", " chillingly", " carefully", " merrily"
	};
	char *animal_location_array[] = {
		" a nearby branch", " an overhanging limb", " deep in the shrubbery", " somewhere in the undergrowth",
		" high in the treetops", " amidst the leaves", " a nearby tree", " amongst the foilage",
		" within the canopy", " within the greenery"
	};

	buf[0] = '\0';

    if ( IS_NPC(ch) )
    	return;

    argument = one_argument( argument, arg );

    pRoom = ch->in_room;

	if (mud_port == play_port && !is_exact_name(ch->name, MUD_OWNER))
	{
		stc("Building is not allowed on this port.\n\r",ch);
		return;
	}
	if ( !IS_BUILDER( ch, pRoom->area ) )
	{
		stc( "Insufficient security to edit area.\n\r" , ch );
       	return;
	}
	/* right now, forests and cities are available */
	if ( !str_prefix( arg, "forest" ) )
	{
		char *forest_adjective_array[] = {
			"dominating", "ruling over", "lording over", "standing in numbers throughout",
			"reigning dominant in", "holding reign over", "standing majestically over",
			"lording like kings over", "holding sway over", "completely dominating",
			"utterly dominating", "holding claim to", "completely dominating",
			"like an army set to guard", "completely surrounding", "rising in number over",
			"rising like lords over", "climbing ever upwards throughout", "utterly claiming",
			"completely claiming"
		};
		char *forest_around_array[] = {
			"surrounding land","nearby area","remaining ground","underlying rabble",
			"underlying forest","forest below","bulk of the scene","immediate view",
			"nearby land","surrounding forest","land all about","landscape",
			"surrounding landscape","everything that can be seen","the remaining flora"
		};
	    ch->desc->pEdit	= (void *) pRoom;
	    ch->desc->editor	= ED_ROOM;

		/* possible first sentence structure */
		if ( number_percent() < 50 )
		{
		firstSentence = TRUE;
		i = number_range(1,32);
		if ( i == 1 ) {
			strcat( buf, " The ancient trees in this forest grow unchecked, " );		}
		else if ( i == 2 ) {
			strcat( buf, " The venerable trees in this forest grow unchecked, " );		}
		else if ( i == 3 ) {
			strcat( buf, " The trees in this ancient-seeming forest grow unchecked, " );		}
		else if ( i == 4 ) {
			strcat( buf, " The trees in this venerable old forest grow unchecked, " );		}
		else if ( i == 5 ) {
			strcat( buf, " There are many venerable trees in this old forest, " );		}
		else if ( i == 6 ) {
			strcat( buf, " This old forest is home to many ancient trees, " );		}
		else if ( i == 7 ) {
			strcat( buf, " This ancient forest is home to many venerable old trees, " );		}
		else if ( i == 8 ) {
			strcat( buf, " This forest is home to an army of venerable old trees, " );		}
		else if ( i == 9 ) {
			strcat( buf, " The old trees in this forest grow strong and straight, " );		}
		else if ( i == 10 ) {
			strcat( buf, " The ancient trees in this forest grow strong and straight, " );		}
		else if ( i == 11 ) {
			strcat( buf, " The ancient trees in this wilderness grow strong and straight, " );		}
		else if ( i == 12 ) {
			strcat( buf, " The venerable old trees in this woodland grow tall and strong, " );		}
		else if ( i == 13 ) {
			strcat( buf, " The venerable old trees in this woodland grow straight and tall, " );		}
		else if ( i == 14 ) {
			strcat( buf, " The trees in this ancient woodland grow straight and tall, " );		}
		else if ( i == 15 ) {
			strcat( buf, " The trees in this ancient forest grow straight and tall, " );		}
		else if ( i == 16 ) {
			strcat( buf, " The trees in this ancient wilderness grow straight and tall, " );		}
		else if ( i == 17 ) {
			strcat( buf, " The trees in this ancient woodland grow tall and strong, " );		}
		else if ( i == 18 ) {
			strcat( buf, " The trees in this venerable old woodland grow straight and tall, " );		}
		else if ( i == 19 ) {
			strcat( buf, " The trees in this forest are marked with age, but remain straight and tall, " );		}
		else if ( i == 20 ) {
			strcat( buf, " The trees in this forest are marked with age, but remain straight and strong, " );		}
		else if ( i == 21 ) {
			strcat( buf, " The trees in this forest are marked with age, but remain tall and mighty, " );		}
		else if ( i == 22 ) {
			strcat( buf, " The trees in this old forest are marked with age, but remain tall and mighty, " );		}
		else if ( i == 23 ) {
			strcat( buf, " The trees in this ancient forest are marked with age, but remain tall and mighty, " );		}
		else if ( i == 24 ) {
			strcat( buf, " The trees throughout this forest are marked with age, but remain tall and strong, " );		}
		else if ( i == 25 ) {
			strcat( buf, " The ancient trees throughout this forest grow unchecked, " );		}
		else if ( i == 26 ) {
			strcat( buf, " The ancient trees throughout this wilderness grow unchecked, " );		}
		else if ( i == 27 ) {
			strcat( buf, " The ancient trees throughout this woodland grow unchecked, " );		}
		else if ( i == 28 ) {
			strcat( buf, " The trees throughout this ancient-seeming forest grow unchecked, " );		}
		else if ( i == 29 ) {
			strcat( buf, " The trees making up this ancient-seeming forest grow unchecked, " );		}
		else if ( i == 30 ) {
			strcat( buf, " There are many venerable trees making up this old forest, " );		}
		else if ( i == 31 ) {
			strcat( buf, " There are many venerable trees throughout this old forest, " );		}
		else if ( i == 32 ) {
			strcat( buf, " There are many venerable old trees within this old forest, " );		}

		i = number_range(1,20);
		strcat( buf, forest_adjective_array[i-1] );
		strcat( buf, " the  " );
		i = number_range(1,15);
		strcat( buf, forest_around_array[i-1] );
		strcat( buf, "." );
		}

		if ( firstSentence == FALSE )
		{
		/* constant first sentence structure */
			strcat( buf, "The");
			i = number_range(1,6);
			strcat( buf, forest_noun_array[i-1] );
			strcat( buf, " grows");
			i = number_range(1,7);
			strcat( buf, growth_verb_array[i-1] );
			i = number_range(1,6);
			strcat( buf, distance_desc_array[i-1] );
			strcat( buf, ".");
		}

		/* possible second sentence structure */
		if ( haveSentence == FALSE )
		{
		i = number_range(1,20);
		if ( i == 1 ) {
			strcat( buf, " Throughout the wilderness, the ground is hard and rocky. " );
			haveSentence = TRUE;	}
		else if ( i == 2 ) {
			strcat( buf, " Sticky cobwebs adorn the leaves and limbs of the surrounding trees. " );
			haveSentence = TRUE;	}
		else if ( i == 3 ) {
			strcat( buf, " Nearby trees bear thick, dark knots in their boles. " );
			haveSentence = TRUE;	}
		else if ( i == 4 ) {
			strcat( buf, " A nearby tree is deeply scarred, as if clawed by a wild animal. " );
			haveSentence = TRUE;	}
		else if ( i == 5 ) {
			strcat( buf, " An old tree, half rotted, has fallen over onto another tree nearby. " );
			haveSentence = TRUE;	}
		else if ( i == 6 ) {
			strcat( buf, " The bark of a nearby tree is blackened halfway up it's trunk, but not by fire. " );
			haveSentence = TRUE;	}
		else if ( i == 7 ) {
			strcat( buf, " A thick-boled tree has been split asunder by a blaze of lightning. " );
			haveSentence = TRUE;	}
		else if ( i == 8 ) {
			strcat( buf, " The sound of animal life can be heard in the nearby trees, a screech, a hiss or a snarl, and a rush of wings. " );
			haveSentence = TRUE;	}
		else if ( i == 9 ) {
			strcat( buf, " A large animal has broken through the nearby brush, leaving torn ground and broken branches in it's wake. " );
			haveSentence = TRUE;	}
		else if ( i == 10) {
			strcat( buf, " The wilderness closes in on itself, seeking to completely devour the land. " );
			haveSentence = TRUE;	}
		else {
			i = 0;
			haveSentence = FALSE;	}
		}

		/* constant second sentence structure */
		i = number_range(1,5);
		if ( i == 1 )
		{
			strcat( buf, "There are" );
			i = number_range(1,6);
			strcat( buf, number_growths_array[i-1] );
			i = number_range(1,10);
			strcat( buf, tree_type_array1[i-1] );
			strcat( buf, " and" );
			i = number_range(1,8);
			strcat( buf, tree_type_array2[i-1] );
			strcat( buf, " with" );
			i = number_range(1,7);
			strcat( buf, foilage_color_array[i-1] );
			strcat( buf, " colored" );
			i = number_range(1,12);
			strcat( buf, foilage_type_array[i-1] );
			strcat( buf, " on them." );
		}
		else if ( i == 2 )
		{
			strcat( buf, "There are" );
			i = number_range(1,6);
			strcat( buf, number_growths_array[i-1] );
			i = number_range(1,8);
			strcat( buf, tree_type_array2[i-1] );
			strcat( buf, " and" );
			i = number_range(1,10);
			strcat( buf, tree_type_array1[i-1] );
			strcat( buf, " with" );
			i = number_range(1,7);
			strcat( buf, foilage_color_array[i-1] );
			strcat( buf, " colored" );
			i = number_range(1,12);
			strcat( buf, foilage_type_array[i-1] );
			strcat( buf, " on them." );

		}
		else if ( i == 3 )
		{
			i = number_range(1,7);
			strcat( buf, number_growths_array2[i-1] );
			i = number_range(1,7);
			strcat( buf, tree_height_array[i-1] );
			strcat( buf, " hardwoods and" );
			i = number_range(1,3);
			strcat( buf, tree_evergreen_array[i-1] );
			i = number_range(1,6);
			strcat( buf, growth_verb_array2[i-1] );
			i = number_range(1,6);
			strcat( buf, forest_noun_array[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 4 )
		{
			strcat( buf, "A" );
			i = number_range(1,11);
			strcat( buf, water_desc_array[i-1] );
			i = number_range(1,13);
			strcat( buf, water_type_array[i-1] );
			i = number_range(1,14);
			strcat( buf, water_move_array[i-1] );
			i = number_range(1,4);
			strcat( buf, distance_desc_array2[i-1] );
			strcat( buf, " the nearby" );
			i = number_range(1,6);
			strcat( buf, forest_noun_array[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 5 )
		{
			i = number_range(1,11);
			strcat( buf, number_growths_array3[i-1] );
			i = number_range(1,5);
			strcat( buf, undergrowth_type_array[i-1] );
			i = number_range(1,5);
			strcat( buf, undergrowth_move_array[i-1] );
			strcat( buf, " the" );
			i = number_range(1,3);
			strcat( buf, forest_noun_array2[i-1] );
			strcat( buf, " floor." );
		}
		/* possible third sentence structure */
		if ( haveSentence == FALSE )
		{
		i = number_range(1,20);
		if ( i == 1 ) {
			strcat( buf, " The ground is hard and rocky throughout this reach of the wilderness. " );
			haveSentence = TRUE;
		}
		else if ( i == 2 ) {
			strcat( buf, " Cobwebs reach from the leaves to the limbs of the nearby trees. " );
			haveSentence = TRUE;
		}
		else if ( i == 3 ) {
			strcat( buf, " Nearby trees are pocked with large, dark knotholes in their trunks. " );
			haveSentence = TRUE;
		}
		else if ( i == 4 ) {
			strcat( buf, " This wilderness is home to an abundance of animal life, evidenced the tracks left in the ground. " );
			haveSentence = TRUE;
		}
		else if ( i == 5 ) {
			strcat( buf, " Several of the nearby trees, long since reached their peak, have fallen over upon themselves. " );
			haveSentence = TRUE;
		}
		else if ( i == 6 ) {
			strcat( buf, " There is a brief trail through the wilderness, providing a walkway through the trees. " );
			haveSentence = TRUE;
		}
		else if ( i == 7 ) {
			strcat( buf, " The roots of the trees that make up this wilderness make hazards along the scant trail. " );
			haveSentence = TRUE;
		}
		else if ( i == 8 ) {
			strcat( buf, " The sound of animal life is dominant in this area of the wilderness, but always hidden by the trees. " );
			haveSentence = TRUE;
		}
		else if ( i == 9 ) {
			strcat( buf, " Something large has left a broken tangle of nearby limbs and branches. " );
			haveSentence = TRUE;
		}
		else if ( i == 10) {
			strcat( buf, " The trees seem to have positioned themselves to block the entrances of their own accord. " );
			haveSentence = TRUE;
		}
		else {
			i = 0;
			haveSentence = FALSE;
		}
		}
		/* constant third sentence structure */
		i = number_range(1,5);
		if ( i == 1 )
		{
			i = number_range(1,3);
			strcat( buf, growth_noun_desc[i-1] );
			strcat( buf, " of" );
			i = number_range(1,4);
			strcat( buf, growth_stuff_array[i-1] );
			strcat( buf, " grows along the" );
			i = number_range(1,4);
			strcat( buf, growth_stuff_array2[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 2 )
		{
			i = number_range(1,4);
			strcat( buf, broke_desc_array[i-1] );
			i = number_range(1,5);
			strcat( buf, broke_type_array[i-1] );
			i = number_range(1,3);
			strcat( buf, broke_adverb_array[i-1] );
			strcat( buf, " the ground." );
		}
		else if ( i == 3 )
		{
			i = number_range(1,23);
			strcat( buf, growth_stuff_array3[i-1] );
			i = number_range(1,10);
			strcat( buf, growth_desc_array[i-1] );
			i = number_range(1,4);
			strcat( buf, distance_desc_array3[i-1] );
			i = number_range(1,4);
			strcat( buf, distance_desc_array4[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 4 )
		{
			i = number_range(1,16);
			strcat( buf, growth_stuff_array4[i-1] );
			i = number_range(1,10);
			strcat( buf, growth_desc_array[i-1] );
			i = number_range(1,4);
			strcat( buf, distance_desc_array3[i-1] );
			i = number_range(1,4);
			strcat( buf, distance_desc_array4[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 5 )
		{
			i = number_range(1,6);
			strcat( buf, growth_stuff_array5[i-1] );
			strcat( buf, " look to have been" );
			i = number_range(1,5);
			strcat( buf, distance_desc_array5[i-1] );
			strcat( buf, " to litter" );
			i = number_range(1,5);
			strcat( buf, place_desc_array[i-1] );
			strcat( buf, "." );
		}
		/* possible fourth sentence structure */
		if ( haveSentence == FALSE )
		{
			i = number_range(1,20);
			if ( i == 1 ) {
			strcat( buf, " The ground all around this area of the wilderness is hard and rocky. " );
			haveSentence = TRUE;
			}
			else if ( i == 2 ) {
			strcat( buf, " Something has created a nest high in the limbs of one of the nearby trees. " );
			haveSentence = TRUE;
			}
			else if ( i == 3 ) {
			strcat( buf, " One of the limbs overhead has been cracked by a heavy weight, and is close to falling. " );
			haveSentence = TRUE;
			}
			else if ( i == 4 ) {
			strcat( buf, " The ground bears marks of animal life, tracks left here and there, and easily seen. " );
			haveSentence = TRUE;
			}
			else if ( i == 5 ) {
			strcat( buf, " The only sounds to be hard throughout the wilderness are those created by the animals that inhabit it. " );
			haveSentence = TRUE;
			}
			else if ( i == 6 ) {
			strcat( buf, " Something close to a trail leads a path through the trees of this area of the wilderness. " );
			haveSentence = TRUE;
			}
			else if ( i == 7 ) {
			strcat( buf, " Gnarled old roots from the eldest of the surrounding trees in the wilderness, seek to overrun the bit of path there is. " );
			haveSentence = TRUE;
			}
			else if ( i == 8 ) {
			strcat( buf, " The sounds of animal life prevail in this area of the wilderness, and can be heard all around. " );
			haveSentence = TRUE;
			}
			else if ( i == 9 ) {
			strcat( buf, " An unknown creature has left a wake of broken limbs and branches in the surrounding wilderness. " );
			haveSentence = TRUE;
			}
			else if ( i == 10) {
			strcat( buf, " The trees make a natural wall, growing close, with smaller trees growing among them. " );
			haveSentence = TRUE;
			}
			else {
			i = 0;
			haveSentence = FALSE;
			}
		}
		switch ( number_range(1,6) )
		{
			case 1: /* insects */ break;
			case 2: /* flowers */
				i = number_range(1,15);
				strcat( buf, rr_flowers_table[i-1].growth );
				strcat( buf, " of " );
				strcat( buf, rr_flowers_table[i-1].height );
				strcat( buf, " " );
				strcat( buf, rr_flowers_table[i-1].color );
				strcat( buf, " " );
				strcat( buf, rr_flowers_table[i-1].name );
				strcat( buf, " grow nearby." );
				break;
			case 3: /* weeds */   break;
				i = number_range(1,15);
				strcat( buf, rr_weeds_table[i-1].growth );
				strcat( buf, " of " );
				strcat( buf, rr_weeds_table[i-1].height );
				strcat( buf, ", " );
				strcat( buf, rr_weeds_table[i-1].color );
				strcat( buf, " " );
				strcat( buf, rr_weeds_table[i-1].name );
				strcat( buf, " grow nearby." );
				break;
			case 4: /* animals */
				i = number_range( 1, 10 );
				strcat( buf, animals_array[i-1] );
				strcat( buf, animal_act_array[i-1] );
				strcat( buf, animal_noise_array[i-1] );
				i = number_range( 1, 10 );
				strcat( buf, " from " );
				strcat( buf, animal_location_array[i-1] );
				strcat( buf, "." );
				break;
			case 5:
				i = number_range(1,10);
				strcat( buf, rr_rocks_table[i-1].size );
				strcat( buf, " " );
				strcat( buf, rr_rocks_table[i-1].growth );
				strcat( buf, " of " );
				strcat( buf, rr_rocks_table[i-1].color );
				strcat( buf, " " );
				strcat( buf, rr_rocks_table[i-1].name );
				strcat( buf, " litter the ground." );
				break;
			case 6:
				break;
		}
		if ( haveSentence == FALSE ) {
			stc("There was no extra sentence generated.\n\r",ch);
		}

	    smash_tilde( buf );
		free_string( pRoom->description );
		pRoom->description = format_string( str_dup(buf) );
		/* format string free's the argument passed to it
		 * so we shouldn't pass it a local arg */
		do_function( ch, &do_look, "auto" );
		return;
	}
	/* end forest */

	/* begin coastal */
	else if ( !str_prefix( arg, "coast" ) )
	{
		char *coast_begin_array1[] = {
			"The coast", "The land's end", "The edge of the land", "The edge of the sea",
			"The shore", "The beach", "The seaboard", "The seaside",
			"The seacoast", "The seashore", "The waterfront",
			"The edge of the ocean", "The border of land and sea"
		};
		char *coast_around_array1[] = {
			" through here", " along this way", " along the way", " here abouts",
			" along here", " around here", " nearby", " at this point"
		};
		char *coast_around_array2[] = {
			" is rocky",
			" is an expanse of smooth beach",
			" is bordered by jagged rocks",
			" is pounded by crashing waves",
			" is littered with smooth stones",
			" is beaten by the surf",
			" seamlessly meets the water",
			" rolls endlessly on",
			" gives away to the blue water",
			" quickly changes to the sea",
			" abruptly changes from land to water",
			" is washed by gentle waves",
			" is flooded by a recent storm",
			" is covered with items washed up by the waves",
			" is spotted with btis of plantlife",
			" is strewn with items washed up from the water's depths"
		};
		char *coast_possible_array1[] = {
			" may see", " might see", " has seen", " sees", " has endured",
			" has weathered", " has stood through", " has stood up to",
			" has lasted through"
		};
		char *coast_weathering_array1[] = {
			" a fair amount", " a large amount", " quite a bit", " a good bit",
			" a large amount", " little", " a small amount",	" hardly any"
		};
		char *coast_weathering_array2[] = {
			" of the pounding by the waves", " of the damage by storm winds",
			" of the punishment from the sea", " of the baking by the sun",
			" of the wear from strong winds"
		};
		char *coast_bonus_array1[] = {
			"A pile of sea grass has been washed ashore, and has quickly begun to dry out.",
			"The heavy scent of the sea hangs thickly in the air.",
			"The sand has been smoothed like silk by the pounding of the waves.",
			"Piles of stones and sea plants mark the line of the high tide.",
			"Broken pieces of shells are scattered across the sand.",
			"A fish flops pathetically on the sand where it has been pushed ashore by a strong wave.",
			"Tiny pools of water form in crevices on the weathered rocks.",
			"The grains of sand are coarse, and resemble the larger stones along the coastline.",
			"Fine grains of sand cover the beach, nearly all the same size and color.",
			"A few hardy plants cling to life on the rocks."
		};
		char *coast_bonus_array2[] = {
			"The coast continues along",
			"The coast continues endlessly along",
			"The jagged coast lies along",
			"The coast borders along",
			"The rocky coast edges",
			"The rocky coast makes an edge to",
			"The sandy beach sits next to",
			"The beach runs abruptly to",
			"The beach stops suddenly at",
			"The beach flows seamlessly into"
		};
		char *coast_bonus_array3[] = {
			" the surrounding ", " the outlying ", " the endless", " the miles of",
			" the great expanse of", " the ceaseless depths of"
		};
		char *coast_bonus_array4[] = {
			" crashing waves", " blue water", " stormy seas",
			" calm waters", " lapping waves",
			" gentle waves", " wind tossed waves", " churning seas", " glassy seas"
		};

	    ch->desc->pEdit	= (void *) pRoom;
	    ch->desc->editor	= ED_ROOM;

	    /* possible first sentence structure */
	    EDIT_ROOM(ch, pRoom);

		i = number_range(1,13);
		strcat( buf, coast_begin_array1[i-1] );

		i = number_range(1,8);
		strcat( buf, coast_around_array1[i-1] );

		i = number_range(1,16);
		strcat( buf, coast_around_array2[i-1] );

		strcat( buf, ". " );
		i = number_range(1,13);
		strcat( buf, coast_begin_array1[i-1] );

		i = number_range(1,9);
		strcat( buf, coast_possible_array1[i-1] );

		i = number_range(1,9);
		strcat( buf, coast_weathering_array1[i-1] );

		i = number_range(1,5);
		strcat( buf, coast_weathering_array2[i-1] );
		strcat( buf, ". " );

		i = number_range(1,10);
		strcat( buf, coast_bonus_array1[i-1] );

		i = number_range(1,10);
		strcat( buf, coast_bonus_array2[i-1] );

		i = number_range(1,6);
		strcat( buf, coast_bonus_array3[i-1] );

		i = number_range(1,9);
		strcat( buf, coast_bonus_array4[i-1] );
		strcat( buf, "." );

	    smash_tilde( buf );
		free_string( pRoom->description );
		pRoom->description = format_string( str_dup(buf) );
		/* format string free's the argument passed to it
		 * so we shouldn't pass it a local arg */
		do_function( ch, &do_look, "auto" );
		return;
	}
	/* end coastal */

	else if ( !str_prefix( arg, "city" ) )
	{
		char *city_numberof_array1[] = {
			" few"," many"," abundant"," sparce"," several"
		};
		char *city_structtype_array1[] = {
			" homes"," shops"," buildings"," quarters"," abodes"
		};
		char *city_distance_array3[] = {
			" enough"," just enough"," about enough"," not quite enough",
			" not enough", " more than enough"," adequate", " ample", " quite enough",
			" easily enough", " almost enough"
		};
		char *city_spacedesc_array1[] = {
			" room"," area"," free space"," free area"," free room",
			" available area"," leftover land"," available land",
			" free land"," room around"," room through"," space around"
		};
		char *city_distance_array4[] =	{
			" through here"," around here"," nearby"," all around"," closely around"," all about"
		};
		char *city_structtype_array3[] =	{
			" many homes"," several homes"," old homes"," roads"," establishments",
			" shops and homes"," homes and shops"," byways"," businessess", " odd taverns and shops",
			" odd shops and buildings", " commerce and trade", " homes and yards", " roads and alleys"
		};
		char *city_amount_array1[] =	{
			" majority of"," greater amount of"," greater portion of"," large majority of",
			" mainstay of"
		};
		char *city_area_array1[] =	{
			" area"," region"," district"," portion"," section"
		};
		char *city_madeof_array1[] =	{
			" composed of"," built from"," made from"," crafted from"," shaped from"
		};
		char *city_road_array1[] =	{
			" way"," street"," route"," throughway"," track"," road"
		};
		char *city_road_array2[] =	{
			" continues along"," proceeds along"," carries along"
		};
		char *city_road_array3[] =	{
			" edged by"," surrounded by"," borbered by"," outlined by"
		};
		char *city_road_array4[] =	{
			" flowers"," feeding troughs"," hitching posts"," doors"," logs"
		};
		char *city_road_array5[] =	{
			" tiny gardens"," shuttered windows"," hedges"," shrubs"," low stone walls"," low brick walls"
		};
		char *city_road_array6[] =	{
			" paved"," bricked"," cobblestone"," flagstone"," cobbled"," gravel"," beaten earth"
		};
		char *city_road_array7[] =	{
			" street"," avenue"," boulevard"," roadway"," side street"," concourse"," road"
		};
		char *city_road_array8[] =	{
			" leads through"," goes around"," meanders throughout"," wanders about",
			" winds about"," twists it's way"," strolls around"
		};
		/* split this char into 2 chars */
		char *city_road_array9[] =	{
			" few"," widely spaced"," various"," many"," diverse"," several"," different",
			" cookie-cutter shaped"," differing"," similar"
		};
		char *city_road_array9a[] =	{
			" few"," various"," various"," many"," several",
		};
		char *city_road_array9b[] =	{
			" different"," cookie-cutter shaped"," differing"," similar"
		};
		char *city_road_array10[] =	{
			" homes"," houses"," dwellings"," abodes"," domiciles"
		};
		char *city_road_array11[] =	{
			" shops"," workshops"," storefronts"," retailers"," businesses"
		};
		char *city_road_array11a[] =	{
			" shops"," workshops"," storefronts"," retailers"," businesses",
			" homes"," houses"," dwellings"," abodes"," domiciles"
		};
	    ch->desc->pEdit	= (void *) pRoom;
	    ch->desc->editor	= ED_ROOM;

	    /* possible first sentence structure */
	    EDIT_ROOM(ch, pRoom);

		i = number_range(1,6);
		if ( i == 1 )
		{
		    strcat( buf, "The" );
			i = number_range(1,5);
			strcat( buf, city_amount_array1[i-1] );
			strcat( buf, " the" );
			i = number_range(1,5);
			strcat( buf, city_structtype_array1[i-1] );
			strcat( buf, " through this" );
			i = number_range(1,5);
			strcat( buf, city_area_array1[i-1] );
			strcat( buf, " tend to be" );
			i = number_range(1,5);
			strcat( buf, city_madeof_array1[i-1] );
			strcat( buf, " the same material as the outlying land." );
		}
		else if ( i == 2 )
		{
		    strcat( buf, "There is" );
			i = number_range(1,5);
			strcat( buf, city_distance_array3[i-1] );
			i = number_range(1,12);
			strcat( buf, city_spacedesc_array1[i-1] );
			i = number_range(1,6);
			strcat( buf, city_distance_array4[i-1] );
			strcat( buf, " for the" );
			i = number_range(1,5);
			strcat( buf, city_numberof_array1[i-1] );
			i = number_range(1,14);
			strcat( buf, city_structtype_array3[i-1] );
			strcat( buf, " that line the road." );
		}

/*		else if ( i == 2 )
		{
		    strcat( buf, "The" );
			i = number_range(1,5);
			strcat( buf, city_distance_array1[i-1] );
			i = number_range(1,4);
			strcat( buf, city_distance_array2[i-1] );
			strcat( buf, " the" );
			i = number_range(1,5);
			strcat( buf, city_numberof_array1[i-1] );
			i = number_range(1,5);
			strcat( buf, city_structtype_array1[i-1] );
			strcat( buf, ".");
		} */
		else if ( i == 3 )
		{
			strcat( buf, "There is" );
			i = number_range(1,11);
			strcat( buf, city_distance_array3[i-1] );
			i = number_range(1,12);
			strcat( buf, city_spacedesc_array1[i-1] );
			i = number_range(1,6);
			strcat( buf, city_distance_array4[i-1] );
			strcat( buf, " for the" );
			i = number_range(1,14);
			strcat( buf, city_structtype_array3[i-1] );
			strcat( buf, " that make up this area." );
		}
		else if ( i == 4 )
		{
			strcat( buf, "The" );
			i = number_range(1,6);
			strcat( buf, city_road_array1[i-1] );
			i = number_range(1,3);
			strcat( buf, city_road_array2[i-1] );
			strcat( buf, "," );
			i = number_range(1,4);
			strcat( buf, city_road_array3[i-1] );
			i = number_range(1,5);
			strcat( buf, city_road_array4[i-1] );
			strcat( buf, " and" );
			i = number_range(1,6);
			strcat( buf, city_road_array5[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 5 )
		{
			strcat( buf, "A" );
			i = number_range(1,7);
			strcat( buf, city_road_array6[i-1] );
			i = number_range(1,7);
			strcat( buf, city_road_array7[i-1] );
			i = number_range(1,7);
			strcat( buf, city_road_array8[i-1] );
			strcat( buf, " the" );
			i = number_range(1,10);
			strcat( buf, city_road_array9[i-1] );
			i = number_range(1,5);
			strcat( buf, city_road_array10[i-1] );
			strcat( buf, " and" );
			i = number_range(1,5);
			strcat( buf, city_road_array11[i-1] );
			strcat( buf, "." );
		}
		else if ( i == 6 )
		{
			strcat( buf, "A" );
			i = number_range(1,7);
			strcat( buf, city_road_array6[i-1] );
			i = number_range(1,7);
			strcat( buf, city_road_array7[i-1] );
			i = number_range(1,7);
			strcat( buf, city_road_array8[i-1] );
			strcat( buf, " the" );
			i = number_range(1,5);
			strcat( buf, city_road_array9a[i-1] );
			i = number_range(1,4);
			strcat( buf, city_road_array9b[i-1] );
			i = number_range(1,5);
			strcat( buf, city_road_array11[i-1] );
			strcat( buf, " and" );
			i = number_range(1,5);
			strcat( buf, city_road_array10[i-1] );
			strcat( buf, "." );
		}
		i = number_range(1,3);
		if ( i == 1 )
		{
			i = number_range(1,10);
			if (i == 1) strcat( buf, " At the corners of the alleys stand light-poles. " );
			else if (i == 2) strcat(buf, " Lighted lamps hang from poles at the corners of the streets. ");
			else if (i == 3) strcat(buf, " Oil lamps hang from light-poles on street corners. ");
			else if (i == 4) strcat(buf, " Oil burning lamps hang from nearby poles. ");
			else if (i == 5) strcat(buf, " Lamps hang at the corners of the alleys, though none are lit. ");
			else if (i == 6) {
				strcat(buf, " A group of nearby" );
				i = number_range(1,5);
				strcat( buf, city_road_array11[i-1] );
				strcat(buf, " stand taller than all the" );
				i = number_range(1,10);
				strcat( buf, city_road_array11a[i-1] );
				strcat(buf, " surrounding them. ");
			}
			else if (i == 7) strcat(buf, " Poles stand tall on each crossway to light the way. ");
			else if (i == 8) strcat(buf, " Lamps on tall shafts have been erected on intersections to iluminate the path. ");
			else if (i == 9) strcat(buf, " Each fork and turn in the road has tall lightpoles, heavy with oil lamps. ");
			else if (i == 10) strcat(buf, " Several of the lamps and nearby windows have been broken out by ruthless children. ");
		}
		if ( i == 2 )
		{
			i = number_range(1,8);
			if (i == 1) strcat( buf, " The stones that make up the road are lain down smoothly. " );
			else if (i == 2) strcat(buf, " Throughout the road, the paving stones are lain evenly. ");
			else if (i == 3) strcat(buf, " Evenly lain stones make up the road that passes through these parts. ");
			else if (i == 4) strcat(buf, " Paving stones are lain down in even symnetry to make up the road. ");
			else if (i == 5) strcat(buf, " The pavings that make up the road through here have withstood years of use. ");
			else if (i == 6) {
				strcat(buf, " Nearby, a set of" );
				i = number_range(1,5);
				strcat( buf, city_road_array11[i-1] );
				strcat(buf, " stand taller than all the" );
				i = number_range(1,10);
				strcat( buf, city_road_array11a[i-1] );
				strcat(buf, " surrounding them. ");
			}
			else if (i == 7) strcat(buf, " Cobblestones have been set to line the road through the city. ");
			else if (i == 8) strcat(buf, " Precise paving bricks have been cut so to fit along the road perfectly. ");
		}
		if ( i == 3 )
		{
			i = number_range(1,9);
			if (i == 1) strcat( buf, " A nearby home dominates the other buildings in this neighborhood. " );
			else if (i == 2) strcat(buf, " The buildings through here seem to be collected into groups. ");
			else if (i == 3) strcat(buf, " Throughout this entire section, the buildings are gathered into groups. ");
			else if (i == 4) strcat(buf, " The neighborhood seems fairly tightly knit, with the buildings closed together in groups. ");
			else if (i == 5) strcat(buf, " The neighborhood here is fairly quiet, and the road a little less travelled. ");
			else if (i == 6) {
				strcat(buf, " A set of nearby" );
				i = number_range(1,5);
				strcat( buf, city_road_array11[i-1] );
				strcat(buf, " stand taller than all the" );
				i = number_range(1,10);
				strcat( buf, city_road_array11a[i-1] );
				strcat(buf, " surrounding them. ");
			}
			else if (i == 7) strcat(buf, " Shoppes and homes are almost seemless in their proximity throughout the vicinity. ");
			else if (i == 8) strcat(buf, " This district is so popular that each structure is almost on top of its neighbor. ");
			else if (i == 9) strcat(buf, " Loose shingles droop precariously from the roof of a nearby home. ");
		}
		i = number_range(1,2);
		if ( i == 1 )
		{
			i = number_range(1,4);
			if (i == 1) strcat( buf, " All in all, the city appears much the same here as other areas. " );
			else if ( i == 2 ) strcat(buf, " Otherwise, the city appears the same as it does in other areas here abouts. ");
			else if ( i == 3 ) strcat(buf, " This area otherwise bears great resemblance in form and shape to the majority of the city. ");
			else if ( i == 4 ) strcat(buf, " This district is otherwise greatly similar to the remainder of the city. ");
		}
		else if ( i == 2 )
		{
			i = number_range(1,3);
			if (i == 1) strcat(buf, " The city road otherwise continues to wind it's way along. ");
			else if ( i == 2 ) strcat(buf, " The road continues to make it's way steadily throughout the city. ");
			else if ( i == 3 ) {
				char *tmp_array1[] = {
				" The city road", " The city highway", "The city street",
				" The road", " The highway", "The street"," The way"
				" The roadway"," The route"," The approach"
				};
				char *tmp_array2[] = {
				" continues to wind it's way along through here",
				" continues to lead steadily through the area",
				" winds it's way steadily along through here",
				" continues to keep a steady pace through this area",
				" makes it's way along the same as it has",
				" continues to make it's way along, the same as it has",
				" works it's way along, oblivious to all else in it's path",
				" continues to weave and twist along the route"
				};
				i = number_range(1,10);
				strcat(buf, tmp_array1[i-1] );
				strcat(buf, " otherwise" );
				i = number_range(1,8);
				strcat(buf, tmp_array2[i-1] );
				strcat(buf, ".");
			}
		}
	    smash_tilde( buf );
		free_string( pRoom->description );
		pRoom->description = format_string( str_dup(buf) );
		do_function( ch, &do_look, "auto" );
		return;
	}
	/* end city */

	else if ( !str_prefix( arg, "road" ) )
	{
		char *road_begin_array1[] = {
			"The road", "The highway", "The street", "The throughway",
			"The roadway", "The pathway", "The coach road", "The cart road",
			"The wagon road", "The track", "The bridle path", "The thoroughfare",
			"The route", "The beaten track", "The beaten road", "The approach"
		};
		char *road_around_array1[] = {
			" through here", " along this way", " along the way", " here abouts",
			" along here", " around here"
		};
		char *road_around_array2[] = {
			" is straight", " is fairly straight", " is arrow straight", " goes on and on",
			" twists around a bit", " runs smoothly along", "twists and turns",
			" leads along smoothly", " gets a little rough", " gets a bit bumpy",
			" is a little rough", " is a bit rough", " well-trodden"
		};
		char *road_possible_array1[] = {
			" may see", " might see", " has seen", " sees", " has endured",
			" has weathered", " has stood through", " has stood up to",
			" has lasted through"
		};
		char *road_travelled_array1[] = {
			" a fair amount", " a large amount", " quite a bit", " a good bit",
			" a large amount", " a steady flow"
		};
		char *road_travelled_array2[] = {
			" of traffic", " of use", " of usage", " of utilization", " of wear"
		};
		char *road_grants_array1[] = {
			" provides for", " allows", " gives", " provides", " allows for",
			" grants", " grants access to", " gives access to", " allows access to",
			" bestows"
		};
		char *road_around_array3[] = {
			" through here", " along this way", " this way", " along through here",
			" here abouts", " in this area", " along here"
		};
		char *road_around_array4[] = {
			" leads through", " runs through", " makes it's way through",
			" runs along through", " leads among", " runs among", " travels through",
			" travels among", " travels along through"
		};
		char *road_around_array5[] = {
			" forcing it's way through", " crowding out", " pushing aside",
			" making it's way through", " cutting through", " pushing through"
		};
		char *road_bonus_array1[] = {
			"Small patches of scraggly brush grow alongside the road for a bit.",
			"A small, rapidly drying puddle remains from the last rain.",
			"An old broken cart wheel lies discarded on the side of the road.",
			"A ruined horse shoe sits in the ditch on the side of the road.",
			"The remains of a camp sit off to the side of the road.",
			"The decaying corpse of what was once an animal has been pushed to the edge of the road.",
			"Nearby, on the edge of the road, marks where a small fire had been made not long ago.",
			"The old cobble stones making up the road have been worn away over time, but still pave the way.",
			"The cobblestones that make up the road have weathered away over time, but still pave the way.",
			"The last rain has washed the road clean of dust."
		};
		char *road_bonus_array2[] = {
			"The road leads it's way along through","The road leads steadily along through",
			"The road makes it's way through","The road makes it's way steadily through",
			"The road travels through","The road travels smoothly through",
			"The road travels among","The road travels steadfastly among",
			"The road travels along through","The road travels steadily along through",
			"The road passes among","The road passes among",
			"The road steadily leads along","The road steadfastly leads along",
			"The road makes it's trek through","The road continues to trek through",
			"The road treks it's way through","The road faithfully treks through",
			"The road treks among","The road steadily treks among"
		};
		char *road_bonus_array3[] = {
			" the surrounding ", " the outlying "
		};
		char *road_bonus_array4[] = {
			" landscape", " territory", " area", "surroundings", " countryside",
			" country"
		};
		char *road_bonus_array5[] = {
			" appears well travelled, but it"," could use some work, but it",
			" appears well maintained, and it"," is a little worse for the wear, but it",
			" appears to be in good condition as it"," bears heavy travel marks as it",
			" appears to be in fair condition as it"," has served it's purpose well, and it",
			" appears to be in good repair as it"," has seen recent maintenance, but it",
			" is well travelled, and it"," has seen recent work, but it",
			" is in good repair, and it"," is often travelled, and it",
			" is in fair repair, and it"," appears travelled often, but it",
			" is traveled often, but it"
		};
		char *road_desc_array1[] = {
			"The paving stones of the road bear resemblance to the earth around here, suggesting it comes from nearby.",
			"The road leads inevitably onwards towards it's final destination.",
			"The road makes it's way steadily on towards it's destination.",
			"The road leads along it's appointed path, towards it's destination.",
			"The road continues onwards in each direction.",
			"The road continues to lead along it's appointed path.",
			"The road continues along the path set before it.",
			"The road follows steadily along it's appointed route.",
			"The road leads the way along, continuing towards it's destination.",
			"The road make it's way along, unfailing in the trip to it's destination."
		};
		char *road_desc_array2[] = {
			"The stones of the road bear a marked resemblance to the surrounding land.",
			"The road leads on towards it's final destination.",
			"The road continues to make it's way towards it's destination.",
			"The road continues on, despite all obstacles.",
			"The road veers only slightly as it continues onward.",
			"The road stretches out, traversing the land.",
			"The road yields to nothing as it stretches out across the land.",
			"The road follows it's course steadily as it seeks it's destination.",
			"The road never veers from the route it travels, seeking it's destination.",
			"The road continues faithfully on."
		};
		char *road_desc_array3[] = {
			" travels on paving stones that bear resemblance to the earth around here, suggesting it comes from nearby.",
			" leads inevitably onwards towards it's final destination.",
			" makes it's way steadily on towards it's destination.",
			" leads along it's appointed path, towards it's destination.",
			" continues onwards in each direction.",
			" continues to lead along it's appointed path.",
			" continues along the path set before it.",
			" follows steadily along it's appointed route.",
			" leads the way along, continuing towards it's destination.",
			" makes it's way along, unfailing in the trip to it's destination."
		};
		char *road_desc_array4[] = {
			" leads along on stones that bear a marked resemblance to the surrounding land.",
			" leads on towards it's final destination.",
			" continues to make it's way towards it's destination.",
			" continues on, despite all obstacles.",
			" veers only slightly as it continues onward.",
			" stretches out, traversing the land.",
			" yields to nothing as it stretches out across the land.",
			" follows it's course steadily as it seeks it's destination.",
			" never veers from the route it travels, seeking it's destination.",
			" continues faithfully on."
		};

		i = number_range(1,3);
		if ( i == 1 )
		{
			i = number_range(1,16);
			strcat( buf, road_begin_array1[i-1] );
			i = number_range(1,6);
			strcat( buf, road_around_array1[i-1] );
			i = number_range(1,13);
			strcat( buf, road_around_array2[i-1] );
			strcat( buf, ", and looks as if it " );
			i = number_range(1,9);
			strcat( buf, road_possible_array1[i-1] );
			i = number_range(1,6);
			strcat( buf, road_travelled_array1[i-1] );
			i = number_range(1,5);
			strcat( buf, road_travelled_array2[i-1] );
			strcat( buf, "." );
			strcat( buf, "The surrounding " );
			strcat( buf, flag_string( sector_flags, pRoom->sector_type ) );
			i = number_range(1,10);
			strcat( buf, road_grants_array1[i-1] );
			strcat( buf, " a view of the outlying landscape." );
			needSentence = FALSE;
		}
		else if ( i == 2 )
		{
			i = number_range(1,16);
			strcat( buf, road_begin_array1[i-1] );
			i = number_range(1,7);
			strcat( buf, road_around_array3[i-1] );
			i = number_range(1,9);
			strcat( buf, road_around_array4[i-1] );
			strcat( buf, " the outlying " );
			strcat( buf, flag_string( sector_flags, pRoom->sector_type ) );
			strcat( buf, ", " );
			i = number_range(1,6);
			strcat( buf, road_around_array5[i-1] );
			strcat( buf, " the landscape." );
			i = number_range(1,10);
			strcat( buf, road_bonus_array1[i-1] );
			needSentence = FALSE;
		}
		else if ( i == 3 )
		{
			i = number_range(1,20);
			strcat( buf, road_bonus_array2[i-1] );
			i = number_range(1,2);
			strcat( buf, road_bonus_array3[i-1] );
			strcat( buf, flag_string( sector_flags, pRoom->sector_type ) );
			strcat( buf, " that make up the " );
			i = number_range(1,6);
			strcat( buf, road_bonus_array4[i-1] );
			strcat( buf, "." );
			strcat( buf, " The road itself" );
			i = number_range(1,17);
			strcat( buf, road_bonus_array5[i-1] );
			needSentence = TRUE;
		}
		i = number_range(1,2);
		if ( needSentence == FALSE )
		{
			if ( i == 1 )
			{
				i = number_range(1,10);
				strcat( buf, road_desc_array1[i-1] );
			}
			else if ( i == 2 )
			{
				i = number_range(1,10);
				strcat( buf, road_desc_array2[i-1] );
			}
		}
		else if ( needSentence == TRUE )
		{
			if ( i == 1 )
			{
				i = number_range(1,10);
				strcat( buf, road_desc_array3[i-1] );
			}
			else if ( i == 2 )
			{
				i = number_range(1,10);
				strcat( buf, road_desc_array4[i-1] );
			}
		}

	    smash_tilde( buf );
		free_string( pRoom->description );
		pRoom->description = format_string( str_dup(buf) );
		do_function( ch, &do_look, "auto" );
		switch ( pRoom->sector_type )
		{
		default: break;
		case SECT_INSIDE:
			stc("Warning, invalid sector for a road. Please correct this.\n\r",ch);
			break;
		}
		return;
	}
	/* end road */

	else
	{
		stc( "A valid sector type is required.\n\r" , ch );
		stc( "(forest road is currently available)\n\r" , ch );
       	return;
	}

}

