/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"

void do_rdesc( CHAR_DATA *ch, char *argument )
{
    char buf[MSL];
    char endbit[2];
    int played;

    if ( !IS_NPC(ch) )
    {
	if (IS_SET(ch->penalty_flags,PENAL_NOWALK))
	{
		stc("You cannot set your Room Description.\n\r",ch);
		return;
	}
	played = ( ch->played + (int) (current_time - ch->logon) ) / 3600;
	/*if ( ch->level < 10 )*/
	if ( played < 4 && ch->pcdata->rebirth <= 0 )
	{
		stc("You must have 4 hours of playing time to set your Room Description.\n\r",ch);
		return;
	}
	smash_tilde( argument );

    endbit[0] = argument[strlen(argument)-1];
    endbit[1] = '\0';

	if (argument[0] == '\0')
	{
        sprintf(buf,"Your Room Description is %s\n\r{c",ch->pcdata->rdesc);
	    stc(buf,ch);
	    return;
	}

	if (!strcmp(argument, "clear"))
	{
		free_string( ch->pcdata->rdesc );
		ch->pcdata->rdesc = NULL;
		stc( "Room Description cleared.\n\r{c", ch);
		return;
	}

	if ( strlen( argument ) < 20 )
	{
		stc( "The Room Description message must be at least twenty characters in length.\n\r", ch);
		return;
	}

    if ( strcmp( endbit, "." ) )
	{
		stc("A Room Description must end in a period.\n\r",ch);
		return;
	}

	if ( strlen( argument ) > 65 )
	{
	    stc( "The total number of characters may not exceed 65, including color codes.\n\r",ch);
	    stc( "Room Descriptions should not exceed more than one line.\n\r",ch);
	    stc( "Room Descriptions should also not be gaudishly color filled.\n\r",ch);
	    return;
	}

	/*if ( strstr(argument,ch->name) == NULL)
	{
	    stc( "{cYou must include your name.\n\r{c",ch);
	    return;
	}*/

    free_string( ch->pcdata->rdesc );
    ch->pcdata->rdesc = str_dup( argument );

    sprintf(buf,"{cYour Room Description is now %s\n\r{c",ch->pcdata->rdesc);
    stc(buf,ch);
    }
    return;
}
