/*************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <malloc.h>
#include <sys/stat.h>
#include "aww.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"
#include "interp.h"

#if !defined(macintosh)
extern  int     _filbuf         args( (FILE *) );
#endif


void	fwrite_rle	args((char *explored, FILE *fp));
void	fread_rle	args((char *explored, FILE *fp));

/* those summaries which reset per session are recorded here */
void reset_summary( CHAR_DATA *ch )
{
	ch->pcdata->summary[SUM_XP_EARNED] = 0;
	ch->pcdata->summary[SUM_LEVELS_GAINED] = 0;
	ch->pcdata->summary[SUM_CRITICALS_INFLICTED] = 0;
	ch->pcdata->summary[SUM_CRITICALS_TAKEN] = 0;
	ch->pcdata->summary[SUM_MOB_KILLS] = 0;
	ch->pcdata->summary[SUM_PC_KILLS] = 0;
	ch->pcdata->summary[SUM_TOURNIES_WON] = 0;
	ch->pcdata->summary[SUM_TRIVIA_ANSWERED] = 0;
	ch->pcdata->summary[SUM_MOTES] = 0;
	ch->pcdata->summary[SUM_AUCTIONS_WON] = 0;
	ch->pcdata->summary[SUM_DEATHS] = 0;
	ch->pcdata->summary[SUM_REBIRTHS] = 0;
	ch->pcdata->summary[SUM_QUESTS_DONE] = 0;
	ch->pcdata->summary[SUM_QPS_EARNED] = 0;
}


/* int rename(const char *oldfname, const char *newfname); viene en stdio.h */

	/*  now defined in newbie.c
void set_features( CHAR_DATA *ch )
{
	switch ( ch->pcdata->eye )
	{
		default: ch->eye = str_dup( "blue" ); break;
		case 0: ch->eye = str_dup( "blue" ); break;
		case 1: ch->eye = str_dup( "sky-blue" ); break;
		case 2: ch->eye = str_dup( "dark-blue" ); break;
		case 3: ch->eye = str_dup( "cobalt-blue" ); break;
		case 4: ch->eye = str_dup( "light-blue" ); break;
		case 5: ch->eye = str_dup( "misty-blue" ); break;
		case 6: ch->eye = str_dup( "clear-blue" ); break;
		case 7: ch->eye = str_dup( "brown" ); break;
		case 8: ch->eye = str_dup( "sandy-brown" ); break;
		case 9: ch->eye = str_dup( "light-brown" ); break;
		case 10: ch->eye = str_dup( "dark-brown" ); break;
		case 11: ch->eye = str_dup( "smokey-brown" ); break;
		case 12: ch->eye = str_dup( "dirt-brown" ); break;
		case 13: ch->eye = str_dup( "muddy-brown" ); break;
		case 14: ch->eye = str_dup( "sea-green" ); break;
		case 15: ch->eye = str_dup( "light-green" ); break;
		case 16: ch->eye = str_dup( "blue-green" ); break;
		case 17: ch->eye = str_dup( "gray" ); break;
		case 18: ch->eye = str_dup( "misty-gray" ); break;
		case 19: ch->eye = str_dup( "smoky-gray" ); break;
		case 20: ch->eye = str_dup( "cloudy-gray" ); break;
		case 21: ch->eye = str_dup( "slate-gray" ); break;
		case 22: ch->eye = str_dup( "hazy-gray" ); break;
		case 23: ch->eye = str_dup( "black" ); break;
		case 24: ch->eye = str_dup( "flat-black" ); break;
		case 25: ch->eye = str_dup( "coal-black" ); break;
		case 26: ch->eye = str_dup( "jet-black" ); break;
		case 27: ch->eye = str_dup( "pitch-black" ); break;
		case 28: ch->eye = str_dup( "night-black" ); break;
		case 29: ch->eye = str_dup( "dull-black" ); break;
		case 30: ch->eye = str_dup( "green" ); break;
		case 31: ch->eye = str_dup( "emerald-green" ); break;
		case 32: ch->eye = str_dup( "dark-green" ); break;
		case 33: ch->eye = str_dup( "bright-green" ); break;
	}

	switch ( ch->pcdata->hair1 )
	{
		default: ch->hair1 = str_dup( "brown" ); break;
		case 0: ch->hair1 = str_dup( "wolf" ); break;
		case 1: ch->hair1 = str_dup( "lizard" ); break;
		case 2: ch->hair1 = str_dup( "ram" ); break;
		case 3: ch->hair1 = str_dup( "hawk" ); break;
		case 4: ch->hair1 = str_dup( "lion" ); break;
		case 5: ch->hair1 = str_dup( "jackal" ); break;
		case 6: ch->hair1 = str_dup( "rat" ); break;
		case 7: ch->hair1 = str_dup( "raven" ); break;
		case 8: ch->hair1 = str_dup( "boar" ); break;
		case 9: ch->hair1 = str_dup( "snake" ); break;
		case 10: ch->hair1 = str_dup( "mutt" ); break;
		case 11: ch->hair1 = str_dup( "mangled" ); break;
		case 12: ch->hair1 = str_dup( "brown" ); break;
		case 13: ch->hair1 = str_dup( "red" ); break;
		case 14: ch->hair1 = str_dup( "blonde" ); break;
		case 15: ch->hair1 = str_dup( "black" ); break;
		case 16: ch->hair1 = str_dup( "gray" ); break;
		case 17: ch->hair1 = str_dup( "white" ); break;
	}
	switch ( ch->pcdata->hair2 )
	{
		default: ch->hair2 = str_dup( "dark-" ); break;
		case 0: ch->hair2 = str_dup( "dark-" ); break;
		case 1: ch->hair2 = str_dup( "light-" ); break;
		case 2: ch->hair2 = str_dup( "deep-" ); break;
		case 3: ch->hair2 = str_dup( "shiny-" ); break;
		case 4: ch->hair2 = str_dup( "soft-" ); break;
		case 5: ch->hair2 = str_dup( "sandy-" ); break;
		case 6: ch->hair2 = str_dup( "fiery-" ); break;
		case 7: ch->hair2 = str_dup( "dirty-" ); break;
		case 8: ch->hair2 = str_dup( "rust-" ); break;
		case 9: ch->hair2 = str_dup( "jet-" ); break;
	}
	switch ( ch->pcdata->hair3 )
	{
		default: ch->hair3 = str_dup( "straight" ); break;
		case 0: ch->hair3 = str_dup( "straight" ); break;
		case 1: ch->hair3 = str_dup( "curly" ); break;
		case 2: ch->hair3 = str_dup( "wavy" ); break;
		case 3: ch->hair3 = str_dup( "kinky" ); break;
		case 4: ch->hair3 = str_dup( "oily" ); break;
		case 5: ch->hair3 = str_dup( "dry" ); break;
		case 6: ch->hair3 = str_dup( "fine" ); break;
		case 7: ch->hair3 = str_dup( "stringy" ); break;
	}
	switch ( ch->pcdata->hair4 )
	{
		default: ch->hair4 = str_dup( "short" ); break;
		case 0: ch->hair4 = str_dup( "short" ); break;
		case 1: ch->hair4 = str_dup( "shoulder-length" ); break;
		case 2: ch->hair4 = str_dup( "cropped" ); break;
		case 3: ch->hair4 = str_dup( "very-long" ); break;
		case 4: ch->hair4 = str_dup( "waist-length" ); break;
		case 5: ch->hair4 = str_dup( "long" ); break;
		case 6: ch->hair4 = str_dup( "stubby" ); break;
		case 7: ch->hair4 = str_dup( "shorn" ); break;
		case 8: ch->hair4 = str_dup( "clipped" ); break;
	}
}
		*/
void convert_features( CHAR_DATA *ch )
{
	/* convert the eye string to an integer */
	if ( !str_cmp ( ch->eye, "blue" ) )               ch->pcdata->eye = 0;
	else if ( !str_cmp ( ch->eye, "sky-blue" ) )      ch->pcdata->eye = 1;
	else if ( !str_cmp ( ch->eye, "dark-blue" ) )     ch->pcdata->eye = 2;
	else if ( !str_cmp ( ch->eye, "cobalt-blue" ) )   ch->pcdata->eye = 3;
	else if ( !str_cmp ( ch->eye, "light-blue" ) )    ch->pcdata->eye = 4;
	else if ( !str_cmp ( ch->eye, "misty-blue" ) )    ch->pcdata->eye = 5;
	else if ( !str_cmp ( ch->eye, "clear-blue" ) )    ch->pcdata->eye = 6;
	else if ( !str_cmp ( ch->eye, "brown" ) )         ch->pcdata->eye = 7;
	else if ( !str_cmp ( ch->eye, "sandy-brown" ) )   ch->pcdata->eye = 8;
	else if ( !str_cmp ( ch->eye, "light-brown" ) )   ch->pcdata->eye = 9;
	else if ( !str_cmp ( ch->eye, "dark-brown" ) )    ch->pcdata->eye = 10;
	else if ( !str_cmp ( ch->eye, "smokey-brown" ) )  ch->pcdata->eye = 11;
	else if ( !str_cmp ( ch->eye, "dirt-brown" ) )    ch->pcdata->eye = 12;
	else if ( !str_cmp ( ch->eye, "muddy-brown" ) )   ch->pcdata->eye = 13;
	else if ( !str_cmp ( ch->eye, "sea-green" ) )     ch->pcdata->eye = 14;
	else if ( !str_cmp ( ch->eye, "light-green" ) )   ch->pcdata->eye = 15;
	else if ( !str_cmp ( ch->eye, "blue-green" ) )    ch->pcdata->eye = 16;
	else if ( !str_cmp ( ch->eye, "gray" ) )          ch->pcdata->eye = 17;
	else if ( !str_cmp ( ch->eye, "misty-gray" ) )    ch->pcdata->eye = 18;
	else if ( !str_cmp ( ch->eye, "smokey-gray" ) )   ch->pcdata->eye = 19;
	else if ( !str_cmp ( ch->eye, "cloudy-gray" ) )   ch->pcdata->eye = 20;
	else if ( !str_cmp ( ch->eye, "slate-gray" ) )    ch->pcdata->eye = 21;
	else if ( !str_cmp ( ch->eye, "hazy-gray" ) )     ch->pcdata->eye = 22;
	else if ( !str_cmp ( ch->eye, "black" ) )         ch->pcdata->eye = 23;
	else if ( !str_cmp ( ch->eye, "flat-black" ) )    ch->pcdata->eye = 24;
	else if ( !str_cmp ( ch->eye, "coal-black" ) )    ch->pcdata->eye = 25;
	else if ( !str_cmp ( ch->eye, "jet-black" ) )     ch->pcdata->eye = 26;
	else if ( !str_cmp ( ch->eye, "pitch-black" ) )   ch->pcdata->eye = 27;
	else if ( !str_cmp ( ch->eye, "night-black" ) )   ch->pcdata->eye = 28;
	else if ( !str_cmp ( ch->eye, "dull-black" ) )    ch->pcdata->eye = 29;
	else if ( !str_cmp ( ch->eye, "green" ) )         ch->pcdata->eye = 30;
	else if ( !str_cmp ( ch->eye, "emerald-green" ) ) ch->pcdata->eye = 31;
	else if ( !str_cmp ( ch->eye, "dark-green" ) )    ch->pcdata->eye = 32;
	else if ( !str_cmp ( ch->eye, "bright-green" ) )  ch->pcdata->eye = 33;
	else ch->pcdata->eye = 0;

	/* convert the hair1 string to an integer - trollocs first */
	if ( !str_cmp( ch->hair1, "wolf" ) ) ch->pcdata->hair1 = 0;
	else if ( !str_cmp( ch->hair1, "lizard" ) ) ch->pcdata->hair1 = 1;
	else if ( !str_cmp( ch->hair1, "ram" ) ) ch->pcdata->hair1 = 2;
	else if ( !str_cmp( ch->hair1, "hawk" ) ) ch->pcdata->hair1 = 3;
	else if ( !str_cmp( ch->hair1, "lion" ) ) ch->pcdata->hair1 = 4;
	else if ( !str_cmp( ch->hair1, "jackal" ) ) ch->pcdata->hair1 = 5;
	else if ( !str_cmp( ch->hair1, "rat" ) ) ch->pcdata->hair1 = 6;
	else if ( !str_cmp( ch->hair1, "raven" ) ) ch->pcdata->hair1 = 7;
	else if ( !str_cmp( ch->hair1, "boar" ) ) ch->pcdata->hair1 = 8;
	else if ( !str_cmp( ch->hair1, "snake" ) ) ch->pcdata->hair1 = 9;
	else if ( !str_cmp( ch->hair1, "mutt" ) ) ch->pcdata->hair1 = 10;
	else if ( !str_cmp( ch->hair1, "mangled" ) ) ch->pcdata->hair1 = 11;
	else if ( !str_cmp( ch->hair1, "brown" ) ) ch->pcdata->hair1 = 12;
	else if ( !str_cmp( ch->hair1, "red" ) ) ch->pcdata->hair1 = 13;
	else if ( !str_cmp( ch->hair1, "blonde" ) ) ch->pcdata->hair1 = 14;
	else if ( !str_cmp( ch->hair1, "black" ) ) ch->pcdata->hair1 = 15;
	else if ( !str_cmp( ch->hair1, "gray" ) ) ch->pcdata->hair1 = 16;
	else if ( !str_cmp( ch->hair1, "white" ) ) ch->pcdata->hair1 = 17;
	else ch->pcdata->hair1 = 12;

	/* convert the hair2 string to an integer */
	if ( !str_cmp( ch->hair2, "dark-" ) ) ch->pcdata->hair2 = 0;
	else if ( !str_cmp( ch->hair2, "light-" ) ) ch->pcdata->hair2 = 1;
	else if ( !str_cmp( ch->hair2, "deep-" ) ) ch->pcdata->hair2 = 2;
	else if ( !str_cmp( ch->hair2, "shiny-" ) ) ch->pcdata->hair2 = 3;
	else if ( !str_cmp( ch->hair2, "soft-" ) ) ch->pcdata->hair2 = 4;
	else if ( !str_cmp( ch->hair2, "sandy-" ) ) ch->pcdata->hair2 = 5;
	else if ( !str_cmp( ch->hair2, "fiery-" ) ) ch->pcdata->hair2 = 6;
	else if ( !str_cmp( ch->hair2, "dirty-" ) ) ch->pcdata->hair2 = 7;
	else if ( !str_cmp( ch->hair2, "rust-" ) ) ch->pcdata->hair2 = 8;
	else if ( !str_cmp( ch->hair2, "jet-" ) ) ch->pcdata->hair2 = 9;
	else ch->pcdata->hair2 = 0;

	/* convert the hair3 string to an integer */
	if ( !str_cmp( ch->hair3, "straight" ) ) ch->pcdata->hair3 = 0;
	else if ( !str_cmp( ch->hair3, "curly" ) ) ch->pcdata->hair3 = 1;
	else if ( !str_cmp( ch->hair3, "wavy" ) ) ch->pcdata->hair3 = 2;
	else if ( !str_cmp( ch->hair3, "kinky" ) ) ch->pcdata->hair3 = 3;
	else if ( !str_cmp( ch->hair3, "oily" ) ) ch->pcdata->hair3 = 4;
	else if ( !str_cmp( ch->hair3, "dry" ) ) ch->pcdata->hair3 = 5;
	else if ( !str_cmp( ch->hair3, "fine" ) ) ch->pcdata->hair3 = 6;
	else if ( !str_cmp( ch->hair3, "stringy" ) ) ch->pcdata->hair3 = 7;
	else ch->pcdata->hair3 = 0;

	/* convert the hair4 string to an integer */
	if ( !str_cmp( ch->hair4, "short" ) ) ch->pcdata->hair4 = 0;
	else if ( !str_cmp( ch->hair4, "shoulder-length" ) ) ch->pcdata->hair4 = 1;
	else if ( !str_cmp( ch->hair4, "cropped" ) ) ch->pcdata->hair4 = 2;
	else if ( !str_cmp( ch->hair4, "very-long" ) ) ch->pcdata->hair4 = 3;
	else if ( !str_cmp( ch->hair4, "waist-length" ) ) ch->pcdata->hair4 = 4;
	else if ( !str_cmp( ch->hair4, "long" ) ) ch->pcdata->hair4 = 5;
	else if ( !str_cmp( ch->hair4, "stubby" ) ) ch->pcdata->hair4 = 6;
	else if ( !str_cmp( ch->hair4, "shorn" ) ) ch->pcdata->hair4 = 7;
	else if ( !str_cmp( ch->hair4, "clipped" ) ) ch->pcdata->hair4 = 8;
	else ch->pcdata->hair4 = 0;

	if ( ch->version < 13 ) ch->version = 13;
}

char *print_flags(int flag)
{
    int count, pos = 0;
    static char buf[52];


    for (count = 0; count < 32;  count++)
    {
        if (IS_SET(flag,1<<count))
        {
            if (count < 26)
                buf[pos] = 'A' + count;
            else
                buf[pos] = 'a' + (count - 26);
            pos++;
        }
    }

    if (pos == 0)
    {
        buf[pos] = '0';
        pos++;
    }

    buf[pos] = '\0';

    return buf;
}

/*
 * Array of containers read for proper re-nesting of objects.
 */
#define MAX_NEST	100
static	OBJ_DATA *	rgObjNest	[MAX_NEST];



/*
 * Local functions.
 */
void	fwrite_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fwrite_obj	args( ( CHAR_DATA *ch,  OBJ_DATA  *obj,
			    FILE *fp, int iNest ) );
void	fwrite_pet	args( ( CHAR_DATA *pet, FILE *fp) );
void	fwrite_mount	args( ( CHAR_DATA *pet, FILE *fp) );
void	fread_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_pet	args( ( CHAR_DATA *ch,  FILE *fp ) );
void    fread_mount	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fread_obj	args( ( CHAR_DATA *ch,  FILE *fp ) );

void save_char_obj(CHAR_DATA * ch, bool backup, bool save_other)
{
	char strsave[MAX_INPUT_LENGTH];
	FILE *fp;

	if ( IS_NPC(ch) )
		return;

	if ( ch->desc != NULL && ch->desc->original != NULL )
		ch = ch->desc->original;

	#if defined(unix)
	if (IS_IMMORTAL(ch))
	{
		sprintf(strsave, "%s%s",GOD_DIR, capitalize(ch->name));
		if ((fp = fopen(strsave,"w")) == NULL)
		{
			bug("Save_char_obj: No god file to fopen",0);
			perror(strsave);
		}
		else
		{
			fprintf(fp,"Lev %2d Trust %2d  %s%s\n", ch->level, get_trust(ch), ch->name, ch->pcdata->title);
			fclose( fp );
		}
	}
	#endif

	if (backup)
		sprintf(strsave, "%s%s.bak", BACKUP_DIR, capitalize(ch->name));
	else
	{
		sprintf(strsave, "%s%s", PLAYER_DIR, capitalize(ch->name));
		save_other = TRUE;
	}

	if ( ( fp = fopen( TEMP_FILE, "w" ) ) == NULL )
	{
		bug( "Save_char_obj: No player file to fopen", 0 );
		perror( strsave );
	}
	else
	{
		fwrite_char( ch, fp );

		if (ch->carrying != NULL && save_other == TRUE)
			fwrite_obj( ch, ch->carrying, fp, 0 );

		if (ch->pet != NULL && ch->pet->in_room == ch->in_room && save_other == TRUE)
			fwrite_pet(ch->pet,fp);

		if (ch->mount && ch->mount->in_room == ch->in_room)
			fwrite_mount(ch->mount, fp);

		fprintf( fp, "#END\n" );
		fclose( fp );
		rename(TEMP_FILE,strsave);
	}
	return;
}



/*
 * Write the char.
 */
void fwrite_char( CHAR_DATA *ch, FILE *fp )
{
	AFFECT_DATA *paf;
	GRANT_DATA *gran;
	BUDDY_DATA *buddy;
	int sn, gn, pos, i;

	fprintf( fp, "#%s\n", IS_NPC(ch) ? "MOB" : "PLAYER"	);

	fprintf( fp, "Name %s~\n",	ch->name		);
	fprintf( fp, "CName %s~\n",	ch->colorname		);
	fprintf( fp, "LastName %s~\n", ch->pcdata->last_name );
	fprintf( fp, "Id   %ld\n", ch->id			);
	fprintf( fp, "LogO %ld\n",	current_time		);
	fprintf( fp, "BDay %d %d %d %d\n", ch->pcdata->birthday.hour, ch->pcdata->birthday.day, ch->pcdata->birthday.month, ch->pcdata->birthday.year);
	fprintf( fp, "Noob %d\n",   ch->pcdata->newbie );
	if ( ch->desc )
		fprintf( fp, "Host %s~\n", ch->desc->host );
	if ( ch->version == 5 )
		ch->version += 1;
	else if ( ch->version == 6 )
		ch->version += 1;
	else if ( ch->version == 7 )
		ch->version += 1;
	else if ( ch->version == 8 )
		ch->version += 1;
	else if ( ch->version == 9 )
		ch->version += 1;
	else if ( ch->version == 10 )
		ch->version += 1;
	else if ( ch->version == 11 )
		ch->version += 1;
	fprintf( fp, "Vers %d\n",   ch->version			);
	if (ch->short_descr[0] != '\0')
		fprintf( fp, "ShD  %s~\n",	ch->short_descr	);
	if( ch->long_descr[0] != '\0')
		fprintf( fp, "LnD  %s~\n",	ch->long_descr	);
	if (ch->description[0] != '\0')
		fprintf( fp, "Desc %s~\n",	ch->description	);

	fprintf( fp, "Summary " );
	for ( i = 0; i <= MAX_SUMMARY; i++ )
	{
		fprintf( fp, "%d ",	ch->pcdata->summary[i] );
	}
	fprintf( fp, "\n" );

	/* new eye, hair1, hair2, hair3, hair4 - experimental */
	if ( ch->version >= 13 )
	{
		fprintf( fp, "Features %d %d %d %d %d\n",
		ch->pcdata->eye, ch->pcdata->hair1, ch->pcdata->hair2, ch->pcdata->hair2, ch->pcdata->hair3 );
	}
	else
	{
		fprintf( fp, "Features %d %d %d %d %d\n", 1, 1, 1, 1, 1 );
		convert_features( ch );
	}

	fprintf( fp, "DFH %d %d\n",	ch->pcdata->dfhunt_player_info[1],ch->pcdata->dfhunt_player_info[2]);

	if( ch->prompt != NULL
	|| !str_cmp( ch->prompt,"<%hhp %mm %vmv> " )
	|| !str_cmp( ch->prompt,"{c<%hhp %mm %vmv>{x " ) )
		fprintf( fp, "Prom %s~\n",      ch->prompt  	);

	fprintf( fp, "Race %s~\n", pc_race_table[ch->race].name );

	if (clan_table[ch->clan].name != NULL)
		fprintf( fp, "Clan %s~\n",clan_table[ch->clan].name);
	else fprintf( fp, "Clan Loner~\n");

	if (ch->rank)
		fprintf( fp,   "GRank %d\n", ch->rank                );
	if ( ch->sub_clan )
		fprintf( fp, "Sguild %s~\n",clan_table[ch->sub_clan].name);
	if ( ch->sub_rank )
		fprintf( fp, "SRank %d\n", ch->sub_rank);

	fprintf( fp, "Sex  %d\n",	ch->sex			);
	fprintf( fp, "GamT %d\n",   ch->pcdata->gamble_type );
	fprintf( fp, "GamC %d\n",   ch->pcdata->gamble_coin );
	fprintf( fp, "GamS %d\n",   ch->pcdata->gamble_sides );
	fprintf( fp, "GamD %d\n",   ch->pcdata->gamble_dice );
	fprintf( fp, "Raffle %d\n", ch->pcdata->ticket_number );
	fprintf( fp, "Deg  %d\n",	ch->pcdata->deguilded );
	fprintf( fp, "Cla  %d\n",	ch->class		);
	fprintf( fp, "Levl %d\n",	ch->level		);
	fprintf( fp, "Rolls %d\n",	ch->pcdata->stat_rolls	);
	fprintf( fp, "Touches %d\n",ch->pcdata->touch_tries	);
	fprintf( fp, "Addict %d\n", ch->pcdata->addict_hours > 0 ? ch->pcdata->addict_hours : 0 );
	fprintf( fp, "MDea %d\n",	ch->mdeath		);
	fprintf( fp, "MKil %d\n",	ch->mkill		);
	fprintf( fp, "Pkil %d\n",	ch->pkill		);
	fprintf( fp, "PDea %d\n",	ch->pdeath		);
	fprintf( fp, "QRun %d\n",	ch->pcdata->questsrun);
	fprintf( fp, "Vault %d\n", ch->pcdata->has_vault ? 1 : 0 );

	fprintf (fp, "Boards       %d ", MAX_BOARD);
	for (i = 0; i < MAX_BOARD; i++)
		fprintf (fp, "%s %ld ", boards[i].short_name, ch->pcdata->last_note[i]);
	fprintf (fp, "\n");

	fprintf( fp, "Batt %d\n",   ch->battles );
	fprintf( fp, "BWon %d\n",   ch->bwins );
	fprintf( fp, "Rebi %d\n",   ch->pcdata->rebirth     );
	fprintf( fp, "Insa %d\n",   ch->pcdata->insanity    );
	if (ch->trust != 0)
		fprintf( fp, "Tru  %d\n",	ch->trust	);
	fprintf( fp, "Sec  %d\n",    ch->pcdata->security	);	/* OLC */
	fprintf( fp, "Hom  %ld\n",   ch->pcdata->home_vnum   );
	fprintf( fp, "JTim %d\n",   ch->pcdata->jail_timer  );
	fprintf( fp, "Warn %d\n",   ch->pcdata->warning );
	if ( ch->version > 10 )
		fwrite_rle(ch->pcdata->explored, fp);
	if ( ch->version > 10 )
	{
		fprintf( fp, "ExpXP %d %d %d %d %d %d %d %d %d %d\n",
		( ch->pcdata->explore_exp[0] == '\0' ? 0 : ch->pcdata->explore_exp[0] ),
		( ch->pcdata->explore_exp[1] == '\0' ? 0 : ch->pcdata->explore_exp[1] ),
		( ch->pcdata->explore_exp[2] == '\0' ? 0 : ch->pcdata->explore_exp[2] ),
		( ch->pcdata->explore_exp[3] == '\0' ? 0 : ch->pcdata->explore_exp[3] ),
		( ch->pcdata->explore_exp[4] == '\0' ? 0 : ch->pcdata->explore_exp[4] ),
		( ch->pcdata->explore_exp[5] == '\0' ? 0 : ch->pcdata->explore_exp[5] ),
		( ch->pcdata->explore_exp[6] == '\0' ? 0 : ch->pcdata->explore_exp[6] ),
		( ch->pcdata->explore_exp[7] == '\0' ? 0 : ch->pcdata->explore_exp[7] ),
		( ch->pcdata->explore_exp[8] == '\0' ? 0 : ch->pcdata->explore_exp[8] ),
		( ch->pcdata->explore_exp[9] == '\0' ? 0 : ch->pcdata->explore_exp[9] ) );
	}
	if ( ch->version > 10 )
		fprintf( fp, "ExplP %d\n", ch->pcdata->explored_pcnt );
	fprintf( fp, "Plyd %d\n", ch->played + (int) (current_time - ch->logon)	);
	if ( ch->version == 7 )
	{
		fprintf( fp, "Not  %ld %ld %ld %ld %ld %ld\n",
			ch->pcdata->last_pnote,ch->pcdata->last_idea,ch->pcdata->last_penalty,
			ch->pcdata->last_news,ch->pcdata->last_changes,ch->pcdata->last_roleplay);
	}
	else if ( ch->version == 8 )
	{
		fprintf( fp, "Not  %ld %ld %ld %ld %ld %ld %ld\n",
			ch->pcdata->last_pnote,ch->pcdata->last_idea,ch->pcdata->last_penalty,
			ch->pcdata->last_news,ch->pcdata->last_changes,ch->pcdata->last_roleplay,
			ch->pcdata->last_restring);
	}
	else if ( ch->version >= 9 )
	{
		fprintf( fp, "Not  %ld %ld %ld %ld %ld %ld %ld %ld\n",
			ch->pcdata->last_pnote,ch->pcdata->last_idea,ch->pcdata->last_penalty,
			ch->pcdata->last_news,ch->pcdata->last_changes,ch->pcdata->last_roleplay,
			ch->pcdata->last_restring,ch->pcdata->last_event);
	}
	else
	{
		fprintf( fp, "Not  %ld %ld %ld %ld %ld\n",
			ch->pcdata->last_pnote,ch->pcdata->last_idea,ch->pcdata->last_penalty,
			ch->pcdata->last_news,ch->pcdata->last_changes );
	}
	fprintf( fp, "Scro %d\n", 	ch->lines		);
	fprintf( fp, "Room %ld\n",
		ch->pcdata->allowed == 0 ? 3700 : ( ch->in_room == get_room_index( ROOM_VNUM_LIMBO )
		&& ch->was_in_room != NULL ) ? ch->was_in_room->vnum : ch->in_room == NULL ? 3001 : ch->in_room->vnum );

	fprintf( fp, "HMV  %d %d %d %d 0 0\n",	ch->hit, ch->max_hit, ch->stam, ch->max_stam);


	fprintf( fp, "OPP %d %d %d %d %d\n",
		ch->pcdata->op_air,
		ch->pcdata->op_water,
		ch->pcdata->op_fire,
		ch->pcdata->op_earth,
		ch->pcdata->op_spirit);

	fprintf( fp, "Allw %d\n", ch->pcdata->allowed );
	fprintf( fp, "Barr %d\n", ch->pcdata->char_barrier );
/*
	if ( ch->pcdata->battle_cry )
		fprintf( fp, "BattleCry %s~\n", ch->pcdata->battle_cry );
*/
	fprintf( fp, "Burn %d\n", ch->pcdata->burnout );

	if ( ch->money[3][0] > 0 )
		fprintf( fp, "GMark %ld\n",	ch->money[3][0] );
	else
		fprintf( fp, "GMark %d\n", 0 );
	if ( ch->money[2][0] > 0 )
		fprintf( fp, "SMark %ld\n", ch->money[2][0] );
	else
		fprintf( fp, "SMark %d\n",0 );
	if ( ch->money[1][0] > 0 )
		fprintf( fp, "SPenny %ld\n", ch->money[1][0] );
	else
		fprintf( fp, "SPenny %d\n",0 );
	if ( ch->money[0][0] > 0 )
		fprintf( fp, "CPenny %ld\n", ch->money[0][0] );
	else
		fprintf( fp, "CPenny %d\n",0 );

	if (ch->money[0][1] > 0)
		fprintf( fp, "BankCP %ld\n", ch->money[0][1] );
	else
		fprintf( fp, "BankCP %d\n", 0 );
	if (ch->money[1][1] > 0)
		fprintf( fp, "BankSP %ld\n", ch->money[1][1] );
	else
		fprintf( fp, "BankSP %d\n", 0 );
	if (ch->money[2][1] > 0)
		fprintf( fp, "BankSM %ld\n", ch->money[2][1] );
	else
		fprintf( fp, "BankSM %d\n", 0 );
	if (ch->money[3][1] > 0)
		fprintf( fp, "BankGM %ld\n", ch->money[3][1] );
	else
		fprintf( fp, "BankGM %d\n", 0 );

	if ( ch->pcdata->bounty > 0 )
		fprintf( fp, "Bounty %ld\n", ch->pcdata->bounty );
	else
		fprintf( fp, "Bounty %d\n", 0 );

    fprintf( fp, "Exp  %d\n",	ch->exp			);
    if (ch->act != 0)
	fprintf( fp, "Act  %s\n",   print_flags(ch->act));
    if (ch->affected_by != 0)
	fprintf( fp, "AfBy %s\n",   print_flags(ch->affected_by));
    fprintf( fp, "Comm %s\n",       print_flags(ch->comm));

	/* Save the flags */
    if (ch->auto_flags != 0)
	    fprintf( fp, "Auto %s\n",   print_flags(ch->auto_flags));
    if (ch->ajah_flags != 0)
	    fprintf( fp, "Ajah %s\n",   print_flags(ch->ajah_flags));
    if (ch->op_flags != 0)
       fprintf( fp, "Chan %s\n",   print_flags(ch->op_flags)); /* Dalsor */
    if (ch->custom_flags != 0)
       fprintf( fp, "Cust %s\n",   print_flags(ch->custom_flags)); /* Dalsor */
    if (ch->spec_flags != 0)
       fprintf( fp, "Spec %s\n",   print_flags(ch->spec_flags)); /* Dalsor */
    if (ch->hist_flags != 0)
       fprintf( fp, "Hist %s\n",   print_flags(ch->hist_flags)); /* Dalsor */
    if (ch->junk != 0)
       fprintf( fp, "Junk %s\n",   print_flags(ch->junk)); /* Rokann */

    if (!IS_NPC(ch)
    && gquest_info.running == GQUEST_OFF
    && IS_SET(ch->war_flags, WAR_GQUEST))
    {
	    REMOVE_BIT(ch->war_flags, WAR_GQUEST);
        reset_gqmob(ch, 0);
    }

    if (ch->war_flags != 0)
       fprintf( fp, "Warf %s\n",   print_flags(ch->war_flags)); /* Dalsor */
    if (ch->penalty_flags != 0)
       fprintf( fp, "Penal %s\n",   print_flags(ch->penalty_flags)); /* Dalsor */

	fprintf( fp, "QuestMob %d\n", ch->questmob );
	fprintf( fp, "QuestObj %d\n", ch->questobj );
    fprintf( fp, "QuestCnt %d\n",  ch->countdown );
    fprintf( fp, "QuestPnts %d\n",  ch->questpoints );
/*    fprintf( fp, "CurrQuest %d\n",  ch->nextquest   );   */ /* no need to print it out if we don't want it */
    if(ch->pcdata->questinfo_data)
	fprintf( fp, "QuestInfo %s~\n",  ch->pcdata->questinfo_data);

    if (ON_GQUEST(ch)
    || (gquest_info.running != GQUEST_OFF
	&& count_gqmobs(ch) == gquest_info.mob_count))
	{
		int i;
	    fprintf(fp, "GQmobs %d ", gquest_info.mob_count);
	    for (i = 0; i < gquest_info.mob_count; i++)
		fprintf(fp, "%ld ", ch->pcdata->gq_mobs[i]);
	    fprintf(fp, "\n");
	}

    if (ch->wiznet)
    	fprintf( fp, "Wizn %s\n",   print_flags(ch->wiznet));
    if (ch->invis_level)
	fprintf( fp, "Invi %d\n", 	ch->invis_level	);
    if (ch->incog_level)
	fprintf(fp,"Inco %d\n",ch->incog_level);
    fprintf( fp, "Pos  %d\n",
	ch->position == POS_FIGHTING ? POS_STANDING : ch->position );
    if (ch->practice != 0)
    	fprintf( fp, "Prac %d\n",	ch->practice	);
    if (ch->train != 0)
	fprintf( fp, "Trai %d\n",	ch->train	);
    if (ch->saving_throw != 0)
	fprintf( fp, "Save  %d\n",	ch->saving_throw);
    fprintf( fp, "Alig  %d\n",	ch->alignment		);
    if (ch->hitroll != 0)
	fprintf( fp, "Hit   %d\n",	ch->hitroll	);
    if (ch->damroll != 0)
	fprintf( fp, "Dam   %d\n",	ch->damroll	);
    fprintf( fp, "ACs %d %d %d %d\n",
	ch->armor[0],ch->armor[1],ch->armor[2],ch->armor[3]);
    if (ch->wimpy !=0 )
	fprintf( fp, "Wimp  %ld\n",	ch->wimpy	);
    fprintf( fp, "Attr %d %d %d %d %d %d %d %d\n",
	ch->perm_stat[STAT_STR],
	ch->perm_stat[STAT_INT],
	ch->perm_stat[STAT_WIS],
	ch->perm_stat[STAT_DEX],
	ch->perm_stat[STAT_CON],
	ch->perm_stat[STAT_REF],
	ch->perm_stat[STAT_INS],
	ch->perm_stat[STAT_CHA]);

    fprintf (fp, "AMod %d %d %d %d %d %d %d %d\n",
	ch->mod_stat[STAT_STR],
	ch->mod_stat[STAT_INT],
	ch->mod_stat[STAT_WIS],
	ch->mod_stat[STAT_DEX],
	ch->mod_stat[STAT_CON],
	ch->mod_stat[STAT_REF],
	ch->mod_stat[STAT_INS],
	ch->mod_stat[STAT_CHA]);

    fprintf (fp, "AttrQuest %d %d %d %d %d %d %d %d\n",
	ch->quest_stat[STAT_STR],
	ch->quest_stat[STAT_INT],
	ch->quest_stat[STAT_WIS],
	ch->quest_stat[STAT_DEX],
	ch->quest_stat[STAT_CON],
	ch->quest_stat[STAT_REF],
	ch->quest_stat[STAT_INS],
	ch->quest_stat[STAT_CHA]);

    if ( IS_NPC(ch) )
    {
		fprintf( fp, "Vnum %ld\n",	ch->pIndexData->vnum	);
    }
    else
    {
		fprintf( fp, "Pass %s~\n",	ch->pcdata->pwd		);
	}
	if (ch->pcdata->bamfin[0] != '\0')
	    fprintf( fp, "Bin  %s~\n",	ch->pcdata->bamfin);
	if (ch->pcdata->bamfout[0] != '\0')
		fprintf( fp, "Bout %s~\n",	ch->pcdata->bamfout);

	if ( ch->pcdata->afkmsg[0] != '\0' )
		fprintf( fp, "AfkMsg %s~\n", ch->pcdata->afkmsg );
   if (ch->pcdata->wkin[0] != '\0')
       fprintf( fp, "Wkin %s~\n",  ch->pcdata->wkin);
   if (ch->pcdata->wout[0] != '\0')
       fprintf( fp, "Wout %s~\n",  ch->pcdata->wout);
   if (ch->pcdata->rdesc != NULL)
       fprintf( fp, "Rdesc %s~\n",  ch->pcdata->rdesc);
   if (ch->pcdata->bonded_to[0] != '\0')
       fprintf( fp, "Bto %s~\n",  ch->pcdata->bonded_to);
   if (ch->pcdata->bonded_by[0] != '\0')
       fprintf( fp, "Bby %s~\n",  ch->pcdata->bonded_by);
   if (ch->pcdata->aiel_clan[0] != '\0')
       fprintf( fp, "AielC %s~\n", ch->pcdata->aiel_clan);
	if ( ch->pcdata->spouse != NULL && ch->pcdata->spouse[0] != '\0' )
		fprintf( fp, "Spouse %s~\n", ch->pcdata->spouse );
    if(ch->pcdata->email[0] != '\0')
        fprintf(fp, "Email %s~\n", ch->pcdata->email);

	fprintf( fp, "Titl %s~\n",	ch->pcdata->title	);
	fprintf( fp, "Beard %d\n", ch->pcdata->beard );
	fprintf( fp, "HairS %d\n", ch->pcdata->hair );
    fprintf( fp, "Pnts %d\n",   	ch->pcdata->points      );
	fprintf( fp, "TSex %d\n",	ch->pcdata->true_sex	);
	fprintf( fp, "LLev %d\n",	ch->pcdata->last_level	);
	fprintf( fp, "HMVP %d %d 0\n", ch->pcdata->perm_hit, ch->pcdata->perm_mana);

	fprintf( fp, "Beac %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld\n",
	( !ch->pcdata->beacons[0] || ch->pcdata->beacons[0] <= 0 ? 3700 : ch->pcdata->beacons[0] ),
	( !ch->pcdata->beacons[1] || ch->pcdata->beacons[1] <= 0 ? 3700 : ch->pcdata->beacons[1] ),
	( !ch->pcdata->beacons[2] || ch->pcdata->beacons[2] <= 0 ? 3700 : ch->pcdata->beacons[2] ),
	( !ch->pcdata->beacons[3] || ch->pcdata->beacons[3] <= 0 ? 3700 : ch->pcdata->beacons[3] ),
	( !ch->pcdata->beacons[4] || ch->pcdata->beacons[4] <= 0 ? 3700 : ch->pcdata->beacons[4] ),
	( !ch->pcdata->beacons[5] || ch->pcdata->beacons[5] <= 0 ? 3700 : ch->pcdata->beacons[5] ),
	( !ch->pcdata->beacons[6] || ch->pcdata->beacons[6] <= 0 ? 3700 : ch->pcdata->beacons[6] ),
	( !ch->pcdata->beacons[7] || ch->pcdata->beacons[7] <= 0 ? 3700 : ch->pcdata->beacons[7] ),
	( !ch->pcdata->beacons[8] || ch->pcdata->beacons[8] <= 0 ? 3700 : ch->pcdata->beacons[8] ),
	( !ch->pcdata->beacons[9] || ch->pcdata->beacons[9] <= 0 ? 3700 : ch->pcdata->beacons[9] ) );

	fprintf( fp, "Cnd  %d %d %d %d\n",
	    ch->pcdata->condition[0],
	    ch->pcdata->condition[1],
	    ch->pcdata->condition[2],
	    ch->pcdata->condition[3] );

	fprintf( fp, "Coloura     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->text[2],
		ch->pcdata->text[0],
		ch->pcdata->text[1],
		ch->pcdata->auction[2],
		ch->pcdata->auction[0],
		ch->pcdata->auction[1],
		ch->pcdata->gossip[2],
		ch->pcdata->gossip[0],
		ch->pcdata->gossip[1],
		ch->pcdata->music[2],
		ch->pcdata->music[0],
		ch->pcdata->music[1],
		ch->pcdata->question[2],
		ch->pcdata->question[0],
		ch->pcdata->question[1] );
	fprintf( fp, "Colourb     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->answer[2],
		ch->pcdata->answer[0],
		ch->pcdata->answer[1],
		ch->pcdata->quote[2],
		ch->pcdata->quote[0],
		ch->pcdata->quote[1],
		ch->pcdata->quote_text[2],
		ch->pcdata->quote_text[0],
		ch->pcdata->quote_text[1],
		ch->pcdata->immtalk_text[2],
		ch->pcdata->immtalk_text[0],
		ch->pcdata->immtalk_text[1],
		ch->pcdata->immtalk_type[2],
		ch->pcdata->immtalk_type[0],
		ch->pcdata->immtalk_type[1] );
	fprintf( fp, "Colourc     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->info[2],
		ch->pcdata->info[0],
		ch->pcdata->info[1],
		ch->pcdata->tell[2],
		ch->pcdata->tell[0],
		ch->pcdata->tell[1],
		ch->pcdata->reply[2],
		ch->pcdata->reply[0],
		ch->pcdata->reply[1],
		ch->pcdata->gtell_text[2],
		ch->pcdata->gtell_text[0],
		ch->pcdata->gtell_text[1],
		ch->pcdata->gtell_type[2],
		ch->pcdata->gtell_type[0],
		ch->pcdata->gtell_type[1] );
	fprintf( fp, "Colourd     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->room_title[2],
		ch->pcdata->room_title[0],
		ch->pcdata->room_title[1],
		ch->pcdata->room_text[2],
		ch->pcdata->room_text[0],
		ch->pcdata->room_text[1],
		ch->pcdata->room_exits[2],
		ch->pcdata->room_exits[0],
		ch->pcdata->room_exits[1],
		ch->pcdata->room_things[2],
		ch->pcdata->room_things[0],
		ch->pcdata->room_things[1],
		ch->pcdata->prompt[2],
		ch->pcdata->prompt[0],
		ch->pcdata->prompt[1] );
	fprintf( fp, "Coloure     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->fight_death[2],
		ch->pcdata->fight_death[0],
		ch->pcdata->fight_death[1],
		ch->pcdata->fight_yhit[2],
		ch->pcdata->fight_yhit[0],
		ch->pcdata->fight_yhit[1],
		ch->pcdata->fight_ohit[2],
		ch->pcdata->fight_ohit[0],
		ch->pcdata->fight_ohit[1],
		ch->pcdata->fight_thit[2],
		ch->pcdata->fight_thit[0],
		ch->pcdata->fight_thit[1],
		ch->pcdata->fight_skill[2],
		ch->pcdata->fight_skill[0],
		ch->pcdata->fight_skill[1] );
	fprintf( fp, "Colourf     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->wiznet[2],
		ch->pcdata->wiznet[0],
		ch->pcdata->wiznet[1],
		ch->pcdata->say[2],
		ch->pcdata->say[0],
		ch->pcdata->say[1],
		ch->pcdata->say_text[2],
		ch->pcdata->say_text[0],
		ch->pcdata->say_text[1],
		ch->pcdata->tell_text[2],
		ch->pcdata->tell_text[0],
		ch->pcdata->tell_text[1],
		ch->pcdata->reply_text[2],
		ch->pcdata->reply_text[0],
		ch->pcdata->reply_text[1] );
	fprintf( fp, "Colourg     %d%d%d %d%d%d %d%d%d %d%d%d %d%d%d\n",
		ch->pcdata->auction_text[2],
		ch->pcdata->auction_text[0],
		ch->pcdata->auction_text[1],
		ch->pcdata->gossip_text[2],
		ch->pcdata->gossip_text[0],
		ch->pcdata->gossip_text[1],
		ch->pcdata->music_text[2],
		ch->pcdata->music_text[0],
		ch->pcdata->music_text[1],
		ch->pcdata->question_text[2],
		ch->pcdata->question_text[0],
		ch->pcdata->question_text[1],
		ch->pcdata->answer_text[2],
		ch->pcdata->answer_text[0],
		ch->pcdata->answer_text[1] );
/*
    for (pos = 0; pos < MAX_IGNORE; pos++)
    {
        if (ch->pcdata->ignore[pos] == NULL)
        break;

        fprintf(fp, "Ignore %s~\n", ch->pcdata->ignore[pos]);
    }
*/
    for (pos = 0; pos < MAX_ALIAS; pos++)
	{
	    if (ch->pcdata->alias[pos] == NULL
	    ||  ch->pcdata->alias_sub[pos] == NULL)
		break;

	    fprintf(fp,"Alias %s %s~\n",ch->pcdata->alias[pos],
		    ch->pcdata->alias_sub[pos]);
	}
	for (buddy = ch->pcdata->buddies; buddy != NULL; buddy = buddy->next)
	{
		if (buddy == NULL)	break;
		if (!str_cmp(buddy->name, "deleted"))	continue;

		fprintf(fp, "Buddy %s~\n", buddy->name);
	}
	if(ch->pcdata->prompt_skill > 0)
	{
		int psn = ch->pcdata->prompt_skill;
		if (psn < MAX_SKILL && skill_table[psn].name != NULL)
			fprintf( fp, "ProSk '%s'\n", skill_table[psn].name );
	}

	for ( sn = 0; sn < MAX_SKILL; sn++ )
	{
	    if ( skill_table[sn].name != NULL && ch->pcdata->learned[sn] > 0 )
	    {
		fprintf( fp, "Sk %d '%s'\n",
		    ch->pcdata->learned[sn], skill_table[sn].name );
	    }
	}

	for ( gn = 0; gn < MAX_GROUP; gn++ )
    {
        if ( group_table[gn].name != NULL && ch->pcdata->group_known[gn])
        {
            fprintf( fp, "Gr '%s'\n",group_table[gn].name);
        }
    }

    for ( paf = ch->affected; paf != NULL; paf = paf->next )
    {
	if (paf->type < 0 || paf->type>= MAX_SKILL)
	    continue;

	fprintf( fp, "Affc '%s' %3d %3d %3d %3d %3d %10d\n",
	    skill_table[paf->type].name,
	    paf->where,
	    paf->level,
	    paf->duration,
	    paf->modifier,
	    paf->location,
	    paf->bitvector
	    );
    }

    for (gran=ch->pcdata->granted; gran != NULL; gran=gran->next)
      fprintf(fp,"Grant '%s' %d\n",gran->name, gran->duration);

    fprintf( fp, "End\n\n" );
    //read_mysql_staff( ch );
    //update_staff( ch, "all" );
    return;
}

void fwrite_pet( CHAR_DATA *pet, FILE *fp)
{
    AFFECT_DATA *paf;

	if ( pet->perm_stat[STAT_REF] < 1 )
		pet->perm_stat[STAT_REF] = 3;
	if ( pet->perm_stat[STAT_INS] < 1 )
		pet->perm_stat[STAT_INS] = 3;
	if ( pet->perm_stat[STAT_CHA] < 1 )
		pet->perm_stat[STAT_CHA] = 3;

	if ( get_curr_stat(pet, pet->mod_stat[STAT_REF]) < 1 )
		pet->mod_stat[STAT_REF] = 0;
	if ( get_curr_stat(pet, pet->mod_stat[STAT_INS]) < 1 )
		pet->mod_stat[STAT_INS] = 0;
	if ( get_curr_stat(pet, pet->mod_stat[STAT_CHA]) < 1 )
		pet->mod_stat[STAT_CHA] = 0;

    fprintf(fp,"#PET\n");

    fprintf(fp,"Vnum %ld\n",pet->pIndexData->vnum);

    fprintf(fp,"Name %s~\n", pet->name);
    fprintf(fp,"LogO %ld\n", current_time);
    if (pet->short_descr != pet->pIndexData->short_descr)
    	fprintf(fp,"ShD  %s~\n", pet->short_descr);
    if (pet->long_descr != pet->pIndexData->long_descr)
    	fprintf(fp,"LnD  %s~\n", pet->long_descr);
    if (pet->description != pet->pIndexData->description)
    	fprintf(fp,"Desc %s~\n", pet->description);
    if (pet->race != pet->pIndexData->race)
    	fprintf(fp,"Race %s~\n", race_table[pet->race].name);
    if (pet->clan)
        fprintf( fp, "Clan %s~\n",clan_table[pet->clan].name);
    fprintf(fp,"Sex  %d\n", pet->sex);
    if (pet->level != pet->pIndexData->level)
    	fprintf(fp,"Levl %d\n", pet->level);
    fprintf(fp, "HMV  %d %d %d %d 0 0\n",
    	pet->hit, pet->max_hit, pet->stam, pet->max_stam);

//	if (pet->mod_hit > 0)	fprintf(fp, "ModHP %d\n", pet->mod_hit);
//	if (pet->mod_stam > 0)	fprintf(fp, "ModSP %d\n", pet->mod_stam);

    if ( pet->money[3][0] > 0 )
		fprintf( fp, "GMark %ld\n",	pet->money[3][0] );
    else
		fprintf( fp, "GMark %d\n", 0 );
    if ( pet->money[2][0] > 0 )
		fprintf( fp, "SMark %ld\n", pet->money[2][0] );
    else
		fprintf( fp, "SMark %d\n",0 );
    if ( pet->money[1][0] > 0 )
		fprintf( fp, "SPenny %ld\n", pet->money[1][0] );
    else
		fprintf( fp, "SPenny %d\n",0 );
    if ( pet->money[0][0] > 0 )
		fprintf( fp, "CPenny %ld\n", pet->money[0][0] );
    else
		fprintf( fp, "CPenny %d\n",0 );

    if (pet->exp > 0)
    	fprintf(fp, "Exp  %d\n", pet->exp);
    if (pet->act != pet->pIndexData->act)
    	fprintf(fp, "Act  %s\n", print_flags(pet->act));
    if (pet->affected_by != pet->pIndexData->affected_by)
    	fprintf(fp, "AfBy %s\n", print_flags(pet->affected_by));
    if (pet->comm != 0)
    	fprintf(fp, "Comm %s\n", print_flags(pet->comm));
    fprintf(fp,"Pos  %d\n", pet->position = POS_FIGHTING ? POS_STANDING : pet->position);
    if (pet->saving_throw != 0)
    	fprintf(fp, "Save %d\n", pet->saving_throw);
    if (pet->alignment != pet->pIndexData->alignment)
    	fprintf(fp, "Alig %d\n", pet->alignment);
    if (pet->hitroll != pet->pIndexData->hitroll)
    	fprintf(fp, "Hit  %d\n", pet->hitroll);
    if (pet->damroll != pet->pIndexData->damage[DICE_BONUS])
    	fprintf(fp, "Dam  %d\n", pet->damroll);
    fprintf(fp, "ACs  %d %d %d %d\n",
    	pet->armor[0],pet->armor[1],pet->armor[2],pet->armor[3]);
    fprintf(fp, "Attr %d %d %d %d %d %d %d %d\n",
    	pet->perm_stat[STAT_STR], pet->perm_stat[STAT_INT],
    	pet->perm_stat[STAT_WIS], pet->perm_stat[STAT_DEX],
    	pet->perm_stat[STAT_CON], pet->perm_stat[STAT_REF],
    	pet->perm_stat[STAT_INS], pet->perm_stat[STAT_CHA]);
    fprintf(fp, "AMod %d %d %d %d %d %d %d %d\n",
    	pet->mod_stat[STAT_STR], pet->mod_stat[STAT_INT],
    	pet->mod_stat[STAT_WIS], pet->mod_stat[STAT_DEX],
    	pet->mod_stat[STAT_CON], pet->mod_stat[STAT_REF],
    	pet->mod_stat[STAT_INS], pet->mod_stat[STAT_CHA]);

    for ( paf = pet->affected; paf != NULL; paf = paf->next )
    {
    	if (paf->type < 0 || paf->type >= MAX_SKILL)
    	    continue;

    	fprintf(fp, "Affc '%s' %3d %3d %3d %3d %3d %10d\n",
    	    skill_table[paf->type].name,
    	    paf->where, paf->level, paf->duration, paf->modifier,paf->location,
    	    paf->bitvector);
    }

    fprintf(fp,"End\n");
    return;
}

void fwrite_obj( CHAR_DATA *ch, OBJ_DATA *obj, FILE *fp, int iNest )
{
	EXTRA_DESCR_DATA *ed;
	AFFECT_DATA *paf;

	if (  obj->next_content != NULL )
		fwrite_obj( ch, obj->next_content, fp, iNest );

	fprintf( fp, "#OBJECT\n" );
	fprintf( fp, "Vnum %ld\n",   obj->pIndexData->vnum        );

	if (!obj->pIndexData->new_format)
		fprintf( fp, "Oldstyle\n");
	if (obj->enchanted)
		fprintf( fp,"Enchanted\n");

	fprintf( fp, "Nest %d\n", iNest );

	if ( obj->name != obj->pIndexData->name)
		fprintf( fp, "Name %s~\n", obj->name );
	if ( obj->short_descr != obj->pIndexData->short_descr)
		fprintf( fp, "ShD  %s~\n", obj->short_descr);
	if ( obj->description != obj->pIndexData->description)
		fprintf( fp, "Desc %s~\n", obj->description );
	if ( obj->material != obj->pIndexData->material )
		fprintf( fp, "Mat %s~\n", obj->material );
	if ( obj->owner != NULL && obj->owner[0] != '\0' )
		fprintf( fp, "Owner %s~\n", obj->owner );
	if ( obj->extra_flags != obj->pIndexData->extra_flags)
		fprintf( fp, "ExtF %d\n", obj->extra_flags );
	if ( obj->wear_flags != obj->pIndexData->wear_flags)
		fprintf( fp, "WeaF %d\n", obj->wear_flags );
	if ( obj->item_type != obj->pIndexData->item_type)
		fprintf( fp, "Ityp %d\n", obj->item_type );
	if ( obj->weight != obj->pIndexData->weight)
		fprintf( fp, "Wt   %d\n", obj->weight );
	if ( obj->condition != obj->pIndexData->condition)
		fprintf( fp, "Cond %d\n", obj->condition );

	fprintf (fp, "Dye %d\n", obj->dye_vnum);

	/* variable data */

	fprintf( fp, "Wear %d\n", obj->wear_loc );

	if (obj->level != obj->pIndexData->level)
		fprintf( fp, "Lev  %d\n", obj->level );
	if (obj->timer != 0)
		fprintf( fp, "Time %d\n", obj->timer );

	fprintf( fp, "Cost %d\n", obj->cost );

	if ( obj->is_tailored == TRUE )
		fprintf( fp, "Tailrd %d\n",  obj->is_tailored );

	if ( obj->is_stitched == TRUE )
		fprintf( fp, "Stitchd %d\n", obj->is_stitched );

	if (obj->value[0] != obj->pIndexData->value[0]
	||  obj->value[1] != obj->pIndexData->value[1]
	||  obj->value[2] != obj->pIndexData->value[2]
	||  obj->value[3] != obj->pIndexData->value[3]
	||  obj->value[4] != obj->pIndexData->value[4]
	||  obj->item_type == ITEM_TREASURECHEST )
		fprintf( fp, "Val  %d %d %d %d %d\n", obj->value[0], obj->value[1], obj->value[2], obj->value[3], obj->value[4] );

	switch ( obj->item_type )
	{
		case ITEM_WEAPON:
		case ITEM_ARMOR:
		case ITEM_TREASURE:
		case ITEM_LIGHT:
		case ITEM_CRAFTING_MANUAL:
			for ( paf = obj->affected; paf != NULL; paf = paf->next )
			{
				if (paf->type >= 0 && paf->type < MAX_SKILL)
					continue;

				fprintf( fp, "Infu %d %d %d %d %d %d %d\n", paf->location, paf->modifier, paf->where, paf->type, paf->duration, paf->bitvector, paf->level );
			}
		break;

		case ITEM_POTION:
		case ITEM_SCROLL:
		case ITEM_PILL:
			if ( obj->value[1] > 0 )
			{
				fprintf( fp, "Spell 1 '%s'\n",skill_table[obj->value[1]].name );
			}

			if ( obj->value[2] > 0 )
			{
				fprintf( fp, "Spell 2 '%s'\n",skill_table[obj->value[2]].name );
			}

			if ( obj->value[3] > 0 )
			{
				fprintf( fp, "Spell 3 '%s'\n",skill_table[obj->value[3]].name );
			}
		break;

		case ITEM_STAFF:
		case ITEM_WAND:
			if ( obj->value[3] > 0 )
			{
				fprintf( fp, "Spell 3 '%s'\n",skill_table[obj->value[3]].name );
			}
			for ( paf = obj->affected; paf != NULL; paf = paf->next )
			{
				fprintf( fp, "Infu %d %d %d %d %d %d %d\n", paf->location, paf->modifier, paf->where, paf->type, paf->duration, paf->bitvector,	paf->level );
				break;
			}
		break;
	}

	for ( paf = obj->affected; paf != NULL; paf = paf->next )
	{
		if (paf->type < 0 || paf->type >= MAX_SKILL)
			continue;

		fprintf( fp, "Affc '%s' %3d %3d %3d %3d %3d %10d\n", skill_table[paf->type].name, paf->where, paf->level, paf->duration, paf->modifier, paf->location, paf->bitvector );
		break;
	}

	for ( ed = obj->extra_descr; ed != NULL; ed = ed->next )
	{
		fprintf( fp, "ExDe %s~ %s~\n", ed->keyword, ed->description );
	}

	fprintf( fp, "End\n\n" );

	if ( obj->contains != NULL )
		fwrite_obj( ch, obj->contains, fp, iNest + 1 );

	return;
}



/*
 * Load a char and inventory into a new ch structure.
 */
bool load_char_obj( DESCRIPTOR_DATA *d, char *name )
{
	char strsave[MAX_INPUT_LENGTH];
	char buf[100];
	CHAR_DATA *ch;
	FILE *fp;
	bool found;
	int stat, i;
	int fd;
	struct stat st;

	ch = new_char();
	ch->pcdata = new_pcdata();

	d->character = ch;
	ch->desc = d;
	ch->name = str_dup( name );
	/*ch->pcdata->last_name   = str_dup( "" );*/
	ch->id = get_pc_id();
	ch->race = race_lookup("andor");
	ch->act = PLR_NOSUMMON;
	ch->comm = COMM_COMBINE | COMM_PROMPT;
	ch->prompt = str_dup("<%hhp %mst> ");
	ch->pcdata->granted = NULL;
	ch->advancing = FALSE;
	ch->advancing_on = NULL;
	ch->nextquest = 10;
	ch->range = RANGE_NONE;
	ch->fight_data = NULL;
	ch->number_of_fights = 0;
	ch->pcdata->teaching = NULL;
	ch->pcdata->teaching_skill = 0;
	ch->pcdata->learning_from = NULL;
	ch->pcdata->learning_skill = 0;

 	/* every characters starts at default board from login.. this board
 	   should be read_level == 0 !
 	*/
	ch->pcdata->in_progress = NULL;
	ch->pcdata->board = &boards[DEFAULT_BOARD];

	ch->battles = 0;
	ch->bwins = 0;
	ch->timer = 0;
	ch->pcdata->ticket_number = -1;

	ch->pcdata->eye = 1;
	ch->pcdata->hair1 = 1;
	ch->pcdata->hair2 = 1;
	ch->pcdata->hair3 = 1;
	ch->pcdata->hair4 = 1;

	ch->pcdata->confirm_delete = FALSE;
	ch->colorname = str_dup(name);
	ch->pcdata->pwd = str_dup( "" );
	ch->pcdata->bamfin = str_dup( "" );
	ch->pcdata->bamfout = str_dup( "" );
	ch->pcdata->afkmsg = str_dup( "" );
	ch->pcdata->wkin                    = str_dup( "" );
	ch->pcdata->wout                    = str_dup( "" );
	ch->pcdata->rdesc                   = str_dup( "" );
	ch->pcdata->bonded_to               = str_dup( "" );
	ch->pcdata->bonded_by               = str_dup( "" );
	ch->pcdata->aiel_clan               = str_dup( "" );
	ch->pcdata->title			= str_dup( "" );
	ch->pcdata->beard     = 0;
	ch->pcdata->hair      = 0;
	ch->pcdata->op_air    = 0;
	ch->pcdata->op_water  = 0;
	ch->pcdata->op_fire   = 0;
	ch->pcdata->op_earth  = 0;
	ch->pcdata->op_spirit = 0;
	ch->pcdata->char_barrier = 0;
	ch->pcdata->jail_timer = 0;
	ch->pcdata->jail_room = 0;
	ch->pcdata->warning = 0;
	ch->pcdata->newbie = 0;
	ch->pcdata->stat_rolls = 9;
	ch->mdeath = 0;
	ch->pdeath = 0;
	ch->pkill = 0;
	ch->mkill = 0;
	ch->camp_room = NULL;
	ch->camp_timer = 0;
	ch->pcdata->questsrun = 0;
	ch->pcdata->allowed = 0;
	ch->pcdata->gamble_type = 2;
	ch->pcdata->gamble_coin = 1;
	ch->pcdata->gamble_dice = 5;
	ch->pcdata->gamble_sides = 6;
	ch->pcdata->spouse = NULL;
	ch->pcdata->addict_hours = 0;
	ch->pcdata->has_vault = FALSE;
	ch->pcdata->in_vault = FALSE;
	ch->pcdata->prior_to_vault = NULL;
	ch->jog_to = -1;

	ch->leader = ch;
	ch->master = ch;

	if (gquest_info.running == GQUEST_OFF && IS_SET(ch->war_flags, WAR_GQUEST))
	{
		REMOVE_BIT(ch->war_flags, WAR_GQUEST);
		reset_gqmob(ch, 0);
	}

	ch->pcdata->explored_pcnt = 1;
	ch->pcdata->new_room = FALSE;
	for (stat =0; stat < MAX_STATS; stat++)
	{
		ch->perm_stat[stat]	= 3;
		ch->mod_stat[stat]      = 0;
		ch->quest_stat[stat]	= 0;
	}

	for (i = 0; i < MAX_BEACONS; i++)
	{
		ch->pcdata->beacons[i] = 3700;
	}
	ch->pcdata->condition[COND_THIRST]	= 48;
	ch->pcdata->condition[COND_FULL]	= 48;
	ch->pcdata->condition[COND_HUNGER]	= 48;
	ch->pcdata->security		= 0;	/* OLC */

	ch->pcdata->email = str_dup ( "" );

	if ( ch->version > 10 )
	{
		/*for (index = 0; index < 32768; index++)
	    	ch->pcdata->explored[index] = '\0';*/
		bzero(ch->pcdata->explored, 4096);
	}

    ch->pcdata->text[0]		= ( NORMAL );
    ch->pcdata->text[1]		= ( WHITE );
    ch->pcdata->text[2]		= 0;
    ch->pcdata->auction[0]	= ( BRIGHT );
    ch->pcdata->auction[1]	= ( YELLOW );
    ch->pcdata->auction[2]	= 0;
    ch->pcdata->auction_text[0]	= ( BRIGHT );
    ch->pcdata->auction_text[1]	= ( WHITE );
    ch->pcdata->auction_text[2]	= 0;
    ch->pcdata->gossip[0]	= ( NORMAL );
    ch->pcdata->gossip[1]	= ( MAGENTA );
    ch->pcdata->gossip[2]	= 0;
    ch->pcdata->gossip_text[0]	= ( BRIGHT );
    ch->pcdata->gossip_text[1]	= ( MAGENTA );
    ch->pcdata->gossip_text[2]	= 0;
    ch->pcdata->music[0]	= ( NORMAL );
    ch->pcdata->music[1]	= ( RED );
    ch->pcdata->music[2]	= 0;
    ch->pcdata->music_text[0]	= ( BRIGHT );
    ch->pcdata->music_text[1]	= ( RED );
    ch->pcdata->music_text[2]	= 0;
    ch->pcdata->question[0]	= ( BRIGHT );
    ch->pcdata->question[1]	= ( YELLOW );
    ch->pcdata->question[2]	= 0;
    ch->pcdata->question_text[0] = ( BRIGHT );
    ch->pcdata->question_text[1] = ( WHITE );
    ch->pcdata->question_text[2] = 0;
    ch->pcdata->answer[0]	= ( BRIGHT );
    ch->pcdata->answer[1]	= ( YELLOW );
    ch->pcdata->answer[2]	= 0;
    ch->pcdata->answer_text[0]	= ( BRIGHT );
    ch->pcdata->answer_text[1]	= ( WHITE );
    ch->pcdata->answer_text[2]	= 0;
    ch->pcdata->quote[0]	= ( NORMAL );
    ch->pcdata->quote[1]	= ( YELLOW );
    ch->pcdata->quote[2]	= 0;
    ch->pcdata->quote_text[0]	= ( NORMAL );
    ch->pcdata->quote_text[1]	= ( GREEN );
    ch->pcdata->quote_text[2]	= 0;
    ch->pcdata->immtalk_text[0]	= ( NORMAL );
    ch->pcdata->immtalk_text[1]	= ( CYAN );
    ch->pcdata->immtalk_text[2]	= 0;
    ch->pcdata->immtalk_type[0]	= ( NORMAL );
    ch->pcdata->immtalk_type[1]	= ( YELLOW );
    ch->pcdata->immtalk_type[2]	= 0;
    ch->pcdata->info[0]		= ( BRIGHT );
    ch->pcdata->info[1]		= ( YELLOW );
    ch->pcdata->info[2]		= 1;
    ch->pcdata->say[0]		= ( NORMAL );
    ch->pcdata->say[1]		= ( GREEN );
    ch->pcdata->say[2]		= 0;
    ch->pcdata->say_text[0]	= ( BRIGHT );
    ch->pcdata->say_text[1]	= ( GREEN );
    ch->pcdata->say_text[2]	= 0;
    ch->pcdata->tell[0]		= ( NORMAL );
    ch->pcdata->tell[1]		= ( GREEN );
    ch->pcdata->tell[2]		= 0;
    ch->pcdata->tell_text[0]	= ( BRIGHT );
    ch->pcdata->tell_text[1]	= ( GREEN );
    ch->pcdata->tell_text[2]	= 0;
    ch->pcdata->reply[0]	= ( NORMAL );
    ch->pcdata->reply[1]	= ( GREEN );
    ch->pcdata->reply[2]	= 0;
    ch->pcdata->reply_text[0]	= ( BRIGHT );
    ch->pcdata->reply_text[1]	= ( GREEN );
    ch->pcdata->reply_text[2]	= 0;
    ch->pcdata->gtell_text[0]	= ( NORMAL );
    ch->pcdata->gtell_text[1]	= ( GREEN );
    ch->pcdata->gtell_text[2]	= 0;
    ch->pcdata->gtell_type[0]	= ( NORMAL );
    ch->pcdata->gtell_type[1]	= ( RED );
    ch->pcdata->gtell_type[2]	= 0;
    ch->pcdata->wiznet[0]		= ( NORMAL );
    ch->pcdata->wiznet[1]		= ( GREEN );
    ch->pcdata->wiznet[2]		= 0;
    ch->pcdata->room_title[0]	= ( NORMAL );
    ch->pcdata->room_title[1]	= ( CYAN );
    ch->pcdata->room_title[2]	= 0;
    ch->pcdata->room_text[0]	= ( NORMAL );
    ch->pcdata->room_text[1]	= ( WHITE );
    ch->pcdata->room_text[2]	= 0;
    ch->pcdata->room_exits[0]	= ( NORMAL );
    ch->pcdata->room_exits[1]	= ( GREEN );
    ch->pcdata->room_exits[2]	= 0;
    ch->pcdata->room_things[0]	= ( NORMAL );
    ch->pcdata->room_things[1]	= ( CYAN );
    ch->pcdata->room_things[2]	= 0;
    ch->pcdata->prompt[0]	= ( NORMAL );
    ch->pcdata->prompt[1]	= ( CYAN );
    ch->pcdata->prompt[2]	= 0;
    ch->pcdata->fight_death[0]	= ( BRIGHT );
    ch->pcdata->fight_death[1]	= ( RED );
    ch->pcdata->fight_death[2]	= 0;
    ch->pcdata->fight_yhit[0]	= ( NORMAL );
    ch->pcdata->fight_yhit[1]	= ( GREEN );
    ch->pcdata->fight_yhit[2]	= 0;
    ch->pcdata->fight_ohit[0]	= ( NORMAL );
    ch->pcdata->fight_ohit[1]	= ( YELLOW );
    ch->pcdata->fight_ohit[2]	= 0;
    ch->pcdata->fight_thit[0]	= ( NORMAL );
    ch->pcdata->fight_thit[1]	= ( RED );
    ch->pcdata->fight_thit[2]	= 0;
    ch->pcdata->fight_skill[0]	= ( BRIGHT );
    ch->pcdata->fight_skill[1]	= ( WHITE );
    ch->pcdata->fight_skill[2]	= 0;

    found = FALSE;

    #if defined(unix)
    /* decompress if .gz file exists */
    sprintf( strsave, "%s%s%s", PLAYER_DIR, capitalize(name),".gz");
    if ( ( fp = fopen( strsave, "r" ) ) != NULL )
    {
	fclose(fp);
	sprintf(buf,"gzip -dfq %s",strsave);
	system(buf);
    }
    #endif

    sprintf( strsave, "%s%s", PLAYER_DIR, capitalize( name ) );


    if ( ( fp = fopen( strsave, "r" ) ) != NULL )
    {
	int iNest;

	fd = fileno( fp );
	if ( fstat( fd, &st ) )
	{
		perror("fstat");
	}
	ch->pcdata->pfile_size = st.st_size;

	for ( iNest = 0; iNest < MAX_NEST; iNest++ )
	    rgObjNest[iNest] = NULL;

	found = TRUE;
	for ( ; ; )
	{
	    char letter;
	    char *word;

	    letter = fread_letter( fp );
	    if ( letter == '*' )
	    {
		fread_to_eol( fp );
		continue;
	    }

	    if ( letter != '#' )
	    {
		bug( "Load_char_obj: # not found.", 0 );
		break;
	    }

	    word = fread_word( fp );
	    if      ( !str_cmp( word, "PLAYER" ) ) fread_char ( ch, fp );
	    else if ( !str_cmp( word, "OBJECT" ) ) fread_obj  ( ch, fp );
	    else if ( !str_cmp( word, "O"      ) ) fread_obj  ( ch, fp );
	    else if ( !str_cmp( word, "PET"    ) ) fread_pet  ( ch, fp );
	    else if ( !str_cmp( word, "MOUNT"  ) ) fread_mount( ch, fp );
	    else if ( !str_cmp( word, "END"    ) ) break;
	    else
	    {
		bug( "Load_char_obj: bad section.", 0 );
		break;
	    }
	}
	fclose( fp );
    }

    /* initialize race */
    if (found)
    {
	int i;

	if (ch->race == 0)
	    ch->race = race_lookup("andor");

	ch->size = pc_race_table[ch->race].size;
	ch->dam_type = 17; /*punch */

	for (i = 0; i < 5; i++)
	{
	    if (pc_race_table[ch->race].skills[i] == NULL)
		break;
	    group_add(ch,pc_race_table[ch->race].skills[i],FALSE);
	}
	ch->affected_by = ch->affected_by|race_table[ch->race].aff;
	ch->imm_flags	= ch->imm_flags | race_table[ch->race].imm;
	ch->res_flags	= ch->res_flags | race_table[ch->race].res;
	ch->vuln_flags	= ch->vuln_flags | race_table[ch->race].vuln;
	ch->form	= race_table[ch->race].form;
	ch->parts	= race_table[ch->race].parts;
    }


    /* RT initialize skills */

    if (found && ch->version < 2)  /* need to add the new skills */
    {
	group_add(ch,"rom basics",FALSE);
	group_add(ch,class_table[ch->class].base_group,FALSE);
	group_add(ch,class_table[ch->class].default_group,TRUE);
	ch->pcdata->learned[gsn_recall] = 50;
    }

    /* fix levels */
    if (found && ch->version < 3 && (ch->level > 35 || ch->trust > 35))
    {
	switch (ch->level)
	{
	    case(40) : ch->level = 60;	break;  /* imp -> imp */
	    case(39) : ch->level = 58; 	break;	/* god -> supreme */
	    case(38) : ch->level = 56;  break;	/* deity -> god */
	    case(37) : ch->level = 53;  break;	/* angel -> demigod */
	}

        switch (ch->trust)
        {
            case(40) : ch->trust = 60;  break;	/* imp -> imp */
            case(39) : ch->trust = 58;  break;	/* god -> supreme */
            case(38) : ch->trust = 56;  break;	/* deity -> god */
            case(37) : ch->trust = 53;  break;	/* angel -> demigod */
            case(36) : ch->trust = 51;  break;	/* hero -> hero */
        }
    }

	if ( found && ch->version <= 13 )
	{
		ch->exp = ch->exp * exp_per_level( ch, ch->pcdata->points ) / 1000;
		ch->version = 14;
	}

	/* init dfhunt array */
	for(i=3; i<7; i++)
		ch->pcdata->dfhunt_player_info[i] = 0;
	ch->pcdata->dfhunt_player_info[0] = 0;
	/* 1 and 2 stay forever. */

    /* ream gold */
    if (found && ch->version < 4)
    {
	ch->money[3][0]   /= 100;
    }
    return found;
}



/*
 * Read in a char.
 */

void fread_char( CHAR_DATA *ch, FILE *fp )
{
    char buf[MAX_STRING_LENGTH];
    char *word;
    bool fMatch;
    int count = 0;
    int lastlogoff = current_time;
    int percent;
    BUDDY_DATA *buddy;

    sprintf(buf,"Loading %s.",ch->name);
    log_string(buf);

    ch->money[2][1] = 0;
    ch->money[1][1] = 0;
    ch->money[0][1] = 0;
    ch->money[3][1] = 0;

	ch->pcdata->bounty    = 0;

    ch->pcdata->op_air    = 0;
    ch->pcdata->op_water  = 0;
    ch->pcdata->op_fire   = 0;
    ch->pcdata->op_earth  = 0;
    ch->pcdata->op_spirit = 0;
    ch->pcdata->burnout = 0;

    if (ch->pcdata->rebirthing == FALSE)
    {
		ch->pcdata->rebirth = 0;
	}
	ch->pcdata->insanity = 0;
	ch->op_flags = '\0';
	ch->auto_flags = '\0';
	ch->ajah_flags = '\0';
	ch->spec_flags = '\0';
	ch->hist_flags = '\0';
	ch->junk = '\0';
	ch->war_flags = '\0';
	ch->pcdata->home_vnum = ROOM_VNUM_ALTAR;
    for ( ; ; )
    {
	word   = feof( fp ) ? "End" : fread_word( fp );
	fMatch = FALSE;

	switch ( UPPER(word[0]) )
	{
	case '*':
	    fMatch = TRUE;
	    fread_to_eol( fp );
	    break;

	case 'A':
	    KEY( "Act",		ch->act,		fread_flag( fp ) );
        if ( !str_cmp( word, "Addict" ) )
        {
            ch->pcdata->addict_hours = fread_number( fp );
            if ( ch->pcdata->addict_hours > 0 )
                ch->pcdata->addict = TRUE;
	    fMatch = TRUE;
            break;
        }
	    KEY( "AffectedBy",	ch->affected_by,	fread_flag( fp ) );
	    KEYS( "AfkMsg", ch->pcdata->afkmsg, fread_string( fp ) );
	    KEY( "AfBy",	ch->affected_by,	fread_flag( fp ) );
	    KEYS( "AielC",	ch->pcdata->aiel_clan,	fread_string( fp ) );
	    KEY( "Alignment",	ch->alignment,		fread_number( fp ) );
	    KEY( "Alig",	ch->alignment,		fread_number( fp ) );

	    if (!str_cmp( word, "Alia"))
	    {
		if (count >= MAX_ALIAS)
		{
		    fread_to_eol(fp);
		    fMatch = TRUE;
		    break;
		}

		ch->pcdata->alias[count] 	= str_dup(fread_word(fp));
		ch->pcdata->alias_sub[count]	= str_dup(fread_word(fp));
		count++;
		fMatch = TRUE;
		break;
	    }

            if (!str_cmp( word, "Alias"))
            {
                if (count >= MAX_ALIAS)
                {
                    fread_to_eol(fp);
                    fMatch = TRUE;
                    break;
                }

                ch->pcdata->alias[count]        = str_dup(fread_word(fp));
                ch->pcdata->alias_sub[count]    = fread_string(fp);
                count++;
                fMatch = TRUE;
                break;
            }

	    if (!str_cmp( word, "AC") || !str_cmp(word,"Armor"))
	    {
		fread_to_eol(fp);
		fMatch = TRUE;
		break;
	    }

	    if (!str_cmp(word,"ACs"))
	    {
		int i;

		for (i = 0; i < 4; i++)
		    ch->armor[i] = fread_number(fp);
		fMatch = TRUE;
		break;
	    }

	    if (!str_cmp(word, "AffD"))
	    {
		AFFECT_DATA *paf;
		int sn;

		paf = new_affect();

		sn = skill_lookup(fread_word(fp));
		if (sn < 0)
		    bug("Fread_char: unknown skill.",0);
		else
		    paf->type = sn;

		paf->level	= fread_number( fp );
		paf->duration	= fread_number( fp );
		paf->modifier	= fread_number( fp );
		paf->location	= fread_number( fp );
		paf->bitvector	= fread_number( fp );
		paf->next	= ch->affected;
		ch->affected	= paf;
		fMatch = TRUE;
		break;
	    }

            if (!str_cmp(word, "Affc"))
            {
                AFFECT_DATA *paf;
                int sn;

                paf = new_affect();

                sn = skill_lookup(fread_word(fp));
                if (sn < 0)
                    bug("Fread_char: unknown skill.",0);
                else
                    paf->type = sn;

                paf->where  = fread_number(fp);
                paf->level      = fread_number( fp );
                paf->duration   = fread_number( fp );
                paf->modifier   = fread_number( fp );
                paf->location   = fread_number( fp );
                paf->bitvector  = fread_number( fp );
                /*paf->next       = ch->affected;
                ch->affected    = paf;*/
                affect_to_char(ch, paf);
                fMatch = TRUE;
                break;
            }

		KEY( "Allw", ch->pcdata->allowed, fread_number( fp ) );

	    if ( !str_cmp( word, "AttrMod"  ) || !str_cmp(word,"AMod"))
	    {
			int stat;

			if ( ch->version < 6 )
			{
				for (stat = 0; stat < 5; stat ++)
				{
				ch->mod_stat[stat] = fread_number(fp);
		 	    }
				fMatch = TRUE;
				break;
		    }
		    else if ( ch->version >= 6 )
			{
				for (stat = 0; stat < 8; stat ++)
				{
				ch->mod_stat[stat] = fread_number(fp);
		 	    }
				fMatch = TRUE;
				break;
		    }
		}
	    if ( !str_cmp( word, "AttrPerm" ) || !str_cmp(word,"Attr"))
	    {
			int stat;
			if ( ch->version < 6 )
			{
				for (stat = 0; stat < 5; stat++)
				{
			    ch->perm_stat[stat] = fread_number(fp);
				}
				fMatch = TRUE;
				break;
		    }
		    else if ( ch->version >= 6 )
			{
				for (stat = 0; stat < 8; stat ++)
				{
				ch->perm_stat[stat] = fread_number(fp);
		 	    }
				fMatch = TRUE;
				break;
		    }
	    }
	    if ( !str_cmp( word, "AttrQuest" ) )
	    {
			int stat;
			if ( ch->version < 6 )
			{
				for (stat = 0; stat < 5; stat++)
				{
			    ch->quest_stat[stat] = fread_number(fp);
				}
				fMatch = TRUE;
				break;
		    }
		    else if ( ch->version >= 6 )
			{
				for (stat = 0; stat < 8; stat ++)
				{
				ch->quest_stat[stat] = fread_number(fp);
		 	    }
				fMatch = TRUE;
				break;
		    }
	    }

		KEY( "Ajah",    ch->ajah_flags,   fread_flag(fp)); /* Dalsor */
		KEY( "Auto",    ch->auto_flags,   fread_flag(fp)); /* Dalsor */
	    break;

	case 'B':
	    KEYS( "Bamfin",	ch->pcdata->bamfin,	    fread_string( fp ) );
	    KEYS( "Bamfout",	ch->pcdata->bamfout,	fread_string( fp ) );
        KEY( "BankCP",   ch->money[0][1],     fread_number( fp ) );
        KEY( "BankSP",   ch->money[1][1],     fread_number( fp ) );
        KEY( "BankSM",   ch->money[2][1],     fread_number( fp ) );
        KEY( "BankGM",   ch->money[3][1],     fread_number( fp ) );
	    KEY( "Barr",    ch->pcdata->char_barrier,   fread_number(fp) );
		if (!strcmp(word, "Beac")) /* memorized rooms */
		{
			int beaconroom, i = 0;
			for ( i = 0; i < MAX_BEACONS; i++ )
			{
				beaconroom = fread_number( fp );
				ch->pcdata->beacons[i] = beaconroom;
				if ( beaconroom == 0 )
					ch->pcdata->beacons[i] = 3700;
			}
			fMatch = TRUE;
			break;
		}
	    KEY( "Beard",   ch->pcdata->beard,      fread_number( fp ) );
	    KEY( "Batt",    ch->battles, fread_number( fp ) );
	    KEY( "BWon",    ch->bwins, fread_number( fp ) );
	    KEYS( "Bin",		ch->pcdata->bamfin,	    fread_string( fp ) );
        if (!strcmp(word, "BDay")) /* Voltecs player birthdays! */
        {
            ch->pcdata->birthday.hour  = fread_number(fp);
            ch->pcdata->birthday.day   = fread_number(fp);
            ch->pcdata->birthday.month = fread_number(fp);
            ch->pcdata->birthday.year  = fread_number(fp);
            fMatch = TRUE;
            break;
        }

 		/* Read in board status */
 	    if (!str_cmp(word, "Boards" ))
 	    {
 			int i,num = fread_number (fp); /* number of boards saved */
 			char *boardname;

 			for (; num ; num-- ) /* for each of the board saved */
 			{
 				boardname = fread_word (fp);
 				i = board_lookup (boardname); /* find board number */

 				if (i == BOARD_NOTFOUND) /* Does board still exist ? */
 				{
 					sprintf (buf, "fread_char: %s had unknown board name: %s. Skipped.", ch->name, boardname);
 					log_string (buf);
 					fread_number (fp); /* read last_note and skip info */
 				}
 				else /* Save it */
 					ch->pcdata->last_note[i] = fread_number (fp);
 			}	 /* for */

 			fMatch = TRUE;
 	    } /* Boards */
	    KEY( "Bounty", 	ch->pcdata->bounty, 	fread_number( fp ) );

	    KEYS( "Bout",	ch->pcdata->bamfout,	fread_string( fp ) );
	    if ( !str_cmp( word, "Bto" ) )
	    {
		     char *tmp = fread_string(fp);
		     ch->pcdata->bonded_to = str_dup(tmp);
		     free_string(tmp);
		     fMatch = TRUE;
		     break;
		}
	    /*KEY( "Bto",	ch->pcdata->bonded_to,		fread_string( fp ) );*/
	    KEYS( "Bby",	ch->pcdata->bonded_by,		fread_string( fp ) );
		KEYS( "BattleCry", ch->pcdata->battle_cry, fread_string( fp ) );

		if (!str_cmp(word, "Buddy"))
		{
			buddy = new_buddy("new");
			free_string(buddy->name);
			buddy->name = fread_string(fp);
			buddy->relationship = 0;
			
			if (ch->pcdata->buddies)
			buddy->next = ch->pcdata->buddies;

			ch->pcdata->buddies = buddy;
			fMatch = TRUE;
			break;
		}
	    KEY( "Burn", ch->pcdata->burnout, fread_number( fp ) );

	    break;

	case 'C':
		KEY( "Chan",    ch->op_flags,   fread_flag(fp)); /* Dalsor */
	    KEY( "Class",	ch->class,		fread_number( fp ) );
	    KEY( "Cla",		ch->class,		fread_number( fp ) );
	    KEYS( "CName",	ch->colorname,		fread_string( fp ) );
	    /* KEY( "Clan",	ch->clan,	clan_lookup(fread_string(fp))); */

	    if ( !str_cmp( word, "Clan" ) ) {
		     char *tmp = fread_string(fp);
		     ch->clan = clan_lookup(tmp);
                     if (ch->clan < 1) ch->clan = 1;
		     free_string(tmp);
		     fMatch = TRUE;
		     break;
		}

	    KEY( "Comm",	ch->comm,		fread_flag( fp ) );

	    if ( !str_cmp( word, "Condition" ) || !str_cmp(word,"Cond"))
	    {
		ch->pcdata->condition[0] = fread_number( fp );
		ch->pcdata->condition[1] = fread_number( fp );
		ch->pcdata->condition[2] = fread_number( fp );
		fMatch = TRUE;
		break;
	    }
            if (!str_cmp(word,"Cnd"))
            {
                ch->pcdata->condition[0] = fread_number( fp );
                ch->pcdata->condition[1] = fread_number( fp );
                ch->pcdata->condition[2] = fread_number( fp );
		ch->pcdata->condition[3] = fread_number( fp );
                fMatch = TRUE;
                break;
            }

	    if( !str_cmp( word, "Coloura" ) )
	    {
		LOAD_COLOUR( text )
		LOAD_COLOUR( auction )
		LOAD_COLOUR( gossip )
		LOAD_COLOUR( music )
		LOAD_COLOUR( question )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Colourb" ) )
	    {
		LOAD_COLOUR( answer )
		LOAD_COLOUR( quote )
		LOAD_COLOUR( quote_text )
		LOAD_COLOUR( immtalk_text )
		LOAD_COLOUR( immtalk_type )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Colourc" ) )
	    {
		LOAD_COLOUR( info )
		LOAD_COLOUR( tell )
		LOAD_COLOUR( reply )
		LOAD_COLOUR( gtell_text )
		LOAD_COLOUR( gtell_type )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Colourd" ) )
	    {
		LOAD_COLOUR( room_title )
		LOAD_COLOUR( room_text )
		LOAD_COLOUR( room_exits )
		LOAD_COLOUR( room_things )
		LOAD_COLOUR( prompt )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Coloure" ) )
	    {
		LOAD_COLOUR( fight_death )
		LOAD_COLOUR( fight_yhit )
		LOAD_COLOUR( fight_ohit )
		LOAD_COLOUR( fight_thit )
		LOAD_COLOUR( fight_skill )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Colourf" ) )
	    {
		LOAD_COLOUR( wiznet )
		LOAD_COLOUR( say )
		LOAD_COLOUR( say_text )
		LOAD_COLOUR( tell_text )
		LOAD_COLOUR( reply_text )
		fMatch = TRUE;
		break;
	    }
	    if( !str_cmp( word, "Colourg" ) )
	    {
		LOAD_COLOUR( auction_text )
		LOAD_COLOUR( gossip_text )
		LOAD_COLOUR( music_text )
		LOAD_COLOUR( question_text )
		LOAD_COLOUR( answer_text )
		fMatch = TRUE;
		break;
	    }
		KEY( "CPenny",  ch->money[0][0],   fread_number(fp)); /* Dalsor */
		KEY( "Cust",    ch->custom_flags,   fread_flag(fp)); /* Dalsor */

	    break;

	case 'D':
	    KEY( "Damroll",	ch->damroll,		fread_number( fp ) );
	    KEY( "Dam",		ch->damroll,		fread_number( fp ) );
	    KEY( "Deg",     ch->pcdata->deguilded, fread_number( fp ) );
	    /*KEYS( "Description",	ch->description,	fread_string( fp ) );*/
	    KEYS( "Desc",	ch->description,	fread_string( fp ) );
		if(!str_cmp(word, "DFH"))
		{
			ch->pcdata->dfhunt_player_info[1] = fread_number(fp);
			ch->pcdata->dfhunt_player_info[2] = fread_number(fp);

			fMatch = TRUE;
			break;
		}
	    break;

	case 'E':
        KEYS( "Email",   ch->pcdata->email,  fread_string( fp ) );
	    if ( !str_cmp( word, "End" ) )
	    {
    		/* adjust hp mana move up  -- here for speed's sake */
    		percent = (current_time - lastlogoff) * 25 / ( 2 * 60 * 60);

		percent = UMIN(percent,100);

    		if (percent > 0 && !IS_AFFECTED(ch,AFF_POISON)
    		&&  !IS_AFFECTED(ch,AFF_PLAGUE))
    		{
        	    ch->hit	+= (get_maxhit(ch) - ch->hit) * percent / 100;
        	    ch->stam    += (get_maxstam(ch) - ch->stam) * percent / 100;
    		}
		return;
	    }
	    /* new eye, hair, etc - experimental
	    if ( !str_cmp( word, "Eye" ) )
	    {
			if ( ch->version <= 12 )
			{
				ch->version = 13;
				ch->eye = fread_string( fp );
				convert_eye( ch );
			}
			else
			{
				ch->pcdata->eye   = fread_number( fp );
				ch->pcdata->hair1 = fread_number( fp );
				ch->pcdata->hair2 = fread_number( fp );
				ch->pcdata->hair3 = fread_number( fp );
				ch->pcdata->hair4 = fread_number( fp );
			}
		}*/
	    /*KEYS( "Eye",	ch->eye,		fread_string( fp ) );*/
	    KEY( "Exp",		ch->exp,		fread_number( fp ) );
	    KEY( "ExplP",		ch->pcdata->explored_pcnt,		fread_number( fp ) );
		if ( !str_cmp( word, "ExpXP" ) )
		{
			int rwd, i = 0;
			for ( i = 0; i < 10; i++ )
			{
				rwd = fread_number( fp );
				ch->pcdata->explore_exp[i] = rwd;
				if ( rwd == 0 )
					ch->pcdata->explore_exp[i] = '\0';
			}
			fMatch = TRUE;
			break;
		}
	    break;

	case 'F':
		if ( !str_cmp( word, "Features" ) && ch->version >= 13 )
		{
			ch->pcdata->eye   = fread_number( fp );
			ch->pcdata->hair1 = fread_number( fp );
			ch->pcdata->hair2 = fread_number( fp );
			ch->pcdata->hair3 = fread_number( fp );
			ch->pcdata->hair4 = fread_number( fp );
			if(ch->pcdata->hair1>12)
				ch->pcdata->hair1-=12;
			set_features( ch );
			fMatch = TRUE;
			break;
		}
	break;

	case 'G':
	    KEY( "GamT",	ch->pcdata->gamble_type,		fread_number( fp ) );
	    KEY( "GamC",	ch->pcdata->gamble_coin,		fread_number( fp ) );
	    KEY( "GamD",	ch->pcdata->gamble_dice,		fread_number( fp ) );
	    KEY( "GamS",	ch->pcdata->gamble_sides,		fread_number( fp ) );
	    KEY( "GMark",   ch->money[3][0],                fread_number( fp ) );
	    if (!str_cmp(word, "GQmobs"))
	    {
			int maxMob = fread_number(fp);
			int i;

			for (i = 0; i < maxMob; i++)
			    ch->pcdata->gq_mobs[i] = fread_number(fp);
			fMatch = TRUE;
			break;
	    }
            if ( !str_cmp( word, "Group" )  || !str_cmp(word,"Gr"))
            {
                int gn;
                char *temp;

                temp = fread_word( fp ) ;
                gn = group_lookup(temp);
                if ( gn < 0 )
                {
                    fprintf(stderr,"%s",temp);
                    bug( "Fread_char: unknown group. ", 0 );
                }
                else
		    gn_add(ch,gn);
                fMatch = TRUE;
		break;
            }
		KEY( "GRank",        ch->rank, fread_number( fp ) );
		if ( !str_cmp( word, "Grant" ) )
        {
        	GRANT_DATA *gran;
			int cmd;
			gran = alloc_mem(sizeof(*gran));
			gran->name = str_dup(fread_word(fp));
			gran->duration = fread_number(fp);
			gran->next = NULL;
			gran->do_fun = NULL;

			for (cmd = 0; cmd_table[cmd].name[0] != '\0'; cmd++ )
				if ( gran->name[0] == cmd_table[cmd].name[0]
				&&  is_exact_name( gran->name, cmd_table[cmd].name ) )
				{
					gran->do_fun = cmd_table[cmd].do_fun;
					gran->level = cmd_table[cmd].level;
					break;
                }
				gran->next = ch->pcdata->granted;
				ch->pcdata->granted = gran;

				if (gran->do_fun == NULL)
				{
				sprintf(buf,"CData: Command %s not found in pfile for %s",
					gran->name,ch->name);
				log_string(buf);
				}
				fMatch = TRUE;
				break;
        }
	    break;

	case 'H':
		KEY( "HairS", ch->pcdata->hair, fread_number( fp ) );
/*
		KEYS( "Hair1", ch->hair1, fread_string( fp ) );
		KEYS( "Hair2", ch->hair2, fread_string( fp ) );
		KEYS( "Hair3", ch->hair3, fread_string( fp ) );
		KEYS( "Hair4", ch->hair4, fread_string( fp ) );
*/
	    KEY( "Hitroll",	ch->hitroll,		fread_number( fp ) );
		KEY( "Hist",    ch->hist_flags,   fread_flag(fp)); /* Dalsor */
	    KEY( "Hit",		ch->hitroll,		fread_number( fp ) );
		/*KEYS( "Host",   ch->desc->host, fread_string( fp ) );*/
	    if( !str_cmp(word, "Host" ) )
	    {	/* don't actually read this in. Want to reset it each log in */
	    	fread_to_eol( fp );
		fMatch = TRUE;
		break;
	    }

	    if ( !str_cmp( word, "HpManaMove" ) || !str_cmp(word,"HMV"))
	    {
		ch->hit		= fread_number( fp );
		ch->max_hit	= fread_number( fp );
		ch->stam	= fread_number( fp );
		ch->max_stam	= fread_number( fp );
		fread_number( fp );
		fread_number( fp );
		fMatch = TRUE;
		break;
	    }

            if ( !str_cmp( word, "HpManaMovePerm" ) || !str_cmp(word,"HMVP"))
            {
                ch->pcdata->perm_hit	= fread_number( fp );
                ch->pcdata->perm_mana   = fread_number( fp );
                fread_number( fp );
                fMatch = TRUE;
                break;
            }
	    KEY( "Hom",		ch->pcdata->home_vnum,		fread_vnum( fp ) );
	    break;

	case 'I':
/*        if (!str_cmp( word, "Ignore"))
        {
	        if (count >= MAX_IGNORE)
	        {
		        fread_to_eol(fp);
		        fMatch = TRUE;
		        break;
	        }
        ch->pcdata->ignore[count]        =      fread_string(fp);
        count++;
        fMatch = TRUE;
        break;
	    }
*/
	    KEY( "Id",		ch->id,			fread_number( fp ) );
	    KEY( "InvisLevel",	ch->invis_level,	fread_number( fp ) );
	    KEY( "Inco",	ch->incog_level,	fread_number( fp ) );
	    KEY( "Insa",    ch->pcdata->insanity, fread_number( fp ) );
	    KEY( "Invi",	ch->invis_level,	fread_number( fp ) );
	    break;
	case 'J':
		KEY( "JTim",    ch->pcdata->jail_timer, fread_number( fp ) );
		KEY( "Junk",    ch->junk,   fread_flag(fp)); /* Rokann */
		break;
	case 'L':
	    KEY( "LastLevel",	ch->pcdata->last_level, fread_number( fp ) );
	    /*KEYS( "LastName", ch->pcdata->last_name, fread_string( fp ) );*/
	    if ( !str_cmp( word, "LastName" ) )
	    {
			ch->pcdata->last_name = fread_string( fp );
                fMatch = TRUE;
                break;
		}
	    KEY( "LLev",	ch->pcdata->last_level, fread_number( fp ) );
	    KEY( "Level",	ch->level,		fread_number( fp ) );
	    KEY( "Lev",		ch->level,		fread_number( fp ) );
	    KEY( "Levl",	ch->level,		fread_number( fp ) );
	    KEY( "LogO",	lastlogoff,		fread_number( fp ) );
	    /*KEY( "Lok",		ch->pcdata->locker_room,	fread_number( fp ) );*/
	    KEYS( "LongDescr",	ch->long_descr,		fread_string( fp ) );
	    KEYS( "LnD",		ch->long_descr,		fread_string( fp ) );
	    break;

	case 'M':
		KEY( "MDea",    ch->mdeath, fread_number( fp ) );
		KEY( "MKil",    ch->mkill, fread_number( fp ) );
                KEY( "ModHP",	ch->mod_hit,		fread_number(fp));
    	        KEY( "ModSP",	ch->mod_stam,		fread_number(fp));
		break;

	case 'N':
	    KEYS( "Name",	ch->name,		fread_string( fp ) );
	    KEY( "Noob",	ch->pcdata->newbie,	fread_number( fp ) );
	    KEY( "Note",	ch->pcdata->last_pnote,	fread_number( fp ) );
	    if (!str_cmp(word,"Not") && ch->version == 7 )
		{
		ch->pcdata->last_pnote			= fread_number(fp);
		ch->pcdata->last_idea			= fread_number(fp);
		ch->pcdata->last_penalty		= fread_number(fp);
		ch->pcdata->last_news			= fread_number(fp);
		ch->pcdata->last_changes		= fread_number(fp);
		ch->pcdata->last_roleplay       = fread_number(fp);
		fMatch = TRUE;
		break;
	    }
		else if (!str_cmp(word, "Not") && ch->version == 8)
		{
		ch->pcdata->last_pnote			= fread_number(fp);
		ch->pcdata->last_idea			= fread_number(fp);
		ch->pcdata->last_penalty		= fread_number(fp);
		ch->pcdata->last_news			= fread_number(fp);
		ch->pcdata->last_changes		= fread_number(fp);
		ch->pcdata->last_roleplay       = fread_number(fp);
		ch->pcdata->last_restring       = fread_number(fp);
		fMatch = TRUE;
		break;
        }
		else if (!str_cmp(word, "Not") && ch->version == 9)
		{
		ch->pcdata->last_pnote			= fread_number(fp);
		ch->pcdata->last_idea			= fread_number(fp);
		ch->pcdata->last_penalty		= fread_number(fp);
		ch->pcdata->last_news			= fread_number(fp);
		ch->pcdata->last_changes		= fread_number(fp);
		ch->pcdata->last_roleplay       = fread_number(fp);
		ch->pcdata->last_restring       = fread_number(fp);
		ch->pcdata->last_event          = fread_number(fp);
		fMatch = TRUE;
		break;
		}
		else if (!str_cmp(word, "Not") && ch->version >= 10)
		{
		ch->pcdata->last_pnote			= fread_number(fp);
		ch->pcdata->last_idea			= fread_number(fp);
		ch->pcdata->last_penalty		= fread_number(fp);
		ch->pcdata->last_news			= fread_number(fp);
		ch->pcdata->last_changes		= fread_number(fp);
		ch->pcdata->last_roleplay       = fread_number(fp);
		ch->pcdata->last_restring       = fread_number(fp);
		ch->pcdata->last_event          = fread_number(fp);
		fMatch = TRUE;
		break;
        }
	    else if (!str_cmp(word,"Not") && ch->version < 7 )
	    {
		ch->pcdata->last_pnote			= fread_number(fp);
		ch->pcdata->last_idea			= fread_number(fp);
		ch->pcdata->last_penalty		= fread_number(fp);
		ch->pcdata->last_news			= fread_number(fp);
		ch->pcdata->last_changes		= fread_number(fp);
		fMatch = TRUE;
		break;
	    }
	    break;

	case 'O':
        if ( !str_cmp( word, "OPP" ) )
        {
            ch->pcdata->op_air	    = fread_number( fp );
            ch->pcdata->op_water    = fread_number( fp );
            ch->pcdata->op_fire     = fread_number( fp );
            ch->pcdata->op_earth    = fread_number( fp );
            ch->pcdata->op_spirit   = fread_number( fp );
            fMatch = TRUE;
            break;
        }

	case 'P':
	    KEYS( "Password",	ch->pcdata->pwd,	fread_string( fp ) );
	    KEYS( "Pass",	ch->pcdata->pwd,fread_string( fp ) );
	    KEY( "PDea",    ch->pdeath,     fread_number( fp ) );
	    KEY( "Penal",   ch->penalty_flags,fread_flag( fp ) );
	    KEY( "PKil",    ch->pkill,      fread_number( fp ) );
	    KEY( "Played",	ch->played,		fread_number( fp ) );
	    KEY( "Plyd",	ch->played,		fread_number( fp ) );
	    KEY( "Points",	ch->pcdata->points,	fread_number( fp ) );
	    KEY( "Pnts",	ch->pcdata->points,	fread_number( fp ) );
	    KEY( "Position",ch->position,	fread_number( fp ) );
	    KEY( "Pos",		ch->position,	fread_number( fp ) );
	    KEY( "Practice",ch->practice,	fread_number( fp ) );
	    KEY( "Prac",	ch->practice,	fread_number( fp ) );
        KEYS( "Prompt", ch->prompt,     fread_string( fp ) );
 	    KEYS( "Prom",	ch->prompt,		fread_string( fp ) );
	     if ( !str_cmp( word, "ProSk" ) )
	     {
		int sn;
		char *temp;
		temp = fread_word( fp );
		sn = skill_lookup(temp);
		if( sn < 0 )
		{
		    fprintf(stderr,"%s",temp);
		    bug( "Fread_char: unknown skill (prompt). ", 0);
		}
		else
		    ch->pcdata->prompt_skill = sn;
		fMatch = TRUE;
		break;
	     }
	    break;

    case 'Q':
    	KEY( "QRun",        ch->pcdata->questsrun,  fread_number( fp ) );
    	KEY( "QuestCnt",    ch->countdown,          fread_number( fp ) );
    	KEY( "QuestMob",    ch->questmob,           fread_number( fp ) );
        KEY( "QuestNext",   ch->nextquest,          fread_number( fp ) );
    	KEY( "QuestObj",    ch->questobj,           fread_number( fp ) );
        KEY( "QuestPnts",   ch->questpoints,        fread_number( fp ) );
	KEY( "QuestInfo",   ch->pcdata->questinfo_data, fread_string(fp));
        break;

	case 'R':
	    /* KEY( "Race",        ch->race,
				race_lookup(fread_string( fp )) ); */
		if ( !str_cmp( word, "Race" ) ) {
	    	char *tmp = fread_string(fp);
	    	ch->race = race_lookup(tmp);
	    	free_string(tmp);
	    	fMatch = TRUE;
	    	break;
		}

	    /*KEYS( "Rank",	ch->pcdata->rank, fread_string( fp ) );*/
		/* this will break all the old code without a version */
		KEY( "Raffle", ch->pcdata->ticket_number, fread_number ( fp ) );
		KEY( "Rebi", ch->pcdata->rebirth, fread_number ( fp ) );
		KEYS( "Rdesc", ch->pcdata->rdesc, fread_string ( fp ) );

	    if ( !str_cmp( word, "Room" ) )
	    {
		ch->in_room = get_room_index( fread_number( fp ) );
		if ( ch->in_room == NULL )
		    ch->in_room = get_room_index( ROOM_VNUM_LIMBO );
		fMatch = TRUE;
		break;
	    }

		KEY( "Rolls", ch->pcdata->stat_rolls, fread_number ( fp ) );

	    if ( !str_cmp( word, "RoomRLE" ) )
	    {
		fread_rle(ch->pcdata->explored, fp);
	        fMatch = TRUE;
		break;
	    }

	    break;

	case 'S':
	    KEY( "SavingThrow",	ch->saving_throw,	fread_number( fp ) );
	    KEY( "Save",	ch->saving_throw,	fread_number( fp ) );
	    KEY( "Scro",	ch->lines,		fread_number( fp ) );
	    KEY( "Sex",		ch->sex,		fread_number( fp ) );
	    KEYS( "ShortDescr",	ch->short_descr,	fread_string( fp ) );
	    KEYS( "ShD",		ch->short_descr,	fread_string( fp ) );
	    KEY( "Sec",         ch->pcdata->security,	fread_number( fp ) );	/* OLC */
		KEY( "SPenny",      ch->money[1][0],   fread_number( fp ) );
		KEY( "SMark",       ch->money[2][0],   fread_number( fp ) );
		if ( !str_cmp( word, "Skill" ) || !str_cmp(word,"Sk"))
		{
			int sn;
			int value;
			char *temp;

			value = fread_number( fp );
			temp = fread_word( fp ) ;
			sn = skill_lookup(temp);
			if ( sn < 0 )
			{
				fprintf(stderr,"%s",temp);
				bug( "Fread_char: unknown skill. ", 0 );
			}
			else
			{
				ch->pcdata->learned[sn] = value;

				if ( is_qskill( sn ) && ch->pcdata->learned[sn] > QSKILL_CAP )
					ch->pcdata->learned[sn] = QSKILL_CAP;
				else
				{
					if ( ch->pcdata->learned[sn] > SKILL_CAP )
						ch->pcdata->learned[sn] = SKILL_CAP;
				}

			}
			fMatch = TRUE;
			break;
		}

		KEY( "Spec",    ch->spec_flags,   fread_flag(fp)); /* Dalsor */
		KEYS( "Spouse",    ch->pcdata->spouse,   fread_string(fp)); /* Dalsor */

		KEY( "SRank",        ch->sub_rank, fread_number( fp ) );

	    if ( !str_cmp( word, "Sguild" ) ) {
		     char *tmp = fread_string(fp);
		     ch->sub_clan = clan_lookup(tmp);
		     free_string(tmp);
		     fMatch = TRUE;
		     break;
		}

		if ( !strcmp( word, "Summary" ) )
		{
			int sums, i = 0;
			for ( i = 0; i <= MAX_SUMMARY; i++ )
			{
				sums = fread_number( fp );
				ch->pcdata->summary[i] = sums;
			}
			fMatch = TRUE;
			reset_summary( ch );
			break;
		}

	    break;

	case 'T':
            KEY( "TrueSex",     ch->pcdata->true_sex,  	fread_number( fp ) );
	    KEY( "TSex",	ch->pcdata->true_sex,   fread_number( fp ) );
	    KEY( "Trai",	ch->train,		fread_number( fp ) );
	    KEY( "Trust",	ch->trust,		fread_number( fp ) );
	    KEY( "Tru",		ch->trust,		fread_number( fp ) );
	    KEY( "Touches",	ch->pcdata->touch_tries,	fread_number( fp ) );

	    if ( !str_cmp( word, "Title" )  || !str_cmp( word, "Titl"))
	    {
		ch->pcdata->title = fread_string( fp );
    		if (ch->pcdata->title[0] != '.' && ch->pcdata->title[0] != ','
		&&  ch->pcdata->title[0] != '!' && ch->pcdata->title[0] != '?')
		{
		    sprintf( buf, " %s", ch->pcdata->title );
		    free_string( ch->pcdata->title );
		    ch->pcdata->title = str_dup( buf );
		}
		fMatch = TRUE;
		break;
	    }

	    break;

	case 'V':
	    KEY( "Vault",     ch->pcdata->has_vault,		fread_number ( fp ) );
	    KEY( "Version",     ch->version,		fread_number ( fp ) );
	    KEY( "Vers",	ch->version,		fread_number ( fp ) );
	    if ( !str_cmp( word, "Vnum" ) )
	    {
		ch->pIndexData = get_mob_index( fread_vnum( fp ) );
		fMatch = TRUE;
		break;
	    }
	    break;

	case 'W':
		KEY( "Warf",    ch->war_flags,   fread_flag(fp)); /* Dalsor */
		KEY( "Warn",    ch->pcdata->warning,   fread_number(fp)); /* Dalsor */
	    KEY( "Wimpy",	ch->wimpy,		fread_number( fp ) );
	    KEY( "Wimp",	ch->wimpy,		fread_number( fp ) );
	    /* added for Walkcode */
        KEYS( "Wkin",    ch->pcdata->wkin,       fread_string( fp ) );
        KEYS( "Wout",    ch->pcdata->wout,       fread_string( fp ) );
	    KEY( "Wizn",	ch->wiznet,		fread_flag( fp ) );
	    break;
	}

	if ( !fMatch )
	{
 /*	    bugf("Could not read an entry for %s,", word ); */
	    /*bug( "Fread_char: no match.", 0 );*/
	    bug( word, 0 );
	    fread_to_eol( fp );
	}
    }
}

/* load a pet from the forgotten reaches */
void fread_pet( CHAR_DATA *ch, FILE *fp )
{
    char *word;
    CHAR_DATA *pet;
    bool fMatch;
    int lastlogoff = current_time;
    int percent;

    /* first entry had BETTER be the vnum or we barf */
    word = feof(fp) ? "END" : fread_word(fp);
    if (!str_cmp(word,"Vnum"))
    {
    	long vnum;

    	vnum = fread_vnum(fp);
    	if (get_mob_index(vnum) == NULL)
	{
    	    bug("Fread_pet: bad vnum %ld.",vnum);
	    pet = create_mobile(get_mob_index(MOB_VNUM_FIDO));
	}
    	else
    	    pet = create_mobile(get_mob_index(vnum));
    }
    else
    {
        bug("Fread_pet: no vnum in file.",0);
        pet = create_mobile(get_mob_index(MOB_VNUM_FIDO));
    }

    for ( ; ; )
    {
    	word 	= feof(fp) ? "END" : fread_word(fp);
    	fMatch = FALSE;

    	switch (UPPER(word[0]))
    	{
    	case '*':
    	    fMatch = TRUE;
    	    fread_to_eol(fp);
    	    break;

    	case 'A':
    	    KEY( "Act",		pet->act,		fread_flag(fp));
    	    KEY( "AfBy",	pet->affected_by,	fread_flag(fp));
    	    KEY( "Alig",	pet->alignment,		fread_number(fp));

    	    if (!str_cmp(word,"ACs"))
    	    {
    	    	int i;

    	    	for (i = 0; i < 4; i++)
    	    	    pet->armor[i] = fread_number(fp);
    	    	fMatch = TRUE;
    	    	break;
    	    }

    	    if (!str_cmp(word,"AffD"))
    	    {
    	    	AFFECT_DATA *paf;
    	    	int sn;

    	    	paf = new_affect();

    	    	sn = skill_lookup(fread_word(fp));
    	     	if (sn < 0)
    	     	    bug("Fread_char: unknown skill.",0);
    	     	else
    	     	   paf->type = sn;

    	     	paf->level	= fread_number(fp);
    	     	paf->duration	= fread_number(fp);
    	     	paf->modifier	= fread_number(fp);
    	     	paf->location	= fread_number(fp);
    	     	paf->bitvector	= fread_number(fp);
    	     	paf->next	= pet->affected;
    	     	pet->affected	= paf;
    	     	fMatch		= TRUE;
    	     	break;
    	    }

            if (!str_cmp(word,"Affc"))
            {
                AFFECT_DATA *paf;
                int sn;

                paf = new_affect();

                sn = skill_lookup(fread_word(fp));
                if (sn < 0)
                    bug("Fread_char: unknown skill.",0);
                else
                   paf->type = sn;

				paf->where	= fread_number(fp);
                paf->level      = fread_number(fp);
                paf->duration   = fread_number(fp);
                paf->modifier   = fread_number(fp);
                paf->location   = fread_number(fp);
                paf->bitvector  = fread_number(fp);
                paf->next       = pet->affected;
                pet->affected   = paf;
                fMatch          = TRUE;
                break;
            }

    	    if (!str_cmp(word,"AMod"))
    	    {
    	     	int stat;

    	     	for (stat = 0; stat < MAX_STATS; stat++)
    	     	    pet->mod_stat[stat] = fread_number(fp);
    	     	fMatch = TRUE;
    	     	break;
    	    }

    	    if (!str_cmp(word,"Attr"))
    	    {
    	         int stat;

    	         for (stat = 0; stat < MAX_STATS; stat++)
    	             pet->perm_stat[stat] = fread_number(fp);
    	         fMatch = TRUE;
    	         break;
    	    }
    	    break;

    	 case 'C':
             KEY( "Clan",       pet->clan,       clan_lookup(fread_string(fp)));
    	     KEY( "Comm",	pet->comm,		fread_flag(fp));
			 KEY( "CPenny", pet->money[0][0],   fread_number(fp)); /* Dalsor */
    	     break;

    	 case 'D':
    	     KEY( "Dam",	pet->damroll,		fread_number(fp));
    	     KEYS( "Desc",	pet->description,	fread_string(fp));
    	     break;

    	 case 'E':
    	     if (!str_cmp(word,"End"))
	     {
		pet->leader = ch;
		pet->master = ch;
		ch->pet = pet;
    		/* adjust hp mana move up  -- here for speed's sake */
    		percent = (current_time - lastlogoff) * 25 / ( 2 * 60 * 60);

    		if (percent > 0 && !IS_AFFECTED(ch,AFF_POISON)
    		&&  !IS_AFFECTED(ch,AFF_PLAGUE))
    		{
		    percent = UMIN(percent,100);
    		    pet->hit	+= (get_maxhit(pet) - pet->hit) * percent / 100;
        	    pet->stam   += (get_maxstam(pet) - pet->stam) * percent / 100;
    		}
    	     	return;
	     }
    	     KEY( "Exp",	pet->exp,		fread_number(fp));
    	     break;

    	 case 'G':
    	     KEY( "GMark",	pet->money[3][0],		fread_number(fp));
    	     break;

    	 case 'H':
    	     KEY( "Hit",	pet->hitroll,		fread_number(fp));

    	     if (!str_cmp(word,"HMV"))
    	     {
    	     	pet->hit	= fread_number(fp);
    	     	pet->max_hit	= fread_number(fp);
    	     	pet->stam	= fread_number(fp);
    	     	pet->max_stam	= fread_number(fp);
    	     	fread_number(fp);
    	     	fread_number(fp);
    	     	fMatch = TRUE;
    	     	break;
    	     }
    	     break;

     	case 'L':
    	     KEY( "Levl",	pet->level,		fread_number(fp));
    	     KEY( "LnD",	pet->long_descr,	fread_string(fp));
	     KEY( "LogO",	lastlogoff,		fread_number(fp));
    	     break;

	case 'M':
    	     KEY( "ModHP",	pet->mod_hit,		fread_number(fp));
    	     KEY( "ModSP",	pet->mod_stam,		fread_number(fp));
	     break;

    	case 'N':
    	     KEYS( "Name",	pet->name,		fread_string(fp));
    	     break;

    	case 'P':
    	     KEY( "Pos",	pet->position,		fread_number(fp));
    	     break;

		case 'R':
			if ( !str_cmp( word, "Race" ) )
			{
				char *tmp = fread_string(fp);
				pet->race = race_lookup(tmp);
				free_string(tmp);
				fMatch = TRUE;
				break;
			}
    	    /*KEYS( "Race",	pet->race, race_lookup(fread_string(fp)));*/
    	    break;

    	case 'S' :
    	    KEY( "Save",	pet->saving_throw,	fread_number(fp));
    	    KEY( "Sex",		pet->sex,		fread_number(fp));
    	    KEYS( "ShD",    pet->short_descr,	fread_string(fp));
	        KEY( "SPenny",  pet->money[1][0],   fread_number( fp ) );
	        KEY( "SMark",   pet->money[2][0],   fread_number( fp ) );
    	    break;

    	if ( !fMatch )
    	{
    	    bug("Fread_pet: no match.",0);
    	    fread_to_eol(fp);
    	}

    	}
    }
}

extern	OBJ_DATA	*obj_free;

void fread_obj( CHAR_DATA *ch, FILE *fp )
{
    OBJ_DATA *obj;
    char *word;
//    char *tmp;
    int iNest;
    bool fMatch;
    bool fNest;
    bool fVnum;
    bool first;
    bool new_format;
    bool make_new;

    fVnum = FALSE;
    obj = NULL;
    first = TRUE;
    new_format = FALSE;
    make_new = FALSE;
    word   = feof( fp ) ? "End" : fread_word( fp );
    if (!str_cmp(word,"Vnum" ))
    {
        long vnum;
		first = FALSE;

        vnum = fread_vnum( fp );
        if (  get_obj_index( vnum )  == NULL )
		{
            bug( "Fread_obj: bad vnum %ld.", vnum );
		}
        else
		{
		    obj = create_object(get_obj_index(vnum),-1);
		    new_format = TRUE;
		}

    }

    if (obj == NULL)
    {
    	obj = new_obj();
    	obj->name		= str_dup( "" );
    	obj->short_descr	= str_dup( "" );
    }

    fNest		= FALSE;
    fVnum		= TRUE;
    iNest		= 0;

    for ( ; ; )
    {
	if (first)
	    first = FALSE;
	else
	    word   = feof( fp ) ? "End" : fread_word( fp );
	fMatch = FALSE;

	switch ( UPPER(word[0]) )
	{
	case '*':
	    fMatch = TRUE;
	    fread_to_eol( fp );
	    break;

	case 'A':
	    if (!str_cmp(word,"AffD"))
	    {
		AFFECT_DATA *paf;
		int sn;

		paf = new_affect();

		sn = skill_lookup(fread_word(fp));
		if (sn < 0)
		    bug("Fread_obj: unknown skill.",0);
		else
		    paf->type = sn;

		paf->level	= fread_number( fp );
		paf->duration	= fread_number( fp );
		paf->modifier	= fread_number( fp );
		paf->location	= fread_number( fp );
		paf->bitvector	= fread_number( fp );
		paf->next	= obj->affected;
		obj->affected	= paf;
		fMatch		= TRUE;
		break;
	    }
        if (!str_cmp(word,"Affc"))
        {
            AFFECT_DATA *paf;
            int sn;

            paf = new_affect();

            sn = skill_lookup(fread_word(fp));
            if (sn < 0)
                bug("Fread_obj: unknown skill.",0);
            else
                paf->type = sn;

			paf->where	= fread_number( fp );
            paf->level      = fread_number( fp );
            paf->duration   = fread_number( fp );
            paf->modifier   = fread_number( fp );
            paf->location   = fread_number( fp );
            paf->bitvector  = fread_number( fp );
            paf->next       = obj->affected;
            obj->affected   = paf;
            fMatch          = TRUE;
            break;
        }
	    break;

	case 'C':
	    KEY( "Cond",	obj->condition,		fread_number( fp ) );
	    if ( obj->condition > 100 )
	    	obj->condition = 100;
	    KEY( "Cost",	obj->cost,		fread_number( fp ) );
	    break;

	case 'D':
	    /*KEYS( "Description",	obj->description,	fread_string( fp ) );*/
//	    KEY( "Desc",	obj->description,	fread_string( fp ) );

	    KEY( "Dye",	obj->dye_vnum,		fread_number( fp ) );

	    if (!str_cmp(word, "Desc"))
	    {
		char *tmp = fread_string(fp);
		free_string(obj->description);
		obj->description = str_dup(tmp);
		free_string(tmp);
		fMatch = TRUE;
		break;
            }

/*
		if ( !str_cmp( word, "Desc" ) )
		{
			char *objd;
			objd = fread_string( fp );
			free_string( obj->description );
			obj->description = str_dup(objd);
			free_string( objd );
			fMatch = TRUE;
			break;
		}
*/
	    break;

	case 'E':
	    if ( !str_cmp( word, "Enchanted"))
	    {
		obj->enchanted = TRUE;
	 	fMatch 	= TRUE;
		break;
	    }

	    KEY( "ExtraFlags",	obj->extra_flags,	fread_number( fp ) );
	    KEY( "ExtF",	obj->extra_flags,	fread_number( fp ) );

	    if ( !str_cmp( word, "ExtraDescr" ) || !str_cmp(word,"ExDe"))
	    {
		EXTRA_DESCR_DATA *ed;

		ed = new_extra_descr();

		ed->keyword		= fread_string( fp );
		ed->description		= fread_string( fp );
		ed->next		= obj->extra_descr;
		obj->extra_descr	= ed;
		fMatch = TRUE;
		break;
	    }

	    if ( !str_cmp( word, "End" ) )
	    {
		if ( !fNest || ( fVnum && obj->pIndexData == NULL ) )
		{
		    bug( "Fread_obj: incomplete object.", 0 );
		    free_obj(obj);
		    return;
		}
		else
    {

		    if ( !fVnum )
		    {
          free_obj( obj );
          obj = create_object( get_obj_index( OBJ_VNUM_DUMMY ), 0 );
		    }

		    if (!new_format)
		    {
		    	obj->next	= object_list;
		    	object_list	= obj;
		    	obj->pIndexData->count++;
		    }

        if ( obj->item_type == ITEM_ANGREAL_FEMALE
        || obj->item_type == ITEM_ANGREAL_MALE )
        {
          if ( obj->value[1] > 20 )
            obj->value[1] = 20;
        }

		    if (!obj->pIndexData->new_format
		    && obj->item_type == ITEM_ARMOR
		    &&  obj->value[1] == 0)
		    {
          obj->value[1] = obj->value[0];
          obj->value[2] = obj->value[0];
		    }

/*	if (make_new)
	{
          int wear;

          wear = obj->wear_loc;
          extract_obj(obj);

          obj = create_object(obj->pIndexData,0);
          obj->wear_loc = wear;
	}
*/

	if ( iNest == 0 || rgObjNest[iNest] == NULL )
        {
          if( ch )
            obj_to_char( obj, ch );
        }
	else if (rgObjNest[iNest-1] != NULL)
          obj_to_obj( obj, rgObjNest[iNest-1] );
		    return;
		}
    }
    break;

	case 'I':
	    if (!str_cmp( word, "Infu" ) )
	    {
	    	AFFECT_DATA *waf, *waf2;
	    	waf = new_affect();
   	        waf->location = fread_number( fp );
       	    waf->modifier = fread_number( fp );
           	waf->where = fread_number( fp );
            waf->type = fread_number( fp );
   	        waf->duration = fread_number( fp );
       	    waf->bitvector = fread_number( fp );
           	waf->level = fread_number( fp );

			if (obj->affected)
			{
				waf2 = obj->affected;

				while (waf2->next != NULL)
					waf2 = waf2->next;

				waf2->next = waf;
			}
			else obj->affected = waf;

/*
			waf->next	= obj->affected;
			obj->affected	= waf;
*/
			fMatch		= TRUE;
			break;
	    }
	    KEY( "ItemType",	obj->item_type,		fread_number( fp ) );
	    KEY( "Ityp",	obj->item_type,		fread_number( fp ) );
	    break;


/*       	case 'K':
    	    if ( !str_cmp( word, "Keyring" ) )
    	    {
    		// load list of key vnums from pfile
	    	load_keyring(fp, obj);
		fMatch = TRUE;
		break;
	    }
	    break;
*/
	case 'L':
	    KEY( "Level",	obj->level,		fread_number( fp ) );
	    KEY( "Lev",		obj->level,		fread_number( fp ) );
	    break;

	case 'M':

	//	KEY( "Mat",     obj->material,  fread_string( fp ) );
	    if (!str_cmp(word, "Mat"))
	    {
		char *tmp = fread_string(fp);
		free_string(obj->material);
		obj->material = str_dup(tmp);
		free_string(tmp);
		fMatch = TRUE;
		break;
            }

		break;

	case 'N':
//	    KEYS( "Name",	obj->name,		fread_string( fp ) );

	    if (!str_cmp(word, "Name"))
	    {
		char *tmp = fread_string(fp);
		free_string(obj->name);
		obj->name = str_dup(tmp);
		free_string(tmp);
		fMatch = TRUE;
		break;
            }


	    if ( !str_cmp( word, "Nest" ) )
	    {
		iNest = fread_number( fp );
		if ( iNest < 0 || iNest >= MAX_NEST )
		{
		    bug( "Fread_obj: bad nest %d.", iNest );
		}
		else
		{
		    rgObjNest[iNest] = obj;
		    fNest = TRUE;
		}
		fMatch = TRUE;
		break;
	    }
	    break;

   	case 'O':
	    if ( !str_cmp( word,"Oldstyle" ) )
	    {
		if (obj->pIndexData != NULL && obj->pIndexData->new_format)
		    make_new = TRUE;
		fMatch = TRUE;
		break;
	    }
		if ( !str_cmp( word, "Owner" ) )
		{
			char *own;
			own = fread_string( fp );
			free_string( obj->owner );
			obj->owner = str_dup( own );
			free_string( own );
			fMatch = TRUE;
			break;
		}
	    break;


	case 'S':
//	    KEY( "ShortDescr",	obj->short_descr,	fread_string( fp ) );
//	    KEY( "ShD",		obj->short_descr,	fread_string( fp ) );

	    if (!str_cmp(word, "ShD"))
	    {
		char *tmp = fread_string(fp);
		free_string(obj->short_descr);
		obj->short_descr = str_dup(tmp);
		free_string(tmp);
		fMatch = TRUE;
		break;
            }

	    if ( !str_cmp( word, "Spell" ) )
	    {
		int iValue;
		int sn;

		iValue = fread_number( fp );
		sn     = skill_lookup( fread_word( fp ) );
		if ( iValue < 0 || iValue > 3 )
		{
		    bug( "Fread_obj: bad iValue %d.", iValue );
		}
		else if ( sn < 0 )
		{
		    bug( "Fread_obj: unknown skill.", 0 );
		}
		else
		{
		    obj->value[iValue] = sn;
		}
		fMatch = TRUE;
		break;
	    }
	    KEY( "Stitchd",	obj->is_stitched,	fread_number( fp ) );
	    break;

	case 'T':
	    KEY( "Timer",	obj->timer,		fread_number( fp ) );
	    KEY( "Time",	obj->timer,		fread_number( fp ) );
	    KEY( "Tailrd",      obj->is_tailored,	fread_number( fp ) );
	    break;

	case 'V':
	    if ( !str_cmp( word, "Values" ) || !str_cmp(word,"Vals"))
	    {
		obj->value[0]	= fread_number( fp );
		obj->value[1]	= fread_number( fp );
		obj->value[2]	= fread_number( fp );
		obj->value[3]	= fread_number( fp );
		if (obj->item_type == ITEM_WEAPON && obj->value[0] == 0)
		   obj->value[0] = obj->pIndexData->value[0];
		if ( obj->item_type == ITEM_WEAPON
		&& ( 1+ obj->value[2] * obj->value[1] / 2 ) <= 81 )
			obj->timer = 1;
		fMatch		= TRUE;
		break;
	    }

	    if ( !str_cmp( word, "Val" ) )
	    {
		obj->value[0] 	= fread_number( fp );
	 	obj->value[1]	= fread_number( fp );
	 	obj->value[2] 	= fread_number( fp );
		obj->value[3]	= fread_number( fp );
		obj->value[4]	= fread_number( fp );
		fMatch = TRUE;
		break;
	    }

	    if ( !str_cmp( word, "Vnum" ) )
	    {
		long vnum;

		vnum = fread_vnum( fp );
		if ( ( obj->pIndexData = get_obj_index( vnum ) ) == NULL )
		    bug( "Fread_obj: bad vnum %ld.", vnum );
		else
		    fVnum = TRUE;
		fMatch = TRUE;
		break;
	    }
	    break;

	case 'W':
	    KEY( "WearFlags",	obj->wear_flags,	fread_number( fp ) );
	    KEY( "WeaF",	obj->wear_flags,	fread_number( fp ) );
	    KEY( "WearLoc",	obj->wear_loc,		fread_number( fp ) );
	    KEY( "Wear",	obj->wear_loc,		fread_number( fp ) );
	    KEY( "Weight",	obj->weight,		fread_number( fp ) );
	    KEY( "Wt",		obj->weight,		fread_number( fp ) );
	    break;

	}

	if ( !fMatch )
	{
	    bug( "Fread_obj: no match.", 0 );
	    fread_to_eol( fp );
	}
    }
}
void fwrite_mount( CHAR_DATA *pet, FILE *fp)
{
    AFFECT_DATA *paf;

    fprintf(fp,"#MOUNT\n");

    fprintf(fp,"Vnum %ld\n",pet->pIndexData->vnum);

    fprintf(fp,"Name %s~\n", pet->name);
    fprintf(fp,"LogO %ld\n", current_time);
    if (pet->short_descr != pet->pIndexData->short_descr)
    	fprintf(fp,"ShD  %s~\n", pet->short_descr);
    if (pet->long_descr != pet->pIndexData->long_descr)
    	fprintf(fp,"LnD  %s~\n", pet->long_descr);
    if (pet->description != pet->pIndexData->description)
    	fprintf(fp,"Desc %s~\n", pet->description);
    if (pet->race != pet->pIndexData->race)
    	fprintf(fp,"Race %s~\n", race_table[pet->race].name);
    if (pet->clan)
        fprintf( fp, "Clan %s~\n",clan_table[pet->clan].name);
    fprintf(fp,"Sex  %d\n", pet->sex);
    if (pet->level != pet->pIndexData->level)
    	fprintf(fp,"Levl %d\n", pet->level);
    fprintf(fp, "HMV  %d %d %d %d 0 0\n",
    	pet->hit, pet->max_hit, pet->stam, pet->max_stam);

//	if (pet->mod_hit > 0)	fprintf(fp, "ModHP %d\n", pet->mod_hit);
//	if (pet->mod_stam > 0)	fprintf(fp, "ModSP %d\n", pet->mod_stam);

    if ( pet->money[3][0] > 0 )
		fprintf( fp, "GMark %ld\n",	pet->money[3][0] );
    else
		fprintf( fp, "GMark %d\n", 0 );
    if ( pet->money[2][0] > 0 )
		fprintf( fp, "SMark %ld\n", pet->money[2][0] );
    else
		fprintf( fp, "SMark %d\n",0 );
    if ( pet->money[1][0] > 0 )
		fprintf( fp, "SPenny %ld\n", pet->money[1][0] );
    else
		fprintf( fp, "SPenny %d\n",0 );
    if ( pet->money[0][0] > 0 )
		fprintf( fp, "CPenny %ld\n", pet->money[0][0] );
    else
		fprintf( fp, "CPenny %d\n",0 );

    if (pet->exp > 0)
    	fprintf(fp, "Exp  %d\n", pet->exp);
    if (pet->act != pet->pIndexData->act)
        fprintf(fp, "Act  %s\n", print_flags(pet->act));
    if (pet->affected_by != pet->pIndexData->affected_by)
        fprintf(fp, "AfBy %s\n", print_flags(pet->affected_by));
    if (pet->comm != 0)
        fprintf(fp, "Comm %s\n", print_flags(pet->comm));
    fprintf(fp,"Pos  %d\n", pet->position = POS_FIGHTING ? POS_STANDING : pet->position);
    if (pet->saving_throw != 0)
    	fprintf(fp, "Save %d\n", pet->saving_throw);
    if (pet->alignment != pet->pIndexData->alignment)
    	fprintf(fp, "Alig %d\n", pet->alignment);
    if (pet->hitroll != pet->pIndexData->hitroll)
    	fprintf(fp, "Hit  %d\n", pet->hitroll);
    if (pet->damroll != pet->pIndexData->damage[DICE_BONUS])
    	fprintf(fp, "Dam  %d\n", pet->damroll);
    fprintf(fp, "ACs  %d %d %d %d\n",
    	pet->armor[0],pet->armor[1],pet->armor[2],pet->armor[3]);
    fprintf(fp, "Attr %d %d %d %d %d %d %d %d\n",
    	pet->perm_stat[STAT_STR], pet->perm_stat[STAT_INT],
    	pet->perm_stat[STAT_WIS], pet->perm_stat[STAT_DEX],
    	pet->perm_stat[STAT_CON], pet->perm_stat[STAT_REF],
    	pet->perm_stat[STAT_INS], pet->perm_stat[STAT_CHA]);
    fprintf(fp, "AMod %d %d %d %d %d %d %d %d\n",
    	pet->mod_stat[STAT_STR], pet->mod_stat[STAT_INT],
    	pet->mod_stat[STAT_WIS], pet->mod_stat[STAT_DEX],
    	pet->mod_stat[STAT_CON], pet->mod_stat[STAT_REF],
    	pet->mod_stat[STAT_INS], pet->mod_stat[STAT_CHA]);

    for ( paf = pet->affected; paf != NULL; paf = paf->next )
    {
    	if (paf->type < 0 || paf->type >= MAX_SKILL)
    	    continue;

    	fprintf(fp, "Affc '%s' %3d %3d %3d %3d %3d %10d\n",
    	    skill_table[paf->type].name,
    	    paf->where, paf->level, paf->duration, paf->modifier,paf->location,
    	    paf->bitvector);
    }

    fprintf(fp,"End\n");
    return;
}



/* load a mount from the forgotten reaches */
void fread_mount( CHAR_DATA *ch, FILE *fp )
{
    char *word;
    CHAR_DATA *pet;
    bool fMatch;
    int lastlogoff = current_time;
    int percent;

    /* first entry had BETTER be the vnum or we barf */
    word = feof(fp) ? "END" : fread_word(fp);
    if (!str_cmp(word,"Vnum"))
    {
    	long vnum;

    	vnum = fread_vnum(fp);
    	if (get_mob_index(vnum) == NULL)
	{
    	    bug("Fread_mount: bad vnum %ld.",vnum);
	    pet = create_mobile(get_mob_index(MOB_VNUM_FIDO));
	}
    	else
    	    pet = create_mobile(get_mob_index(vnum));
    }
    else
    {
        bug("Fread_mount: no vnum in file.",0);
        pet = create_mobile(get_mob_index(MOB_VNUM_FIDO));
    }

    for ( ; ; )
    {
    	word 	= feof(fp) ? "END" : fread_word(fp);
    	fMatch = FALSE;

    	switch (UPPER(word[0]))
    	{
    	case '*':
    	    fMatch = TRUE;
    	    fread_to_eol(fp);
    	    break;

    	case 'A':
            KEY( "Act",         pet->act,               fread_flag(fp));
            KEY( "AfBy",        pet->affected_by,       fread_flag(fp));
    	    KEY( "Alig",	pet->alignment,		fread_number(fp));

    	    if (!str_cmp(word,"ACs"))
    	    {
    	    	int i;

    	    	for (i = 0; i < 4; i++)
    	    	    pet->armor[i] = fread_number(fp);
    	    	fMatch = TRUE;
    	    	break;
    	    }

    	    if (!str_cmp(word,"AffD"))
    	    {
    	    	AFFECT_DATA *paf;
    	    	int sn;

                paf = new_affect();

                sn = skill_lookup(fread_word(fp));
                if (sn < 0)
                    bug("Fread_char: unknown skill.",0);
                else
                   paf->type = sn;

                paf->level      = fread_number(fp);
                paf->duration   = fread_number(fp);
                paf->modifier   = fread_number(fp);
                paf->location   = fread_number(fp);
                paf->bitvector  = fread_number(fp);
                paf->next       = pet->affected;
                pet->affected   = paf;
                fMatch          = TRUE;
                break;
	   }

            if (!str_cmp(word,"Affc"))
            {
                AFFECT_DATA *paf;
                int sn;

                paf = new_affect();

                sn = skill_lookup(fread_word(fp));
                if (sn < 0)
                    bug("Fread_char: unknown skill.",0);
                else
                   paf->type = sn;

                paf->where      = fread_number(fp);
                paf->level      = fread_number(fp);
                paf->duration   = fread_number(fp);
                paf->modifier   = fread_number(fp);
                paf->location   = fread_number(fp);
                paf->bitvector  = fread_number(fp);
                paf->next       = pet->affected;
                pet->affected   = paf;
                fMatch          = TRUE;
                break;
	    }

    	    if (!str_cmp(word,"AMod"))
    	    {
    	     	int stat;

    	     	for (stat = 0; stat < MAX_STATS; stat++)
    	     	    pet->mod_stat[stat] = fread_number(fp);
    	     	fMatch = TRUE;
    	     	break;
    	    }

    	    if (!str_cmp(word,"Attr"))
    	    {
    	         int stat;

    	         for (stat = 0; stat < MAX_STATS; stat++)
    	             pet->perm_stat[stat] = fread_number(fp);
    	         fMatch = TRUE;
    	         break;
    	    }
    	    break;

		case 'C':
			if ( !str_cmp( word, "Clan" ) )
			{
				char *tmp = fread_string(fp);
				pet->clan = clan_lookup(tmp);
				free_string(tmp);
				fMatch = TRUE;
				break;
			}
			 /*KEYS( "Clan",       pet->clan,       clan_lookup(fread_string(fp)));*/
		     KEY( "Comm",	pet->comm,		fread_flag(fp));
		     KEY( "Cpenny", pet->money[0][0], fread_number(fp));
    	     break;

    	 case 'D':
    	     KEY( "Dam",	pet->damroll,		fread_number(fp));
    	     KEYS( "Desc",	pet->description,	fread_string(fp));
    	     break;

    	 case 'E':
    	     if (!str_cmp(word,"End"))
	     {
                ch->mount = pet;
                pet->mount = ch;
                /* adjust hp mana move up  -- here for speed's sake */
                percent = (current_time - lastlogoff) * 25 / ( 2 * 60 * 60);

                if (percent > 0 && !IS_AFFECTED(ch,AFF_POISON)
                &&  !IS_AFFECTED(ch,AFF_PLAGUE))
                {
                    percent = UMIN(percent,100);
                    pet->hit    += (get_maxhit(pet) - pet->hit) * percent / 100;
                    pet->stam   += (get_maxstam(pet) - pet->stam) * percent / 100;
                }

    	     	return;
	     }
    	     KEY( "Exp",	pet->exp,		fread_number(fp));
    	     break;

    	 case 'G':
    	     KEY( "GMark",	pet->money[3][0],		fread_number(fp));
    	     break;

    	 case 'H':
    	     KEY( "Hit",	pet->hitroll,		fread_number(fp));

    	     if (!str_cmp(word,"HMV"))
    	     {
    	     	pet->hit	= fread_number(fp);
    	     	pet->max_hit	= fread_number(fp);
    	     	pet->stam	= fread_number(fp);
    	     	pet->max_stam	= fread_number(fp);
    	     	fread_number(fp);
    	     	fread_number(fp);
    	     	fMatch = TRUE;
    	     	break;
    	     }
    	     break;

     	case 'L':
    	     KEY( "Levl",	pet->level,		fread_number(fp));
    	     KEYS( "LnD",	pet->long_descr,	fread_string(fp));
             KEY( "LogO",       lastlogoff,             fread_number(fp));
    	     break;

	case 'M':
    	     KEY( "ModHP",	pet->mod_hit,		fread_number(fp));
    	     KEY( "ModSP",	pet->mod_stam,		fread_number(fp));
	     break;

    	case 'N':
    	     KEY( "Name",	pet->name,		fread_string(fp));
    	     break;

    	case 'P':
    	     KEY( "Pos",	pet->position,		fread_number(fp));
    	     break;

		case 'R':
			if ( !str_cmp( word, "Race" ) )
			{
				char *tmp = fread_string(fp);
				pet->race = race_lookup(tmp);
				free_string(tmp);
				fMatch = TRUE;
				break;
			}
			/*KEYS( "Race",	pet->race, race_lookup(fread_string(fp)));*/
    	    break;

    	case 'S' :
    	    KEY( "Save",	pet->saving_throw,	fread_number(fp));
    	    KEY( "Sex",		pet->sex,		fread_number(fp));
    	    KEYS( "ShD",		pet->short_descr,	fread_string(fp));
    	    KEY( "SPenny", pet->money[1][0], fread_number(fp));
    	    KEY( "SMark", pet->money[2][0], fread_number(fp));
    	    break;

    	if ( !fMatch )
    	{
    	    bug("Fread_mount: no match.",0);
    	    fread_to_eol(fp);
    	}

    	}
    }

}




