/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"

/*
char *const distance1[4]=
{
"{cright here.", "{cnearby to the %s.", "{cnot far %s.", "{coff in the distance %s."
};
*/

char *const distance1[4]=
{
"Here               ", "Nearby %-10s  ", "Not Far %-10s ", "Distant %-10s "
};

void scan_list1           args((ROOM_INDEX_DATA *scan_room, CHAR_DATA *ch,
                               sh_int depth, sh_int door));
void scan_char1           args((CHAR_DATA *victim, CHAR_DATA *ch,
                               sh_int depth, sh_int door));

void do_scan(CHAR_DATA *ch, char *argument)
{
	extern char *const dir_name[];
	char arg1[MAX_INPUT_LENGTH], buf[MAX_INPUT_LENGTH];
	ROOM_INDEX_DATA *scan_room;
	EXIT_DATA *pExit;
	sh_int door, depth;

	argument = one_argument(argument, arg1);

	if (arg1[0] == '\0')
	{
		act("{c$n looks all around.", ch, NULL, NULL, TO_ROOM);
		stc("{cLooking around you see:\n\r", ch);
                scan_list1(ch->in_room, ch, 0, -1);

		for (door=0; door < MAX_DIR; door++)
		{
			if ((pExit = ch->in_room->exit[door]) != NULL)
				scan_list1(pExit->u1.to_room, ch, 1, door);
		}
		check_improve(ch,gsn_scan,TRUE,5);
		return;
	}
	else if (!str_cmp(arg1, "n") || !str_cmp(arg1, "north")) door = 0;
	else if (!str_cmp(arg1, "e") || !str_cmp(arg1, "east"))  door = 1;
	else if (!str_cmp(arg1, "s") || !str_cmp(arg1, "south")) door = 2;
	else if (!str_cmp(arg1, "w") || !str_cmp(arg1, "west"))  door = 3;
	else if (!str_cmp(arg1, "u") || !str_cmp(arg1, "up" ))   door = 4;
	else if (!str_cmp(arg1, "d") || !str_cmp(arg1, "down"))  door = 5;
	else if (!str_cmp(arg1, "ne") || !str_cmp(arg1, "northeast"))  door = 6;
	else if (!str_cmp(arg1, "se") || !str_cmp(arg1, "southeast"))  door = 7;
	else if (!str_cmp(arg1, "sw") || !str_cmp(arg1, "southwest"))  door = 8;
	else if (!str_cmp(arg1, "nw") || !str_cmp(arg1, "northwest"))  door = 9;
	else { send_to_char("{cWhich way do you want to scan?\n\r", ch); return; }

	act("{cYou peer intently $T.", ch, NULL, dir_name[door], TO_CHAR);
	act("{c$n peers intently $T.", ch, NULL, dir_name[door], TO_ROOM);
	sprintf(buf, "{cLooking %s you see:\n\r", dir_name[door]);

	scan_room = ch->in_room;

	for (depth = 1; depth < 4; depth++)
	{
		if ((pExit = scan_room->exit[door]) != NULL)
		{
			scan_room = pExit->u1.to_room;
			scan_list1(pExit->u1.to_room, ch, depth, door);
		}
	}
	check_improve(ch,gsn_scan,TRUE,5);
	return;
}

void scan_list1(ROOM_INDEX_DATA *scan_room, CHAR_DATA *ch, sh_int depth, sh_int door)
{
	CHAR_DATA *rch;

	if (scan_room == NULL) return;

	for (rch=scan_room->people; rch != NULL; rch=rch->next_in_room)
	{
		if (rch == ch) continue;
		if (!IS_NPC(rch) && rch->invis_level > get_trust(ch)) continue;
		if ( IS_SET(rch->act,ACT_UNDEAD) )
		{
			if (IS_NPC(rch) && rch->pIndexData->vnum != ch->questmob)
				continue;
		}
		if (can_see(ch, rch)) scan_char1(rch, ch, depth, door);
	}
	return;
}

void scan_char1(CHAR_DATA *victim, CHAR_DATA *ch, sh_int depth, sh_int door)
{
	extern char *const dir_name[];
	extern char *const distance1[];
	char buf[MIL];

	buf[0] = '\0';

	if ( IS_SET(victim->act,ACT_UNDEAD) )
	{
		if (IS_NPC(victim) && victim->pIndexData->vnum != ch->questmob)
		return;
	}

	if (ON_GQUEST(ch)
	&& IS_NPC(victim)
	&& is_gqmob(ch, victim->pIndexData->vnum) != -1)
		strcat(buf, "(GQuest) ");

	sprintf(buf, distance1[depth], dir_name[door]);
	strcat(buf, PERS(victim, ch));
	strcat(buf, "\n\r");

	stc(buf, ch);
	return;
}
