#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"
#include "mysql5_interface.h"

#define msg ptc
char * show_rbi_letter_no_color args((CHAR_DATA *ch));

/* New score command -- Dalsor 04.26.2013 */
long fileSize(FILE *fp)
{    
	fseek(fp, 0L, SEEK_END);
	return ftell(fp);
}
int get_pfile_size( CHAR_DATA *ch )
{
	FILE *fp;
	char strsave[MAX_INPUT_LENGTH]; 

	sprintf( strsave, "%s%s", PLAYER_DIR, capitalize( ch->name ) );

	if ( ( fp = fopen( strsave, "r" ) ) != NULL ) 
	{
		ch->pcdata->pfile_size = fileSize(fp);
		fclose( fp );
	}
	return ch->pcdata->pfile_size;
}

void show_new_score( CHAR_DATA *ch, CHAR_DATA *viewer)
{
	int pfile = get_pfile_size(ch);

	msg(viewer,"   {wYou are %s{w %s{w, {w%s\n\r",
		ch->name, ch->pcdata->last_name, clan_table[ch->clan].name);

	msg(viewer,"{C+{c---------------------------------------------------------------{C+{c\n\r");

	msg(viewer,"{c|{w  {CLevel{w: {c%-4d  {CRemorts{w: {c%-4d  {CTier{w: {c%-2d {w[{c%s{w]   {CStatus{w: {c%-7s   {c|{w\n\r", 
		ch->level, ch->pcdata->rebirth, calc_remort_tier(ch), show_rbi_letter_no_color(ch), can_remort(ch) ? "Rebirth" : "Level" );

	msg(viewer,"{c|{w  {CQuest Points{w: {c%-6d  {CQuests Run{w: {c%-5d  {CStatus{w: {c%-7s     {c|{w\n\r",
		ch->questpoints, ch->pcdata->questsrun, ch->nextquest == 0 ? "Ready" : "Waiting" );

	msg(viewer,"{C+{c---------------------------------------------------------------{C+{c\n\r");

	msg(viewer,"{c|{W                      {GINFORMATIONAL STATS                      {c|{w\n\r");

	msg(viewer,"{C+{c------------------------------{C+{c--------------------------------{C+{c\n\r");

	msg(viewer,"{c|{w   {CHealth{w:  {c%-7d {w[{c%-7d{w] {c|{w   {CInverted{w:  {c%-3s               {c|{w\n\r", 
		ch->hit, get_maxhit(ch), IS_AFFECTED(ch, AFF_INVISIBLE) ? "Yes" : "No" );

	msg(viewer,"{c|{w   {CStamina{w: {c%-7d {w[{c%-7d{w] {c|{w   {CHiding{w:    {c%-7s           {c|{w\n\r", 
		ch->stam, get_maxstam(ch), IS_AFFECTED(ch, AFF_HIDE) ? "Hiding" : "Visible" );

	msg(viewer,"{c|{w   {CWimpy{w:   {c%-7ld           {c|{w   {CSneaking{w:  {c%-10s        {c|{w\n\r", 
		ch->wimpy, IS_AFFECTED(ch, AFF_SNEAK) ? "Silent" : "Not Silent" );

	msg(viewer,"{c|{w   {CTrains{w:  {c%-6d            {C+{c--------------------------------{C+{w \n\r",
		ch->train);

	msg(viewer,"{c|{w   {CPoisoned{w:    {c%-3s           {c|{w   {CCopper{w: {c%7ld {w[{c%-7ld{w]    {c|{w\n\r",
		is_affected(ch, gsn_poison) ? "Yes" : "No", ch->money[0][0], ch->money[0][1]  );

	msg(viewer,"{c|{w   {CBlinded{w:     {c%-3s           {c|{w   {CSilver{w: {c%7ld {w[{c%-7ld{w]    {c|{w\n\r",
		IS_AFFECTED(ch, gsn_blindness) ? "Yes" : "No", ch->money[1][0], ch->money[1][1] );

	msg(viewer,"{C+{c------------------------------{C+{w   {CMarks{w:  {c%7ld {w[{c%-7ld{w]    {c|{w\n\r",
		ch->money[2][0], ch->money[2][1]);

	msg(viewer,"{c|{w   {CPFile Size{w:  {c%-6s        {c|{w   {CGold{w:   {c%7ld {w[{c%-7ld{w]    {c|{w\n\r",
		pfile > 50000 ? "Huge" : 
		pfile > 30000 ? "Large" : 
		pfile > 10000 ? "Medium" : "Small", 
		ch->money[3][0], ch->money[3][1]);

	msg(viewer,"{c|{w   {CWeight{w:      {c%-5d         {C+{c--------------------------------{C+{w\n\r",
		get_carry_weight(ch) );

	msg(viewer,"{c|{w   {CCarrying{w:    {c%-5d {w[{c%-5d{w] {c|{w   {CUnread Notes{w:  {c%-3d           {c|{w\n\r",
		ch->carry_number, can_carry_n(ch), count_unread_notes(ch) );

	msg(viewer,"{C+{c------------------------------{C+{c--------------------------------{C+{c\n\r");

	if(IS_SET( ch->op_flags, OP_CHANNELER))
	{
		msg(viewer,"{c|{W   {GARMOR STATS                {c|{W   {GONE POWER STATS              {c|{w\n\r");

		msg(viewer,"{C+{c------------------------------{C+{c--------------------------------{C+{c\n\r");

		msg(viewer,"{c|{w   {CPierce{w: {c%-6d             {c|{w   {CAir{w:   {c%-3d   {CSpirit{w:  {c%-3d    {c|{w\n\r", 
			GET_AC(ch,AC_PIERCE), ch->pcdata->op_air, ch->pcdata->op_spirit);

		msg(viewer,"{c|{w   {CBash{w:   {c%-6d             {c|{w   {CEarth{w: {c%-3d   {CWater{w:   {c%-3d    {c|{w\n\r", 
			GET_AC(ch,AC_BASH), ch->pcdata->op_earth, ch->pcdata->op_water);

		msg(viewer,"{c|{w   {CSlash{w:  {c%-6d             {c|{w   {CFire{w:  {c%-3d                   {c|{w\n\r", 
			GET_AC(ch,AC_SLASH), ch->pcdata->op_fire);

		msg(viewer,"{c|{w   {CWeaves{w: {c%-6d             {c|{w   {CAverage{w: {c%-3d {w[{c%-3d{w]           {c|{w\n\r", 
			GET_AC(ch,AC_EXOTIC), true_op_average(ch), true_op_average(ch)+true_angreal_bonus(ch));
	}
	else
	{
		msg(viewer,"{c|{W   {GARMOR STATS                {c|{W   {GMASTERY                      {c|{w\n\r");

		msg(viewer,"{C+{c------------------------------{C+{c--------------------------------{C+{c\n\r");

		msg(viewer,"{c|{w   {CPierce{w: {c%-6d             {c|{w   {CPrecise{w:     {c%-3d             {c|{w\n\r",
			GET_AC(ch,AC_PIERCE), get_skill(ch,gsn_precision));

		msg(viewer,"{c|{w   {CBash{w:   {c%-6d             {c|{w   {CEfficient{w:   {c%-3d             {c|{w\n\r",
			GET_AC(ch,AC_BASH), get_skill(ch,gsn_efficient));

		msg(viewer,"{c|{w   {CSlash{w:  {c%-6d             {c|{w   {CMaster{w:      {c%-3d             {c|{w\n\r",
			GET_AC(ch,AC_SLASH), master_perc(ch));

		msg(viewer,"{c|{w   {CWeaves{w: {c%-6d             {c|{w   {CReaction{w:    {c%-3d             {c|{w\n\r",
			GET_AC(ch,AC_EXOTIC), get_skill(ch,gsn_anticipate));
	}

	msg(viewer,"{C+{c------------------------{C+{c-----{C+{c------------------{C+{c-------------{C+{c\n\r");

	msg(viewer,"{c|{W  {GCOMBAT STATS          {c|{W {GBODY STATS             {c|{W {GTALENTS     {c|{w\n\r");

	msg(viewer,"{C+{c------------------------{C+{c------------------------{C+{c-------------{C+{c\n\r");

	msg(viewer,"{c|{w  {CStrength{w:    {c%-3d {w[{c%-3d{w]{c|{w {CIntelligence{w: {c%-3d {w[{c%-3d{w]{c|{w %sWolfkin     {c|{w\n\r",
		get_curr_stat(ch,STAT_STR),ch->perm_stat[STAT_STR], 
		get_curr_stat(ch,STAT_INT),ch->perm_stat[STAT_INT],
		WOLF(ch) ? "{G" : "{R" );

	msg(viewer,"{c|{w  {CDexterity{w:   {c%-3d {w[{c%-3d{w]{c|{w {CWisdom{w:       {c%-3d {w[{c%-3d{w]{c|{w %sDreamer     {c|{w\n\r",
		get_curr_stat(ch,STAT_DEX),ch->perm_stat[STAT_DEX], 
		get_curr_stat(ch,STAT_WIS),ch->perm_stat[STAT_WIS],
		DREAM(ch) ? "{G" : "{R" );

	msg(viewer,"{c|{w  {CReflex{w:      {c%-3d {w[{c%-3d{w]{c|{w {CInstinct{w:     {c%-3d {w[{c%-3d{w]{c|{w %sSeer        {c|{w\n\r",
		get_curr_stat(ch,STAT_REF),ch->perm_stat[STAT_REF], 
		get_curr_stat(ch,STAT_INS),ch->perm_stat[STAT_INS],
		SEER(ch) ? "{G" : "{R" );

	msg(viewer,"{c|{w  {CHit Roll{w:    {c%-5d    {c|{w {CCharisma{w:     {c%-3d {w[{c%-3d{w]{c|{w %sTa'veren    {c|{w\n\r",
		GET_HITROLL(ch),
		get_curr_stat(ch,STAT_CHA),ch->perm_stat[STAT_CHA], 
		TAV(ch) ? "{G" : "{R" );

	msg(viewer,"{c|{w  {CDamage Roll{w: {c%-4d     {c|{w {CConstitution{w: {c%-3d {w[{c%-3d{w]{c|{w             {c|{w\n\r",
		GET_DAMROLL(ch),
		get_curr_stat(ch,STAT_CON),ch->perm_stat[STAT_CON] );

	msg(viewer,"{C+{c------------------------{C+{c------------------------{C+{c-------------{C+{c\n\r");

	nlcr(viewer); 
}

void do_new_score( CHAR_DATA *ch, char *argument )
{
	char arg1[MIL];
	CHAR_DATA *viewer = NULL;

	argument = one_argument( argument, arg1 ); 

	if (IS_NPC(ch)) 
		return;

	if(arg1[0] == '\0')
		viewer = ch;

	else if(IS_IMMORTAL(ch) && !str_cmp(argument,"force") )
	{
		if ( (( viewer = get_pc_world( ch, arg1 ) ) == NULL) || (viewer->invis_level>0 && !IS_IMMORTAL(ch)) )
		{
			stc("Show your score to who?\n",ch); 
			return;                 
		}
		show_new_score(viewer/* not viewer, but the victim */, ch /* the real immortal viewer */);
		return;
	}   
	else
	{    
		if ( (( viewer = get_pc_world( ch, arg1 ) ) == NULL) || (viewer->invis_level>0 && !IS_IMMORTAL(ch)) )
		{
			stc("Show your score to who?\n",ch);
			return;
		}
		else
		{
			ptc(ch,"You show your score to %s.\n\r", viewer->name);
			ptc(viewer,"%s shows %s score to you.\n\r",ch->name, ch->sex == SEX_FEMALE ? "her" : "his");
		}
	}
	show_new_score(ch, viewer);
}

void do_worth( CHAR_DATA *ch, char *argument )
{

        msg( ch, "{C+{c-----------------------------------{C+{c\n\r");

	stc( "{c|{w              Money                {c|{x\n\r", ch );

        msg( ch, "{C+{c-----------------------------------{C+{c\n\r");

        stc( "{c|{w  On Hand          In Bank         {c|{x\n\r", ch );

        msg( ch, "{c|{w  {CCopper{w: {c%7ld  {w[{c%-7ld{w]       {c|{x\n\r", ch->money[0][0], ch->money[0][1]);
        msg( ch, "{c|{w  {CSilver{w: {c%7ld  {w[{c%-7ld{w]       {c|{x\n\r", ch->money[1][0], ch->money[1][1]);
        msg( ch, "{c|{w  {CMarks{w:  {c%7ld  {w[{c%-7ld{w]       {c|{x\n\r", ch->money[2][0], ch->money[2][1]);
        msg( ch, "{c|{w  {CGold{w:   {c%7ld  {w[{c%-7ld{w]       {c|{x\n\r", ch->money[3][0], ch->money[3][1]);

        msg( ch, "{C+{c-----------------------------------{C+{c\n\r");

        stc( "{c|{w              Points               {c|{x\n\r", ch );

        msg( ch, "{C+{c-----------------------------------{C+{c\n\r");

        msg( ch, "{c|{w  {CQPs{w:    {c%7d  {CQTimer{w: {c%-3d     {c|{x\n\r", ch->questpoints, ch->nextquest);
        msg( ch, "{c|{w  {CEXP{w:    {c%d  {CTrains{w: {c%-6d  {c|{x\n\r", ch->exp, ch->train );

        msg( ch, "{C+{c-----------------------------------{C+{c\n\r");

        return;
}


