/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif

#include <sys/wait.h>

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/resource.h>
#include <ulimit.h>
#include <unistd.h> /* OLC -- for close read write etc */
#include <stdarg.h> /* printf_to_char */
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>

#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "mysql5_interface.h"

char *check_dye args((OBJ_DATA *obj, char *string, int dye_vnum));

/*
 * Write to one char.
 */
void send_to_char_bw( const char *txt, CHAR_DATA *ch )
{
    if ( txt != NULL && ch->desc != NULL )
        write_to_buffer( ch->desc, txt, strlen(txt) );
    return;
}

/*
 * Send a page to one char.
 */
void page_to_char_bw( const char *txt, CHAR_DATA *ch )
{
    if ( txt == NULL || ch->desc == NULL)
	return;

    if (ch->lines == 0 )
    {
	send_to_char_bw(txt,ch);
	return;
    }

#if defined(macintosh)
	send_to_char_bw(txt,ch);
#else
    ch->desc->showstr_head = alloc_mem(strlen(txt) + 1);
    strcpy(ch->desc->showstr_head,txt);
    ch->desc->showstr_point = ch->desc->showstr_head;
    show_string(ch->desc,"");
#endif
}

/*
 * Page to one char, new colour version, by Lope.
 */
void send_to_char( const char *txt, CHAR_DATA *ch )
{
	const char *point;
	char	*point2;
	char	buf[MSL*4];
	int	skip = 0;

	buf[0] = '\0';
	point2 = buf;

	if( txt && ch->desc )
	{
		if( IS_SET( ch->act, PLR_COLOUR ) )
		{
			for( point = txt ; *point ; point++ )
 	        {
	 		    if( *point == '{' )
	 		    {
		 			point++;
		 			skip = colour( *point, ch, point2 );
		 			while( skip-- > 0 )
		 			    ++point2;
		 			continue;
	 		    }
	 		    *point2 = *point;
	 		    *++point2 = '\0';
	 		}
	 		*point2 = '\0';
         	write_to_buffer( ch->desc, buf, point2 - buf );
 	    }
 	    else
 	    {
	 		for( point = txt ; *point ; point++ )
 	        {
	 		    if( *point == '{' )
	 		    {
		 			point++;
		 			continue;
	 		    }
	 		    *point2 = *point;
	 		    *++point2 = '\0';
	 		}
	 		*point2 = '\0';
         	write_to_buffer( ch->desc, buf, point2 - buf );
 	    }
 	}
	return;
}
/*
void stc( const char *txt, CHAR_DATA *ch )
{
    const	char 	*point;
	char 	*point2;
	char 	buf[ MAX_STRING_LENGTH*4 ];
	int	skip = 0;
    buf[0] = '\0';
    point2 = buf;
    if( txt && ch->desc )
	{
	    if( IS_SET( ch->act, PLR_COLOUR ) )
	    {
		for( point = txt ; *point ; point++ )
	        {
		    if( *point == '{' )
		    {
			point++;
			skip = colour( *point, ch, point2 );
			while( skip-- > 0 )
			    ++point2;
			continue;
		    }
		    *point2 = *point;
		    *++point2 = '\0';
		}
		*point2 = '\0';
        	write_to_buffer( ch->desc, buf, point2 - buf );
	    }
	    else
	    {
		for( point = txt ; *point ; point++ )
	        {
		    if( *point == '{' )
		    {
			point++;
			continue;
		    }
		    *point2 = *point;
		    *++point2 = '\0';
		}
		*point2 = '\0';
        	write_to_buffer( ch->desc, buf, point2 - buf );
	    }
	}
    return;
}
*/

void page_to_char( const char *txt, CHAR_DATA *ch )
{
	const char *point;
	char *point2;
	char buf[MSL*4];
	int skip = 0;

	#if defined(macintosh)
	    stc( txt, ch );
	#else
	buf[0] = '\0';
	point2 = buf;
    if( txt && ch->desc )
	{
	    if( IS_SET( ch->act, PLR_COLOUR ) )
	    {
			for( point = txt ; *point ; point++ )
	        {
			    if( *point == '{' )
			    {
					point++;
					skip = colour( *point, ch, point2 );
					while( skip-- > 0 )
					    ++point2;
					continue;
			    }
			    *point2 = *point;
			    *++point2 = '\0';
			}
			*point2 = '\0';
			ch->desc->showstr_head  = alloc_mem( strlen( buf ) + 1 );
			strcpy( ch->desc->showstr_head, buf );
			ch->desc->showstr_point = ch->desc->showstr_head;
			show_string( ch->desc, "" );
	    }
	    else
	    {
			for( point = txt ; *point ; point++ )
	        {
			    if( *point == '{' )
			    {
					point++;
					continue;
			    }
			    *point2 = *point;
			    *++point2 = '\0';
			}
			*point2 = '\0';
			ch->desc->showstr_head  = alloc_mem( strlen( buf ) + 1 );
			strcpy( ch->desc->showstr_head, buf );
			ch->desc->showstr_point = ch->desc->showstr_head;
			show_string( ch->desc, "" );
	    }
	}
	#endif
    return;
}

/* string pager */
void show_string(struct descriptor_data *d, char *input)
{
    char buffer[4*MAX_STRING_LENGTH];
    char buf[MAX_INPUT_LENGTH];
    register char *scan, *chk;
    int lines = 0, toggle = 1;
    int show_lines;

    one_argument(input,buf);
    if (buf[0] != '\0')
    {
		if (d->showstr_head)
		{
		    free_mem(d->showstr_head,strlen(d->showstr_head)+1);
		    d->showstr_head = 0;
		}
    	d->showstr_point  = 0;
		return;
    }

    if (d->character)
		show_lines = d->character->lines;
    else
		show_lines = 0;

    for (scan = buffer; ; scan++, d->showstr_point++)
    {
		if (((*scan = *d->showstr_point) == '\n' || *scan == '\r')
	    && (toggle = -toggle) < 0)
		    lines++;

		else if (!*scan || (show_lines > 0 && lines >= show_lines))
		{
		    *scan = '\0';
		    write_to_buffer(d,buffer,strlen(buffer));
		    for (chk = d->showstr_point; isspace(*chk); chk++);
		    {
				if (!*chk)
				{
				    if (d->showstr_head)
	        	    {
	            		free_mem(d->showstr_head,strlen(d->showstr_head)+1);
	            		d->showstr_head = 0;
	        	    }
	        	    d->showstr_point  = 0;
	    		}
		    }
		    return;
		}
    }
    return;
}

/* quick sex fixer */
void fix_sex(CHAR_DATA *ch)
{
    if (ch->sex < 0 || ch->sex > 2)
    	ch->sex = IS_NPC(ch) ? 0 : ch->pcdata->true_sex;
}

void act_new( const char *format, CHAR_DATA *ch, const void *arg1,
	      const void *arg2, int type, int min_pos)
{
    static char * const he_she  [] = { "it",  "he",  "she" };
    static char * const him_her [] = { "it",  "him", "her" };
    static char * const his_her [] = { "its", "his", "her" };

    char buf[MAX_STRING_LENGTH];
    char fname[MAX_INPUT_LENGTH];
    CHAR_DATA *to;
    CHAR_DATA *vch = (CHAR_DATA *) arg2;
    OBJ_DATA *obj1 = (OBJ_DATA  *) arg1;
    OBJ_DATA *obj2 = (OBJ_DATA  *) arg2;
    const char *str;
    const char *i;
    char *point;
    char              *pbuff;
	char              buffer[ MAX_STRING_LENGTH*2 ];
    bool              fColour = FALSE;


    /*
     * Discard null and zero-length messages.
     */
    if ( format == NULL || format[0] == '\0' )
        return;

    /* discard null rooms and chars */
    if (ch == NULL || ch->in_room == NULL)
		return;

/*
   	strcat(buffer,"{w");
   	strcat(buf,"{w");
*/
    to = ch->in_room->people;
    if ( type == TO_VICT )
    {
        if ( vch == NULL )
        {
            bug( "Act: null vch with TO_VICT.", 0 );
            return;
        }

		if (vch->in_room == NULL)
		    return;
        to = vch->in_room->people;
    }

    for ( ; to != NULL; to = to->next_in_room )
    {
		if ( (!IS_NPC(to) && to->desc == NULL )
		||   ( IS_NPC(to) && !HAS_TRIGGER_MOB(to, TRIG_ACT) )
		||    to->position < min_pos )
            continue;

        if ( (type == TO_CHAR) && to != ch )
            continue;
        if ( type == TO_VICT && ( to != vch || to == ch ) )
            continue;
        if ( type == TO_ROOM && to == ch )
            continue;
        if ( type == TO_NOTVICT && (to == ch || to == vch) )
            continue;

        point   = buf;
        str     = format;
        while ( *str != '\0' )
        {
            if ( *str != '$' )
            {
                *point++ = *str++;
                continue;
            }
			fColour = TRUE;
            ++str;
			i = " <@@@> ";

            if ( arg2 == NULL && *str >= 'A' && *str <= 'Z' )
            {
                bug( "Act: missing arg2 for code %d.", *str );
                i = " <@@@> ";
            }
            else
            {
                switch ( *str )
                {
                default:  bug( "Act: bad code %d.", *str );
                    i = " <@@@> ";                                break;
                /* Thx alex for 't' idea */
                case 't':
                	if (arg1)
                		i = (char *) arg1;
                	else
                		bug("Act: bad code $t for 'arg1'",0);
               	break;
                case 'T':
					i = (char *) arg2;
				break;
                case 'n':
                	if (ch&&to)
                		i = PERS( ch,  to  );
               	else
               		bug("Act: bad code $n for 'ch or to'",0);
               	break;
                case 'N':
                	if (vch&&to)
                		i = PERS( vch, to  );
               	else
               		bug("Act: bad code $N for 'vch or to'",0);
               	break;
                case 'e':
                	if (ch)
                		i = he_she  [URANGE(0, ch  ->sex, 2)];
               	else
               		bug("Act: bad code $e for 'ch'",0);
               	break;
                case 'E':
                	if (vch)
                		i = he_she  [URANGE(0, vch ->sex, 2)];
                	else
                		bug("Act: bad code $E for 'vch'",0);
               	break;
                case 'm':
                	if (ch)
                		i = him_her [URANGE(0, ch  ->sex, 2)];
               	else
               		bug("Act: bad code $m for 'ch'",0);
               	break;
                case 'M':
                	if (vch)
                		i = him_her [URANGE(0, vch ->sex, 2)];
               	else
               		bug("Act: bad code $M for 'vch'",0);
               	break;
                case 's':
                	if (ch)
                		i = his_her [URANGE(0, ch  ->sex, 2)];
               	else
               		bug("Act: bad code $s for 'ch'",0);
               	break;
                case 'S':
                	if (vch)
                		i = his_her [URANGE(0, vch ->sex, 2)];
               	else
               		bug("Act: bad code $S for 'vch'",0);
               	break;
                case 'p':
					if (obj1)
					i = can_see_obj( to, obj1 ) ? check_dye(obj1, "", obj1->dye_vnum) : "something";
					else
						bug("Act: bad code $p for 'obj1'",0);
				break;
				case 'P':
					i = can_see_obj( to, obj2 ) ? check_dye(obj2, "", obj2->dye_vnum) : "something";
				break;
				case 'd':
					if ( arg2 == NULL || ((char *) arg2)[0] == '\0' )
					{
						i = "door";
					}
					else
					{
						one_argument( (char *) arg2, fname );
						i = fname;
					}
				break;
				}
            }
            ++str;
            while ( ( *point = *i ) != '\0' )
                ++point, ++i;
        }

		*point++ = '\n';
		*point++ = '\r';
		*point   = '\0';
		pbuff    = buffer;
		colourconv( pbuff, buf, to );
		buf[0] = UPPER(buf[0]);

		if (to->desc && (to->desc->connected == CON_PLAYING))
			write_to_buffer( to->desc, buffer, 0 );
		else
			if ( IS_NPC(to) && MOBtrigger )
				p_act_trigger( buf, to, NULL, NULL, ch, arg1, arg2, TRIG_ACT );

		if ( type == TO_ROOM || type == TO_NOTVICT )
		{
			OBJ_DATA *obj, *obj_next;
			CHAR_DATA *tch, *tch_next;

			point   = buf;
			str     = format;
			while( *str != '\0' )
			{
				*point++ = *str++;
			}
			*point   = '\0';

			for( obj = ch->in_room->contents; obj; obj = obj_next )
			{
				obj_next = obj->next_content;
				if ( HAS_TRIGGER_OBJ( obj, TRIG_ACT ) )
					p_act_trigger( buf, NULL, obj, NULL, ch, NULL, NULL, TRIG_ACT );
			}

			for( tch = ch; tch; tch = tch_next )
			{
				tch_next = tch->next_in_room;
				for ( obj = tch->carrying; obj; obj = obj_next )
				{
					obj_next = obj->next_content;
					if ( HAS_TRIGGER_OBJ( obj, TRIG_ACT ) )
						p_act_trigger( buf, NULL, obj, NULL, ch, NULL, NULL, TRIG_ACT );
				}
			}
			if ( HAS_TRIGGER_ROOM( ch->in_room, TRIG_ACT ) )
				p_act_trigger( buf, NULL, NULL, ch->in_room, ch, NULL, NULL, TRIG_ACT );
		}
	}
	return;
}


int colour( char type, CHAR_DATA *ch, char *string )
{
	PC_DATA *col;
	char buf[MSL];
	char code[ 20 ];
	char *p = '\0';
	int r, g, b;

     if( IS_NPC( ch ) )
 	 return( 0 );

     col = ch->pcdata;

     switch( type )
     {
 	default:
 	    sprintf( code, CLEAR );
 	    break;
 	case 'a':
	// Dark Apricot
 	    sprintf( code, "\t[F422]");
 	    break;
 	case 'A':
	// Light Apricot
 	    sprintf( code, "\t[F421]");
 	    break;
 	case 'b':
 	    sprintf( code, C_BLUE );
 	    break;
 	case 'B':
 	    sprintf( code, C_B_BLUE );
 	    break;
 	case 'c':
 	    sprintf( code, C_CYAN );
 	    break;
 	case 'C':
 	    sprintf( code, C_B_CYAN );
 	    break;
 	case 'd':
	// Dark Black
 	    sprintf( code, "\t[F111]");
 	    break;
 	case 'D':
	// Light Black
 	    sprintf( code, "\t[F222]");
 	    break;
 	case 'e':
	// Periwinkle
 	    sprintf( code, "\t[F325]");
 	    break;
 	case 'E':
	// Light Periwinkle
 	    sprintf( code, "\t[F335]");
 	    break;
 	case 'f':
	// Forest Green 1
 	    sprintf( code, "\t[F120]");
 	    break;
 	case 'F':
	// Forest Green 2
 	    sprintf( code, "\t[F121]");
 	    break;
 	case 'g':
 	    sprintf( code, C_GREEN );
 	    break;
 	case 'G':
 	    sprintf( code, C_B_GREEN );
 	    break;
 	case 'h':
	// Dark Maroon
 	    sprintf( code, "\t[F201]");
 	    break;
 	case 'H':
	// Light Maroon
 	    sprintf( code, "\t[F202]");
 	    break;
 	case 'i':
	// Dark Indigo
 	    sprintf( code, "\t[F104]");
 	    break;
 	case 'I':
	// Light Indigo
 	    sprintf( code, "\t[F114]");
 	    break;
 	case 'j':
 	    sprintf( code, "\t[F030]");
 	    break;
 	case 'J':
 	    sprintf( code, "\t[F230]");
 	    break;
 	case 'k':
	// Dark Pink
 	    sprintf( code, "\t[F402]");
 	    break;
 	case 'K':
	// Light Pink
 	    sprintf( code, "\t[F503]");
 	    break;
 	case 'l':
	// Dark Lime
 	    sprintf( code, "\t[F240]");
 	    break;
 	case 'L':
	// Light Lime
 	    sprintf( code, "\t[F350]");
 	    break;
 	case 'm':
 	    sprintf( code, C_MAGENTA );
 	    break;
 	case 'M':
 	    sprintf( code, C_B_MAGENTA );
 	    break;
 	case 'n':
	// Dark Brown
 	    sprintf( code, "\t[F210]");
 	    break;
 	case 'N':
	// Light Brown
 	    sprintf( code, "\t[F321]");
 	    break;
 	case 'o':
	// Dark Orange
 	    sprintf( code, "\to");
 	    break;
 	case 'O':
	// Light Orange
 	    sprintf( code, "\tO");
 	    break;
 	case 'p':
	// Dark Purple
 	    sprintf( code, "\t[F204]");
 	    break;
 	case 'P':
	// Light Purple
 	    sprintf( code, "\t[F305]");
 	    break;
 	case 'q':
 	    sprintf( code, "\t[F002]");
 	    break;
 	case 'Q':
 	    sprintf( code, "\t[F010]");
 	    break;
 	case 'r':
 	    sprintf( code, C_RED );
 	    break;
 	case 'R':
 	    sprintf( code, C_B_RED );
 	    break;
 	case 's':
	// Dark Scarlet
 	    sprintf( code, "\t[F200]");
 	    break;
 	case 'S':
	// Light Scarlet
 	    sprintf( code, "\t[F400]");
 	    break;
 	case 't':
	// Dark Teal
 	    sprintf( code, "\t[F042]");
 	    break;
 	case 'T':
	// Light Teal
 	    sprintf( code, "\t[F053]");
 	    break;
 	case 'u':
	// Dark Turquoise
 	    sprintf( code, "\t[F024]");
 	    break;
 	case 'U':
	// Light Turquoise
 	    sprintf( code, "\t[F035]");
 	    break;
 	case 'v':
 	    sprintf( code, "\t[F344]");
 	    break;
 	case 'V':
 	    sprintf( code, "\t[F545]");
 	    break;
 	case 'W':
	// Light White
 	    sprintf( code, "\t[F555]");
 	    break;
 	case 'w':
	// Dark White
 	    sprintf( code, "\t[F444]");
 	    break;
 	case 'x': case 'X':
 	    sprintf( code, CLEAR );
 	    break;
 	case 'Y':
 	    sprintf( code, C_B_YELLOW );
 	    break;
 	case 'y':
 	    sprintf( code, C_YELLOW );
 	    break;
 	case 'z':
 	    sprintf( code, "\t[F440]");
 	    break;
 	case 'Z':
 	    sprintf( code, "\t[F540]");
 	    break;
	case '?':
	    r = number_range(1, 5);
	    g = number_range(1, 5);
	    b = number_range(1, 5);
	    sprintf(buf, "\t[F%d%d%d]", r, g, b);
	    sprintf( code, buf );
	    break;
	case ':':
	    sprintf (code, "\t");
	    break;
	case '_':
	    sprintf (code, C_UNDERSCORE);
	    break;
 	case '`':
 	    sprintf( code, "%c", '~' );
 	    break;
 	case '{':
 	    sprintf( code, "%c", '{' );
 	    break;

		case '!':
		sprintf (code, CB_BLUE);
		break;
		case '@':
		sprintf (code, CB_CYAN);
		break;
		case '#':
		sprintf (code, CB_GREEN);
		break;
		case '$':
		sprintf (code, CB_MAGENTA);
		break;
		case '%':
		sprintf (code, CB_RED);
		break;
		case '^':
		sprintf (code, CB_WHITE);
		break;
		case '&':
		sprintf (code, CB_YELLOW);
		break;
     }

     p = code;
     while( *p != '\0' )
     {
 	*string = *p++;
 	*++string = '\0';
     }

     return( strlen( code ) );
 }

 void colourconv( char *buffer, const char *txt, CHAR_DATA *ch )
 {
     const	char	*point;
 		int	skip = 0;

     if( ch->desc && txt )
     {
 	if( IS_SET( ch->act, PLR_COLOUR ) )
 	{
 	    for( point = txt ; *point ; point++ )
 	    {
 		if( *point == '{' )
 		{
 		    point++;
 		    skip = colour( *point, ch, buffer );
 		    while( skip-- > 0 )
 			++buffer;
 		    continue;
 		}
 		*buffer = *point;
 		*++buffer = '\0';
 	    }
 	    *buffer = '\0';
 	}
 	else
 	{
 	    for( point = txt ; *point ; point++ )
 	    {
 		if( *point == '{' )
 		{
 		    point++;
 		    continue;
 		}
 		*buffer = *point;
 		*++buffer = '\0';
 	    }
 	    *buffer = '\0';
 	}
     }
     return;
 }



/*
 * Macintosh support functions.
 */
#if defined(macintosh)
int gettimeofday( struct timeval *tp, void *tzp )
{
    tp->tv_sec  = time( NULL );
    tp->tv_usec = 0;
}
#endif

/* source: EOD, by John Booth <???> */

void printf_to_char (CHAR_DATA *ch, char *fmt, ...)
{
	char buf [MAX_STRING_LENGTH];
	va_list args;
	va_start (args, fmt);
	vsprintf (buf, fmt, args);
	va_end (args);

	stc (buf, ch);
}

void add_mysql_log( char *type, char *txt, ... )
{
        char mysql_buf[MSL], buf[MSL];
        va_list args;
        va_start (args, txt);
        vsprintf (buf, txt, args);
        va_end (args);

	if ( txt == NULL || txt[0] == '\0' )
		return;

	sprintf( mysql_buf, "insert into log_history values( \"\", \"%s\", \"%d\", \"%ld\", \"%s\" );", type, mud_port, current_time, sql_escape_string(txt) );
	logf( mysql_buf );
	mysql_real_query(result_db, mysql_buf, strlen(mysql_buf));

        if( mysql_affected_rows(result_db) < 1)
		log_string("MYSQL: Error saving MYSQL log.");

	return;

}

void bugf (char * fmt, ...)
{
	char buf [2*MSL];
	va_list args;
	va_start (args, fmt);
	vsprintf (buf, fmt, args);
	va_end (args);

	bug (buf, 0);
}
/* This code was posted by a fellow on the ROM mailing list.
 * I dont have the name of the original author, but it's a
 * nice addition. -Dal
 */
char *color_strip( const char *txt )
{
	const   char    *point;
	char    *point2;
	char    buf[MSL*4];

	if(!txt)
		return str_dup("");

	buf[0] = '\0';
	point2 = buf;

	for( point = txt ; *point ; point++ )
	{
		if( *point == '{' )
		{
		point++;
		continue;
		}
		*point2 = *point;
		*++point2 = '\0';
		/* seems that this is redundant
		 * *point2++ = *point;
		 * would be simpler
		 * */
	}
	*point2 = '\0';
	return str_dup(buf);
}

/* added for intro quotes - Dalsor */

bool check_swear_string( char *argument )
{

    /*
     * No fucking cuss words.
     */
    if (!str_prefix(argument,"dick")
    || !str_prefix(argument,"shit")
    || !str_prefix(argument,"pussy")
    || !str_prefix(argument,"cunt")
    || !str_prefix(argument,"fucking")
    || !str_prefix(argument,"cock")
    || !str_prefix(argument,"twat")
    || !str_prefix(argument,"bitch")
    || !str_prefix(argument,"wtf")
    || !str_prefix(argument,"slut") )
    {
	return FALSE;
    }

    return TRUE;
}
