/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aww.h"
#include "recycle.h"
#include "interp.h"
#include "tables.h"
#include "olc.h"

#define OBJ_VNUM_SHAPING_PRODUCT 909
#define OBJ_VNUM_SHAPING_MATERIAL 911

/* fletch command to make arrows */
/*
void do_fletch( CHAR_DATA *ch, char *argument )
{

	OBJ_DATA *tool;
	OBJ_DATA *material;
	OBJ_DATA *product;
	char arg1[MIL];
	char arg2[MIL];
	char arg3[MIL];
	char arg4[MIL];
	char arg5[MIL];
	char *quality;
	char bufC[MSL];
	char bufR[MSL];
	bool has_shaper = FALSE, has_limb = FALSE;
	int modifier, rank, shaping, archery;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );
	argument = one_argument( argument, arg4 );
	argument = one_argument( argument, arg5 );

	if ( IS_NPC( ch ) )
		return;

	modifier = ch->pcdata->learned[gsn_fletching];
	woodcraft = ch->pcdata->learned[gsn_woodcraft];
	archery = ch->pcdata->learned[gsn_archery];
	rank = modifier / 5;
	if ( rank <= 0 )
		rank = 1;
	if ( shaping <= 0 )
		woodcraft = 1;
	if ( archery <= 0 )
		archery = 1;

	ptc( ch, "Modifier: %d, Rank: %d\n\r", modifier, rank );

	if ( modifier <= 50 )
		quality = str_dup( "poorly" );
	else if ( modifier <= 75 )
		quality = str_dup( "reasonably" );
	else if ( modifier <= 90 )
		quality = str_dup( "moderately" );
	else if ( modifier <= 99 )
		quality = str_dup( "well" );
	else
		quality = str_dup( "perfectly" );

	if ( arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0' || arg4[0] == '\0' || arg5[0] == '\0' )
	{
		stc("None of the arguments can be null.\n\r\n\r", ch );
		stc("Syntax: fletch <object> into arrow with <shaper>.\n\r", ch );
		stc("Example: fletch limb into arrow with shaper.\n\r", ch );
		return;
	}
	if ( str_cmp( arg2, "into" ) )
	{
		stc("You must provide the correct syntax.\n\r\n\r", ch );
		stc("Syntax: fletch <object> into arrow with <shaper>.\n\r", ch );
		stc("Example: fletch limb into arrow with shaper.\n\r", ch );
		return;
	}
	if ( str_cmp( arg4, "with" ) )
	{
		stc("You must provide the exact syntax.\n\r\n\r", ch );
		stc("Syntax: fletch <object> into arrow with <shaper>.\n\r", ch );
		stc("Example: fletch limb into arrow with shaper.\n\r", ch );
		return;
	}
	if ( ( material = get_obj_carry( ch, arg1, ch ) ) != NULL )
	{
		if ( material->item_type != ITEM_SHAPE_LIMB )
		{
			stc("You'll need a stout limb to shape an arrow.\n\r\n\r", ch );
			return;
		}
		if ( material->item_type == ITEM_SHAPE_LIMB )
			has_limb = TRUE;
	}
	if ( ( tool = get_obj_carry( ch, arg5, ch ) ) != NULL )
	{
		if ( tool->item_type != ITEM_SHAPE_SHAPER )
		{
			stc("This is not a valid tool.\n\r\n\r", ch );
			stc("You'll need a wood shaper to fashion an arrow.\n\r", ch );
			return;
		}
		if ( tool->item_type == ITEM_SHAPE_SHAPER )
			has_shaper = TRUE;
	}
	if ( !has_shaper )
	{
		stc("You do not have a proper tool.\n\r\n\r", ch );
		return;
	}
	if ( !has_limb )
	{
		stc("You do not have a proper limb.\n\r\n\r", ch );
		return;
	}

	if ( material->value[0] >= 4 )
	{
		stc("It's already been shaped as much as it can be.\n\r", ch );
		return;
	}

	if ( material->value[0] == 0 )
	{
		act("You scrape $t with $T, revealing the clean wood beneath.",ch,material->short_descr,tool->short_descr,TO_CHAR );
		act("$n scrapes $t with $T, revealing the clean wood beneath.",ch,material->short_descr,tool->short_descr,TO_ROOM );
		material->value[0] += 1;
		if ( number_percent() > modifier )
		{
			act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
			act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
			extract_obj( material );
			check_improve( ch, gsn_shaping, FALSE, 5 );
			return;
		}
		return;
	}
	if ( material->value[0] == 1 )
	{
		act("You shave $t with $T, cleaning off the rough edges and forming a shaft.",ch,material->short_descr,tool->short_descr,TO_CHAR );
		act("$n shaves $t with $T, cleaning off the rough edges and forming a shaft.",ch,material->short_descr,tool->short_descr,TO_ROOM );
		material->value[0] += 1;
		if ( number_percent() > modifier )
		{
			act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
			act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
			extract_obj( material );
			check_improve( ch, gsn_shaping, FALSE, 5 );
			return;
		}
		return;
	}
	if ( material->value[0] == 2 )
	{
		act("You smooth $t with $T, careful to form an even balance.",ch,material->short_descr,tool->short_descr,TO_CHAR );
		act("$n smooths $t with $T, careful to form an even balance.",ch,material->short_descr,tool->short_descr,TO_ROOM );
		material->value[0] += 1;
		if ( number_percent() > modifier )
		{
			act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
			act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
			extract_obj( material );
			check_improve( ch, gsn_shaping, FALSE, 5 );
			return;
		}
		return;
	}
	if ( material->value[0] == 3 )
	{
		sprintf( bufC, "You finish $t with $T, holding aloft a %s balanced wooden arrow.", quality );
		sprintf( bufR, "$n finishes $t with $T, holding aloft a %s balanced wooden arrow.", quality );
		act(bufC,ch,material->short_descr,tool->short_descr,TO_CHAR );
		act(bufR,ch,material->short_descr,tool->short_descr,TO_ROOM );
		material->value[0] += 1;
		if ( number_percent() > modifier )
		{
			act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
			act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
			extract_obj( material );
			check_improve( ch, gsn_shaping, FALSE, 5 );
			return;
		}
	}
	extract_obj( material );
	product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), 1 );
	free_string( product->name );
	product->name = str_dup( "wooden arrow" );
	free_string( product->short_descr );
	product->short_descr = str_dup( "a wooden arrow" );
	free_string( product->description );
	product->description = str_dup( "Here lies a wooden arrow." );
	product->item_type = ITEM_ARROW;
	product->wear_flags = ITEM_TAKE;
	product->material = str_dup( "softwood" );
	product->condition = 100 + modifier;
	product->weight = 2;
	product->cost = 5;
	product->guild = str_dup("Loner");
	product->value[1] = 1;
	product->value[2] = (modifier + rank) + (archery + shaping);
	if ( product->value[2] < 1 )
		product->value[0] = 1;
	obj_to_char( product, ch );
	check_improve( ch, gsn_fletching, TRUE, 5 );
	return;
}
void do_shape ( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *tool;
	OBJ_DATA *material;
	OBJ_DATA *product;
	char arg1[MIL];
	char arg2[MIL];
	char arg3[MIL];
	bool has_knife = FALSE;
	bool has_shaper = FALSE;
	int chance = 0;
	int modifier = 0;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );

	if ( arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0' )
	{
	stc("None of the arguments can be null.\n\r\n\r", ch );
	stc("Syntax: shape object with tool.\n\r", ch );
	stc("Example: shape stick with knife.\n\r", ch );
	return;
	}
	if ( str_cmp( arg2, "with" ) )
	{
	stc("You must provide the correct syntax.\n\r\n\r", ch );
	stc("Syntax: shape object with tool.\n\r", ch );
	stc("Example: shape stick with knife.\n\r", ch );
	return;
	}
	if ( ( ch->pcdata->learned[gsn_shaping]) == 0 )
	{
		stc( "You do not know how to shape.\n\r", ch );
		return;
	}	
	if ( ( material = get_obj_carry( ch, arg1, ch ) ) != NULL )
	{
		if ( ( tool = get_obj_carry( ch, arg3, ch ) ) != NULL )
		{
			if ( tool->item_type == ITEM_SHAPE_KNIFE )
				has_knife = TRUE;
			else if ( tool->item_type == ITEM_SHAPE_SHAPER )
				has_shaper = TRUE;
			else
			{
				stc("This is not a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
			}
			chance = get_skill( ch, gsn_shaping );
			if(!chance)
			{
				stc("You have the tool. But you have no idea what to do with it.\n\r",ch);
				return;
			}
			modifier += get_curr_stat( ch, STAT_DEX );
			modifier += get_curr_stat( ch, STAT_REF );
			modifier += get_curr_stat( ch, STAT_INT );
			modifier += get_curr_stat( ch, STAT_INS );
			modifier += get_curr_stat( ch, STAT_WIS );
			modifier /= 5;
			modifier += chance / 10;

			// if ( chance <= 0 )
			// {
			// stc("You have no chance to shape this material with this tool.\n\r", ch );
			// return;
			// }

			if ( material->item_type == ITEM_SHAPE_STICK )
			{
				if ( material->value[0] >= 4 )
				{
				stc("It's already been shaped as much as it can be.\n\r", ch );
				return;
				}
				if ( has_knife )
				{
					act("You whittle on $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n whittles on $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
				}
				else if ( has_shaper )
				{
					act("You shape $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() - 10 > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
				}
				else
				{
				stc("You do not have a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
				}
				if ( material->value[0] == 1 )
				{
				act("You form the body of a slim dart with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n forms the body of a slim dart with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 2 )
				{
				act("You form the tip of a slim dart with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n forms the tip of a slim dart with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 3 )
				{
				act("You trim the end of a slim dart into flights with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n trims the end of a slim dart into flights with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 4 )
				{
				act("You smooth a slim dart and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n smoothes a slim dart, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				extract_obj( material );
				product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), ch->level );
				product->name = str_dup( "slim dart" );
				product->short_descr = str_dup( "a slim dart" );
				product->description = str_dup( "Here lies a slim dart." );
				product->item_type = ITEM_WEAPON;
				product->wear_flags = ITEM_TAKE;
				product->wear_flags += ITEM_WIELD;
				product->material = str_dup( "softwood" );
				product->weight = 5;
				product->cost = 5;
				product->guild = str_dup("Loner");
				product->value[0] = WEAPON_DAGGER;
				product->value[1] = 1;
				product->value[2] = ch->level / 4;
				if ( product->value[2] < 1 )
					product->value[0] = 1;
				if ( product->value[2] > 151)
					product->value[2] = 151;
				product->value[3] = attack_lookup("pierce");
				obj_to_char( product, ch );
				check_improve( ch, gsn_shaping, TRUE, 5 );
				}
			}
			else if ( material->item_type == ITEM_SHAPE_LIMB )
			{
				// if ( chance <= 75 )
				// {
				// stc("You have no chance to shape this material with this tool.\n\r", ch );
				// return;
				// }

				if ( material->value[0] >= 5 )
				{
				stc("It's already been shaped as much as it can be.\n\r", ch );
				return;
				}
				if ( has_knife )
				{
					act("You whittle on $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n whittles on $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
					if ( material->value[0] == 1 )
					{
					act("You carve the body of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves the body of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 2 )
					{
					act("You carve a slitted tip onto the end of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves a slitted tip onto the end of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 3 )
					{
					act("You carve hollows into a crude pipe with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves hollows into a crude pipe with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 4 )
					{
					act("You carve small finger holes into a rough pipe with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves small finger holes into a rough pipe with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 5 )
					{
					act("You smooth a pipe and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n smoothes a pipe, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					extract_obj( material );
					product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), 1 );
					product->name = str_dup( "wooden pipe" );
					product->short_descr = str_dup( "a wooden piper's pipe" );
					product->description = str_dup( "Here lies a wooden piper's pipe." );
					product->item_type = ITEM_WIND_PIPES;
					product->wear_flags = ITEM_TAKE;
					product->wear_flags += ITEM_HOLD;
					product->material = str_dup( "softwood" );
					product->weight = 5;
					product->cost = 10;
					product->guild = str_dup("Loner");
					obj_to_char( product, ch );
					check_improve( ch, gsn_shaping, TRUE, 5 );
					}
				}
				else if ( has_shaper )
				{
					act("You shape $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
					if ( material->value[0] == 1 )
					{
					act("You carve the length of a stout rod with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves the length of a stout rod with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 2 )
					{
					act("You carve a mouthpiece onto the end of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves a mouthpiece onto the end of a sturdy rod with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 3 )
					{
					act("You carve hollows into a crude tube with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves hollows into a crude tube with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 4 )
					{
					act("You carve small finger holes into a rough tube with $T.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n carves small finger holes into a rough tube with $T.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 5 )
					{
					act("You smooth a flute and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n smoothes a flute, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					extract_obj( material );
					product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), 1 );
					product->name = str_dup( "wooden flute" );
					product->short_descr = str_dup( "a wooden flute" );
					product->description = str_dup( "Here lies a wooden flute." );
					product->item_type = ITEM_WIND_FLUTE;
					product->wear_flags = ITEM_TAKE;
					product->wear_flags += ITEM_HOLD;
					product->material = str_dup( "softwood" );
					product->weight = 5;
					product->cost = 10;
					product->guild = str_dup("Loner");
					obj_to_char( product, ch );
					check_improve( ch, gsn_shaping, TRUE, 5 );
					}
				}
				else
				{
				stc("You do not have a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
				}
			}
			else if ( material->item_type == ITEM_SHAPE_BRANCH )
			{
				// if ( chance < 85 )
				// {
				// stc("You have no chance to shape this material with this tool.\n\r", ch );
				// return;
				// }

				if ( material->value[0] >= 5 )
				{
				stc("It's already been shaped as much as it can be.\n\r", ch );
				return;
				}
				if ( has_knife )
				{
					act("You whittle on $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n whittles on $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
					if ( material->value[0] == 1 )
					{
					act("You shave the bark from $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shaves the bark from $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 2 )
					{
					act("You smooth and clean $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n smoothes and cleans $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 3 )
					{
					act("You shape handgrips into $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes handgrips into $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 4 )
					{
					act("You trim the rough spots off $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n trims the rough spots off $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 5 )
					{
					act("You smooth a rod and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n smoothes a rod, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					extract_obj( material );
					product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), ch->level );
					product->name = str_dup( "beating rod" );
					product->short_descr = str_dup( "a beating rod" );
					product->description = str_dup( "Here lies a beating rod." );
					product->item_type = ITEM_WEAPON;
					product->wear_flags = ITEM_TAKE;
					product->wear_flags += ITEM_WIELD;
					product->material = str_dup( "hardwood" );
					product->weight = 10;
					product->cost = 20;
					product->guild = str_dup("Loner");
					product->value[0] = WEAPON_MACE;
					product->value[1] = 1;
					product->value[2] = ch->level / 3.5;
					product->value[2] += 6;
					if ( product->value[2] < 1 )
						product->value[2] = 1;
					if ( product->value[2] > 151 )
						product->value[2] = 151;
					product->value[3] = attack_lookup("beating");
					obj_to_char( product, ch );
					check_improve( ch, gsn_shaping, TRUE, 5 );
					}
				}
				else if ( has_shaper )
				{
					act("You shape $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
					if ( material->value[0] == 1 )
					{
					act("You shave the bark from $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shaves the bark from $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 2 )
					{
					act("You smooth and clean $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n smoothes and cleans $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 3 )
					{
					act("You shape handgrips into $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes handgrips into $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 4 )
					{
					act("You trim the rough spots off $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n trims the rough spots off $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					}
					else if ( material->value[0] == 5 )
					{
					act("You smooth a staff and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
					act("$n smoothes a staff, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
					WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
					extract_obj( material );
					product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), ch->level );
					product->name = str_dup( "quarter staff" );
					product->short_descr = str_dup( "a quarter staff" );
					product->description = str_dup( "Here lies a quarter staff." );
					product->item_type = ITEM_WEAPON;
					product->wear_flags = ITEM_TAKE;
					product->wear_flags += ITEM_WIELD;
					product->material = str_dup( "hardwood" );
					product->weight = 15;
					product->cost = 25;
					product->guild = str_dup("Loner");
					product->value[0] = WEAPON_STAFF;
					product->value[1] = 1;
					product->value[2] = ch->level / 3.5;
					product->value[2] += 7;
					if ( product->value[2] < 1 )
						product->value[0] = 1;
					if ( product->value[2] > 151 )
						product->value[2] = 151;
					product->value[3] = attack_lookup("pound");
					obj_to_char( product, ch );
					check_improve( ch, gsn_shaping, TRUE, 5 );
					}
				}
				else
				{
				stc("You do not have a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
				}
			}
			else if ( material->item_type == ITEM_SHAPE_BLOCK )
			{
				// if ( chance < 95 )
				// {
				// stc("You have no chance to shape this material with this tool.\n\r", ch );
				// return;
				// }

				if ( material->value[0] >= 4 )
				{
				stc("It's already been shaped as much as it can be.\n\r", ch );
				return;
				}
				if ( has_knife )
				{
					act("You whittle on $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n whittles on $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
				}
				else if ( has_shaper )
				{
					act("You shape $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() - 10 > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					return;
					}
				}
				else
				{
				stc("You do not have a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
				}
				if ( material->value[0] == 1 )
				{
				act("You hew the edges of a block $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n hews the edges of a block with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 2 )
				{
				act("You form a large square with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n forms a large square with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 3 )
				{
				act("You trim the rough edges of a block with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n trims the rough edges of a block with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 4 )
				{
				act("You smooth a block down to size and finish the keyblank.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n smoothes a block down to size, finishing the keyblank.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				extract_obj( material );
				product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), 1 );
				product->name = str_dup( "keyblank" );
				product->short_descr = str_dup( "a keyblank" );
				product->description = str_dup( "Here lies a keyblank." );
				product->item_type = ITEM_SHAPE_KEYBLANK;
				product->wear_flags = ITEM_TAKE;
				product->material = str_dup( "softwood" );
				product->weight = 5;
				product->cost = 5;
				product->guild = str_dup("Loner");
				product->value[0] = 0;
				obj_to_char( product, ch );
				check_improve( ch, gsn_shaping, TRUE, 5 );
				}
			}
			else if ( material->item_type == ITEM_SHAPE_KEYBLANK )
			{
				// if ( chance < 100 )
				// {
				// stc("You have no chance to shape this material with this tool.\n\r", ch );
				// return;
				// }

				if ( material->value[0] >= 4 )
				{
				stc("It's already been shaped as much as it can be.\n\r", ch );
				return;
				}
				if ( has_knife )
				{
					act("You whittle on $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n whittles on $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
				}
				else if ( has_shaper )
				{
					act("You shape $t with $T.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n shapes $t with $T.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					material->value[0] += 1;
					if ( number_percent() - 10 > modifier )
					{
					act("You fumble and ruin $t.",ch,material->short_descr,tool->short_descr,TO_CHAR );
					act("$n fumbles and ruins $t.",ch,material->short_descr,tool->short_descr,TO_ROOM );
					extract_obj( material );
					check_improve( ch, gsn_shaping, FALSE, 5 );
					return;
					}
				}
				else
				{
				stc("You do not have a valid tool.\n\r\n\r", ch );
				stc("Syntax: shape object with tool.\n\r", ch );
				stc("Example: shape stick with knife.\n\r", ch );
				return;
				}
				if ( material->value[0] == 1 )
				{
				act("You form the body of a lockpick with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n forms the body of a lockpick with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 2 )
				{
				act("You form the tip of a lockpick with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n forms the tip of a lockpick with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 3 )
				{
				act("You trim the end and fingergrips of a lockpick with $T.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n trims the end and fingergrips of a lockpick with $T.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				}
				else if ( material->value[0] == 4 )
				{
				act("You smooth a slim lockpick and finish the task.",ch,NULL,tool->short_descr,TO_CHAR );
				act("$n smoothes a slim lockpick, finishing the task.",ch,NULL,tool->short_descr,TO_ROOM );
				WAIT_STATE( ch, PULSE_VIOLENCE * 4 );
				extract_obj( material );
				product = create_object( get_obj_index( OBJ_VNUM_SHAPING_PRODUCT ), 1 );
				product->name = str_dup( "slim lockpick" );
				product->short_descr = str_dup( "a slim lockpick" );
				product->description = str_dup( "Here lies a slim lockpick." );
				product->item_type = ITEM_LOCKPICK;
				product->wear_flags = ITEM_TAKE;
				product->wear_flags += ITEM_HOLD;
				product->material = str_dup( "hardwood" );
				product->weight = 5;
				product->cost = 50;
				product->guild = str_dup("Loner");
				product->value[0] = ch->level / 10;
				product->value[0] += modifier * 2;
				if ( product->value[0] < 1 )
					product->value[0] = 1;
				obj_to_char( product, ch );
				check_improve( ch, gsn_shaping, TRUE, 5 );
				}
			}
			else
			{
			stc("This is not a valid material.\n\r\n\r", ch );
			stc("Syntax: shape object with tool.\n\r", ch );
			stc("Example: shape stick with knife.\n\r", ch );
			return;
			}
		}
		else
		{
		stc("This is not a valid material.\n\r\n\r", ch );
		stc("Syntax: shape object with tool.\n\r", ch );
		stc("Example: shape stick with knife.\n\r", ch );
		return;
		}
	}
	else
	{
	stc("This is not a valid tool.\n\r\n\r", ch );
	stc("Syntax: shape object with tool.\n\r", ch );
	stc("Example: shape stick with knife.\n\r", ch );
	}
	return;
}
*/

void do_forage(CHAR_DATA *ch, char *argument)
{
	if (IS_NPC(ch))	return;

	if (IS_SET(ch->act, PLR_FORAGE))
	{
		stc("You will no longer search for useful items while exploring.\n\r", ch);
		REMOVE_BIT(ch->act, PLR_FORAGE);
	}
	else
	{
		stc("You will now search for useful items while exploring.\n\r", ch);
		SET_BIT(ch->act, PLR_FORAGE);
	}

	return;
}

OBJ_DATA *random_herb ( void )
{
	OBJ_DATA *herb;
	int roll = number_range(1, MAX_HERB - 1);
	char buf[MSL];

	herb = create_object(get_obj_index(8), 0);

	herb->value[0] = roll;

	sprintf(buf, "%s herb", herb_flags[roll].name);
	free_string(herb->name);
	herb->name = str_dup(buf);

	sprintf(buf, "some %s", herb_flags[roll].name);
	free_string(herb->short_descr);
	herb->short_descr = str_dup(buf);

	sprintf(buf, "Some %s is lying here on the ground.", herb_flags[roll].name);
	free_string(herb->description);
	herb->description = str_dup(buf);

	free_string(herb->material);
	herb->material = str_dup(herb_flags[roll].name);
	
	return herb;
	
}

void forage ( CHAR_DATA *ch )
{
	int type = 0;
	bool found = FALSE;
	OBJ_DATA *obj;

    switch(ch->in_room->sector_type)
    {
    	default:                        type = 0; break;
		case(SECT_INSIDE):				type = 0; break;
		case(SECT_CITY):				type = 0; break;
		case(SECT_FIELD):				type = 1; break;
		case(SECT_FOREST):				type = 2; break;
		case(SECT_HILLS):				type = 3; break;
		case(SECT_MOUNTAIN):			type = 4; break;
		case(SECT_WATER_SWIM):			type = 0; break;
		case(SECT_WATER_NOSWIM):		type = 0; break;
		case(SECT_AIR):					type = 0; break;
	    case(SECT_TUNDRA):              type = 5; break;
	    case(SECT_BLIGHT):              type = 6; break;
	    case(SECT_COASTAL):             type = 7; break;
	    case(SECT_ROAD):                type = 1; break;
	    case(SECT_MARSH):               type = 8; break;
		case(SECT_DESERT):				type = 9; break;
		case(SECT_WASTE):               type = 9; break;
		case(SECT_LAKE_FRESH):          type = 10; break;
		case(SECT_RIVER_FRESH):         type = 10; break;
		case(SECT_LAKE_SALT):           type = 11; break; /* not used yet */
		case(SECT_RIVER_SALT):          type = 11; break; /* not used yet */
		case(SECT_VOLCANIC):            type = 12; break; /* not used yet */
    }

    if ( type == 0 )
	return;

	act("You scan the ground, looking for items of use.",ch,NULL,NULL,TO_CHAR);
	act("$n scans the ground, looking for items of use.",ch,NULL,NULL,TO_ROOM);

    if ( get_skill(ch, gsn_forage) / 2 > number_percent() && type > 0 )
    	found = TRUE;

    if ( type == 0 || !found )
    {
        check_improve(ch, gsn_forage, FALSE, 8);
	return;
    }

    if ( type == 1)
    {
		switch( number_range(1,8) )
		{
		case 1:
			act("You manage to find a stick.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a stick.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_STICK;
			obj->name = str_dup("stick");
			obj->short_descr = str_dup("a stick");
			obj->description = str_dup("Here lies a stick.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 2:
			act("You manage to find a honeycomb.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a honeycomb.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_FOOD;
			obj->name = str_dup("honeycomb");
			obj->short_descr = str_dup("a honeycomb");
			obj->description = str_dup("Here lies a honeycomb.");
			obj->material = str_dup("honey");
			obj->weight = 2;
			obj->cost = 0;
			obj->value[0] = 5;
			obj->value[1] = 5;
			obj->value[3] = 0;
			obj_to_char( obj, ch );
		break;
		case 3:
			act("You manage to find a mushroom.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a mushroom.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_MUSHROOM;
			obj->name = str_dup("mushroom");
			obj->short_descr = str_dup("a mushroom");
			obj->description = str_dup("Here lies a mushroom.");
			obj->material = str_dup("food");
			obj->weight = 2;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 4:
			obj = random_herb();
			obj->weight = 1;
			obj->cost = 0;
 
			act("You manage to find $p.",ch, obj, NULL,TO_CHAR);
			act("$n manages to find $p.",ch, obj, NULL,TO_ROOM);
			obj_to_char( obj, ch );
		break;
		default:
			act("You can only manage to find a few weeds and grasses.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}

	}
    else if ( type == 2 && found )
    {
    	switch( number_range( 1, 6 ) )
    	{
    	case 1:
			act("You manage to find a stick.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a stick.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_STICK;
			obj->name = str_dup("stick");
			obj->short_descr = str_dup("a stick");
			obj->description = str_dup("Here lies a stick.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
    	case 2:
			act("You manage to find a limb.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a limb.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_LIMB;
			obj->name = str_dup("limb");
			obj->short_descr = str_dup("a limb");
			obj->description = str_dup("Here lies a limb.");
			obj->material = str_dup("softwood");
			obj->weight = 10;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
    	case 3:
			act("You manage to find a branch.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a branch.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_BRANCH;
			obj->name = str_dup("branch");
			obj->short_descr = str_dup("a branch");
			obj->description = str_dup("Here lies a branch.");
			obj->material = str_dup("softwood");
			obj->weight = 20;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 4:
			act("You manage to find a mushroom.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a mushroom.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_MUSHROOM;
			obj->name = str_dup("mushroom");
			obj->short_descr = str_dup("a mushroom");
			obj->description = str_dup("Here lies a mushroom.");
			obj->material = str_dup("softwood");
			obj->weight = 2;
			obj->cost = 0;
			obj_to_char( obj, ch );
			break;
		case 5:
			obj = random_herb();
			obj->weight = 1;
			obj->cost = 0;
 
			act("You manage to find $p.",ch, obj, NULL,TO_CHAR);
			act("$n manages to find $p.",ch, obj, NULL,TO_ROOM);
			obj_to_char( obj, ch );
		break;

    		default:
			act("You can only manage to find a few leaves and twigs.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}
	}
    else if ( type == 3 && found )
    {
		switch( number_range(1,4) )
		{
		case 1:
			act("You manage to find a stick.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a stick.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_STICK;
			obj->name = str_dup("stick");
			obj->short_descr = str_dup("a stick");
			obj->description = str_dup("Here lies a stick.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 2:
			obj = random_herb();
			obj->weight = 1;
			obj->cost = 0;
 
			act("You manage to find $p.",ch, obj, NULL,TO_CHAR);
			act("$n manages to find $p.",ch, obj, NULL,TO_ROOM);
			obj_to_char( obj, ch );
		break;

		default:
			act("You can only manage to find a few clumps of dirt.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}
	}
    else if ( type == 4 && found )
    {
		switch( number_range(1,4 ) )
		{
		case 1:
			act("You manage to find a stick.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a stick.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_STICK;
			obj->name = str_dup("stick");
			obj->short_descr = str_dup("a stick");
			obj->description = str_dup("Here lies a stick.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 2:
			act("You manage to find a limb.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a limb.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_LIMB;
			obj->name = str_dup("limb");
			obj->short_descr = str_dup("a limb");
			obj->description = str_dup("Here lies a limb.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 3:
			obj = random_herb();
			obj->weight = 1;
			obj->cost = 0;
 
			act("You manage to find $p.",ch, obj, NULL,TO_CHAR);
			act("$n manages to find $p.",ch, obj, NULL,TO_ROOM);
			obj_to_char( obj, ch );
		break;

		default:
			act("You can only manage to find a few rocks and pebbles.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}

	}
    else if ( type == 5 && found )
    {
		act("You can only manage to find some snow.",ch,NULL,NULL,TO_CHAR);
		found = FALSE;
	}
    else if ( type == 6 && found )
    {
		act("You can only manage to find an old bone.",ch,NULL,NULL,TO_CHAR);
		found = FALSE;
	}
    else if ( type == 7 && found )
    {
		act("You can only manage to find some sand and seaweed.",ch,NULL,NULL,TO_CHAR);
		found = FALSE;
	}
    else if ( type == 8 && found )
    {
		switch( number_range(1,2 ) )
		{
		case 1:
			obj = random_herb();
			obj->weight = 1;
			obj->cost = 0;
 
			act("You manage to find $p.",ch, obj, NULL,TO_CHAR);
			act("$n manages to find $p.",ch, obj, NULL,TO_ROOM);
			obj_to_char( obj, ch );
		break;

		default:
			act("You can only manage to find some cattails.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}

	}
    else if ( type == 9 && found )
    {
		act("You can only manage to find sand.",ch,NULL,NULL,TO_CHAR);
		found = FALSE;
	}
    else if ( type == 10 && found )
    {
		switch( number_range( 1,7 ) )
		{
		case 1:
			act("You manage to find a mushroom.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a muchroom.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_MUSHROOM;
			obj->name = str_dup("mushroom");
			obj->short_descr = str_dup("a mushroom");
			obj->description = str_dup("Here lies a mushroom.");
			obj->material = str_dup("softwood");
			obj->weight = 2;
			obj->cost = 0;
			obj_to_char( obj, ch );
			break;
		case 2:
			act("You manage to find a clematis flower.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a clematis flower.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_CLEMATIS;
			obj->name = str_dup("clematis flower");
			obj->short_descr = str_dup("a clematis flower");
			obj->description = str_dup("Here lies a clematis flower.");
			obj->material = str_dup("softwood");
			obj->weight = 1;
			obj->cost = 0;
			obj_to_char( obj, ch );
			break;
		case 3:
			act("You manage to find some hawthorn berries.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find some hawthorn berries.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_HAWTHORN;
			obj->name = str_dup("hawthorn berries");
			obj->short_descr = str_dup("some hawthorn berries");
			obj->description = str_dup("Here lies some hawthorn berries.");
			obj->material = str_dup("softwood");
			obj->weight = 1;
			obj->cost = 0;
			obj_to_char( obj, ch );
			break;
		case 4:
			act("You manage to find some boneset flowers.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find some boneset flowers.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_BONESET;
			obj->name = str_dup("boneset flowers");
			obj->short_descr = str_dup("some boneset flowers");
			obj->description = str_dup("Here lies some boneset flowers.");
			obj->material = str_dup("softwood");
			obj->weight = 1;
			obj->cost = 0;
			obj_to_char( obj, ch );
			break;
    	case 5:
			act("You manage to find a stick.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a stick.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_STICK;
			obj->name = str_dup("stick");
			obj->short_descr = str_dup("a stick");
			obj->description = str_dup("Here lies a stick.");
			obj->material = str_dup("softwood");
			obj->weight = 5;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
    	case 6:
			act("You manage to find a limb.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a limb.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_LIMB;
			obj->name = str_dup("limb");
			obj->short_descr = str_dup("a limb");
			obj->description = str_dup("Here lies a limb.");
			obj->material = str_dup("softwood");
			obj->weight = 10;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
    	case 7:
			act("You manage to find a branch.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a branch.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_BRANCH;
			obj->name = str_dup("branch");
			obj->short_descr = str_dup("a branch");
			obj->description = str_dup("Here lies a branch.");
			obj->material = str_dup("softwood");
			obj->weight = 20;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 8:
			act("You manage to find a snake skin.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a snake skin.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_SNAKESKIN;
			obj->name = str_dup("snake skin");
			obj->short_descr = str_dup("a snake skin");
			obj->description = str_dup("Here lies a snake skin.");
			obj->material = str_dup("soft leather");
			obj->weight = 3;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 9:
			act("You manage to find a honeycomb.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a honeycomb.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_FOOD;
			obj->name = str_dup("honeycomb");
			obj->short_descr = str_dup("a honeycomb");
			obj->description = str_dup("Here lies a honeycomb.");
			obj->material = str_dup("honey");
			obj->weight = 2;
			obj->cost = 0;
			obj->value[0] = 5;
			obj->value[1] = 5;
			obj->value[3] = 0;
			obj_to_char( obj, ch );
		break;
		default:
			act("You can only manage to find some soggy leaves.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}
	}
    else if ( type == 12 && found )
    {
		switch( number_range( 1,2 ) )
		{
		case 1:
			act("You manage to find a sharp wedge of obsidian.",ch,NULL,NULL,TO_CHAR);
			act("$n manages to find a sharp wedge of obsidian.",ch,NULL,NULL,TO_ROOM);
			obj = create_object(get_obj_index(OBJ_VNUM_SHAPING_MATERIAL), 0 );
			obj->item_type = ITEM_SHAPE_OBSIDION;
			obj->name = str_dup("obsidian wedge");
			obj->short_descr = str_dup("an obsidian wedge");
			obj->description = str_dup("Here lies a sharp wedge of obsidian.");
			obj->material = str_dup("hard stone");
			obj->weight = 3;
			obj->cost = 0;
			obj_to_char( obj, ch );
		break;
		case 2:
			act("You can only manage to find some ash.",ch,NULL,NULL,TO_CHAR);
			found = FALSE;
		break;
		}
	}
	else
	{
		act("You can only manage to find some soggy leaves.",ch,NULL,NULL,TO_CHAR);
		found = FALSE;
	}

	if (found)	check_improve(ch, gsn_forage, TRUE, 6);
	else		check_improve(ch, gsn_forage, FALSE, 7);
	return;
}
