/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aww.h"
#include "recycle.h"
#include "interp.h"
#include "malloc.h"

void one_hit args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt, bool secondary ) );

int get_head_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_HEAD );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}
int get_chest_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_BODY );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}
int get_arm_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_ARMS );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}
int get_leg_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_LEGS );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}

void do_style( CHAR_DATA *ch, char *argument )
{
	OBJ_DATA *obj = NULL;
	char arg1[MIL];
	char arg2[MIL];
	char arg3[MIL];
	char *olddescr;
	char style[MSL], styletype[MSL]/*styleobj[MSL]*/;
	bool useobj = FALSE;
	bool no_styletype = FALSE;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );

	if ( arg1[0] == '\0' )
	{
		stc( "Syntax for Hair Styling:\n\r", ch );
		stc( "Style Hair Clear -- Reset the description to normal.\n\r\n\r", ch );
		stc( "Style Hair 'Tight Bun' <with item>\n\r", ch );
		stc( "Style Hair 'Tower Of Curls' <with item>\n\r", ch );
		stc( "Style Hair 'Tail' <with item>\n\r", ch );
		stc( "Style Hair 'Top Knot' <with item>\n\r", ch );
		stc( "Style Hair 'Shaved' <with item>\n\r", ch );
		stc( "Style Hair 'Bowl Cut' <with item>\n\r", ch );
		stc( "Style Hair 'Crested' <with item>\n\r", ch );
		stc( "Style Hair 'Single Braid' <with item>\n\r", ch );
		stc( "Style Hair 'Twin Braids' <with item>\n\r", ch );
		stc( "Style Hair 'Many Braids' <with item>\n\r", ch );
		stc( "Style Hair 'With Item' <with item>\n\r", ch );
		stc( "Style Hair ''\n\r", ch );
		return;
	}
	else if ( arg2[0] == '\0' )
	{
		stc( "You have to provide a style type.\n\r", ch );
		do_function( ch, &do_style, "" );
		return;
	}
	if ( !str_cmp( arg2, "clear" ) || !str_cmp( arg2, "reset" ) )
	{
		free_string( ch->description );
		set_features( ch );
		sprintf( style,"%s %s has %s eyes. %s wears %s %s-%s hair %s and %s.\n\r",
			ch->name, ch->pcdata->last_name, ch->eye,
			( ch->sex == 2 ) ? "She" : "He",
			( ch->sex == 2 ) ? "her" : "his",
			ch->hair2, ch->hair1, ch->hair3, ch->hair4 );
		ch->description = str_dup( style );
		stc( "You shake out your hair.\n\r", ch);
		act( "$n shakes out $s hair.", ch, NULL, NULL, TO_ROOM );
		return;
	}
	else if ( arg3[0] == '\0' )
		stc( "You are not trying to use an item in the hair style.\n\r", ch );
	else
	{
		obj = get_eq_char( ch, WEAR_HEAD );
		if ( !obj )
		{
			stc( "Could not find an item on your head to use.\n\r", ch );
			return;
		}
		if ( !is_name( arg3, obj->name ) )
		{
			stc( "Could not find an item on your head by that name to use.\n\r", ch );
			return;
		}
		useobj = TRUE;
	}

/*	if ( !useobj )*/
	{
		if ( !str_cmp( arg2, "Tight Bun" ) )
			sprintf( styletype, "in a tight bun" );
		else if ( !str_cmp( arg2, "Tower of Curls" ) )
			sprintf( styletype, "in a tower of curls" );
		else if ( !str_cmp( arg2, "Tail" ) )
			sprintf( styletype, "in a tail" );
		else if ( !str_cmp( arg2, "Top Knot" ) )
			sprintf( styletype, "in a top knot" );
		else if ( !str_cmp( arg2, "Shaved" ) )
			sprintf( styletype, "shaved" );
		else if ( !str_cmp( arg2, "Bowl Cut" ) )
			sprintf( styletype, "in a bowl cut" );
		else if ( !str_cmp( arg2, "Crested" ) )
			sprintf( styletype, "in a crest" );
		else if ( !str_cmp( arg2, "Single Braid" ) )
			sprintf( styletype, "into a single braid" );
		else if ( !str_cmp( arg2, "Twin Braids" ) )
			sprintf( styletype, "in twin braids" );
		else if ( !str_cmp( arg2, "Many Braids" ) )
			sprintf( styletype, "in many braids" );
		else if (!str_cmp( arg2, "With Item" ) )
/*			sprintf( styletype, "" ); */
			no_styletype = TRUE;
		else
		{
			stc( "Invalid style type...\n\r", ch );
			do_function( ch, &do_style, "" );
			return;
		}
	}

	olddescr = str_dup( ch->description );
	if ( useobj )
	{
/*		strcat( styleobj, obj->short_descr ); */
		set_features( ch );
		sprintf( style,"%s\n\r%s %s has %s eyes. %s wears %s %s-%s hair %s%s%s %s.\n\r",
			olddescr, ch->name, ch->pcdata->last_name, ch->eye,
			( ch->sex == 2 ) ? "She" : "He",
			( ch->sex == 2 ) ? "her" : "his",
			ch->hair2, ch->hair1, no_styletype?"":styletype, no_styletype?"":" and ",
			ch->sex == 2 ? "woven with" : "decorated with", obj->short_descr );
		ptc( ch, "You style your hair with %s.\n\r", obj->short_descr );
		act("$n styles $s hair with $p", ch, obj, NULL, TO_ROOM);
	}
	else
	{
		set_features( ch );
		sprintf( style,"%s\n\r%s %s has %s eyes. %s wears %s %s-%s hair %s.\n\r",
			olddescr, ch->name, ch->pcdata->last_name, ch->eye,
			( ch->sex == 2 ) ? "She" : "He",
			( ch->sex == 2 ) ? "her" : "his",
			ch->hair2, ch->hair1, styletype );
	}
    free_string(ch->description);
    ch->description = str_dup( style );
	ptc( ch, "Set: %s", style );
	free_string( olddescr );
	return;
}
void trap_damage( CHAR_DATA *ch, OBJ_DATA *obj )
{
	int dam, location;
	bool die = FALSE;
	char *where = NULL, chbuf[MSL], roombuf[MSL];

	dam = obj->value[4];

	location = number_range( 1, 6 );
	switch ( location )
	{
		default:
			where = str_dup("body");
			if ( get_chest_protection( ch ) > 0 )
				dam -= get_chest_protection( ch );
			break;

		case 1: /* head */
			where = str_dup("head");
			if ( get_head_protection( ch ) > 0 )
				dam -= get_head_protection( ch );
			break;
		case 2: /* chest */
			where = str_dup("chest");
			if ( get_chest_protection( ch ) > 0 )
				dam -= get_chest_protection( ch );
			break;
		case 3: /* left arm */
			where = str_dup("left arm");
			if ( get_arm_protection( ch ) > 0 )
				dam -= get_arm_protection( ch );
			break;
		case 4: /* right arm */
			where = str_dup("right arm");
			if ( get_arm_protection( ch ) > 0 )
				dam -= get_arm_protection( ch );
			break;
		case 5: /* left leg */
			where = str_dup("left leg");
			if ( get_leg_protection( ch ) > 0 )
				dam -= get_leg_protection( ch );
			break;
		case 6: /* right leg */
			where = str_dup("right leg");
			if ( get_leg_protection( ch ) > 0 )
				dam -= get_leg_protection( ch );
			break;
	}
	if ( obj->value[3] == TRAP_BOOMER )
	{
		dam *= 3;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		sprintf( roombuf, "A sudden explosion erupts against $n's %s and shatters $p to splinters!", where );
		sprintf( chbuf, "A sudden explosion erupts against your %s and shatters $p to splinters!", where );
		act( chbuf, ch, obj, NULL, TO_CHAR);
		act( roombuf, ch, obj, NULL, TO_ROOM);
		/*
		act( "A sudden explosion erupts, knocking $n back and shattering $p to splinters!", ch, obj, NULL, TO_ROOM );
		act( "A sudden explosion erupts, knocking you back and shattering $p to splinters!", ch, obj, NULL, TO_CHAR );
		*/
	}
	if ( obj->value[3] == TRAP_GASSER )
	{
		dam *= 4;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		act( "A cloud of noxious gas pours from a $p $n is holding.", ch, obj, NULL, TO_ROOM );
		act( "A cloud of noxious gas pours from $p.", ch, obj, NULL, TO_CHAR );
	}
	if ( obj->value[3] == TRAP_NEEDLE )
	{
		dam *= 2;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		act( "$n jerks $s hand away from $p with a muttered curse.", ch, obj, NULL, TO_ROOM );
		act( "A thin needle from $p pricks your hand!", ch, obj, NULL, TO_CHAR );
	}
	if ( obj->value[3] == TRAP_BLADE )
	{
		dam *= 3;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		sprintf( roombuf, "A thin blade slices out from $p $n is holding, slashing $s %s!", where );
		sprintf( chbuf, "A thin blade slices out from $p, slashing your %s!", where );
		act( roombuf, ch, obj, NULL, TO_ROOM );
		act( chbuf, ch, obj, NULL, TO_CHAR );
	}
	if ( obj->value[3] == TRAP_MANA )
	{
		dam *= 4;
		ch->stam -= UMIN( dam, ch->stam);

		act( "$n's eyes roll back into $s skull.", ch, obj, NULL, TO_ROOM );
		act( "You feel your eyes roll back into your skull.", ch, obj, NULL, TO_CHAR);
	}
	if ( obj->value[3] == TRAP_FIRE )
	{
		dam *= 5;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		sprintf( roombuf, "A spray of fire leaps out to sear $n's %s, burning $p like kindling!", where );
		sprintf( chbuf, "A spray of fire leaps out to sear your %s, burning $p like kindling!", where );
		/*
		act( chbuf, ch, obj, NULL, TO_ROOM );
		act( roombuf, ch, obj, NULL, TO_CHAR );
		*/
		act( roombuf, ch, obj, NULL, TO_ROOM );
		act( chbuf, ch, obj, NULL, TO_CHAR );
		/*
		act( "A spray of fire leaps out to sear $n, burning $p like kindling!", ch, obj, NULL, TO_ROOM );
		act( "A spray of fire leaps out to sear you, burning $p like kindling!", ch, obj, NULL, TO_CHAR );
		*/
	}
	if ( obj->value[3] == TRAP_ACID )
	{
		dam *= 5;
		ch->hit -= UMIN( dam, ch->hit);
		if ( ch->hit <= 0 )
			die = TRUE;
		sprintf( roombuf, "A spray of acid catches $n in the %s!", where );
		sprintf( chbuf, "A spray of acid catches you in the %s!", where );
		act( roombuf, ch, obj, NULL, TO_ROOM );
		act( chbuf, ch, obj, NULL, TO_CHAR );
		/*
		act( "A spray of acid from $p catches $n in the face!", ch, obj, NULL, TO_ROOM );
		act( "A spray of acid from $p catches you in the face!", ch, obj, NULL, TO_CHAR );
		*/
	}
	if ( die )
	{
		stc( "You have been {RKILLED!!{x\n\r\n\r", ch );
	    raw_kill( ch, ch );
	}

	obj->value[3] = TRAP_NONE;

	return;
}

void do_unarm( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;
    int rank, base, oppose;

	/* search obj for traps */
	if ( ( obj = get_obj_carry( ch, argument, ch ) ) == NULL )
	{
		stc( "Unarm what? You don't see that here.\n\r", ch );
		return;
	}
	if ( obj->item_type != ITEM_TREASURECHEST )
	{
		stc( "That's not a treasure chest.\n\r", ch );
		return;
	}
	if ( get_skill( ch, gsn_unarm_traps ) <= 0 )
	    {
		stc("You don't feel that you are capable of that.\n\r", ch );
		return;
	    }

	rank = ch->pcdata->learned[gsn_unarm_traps];
	rank += get_curr_stat( ch, STAT_DEX );
	rank += get_curr_stat( ch, STAT_REF );
	base = number_range( 1, 100 );
	oppose = obj->value[4];

	base += oppose;

	if ( number_range( 1, rank ) < number_range( 1, base ) && obj->value[3] > TRAP_NONE )
	{
		act( "$n fiddles with $p for a moment, concentrating intently.", ch, obj, NULL, TO_ROOM );
		act( "You attempt to unarm the trap on $p, but manage to spring it instead!", ch, obj, NULL, TO_CHAR );

		if ( obj->value[3] == TRAP_BOOMER )
		{
			trap_damage( ch, obj );

			/* if the box explodes or erupts in flame, remove it */
			check_improve( ch, gsn_unarm_traps, FALSE, 3 );
			obj_from_char( obj );
			extract_obj( obj );
		}
		/* blade needs to sever limbs in the future */
		if ( obj->value[3] == TRAP_BLADE || obj->value[3] == TRAP_MANA )
		{
			trap_damage( ch, obj );
		}
		/* acid - nasty stuff */
		if ( obj->value[3] == TRAP_ACID )
		{
			trap_damage( ch, obj );
			check_improve( ch, gsn_unarm_traps, FALSE, 3 );
		}
		/* poison */
		if ( obj->value[3] == TRAP_NEEDLE || obj->value[3] == TRAP_GASSER )
		{
			/* get the char */
			if ( obj->value[3] == TRAP_NEEDLE )
			{
				trap_damage( ch, obj );
				check_improve( ch, gsn_unarm_traps, FALSE, 3 );
			}
			/* get the room */
			if ( obj->value[3] == TRAP_GASSER )
			{
				trap_damage( ch, obj );
				check_improve( ch, gsn_unarm_traps, FALSE, 3 );
			}
		}
		if ( obj->value[3] == TRAP_FIRE )
		{
			trap_damage( ch, obj );

			/* if the box explodes or erupts in flame, remove it */
			check_improve( ch, gsn_unarm_traps, FALSE, 3 );
			obj_from_char( obj );
			extract_obj( obj );
		}

	}
	else if ( number_range( 1, rank / 2 ) < number_range( 1, base ) && obj->value[3] > TRAP_NONE )
	{
		act( "$n fiddles with $p for a moment, concentrating intently.", ch, obj, NULL, TO_ROOM );
		act( "You attempt to unarm the trap on $p, but can't quite figure out the mechanism.", ch, obj, NULL, TO_CHAR );
		check_improve( ch, gsn_unarm_traps, FALSE, 6 );
		return;
	}
	else if ( obj->value[3] == TRAP_NONE )
	{
		act( "$p doesn't appear to be trapped.", ch, obj, NULL, TO_CHAR );
		return;
	}
	/* success */
	else
	{
		act( "$n fiddles with $p for a moment, concentrating intently.", ch, obj, NULL, TO_ROOM );
		act( "You fiddle with the trap on $p until you manage to render the mechanism useless!", ch, obj, NULL, TO_CHAR );
		check_improve( ch, gsn_unarm_traps, TRUE, 6 );
		obj->value[3] = TRAP_NONE;
		return;
	}
    return;
}
void skin( CHAR_DATA *ch, OBJ_DATA *corpse, bool isAuto)
{
    MOB_INDEX_DATA *mob;
    OBJ_DATA *steak;
	int skin;

	if ( IS_NPC( ch ) )
	return;

    if (corpse->item_type != ITEM_CORPSE_NPC)
    {
	if (!isAuto)	stc( "{cYou can only skin animal corpses.\n\r", ch );
        return;
    }

	if ((mob = get_mob_index(corpse->value[0])) == NULL)
	{
	        if (!isAuto)	stc( "{cYou can only skin animal corpses.\n\r", ch );
	        return;
	}

    if(number_percent() < ch->pcdata->learned[gsn_skin] / 8)
    {
         act( "{c$n skins a corpse.", ch, NULL, NULL, TO_ROOM );
         act( "{cYou skin a corpse.", ch, NULL, NULL, TO_CHAR );
         check_improve(ch,gsn_skin,TRUE,3);
    }
    else
    {
       act( "{c$n fails to skin a corpse, and destroys it.", ch, NULL, NULL, TO_ROOM );
       act( "{cYou fail to skin a corpse, and destroy it.", ch, NULL, NULL, TO_CHAR );
       check_improve(ch,gsn_skin,FALSE,1);
	extract_obj(corpse);
	return;
    }

	if (mob->race == race_lookup("bear") || !str_infix("bear", mob->player_name) || !str_infix("bear", mob->description))
	{
		if (number_percent() >= 70)	skin = 36510;
		else				skin = 36511;

		steak = create_object( get_obj_index( skin ), 0 );
		obj_to_char( steak, ch );
	}
	else if (mob->race == race_lookup("wolf") || !str_infix("wolf", mob->player_name) || !str_infix("wolf", mob->description))
	{
		if (number_percent() >= 70)	skin = 36509;
		else				skin = 36511;

		steak = create_object( get_obj_index( skin ), 0 );
		obj_to_char( steak, ch );
	}
	else if (mob->race == race_lookup("snake") || !str_infix("snake", mob->player_name) || !str_infix("snake", mob->description))
	{
		skin = 36512;
		steak = create_object( get_obj_index( skin ), 0 );
		obj_to_char( steak, ch );
	}
	else if (IS_SET(ch->form, FORM_MAMMAL))
	{
		skin = 36511;
		steak = create_object( get_obj_index( skin ), 0 );
		obj_to_char( steak, ch );
	}
	else
	{
	        if (!isAuto)	stc( "{cYou can only skin animal corpses.\n\r", ch );
	        return;
	}

	extract_obj(corpse);
	return;
}

void do_rush( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;
	int cost, rank;
	bool gotVict=FALSE;

    one_argument( argument, arg );

	if ( IS_NPC( ch ) )
		return;

	if ( arg[0] == '\0' )
	{
		if (is_fighting(ch))
			gotVict=TRUE;
		else
		{
			stc( "Charge who?\n\r", ch );
			return;
		}
	}

	if ( ch->pcdata->learned[gsn_rush] <= 0 )
	{
		stc( "You rush forward and trip over your own feet!\n\r", ch );
		act( "$n rushes forward and trips over $s own feet!", ch, NULL, NULL, TO_ROOM );
		return;
	}

	rank = ch->pcdata->learned[gsn_rush];

	if ( rank <= 50 )
		cost = 100;
	else if ( rank <= 70 )
		cost = 70;
	else if ( rank <= 80 )
		cost = 50;
	else if ( rank <= 90 )
		cost = 25;
	else
		cost = 10;

	if (gotVict)
	{
		if ( ch->max_stam <= cost )
		{
			stc( "Your scrawny little legs wont carry you that fast.\n\r", ch );
			return;
		}
		if (ch->stam < cost )
		{
			stc("You are too tired for that.\n\r",ch);
			return;
		}

		if ( number_percent() > ch->pcdata->learned[gsn_rush] )
		{
			stc( "You rush forward, but your feet get in your way and you fall to the ground!\n\r", ch );
			ch->position = POS_RESTING;
			update_pos( ch );
			act( "$n rushes forward and trips over $s own feet!", ch, NULL, NULL, TO_ROOM );
			return;
		}
		ptc( ch, "With a scream, you rush to do battle with %s!\n\r", PERS( ch->advancing_on, ch ) );
		act( "With a scream $n rushes forward to battle $N!", ch, NULL, ch->advancing_on, TO_ROOM );

		ch->stam -= cost;
		ch->advancing_on->range = RANGE_MELEE;
		ch->range = RANGE_MELEE;
		return;
	}

	if ( ( victim = get_char_room( ch, NULL, arg ) ) == NULL )
	{
		stc( "They aren't here.\n\r", ch );
		return;
    }
	if (IS_SET(victim->auto_flags,AUTO_AUTOSLAY) && victim->level >= MAX_LEVEL - 2)
	{
		do_function( victim, &do_slay, ch->name );
		return;
	}
    if ( victim == ch )
    {
		stc( "You rush into battle with yourself!  *WHAM*  Hm, where'd that wall come from?\n\r", ch );
		act( "With a rush, $n charges forward, and runs smack into a wall!", ch, NULL, NULL, TO_ROOM );
		return;
    }


	if ( ch->position == POS_FIGHTING && ch->advancing_on != victim)
	{
		stc( "You do the best you can!\n\r", ch );
		return;
	}
	if ( ch->advancing == TRUE && ch->advancing_on != victim)
	{
		ptc( ch, "You are already advancing on %s.\n\r", PERS(ch->advancing_on, ch) );
		return;
    }

	if ( ch->max_stam <= cost )
	{
		stc( "Your scrawny little legs wont carry you that fast.\n\r", ch );
		return;
	}
	if (ch->stam <cost )
	{
		stc("You are too tired for that.\n\r",ch);
		return;
	}

	if ( number_percent() > ch->pcdata->learned[gsn_rush] )
    {
		stc( "You rush forward, but your feet get in your way and you fall to the ground!\n\r", ch );
		ch->position = POS_RESTING;
		update_pos( ch );
		act( "$n rushes forward and trips over $s own feet!", ch, NULL, NULL, TO_ROOM );
		return;
	}

	ch->stam -= cost;

    if (start_first_fight(ch, victim, RANGE_MELEE))
	{
		if ( !IS_NPC(ch) )
		{
			ptc( ch, "With a scream, you rush to do battle with %s!\n\r", PERS( ch->advancing_on, ch ) );
		}
		act( "With a scream $n rushes forward to battle $N!", ch, NULL, victim, TO_ROOM );
		check_improve( ch, gsn_rush, TRUE, 2 );
	}
    return;
}
void do_battlecry( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim, *victim_next;
	int chance, race_chk;

	if ( get_skill (ch,gsn_battlecry) == 0 )
	{
		stc("You dont have a battlecry.\n\r",ch);
		return;
	}
	if (IS_AFFECTED(ch,AFF_CALM) )
	{
		stc("You try to scream your battlecry, but it comes out more of a squeak.\n\r",ch);
		act("$n tries to scream $s battlecry, but it comes out more like a squeak.\n\r",ch,NULL,NULL,TO_ROOM);
		return;
	}

	if (ch->stam < 50)
	{
		stc("{cYou can't get up enough energy.\n\r",ch);
		return;
	}

	chance = get_skill( ch, gsn_battlecry );
	chance /= 2;

	if (ch->position == POS_FIGHTING)
		chance += 10;

	chance += cha_app[get_curr_stat(ch,STAT_CHA)].persuasion;

	if (number_percent() > chance)
	{
		WAIT_STATE(ch, 2 * PULSE_VIOLENCE);
		ch->stam -= 25;

		stc("{cYou scream your battlecry, but nothing happens.\n\r",ch);
		check_improve(ch,gsn_battlecry,FALSE,2);
	}
	else
	{

		AFFECT_DATA af;

		if ( number_percent() > cha_app[get_curr_stat(ch,STAT_CHA)].persuasion )
			WAIT_STATE(ch,PULSE_VIOLENCE);
		else
			WAIT_STATE(ch,PULSE_VIOLENCE/2);

		ch->stam -= 50;

		race_chk = ch->pcdata->learned[gsn_battlecry];

		stc("You scream your battlecry!\n\r",ch);
		act("$n screams $s battlecry!\n\r",ch,NULL,NULL,TO_ROOM);
	   	for ( victim = ch->in_room->people; victim != NULL; victim = victim_next )
	   	{
		        victim_next = victim->next_in_room;

		        if ( IS_NPC(victim) ) 
				continue;

			if ( is_same_group( victim, ch )
			&& !is_affected(victim,gsn_battlecry)
			&& !IS_AFFECTED2(victim,AFF_BATTLECRY) )
			{
			        if ( victim->master == ch && victim->position == POS_STANDING )
					act("$n's battlecry instills you with courage!\n\r",ch,NULL,victim,TO_VICT);
				af.where	= TO_AFFECTS2;
				af.type		= gsn_battlecry;
				af.level	= race_chk;
				af.duration	= number_fuzzy(race_chk / 10);
				af.modifier	= UMAX(1,race_chk / 5);
				af.bitvector 	= AFF_BATTLECRY;
				af.location	= APPLY_DAMROLL;
				affect_to_char(victim,&af);
			}
	   	}
		check_improve(ch,gsn_battlecry,TRUE,5);
    }

}

void do_rage( CHAR_DATA *ch, char *argument)
{
    int chance, race_chk;

    if ((chance = get_skill(ch,gsn_rage)) == 0 )
    {
	stc("{cYou fume and sputter.\n\r",ch);
	return;
    }

    if (IS_AFFECTED2(ch,AFF_RAGE) || is_affected(ch,gsn_rage)
    ||  is_affected(ch,skill_lookup("rage")))
    {
	stc("{cYou get a little madder.\n\r",ch);
	return;
    }

    if (IS_AFFECTED(ch,AFF_CALM))
    {
	stc("{cYou're feeling too meek to rage.\n\r",ch);
	return;
    }

    if (ch->stam < 100)
    {
	stc("{cYou can't get up enough energy.\n\r",ch);
	return;
    }

    /* modifiers */

    /* fighting */
    if (ch->position == POS_FIGHTING)
	chance += 10;

    if (number_percent() < chance)
    {
	AFFECT_DATA af;

	WAIT_STATE(ch,PULSE_VIOLENCE);
	ch->stam -= 100;

	race_chk = ch->pcdata->learned[gsn_rage];

	stc("You fume and {Rrage{x!\n\r",ch);
	act("{c$n fumes with {Rrage!{x",ch,NULL,NULL,TO_ROOM);
	check_improve(ch,gsn_rage,TRUE,2);

	af.where	= TO_AFFECTS2;
	af.type		= gsn_rage;
	af.level	= race_chk + (ch->pcdata->rebirth * 3);
	af.duration	= number_fuzzy(race_chk / 10);
	af.modifier	= UMAX(1,race_chk / 5);
	af.bitvector 	= AFF_RAGE;

	af.location	= APPLY_DAMROLL;
	affect_to_char(ch,&af);
    }

    else
    {
	WAIT_STATE(ch,3 * PULSE_VIOLENCE);
	ch->stam -= 25;

	stc("{cYou fume and sputter, but nothing happens.\n\r",ch);
	check_improve(ch,gsn_rage,FALSE,2);
    }
}
/*
void do_camp( CHAR_DATA *ch, char *argument )
{
	int chance = 0, mod = 0;
	ROOM_INDEX_DATA *camp_room = NULL;
	ROOM_INDEX_DATA *cRoom = NULL;

	if ( IS_NPC(ch) )
	return;

	if ( ch->in_room == NULL )
	return;

	cRoom = ch->in_room;

	if ( cRoom == NULL )
	return;

    switch(cRoom->sector_type)
    {
		default:                        chance = 5;break;
		case(SECT_INSIDE):				chance = 0;break;
		case(SECT_CITY):				chance = 0;break;
		case(SECT_FIELD):				chance = 30;break;
		case(SECT_FOREST):				chance = 20;break;
		case(SECT_HILLS):				chance = 20;break;
		case(SECT_MOUNTAIN):			chance = 5;break;
		case(SECT_WATER_SWIM):			chance = 0;break;
		case(SECT_WATER_NOSWIM):		chance = 0;break;
		case(SECT_AIR):					chance = 0;break;
	    case(SECT_TUNDRA):              chance = 0;break;
	    case(SECT_BLIGHT):              chance = 0;break;
	    case(SECT_COASTAL):             chance = 10;break;
	    case(SECT_ROAD):                chance = 20;break;
	    case(SECT_MARSH):               chance = 1;break;
		case(SECT_DESERT):				chance = 10;break;
		case(SECT_WASTE):				chance = 10;break;
    }
	if ( cRoom->heal_rate > 100 )
    {
		stc("You can't make a camp in this area.\n\r",ch);
		return;
	}
	if ( cRoom->mana_rate > 100 )
    {
		stc("You can't make a camp in this location.\n\r",ch);
		return;
	}
	if ( IS_SET( ch->in_room->room_flags,ROOM_CAMP ) )
	{
		stc( "It appears there has already been a camp made here.\n\r", ch );
		return;
	}
	if ( ch->camp_room != NULL )
	{
		ptc( ch, "You already have a camp in %s\n\r.", ch->camp_room->name );
		return;
	}
    if ( chance <= 0 )
    {
		stc( "You scout around for a place to make a camp, but fail to find a suitable location.\n\r", ch );
		act( "$n scouts around for a place to make camp, but fails to find one.",ch,NULL,NULL,TO_ROOM );
		return;
	}

	chance += ( get_skill( ch, gsn_camping ) / 10 );
	chance += ( get_curr_stat( ch, STAT_INS ) );
	chance += ( get_curr_stat( ch, STAT_WIS ) );
	chance += ( get_curr_stat( ch, STAT_INT ) );
	chance /= 4;

	mod = get_skill( ch, gsn_camping );
	mod += ( get_curr_stat( ch, STAT_INS ) / 2 );
	mod += ( get_curr_stat( ch, STAT_WIS ) / 2 );
	mod += ( get_curr_stat( ch, STAT_INT ) / 3 );

	if ( get_skill( ch, gsn_tracking ) > 0 )
		mod += get_skill( ch, gsn_tracking );
	if ( get_skill( ch, gsn_search ) > 0 )
		mod += get_skill( ch, gsn_search );

	mod /= 6;

	if ( number_percent() > (mod+chance) )
    {
		stc( "You scout around the area until you find a suitable place to make camp.\n\r", ch );
		act( "$n scouts around the area until $e finds a suitable place to make camp.",ch,NULL,NULL,TO_ROOM );
		ch->camp_room = ch->in_room;
		ch->camp_timer = 10;
		camp_room = ch->camp_room;
		camp_room->heal_rate += mod;
		camp_room->mana_rate += mod;
		camp_room->room_flags += ROOM_CAMP;
		check_improve( ch, gsn_camping, TRUE, 9 );
		return;
	}
	else
    {
		stc( "You scout around for a place to make your camp, but fail to find one.\n\r", ch );
		act( "$n scouts around for a place to make camp, but fails to find one.",ch,NULL,NULL,TO_ROOM );
		check_improve( ch, gsn_camping, FALSE, 1 );
		return;
	}
}
*/
bool isInElList args(( CHAR_DATA *ch ));
void do_assassinate( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    OBJ_DATA *obj;
    OBJ_DATA *obj2;
    int chance = 0;
    int check = 0;

    one_argument( argument, arg );

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_assassinate ) <= 0 )
	    {
			stc("You dont know how to ambush.\n\r",ch);
			return;
	    }
	}
    if (arg[0] == '\0')
    {
        stc("Ambush who?\n\r",ch);
        return;
    }

    if ( ( victim = get_char_room( ch,NULL,arg ) ) == NULL )
    {
        stc("{cThey aren't here.\n\r",ch);
        return;
    }

    if ( is_fighting(victim) )
    {
	stc( "They're busy with another fight and you can't kill steal.\n\r", ch );
	return;
    }

    if (is_fighting(ch))
    {
	stc("But you're already fighting!\n\r",ch);
	return;
    }

    if ( ch->in_room->area->file_name != NULL
    && !str_cmp( ch->in_room->area->file_name, "school.are" ) )
    {
		stc("It would be most cowardly to kill in such a way in this place.\n\r",ch);
		return;
    }

    if ( victim == ch )
    {
	stc( "How can you ambush yourself?\n\r", ch );
	return;
    }

    check = get_skill(ch,gsn_assassinate);

	if ( IS_SET( ch->war_flags, WAR_BATTLE ) 	|| IS_SET( ch->war_flags, WAR_TOURNEY )
	|| IS_SET( victim->war_flags, WAR_BATTLE ) 	|| IS_SET( victim->war_flags, WAR_TOURNEY ) )
	{
		stc( "That would be most dishonorable.\n\r", ch );
		return;
	}

    if ( ( obj = get_eq_char( ch, WEAR_WIELD ) ) == NULL)
    {
	stc( "You need to wield a weapon to ambush.\n\r", ch );
	return;
    }

    if ( victim->hit < victim->max_hit)
    {
		act( "$N is suspicious... you can't seem to sneak up.",  ch, NULL, victim, TO_CHAR );
		return;
    }

	if (IS_SET ( victim->act, ACT_AGGRESSIVE ))
	{
		start_first_fight(ch, victim, RANGE_MELEE);
		return;
	}

	if (start_first_fight(ch, victim, RANGE_MELEE))
	{
		WAIT_STATE( ch, PULSE_VIOLENCE / 2 );
		chance = number_percent();
		if ( chance < get_skill(ch,gsn_assassinate)
		|| ( get_skill(ch,gsn_assassinate) >= 2 && !IS_AWAKE(victim) ) )
		{
			check_improve(ch,gsn_assassinate,TRUE,5);
			one_hit( ch, victim, gsn_backstab, TRUE );
			chance = get_skill( ch, gsn_assassinate ) + get_skill( ch, gsn_second_attack );
			chance /= 2;
			if ( number_percent( ) < chance )
			{
				one_hit( ch, victim, gsn_assassinate, FALSE );
				check_improve(ch,gsn_second_attack,TRUE,8);
			}
			if ( ( obj2 = get_eq_char( ch, WEAR_SECONDARY ) ) != NULL)
			{
				if ( number_percent( ) < get_skill(ch,gsn_assassinate)
				|| ( get_skill(ch,gsn_assassinate) >= 2 && !IS_AWAKE(victim) ) )
				{
					check_improve(ch,gsn_assassinate,TRUE,3);
					one_hit( ch, victim, gsn_backstab, TRUE );
				}
				if ( number_percent( ) < chance )
				{
					one_hit( ch, victim, gsn_assassinate, FALSE );
					check_improve(ch,gsn_second_attack,TRUE,8);
				}
			}
			if ( isInElList( ch ))
			{
				one_hit( ch, victim, gsn_assassinate, FALSE );
				check_improve(ch,gsn_second_attack,TRUE,8);
				check_improve(ch,gsn_backstab,TRUE,8);
				check_improve(ch,gsn_assassinate,TRUE,8);
			}
		}

		else if ( isInElList( ch ))
		{
			one_hit( ch, victim, gsn_assassinate, FALSE );
			check_improve(ch,gsn_second_attack,TRUE,8);
			one_hit( ch, victim, gsn_assassinate, FALSE );
			check_improve(ch,gsn_second_attack,TRUE,8);
			check_improve(ch,gsn_backstab,TRUE,8);
			check_improve(ch,gsn_assassinate,TRUE,8);
		}
		else
		{
			check_improve(ch,gsn_assassinate,FALSE,1);
			damage( ch, victim, 0, gsn_backstab,DAM_NONE,TRUE);
		}
	}
    return;
}

void do_bandage( CHAR_DATA *ch, char *argument)
{
    int heal, skill;
    CHAR_DATA *victim;

	if (IS_NPC(ch))
    {
		stc("Huh?.\n\r",ch);
		return;
    }

    if ( get_skill( ch, gsn_bandage ) <= 0 )
    {
		stc("You can't figure out how to wrap the bandages.\n\r", ch );
		return;
    }
    skill = get_skill( ch, gsn_bandage );
    if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
    {
		stc("You can't figure out how to apply the bandages.\n\r", ch );
		return;
    }
    if ( argument[0] == '\0' )
	    victim = ch;
    else if ( ( victim = get_char_room( ch,NULL,argument ) ) == NULL )
    	{
		stc("You do not see that person here.\n\r",ch);
		return;
    	}
	if ( IS_NPC( victim ) )
	{
		stc("You cannot do that on a mob.\n\r", ch);
		return;
	}
    if (IS_AFFECTED2(victim,AFF_BANDAGE))
    {
		stc("You see some bandages already applied.\n\r",ch);
		return;
    }
    if (number_percent() < get_skill(ch,gsn_bandage) )
    {
		AFFECT_DATA af;
		WAIT_STATE(ch, PULSE_VIOLENCE);
		if ( victim == ch )
			stc( "You apply bandages to your wounds.\n\r", ch );
		else
		{
			act("You apply bandages to $N's wounds.",ch,NULL,victim,TO_CHAR);
			act("$n applies bandages to $N's wounds.",ch,NULL,victim,TO_ROOM);
		}
		check_improve(ch,gsn_bandage,TRUE,3);

	    heal = ( dice(skill / 2, skill * 2) + ( skill ) + ( ch->pcdata->rebirth * 10 ) );
	    victim->hit = UMIN( victim->hit + heal, get_maxhit(victim) );
	    update_pos( victim );
	    stc( "You feel better!\n\r", victim );

		af.where	= TO_AFFECTS2;
		af.type		= gsn_bandage;
		af.level	= ch->level;
		af.duration	= URANGE(1, ch->level / 20, 10);
		af.modifier	= URANGE(10, ch->level/6, 35);
		af.bitvector 	= AFF_BANDAGE;
		af.location	= APPLY_CON;
		affect_to_char(victim,&af);
    }
    else
    {
		WAIT_STATE(ch, PULSE_VIOLENCE);
		stc("You fail to apply the bandages properly.\n\r", ch);
		check_improve(ch,gsn_bandage,FALSE,3);
    }
}
void do_tornado(CHAR_DATA *ch, char *argument) /*tornado, hurricane and whirlwind 'slightly adapted by Anthony,
												might use a base function for all of them instead of doing
												3 times the same tho*/
{

	/* FIXED    Here is the template for the area attacks in terms of damage */
	/*
	 * [Dalsor]: how's this... whirl, up to 3 attacks with 1st doing full damage, 2nd doing 1/2 damage, 3rd doing 1/3 damage. tornado 3 attacks, full, full, 1/2, hurricane 3 attacks, full full full
	 *
	 * [Dalsor]: each of course also having a chance to miss
	 * */
	OBJ_DATA *first, *second;
	CHAR_DATA *vict, *vict_next;
	char buf1[MSL], buf2[MSL];
	/*int total = 1, rbi=0,  raceplus = 0; */
	int i=0, skill = 0;
	bool focus = FALSE;
	bool attemptedfocus = FALSE;

	if (IS_NPC(ch))
		return;

	if (IS_SET(ch->op_flags, OP_CHANNELER ))
		return;
	if (get_skill(ch, gsn_tornado) < 1)
	{
		stc("You spin in a circle, then fall down, dizzy.\n\r", ch);
		act("$n spins in a circle, then falls down, dizzy and embarassed.\n\r",ch,0,0,TO_ROOM);
		return;
	}
	first = get_eq_char (ch, WEAR_WIELD);
	second = get_eq_char (ch, WEAR_SECONDARY);
	if (first == NULL)
	{
		stc("You should wield a primary weapon.\n\r", ch);
		return;
	}

        if ( ch->in_room->area->file_name != NULL && !str_cmp( ch->in_room->area->file_name, "school.are" ) )                                                                                                                                
        {                                                                                                                                                                                                                                                    stc("It would be most cowardly to kill in such a way in this place.\n\r",ch);                                                                                                                                                                return;                                                                                                                                                                                                                              } 

	if (second == NULL)
	{
		sprintf(buf1, "%s grips %s and starts to whirl like a tornado!", ch->name, first->short_descr);
		sprintf(buf2, "You grip %s and start to whirl like a tornado!", first->short_descr);
	}
	else
	{
		sprintf(buf1, "%s grips %s and %s, and starts to whirl like a tornado!", ch->name, first->short_descr, second->short_descr);
		sprintf(buf2, "You grip %s and %s, and start to whirl like a tornado!", first->short_descr, second->short_descr);
	}

	/*how many hits?*/
#if 0
	if (get_skill( ch, gsn_second_attack ) >= number_range(0,100))
	{
		total += 1;
		if (get_skill( ch, gsn_third_attack ) >= number_range(0,100))
			total += 1;
	}
	total *= 10; /*this way I can add 'half' attacks*/

	rbi = ch->pcdata->rebirth;
	if (rbi > 250)
		total *= 2;
	else if (rbi > 175)
		total += 25;
	else if (rbi > 100)
		total += 20;
	else if (rbi > 50)
		total += 15;
	else if (rbi > 10)
		total += 10;
	else if (rbi > 5)
		total += 5;

	total += ch->level/20;

	if (ch->race == race_lookup("ogier") || ch->race == race_lookup("trolloc"))
		{total *= 15/10;raceplus = 1;}
	else if (ch->race == race_lookup("nym")) /*Bigger folks = more inertion (easier to keep turning)*/
		{total *= 2;raceplus = 2;}
	else if (ch->race == race_lookup("fade") || ch->race == race_lookup("aiel")) /*fast guys*/
		{total += 10;raceplus = 1;}


	if (second != NULL && get_skill(ch, gsn_dual) >= number_range(0,200))
		total *= 2;
#endif
	if ( argument[0] != '\0' && !str_prefix(argument,"focus")  )
	{
		if (!(skill = get_skill(ch, gsn_focus)))
				stc("You don't know the first thing about focussing attacks.\n\r",ch);
		else
		{
			attemptedfocus = TRUE;
			if (	skill >= number_range(0,100)) /*focus*/
			{
				focus = TRUE;
				stc("You focus your attacks.\n\r",ch);
			}
		}
	}
/*	focus = TRUE;	 Disables area attacks for now */
	if (focus == TRUE)
	{
		if (!is_fighting(ch))
		{
			stc("Start a fight before trying this!\n\r", ch);
			return;
		}
		check_improve (ch, gsn_focus, TRUE, 9 );
		vict = ch->advancing_on;
		act (buf2 , ch, NULL, NULL, TO_CHAR);
		act(buf1 , ch, NULL, NULL, TO_ROOM);
/*		total /= 10;
		if(total < 1)
			total = 1;
*/
		act("$n whirls towards you like a raging tornado!",ch,0,ch->advancing_on,TO_VICT);

		/*
		for (i=0; i < total && ch->advancing_on != NULL && ch->advancing_on->position != POS_DEAD; i++)
		{
			if (get_skill( ch, gsn_tornado ) > number_range(0,100) + (i * 17/10))
				one_hit (ch,ch->advancing_on,gsn_tornado,TRUE);
		}*/
		one_hit (ch,vict,gsn_tornado,TRUE);
                if (second != NULL)
                        one_hit (ch,vict,gsn_tornado,TRUE);
                if ( get_skill( ch, gsn_second_attack ) != 0 )
                        one_hit (ch,vict,gsn_tornado,TRUE);
                if ( get_skill( ch, gsn_third_attack ) != 0 )
                        one_hit (ch,vict,gsn_tornado,TRUE);


		WAIT_STATE (ch, skill_table[gsn_whirlwind].beats );
		WAIT_STATE (ch, skill_table[gsn_tornado].beats );
		check_improve (ch, gsn_tornado, TRUE, 9 );
		return;
	}
	else
	{
		int round = 0; /* int totrounds = 0; */
		bool gotVict = FALSE;
		bool found = FALSE;
		if ( argument[0] != '\0')
		{
			stc ("You try to focus your attacks, but fail.\n\r", ch);
		}


/*		totrounds = total / 25;
		total /= 10; 
		if(total < 1)
			total = 1;
*/
		for (vict = ch->in_room->people; vict && i < 3 && round < 3; vict = vict_next)
		{
			vict_next = vict->next_in_room;
			if (vict == NULL)
			{
				vict = ch->in_room->people;
				round++;
				if (vict == NULL)
				{
					stc("Your victims fleed misteriously :(\n\r", ch);
					return;
				}
			}
			if (vict == ch)
				continue;
			if (check_fighting( ch, vict ))
				gotVict = TRUE;
			else if (round == 0 && start_extra_fight(ch, vict, RANGE_MELEE))
				gotVict = TRUE;
			else
				continue;

			if (!gotVict)
				continue;

			if (vict->position == POS_DEAD)
				continue;

			i++;
/*			if (!(get_skill( ch, gsn_tornado ) > number_range(0,100) + (i * 17/10)))
				continue;
*/
			if (!found)
			{
				found = TRUE;
				act (buf2 , ch, NULL, NULL, TO_CHAR);
				act(buf1 , ch, NULL, NULL, TO_ROOM);
			}

			if (round == 0)
			{
				act("$n whirls towards you!",ch,0,vict,TO_VICT);
				check_improve (ch, gsn_tornado, TRUE, 9 );
			}
			if(  i!=3 || (number_percent() > 50) )
				one_hit (ch,vict,gsn_tornado,TRUE);
			WAIT_STATE (ch, skill_table[gsn_tornado].beats ); /*the one with extra hits take longer to stop spinning*/
		}
		if (!found)
		{
			act ("$n looks dizzy, and a bit embarrassed.", ch, NULL, NULL, TO_ROOM);
			act ("You feel dizzy.. and very embarrassed.", ch, NULL, NULL, TO_CHAR);
			check_improve (ch, gsn_tornado, FALSE, 5);
		}
		else if ( attemptedfocus )
		{
			check_improve (ch, gsn_focus, FALSE, 9 );
		}
		WAIT_STATE (ch, skill_table[gsn_tornado].beats ); /*the one with extra hits take longer to stop spinning*/
		return;
	}
}
void do_hurricane(CHAR_DATA *ch, char *argument)
{
	OBJ_DATA *first, *second;
	CHAR_DATA *vict, *vict_next;
	char buf1[MSL], buf2[MSL];
	/*int total = 1, rbi=0,  raceplus = 0; */
	int i=0, skill = 0;
	bool focus = FALSE;
	bool attemptedfocus = FALSE;

	if (IS_NPC(ch))
		return;

	if (IS_SET(ch->op_flags, OP_CHANNELER ))
		return;

	if (get_skill(ch, gsn_hurricane) < 1)
	{
		stc("You spin in a circle, then fall down, dizzy.\n\r", ch);
		act("$n spins in a circle, then falls down, dizzy and embarassed.\n\r",ch,0,0,TO_ROOM);
		return;
	}
	first = get_eq_char (ch, WEAR_WIELD);
	second = get_eq_char (ch, WEAR_SECONDARY);
	if (first == NULL)
	{
		stc("You should wield a primary weapon.\n\r", ch);
		return;
	}

        if ( ch->in_room->area->file_name != NULL && !str_cmp( ch->in_room->area->file_name, "school.are" ) )                                                                                                                                
        {                                                                                                                                                                                                                                                    stc("It would be most cowardly to kill in such a way in this place.\n\r",ch);                                                                                                                                                                return;                                                                                                                                                                                                                              }

	if (second == NULL)
	{
		sprintf(buf1, "%s grips %s and starts to whirl like a hurricane!", ch->name, first->short_descr);
		sprintf(buf2, "You grip %s and start to whirl like a hurricane!", first->short_descr);
	}
	else
	{
		sprintf(buf1, "%s grips %s and %s, and starts to whirl like a hurricane!", ch->name, first->short_descr, second->short_descr);
		sprintf(buf2, "You grip %s and %s, and start to whirl like a hurricane!", first->short_descr, second->short_descr);
	}

	/*how many hits?*/
#if 0
	if (get_skill( ch, gsn_second_attack ) >= number_range(0,100))
	{
		total += 1;
		if (get_skill( ch, gsn_third_attack ) >= number_range(0,100))
			total += 1;
	}
	total *= 10; /*this way I can add 'half' attacks*/

	rbi = ch->pcdata->rebirth;
	if (rbi > 250)
		total *= 2;
	else if (rbi > 175)
		total += 25;
	else if (rbi > 100)
		total += 20;
	else if (rbi > 50)
		total += 15;
	else if (rbi > 10)
		total += 10;
	else if (rbi > 5)
		total += 5;

	total += ch->level/20;

	if (ch->race == race_lookup("ogier") || ch->race == race_lookup("trolloc"))
		{total *= 15/10;raceplus = 1;}
	else if (ch->race == race_lookup("nym")) /*Bigger folks = more inertion (easier to keep turning)*/
		{total *= 2;raceplus = 2;}
	else if (ch->race == race_lookup("fade") || ch->race == race_lookup("aiel")) /*fast guys*/
		{total += 10;raceplus = 1;}


	if (second != NULL && get_skill(ch, gsn_dual) >= number_range(0,200))
		total *= 2;

	total *= 2; /* for hurricane, tornado is 'standard'*/
#endif
	if ( argument[0] != '\0' && !str_prefix(argument,"focus")  )
	{
		if (!(skill = get_skill(ch, gsn_focus)))
				stc("You don't know the first thing about focussing attacks.\n\r",ch);
		else
		{
			attemptedfocus = TRUE;
			if (	skill >= number_range(0,100)) /*focus*/
			{
				focus = TRUE;
				stc("You focus your attacks.\n\r",ch);
			}
		}
	}
/*	focus = TRUE;	 Disables area attacks for now */
	if (focus == TRUE)
	{
		if (!is_fighting(ch))
		{
			stc("Start a fight before trying this!\n\r", ch);
			return;
		}
		check_improve (ch, gsn_focus, TRUE, 9 );
		vict = ch->advancing_on;
		act (buf2 , ch, NULL, NULL, TO_CHAR);
		act(buf1 , ch, NULL, NULL, TO_ROOM);
/*		total /= 10;
		if(total < 1)
			total = 1;
*/
		act("$n whirls towards you like a raging hurricane!",ch,0,ch->advancing_on,TO_VICT);
/*
		for (i=0; i < total && ch->advancing_on != NULL && ch->advancing_on->position != POS_DEAD; i++)
		{
			if (get_skill( ch, gsn_hurricane ) > number_range(0,100) + (i * 2))
				one_hit (ch,ch->advancing_on,gsn_hurricane,TRUE);
		}
*/
		one_hit (ch,vict,gsn_hurricane,TRUE);
                if (second != NULL)
                        one_hit (ch,vict,gsn_hurricane,TRUE);
                if ( get_skill( ch, gsn_second_attack ) != 0 )
                       one_hit (ch,vict,gsn_hurricane,TRUE);
                if ( get_skill( ch, gsn_third_attack ) != 0 )
                       one_hit (ch,vict,gsn_hurricane,TRUE);
                if (!( get_skill( ch, gsn_second_attack ) == 0 && second != NULL ))
                        one_hit (ch,vict,gsn_hurricane,TRUE);
                if (!( get_skill( ch, gsn_third_attack ) == 0 && second != NULL ))
                        one_hit (ch,vict,gsn_hurricane,TRUE);

		/* extra lag for focussed attacks --Sil */
		WAIT_STATE (ch, skill_table[gsn_whirlwind].beats );
		WAIT_STATE (ch, skill_table[gsn_hurricane].beats  );
		check_improve (ch, gsn_hurricane, TRUE, 9);
		return;
	}
	else
	{
		int round = 0; /* int totrounds = 0; */
		bool gotVict = FALSE;
		bool found = FALSE;

		if ( attemptedfocus )
			stc ("You try to focus your attacks, but fail.\n\r", ch);
/*
		totrounds = total / 25;
		total /= 10;
		if(total < 1)
			total = 1;

		for (vict = ch->in_room->people; (i <= total) && (round <= totrounds); vict = vict->next_in_room)  */
		for (vict = ch->in_room->people; vict && i < 3 && round < 3; vict = vict_next)
		{
			vict_next = vict->next_in_room;
			if (vict == NULL)
			{
				vict = ch->in_room->people;
				round++;
				if (vict == NULL)
				{
					stc("Your victims fleed misteriously :(\n\r", ch);
					return;
				}
			}
			if (vict == ch)
				continue;
			if (check_fighting( ch, vict ))
				gotVict = TRUE;
			else if (round == 0 && start_extra_fight(ch, vict, RANGE_MELEE))
				gotVict = TRUE;
			else
				continue;

			if (!gotVict)
				continue;

			if (vict->position == POS_DEAD)
				continue;

			/*
			if (!(get_skill( ch, gsn_hurricane ) > number_range(0,100) + (i * 2)))
				continue;
			*/
			if (!found)
			{
				found = TRUE;
				act (buf2 , ch, NULL, NULL, TO_CHAR);
				act(buf1 , ch, NULL, NULL, TO_ROOM);
			}

			if (round == 0)
			{
				act("$n whirls towards you like a raging hurricane!",ch,0,vict,TO_VICT);
				check_improve (ch, gsn_hurricane, TRUE, 9 );
			}
			i++;
			one_hit (ch,vict,gsn_hurricane,TRUE);
			WAIT_STATE (ch, skill_table[gsn_hurricane].beats  ); /*the one with extra hits take longer to stop spinning*/
		}
		if (!found)
		{
			act ("$n looks dizzy, and a bit embarrassed.", ch, NULL, NULL, TO_ROOM);
			act ("You feel dizzy.. and very embarrassed.", ch, NULL, NULL, TO_CHAR);
			check_improve (ch, gsn_hurricane, FALSE, 5);
			/* this allows to spam hurricane, but it still lags them . . . */
		}
		else if ( attemptedfocus )
			check_improve (ch, gsn_focus, FALSE, 9 );
		WAIT_STATE (ch, skill_table[gsn_hurricane].beats ); /*the one with extra hits take longer to stop spinning*/
		return;
	}
}

void do_whirlwind(CHAR_DATA *ch, char *argument)
{
	OBJ_DATA *first, *second;
	CHAR_DATA *vict, *vict_next;
	char buf1[MSL], buf2[MSL];
	/*int total = 1, rbi=0,  raceplus = 0; */
	int i=0, skill = 0;
	bool focus = FALSE;
	bool attemptedfocus = FALSE;

	if (IS_NPC(ch))
		return;
	if (get_skill(ch, gsn_whirlwind) < 1)
	{
		stc("You spin in a circle, then fall down, dizzy.\n\r", ch);
		act("$n spins in a circle, then falls down, dizzy and embarassed.\n\r",ch,0,0,TO_ROOM);
		return;
	}
	first = get_eq_char (ch, WEAR_WIELD);
	second = get_eq_char (ch, WEAR_SECONDARY);
	if (first == NULL)
	{
		stc("You should wield a primary weapon.\n\r", ch);
		return;
	}

	if ( ch->in_room->area->file_name != NULL && !str_cmp( ch->in_room->area->file_name, "school.are" ) )
	{
		stc("It would be most cowardly to kill in such a way in this place.\n\r",ch);
		return;
	}
	/*messages*/
	if (second == NULL)
	{
		sprintf(buf1, "%s grips %s and starts to whirl like a whirlwind!", ch->name, first->short_descr);
		sprintf(buf2, "You grip %s and start to whirl like a whirlwind!", first->short_descr);
	}
	else
	{
		sprintf(buf1, "%s grips %s and %s, and starts to whirl like a whirlwind!", ch->name, first->short_descr, second->short_descr);
		sprintf(buf2, "You grip %s and %s, and start to whirl like a whirlwind!", first->short_descr, second->short_descr);
	}

	/*how many hits?*/
#if 0
	if (get_skill( ch, gsn_second_attack ) >= number_range(0,100))
	{
		total += 1;
		if (get_skill( ch, gsn_third_attack ) >= number_range(0,100))
			total += 1;
	}
	total *= 10; /*this way I can add 'half' attacks*/

	rbi = ch->pcdata->rebirth;
	if (rbi > 250)
		total *= 2;
	else if (rbi > 175)
		total += 25;
	else if (rbi > 100)
		total += 20;
	else if (rbi > 50)
		total += 15;
	else if (rbi > 10)
		total += 10;
	else if (rbi > 5)
		total += 5;

	total += ch->level/20;

	if (ch->race == race_lookup("ogier") || ch->race == race_lookup("trolloc"))
		{total *= 15/10;raceplus = 1;}
	else if (ch->race == race_lookup("nym")) /*Bigger folks = more inertion (easier to keep turning)*/
		{total *= 2;raceplus = 2;}
	else if (ch->race == race_lookup("fade") || ch->race == race_lookup("aiel")) /*fast guys*/
		{total += 10;raceplus = 1;}


	if (second != NULL && get_skill(ch, gsn_dual) >= number_range(0,200))
		total *= 2;

	total /= 2; /* for whirlwind, tornado is 'standard'*/
#endif
	if ( argument[0] != '\0' && !str_prefix(argument,"focus")  )
	{
		if (!(skill = get_skill(ch, gsn_focus)) || IS_SET(ch->op_flags, OP_CHANNELER))
				stc("You don't know the first thing about focussing attacks.\n\r",ch);
		else
		{
			attemptedfocus = TRUE;
			if (	skill >= number_range(0,100)) /*focus*/
			{
				focus = TRUE;
				stc("You focus your attacks.\n\r",ch);
			}
		}
	}
/*	focus = TRUE;	 Disables area attacks for now */
	if (focus == TRUE)
	{
		if (!is_fighting(ch))
		{
			stc("Start a fight before trying this!\n\r", ch);
			return;
		}
		check_improve (ch, gsn_focus, TRUE, 9 );
		vict = ch->advancing_on;
		act (buf2 , ch, NULL, NULL, TO_CHAR);
		act(buf1 , ch, NULL, NULL, TO_ROOM);
/*		total /= 10;
		if(total < 1)
			total = 1;
*/
		act("$n whirls towards you!",ch,0,ch->advancing_on,TO_VICT);
/*
		for (i=0; i < total && ch->advancing_on != NULL && ch->advancing_on->position != POS_DEAD; i++)
		{
			if (get_skill( ch, gsn_whirlwind ) > number_range(0,100) + (i * 2))
				one_hit (ch,ch->advancing_on,gsn_whirlwind,TRUE);
		}
*/
		one_hit (ch,vict,gsn_whirlwind,TRUE);
                if (second != NULL)
                        one_hit (ch,vict,gsn_whirlwind,TRUE);


		WAIT_STATE (ch, skill_table[gsn_whirlwind].beats );
		check_improve (ch, gsn_whirlwind, TRUE, 9 );
		return;
	}
	else
	{
		int round = 0; /* int totrounds = 0; */
		bool gotVict = FALSE;
		bool found = FALSE;
		if ( attemptedfocus )
			stc ("You try to focus your attacks, but fail.\n\r", ch);

/*
		totrounds = total / 25;
		total /= 10;
*/
		for (vict = ch->in_room->people; vict && i < 3 && round < 3; vict = vict_next)
		{
			vict_next = vict->next_in_room;


			if (vict == NULL)
			{
				vict = ch->in_room->people;
				round++;
				if (vict == NULL)
				{
					stc("Your victims fleed misteriously :(\n\r", ch);
					return;
				}
			}

			if (vict == ch)
				continue;
			if (check_fighting( ch, vict ))
				gotVict = TRUE;
			else if (round == 0 && start_extra_fight(ch, vict, RANGE_MELEE))
				gotVict = TRUE;
			else
				continue;

			if (!gotVict)
				continue;

			if (vict->position == POS_DEAD)
				continue;

			i++;
/*			if (!(get_skill( ch, gsn_whirlwind ) > number_range(0,100) + (i * 2)))
				continue;
*/
			if (!found)
			{
				found = TRUE;
				act (buf2 , ch, NULL, NULL, TO_CHAR);
				act(buf1 , ch, NULL, NULL, TO_ROOM);
			}

			if (round == 0)
			{
				act("$n whirls towards you!",ch,0,vict,TO_VICT);
				check_improve (ch, gsn_whirlwind, TRUE, 9 );
			}
			if( (i==1) || (i==2 && (number_percent() > 50)) || (i==3 && (number_percent() > 66) ) )
				one_hit (ch,vict,gsn_whirlwind,TRUE);
			WAIT_STATE (ch, skill_table[gsn_whirlwind].beats ); /*the one with extra hits take longer to stop spinning*/
		}
		if (!found)
		{
			act ("$n looks dizzy, and a bit embarrassed.", ch, NULL, NULL, TO_ROOM);
			act ("You feel dizzy.. and very embarrassed.", ch, NULL, NULL, TO_CHAR);
			check_improve (ch, gsn_whirlwind, FALSE, 5);
		}
		else if ( attemptedfocus )
		{
			check_improve (ch, gsn_focus, FALSE, 9 );
		}
		WAIT_STATE (ch, skill_table[gsn_whirlwind].beats ); /*the one with extra hits take longer to stop spinning*/
		return;
	}
}
