/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"

int calc_remort_tier(CHAR_DATA *ch);

sh_int  gsn_forage;
sh_int  gsn_fear;
sh_int  gsn_smelting;
sh_int  gsn_adorn;
sh_int  gsn_sew;
sh_int  gsn_stitch;
sh_int  gsn_hem;
sh_int  gsn_unarm_traps;
sh_int  gsn_fletching;
sh_int  gsn_archery;
sh_int  gsn_knit_flesh;
sh_int  gsn_instrument;
sh_int  gsn_rush;
sh_int  gsn_tailor;
sh_int  gsn_tornado;
sh_int  gsn_hurricane;
sh_int  gsn_focus;
sh_int  gsn_scan;
sh_int  gsn_far_sight;
sh_int  gsn_bandage;
sh_int  gsn_music_merriment;
sh_int  gsn_music_serenade;
sh_int  gsn_assassinate;
sh_int  gsn_music_confidence;
sh_int  gsn_anticipate;
sh_int  gsn_precision;
sh_int  gsn_efficient;
sh_int  gsn_gifted;
sh_int  gsn_windfall;
sh_int  gsn_evaluate;
sh_int  gsn_intimidate;
sh_int  gsn_disguise;
sh_int  gsn_bloodlust;
sh_int  gsn_bribery;
sh_int  gsn_angrealstudy;
sh_int  gsn_engraving;
sh_int  gsn_balancing;
sh_int  gsn_truesense;
sh_int  gsn_feint;
sh_int  gsn_lunge;
sh_int  gsn_sweep;
sh_int  gsn_stagger;
sh_int  gsn_shieldbash;
sh_int  gsn_swordbreak;
sh_int  gsn_shieldbreak;
sh_int  gsn_chop;
sh_int  gsn_drawback;
sh_int  gsn_dismember;
sh_int  gsn_ravage;
sh_int          gsn_forge;
sh_int          gsn_camping;
sh_int          gsn_woodcraft;
sh_int          gsn_music_inspiration;
sh_int          gsn_music_courage;
sh_int          gsn_advanced_rescue;
sh_int          gsn_advanced_rescue;
sh_int          gsn_rage;
sh_int          gsn_battlecry;
sh_int          gsn_swim;
sh_int          gsn_speardance;
sh_int          gsn_charge;
sh_int          gsn_infuse;
sh_int          gsn_shadow_pass;
sh_int          gsn_tracking;
sh_int  		gsn_riding;
sh_int			gsn_backstab;
sh_int          gsn_jewelcraft;
sh_int          gsn_treesing;
sh_int			gsn_circle;
sh_int          gsn_demand;
sh_int          gsn_drag;
sh_int          gsn_brew;
sh_int 		gsn_herbalknowledge;
sh_int 		gsn_headache;
sh_int 		gsn_stomachache;
sh_int 		gsn_fever;
sh_int          gsn_sharpen;
sh_int          gsn_repair;
sh_int          gsn_reinforce;
sh_int          gsn_enhance;
sh_int			gsn_climb;
sh_int          gsn_veil;
sh_int          gsn_tail;
sh_int          gsn_whirlwind;
sh_int          gsn_search;
sh_int			gsn_dodge;
sh_int			gsn_envenom;
sh_int			gsn_hide;
sh_int			gsn_peek;
sh_int			gsn_pick_lock;
sh_int			gsn_sneak;
sh_int			gsn_steal;

sh_int			gsn_disarm;
sh_int			gsn_enhanced_damage;
sh_int			gsn_kick;
sh_int			gsn_punch;
sh_int			gsn_sidekick;
sh_int			gsn_jumpkick;
sh_int			gsn_leapkick;
sh_int			gsn_headbutt;
sh_int			gsn_elbow;
sh_int			gsn_knee;
sh_int			gsn_legsweep;
sh_int			gsn_hookkick;
sh_int			gsn_parry;
sh_int			gsn_rescue;
sh_int			gsn_tank;
sh_int			gsn_second_attack;
sh_int			gsn_third_attack;

sh_int			gsn_blindness;
sh_int			gsn_charm_person;
sh_int			gsn_curse;
sh_int			gsn_invis;
sh_int			gsn_mass_invis;
sh_int			gsn_poison;
sh_int			gsn_plague;
sh_int			gsn_sleep;
sh_int			gsn_sanctuary;
sh_int			gsn_fly;
sh_int          gsn_burn;
sh_int          gsn_glow;
/* new gsns */

sh_int  		gsn_axe;
sh_int  		gsn_dagger;
sh_int  		gsn_flail;
sh_int  		gsn_mace;
sh_int  		gsn_polearm;
sh_int			gsn_shield_block;
sh_int  		gsn_spear;
sh_int  		gsn_staff;
sh_int  		gsn_sword;
sh_int  		gsn_whip;
sh_int          gsn_bow;
sh_int  gsn_net;
sh_int  gsn_hammer;
sh_int  gsn_sling;
sh_int  gsn_swordbreaker;
sh_int  gsn_sap;
sh_int  gsn_shortsword;
sh_int  gsn_lance;
sh_int  gsn_ashandarei;

sh_int  		gsn_bash;
sh_int  		gsn_berserk;
sh_int          gsn_counter;
sh_int  		gsn_dirt;
sh_int  		gsn_hand_to_hand;
sh_int  		gsn_trip;

sh_int  		gsn_fast_healing;
sh_int  		gsn_haggle;
sh_int  		gsn_lore;
sh_int  		gsn_meditation;

sh_int  		gsn_scrolls;
sh_int  		gsn_staves;
sh_int          gsn_teach;
sh_int  		gsn_wands;
sh_int  		gsn_recall;
sh_int          gsn_butcher;
sh_int          gsn_skin;
sh_int          gsn_throw;
sh_int          gsn_strangle;
sh_int          gsn_blackjack;
sh_int          gsn_treat;
sh_int          gsn_void;
sh_int          gsn_sweepkick;
sh_int          gsn_spinkick;
sh_int          gsn_claw;
sh_int          gsn_bite;
sh_int          gsn_dual;
/* stances */
sh_int          gsn_heron;
sh_int          gsn_bird;
sh_int          gsn_wind;
sh_int          gsn_water;
sh_int          gsn_stone;
sh_int          gsn_animal;
sh_int          gsn_sky;
sh_int          gsn_cat;
sh_int          gsn_storm;
sh_int          gsn_lizard;
sh_int          gsn_boar;
sh_int          gsn_elemental;
sh_int          gsn_will;
sh_int          gsn_fire;
sh_int          gsn_ice;
sh_int          gsn_spirit;
sh_int          gsn_crown;
sh_int          gsn_circle;

/* end stances */

/* spearforms */
sh_int gsn_eagle;
sh_int gsn_capar;
sh_int gsn_gara;
sh_int gsn_hare;
sh_int gsn_snake;
sh_int gsn_ji;
sh_int gsn_sand;
sh_int gsn_ridgecat;
sh_int gsn_lion;
sh_int gsn_dream;
sh_int gsn_shadow;
sh_int gsn_wrath;
sh_int gsn_mystic;
sh_int gsn_ring;
sh_int gsn_earth;
sh_int gsn_balance;
sh_int gsn_dance;

/* end spearforms */
sh_int          gsn_engage;
sh_int          gsn_grip;

int clan_lookup args(( const char *name ));



bool sk_inactive (int sn)
{
	if (sn == skill_lookup("animal"))	return TRUE;
	if (sn == skill_lookup("recall"))	return TRUE;
	if (sn == skill_lookup("reserved"))	return TRUE;
	if (sn == skill_lookup("tailor"))	return TRUE;
	if (sn == skill_lookup("infuse"))	return TRUE;
	if (sn == skill_lookup("fletching"))	return TRUE;
	if (sn == skill_lookup("hem"))		return TRUE;

	return FALSE;
}

bool can_gain_sk (CHAR_DATA *ch, int sn)
{
	if (IS_IMMORTAL(ch))	return TRUE;
	if (sk_inactive(sn))	return FALSE;

	if (IS_SET(ch->op_flags, OP_CHANNELER))
	{
		if (sn == skill_lookup("bandage"))	return FALSE;
		if (sn == skill_lookup("tornado"))	return FALSE;
		if (sn == skill_lookup("hurricane"))	return FALSE;
	}
	else if (skill_table[sn].spell_fun != spell_null)	return FALSE;

	if (ch->race == race_lookup("aiel")
	||  ch->race == race_lookup("trolloc")
	||  ch->race == race_lookup("ogier"))
	{
		if (sn == skill_lookup("heron"))	return FALSE;
		if (sn == skill_lookup("wind"))		return FALSE;
		if (sn == skill_lookup("water"))	return FALSE;
		if (sn == skill_lookup("sky"))		return FALSE;
		if (sn == skill_lookup("stone"))	return FALSE;
		if (sn == skill_lookup("storm"))	return FALSE;
		if (sn == skill_lookup("lizard"))	return FALSE;
		if (sn == skill_lookup("boar"))		return FALSE;
		if (sn == skill_lookup("bird"))		return FALSE;
		if (sn == skill_lookup("cat"))		return FALSE;
		if (sn == skill_lookup("elemental"))	return FALSE;
		if (sn == skill_lookup("will"))		return FALSE;
		if (sn == skill_lookup("fire"))		return FALSE;
		if (sn == skill_lookup("ice"))		return FALSE;
		if (sn == skill_lookup("spirit"))	return FALSE;
		if (sn == skill_lookup("circle"))	return FALSE;
		if (sn == skill_lookup("crown"))	return FALSE;
	}

	if (ch->race != race_lookup("aiel"))
	{
		if (sn == skill_lookup("eagle"))	return FALSE;
		if (sn == skill_lookup("capar"))	return FALSE;
		if (sn == skill_lookup("gara"))		return FALSE;
		if (sn == skill_lookup("hare"))		return FALSE;
		if (sn == skill_lookup("snake"))	return FALSE;
		if (sn == skill_lookup("ji"))		return FALSE;
		if (sn == skill_lookup("sand"))		return FALSE;
		if (sn == skill_lookup("ridgecat"))	return FALSE;
		if (sn == skill_lookup("lion"))		return FALSE;
		if (sn == skill_lookup("dream"))	return FALSE;
		if (sn == skill_lookup("shadow"))	return FALSE;
		if (sn == skill_lookup("wrath"))	return FALSE;
		if (sn == skill_lookup("mystic"))	return FALSE;
		if (sn == skill_lookup("ring"))		return FALSE;
		if (sn == skill_lookup("earth"))	return FALSE;
		if (sn == skill_lookup("balance"))	return FALSE;
		if (sn == skill_lookup("dance"))	return FALSE;
		if (sn == skill_lookup("speardance"))	return FALSE;
	}

	if (sn == skill_lookup("ashandarei")
	&& ch->clan != clan_lookup("bandredhand")
	&& ch->clan != clan_lookup("bandcavalry"))	return FALSE;

	if (sn == skill_lookup("instrument")
	&& ch->clan != clan_lookup("gleeman"))		return FALSE;

	if (sn == skill_lookup("treesing")
	&& ch->race != race_lookup("ogier"))		return FALSE;

	if (sn == skill_lookup("fear")
	&& ch->race != race_lookup("fade"))		return FALSE;

	return TRUE;
}






void check_for_skills( CHAR_DATA *ch, int sn )
{
	int tn, cnt = 0;
	char skbuf[MSL];

	skbuf[0] = '\0';
        for ( tn = 0; tn < MAX_SKILL; tn++ )
        {
                if ( skill_table[tn].name == NULL )
                        break;

                if (skill_table[tn].req_skill &&  !str_cmp( skill_table[tn].req_skill, skill_table[sn].name ) )
                {
			if ( cnt > 0 )
				strcat( skbuf, ", " );

			cnt++;
			strcat( skbuf, skill_table[tn].name );
                        //ptc( ch, "{yYou can now gain the {Y%s{y skill!{x\n\r", skill_table[tn].name );
		}
	}
	if ( cnt > 0 )
	{
		ptc( ch, "{yYou can now gain {Y%s{y.{x\n\r", cnt > 1 ? "s" : "", skbuf );
	}
	return;
}

void do_tree( CHAR_DATA *ch, char *argument )
{
	int sn, tn, en;
	char arg[MIL];

	argument = one_argument( argument, arg );

	if ( arg[0] == '\0' )
	{
		stc("Syntax: tree <skillname>\n\r", ch);
		return;
	}
	if ( ( sn = skill_lookup( arg ) )  < 0 )
	{
		stc("No such skill.\n\r", ch);
		return;
	}
	if ( skill_table[sn].spell_fun != spell_null )
	{
		stc("This only works on skills.\n\r", ch);
		return;
	}

	ptc( ch, "{w.{B----> {wTree view for %s{x\n\r", skill_table[sn].name );

	for ( tn = 0; tn < MAX_SKILL; tn++ )
	{
		if ( skill_table[tn].name == NULL )
			break;

		if (skill_table[tn].req_skill &&  !str_cmp( skill_table[tn].req_skill, skill_table[sn].name ) )
		{
			ptc( ch, "   {w.{B-> {w%s{x\n\r", skill_table[tn].name );
			for ( en = 0; en < MAX_SKILL; en++ )
			{
				if ( skill_table[en].name == NULL )
					break;

				if (skill_table[en].req_skill &&  !str_cmp( skill_table[en].req_skill, skill_table[tn].name ) )
					ptc( ch, "   {w.{B----> {w%s{x\n\r", skill_table[en].name );
			}
		}
	}
}
void reset_learning( CHAR_DATA *ch )
{
	CHAR_DATA *teacher;

	if ( ch == NULL )
		return;

	if ( IS_NPC( ch ) )
		return;

	if ( ch->pcdata->learning_skill > 0 )
		ch->pcdata->learning_skill = 0;

	if ( (teacher = ch->pcdata->learning_from) != NULL )
	{
		ch->pcdata->learning_from = NULL;
		stc("Your student has stopped learning from you.\n\r", teacher);
		reset_teaching(teacher);
	}

	return;
}

void reset_teaching( CHAR_DATA *ch )
{
	CHAR_DATA *student;

	if ( ch == NULL )
		return;

	if ( IS_NPC( ch ) )
		return;

	if ( ch->pcdata->teaching_skill > 0 )
		ch->pcdata->teaching_skill = 0;

	if ( (student = ch->pcdata->teaching) != NULL )
	{
		ch->pcdata->teaching = NULL;
		stc("Your teacher has stopped teaching you.\n\r", student);
		reset_learning(student);
	}

	return;
}

void do_learn(CHAR_DATA *ch, char *argument)
{
	/* learn function allows a person to request to learn a skill from
	 * another person, or to verify learning when taught.
	 * learn from <char>
	 */
	char arg1[MSL];
	char arg2[MSL];
	CHAR_DATA *teacher = NULL;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if (IS_NPC(ch))	return;

	if (arg1[0] != '\0' && !str_cmp(arg1, "stop"))
	{
//		stc("You are no longer learning anything to anyone.\n\r", ch);
		reset_learning(ch);
		return;
	}

	if ( arg1[0] == '\0' || arg2[0] == '\0' || str_cmp( arg1, "from" ) )
	{
		if (ch->pcdata->learning_from)
		{
			ptc(ch, "You are currently learning %s from %s.\n\r", skill_table[ch->pcdata->learning_skill].name, ch->pcdata->learning_from->name);
			ptc(ch, "Your %s skill: %d%%.  Thier skill: %d%%.\n\r",
			skill_table[ch->pcdata->learning_skill].name,
			ch->pcdata->learned[ch->pcdata->learning_skill],
			ch->pcdata->learning_from->pcdata->learned[ch->pcdata->learning_skill]);
			stc("Type 'learn stop' to stop teaching.\n\r", ch);
			return;
		}
		else
		{
			stc( "Syntax: learn from <person name>\n\r", ch );
			reset_learning( ch );
			return;
		}

	}

	if ((teacher = get_char_room(ch, NULL, arg2)) == NULL)
	{
		stc("Learn from whom?\n\r", ch);
		return;
	}

	if ( teacher == ch )
	{
		stc( "You can't teach yourself. Try using the skill instead.\n\r", ch );
		return;
	}

	if ( teacher->pcdata->teaching == NULL )
	{
		stc("Ask them to teach you if you want to learn from them.\n\r",ch);
		return;
	}

	/* is the student requesting to learn a skill from a teacher?
	if ( ch->pcdata->learning_from == NULL )
	{
		ptc( ch, "You ask %s if you may learn %s from %s.\n\r",
			teacher->name, skill_table[sn].name,
			teacher->sex == SEX_MALE ? "him" :
			teacher->sex == SEX_FEMALE ? "her" : "it" );
		ptc( teacher, "%s wishes to learn %s from you. Will you teach them?\n\r",
			ch->name, skill_table[sn].name );
		ptc( teacher, "If so, type teach %s to %s.\n\r",
			skill_table[sn].name, ch->name );
		ch->pcdata->learning_from = teacher;
		ch->pcdata->learning_skill = sn;
		return;
	}*/
	/* is the student responding to an offer from a teacher? */
	if ( teacher->pcdata->teaching == ch )
	{
		ch->pcdata->learning_from = teacher;
		ch->pcdata->learning_skill = teacher->pcdata->teaching_skill;

		ptc( teacher, "%s begins to learn %s from you.\n\r",
		ch->name, skill_table[ch->pcdata->learning_skill].name );
		ptc( ch, "You begin to learn %s from %s.\n\r",
		skill_table[ch->pcdata->learning_skill].name, teacher->name );
		return;
	}
	else if ( teacher->pcdata->teaching != NULL )
	{
		stc("They're already teaching someone.\n\r",ch);
		return;
	}
	else
	{
		stc("Something went wrong.\n\r", ch);
		return;
	}
	return;
}

void do_teach(CHAR_DATA *ch, char *argument)
{
	char arg1[MIL], arg2[MIL], arg3[MIL];
	CHAR_DATA *student;
	int sn=0;
	char buf[MSL];

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );

	student = ch->pcdata->teaching;

	if (arg1[0] != '\0' && !str_cmp(arg1, "stop"))
	{
//		stc("You are no longer teaching anything to anyone.\n\r", ch);
		reset_teaching(ch);
		return;
	}

	if ( arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0' || str_cmp( arg2, "to" ) )
	{
		if (student && !IS_NPC(student))
		{
			if (student->pcdata->learning_from == NULL)
			{
				ptc(ch, "You're waiting for %s to start learning %s from you.\n\r", student->name, skill_table[ch->pcdata->teaching_skill].name);
				stc("Type 'teach stop' to cancel.\n\r", ch);
				return;
			}

			ptc(ch, "You are currently teaching %s to %s.\n\r",
			skill_table[ch->pcdata->teaching_skill].name, student->name);
			ptc(ch, "Your %s skill: %d%%.  Thier skill: %d%%.\n\r",
			skill_table[ch->pcdata->teaching_skill].name,
			ch->pcdata->learned[ch->pcdata->teaching_skill],
			student->pcdata->learned[ch->pcdata->teaching_skill]);
			stc("Type 'teach stop' to stop teaching.\n\r", ch);
			return;
		}
		else
		{
			stc( "Syntax: teach <skill name> to <person name>\n\r", ch );
			return;
		}
	}
	if ( ( sn = skill_lookup( arg1 ) ) < 0 )
	{
		stc( "Which skill are you trying to teach?", ch );
		return;
	}

	if ( ( student = get_char_room( ch, NULL, arg3 ) ) == NULL )
	{
		stc("That person is not in the room with you.\n\r", ch);
		return;
	}

	if ( student == ch )
	{
		stc( "You can't teach yourself. Try using the skill instead.\n\r", ch );
		return;
	}
	if ( IS_NPC( student ) )
	{
		stc( "You can't teach npc's, no matter how much they want to learn.\n\r", ch );
		return;
	}

	if (student->pcdata->learned[sn] <= 0)
	{
		sprintf(buf, "%s %s", arg1, arg3);
		do_teach_old(ch, buf);
		return;
	}
	

	if (sn == gsn_teach)
	{
		stc("You can't teach this skill.\n\r", ch);
		return;
	}

	if ( get_skill( ch, gsn_teach ) <= 0 )
	{
		stc ("{cYou dont know how to teach!\n\r", ch);
		return;
	}

	if ( ch->pcdata->learned[sn] < student->pcdata->learned[sn] )
	{
		stc( "Maybe you should get them to teach you how to do that.\n\r", ch );
		return;
	}


	if ( student->pcdata->learning_from == NULL )
	{
		ptc( ch, "You offer to teach %s to %s.\n\r",
			skill_table[sn].name, student->name );
		ptc( student, "%s wishes to teach %s to you. Will you learn from them?\n\r",
			ch->name, skill_table[sn].name );
		ptc( student, "If so, type learn from %s.\n\r", ch->name );
		ch->pcdata->teaching = student;
		ch->pcdata->teaching_skill = sn;
		return;
	}
	if ( student->pcdata->learning_from != NULL )
	{
		ptc( ch, "%s already has an offer for learning.\n\r",
			student->name );
		ptc( student, "%s offers to teach you %s, but you already have an offer from %s.\n\r",
			ch->name, skill_table[sn].name, student->pcdata->learning_from->name );
		return;
	}
	else
	{
		stc("Something went wrong.\n\r", ch);
		return;
	}
	return;
}

int get_train_cost ( CHAR_DATA *ch, int stat )
{
	int cost;

	if ( ch->perm_stat[stat] <= 5 )
		cost = 1;
	else
		cost = ch->perm_stat[stat] / 5;

	if ( stat == STAT_STR )
	    ptc( ch, "(%3d) Strength\n\r", cost );
	else if ( stat == STAT_DEX )
	    ptc( ch, "(%3d) Dexterity\n\r", cost );
	else if ( stat == STAT_REF )
	    ptc( ch, "(%3d) Reflex\n\r", cost );
	else if ( stat == STAT_CON )
	    ptc( ch, "(%3d) Constitution\n\r", cost );
	else if ( stat == STAT_INT )
	    ptc( ch, "(%3d) Intelligence\n\r", cost );
	else if ( stat == STAT_WIS )
	    ptc( ch, "(%3d) Wisdom\n\r", cost );
	else if ( stat == STAT_INS )
	    ptc( ch, "(%3d) Instinct\n\r", cost );
	else if ( stat == STAT_CHA )
	    ptc( ch, "(%3d) Charisma\n\r", cost );

	return cost;
}

void do_train( CHAR_DATA *ch, char *argument )
{
    char buf2[MSL];
    char arg1[MIL];
    char arg2[MIL];
    CHAR_DATA *mob;
    sh_int stat = - 1;
    char *pOutput = NULL;
    int cost = 1, mod = 1;
    int i=0, j=0;

    if ( IS_NPC(ch) )
	return;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

    for ( mob = ch->in_room->people; mob; mob = mob->next_in_room )
    {
	if ( IS_NPC(mob) && IS_SET(mob->act, ACT_TRAIN) )
	    break;
    }

    if ( mob == NULL )
    {
	send_to_char( "{cYou can't do that here.\n\r{c", ch );
	return;
    }

    if ( arg1[0] == '\0' )
    {
		ptc( ch, "{cYou have %d training sessions remaining to you.\n\r", ch->train );
		stc( "You may train multiple times at once: Ex: train hp 5\n\r",ch);
		stc( "You can train the following stats:\n\rCost  Stat\n\r----  ----\n\r",ch );

		get_train_cost(ch, STAT_STR);
		get_train_cost(ch, STAT_INT);
		get_train_cost(ch, STAT_WIS);
		get_train_cost(ch, STAT_DEX);
		get_train_cost(ch, STAT_CON);
		get_train_cost(ch, STAT_REF);
		get_train_cost(ch, STAT_INS);
		get_train_cost(ch, STAT_CHA);
		if ( ch->hit <= 999999 )
		{
			stc( "(  1) Hp\n\r",ch);
		}
		if ( ch->stam <= 999999 )
		{
			stc( "(  1) Stamina\n\r",ch);
		}

		return;
    }
    if ( arg2[0] == '\0' )
	    cost = 1;
	else if ( !is_number(arg2) || atoi(arg2) <= 0 )
	{
		stc("Only positive numerics are allowed.\n\r",ch);
		return;
	}
	else
	{
		cost *= atoi(arg2);
		mod = atoi(arg2);
	}
	if ( mod > 1000 )
	{
		stc("You can modify by a maximum of 1000 at a time.\n\r",ch);
		stc("Example: train hp 1000 will train 10,000 hit points for a cost of 100 trains.\n\r",ch);
		return;
	}
	if ( mod > 1 )
	{
		ptc( ch, "You are multiplying your train cost by %d.\n\r", cost );
	}

    if ( !str_prefix( arg1, "strength" ) ) {
		stat        = STAT_STR;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "strength";
    }
    else if ( !str_prefix( arg1, "intelligence" ) ) {
		stat	    = STAT_INT;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "intelligence";
    }
    else if ( !str_prefix( arg1, "wisdom" ) ) {
		stat	    = STAT_WIS;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "wisdom";
    }
    else if ( !str_prefix( arg1, "dexterity" ) ) {
		stat  	    = STAT_DEX;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "dexterity";
    }
    else if ( !str_prefix( arg1, "constitution" ) ) {
		stat	    = STAT_CON;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "constitution";
    }
    else if ( !str_prefix( arg1, "reflex" ) ) {
		stat	    = STAT_REF;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "reflex";
    }
    else if ( !str_prefix( arg1, "instinct" ) ) {
		stat	    = STAT_INS;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "instinct";
    }
    else if ( !str_prefix( arg1, "charisma" ) ) {
		stat	    = STAT_CHA;
		/*cost = get_train_cost(ch, stat) * cost;*/
		pOutput     = "charisma";
    }
    else if ( !str_prefix(arg1, "hp" ) ) {
		pOutput = "hit points";
	}

    else if ( !str_prefix(arg1, "stamina" ) ) {
		pOutput = "stamina points";
	}

    else
    {
		get_train_cost(ch, ch->perm_stat[STAT_STR] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_INT] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_WIS] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_DEX] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_CON] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_REF] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_INS] * cost);
		get_train_cost(ch, ch->perm_stat[STAT_CHA] * cost);
		if ( ch->hit <= 999999 )
		{ stc( "(  1) Hp\n\r",ch); }
		if ( ch->stam <= 999999 )
		{ stc( "(  1) Stamina\n\r",ch); }
		return;
    }

	if (stat != -1)
	{
		j=ch->perm_stat[stat];
		i=cost;
		cost = 0;
		for (;i != 0;i--)
		{
			if ( j <= 5 )
				cost += 1;
			else
				cost += j / 5;
			j++;
		}
	}

	if ( cost > ch->train )
	{
		send_to_char( "{cYou don't have enough training sessions.\n\r", ch );
		return;
	}

    if (!str_prefix(arg1,"hp"))
    {
		if (( ch->hit >= 999999 ))
		{
			send_to_char( "{cYou already have the max hit points allowed.\n\r",ch);
			return;
		}
		ch->train -= cost;
        ch->pcdata->perm_hit += 10 * mod;
        ch->max_hit += 10 * mod;
        ch->hit += 10 * mod;
        sprintf(buf2,
        "{w%s leads %s to an area dedicated to defining the body and increasing overall fitness. %s works diligently at the task until %s allows %s to stop.",
        mob->short_descr, ch->name, ch->name, mob->short_descr,
		ch->sex == SEX_MALE   ? "him" :
		ch->sex == SEX_FEMALE ? "her" : "it{c");
        act( "{c$t{c",ch,buf2,NULL,TO_CHAR);
        ptc( ch, "{cYour durability increases! You now have %d hit points!{c\n\r",ch->pcdata->perm_hit);
        return;
    }

    if (!str_prefix(arg1,"stamina"))
    {
        if (( ch->max_stam >= 1000000))
        {
        send_to_char( "{cYou already have the max stamina points allowed.\n\r",ch);
        return;
        }
		ch->train -= cost;
        ch->pcdata->perm_mana += 10 * mod;
        ch->max_stam += 10 * mod;
        ch->stam += 10 * mod;
        sprintf(buf2,
        "{w%s directs %s to a giant wheel and instructs %s to climb inside. %s keeps %s running inside the wheel for what seems an eternity, then suddenly, the training is over.",
        mob->short_descr, ch->name,
		ch->sex == SEX_MALE   ? "him" :
		ch->sex == SEX_FEMALE ? "her" : "it{c",
		mob->short_descr,ch->name);
        act( "{c$t{c",ch,buf2,NULL,TO_CHAR);
        ptc( ch, "{cYour stamina increases! You now have %d stamina points!{c\n\r",ch->pcdata->perm_mana);
        return;
    }

	if ( ch->perm_stat[stat] + mod >= get_max_train(ch, stat) )
    {
		act( "That would put your over the limit for your $T.", ch, NULL, pOutput, TO_CHAR );
		return;
    }

    if ( ch->perm_stat[stat] >= get_max_train(ch,stat) )
    {
		act( "{cYour $T is already at maximum.{c", ch, NULL, pOutput, TO_CHAR );
		return;
    }

    /*if ( cost > ch->train )
    {
		send_to_char( "{cYou don't have enough training sessions.\n\r{c", ch );
		return;
    }*/

    ch->train		-= cost;
    ch->perm_stat[stat]		+= mod;

    ptc( ch, "Your %s increases at a cost of %d trains.\n\r", pOutput, cost );
    act( "{c$n's $T increases!{c", ch, NULL, pOutput, TO_ROOM );
    return;
}
int sort_gain_skill_by_alpha(const void *askill, const void *bskill )
{
	struct sort_skill_struct aaskill;
	struct sort_skill_struct bbskill;
	aaskill = *(struct sort_skill_struct *) askill;
	bbskill = *(struct sort_skill_struct *) bskill;
	if (aaskill.weave && !bbskill.weave)
		return 1;
	else if (!aaskill.weave && bbskill.weave)
		return -1;
	else
	return strcmp(aaskill.name,bbskill.name);
}
/* used to get new skills */
void do_gain(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *trainer;
    int sn = 0, skReq = 0;
    bool canGain = FALSE, skillReq = FALSE;
    int req_earth, req_air, req_fire, req_water, req_spirit;
    int cost;

    if (IS_NPC(ch))
	return;

    /* find a trainer */
    for ( trainer = ch->in_room->people; trainer != NULL; trainer = trainer->next_in_room )
    {
		if (IS_NPC(trainer) && IS_SET(trainer->act,ACT_GAIN))
		    break;
	}

    if (trainer == NULL || !can_see(ch,trainer))
    {
	send_to_char( "{cYou can't do that here.\n\r",ch);
	return;
    }

    one_argument(argument,arg);

    if (arg[0] == '\0')
    {
	do_function(trainer, &do_say, "{cPardon me?");
	return;
    }

    if (!str_prefix(arg,"list"))
    {
	int col;
    	BUFFER *output;
	struct sort_skill_struct sort_skill[MAX_SKILL];
    	char buf2[MAX_STRING_LENGTH];
	int i;

    	output = new_buf();
	col = 0;
	i = 0;

        sprintf(buf, "%-15s %-15s%-4s %-15s %-15s%-4s\n\r", "skill","req","cost","skill","req","cost");
        add_buf(output,buf);

	for (sn = 0; sn < MAX_SKILL; sn++)
	{
		if (skill_table[sn].name == NULL)			break;
		if (skill_table[sn].remort_only > ch->pcdata->rebirth)	continue;
		if (!can_gain_sk(ch, sn))				continue;

		if (!ch->pcdata->learned[sn] && skill_table[sn].rating[ch->class] > 0)
		{
			int cl;
			sort_skill[i].name = skill_table[sn].name;
			sort_skill[i].req_skill = skill_table[sn].req_skill;
			sort_skill[i].rating = skill_table[sn].rating[ch->class];
			sort_skill[i].weave = ( skill_table[sn].spell_fun != spell_null);

			if((sort_skill[i].req_skill == NULL)||(sort_skill[i].req_skill == 0) ||( ( get_skill( ch, skill_lookup( sort_skill[i].req_skill )) ) > 84 ))
			{
				if (sort_skill[i].weave
				&& (ch->pcdata->op_earth < skill_table[sn].sphere_earth
				||  ch->pcdata->op_air < skill_table[sn].sphere_air
				||  ch->pcdata->op_fire < skill_table[sn].sphere_fire
				||  ch->pcdata->op_water < skill_table[sn].sphere_water
				||  ch->pcdata->op_spirit < skill_table[sn].sphere_spirit))
					cl = 1;
				else
					cl = 2;
			}
			else if (get_skill( ch, skill_lookup( sort_skill[i].req_skill ))  > 0)
				cl = 1;
			else
				cl = 0;

			sort_skill[i].can_learn = cl;
			i++;
		}
	}

	qsort(sort_skill,i,sizeof(struct sort_skill_struct),sort_gain_skill_by_alpha);

	for (sn=0; sn < i; sn++)
	{
		if (sort_skill[sn].can_learn == 2)	sprintf(buf2,"{g");
		else if (sort_skill[sn].can_learn == 1)	sprintf(buf2,"{y");
		else					sprintf(buf2,"{c");

		sprintf(buf,"%s%-15s %-15s {c%-4d", buf2, sort_skill[sn].name,
		sort_skill[sn].req_skill, sort_skill[sn].rating);
		add_buf(output,buf);

                if (++col % 2 == 0) add_buf(output, "{c\n\r");
        }

        if (col % 2 != 0) add_buf(output, "{c\n\r");
	page_to_char( buf_string(output), ch );
	free_buf(output);
	return;
    }

    sn = skill_lookup(argument);
    if (sn > -1)
    {
/*
	if (skill_table[sn].spell_fun != spell_null)
	{
	    act("{G$N tells you {g'{GI cannot teach you weaves.{g'{x",
		ch,NULL,trainer,TO_CHAR);
	    return;
	}
*/

	if (!can_gain_sk(ch, sn))
	{
		stc("What skill?\n\r", ch);
		return;
	}

        if (ch->pcdata->learned[sn])
        {
            act("{G$N tells you {g'{GYou already know that skill!{g'{G",
                ch,NULL,trainer,TO_CHAR);
            return;
        }

	cost = skill_table[sn].rating[ch->class];

  if ( skill_table[sn].spell_fun == spell_null )
  {
		/* Is there a valid required skill? If the req is
		 * 0 or NULL, the character can gain.
		 */
		if ( skill_table[sn].req_skill == NULL
		|| skill_table[sn].req_skill == 0 )
		{
			skillReq = FALSE;
			/*stc("You can gain this skill because the req 0 or NULL.\n\r",ch );*/
			canGain = TRUE;
		}
		/* Now check to make sure the req is a valid skill
		 * using skill_lookup
		 */
		if ( skill_table[sn].req_skill != NULL && !canGain )
		{
			skillReq = TRUE;
			if ( skill_table[sn].req_skill > 0 || skill_table[sn].req_skill != NULL )
			{
				skReq = skill_lookup(skill_table[sn].req_skill);
				canGain = TRUE;
			}
			if ( !str_cmp( skill_table[sn].req_skill, "reserved" ) )
				canGain = TRUE;
	//		ptc( ch, "skReq is %s.\n\rSkill_table says its %s.\n\r",
	//			skill_table[skReq].name, skill_table[sn].req_skill );
		}
		/*else if ( !skReq || !canGain )
		{
			stc("Something went wrong. You can't gain this skill.\n\r",ch );
			return;
		}*/
		if ( skillReq )
		{
			if ( get_skill( ch, skill_lookup( skill_table[sn].req_skill ) ) < 85 )
			{
				ptc(ch,"The %s skill is required at 85% before you can learn %s.\n\r",
					skill_table[skReq].name, skill_table[sn].name );
				return;
			}
		}

    if (skill_table[sn].rating[ch->class] <= 0)
    {
        act("{G$N tells you {g'{GThat skill is beyond your abilities.{g'{x",
            ch,NULL,trainer,TO_CHAR);
        return;
    }

    if (ch->train < cost)
    {
        act("{G$N tells you {g'{GYou do not have enough trains to purchase that skill.{g'{x",
            ch,NULL,trainer,TO_CHAR);
        return;
    }

		if ( skill_table[sn].remort_only > ch->pcdata->rebirth )
		{
			stc("You have not lived enough lives for this skill.\n\r",ch);
			return;
		}

		if (skill_table[sn].remort_only == TRUE
		&& ch->pcdata->rebirth < 1)
		{
			stc("You have not lived enough lives for this skill.\n\r",ch);
			return;
		}

        /* add the skill */
		ch->pcdata->learned[sn] = 1;
    act("$N trains you in the art of $t", ch,skill_table[sn].name,trainer,TO_CHAR);

    ch->train -= cost;
    return;
    }
  }
  if ( sn <= -1 )
  {
    stc("What skill?\n\r", ch);
    return;
  }

  if ( skill_table[sn].spell_fun != spell_null )
  {
/*
   		if ( skill_table[sn].remort_only > 0 )
		{
			stc("You can only learn non-remort weaves in this manner.\n\r",ch);
			return;
		}
*/
    if (ch->train < skill_table[sn].rating[ch->class])
    {
      act("{G$N tells you {g'{GYou do not have enough trains to purchase that skill.{g'{x",ch,NULL,trainer,TO_CHAR);
      return;
    }
	req_earth = skill_table[sn].sphere_earth;
	req_air = skill_table[sn].sphere_air;
	req_fire = skill_table[sn].sphere_fire;
	req_water = skill_table[sn].sphere_water;
	req_spirit = skill_table[sn].sphere_spirit;

	if ( ch->pcdata->op_earth < req_earth )
	{
		stc("You do not possess the required strength in Earth for this weave.\n\r", ch);
		return;
	}
	if ( ch->pcdata->op_air < req_air )
	{
		stc("You do not possess the required strength in Air for this weave.\n\r", ch);
		return;
	}
	if ( ch->pcdata->op_fire < req_fire )
	{
		stc("You do not possess the required strength in Fire for this weave.\n\r", ch);
		return;
	}
	if ( ch->pcdata->op_water < req_water )
	{
		stc("You do not possess the required strength in Water for this weave.\n\r", ch);
		return;
	}
	if ( ch->pcdata->op_spirit < req_spirit )
	{
		stc("You do not possess the required strength in Spirit for this weave.\n\r", ch);
		return;
	}
    /* add the weave */
		ch->pcdata->learned[sn] = 1;
    act("$N trains you in the art of $t", ch,skill_table[sn].name,trainer,TO_CHAR);
    ch->train -= cost;
    return;
  }

  act("{G$N tells you {g'{GI do not understand...{g'{x",ch,NULL,trainer,TO_CHAR);
}




/* RT spells and skills show the players spells (or skills) */

void do_spells(CHAR_DATA *ch, char *argument)
{
    BUFFER *buffer;
    char arg[MAX_INPUT_LENGTH];
    char spell_list[LEVEL_HERO + 1][MAX_STRING_LENGTH];
    char spell_columns[LEVEL_HERO + 1];
    int sn, level, min_lev = 1, max_lev = LEVEL_HERO, mana;
    bool fAll = FALSE, found = FALSE;
    char buf[MAX_STRING_LENGTH];

    if (IS_NPC(ch))
      return;

    if (argument[0] != '\0')
    {
	fAll = TRUE;

	if (str_prefix(argument,"all"))
	{
	    argument = one_argument(argument,arg);
	    if (!is_number(arg))
	    {
		send_to_char( "{cArguments must be numerical or all.\n\r",ch);
		return;
	    }
	    max_lev = atoi(arg);

	    if (max_lev < 1 || max_lev > LEVEL_HERO)
	    {
		sprintf(buf,"{cLevels must be between 1 and %d.\n\r",LEVEL_HERO);
		send_to_char(buf,ch);
		return;
	    }

	    if (argument[0] != '\0')
	    {
		argument = one_argument(argument,arg);
		if (!is_number(arg))
		{
		    send_to_char( "{cArguments must be numerical or all.\n\r",ch);
		    return;
		}
		min_lev = max_lev;
		max_lev = atoi(arg);

		if (max_lev < 1 || max_lev > LEVEL_HERO)
		{
		    sprintf(buf,
			"{cLevels must be between 1 and %d.\n\r",LEVEL_HERO);
		    send_to_char(buf,ch);
		    return;
		}

		if (min_lev > max_lev)
		{
		    send_to_char( "{cThat would be silly.\n\r",ch);
		    return;
		}
	    }
	}
    }


    /* initialize data */
    for (level = 0; level < LEVEL_HERO + 1; level++)
    {
        spell_columns[level] = 0;
        spell_list[level][0] = '\0';
    }

    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL )
	    break;

	if ((level = skill_table[sn].skill_level[ch->class]) < LEVEL_HERO + 1
	&&  (fAll || level <= ch->level)
	&&  level >= min_lev && level <= max_lev
	&&  skill_table[sn].spell_fun != spell_null
	&&  ch->pcdata->learned[sn] > 0)
        {
	    found = TRUE;
	    level = skill_table[sn].skill_level[ch->class];
	    if (ch->level < level)
	    	sprintf(buf,"{c%-18s n/a      ", skill_table[sn].name);
	    else
	    {
		mana = skill_table[sn].min_mana;
		    /*100/(2 + ch->level - level));*/
	        sprintf(buf,"{c%-18s  %3d mana  ",skill_table[sn].name,mana);
	    }

	    if (spell_list[level][0] == '\0')
          	sprintf(spell_list[level],"{c\n\rLevel %2d: %s",level,buf);
	    else /* append */
	    {
          	if ( ++spell_columns[level] % 2 == 0)
		    strcat(spell_list[level],"\n\r          ");
          	strcat(spell_list[level],buf);
	    }
	}
    }

    /* return results */

    if (!found)
    {
      	send_to_char( "{cNo weaves found.\n\r",ch);
      	return;
    }

    buffer = new_buf();
    for (level = 0; level < LEVEL_HERO + 1; level++)
      	if (spell_list[level][0] != '\0')
	    add_buf(buffer,spell_list[level]);
    add_buf(buffer,"\n\r");
    page_to_char(buf_string(buffer),ch);
    free_buf(buffer);
}

void do_skills(CHAR_DATA *ch, char *argument)
{
    BUFFER *buffer;
    char arg[MAX_INPUT_LENGTH];
    char skill_list[LEVEL_HERO + 1][MAX_STRING_LENGTH];
    char skill_columns[LEVEL_HERO + 1];
    int sn, level, min_lev = 1, max_lev = LEVEL_HERO;
    bool fAll = FALSE, found = FALSE;
    char buf[MAX_STRING_LENGTH];

    if (IS_NPC(ch))
      return;

    if (argument[0] != '\0')
    {
	fAll = TRUE;

	if (str_prefix(argument,"all"))
	{
	    argument = one_argument(argument,arg);
	    if (!is_number(arg))
	    {
		send_to_char( "{cArguments must be numerical or all.\n\r",ch);
		return;
	    }
	    max_lev = atoi(arg);

	    if (max_lev < 1 || max_lev > LEVEL_HERO)
	    {
		sprintf(buf,"{cLevels must be between 1 and %d.\n\r",LEVEL_HERO);
		send_to_char(buf,ch);
		return;
	    }

	    if (argument[0] != '\0')
	    {
		argument = one_argument(argument,arg);
		if (!is_number(arg))
		{
		    send_to_char( "{cArguments must be numerical or all.\n\r",ch);
		    return;
		}
		min_lev = max_lev;
		max_lev = atoi(arg);

		if (max_lev < 1 || max_lev > LEVEL_HERO)
		{
		    sprintf(buf,
			"{cLevels must be between 1 and %d.\n\r",LEVEL_HERO);
		    send_to_char(buf,ch);
		    return;
		}

		if (min_lev > max_lev)
		{
		    send_to_char( "{cThat would be silly.\n\r",ch);
		    return;
		}
	    }
	}
    }


    /* initialize data */
    for (level = 0; level < LEVEL_HERO + 1; level++)
    {
        skill_columns[level] = 0;
        skill_list[level][0] = '\0';
    }

    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL )
	    break;

	if (sn == skill_lookup("animal") || sn == skill_lookup("recall"))	continue;

	if ((level = skill_table[sn].skill_level[ch->class]) < LEVEL_HERO + 1
	&&  (fAll || level <= ch->level)
	&&  level >= min_lev && level <= max_lev
	&&  skill_table[sn].spell_fun == spell_null
	&&  ch->pcdata->learned[sn] > 0)
        {
	    found = TRUE;
	    level = skill_table[sn].skill_level[ch->class];
	    if (ch->level < level)
	    	sprintf(buf,"{c%-18s n/a      ", skill_table[sn].name);
	    else
	    	sprintf(buf,"{c%-18s %3d%%      ",skill_table[sn].name,
		    ch->pcdata->learned[sn]);

	    if (skill_list[level][0] == '\0')
          	sprintf(skill_list[level],"{c\n\rLevel %2d: %s",level,buf);
	    else /* append */
	    {
          	if ( ++skill_columns[level] % 2 == 0)
		    strcat(skill_list[level],"\n\r          ");
          	strcat(skill_list[level],buf);
	    }
	}
    }

    /* return results */

    if (!found)
    {
      	send_to_char( "{cNo skills found.\n\r",ch);
      	return;
    }

    buffer = new_buf();
    for (level = 0; level < LEVEL_HERO + 1; level++)
      	if (skill_list[level][0] != '\0')
	    add_buf(buffer,skill_list[level]);
    add_buf(buffer,"\n\r");
    page_to_char(buf_string(buffer),ch);
    free_buf(buffer);
}

/* shows skills, groups and costs (only if not bought) */
void list_group_costs(CHAR_DATA *ch)
{
    char buf[100];
    int gn,sn,col;

    if (IS_NPC(ch))
	return;

    col = 0;

    sprintf(buf,"{c%-18s %-5s %-18s %-5s %-18s %-5s\n\r","group","cp","group","cp","group","cp");
    send_to_char(buf,ch);

    for (gn = 0; gn < MAX_GROUP; gn++)
    {
	if (group_table[gn].name == NULL)
	    break;

        if (!ch->gen_data->group_chosen[gn]
	&&  !ch->pcdata->group_known[gn]
	&&  group_table[gn].rating[ch->class] > 0)
	{
	    sprintf(buf,"{c%-18s %-5d ",group_table[gn].name,
				    group_table[gn].rating[ch->class]);
	    send_to_char(buf,ch);
	    if (++col % 3 == 0)
		send_to_char( "{c\n\r",ch);
	}
    }
    if ( col % 3 != 0 )
        send_to_char( "\n\r", ch );
    send_to_char( "{c\n\r",ch);

    col = 0;

    sprintf(buf,"{c%-18s %-5s %-18s %-5s %-18s %-5s\n\r","skill","cp","skill","cp","skill","cp");
    send_to_char(buf,ch);

    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL)
            break;

        if (!ch->gen_data->skill_chosen[sn]
	&&  ch->pcdata->learned[sn] == 0
	&&  skill_table[sn].spell_fun == spell_null
	&&  skill_table[sn].rating[ch->class] > 0)
        {
            sprintf(buf,"{c%-18s %-5d ",skill_table[sn].name,
                                    skill_table[sn].rating[ch->class]);
            send_to_char(buf,ch);
            if (++col % 3 == 0)
                send_to_char( "{c\n\r",ch);
        }
    }
    if ( col % 3 != 0 )
        send_to_char( "\n\r", ch );
    send_to_char( "{c\n\r",ch);

    sprintf(buf,"{cCreation points: %d\n\r",ch->pcdata->points);
    send_to_char(buf,ch);
    sprintf(buf,"{cExperience per level: %d\n\r",
	    exp_per_level(ch,ch->gen_data->points_chosen));
    send_to_char(buf,ch);
    return;
}


void list_group_chosen(CHAR_DATA *ch)
{
    char buf[100];
    int gn,sn,col;

    if (IS_NPC(ch))
        return;

    col = 0;

    sprintf(buf,"{c%-18s %-5s %-18s %-5s %-18s %-5s","group","cp","group","cp","group","cp\n\r");
    send_to_char(buf,ch);

    for (gn = 0; gn < MAX_GROUP; gn++)
    {
        if (group_table[gn].name == NULL)
            break;

        if (ch->gen_data->group_chosen[gn]
	&&  group_table[gn].rating[ch->class] > 0)
        {
            sprintf(buf,"{c%-18s %-5d ",group_table[gn].name,
                                    group_table[gn].rating[ch->class]);
            send_to_char(buf,ch);
            if (++col % 3 == 0)
                send_to_char( "{c\n\r",ch);
        }
    }
    if ( col % 3 != 0 )
        send_to_char( "\n\r", ch );
    send_to_char( "{c\n\r",ch);

    col = 0;

    sprintf(buf,"{c%-18s %-5s %-18s %-5s %-18s %-5s","skill","cp","skill","cp","skill","cp\n\r");
    send_to_char(buf,ch);

    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL)
            break;

        if (ch->gen_data->skill_chosen[sn]
	&&  skill_table[sn].rating[ch->class] > 0)
        {
            sprintf(buf,"{c%-18s %-5d ",skill_table[sn].name,
                                    skill_table[sn].rating[ch->class]);
            send_to_char(buf,ch);
            if (++col % 3 == 0)
                send_to_char( "{c\n\r",ch);
        }
    }
    if ( col % 3 != 0 )
        send_to_char( "\n\r", ch );
    send_to_char( "{c\n\r",ch);

    sprintf(buf,"{cCreation points: %d\n\r",ch->gen_data->points_chosen);
    send_to_char(buf,ch);
    sprintf(buf,"{cExperience per level: %d\n\r",
	    exp_per_level(ch,ch->gen_data->points_chosen));
    send_to_char(buf,ch);
    return;
}

int exp_per_level(CHAR_DATA *ch, int points)
{
    int expl/*inc*/;

    if (IS_NPC(ch))
	return 1000;
#if 0
    expl = 1000;
    inc = 500;

/*
    if (points < 40)
	return 1000 * (pc_race_table[ch->race].class_mult[ch->class] ?
		       pc_race_table[ch->race].class_mult[ch->class]/100 : 1);

*/
    /* processing */
    points -= 40;

    while (points > 9)
    {
		expl += inc;
	        points -= 10;
	        if (points > 9)
		{
		    expl += inc;
		    inc *= 2;
		    points -= 10;
		}
    }

    expl += points * inc / 10;
#endif

    expl = 1000 + ( ch->pcdata->rebirth * 10 );

    /*return expl * pc_race_table[ch->race].class_mult[ch->class]/100;*/
    return expl;
}

/* this procedure handles the input parsing for the skill generator */
bool parse_gen_groups(CHAR_DATA *ch,char *argument)
{
    char arg[MAX_INPUT_LENGTH];
    char buf[100];
    int gn,sn,i;

    if (argument[0] == '\0')
	return FALSE;

    argument = one_argument(argument,arg);

    if (!str_prefix(arg,"help"))
    {
	if (argument[0] == '\0')
	{
	    do_function(ch, &do_help, "group help");
	    return TRUE;
	}

        do_function(ch, &do_help, argument);
	return TRUE;
    }

    if (!str_prefix(arg,"add"))
    {
	if (argument[0] == '\0')
	{
	    send_to_char( "{cYou must provide a skill name.\n\r",ch);
	    return TRUE;
	}

	gn = group_lookup(argument);
	if (gn != -1)
	{
	    if (ch->gen_data->group_chosen[gn]
	    ||  ch->pcdata->group_known[gn])
	    {
		send_to_char( "{cYou already know that group!\n\r",ch);
		return TRUE;
	    }

	    if (group_table[gn].rating[ch->class] < 1)
	    {
	  	send_to_char( "{cThat group is not available.\n\r",ch);
	 	return TRUE;
	    }

	    /* Close security hole */
	    if (ch->gen_data->points_chosen + group_table[gn].rating[ch->class]
		> 300)
	    {
		send_to_char(
		    "{cYou cannot take more than 300 creation points.\n\r", ch);
		return TRUE;
	    }

	    sprintf(buf,"{c%s group added\n\r",group_table[gn].name);
	    send_to_char(buf,ch);
	    ch->gen_data->group_chosen[gn] = TRUE;
	    ch->gen_data->points_chosen += group_table[gn].rating[ch->class];
	    gn_add(ch,gn);
	    ch->pcdata->points += group_table[gn].rating[ch->class];
	    return TRUE;
	}

	sn = skill_lookup(argument);
	if (sn != -1)
	{
	    if (ch->gen_data->skill_chosen[sn]
	    ||  ch->pcdata->learned[sn] > 0)
	    {
		send_to_char( "{cYou already know that skill!\n\r",ch);
		return TRUE;
	    }

	    if (skill_table[sn].rating[ch->class] < 1
	    ||  skill_table[sn].spell_fun != spell_null)
	    {
		send_to_char( "{cThat skill is not available.\n\r",ch);
		return TRUE;
	    }

	    /* Close security hole */
	    if (ch->gen_data->points_chosen + skill_table[sn].rating[ch->class]
		> 300)
	    {
		send_to_char(
		    "{cYou cannot take more than 300 creation points.\n\r", ch);
		return TRUE;
	    }
	    sprintf(buf, "{c%s skill added\n\r",skill_table[sn].name);
	    send_to_char(buf,ch);
	    ch->gen_data->skill_chosen[sn] = TRUE;
	    ch->gen_data->points_chosen += skill_table[sn].rating[ch->class];
	    ch->pcdata->learned[sn] = 1;
	    ch->pcdata->points += skill_table[sn].rating[ch->class];
	    return TRUE;
	}

	send_to_char( "{cNo skills or groups by that name...\n\r",ch);
	return TRUE;
    }

    if (!strcmp(arg,"drop"))
    {
	if (argument[0] == '\0')
  	{
	    send_to_char( "{cYou must provide a skill to drop.\n\r",ch);
	    return TRUE;
	}

	gn = group_lookup(argument);
	if (gn != -1 && ch->gen_data->group_chosen[gn])
	{
	    send_to_char( "{cGroup dropped.\n\r",ch);
	    ch->gen_data->group_chosen[gn] = FALSE;
	    ch->gen_data->points_chosen -= group_table[gn].rating[ch->class];
	    gn_remove(ch,gn);
	    for (i = 0; i < MAX_GROUP; i++)
	    {
		if (ch->gen_data->group_chosen[gn])
		    gn_add(ch,gn);
	    }
	    ch->pcdata->points -= group_table[gn].rating[ch->class];
	    return TRUE;
	}

	sn = skill_lookup(argument);
	if (sn != -1 && ch->gen_data->skill_chosen[sn])
	{
	    send_to_char( "{cSkill dropped.\n\r",ch);
	    ch->gen_data->skill_chosen[sn] = FALSE;
	    ch->gen_data->points_chosen -= skill_table[sn].rating[ch->class];
	    ch->pcdata->learned[sn] = 0;
	    ch->pcdata->points -= skill_table[sn].rating[ch->class];
	    return TRUE;
	}

	send_to_char( "{cYou haven't bought any such skill or group.\n\r",ch);
	return TRUE;
    }

    if (!str_prefix(arg,"premise"))
    {
	do_function(ch, &do_help, "premise");
	return TRUE;
    }

    if (!str_prefix(arg,"list"))
    {
	list_group_costs(ch);
	return TRUE;
    }

    if (!str_prefix(arg,"learned"))
    {
	list_group_chosen(ch);
	return TRUE;
    }

    if (!str_prefix(arg,"info"))
    {
	do_function(ch, &do_groups, argument);
	return TRUE;
    }

    return FALSE;
}






/* shows all groups, or the sub-members of a group */
void do_groups(CHAR_DATA *ch, char *argument)
{
    char buf[100];
    DESCRIPTOR_DATA *d, *gch;
    CHAR_DATA *leader, *follower;
    int gn,sn,col = 0;

    if (IS_NPC(ch))
	return;

	stc("\n\r{W<{R---------------------------------------------------------{W>{x\n\r", ch);
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if ( d->connected != CON_PLAYING || !d->character )
			continue;

		leader = (d->character->leader != NULL) ? d->character->leader : d->character;

		if ( leader == d->character )
			continue;

		ptc( ch, " {Y%s's group:: {wHigh Range: {W%d{x\n\r", leader->name, leader->level );
		for ( gch = descriptor_list; gch != NULL; gch = gch->next )
		{
			if ( gch->connected != CON_PLAYING || !gch->character )
				continue;
			follower = gch->character;
			if ( leader == follower )
				continue;
		    if ( is_same_group( follower, leader ) )
		    {
				ptc( ch, " {w%-14s {x", follower->name );
		    }
		    if ( col >= 3 )
		    {
				stc("{x\n\r", ch);
				col = 0;
			}
		}
		stc("\n\r{W<{R---------------------------------------------------------{W>{x\n\r", ch);
	}

	return;
    col = 0;

    if (argument[0] == '\0')
    {   /* show all groups */

	for (gn = 0; gn < MAX_GROUP; gn++)
        {
	    if (group_table[gn].name == NULL)
		break;
	    if (ch->pcdata->group_known[gn])
	    {
		sprintf(buf,"{c%-20s ",group_table[gn].name);
		send_to_char(buf,ch);
		if (++col % 3 == 0)
		    send_to_char( "{c\n\r",ch);
	    }
        }
        if ( col % 3 != 0 )
            send_to_char( "\n\r", ch );
        sprintf(buf,"{cCreation points: %d\n\r",ch->pcdata->points);
	send_to_char(buf,ch);
	return;
     }

     if (!str_cmp(argument,"all"))    /* show all groups */
     {
        for (gn = 0; gn < MAX_GROUP; gn++)
        {
            if (group_table[gn].name == NULL)
                break;
	    sprintf(buf,"{c%-20s ",group_table[gn].name);
            send_to_char(buf,ch);
	    if (++col % 3 == 0)
            	send_to_char( "{c\n\r",ch);
        }
        if ( col % 3 != 0 )
            send_to_char( "\n\r", ch );
	return;
     }


     /* show the sub-members of a group */
     gn = group_lookup(argument);
     if (gn == -1)
     {
	send_to_char( "{cNo group of that name exist.\n\r",ch);
	send_to_char(
	    "{cType 'groups all' or 'info all' for a full listing.\n\r",ch);
	return;
     }

     for (sn = 0; sn < MAX_IN_GROUP; sn++)
     {
	if (group_table[gn].spells[sn] == NULL)
	    break;
	sprintf(buf,"{c%-20s ",group_table[gn].spells[sn]);
	send_to_char(buf,ch);
	if (++col % 3 == 0)
	    send_to_char( "{c\n\r",ch);
     }
    if ( col % 3 != 0 )
        send_to_char( "\n\r", ch );
}

/* checks for skill improvement */
void check_improve( CHAR_DATA *ch, int sn, bool success, int multiplier )
{
	int chance;
	int intStat = 0, wisStat = 0, insStat = 0;
	int rating = 0;
	char buf[100];
	CHAR_DATA *teacher = NULL;
	bool learning = FALSE;
	bool spamminnskillin = FALSE;

	if (IS_NPC(ch))
		return;

	if ( ch->pcdata->learned[sn] == 0 )
		return;

	if ( gevent->running && gevent->num == 12 )
		spamminnskillin = TRUE;

	rating = skill_table[sn].rating[ch->class];

	if ( rating == 0 )
		rating = 1;

	/* check to see if the character has a chance to learn */

	intStat = ( get_curr_stat( ch, STAT_INT ) / 5 );
	if ( intStat <= 0 )
		intStat = 1;

	wisStat = ( get_curr_stat( ch, STAT_WIS ) / 5 );
	if ( wisStat <= 0 )
		wisStat = 1;

	insStat = ( get_curr_stat( ch, STAT_INS ) / 5 );
	if ( insStat <= 0 )
		insStat = 1;

	chance = 10 * int_app[get_curr_stat(ch,STAT_INT)].learn; // Up to 10 * 141 = 1410

	if (ch->pcdata->learning_skill == sn && sn != gsn_teach)
	{
		for (teacher = ch->in_room->people; teacher != NULL; teacher = teacher->next_in_room)
		{
			if (IS_NPC(teacher))	continue;
			if (teacher == ch)	continue;
			if (teacher->pcdata->teaching != ch)	continue;

			if (teacher->pcdata->learned[sn] > ch->pcdata->learned[sn])
			{
				learning = TRUE;
				break;
			}
		}
	}



	chance /= ( multiplier * rating * 4);
	chance += ch->pcdata->rebirth * 2;
	chance += calc_remort_tier(ch) * 10;
	chance += ( intStat + wisStat + insStat );

	if ( isInElList( ch ))
		chance *= 2;

	if ( is_qskill( sn ) && ch->pcdata->learned[sn] >= QSKILL_CAP )
	{
		ch->pcdata->learned[sn] = QSKILL_CAP;
		return;
	}

	if ( ch->pcdata->learned[sn] >= 100 && ch->pcdata->learned[sn] <= 149 )
		chance -= 25;
	else if ( ch->pcdata->learned[sn] >= 150 && ch->pcdata->learned[sn] <= 199 )
		chance -= 50;
	else if ( ch->pcdata->learned[sn] >= 200 && ch->pcdata->learned[sn] <= 249 )
		chance -= 75;
	else if ( ch->pcdata->learned[sn] >= 250 && ch->pcdata->learned[sn] <= 299 )
		chance -= 100;
	else if ( ch->pcdata->learned[sn] >= 300 && ch->pcdata->learned[sn] <= 349 )
		chance -= 150;
	else if ( ch->pcdata->learned[sn] >= 350 && ch->pcdata->learned[sn] <= 399 )
		chance -= 200;
	else if ( ch->pcdata->learned[sn] >= 400 && ch->pcdata->learned[sn] <= 425 )
		chance -= 250;
	else if ( ch->pcdata->learned[sn] >= 426 && ch->pcdata->learned[sn] <= 450 )
		chance -= 300;
	else if ( ch->pcdata->learned[sn] >= 451 && ch->pcdata->learned[sn] <= 475 )
		chance -= 350;
	else if ( ch->pcdata->learned[sn] >= 476 && ch->pcdata->learned[sn] <= 500 )
		chance -= 400;
	else if ( ch->pcdata->learned[sn] >= 501 && ch->pcdata->learned[sn] <= 525 )
		chance -= 450;
	else if ( ch->pcdata->learned[sn] >= 526 && ch->pcdata->learned[sn] <= 550 )
		chance -= 500;
	else if ( ch->pcdata->learned[sn] >= 551 && ch->pcdata->learned[sn] <= 575 )
		chance -= 600;
	else if ( ch->pcdata->learned[sn] >= 576 && ch->pcdata->learned[sn] <= 600 )
		chance -= 700;
	else if ( ch->pcdata->learned[sn] >= 601 && ch->pcdata->learned[sn] <= 625 )
		chance -= 800;
	else if ( ch->pcdata->learned[sn] >= 626 && ch->pcdata->learned[sn] <= 650 )
		chance -= 900;
	else if ( ch->pcdata->learned[sn] >= 651 )
		chance -= 999;

	if ( isInElList( ch ))
		chance *= 2;

	if (learning && teacher)
	chance += (teacher->pcdata->learned[gsn_teach] + teacher->pcdata->learned[sn]) / 10;

	if (spamminnskillin)
		chance *= 1.25;

	if (number_range(1,1000) > chance)
	{
		if (teacher && learning && sn != gsn_teach)
			check_improve(teacher, gsn_teach, FALSE, 7);

		return;
	}

	/* now that the character has a CHANCE to learn, see if they really have */

	if (success)
	{
		chance = URANGE(5,100 - ch->pcdata->learned[sn], 95);
		if (number_percent() < chance)
		{
			if (learning && teacher)
			{
				ptc(ch, "{Y%s {yhelps you in your {Ylearning {yby showing you what you did right.{x\n\r", teacher->name);
				ptc(teacher, "{yYou help %s in {Ylearning {y%s by showing them what they did right.{x\n\r", ch->name, skill_table[sn].name);
				check_improve(teacher, gsn_teach, TRUE, 3);
			}

			sprintf(buf,"{yYou have become better at {Y%s!{x\n\r", skill_table[sn].name);
			send_to_char(buf,ch);
			ch->pcdata->learned[sn]++;

			if ( ch->pcdata->learned[sn] == 85 )
			{
				check_for_skills( ch, sn );
			}

			gain_exp(ch,2 * skill_table[sn].rating[ch->class]);

			if ( ch->pcdata->learned[gsn_gifted] > 0 )
				check_improve( ch, gsn_gifted, TRUE, 1 );
		}
		else if (learning && teacher)
		{
			check_improve(teacher, gsn_teach, FALSE, 4);
		}
	}
	else
	{
		chance = URANGE(5,ch->pcdata->learned[sn]/2,30);
		if (number_percent() < chance)
		{
			if (learning && teacher)
			{
				ptc(ch, "{Y%s {yhelps you in your {Ylearning {yby showing you what you did {Ywrong{y.{x\n\r", teacher->name);
				ptc(teacher, "{yYou help {Y%s {yin learning {Y%s {yby showing them what they did {Ywrong{y.{x\n\r", ch->name, skill_table[sn].name);
				check_improve(teacher, gsn_teach, TRUE, 5);
			}

			if (sn == gsn_teach && ch->pcdata->teaching)
			{
				ptc(ch, "{yYou couldn't find a way to show {Y%s {yhow to use {Y%s {ybetter.{x\n\r", ch->pcdata->teaching->name, skill_table[ch->pcdata->teaching_skill].name);
			}


			sprintf(buf,"{yYou learn from your mistakes, and your {Y%s{y skill improves.{x\n\r",skill_table[sn].name);
			send_to_char(buf,ch);
			ch->pcdata->learned[sn]++;

			if ( ch->pcdata->learned[sn] == 85 )
			{
				check_for_skills( ch, sn );
			}

			gain_exp(ch,2 * skill_table[sn].rating[ch->class]);
		}
		else if (learning && teacher)
			check_improve(teacher, gsn_teach, FALSE, 6);
	}
}

/* returns a group index number given the name */
int group_lookup( const char *name )
{
    int gn;

    for ( gn = 0; gn < MAX_GROUP; gn++ )
    {
        if ( group_table[gn].name == NULL )
            break;
        if ( LOWER(name[0]) == LOWER(group_table[gn].name[0])
        &&   !str_prefix( name, group_table[gn].name ) )
            return gn;
    }

    return -1;
}

/* recursively adds a group given its number -- uses group_add */
void gn_add( CHAR_DATA *ch, int gn)
{
    int i;

    ch->pcdata->group_known[gn] = TRUE;
    for ( i = 0; i < MAX_IN_GROUP; i++)
    {
        if (group_table[gn].spells[i] == NULL)
            break;
        group_add(ch,group_table[gn].spells[i],FALSE);
    }
}

/* recusively removes a group given its number -- uses group_remove */
void gn_remove( CHAR_DATA *ch, int gn)
{
    int i;

    ch->pcdata->group_known[gn] = FALSE;

    for ( i = 0; i < MAX_IN_GROUP; i ++)
    {
	if (group_table[gn].spells[i] == NULL)
	    break;
	group_remove(ch,group_table[gn].spells[i]);
    }
}

/* use for processing a skill or group for addition  */
void group_add( CHAR_DATA *ch, const char *name, bool deduct)
{
    int sn,gn;

    if (IS_NPC(ch)) /* NPCs do not have skills */
	return;

    sn = skill_lookup(name);

    if (sn != -1)
    {
	if (ch->pcdata->learned[sn] == 0) /* i.e. not known */
	{
	    ch->pcdata->learned[sn] = 1;
	    if (deduct)
	   	ch->pcdata->points += skill_table[sn].rating[ch->class];
	}
	return;
    }

    /* now check groups */

    gn = group_lookup(name);

    if (gn != -1)
    {
	if (ch->pcdata->group_known[gn] == FALSE)
	{
	    ch->pcdata->group_known[gn] = TRUE;
	    if (deduct)
		ch->pcdata->points += group_table[gn].rating[ch->class];
	}
	gn_add(ch,gn); /* make sure all skills in the group are known */
    }
}

/* used for processing a skill or group for deletion -- no points back! */

void group_remove(CHAR_DATA *ch, const char *name)
{
    int sn, gn;

     sn = skill_lookup(name);

    if (sn != -1)
    {
	ch->pcdata->learned[sn] = 0;
	return;
    }

    /* now check groups */

    gn = group_lookup(name);

    if (gn != -1 && ch->pcdata->group_known[gn] == TRUE)
    {
	ch->pcdata->group_known[gn] = FALSE;
	gn_remove(ch,gn);  /* be sure to call gn_add on all remaining groups */
    }
}
