/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "spearforms.h"

int MaxsStanceSpecifics = 26;
void	group_gain	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
void	raw_kill	args( ( CHAR_DATA *victim ) );
void	death_cry	args( ( CHAR_DATA *ch ) );
bool	remove_obj	args( (CHAR_DATA *ch, int iWear, bool fReplace ) );
void	one_hit		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt, bool secondary ) );
bool	check_dodge	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	check_parry	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    check_shield_block     args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    spearforms args( ( CHAR_DATA *ch ) );
bool is_true_aiel( CHAR_DATA *ch )
{
    if ( ch->clan == clan_lookup( "wiseone" )
    || ch->clan == clan_lookup( "clanchief" )
    || ch->clan == clan_lookup( "thespear" )
    || ch->clan == clan_lookup( "blackeye" )
    || ch->clan == clan_lookup( "spearmaiden" )
    || ch->clan == clan_lookup( "eaglebrother" )
    || ch->clan == clan_lookup( "dawnrunner" )
    || ch->clan == clan_lookup( "knifehand" )
    || ch->clan == clan_lookup( "mountaindancer" )
    || ch->clan == clan_lookup( "nightspear" )
    || ch->clan == clan_lookup( "redshield" )
    || ch->clan == clan_lookup( "stonedog" )
    || ch->clan == clan_lookup( "thunderwalker" )
    || ch->clan == clan_lookup( "trueblood" )
    || ch->clan == clan_lookup( "waterseeker" )
    || ch->clan == clan_lookup( "crafters" ) )
    return TRUE;

    else
    return FALSE;
}

int sforms_bonus( CHAR_DATA *ch, bool offensive )
{
	int chance = 0;
	int bonus = 0, wieldType = 0, wieldBonus = 0;
	int i = 0, x = 0;
	OBJ_DATA *wield;

	if ( offensive )
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->off_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						chance = get_skill( ch, skill_lookup( sstance_table[i-1].realName ) );
						if ( chance <= 0 )
							return 0;
						if ( chance <= 0 )
						{
							bonus = 0;
							chance = 0;
						}
						else
						{
							if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
							{
								if ( chance > 5 )
									chance /= 2;
							}
							bonus = chance;
							wield = get_eq_char( ch, WEAR_WIELD );
							if ( wield == NULL )
								return 0;
							else if ( wield->value[0] == sstance_table[i-1].primeWeapon )
							{
								wieldType = get_weapon_sn(ch);
								wieldBonus = get_weapon_skill(ch, wieldType);
								bonus += wieldBonus;
								bonus += sstance_table[i-1].primeBonus;
								check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 3 );
								return bonus;
							}
							else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
							{
								wieldType = get_weapon_sn(ch);
								wieldBonus = ( get_weapon_skill(ch, wieldType) / 2 );
								bonus += wieldBonus;
								bonus += ( sstance_table[i-1].secondaryBonus / 2 );
								check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 2 );
								return bonus;
							}
							else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
							{
								wieldType = get_weapon_sn(ch);
								wieldBonus = ( get_weapon_skill(ch, wieldType) / 3 );
								bonus += wieldBonus;
								bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
								check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 1 );
								return bonus;
							}
							else
								return 0;
						}
					}
				}
			}
		}
	}
	else
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->def_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						chance = get_skill( ch, skill_lookup( sstance_table[i-1].realName ) );
						if ( chance <= 0 )
							return 0;
						if ( chance <= 0 )
						{
							bonus = 0;
							chance = 0;
						}
						else
						{
							if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
							{
								if ( chance > 5 )
									chance /= 2;
							}
							bonus = chance;
							wield = get_eq_char( ch, WEAR_WIELD );
							if ( wield == NULL )
							{
								stc("Wield is NULL.\n\r",ch);
								return 0;
							}
							else
							{
								bonus = chance;
								wield = get_eq_char( ch, WEAR_WIELD );
								if ( wield == NULL )
									return 0;
								else if ( wield->value[0] == sstance_table[i-1].primeWeapon )
								{
									wieldType = get_weapon_sn(ch);
									wieldBonus = get_weapon_skill(ch, wieldType);
									bonus += wieldBonus;
									bonus += sstance_table[i-1].primeBonus;
									return bonus;
								}
								else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
								{
									wieldType = get_weapon_sn(ch);
									wieldBonus = ( get_weapon_skill(ch, wieldType) / 2 );
									bonus += wieldBonus;
									bonus += ( sstance_table[i-1].secondaryBonus / 2 );
									return bonus;
								}
								else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
								{
									wieldType = get_weapon_sn(ch);
									wieldBonus = ( get_weapon_skill(ch, wieldType) / 3 );
									bonus += wieldBonus;
									bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
									return bonus;
								}
								else
									return 0;
							}
						}
					}
				}
			}
		}
	}
	return bonus;

}
void toggle_sforms( CHAR_DATA *ch, bool offensive )
{
	int i = 0, x = 0;
	if ( offensive )
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->off_sforms_flags, sstance_table[i-1].form ) )
			{
			REMOVE_BIT( ch->off_sforms_flags, sstance_table[i-1].form );
			for ( x = 1; x <= 5; x++ )
			{
				if ( IS_SET( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
				{
					ptc( ch, "You step out of the attack version of %s.\n\r", sstance_table[i-1].nameLong[x-1] );
					REMOVE_BIT( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					SET_BIT( ch->off_sforms_flags, sStanceNone );
				}
			}
			}
		}
	}
	else
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->def_sforms_flags, sstance_table[i-1].form ) )
			{
			REMOVE_BIT( ch->def_sforms_flags, sstance_table[i-1].form );
			for ( x = 1; x <= 5; x++ )
			{
				if ( IS_SET( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
				{
					ptc( ch, "You step out of the defensive version of %s.\n\r", sstance_table[i-1].nameLong[x-1] );
					REMOVE_BIT( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					SET_BIT( ch->def_sforms_flags, sStanceNone );
				}
			}
			}
		}
	}
	return;
}
char * sstance_lookup( CHAR_DATA *ch, bool offensive )
{
	int i = 0, x = 0;

	if ( offensive )
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->off_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						return sstance_table[i-1].nameLong[x-1];
					}
				}
			}
		}
	}
	else
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->def_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						return sstance_table[i-1].nameLong[x-1];
					}
				}
			}
		}
	}
	return "";
}

bool sform_is_set( CHAR_DATA *ch, bool offensive )
{
	int i = 0, x = 0;

	if ( offensive )
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->off_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						return TRUE;
					}
				}
			}
		}
	}
	else
	{
		for ( i = 1; i <= MaxStance; i++ )
		{
			if ( IS_SET( ch->def_sforms_flags, sstance_table[i-1].form ) )
			{
				for ( x = 1; x <= 5; x++ )
				{
					if ( IS_SET( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] ) )
					{
						return TRUE;
					}
				}
			}
		}
	}
	return FALSE;
}
bool validsFormCombo( CHAR_DATA *ch, char *arg1, char *arg2 )
{
	int i = 0, x = 0, sn;
	bool first = FALSE, second = FALSE;
	if ( !ch ) return FALSE;
	if ( !arg1 || arg1[0] == '\0' ) return FALSE;
	if ( !arg2 || arg2[0] == '\0' ) return FALSE;

	for ( i = 1; i <= MaxStance; i++ )
	{
	    for ( x = 1; x <= 5; x++ )
	    {
		if ( !str_cmp( arg1, sstance_table[i-1].nameShort[x-1] ) )
		{
		    sn = skill_lookup( sstance_table[i-1].realName );
		    if ( ch->pcdata->learned[sn] < 75 )
		    {
			ptc( ch, "You attempt %s, but can't quite manage the form.\n\r", sstance_table[i-1].nameLong[x-1] );
			first = FALSE;
		    }
		    else
		    {
			first = TRUE;
			break;
		    }
		}
		if ( first )
		    break;
	    }
	    if ( first )
		break;
	}
	for ( i = 1; i <= MaxStance; i++ )
	{
	    for ( x = 1; x <= 5; x++ )
	    {
		if ( !str_cmp( arg2, sstance_table[i-1].nameShort[x-1] ) )
		{
		    sn = skill_lookup( sstance_table[i-1].realName );
		    if ( ch->pcdata->learned[sn] < 75 )
		    {
			ptc( ch, "You attempt %s, but can't quite manage the form.\n\r", sstance_table[i-1].nameLong[x-1] );
			second = FALSE;
		    }
		    else
		    {
			second = TRUE;
			break;
		    }
		}
		if ( second )
		    break;
	    }
	    if ( second )
		break;
	}
	if ( first && second )
	    return TRUE;
	return FALSE;
}

int sfmaster_mod( CHAR_DATA *ch )
{
    int mod = 0;

    mod = get_skill( ch, gsn_precision );
    mod += get_skill( ch, gsn_efficient );
    mod += get_skill( ch, gsn_anticipate );

    if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
        mod /= 1.5;

    if ( !IS_SET( ch->op_flags, OP_CHANNELER ) )
    {
        mod += ch->pcdata->rebirth;
	if ( spearmaster( ch ) )
	    mod += 100;
	if ( number_percent() <= get_skill( ch, gsn_focus ) )
	{
	    mod *= 1.5;
	    check_improve (ch, gsn_focus, TRUE, 9 );
	}
    }

    if ( mod <= 1 )
	return 1;
    else
	return mod;
}
int sfcombo_damage( CHAR_DATA *ch, char *arg, bool primary )
{
    int i = 0, x = 0, chance = 0, bonus = 0, wieldType, wieldBonus, range;
    int bonus2 = 0, wieldType2, wieldBonus2, range2;
    OBJ_DATA *wield, *wield2;

    if ( ( wield = get_eq_char( ch, WEAR_WIELD ) ) == NULL )
        return 0;

    for ( i = 1; i <= MaxStance; i++ )
    {
	for ( x = 1; x <= 5; x++ )
	{
	    if ( !str_cmp( arg, sstance_table[i-1].nameShort[x-1] ) )
	    {
		chance = get_skill( ch, skill_lookup( sstance_table[i-1].realName ) );
		if ( primary )
		{
		    bonus = chance;
		    wieldType = get_weapon_sn(ch);
		    wieldBonus = get_weapon_skill(ch, wieldType);
		    bonus += wieldBonus;
		    bonus += sstance_table[i-1].primeBonus;
		    check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 3 );
		    range = (1 + wield->value[1] * wield->value[2] / 2 );
		    bonus += number_range( 1, range );
		    if ( ( wield2 = get_eq_char( ch, WEAR_SECONDARY ) ) != NULL )
		    {
			wieldType2 = get_weapon_sn(ch);
			wieldBonus2 = get_weapon_skill(ch, wieldType2);
			bonus2 += wieldBonus2;
			bonus2 += sstance_table[i-1].primeBonus;
		    }
		    range2 = (1 + wield2->value[1] * wield2->value[2] / 2 );
		    bonus2 += number_range( 1, range2 );
		    bonus += bonus2;
		    return bonus + sfmaster_mod( ch );
		}
		else
		{
		    bonus = chance;
		    wieldType = get_secondary_sn(ch);
		    wieldBonus = get_weapon_skill(ch, wieldType);
		    bonus += wieldBonus;
		    bonus += sstance_table[i-1].primeBonus;
		    check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 3 );
		    range = (1 + wield->value[1] * wield->value[2] / 2 );
		    bonus += number_range( 1, range );
		    if ( !IS_SET( ch->op_flags, OP_CHANNELER ) )
		    {
			if ( ( wield2 = get_eq_char( ch, WEAR_SECONDARY ) ) != NULL )
			{
			    wieldType2 = get_secondary_sn(ch);
			    wieldBonus2 = get_weapon_skill(ch, wieldType2);
			    bonus2 += wieldBonus2;
			    bonus2 += sstance_table[i-1].primeBonus;
			    range2 = (1 + wield2->value[1] * wield2->value[2] / 2 );
			    bonus2 += number_range( 1, range2 );
			    bonus += bonus2;
			}
		    }
		    return bonus + sfmaster_mod( ch );
		}
	    }
	}
    }
    return 0;
}

void do_spearforms( CHAR_DATA *ch, char *argument )
{
	char arg1[MIL];
	char arg2[MIL];
	char arg3[MIL];
	char dispBuf1[MSL];
	char dispBuf2[MSL];
	char *buffer1 = NULL;
	char *buffer2 = NULL;
	int i = 0, x = 0;
	int disp = 0, count = 0, flows = 0, flows2 = 0, grace = 1;
	int points = 0, skill = 0, skillPerc = 0;
	bool hasForm = FALSE;

	char *flow[] = {
		"shifts", "moves", "flows", "glides", "maneuvers"
	};
	char *flow2[] = {
		"shift", "move", "flow", "glide", "maneuver"
	};
	char *graceful[] = {
		"awkwardly", "jerkily", "stiffly", "forcefully", "with ease",
		"easily", "almost perfectly", "smoothly", "gracefully", "perfectly"
	};

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );
	argument = one_argument( argument, arg3 );

	points += get_skill( ch, gsn_anticipate );
	points += get_skill( ch, gsn_precision );
	points += get_skill( ch, gsn_efficient );
	points += ( ch->perm_stat[STAT_STR] / 4 );
	points += ( ch->perm_stat[STAT_REF] / 4 );
	points += ( ch->perm_stat[STAT_DEX] / 4 );
	points += ( ch->perm_stat[STAT_INS] / 4 );
	points += ( ch->perm_stat[STAT_CON] / 4 );

    if (ch->race != race_lookup("aiel") )
    {
    	stc("{cYou lack the knowledge to assume this form.\n\r",ch);
    	return;
    }
    if ( !is_true_aiel( ch ) )
    {
    	stc("Stop pretending to follow ji'e'toh.\n\r",ch);
    	return;
    }


	if ( arg1[0] == '\0' )
	{
		stc( "{WSyntax:{x\n\r", ch );
		stc( "{RSpearForms Short{x\n\r", ch );
		stc( "{w  Provides a listing of the form groups and abbreviated{x\n\r", ch );
		stc( "{w  names of the forms. The abbreviated name is provided{x\n\r", ch );
		stc( "{w  when setting or changing the current form.{x\n\r", ch );
		stc( "{RSpearForms Full{x\n\r", ch );
		stc( "{w  Provides a complete list of all groups and forms with{x\n\r", ch );
		stc( "{w  abbreviated names and descriptive names.{x\n\r", ch );
		stc( "{RSpearForms Offensive <form short name>{x\n\r", ch );
		stc( "{w  Set the offensive form to the abbreviated name.{x\n\r", ch );
		stc( "{RSpearForms Defensive <form short name>{x\n\r", ch );
		stc( "{w  Set the defensive form to the abbreviated name.{x\n\r", ch );
		stc( "{RSpearForms Clear{x\n\r", ch );
		stc( "{w  Clears both offensive and defensive forms.{x\n\r", ch );
		stc( "{RSpearForms Help{x\n\r", ch );
		stc( "{w  Provides help on using forms.{x\n\r", ch );
		stc( "{RSpearForms Specifics{x\n\r", ch );
		stc( "{w  Provides more detailed information on forms.{x\n\r", ch );
		stc( "{RSpearForms Display{x\n\r", ch );
		stc( "{w  Performs a 'kata' based on known forms.{x\n\r", ch );
		stc( "{RSpearForms Show{x\n\r", ch );
		stc( "{w  Displays the current forms set.{x\n\r", ch );
		return;
	}
	if ( !str_prefix( arg1, "combo" ) )
	{
	    CHAR_DATA *victim;
	    int dmg = 0;
	    if ( !is_fighting(ch) )
	    {
		stc( "You're not fighting anyone right now.\n\r", ch );
		return;
	    }
	    else
		( victim = ch->fight_data->fighter );

	    if ( arg2[0] == '\0' || arg3[0] == '\0' )
	    {
		stc( "You must supply valid arguments.\n\r", ch );
		stc( "Forms Combo <Set1> <Set2>\n\r", ch );
		stc( "Set1 and Set2 cannot be of the same group.\n\r", ch );
		stc( "You must be skilled (75% or greater) in both set groups.\n\r", ch );
		stc( "Example: forms combo sts wom\n\r", ch );
		return;
	    }
	    if ( !str_cmp( arg2, arg3 ) )
	    {
			stc( "You can't use the same forms for both parts of the combo.\n\r", ch );
			return;
	    }
	    else if ( !validsFormCombo( ch, arg2, arg3 ) )
	    {
		stc( "The combo you specified is not valid.\n\r", ch );
		stc( "Forms Combo <Set1> <Set2>\n\r", ch );
		stc( "Set1 and Set2 cannot be of the same group.\n\r", ch );
		stc( "You must be skilled (75% or greater) in both set groups.\n\r", ch );
		stc( "Example: forms combo sts wom\n\r", ch );
		return;
	    }
	    else
	    {
	        int dmg1 = 0, dmg2 = 0;
		OBJ_DATA *wield, *wield2;
		if ( ( wield = get_eq_char( ch, WEAR_WIELD ) ) == NULL )
		{
		    stc( "You must wield a primary weapon.\n\r", ch );
		    return;
		}
		if ( ( wield2 = get_eq_char( ch, WEAR_SECONDARY ) ) == NULL )
		{
		    stc( "You're not wielding a secondary weapon.\n\r", ch );
		    return;
		}
	        dmg1 = sfcombo_damage( ch, arg2, TRUE );
	        dmg2 = sfcombo_damage( ch, arg3, FALSE );
		dmg = number_range( UMAX( dmg1, dmg2 ), ( dmg1 + dmg2 ) );
		if ( dice( 1,20 ) >= 20 )
		{
		    act( "You critically strike $N!", ch, NULL, victim, TO_CHAR );
		    act( "$n critically strikes you!", ch, NULL, victim, TO_VICT );
		    act( "$n critically strikes $N!", ch, NULL, victim, TO_NOTVICT );
		    dmg *= 2;
		}
		damage( ch, victim, dmg, gsn_heron, DAM_HARM, TRUE );
		WAIT_STATE( ch, PULSE_VIOLENCE - 2 );
	    }
	    return;
	}
	if ( !str_prefix( arg1, "help" ) )
	{
	return;
		for ( i = 0; i <= MaxStanceHelp; i++ )
		{
			if ( i == 0 )
				continue;
			ptc( ch, "%s\n\r", sstance_help_table[i-1].help );
			if ( i == MaxStanceHelp )
				break;
		}
		return;
	}
	if ( !str_prefix( arg1, "show" ) )
	{
		if ( sform_is_set( ch, TRUE ) )
		{
			ptc( ch, "Off: %29s\n\r", sstance_lookup( ch, TRUE ) );
		}
		if ( sform_is_set( ch, FALSE ) )
		{
			ptc( ch, "Def: %29s\n\r", sstance_lookup( ch, FALSE ) );
		}
		return;
	}
	if ( !str_prefix( arg1, "specifics" ) )
	{
	return;
		for ( i = 0; i <= MaxsStanceSpecifics; i++ )
		{
			if ( i == 0 )
				continue;
			ptc( ch, "%s\n\r", sstance_specifics_table[i-1].help );
			if ( i == MaxsStanceSpecifics )
				break;
		}
		return;
	}
	if ( !str_prefix( arg1, "clear" ) )
	{
		stc( "You drop down into a normal attack position.\n\r", ch );
		toggle_sforms( ch, TRUE );
		stc( "You drop down into a normal defense position.\n\r", ch );
		toggle_sforms( ch, FALSE );
		return;
	}
	if ( !str_prefix( arg1, "short" ) )
	{
		stc( "{R+{r---------------{w==========={r---------------{R+{x\n\r", ch );
		for ( i = 0; i <= MaxStance; i++ )
		{
			if ( sstance_table[i].realName == '\0'
			|| sstance_table[i].realName == NULL
			|| !sstance_table[i].realName
			|| i == 0 )
				continue;
			ptc( ch, "{R|{w %-9s {r({w%s{r) {r({w%s{r) {r({w%s{r) {r({w%s{r) {r({w%s{r) {R|{x\n\r",
				sstance_table[i - 1].realName,
				sstance_table[i - 1].nameShort[0],
				sstance_table[i - 1].nameShort[1],
				sstance_table[i - 1].nameShort[2],
				sstance_table[i - 1].nameShort[3],
				sstance_table[i - 1].nameShort[4]
				);
			if ( i == MaxStance )
				break;
		}
		stc( "{R+{r---------------{w==========={r---------------{R+{x\n\r", ch );
		return;
	}
	else if ( !str_prefix( arg1, "full" ) || !str_prefix( arg1, "long" ) )
	{
		stc( "{R+{r---------------{w==========={r---------------{R+{x\n\r", ch );
		for ( i = 0; i <= MaxStance; i++ )
		{
			if ( sstance_table[i].realName == '\0'
			|| sstance_table[i].realName == NULL
			|| !sstance_table[i].realName
			|| i == 0 )
				continue;
			ptc( ch, "{R|{w {R%-9s {w({W%s{w) {w({W%s{w) {w({W%s{w) {w({W%s{w) {w({W%s{w) {R|{x\n\r{R|{w %-12s %-12s %-13s {R|\n\r" \
			         "{R|{w %-39s {R|{x\n\r{R|{w %-39s {R|{x\n\r{R|{w %-39s {R|{x\n\r{R|{w %-39s {R|{x\n\r{R|{w %-39s {R|{x\n\r",
				sstance_table[i - 1].realName,
				sstance_table[i - 1].nameShort[0],
				sstance_table[i - 1].nameShort[1],
				sstance_table[i - 1].nameShort[2],
				sstance_table[i - 1].nameShort[3],
				sstance_table[i - 1].nameShort[4],
		    	sstance_table[i-1].primeWeapon == WEAPON_EXOTIC ? "Exotic" :
		    	sstance_table[i-1].primeWeapon == WEAPON_SWORD ? "Sword" :
		    	sstance_table[i-1].primeWeapon == WEAPON_DAGGER ? "Dagger" :
		    	sstance_table[i-1].primeWeapon == WEAPON_SPEAR ? "Spear" :
		    	sstance_table[i-1].primeWeapon == WEAPON_STAFF ? "Staff" :
		    	sstance_table[i-1].primeWeapon == WEAPON_MACE ? "Mace" :
			   	sstance_table[i-1].primeWeapon == WEAPON_AXE ? "Axe" :
		    	sstance_table[i-1].primeWeapon == WEAPON_FLAIL ? "Flail" :
		    	sstance_table[i-1].primeWeapon == WEAPON_WHIP ? "Whip" :
		    	sstance_table[i-1].primeWeapon == WEAPON_POLEARM ? "Polearm" :
		    	"unknown",
		    	sstance_table[i-1].secondWeapon == WEAPON_EXOTIC ? "Exotic" :
		    	sstance_table[i-1].secondWeapon == WEAPON_SWORD ? "Sword" :
		    	sstance_table[i-1].secondWeapon == WEAPON_DAGGER ? "Dagger" :
		    	sstance_table[i-1].secondWeapon == WEAPON_SPEAR ? "Spear" :
		    	sstance_table[i-1].secondWeapon == WEAPON_STAFF ? "Staff" :
		    	sstance_table[i-1].secondWeapon == WEAPON_MACE ? "Mace" :
			   	sstance_table[i-1].secondWeapon == WEAPON_AXE ? "Axe" :
		    	sstance_table[i-1].secondWeapon == WEAPON_FLAIL ? "Flail" :
		    	sstance_table[i-1].secondWeapon == WEAPON_WHIP ? "Whip" :
		    	sstance_table[i-1].secondWeapon == WEAPON_POLEARM ? "Polearm" :
		    	"unknown",
		    	sstance_table[i-1].tertWeapon == WEAPON_EXOTIC ? "Exotic" :
		    	sstance_table[i-1].tertWeapon == WEAPON_SWORD ? "Sword" :
		    	sstance_table[i-1].tertWeapon == WEAPON_DAGGER ? "Dagger" :
		    	sstance_table[i-1].tertWeapon == WEAPON_SPEAR ? "Spear" :
		    	sstance_table[i-1].tertWeapon == WEAPON_STAFF ? "Staff" :
		    	sstance_table[i-1].tertWeapon == WEAPON_MACE ? "Mace" :
			   	sstance_table[i-1].tertWeapon == WEAPON_AXE ? "Axe" :
		    	sstance_table[i-1].tertWeapon == WEAPON_FLAIL ? "Flail" :
		    	sstance_table[i-1].tertWeapon == WEAPON_WHIP ? "Whip" :
		    	sstance_table[i-1].tertWeapon == WEAPON_POLEARM ? "Polearm" :
		    	"unknown",
				/*sstance_table[i - 1].primeWeapon,
				sstance_table[i - 1].secondWeapon,
				sstance_table[i - 1].tertWeapon,*/
				sstance_table[i - 1].nameLong[0],
				sstance_table[i - 1].nameLong[1],
				sstance_table[i - 1].nameLong[2],
				sstance_table[i - 1].nameLong[3],
				sstance_table[i - 1].nameLong[4]
				);
			if ( i == MaxStance )
				break;
		}
		stc( "{R+{r---------------{w==========={r---------------{R+{x\n\r", ch );
		return;
	}
	else if ( !str_prefix( arg1, "offensive" ) )
	{
		OBJ_DATA *wield;
		int bonus = 0;

		wield = get_eq_char( ch, WEAR_WIELD );

		if ( arg2[0] == '\0' )
		{
			stc( "{WSyntax:{x\n\r", ch );
			stc( "{RSpearForms Short{x\n\r", ch );
			stc( "{w  Provides a listing of the form groups and abbreviated{x\n\r", ch );
			stc( "{w  names of the forms. The abbreviated name is provided{x\n\r", ch );
			stc( "{w  when setting or changing the current form.{x\n\r", ch );
			stc( "{RSpearForms Full{x\n\r", ch );
			stc( "{w  Provides a complete list of all groups and forms with{x\n\r", ch );
			stc( "{w  abbreviated names and descriptive names.{x\n\r", ch );
			stc( "{RSpearForms Offensive <form short name>{x\n\r", ch );
			stc( "{w  Set the offensive form to the abbreviated name.{x\n\r", ch );
			stc( "{RSpearForms Defensive <form short name>{x\n\r", ch );
			stc( "{w  Set the defensive form to the abbreviated name.{x\n\r", ch );
			stc( "{RSpearForms Clear{x\n\r", ch );
			stc( "{w  Clears both offensive and defensive forms.{x\n\r", ch );
			stc( "{RSpearForms Help{x\n\r", ch );
			stc( "{w  Provides help on using forms.{x\n\r", ch );
			stc( "{RSpearForms Specifics{x\n\r", ch );
			stc( "{w  Provides more detailed information on forms.{x\n\r", ch );
			stc( "{RSpearForms Display{x\n\r", ch );
			stc( "{w  Performs a 'kata' based on known forms.{x\n\r", ch );
			stc( "{RSpearForms Show{x\n\r", ch );
			stc( "{w  Displays the current forms set.{x\n\r", ch );
			return;
		}
		if ( wield == NULL )
		{
			stc("You must wield a weapon.\n\r", ch);
			return;
		}
		for ( i = 0; i <= MaxStance; i++ )
		{
			if ( i == 0 )
				continue;
			for ( x = 0; x <= 5; x++ )
			{
				if ( x == 0 )
					continue;
				if ( !str_cmp( arg2, sstance_table[i-1].nameShort[x-1] ) )
				{
					toggle_sforms( ch, TRUE );
					if ( ch->pcdata->rebirth - x >= sstance_table[i-1].rbi )
					{

						if ( wield->value[0] == sstance_table[i-1].primeWeapon )
						{
							bonus += sstance_table[i-1].primeBonus;
						}
						else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
						{
							bonus += ( sstance_table[i-1].secondaryBonus / 2 );
						}
						else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
						{
							bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
						}
						if ( bonus <= 0 )
						{
							stc("You must be doing something wrong.\n\r", ch);
							return;
						}

						ptc( ch, "You set to attack with %s.\n\r",
							sstance_table[i-1].nameLong[x-1] );
						SET_BIT( ch->off_sforms_flags, sstance_table[i-1].form );
						SET_BIT( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					}
					else
					{

						if ( wield->value[0] == sstance_table[i-1].primeWeapon )
						{
							bonus += sstance_table[i-1].primeBonus;
						}
						else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
						{
							bonus += ( sstance_table[i-1].secondaryBonus / 2 );
						}
						else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
						{
							bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
						}
						if ( bonus <= 0 )
						{
							stc("You must be doing something wrong.\n\r", ch);
							return;
						}

						ptc( ch, "You set to attack with %s, though you feel a bit clumsy with it.\n\r",
							sstance_table[i-1].nameLong[x-1] );
						SET_BIT( ch->off_sforms_flags, sstance_table[i-1].form );
						SET_BIT( ch->off_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					}
					hasForm = TRUE;
					break;
				}
			}
			if ( i == MaxStance && !hasForm )
			{
				stc( "Unknown form. See SpearForms Short for a list of\n\r", ch );
				stc( "valid spearform abbreviations.\n\r", ch );
				break;
			}
			if ( hasForm )
				break;
		}
		return;
	}
	else if ( !str_prefix( arg1, "defensive" ) )
	{
		OBJ_DATA *wield;
		int bonus = 0;

		wield = get_eq_char( ch, WEAR_WIELD );

		if ( arg2[0] == '\0' )
		{
			stc( "{WSyntax:{x\n\r", ch );
			stc( "{RSpearForms Short{x\n\r", ch );
			stc( "{w  Provides a listing of the form groups and abbreviated{x\n\r", ch );
			stc( "{w  names of the forms. The abbreviated name is provided{x\n\r", ch );
			stc( "{w  when setting or changing the current form.{x\n\r", ch );
			stc( "{RSpearForms Full{x\n\r", ch );
			stc( "{w  Provides a complete list of all groups and forms with{x\n\r", ch );
			stc( "{w  abbreviated names and descriptive names.{x\n\r", ch );
			stc( "{RSpearForms Offensive <form short name>{x\n\r", ch );
			stc( "{w  Set the offensive form to the abbreviated name.{x\n\r", ch );
			stc( "{RSpearForms Defensive <form short name>{x\n\r", ch );
			stc( "{w  Set the defensive form to the abbreviated name.{x\n\r", ch );
			stc( "{RSpearForms Clear{x\n\r", ch );
			stc( "{w  Clears both offensive and defensive forms.{x\n\r", ch );
			stc( "{RSpearForms Help{x\n\r", ch );
			stc( "{w  Provides help on using forms.{x\n\r", ch );
			stc( "{RSpearForms Specifics{x\n\r", ch );
			stc( "{w  Provides more detailed information on forms.{x\n\r", ch );
			stc( "{RSpearForms Display{x\n\r", ch );
			stc( "{w  Performs a 'kata' based on known forms.{x\n\r", ch );
			stc( "{RSpearForms Show{x\n\r", ch );
			stc( "{w  Displays the current forms set.{x\n\r", ch );
			return;
		}
		if ( wield == NULL )
		{
			stc("You must wield a weapon.\n\r", ch);
			return;
		}
		for ( i = 0; i <= MaxStance; i++ )
		{
			if ( i == 0 )
				continue;
			for ( x = 0; x <= 5; x++ )
			{
				if ( x == 0 )
					continue;
				if ( !str_cmp( arg2, sstance_table[i-1].nameShort[x-1] ) )
				{
					toggle_sforms( ch, FALSE );
					if ( ch->pcdata->rebirth - x >= sstance_table[i-1].rbi )
					{

						if ( wield->value[0] == sstance_table[i-1].primeWeapon )
						{
							bonus += sstance_table[i-1].primeBonus;
						}
						else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
						{
							bonus += ( sstance_table[i-1].secondaryBonus / 2 );
						}
						else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
						{
							bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
						}
						if ( bonus <= 0 )
						{
							stc("You must be doing something wrong.\n\r", ch);
							return;
						}

						ptc( ch, "You set to defend with %s.\n\r",
							sstance_table[i-1].nameLong[x-1] );
						SET_BIT( ch->def_sforms_flags, sstance_table[i-1].form );
						SET_BIT( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					}
					else
					{

						if ( wield->value[0] == sstance_table[i-1].primeWeapon )
						{
							bonus += sstance_table[i-1].primeBonus;
						}
						else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
						{
							bonus += ( sstance_table[i-1].secondaryBonus / 2 );
						}
						else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
						{
							bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
						}
						if ( bonus <= 0 )
						{
							stc("You must be doing something wrong.\n\r", ch);
							return;
						}

						ptc( ch, "You set to defend with %s, though you feel a bit clumsy with it.\n\r",
							sstance_table[i-1].nameLong[x-1] );
						SET_BIT( ch->def_sforms_flags, sstance_table[i-1].form );
						SET_BIT( ch->def_sub_sforms_flags, sstance_table[i-1].subForm[x-1] );
					}
					hasForm = TRUE;
					break;
				}
			}
			if ( i == MaxStance && !hasForm )
			{
				stc( "Unknown spearform. See Forms Short for a list of\n\r", ch );
				stc( "valid form abbreviations.\n\r", ch );
				break;
			}
			if ( hasForm )
				break;
		}
		return;
	}
	if ( !str_prefix( arg1, "display" ) )
	{

		OBJ_DATA *wield;
		int wieldType = 0, bonus = 0;

		stc("Buggy command...\n\r",ch);
		return;

		wield = get_eq_char( ch, WEAR_WIELD );
		if ( wield == NULL )
		{
			stc("You must wield a weapon.\n\r", ch);
			return;
		}

		dispBuf1[0] = '\0';
		dispBuf2[0] = '\0';
		disp = number_range( 2, 5 );
		skillPerc = 0;
		free_string( dispBuf1 );
		free_string( dispBuf2 );

		for ( count = 1; count <= disp; count++ )
		{
			i = number_range( 1, MaxStance );
			x = number_range( 1,5 );
			flows = number_range( 1,5 );
			flows2 = number_range( 1,5 );
			grace = 1;

			skill = skill_lookup(sstance_table[i-1].realName);
			skillPerc = get_skill( ch, skill );

			/*if ( skillPerc <= 0 )
				continue;*/

			if ( wield->value[0] == sstance_table[i-1].primeWeapon )
			{
				wieldType = get_weapon_sn(ch);
				bonus += sstance_table[i-1].primeBonus;
			}
			else if ( wield->value[0] == sstance_table[i-1].secondWeapon )
			{
				wieldType = get_weapon_sn(ch);
				bonus += ( sstance_table[i-1].secondaryBonus / 2 );
			}
			else if ( wield->value[0] == sstance_table[i-1].tertWeapon )
			{
				wieldType = get_weapon_sn(ch);
				bonus += ( sstance_table[i-1].tertiaryBonus / 3 );
			}
			if ( bonus <= 0 )
			{
				stc("You must be doing something wrong.\n\r", ch);
				return;
			}
			if ( IS_SET( ch->op_flags, OP_CHANNELER ) )
			{
				if ( bonus > 5 )
					bonus /= 2;
			}

			points += bonus;
			points += skillPerc;
			grace = (1 * points );
			grace /= 100;
			grace = number_range( grace -1, grace +1 );
			if ( grace < 1 )
				grace = 1;
			if ( grace > 10 )
				grace = 10;

			if ( count == 1 )
			{
				if ( ch->sex == SEX_MALE )
				{
					if ( points <= 99 )
						strcat( dispBuf1, MasteryOneM );
					else if ( points <= 199 )
						strcat( dispBuf1, MasteryTwoM );
					else if ( points <= 299 )
						strcat( dispBuf1, MasteryThreeM );
					else if ( points <= 399 )
						strcat( dispBuf1, MasteryFourM );
					else if ( points <= 499 )
						strcat( dispBuf1, MasteryFiveM );
					else if ( points <= 599 )
						strcat( dispBuf1, MasterySixM );
					else if ( points <= 699 )
						strcat( dispBuf1, MasterySevenM );
					else if ( points <= 799 )
						strcat( dispBuf1, MasteryEightM );
					else if ( points <= 899 )
						strcat( dispBuf1, MasteryNineM );
					else if ( points <= 999 || points > 999 )
						strcat( dispBuf1, MasteryTenM );
				}
				if ( ch->sex == SEX_FEMALE )
				{
					if ( points <= 99 )
						strcat( dispBuf1, MasteryOneF );
					else if ( points <= 199 )
						strcat( dispBuf1, MasteryTwoF );
					else if ( points <= 299 )
						strcat( dispBuf1, MasteryThreeF );
					else if ( points <= 399 )
						strcat( dispBuf1, MasteryFourF );
					else if ( points <= 499 )
						strcat( dispBuf1, MasteryFiveF );
					else if ( points <= 599 )
						strcat( dispBuf1, MasterySixF );
					else if ( points <= 699 )
						strcat( dispBuf1, MasterySevenF );
					else if ( points <= 799 )
						strcat( dispBuf1, MasteryEightF );
					else if ( points <= 899 )
						strcat( dispBuf1, MasteryNineF );
					else if ( points <= 999 || points > 999 )
						strcat( dispBuf1, MasteryTenF );
				}
			}
			/* buf1 = message to the room */
			if ( count == 1 )
			{
				strcat( dispBuf1, " " );
				strcat( dispBuf1, capit2( ch->name ) );
			}
			else
				strcat( dispBuf1, "then " );
			strcat( dispBuf1, " " );
			strcat( dispBuf1, flow[flows-1] );
			strcat( dispBuf1, " " );
			strcat( dispBuf1, graceful[grace-1] );
			strcat( dispBuf1, " into the form " );
			strcat( dispBuf1, sstance_table[i-1].nameLong[x-1] );
			if ( ch->pcdata->rebirth - x < sstance_table[i-1].rbi )
			{
				strcat( dispBuf1, ", but stumbles a bit" );
			}
			if ( count == disp )
				strcat( dispBuf1, "." );
			else
				strcat( dispBuf1, ", " );

			/* buf2 = message to the char */
			if ( count == 1 )
				strcat( dispBuf2, "You " );
			else
				strcat( dispBuf2, "then " );
			strcat( dispBuf2, flow2[flows2-1] );
			strcat( dispBuf2, " into the form " );
			strcat( dispBuf2, sstance_table[i-1].nameLong[x-1] );
			if ( ch->pcdata->rebirth - x < sstance_table[i-1].rbi )
			{
				strcat( dispBuf2, ", then stumble a bit" );
			}
			if ( count == disp )
				strcat( dispBuf2, "." );
			else
				strcat( dispBuf2, ", " );

			if ( skillPerc > 0 )
				check_improve( ch, skill_lookup(sstance_table[i-1].realName), TRUE, 1 );

		}
		if ( dispBuf1[0] != '\0' && dispBuf2[0] != '\0' )
		{
			buffer1 = format_string( dispBuf1 );
			buffer2 = format_string( dispBuf2 );
			act( buffer1, ch, NULL, NULL, TO_ROOM );
			act( buffer2, ch, NULL, NULL, TO_CHAR );
		}
		else
			stc( "You lack the knowledge.\n\r", ch );

		WAIT_STATE( ch, PULSE_VIOLENCE * 3 );

		return;
	}
	else
	{
		stc( "{WSyntax:{x\n\r", ch );
		stc( "{RSpearForms Short{x\n\r", ch );
		stc( "{w  Provides a listing of the form groups and abbreviated{x\n\r", ch );
		stc( "{w  names of the forms. The abbreviated name is provided{x\n\r", ch );
		stc( "{w  when setting or changing the current form.{x\n\r", ch );
		stc( "{RSpearForms Full{x\n\r", ch );
		stc( "{w  Provides a complete list of all groups and forms with{x\n\r", ch );
		stc( "{w  abbreviated names and descriptive names.{x\n\r", ch );
		stc( "{RSpearForms Offensive <form short name>{x\n\r", ch );
		stc( "{w  Set the offensive form to the abbreviated name.{x\n\r", ch );
		stc( "{RSpearForms Defensive <form short name>{x\n\r", ch );
		stc( "{w  Set the defensive form to the abbreviated name.{x\n\r", ch );
		stc( "{RSpearForms Clear{x\n\r", ch );
		stc( "{w  Clears both offensive and defensive forms.{x\n\r", ch );
		stc( "{RSpearForms Help{x\n\r", ch );
		stc( "{w  Provides help on using forms.{x\n\r", ch );
		stc( "{RSpearForms Specifics{x\n\r", ch );
		stc( "{w  Provides more detailed information on forms.{x\n\r", ch );
		stc( "{RSpearForms Display{x\n\r", ch );
		stc( "{w  Performs a 'kata' based on known forms.{x\n\r", ch );
		stc( "{RSpearForms Show{x\n\r", ch );
		stc( "{w  Displays the current forms set.{x\n\r", ch );
		return;
	}
	return;
}
