/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "tables.h"

/*
 * The following special functions are available for mobiles.
 */
DECLARE_SPEC_FUN(	spec_cast_adept		);
DECLARE_SPEC_FUN(	spec_cast_cleric	);
DECLARE_SPEC_FUN(	spec_weave_damane	);
DECLARE_SPEC_FUN(   spec_questmaster    );   /* Vassago */
DECLARE_SPEC_FUN(	spec_thief		    );
DECLARE_SPEC_FUN(	spec_puff		    );
DECLARE_SPEC_FUN(	spec_bizcax		    );
DECLARE_SPEC_FUN(	spec_poison		    );
DECLARE_SPEC_FUN(	spec_darkhound	    );
DECLARE_SPEC_FUN(	spec_registar	    );
DECLARE_SPEC_FUN(	spec_caem_gCapt	    );
DECLARE_DO_FUN(do_mobforms);
/* the function table */
const   struct  spec_type    spec_table[] =
{
    {	"spec_cast_adept",		spec_cast_adept		    },
    {	"spec_cast_cleric",		spec_cast_cleric	    },
    {   "spec_weave_adept",     spec_cast_adept         },
    {   "spec_weave_damane",    spec_weave_damane        },
    {   "spec_questmaster",     spec_questmaster        },
    {   "spec_thief",           spec_thief              },
    {   "spec_puff",            spec_puff               },
    {   "spec_bizcax",          spec_bizcax             },
    {   "spec_poison",          spec_poison             },
    {   "spec_darkhound",       spec_darkhound          },
    {   "spec_registar",        spec_registar           },
    {   "spec_caem_gCapt",      spec_caem_gCapt         },
    {	NULL,				NULL			}
};

/*
 * Given a name, return the appropriate spec fun.
 */
SPEC_FUN *spec_lookup( const char *name )
{
   int i;

   for ( i = 0; spec_table[i].name != NULL; i++)
   {
        if (LOWER(name[0]) == LOWER(spec_table[i].name[0])
        &&  !str_prefix( name,spec_table[i].name))
            return spec_table[i].function;
   }

    return 0;
}

char *spec_name( SPEC_FUN *function)
{
    int i;

    for (i = 0; spec_table[i].function != NULL; i++)
    {
	if (function == spec_table[i].function)
	    return spec_table[i].name;
    }

    return NULL;
}

void march_halt( CHAR_DATA *ch )
{
	act( "{g$n barks, {G'{gParade, halt!{G'{x", ch, NULL, NULL, TO_ROOM );
	act( "The guards following the Captain stop and stand at stiff attention.", ch, NULL, NULL, TO_ROOM );
	return;
}
bool chance args( ( int num ) );
bool spec_caem_gCapt(CHAR_DATA * ch)
{
	CHAR_DATA *pers;
	OBJ_DATA *pipe, *pipe_next;
	bool has_pipe = FALSE;
	extern int social_count;
	int i, x, y, z, att, socs = 10, rndSoc;
	/* these are all socials that can be targetted */
	char *socTArray [] = {
		"growl", "ahem", "mutter", "blownose", "smirk", "squint", "ruffle", "pounce", "egrin", "scowl"
	};
	/* these are the targetted flirts he will use to 'attract/repel' women */
	char *socFArray [] = {
		"whistle", "flirt", "lgrin", "tip", "fstar", "serenade", "bashful", "boast", "adore", "rose"
	};

	rndSoc = ( number_range ( 0, ( social_count - 1 ) ) );
	i = number_range( 1, 100 );
	x = number_range( 1, 4 );
	y = number_range( 1, 100 );
	z = number_range( 1, 6 );
	att = number_range( 1, 5 );

	if ( is_fighting(ch) )
	{
		if ( ch->advancing == FALSE )
			return FALSE;
		if ( ch->advancing_on == NULL )
			return FALSE;
		if ( ch->range < RANGE_MISSLE )
			return FALSE;
		switch ( att )
		{
			case 1:
			    do_function( ch, &do_bash, "");
			break;
			case 2:
				do_function( ch, &do_wear, "longsword" );
			    do_function( ch, &do_disarm, "");
				do_function( ch, &do_remove, "longsword" );
			break;
			case 3:
			    do_function( ch, &do_kick, "");
			break;
			case 4:
			    do_function(ch, &do_dirt, "");
			break;
			case 5:
			    do_function(ch, &do_mobforms, "");
			break;
		}
		return FALSE;
	}
	if ( i < 95 )
		return FALSE;
	if ( i < 85 && chance( 20 ) )
	{
		char socBuf[MIL];
		int rSoc = number_range( 1, socs );
		/* we don't check for pers = ch cause we want him to act goofy sometimes */
		for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
		{
			/* is pers is a true newbie, he might give them stuff */
			if ( !IS_NPC( pers ) && pers->level < 20 && pers->pcdata->newbie == 1 )
			{
				return FALSE;
			}

			/* he's a gentleman, so he wont social them unless to flirt */
			if ( chance ( 20 ) && pers->sex != SEX_FEMALE )
			{
				sprintf( socBuf, "%s %s", socTArray[rSoc-1], pers->name );
				interpret( ch, socBuf );
				break;
			}
			/* let him flirt */
			else if ( chance ( 20 ) && pers->sex == SEX_FEMALE )
			{
				sprintf( socBuf, "%s %s", socFArray[rSoc-1], pers->name );
				interpret( ch, socBuf );
				break;
			}
			/* sometime he'll just spit out a social */
			else if ( chance( 20 ) )
			{
				act( social_table[rndSoc].others_no_arg, ch, NULL, NULL, TO_ROOM );
				break;
			}
		}
		return FALSE;
	}

	if ( ch->position == POS_RESTING )
	{
		do_stand( ch, "" );
	}
	switch( y )
	{
		default:
		break;
		case 1:
			if ( ch->position == POS_RESTING )
			do_appraise( ch, "sword" );
		break;

		case 2:
			act( "$n absently scratches at the beard covering his chin, obviously deep in thought.", ch, NULL, NULL, TO_ROOM );
		break;

		case 3:
			act( "$n casts a searching gaze across the people in the crowd.", ch, NULL, NULL, TO_ROOM );
			if ( chance( 50 ) )
			{
				for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
				{
					if ( !IS_NPC( pers ) )
						continue;
					if ( pers )
						break;
				}
				if ( pers && IS_NPC( pers ) && pers->pIndexData && pers->pIndexData->vnum == 3220 )
				{
					act( "{g$n shouts, {G'{gHey $N! No loitering! Get a move on!{G'{x", ch, NULL, pers, TO_ROOM );
					do_west( pers, "" );
				}
				if ( pers && IS_NPC( pers ) && pers->pIndexData && pers->pIndexData->vnum == 3109 )
				{
					act( "{g$n shouts, {G'{gHey $N! No loitering! Get a move on!{G'{x", ch, NULL, pers, TO_ROOM );
					do_north( pers, "" );
				}
				if ( pers && IS_NPC( pers ) && pers->pIndexData && pers->pIndexData->vnum == 3220 )
				{
					act( "{g$n shouts, {G'{gHey $N! No loitering! Get a move on!{G'{x", ch, NULL, pers, TO_ROOM );
					do_south( pers, "" );
				}
				if ( pers && IS_NPC( pers ) && pers->pIndexData && pers->pIndexData->vnum == 3219 )
				{
					act( "{g$n shouts, {G'{gYou there $N! No loitering! Get a move on!{G'{x", ch, NULL, pers, TO_ROOM );
					do_east( pers, "" );
				}
			}
		break;

		case 4:
			if ( ch->in_room && ch->in_room->vnum == 3001 )
			{
				switch( x )
				{
					case 1: /* goto 3003 */
						act( "{g$n barks, {G'{gParade, turn! Face... East!{G'{x", ch, NULL, NULL, TO_ROOM );
						act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
						act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
						do_east( ch, "" );
					break;
					case 2: /* goto 3005 */
						act( "{g$n barks, {G'{gParade, turn! Face... South!{G'{x", ch, NULL, NULL, TO_ROOM );
						act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
						act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
						do_south( ch, "" );
					break;
					case 3: /* goto 3004 */
						act( "{g$n barks, {G'{gParade, turn! Face... West!{G'{x", ch, NULL, NULL, TO_ROOM );
						act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
						act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
						do_west( ch, "" );
					break;
					case 4: /* goto 3002 */
						act( "{g$n barks, {G'{gParade, turn! Face... North!{G'{x", ch, NULL, NULL, TO_ROOM );
						act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
						act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
						do_north( ch, "" );
					break;
				}
				return TRUE;
			}
			if ( ch->in_room && ch->in_room->vnum == 3003 ) /* bank entrance */
			{
				march_halt( ch );
				do_enter( ch, "door" );
				act( "$n, Captain of the Guard, glances casually about the room.", ch, NULL, NULL, TO_ROOM );
				if ( ch->in_room->people != NULL )
					wait_function( ch, 2, do_say, "Peace be on the people of Caemlyn." );
				wait_function( ch, 2, do_enter, "door" );
				wait_act( 4, "{g$n barks, {G'{gParade, turn! Face... West!{G'{x", ch, NULL, NULL, TO_ROOM );
				wait_act( 4, "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
				wait_act( 4, "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
				wait_function( ch, 4, do_west, "" );
				return TRUE;
			}
			if ( ch->in_room && ch->in_room->vnum == 3005 ) /* south plaza */
			{
				act( "{gThe Captain barks, {G'{gParade, turn! Face... North!{G'{x", ch, NULL, NULL, TO_ROOM );
				act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
				act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
				do_north( ch, "" );
				return TRUE;
			}
			if ( ch->in_room && ch->in_room->vnum == 3004 ) /* pawn entrance */
			{
				march_halt( ch );
				do_enter( ch, "tent" );
				act( "{g$n, Captain of the Guard, glances casually about the room.", ch, NULL, NULL, TO_ROOM );
				if ( ch->in_room->people != NULL )
					wait_function( ch, 2, do_say, "Peace be on the people of Caemlyn." );
				wait_function( ch, 2, do_north, "" );
				wait_act( 4, "{g$n barks, {G'{gParade, turn! Face... East!{G'{x", ch, NULL, NULL, TO_ROOM );
				wait_act( 4, "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
				wait_act( 4, "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
				wait_function( ch, 4, do_east, "" );
				return TRUE;
			}
			if ( ch->in_room && ch->in_room->vnum == 3002 ) /* north plaza */
			{
				act( "{g$n barks, {G'{gParade, turn! Face... South!{G'{x", ch, NULL, NULL, TO_ROOM );
				act( "The guards following $n turn with a click of their boot heels.", ch, NULL, NULL, TO_ROOM );
				act( "{g$n barks, {G'{gMarch!{G'{x", ch, NULL, NULL, TO_ROOM );
				do_south( ch, "" );
				return TRUE;
			}
		break;

		case 5:
			if ( ch->in_room && ch->in_room->vnum == 3001 )
			{
				if( chance( 50 ) )
					act( "{g$n mutters, {G'{gToo much marching today. Worked up a good thirst...{G'{x", ch, NULL, NULL, TO_ROOM );
				else
					act( "{g$n says, {G'{gCan you believe this heat lately? Seems... Unnatural.{G'{x", ch, NULL, NULL, TO_ROOM );
				do_drink( ch, "fountain" );
				return TRUE;
			}
		break;

		case 6:
			if ( ch->in_room && ch->in_room->vnum == 3001 )
			{
				if ( chance( 50 ) )
				{
					do_rest( ch, "bench" );
					act( "{g$n asks, {G'{gWhat? You think I'm going to stand on my flaming feet all bloody day?{G'{x", ch, NULL, NULL, TO_ROOM );
					return TRUE;
				}
				else
				{
					do_rest( ch, "bench" );
					act( "{g$n says, {G'{gAll this marching is murder on my feet and back.{G'{x", ch, NULL, NULL, TO_ROOM );
					return TRUE;
				}
			}
		break;

		case 7:
			do_search( ch, "" );
			return TRUE;
		break;

		case 8:
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers )
			{
				if( chance( 50 ) )
					act( "{g$n growls, {G'{gWhat are you looking at $N?{G'{x", ch, NULL, pers, TO_ROOM );
				else
					act( "{g$n asks, {G'{gDon't you ever get tired of just sitting around here, $N?{G'{x", ch, NULL, pers, TO_ROOM );
			}
			return TRUE;
		break;

		case 9:
			if ( ch->in_room && ch->in_room->vnum == 3001 ) /* north plaza */
				act( "$n idly traces a finger through the waters of {Wan {wo{Wval {ws{Whaped {wf{Wountain{x.", ch, NULL, NULL, TO_ROOM );
			return TRUE;
		break;

		case 10:
			for ( pipe = ch->carrying; pipe != NULL; pipe = pipe_next )
			{
			    pipe_next = pipe->next_content;
			    if ( pipe->item_type == ITEM_PIPE_TABAC )
			    {
			    	has_pipe = TRUE;
			    	break;
			    }
			}
			if ( has_pipe )
			{
				switch( z )
				{
					case 1:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "rings" );
						if( chance ( 20 ) )
							wait_act( 4, "{g$n smiles and says, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
					case 2:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "lines" );
						if ( chance( 20 ) )
							wait_act( 4, "{g$n coughs, then laughs and says, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
					case 3:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "balls" );
						if ( chance( 20 ) )
							wait_act( 4, "{g$n says with a smirk, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
					case 4:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "web" );
						if ( chance( 20 ) )
							wait_act( 4, "{g$n says around a mouthful of smoke, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
					case 5:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "phoenix" );
						if( chance( 20 ) )
							wait_act( 4, "{g$n grins and says, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
					case 6:
						do_smoke( ch, "pipe" );
						wait_function( ch, 3, do_exhale, "horns" );
						if ( chance( 20 ) )
							wait_act( 4, "{g$n coughs a little and says, {G'{gNow that's the good stuff.{G'{x", ch, NULL, NULL, TO_ROOM );
					break;
				}
				return TRUE;
			}
			else
			{
				OBJ_INDEX_DATA *pObj;
				act( "{g$n mutters, {G'{gI'll have to go see Jakob about getting some more tabac for my pipe...{G'{x", ch, NULL, NULL, TO_ROOM );
			    act( "{c$n beseeches transportation and receives it.{c", ch, NULL, NULL, TO_ROOM );
			    char_from_room( ch );
			    char_to_room( ch, get_room_index( ROOM_VNUM_PLAZA ) );
			    act( "{c$n appears in the room, trembling from some horrible experience, and collapses.{c", ch, NULL, NULL, TO_ROOM );
			    act( "{c$n stands up.{c", ch, NULL, NULL, TO_ROOM );
			    do_west( ch, "" );
			    do_west( ch, "" );
			    do_open( ch, "north" );
			    do_north( ch, "" );

				pObj = get_obj_index( 3198 );
				pipe = create_object( pObj, 1 );
				obj_to_char( pipe, ch );
			    act( "{c$n buys $p.", ch, pipe, NULL, TO_ROOM );

			    do_open( ch, "south" );
			    do_south( ch, "" );
			    do_east( ch, "" );
			    do_east( ch, "" );
			}
			return TRUE;
		break;

		case 11:
			if ( ch->in_room && ch->in_room->vnum == 3005 ) /* south plaza */
			{
				act( "{g$n growls, {G'{gFlaming peddlers are taking over the city these days.{G'{x", ch, NULL, NULL, TO_ROOM );
				for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
				{
					if ( !IS_NPC( pers ) )
						continue;
					if ( pers && IS_NPC( pers ) && pers->pIndexData && pers->pIndexData->vnum == 3000 )
						break;
				}
				if ( pers )
				{
					act( "{W$n grunts sourly at an old peddler.{x", ch, NULL, pers, TO_ROOM );
					wait_act( 2, "{WAn old peddler scratches his head in bewilderment.{x", pers, NULL, NULL, TO_ROOM );
				}
			}
		break;

		case 12:
			if ( weather_info.sky == SKY_RAINING )
				act( "{g$n says, {G'{gBloody rain needs to let up a bit and let a man do his job.{G'{x", ch, NULL, NULL, TO_ROOM );
		break;

		case 13:
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers )
			{
				if ( chance( 20 ) && !str_cmp( clan_table[pers->clan].name, "loner" ) )
					act("{g$n says, {G'{g$N{g! I hear the Thief Takers looking for new recruits. You should see about joining.{G'{x", ch, NULL, pers, TO_ROOM);
				else if ( chance( 20 ) && !str_cmp( clan_table[pers->clan].name, "loner" ) )
					act( "{g$n says, {G'{gYou seem hale enough, $N{g. You should look into joining the Queen's Guard.{G'{x", ch, NULL, pers, TO_ROOM );
				else if ( chance( 20 ) && !str_cmp( clan_table[pers->clan].name, "loner" ) )
					act( "{g$n says, {G'{gYou should look into joining the Queen's Guard, $N{g.{G'{x", ch, NULL, pers, TO_ROOM );
				else if ( chance( 20 ) && !str_cmp( clan_table[pers->clan].name, "loner" ) )
					act( "{g$n says, {G'{gThe Band of the Red Hand was here recently, $N{g. Maybe that's the life for you.{G'{x", ch, NULL, pers, TO_ROOM );

				else if ( chance( 20 ) && !str_cmp( clan_table[pers->clan].name, "aessedai" ) )
				{
					if( chance( 50 ) )
						act( "{g$n says, {G'{gLight illumine you, m'lady $N.{G'{x", ch, NULL, pers, TO_ROOM );
					else
						act( "{g$n says with a bow, {G'{gYou honor Caemlyn with your presence, Lady $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "warder" )
				|| !str_cmp( clan_table[pers->clan].name, "youngling" )
				|| !str_cmp( clan_table[pers->clan].name, "towerguard" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says, {G'{gStrength for your sword, Lord $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( chance( 20 ) && pers->race == race_lookup( "malkier" ) )
				{
					if (pers->sex == SEX_FEMALE)
						act( "{g$n says, {G'{gI had heard the Golden Crane flew again. Grace favor you, Lady $N.{G'{x", ch, NULL, pers, TO_ROOM );
					else
						act( "{g$n says, {G'{gI had heard the Golden Crane flew again. Grace favor you, Lord $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( pers->race == race_lookup( "kandor" )
				|| pers->race == race_lookup( "arafel" )
				|| pers->race == race_lookup( "shienar" )
				|| pers->race == race_lookup( "saldaea" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n asks, {G'{gLong way down from the borderlands, aren't you, $N?{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( ch->race == race_lookup( "tuathaan" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says, {G'{gFlaming tinkers... Don't be trying to snatch any children around here, $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "ogier" )
				|| !str_cmp( clan_table[pers->clan].name, "elder" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says in an old language, {G'{gKiserai ti Wansho! We welcome you to Caemlyn, $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "thieftaker" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says, {G'{gThe Thief Takers are welcome in Caemlyn, $N.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "blightguard" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says, {G'{gA long way from the blight border aren't you, $N?{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "band" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n says, {G'{gHey, $N{g! Want to meet me at the Crown for an ale later tonight?{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "children" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n mutters, {G'{gThe Children of the Light hold no writ in Caemlyn, $N{g...{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "gleeman" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n exclaims, {G'{gHai, $N{g! Are you putting on a show hereabouts?{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( !str_cmp( clan_table[pers->clan].name, "ashaman" ) )
				{
					if ( chance( 20 ) )
						act( "{g$n mutters, {G'{g$N{g, why don't you take yourself back to your mad brothers in that forsaken Tower?{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( chance( 20 ) && pers->race == race_lookup( "aiel" ) )
				{
					act( "{g$n mutters, {G'{gAiel in Caemlyn... Not starting another war are you, $N?{G'{x", ch, NULL, pers, TO_ROOM );
					if( chance( 50 ) )
						act( "{g$n says, {G'{gIf you are, take it up to Cairhien. Heard there was some of your kind up that way already.{G'{x", ch, NULL, pers, TO_ROOM );
					else
						act( "{g$n says, {G'{gI still got scars from the last time your kind came down looking for trouble.{G'{x", ch, NULL, pers, TO_ROOM );
				}
				else if ( chance( 20 ) && pers->race == race_lookup( "trolloc" ) )
				{
					act( "{g$n shouts, {G'{gTrollocs are in Caemlyn! Rouse the guard!{G'{x", ch, NULL, pers, TO_ROOM );
				}
			}
			return TRUE;
		break;
		case 14:
			if ( chance( 20 ) )
			{
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers && pers->position <= POS_SITTING )
			{
				wait_act( 2, "{g$n mutters, {G'{gBloody flaming layabouts loitering in the Plaza...{G'{x", ch, NULL, pers, TO_ROOM );
			}
			}
		break;
                case 15:
			if ( chance( 20 ) )
			{
                        for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
                        {
                                if ( IS_NPC( pers ) )
                                        continue;
                                if ( pers->incog_level > 0 || pers->invis_level > 0 )
                                        continue;
                                if ( pers )
                                        break;
                        }
                        if ( pers && pers->position <= POS_SITTING )
                        {
                                wait_act( 2, "{g$n asks, {G'{gHey $N{g, how do you get an Amadician out of a tree?{G'{x", ch, NULL, pers, TO_ROOM );
				wait_act( 4, "{g$n roars with laughter, {G'{gYou cut the rope!{G'{x", ch, NULL, pers, TO_ROOM );
                        }
			}
                break;
		case 16:
			if ( chance( 20 ) )
			{
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers )
			{
				wait_act( 2, "{g$n says, {G'{gHey $N{g, I used to be an adventurer like you, then I took an arrow to the knee.{G'{x", ch, NULL, pers, TO_ROOM );
			}
			}
		break;

                case 17:
			if ( chance( 20 ) )
			{
                        for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
                        {                                
				if ( IS_NPC( pers ) )
                                        continue;
                                if ( pers->incog_level > 0 || pers->invis_level > 0 )
                                        continue;
                                if ( pers )
                                        break;
                        }
                        if ( pers && WOLF(pers) )
                        {
                                wait_act( 2, "{g$n says, {G'{gI find your wolfish grin... unsettling, $N.{G'{x", ch, NULL, pers, TO_ROOM );
                        }
			}                
		break;

                case 18:
			if ( chance( 20 ) )
			{
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
                                if ( IS_NPC( pers ) )                                        
					continue;
                                if ( pers->incog_level > 0 || pers->invis_level > 0 )
                                        continue;
                                if ( pers )
                                        break;
                        }
                        if ( pers && pers->pcdata && pers->pcdata->rebirth > 25 ) /* past the first tier */
                        {
                                wait_act( 2, "{g$n says, {G'{gThere is talk among the people about you, $N.{G'{x", ch, NULL, pers, TO_ROOM );
			}
			}
                break;

                case 19:
			if ( chance( 20 ) )
			{
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers ) /* past the first tier */
                        {
                                wait_act( 2, "{g$n smirks and says, {G'{gLet me guess, $N{g. Someone stole your sweetroll.{G'{x", ch, NULL, pers, TO_ROOM );
                        }
			}
		break;


                case 20:
			if ( chance( 20 ) )
			{
			for ( pers = ch->in_room->people; pers != NULL; pers = pers->next_in_room )
			{
				if ( IS_NPC( pers ) )
					continue;
				if ( pers->incog_level > 0 || pers->invis_level > 0 )
					continue;
				if ( pers )
					break;
			}
			if ( pers  )
			{
				wait_act( 2, "{g$n says, {G'{gDisrespect the law, $N{g, and you disrespect me.{G'{x", ch, NULL, pers, TO_ROOM );
			}
			}
                break;

	}

    return FALSE;
}

bool spec_registar(CHAR_DATA * ch)
{
    if (is_fighting(ch))
	return spec_weave_damane(ch);
    return FALSE;
}

bool spec_questmaster (CHAR_DATA *ch)
{
    if (is_fighting(ch)) return spec_cast_adept( ch );
    return FALSE;
}

bool spec_cast_adept( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    CHAR_DATA *v_next;
    int range = number_range( 1, 7 );

    if ( !IS_AWAKE(ch) )
	return FALSE;

    for ( victim = ch->in_room->people; victim != NULL; victim = v_next )
    {
		v_next = victim->next_in_room;
		if ( victim != ch
		&& can_see( ch, victim )
		&& number_bits( 1 ) == 0
		&& !IS_NPC(victim)
		&& victim->level < 20)
	    break;
    }

    if ( victim == NULL )
	return FALSE;

    switch ( range )
    {
    case 1:
        act( "$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
		weave_defense( skill_lookup( "defense" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 2:
        act( "$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
		weave_vigor( skill_lookup( "vigor" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 3:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
		weave_heal( skill_lookup( "heal" ),ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 4:
        act("$n channels the One Power.", ch,NULL, NULL, TO_ROOM );
		weave_cure_light( skill_lookup( "cure light" ),ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 5:
        act( "$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
        weave_shield( skill_lookup( "shield" ),ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 6:
        act("$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
        weave_cure_serious( skill_lookup( "cure serious" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 7:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
		weave_cure_critical(skill_lookup("cure critical"),ch->level,ch,victim,TARGET_CHAR);
    }

    return FALSE;
}

bool spec_weave_damane( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    CHAR_DATA *v_next;

    if ( !IS_AWAKE(ch) )
	return FALSE;

    return FALSE;
    for ( victim = ch->in_room->people; victim != NULL; victim = v_next )
    {
	v_next = victim->next_in_room;
	if ( victim != ch && can_see( ch, victim ) && number_bits( 1 ) == 0
	     && !IS_NPC(victim) )
	    break;
    }

    if ( victim == NULL )
	return FALSE;

    switch ( number_range( 1, 10 ) )
    {
    case 1:
        act( "$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
	weave_defense( skill_lookup( "thunder blast" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 2:
        act( "$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
	weave_vigor( skill_lookup( "thunder lance" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 3:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_blinding( skill_lookup( "thunder strike" ),
	    ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 4:
        act("$n channels the One Power.", ch,NULL, NULL, TO_ROOM );
	weave_cure_light( skill_lookup( "spirit shatter" ),
	    ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 5:
        act( "$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_poison( skill_lookup( "spirit hammer" ),
	    ch->level, ch, victim,TARGET_CHAR);
	return TRUE;

    case 6:
        act("$n channels the One Power.", ch, NULL, NULL, TO_ROOM );
        weave_vigor( skill_lookup( "spirit fist" ), ch->level,ch,victim,TARGET_CHAR);
	return TRUE;

    case 7:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_disease(skill_lookup("fire bolt"),
	    ch->level,ch,victim,TARGET_CHAR);

    case 8:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_disease(skill_lookup("geyser"),
	    ch->level,ch,victim,TARGET_CHAR);

    case 9:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_disease(skill_lookup("drown"),
	    ch->level,ch,victim,TARGET_CHAR);

    case 10:
        act("$n channels the One Power.",ch,NULL,NULL,TO_ROOM);
	weave_cure_disease(skill_lookup("drown"),
	    ch->level,ch,victim,TARGET_CHAR);
    }

    return FALSE;
}

bool spec_cast_cleric( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    CHAR_DATA *v_next;
    char *spell;
    int sn;

    if ( ch->position != POS_FIGHTING )
	return FALSE;

    for ( victim = ch->in_room->people; victim != NULL; victim = v_next )
    {
	v_next = victim->next_in_room;
	if ( check_fighting(ch, victim) && number_bits( 2 ) == 0 )
	    break;
    }

    if ( victim == NULL )
	return FALSE;

    for ( ;; )
    {
	int min_level;

	switch ( number_bits( 4 ) )
	{
	default: min_level = 16; spell = "flog";   break;
	}

	if ( ch->level >= min_level )
	    break;
    }

    if ( ( sn = skill_lookup( spell ) ) < 0 )
	return FALSE;
    (*skill_table[sn].spell_fun) ( sn, ch->level, ch, victim,TARGET_CHAR);
    return TRUE;
}

bool spec_poison( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    int level;
    AFFECT_DATA af;

	level = ch->level;

	if(!is_fighting(ch))
		return FALSE;

    if ( ch->position != POS_FIGHTING
    || ( victim = ch->advancing_on ) == NULL
    ||   number_percent( ) > 2 * ch->level )
	return FALSE;

    act( "You bite $N!",  ch, NULL, victim, TO_CHAR    );
    act( "$n bites $N!",  ch, NULL, victim, TO_NOTVICT );
    act( "$n bites you!", ch, NULL, victim, TO_VICT    );
    if (!saves_spell(level / 2,victim,DAM_POISON))
    {
		stc("{RYou feel poison coursing through your veins.{c\n\r", victim);
   		af.where     = TO_AFFECTS;
   		af.type      = gsn_poison;
   		af.level     = level * 3/4;
   		af.duration  = level / 2;
   		af.location  = APPLY_STR;
   		af.modifier  = -1;
   		af.bitvector = AFF_POISON;
   		affect_join( victim, &af );
    }

    /*spell_poison( gsn_poison, ch->level, ch, victim );*/
    return TRUE;
}



bool spec_thief( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    CHAR_DATA *v_next;
    long gold;

    if ( ch->position != POS_STANDING )
	return FALSE;

    for ( victim = ch->in_room->people; victim != NULL; victim = v_next )
    {
	v_next = victim->next_in_room;

	if ( IS_NPC(victim)
	||   victim->level >= LEVEL_IMMORTAL
	||   number_bits( 5 ) != 0
	||   !can_see(ch,victim))
	    continue;

	if ( IS_AWAKE(victim) && number_range( 0, ch->level ) == 0 )
	{
	    act( "You discover $n's hands in your wallet!",
		ch, NULL, victim, TO_VICT );
	    act( "$N discovers $n's hands in $S wallet!",
		ch, NULL, victim, TO_NOTVICT );
	    return TRUE;
	}
	else
	{
	    gold = victim->money[0][0] * UMIN(number_range( 1, 20 ),ch->level) / 100;
	    gold = UMIN(gold, ch->level * ch->level * 20 );
	    ch->money[0][0]     += gold;
	    victim->money[0][0] -= gold;
	    return TRUE;
	}
    }

    return FALSE;
}

bool spec_bizcax( CHAR_DATA *ch )
{
char buf[MAX_STRING_LENGTH];
	int rnd_social, silliness;
	bool pc_found = TRUE;
    CHAR_DATA *wch;
    CHAR_DATA *wch_next;
    CHAR_DATA *nch;
    CHAR_DATA *ch_next;
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    CHAR_DATA *victim;
	extern int social_count;

	if ( !IS_AWAKE(ch) )
		return FALSE;

	victim = NULL;

    for ( wch = char_list; wch != NULL; wch = wch_next )
    {
		wch_next = wch->next;
		if ( IS_NPC(wch)
		||   wch->in_room == NULL )
		    continue;

		for ( nch = wch->in_room->people; nch != NULL; nch = ch_next )
		{
		    int count;
		    ch_next	= nch->next_in_room;
		    if ( !IS_NPC(nch)
		    ||   number_bits(1) == 0)
			continue;
		    count	= 0;
		    victim	= NULL;
		    for ( vch = wch->in_room->people; vch != NULL; vch = vch_next )
		    {
				vch_next = vch->next_in_room;
				if ( !IS_NPC(vch) )
				{
				    if ( number_range( 0, count ) == 0 )
					victim = vch;
				    count++;
				}
		    }

		    if (victim == NULL)
				return FALSE;
		}

	}
	rnd_social = (number_range (0, ( social_count - 1)) );

	/* Choose some manner of silliness to perpetrate.  */

	silliness = number_range (1, 100);
	if ( silliness <= 59)
		return TRUE;
	else if (silliness <= 60)
	{
		do_emote (ch, "suddenly starts to run around you.");
		do_emote (ch, "looks at you and can't stop laughing.");
		do_emote (ch, "tags you.");
		act ( "$n exclaims, 'No tag backs!'",ch,NULL,NULL,TO_ROOM);
		do_emote(ch, "giggles as she runs away from you.");
	}
	else if (silliness <= 61)
		{
			do_emote (ch, "starts to bang her head to some sort of violent music in her mind.");
			act ( "$n sings, 'Bang your head! Yeah! Bang your head!",ch,NULL,NULL,TO_ROOM);
		}
	else if (silliness <= 62)
		{
			do_emote (ch, "walks around holding a keg tap.");
			act ( "$n asks, 'Where's the beer?'",ch,NULL,NULL,TO_ROOM);
		}
	else if (silliness <= 63)
		{
			do_emote (ch, "starts to chortle like a maniac.");
			act ( "$n says, 'FIRE! Heh, Fire like, rocks and stuff.",ch,NULL,NULL,TO_ROOM);
		}
	else if (silliness <= 64)
		{
			do_emote (ch, "holds her hands to her chest with a look of rapture.");
			act ( "$n gushes, 'I would like to thank all the little people who made this possible.'",ch,NULL,NULL,TO_ROOM);
		}
	else if (silliness <= 65)
		{
			do_emote (ch, "pushes you aside.");
			act ( "$n says, 'Ladies and Amyrlins first.'",ch,NULL,NULL,TO_ROOM);
		}
	else if (silliness <= 66)
		{
			do_emote (ch, "sticks her tongue out at you.");
		}
	else if (silliness <= 67)
		{
			do_emote (ch, "makes a quick check of her hair.");
			act ( "$n says, 'At least I'm not Graendal.'",ch,NULL,NULL,TO_ROOM);
		}

	else if ( silliness <= 68)
	{
		act ( "$n says, 'Supercalifragilisticespialidocious.'",ch,NULL,NULL,TO_ROOM);
		act ( "$n sings, 'Just a spoonful of sugar helps the medicine go down...'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 69)
	{
		act ( "$n says, 'I listen to NOBODY!!'",ch,NULL,NULL,TO_ROOM);
		act ( "$n says, 'Did you write a note?'",ch,NULL,NULL,TO_ROOM);
		act ( "$n stops $s ears up with her fingers.",ch,NULL,NULL,TO_ROOM);
		act ( "$n says, 'You can't make me do anything!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 70)
	{
		act ( "$n sings, 'I'm Henry the Eighth, I am...'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 71)
	{
		act ( "$n sings, 'Georgiaaaaa, georgia.... I got Georgia on my mind...'",ch,NULL,NULL,TO_ROOM);
		do_emote ( ch, "hums show tunes softly to herself." );
	}
	else if ( silliness <= 72)
	{
		do_emote (ch, "starts to skip, looks like she's trying to gallop.");
		act ( "$n shouts, 'Woohoo! I'm Annie Oakley! Woohoo!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 73)
	{
		act ( "$n says, 'Oooohhhhh.. Coookieeeee'" ,ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 74)
	{
		act (  "$n says, 'Oh, now what do you want?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 75)
	{
		do_emote ( ch, "holds up a nummy chocolate cookie.");
		do_emote ( ch, "raises and eybrow at you.");
		act ( "$n asks, 'Who knew they'd be so dang popular?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 76)
	{
		act ( "$n says, 'Bloody Darkfriends. They'd make good fuel for my fire.'",ch,NULL,NULL,TO_ROOM);
		do_emote ( ch, "rubs her hands together greedily.");
	}
	else if ( silliness <= 77)
	{
		act ( "$n hops around on one foot and plays hopscotch with.. no one.",ch,NULL,NULL,TO_ROOM);
		do_say ( ch, buf );
	}
	else if ( silliness <= 78)
	{
		act( "$n says, 'I'm not caffeinated yet. Stop bugging me.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 79)
	{
		do_emote ( ch, "growls at nobody in particular." );
		act("$n says, 'The White Tower could conquer the Dark One alone.'",ch,NULL,NULL,TO_ROOM);
		act("$n says, 'We need not rely on the Lord Dragon's whims.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 80)
	{
		act( "$n says, 'do you smell something odd? Must be those Darkfriends.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 81)
	{
		do_emote(ch, "walks around in a huff, tugging at her hair.");
		act("$n says, 'Where the heck is {RE{rvil {RD{ralsor{x when I need him?!?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 82)
	{
		do_emote(ch, "takes off her shoe, holds it to her ear, and begins to speak into it.");
		act("$n says,'Helloooooo?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 83)
	{
		do_emote(ch, "sizes up {RE{rvil {RD{ralsor{x's skin for a pair of gloves.");
	}
	else if ( silliness <= 84)
	{
		do_emote(ch,"gives you a wet willy. Eewwwww!" );
		act("$n says, 'Gotcha!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 85)
	{
		do_emote(ch, "begins madly searching for a needle in a haystack.");
		act("$n mutters, 'I know I left it here someplace...'",ch,NULL,NULL,TO_ROOM );
	}
	else if ( silliness <= 86)
	{
		do_emote( ch, "attempts to change her form... and fails");
	}
	else if ( silliness <= 87)
	{
		do_emote(ch,"starts to dance a tango with an imaginary partner." );
	}
	else if ( silliness <= 88)
	{
		do_emote(ch,"tests the flexibility of her riding crop, for no reason in particular." );
	}
	else if ( silliness <= 89)
	{
		do_emote(ch,"trips over her own feet." );
		act("$n says,'Uhm, I meant to do that. Yeah.'",ch,NULL,NULL,TO_ROOM );
	}
	else if ( silliness <= 90)
	{
		do_emote(ch,"munches on a piece of celery.");
		act("$n says, 'Silly carnivores.'",ch,NULL,NULL,TO_ROOM );
	}
	else if ( silliness <= 91)
	{
		do_emote(ch,"winks at the passing sailors");
		act("$n says, 'Come up and see me some time, big boy.'",ch,NULL,NULL,TO_ROOM );
	}
	else if ( silliness <= 92)
	{
		act( social_table[rnd_social].others_no_arg,
			ch, NULL, NULL, TO_ROOM    );
		act( social_table[rnd_social].char_no_arg,
			ch, NULL, NULL, TO_CHAR    );
	}
	else if ( silliness <= 95)
	{
		if ( (!pc_found)
		|| 	 (victim != ch->in_room->people) )
				return FALSE;
		act( social_table[rnd_social].others_found,
			 ch, NULL, victim, TO_NOTVICT );
		act( social_table[rnd_social].char_found,
			 ch, NULL, victim, TO_CHAR    );
		act( social_table[rnd_social].vict_found,
			 ch, NULL, victim, TO_VICT    );
	}
	else if ( silliness <= 97)
	{
		act( "For a moment, $n flickers and phases.",
			ch, NULL, NULL, TO_ROOM );
		act( "For a moment, you flicker and phase.",
			ch, NULL, NULL, TO_CHAR );
	}
	else
	{
		if (ch->position < POS_FIGHTING)
		{
			act( "$n pauses for a minute to touch up her hair...",
				ch, NULL, NULL, TO_ROOM );
			act( "   ...but then $n returns with an unholy vengence.",
				ch, NULL, NULL, TO_ROOM );
			act( "For a moment, the world's mathematical beauty is lost to you!",
				ch, NULL, NULL, TO_CHAR );
			act( "   ...but joy! yet another novel phenomenon seizes your attention.",
				ch, NULL, NULL, TO_CHAR);
			return TRUE;
		}
	}
	return FALSE;
}

bool beer = FALSE;
int prev_silly1;
int prev_silly2;
int prev_silly3;
int prev_silly4;
int prev_silly5;

bool spec_puff( CHAR_DATA *ch )
{
	char buf[MAX_STRING_LENGTH];
	int rnd_social, silliness;
	bool pc_found = TRUE;
    CHAR_DATA *wch;
    CHAR_DATA *wch_next;
    CHAR_DATA *nch;
    CHAR_DATA *ch_next;
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    CHAR_DATA *victim;
	extern int social_count;

	if ( !IS_AWAKE(ch) )
		return FALSE;

	victim = NULL;

    for ( wch = char_list; wch != NULL; wch = wch_next )
    {
		wch_next = wch->next;
		if ( IS_NPC(wch)
		||   wch->in_room == NULL )
		    continue;

		for ( nch = wch->in_room->people; nch != NULL; nch = ch_next )
		{
		    int count;
		    ch_next	= nch->next_in_room;
		    if ( !IS_NPC(nch)
		    ||   number_bits(1) == 0)
			continue;
		    count	= 0;
		    victim	= NULL;
		    for ( vch = wch->in_room->people; vch != NULL; vch = vch_next )
		    {
				vch_next = vch->next_in_room;
				if ( !IS_NPC(vch) )
				{
				    if ( number_range( 0, count ) == 0 )
					victim = vch;
				    count++;
				}
		    }

		    if (victim == NULL)
				return FALSE;
		}

	}
	rnd_social = (number_range (0, ( social_count - 1)) );

	/* Choose some manner of silliness to perpetrate.  */

	silliness = number_range (1, 1000);
	silliness = silliness / 10;


	if ( silliness <= 28)
		return TRUE;

	else if ( silliness == 29 )
	{
	act("$n sniffles. He was writing some code and caught a bug.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 30 )
	{
	act("$n eeps, then murfs, then murgles, then shrugs and looks apologetic.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 31 )
	{
	act("$n assumes the form Kicking Some Booty.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 32 )
	{
	act("$n assumes the form Deer Stares into the Headlights.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 33 )
	{
	act("$n assumes the form Over the River and Through the Woods to Grandmother's House We Go.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 34 )
	{
	act("$n assumes the forms Just Kill the Thing and Go Home.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 35 )
	{
	act("$n says, 'Saidar: The Force. Saidin: The Dark Side of the Force.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 36 )
	{
	act("$n says, 'Put on your best clothes, everyone, the Trollocs have invited us over for dinner!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 37 )
	{
	act("$n says, 'My, what a beautiful big black red-eyed dog! Here doggy, doggy!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 38 )
	{
	act("$n says, 'Hmmm, I'm out of firewood. I wonder if the tubes Aludra gave me will burn?'",ch,NULL,NULL,TO_ROOM);
	}

	else if ( silliness == 39 )
	{
	act("$n says, 'Why do we call it the Last Battle, when we have one every turning of the wheel?",ch,NULL,NULL,TO_ROOM);
	act("$n hmm, 'I know, I know. But how would we get the mortals to take it seriously if it was called 'Repetition Infinitum Gaidon'? Hard enough getting the Dragon off his backside and unifying the nations as it is.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 40 )
	{
		act("$n yells to an unseen friend, 'Shai'tan! How the devil are you? ... Oops! Sorry, bad joke.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 41 )
	{
	act("$n asks, 'Want to hear a joke?' (and assumes you do)",ch,NULL,NULL,TO_ROOM);
	act("Lan and Rand are playing pool in the Great Serpent Inn...",ch,NULL,NULL,TO_ROOM);
	act("Lan: You cheating swine!",ch,NULL,NULL,TO_ROOM);
	act("Rand: What? Me?",ch,NULL,NULL,TO_ROOM);
	act("Lan: Yeah, you channelled it into the pocket !",ch,NULL,NULL,TO_ROOM);
	act("Rand: Did not!",ch,NULL,NULL,TO_ROOM);
	act("Lan: Did too!",ch,NULL,NULL,TO_ROOM);
	act("Thom: (coming over from the bar with Perrin) Lads, lads, give it a rest will you? Rand, that's very unsporting you know.",ch,NULL,NULL,TO_ROOM);
	act("Rand: Well, I NEVER win (sulks) Whether it's cards with Mat, or Arm-wrestling with Perrin, or Swordplay with Lan, I always come second!",ch,NULL,NULL,TO_ROOM);
	act("Mat: (from across the bar) THAT'S NOT WHAT MIN TOLD US! ABOUT YOU COMING SECOND I MEAN....",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 42 )
	{
		act("$n says, 'I Smoked my pipe. Tried to draw to much of the True Smoke than was good for me, and burnt my throat out. Appealed to my Bazarro Kaxandra for healing - she just sniffed.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 43 )
	{
		act("$n says in a booming voice, 'CHOSEN, MEET THE NEW NAE'BLIS.... BELA, MEET MY CHOSEN....",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 44 )
	{
		act("$n asks, 'Right, I'll ask you this once... Are you a DarkFriend? No? Oh....sorry, off you go then. Bye now.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 45 )
	{
		act("$n says, 'Be very careful on this 'skimming' platform, my lord.... My lord? Rand? RAND?",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 46 )
	{
		act("$n asks, 'Is hair loss getting YOU down?  Are you, too, plagued by premature",ch,NULL,NULL,TO_ROOM);
		act("baldness?  Would you SELL YOUR SOUL to move that hairline forward an inch",ch,NULL,NULL,TO_ROOM);
		act("or two?  Well, as a fellow channeler of saidin, I know exactly what you're",ch,NULL,NULL,TO_ROOM);
		act("talking about.  Rotting disease SUCKS, doesn't it?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 47 && victim && victim->sex == SEX_FEMALE )
	{
		act("$n says, 'You must be from Tel'aran'rhiod 'cause you look like you walked out of my dreams..'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 48 && victim && victim->sex == SEX_FEMALE )
	{
		act("$n says, 'Duty is heavier than a mountain, and what a pair of mountains you have.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 49 && victim && victim->sex == SEX_FEMALE )
	{
		act("$n asks, 'Want to see my sword that's not a sword?'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 50 )
	{
		act("$n **VROOOOOOMMMSSSSS**",ch,NULL,NULL,TO_ROOM);
		act("$n says, 'How's my driving? Call 1-800-DARK-ONE'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 51 )
	{
		act("$n opens his mouth, then says, 'I forgot.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 52 )
	{
		act("$n pauses to ponder a moment.",ch,NULL,NULL,TO_ROOM);
		act("Maybe the Green Man tree will produce seeds!  Then, we'll have fresh",ch,NULL,NULL,TO_ROOM);
		act("little Nymphoes running around.  Err I mean Nyms.  I guess Aginor",ch,NULL,NULL,TO_ROOM);
		act("and Balthamel were Nym foes.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 53 )
	{
		act("$n asks, 'Want to know what really happened to the seals?'",ch,NULL,NULL,TO_ROOM);
		act("In former days, seals were trained by the Sea Folk to balance small",ch,NULL,NULL,TO_ROOM);
		act("replicas of the Wheel of Time (tm) on their noses.  The seals were",ch,NULL,NULL,TO_ROOM);
		act("too busy doing this to reproduce, and face extinction.  The last",ch,NULL,NULL,TO_ROOM);
		act("known seal was captured by the Seanchan and now juggles moons in",ch,NULL,NULL,TO_ROOM);
		act("the Tower of Ravens.",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 54 )
	{
		act("$n recites, 'Daughter of the Net, she surfs again.'",ch,NULL,NULL,TO_ROOM);
		act("'The ancient flamewar, she yet fights.'",ch,NULL,NULL,TO_ROOM);
		act("'A new browser she seeks, that can serve her and crash, yet serve still.'",ch,NULL,NULL,TO_ROOM);
		act("'What can stand against her hacking?'",ch,NULL,NULL,TO_ROOM);
		act("'The firewall shall kneel.'",ch,NULL,NULL,TO_ROOM);
		act("'Lag calls lag.'",ch,NULL,NULL,TO_ROOM);
		act("'Lag feeds lag.'",ch,NULL,NULL,TO_ROOM);
		act("'Lag is, and lag was, and lag shall ever be.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 55 )
	{
		act("$n intones, 'Trust is the color of a dark seed growing,'",ch,NULL,NULL,TO_ROOM);
		act("'Trust is the color of a heart's blood flowing.'",ch,NULL,NULL,TO_ROOM);
		act("'Trust is the color of a soul's last breath.'",ch,NULL,NULL,TO_ROOM);
		act("'Trust is the color of death.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 56 )
	{
		act("$n yells, 'Hey, Bizarro Kaxandra, get me a beer!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 57 )
	{
		act("$n says, 'Sa souvraya niende misain ye.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness == 58 )
	{
		act("$n says, 'The Creator made women to please the eye and trouble the mind.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 60 && beer)
	{
		act ( "$n queries, 'I have lost my beer. Have you seen it?", ch,NULL,NULL,TO_ROOM );
		do_emote ( ch, "holds his hands about <---> far apart." );
		act ( "$n says, 'It is about this big. And looks like...'", ch,NULL,NULL,TO_ROOM );
		sprintf(buf," )---------(  \n\r");
		strcat (buf," |---------|  \n\r");
		strcat (buf," |         |  \n\r");
		strcat (buf," |Wudbeiser|  \n\r");
		strcat (buf," |         |  \n\r");
		strcat (buf," |  Queen  |  \n\r");
		strcat (buf," |   of    |  \n\r");
		strcat (buf," |  Beers  |  \n\r");
		strcat (buf," |         |  \n\r");
		strcat (buf," |---------|  \n\r");
		strcat (buf," )---------(  \n\r");
		act( buf, ch,NULL,NULL,TO_ROOM );
		buf[0] = '\0';
	}
	else if ( silliness <= 61 && victim != NULL)
	{
		act ( "$n says, 'My name is Evil Dalsorio. But you can call me Evil Dalsor.'", ch,NULL,NULL,TO_ROOM );
	}
	else if ( silliness <= 62 && victim != NULL)
	{
		act ( "$n steps in front of $N and wields an imaginary six-fingered sword.", ch,NULL,victim,TO_ROOM );
		act ( "$n says, 'My name is Evil Dalsor. You killed my father.'", ch,NULL,NULL,TO_ROOM );
		act ( "$n growls, 'Prepare to die!'", ch,NULL,victim,TO_ROOM );
	}
	else if ( silliness <= 63)
	{
		act ( "$n sings, 'I am the walrus! I am the Apeman!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 64 && beer && victim != NULL)
	{
		act ( "$n shoots $N an accusing look.", ch,NULL,victim,TO_ROOM );
		act ( "$n growls, 'Did you steal my beer, $N? I bet you did, you lousy thief. Hand it over!'", ch,NULL,victim,TO_ROOM );
	}
	else if ( silliness <= 65)
	{
		do_emote ( ch, "rummages around in his pockets frantically." );
		act ( "$n exclaims, 'My beer! I've lost my beer!'",ch,NULL,NULL,TO_ROOM);
		beer = TRUE;
	}
	else if ( silliness <= 66)
	{
		act ( "$n exclaims, 'THAT SUCKS!'",ch,NULL,NULL,TO_ROOM);
		do_emote ( ch, "rolls around on the ground, laughing hysterically." );
	}
	else if ( silliness <= 67)
	{
		act ( "$n says, 'Well met.'",ch,NULL,NULL,TO_ROOM);
		act ( "$n says, 'May the dung on your trail be always less high than your boots.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 68)
	{
		act ( "$n says, 'I am only a figment of your imagination.'",ch,NULL,NULL,TO_ROOM);
		act ( "$n says, 'You should pretend I'm not here.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 69)
	{
		act ( "$n says, 'Stop talking to me! I'm not listening to you....'",ch,NULL,NULL,TO_ROOM);
		act ( "$n sings, 'LALALALA....'",ch,NULL,NULL,TO_ROOM);
		act ( "$n says, '$n stops $s ears up with his fingers.'",ch,NULL,NULL,TO_ROOM);
		act ( "$n exclaims, 'I can't hear you!'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 70)
	{
		act ( "$n sings, 'And a beer in a pear tree...'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 71)
	{
		act ( "$n sings, '99 bottles of beer on the wall....'",ch,NULL,NULL,TO_ROOM);
		beer = TRUE;
	}
	else if ( silliness <= 72)
	{
		act ( "$n sings, 'We'll spend Sunday afternoon poisoning pigeons in the park.'",ch,NULL,NULL,TO_ROOM);
	}
	else if ( silliness <= 73)
	{
		do_emote ( ch, "makes innapropriate noises with his hands under his armpits and giggles madly." );
	}
	else if ( silliness <= 74)
	{
		sprintf ( buf, "Pull my finger, go on, I dare ya.");
		do_say ( ch, buf );
	}
	else if ( silliness <= 75)
	{
		sprintf ( buf, "Macho Macho man.. I wanna be, a Macho Man.");
		do_say ( ch, buf );
	}
	else if ( silliness <= 76)
	{
		sprintf( buf, "I squish your head!");
		do_say ( ch, buf );
		do_emote ( ch, "presses thumb and forefinger together tightly.");
	}
	else if ( silliness <= 77)
	{
		sprintf( buf, "*** ROAR *** My name is PONNET! *** ROAR ***");
		do_say ( ch, buf );
	}
	else if ( silliness <= 78)
	{
		sprintf( buf, "sings, 'Puff the magic dragon, lived by the sea...'");
		do_emote ( ch, buf );
	}
	else if ( silliness <= 79)
	{
		sprintf( buf, "sings, 'Deaaaad puppies aren't much fun...'");
		do_emote ( ch, buf );
	}
	else if ( silliness <= 80)
	{
		sprintf( buf, "sings, 'Fish heads, fish heads, rolly polly fish heads. Eat em up, yum!'");
		do_emote ( ch, buf );
	}
	else if ( silliness <= 81)
	{
		sprintf( buf, "Yes, fear me. You will fear me. Yes....");
		do_say ( ch, buf );
	}
	else if ( silliness <= 82)
	{
		sprintf( buf, "Kneel or you will be knelt!");
		do_say ( ch, buf );
	}
	else if ( silliness <= 83)
	{
		sprintf( buf, "Light! But you sure are an ugly one!");
		do_say ( ch, buf );
	}
	else if ( silliness <= 84)
	{
		sprintf( buf, "Tongue-tied and twisted, just an earthbound misfit...");
		do_say ( ch, buf);
	}
	else if ( silliness <= 85)
	{
		sprintf( buf, "Get your boogie on!");
		do_say ( ch, buf);
	}
	else if ( silliness <= 86)
	{
		do_emote( ch, "points and cackles!");
	}
	else if ( silliness <= 87)
	{
		sprintf( buf, "The colors, the colors!");
		do_say ( ch, buf);
	}
	else if ( silliness <= 88)
	{
		sprintf( buf, "The Wheel of Time turns, and Ages come and pass...");
		do_say ( ch, buf );
	}
	else if ( silliness <= 89)
	{
		sprintf( buf, "Did you know that you are only a figment of my imagination?");
		do_say ( ch, buf);
	}
	else if ( silliness <= 90)
	{
		sprintf( buf, "sings to the trees, and the trees sway in time to the music.");
		do_emote ( ch, buf);
	}
	else if ( silliness <= 91)
	{
		sprintf( buf, "sways in time to an unheard medley");
		do_emote ( ch, buf);
	}
	else if ( silliness <= 92)
	{
		act( social_table[rnd_social].others_no_arg,
			ch, NULL, NULL, TO_ROOM    );
		act( social_table[rnd_social].char_no_arg,
			ch, NULL, NULL, TO_CHAR    );
	}
	else if ( silliness <= 95)
	{
		if ( (!pc_found)
		|| 	 (victim != ch->in_room->people) )
			return FALSE;
		act( social_table[rnd_social].others_found,
			 ch, NULL, victim, TO_NOTVICT );
		act( social_table[rnd_social].char_found,
			 ch, NULL, victim, TO_CHAR    );
		act( social_table[rnd_social].vict_found,
			 ch, NULL, victim, TO_VICT    );
	}
	else if ( silliness <= 97)
	{
		act( "For a moment, $n flickers and phases.",
			ch, NULL, NULL, TO_ROOM );
		act( "For a moment, you flicker and phase.",
			ch, NULL, NULL, TO_CHAR );
	}
	else
	{
		if (ch->position < POS_FIGHTING)
		{
			act( "For a moment, $n seems lucid...",
				ch, NULL, NULL, TO_ROOM );
			act( "   ...but then $e returns to $s contemplations once again.",
				ch, NULL, NULL, TO_ROOM );
			act( "For a moment, the world's mathematical beauty is lost to you!",
				ch, NULL, NULL, TO_CHAR );
			act( "   ...but joy! yet another novel phenomenon seizes your attention.",
				ch, NULL, NULL, TO_CHAR);
			return TRUE;
		}
	}
	return FALSE;
}

bool spec_darkhound( CHAR_DATA *ch )
{
    CHAR_DATA *victim;
    AFFECT_DATA af;
	int level = ch->level;
	int darkness = 0;

    if ( !IS_AWAKE(ch) )
	return FALSE;
	if ( !is_fighting(ch) )
	return FALSE;
	if ( ( victim = ch->advancing_on ) == NULL )
	return FALSE;

	victim = ch->advancing_on;

	darkness = number_range( 1, 100 );

	if ( darkness > 1 && darkness < 20 )
	{
	act("$n sinks it's teeth into $N, covering $M in saliva!",ch,NULL,victim,TO_ROOM);
	act("$n sinks it's teeth into you, covering you in saliva!",ch,NULL,victim,TO_VICT);
	af.where     = TO_AFFECTS;
	af.type      = gsn_poison;
	af.level     = level * 3/4;
	af.duration  = level / 2;
	af.location  = APPLY_STR;
	af.modifier  = -1;
	af.bitvector = AFF_POISON;
	affect_to_char( victim, &af );
	}
	else if ( darkness >= 20 && darkness < 30 )
	{
	act("$n throws back it's head and howls a gutteral howl!",ch,NULL,victim,TO_ROOM);
	}
	else if ( darkness >= 30 && darkness < 40 )
	{
	act("$n slams into you, and sends you sprawling across the ground!",ch,NULL,victim,TO_VICT);
	act("$n slams into $N and sends $M sprawling across the ground!",ch,NULL,victim,TO_NOTVICT);
	DAZE_STATE(victim, 3 * PULSE_VIOLENCE);
	victim->position = POS_RESTING;
	damage(ch,victim,number_range(2,2 + 2 * ch->size),gsn_bash,DAM_BASH,FALSE);
	}
	else if ( darkness >= 40 && darkness < 50 )
	{
	act("$n bites your ankle and holds tight, tripping you!",ch,NULL,victim,TO_VICT);
	act("$n bites $N's ankle, tripping $M and sending $M to the ground!",ch,NULL,victim,TO_NOTVICT);
	DAZE_STATE(victim,2 * PULSE_VIOLENCE);
	victim->position = POS_RESTING;
	damage(ch,victim,number_range(2, 2 +  2 * victim->size),gsn_trip,DAM_BASH,TRUE);
	}
	else if ( darkness >= 50 && darkness < 60 )
	{
	act("$n leaps for your throat and sinks it's fangs in deep!",ch,NULL,victim,TO_VICT);
	act("$n leaps for $N's throat and sinks it's fangs in deep!",ch,NULL,victim,TO_NOTVICT);
	multi_hit( ch, victim, gsn_bite );
	}
	else if ( darkness >= 60 && darkness < 70 )
	{
	}
	else if ( darkness >= 70 && darkness < 80 )
	{
	}
	else if ( darkness >= 80 && darkness < 90 )
	{
	}
	else if ( darkness >= 90 && darkness < 100 )
	{
	}
	else if ( darkness == 100 )
	{
	}
	return FALSE;
}
