/***************************************************************************
                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/
    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.
    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.
    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.
    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.
    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.
	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"
#include "db.h"
#include "olc.h"
#include "mysql5_interface.h"

void check_healing args(( CHAR_DATA *ch, CHAR_DATA *victim ));
bool check_dispel args(( int dis_level, CHAR_DATA *victim, int sn));

void do_spellup( CHAR_DATA *ch, char *argument )
{
	int op_bonus = 50;
	int healnum;
	int level = 50;
	int rbi_mod;
    	AFFECT_DATA af;
    	CHAR_DATA *victim;

	if ( ( victim = get_char_world( ch, argument ) ) == NULL )
	{
		ptc( ch, "I can't do that, %s.\n\r", ch->name );
		return;
	}
	if ( IS_NPC(victim) )
	{
		ptc( ch, "I can't do that, %s.\n\r", ch->name );
		return;
	}

	rbi_mod = victim->pcdata->rebirth - 100;

	if ( rbi_mod <= 0 )
		rbi_mod = 1;

	op_bonus += rbi_mod;

	/* barrier */
	if ( victim->pcdata->char_barrier <= 0 )
	{
		victim->pcdata->char_barrier = level * 5 + op_bonus;
		if ( !IS_SET(victim->op_flags,OP_BARRIER) )
			SET_BIT(victim->op_flags, OP_BARRIER);
	    	stc( "{cYou feel a barrier spring up around you!\n\r", victim );
	    	if ( ch != victim )
	   	{
	        	act("{cYou weave a barrier around $N.",ch,NULL,victim,TO_CHAR);
	        act( "{c$n weaves a barrier around you.",ch,NULL,victim,TO_VICT);
		}
	}
	if ( !IS_AFFECTED(victim,AFF_DETECT_MAGIC) || !is_affected(victim, skill_lookup("seeing") ) )
	{
		/* see magic */
		af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("seeing");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	   	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_MAGIC;
	    	affect_to_char( victim, &af );
	    	stc( "{cYour eyes tingle.\n\r", victim );
	    	if ( ch != victim )
			stc( "{cOk.\n\r", ch );
	}
	if ( !IS_AFFECTED( victim, AFF_DETECT_INVIS) || !is_affected(victim, skill_lookup("see invis") ) )
	{
		/* see invis */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see invis");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_INVIS;
	    	affect_to_char( victim, &af );
	    	stc( "{cYour eyes tingle.\n\r", victim );
	    	if ( ch != victim )
			stc( "{cOk.\n\r", ch );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_HIDDEN) || !is_affected(victim, skill_lookup("see hidden") ) )
	{
		/* see hidden */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see hidden");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.location  = APPLY_NONE;
	    	af.modifier  = 0;
	    	af.bitvector = AFF_DETECT_HIDDEN;
	    	affect_to_char( victim, &af );
	    	stc( "{cYour awareness improves.\n\r", victim );
	    	if ( ch != victim )
			stc( "{cOk.\n\r", ch );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_GOOD) || !is_affected(victim, skill_lookup("see light") ) )
	{
		/* see light */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see light");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_GOOD;
	    	affect_to_char( victim, &af );
	    	stc( "{cYour eyes tingle.\n\r", victim );
	    	if ( ch != victim )
	        	stc( "{cOk.\n\r", ch );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_EVIL) || !is_affected(victim, skill_lookup("see shadow") ) )
	{
		/* see shadow */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see shadow");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_EVIL;
	    	affect_to_char( victim, &af );
	    	stc( "{cYour eyes tingle.\n\r", victim );
	    	if ( ch != victim )
			stc( "{cOk.\n\r", ch );
	}
	if ( !IS_AFFECTED(victim, OP_LARGE) || !is_affected(victim, skill_lookup("large") ) )
	{
		/* large */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("large");
	    	af.level     = ch->level/2;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = (ch->level / 10) + op_bonus;
	    	af.location  = APPLY_STR;
	    	af.bitvector = OP_LARGE;
	    	affect_to_char( victim, &af );
	    	if (victim == ch)
	    	{
	    		stc( "{cYou begin to grow, your arms and thighs getting thicker and more muscled!{x\n\r", victim );
			act( "$n begins to grow, $s arms and thighs growing thicker and more muscled!{x",ch,0,victim,TO_ROOM);
		}
		else
		{
	    		act( "You weave the flows, enhancing $N's strength.",ch,NULL,victim,TO_CHAR);
    			act( "$N begins to grow, $S arms and thighs growing thicker and more muscled!{x",ch,0,victim,TO_NOTVICT);
    			stc( "{cYou begin to grow, your arms and thighs getting thicker and more muscled!{x\n\r", victim );
		}
	}

	if (/* !IS_AFFECTED(victim, AFF_SPEED) ||*/ !is_affected(victim, skill_lookup("speed") ) )
	{
		/* speed */
	    	af.where     = TO_AFFECTS2;
	    	af.type      = skill_lookup("speed");
	    	af.level     = ch->level/2;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = (ch->level / 10) + op_bonus;
	    	af.location  = APPLY_DEX;
	    	af.bitvector = AFF_SPEED;
	    	affect_to_char( victim, &af );
	  	if (victim == ch)
	    	{
    			stc( "{cYou feel faster and more coordinated!{x\n\r", victim );
    			act( "$N suddenly appears faster and more coordinated!{x",ch,0,victim,TO_ROOM);
		}
		else
		{
    			stc( "{cYou feel faster and more coordinated!{x\n\r", victim );
			act( "You weave the flows, enhancing $N's speed.",ch,NULL,victim,TO_CHAR);
    			act( "$N suddenly appears faster and more coordinated!{x",ch,0,victim,TO_NOTVICT);
		}
	}

	if ( /*!IS_AFFECTED(victim, AFF_ENDURANCE) ||*/ !is_affected(victim, skill_lookup("endurance") ) )
	{
		/* endurance */
		af.where	= TO_AFFECTS2;
		af.type 	= skill_lookup("endurance");
		af.level	= ch->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (ch->level / 10) + op_bonus;
    		af.location  	= APPLY_CON;
    		af.bitvector 	= AFF_ENDURANCE;
    		affect_to_char( victim, &af );

    		if (victim == ch)
    		{
    			stc( "{cYou feel refreshed, ready to run laps around the Waste!{x\n\r", victim );
	    		act( "$n looks refreshed, and ready to run laps around the Waste.{x",ch,0,0,TO_ROOM);
		}
		else
		{
			act( "You weave the flows, enhancing $N's endurance.",ch,NULL,victim,TO_CHAR);
    			act( "$N looks refreshed, and ready to run laps around the Waste.{x",ch,0,victim,TO_NOTVICT);
    			stc( "{cYou feel refreshed, ready to run laps around the Waste!{x\n\r", victim );
		}
	}
	if ( !IS_AFFECTED(victim, AFF_INSTINCT) || !is_affected(victim, skill_lookup("hunters instinct") ) )
	{
		/* hunters instinct */
		af.where     	= TO_AFFECTS2;
    		af.type      	= skill_lookup("hunters instinct");
    		af.level	= ch->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (ch->level / 10) + op_bonus;
    		af.location  	= APPLY_INS;
    		af.bitvector 	= AFF_INSTINCT;
    		affect_to_char( victim, &af );
    		if (victim == ch)
    		{
    			stc( "{cYou feel more aware of what is going on around you!{x\n\r", victim );
	        	act( "$n seems more alert, as $e scans the area for danger!{x",ch,0,0,TO_ROOM);
		}
		else
		{
			act( "You weave the flows, enhancing $N's awareness.",ch,NULL,victim,TO_CHAR);
	    		stc( "{cYou feel more aware of what is going on around you!{x\n\r", victim );
    			act( "$N seems more alert, as $E scans the area for danger!{x",ch,0,victim,TO_NOTVICT);
		}
	}
	if ( !IS_AFFECTED(victim, AFF_PANTHER) || !is_affected(victim, skill_lookup("panther reflex") ) )
	{
		/* panther reflex */
		af.where	= TO_AFFECTS2;
    		af.type      	= skill_lookup("panther reflex");
    		af.level	= ch->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (ch->level / 10) + op_bonus;
    		af.location  	= APPLY_REF;
    		af.bitvector    = AFF_PANTHER;
    		affect_to_char( victim, &af );
   	 	if (victim == ch)
    		{
    			stc( "{cYour muscles feel looser, and everything is in sharp focus!{x\n\r", victim );
    			act( "$N suddenly appears more loose, and $S eyes focus sharply!{x",ch,0,victim,TO_NOTVICT);
    		}
		else
		{
    			stc( "{cYour muscles feel looser, and everything is in sharp focus!{x\n\r", victim );
			act( "You weave the flows, enhancing $N's reflex.",ch,NULL,victim,TO_CHAR);
    			act( "$N suddenly appears more loose, and $S eyes focus sharply!{x",ch,0,victim,TO_NOTVICT);
		}
	}
	if ( !IS_AFFECTED(victim, OP_FSHIELD) || !is_affected(victim, skill_lookup("fire shield") ) )
	{
		/* fire shield */
		af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("fire shield");
	   	af.level     = ch->level/2;
	    	af.duration  = ch->level/10 + op_bonus;
	    	af.modifier  = -20;
	    	af.location  = APPLY_AC;
	    	af.bitvector = OP_FSHIELD;
	    	affect_to_char( victim, &af );
	    	if (victim == ch)
	    	{
	    		stc( "{cYou are surrounded by a {WS{whi{rel{Rd of{r F{wir{We.{x\n\r", victim );
		    	act( "$n is surrounded by a {WS{whi{rel{Rd of{r F{wir{We!",ch,0,0,TO_ROOM);
		}
		else
	    		act( "$N is surrounded by a {WS{whi{rel{Rd of{r F{wir{We!",ch,0,victim,TO_ROOM);
	}
	if ( !is_affected(victim, skill_lookup("shield") ) )
	{
		/* shield */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("shield");
	    	af.level     = level;
	    	af.duration  = 8 + level + op_bonus;
	    	af.modifier  = -op_bonus;
		af.location  = APPLY_AC;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	    	stc("You weave flows of spirit.\n\r",ch);
	    	act("{c$n is enveloped by a brief flash of light.", victim, NULL, NULL, TO_ROOM );
	    	stc( "{cYou are enveloped in a brief flash of light.\n\r", victim );
	}
	if ( !is_affected(victim, skill_lookup("defense") ) )
	{
		/* defense */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("defense");
	    	af.level     = level;
	    	af.duration  = 24 + op_bonus;
	    	af.modifier  = -20;
	    	af.location  = APPLY_AC;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	    	stc( "{cYou feel the One Power defending you.\n\r", victim );
	    	act("{c$N is defended by your weave.",ch,NULL,victim,TO_CHAR);
	}
	if ( !is_affected(victim, skill_lookup("vigor") ) )
	{
	    	/* vigor */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("vigor");
	    	af.level     = level;
	    	af.duration  = 6+level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = ch->level / 8 + op_bonus;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	    	af.location  = APPLY_SAVING_SPELL;
	    	af.modifier  = 0 - level / 8;
	    	affect_to_char( victim, &af );
	    	stc( "{cYou feel envigorated!\n\r", victim );
	    	if ( ch != victim )
	        	act("{cYou weave a vigor upon $N.",ch,NULL,victim,TO_CHAR);
	}
	if ( !is_affected(victim, skill_lookup("advanced shield") ) )
	{
		/* advanced shield */
		af.where     = TO_AFFECTS;
   		af.type      = skill_lookup("advanced shield");
    		af.level     = level;
    		af.duration  = level + op_bonus;
    		af.location  = APPLY_AC;
    		af.modifier  = 0 - (ch->level / 2 + op_bonus);
    		af.bitvector = 0;
    		affect_to_char( victim, &af );
    		stc("You weave flows of spirit.\n\r",ch);
    		act("{c$n is enveloped by a brief flash of light.", victim, NULL, NULL, TO_ROOM );
    		stc( "{cYou are enveloped in a brief flash of light.\n\r", victim );
	}
	if ( !is_affected(victim, skill_lookup("greater shield") ) )
	{
		/* greater shield */
		af.where     = TO_AFFECTS;
   	 	af.type      = skill_lookup("greater shield");
    		af.level     = level;
    		af.duration  = level + op_bonus;
    		af.location  = APPLY_AC;
    		af.modifier  = 0 - (ch->level + op_bonus);
    		af.bitvector = 0;
   		affect_to_char( victim, &af );
   		act("{c$n is enveloped by a brief flash of light.", victim, NULL, NULL, TO_ROOM );
    		stc( "{cYou are enveloped in a brief flash of light.\n\r", victim );
	}
	if ( !is_affected(victim, skill_lookup("tower of defense") ) )
	{
		/* tower of defense */
            	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of defense");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("Tower of defense");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 200 + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	   	stc( "{cYou weave a {BTo{bw{Ber {cof {BDe{bfen{Bse.{x\n\r", ch );
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphenous cloud of purple and green.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphenous cloud of purple and green.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphenous cloud of purple and green.",ch,NULL,victim,TO_NOTVICT);
		}
	}
	if ( !is_affected(victim, skill_lookup("tower of mind") ) )
	{
		/* tower of mind */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of mind");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of mind");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 150 + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	stc( "{cYou weave a {BTo{bw{Ber {cof {BM{bin{Bd.{x\n\r", ch );
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphenous cloud of purple and red.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphenous cloud of purple and red.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphenous cloud of purple and red.",ch,NULL,victim,TO_NOTVICT);
		}
	}
	if ( !is_affected(victim, skill_lookup("tower of war") ) )
	{
		/* tower of war */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of war");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of war");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 100 + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	        act("{cYou weave a {BTo{bw{Ber {cof {BW{ba{BR.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphenous cloud of purple and black.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphenous cloud of purple and black.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphenous cloud of purple and black.",ch,NULL,victim,TO_NOTVICT);
		}
	}
	if ( !is_affected(victim, skill_lookup("tower of justice") ) )
	{
		/* tower of justice */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of justice");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  =  (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of justice");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 50 + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

        	act("{cYou weave a {BTo{bw{Ber {cof {BJu{bsti{Bce.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphenous cloud of purple and gray.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphenous cloud of purple and gray.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphenous cloud of purple and gray.",ch,NULL,victim,TO_NOTVICT);
		}
	}
	if ( !is_affected(victim, skill_lookup("tower of power") ) )
	{
		/* tower of power */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of power");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  =  (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	   	af.type      = skill_lookup("tower of power");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level + op_bonus);
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

        	act("{cYou weave a {BTo{bw{Ber {cof {BPo{bw{Ber.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphenous cloud of purple and white.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphenous cloud of purple and white.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphenous cloud of purple and white.",ch,NULL,victim,TO_NOTVICT);
		}
	}
	if ( victim->hit < get_maxhit(victim) )
	{
		/* healing hp */
	    	healnum = ch->level + int_app[get_curr_stat(ch,STAT_INT)].op_focus * 11 / 9;
	    	healnum += op_bonus;
	    	victim->hit = UMIN( victim->hit + healnum, get_maxhit(victim));
	    	update_pos( victim );
	    	if ( victim != ch )
	    	{
			act( "{cYou weave flows of the One Power, Healing $N's wounds.",ch,0,victim,TO_CHAR );
		    	act("{c$n takes your head between $s hands. Fingers of ice and fire shoot up your spine.",ch,NULL,victim,TO_VICT);
		    	stc( "{cA warm feeling fills your body.\n\r", victim );
		    	act("{c$n takes $N's head between $s hands. $N shivers violently.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
			stc( "{cAs you draw upon the True Source, a warm feeling fills your body.\n\r", victim );
		}
		check_healing(ch,victim);
	}
	/* blindness */
    	if ( !is_affected( victim, gsn_blindness ) )
    	{
        	if (victim == ch)
          		stc( "{cYou aren't blind.\n\r",ch);
        	else
          		act("{c$N doesn't appear to be blinded.",ch,NULL,victim,TO_CHAR);
    	}
    	if (check_dispel(level+op_bonus,victim,gsn_blindness))
    	{
        	stc( "{cYour vision returns!\n\r", victim );
        	act("{c$n is no longer blinded.",victim,NULL,NULL,TO_ROOM);
    	}
}

void do_questspellup( CHAR_DATA *victim )
{
	int op_bonus = 500;
	int level = 1000;
	AFFECT_DATA af;

	if (IS_NPC(victim))	return;

	stc ( "{wWeaves of {WSa{Did{Win {wand {WSa{wid{War {wsurround you and you shimmer brightly for a brief period.{x\n\r", victim );
	act ( "{wWeaves of {WSa{Did{Win {wand {WSa{wid{War {wsurrounds $n and they shimmer brightly for a brief period.{x{x", victim,0, 0,TO_NOTVICT );

	/* barrier */
	if ( victim->pcdata->char_barrier <= 0 )
	{
		victim->pcdata->char_barrier = level * 5 + op_bonus;
		if ( !IS_SET(victim->op_flags,OP_BARRIER) )
			SET_BIT(victim->op_flags, OP_BARRIER);
	}
	if ( !IS_AFFECTED(victim,AFF_DETECT_MAGIC) || !is_affected(victim, skill_lookup("seeing") ) )
	{
		/* see magic */
		af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("seeing");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	   	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_MAGIC;
	    	affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED( victim, AFF_DETECT_INVIS) || !is_affected(victim, skill_lookup("see invis") ) )
	{
		/* see invis */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see invis");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_INVIS;
	    	affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_HIDDEN) || !is_affected(victim, skill_lookup("see hidden") ) )
	{
		/* see hidden */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see hidden");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.location  = APPLY_NONE;
	    	af.modifier  = 0;
	    	af.bitvector = AFF_DETECT_HIDDEN;
	    	affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_GOOD) || !is_affected(victim, skill_lookup("see light") ) )
	{
		/* see light */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see light");
	    	af.level     = level;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_GOOD;
	    	affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, AFF_DETECT_EVIL) || !is_affected(victim, skill_lookup("see shadow") ) )
	{
		/* see shadow */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("see shadow");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.modifier  = 0;
	    	af.location  = APPLY_NONE;
	    	af.bitvector = AFF_DETECT_EVIL;
	    	affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, OP_LARGE) || !is_affected(victim, skill_lookup("large") ) )
	{
		/* large */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("large");
	    	af.level     = victim->level/2;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = (victim->level / 10) + op_bonus;
	    	af.location  = APPLY_STR;
	    	af.bitvector = OP_LARGE;
	    	affect_to_char( victim, &af );
	}

	if (/* !IS_AFFECTED(victim, AFF_SPEED) ||*/ !is_affected(victim, skill_lookup("speed") ) )
	{
		/* speed */
	    	af.where     = TO_AFFECTS2;
	    	af.type      = skill_lookup("speed");
	    	af.level     = victim->level/2;
	    	af.duration  = level+op_bonus;
	    	af.modifier  = (victim->level / 10) + op_bonus;
	    	af.location  = APPLY_DEX;
	    	af.bitvector = AFF_SPEED;
	    	affect_to_char( victim, &af );
	}

	if ( /*!IS_AFFECTED(victim, AFF_ENDURANCE) ||*/ !is_affected(victim, skill_lookup("endurance") ) )
	{
		/* endurance */
		af.where	= TO_AFFECTS2;
		af.type 	= skill_lookup("endurance");
		af.level	= victim->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (victim->level / 10) + op_bonus;
    		af.location  	= APPLY_CON;
    		af.bitvector 	= AFF_ENDURANCE;
    		affect_to_char( victim, &af );

	}
	if ( !IS_AFFECTED(victim, AFF_INSTINCT) || !is_affected(victim, skill_lookup("hunters instinct") ) )
	{
		/* hunters instinct */
		af.where     	= TO_AFFECTS2;
    		af.type      	= skill_lookup("hunters instinct");
    		af.level	= victim->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (victim->level / 10) + op_bonus;
    		af.location  	= APPLY_INS;
    		af.bitvector 	= AFF_INSTINCT;
    		affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, AFF_PANTHER) || !is_affected(victim, skill_lookup("panther reflex") ) )
	{
		/* panther reflex */
		af.where	= TO_AFFECTS2;
    		af.type      	= skill_lookup("panther reflex");
    		af.level	= victim->level/2;
		af.duration  	= level+op_bonus;
		af.modifier 	= (victim->level / 10) + op_bonus;
    		af.location  	= APPLY_REF;
    		af.bitvector    = AFF_PANTHER;
    		affect_to_char( victim, &af );
	}
	if ( !IS_AFFECTED(victim, OP_FSHIELD) || !is_affected(victim, skill_lookup("fire shield") ) )
	{
		/* fire shield */
		af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("fire shield");
	   	af.level     = victim->level/2;
	    	af.duration  = victim->level/10 + op_bonus;
	    	af.modifier  = -20;
	    	af.location  = APPLY_AC;
	    	af.bitvector = OP_FSHIELD;
	    	affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("shield") ) )
	{
		/* shield */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("shield");
	    	af.level     = level;
	    	af.duration  = 8 + level + op_bonus;
	    	af.modifier  = -op_bonus;
		af.location  = APPLY_AC;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("defense") ) )
	{
		/* defense */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("defense");
	    	af.level     = level;
	    	af.duration  = 24 + op_bonus;
	    	af.modifier  = -20;
	    	af.location  = APPLY_AC;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("vigor") ) )
	{
	    	/* vigor */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("vigor");
	    	af.level     = level;
	    	af.duration  = 6+level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = victim->level / 8 + op_bonus;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );
	    	af.location  = APPLY_SAVING_SPELL;
	    	af.modifier  = 0 - level / 8;
	    	affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("advanced shield") ) )
	{
		/* advanced shield */
		af.where     = TO_AFFECTS;
   		af.type      = skill_lookup("advanced shield");
    		af.level     = level;
    		af.duration  = level + op_bonus;
    		af.location  = APPLY_AC;
    		af.modifier  = 0 - (victim->level / 2 + op_bonus);
    		af.bitvector = 0;
    		affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("greater shield") ) )
	{
		/* greater shield */
		af.where     = TO_AFFECTS;
   	 	af.type      = skill_lookup("greater shield");
    		af.level     = level;
    		af.duration  = level + op_bonus;
    		af.location  = APPLY_AC;
    		af.modifier  = 0 - (victim->level + op_bonus);
    		af.bitvector = 0;
   		affect_to_char( victim, &af );
	}
	if ( !is_affected(victim, skill_lookup("tower of defense") ) )
	{
		/* tower of defense */
            	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of defense");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level - 250 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("Tower of defense");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 200 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	}
	if ( !is_affected(victim, skill_lookup("tower of mind") ) )
	{
		/* tower of mind */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of mind");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level - 200 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of mind");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 150 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	}
	if ( !is_affected(victim, skill_lookup("tower of war") ) )
	{
		/* tower of war */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of war");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level - 150 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of war");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 100 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	}
	if ( !is_affected(victim, skill_lookup("tower of justice") ) )
	{
		/* tower of justice */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of justice");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  =  (level - 100 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of justice");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level - 50 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	}
	if ( !is_affected(victim, skill_lookup("tower of power") ) )
	{
		/* tower of power */
	    	af.where     = TO_AFFECTS;
	    	af.type      = skill_lookup("tower of power");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_HITROLL;
	    	af.modifier  = (level - 50 + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	    	af.where     = TO_AFFECTS;
	   	af.type      = skill_lookup("tower of power");
	    	af.level     = level;
	    	af.duration  = level + op_bonus;
	    	af.location  = APPLY_AC;
	    	af.modifier  = 0 - (level + op_bonus) / 2;
	    	af.bitvector = 0;
	    	affect_to_char( victim, &af );

	}

	return;
}
