/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

    File: string.c

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

    This code was freely distributed with the The Isles 1.1 source code,
    and has been used here for OLC - OLC would not be what it is without
    all the previous coders who released their source code.

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "tables.h"
#include "olc.h"

void save_bugs args((void));
char *string_linedel( char *, int );
char *string_lineadd( char *, char *, int );
char *numlineas( char * );
void save_area args((AREA_DATA *area));

/*******************************************************************************
 *         _               | File Name:   format_string.c
 *        / \      _-'     | Description: This snippet allows you to incoorperate
 *      _/|  \-''- _ /     |              the format string command on your mud.
 * __-' |          \       |              format_str_len will format any string
 *     /              \    |              to a length excluding color codes.
 *     /       "o.  |o |   |              It can also center/left/right or ignore
 *     |            \ ;    |              alignment.
 *                   ',    |
 *        \_         __\   | (c) 2000-2001 TAKA
 *          ''-_    \.//   | (c) 2000-2001 The GhostMud Project Team
 *            / '-____'    |
 *           /             | You may use this code under GNU license restriction
 *         _'  The Wolf    | 1) This header block remains in the code.
 *       _-'   strikes!    | 2) You email me at a_ghost_dancer@excite.com
 *_________________________|    letting me know you are using this code
 *                              please incluse your name, your mud name
 * All rights reserved          your mud address, your email and this file
 * GhostMud is copyrighted      name.
 * by TAKA                   3) In your help files mention me where appropriate
 *                              IE: help snippets.
 *                           4) Your use of this snippet must not violate any
 *                              ROM, MERC or DIKU license.
 *********************************************************************************/



/*
 * If there are any problems with implimentation, please mail me and I will
 * try to help. If there is a general problem in the code, please note the
 * list so those that are using it can fix it. As far as I know, when
 * released, all code is bug free, but I make no claims or promises that
 * this will not fry your system, etc, etc. And as with most, i take no
 * responsability if this breaks anything. Use at your own risk. My main
 * concern is that the snipets work and that they don't conflict with anything.
 * If anyone has any general tips for me, again, feel free to mail me.
 *
 * Permission is granted to post this to other list, put it on a web site,
 * etc, etc, as long as I am given full credit for it.
 *
 * -Taka
 * <a_ghost_dancer@excite.com>
 *
 * GhostMUD has a user list at GhostMUD-subscribe@yahoogroups.com
 * I monitor this list and answer questions there so many can benifit from
 * the answers.
 *
 * A web page with my snippets and code releases is being set up at
 * http://ghostmud.betterbox.net/code/
 * http://ghostmud.betterbox.net/snippets/
 * Both dos and linux versions of GhostMUD will appear on the code page
 * very soon.
 *
 * Anyone using my snippets or wishing to keep up with my latest work can
 * find this information there.
 *
 *
 	char *FmtString
 	char buf[MSL];

 	FmtString = format_str_len(whotitle, 14, ALIGN_CENTER);
    strcpy (buf, FmtString);

    printf_to_char(ch, "this is your string now: %s", buf);

 * NOTE if you do not have printf_to_char then get it from Erwin it is
 * very handy.
 *
 */



char * format_str_len(char * string, int length, int align);

/*
 * format string alignment functions
 */
#define ALIGN_NONE			0
#define ALIGN_LEFT			1
#define ALIGN_RIGHT			2
#define ALIGN_CENTER		3

/*
 * format a string to a length
 * by TAKA of GhostMUD project
 */
char * format_str_len(char * string, int length, int align)
{
    char buf[MSL];
	char buf2[MSL];
    char *new_string;
    char *count_string;
    char temp;
    int count = 0, nCount = 0;
    int pos = 0;

    new_string = buf;
	count_string = buf2;
	strcpy(buf2, string);

	/* get count for alignment */
	while( *count_string && nCount != length )
    {
        temp = *count_string++;

		if (temp == '{' )
        {
			temp = *count_string++;
			if (temp == '{')
                nCount++;
            continue;
        }
        nCount++;
    }

	/* force alignment of text to the right */
	if(align == ALIGN_RIGHT)
	{
		count = (length - ++nCount);
		while(nCount++ <= length)
		{
	        buf[pos++] = ' ';
		}
	}

	/* force alignment of text to the center */
	if(align == ALIGN_CENTER)
	{
		nCount = (length - nCount) / 2;
		count = nCount;
		while(nCount-- > 0)
		{
	        buf[pos++] = ' ';
		}
	}

	/* add to buffer */
	while( *string && count != length )
    {
        temp = *string++;
        buf[pos++] = temp;

		if (temp == '{' )
        {
            buf[pos] = *string++;

			if (buf[pos] == '{')
                count++;

			pos++;
            continue;
        }
        count++;
    }

	/* pad remaining space with blanks */
	while (count++ < length)
        buf[pos++] = ' ';

	buf[pos] = '\0';

	return (new_string);
}


/*****************************************************************************
 Name:		string_edit
 Purpose:	Clears string and puts player into editing mode.
 Called by:	none
 ****************************************************************************/
void string_edit( CHAR_DATA *ch, char **pString )
{
    send_to_char( "{W-========- {cEntering EDIT Mode {W-=========-\n\r", ch );
    send_to_char( "    {CType .h on a new line for help{c\n\r", ch );
    if ( ch->desc->connected == CON_PLAYING )
	    send_to_char( " {CTerminate with a ~ or @ on a blank line.{c\n\r", ch );
	else
	    send_to_char( " {CTerminate with a @ on a blank line.{c\n\r", ch );
    send_to_char( "{W-=======================================-{c\n\r", ch );

    if ( *pString == NULL )
    {
        *pString = str_dup( "" );
    }
    else
    {
        **pString = '\0';
    }

    ch->desc->pString = pString;

    return;
}



/*****************************************************************************
 Name:		string_append
 Purpose:	Puts player into append mode for given string.
 Called by:	(many)olc_act.c
 ****************************************************************************/
void string_append( CHAR_DATA *ch, char **pString )
{
    send_to_char( "{W-========- {cEntering EDIT Mode {W-=========-\n\r", ch );
    send_to_char( "    {CType .h on a new line for help{c\n\r", ch );
    if ( ch->desc->connected == CON_PLAYING )
	    send_to_char( " {CTerminate with a ~ or @ on a blank line.{c\n\r", ch );
	else
	    send_to_char( " {CTerminate with a @ on a blank line.{c\n\r", ch );
    send_to_char( "{W-=======================================-{c\n\r", ch );

    if ( *pString == NULL )
    {
        *pString = str_dup( "" );
    }
    send_to_char( numlineas(*pString), ch );

/* numlineas entrega el string con \n\r */
/*  if ( *(*pString + strlen( *pString ) - 1) != '\r' )
	send_to_char( "\n\r", ch ); */

    ch->desc->pString = pString;

    return;
}



/*****************************************************************************
 Name:		string_replace
 Purpose:	Substitutes one string for another.
 Called by:	string_add(string.c) (aedit_builder)olc_act.c.
 ****************************************************************************/
char * string_replace( char * orig, char * old, char * new )
{
    char xbuf[MAX_STRING_LENGTH];
    int i;

    xbuf[0] = '\0';
    strcpy( xbuf, orig );
    if ( strstr( orig, old ) != NULL )
    {
        i = strlen( orig ) - strlen( strstr( orig, old ) );
        xbuf[i] = '\0';
        strcat( xbuf, new );
        strcat( xbuf, &orig[i+strlen( old )] );
        free_string( orig );
    }

    return str_dup( xbuf );
}



/*****************************************************************************
 Name:		string_add
 Purpose:	Interpreter for string editing.
 Called by:	game_loop_xxxx(comm.c).
 ****************************************************************************/
void string_add( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];

    /*
     * Thanks to James Seng
     */
    smash_tilde( argument );

    if ( *argument == '.' )
    {
        char arg1 [MAX_INPUT_LENGTH];
        char arg2 [MAX_INPUT_LENGTH];
        char arg3 [MAX_INPUT_LENGTH];
        char tmparg3 [MAX_INPUT_LENGTH];

        argument = one_argument( argument, arg1 );
        argument = first_arg( argument, arg2, FALSE );
	strcpy( tmparg3, argument );
        argument = first_arg( argument, arg3, FALSE );

        if ( !str_cmp( arg1, ".c" ) )
        {
            send_to_char( "{cString cleared.\n\r", ch );
	    free_string(*ch->desc->pString);
	    *ch->desc->pString = str_dup( "" );
            return;
        }

        if ( !str_cmp( arg1, ".s" ) )
        {
            send_to_char( "{cString so far:\n\r", ch );
            send_to_char( numlineas(*ch->desc->pString), ch );
            return;
        }

        if ( !str_cmp( arg1, ".r" ) )
        {
            if ( arg2[0] == '\0' )
            {
                send_to_char(
                    "{cusage:  .r \"old string\" \"new string\"\n\r", ch );
                return;
            }

            *ch->desc->pString =
                string_replace( *ch->desc->pString, arg2, arg3 );
            sprintf( buf, "{c'%s' replaced with '%s'.\n\r", arg2, arg3 );
            send_to_char( buf, ch );
            return;
        }

        if ( !str_cmp( arg1, ".f" ) )
        {
            *ch->desc->pString = format_string( *ch->desc->pString );
            send_to_char( "{cString formatted.\n\r", ch );
            return;
        }

	if ( !str_cmp( arg1, ".ld" ) )
	{
		*ch->desc->pString = string_linedel( *ch->desc->pString, atoi(arg2) );
		send_to_char( "{cLine deleted.\n\r", ch );
		return;
	}

	if ( !str_cmp( arg1, ".li" ) )
	{
		*ch->desc->pString = string_lineadd( *ch->desc->pString, tmparg3, atoi(arg2) );
		send_to_char( "{cLine inserted.\n\r", ch );
		return;
	}

	if ( !str_cmp( arg1, ".lr" ) )
	{
		*ch->desc->pString = string_linedel( *ch->desc->pString, atoi(arg2) );
		*ch->desc->pString = string_lineadd( *ch->desc->pString, tmparg3, atoi(arg2) );
		send_to_char( "{cLine replaced.\n\r", ch );
		return;
	}

        if ( !str_cmp( arg1, ".h" ) )
        {
            send_to_char( "{cSedit help (commands on blank line):   \n\r", ch );
            send_to_char( "{c.r 'old' 'new'   - replace a substring \n\r", ch );
            send_to_char( "{c                   (requires '', \"\") \n\r", ch );
            send_to_char( "{c.h               - get help (this info)\n\r", ch );
            send_to_char( "{c.s               - show string so far  \n\r", ch );
            send_to_char( "{c.f               - (word wrap) string  \n\r", ch );
            send_to_char( "{c.c               - clear string so far \n\r", ch );
            send_to_char( "{c.ld <num>        - remove line number <num>\n\r", ch );
            send_to_char( "{c.li <num> <str>  - insert line <num> with string <str>\n\r", ch );
	    send_to_char( "{c.lr <num> <str>  - replace line <num> with <str>\n\r", ch );
            send_to_char( "{c@                - end string          \n\r", ch );
            return;
        }

        send_to_char( "{cSEdit:  Invalid dot command.\n\r", ch );
        return;
    }

    if ( *argument == '~' || *argument == '@' )
    {
	ptc(ch, "String has been edited, you're in editor %d.\n\r", ch->desc->editor);
	
	if ( ch->desc->editor == ED_MPCODE ) /* for the mobprogs */
	{
		MOB_INDEX_DATA *mob;
		int hash;
		PROG_LIST *mpl;
		PROG_CODE *mpc;

		EDIT_MPCODE(ch, mpc);

		if ( mpc != NULL )
			for ( hash = 0; hash < MAX_KEY_HASH; hash++ )
				for ( mob = mob_index_hash[hash]; mob; mob = mob->next )
					for ( mpl = mob->mprogs; mpl; mpl = mpl->next )
						if ( mpl->vnum == mpc->vnum )
						{
							sprintf( buf, "{cModified mob %ld.\n\r", mob->vnum );
							send_to_char( buf, ch );
							mpl->code = mpc->code;
						}
        }
	if ( ch->desc->editor == ED_OPCODE ) /* for the objprogs */
	{
		OBJ_INDEX_DATA *obj;
		int hash;
		PROG_LIST *opl;
		PROG_CODE *opc;

		EDIT_OPCODE(ch, opc);

		if ( opc != NULL )
		{
			stc("Updating objects..\n\r", ch);
			for ( hash = 0; hash < MAX_KEY_HASH; hash++ )
				for ( obj = obj_index_hash[hash]; obj; obj = obj->next )
					for ( opl = obj->oprogs; opl; opl = opl->next )
						if ( opl->vnum == opc->vnum )
						{
							sprintf( buf, "{cModified object %ld.\n\r", obj->vnum );
							send_to_char( buf, ch );
							opl->code = opc->code;
						}
		}
	}

	if ( ch->desc->editor == ED_RPCODE ) /* for the roomprogs */
	{
		ROOM_INDEX_DATA *room;
		int hash;
		PROG_LIST *rpl;
		PROG_CODE *rpc = (PROG_CODE*) ch->desc->pEdit;

		if ( rpc != NULL )
		{
			stc("Updating rooms..\n\r", ch);
			for ( hash = 0; hash < MAX_KEY_HASH; hash++ )
				for ( room = room_index_hash[hash]; room; room = room->next )
					for ( rpl = room->rprogs; rpl; rpl = rpl->next )
						if ( rpl->vnum == rpc->vnum )
						{
							sprintf( buf, "{cModified room %ld.\n\r", room->vnum );
							send_to_char( buf, ch );
							rpl->code = rpc->code;
						}
		}
	}

        ch->desc->pString = NULL;

	if (ch->in_room != NULL && is_room_owner(ch, ch->in_room))
		save_area(ch->in_room->area);

        return;
    }

    strcpy( buf, *ch->desc->pString );

    /*
     * Truncate strings to MAX_STRING_LENGTH.
     * --------------------------------------
     */
    if ( strlen( buf ) + strlen( argument ) >= ( MAX_STRING_LENGTH - 4 ) )
    {
        send_to_char( "{cString too long, last line skipped.\n\r", ch );

	/* Force character out of editing mode. */
        ch->desc->pString = NULL;
        return;
    }

	if ( ch->desc->connected == CON_BUGREPORTING_MSG
	|| ch->desc->connected == CON_BUGREPORTING_IMMINFO
	|| ch->desc->connected == CON_BUGREPORTING_MORTINFO )
	{
	    save_bugs();
	    ch->desc->connected = CON_PLAYING;
	    /*ch->desc->pString = NULL;*/
	}

    /*
     * Ensure no tilde's inside string.
     * --------------------------------
     */
    smash_tilde( argument );

    strcat( buf, argument );
    strcat( buf, "\n\r" );
    free_string( *ch->desc->pString );
    *ch->desc->pString = str_dup( buf );
    return;
}



/*
 * Thanks to Kalgen for the new procedure (no more bug!)
 * Original wordwrap() written by Surreality.
 */
/*****************************************************************************
 Name:		format_string
 Purpose:	Special string formating and word-wrapping.
 Called by:	string_add(string.c) (many)olc_act.c
 ****************************************************************************/
/*
 * Thanks to Kalgen for the new procedure (no more bug!)
 * Original wordwrap() written by Surreality.
 */
/*****************************************************************************
 Name:		format_string
 Purpose:	Special string formating and word-wrapping.
 Called by:	string_add(string.c) (many)olc_act.c
 ****************************************************************************/
char *format_string( char *oldstring )
{
  char xbuf[MAX_STRING_LENGTH];
  char xbuf2[MAX_STRING_LENGTH];
  char *rdesc;
  int i=0;
  bool cap=TRUE;

  xbuf[0]=xbuf2[0]=0;

  i=0;

  for (rdesc = oldstring; *rdesc; rdesc++)
  {
    if (*rdesc=='\n')
    {
      if (xbuf[i-1] != ' ')
      {
        xbuf[i]=' ';
        i++;
      }
    }
    else if (*rdesc=='\r') ;
    else if (*rdesc==' ')
    {
      if (xbuf[i-1] != ' ')
      {
        xbuf[i]=' ';
        i++;
      }
    }
    else if (*rdesc==')')
    {
      if (xbuf[i-1]==' ' && xbuf[i-2]==' ' &&
          (xbuf[i-3]=='.' || xbuf[i-3]=='?' || xbuf[i-3]=='!'))
      {
        xbuf[i-2]=*rdesc;
        xbuf[i-1]=' ';
        xbuf[i]=' ';
        i++;
      }
      else
      {
        xbuf[i]=*rdesc;
        i++;
      }
    }
    else if (*rdesc=='.' || *rdesc=='?' || *rdesc=='!') {
      if (xbuf[i-1]==' ' && xbuf[i-2]==' ' &&
          (xbuf[i-3]=='.' || xbuf[i-3]=='?' || xbuf[i-3]=='!')) {
        xbuf[i-2]=*rdesc;
        if (*(rdesc+1) != '\"')
        {
          xbuf[i-1]=' ';
          xbuf[i]=' ';
          i++;
        }
        else
        {
          xbuf[i-1]='\"';
          xbuf[i]=' ';
          xbuf[i+1]=' ';
          i+=2;
          rdesc++;
        }
      }
      else
      {
        xbuf[i]=*rdesc;
        if (*(rdesc+1) != '\"')
        {
          xbuf[i+1]=' ';
          xbuf[i+2]=' ';
          i += 3;
        }
        else
        {
          xbuf[i+1]='\"';
          xbuf[i+2]=' ';
          xbuf[i+3]=' ';
          i += 4;
          rdesc++;
        }
      }
      cap = TRUE;
    }
    else
    {
      xbuf[i]=*rdesc;
      if ( cap )
        {
          cap = FALSE;
          xbuf[i] = UPPER( xbuf[i] );
        }
      i++;
    }
  }
  xbuf[i]=0;
  strcpy(xbuf2,xbuf);

  rdesc=xbuf2;

  xbuf[0]=0;

  for ( ; ; )
  {
    for (i=0; i<77; i++)
    {
      if (!*(rdesc+i)) break;
    }
    if (i<77)
    {
      break;
    }
    for (i=(xbuf[0]?76:73) ; i ; i--)
    {
      if (*(rdesc+i)==' ') break;
    }
    if (i)
    {
      *(rdesc+i)=0;
      strcat(xbuf,rdesc);
      strcat(xbuf,"\n\r");
      rdesc += i+1;
      while (*rdesc == ' ') rdesc++;
    }
    else
    {
      bug ("No spaces", 0);
      *(rdesc+75)=0;
      strcat(xbuf,rdesc);
      strcat(xbuf,"-\n\r");
      rdesc += 76;
    }
  }
  while (*(rdesc+i) && (*(rdesc+i)==' '||
                        *(rdesc+i)=='\n'||
                        *(rdesc+i)=='\r'))
    i--;
  *(rdesc+i+1)=0;
  strcat(xbuf,rdesc);
  if (xbuf[strlen(xbuf)-2] != '\n')
    strcat(xbuf,"\n\r");

  free_string(oldstring);
  return(str_dup(xbuf));
}


/*
 * Used above in string_add.  Because this function does not
 * modify case if fCase is FALSE and because it understands
 * parenthesis, it would probably make a nice replacement
 * for one_argument.
 */
/*****************************************************************************
 Name:		first_arg
 Purpose:	Pick off one argument from a string and return the rest.
 		Understands quates, parenthesis (barring ) ('s) and
 		percentages.
 Called by:	string_add(string.c)
 ****************************************************************************/
char *first_arg( char *argument, char *arg_first, bool fCase )
{
    char cEnd;

    while ( *argument == ' ' )
	argument++;

    cEnd = ' ';
    if ( *argument == '\'' || *argument == '"'
      || *argument == '%'  || *argument == '(' )
    {
        if ( *argument == '(' )
        {
            cEnd = ')';
            argument++;
        }
        else cEnd = *argument++;
    }

    while ( *argument != '\0' )
    {
	if ( *argument == cEnd )
	{
	    argument++;
	    break;
	}
    if ( fCase ) *arg_first = LOWER(*argument);
            else *arg_first = *argument;
	arg_first++;
	argument++;
    }
    *arg_first = '\0';

    while ( *argument == ' ' )
	argument++;

    return argument;
}




/*
 * Used in olc_act.c for aedit_builders.
 */
char * string_unpad( char * argument )
{
    char buf[MAX_STRING_LENGTH];
    char *s;

    s = argument;

    while ( *s == ' ' )
        s++;

    strcpy( buf, s );
    s = buf;

    if ( *s != '\0' )
    {
        while ( *s != '\0' )
            s++;
        s--;

        while( *s == ' ' )
            s--;
        s++;
        *s = '\0';
    }

    free_string( argument );
    return str_dup( buf );
}



/*
 * Same as capitalize but changes the pointer's data.
 * Used in olc_act.c in aedit_builder.
 */
char * string_proper( char * argument )
{
    char *s;

    s = argument;

    while ( *s != '\0' )
    {
        if ( *s != ' ' )
        {
            *s = UPPER(*s);
            while ( *s != ' ' && *s != '\0' )
                s++;
        }
        else
        {
            s++;
        }
    }

    return argument;
}

char *string_linedel( char *string, int line )
{
	char *strtmp = string;
	char buf[MAX_STRING_LENGTH];
	int cnt = 1, tmp = 0;

	buf[0] = '\0';

	for ( ; *strtmp != '\0'; strtmp++ )
	{
		if ( cnt != line )
			buf[tmp++] = *strtmp;

		if ( *strtmp == '\n' )
		{
			if ( *(strtmp + 1) == '\r' )
			{
				if ( cnt != line )
					buf[tmp++] = *(++strtmp);
				else
					++strtmp;
			}

			cnt++;
		}
	}

	buf[tmp] = '\0';

	free_string(string);
	return str_dup(buf);
}

char *string_lineadd( char *string, char *newstr, int line )
{
	char *strtmp = string;
	int cnt = 1, tmp = 0;
	bool done = FALSE;
	char buf[MAX_STRING_LENGTH];

	buf[0] = '\0';

	for ( ; *strtmp != '\0' || (!done && cnt == line); strtmp++ )
	{
		if ( cnt == line && !done )
		{
			strcat( buf, newstr );
			strcat( buf, "\n\r" );
			tmp += strlen(newstr) + 2;
			cnt++;
			done = TRUE;
		}

		buf[tmp++] = *strtmp;

		if ( done && *strtmp == '\0' )
			break;

		if ( *strtmp == '\n' )
		{
			if ( *(strtmp + 1) == '\r' )
				buf[tmp++] = *(++strtmp);

			cnt++;
		}

		buf[tmp] = '\0';
	}

	free_string(string);
	return str_dup(buf);
}

/* buf queda con la linea sin \n\r */
char *getline_( char *str, char *buf )
{
	int tmp = 0;
	bool found = FALSE;

	while ( *str )
	{
		if ( *str == '\n' )
		{
			found = TRUE;
			break;
		}

		buf[tmp++] = *(str++);
	}

	if ( found )
	{
		if ( *(str + 1) == '\r' )
			str += 2;
		else
			str += 1;
	} /* para que quedemos en el inicio de la prox linea */

	buf[tmp] = '\0';

	return str;
}

char *numlineas( char *string )
{
	int cnt = 1;
	static char buf[MAX_STRING_LENGTH*2];
	char buf2[MAX_STRING_LENGTH], tmpb[MAX_STRING_LENGTH];

	buf[0] = '\0';

	while ( *string )
	{
		string = getline_( string, tmpb );
		sprintf( buf2, "%2d. %s\n\r", cnt++, tmpb );
		strcat( buf, buf2 );
	}

	return buf;
}

#define	ANSI_KEY        '{'
#define	ANSI_CUSTOM     '\x11'
#define ANSI_END	    '\x12'

/* Removes all colour coding from a string */
void smash_colour ( char *buffer, char *str )
{
    int i = 0;
    char buf[MSL];

    memset ( buf, 0, MSL );

    if ( !str || *str == '\0' )
        return;

    while ( *str != '\0' )
    {
        if ( *str == ANSI_KEY )
        {
            str++;
            str++;
        }
        else if ( *str == ANSI_CUSTOM )
        {
            str++;
            while ( *str != ANSI_END )
                str++;
            str++;
        }
        else
        {
            buf[i] = *str;
            i++;
            str++;
        }
    }
    strcpy ( buffer, buf );
    return;
}

/* Counts the length of a string excluding colour codes */
int strlen_color ( const char *string )
{
    int i, count = 0;
    char arg[MSL];

    if ( !string )
        return count;

    strcpy ( arg, string );

    for ( i = 0; i <= MIL; i++ )
    {

        if ( arg[i] == '\0' )
        {
            break;
        }

        else if ( string[i] != ANSI_KEY && string[i] != ANSI_CUSTOM )
        {
            count++;
            continue;
        }

        else if ( arg[i] == ANSI_KEY && arg[i + 1] == ANSI_KEY )
        {
            i++;
            count++;
            continue;
        }

        else if ( arg[i] == ANSI_KEY && arg[i + 1] != ANSI_KEY &&
                  arg[i + 1] != '\0' )
        {
            i += 1;
            continue;
        }
        else if ( arg[i] == ANSI_CUSTOM )
        {
            i += 1;
            while ( arg[i] != ANSI_END )
                i += 1;
            i += 1;
            continue;
        }
        else if ( arg[i] == ANSI_KEY && arg[i + 1] == '\0' )
        {
            break;
        }

        else
        {
            count++;
            continue;
        }
    }

    return count;
}

/* returns true if the last char in a string i a colour code */
bool check_cstring ( char *string )
{
    int i;

    if ( string[0] == '\0' )
    {
        return FALSE;
    }

    for ( i = 0; i < strlen ( string ); i++ )
    {

        if ( string[i] == '\0' )
        {
            return FALSE;
        }

        else if ( string[i] != ANSI_KEY )
        {
            continue;
        }

        else if ( string[i] == ANSI_KEY && string[i + 1] != '\0' )
        {
            i++;
            continue;
        }

        else if ( string[i] == ANSI_KEY && string[i + 1] == '\0' )
        {
            return TRUE;
        }

        else
        {
            continue;
        }
    }

    return FALSE;
}
