/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <time.h>
#include "aww.h"
#include "tables.h"

const struct non_safe_areas_type  non_safe_areas_table [] =
{
        { "wild.are" },
        { "westroad.are" },
        { "southrd.are" },
        { "termool.are" },
        { "qhwy.are" },
        { "westwood.are" },
        { "gwall.are" },
        { "lgarris.are" },
        { "mirk.are" },
        { "mirk2.are" },
        { "ebousewr.are" },
        { "jangai.are" },
        { "blight.are" },
        { "extra.are" },
        { "random.are" },
        { "losttowr.are" },
        { "mmist.are" },
        { "mmist2.are" },
        { "towghen.are" },
        { "braem.are" },
        { "ways.are" },
        { "amadrd.are" },
        { "caemrd.are" },
        { "caemfarm.are" },
        { "3fold.are" },
        { "thakan.are" },
        { "shayul.are" },
        { "bandit.are" },
        { "thief.are" },
        { "wartower.are" },
        { "tow2.are" },
        { "madmen.are" },
        { "shadcoas.are" },
        { "midroads.are" },
        { "wshienrd.are" },
        { "arakanrd.are" },
        { "salkanrd.are" },
        { "tvarafrd.are" },
        { "kanforst.are" },
        { "salsthrd.are" },
        { "salforst.are" },
        { "paerishswor.are" },
        { NULL },
};
const   struct  gevent_type gevent_table [] =
{
	{ /* 0 */
		0, "Shadows Embrace", "{bSh{Badows {bEm{Bbrace{x", 15,
		"The Dark One raises ghosts to strengthen his armies.",
		"Ghosts are raised by the Dark One to strengthen his armies.\n\r" \
		"As creatures die they are replaced by avenging spirits\n\r" \
		"which seek to carry out the Dark One's work.\n\r",
		"<1|2|3> Set strength to 1 lesser, 2 equal, 3 greater.",
		TRUE, 0, FALSE,
	},
	{ /* 1 */
		1, "False Dragon", "{RFal{rse {RDra{rgon{x", 60,
		"A False Dragon has arisen to claim control of the lands.",
		"A False Dragon has arisen to claim control of the lands.\n\r" \
		"While this event is running, PK is allowed.\n\r",
		"<#> Sets number of followers the False Dragon Has.",
		TRUE, 100, TRUE,
	},
	{ /* 2 */
		2, "Raffle", "{YRa{yff{Yle{x", 3,
		"A powerful item is raffled.",
		"A powerful item is raffled. You may purchase tickets at your\n\r" \
		"local bank clerk, who has an unlimited supply. Once the time\n\r" \
		"for this event has ended the the person with the winning ticket\n\r" \
		"will receive the item that has been raffled. Note: To buy a ticket\n\r" \
		"from the bank clerk, type {yGevent Raffle Ticket{x\n\r",
		"<Item> Sets the item to be raffled.",
		TRUE, 0, FALSE,
	},
	{ /* 3 */
		3, "Free XP", "{wFree {WXP{x", 60,
		"A number of free experience points are given per kill.",
		"A number of free experience points are given per kill. While this\n\r" \
		"event is going on any kill will generate additional XP and trains.\n\r",
		"<#> Sets the number of free XPs per kill.",
		TRUE, 100, TRUE,
	},
	{ /* 4 */
		4, "Free QP", "{wFree {WQP{x", 60,
		"A number of free quest points are given per quest.",
		"A number of free quest points are given per quest. While this event\n\r" \
		"is running any quest that is completed will generate an additional\n\r" \
		"quest point reward which is added to the normal reward.\n\r",
		"<#> Sets the number of free XPs per kill.",
		TRUE, 100, TRUE,
	},
	{ /* 5 */
		5, "Treasure Hunt", "{CTr{Ceasu{Cre {CH{cun{Ct{x", 20,
		"Random items are made part of a treasure hunt.",
		"A number of random items in the MUD are made part of a treasure\n\r" \
		"hunt. When the event ends, whoever has the most items will win a\n\r" \
		"reward of gold coins.\n\r",
		"<#> Sets the reward in gold coins.",
		FALSE, 0, FALSE,
	},
	{ /* 6 */
		6, "Free Heals", "{gF{Gree {gH{Geals{x", 60,
		"Characters receive free heals of random types.",
		"Characters receive free heals of random types for the duration of\n\r" \
		"the event. Each heal for each character is randomly determined each\n\r" \
		"time a heal occurs.\n\r",
		"<#> No special options.",
		TRUE, 100, TRUE,
	},
	{ /* 7 */
		7, "Hawkwing's Revenge", "{RH{ya{Ywk{Rw{yi{Yng{R'{ys {rRevenge{x", 20,
		"Hawkwing's followers return to finish their assault.",
		"Characters choose to follow Hawkwing's armies or defend Tar Valon.\n\r" \
		"Once the last attacker or defender is dead, the battle is decided\n\r" \
		"and rewards are metted out.\n\r\n\rThis is a PK event.",
		"<#> No special options.",
		FALSE, 0, FALSE,
	},
	{ /* 8 */
		8, "Avenging Malkier", "{RAvenging {WMa{wl{Dk{wie{Wr{x", 20,
		"The Golden Crane has been raised.",
		"Characters choose to follow into the Blight to avenge the fallen.\n\r" \
		"nation of Malkier. Only those in the Shadow guilds may choose to\n\r" \
		"to defend the Shadow-overrun nation. Once the last attacker or\n\r" \
		"defender is dead, the battle is decided and the rewards are metted\n\r" \
		"out.\n\r\n\rThis is a PK event.",
		"<#> No special options.",
		FALSE, 0, FALSE,
	},
	{ /* 9 */
		9, "Happy Hour", "{GH{gapp{Gy {GH{gou{Gr{x", 20,
		"Let the Party Start!",
		"The Dark One and the Creator have finally agreed on something: You\n\r" \
		"people need to party more!\n\r",
		"<#> No special options.",
		TRUE, 50, TRUE,
	},
	{ /* 10 */
		10, "Matrim's Luck", "{DM{ga{Gtr{gi{Dm{w's {DL{gu{Gc{Dk{x", 60,
		"Mat's luck spreads briefly through the world's people.",
		"Characters are given a Ta'veren's luck for a brief while. Bonuses are\n\r" \
		"given to many different things while this event is in place.\n\r",
		"<#> No special options.",
		TRUE, 150, TRUE,
	},
	{ /* 11 */
		11, "Creator's Blessing", "{WC{wr{Ce{Wa{wt{Co{Wr{w's {WB{wl{Ce{Ws{wsi{Cn{Wg{x", 20,
		"The Creator' Light shines upon the people of the world.",
		"Characters are given special bonuses and enhancements while this event is\n\r" \
		"running. In some cases, the bonuses may last even after the event has ended.\n\r",
		"<#> No special options.",
		FALSE, 150, TRUE,
	},
	{ /* 12 */
		12, "Spammin'n'Skillin'", "{YSp{ya{Ymmi{yn'{Yn'{yS{Ykil{yli{Yn'{x", 30,
		"Characters will have an increased chance to improve their skills.",
		"Characters will have an increased chance to improve their skills.\n\r",
		"<#> No special options.",
		TRUE, 150, TRUE,
	},
	{ /* 13 */
		13, "Ton'o'Chests", "{DT{con{C'o'Che{cst{Ds{x", 60,
		"All mobs can drop chests and have an increased chance to drop them.",
		"All mobs can drop chests and have an increased chance to drop them.\n\r",
		"<#> No special options.",
		TRUE, 150, TRUE,
	},
	{ /* 14 */
		14, "Creator's Light", "{WCreator's Light{x", 60,
		"Heals, Double QP and Double XP are active.",
		"Heals, Double QP and Double XP are active.\n\r",
		"<#> No special options.",
		TRUE, 0, FALSE,
	},
	{ /* 15 */
		15, "Lynch Mob", "{gL{Gy{wn{Gc{gh {GM{wo{Gb{x", 60,
		"Group level restrictions are removed.",
		"While this event is running, all restrictions on grouping are\n\r" \
		"removed. When the event is over, care should be taken when the\n\r" \
		"restrictions are re-applied, characters may be suddenly be removed\n\r" \
		"from groups without warning.\n\r",
		"<#> No special options.",
		TRUE, 100, TRUE,
	},
	{ /* ender */
		0, NULL, NULL, -1,
		"Nothingness. The void of the event table.",
		"Nothingness. The void of the event table.",
		"Nothingness. The void of the event table.",
		FALSE, 0, FALSE,
	},
};

const struct material_type material_table[] =
{
	/* lookup name      definition         density value weapon modifier */
	{ "unknown",        MATERIAL_UNKNOWN,       0,  0,   0, 0, 0, 0, 0, 0    }, /* 1 */
	{ "silk",           MATERIAL_SILK,          1,  50,  0, 0, 1, 1, 0, 10    }, /* 2 */
	{ "cloth",          MATERIAL_CLOTH,         2,  5,   0, 1, 2, 2, 1, 2    }, /* 3 */
	{ "algode",         MATERIAL_ALGODE,        3,  5,   0, 2, 2, 2, 1, 3    }, /* 4 */
	{ "burlap",         MATERIAL_BURLAP,        3,  2,   0, 2, 2, 2, 2, 2    }, /* 5 */
	{ "wool",           MATERIAL_WOOL,          4,  5,   0, 2, 3, 3, 1, 2    },
	{ "linen",          MATERIAL_CLOTH,         2,  5,   0, 2, 3, 3, 1, 2   },
	{ "velvet",	        MATERIAL_CLOTH,	        2,  5,   0, 2, 3, 3, 1, 2	 },
	{ "lace",	        MATERIAL_CLOTH,	        1,  5,   0, 2, 3, 3, 1, 2    },
	{ "paper",          MATERIAL_PAPER,         4,  5,   0, 0, 1, 1, 1, 2    }, /* 10 */
	{ "vellum",         MATERIAL_VELLUM,        4,  6,   0, 1, 1, 1, 1, 3    },
	{ "twine",          MATERIAL_TWINE,         4,  5,   0, 0, 0, 0, 0, 2    },
	{ "hemp",           MATERIAL_HEMP,          4,  2,   0, 0, 0, 0, 0, 2    },
	{ "wire",           MATERIAL_WIRE,          6,  5,   0, 0, 0, 0, 0, 3    },
	{ "feather",        MATERIAL_FEATHER,       1,  10,  0, 0, 0, 1, 0, 1   },
	{ "clay",           MATERIAL_STONE_SOFT,    10, 10,  0, 3, 3, 1, 1, 5   }, /* 15 */
	{ "gold cloth",     MATERIAL_CLOTH,         3,  12,  0, 2, 2, 2, 2, 8   },
	{ "silver cloth",   MATERIAL_CLOTH,         3,  10,  0, 3, 3, 3, 3, 8   },
	{ "fancloth",       MATERIAL_CLOTH,         10, 50,  0, 5, 5, 5, 5, 10   },
	{ "food",           MATERIAL_FOOD,          5,  2,   0, 1, 1, 1, 1, 1    }, /* 20 */
	{ "fur",            MATERIAL_FUR,           6,  8,   0, 4, 4, 4, 4, 2    },
	{ "rabbit skin",    MATERIAL_LEATHER_SOFT,  5,  10,  0, 4, 4, 4, 4, 3   },
	{ "soft leather",   MATERIAL_LEATHER_SOFT,  7,  10,  0, 4, 4, 4, 4, 3   },
	{ "boiled leather", MATERIAL_LEATHER_SOFT,  8,  12,  0, 5, 5, 5, 5, 4   },
	{ "cured leather",  MATERIAL_LEATHER_HARD,  9,  15,  0, 6, 6, 6, 6, 5   }, /* 25 */
	{ "hard leather",   MATERIAL_LEATHER_HARD,  8,  20,  0, 6, 6, 6, 6, 6   },
	{ "soft wood",      MATERIAL_WOOD_SOFT,     7,  5,   2, 6, 6, 6, 6, 2    },
	{ "pine",           MATERIAL_WOOD_SOFT,     8,  6,   2, 6, 6, 6, 6, 3    },
	{ "leatherleaf",    MATERIAL_WOOD_SOFT,     9,  7,   3, 6, 6, 6, 6, 3    },
	{ "rosewood",       MATERIAL_WOOD_SOFT,     9,  7,   3, 6, 6, 6, 6, 4    }, /* 30 */
	{ "satinwood",      MATERIAL_WOOD_SOFT,     9,  7,   3, 6, 6, 6, 6, 4    },
	{ "hemlock",        MATERIAL_WOOD_SOFT,     9,  7,   3, 6, 6, 6, 6, 5    },
	{ "poplar",         MATERIAL_WOOD_SOFT,     9,  7,   3, 6, 6, 6, 6, 5    },
	{ "fir",            MATERIAL_WOOD_SOFT,     10, 8,   4, 6, 6, 6, 6, 5    },
	{ "beech",          MATERIAL_WOOD_SOFT,     10, 8,   4, 6, 6, 6, 6, 5    }, /* 35 */
	{ "spruce",         MATERIAL_WOOD_SOFT,     10, 9,   4, 6, 6, 6, 6, 6    },
	{ "cypress",        MATERIAL_WOOD_SOFT,     10, 10,  4, 6, 6, 6, 6, 6   },
	{ "juniper",        MATERIAL_WOOD_SOFT,     10, 10,  4, 6, 6, 6, 6, 6   },
	{ "walnut",         MATERIAL_WOOD_HARD,     11, 11,  5, 7, 7, 7, 7, 7   },
	{ "cedar",          MATERIAL_WOOD_HARD,     11, 12,  5, 7, 7, 7, 7, 7   }, /* 40 */
	{ "maple",          MATERIAL_WOOD_HARD,     11, 13,  5, 7, 7, 7, 7, 8   },
	{ "mahogany",       MATERIAL_WOOD_HARD,     11, 14,  5, 7, 7, 7, 7, 9   },
	{ "teak",           MATERIAL_WOOD_SOFT,     10, 15,  3, 6, 6, 6, 6, 9   },
	{ "ebony",          MATERIAL_WOOD_HARD,     12, 16,  6, 7, 7, 7, 7, 9   },
	{ "redwood",        MATERIAL_WOOD_HARD,     13, 17,  6, 7, 7, 7, 7, 9   }, /* 45 */
	{ "willow",         MATERIAL_WOOD_SOFT,     11, 18,  4, 6, 6, 6, 6, 9   },
	{ "oak",            MATERIAL_WOOD_HARD,     15, 19,  6, 7, 7, 7, 7, 10   },
	{ "yew",            MATERIAL_WOOD_HARD,     16, 20,  6, 7, 7, 7, 7, 10   },
	{ "hard wood",      MATERIAL_WOOD_HARD,     10, 10,  6, 7, 7, 7, 7, 9   },
	{ "bone",           MATERIAL_BONE,          11, 10,  5, 8, 8, 8, 8, 5   }, /* 50 */
	{ "sungwood",       MATERIAL_WOOD_SUNG,     12, 500, 7, 8, 8, 8, 8, 10  },
	{ "softstone",      MATERIAL_STONE_SOFT,    13, 25,  6, 6, 6, 6, 6, 2   },
	{ "sand",           MATERIAL_STONE_SOFT,    3,  10,  0, 1, 1, 1, 1, 2   },
	{ "loose stone",    MATERIAL_STONE_SOFT,    4,  12,  0, 2, 2, 2, 2, 2   },
	{ "sandstone",      MATERIAL_STONE_SOFT,    5,  14,  1, 2, 2, 2, 2, 3   }, /* 55 */
	{ "shale",          MATERIAL_STONE_SOFT,    6,  16,  2, 2, 2, 2, 2, 3   },
	{ "flint",          MATERIAL_STONE_SOFT,    7,  18,  3, 3, 3, 3, 3, 4   },
	{ "quartz",         MATERIAL_STONE_SOFT,    8,  20,  3, 3, 3, 3, 3, 5   },
	{ "limestone",      MATERIAL_STONE_HARD,    9,  22,  3, 4, 4, 4, 4, 4   },
	{ "granite",        MATERIAL_STONE_HARD,    10, 25,  5, 5, 5, 5, 5, 4   }, /* 60 */
	{ "marble",         MATERIAL_STONE_HARD,    12, 30,  5, 5, 5, 5, 5, 5   },
	{ "hardstone",      MATERIAL_STONE_HARD,    14, 35,  7, 6, 6, 6, 6, 4   },
	{ "precious metal", MATERIAL_METAL_PRECIOUS,15, 250, 10,5, 5, 5, 5, 10  },
	{ "soft metal",     MATERIAL_METAL_SOFT,    8,  10,  7, 6, 6, 6, 6, 5   },
	{ "bronze",         MATERIAL_METAL_SOFT,    10, 10,  7, 7, 7, 7, 7, 8   }, /* 65 */
	{ "copper",         MATERIAL_METAL_SOFT,    12, 12,  8, 8, 7, 7, 7, 9   },
	{ "lead",           MATERIAL_METAL_HARD,    14, 14,  8, 8, 8, 8, 8, 9   },
	{ "silver",         MATERIAL_METAL_SOFT,    10, 20,  5, 6, 6, 6, 6, 12   },
	{ "nickel",         MATERIAL_METAL_HARD,    15, 25,  8, 8, 8, 8, 8, 10   },
	{ "gold",           MATERIAL_METAL_SOFT,    8,  75,  4, 5, 5, 5, 5, 15   }, /* 70 */
	{ "iron",           MATERIAL_METAL_HARD,    17, 30,  8, 8, 8, 8, 8, 12   },
	{ "steel",          MATERIAL_METAL_HARD,    20, 30,  10,10,10,10,10, 15   },
	{ "platinum",       MATERIAL_METAL_HARD,    20, 50,  11,11,11,11,11, 16   },
	{ "hard metal",     MATERIAL_METAL_HARD,    15, 40,  12,12,12,12,12, 20   },
	{ "gemstone",       MATERIAL_STONE_GEM,     18, 500, 10,10,10,10,10, 18  }, /* 75 */
	{ "black steel",    MATERIAL_BLACKSTEEL,    18, 50,  12,12,12,12,12, 18  },
	{ "powerwrought steel", MATERIAL_POWERWROUGHT,    19, 100,  15,15,15,15,15, 19  },
	{ NULL,             MATERIAL_UNKNOWN,       0,  0,   0, 0, 0, 0, 0,  0    }  /* 79 */
};

/* for position */
const struct position_type position_table[] =
{
    {	"dead",			"dead"	},
    {	"mortally wounded",	"mort"	},
    {	"incapacitated",	"incap"	},
    {	"stunned",		"stun"	},
    {	"sleeping",		"sleep"	},
    {	"resting",		"rest"	},
    {   "sitting",		"sit"   },
    {	"fighting",		"fight"	},
    {	"standing",		"stand"	},
    {	NULL,			NULL	}
};

/* for sex */
const struct sex_type sex_table[] =
{
   {	"none"		},
   {	"male"		},
   {	"female"	},
   {	"either"	},
   {	NULL		}
};

/* for sizes */
const struct size_type size_table[] =
{
    {	"tiny"		},
    {	"small" 	},
    {	"medium"	},
    {	"large"		},
    {	"huge", 	},
    {	"giant" 	},
    {	NULL		}
};

/* various flag tables */
const struct flag_type act_flags[] =
{
    {	"npc",			A,	FALSE	},
    {	"sentinel",		B,	TRUE	},
    {	"scavenger",	C,	TRUE	},
    {	"aggressive",	F,	TRUE	},
    {	"mount",		E,	TRUE	},
    {	"stay_area",	G,	TRUE	},
    {	"wimpy",		H,	TRUE	},
    {	"pet",			I,	TRUE	},
    {	"train",		J,	TRUE	},
    {	"practice",		K,	TRUE	},
    {   "gambler",      L,  TRUE    },
    {   "jeweler",      M,  TRUE    },
    {	"undead",		O,	TRUE	},
    {	"cleric",		Q,	TRUE	},
    {	"mage",			R,	TRUE	},
    {	"thief",		S,	TRUE	},
    {	"warrior",		T,	TRUE	},
    {	"noalign",		U,	TRUE	},
    {	"nopurge",		V,	TRUE	},
    {	"outdoors",		W,	TRUE	},
    {	"indoors",		Y,	TRUE	},
    {	"healer",		aa,	TRUE	},
    {	"gain",			bb,	TRUE	},
    {	"update_always",cc,	TRUE	},
    {	"changer",		dd,	TRUE	},
    {   "stringer",     ee, TRUE    },
    {	NULL,			0,	FALSE	}
};

const struct flag_type plr_flags[] =
{
    {	"npc",			A,	FALSE	},
    {	"autoassist",	C,	FALSE	},
    {	"autoexit",		D,	FALSE	},
    {	"autoloot",		E,	FALSE	},
    {	"autosac",		F,	FALSE	},
    {	"autogold",		G,	FALSE	},
    {	"autosplit",	H,	FALSE	},
    {	"holylight",	N,	FALSE	},
    {	"can_loot",		P,	FALSE	},
    {	"nosummon",		Q,	FALSE	},
    {	"nofollow",		R,	FALSE	},
    {	"colour",		T,	FALSE	},
    {	"permit",		U,	TRUE	},
    {	"log",			W,	FALSE	},
    {	"deny",			X,	FALSE	},
    {	"freeze",		Y,	FALSE	},
    {	"thief",		Z,	FALSE	},
    {	"killer",		aa,	FALSE	},
    {	NULL,			0,	0	}
};

const struct flag_type auto_flags[] =
{
	{   "autodamage",   A,  TRUE   },
	{   "autobutcher",  B,  TRUE   },
	{   "autoslay",     C,  TRUE   },
	{   "autolog",      D,  TRUE   },
	{   "autoskin",     E,  TRUE   },
	{   "hints",        F,  TRUE   },
	{   "autorecall",   G,  TRUE   },
	{   "automap",      H,  TRUE   },
	{   "autocounter",  I,  TRUE   },
	{   "autoparry",    J,  TRUE   },
	{   "autododge",    K,  TRUE   },
	{   "autowar",      L,  TRUE   },
	{   "autopeek",     M,  TRUE   },
	{   "autoroa",      N,  TRUE   },
	{   "autoftag",     O,  TRUE   },
	{   "autotourney",  P,  TRUE   },
	{   "autotrivia",   Q,  TRUE   },
	{   "autobox",      R,  TRUE   },
	{   "autosavemess", S,  TRUE   },
	{   "autoh2h",      T,  TRUE   },
    {	NULL,			0,	0	   }
};

const struct flag_type op_flags[] =
{
	{   "channeler",    A,  TRUE   },
	{   "grasped",      B,  TRUE   },
	{   "fshield",      E,  TRUE   },
	{   "large",        F,  TRUE   },
	{   NULL,           0,  0      }
};

const struct flag_type talent_flags[] =
{
	{   "warding",       A,  TRUE   },
	{   "elementalism",  B,  TRUE   },
	{   "healing",       C,  TRUE   },
	{   "clouddancing",  D,  TRUE   },
	{   "earthsinging",  E,  TRUE   },
	{   NULL,            0,  0      }
};

const struct flag_type spec_flags[] =
{
	{   "wolfkin",      A,  TRUE   },
	{   "taveren",      B,  TRUE   },
	{   "ageless",      C,  TRUE   },
	{   "dreamwalker",  D,  TRUE   },
	{   "dreaming",     E,  TRUE   },
	{   "mentor",       F,  TRUE   },
	{   "seer",         G,  TRUE   },
	{   "married",      H,  TRUE   },
	{   "x",            I,  TRUE   },
	{   "noteach",      J,  TRUE   },
    {	NULL,			0,	0	   }
};

const struct flag_type hist_flags[] =
{
	{   "merchant",      A,  TRUE   },
	{   "soldier",       B,  TRUE   },
	{   "beggar",        C,  TRUE   },
	{   "artist",        D,  TRUE   },
	{   "farmer",        E,  TRUE   },
	{   "child",         F,  TRUE   },
	{   "musician",      G,  TRUE   },
	{   "sailor",        H,  TRUE   },
	{   "noble",         I,  TRUE   },
	{   "shadow",      J,  TRUE   }, /* used to identify shadow guild for darkgifts */
	{   "recruiter",   K,  TRUE   },
	{   "guildleader",     L,  TRUE   },
	{   "shadowgift",      M, TRUE    }, /* Dark GIFT! */
	{   "bonder",      N, TRUE    },
	{   "bonded",    O, TRUE    },

    {	NULL,			 0,	 0	    }
};

const struct flag_type tabac_flags[] =
{
	{   "smoking",      A,  TRUE   },
	{   "chewing",      B,  TRUE   },
    {	NULL,			0,	0	   }
};

const struct flag_type war_flags[] =
{
	{   "veiled",       A,  TRUE   },
	{   "questor",      B,  TRUE   },
	{   "bounty",       C,  TRUE   },
	{   "pk",           D,  TRUE   },
	{   "msp",          E,  TRUE   },
	{   "held",         F,  TRUE   },
	{   "moderator",    G,  TRUE   },
	{   "daishan",      H,  TRUE   },
	{   "mhael",        I,  TRUE   },
	{   "naeblis",      J,  TRUE   },
	{   "masterbard",   K,  TRUE   },
	{   "queensguard",  L,  TRUE   },
	{   "wisest",       M,  TRUE   },
	{   "mentor",       N,  TRUE   },
	{   "prophet",      O,  TRUE   },
	{   "autofight",    P,  TRUE   },
	{   "immortal",     Q,  TRUE   },
	{   "gquest",       R,  TRUE   },
	{   "battle",       S,  TRUE   },
	{   "tourney",      T,  TRUE   },
	{   "coder",	    U,  TRUE   },
    {	NULL,			0,	0	   }
};

const struct flag_type penalty_flags[] =
{
	{   "nowalk",       A,  FALSE   },
	{   "nomove",       B,  FALSE   },
    {   "nochannel",	C,	FALSE	},
    {   "noemote",		D,	FALSE	},
    {   "noshout",		E,	FALSE	},
    {   "notell",		F,	FALSE	},
    {   "jailed",		G,	FALSE	},
    {	NULL,			0,	0	   }
};

const struct flag_type ajah_flags[] =
{
	{   "red",      A,  TRUE   },
	{   "blue",     B,  TRUE   },
	{   "green",    C,  TRUE   },
	{   "gray",     D,  TRUE   },
	{   "white",    E,  TRUE   },
	{   "yellow",   F,  TRUE   },
	{   "brown",    G,  TRUE   },
	{   "black",    H,  TRUE   },
	{   "all",      I,  TRUE   },
    {	NULL,		0,	0	   }
};


const struct flag_type affect_flags[] =
{
    {	"blind",		A,	TRUE	},
    {	"invisible",		B,	TRUE	},
    {	"detect_evil",		C,	TRUE	},
    {	"detect_invis",		D,	TRUE	},
    {	"detect_magic",		E,	TRUE	},
    {	"detect_hidden",	F,	TRUE	},
    {	"detect_good",		G,	TRUE	},
    {	"sanctuary",		H,	TRUE	},
    {	"faerie_fire",		I,	TRUE	},
    {	"infrared",		J,	TRUE	},
    {	"curse",		K,	TRUE	},
    {	"poison",		M,	TRUE	},
    {	"protect_evil",		N,	TRUE	},
    {	"protect_good",		O,	TRUE	},
    {	"sneak",		P,	TRUE	},
    {	"hide",			Q,	TRUE	},
    {	"sleep",		R,	TRUE	},
    {	"charm",		S,	TRUE	},
    {	"flying",		T,	TRUE	},
    {	"pass_door",		U,	TRUE	},
    {	"haste",		V,	TRUE	},
    {	"calm",			W,	TRUE	},
    {	"plague",		X,	TRUE	},
    {	"weaken",		Y,	TRUE	},
    {	"dark_vision",		Z,	TRUE	},
    {	"berserk",		aa,	TRUE	},
    {	"swim",			bb,	TRUE	},
    {	"regeneration",		cc,	TRUE	},
    {	"slow",			dd,	TRUE	},
    {	"void",			ee,	TRUE	},
    {	NULL,			0,	0	}
};

const struct flag_type off_flags[] =
{
    {	"area_attack",		A,	TRUE	},
    {	"backstab",		B,	TRUE	},
    {	"bash",			C,	TRUE	},
    {	"berserk",		D,	TRUE	},
    {	"disarm",		E,	TRUE	},
    {	"dodge",		F,	TRUE	},
    {	"fade",			G,	TRUE	},
    {	"fast",			H,	TRUE	},
    {	"kick",			I,	TRUE	},
    {	"dirt_kick",		J,	TRUE	},
    {	"parry",		K,	TRUE	},
    {	"rescue",		L,	TRUE	},
    {	"tail",			M,	TRUE	},
    {	"trip",			N,	TRUE	},
    {	"crush",		O,	TRUE	},
    {	"assist_all",		P,	TRUE	},
    {	"assist_align",		Q,	TRUE	},
    {	"assist_race",		R,	TRUE	},
    {	"assist_players",	S,	TRUE	},
    {	"assist_guard",		T,	TRUE	},
    {	"assist_vnum",		U,	TRUE	},
    {   "charge",           V,  TRUE    },
    {   "circle",           W,  TRUE    },
    {   "forms",            X,  TRUE    },
    {   "spirit",           Y,  TRUE    },
    {	NULL,			0,	0	}
};

const struct flag_type imm_flags[] =
{
    {	"summon",		A,	TRUE	},
    {	"charm",		B,	TRUE	},
    {	"magic",		C,	TRUE	},
    {	"weapon",		D,	TRUE	},
    {	"bash",			E,	TRUE	},
    {	"pierce",		F,	TRUE	},
    {	"slash",		G,	TRUE	},
    {	"fire",			H,	TRUE	},
    {	"cold",			I,	TRUE	},
    {	"lightning",		J,	TRUE	},
    {	"acid",			K,	TRUE	},
    {	"poison",		L,	TRUE	},
    {	"negative",		M,	TRUE	},
    {	"holy",			N,	TRUE	},
    {	"energy",		O,	TRUE	},
    {	"mental",		P,	TRUE	},
    {	"disease",		Q,	TRUE	},
    {	"drowning",		R,	TRUE	},
    {	"light",		S,	TRUE	},
    {	"sound",		T,	TRUE	},
    {	"wood",			X,	TRUE	},
    {	"silver",		Y,	TRUE	},
    {	"iron",			Z,	TRUE	},
    {	NULL,			0,	0	}
};

const struct flag_type form_flags[] =
{
    {	"edible",		FORM_EDIBLE,		TRUE	},
    {	"poison",		FORM_POISON,		TRUE	},
    {	"magical",		FORM_MAGICAL,		TRUE	},
    {	"instant_decay",	FORM_INSTANT_DECAY,	TRUE	},
    {	"other",		FORM_OTHER,		TRUE	},
    {	"animal",		FORM_ANIMAL,		TRUE	},
    {	"sentient",		FORM_SENTIENT,		TRUE	},
    {	"undead",		FORM_UNDEAD,		TRUE	},
    {	"construct",		FORM_CONSTRUCT,		TRUE	},
    {	"mist",			FORM_MIST,		TRUE	},
    {	"intangible",		FORM_INTANGIBLE,	TRUE	},
    {	"biped",		FORM_BIPED,		TRUE	},
    {	"centaur",		FORM_CENTAUR,		TRUE	},
    {	"insect",		FORM_INSECT,		TRUE	},
    {	"spider",		FORM_SPIDER,		TRUE	},
    {	"crustacean",		FORM_CRUSTACEAN,	TRUE	},
    {	"worm",			FORM_WORM,		TRUE	},
    {	"blob",			FORM_BLOB,		TRUE	},
    {	"mammal",		FORM_MAMMAL,		TRUE	},
    {	"bird",			FORM_BIRD,		TRUE	},
    {	"reptile",		FORM_REPTILE,		TRUE	},
    {	"snake",		FORM_SNAKE,		TRUE	},
    {	"dragon",		FORM_DRAGON,		TRUE	},
    {	"amphibian",		FORM_AMPHIBIAN,		TRUE	},
    {	"fish",			FORM_FISH ,		TRUE	},
    {	"cold_blood",		FORM_COLD_BLOOD,	TRUE	},
    {	NULL,			0,			0	}
};

const struct flag_type part_flags[] =
{
    {	"head",			PART_HEAD,		TRUE	},
    {	"arms",			PART_ARMS,		TRUE	},
    {	"legs",			PART_LEGS,		TRUE	},
    {	"heart",		PART_HEART,		TRUE	},
    {	"brains",		PART_BRAINS,		TRUE	},
    {	"guts",			PART_GUTS,		TRUE	},
    {	"hands",		PART_HANDS,		TRUE	},
    {	"feet",			PART_FEET,		TRUE	},
    {	"fingers",		PART_FINGERS,		TRUE	},
    {	"ear",			PART_EAR,		TRUE	},
    {	"eye",			PART_EYE,		TRUE	},
    {	"long_tongue",		PART_LONG_TONGUE,	TRUE	},
    {	"eyestalks",		PART_EYESTALKS,		TRUE	},
    {	"tentacles",		PART_TENTACLES,		TRUE	},
    {	"fins",			PART_FINS,		TRUE	},
    {	"wings",		PART_WINGS,		TRUE	},
    {	"tail",			PART_TAIL,		TRUE	},
    {	"claws",		PART_CLAWS,		TRUE	},
    {	"fangs",		PART_FANGS,		TRUE	},
    {	"horns",		PART_HORNS,		TRUE	},
    {	"scales",		PART_SCALES,		TRUE	},
    {	"tusks",		PART_TUSKS,		TRUE	},
    {	NULL,			0,			0	}
};

const struct flag_type comm_flags[] =
{
    {	"quiet",		COMM_QUIET,		    TRUE	},
    {	"pdeath",		COMM_PDEATH,	    TRUE	},
    {   "deaf",			COMM_DEAF,		    TRUE	},
    {   "nowiz",		COMM_NOWIZ,		    TRUE	},
    {   "noclangossip",	COMM_NOAUCTION,	    TRUE	},
    {   "noooc",		COMM_NOOOC,		    TRUE	},
    {   "noic",         COMM_NOIC,          TRUE    },
    {   "noquestion",	COMM_NOQUESTION,	TRUE	},
    {   "nomusic",		COMM_NOMUSIC,		TRUE	},
    {   "noclan",		COMM_NOCLAN,		TRUE	},
    {   "noquote",		COMM_NOQUOTE,		TRUE	},
    {   "shoutsoff",	COMM_SHOUTSOFF,		TRUE	},
    {   "compact",		COMM_COMPACT,		TRUE	},
    {   "brief",		COMM_BRIEF,		    TRUE	},
    {   "prompt",		COMM_PROMPT,		TRUE	},
    {   "combine",		COMM_COMBINE,		TRUE	},
    {   "telnet_ga",	COMM_TELNET_GA,		TRUE	},
    {   "show_affects",	COMM_SHOW_AFFECTS,	TRUE	},
    {   "nograts",		COMM_NOGRATS,		TRUE	},
    {   "snoop_proof",	COMM_SNOOP_PROOF,	FALSE	},
    {   "rp",			COMM_RP,		    TRUE	},
    {   "afk",			COMM_AFK,		    TRUE	},
	{ "nogl", 			COMM_NOGL,			TRUE },
    { NULL, 0, 0 } };

const struct flag_type mprog_flags[] =
{
    {	"act",			TRIG_ACT,		TRUE	},
    {	"bribe",		TRIG_BRIBE,		TRUE 	},
    {	"death",		TRIG_DEATH,		TRUE    },
    {	"entry",		TRIG_ENTRY,		TRUE	},
    {	"fight",		TRIG_FIGHT,		TRUE	},
    {	"give",			TRIG_GIVE,		TRUE	},
    {	"greet",		TRIG_GREET,		TRUE    },
    {	"grall",		TRIG_GRALL,		TRUE	},
    {	"kill",			TRIG_KILL,		TRUE	},
    {	"hpcnt",		TRIG_HPCNT,		TRUE    },
    {	"random",		TRIG_RANDOM,		TRUE	},
    {	"speech",		TRIG_SPEECH,		TRUE	},
    {	"exit",			TRIG_EXIT,		TRUE    },
    {	"exall",		TRIG_EXALL,		TRUE    },
    {	"delay",		TRIG_DELAY,		TRUE    },
    {	"surr",			TRIG_SURR,		TRUE    },
    {	"surrender",	TRIG_SURR,		TRUE    },
    {	NULL,			0,			TRUE	}
};
const struct flag_type oprog_flags[] =
{
    {	"act",			TRIG_ACT,		TRUE	},
    {	"fight",		TRIG_FIGHT,		TRUE	},
    {	"give",			TRIG_GIVE,		TRUE	},
    /*{   "greet",		TRIG_GRALL,		TRUE	},*/
    {	"greet",		TRIG_GREET,		TRUE	},
    {	"random",		TRIG_RANDOM,		TRUE	},
    {   "speech",		TRIG_SPEECH,		TRUE	},
    {	"exall",		TRIG_EXALL,		TRUE	},
    {	"delay",		TRIG_DELAY,		TRUE	},
    {	"drop",		TRIG_DROP,		TRUE	},
    {	"get",		TRIG_GET,		TRUE	},
    {	"sit",		TRIG_SIT,		TRUE	},
    {	NULL,			0,			TRUE	},
};

const struct flag_type rprog_flags[] =
{
    {	"act",			TRIG_ACT,		TRUE	},
    {	"fight",		TRIG_FIGHT,		TRUE	},
    {	"drop",			TRIG_DROP,		TRUE	},
    /*{	"greet",		TRIG_GRALL,		TRUE	},*/
    {	"greet",		TRIG_GREET,		TRUE	},
    {	"random",		TRIG_RANDOM,		TRUE	},
    {	"speech",		TRIG_SPEECH,		TRUE	},
    {	"exall",		TRIG_EXALL,		TRUE	},
    {	"delay",		TRIG_DELAY,		TRUE	},
    {	NULL,			0,			TRUE	},
};

const struct flag_type area_flags[] =
{
    {	"none",			AREA_NONE,		FALSE	},
    {	"changed",		AREA_CHANGED,		TRUE	},
    {	"added",		AREA_ADDED,		TRUE	},
    {	"loading",		AREA_LOADING,		FALSE	},
    {	NULL,			0,			0	}
};



const struct flag_type sex_flags[] =
{
    {	"male",			SEX_MALE,		TRUE	},
    {	"female",		SEX_FEMALE,		TRUE	},
    {	"neutral",		SEX_NEUTRAL,		TRUE	},
    {   "random",               3,                      TRUE    },   /* ROM */
    {	"none",			SEX_NEUTRAL,		TRUE	},
    {	NULL,			0,			0	}
};



const struct flag_type exit_flags[] =
{
    {   "door",			EX_ISDOOR,		TRUE    },
    {	"closed",		EX_CLOSED,		TRUE	},
    {	"locked",		EX_LOCKED,		TRUE	},
    {   "climb",        EX_CLIMB,       TRUE    },
    {	"pickproof",	EX_PICKPROOF,		TRUE	},
    {   "nopass",		EX_NOPASS,		TRUE	},
    {   "easy",			EX_EASY,		TRUE	},
    {   "hard",			EX_HARD,		TRUE	},
    {	"infuriating",	EX_INFURIATING,		TRUE	},
    {	"noclose",		EX_NOCLOSE,		TRUE	},
    {	"nolock",		EX_NOLOCK,		TRUE	},
    {	NULL,			0,			0	}
};



const struct flag_type door_resets[] =
{
    {	"open and unlocked",	0,		TRUE	},
    {	"closed and unlocked",	1,		TRUE	},
    {	"closed and locked",	2,		TRUE	},
    {	NULL,			0,		0	}
};



const struct flag_type room_flags[] =
{
    {	"dark",			ROOM_DARK,		TRUE	},
    {   "jail",         ROOM_JAIL,      TRUE    },
    {	"no_mob",		ROOM_NO_MOB,		TRUE	},
    {	"indoors",		ROOM_INDOORS,		TRUE	},
    {	"stedding",		ROOM_STEDDING,		TRUE	},
    {	"casino",		ROOM_CASINO,		TRUE	},
    {	"private",		ROOM_PRIVATE,		TRUE    },
    {	"safe",			ROOM_SAFE,		TRUE	},
    {	"solitary",		ROOM_SOLITARY,		TRUE	},
    {	"pet_shop",		ROOM_PET_SHOP,		TRUE	},
    {	"no_recall",		ROOM_NO_RECALL,		TRUE	},
    {	"imp_only",		ROOM_IMP_ONLY,		TRUE    },
    {	"gods_only",	        ROOM_GODS_ONLY,		TRUE    },
    {	"heroes_only",		ROOM_HEROES_ONLY,	TRUE	},
    {	"newbies_only",		ROOM_NEWBIES_ONLY,	TRUE	},
    {	"law",			ROOM_LAW,		TRUE	},
    {   "nowhere",		ROOM_NOWHERE,		TRUE	},
    {   "bank",         ROOM_BANK,          TRUE    },
    {   "pawnshop",     ROOM_PAWNSHOP,      TRUE    },
    {   "playerkill",   ROOM_PK,            TRUE    },
    {   "nogate",       ROOM_NOGATE,        TRUE    },
    {   "climb",        ROOM_CLIMB,         TRUE    },
    {   "home",         ROOM_HOME,          TRUE    },
    {   "buildhome",    ROOM_BUILDHOME,          TRUE    },
    {   "msp",          ROOM_MSP,          TRUE    },
    {   "mountshop",    ROOM_MOUNT_SHOP,    TRUE    },
    {   "locker",       ROOM_LOCKER,        TRUE    },
    {   "welllit",      ROOM_WELL_LIT,      TRUE    },
    {	NULL,			0,			0	}
};



const struct flag_type sector_flags[] =
{
    {	"inside",	  SECT_INSIDE,		TRUE	},
    {	"city",		  SECT_CITY,		TRUE	},
    {	"field",	  SECT_FIELD,		TRUE	},
    {	"forest",	  SECT_FOREST,		TRUE	},
    {	"hills",	  SECT_HILLS,		TRUE	},
    {	"mountain",	  SECT_MOUNTAIN,		TRUE	},
    {	"swim",		  SECT_WATER_SWIM,	TRUE	},
    {	"noswim",	  SECT_WATER_NOSWIM,	TRUE	},
    {   "unused",	  SECT_UNUSED,		TRUE	},
    {	"air",		  SECT_AIR,		TRUE	},
    {	"desert",	  SECT_DESERT,		TRUE	},
    {   "blight",     SECT_BLIGHT,            TRUE    },
    {   "coastal",    SECT_COASTAL,           TRUE    },
    {   "road",       SECT_ROAD,              TRUE    },
    {   "marsh",      SECT_MARSH,             TRUE    },
    {   "tundra",     SECT_TUNDRA,            TRUE    },
    {   "waste",      SECT_WASTE,            TRUE    },
    {   "freshlake",  SECT_LAKE_FRESH,            TRUE    },
    {   "saltlake",   SECT_LAKE_SALT,            TRUE    },
    {   "freshriver", SECT_RIVER_SALT,            TRUE    },
    {   "saltriver",  SECT_RIVER_FRESH,            TRUE    },
    {   "volcanic",   SECT_VOLCANIC,            TRUE    },
    {   "ocean",      SECT_OCEAN,            TRUE    },
    {   "underground",SECT_UNDERGROUND,            TRUE    },
    {   "underwater", SECT_UNDERWATER,            TRUE    },
    {   "foothills",  SECT_FOOTHILLS,            TRUE    },
    {   "jungle",     SECT_JUNGLE,            TRUE    },
    {   "farmland",   SECT_FARMLAND,            TRUE    },
    {   "steppe",     SECT_STEPPE,            TRUE    },
    {   "plain",      SECT_PLAIN,            TRUE    },
    {   "meadow",     SECT_MEADOW,            TRUE    },
    {	NULL,		0,			0	}
};



const struct flag_type type_flags[] =
{
    {	"light",		ITEM_LIGHT,		    TRUE	},
    {	"scroll",		ITEM_SCROLL,		TRUE	},
    {	"wand",			ITEM_WAND,		    TRUE	},
    {	"staff",		ITEM_STAFF,		    TRUE	},
    {	"weapon",		ITEM_WEAPON,		TRUE	},
    {	"treasure",		ITEM_TREASURE,		TRUE	},
    {	"herb",			ITEM_HERB,		TRUE	},
    {	"armor",		ITEM_ARMOR,		    TRUE	},
    {	"potion",		ITEM_POTION,		TRUE	},
    {	"furniture",	ITEM_FURNITURE,		TRUE	},
    {	"trash",		ITEM_TRASH,		    TRUE	},
    {	"container",	ITEM_CONTAINER,		TRUE	},
    {	"drinkcontainer",ITEM_DRINK_CON,	TRUE	},
    {	"key",			ITEM_KEY,		    TRUE	},
    {	"food",			ITEM_FOOD,		    TRUE	},
    {	"money",		ITEM_MONEY,		    TRUE	},
    {	"boat",			ITEM_BOAT,		    TRUE	},
    {	"npccorpse",	ITEM_CORPSE_NPC,	TRUE	},
    {	"pc corpse",	ITEM_CORPSE_PC,		FALSE	},
    {	"fountain",		ITEM_FOUNTAIN,		TRUE	},
    {	"pill",			ITEM_PILL,		    TRUE	},
    {	"protect",		ITEM_PROTECT,		TRUE	},
    {	"map",			ITEM_MAP,		    TRUE	},
    {   "portal",		ITEM_PORTAL,		TRUE	},
    {   "warpstone",	ITEM_WARP_STONE,	TRUE	},
    {	"roomkey",		ITEM_ROOM_KEY,		TRUE	},
    { 	"gem",			ITEM_GEM,	  	    TRUE	},
    {	"jewelry",		ITEM_JEWELRY,		TRUE	},
    {	"jukebox",		ITEM_JUKEBOX,		TRUE	},
	{	"quiver",		ITEM_QUIVER,		TRUE	},
	{	"arrow",		ITEM_ARROW,			TRUE	},
	{   "pipetabac",    ITEM_PIPE_TABAC,    TRUE    },
	{   "chewtabac",    ITEM_CHEW_TABAC,    TRUE    },
	{   "maleangreal",  ITEM_ANGREAL_MALE,  TRUE    },
	{   "femaleangreal",ITEM_ANGREAL_FEMALE,TRUE    },
	{   "cloth_bolt",        ITEM_CLOTH_BOLT,    TRUE    },
	{   "treepc",       ITEM_TREE_PC,       TRUE    },
	{   "notepaper",    ITEM_NOTEPAPER,     TRUE    },
	{   "trigger",      ITEM_TRIGGER,       TRUE    },
	{   "lockpick",     ITEM_LOCKPICK,      TRUE    },
	{   "mirror",       ITEM_MIRROR,        TRUE    },
	{   "razor",        ITEM_RAZOR,         TRUE    },
	{   "brush",        ITEM_BRUSH,         TRUE    },
	{   "fireoil",      ITEM_FIREOIL,       TRUE    },
	{   "journal",      ITEM_JOURNAL,       TRUE    },
	{   "pipes",        ITEM_WIND_PIPES,    TRUE    },
	{   "flute",        ITEM_WIND_FLUTE,    TRUE    },
	{   "bittern",      ITEM_STRINGED_BITTERN, TRUE    },
	{   "drums",        ITEM_PERCUSSION_DRUMS, TRUE    },
	{   "carver_knife", ITEM_SHAPE_KNIFE,   TRUE    },
	{   "wood_shaper",  ITEM_SHAPE_SHAPER,  TRUE    },
	{   "wood_stick",   ITEM_SHAPE_STICK,   TRUE    },
	{   "wood_limb",    ITEM_SHAPE_LIMB,    TRUE    },
	{   "wood_branch",  ITEM_SHAPE_BRANCH,  TRUE    },
	{   "wood_block",   ITEM_SHAPE_BLOCK,   TRUE    },
	{   "keyblank",     ITEM_SHAPE_KEYBLANK,TRUE    },
    {   "ore",          ITEM_SMITH_ORE, TRUE },
    {   "hammer",       ITEM_SMITH_HAMMER, TRUE },
    {   "anvil",        ITEM_SMITH_ANVIL, TRUE },
    {   "barrel",       ITEM_SMITH_BARREL, TRUE },
    {   "furnace",      ITEM_SMITH_FURNACE, TRUE },
    {   "grinder",      ITEM_SMITH_GRINDER, TRUE },
    {   "commdev",      ITEM_COMM_DEV, TRUE },
    {   "window",       ITEM_WINDOW, TRUE },
    {   "keyring",      ITEM_KEYRING, TRUE },
    {   "mushroom",     ITEM_SHAPE_MUSHROOM, TRUE },
    {   "clematis",     ITEM_SHAPE_CLEMATIS, TRUE },
    {   "hawthorn",     ITEM_SHAPE_HAWTHORN, TRUE },
    {   "boneset",      ITEM_SHAPE_BONESET, TRUE },
    {   "obsidion",     ITEM_SHAPE_OBSIDION, TRUE },
    {   "snakeskin",    ITEM_SHAPE_SNAKESKIN, TRUE },
    {   "tome",         ITEM_TOME, TRUE },
    {   "clock",        ITEM_CLOCK, TRUE },
    {   "brush",        ITEM_BRUSH, TRUE },
    {   "lamppost",     ITEM_LAMPPOST, TRUE },
    {   "rope",         ITEM_ROPE, TRUE },
    {   "piton",        ITEM_PITON, TRUE },
    {   "crafting_material",        ITEM_CRAFTING_MATERIAL, TRUE },
    {   "crafting_manual",        ITEM_CRAFTING_MANUAL, TRUE },
    {   "dye",        ITEM_DYE, TRUE },
    {   "adornment",        ITEM_ADORNMENT, TRUE },
    {	NULL,			0,			0	}
};

const struct flag_type craftskill_flags[] =
{
	{  "none",	   	CRAFT_NONE,		TRUE },
	{  "sewing",       	CRAFT_SEW,		TRUE },
	{  "forging",      	CRAFT_FORGE,		TRUE },
	{  "woodcrafting",	CRAFT_WOODCRAFT,	TRUE },
	{  "jewelcrafting",	CRAFT_JEWELCRAFT,	TRUE },
	{  NULL,           	0, 			FALSE}
};

const struct flag_type craftpadj_flags[] =
{
	{  "none",	0, TRUE },
	{  "pair of ",	1, TRUE },
	{  "set of ",	2, TRUE },
	{  "suit of ",	3, TRUE },
	{  NULL,	0, FALSE}
};

const struct flag_type trigger_flags[] =
{
	{  "nada",       A, TRUE },
	{  "turn",       B, TRUE },
	{  "push",       C, TRUE },
	{  "pull",       D, TRUE },
	{  NULL,         0, FALSE}
};
const struct flag_type trigger_action_flags[] =
{
	{  "turn_denada",       A, TRUE },
	{  "turn_opendoor",     B, TRUE },
	{  "turn_closedoor",    C, TRUE },
	{  "turn_lockdoor",     D, TRUE },
	{  "turn_unlockdoor",   E, TRUE },
	{  NULL,            0                }
};

const struct flag_type extra_flags[] =
{
    {	"glow",			ITEM_GLOW,		TRUE	},
    {	"hum",			ITEM_HUM,		TRUE	},
    {	"dark",			ITEM_DARK,		TRUE	},
    {	"lock",			ITEM_LOCK,		TRUE	},
    {	"evil",			ITEM_EVIL,		TRUE	},
    {	"invis",		ITEM_INVIS,		TRUE	},
    {	"magic",		ITEM_MAGIC,		TRUE	},
    {	"nodrop",		ITEM_NODROP,		TRUE	},
    {	"crafted",		ITEM_CRAFTED,		TRUE	},
    {	"adorned",		ITEM_ADORNED,		TRUE	},
    {	"antigood",		ITEM_ANTI_GOOD,		TRUE	},
    {	"antievil",		ITEM_ANTI_EVIL,		TRUE	},
    {	"noremove",		ITEM_NOREMOVE,		TRUE	},
    {	"inventory",		ITEM_INVENTORY,		TRUE	},
    {	"nopurge",		ITEM_NOPURGE,		TRUE	},
    {	"rotdeath",		ITEM_ROT_DEATH,		TRUE	},
    {	"visdeath",		ITEM_VIS_DEATH,		TRUE	},
    {   "shimmer",      ITEM_SHIMMER,       TRUE    },
    {   "reinforced",		ITEM_REINFORCED,		TRUE	},
    {	"meltdrop",		ITEM_MELT_DROP,		TRUE	},
    {	"hadtimer",		ITEM_HAD_TIMER,		TRUE	},
    {	"sellextract",		ITEM_SELL_EXTRACT,	TRUE	},
    {   "spiked",       ITEM_SPIKED,        TRUE    },
    {	"burnproof",		ITEM_BURN_PROOF,	TRUE	},
    {	"nouncurse",		ITEM_NOUNCURSE,		TRUE	},
    {   "balanced",     ITEM_BALANCED,      TRUE    },
	{	"nosell",			ITEM_NOSELL,		TRUE	},
	{	"noload",			ITEM_NOLOAD,		TRUE	},
	{	"remort",			ITEM_REMORT,		TRUE	},
    {	NULL,			0,			0	}
};



const struct flag_type wear_flags[] =
{
    {	"take",			ITEM_TAKE,		TRUE	},
    {	"finger",		ITEM_WEAR_FINGER,	TRUE	},
    {	"neck",			ITEM_WEAR_NECK,		TRUE	},
    {	"body",			ITEM_WEAR_BODY,		TRUE	},
    {	"head",			ITEM_WEAR_HEAD,		TRUE	},
    {	"legs",			ITEM_WEAR_LEGS,		TRUE	},
    {	"feet",			ITEM_WEAR_FEET,		TRUE	},
    {	"hands",		ITEM_WEAR_HANDS,	TRUE	},
    {	"arms",			ITEM_WEAR_ARMS,		TRUE	},
    {	"shield",		ITEM_WEAR_SHIELD,	TRUE	},
    {	"about",		ITEM_WEAR_ABOUT,	TRUE	},
    {	"waist",		ITEM_WEAR_WAIST,	TRUE	},
    {	"wrist",		ITEM_WEAR_WRIST,	TRUE	},
    {	"wield",		ITEM_WIELD,		TRUE	},
    {	"hold",			ITEM_HOLD,		TRUE	},
    {   "nosac",		ITEM_NO_SAC,		TRUE	},
    {	"wearfloat",		ITEM_WEAR_FLOAT,	TRUE	},
    {   "nose",                 ITEM_WEAR_NOSE,         TRUE    },
    {   "ear",                 ITEM_WEAR_EAR,         TRUE    },
    {   "shoulders",            ITEM_WEAR_SHOULDERS,    TRUE    },
    {   "back",                 ITEM_WEAR_BACK,         TRUE    },
    {   "eyes",                 ITEM_WEAR_EYES,         TRUE    },
    {   "calf",                 ITEM_WEAR_CALF,         TRUE    },
    {   "thigh",                ITEM_WEAR_THIGH,        TRUE    },
    {   "forearm",              ITEM_WEAR_FOREARM,      TRUE    },
    {   "ankle",              ITEM_WEAR_ANKLE,      TRUE    },
    {   "nearmind",              ITEM_WEAR_NEAR_MIND,      TRUE    },
    {   "face",              ITEM_WEAR_FACE,      TRUE    },
    {   "angreal",              ITEM_WEAR_ANGREAL,      TRUE    },
/*    {   "twohands",            ITEM_TWO_HANDS,         TRUE    }, */
    {	NULL,			0,			0	}
};

/*
 * Used when adding an affect to tell where it goes.
 * See addaffect and delaffect in act_olc.c
 */
const struct flag_type apply_flags[] =
{
    {	"none",			APPLY_NONE,		TRUE	},
    {	"strength",		APPLY_STR,		TRUE	},
    {	"dexterity",		APPLY_DEX,		TRUE	},
    {	"intelligence",		APPLY_INT,		TRUE	},
    {	"wisdom",		APPLY_WIS,		TRUE	},
    {	"constitution",		APPLY_CON,		TRUE	},
    {	"sex",			APPLY_SEX,		TRUE	},
    {	"class",		APPLY_CLASS,		TRUE	},
    {	"level",		APPLY_LEVEL,		TRUE	},
    {	"age",			APPLY_AGE,		TRUE	},
    {	"height",		APPLY_HEIGHT,		TRUE	},
    {	"weight",		APPLY_WEIGHT,		TRUE	},
    {	"mana",			APPLY_MANA,		TRUE	},
    {	"hp",			APPLY_HIT,		TRUE	},
    {	"move",			APPLY_MOVE,		TRUE	},
    {	"gold",			APPLY_GOLD,		TRUE	},
    {	"experience",		APPLY_EXP,		TRUE	},
    {	"ac",			APPLY_AC,		TRUE	},
    {	"hitroll",		APPLY_HITROLL,		TRUE	},
    {	"damroll",		APPLY_DAMROLL,		TRUE	},
    {	"saves",		APPLY_SAVES,		TRUE	},
    {	"savingpara",		APPLY_SAVING_PARA,	TRUE	},
    {	"savingrod",		APPLY_SAVING_ROD,	TRUE	},
    {	"savingpetri",		APPLY_SAVING_PETRI,	TRUE	},
    {	"savingbreath",		APPLY_SAVING_BREATH,	TRUE	},
    {	"savingspell",		APPLY_SAVING_SPELL,	TRUE	},
    {	"spellaffect",		APPLY_SPELL_AFFECT,	FALSE	},
    {	"reflex",		APPLY_REF,		TRUE	},
    {	"instinct",		APPLY_INS,		TRUE	},
    {	"charisma",		APPLY_CHA,		TRUE	},
    {	NULL,			0,			0	}
};



/*
 * What is seen.
 */
const struct flag_type wear_loc_strings[] =
{
    {	"in the inventory",	WEAR_NONE,	TRUE	},
    {	"as a light",		WEAR_LIGHT,	TRUE	},
    {	"on the left finger",	WEAR_FINGER_L,	TRUE	},
    {	"on the right finger",	WEAR_FINGER_R,	TRUE	},
    {	"around the neck (1)",	WEAR_NECK_1,	TRUE	},
    {	"around the neck (2)",	WEAR_NECK_2,	TRUE	},
    {	"on the body",		WEAR_BODY,	TRUE	},
    {	"over the head",	WEAR_HEAD,	TRUE	},
    {	"on the legs",		WEAR_LEGS,	TRUE	},
    {	"on the feet",		WEAR_FEET,	TRUE	},
    {	"on the hands",		WEAR_HANDS,	TRUE	},
    {	"on the arms",		WEAR_ARMS,	TRUE	},
    {	"as a shield",		WEAR_SHIELD,	TRUE	},
    {	"about the body",	WEAR_ABOUT,	TRUE	},
    {	"around the waist",	WEAR_WAIST,	TRUE	},
    {	"on the left wrist",	WEAR_WRIST_L,	TRUE	},
    {	"on the right wrist",	WEAR_WRIST_R,	TRUE	},
    {	"wielded",		WEAR_WIELD,	TRUE	},
    {	"held in the hands",	WEAR_HOLD,	TRUE	},
    {	"floating nearby",	WEAR_FLOAT,	TRUE	},
    {   "in the nose",          WEAR_NOSE,      TRUE    },
    {   "in the ear (1)",        WEAR_EAR_1,    TRUE,   },
    {   "in the ear (2)",        WEAR_EAR_2,    TRUE,   },
    {   "on the shoulders",     WEAR_SHOULDERS, TRUE    },
    {   "on the back",          WEAR_BACK,      TRUE    },
    {   "over the eyes",        WEAR_EYES,      TRUE    },
    {   "on the left calf",     WEAR_CALF_L,    TRUE    },
    {   "on the right calf",    WEAR_CALF_R,    TRUE    },
    {   "on the left thigh",    WEAR_THIGH_L,   TRUE    },
    {   "on the right thigh",   WEAR_THIGH_R,   TRUE    },
    {   "on the left forearm",  WEAR_FOREARM_L, TRUE    },
    {   "on the right forearm", WEAR_FOREARM_R, TRUE    },
    {   "on the left ankle", WEAR_ANKLE_L, TRUE    },
    {   "on the right ankle", WEAR_ANKLE_R, TRUE    },
    {   "close to the mind", WEAR_NEAR_MIND, TRUE    },
    {   "over the face", WEAR_FACE, TRUE    },
    {   "as an angreal", WEAR_ANGREAL, TRUE    },
    {	NULL,			0	      , 0	}
};


const struct flag_type wear_loc_flags[] =
{
    {	"none",		WEAR_NONE,	TRUE	},
    {	"light",	WEAR_LIGHT,	TRUE	},
    {	"lfinger",	WEAR_FINGER_L,	TRUE	},
    {	"rfinger",	WEAR_FINGER_R,	TRUE	},
    {	"neck1",	WEAR_NECK_1,	TRUE	},
    {	"neck2",	WEAR_NECK_2,	TRUE	},
    {	"body",		WEAR_BODY,	TRUE	},
    {	"head",		WEAR_HEAD,	TRUE	},
    {	"legs",		WEAR_LEGS,	TRUE	},
    {	"feet",		WEAR_FEET,	TRUE	},
    {	"hands",	WEAR_HANDS,	TRUE	},
    {	"arms",		WEAR_ARMS,	TRUE	},
    {	"shield",	WEAR_SHIELD,	TRUE	},
    {	"about",	WEAR_ABOUT,	TRUE	},
    {	"waist",	WEAR_WAIST,	TRUE	},
    {	"lwrist",	WEAR_WRIST_L,	TRUE	},
    {	"rwrist",	WEAR_WRIST_R,	TRUE	},
    {	"wielded",	WEAR_WIELD,	TRUE	},
    {	"hold",		WEAR_HOLD,	TRUE	},
    {	"floating",	WEAR_FLOAT,	TRUE	},
    {   "nose",         WEAR_NOSE,      TRUE    },
    {   "ear1",         WEAR_EAR_1,      TRUE    },
    {   "ear2",         WEAR_EAR_2,      TRUE    },
    {   "shoulders",    WEAR_SHOULDERS, TRUE    },
    {   "back",         WEAR_BACK,      TRUE    },
    {   "eyes",         WEAR_EYES,      TRUE    },
    {   "lcalf",        WEAR_CALF_L,    TRUE    },
    {   "rcalf",        WEAR_CALF_R,    TRUE    },
    {   "lthigh",       WEAR_THIGH_L,   TRUE    },
    {   "rthigh",       WEAR_THIGH_R,   TRUE    },
    {   "lforearm",     WEAR_FOREARM_L, TRUE    },
    {   "rforearm",     WEAR_FOREARM_R, TRUE    },
	{	"lodge_leg",	WEAR_LODGE_LEG,	TRUE	},
	{	"lodge_arm",	WEAR_LODGE_ARM,	TRUE	},
	{	"lodge_rib",	WEAR_LODGE_RIB,	TRUE	},
    {	NULL,		0,		0	}
};

const struct flag_type container_flags[] =
{
    {	"closeable",		1,		TRUE	},
    {	"pickproof",		2,		TRUE	},
    {	"closed",		4,		TRUE	},
    {	"locked",		8,		TRUE	},
    {	"puton",		16,		TRUE	},
    {	NULL,			0,		0	}
};

const struct flag_type ac_type[] =
{
    {   "pierce",        AC_PIERCE,            TRUE    },
    {   "bash",          AC_BASH,              TRUE    },
    {   "slash",         AC_SLASH,             TRUE    },
    {   "exotic",        AC_EXOTIC,            TRUE    },
    {   NULL,              0,                    0       }
};


const struct flag_type size_flags[] =
{
    {   "tiny",          SIZE_TINY,            TRUE    },
    {   "small",         SIZE_SMALL,           TRUE    },
    {   "medium",        SIZE_MEDIUM,          TRUE    },
    {   "large",         SIZE_LARGE,           TRUE    },
    {   "huge",          SIZE_HUGE,            TRUE    },
    {   "giant",         SIZE_GIANT,           TRUE    },
    {   NULL,              0,                    0       },
};





/* Herb Types */
const struct flag_type herb_flags[] =
{
	{	"none",			HERB_NONE,		TRUE	},
	{	"acem",			HERB_ACEM,		TRUE    },
	{	"andilay",		HERB_ANDILAY,		TRUE    },
	{	"asping rot",		HERB_ASPINGROT,		TRUE    },
	{	"blue goatflowers",	HERB_BLUEGOATFLOWER,	TRUE    },
	{	"bluewort",		HERB_BLUEWORT,		TRUE    },
	{	"chainleaf",		HERB_CHAINLEAF,		TRUE    },
	{	"crimsonthorn",		HERB_CRIMSONTHORN,	TRUE    },
	{	"dogwort",		HERB_DOGWORT,		TRUE    },
	{	"feverbane",		HERB_FEVERBANE,		TRUE    },
	{	"five-finger",		HERB_FIVEFINGER,	TRUE    },
	{	"flatwort",		HERB_FLATWORT,		TRUE    },
	{	"forkroot",		HERB_FORKROOT,		TRUE    },
	{	"foxtail",		HERB_FOXTAIL,		TRUE    },
	{	"goatstongue",		HERB_GOATSTONGUE,	TRUE    },
	{	"goosemint",		HERB_GOOSEMINT,		TRUE    },
	{	"greenwort",		HERB_GREENWORT,		TRUE    },
	{	"grey fennel",		HERB_GREYFENNEL,	TRUE    },
	{	"ground ivy",		HERB_GROUNDIVY,		TRUE    },
	{	"healall",		HERB_HEALALL,		TRUE    },
	{	"honey",		HERB_HONEY,		TRUE    },
	{	"lionheart",		HERB_LIONHEART,		TRUE    },
	{	"mardroot",		HERB_MARDROOT,		TRUE    },
	{	"marisin",		HERB_MARISIN,		TRUE    },
	{	"marshwhite",		HERB_MARSHWHITE,	TRUE    },
	{	"peach pit powder",	HERB_PEACHPIT,		TRUE    },
	{	"red fennel",		HERB_REDFENNEL,		TRUE    },
	{	"silverleaf",		HERB_SILVERLEAF,	TRUE    },
	{	"sleepwell",		HERB_SLEEPWELL,		TRUE    },
	{	"sunburst root",	HERB_SUNBURSTROOT,	TRUE    },
	{	"tarchrot leaves",	HERB_TARCHROTLEAF,	TRUE    },
	{	"timsin root",		HERB_TIMSINROOT,	TRUE    },
	{	"willow bark",		HERB_WILLOWBARK,	TRUE    },
	{	"worrynot leaves",	HERB_WORRYNOT,		TRUE    },
	{	NULL,		0,			0	}
};

const struct flag_type weapon_class[] =
{
    {   "exotic",	     WEAPON_EXOTIC,		TRUE    },
    {   "sword",	     WEAPON_SWORD,		TRUE    },
    {   "dagger",	     WEAPON_DAGGER,		TRUE    },
    {   "spear",	     WEAPON_SPEAR,		TRUE    },
    {   "mace",		     WEAPON_MACE,		TRUE    },
    {   "axe",		     WEAPON_AXE,			TRUE    },
    {   "flail",	     WEAPON_FLAIL,		TRUE    },
    {   "whip",		     WEAPON_WHIP,		TRUE    },
    {   "polearm",	     WEAPON_POLEARM,		TRUE    },
    {   "shortbow",      WEAPON_SHORTBOW,    TRUE    },
    {   "staff",         WEAPON_STAFF,       TRUE    },
    {   "longbow",       WEAPON_LONGBOW,     TRUE    },
    {   "recurvedbow",   WEAPON_RECURVEDBOW,TRUE    },
    {   "compositebow",  WEAPON_COMPOSITEBOW,TRUE    },
    {   "crossbow",      WEAPON_CROSSBOW,     TRUE    },
    {   "net",           WEAPON_NET,     TRUE    },
    {   "scythesword",   WEAPON_SCYTHESWORD,     TRUE    },
    {   "trident",       WEAPON_TRIDENT,     TRUE    },
    {   "hammer",        WEAPON_HAMMER,     TRUE    },
    {   "sling",         WEAPON_SLING,     TRUE    },
    {   "swordbreaker",  WEAPON_SWORDBREAKER,     TRUE    },
    {   "sap",           WEAPON_SAP,     TRUE    },
    {   "shortsword",    WEAPON_SHORTSWORD,     TRUE    },
    {   "lance",         WEAPON_LANCE,     TRUE    },
    {   "ashandarei",    WEAPON_ASHANDAREI,     TRUE    },
    {   "lightcrossbow", WEAPON_LIGHTCROSSBOW,     TRUE    },
    {   NULL,		0,			0       }
};


const struct flag_type weapon_type2[] =
{
    {   "flaming",       WEAPON_FLAMING,       TRUE    },
    {   "frost",         WEAPON_FROST,         TRUE    },
    {   "vampiric",      WEAPON_VAMPIRIC,      TRUE    },
    {   "sharp",         WEAPON_SHARP,         TRUE    },
    {   "vorpal",        WEAPON_VORPAL,        TRUE    },
    {   "twohands",     WEAPON_TWO_HANDS,     TRUE    },
    {	"shocking",	 WEAPON_SHOCKING,      TRUE    },
    {	"poison",	WEAPON_POISON,		TRUE	},
    {	"loaded",	WEAPON_LOADED,		TRUE	},
    {	"inf_str",	WEAPON_INFUSE_STR,		TRUE	},
    {	"inf_con",	WEAPON_INFUSE_CON,		TRUE	},
    {	"inf_dex",	WEAPON_INFUSE_DEX,		TRUE	},
    {	"inf_int",	WEAPON_INFUSE_INT,		TRUE	},
    {	"inf_wis",	WEAPON_INFUSE_WIS,		TRUE	},
    {	"inf_ref",	WEAPON_INFUSE_REF,		TRUE	},
    {	"inf_cha",	WEAPON_INFUSE_CHA,		TRUE	},
    {	"inf_ins",	WEAPON_INFUSE_INS,		TRUE	},
    {	"inf_hr",	WEAPON_INFUSE_HR,		TRUE	},
    {	"inf_dr",	WEAPON_INFUSE_DR,		TRUE	},
    {   NULL,              0,                    0       }
};

const struct flag_type res_flags[] =
{
    {	"summon",	 RES_SUMMON,		TRUE	},
    {   "charm",         RES_CHARM,            TRUE    },
    {   "magic",         RES_MAGIC,            TRUE    },
    {   "weapon",        RES_WEAPON,           TRUE    },
    {   "bash",          RES_BASH,             TRUE    },
    {   "pierce",        RES_PIERCE,           TRUE    },
    {   "slash",         RES_SLASH,            TRUE    },
    {   "fire",          RES_FIRE,             TRUE    },
    {   "cold",          RES_COLD,             TRUE    },
    {   "lightning",     RES_LIGHTNING,        TRUE    },
    {   "acid",          RES_ACID,             TRUE    },
    {   "poison",        RES_POISON,           TRUE    },
    {   "negative",      RES_NEGATIVE,         TRUE    },
    {   "holy",          RES_HOLY,             TRUE    },
    {   "energy",        RES_ENERGY,           TRUE    },
    {   "mental",        RES_MENTAL,           TRUE    },
    {   "disease",       RES_DISEASE,          TRUE    },
    {   "drowning",      RES_DROWNING,         TRUE    },
    {   "light",         RES_LIGHT,            TRUE    },
    {	"sound",	RES_SOUND,		TRUE	},
    {	"wood",		RES_WOOD,		TRUE	},
    {	"silver",	RES_SILVER,		TRUE	},
    {	"iron",		RES_IRON,		TRUE	},
    {   NULL,          0,            0    }
};


const struct flag_type vuln_flags[] =
{
    {	"summon",	 VULN_SUMMON,		TRUE	},
    {	"charm",	VULN_CHARM,		TRUE	},
    {   "magic",         VULN_MAGIC,           TRUE    },
    {   "weapon",        VULN_WEAPON,          TRUE    },
    {   "bash",          VULN_BASH,            TRUE    },
    {   "pierce",        VULN_PIERCE,          TRUE    },
    {   "slash",         VULN_SLASH,           TRUE    },
    {   "fire",          VULN_FIRE,            TRUE    },
    {   "cold",          VULN_COLD,            TRUE    },
    {   "lightning",     VULN_LIGHTNING,       TRUE    },
    {   "acid",          VULN_ACID,            TRUE    },
    {   "poison",        VULN_POISON,          TRUE    },
    {   "negative",      VULN_NEGATIVE,        TRUE    },
    {   "holy",          VULN_HOLY,            TRUE    },
    {   "energy",        VULN_ENERGY,          TRUE    },
    {   "mental",        VULN_MENTAL,          TRUE    },
    {   "disease",       VULN_DISEASE,         TRUE    },
    {   "drowning",      VULN_DROWNING,        TRUE    },
    {   "light",         VULN_LIGHT,           TRUE    },
    {	"sound",	 VULN_SOUND,		TRUE	},
    {   "wood",          VULN_WOOD,            TRUE    },
    {   "silver",        VULN_SILVER,          TRUE    },
    {   "iron",          VULN_IRON,            TRUE    },
    {   NULL,              0,                    0       }
};

const struct flag_type position_flags[] =
{
    {   "dead",           POS_DEAD,            FALSE   },
    {   "mortal",         POS_MORTAL,          FALSE   },
    {   "incap",          POS_INCAP,           FALSE   },
    {   "stunned",        POS_STUNNED,         FALSE   },
    {   "sleeping",       POS_SLEEPING,        TRUE    },
    {   "resting",        POS_RESTING,         TRUE    },
    {   "sitting",        POS_SITTING,         TRUE    },
    {   "fighting",       POS_FIGHTING,        FALSE   },
    {   "standing",       POS_STANDING,        TRUE    },
    {   NULL,              0,                    0       }
};

const struct flag_type portal_flags[]=
{
    {   "normal_exit",	  GATE_NORMAL_EXIT,	TRUE	},
    {	"no_curse",	  GATE_NOCURSE,		TRUE	},
    {   "go_with",	  GATE_GOWITH,		TRUE	},
    {   "buggy",	  GATE_BUGGY,		TRUE	},
    {	"random",	  GATE_RANDOM,		TRUE	},
    {   NULL,		  0,			0	}
};

const struct flag_type furniture_flags[]=
{
    {   "stand_at",	  STAND_AT,		TRUE	},
    {	"stand_on",	  STAND_ON,		TRUE	},
    {	"stand_in",	  STAND_IN,		TRUE	},
    {	"sit_at",	  SIT_AT,		TRUE	},
    {	"sit_on",	  SIT_ON,		TRUE	},
    {	"sit_in",	  SIT_IN,		TRUE	},
    {	"rest_at",	  REST_AT,		TRUE	},
    {	"rest_on",	  REST_ON,		TRUE	},
    {	"rest_in",	  REST_IN,		TRUE	},
    {	"sleep_at",	  SLEEP_AT,		TRUE	},
    {	"sleep_on",	  SLEEP_ON,		TRUE	},
    {	"sleep_in",	  SLEEP_IN,		TRUE	},
    {	"put_at",	  PUT_AT,		TRUE	},
    {	"put_on",	  PUT_ON,		TRUE	},
    {	"put_in",	  PUT_IN,		TRUE	},
    {	"put_inside",	  PUT_INSIDE,		TRUE	},
    {	NULL,		  0,			0	}
};

const	struct	flag_type	apply_types	[]	=
{
	{	"affects",	TO_AFFECTS,	TRUE	},
	{	"object",	TO_OBJECT,	TRUE	},
	{	"immune",	TO_IMMUNE,	TRUE	},
	{	"resist",	TO_RESIST,	TRUE	},
	{	"vuln",		TO_VULN,	TRUE	},
	{	"weapon",	TO_WEAPON,	TRUE	},
	{	"affects2",	TO_AFFECTS2,TRUE	},
	{	NULL,		0,		TRUE	}
};

const	struct	bit_type	bitvector_type	[]	=
{
	{	affect_flags,	"affect"	},
	{	apply_flags,	"apply"		},
	{	imm_flags,	"imm"		},
	{	res_flags,	"res"		},
	{	vuln_flags,	"vuln"		},
	{	weapon_type2,	"weapon"	}
};
const struct flag_type act2_flags[] =
{
    {	"invade",		A,	FALSE	},
    {   "nothing",              B,      FALSE   },
    {	NULL,			0,	FALSE	}
};

const   struct  race_invade_type  race_invade_table []  =
{
  { "warder",	25,	150,	"warder"   },
  { "sedai",    7,      150,    "sedai"    },
  { "tower",    50,      200,    "tower"    },
  { "seanchan", 5,      200,    "seanchan" },
  { "shaido",   5,      200,    "shaido"   },
  { "child", 	5,      200,    "child"    },
  { "trollocs", 25,     300,    "trollocs" },
  { "darkone",  30,     300,    "darkone"  },
  { "darkhound",  30,   75,    "darkhound"  },
  { "halloween",  200,   200,    "halloween"  },
  { "apples",  50,   200,    "apples"  },
  { "plumpking",  50,   100,    "plumpking"  },
 { NULL,	0,	0,	NULL       }
};


const   struct  town_invade_type  town_invade_table []  =
{
{ "dumai wells", 2900, 2999, NULL, "seanchan", "tower", NULL, NULL},
{ "queens highway", 1200, 1299, "trolloc", NULL, NULL, NULL, NULL},
{ "carysford", 1100, 1199, "trolloc", NULL, NULL, NULL, NULL},
{ "aringill", 600, 699, "trolloc", NULL, NULL, NULL, NULL},
{ "emonds field", 2000, 2099, "trolloc", NULL, NULL, NULL, NULL},
{ "watch hill", 6600, 6699, "trolloc", NULL, NULL, NULL, NULL},
{ "baerlon", 5200, 5299, "trolloc", NULL, NULL, NULL, NULL},
{ "taren ferry", 2200, 2299, "trolloc", NULL, NULL, NULL, NULL},
{ "rhuidean", 9400, 9499, "trolloc", NULL, NULL, NULL, NULL},
{ "blight", 3900, 4199, "trolloc", "darkone", NULL, NULL, NULL},
{ "shienar", 9500, 9799, "trolloc", NULL, NULL, NULL, NULL},
{ "tar valon", 7000, 7499, "trolloc", NULL, NULL, NULL, NULL},
{ "tar valon highway", 9900, 9999, "trolloc", NULL, NULL, NULL, NULL},
{ "cairhien", 5300, 5399, "trolloc", NULL, NULL, NULL, NULL},
{ "the ways", 1300, 1499, "trolloc", NULL, NULL, NULL, NULL},
{ "illian", 4200, 4500, "trolloc", NULL, NULL, NULL, NULL},
{ "amador", 11401, 11600, "trolloc", NULL, NULL, NULL, NULL},
{ "tear", 11801, 12200, "trolloc", "darkone", NULL, NULL, NULL},
{ "caemlyn road", 13200, 13399, "trolloc", "darkone", NULL, NULL, NULL},
{ "kandor", 6700, 6999, "trolloc", NULL, NULL, NULL, NULL},
{ "tower of ghenji", 12201, 12250, "trolloc", NULL, NULL, NULL, NULL},
{ "ebou dar", 8000, 8299, "trolloc", NULL, NULL, NULL, NULL},
{ "braem woods", 6100, 6199, "trolloc", NULL, NULL, NULL, NULL},
{ "haddon mirk", 2100, 2199, "trolloc", NULL, NULL, NULL, NULL},
{ "whitebridge", 5600, 5699, "trolloc", NULL, NULL, NULL, NULL},
{ "salidar", 11201, 11400 , "trolloc", NULL, NULL, NULL, NULL},
{ "cairhien", 12501, 12800, "trolloc", NULL, NULL, NULL, NULL},
{ "tamille", 15501, 15599, "trolloc", NULL, NULL, NULL, NULL},
{ "road of salidar", 16300, 16399, "trolloc", NULL, NULL, NULL, NULL},
{ "the sand hills", 11001, 11200, "trolloc", NULL, NULL, NULL, NULL},
{ "the amadician road", 7851, 7900, "trolloc", NULL, NULL, NULL, NULL},
{ "realm", 3000, 7799, "halloween", NULL, NULL, NULL, NULL},
{ "world", 8000, 12000, "halloween", NULL, NULL, NULL, NULL},

  { NULL, 0, 0, NULL, NULL, NULL, NULL, NULL},
  { NULL, 0, 0, NULL, NULL, NULL, NULL, NULL}
};

const   struct  invader_type  invader_table []  =
{
  { "child",	9021, 30 },
  { "child",	9022, 40 },
  { "child",	9027, 50 },
  { "shaido",	9009, 50 },
  { "shaido",	9008, 50 },
  { "shaido",	9029, 50 },
  { "darkhound", 9016, 25 },
  { "darkhound", 9019, 25 },
  { "darkhound", 9020, 15 },
  { "darkone", 9006, 13 },
  { "darkone", 9048, 50 },
  { "darkone", 9049, 25 },
  { "darkone", 9046, 25 },
  { "darkone", 9045, 5 },
  { "darkone", 9043, 25 },
  { "darkone", 9044, 25 },
  { "trollocs",	9050, 50  },
  { "trollocs",	9031, 25  },
  { "trollocs",	9032, 25  },
  { "trollocs",	9033, 25  },
  { "trollocs",	9034, 25  },
  { "trollocs",	9035, 25  },
  { "trollocs",	9036, 25  },
  { "trollocs",	9037, 25  },
  { "trollocs",	9038, 25  },
  { "trollocs",	9039, 25  },
  { "trollocs",	9040, 25  },
  { "trollocs",	9041, 25  },
  { "trollocs",	9042, 25  },
  { "tower",    9000, 25  },
  { "tower",    9001, 25  },
  { "tower",    9002, 25  },
  { "tower",    9003, 25  },
  { "tower",    9004, 25  },
  { "tower",    9005, 25  },
  { "tower",    9030, 75  },
  { "tower",    9007, 75  },
  { "sedai",	9000, 25  },
  { "sedai",	9001, 25  },
  { "sedai",	9002, 25  },
  { "sedai",	9003, 25  },
  { "sedai",	9004, 25  },
  { "sedai",	9005, 25  },
  { "warder",	9030, 75  },
  { "warder",	9007, 75  },
  { "seanchan",	9024, 5   },
  { "seanchan",	9025, 5   },
  { "seanchan",	9026, 5   },
  { "seanchan",	9023, 10  },
  { "seanchan",	9028, 10  },
  { "seanchan",	20342, 50  },
  { "seanchan",	20340, 25  },
  { "seanchan",	20341, 50  },
  { "seanchan",	20356, 25  },
   { "seanchan",20328, 50  },
  { "seanchan",	20333, 50  },
  { "halloween", 3800, 50  },
  { "halloween", 3801, 50  },
  { "halloween", 3802, 50  },
  { "halloween", 3803, 50  },
  { "apples", 3812, 50  },
  { "plumpking", 3811, 1  },
  { "plumpking", 3813, 50  },

 { NULL,	0, 0   }
};




const struct craftadorn_type craftadorn_table [] =
{
	/*	short name,	itemsallowed,			item suffix*/
	{	"none",		"",		"%s"				},
	{	"belt buckle",	"belts",	"{1with %s {1belt buckle"	},
	{	"carving",	"wood",		"{1carved with %s"		},
	{	"brand",	"wood leather",	"{1with %s {1brand"			},
	{	"inscription",	"metal",	"{1inscribed with '%s{1'"		},
	{	"emblazoning",	"metal",	"{1emblazoned with %s"		},
	{	"engraving",	"metal",	"{1engraved with %s"		},
	{	"inset",	"metal",	"{1inset with %s"			},
	{	"etching",	"metal wood",	"{1etched with %s"		},
	{	"pin",		"cloth",	"{1pinned with %s"		},
	{	"embroidery",	"cloth",	"{1with %s {1embroidery"		},
	{	"patch",	"cloth",	"{1patched with %s"		},
	{	"stitching",	"cloth",	"{1stitched with %s"		},
	{	"design",	"cloth",	"{1with %s {1design"		},
	{	"painting",	"any",		"{1painted with %s"		},
	{	"emblem",	"any",		"{1with %s {1emblem"		},
	{	"fashioning",	"any",		"{1fashioned with %s"		},
	{	"wrap",		"any",		"{1wrapped with %s"		},
	{	"affixment",	"any",		"{1affixed with %s"		},
	{	"tooling",	"any",		"{1with %s {1tooling"		},
	{	"binding",	"any",		"{1bound with %s"			},
	{	"adornment",	"any",		"{1adorned with %s"		},
	{	"bearing",	"any",		"{1bearing %s"			},
	{	"with",		"any",		"{1with %s"			},
	{	NULL,		NULL,		NULL				}
};

const struct craftcolors_type craftcolors_table [] =
{
	{	"None", 	""		},
	{	"b",		C_BLUE		},
	{	"c",		C_CYAN		},
	{	"g",		C_GREEN		},
	{	"m",		C_MAGENTA	},
	{	"r",		C_RED		},
	{	"w",		C_WHITE		},
	{	"y",		C_YELLOW	},
	{	"B",		C_B_BLUE	},
	{	"C",		C_B_CYAN	},
	{	"G",		C_B_GREEN	},
	{	"M",		C_B_MAGENTA	},
	{	"R",		C_B_RED		},
	{	"W",		C_B_WHITE	},
	{	"Y",		C_B_YELLOW	},
	{	"D",		C_D_GREY	}
};

const   struct  room_invade_type  room_invade_table []  =
{
  { "dumai", 2999},
  { "dumai", 2975},
  { "dumai", 2971},
  { "dumai", 2972},
  { "dumai", 2973},
  { "dumai", 2974},
  { "dumai", 2976},
  { "dumai", 2977},
  { "dumai", 2980},
  { "dumai", 2981},
  { "dumai", 2982},
  { "dumai", 2983},
  { "dumai", 2984},
  { "dumai", 2985},
  { "stone tear", 11933},
  { "stone tear", 11934},
  { "stone tear", 11935},
  { "stone tear", 11936},
  { "stone tear", 11937},
  { "stone tear", 11938},

  { NULL,0}
};

const  struct flag_type affect2_flags[] =
{

	{ "speed",     		  A, TRUE }, /* bits for affected2 by*/
	{ "endurance", 		  B, TRUE },
	{ "panther reflex",   C, TRUE },
	{ "hunters instinct", D, TRUE },
	{ "battlecry",        E, TRUE },
	{ "rage",             F, TRUE },
	{ "inspiration",      G, TRUE },
	{ "courage",          H, TRUE },
	{ "serenade",         I, TRUE },
	{ "bandage",          J, TRUE },
	{ "bigger",           L, TRUE },
	{ "quicken",          M, TRUE },
	{ "innervation",      N, TRUE },
	{ "fortitude",        O, TRUE },
	{ "sixth sense",      P, TRUE },
};
