/***************************************************************************
                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/
    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.
    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.
    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.
    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.
    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.
	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "talents.h"
#include "recycle.h"
#include "lookup.h"
#include "mysql5_interface.h"

/*Locals */

bool is_shadow args((CHAR_DATA *ch));
void add_to_married_list args((char *name, char *colour_name));
void refresh_married_list args((CHAR_DATA *ch, char *name, char* colourname));
int calc_remort_tier( CHAR_DATA *ch);
char * get_remort_title(CHAR_DATA *ch);

CHAR_DATA *mentor;
void mentor_call args(( CHAR_DATA *ch, char *argument ));
void mentor_end  args(( CHAR_DATA *ch, char *argument ));


/*void mentor_send args(( CHAR_DATA *ch, char *argument ));*/

void do_mentor( CHAR_DATA *ch, char *argument )
{
	DESCRIPTOR_DATA *d = NULL;
	char arg1[MIL];
	char arg2[MIL];
	char buf1[MSL];
	char buf2[MSL];
	char buf3[MSL];
	char buf4[MSL];
	char buf5[MSL];
	char mBuf[MSL];
	int count = 0;
	bool mFound = FALSE;

	buf2[0] = '\0';
	mBuf[0] = '\0';

	if ( IS_NPC( ch ) || ch->desc == NULL )
		return;

    argument = one_argument( argument, arg1 );

    if ( arg1[0] == '\0' )
    {
	    if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
	        stc("Mentor Join - Join an active Mentor Session.\n\r", ch);
		    if ( MENTOR_SESSION < 1 )
			    stc("               There is no Mentor Session active right now.\n\r",ch);
			else
			    stc("               There is a Mentor Session active right now!\n\r",ch);
	        stc("Mentor Ask  - Will send a message to Mentors that you need help.\n\r", ch);
	        for ( d = descriptor_list; d != NULL; d = d->next )
	        {
		        if ( d->connected == CON_PLAYING
	            && IS_SET( d->character->spec_flags,SPEC_MENTOR ) && can_see(ch,d->character) )
		        {
		            mFound = TRUE;
		        }
		    }
	   		if ( mFound )
		   		stc("{wThere is currently a Mentor online to receive a call.{x\n\r",ch);
		   	else
		   		stc("{wThere is no Mentor online right now to receive a call.{x\n\r",ch);
	    }
	    else
	    {
	        stc("Syntax:\n\r",ch);
	        stc("Mentor Join - Join an active Mentor Session.\n\r", ch);
		    if ( MENTOR_SESSION < 1 )
			    stc("               There is no Mentor Session active right now.\n\r",ch);
			else
			    stc("               There is a Mentor Session active right now!\n\r",ch);
	        stc("Mentor Ask  - Will send a message to Mentors that you need help.\n\r", ch);
	        stc("Mentor Call - Announces a Mentor Session and invites players to join.\n\r",ch);
	        stc("Mentor End  - Ends a current Mentor Session.\n\r",ch);
	        stc("Mentor Send - Sends a message to all active Mentors.\n\r",ch);
	        stc("Mentor Goto - Goto a non-verified character.\n\r", ch);
	        stc("Mentor Who  - Display a list of non-verified characters.\n\r",ch);
	        stc("Mentor Stat - Display basic character information.\n\r",ch);
	        stc("Mentor Verify  - Verifies character.\n\r",ch);
	        stc("Mentor Socket  - Shows active player connections.\n\r",ch);
	        stc("Mentor Newpack - Provides a newbie with a pack of goodies.\n\r",ch);
	        stc("Mentor Newdoc  - Sends a newbie document to the specified email address.\n\r",ch);
		}
        return;
    }

    if ( !str_prefix( arg1, "join" ) )
    {
	    if ( MENTOR_SESSION < 1 )
	    {
	    	stc("There is no Mentor Session active at the moment.\n\r",ch);
	    	return;
	    }
	    else
	    {
	    	if ( mentor == NULL )
	    	{
	    		stc("Could not figure out who the Mentor is to send you to.\n\r",ch);
	    		return;
	    	}
	    	if ( is_fighting(ch) )
	    	{
	    		stc("{RFinish the fight!{x\n\r",ch);
	    		return;
	    	}
	    	char_from_room( ch );
	    	char_to_room( ch, mentor->in_room );
	    	act( "$n has joined the Mentor Session.", ch, NULL, NULL, TO_ROOM );
	    	do_function( ch, &do_look, "auto" );
	    	return;
	    }
    }
    if ( !str_prefix( arg1, "ask" ) )
    {
		mentor_alert( "{R%s is asking for help!!{x", ch->name );
        for ( d = descriptor_list; d != NULL; d = d->next )
        {
	        if ( d->connected == CON_PLAYING
            && IS_SET( d->character->spec_flags,SPEC_MENTOR )
		  && can_see(ch,d->character) )
	            mFound = TRUE;
	    }
	    WAIT_STATE( ch, PULSE_VIOLENCE * 3 );
   		stc("{wYou send a message to the Mentor Society asking for assistance.{x\n\r",ch);
   		stc("{wIn order to prevent people from spamming this command you will{x\n\r",ch);
   		stc("{wbe lagged for a few moments. Please don't abuse the Mentors by{x\n\r",ch);
   		stc("{wrepeating this command over and over. It may take a few moments{x\n\r",ch);
   		stc("{wfor a Mentor to respond to the message depending on if there is{x\n\r",ch);
   		stc("{wone online and where they are. We will now check for Mentors who{x\n\r",ch);
   		stc("{wmay be logged into the game.{x\n\r",ch);
   		if ( mFound )
	   		stc("{wThere is currently a Mentor online who has received the call.{x\n\r",ch);
	   	else
	   		stc("{wThere is no Mentor online right now to receive the call.{x\n\r",ch);
	    return;
    }

    /* Beyond here, only Mentors are allowed to use these commands.
     * Dalsor
     */

    if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
    {
       	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
   	    return;
    }

	if ( !str_prefix( arg1, "newdoc" ))
	{
	    char arg2[MIL], buf[MSL];

		argument = one_argument( argument, arg2 );

    	if ( arg2 == NULL || arg2[0] == '\0' )
	    {
        	stc("You must provide an email address to send to.\n\r",ch);
    	    return;
	    }
	/* and we should base it on their inputted email address, not something they need to tell. */

	    sprintf(buf,"mail %s -s \"New player document\" < ~/doc/newbie.txt &", arg2);
		system(buf);
/* we should not be posting player emails to all mentors. */
	    ptc( ch, "Newbie document sent to %s.\n\r", arg2 );

	    mentor_alert("%s sent \"%s\" the newbie document.", ch->name, arg2);
	    return;
	}


    if ( !str_prefix( arg1, "who" ) )
    {
		DESCRIPTOR_DATA *d;
		CHAR_DATA *ment;
		bool found = FALSE;
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }
	    for (d = descriptor_list; d != NULL; d = d->next)
	    {
			if ( !d->character )
				continue;
			if ( d->connected != CON_PLAYING )
				continue;
			if ( !d->character->pcdata )
				continue;
			if ( d->character->pcdata->allowed == 1 )
				continue;
			else
			{
				ptc( ch, "{w  Not Verified: {W%s{x\n\r", capit2( d->character->name ) );
				found = TRUE;
				mFound = FALSE;  /* these 3 lines should fix the multiple mentor bug */
				mBuf[0] = '\0';
				count = 0;
				for ( ment = d->character->in_room->people; ment != NULL; ment = ment->next_in_room )
				{
					if ( IS_SET( ment->spec_flags, SPEC_MENTOR ) )
					{
						strcat( mBuf, ment->name );
						strcat( mBuf, " " );
						mFound = TRUE;
						count += 1;
					}
				}
				if ( !mFound )
				{
				    if ( d->character->in_room->vnum >= 31000 && d->character->in_room->vnum <= 31999 )
					ptc( ch, "  {W%s{w is on the tour.{x\n\r", d->character->name );
				    else
					ptc( ch, "  {W%s{w is not being attended to.{x\n\r", d->character->name );
				}
				else
				{
					ptc( ch, "{W%s{w%s in the room with {W%s{x.\n\r",
					mBuf, count <= 1 ? "is" : "are", d->character->name );
				}
				stc("{r----------------------------------------{x\n\r", ch);
			}
		}
		if ( !found )
			stc( "No one needs to be verified.\n\r", ch );
		return;
	}

    if ( !str_prefix( arg1, "goto" ) )
    {
		CHAR_DATA *victim;
		argument = one_argument( argument, arg2 );

    	if ( arg2 == NULL )
	    {
        	stc("Must provide a newbie name to goto.\n\r",ch);
    	    return;
	    }
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }
	    if ( ( victim = get_char_world( ch, arg2 ) ) == NULL )
	    {
        	stc("Character not found in current descriptor list.\n\r",ch);
    	    return;
	    }
	    if ( IS_NPC( victim ) )
	    {
        	stc("Character is an NPC.\n\r",ch);
    	    return;
	    }
	    if ( victim->pcdata && victim->pcdata->allowed == 1 )
	    {
        	stc("Character is already verified.\n\r",ch);
    	    return;
	    }
		if ( ch->pcdata->in_vault )
		{
		do_function( ch, &do_locker, "close" );
		}
	    if ( victim->in_room != NULL && victim->pcdata && victim->pcdata->allowed == 0 )
	    {
		char mBuf[MIL];
    		if( ch->position == POS_SLEEPING)
			do_function( ch, &do_stand, "");
		sprintf( mBuf, "send I am attending to %s.", victim->name );
		do_function( ch, &do_mentor, mBuf );
			act("$n leaves on Mentor business.", ch, NULL,NULL,TO_ROOM);
        	ptc(ch,"Sending you to %s.\n\r",victim->name);
		    char_from_room( ch );
		    char_to_room( ch, victim->in_room );
		    do_function( ch, &do_look, "auto");
		    ptc(victim,"{GMentor %s appears in the room before you.{x\n\r",capit2(ch->name));
    	    return;
	    }
	}
    if ( !str_prefix( arg1, "send" ) )
    {
	    char *safe_arg;
	    /*argument = one_argument( argument, arg2 );*/
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }
	    if ( arg2 == NULL )
	    {
        	stc("Say what to your fellow Mentors?:\n\r",ch);
    	    return;
	    }
        /*act_new("{w({GMentor $n{w){W::{G {g'{G$t{g'{x",ch,capit2(argument),NULL,TO_CHAR,POS_DEAD);*/
	safe_arg = double_percent( argument );  /* turns % into %% , and makes it safe to go through a vaprintf */
        mentor_send( ch, capit2( safe_arg ) );
	free_string(safe_arg);
        /*
        for ( d = descriptor_list; d != NULL; d = d->next )
        {
	        if ( d->connected == CON_PLAYING
            && IS_SET( d->character->spec_flags,SPEC_MENTOR ) )
	        {
            act_new("{w({GMentor $n{w){W::{G {g'{G$t{g'{x",ch,capit2(argument),d->character,TO_VICT,POS_DEAD);
	        }
	    }
	    */
	    return;
    }

    if ( !str_prefix( arg1, "call" ) )
    {
	    if ( MENTOR_SESSION > 0 )
	    {
	    	stc("There is already a Mentor Session active at the moment.\n\r",ch);
	    	return;
	    }
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor.\n\r",ch);
    	    return;
	    }
       	stc("You call a Mentor Session.\n\r",ch);
		sprintf(buf1, "            {R*****************************************************{x\n\r");
        sprintf(buf2, "{wMentor $n has called a Mentor Session.\n\rThose who wish to attend should type Mentor Join.{x\n\r");
        /*sprintf(buf3, "{w Those who wish to attend should type Mentor Join. {x\n\r");*/
        sprintf(buf4, "            {R*****************************************************{x");
        strcat( buf5, buf1 );
        strcat( buf5, buf2 );
        strcat( buf5, buf3 );
        strcat( buf5, buf4 );
        for ( d = descriptor_list; d != NULL; d = d->next )
        {
	        if ( d->connected == CON_PLAYING )
	        {
            act( buf2, ch, NULL, d->character, TO_VICT );
            MENTOR_SESSION = 1;
            mentor = ch;
	        }
	    }
	    return;
    }
    if ( !str_prefix( arg1, "end" ) )
    {
	    if ( MENTOR_SESSION < 1 )
	    {
	    	stc("There is no Mentor Session active at the moment.\n\r",ch);
	    	return;
	    }
    	if ( mentor == NULL )
	    {
	    	stc("There is no Mentor Session active at the moment.\n\r",ch);
	    	return;
	    }
	    if ( mentor != ch )
	    {
	    	stc("Only the invoking Mentor may end the session.\n\r",ch);
	    	return;
	    }
       	stc("You call an end to the Mentor Session.\n\r",ch);
       	act("$n calls an end to the Mentor Session.",ch,NULL,NULL,TO_ROOM);
	    MENTOR_SESSION = 0;
	    mentor = NULL;
    }

    if ( !str_prefix( arg1, "socket" ) )
	{
	    CHAR_DATA       *vch;
	    DESCRIPTOR_DATA *d;
	    char            buf  [ MAX_STRING_LENGTH ];
	    char            buf2 [ MAX_STRING_LENGTH ];
	    int             count;
	    char *          st;
	    char            s[100];
	    char            idle[10];

	/* disabled due to abuse */
	return;
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }

	    count       = 0;
	    buf[0]      = '\0';
	    buf2[0]     = '\0';

	    strcat( buf2, "\n\r[Num Connected_State Login@ Idl] Player Name Host\n\r" );
	    strcat( buf2,
		"--------------------------------------------------------------------------\n\r");
	    for ( d = descriptor_list; d; d = d->next )
	    {
	        if ( d->character && can_see( ch, d->character ) )
	        {
	           /* NB: You may need to edit the CON_ values */
	           switch( d->connected )
	           {
	              case CON_PLAYING:              st = "    PLAYING    ";    break;
	              case CON_GET_NAME:             st = "   Get Name    ";    break;
	              case CON_GET_OLD_PASSWORD:     st = "Get Old Passwd ";    break;
	              case CON_CONFIRM_NEW_NAME:     st = " Confirm Name  ";    break;
	              case CON_GET_NEW_PASSWORD:     st = "Get New Passwd ";    break;
	              case CON_CONFIRM_NEW_PASSWORD: st = "Confirm Passwd ";    break;
	              case CON_GET_NEW_RACE:         st = "  Get New Race ";    break;
	              case CON_GET_NEW_SEX:          st = "  Get New Sex  ";    break;
	              case CON_GET_NEW_CLASS:        st = " Get New Class ";    break;
	              case CON_BREAK_CONNECT: 	     st = "   LINKDEAD    ";    break;
	              case CON_COPYOVER_RECOVER:     st = "   COPYOVER    ";    break;
	              case CON_CHANNELER:            st = "   CHANNELER   ";    break;
	              case CON_CHAR_BACKG:           st = "  BACKGROUND   ";    break;
	              case CON_CHAR_EYE:             st = "     EYE       ";    break;
	              case CON_GET_HAIR1:            st = "    HAIR1      ";    break;
	              case CON_GET_HAIR2:            st = "    HAIR2      ";    break;
	              case CON_GET_HAIR3:            st = "    HAIR3      ";    break;
	              case CON_GET_HAIR4:            st = "    HAIR4      ";    break;
	              case CON_CONNECT_CHAR:         st = " CONNECT CHAR  ";    break;
	              case CON_CHAR_RANDOM:          st = "   RANDOM      ";    break;
	              case CON_GET_AIEL_SOCIETY:     st = "  AIEL SOC     ";    break;
	              case CON_GET_TROLLOC_CLAN:     st = " TROLLOC CLAN  ";    break;
	              case CON_CLEAN_UP:             st = "   CLEAN UP    ";    break;
	              case CON_KEEP_STATS:           st = "  KEEP STATS   ";    break;
	              case CON_GET_AIEL_CLAN:        st = "  AIEL CLAN    ";    break;
	              case CON_ACCEPT_FOLLOWER:      st = "   GROUPING    ";    break;
	              case CON_SHOW_POLICY:          st = "    POLICY     ";    break;
	              case CON_ACCEPT_RULES:         st = " ACCEPT RULES  ";    break;
	              case CON_AIEL_SOCIETY_NEW:     st = " AIEL SOC NEW  ";    break;
	              case CON_SEANCHAN:             st = "   SEANCHAN    ";    break;
	              case CON_BUGREPORTING_MSG:     st = "     BUG       ";    break;
	              case CON_BUGREPORTING_IMMINFO: st = "     BUG       ";    break;
	              case CON_BUGREPORTING_MORTINFO:st = "     BUG       ";    break;
	              case CON_GET_LAST_NAME:        st = "   LAST NAME   ";    break;
	              case CON_NOTE_TO:              st = "    NOTE       ";    break;
	              case CON_NOTE_SUBJECT:         st = "    NOTE       ";    break;
	              case CON_NOTE_EXPIRE:          st = "    NOTE       ";    break;
	              case CON_NOTE_TEXT:            st = "    NOTE       ";    break;
	              case CON_NOTE_FINISH:          st = "    NOTE       ";    break;
	              case CON_CHAR_DESCRIPTION:     st = "  DESCRIPTION  ";    break;
	              case CON_GET_FAMILY_NAME:      st = "  FAMILY NAME  ";    break;
	              default:                       st = "   !UNKNOWN!   ";    break;
	           }
	           count++;

	           /* Format "login" value... */
	           vch = d->original ? d->original : d->character;
	           strftime( s, 100, "%I:%M%p", localtime( &vch->logon ) );


	           if ( vch->timer > 0 )
	              sprintf( idle, "%-2d", vch->timer );
	           else
	              sprintf( idle, "  " );

	           sprintf( buf, "[%3d %s %7s %2s] %-12s %-32.32s\n\r",
	              d->descriptor,
	              st,
	              s,
	              idle,
	              ( d->original ) ? d->original->name : ( d->character ) ? d->character->name : "(None!)",
	              is_exact_name(d->character->name, "Caedd") ? "193.129.14.24" :
			is_exact_name(d->character->name,"Sarele") ? "203.126.17.4" : d->host );

	           strcat( buf2, buf );

	        }
	    }

	    sprintf( buf, "\n\r%d user%s\n\r", count, count == 1 ? "" : "s" );
	    strcat( buf2, buf );
	    send_to_char( buf2, ch );
	    return;
	}

	if ( !str_prefix( arg1, "verify" ) )
	{

		CHAR_DATA *victim;
	    argument = one_argument( argument, arg2 );
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }
		if ( ( victim = get_char_world( ch, arg2 ) ) == NULL )
		{
			stc("Could not find that person.\n\r",ch);
			return;
		}
		if ( IS_NPC( victim ) || IS_NPC( ch ) || !victim->desc || !victim->pcdata )
		{
			stc("Not on NPCs, linkdead folk, or those without pcdata.\n\r",ch);
			return;
		}
		if ( victim->pcdata && victim->pcdata->allowed == 0 )
		{
			stc( "Verified.\n\r",ch);
			victim->pcdata->allowed = 1;
			ptc( victim, "%s has verified you. You are now allowed to leave the school.\n\rBe sure to SAVE!\n\r", ch->name );
		    sprintf( log_buf, "{c%s was verified by %s at %s [room %ld]",
	             victim->name,
	             ch->name,
	            victim->in_room->name, victim->in_room->vnum);
		    log_string( log_buf);
            wiznet(log_buf,NULL,NULL,WIZ_NEWBIE,0,0);
			mentor_alert( "%s has been verified by %s.", victim->name, ch->name );
			ch->pcdata->verifications++;
	    		//update_staff( ch, "commands" );
		}
		return;
	}

    if ( !str_prefix( arg1, "newpack" ) )
    {

	OBJ_DATA *obj;
	OBJ_DATA *sack;
	CHAR_DATA *victim;
	int i;
    	if ( !IS_SET( ch->spec_flags,SPEC_MENTOR ) )
	    {
        	stc("You are not a Mentor, or not an Immortal.\n\r",ch);
    	    return;
	    }
	argument = one_argument( argument, arg2 );
	if ( ( victim = get_char_room( ch, NULL, arg2 ) ) == NULL )
	{
	    stc( "Who? Make sure you're in the room with them.\n\r", ch );
	    return;
	}
	/* check to make sure the target isn't invalid goes here
	 * possibly check # of remorts, lvl
	 * whether or not its a mob, that sort of stuff
	 * */

	/* make the sack */
	sack = create_object( get_obj_index( 3004 ), 0 );
	sack->cost = 0;

	/* saida */
	obj = create_object( get_obj_index( 3716 ), 0 );
	obj->cost = 0;
	obj_to_obj( obj, sack );

	/* lockpick */
	obj = create_object( get_obj_index( 719 ), 0 );
	obj->cost = 0;
	obj_to_obj( obj, sack );

	/* jokes scroll */
	obj = create_object( get_obj_index( 3763 ), 0 );
	obj->cost = 0;
	obj_to_obj( obj, sack );

	/* glow book */
	obj = create_object( get_obj_index( 3745 ), 0 );
	obj->cost = 0;
	obj_to_obj( obj, sack );

	/* 5 reed torch */
	for ( i = 0; i < 5; i++ )
	{
	    obj = create_object( get_obj_index( 3757 ), 0 );
	    obj->cost = 0;
	    obj_to_obj( obj, sack );
	}

	/* 5 healing potions */
	for ( i = 0; i < 5; i++ )
	{
	    obj = create_object( get_obj_index( 3275 ), 0 );
	    obj->cost = 0;
	    obj_to_obj( obj, sack );
	}
	ptc( ch, "You give %s a newbie sack.\n\r", victim->name );
	ptc( victim, "%s gives you a sack specially designed to assist new players.\n\rType Look In Sack to see the contents.\n\r", ch->name );
	stc( "To use the Green Herb Tea, type Get Tea From Sack then Quaff Tea. This will heal you some.\n\r", victim );
	stc( "To use the Reed Torch, type Get Torch From Sack then Hold Torch. This will let you see when there is no light.\n\r", victim );
	stc( "To use the Thick Book or List of Jokes you must have the Scrolls Skill and you must be a Channeler!\n\r", victim );
	stc( "To get the Scrolls Skill find the Practice Hall. Type Gain Scrolls then type Practice Scrolls.\n\rStudy Book or Study List to learn these weaves.\n\r", victim );
	stc( "To use the Saida Device, type Get Saida From Sack then Wear Saida. This will allow you to see Global,\n\rand talk on it once you have played for an hour.\n\r", victim );
	obj_to_char( sack, victim );
	return;
    }

}
/* Seeing talent
 * checks first to see if the person who is looked at
 * has a talent, like ta'veren, wolfkin, etc, and gives
 * a description, also checks for guild, channeler, blade
 * master, etc.
 */
/* if seeing( ch, victim ) show_seer( ch, victim ); */
bool    blademaster args( ( CHAR_DATA *ch ) );
int seeing( CHAR_DATA *ch, CHAR_DATA *victim )
{
	int images = 0;

	if (IS_NPC(ch) || IS_NPC(victim))
		return 0;

	if (!IS_SET(ch->spec_flags, SPEC_SEER))
		return 0;

	if (!IS_SET(clan_table[victim->clan].flags,GUILD_INDEPENDENT))
		images += 1;

	if (IS_SET( victim->war_flags, WAR_MENTOR ) )
		images += 1;

	if (IS_SET( victim->war_flags, WAR_MODERATOR ) )
		images += 1;

	if (IS_SET( victim->op_flags, OP_CHANNELER ) )
		images += 1;

	if (blademaster( victim ) )
		images += 1;

	if (IS_SET( victim->spec_flags, SPEC_WOLFBROTHER ) )
		images += 1;

	if (IS_SET( victim->spec_flags, SPEC_TAVEREN ) )
		images += 1;

	if (IS_SET( victim->spec_flags, SPEC_DREAMWALKER ) )
		images += 1;

	if (IS_SET( victim->spec_flags, SPEC_SEER ) )
		images += 1;

	return images;
}
void show_seer( CHAR_DATA *ch, CHAR_DATA *victim )
{
	static char buf[MAX_STRING_LENGTH];
	int images = seeing(ch, victim);

	buf[0] = '\0';

	if (!IS_SET(ch->spec_flags, SPEC_SEER))	return;

	if (images <= 0)
	{
		stc("You can't see any images around them.\n\r", ch);
		return;
	}

	ptc(ch, "You see %simage%s floating around %s.\n\r",
		images == 1 ? "an " : "",
		images > 1 ? "s" : "",
		capit2(victim->name));

	if (!IS_SET(clan_table[victim->clan].flags,GUILD_INDEPENDENT)
	&& clan_table[victim->clan].seer != NULL )
	{
		strcat(buf, clan_table[victim->clan].seer);
		strcat(buf, ". ");
	}

	if (IS_SET( victim->war_flags, WAR_MENTOR ) )
		strcat(buf, "An Open Palm. ");

	if (IS_SET( victim->war_flags, WAR_MODERATOR ) )
		strcat(buf, "Scales and Balance. ");

	if (IS_SET( victim->op_flags, OP_CHANNELER ) )
		strcat(buf, "Wheel with Seven Spokes. " );

	if (blademaster( victim ) )
		strcat(buf, "Heron in Flight. " );

	if (IS_SET( victim->spec_flags, SPEC_WOLFBROTHER ) )
		strcat(buf, "Howling Wolf before a Full Moon. " );

	if (IS_SET( victim->spec_flags, SPEC_TAVEREN ) )
		strcat(buf, "A Loose Thread. " );

	if (IS_SET( victim->spec_flags, SPEC_DREAMWALKER ) )
		strcat(buf, "Inverted Mirror. " );

	if (IS_SET( victim->spec_flags, SPEC_SEER ) )
		strcat(buf, "An eye staring back at you. " );

	strcat(buf, "\n\r");

	/* FIXME    i -1 ranges from -1 to 25
	for ( i = 0; i <= 26; i++ )
	{
		if ( !str_cmp( race_table[victim->race].name, seeing_city_table[i].name ) )
		{
			strcat(buf, seeing_city_table[i].symbol );
			strcat(buf, " ");
			break;
		}
	}
	*/

	stc(buf, ch);
	return;
}

char * show_rbi_letter_no_color(CHAR_DATA *ch)
{
	char *retVal;
	char buf[MSL];
	int chRbi = 0;/*The colour in a certain tier*/                                                                                                                                               
        int tier = 0;/*This is Young, Adventurer, etc.*/                                                                                                                                             
                                                                                                                                                                                                     
        buf[0] = '\0';                                                                                                                                                                               
                                                                                                                                                                                                     
        if (IS_NPC(ch))                                                                                                                                                                              
                return str_dup("");                                                                                                                                                                  
        if (ch->desc == NULL || !ch->desc)                                                                                                                                                           
                return str_dup("");                                                                                                                                                                  
        if (ch->pcdata == NULL || !ch->pcdata)                                                                                                                                                       
                return str_dup("");                                                                                                                                                                  
                                                                                                                                                                                                     
        tier = calc_remort_tier(ch);                                                                                                                                                                 
                                                                                                                                                                                                     
        if ( tier < 1 )                                                                                                                                                                              
        {                                                                                                                                                                                            
                tier = 1;                                                                                                                                                                            
                chRbi = 0;                                                                                                                                                                           
        }                                                                                                                                                                                            
                                                                                                                                                                                                     
        if ( IS_IMMORTAL(ch) )
                return str_dup("{WI");

        /*if ( ch->pcdata->rebirth == 0 )
                return "{YY";*/

        strcat( buf, rbi_table[tier].letter );

        retVal = str_dup( buf );

        return retVal;
}
char * show_rbi_letter(CHAR_DATA *ch)
{
	char *retVal;
	char buf[MSL];
	int chRbi = 0;/*The colour in a certain tier*/
	int tier = 0;/*This is Young, Adventurer, etc.*/

	buf[0] = '\0';

	if (IS_NPC(ch))
		return str_dup("");
	if (ch->desc == NULL || !ch->desc)
		return str_dup("");
	if (ch->pcdata == NULL || !ch->pcdata)
		return str_dup("");

	tier = calc_remort_tier(ch);

	if ( tier < 1 )
	{
		tier = 1;
		chRbi = 0;
	}

	if ( IS_IMMORTAL(ch) )
		return str_dup("{WI");

	/*if ( ch->pcdata->rebirth == 0 )
		return "{YY";*/

	strcat( buf, rbi_table[tier].tClr );
	strcat( buf, rbi_table[tier].letter );

	retVal = str_dup( buf );

	return retVal;
}

char * show_rbi_title(CHAR_DATA *ch)
{
	char *retVal;
	char buf[MSL];
	int chRbi = 0;
	buf[0] = '\0';
	if (IS_NPC(ch))
		return str_dup("");
	if (ch->desc == NULL || !ch->desc)
		return str_dup("");
	if (ch->pcdata == NULL || !ch->pcdata)
		return str_dup("");
	chRbi = calc_remort_tier(ch);
	if (chRbi <= 1)
	{
		if( ch->sex == SEX_FEMALE)
			return str_dup("Lady");
		else
			return str_dup("Lord");
	}
	if ( IS_IMMORTAL(ch) )
		return str_dup("{WI");
	/*if ( chRbi == 0 )
		return "";*/
	if ( ch->sex == SEX_FEMALE )
		strcat( buf, rbi_table[chRbi].fTitle );
	else
		strcat( buf, rbi_table[chRbi].mTitle );
	retVal = str_dup( buf );
	return retVal;
}

void	fwrite_char	args( ( CHAR_DATA *ch,  FILE *fp ) );
void	fwrite_obj	args( ( CHAR_DATA *ch,  OBJ_DATA  *obj, FILE *fp, int iNest ) );
void	fwrite_pet	args( ( CHAR_DATA *pet, FILE *fp) );
void	fwrite_mount	args( ( CHAR_DATA *pet, FILE *fp) );
DECLARE_SPELL_FUN(spell_null);

bool is_qskill( int sn )
{
	if ( sn == skill_lookup( "anticipate" ) )
		return TRUE;
	if ( sn == skill_lookup( "precision" ) )
		return TRUE;
	if ( sn == skill_lookup( "efficient" ) )
		return TRUE;
	if ( sn == skill_lookup( "gifted" ) )
		return TRUE;
	if ( sn == skill_lookup( "windfall" ) )
		return TRUE;
	if ( sn == skill_lookup( "evaluate" ) )
		return TRUE;
	if ( sn == skill_lookup( "feint" ) )
		return TRUE;
	if ( sn == skill_lookup( "lunge" ) )
		return TRUE;
	if ( sn == skill_lookup( "draw" ) )
		return TRUE;
	if ( sn == skill_lookup( "angrealstudy" ) )
		return TRUE;
	if ( sn == skill_lookup( "bribery" ) )
		return TRUE;
	if ( sn == skill_lookup( "stagger" ) )
		return TRUE;
	if ( sn == skill_lookup( "chop" ) )
		return TRUE;
	if ( sn == skill_lookup( "focus" ) )
		return TRUE;
	if ( sn == skill_lookup( "far sight" ) )
		return TRUE;

	return FALSE;
}

int count_skill_percs( CHAR_DATA *ch )
{
	FILE *fp;
	int skills = 0, weaves = 0, skTot = 0, wvTot = 0, sn, perc = 0, over75 = 0, ovTot = 0;

	if ( !ch )
	return 0;

	for ( sn = 0; sn < MAX_SKILL; sn++ )
	{
	    if ( skill_table[sn].name == NULL )
			break;
	    if ( ch->pcdata->learned[sn] < 1 )
			continue;

		if ( is_qskill( sn ) )
			continue;

		perc += ch->pcdata->learned[sn];
		if ( skill_table[sn].spell_fun == spell_null )
		{
			if ( ch->pcdata->learned[sn] > 75 )
				over75++;
			if ( ch->pcdata->learned[sn] > 75 )
				ovTot += ch->pcdata->learned[sn] - 75;
			skTot += ch->pcdata->learned[sn];
			skills++;
		}
		else
		{
			if ( ch->pcdata->learned[sn] > 75 )
				over75++;
			if ( ch->pcdata->learned[sn] > 75 )
				ovTot += ch->pcdata->learned[sn] - 75;
			wvTot += ch->pcdata->learned[sn];
			weaves++;
		}
	}

	/*ptc( ch, "Char: %s CanChan? %s Over75: %d (%d) Perc: %d Sk: %d (%d) Wv: %d (%d)\n",
		ch->name, IS_SET(ch->op_flags,OP_CHANNELER) ? "Yes" : "No", over75, ovTot, perc, skills, skTot, weaves, wvTot );*/

	if ( ( fp = fopen( "../data/skcnt.txt", "a" ) ) != NULL )
	{
		fprintf( fp, "Char: %s CanChan? %s Over75: %d (%d) Perc: %d Sk: %d (%d) Wv: %d (%d)\n",
		ch->name, IS_SET(ch->op_flags,OP_CHANNELER) ? "Yes" : "No", over75, ovTot, perc, skills, skTot, weaves, wvTot );
		fclose( fp );
	}

	return 0;
}

int remort_req( CHAR_DATA *ch )
{
	return ch->pcdata->rebirth * 10;
}

/* New remort shit. Still 250 morts in total, broken into ten tiers. Tiers are going to play into the rebirth bonuses, not number of morts. - Kerrick */
int calc_remort_tier( CHAR_DATA *ch)
{
	int tier;

	if (ch->pcdata->rebirth <= 25)
	{
		tier = 1;
	}
	else if (ch->pcdata->rebirth <= 50)
	{
		tier = 2;
	}
	else if (ch->pcdata->rebirth <= 75)
	{
		tier = 3;
	}
	else if (ch->pcdata->rebirth <= 100)
	{
		tier = 4;
	}
	else if (ch->pcdata->rebirth <= 125)
	{
		tier = 5;
	}
 	else if (ch->pcdata->rebirth <= 150)
	{
		tier = 6;
	}
	else if (ch->pcdata->rebirth <= 175)
	{
		tier = 7;
	}
	else if (ch->pcdata->rebirth <= 200)
	{
		tier = 8;
	}
	else if (ch->pcdata->rebirth <= 225)
	{
		tier = 9;
	}
	else	tier = 10;

	return tier;
}

bool can_remort( CHAR_DATA *ch )
{
	int tier;
	int level_req;

	tier = calc_remort_tier(ch);
	level_req = tier * 25;
	level_req += 225;

	if(ch->level >= level_req)
	{
		return TRUE;
	}
	return FALSE;
}

void show_lost_qskills (CHAR_DATA *ch, bool adjust)
{
	int sk;
	int rollover = 100; /* Skill % they need to roll a skill over */
	bool found = FALSE;
	char buf[MSL];
	BUFFER *output;

	output = new_buf();

	if (calc_remort_tier(ch) == 1)	
		rollover = 76;
	else
		rollover = 101;

	for (sk = 0; skill_table[sk].name != NULL; sk++)
	{
		// Since we're allowing players to keep all skills, let's skip the qskill check -- Dalsor 12/14/2012
		//if (!is_qskill(sk))			continue; 
		if (ch->pcdata->learned[sk] <= 0)	continue;
		if (ch->pcdata->learned[sk] > rollover)	continue;
		if (sk == skill_lookup("gifted"))	continue;
		found = TRUE;
		break;
	}

	if (found)
		stc("\n\rIf you remort now, you will lose the following skills:\n\r", ch);

	ptc(ch,"Your skill rollover requirment is %d.\n\rNote that if you have a QUEST SKILL, it will always carry over.\n\r", rollover);
	for (sk = 0; skill_table[sk].name != NULL; sk++)
	{
		// Since we're allowing players to keep all skills, let's skip the qskill check -- Dalsor 12/14/2012
		if (is_qskill(sk))			continue;
		if (ch->pcdata->learned[sk] <= 0)	continue;
		if (ch->pcdata->learned[sk] >= rollover)	continue;
		sprintf( buf, " {c- {W%s, needing %d%% more{x\n\r", skill_table[sk].name, rollover - ch->pcdata->learned[sk]);
		add_buf( output, buf );	
		//ptc(ch, " {c- {W%s, needing %d%% more{x\n\r", skill_table[sk].name, rollover - ch->pcdata->learned[sk]);		
	}
	page_to_char(buf_string(output), ch);
	free_buf(output);

	return;
}

void do_rebirth(CHAR_DATA *ch, char *argument)
{
	DESCRIPTOR_DATA *d, *dto;
	char buf[MSL];
	char arg[MIL];
	CHAR_DATA *vch;
	int i, rebi;

	argument = one_argument( argument, arg );

	if ( IS_NPC(ch) || ( d = ch->desc ) == NULL )
		return;

	/* Clear the rebirth queue just in case - Imms only */
	if ( IS_IMMORTAL(ch) && !str_cmp( arg, "clear" ) )
	{
		if ( REBIRTH_IN_PROGRESS == 1 )
		{
			REBIRTH_IN_PROGRESS = 0;
			stc("Rebirth was at 1. It has been set 0.\n\r", ch);
			return;
		}
	}

	/* Make sure the rebirth is legal and valid */
	if ( !can_remort( ch ) )
	{
		stc( "You are not ready to be reborn.\n\r", ch );
		return;
	}

	if (IS_IMMORTAL(ch))
	{
		stc("Immortals SHOULD NOT try to be reborn.\n\r",ch);
		//return;
	}
	if (REBIRTH_IN_PROGRESS == 1)
	{
		stc("Someone is already being reborn right now. Wait a few minutes and try again.\n\r",ch);
		return;
	}
	if ( ch->pcdata->in_vault )
	{
		do_function( ch, &do_locker, "close" );
	}
	if ( ch->pcdata->in_vault )
	{
		stc("You can not be reborn while in the vault.\n\r",ch);
		return;
	}

	/* Everything legal and valid - lets get it on. */
	if ( !ch->pcdata->confirm_rebirth )
	{
		stc("{cYou are considering being reborn. Type Rebirth with an argument to remove rebirth status.{c\n\r",ch);
		ch->pcdata->confirm_rebirth = TRUE;
		show_lost_qskills(ch, false);
	    	wiznet("$N is considering rebirth.",ch,NULL,0,0,get_trust(ch));
		return;
	}
	else if (arg[0] != '\0' && ch->pcdata->confirm_rebirth )
	{
		stc("{cRebirth status removed.{c\n\r",ch);
		wiznet("$N was considering rebirth. Status removed",ch,NULL,0,0,get_trust(ch));
		ch->pcdata->confirm_rebirth = FALSE;
		return;
	}

	ch->pcdata->confirm_rebirth = FALSE;

	/* This saves some base stats to be reloaded after the rebirth finished.*/
	count_skill_percs( ch );

	/* Start the actual process - but save them first just in case. */

	do_function( ch, &do_save, "" );

	if ( ch->pcdata && ch->pcdata->deguilded == 1 )
		ch->pcdata->deguilded = 0;

	/* This updates mysql - don't need it for the moment
	update_staff( ch, "all" );*/

	REBIRTH_IN_PROGRESS = 1;

	rebi = ch->pcdata->rebirth;
/*    sprintf( strsave, "%s%s", PLAYER_DIR, capitalize( ch->name ) ); */
	stop_all_fighting( ch );

	wiznet( "$N has been reborn.", ch, NULL, 0, 0, 0 );

	/* Move them to void */
	char_from_room(ch);
	char_to_room(ch, get_room_index(1));

	/* Inform the world - LOOK AT ME WOOT! */
	for ( dto = descriptor_list; dto != NULL; dto = dto->next )
	{
		if ( !dto->character || dto->connected != CON_PLAYING )
			continue;
		vch = dto->character;
		if ( IS_NPC(vch) || IS_SET(vch->comm,COMM_QUIET) || !IS_SET(vch->comm,COMM_PREBIRTH) )
			continue;
		sprintf(buf,
		"{r                              ***{R**{w**{R**{r***{x\n\r");
		stc(buf,vch);
		sprintf(buf,
		"\n\r{W               %s %s has been Respun into the Pattern.\n\r\n\r",
		show_rbi_title(ch), ch->name);
		stc(buf,vch);
		sprintf(buf,
		"{r                              ***{R**{w**{R**{r***{x\n\r");
		stc(buf,vch);
	}
   
	//update_staff( ch, "all" );
	ch->on				= NULL;
	ch->pcdata->rebirthing = TRUE;
	ch->pcdata->burnout = 0;
	ch->level = 0;
	d->character->pcdata->rebirthing = TRUE;

	clear_irc( ch );

	/* this is for summary, not for the total number of rebirths -- Dalsor */
	d->character->pcdata->summary[SUM_REBIRTHS] += 1;

	/* do some mysql logging so players can see who remorted last -- Dalsor 02.20.2014 */
	if ( mud_port == play_port )
	{
		char mysql_buf[MIL];

		mysql_buf[0] = '\0';
		sprintf(mysql_buf, "insert into remort_history values (\"\", \"%s\", \"%ld\", \"%s\", \"%s\")",
			ch->name, current_time, ch->desc->host, show_rbi_title(ch) );

		mysql_real_query(result_db, mysql_buf, strlen(mysql_buf));

		if( mysql_affected_rows(result_db) < 1)
		{
			stc("Error writing remort to database.\n\r", ch);
			log_string("MYSQL: Error saving remort log.");
		}
	}
	/* end mysql logging */

	/* set the stats down */
	for (i = 0; i < MAX_STATS; i ++)
	{
		ch->perm_stat[i] = 13;
	}

	/* Strip affects */
	while (ch->affected) affect_remove(ch, ch->affected);

	ch->max_hit = 50;
	ch->max_stam = 50;
	ch->hit = 50;
	ch->stam = 50;
	ch->mod_hit = 0;
	ch->mod_stam = 0;

	stc ("\n\r", ch);
	check_talents(ch);

	if (ch->clan == clan_lookup("dreadlord")
	|| ch->clan == clan_lookup("chosen"))
		ch->pcdata->learned[skill_lookup("summon darkhound")] = 50;

	stc("\n\rYou may take the Tour if you wish, to change your features, \n\r",d->character);
	stc("or choose to channel, and other things. Note that you do not\n\r",d->character);
	stc("need to complete the entire Tour.\n\r",d->character);
	stc("\n\rIf you wish to reroll your stats, you may do so right now, but only in this room.{x\n\r", d->character);

	d->character->pcdata->rebirthing = TRUE;
	d->character->level = 0;
	d->connected = CON_CONNECT_CHAR;

	return;
}

/* bonds */
void do_bondtalk( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char *tmp2;

	if (IS_NPC(ch))
		return;

    if ( argument[0] == '\0' )
    {
		stc( "{cSay what to your bondmate?\n\r", ch );
		return;
    }
	if (ch->pcdata->bonded_to[0] == '\0')
	{
		stc("But you're not bonded to anyone.\n\r",ch);
		return;
	}
	if (ch->pcdata->bonded_to[0] != '\0')
	{
		tmp2 = (str_dup(ch->pcdata->bonded_to));
  	  	if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
	  		argument = makedrunk(argument,ch);
		if ( ( victim = get_pc_world( ch, tmp2 ) ) != NULL)
		{
			if ( !IS_AWAKE( victim ) )
			{
				stc("Your bond seems to be too asleep right now.\n\r", ch);
				free_string( tmp2 );
				return;
			}
			if (is_shadow(ch) || is_shadow(victim ) )
			{
		    	act("{b<{BD{bark{BB{bond: {w$n{b> {B'{w$t{B'{x",ch,argument,victim,TO_VICT);
		    	act("{b<{BD{bark{BB{bond: {w$n{b> {B'{w$t{B'{x",ch,argument,victim,TO_CHAR);
			}
			else
			{
		    	act("{b<{BBond: {w$n{b> {B'{w$t{B'{x",ch,argument,victim,TO_VICT);
		    	act("{b<{BBond: {w$n{b> {B'{w$t{B'{x",ch,argument,victim,TO_CHAR);
			}
		}
		else
		{
			stc( "Your bond is absent right now.\n\r", ch );
		}
		free_string( tmp2 );
	}
	else
	    return;
}
void do_bondmote( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char *tmp2;
    int i = 0;
    bool found = FALSE;
    char *emote[] = {
		"anger",       "disbelief",  "sadness",     "fear",           "happiness",
		"love",        "confusion",  "tiredness",   "contentedness",  "threat",
		"frustration", "impatience", "bitterness",  "pain",           "anxiety",
		"regret",      "amusement",  "jealousy",    "innocence",      "comfort",
		"warmth",      "support",    "mischief",    "loneliness",     "satisfaction",
		"sympathy",    "excitement", "exasperation","embarassment",	  "affection",
		"relief",	   "irritation", "playfulness", "longing",		  "desire",
		"sorrow",	   "resentment"
	}; /* 37 bondmotes */
	if (IS_NPC(ch))
		return;
    if ( argument[0] == '\0' )
    {
		stc("anger           disbelief\n\r",ch);
		stc("sadness         fear\n\r",ch);
		stc("happiness       love\n\r",ch);
		stc("confusion       tiredness\n\r",ch);
		stc("contentedness   threat\n\r",ch);
		stc("frustration     impatience\n\r",ch);
		stc("bitterness      pain\n\r",ch);
		stc("anxiety         regret\n\r",ch);
		stc("amusement       jealousy\n\r",ch);
		stc("innocence       comfort\n\r",ch);
		stc("warmth          support\n\r",ch);
		stc("mischief        loneliness\n\r",ch);
		stc("satisfaction    sympathy\n\r",ch);
		stc("excitement      exasperation\n\r",ch);
		stc("embarassment    affection\n\r",ch);
		stc("relief          irritation\n\r", ch);
		stc("playfulness     longing\n\r",	ch);
		stc("desire          sorrow\n\r",ch);
		stc("resentment\n\r",ch);
		stc("Send what emotion to your bondmate?\n\r", ch );
		return;
    }
    for ( i = 0; i < 37; i++ )
    {
		if ( !str_cmp( argument, emote[i] ) )
		{
			found = TRUE;
			break;
		}
	}
	if ( !found )
    {
		stc("anger           disbelief\n\r",ch);
		stc("sadness         fear\n\r",ch);
		stc("happiness       love\n\r",ch);
		stc("confusion       tiredness\n\r",ch);
		stc("contentedness   threat\n\r",ch);
		stc("frustration     impatience\n\r",ch);
		stc("bitterness      pain\n\r",ch);
		stc("anxiety         regret\n\r",ch);
		stc("amusement       jealousy\n\r",ch);
		stc("innocence       comfort\n\r",ch);
		stc("warmth          support\n\r",ch);
		stc("mischief        loneliness\n\r",ch);
		stc("satisfaction    sympathy\n\r",ch);
		stc("excitement      exasperation\n\r",ch);
		stc("embarassment    affection\n\r",ch);
		stc("relief          irritation\n\r", ch);
		stc("playfulness     longing\n\r",	ch);
		stc("desire          sorrow\n\r",ch);
		stc("resentment\n\r",ch);
		stc("Send what emotion to your bondmate?\n\r", ch );
		return;
    }
	if (ch->pcdata->bonded_to[0] == '\0')
	{
		stc("But you're not bonded to anyone.\n\r",ch);
		return;
	}
	if (ch->pcdata->bonded_to[0] != '\0')
	{
		tmp2 = (str_dup(ch->pcdata->bonded_to));
		if ( ( victim = get_pc_world( ch, tmp2 ) ) != NULL)
		{
			if ( !IS_AWAKE( victim ) )
			{
				stc("Your bond seems to be too asleep right now.\n\r", ch);
				free_string( tmp2 );
				return;
			}
	    	act("You perceive a sense of $t through your bond.",ch,argument,victim,TO_VICT);
	    	act("You project a sense of $t through your bond.{x",ch,argument,victim,TO_CHAR);
		}
		else
		{
			stc( "Your bond is absent right now.\n\r", ch );
		}
		free_string( tmp2 );
	}
    return;
}
void do_bondwhere( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char *tmp2;
    char buf[MSL];
	if (IS_NPC(ch))
		return;
	if ( ch->pcdata->bonded_to == NULL )
	{
		stc( "You don't seem to be bonded to anyone.\n\r",ch );
		return;
	}
	if (ch->pcdata->bonded_to[0] == '\0')
	{
		stc( "But you're not bonded to anyone.\n\r",ch );
		return;
	}
	if (ch->pcdata->bonded_to[0] != '\0')
	{
		tmp2 = ( str_dup( ch->pcdata->bonded_to ) );
		sprintf( buf,argument );
		if ( ( victim = get_pc_world( ch, tmp2 ) ) != NULL)
		{
			ptc( ch, "%s is near %s", victim->name, victim->in_room->name );
		}
		else
		{
			stc( "Your bond is absent right now.\n\r", ch );
		}
		free_string( tmp2 );
	}
    return;
}
/* marriages */
void do_propose (CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *spouse;
    if ( IS_NPC( ch ) )
        return;
    if ( IS_MARRIED ( ch ) )
    {
        stc( "You are already married, are you planning on cheating?!\n\r",ch );
        return;
    }
    if ( argument[0] == '\0')
    {
        stc("Propose to who?\n\r", ch);
        return;
    }
    if ( ( spouse = get_char_room ( ch, NULL, argument ) ) == NULL )
    {
        stc ( "They aren't here.\n\r", ch );
        return;
    }
    if ( IS_NPC ( spouse ) || spouse == ch )
    {
        stc ( "You can't do that.\n\r", ch );
        return;
    }
    if ( IS_MARRIED ( spouse ) )
    {
        stc( "They are already married I don't think they're interested.\n\r",ch );
        return;
    }
    free_string(ch->pcdata->proposal);
	    ch->pcdata->proposal = str_dup( spouse->name );
    free_string(spouse->pcdata->proposal);
	    spouse->pcdata->proposal = str_dup( ch->name );
    act( "You kneel down and propose marriage to $N.", ch, NULL, spouse, TO_CHAR );
    act( "$n kneels down and proposes marriage to you! Will you consent?", ch, NULL, spouse, TO_VICT );
    act( "$n kneels down and proposes marriage to $N!", ch, NULL, spouse, TO_NOTVICT );
    return;
}
void do_consent (CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *spouse;
    if ( IS_NPC ( ch ) )
        return;
    if ( IS_MARRIED ( ch ) )
    {
        stc( "You are already married, are you planning on cheating?!\n\r",ch );
        return;
    }
    if ( argument[0] == '\0')
    {
        stc("Consent to who?\n\r", ch);
        return;
    }
    if ( ( spouse = get_char_room ( ch, NULL, argument ) ) == NULL )
    {
        stc ( "They aren't here.\n\r", ch );
        return;
    }
    if ( IS_NPC ( spouse ) || spouse == ch )
    {
        stc ( "You can't do that.\n\r", ch );
        return;
    }
    if ( IS_MARRIED ( spouse ) )
    {
        stc( "They are already married I don't think they're interested.\n\r",ch );
        return;
    }
    if ( spouse->pcdata->proposal == NULL || spouse->pcdata->proposal[0] == '\0' )
    {
        stc ( "They haven't proposed to anyone!\n\r", ch );
        return;
    }
/*
    if ( spouse->pcdata->proposal == NULL || spouse->pcdata->proposal[0] == '\0' ||
         str_cmp( spouse->pcdata->spouse, spouse->name ) )
    {
        stc ( "They haven't proposed marriage! How embarrasing!\n\r", ch );
        return;
    }
*/
	if ( !str_cmp( ch->pcdata->proposal, spouse->name )
	&& !str_cmp( spouse->pcdata->proposal, ch->name ) )
	{
	    free_string( ch->pcdata->spouse );
			ch->pcdata->spouse = str_dup( spouse->name );
		free_string( spouse->pcdata->spouse );
			spouse->pcdata->spouse = str_dup( ch->name );
	    act ( "You consent to $N's proposal of marriage!", ch, NULL, spouse,
	          TO_CHAR );
	    act ( "$n consents to your proposal of marriage!", ch, NULL, spouse,
	          TO_VICT );
	    act ( "$n consents to $N's proposal of marriage!", ch, NULL, spouse,
	          TO_NOTVICT );
	    return;
	}
    else
    {
        stc ( "They haven't proposed to anyone to you!\n\r", ch );
        return;
    }
}
void do_marry (CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *vict1, *vict2;
    char arg1[MIL], arg2[MIL];
    char buf[MIL];
    argument = one_argument ( argument, arg1 );
    argument = one_argument ( argument, arg2 );
    if ( arg1[0] == '\0' || arg2[0] == '\0' )
    {
        stc ( "Syntax: marry <husband> <wife>\n\r", ch );
        return;
    }
    if ( !str_cmp( arg1, "unmarry" ) )
    {
		if ( IS_IMMORTAL( ch ) )
		{
		    if ( ( vict1 = get_char_room ( ch, NULL, arg2 ) ) != NULL )
		    {
				stc("Clearing the marriage data.\n\r", ch);
			    REMOVE_BIT ( vict1->spec_flags, SPEC_MARRIED );
			    free_string( vict1->pcdata->spouse );
				vict1->pcdata->spouse = str_dup( "" );
    			refresh_married_list(ch, vict1->name, "NULL");
				compose_title(vict1);
				return;
			}
			else
			{
				stc("Cant find that person.\n\r", ch);
				return;
			}
		}
	}
    if ( ( vict1 = get_char_room ( ch, NULL, arg1 ) ) == NULL ||
         ( vict2 = get_char_room ( ch, NULL, arg2 ) ) == NULL )
    {
        stc ( "They seemed to have gotten cold feet! Where'd they go?\n\r",
                 ch );
        return;
    }
    if ( IS_NPC ( vict1 ) || IS_NPC ( vict2 ) || vict1 == vict2 )
    {
        stc ( "Don't think so.\n\r", ch );
        return;
    }
    if ( vict1->pcdata->spouse == NULL || vict1->pcdata->spouse[0] == '\0' )
    {
        ptc ( ch, "%s hasn't proposed to anyone.\n\r", vict1->name );
        return;
    }
    if ( vict2->pcdata->spouse == NULL || vict2->pcdata->spouse[0] == '\0' )
    {
        ptc ( ch, "%s hasn't proposed to anyone.\n\r", vict2->name );
        return;
    }
    if ( IS_SET ( vict1->spec_flags, SPEC_MARRIED ) )
    {
        ptc ( ch, "%s is already married.. maybe they need a divorce.\n\r",vict1->name );
        return;
    }
    if ( IS_SET ( vict2->spec_flags, SPEC_MARRIED ) )
    {
        ptc ( ch,"%s is already married.. maybe they need a divorce.\n\r",vict2->name );
        return;
    }
    SET_BIT ( vict1->spec_flags, SPEC_MARRIED );
    SET_BIT ( vict2->spec_flags, SPEC_MARRIED );
    act ( "$N pronounces you man and wife!", vict1, NULL, ch, TO_CHAR );
    act ( "$N pronounces you man and wife!", vict2, NULL, ch, TO_CHAR );
    act ( "$t pronounces $n and $N man and wife!", vict1, ch->name ,vict2, TO_NOTVICT );

    sprintf(buf, "{W*{w%s{W*", vict2->name);
    refresh_married_list(ch, vict1->name, buf);
    buf[0]='\0';
    sprintf(buf, "{W*{w%s{W*", vict1->name);
    refresh_married_list(ch, vict2->name, buf);
    compose_title(vict1);
    compose_title(vict2);
    /*
    buf[0]='\0';

	    sprintf( buf,"#{c%s %s and %s were joined in marriage by %s\n\r",
		get_time_string_for_records(),	vict1->name, vict2->name, ch->name );

    record_info("married", buf, ch);
	*/

    return;
}
void do_divorce (CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *vict1, *vict2;
    char arg1[MIL], arg2[MIL];
    argument = one_argument ( argument, arg1 );
    argument = one_argument ( argument, arg2 );
    if ( arg1[0] == '\0' || arg2[0] == '\0' )
    {
        stc ( "Syntax: divorce <husband> <wife>\n\r", ch );
        return;
    }
    if ( ( vict1 = get_char_room ( ch, NULL, arg1 ) ) == NULL ||
         ( vict2 = get_char_room ( ch, NULL, arg2 ) ) == NULL )
    {
        stc ( "They're not here.\n\r", ch );
        return;
    }
    if ( IS_NPC ( vict1 ) || IS_NPC ( vict2 ) || vict1 == vict2 )
    {
        stc ( "Don't think so.\n\r", ch );
        return;
    }
    if ( vict1->pcdata->spouse == NULL || vict1->pcdata->spouse[0] == '\0' ||
         !IS_SET ( vict1->spec_flags, SPEC_MARRIED ) )
    {
        act ( "$N is not married.", ch, NULL, vict1, TO_CHAR );
        return;
    }
    if ( vict2->pcdata->spouse == NULL || vict2->pcdata->spouse[0] == '\0' ||
         !IS_SET ( vict2->spec_flags, SPEC_MARRIED ) )
    {
        act ( "$N is not married.", ch, NULL, vict2, TO_CHAR );
        return;
    }
    REMOVE_BIT ( vict1->spec_flags, SPEC_MARRIED );
    REMOVE_BIT ( vict2->spec_flags, SPEC_MARRIED );
    free_string( vict1->pcdata->spouse );
	vict1->pcdata->spouse = str_dup( "" );
    free_string( vict2->pcdata->spouse );
	vict2->pcdata->spouse = str_dup( "" );
    act ( "$N hands you your divorce papers.", vict1, NULL, ch, TO_CHAR );
    act ( "$N hands you your divorce papers.", vict2, NULL, ch, TO_CHAR );
    act ( "$t hands $n and $N their divorce papers.", vict1, ch->name,
          vict2, TO_NOTVICT );

    refresh_married_list(ch, vict1->name, "NULL");
    compose_title(vict1);
    refresh_married_list(ch, vict2->name, "NULL");
    compose_title(vict2);

    return;
}
void do_spouse(CHAR_DATA *ch, char *argument)
{
    CHAR_DATA *spouse;
    char buf[MSL*2];
    if ( IS_NPC ( ch ) )
        return;
    if ( !IS_MARRIED ( ch ) )
    {
        stc ( "You aren't married!\n\r", ch );
        return;
    }
    if ( argument[0] == '\0' )
    {
        stc ( "Tell your spouse what?\n\r", ch );
        return;
    }
    if ( !str_cmp( argument, "last" ))
    {
	show_channel_logs(ch, "spouse");
	return;
    }

    if ( ( spouse = get_pc_world ( ch, ch->pcdata->spouse ) ) == NULL )
    {
        act ( "You can't find $t.", ch, ch->pcdata->spouse, NULL, TO_CHAR );
        return;
    }

    if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
	argument = makedrunk(argument,ch);

    act( "{wYou confide in $N: {C$t{x", ch, argument, spouse, TO_CHAR );
    act( "{w$N confides in you: {C$t{x", spouse, argument, ch, TO_CHAR );

    sprintf( buf, "{w%s{D:{C %s{x", ch->name, argument);
    add_channel_log("spouse", ch->name, spouse->name, buf );

    return;
}
/* dreamwalkers */
void do_dream( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;
    char arg1[MIL];
    char arg2[MIL];
    char look_buf[MSL];
    char buf[MSL];
    look_buf[0] = '\0';
    argument = one_argument( argument, arg1 );
    if ( IS_NPC(ch) )
    return;
    if (!IS_SET( ch->spec_flags,SPEC_DREAMWALKER ) )
    {
    stc( "You should not meddle in the world of dreams.\n\r", ch );
    return;
    }
	if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
	{
	stc("You're currently in a battle.\n\r",ch);
	return;
	}
	if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
	{
	stc("You're currently in a tourney.\n\r",ch);
	return;
	}
    if ( arg1[0] == '\0' )
    {
    stc( "What do you wish to do in Tel'aran'rhiod?\n\r", ch );
    do_function( ch, &do_dream, "help" );
    return;
    }
    if ( ch->position != POS_SLEEPING )
    {
    stc( "You should be sleeping before entering Tel'aran'rhiod.\n\r", ch );
    return;
    }
    if ( !str_prefix( arg1, "enter" ) )
    {
	    if ( ch->hit < get_maxhit(ch) / 2
	    || ch->stam < get_maxstam(ch) / 2 )
	    {
		stc( "You are too weak to enter Tel'aran'rhiod.\n\r", ch );
		return;
		}
        SET_BIT( ch->spec_flags,SPEC_DREAMING );
        //bugf("Dream (enter) Trying to set %s VR to %d.", ch->name, ch->in_room->vnum );
        ch->pcdata->virtual_room = ch->in_room;
        stc( "You step into the world of dreams.\n\r", ch );
        return;
    }
    if ( !IS_SET( ch->spec_flags,SPEC_DREAMING ) )
    {
    stc( "You must enter Tel'aran'rhiod.\n\r", ch );
    return;
    }
    if ( !ch->pcdata->virtual_room || ch->pcdata->virtual_room == NULL )
    {
	    stc( "An error occured. Resetting your data.\n\r", ch );
        REMOVE_BIT( ch->spec_flags,SPEC_DREAMING );
        do_function( ch, &do_wake, "" );
	    return;
    }
    if ( !str_prefix( arg1, "leave" ) )
    {
        REMOVE_BIT( ch->spec_flags,SPEC_DREAMING );
        if ( ch->pcdata->virtual_room != ch->in_room )
        {
        stc( "You attempt to twist tel'aran'rhiod to suit your needs.\n\r", ch );
        stc( "You step out of the world of dreams and find yourself elsewhere.\n\r", ch );
        }
        else
        {
        stc( "You step out of the world of dreams.\n\r", ch );
        }
        //bug("Dream:: Move to the virtual room.", 0 );
        if ( !ch->pcdata->virtual_room || ch->pcdata->virtual_room == NULL )
        {
	        bug("Dream:: Virtual room is NULL. Aborting.", 0 );
        	return;
		}
        if ( ch->pcdata->virtual_room->vnum != ch->in_room->vnum );
        char_from_room( ch );
        char_to_room( ch, ch->pcdata->virtual_room );
        ch->hit = ch->hit - (ch->hit * 2/100);
        ch->stam = ch->stam - (ch->stam * 2/100);
        do_function( ch, &do_wake, "" );
        return;
    }
    if ( !str_prefix( arg1, "peek" ) )
    {
        CHAR_DATA *victim;
	    argument = one_argument( argument, arg2 );
        if ( arg2[0] == '\0' )
        {
        stc( "Who's dreams do you wish to peek into?\n\r", ch );
        return;
        }
        if ( ( victim = get_char_world( ch, arg2 ) ) == NULL
        || victim->position != POS_SLEEPING
        || IS_NPC(victim) )
        {
	    stc( "You failed.\n\r", ch );
	    return;
        }
        else
        {
        ptc ( ch, "You peek into %s's dreams.\n\r", victim->name );
        ptc ( ch, "%s is a %d times reborn %s", victim->name, victim->pcdata->rebirth, clan_table[victim->clan].name );
        if ( number_percent() / 2 > number_percent() )
            stc( "Your dreams become troubled.\n\r", victim );
        }
    }
    if ( !str_prefix( arg1, "walk" ) )
    {
        ROOM_INDEX_DATA *pRoomIndex = NULL;
        bool can_gate = FALSE;
        int a;
	    argument = one_argument( argument, arg2 );
        if ( arg2[0] == '\0' )
	    {
	    stc("To must specify a memorized room as the location.\n\r",ch);
	    return;
	    }
	    if ( !is_number(arg2) )
	    {
	    stc("You must specify a memorized location.\n\r",ch);
	    return;
	    }
	    a = atoi(arg2);
	    if( a < 0 || a >= MAX_BEACONS )
	    {
	    stc("That number is out of range.\n\r", ch );
	    return;
	    }
	    for( a = 0; a < MAX_BEACONS; a++ )
	    {
    	    pRoomIndex = get_room_index( ch->pcdata->beacons[a] );
	        if ( a == atoi(arg2) )
	        {
	        can_gate = TRUE;
 	        break;
	        }
	    }
	    if (!can_gate || pRoomIndex == NULL)
	    {
	    stc("You can't dreamwalk there.\n\r",ch);
	    return;
	    }
        stc( "You project yourself through the world of dreams.\n\r", ch );
        //bugf("Dream (walk) Trying to set %s VR to %d.", ch->name, pRoomIndex->vnum );
        ch->pcdata->virtual_room = pRoomIndex;
        //bugf("Dream (walk) Set %s VR to %d.", ch->name, pRoomIndex->vnum );
        stc( ch->pcdata->virtual_room->description, ch );
        return;
    }
    if ( !str_prefix( arg1, "list" ) )
    {
        ROOM_INDEX_DATA *pRoomIndex = NULL;
        int a;
        stc( " {wNm {R| {wLocation name{x\n\r" , ch );
        stc( "{W-{w==={R+{w==============={W-{x\n\r" , ch );
        for( a = 0; a < MAX_BEACONS; a++ )
        {
            pRoomIndex = get_room_index( ch->pcdata->beacons[a] );
           sprintf( buf, " {w%2d {R| %s{x\n\r", a,
           ( pRoomIndex == NULL ? "{w({Runused{w){x" : pRoomIndex->name ) );
           stc( buf, ch );
           pRoomIndex = NULL;
           }
           return;
    }
    if ( !str_prefix( arg1, "look" ) )
    {
        stc( "You look around the world of dreams and see.\n\r", ch );
        if ( ch->pcdata->virtual_room->vnum != ch->in_room->vnum )
            stc( ch->pcdata->virtual_room->description, ch );
        else
            stc( ch->in_room->description, ch );
        for ( d = descriptor_list; d != NULL; d = d->next )
        {
            CHAR_DATA *victim;
            victim = d->original ? d->original : d->character;
            if ( d->connected == CON_PLAYING
            && d->character != ch
            && victim->position == POS_SLEEPING )
            {
            stc( victim->name, ch );
            if ( victim->hit < victim->max_hit )
                sprintf( buf, " who looks to be having a fitfull sleep." );
            if ( victim->hit == victim->max_hit )
                sprintf( buf, " who looks to be having a restful sleep." );
            if ( buf[0] != '\0' )
                stc ( buf, ch );
            stc( "\n\r", ch );
            if ( IS_SET( victim->spec_flags,SPEC_DREAMING ) )
            	ptc( ch, "%s is also walking the world of dreams.\n\r", victim->name );
            }
        }
        return;
    }
    if ( !str_prefix( arg1, "talk" ) )
    {
		strcpy( arg2, argument );
        act_new("{b[{WD{Cre{camt{Cal{Wk {c({C$n{c){b]{B:{w '$t'{x",ch,argument,NULL,TO_CHAR,POS_DEAD);
        for ( d = descriptor_list; d != NULL; d = d->next )
        {
	        if ( d->connected == CON_PLAYING
            && !IS_AWAKE(d->character)
            && IS_SET( d->character->spec_flags,SPEC_DREAMING ) )
	        {
            act_new("{b[{WD{Cre{camt{Cal{Wk {c({C$n{c){b]{B:{w '$t'{x",ch,argument,d->character,TO_VICT,POS_DEAD);
	        }
	    }
    return;
    }
    if ( !str_prefix( arg1, "help" ) )
    {
    stc( "You are strong enough to perform the following:\n\r", ch );
    stc( "  +-------------------+\n\r" ,ch );
    stc( "  | Enter        Walk |\n\r" ,ch );
    stc( "  | Look         Peek |\n\r" ,ch );
    stc( "  | Leave        List |\n\r" ,ch );
    stc( "  | Talk              |\n\r" ,ch );
    stc( "  +-------------------+\n\r" ,ch );
    return;
    }
}


void refresh_bonded_list (CHAR_DATA *ch, char *name, char* colourname)
{
	FILE *fp1;	/*in*/
	FILE *fp2;	/*out*/
	bool found=FALSE;
	char data[100];
	char buf[MIL];

	sprintf(buf, "%s\n", name);

	fp1=fopen("../data/bonded.lst", "r");
	fp2=fopen("../data/bonded.tmp", "w");

	if(!fp1 || !fp2)
	{
		bugf("../data/bonded.lst doesn't exist or an error ocurred opening temp file.");
		return;
	}

	while (!feof(fp1))
	{
		data[0]='\0';
		fgets(data, 100, fp1);
		if (data[0]=='#')
		{
			fputs(data, fp2);
			continue;
		}
		if (!strcmp(data, buf))
		{
			found = TRUE;
			if (!strcmp("NULL", colourname))
			{
				ptc(ch, "Successfully removed: %s\n\r", data);
				fgets(data, 100, fp1);
			}
			else
			{
				fputs(data, fp2);
				fprintf(fp2, "%s\n", colourname);
				fgets(data, 100, fp1);
				ptc(ch, "Updated: %s {cto %s{c\n\r", data, colourname);
			}
		}
		else if (data[0]!='\0')
		{
			fputs(data, fp2);
			fgets(data, 100, fp1);
			fputs(data, fp2);
		}
	}

	if (!found && strcmp("NULL", colourname))
	{
		stc("New record added\n\r", ch);
		fprintf(fp2, "%s\n", name);
		fprintf(fp2, "%s\n", colourname);
	}

	fclose (fp1);
	fclose (fp2);

	system( "cp ../data/bonded.tmp ../data/bonded.lst" );
}


void refresh_married_list (CHAR_DATA *ch, char *name, char* colourname)
{
	FILE *fp1;	/*in*/
	FILE *fp2;	/*out*/
	bool found=FALSE;
	char data[100];
	char buf[MIL];

	sprintf(buf, "%s\n", name);

	fp1=fopen("../data/married.lst", "r");
	fp2=fopen("../data/married.tmp", "w");

	if(!fp1 || !fp2)
	{
		bugf("married.lst doesn't exist or error creating temp file");
		return;
	}

	while (!feof(fp1))
	{
		data[0]='\0';
		fgets(data, 100, fp1);
		if (data[0]=='#')
		{
			fputs(data, fp2);
			continue;
		}
		if (!strcmp(data, buf))
		{
			found = TRUE;
			if (!strcmp("NULL", colourname))
			{
				ptc(ch, "Succesfully removed: %s\n\r", data);
				fgets(data, 100, fp1);
			}
			else
			{
				fputs(data, fp2);
				fprintf(fp2, "%s\n", colourname);
				fgets(data, 100, fp1);
				ptc(ch, "Updated: %s {cto %s{c\n\r", data, colourname);
			}
		}
		else if (data[0]!='\0')
		{
			fputs(data, fp2);
			fgets(data, 100, fp1);
			fputs(data, fp2);
		}
	}
	if (!found && strcmp("NULL", colourname))
	{
		stc("New record added\n\r", ch);
		fprintf(fp2, "%s\n", name);
		fprintf(fp2, "%s\n", colourname);
	}
	fclose (fp1);
	fclose (fp2);

	system( "cp ../data/married.tmp ../data/married.lst" );
}

char *get_colour_name(char *name , bool IS_SPOUSE)
{
	FILE *fp1;
	bool found=FALSE;
	char data[100];
	char buf[100];

	sprintf(buf, "%s\n", name);

	if(IS_SPOUSE)
	{
		fp1=fopen("../data/married.lst", "r");
		if(fp1 == NULL)
		{
			bugf("missing data/married.lst");
			return str_dup("NULL");
		}
	}
	else
	{
		fp1=fopen("../data/bonded.lst", "r");
		if(fp1 == NULL)
		{
			bugf("missing data/bonded.lst");
			return str_dup("NULL");
		}
	}

	while (!feof(fp1))
	{
		data[0]='\0';
		fgets(data, 100, fp1);
		if (data[0]=='#')
			continue;
		if (!strcasecmp(data, buf))
		{
			found = TRUE;
			data[0]='\0';
			fgets(data, 100, fp1);
			fclose(fp1);
			return str_dup(data);
		}
		else if (data[0]!='\0')
		{
			fgets(data, 100, fp1);
		}
	}

	fclose (fp1);
	return str_dup("NULL");
}
/* for record stuff to be added later */
#if 0
void record_info (char *tag, char *info, CHAR_DATA *ch)
{
	FILE *fp1;	/*in*/
	char filename[100];

	if (str_cmp(tag, "married") && str_cmp(tag, "guild") && str_cmp(tag, "rank"))
	{
		stc("Sorry we don't do that here.\n\r", ch);
		bugf("Unknown 'record'-tag : %s for info %s", tag, info);
		return;
	}

	if (ch->in_room->area->recordfile == NULL || !str_cmp(ch->in_room->area->recordfile, "none"))
	{
		stc("The action goes unnoticed of any registrar\n\r", ch);
		return;
	}

	sprintf(filename, "../data/records/%s.%s", ch->in_room->area->recordfile, tag);

    if ( ( fp1 = fopen( filename, "a" ) ) == NULL )
    {
        fp1 = fopen( filename, "w" );
    }

	if (!fp1)	return;

	fprintf(fp1, "%s\n", info);

	fclose (fp1);
	stc("A registrar carefully takes notes.\n\r", ch);
	return;
}

void replay_info (char *tag, CHAR_DATA *ch)
{
	if (str_cmp(tag, "married") && str_cmp(tag, "guild") && str_cmp(tag, "rank"))
	{
		stc("Sorry we don't do that here.\n\r", ch);
		return;
	}
	if (ch->in_room->area->recordfile == NULL || !str_cmp(ch->in_room->area->recordfile, "none"))
	{
		bugf("%s tried to consult a recordbook in room %s, the area doesn't have a file tho", ch->name, ch->in_room->area->name);
		stc("{xThis books has been left alone for a long long time,\n\rif entries ever have been made, the ink has faded with time.\n\rNothing can be seen anymore.\n\r", ch);
		return;
	}

	FILE *fp1;
	char filename[100];
	char data[100];
	BUFFER *output;

	sprintf(filename, "../data/records/%s.%s", ch->in_room->area->recordfile, tag);

    if ( ( fp1 = fopen( filename, "r" ) ) == NULL )
    {
        stc("The book has been unused so far, and the pages still await a first entry.\n\r", ch);
        return;
    }

    output = new_buf();

	while (!feof(fp1))
	{
		data[0]='\0';
		fgets(data, 100, fp1);
		if (data[0]!='#')
			continue;
		add_buf(output,data);
	}

	fclose (fp1);

    page_to_char(buf_string(output),ch);

    free_buf(output);

	return;
}

#endif

void show_talents ( CHAR_DATA *ch )
{
	if (WOLF(ch))	stc("{wYou run and fight alongside the wolves.{x\n\r", ch);
	if (SEER(ch))	stc("{wYou are able to see auras around others.{x\n\r", ch);
	if (TAV(ch))	stc("{wThe wheel weaves its pattern around you.{x\n\r", ch);
	if (DREAM(ch))	stc("{wYou can enter Tel'aran'rhiod at will.{x\n\r", ch);
	return;
}

void check_talents( CHAR_DATA *ch )
{
    int chance = 1, tchance;

    if (IS_NPC(ch))
	return;

    chance += ch->pcdata->rebirth;
    chance += calc_remort_tier(ch) * 10;

	show_talents(ch);

    if (number_range(1,1000) > chance)
	return;

    	tchance = number_range(1, 4);
    	if (tchance == 1)
    	{
		stc("{WYou now run and fight alongside the wolves.{x\n\r", ch);
		SET_BIT(ch->spec_flags, SPEC_WOLFBROTHER);
		return;
	}
	else if (tchance == 2)
	{
		stc("{WThe wheel now weaves its pattern around you.{x\n\r", ch);
		SET_BIT(ch->spec_flags, SPEC_TAVEREN);
		return;
	}
	else if (tchance == 3)
	{
		stc("{WYou can now enter Tel'aran'rhiod at will.{x\n\r", ch);
		SET_BIT(ch->spec_flags, SPEC_DREAMWALKER);
		return;
    	}
    	else if (tchance == 4)
    	{
		stc("{WYou are now able to see auras around others.{x\n\r", ch);
		SET_BIT(ch->spec_flags, SPEC_SEER);
		return;
	}
	return;
}

char * get_remort_title(CHAR_DATA *ch)
{
	char *retVal;
	char buf[MSL];
	int chRbi = calc_remort_tier(ch);
	buf[0] = '\0';

	if ( ch->sex == SEX_FEMALE )
		strcat( buf, rbi_table[chRbi].fTitle );
	else
		strcat( buf, rbi_table[chRbi].mTitle );
	retVal = str_dup( buf );
	return retVal;
}
