/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"

int TOURNEY_AREA = 0;
int TOURNEY_FIRST;
CHAR_DATA *warMaster;

void talk_tourney(char *argument)
{
    DESCRIPTOR_DATA *d;
    char buf[MSL];
    CHAR_DATA *original;

    sprintf( buf,"{w[{rTo{Ru{wrn{rey{w]{W:: %s{x\n\r", argument);

    for (d = descriptor_list; d != NULL; d = d->next)
    {
        original = d->original ? d->original : d->character; /* if switched */
        if (original &&  d->connected == CON_PLAYING && IS_SET(d->character->auto_flags,AUTO_TOURNEY) )
            stc( buf , original );

    }
}

/*Now we need a way to let imms talk on it */
void do_tchat( CHAR_DATA *ch, char *argument )
{
    talk_tourney( argument );
    return;
}

void tourney_open( int lower, int upper )
{
	char buf[MSL];
	
	TOURNEY_AREA = 53;
	TOURNEY_FIRST = 3726;

	tourney->open = TRUE;
	tourney->level1 = lower;
	tourney->level2 = upper;
	tourney->timer = 20;

	if ( lower <= 1 && upper <= 50 )
	{
		sprintf( buf,"{wThe {WBeginner's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Beginner's" );
		tourney->lastclass = 1;
		talk_tourney( buf );
	}
	else if ( lower >= 51 && upper <= 100 )
	{
		sprintf( buf,"{wThe {WWarrior's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Warrior's" );
		tourney->lastclass = 2;
		talk_tourney( buf );
	}
	else if ( lower >= 101 && upper <= 150 )
	{
		sprintf( buf,"{wThe {WVeteran's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Veteran's" );
		tourney->lastclass = 3;
		talk_tourney( buf );
	}
	else if ( lower >= 151 && upper <= 200 )
	{
		sprintf( buf,"{wThe {WChampion's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Champion's" );
		tourney->lastclass = 4;
		talk_tourney( buf );
	}
	else if ( lower >= 201 && upper <= 250 )
	{
		sprintf( buf,"{wThe {WDestroyer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Destroyer's" );
		tourney->lastclass = 5;
		talk_tourney( buf );
	}
	else if ( lower >= 251 && upper <= 500 )
	{
		sprintf( buf,"{wThe {WSlayer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Slayer's" );
		tourney->lastclass = 6;
		talk_tourney( buf );
	}
	else if ( lower >= 501 && upper <= 1000 )
	{
		sprintf( buf,"{wThe {Wn'Dore Mordero's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "n'Dore Mordero's" );
		tourney->lastclass = 7;
		talk_tourney( buf );
	}
	else
	{
		sprintf( buf,"{wThe {WFreaky Deeky Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		tourney->tclass = str_dup( "Freaky Deeky" );
		tourney->lastclass = 8;
		talk_tourney( buf );
	}

	sprintf( buf,"{wA Tourney is now open for levels {R%d {r- {R%d{w in the Room of Death!{x\n\r",lower,upper);
	talk_tourney( buf );

	return;
}
void do_topen(CHAR_DATA *ch, char* argument )
{
	int   upper;
	int   lower;
	char  arg1[MIL];
	char  arg2[MIL];
	int   number;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if ( IS_NPC( ch ) ) /*mobs can't open tournies */
	return;

	lower = 0;
	upper = 0;
	number = 0;

	if ( arg1[0] == '\0' || arg2[0] == '\0' )
	{
		stc("Syntax:\n\r",ch);
		stc("TOpen <Lower Level> <Upper Level>\n\r",ch);
		stc("TOpen 1 250 will start a Tourney in the Room of Death for levels 1 to 250.\n\r",ch);
		return;
	}

	if ( is_number( arg1 ) && is_number( arg2 ) )
	{
		lower = atoi( arg1 );
		upper = atoi( arg2 );
	}
	else
	{
		stc("Syntax is: topen <level 1> <level 2>.\n\r", ch );
		return;
	}

	TOURNEY_AREA = 53;
	TOURNEY_FIRST = 3726;
	ptc( ch, "TOURNEY_FIRST set to %d, %d.\n\r", TOURNEY_AREA, TOURNEY_FIRST );
	tourney->open = TRUE;
	tourney->status = 2;
	tourney->level1 = lower;
	tourney->level2 = upper;

	tourney_open( lower, upper );

	/*	
	if ( lower <= 1 && upper <= 50 )
	{
		sprintf( buf,"{wThe {WBeginner's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 51 && upper <= 100 )
	{
		sprintf( buf,"{wThe {WWarrior's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 101 && upper <= 150 )
	{
		sprintf( buf,"{wThe {WVeteran's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 151 && upper <= 200 )
	{
		sprintf( buf,"{wThe {WChampion's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 201 && upper <= 250 )
	{
		sprintf( buf,"{wThe {WDestroyer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 251 && upper <= 500 )
	{
		sprintf( buf,"{wThe {WSlayer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}
	else if ( lower >= 501 && upper <= 1000 )
	{
		sprintf( buf,"{wThe {Wn'Dore Mordero's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
		talk_tourney( buf );
	}

	sprintf( buf,"{wA Tourney is now open for levels {R%d {r- {R%d{w in the Room of Death!{x\n\r",lower,upper);
	talk_tourney( buf );
	*/
	return;
}

/* Now that we've opened a tourney, we need a way to close it */
void do_tclose (CHAR_DATA *ch, char *argument)
{
	char            buf[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;
	AREA_DATA       *pArea;
	int             place;
	int             lvnum;
	int             uvnum;
	int             avnum = TOURNEY_AREA;
	bool            found_area = FALSE;

	if ( IS_NPC( ch ) ) /*Since mobs can't open tournies, let's not let them close tournies*/
	return;

	avnum = TOURNEY_AREA;

	if ( avnum == 0 )
	{
		bugf( "TOURNEY:: Tourney vnum is 0.", 0 );
		return;
	}
   /*actual closing of tournies and scattering of players */

	tourney->open = FALSE;
	sprintf( buf,"The gathering of the gladiators is done!\n\r" );
	talk_tourney( buf );

    for ( pArea = area_first; pArea; pArea = pArea->next )
    {
		if ( pArea->vnum == avnum )
		{
			found_area = TRUE;
			break;
		}
	}
	if ( !found_area )
	{
		bugf( "TOURNEY:: Tourney Area Not Found.", 0 );
		return;
	}
	/*
	lvnum = pArea->min_vnum;
	uvnum = pArea->max_vnum;
	*/
	lvnum = 3726;
	uvnum = 3726;

	TOURNEY_FIRST = lvnum;

	for( ch = char_list; ch; ch = ch->next)
	{
		if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
		{
		if( !IS_SET( ch->war_flags, WAR_PK ) )
			SET_BIT( ch->war_flags, WAR_PK );
		place = number_range(lvnum, uvnum);
		/*location = get_room_index( place );*/
		if ( ( location = get_room_index( place ) ) == NULL )
		{
			bugf( "TOURNEY:: Place (%d) is NULL", place );
			return;
		}
		char_from_room( ch );
		char_to_room( ch, location );
		do_function( ch, &do_visible, "" );
		}
	}

	tourney->running = TRUE;
	return;
}

/*Just in case we need it*/
void do_tstop(CHAR_DATA *ch, char * argument)
{
	char            buf[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;
	int             place;

	if(IS_NPC( ch ) )
	return;
	place = 3001;
	location = get_room_index( place );

	if( !tourney->running && !tourney->open )
	{
		stc( "There is no tourney going on that you can stop.\n\r", ch );
		return;
	}

	sprintf( buf,"{wThe tourney has been stopped!{x\n\r" );
	talk_tourney( buf );

	for(ch = char_list; ch; ch = ch->next )
	{
		if(IS_SET( ch->war_flags, WAR_TOURNEY ) )
		{
			if ( is_fighting(ch) )
			stop_all_fighting( ch );

			REMOVE_BIT( ch->war_flags, WAR_TOURNEY );
			char_from_room( ch );
			char_to_room( ch, location );
		}
	}
	tourney->running = FALSE;
	tourney->open = FALSE;
	tourney->status = 1;
	tourney->timer = -1;
	tourney->tclass = str_dup( "Beginner's" );
	tourney->lastclass = 1;
	return;
}
/*Here's a little tidbit just for fun
 *Add players to tourney regardless of level */
void do_tadd( CHAR_DATA * ch, char * argument )
{
	CHAR_DATA        *victim;
	CHAR_DATA        *rch;
	ROOM_INDEX_DATA  *location;
	int               place;
	char              arg1[MIL];
	char              buf[MSL];

	argument = one_argument(argument, arg1 );

	rch = get_char_world( ch, arg1 );

	if(!tourney->running && !tourney->open )
	{
		stc( "There is no tourney going on at the moment.\n\r", ch );
		return;
	}

	if (arg1[0] == '\0')
	{
		stc( "Add who to the tourney?\n\r", ch );
		return;
	}

	if ( !( victim = get_char_world( ch, arg1 ) ) )
	{
		stc( "They aren't here.\n\r", ch );
		return;
	}

	place = 3726;
	location = get_room_index( place );

	if ( IS_NPC( victim ) )
	{
		stc( "Not on mobs.\n\r", ch );
		return;
	}
	else
	{
		act( "{wGladiator $n has gone to seek glory in the Tourney!{x", victim, NULL, NULL, TO_ROOM );
		char_from_room( victim );
		char_to_room( victim, location );
		act( "{wGladiator $n has arrived in the arena!{x", victim, NULL, NULL, TO_ROOM );
		do_look( victim, "auto" );
		SET_BIT ( victim->war_flags, WAR_TOURNEY );
		sprintf( buf,"{wGladiator %s has joined the tourney!{x\n\r",victim->name );
		talk_tourney( buf );
		victim->stam = get_maxstam(victim);
		victim->hit = get_maxhit(victim);
		sprintf( buf, "{wGladiator %s added to the tourney.\n\r", victim->name );
		stc( buf, ch );
	}
	return;
}
/*Since we can add players...let's be able to remove them
  as well. */
void do_tremove( CHAR_DATA * ch, char * argument )
{
	CHAR_DATA         *victim;
	CHAR_DATA         *rch;
	ROOM_INDEX_DATA   *location;
	int                place = 3001;
	char               buf[MSL];
	char               arg1[MSL];


	argument = one_argument( argument, arg1 );

	rch = get_char_world( ch, arg1 );

	if(!tourney->running && !tourney->open )
	{
		stc( "There is no tourney going on at the moment.\n\r", ch );
		return;
	}

	if (arg1[0] == '\0')
	{
		stc( "Remove who from the tourney?\n\r", ch );
		return;
	}

	if ( !( victim = get_char_world( ch, arg1 ) ) )
	{
		stc( "They aren't here.\n\r", ch );
		return;
	}

	if (IS_NPC( victim ) )
	{
		stc( "Not on mobs.\n\r", ch );
		return;
	}
	else
	{
		REMOVE_BIT( victim->war_flags, WAR_TOURNEY );
		place = ROOM_VNUM_PLAZA;
		location = get_room_index( place );
		sprintf( buf, "%s has removed you from tourney.\n\r", ch->name );
		stc( buf, victim );
		char_from_room( victim );
		char_to_room( victim, location );
		do_look( victim, "auto" );
		sprintf( buf, "%s has been removed from the tourney.\n\r", victim->name );
		stc( buf, ch );
	}
	return;
}

void do_tourney (CHAR_DATA *ch, char * argument)
{
	ROOM_INDEX_DATA             *location;
	char            buf[MSL];
	char arg[MIL];
	int             place = TOURNEY_FIRST;
	char arg1[MIL];
	char arg2[MIL];
	int   upper;
	int   lower;

	argument = one_argument( argument, arg );
	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if (IS_NPC( ch ) )
	return;

	ptc( ch, "Tourney is currently is status %s, class %s. Time till loop: %d.\n\r",
	tourney->status == 1 ? "Idle" : tourney->status == 2 ? "Waiting" : "Running", tourney->tclass, tourney->timer );
	if ( arg[0] != '\0' && ( !str_prefix( arg, "who" ) || !str_prefix( arg, "list" ) ) )
	{
	    DESCRIPTOR_DATA *d;
		stc("{W+- {RCurrent Tourney Participants{W -+{x\n\r",ch);
	    for ( d = descriptor_list; d != NULL; d = d->next )
	    {
			if ( d == NULL || !d || d->connected != CON_PLAYING )
				continue;
			if ( !IS_SET( d->character->war_flags, WAR_TOURNEY ) )
				continue;
			ptc(ch,"{W|{R  %-15s                {W|{x\n\r", d->character->name);
		}
		stc("{W+-                               -+{x\n\r",ch);
		return;

	}
	if ( !str_cmp( arg, "set" ) && IS_IMMORTAL( ch ) )
	{
		tourney->timer = atoi( arg1 );
		tourney->tclass = str_dup( "Beginner's" );
		tourney->level1 = 1;
		tourney->level2 = 50;
		tourney->lastclass = 1;
		tourney->status = 2;
		ptc( ch, "Timer set to %d. All tourney values reset.\n\r", atoi( arg1 ) );
		return;
	}
	if ( !str_cmp( arg, "quit" ) )
	{
		if(!IS_SET( ch->war_flags, WAR_TOURNEY))
		{
			stc( "You aren't in a tourney.\n\r",ch);
			return;
		}
		REMOVE_BIT( ch->war_flags, WAR_TOURNEY );
		place = ROOM_VNUM_PLAZA;
		location = get_room_index( place );
		stc( "You have been removed from the tourney.\n\r", ch );
		char_from_room( ch );
		char_to_room( ch, location );
		do_look( ch, "auto" );
		sprintf( buf, "%s has quit the tourney!\n\r", ch->name );
		talk_tourney( buf );
		return;
	}

	if ( !str_cmp( arg, "close" ) )
	{
		char            buf[MAX_STRING_LENGTH];
		ROOM_INDEX_DATA *location;
		int             place;
		int             lvnum;
		int             uvnum;

		lvnum = 3726;
		uvnum = 3726;

		stc( "Tournies are automated now. Just wait. Type tourney by itself to see the status.\n\r", ch );
		return;
		if ( ch != warMaster && !IS_IMMORTAL( ch ) )
		{
			stc( "You did not call this Tourney.\n\r", ch );
			return;
		}
		tourney->open = FALSE;
		sprintf( buf,"The gathering of the gladiators is done!\n\r" );
		talk_tourney( buf );
		TOURNEY_FIRST = lvnum;

		for( ch = char_list; ch; ch = ch->next)
		{
			if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
			{
				if( !IS_SET( ch->war_flags, WAR_PK ) )
					SET_BIT( ch->war_flags, WAR_PK );
				place = number_range(lvnum, uvnum);
				if ( ( location = get_room_index( place ) ) == NULL )
				{
					bugf( "TOURNEY:: Place (%d) is NULL", place );
					return;
				}
				char_from_room( ch );
				char_to_room( ch, location );
				do_function( ch, &do_visible, "" );
				do_function( ch, &do_look, "auto" );
				stc( "Earn honor in the Arena! Defeat your enemies and win rewards the like of which will make a King envious.\n\r", ch );
			}
		}
		tourney->running = TRUE;
		return;
	}
	if( arg[0] != '\0' && !str_prefix( arg, "open" ) )
	{
		int             range;
		/*if ( IS_IMMORTAL( ch ) )
		{
			stc( "You do not need to pay to open a Tourney, O priviledged one. Just topen a tourney.\n\r", ch );
			return;
		}*/
		stc( "Tournies are automated now. Just wait. Type tourney by itself to see the status.\n\r", ch );
		return;
		if ( tourney->open || tourney->running )
		{
			stc( "Wait till the current tourny is done.\n\r", ch );
			return;
		}
		if ( arg1[0] == '\0' || arg2[0] == '\0' )
		{
			stc( "Syntax: Tourney Open LowerLevel UpperLevel\n\r", ch );
			stc( "Example: Tourney Open 1 50\n\r", ch );
			stc( "It costs 250 quest points to open a Tourney.\n\r", ch );
			return;
		}
		if ( is_number( arg1 ) && is_number( arg2 ) )
		{
			lower = atoi( arg1 );
			upper = atoi( arg2 );
		}
		else
		{
			stc("Syntax is: Tourney Open <level 1> <level 2>.\n\r", ch );
			return;
		}
		if ( lower < 10 )
		{
			stc( "Low range cannot be less than 10.\n\r", ch );
			return;
		}
		range = upper - lower;
		if ( range > 50 || range <= 1 )
		{
			if ( lower >= 250 )
			;
			else
			{
				stc( "Range between lower and upper must be less than or equal to 50 and greater than 1.\n\r", ch );
				return;
			}
		}
		if ( ch->questpoints < 250 )
		{
			stc("It will cost 250 quest points to open a Tourney, which you do not have.\n\r", ch );
			return;
		}
		if ( lower <= 0 || upper >= 1001 )
		{
			stc( "Invalid level range. Try again.\n\r", ch );
			return;
		}
		ch->questpoints -= 250;
		warMaster = ch;
		ptc( ch, "250 QPs deducted and the Tourney for %d %d has begun.\n\r", lower, upper );
		stc( "When the blood is ready to be spilt, type Tourney Close.\n\r", ch );
                logf( "Tourney opened by %s", ch->name );
		tourney->open = TRUE;
		tourney->level1 = lower;
		tourney->level2 = upper;

		if ( lower <= 50 && upper <= 50 )
		{
			sprintf( buf,"{wThe {WBeginner's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 50 && upper <= 100 )
		{
			sprintf( buf,"{wThe {WWarrior's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 100 && upper <= 150 )
		{
			sprintf( buf,"{wThe {WVeteran's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 150 && upper <= 200 )
		{
			sprintf( buf,"{wThe {WChampion's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 200 && upper <= 250 )
		{
			sprintf( buf,"{wThe {WDestroyer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 250 && upper <= 500 )
		{
			sprintf( buf,"{wThe {WSlayer's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}
		else if ( lower >= 500 && upper <= 1000 )
		{
			sprintf( buf,"{wThe {Wn'Dore Mordero's Class{w is called to the {WTourney{w in the {RRoom of Death!{x\n\r");
			talk_tourney( buf );
		}

		sprintf( buf,"{wA Tourney is now open for levels {R%d {r- {R%d{w in the Room of Death!{x\n\r",lower,upper);
		talk_tourney( buf );

		return;
	}

	if ( !str_cmp( arg, "join" ) )
	{
		CHAR_DATA *ach;
		if( tourney->status != 2 )
		{
			stc("There is no tourney currently open. Type tourney to see the current tourney status.\n\r",ch );    	
			return;
		}
        	if ( ch->level < tourney->level1 || ch->level > tourney->level2 )
        	{
			ptc( ch, "You don't fit in the %s class, which is %d - %d.\n\r", tourney->tclass, tourney->level1, tourney->level2 );
			return;
		}

		for( ach = char_list; ach; ach = ach->next)
		{
		    if ( IS_SET( ach->war_flags, WAR_TOURNEY ) )
		    {
	    		if(is_alt_of(ch,ach))
	    		{
			    stc( "You already have an alt in that tourney.\n\r", ch );
			    return;
			}
		    }
	    	}
		if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
			return;

/*			ptc( ch, "Attempting to send you to %d.\n\r", place ); */
		place = 1050;
		location = get_room_index( place );
		if ( is_fighting(ch) )
		{
			stc("Finish the fight first.\n\r", ch);
			return;
		}
		act( "{wGladiator $n has gone to seek glory in the arena.{x", ch, NULL, NULL, TO_ROOM );
		char_from_room( ch);
		char_to_room( ch, location );
		act( "{wGladiator $n has arrived in the arena.{x", ch, NULL, NULL, TO_ROOM );
		do_look(ch, "auto" );
		SET_BIT (ch->war_flags, WAR_TOURNEY );
		sprintf(buf,"{wGladiator %s has joined the Tourney!{x\n\r",ch->name);
		talk_tourney( buf );
		ch->stam = get_maxstam(ch);
		ch->hit = get_maxhit(ch);
	}
	return;
}

