#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "tables.h"
#include "olc.h"
#include "recycle.h"
#include "lookup.h"


bool is_wood args(( OBJ_INDEX_DATA *pObj ));
void clear_obj_values args(( OBJ_INDEX_DATA *pObj ));
bool check_obj args( ( CHAR_DATA *ch, OBJ_INDEX_DATA *pObj ) );

int get_stuff (OBJ_INDEX_DATA *obj, int type)
{
	AFFECT_DATA *af;

	for (af = obj->affected; af != NULL; af = af->next)
	{
		if (type == 1 && af->location != APPLY_WIS)	continue;
		if (type == 2 && af->location != APPLY_INT)	continue;
		if (type == 4 && af->location != APPLY_STR)	continue;
		if (type == 3 && af->location != APPLY_DAMROLL)	continue;

		return af->modifier;
	}

	return 0;
}

void list_mobs (CHAR_DATA *ch, int min, int max)
{
	MOB_INDEX_DATA *mob;
	int j;

	for (j = 1; j <= 32599; j++)
	{
		mob = get_mob_index(j);
		if (mob == NULL)	continue;
		if (mob->count <= 1)	continue;
		if (mob->pShop)		continue;
		if (mob->level > max || mob->level < min)	continue;
		ptc(ch, "Name: %15s   Level: %4d   Count: %d   Area: %s\n\r", mob->short_descr, mob->level, mob->count, mob->area->name
 );
	}
	return;
}


bool set_obj_shit(CHAR_DATA *ch, OBJ_INDEX_DATA *pObj)
/* Dal */
{
	int tmp1, tmp2, tmp3, tmp4, tmp5, mat;
	AFFECT_DATA *pAf;
    bool found = FALSE;

    if ( pObj->affected != NULL )
    {
		pAf = pObj->affected;
		pObj->affected = pAf->next;
		free_affect( pAf );
	}

	pObj->cost = 0;
	pObj->level = 1;
	tmp1 = 2;
	tmp2 = 0;
	tmp3 = 0;
	tmp4 = 0;
	tmp5 = 0;
	if (!strcmp(pObj->material,"unknown"))
	{
		return FALSE;
	}
	for ( mat = 0; material_table[mat].name != NULL; mat++ )
	{
		if ( !str_cmp( pObj->material, material_table[mat].name ) )
		{
			found = TRUE;
			if ( material_table[mat].weapon == 0 && pObj->item_type == ITEM_WEAPON )
			{
				return FALSE;
			}
			if ( pObj->item_type == ITEM_ARROW && !is_wood( pObj ) )
	        {
	       	return FALSE;
			}
			if ( pObj->item_type == ITEM_WEAPON )
			{
				tmp2 = material_table[mat].value * 10;
				tmp3 = material_table[mat].density;
				tmp4 = material_table[mat].density * 2;
				tmp5 = material_table[mat].weapon * 5;
			}
			if ( pObj->item_type == ITEM_ARMOR )
			{
				tmp2 = material_table[mat].value * 12;
				if (IS_SET(pObj->extra_flags,ITEM_REMORT))
	   				tmp2 *= 2;
			}
			break;
		}
	}
	if ( !found )
	{
		return FALSE;
	}
	switch ( pObj->item_type )
	{
		default:
			pObj->weight = material_table[mat].density;
   			pObj->cost = material_table[mat].value * material_table[mat].density;
			if (pObj->weight <= 0) {
				pObj->weight = 1;
			}
		break;
		case ITEM_KEYRING:
			pObj->value[0] = 0;
			pObj->value[1] = 0;
			pObj->value[2] = 0;
			pObj->value[3] = 0;
			pObj->value[4] = 0;
   			pObj->cost = 1000;
			pObj->weight = material_table[mat].density;
		break;
		case (ITEM_ANGREAL_MALE): case (ITEM_ANGREAL_FEMALE):
			pObj->value[1] = material_table[mat].density;
   			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->weight = material_table[mat].density;
		break;
        case ITEM_SCROLL:
        case ITEM_POTION:
        case ITEM_PILL:
			pObj->cost = (pObj->value[0] * pObj->value[0]) / 2;
			if ( pObj->cost < 20 )
				pObj->cost = 20;
			pObj->weight = material_table[mat].density;
		break;
		case (ITEM_JOURNAL):
			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->weight = 10 + material_table[mat].density;
		break;
		case (ITEM_LIGHT):
			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->weight = material_table[mat].density;
			pObj->value[2] = material_table[mat].value * 10;
		break;
		case (ITEM_ARROW):
			pObj->cost = material_table[mat].value * material_table[mat].density / 10;
			pObj->weight = material_table[mat].density / 10;
			pObj->value[1] = 2;
			pObj->value[2] = material_table[mat].value * 10;
		break;
		case (ITEM_FOOD):
			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->weight = material_table[mat].density;
			pObj->value[0] = tmp1 / 2;
			pObj->value[1] = tmp1 / 2;
		break;
		case (ITEM_FIREOIL):
			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->value[0] = 5;
			pObj->value[2] = tmp1;
			pObj->weight = material_table[mat].density;
		break;
		case (ITEM_QUIVER):
   			pObj->value[0] = tmp1 / 2;
   			pObj->value[1] = 1;
   			pObj->value[2] = tmp1;
   			pObj->cost = material_table[mat].value * material_table[mat].density;
			pObj->weight = material_table[mat].density;
   		break;

     	case (ITEM_WEAPON):
        if (pObj->value[0] == (WEAPON_SWORD))
        {
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "slice" );
		else	pObj->value[3] = attack_lookup( "slash" );
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
   			pObj->value[2] = (tmp1 / 4) + 7 + tmp5;
   			if (pObj->value[2] == 0)
   			{ pObj->value[2] = 1; }
   			pObj->cost = 15 + tmp2;
			pObj->weight = 4 + material_table[mat].density;
    		break;
		}
       	else if (pObj->value[0] == (WEAPON_EXOTIC))
       	{
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "fury" );
		else	pObj->value[3] = attack_lookup( "wrath" );

        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
   			pObj->value[2] = (tmp1 / 5) + 5 + tmp5;
   			if (pObj->value[2] == 0)
   			{ pObj->value[2] = 1; }
   			pObj->cost = 10 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
       	else if (pObj->value[0] == (WEAPON_DAGGER))
	    {
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "stab" );
		else	pObj->value[3] = attack_lookup( "pierce" );

        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 6) + 4 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 2 + tmp2;
			pObj->weight = 1 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == (WEAPON_SPEAR)
	    || pObj->value[0] == (WEAPON_STAFF))
	    {

		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "stab" );
		else	pObj->value[3] = attack_lookup( "fury" );
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.5) + 7 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 1 + tmp2;
			pObj->weight = 4 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == (WEAPON_MACE))
	    {
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "pound" );
		else	pObj->value[3] = attack_lookup( "smash" );
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.5) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 12 + tmp2;
			pObj->weight = 12 + material_table[mat].density;
		    break;
		}
	   	else if (pObj->value[0] == (WEAPON_AXE))
	   	{
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "cleave" );
		else	pObj->value[3] = attack_lookup( "chop" );
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 3.5) + 8 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 10 + tmp2;
			pObj->weight = 7 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == (WEAPON_FLAIL))
	    {
		if (number_percent() <= 50)
			pObj->value[3] = attack_lookup( "pound" );
		else	pObj->value[3] = attack_lookup( "crush" );
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 5) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 5 + tmp2;
			pObj->weight = 6 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == (WEAPON_WHIP))
	    {

			pObj->value[3] = attack_lookup( "whip" );

        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 7) + 3 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 1 + tmp2;
			pObj->weight = 2 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == (WEAPON_POLEARM))
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4) + 7 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 5 + tmp2;
			pObj->weight = 9 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_SHORTBOW)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 7 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 30 + tmp2;
			pObj->weight = 2 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_LONGBOW)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 8 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 100 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_RECURVEDBOW)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 9 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 100 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_COMPOSITEBOW)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 10 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 100 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_CROSSBOW)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 11 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 50 + tmp2;
			pObj->weight = 9 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_NET)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 7) + 3 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 20 + tmp2;
			pObj->weight = 10 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_HAMMER)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.5) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 12 + tmp2;
			pObj->weight = 8 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_SLING)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 6) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 2 + tmp2;
			pObj->weight = 2 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_SWORDBREAKER)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.2) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 25 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_SAP)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 5.5) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 2 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_SHORTSWORD)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.5) + 7 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 10 + tmp2;
			pObj->weight = 3 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_LANCE)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4.5) + 7 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 10 + tmp2;
			pObj->weight = 10 + material_table[mat].density;
		    break;
		}
	    else if (pObj->value[0] == WEAPON_ASHANDAREI)
	    {
        	if ( !check_obj( ch, pObj ) )
	        	return FALSE;
			if (!IS_SET(pObj->extra_flags,ITEM_REMORT))
   				pObj->value[1] = 1;
   			else
   				pObj->value[1] = 2;
			pObj->value[2] = (tmp1 / 4) + 6 + tmp5;
			if (pObj->value[2] == 0)
			{ pObj->value[2] = 1; }
   			pObj->cost = 80 + tmp2;
			pObj->weight = 15 + material_table[mat].density;
		    break;
		}
	    else
	    {
		    break;
		}
	   	case (ITEM_ARMOR):
		   	if (CAN_WEAR(pObj, ITEM_WEAR_SHIELD))
		   	{
				pObj->value[0] = material_table[mat].pierce + 18;
				pObj->value[1] = material_table[mat].bash + 18;
				pObj->value[2] = material_table[mat].slash + 18;
				pObj->value[3] = material_table[mat].weaves + 18;
	   			pObj->cost = material_table[mat].value * 9;
	   			pObj->weight = 18 + material_table[mat].density;
				break;
			}
		   	else if (CAN_WEAR(pObj, ITEM_WEAR_BODY))
		   	{
				pObj->value[0] = material_table[mat].pierce + 20;
				pObj->value[1] = material_table[mat].bash + 20;
				pObj->value[2] = material_table[mat].slash + 20;
				pObj->value[3] = material_table[mat].weaves + 20;
	   			pObj->cost = material_table[mat].value * 10;
	   			pObj->weight = 20 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_WAIST)
			|| CAN_WEAR(pObj, ITEM_HOLD)
			|| CAN_WEAR(pObj, ITEM_WEAR_BACK)
			|| CAN_WEAR(pObj, ITEM_WEAR_HEAD)
			|| CAN_WEAR(pObj, ITEM_WEAR_FOREARM)
			|| CAN_WEAR(pObj, ITEM_WEAR_THIGH)
			|| CAN_WEAR(pObj, ITEM_WEAR_CALF)
			|| CAN_WEAR(pObj, ITEM_WEAR_WRIST)
			|| CAN_WEAR(pObj, ITEM_WEAR_ABOUT)
			|| CAN_WEAR(pObj, ITEM_WEAR_NECK)
			|| CAN_WEAR(pObj, ITEM_WEAR_ARMS)
			|| CAN_WEAR(pObj, ITEM_WEAR_HANDS)
			|| CAN_WEAR(pObj, ITEM_WEAR_FEET)
			|| CAN_WEAR(pObj, ITEM_WEAR_LEGS) )
		   	{
				pObj->value[0] = material_table[mat].pierce + 8;
				pObj->value[1] = material_table[mat].bash + 8;
				pObj->value[2] = material_table[mat].slash + 8;
				pObj->value[3] = material_table[mat].weaves + 8;
	   			pObj->cost = material_table[mat].value * 4;
	   			pObj->weight = 8 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_SHOULDERS))
		   	{
				pObj->value[0] = material_table[mat].pierce + 12;
				pObj->value[1] = material_table[mat].bash + 12;
				pObj->value[2] = material_table[mat].slash + 12;
				pObj->value[3] = material_table[mat].weaves + 12;
	   			pObj->cost = material_table[mat].value * 6;
	   			pObj->weight = 12 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_NOSE)
			|| CAN_WEAR(pObj, ITEM_WEAR_EYES))
		   	{
				pObj->value[0] = material_table[mat].pierce + 2;
				pObj->value[1] = material_table[mat].bash + 2;
				pObj->value[2] = material_table[mat].slash + 2;
				pObj->value[3] = material_table[mat].weaves + 2;
	   			pObj->cost = material_table[mat].value;
	   			pObj->weight = 2 + material_table[mat].density;
				break;
			}
	        else if (CAN_WEAR(pObj, ITEM_WEAR_FLOAT))
		   	{
				pObj->value[0] = material_table[mat].pierce + 1;
				pObj->value[1] = material_table[mat].bash + 1;
				pObj->value[2] = material_table[mat].slash + 1;
				pObj->value[3] = material_table[mat].weaves + 1;
	   			pObj->cost = material_table[mat].value;
	   			pObj->weight = 1 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_EAR)
			|| CAN_WEAR(pObj,ITEM_WEAR_FINGER))
		   	{
				pObj->value[0] = material_table[mat].pierce + 1;
				pObj->value[1] = material_table[mat].bash + 1;
				pObj->value[2] = material_table[mat].slash + 1;
				pObj->value[3] = material_table[mat].weaves + 1;
	   			pObj->cost = material_table[mat].value;
	   			pObj->weight = 2 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_ANKLE))
		   	{
				pObj->value[0] = material_table[mat].pierce + 2;
				pObj->value[1] = material_table[mat].bash + 2;
				pObj->value[2] = material_table[mat].slash + 2;
				pObj->value[3] = material_table[mat].weaves + 2;
	   			pObj->cost = material_table[mat].value * 2;
	   			pObj->weight = 2 + material_table[mat].density;
				break;
			}
			else if (CAN_WEAR(pObj, ITEM_WEAR_FACE))
		   	{
				pObj->value[0] = material_table[mat].pierce + 3;
				pObj->value[1] = material_table[mat].bash + 3;
				pObj->value[2] = material_table[mat].slash + 3;
				pObj->value[3] = material_table[mat].weaves + 3;
	   			pObj->cost = material_table[mat].value * 2;
	   			pObj->weight = 2 + material_table[mat].density;
				break;
			}
		    else
		    {
			    break;
			}
		}
	    return FALSE;
}



bool check_room_exits (ROOM_INDEX_DATA *room)
{
	int door;

	for (door = 0; door < MAX_DIR; door++)
		if (room->exit[door] != NULL)	return TRUE;

	return FALSE;
}


void list_areacrops(CHAR_DATA *ch)
{
	AREA_DATA *area;
	//ROOM_INDEX_DATA *room;
	int x;
	BUFFER *buffer = new_buf();
	char buf[MSL];
	int save = 0;

	/* Go through each area.. */
	for (area = area_first; area != NULL; area = area->next)
	{
		/******************************************************
		* Find what the highest vnum it could be cropped to..
		******************************************************/
		/* starting with the upper vnum of the area, search backwards until we find a valid room/object/or mob.. */

		for (x = area->max_vnum; x > area->min_vnum; x--)
		{
			if (get_room_index(x) != NULL
			&& check_room_exits(get_room_index(x))
			&& str_cmp("", get_room_index(x)->name))	break;
			if (get_mob_index(x) != NULL)			break;
			if (get_room_index(x) != NULL)			break;
		}

		if (x == area->max_vnum || x == area->min_vnum || get_room_index(x) == NULL)
			continue;

		sprintf(buf, "{wLooking at %s (%ld - %ld)\n\r", area->name, area->min_vnum, area->max_vnum);
		add_buf(buffer, buf);

		sprintf(buf, "{D -> {YCould be cropped at: %d, saving %ld vnums.\n\r", x, area->max_vnum - x);
		add_buf(buffer, buf);
		save += area->max_vnum - x;
	}

	ptc(ch, "You could save %d vnums by cropping these.\n\r", save);

	page_to_char(buf_string(buffer), ch);
	free_buf(buffer);
	return;
}


void do_trainerdump (CHAR_DATA *ch, char *argument)
{
	AREA_DATA *area;
	long vnum;
	OBJ_INDEX_DATA *pObj;
	OBJ_DATA *owhere;
	char buf[MSL];
	BUFFER *buffer = new_buf();
	AFFECT_DATA *af;
	bool summary = FALSE;
	char arg[MSL];
	int cnt;
	int lvl;
	int area_vnum;

	argument = one_argument(argument, arg);

	if (arg[0] == '\0' || !str_cmp(arg, "list"))
		summary = TRUE;

	if (is_number(arg))	area_vnum = atoi(arg);
	else
	{
		area_vnum = 1;
		summary = TRUE;
	}

	for (area = area_first; area != NULL; area = area->next)
	{
		cnt = 0;
		lvl = 0;

		if (!summary && area_vnum != area->vnum)		continue;

		for (vnum = area->min_vnum; vnum <= area->max_vnum; vnum++)
		{
			if ((pObj = get_obj_index(vnum)) == NULL)	continue;
			if (pObj->affected == NULL)			continue;

			sprintf(buf, "%ld", pObj->vnum);
			owhere = get_obj_by_vnum(ch, buf);
			if (owhere == NULL)					continue;
			if (owhere->carried_by == NULL)				continue;
			if (owhere->carried_by->pIndexData == NULL)		continue;
			if (owhere->carried_by->pIndexData->pShop != NULL)	continue;

			cnt++;
			lvl += owhere->carried_by->level;

			if (cnt == 1 && !summary)
			{
				add_buf(buffer, "{D       -----------------------------------------------------\n\r");
				sprintf(buf, "{D       -------- {WAREA NAME: %23s  {D--------\n\r", area->name);
				add_buf(buffer, buf);
				add_buf(buffer, "{D       -----------------------------------------------------\n\r\n\r");
			}

			if (summary)	continue;

			sprintf(buf, " {D-> {x%s, dropped by %s [%d]. ", pObj->short_descr,
			owhere->carried_by->short_descr, owhere->carried_by->level);
			add_buf(buffer, buf);

			for (af = pObj->affected; af != NULL; af = af->next)
			{
				sprintf(buf, "{WBonus to %s. ", affect_loc_name(af->location));
				add_buf(buffer, buf);
			}

			add_buf(buffer, "\n\r");
		}

		if (summary)
		{
			if (cnt <= 0)	continue;
			lvl = lvl / cnt;

			sprintf(buf, " {D-> [{C%3d{D] {x%20s, average level of {W%d{x. {W%d {xdroppable items.\n\r",
			area->vnum, area->name, lvl, cnt);
			add_buf(buffer, buf);
		}
		else if (cnt <= 0)
		{
			add_buf(buffer, "There are no items in this area or the area is not valid.\n\r");
		}
	}

	page_to_char(buf_string(buffer),ch);
	return;
}



bool has_exits args((ROOM_INDEX_DATA *pRoom));

void do_trainerdump_old( CHAR_DATA *ch, char *argument )
{
//	OBJ_INDEX_DATA *obj;
	ROOM_INDEX_DATA *room;
//	OBJ_DATA *owhere;
	long j;
	int cnt = 0;
//	AFFECT_DATA *pAf;
//	int v0, v3, v4;

	if ( !IS_IMMORTAL( ch ) )
	{
		return;
	}

//	list_areacrops(ch);
//	return;

//	list_mobs(ch, 500, 700);
//	return;

//	show_all_droppable_objects (ch, argument);
	return;

	for (j = 1; j <= 32599; j++)
	{
//		obj = get_obj_index(j);
//		if (obj == NULL)						continue;

		room = get_room_index(j);
		if (room == NULL)						continue;

//		if (has_exits(room))		continue;
		if (room->reset_first != NULL)	continue;
		if (str_cmp(room->name, ""))	continue;

//		free_room(room);

		cnt++;

//		if (is_arg_clan(obj->guild))					continue;
/*		if (str_cmp(obj->guild, "Deathwatch")
		&& str_cmp(obj->guild, "Seanchan")
		&& str_cmp(obj->guild, "Morat")
		&& str_cmp(obj->guild, "Suldam")
		&& str_cmp(obj->guild, "Blood")
		&& str_cmp(obj->guild, "Sojhin")
		&& str_cmp(obj->guild, "Hailene")
		&& str_cmp(obj->guild, "Seeker"))
				continue;
*/
/*		if (obj->item_type != ITEM_ARMOR)
			continue;

		owhere = get_obj_world(ch, obj->name);
		if (owhere == NULL)						continue;
		if (owhere->carried_by == NULL)					continue;
		if (owhere->carried_by->pIndexData == NULL)			continue;
		if (owhere->carried_by->pIndexData->pShop != NULL)		continue;
*/
//		if (!str_cmp(obj->guild, "Seafolk"))	continue;
//		if (!str_cmp(obj->guild, "Stump"))	continue;
//		if (!str_cmp(obj->guild, "Dragonsworn"))	continue;


//		ptc(ch, "%5d: %s - Clan %s\n\r", obj->vnum, obj->short_descr, obj->guild);
/*
		if (!str_cmp(obj->guild, "0")
		|| !str_cmp(obj->guild, "copper")
		|| !str_cmp(obj->guild, "silver")
		|| !str_cmp(obj->guild, "gold")
		|| !str_cmp(obj->guild, "meat")
		|| !str_cmp(obj->guild, "wood")
		|| !str_cmp(obj->guild, "fruit")
		|| !str_cmp(obj->guild, "bread")
		|| !str_cmp(obj->guild, "steel")
		|| !str_cmp(obj->guild, "food")
		|| !str_cmp(obj->guild, "lumps")
		|| !str_cmp(obj->guild, "")
		|| !str_cmp(obj->guild, "manetheren")
		|| !str_cmp(obj->guild, "cheese")
		|| !str_cmp(obj->guild, "sackcloth")
		|| !str_cmp(obj->guild, "oak")
		|| !str_cmp(obj->guild, "raerbit")
		|| !str_cmp(obj->guild, "energy")
		|| !str_cmp(obj->guild, "unknown"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Loner");
		}

		if (!str_cmp(obj->guild, "kobal")
		|| !str_cmp(obj->guild, "dhavol"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Trolloc");
		}

		if (!str_cmp(obj->guild, "tinker")
		|| !str_cmp(obj->guild, "covenant"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Crafters");
		}

		if (!str_cmp(obj->guild, "empress"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Blood");
		}

		if (!str_cmp(obj->guild, "moratraken"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Morat");
		}
*/
/*
		if (!str_cmp(obj->guild, "TheSpear")
		|| !str_cmp(obj->guild, "thespear"))
		{
			free_string(obj->guild);
			obj->guild = str_dup("Aiel");
			SET_BIT(obj->area->area_flags, AREA_CHANGED);
		}
*/
//		if (get_stuff(obj, 4) >= 1)	ptc(ch, "%5d: %s - %d STR\n\r", obj->vnum, obj->short_descr, get_stuff(obj, 4));
//		if (get_stuff(obj, 2) >= 15)	ptc(ch, "%5d: %s - %d INT\n\r", obj->vnum, obj->short_descr, get_stuff(obj, 2));

/*		if (get_stuff(obj, 3) >= 16)
		{
			cnt++;
			if (cnt > 50)		break;
			ptc(ch, "%5d: %s - %d DR\n\r", obj->vnum, obj->short_descr, get_stuff(obj, 3));
		}
*/

//	ptc(ch, "Setting '%s'.\n\r", obj->name);

/*
	v0 = obj->value[0];
	v3 = obj->value[3];
	v4 = obj->value[4];
*/
/*
	free_string( obj->material );
	obj->material = str_dup("hard metal");
	obj->condition = 100;
//	SET_BIT(obj->extra_flags,ITEM_REMORT);
	clear_obj_values( obj );
*/
/*
	obj->value[0] = v0;
	obj->value[3] = v3;
	obj->value[4] = v4;

	set_obj_shit(ch, obj);

    pAf             =   new_affect();
    pAf->location   =   APPLY_DAMROLL;
    pAf->modifier   =   17;
    pAf->where	    =   TO_OBJECT;
    pAf->type       =   -1;
    pAf->duration   =   -1;
    pAf->bitvector  =   0;
    pAf->level      =	1;
    pAf->next       =   obj->affected;
    obj->affected  =   pAf;
    obj->cost      =   17 * obj->cost;
*/

	}
	ptc( ch, "Loop killed at vnum {r%ld{x. Counted %d matches.\n\r", j, cnt );
	return;
}

