/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aww.h"
#include "recycle.h"
#include "interp.h"
#include "magic.h"

DECLARE_DO_FUN(do_yell		);
DECLARE_DO_FUN(do_sleep		);
DECLARE_DO_FUN(do_sit		);
DECLARE_DO_FUN(do_bash_door	);
DECLARE_DO_FUN(do_throw_spear	);

DECLARE_SPELL_FUN(	spell_poison	);
DECLARE_SPELL_FUN(	spell_blindness	);

bool    is_obj_char_clan args( ( CHAR_DATA *ch, OBJ_DATA *obj) );
void	one_hit		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt ,bool secondary) );
/*void	set_fighting	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );*/
bool	remove_obj	args( (CHAR_DATA *ch, int iWear, bool fReplace ) );
bool	check_dodge	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool	check_parry	args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    check_shield_block     args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
OBJ_DATA *make_special args(( OBJ_DATA *fObj ));

int get_hand_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_HANDS );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}

int get_foot_protection( CHAR_DATA *ch )
{
	OBJ_DATA *obj;

	obj = get_eq_char( ch, WEAR_FEET );

	if ( obj == NULL )
		return 0;
	else
	{
		if ( obj->item_type == ITEM_ARMOR )
			return obj->value[0];
	}
	return 0;
}

void do_punch( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, skill = 0, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
	    if ( get_skill( ch, gsn_punch ) == 0 )
	    {
		if ( get_skill( ch, gsn_hand_to_hand) == 0 )
		{
		    stc("You dont know how to punch.\n\r",ch);
		    return;
		}
	    }
	}

	race_chk = get_hand_protection( ch );

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	chance = number_range(1,100);
	if ( get_skill( ch,gsn_punch) == 0 && get_skill(ch, gsn_hand_to_hand) > 0)
		skill = get_skill(ch, gsn_hand_to_hand);
	else if (get_skill( ch,gsn_punch) > 0)
		skill = get_skill(ch, gsn_punch);
    WAIT_STATE( ch, skill_table[gsn_punch].beats );
    if (skill+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		if ( get_skill( ch, gsn_punch ) == 0 && get_skill( ch, gsn_hand_to_hand ) > 0 )
		{
		    damage(ch,victim,number_range(1,race_chk),gsn_hand_to_hand, DAM_BASH, TRUE);	
		}
		else
		{ 
		    damage(ch,victim,number_range(1,race_chk),gsn_punch,DAM_BASH,TRUE);
		    check_improve(ch,gsn_punch,TRUE,3);
		}
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_punch,DAM_BASH,TRUE);
		check_improve(ch,gsn_punch,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_sidekick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_sidekick ) == 0 )
	    {
			stc("You dont know how to side kick.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_hand_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_sidekick].beats );
    if (get_skill(ch,gsn_sidekick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_sidekick,DAM_BASH,TRUE);
		check_improve(ch,gsn_sidekick,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_sidekick,DAM_BASH,TRUE);
		check_improve(ch,gsn_sidekick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_jumpkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_jumpkick ) == 0 )
	    {
			stc("You dont know how to jump kick.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_hand_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_jumpkick].beats );
    if (get_skill(ch,gsn_jumpkick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_jumpkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_jumpkick,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_jumpkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_jumpkick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_leapkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_leapkick ) == 0 )
	    {
			stc("You dont know how to leap kick.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_hand_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_leapkick].beats );
    if (get_skill(ch,gsn_leapkick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_leapkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_leapkick,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_leapkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_leapkick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_headbutt( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_headbutt ) == 0 )
	    {
			stc("You dont know how to head butt.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_head_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_headbutt].beats );
    if (get_skill(ch,gsn_headbutt)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_headbutt,DAM_BASH,TRUE);
		check_improve(ch,gsn_headbutt,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_headbutt,DAM_BASH,TRUE);
		check_improve(ch,gsn_headbutt,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_elbow( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_elbow ) == 0 )
	    {
			stc("You dont know how to elbow .\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_arm_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_elbow].beats );
    if (get_skill(ch,gsn_elbow)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_elbow,DAM_BASH,TRUE);
		check_improve(ch,gsn_elbow,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_elbow,DAM_BASH,TRUE);
		check_improve(ch,gsn_elbow,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_knee( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_knee ) == 0 )
	    {
			stc("You dont know how to knee.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_leg_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_knee].beats );
    if (get_skill(ch,gsn_knee)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_knee,DAM_BASH,TRUE);
		check_improve(ch,gsn_knee,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_knee,DAM_BASH,TRUE);
		check_improve(ch,gsn_knee,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_legsweep( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_legsweep ) == 0 )
	    {
			stc("You dont know how to legsweep.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_foot_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_legsweep].beats );
    if (get_skill(ch,gsn_legsweep)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_legsweep,DAM_BASH,TRUE);
		check_improve(ch,gsn_legsweep,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_legsweep,DAM_BASH,TRUE);
		check_improve(ch,gsn_legsweep,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_hookkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_hookkick ) == 0 )
	    {
			stc("You dont know how to hook kick.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	race_chk = get_foot_protection( ch );

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_hookkick].beats );
    if (get_skill(ch,gsn_hookkick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_hookkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_hookkick,TRUE,3);
		check_improve(ch,gsn_hand_to_hand,TRUE,3);
    }
    else
    {
		damage( ch, victim, 0, gsn_hookkick,DAM_BASH,TRUE);
		check_improve(ch,gsn_hookkick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_spinkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;

    /*if ( !IS_NPC(ch)
    &&   ch->level < skill_table[gsn_spinkick].skill_level[ch->class] )
    {
	stc("{cYou better leave the martial arts to fighters.\n\r", ch );
	return;
    }*/

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_spinkick ) <= 0 )
	    {
			stc("You dont know how to spin spin kick.\n\r",ch);
			return;
	    }
	}

    if ( !is_fighting(ch) || ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them , they are not in melee.\n\r", ch );
	return;
    }

	stc( "{wYou spin in an arc on your heel and kick.\n\r", ch );
	act("{w$n spins in an arc on $s heel in a kick.",ch,0,0,TO_ROOM);
    WAIT_STATE( ch, skill_table[gsn_kick].beats*1.5 );
    if (get_skill(ch,gsn_spinkick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_INS] / 3
    > number_percent())
    {
	damage(ch,victim,number_range( 1, ch->level+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_STR]),
	gsn_spinkick,DAM_BASH,TRUE);
	check_improve(ch,gsn_spinkick,TRUE,5);
    }
    else
    {
	damage( ch, victim, 0, gsn_spinkick,DAM_BASH,TRUE);
	check_improve(ch,gsn_spinkick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_sweepkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;

    /*if ( !IS_NPC(ch)
    &&   ch->level < skill_table[gsn_sweepkick].skill_level[ch->class] )
    {
	stc("{cYou better leave the martial arts to fighters.\n\r", ch );
	return;
    }*/

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;
	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_sweepkick ) <= 0 )
	    {
			stc("You dont know how to sweep kick.\n\r",ch);
			return;
	    }
	}

    if ( !is_fighting(ch) || ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them , they are not in melee.\n\r", ch );
	return;
    }

	act( "{wYou try and kick $N's heels out from under $M.\n\r", ch,0,victim,TO_CHAR );
	act("{w$n kicks at $N's heels in a sweeping arc.",ch,0,victim,TO_ROOM);
    WAIT_STATE( ch, skill_table[gsn_kick].beats*1.5 );
    if (get_skill(ch,gsn_sweepkick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_DEX] / 3
    > number_percent())
    {
	if (victim->position == POS_RESTING)
		stc("Your victim is already prone. But you kick them anyway.\n\r",ch);
	else
	{
		act( "{wYou send $N sprawling!\n\r", ch,0,victim,TO_CHAR );
		act("{w$n sends $N sprawling!",ch,0,victim,TO_ROOM);
		victim->position = POS_RESTING;
	}
	damage(ch,victim,number_range( 1, ch->level+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_INS]),
	gsn_spinkick,DAM_BASH,TRUE);
	check_improve(ch,gsn_sweepkick,TRUE,5);
    }
    else
    {
	damage( ch, victim, 0, gsn_spinkick,DAM_BASH,TRUE);
	check_improve(ch,gsn_sweepkick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}

void do_kick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    int race_chk, chance, bonus = 0;

    if (IS_NPC(ch) && !IS_SET(ch->off_flags,OFF_KICK))
	return;

	if ( !IS_NPC( ch ) )
	{
		if ( get_skill( ch, gsn_kick ) == 0 )
	    {
			stc("You dont know how to kick.\n\r",ch);
			return;
	    }
	}

    if (!is_fighting(ch) ||  ( victim = ch->advancing_on ) == NULL )
    {
	stc( "{cYou aren't fighting anyone.\n\r", ch );
	return;
    }
    if ( ch->range < RANGE_MELEE )
    {
	stc( "{cYou cannot hit them, they are not in melee.\n\r", ch );
	return;
    }

	if ((ch->race == race_lookup( "trolloc")
	|| ch->race == race_lookup( "ogier")
	|| !IS_SET(ch->op_flags,OP_CHANNELER)))
		race_chk = ch->level + 15;
    else
		race_chk = ch->level;

	chance = number_range(1,100);
    WAIT_STATE( ch, skill_table[gsn_kick].beats );
    if (get_skill(ch,gsn_kick)+ch->mod_stat[STAT_REF]+ch->mod_stat[STAT_INS] / 3 > number_percent())
    {
		if ( get_skill( ch, gsn_hand_to_hand ) == 0 )
			race_chk += 1;
		else
		{
			if ( !IS_NPC(ch) )
				bonus = ch->pcdata->learned[gsn_hand_to_hand];
			else if ( IS_NPC(ch) )
				bonus = ch->level;
			if ( bonus >= chance )
				race_chk += bonus;
		}
		damage(ch,victim,number_range(1,race_chk),gsn_kick,DAM_BASH,TRUE);
		check_improve(ch,gsn_kick,TRUE,3);
    }
    else
    {
	damage( ch, victim, 0, gsn_kick,DAM_BASH,TRUE);
	check_improve(ch,gsn_kick,FALSE,1);
    }
	check_killer(ch,victim);
    return;
}
