/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "tables.h"
#include "music.h"
#include "recycle.h"
#include "faire.h"

void msdp_update args( ( void ) ); /* <--- Add this line */

/*
 * Local functions.
 */
int hit_gain args( ( CHAR_DATA *ch ) );
int stam_gain	args( ( CHAR_DATA *ch ) );
void mobile_update	args( ( void ) );
void weather_update	args( ( void ) );
void char_update	args( ( void ) );
void obj_update	args( ( void ) );
void aggr_update	args( ( void ) );
void update_birthday args ( ( void ) );
void quest_update    args( ( void ) ); /* Vassago - quest.c */
void fireoil_update  args(( void ));
void olcautosave     args( ( void ) );
void free_event args( (EVENT_DATA *ev) );
void save_area_list args ( (void) );
void save_area args( ( AREA_DATA *pArea ) );
void room_update	args( ( AREA_DATA *pArea ) );
void room_aff_update	args( ( ROOM_INDEX_DATA *room ) );
void update_companions args( ( CHAR_DATA *ch ) );
void who_html_update args(( int mud_port ));
void update_bugs args((void));
bool chance args(( int num ));
/* used for saving */

int save_number = 0;
int beard_number = 0;
int camp_number = 0;
int jtimer = 0;
int addictTimer;
int vtimer = 0;
int calc_remort_tier(CHAR_DATA *ch);

    extern bool wizlock; // prool

void msdp_update( void )
{

    DESCRIPTOR_DATA *d;

    int PlayerCount = 0;



    for ( d = descriptor_list; d != NULL; d = d->next )

    {

	if ( d->character && d->connected == CON_PLAYING && !IS_NPC(d->character) )

        {

            char buf[MAX_STRING_LENGTH];

            CHAR_DATA *pOpponent;

		if (d->character && d->character->fight_data && d->character->fight_data->fighter)
			pOpponent = d->character->fight_data->fighter;
		else	pOpponent = NULL;

            ROOM_INDEX_DATA *pRoom = d->character->in_room;

            AFFECT_DATA *paf;



            ++PlayerCount;



            MSDPSetString( d, eMSDP_CHARACTER_NAME, d->character->name );

            MSDPSetNumber( d, eMSDP_ALIGNMENT, d->character->alignment );

            MSDPSetNumber( d, eMSDP_EXPERIENCE, d->character->exp );

/*

            MSDPSetNumber( d, eMSDP_EXPERIENCE_MAX, TBD );

            MSDPSetNumber( d, eMSDP_EXPERIENCE_TNL, TBD );

*/

            MSDPSetNumber( d, eMSDP_HEALTH, d->character->hit );

            MSDPSetNumber( d, eMSDP_HEALTH_MAX, d->character->max_hit );

            MSDPSetNumber( d, eMSDP_LEVEL, d->character->level );

/*

            MSDPSetNumber( d, eMSDP_RACE, TBD );

            MSDPSetNumber( d, eMSDP_CLASS, TBD );

*/

            MSDPSetNumber( d, eMSDP_MANA, d->character->stam );

            MSDPSetNumber( d, eMSDP_MANA_MAX, d->character->max_stam );

            MSDPSetNumber( d, eMSDP_WIMPY, d->character->wimpy );

            MSDPSetNumber( d, eMSDP_PRACTICE, d->character->practice );

//            MSDPSetNumber( d, eMSDP_MONEY, d->character->gold );

//            MSDPSetNumber( d, eMSDP_MOVEMENT, d->character->move );

  //          MSDPSetNumber( d, eMSDP_MOVEMENT_MAX, d->character->max_move );

            MSDPSetNumber( d, eMSDP_HITROLL, GET_HITROLL(d->character) );

            MSDPSetNumber( d, eMSDP_DAMROLL, GET_DAMROLL(d->character) );

//            MSDPSetNumber( d, eMSDP_AC, GET_AC(d->character) );

            MSDPSetNumber( d, eMSDP_STR, get_curr_stat(d->character, STAT_STR) );

            MSDPSetNumber( d, eMSDP_INT, get_curr_stat(d->character, STAT_INT) );

            MSDPSetNumber( d, eMSDP_WIS, get_curr_stat(d->character, STAT_WIS) );

            MSDPSetNumber( d, eMSDP_DEX, get_curr_stat(d->character, STAT_DEX) );

            MSDPSetNumber( d, eMSDP_CON, get_curr_stat(d->character, STAT_CON) );

            MSDPSetNumber( d, eMSDP_STR_PERM, d->character->perm_stat[STAT_STR] );

            MSDPSetNumber( d, eMSDP_INT_PERM, d->character->perm_stat[STAT_INT] );

            MSDPSetNumber( d, eMSDP_WIS_PERM, d->character->perm_stat[STAT_WIS] );

            MSDPSetNumber( d, eMSDP_DEX_PERM, d->character->perm_stat[STAT_DEX] );

            MSDPSetNumber( d, eMSDP_CON_PERM, d->character->perm_stat[STAT_CON] );



            /* This would be better moved elsewhere */

            if ( pOpponent != NULL )

            {

                int hit_points = (pOpponent->hit * 100) / pOpponent->max_hit;

                MSDPSetNumber( d, eMSDP_OPPONENT_HEALTH, hit_points );

                MSDPSetNumber( d, eMSDP_OPPONENT_HEALTH_MAX, 100 );

                MSDPSetNumber( d, eMSDP_OPPONENT_LEVEL, pOpponent->level );

                MSDPSetString( d, eMSDP_OPPONENT_NAME, pOpponent->name );

            }

            else /* Clear the values */

            {

                MSDPSetNumber( d, eMSDP_OPPONENT_HEALTH, 0 );

                MSDPSetNumber( d, eMSDP_OPPONENT_LEVEL, 0 );

                MSDPSetString( d, eMSDP_OPPONENT_NAME, "" );

            }



            /* Only update room stuff if they've changed room */

            if ( pRoom && pRoom->vnum != d->pProtocol->pVariables[eMSDP_ROOM_VNUM]->ValueInt )

            {

                int i; /* Loop counter */

                buf[0] = '\0';



                for ( i = DIR_NORTH; i < MAX_DIR; ++i )

                {

                    if ( pRoom->exit[i] != NULL )

                    {

                        const char MsdpVar[] = { (char)MSDP_VAR, '\0' };

                        const char MsdpVal[] = { (char)MSDP_VAL, '\0' };



                        strcat( buf, MsdpVar );

                        strcat( buf, dir_name[i] );

                        strcat( buf, MsdpVal );



                        if ( IS_SET(pRoom->exit[i]->exit_info, EX_CLOSED) )

                            strcat( buf, "C" );

                        else /* The exit is open */

                            strcat( buf, "O" );

                    }

                }



                if ( pRoom->area != NULL )

                    MSDPSetString( d, eMSDP_AREA_NAME, pRoom->area->name );



                MSDPSetString( d, eMSDP_ROOM_NAME, pRoom->name );

                MSDPSetTable( d, eMSDP_ROOM_EXITS, buf );

                MSDPSetNumber( d, eMSDP_ROOM_VNUM, pRoom->vnum );

            }

/*

            MSDPSetNumber( d, eMSDP_WORLD_TIME, d->character-> );

*/



            buf[0] = '\0';

            for ( paf = d->character->affected; paf; paf = paf->next )

            {

                char skill_buf[MAX_STRING_LENGTH];

                sprintf( skill_buf, "%c%s%c%d",

                    (char)MSDP_VAR, skill_table[paf->type].name, 

                    (char)MSDP_VAL, paf->duration );

                strcat( buf, skill_buf );

            }

            MSDPSetTable( d, eMSDP_AFFECTS, buf );



            MSDPUpdate( d );

        }

    }



    /* Ideally this should be called once at startup, and again whenever 

     * someone leaves or joins the mud.  But this works, and it keeps the 

     * snippet simple.  Optimise as you see fit.

     */

    MSSPSetPlayers( PlayerCount );

}


void init_faire_mobs args(( int location, int fLookup ));
void init_faire_rooms args((CHAR_DATA *ch, int location, int fLookup ));
void init_faire_portal args(( int location, int fLookup ));
extern int FaireLocation;

bool empty_faire ( void )
{
	AREA_DATA *faire;

	for (faire = area_first; faire != NULL; faire = faire->next)
	{
		if (!str_cmp(faire->name, "Faire"))
		{
			if (faire->nplayer > 0)			return FALSE;
			return TRUE;
		}
	}

	return FALSE;
}

void faire_update (void)
{
	static int faire_ticks;
	int location;
	DESCRIPTOR_DATA *d;

	if (faire->open == FALSE)	return;

	// Cycle inventory every half hour with a chance to move locations if the faire is empty
	if ( --faire_ticks <= 0 )
	{
                faire_ticks      = 60;

		// Pack up and move the faire
		if (empty_faire() && number_percent() <= 50);
		{
			location = number_range(0, 15);
			free_string(faire->location);
			faire->location = str_dup(faire_location_table[location].pName);
			FaireLocation = faire_location_table[location].vnum;
			init_faire_rooms( NULL, FaireLocation, location );
			init_faire_portal( FaireLocation, location );

			for ( d = descriptor_list; d; d = d->next )
			{
				if ( d->connected != CON_PLAYING )	continue;

				stc("\n\r              {R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{x\n\r", d->character);
				ptc( d->character, "{wA crier rushes by, bringing news of a Faire in %s!\n\r",
				capit2( faire_location_table[location].pName ) );
				stc("              {R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{r={R-{x\n\r", d->character);
                                        
			}
		}
			
		init_faire_mobs( FaireLocation, 0);
	}

	return;
}



/*
 * Handle all kinds of updates.
 * Called once per pulse from game loop.
 * Random times to defeat tick-timing clients and players.
 */

void update_handler( void )
{
    static  int     pulse_area;
    static  int     pulse_mobile;
    static  int     pulse_violence;
    static  int     pulse_point;
    static	int		pulse_auction;
    static	int	    pulse_event;
    static  int     pulse_ferry;
    static  int     pulse_fireoil;
    static  int     pulse_hour;
    static  int     pulse_dream;
    static  int     pulse_quest;
    static  int     pulse_minute;
    static  int     pulse_copyover;
//    static  int     pulse_msdp; /* <--- Add this line */
/*
    if ( --pulse_msdp <= 0 )
    {
        pulse_msdp      = PULSE_PER_SECOND;
        msdp_update();
    }
*/

	if (--pulse_copyover <= 0)
	{
		char buf[MAX_STRING_LENGTH];
		extern int bootcount;
		int minutes;
		pulse_copyover = PULSE_PER_SECOND;

		bootcount--;

		minutes = bootcount / 60;

		if (bootcount > 0)
		{
			if (bootcount <= 5)	// 5 seconds or less - show every second
			{
				sprintf(buf, "There will be a copyover in %d second%s.", bootcount, bootcount == 1 ? "" : "s");
				sysmsg (buf);
			}
			else if (bootcount <= 30 && bootcount % 10 == 0) // 30 seconds or less - show every 10 seconds
			{
				sprintf(buf, "There will be a copyover in %d seconds.", bootcount);
				sysmsg (buf);
			}
			else if (bootcount <= 300 && bootcount % 60 == 0) // 5 minutes or less - show every minute
			{
				sprintf(buf, "There will be a copyover in %d minute%s.", bootcount / 60, (bootcount / 60) == 1 ? "" : "s");
				sysmsg (buf);
			}
			else if (bootcount > 600)
				;
			else if (bootcount % 300 == 0) // else every 5 minutes
			{
				sprintf(buf, "There will be a copyover in %d minutes.", bootcount / 60);
				sysmsg (buf);
			}
		}
		else if (bootcount == 0) copyover();
	}

/* timed events */
    if ( --pulse_event <= 0 )
    {
        pulse_event             = PULSE_EVENT;
        event_update();
    }

    if ( --pulse_minute <= 0 )
    {
		pulse_minute = PULSE_MINUTE;
		gevent_update();
		//faire_update();
	}

    if ( --pulse_dream <= 0 )
    {
        pulse_dream             = PULSE_DREAM;
        dream_update();
    }

	if ( --pulse_auction <= 0 )
	{
        pulse_auction   = PULSE_AUCTION;
        auction_update( );
	}

    if ( --pulse_area <= 0 )
    {
		pulse_area	= PULSE_AREA;
		/* number_range( PULSE_AREA / 2, 3 * PULSE_AREA / 2 ); */
		area_update	( );
	    olcautosave ( );

    	if (wizlock_timer != -1)
			if (--wizlock_timer <= 0 )
				wizlock = FALSE;
    }

    if ( --pulse_fireoil <= 0 )
    {
	    pulse_fireoil     = PULSE_FIREOIL;
	    fireoil_update    ( );
    }

	if ( --pulse_ferry <= 0 )
	{
		pulse_ferry = PULSE_FERRY;
		ferry_update( );
		ship_advance( );
		caravan_advance( );
	}

    if ( --pulse_mobile   <= 0 )
    {
		pulse_mobile	= PULSE_MOBILE;
		mobile_update	( );
    }

    if ( --pulse_violence <= 0 )
    {
		pulse_violence	= PULSE_VIOLENCE;
		violence_update	( );
		if ( battle->running == TRUE && battle->open == FALSE )
	        battle_update   ( );

		tourney_update   ( );

	    if ( trivia->running )
	    	trivia_update();

    }

    if ( --pulse_hour <= 0 )
    {
		pulse_hour = PULSE_HOUR;
		wiznet("{wHourly Chime!{c",NULL,NULL,WIZ_TICKS,0,0);
		weather_update	( );
		update_clocks();
	}

    if ( --pulse_quest   <= 0 )
    {
		pulse_quest	= PULSE_QUEST;
		quest_update();
    }

    if ( --pulse_point    <= 0 )
    {
		wiznet( "{wTICK!{c",NULL,NULL,WIZ_TICKS,0,0 );
		pulse_point = PULSE_TICK;
		number_range( PULSE_TICK / 2, 3 * PULSE_TICK / 2 );
		char_update();
		obj_update();
		dfhunt_update();
	    tag_update();
		/*who_html_update( mud_port );*/
		update_bugs();
    	gquest_update();
    	gquest_wait();
    }

/*    if(dfhunt_game_info[0] > 0)
    	dfhunt_recount();
*/
	/* moved to beginning of dfhunt_update */
    aggr_update( );
    tail_chain( );
    return;
}

void set_tourney_class( void )
{
	switch( tourney->lastclass )
	{
		case 1:
			tourney->tclass = str_dup( "Warrior's" );
			tourney->level1 = 50;
			tourney->level2 = 100;
			break;
		case 2:
			tourney->tclass = str_dup( "Veteran's" );
			tourney->level1 = 100;
			tourney->level2 = 150;
			break;
		case 3:
			tourney->tclass = str_dup( "Champion's" );
			tourney->level1 = 150;
			tourney->level2 = 200;
			break;
		case 4:
			tourney->tclass = str_dup( "Destroyer's" );
			tourney->level1 = 200;
			tourney->level2 = 250;
			break;
		case 5:
			tourney->tclass = str_dup( "Slayer's" );
			tourney->level1 = 250;
			tourney->level2 = 500;
			break;
		case 6:
			tourney->tclass = str_dup( "n'Dore Mordero's" );
			tourney->level1 = 500;
			tourney->level2 = 1000;
			break;
		case 7:
			tourney->tclass = str_dup( "Freaky Deeky's" );
			tourney->level1 = 1;
			tourney->level2 = 1000;
			break;
		case 8:
			tourney->tclass = str_dup( "Beginner's" );
			tourney->level1 = 1;
			tourney->level2 = 50;
			break;
	}
	if ( tourney->lastclass == 8 )
		tourney->lastclass = 1;
	else
		tourney->lastclass++;
}
void tourney_update ( void )
{
	DESCRIPTOR_DATA   * d;
	CHAR_DATA   * winner = NULL;
	ROOM_INDEX_DATA *location;
	int          place;
	int          count;
	char         buf[MSL];

	count = 0;

	/*
	if ( tourney->timer != -1 )
	{
		if ( tourney->timer == 20 || tourney->timer == 10 || tourney->timer == 5 || tourney->timer == 1 )
		{
			sprintf( buf, "Tourney timer is %d, status: %d, class %s", tourney->timer, tourney->status, tourney->tclass );
			talk_tourney( buf );
		}
	}
    */
	switch ( tourney->status )
	{
		default:
			mlog( "BUG", "TOURNEY: Invalid status was evaluated in tourney_update.", __LINE__, __FILE__);
			break;
		case 1:
			/* tourney is idle, decrement the timer */
			tourney->timer -= 1;
			if ( tourney->timer < 22)
				tourney->status = 2;
			break;
		case 2:
			/* tourney is waiting for warriors to join */
			for( d = descriptor_list; d != NULL; d = d->next )
			{
				if ( !d || !d->character )
					continue;
				if ( d->connected != CON_PLAYING )
					continue;
				if( IS_SET( d->character->war_flags, WAR_TOURNEY ) )
				{
					count += 1;
				}
			}
			if ( tourney->timer == 20 || tourney->timer == 10 || tourney->timer == 5 || tourney->timer == 1 )
			{
			sprintf( buf, "{RWaiting{r:: {wTime left to join {W%s {wclass: {R%d Range: (%d-%d){x", tourney->tclass, tourney->timer, tourney->level1, tourney->level2 );
			talk_tourney( buf );
			sprintf( buf, "{RWaiting{r:: {wGladiators waiting: {R%d{x", count );
			talk_tourney( buf );
			}
			tourney->timer -= 1;
			if ( tourney->timer <= 0 )
			{
				tourney->status = 3;
				tourney->timer = -1;
			}
			break;
		case 3:
			/* tourney is sort of running, set the timer */
			tourney->timer -= 1;
			break;
		case 4:
			/* tourney is running, check for winner */
			place = 3001;
			location = get_room_index( place );

			for( d = descriptor_list; d != NULL; d = d->next )
			{
				if ( !d || !d->character )
					continue;
				if ( d->connected != CON_PLAYING )
					continue;
				if( IS_SET( d->character->war_flags, WAR_TOURNEY ) )
				{
					count += 1;
					winner = d->character;
				}
			}
			/*
			if ( count > 1 )
			{
				tourney->timer = -1;
				tourney->status = 4;
			}
			*/
			if ( count == 1 && winner != NULL )
			{
				sprintf( buf,"{w%s has won the tourney!{x\n\r",winner->name);
				talk_tourney( buf );
				REMOVE_BIT(winner->war_flags, WAR_TOURNEY);
				winner->hit = get_maxhit(winner);
				winner->stam = get_maxstam(winner);
				winner->questpoints += 50;
				winner->pcdata->summary[SUM_TOURNIES_WON] += 1;
				winner->pcdata->summary[SUM_TOURNIES_WON_EVER] += 1;
				stc("{wYou gain 50 quest points for your victory in the tourney!{x\n\r",winner);
				char_from_room( winner );
				char_to_room( winner, location );
				do_look( winner, "auto" );
				tourney->running = FALSE;
				if ( tourney->lastclass == 8 )
				{
					talk_tourney( "All classes ran. Next tourney time: 4000." );
					tourney->timer = 4000;
					tourney->status = 1;
					tourney->lastclass = 8;
					tourney->running = FALSE;
					tourney->level1 = 1;
					tourney->level2 = 50;
					set_tourney_class();
					return;
				}
				set_tourney_class();
				sprintf( buf, "{wNow preparing for a %s Tourney! (%d-%d){x\n\r", tourney->tclass, tourney->level1, tourney->level2 );
				talk_tourney( buf );
				tourney->running = FALSE;
				tourney->status = 2;
				tourney->timer = 20; /* change this! */
			}
			else if (count == 0 )
			{
				sprintf( buf,"{wNo one has won the tourney!{x\n\r");
				talk_tourney( buf );
				tourney->running = FALSE;
				if ( tourney->lastclass == 8 )
				{
					talk_tourney( "All classes ran. Next tourney time: 4000." );
					tourney->timer = 4000;
					tourney->status = 1;
					tourney->lastclass = 8;
					tourney->running = FALSE;
					tourney->level1 = 1;
					tourney->level2 = 50;
					set_tourney_class();
					return;
				}
				set_tourney_class();
				sprintf( buf, "{wNow preparing for a %s Tourney! (%d-%d){x\n\r", tourney->tclass, tourney->level1, tourney->level2 );
				talk_tourney( buf );
				tourney->running = FALSE;
				tourney->status = 2;
				tourney->timer = 20; /* change this! */
			}
			break;
	}
/*
	if( tourney->running == FALSE || tourney->open == TRUE )
	return;
*/
	/*if ( tourney->running == TRUE && count <= 0 )*/
	if ( tourney->status == 3 && tourney->timer == -1 && count <= 1 )
	{
		sprintf( buf, "{wNot enough gladiators for the %s class Tourney!{x\n\r", tourney->tclass );
		talk_tourney( buf );
		if (count == 1)
		{
		  for( d = descriptor_list; d != NULL; d = d->next )
		  {
		    if ( !d || !d->character )
			continue;
		    if ( d->connected != CON_PLAYING )
			continue;
		    if( IS_SET( d->character->war_flags, WAR_TOURNEY ) )
		    {
			winner = d->character;
			break;
		    }
		  }
			place = 3001;
			location = get_room_index( place );
		  REMOVE_BIT(winner->war_flags, WAR_TOURNEY);
		  char_from_room( winner );
		  char_to_room( winner, location );
		  do_look( winner, "auto" );
		}
		if ( tourney->lastclass == 8 )
		{
			talk_tourney( "All classes ran. Next tourney time: 4000." );
			tourney->timer = 4000;
			tourney->status = 1;
			tourney->lastclass = 8;
			tourney->running = FALSE;
			tourney->level1 = 1;
			tourney->level2 = 50;
			set_tourney_class();
			return;
		}
		set_tourney_class();
		sprintf( buf, "{wNow preparing for a %s Tourney (%d-%d)!{x\n\r", tourney->tclass, tourney->level1, tourney->level2 );
		talk_tourney( buf );
		tourney->running = FALSE;
		tourney->status = 2;
		tourney->timer = 20; /* change this! */
		return;
	}
	if ( tourney->status == 3 && tourney->timer == -1 )
	{
		ROOM_INDEX_DATA *location;
		sprintf( buf, "{w%d gladiators now fighting in the %s Tourney!{x\n\r", count, tourney->tclass );
		talk_tourney( buf );
		talk_tourney( "{WLet the Tourney BEGIN!{x\n\r" );
		tourney->running = TRUE;
		tourney->status = 4;
		for( d = descriptor_list; d != NULL; d = d->next )
		{
			if ( !d || !d->character )
				continue;
			if ( d->connected != CON_PLAYING )
				continue;
			if ( IS_SET( d->character->war_flags, WAR_TOURNEY ) )
			{
				if ( !IS_SET( d->character->war_flags, WAR_PK ) )
					SET_BIT( d->character->war_flags, WAR_PK );
				if ( ( location = get_room_index( 3726 ) ) == NULL )
				{
					mlog( "BUG", "TOURNEY:: Place is NULL" );
					return;
				}
				char_from_room( d->character );
				char_to_room( d->character, location );
				do_function( d->character, &do_visible, "" );
				do_function( d->character, &do_look, "auto" );
			}
		}
	}

	tourney->running = TRUE;
	return;
}

void battle_update ( void )
{
	CHAR_DATA   * ch;
	CHAR_DATA   * winner = NULL;
	ROOM_INDEX_DATA *location;
	int          place;
	int          count;
	char         buf[MAX_STRING_LENGTH];

	count = 0;

	if( battle->running == FALSE || battle->open == TRUE )
	return;

	place = 3001;
	location = get_room_index( place );

	for( ch = char_list; ch; ch = ch->next )
	{
		if( IS_SET( ch->war_flags, WAR_BATTLE ) )
		{
			++count;
			winner = ch;
		}
	}

	if( count == 1 && winner != NULL )
	{
		sprintf( buf,"{w%s has won the campaign!{x\n\r",winner->name);
		talk_battle( buf );
		winner->bwins++;
		REMOVE_BIT(winner->war_flags, WAR_BATTLE);
		winner->hit = get_maxhit(winner);
		winner->stam = get_maxstam(winner);
		winner->questpoints += 250;
		stc("{wYou gain 250 quest points for your victory in the campaign!{x\n\r",winner);
		char_from_room( winner );
		char_to_room( winner, location );
		do_look( winner, "auto" );
		battle->running = FALSE;
	}
	battle->running = TRUE;
	return;
}

void room_update( AREA_DATA *pArea )
{
	ROOM_INDEX_DATA *room;
	int vnum;

	for ( vnum = pArea->min_vnum; vnum <= pArea->max_vnum; vnum ++ )
	{
		if ( (room = get_room_index(vnum)) )
		room_aff_update(room);
	}
	return;
}


void room_aff_update( ROOM_INDEX_DATA *room )
{
	AFFECT_DATA *paf;
	AFFECT_DATA *paf_next;

	for ( paf = room->affected; paf != NULL; paf = paf_next )
	{
	    paf_next	= paf->next;
	    if ( paf->duration > 0 )
	    {
			paf->duration--;
			if (number_range(0,4) == 0 && paf->level > 0)
				paf->level--;  /* spell strength fades with time */
        }
	    else if ( paf->duration < 0 )
		;
	    else
	    {
		if ( paf_next == NULL
		||   paf_next->type != paf->type
		||   paf_next->duration > 0 )
		{
		    if ( paf->type > 0 && skill_table[paf->type].msg_off )
		    {
		/*	send_to_char( skill_table[paf->type].msg_off, ch);
			send_to_char( "\n\r", ch );  */
		    }
		}

		affect_remove_room( room, paf );
	    }
	}

}

/*
 * Advancement stuff.
 */
void advance_level( CHAR_DATA *ch, bool hide )
{
    char buf[MAX_STRING_LENGTH];
    int add_hp;
    int add_mana;
    int add_prac;
    int add_train;

    ch->pcdata->last_level =
	( ch->played + (int) (current_time - ch->logon) ) / 3600;

    add_hp	= con_app[get_curr_stat(ch,STAT_CON)].hitp + number_range(
		    class_table[ch->class].hp_min,
		    class_table[ch->class].hp_max );
	if ((ch->race == race_lookup( "trolloc")
	|| ch->race == race_lookup( "ogier")
	|| !IS_SET(ch->op_flags,OP_CHANNELER)))
        add_hp += 2;
    add_mana 	= number_range(2,(2*get_curr_stat(ch,STAT_INT)
				  + get_curr_stat(ch,STAT_WIS))/5);
    if (!class_table[ch->class].fMana)
	add_mana /= 2;

    add_prac	= wis_app[get_curr_stat(ch,STAT_WIS)].practice;
    /*add_train = (get_curr_stat(ch,STAT_WIS) + get_curr_stat(ch,STAT_INT)/10);*/
	add_train	= wis_app[get_curr_stat(ch,STAT_WIS)].practice;

	if ( ch->level <= 10 )
	{
    add_prac	+= 5;
	add_train	+= 2;
	}

    add_hp = add_hp * 9/10;
    add_mana = add_mana * 9/10;

    add_hp	= UMAX(  2, add_hp   );
    add_mana	= UMAX(  2, add_mana );

    ch->max_hit 	+= add_hp;
    ch->max_stam	+= add_mana;
/*    ch->practice	+= add_prac; */
    ch->train		+= add_train;

    ch->pcdata->perm_hit	+= add_hp;
    ch->pcdata->perm_mana	+= add_mana;

    if (!hide)
    {
    	sprintf(buf,
	    "{cYou gain {C%d{c hp%s, {C%d{c stamina, {C%d{c practice%s, {C%d{c train%s.\n\r",
	    add_hp, add_hp == 1 ? "" : "s", add_mana,
	    add_prac, add_prac == 1 ? "" : "s",
	    add_train, add_train == 1 ? "" : "s");
	stc( buf, ch );
    }
	if (IS_SET(ch->custom_flags,SPEC_WOLFBROTHER))
	{
    if (ch->level < 31 && ch->level > 29)
    	stc("{wYou hear a howl, from somewhere. Then others, seeming all around you.\n\r",ch);
    if (ch->level < 51 && ch->level > 49)
    	stc("{wYou catch yourself scratching absently behind your ear..\n\r",ch);
	}
/*	do_function( ch, &do_save, "" );   this spams out when used in advance*/
	/*if (!IS_SET(ch->op_flags, OP_CHANNELER) && ch->level > 79 && ch->level < 81)
	{
		stc("As your skill grows, you become more affluent with your weapon, growing closer to the title of Blademaster.\n\r",ch);
		ch->pcdata->learned[gsn_bird] = 1;
		ch->pcdata->learned[gsn_heron] = 1;
	}*/
}



void gain_exp( CHAR_DATA *ch, int gain )
{
	char buf[MAX_STRING_LENGTH];
	int trainGain, tbonus;

	if ( IS_NPC(ch) || ch->level >= MAX_LEVEL )
		return;

	ch->pcdata->summary[SUM_XP_EARNED] += gain;

	ch->exp = UMAX( exp_per_level(ch,ch->pcdata->points), ch->exp + gain );

	if ( check_windfall(ch) )
	{
		stc("{wWindfall! The dice lands in your favor!{x\n\r",ch);
		gain = gain * 1.25;
	}

	tbonus = calc_remort_tier(ch);

	/* Gain trains from exp. */
	if ( gain <= 0 )
		return;
	if ( gain < 100 )
		trainGain = 1;
	else
		trainGain = ( gain / 100 );

	if ( trainGain > 6 + tbonus )
		trainGain = 6 + tbonus;

	if ( trainGain > 0 )
	{
		ptc( ch, "You gain %d train%s!\n\r", trainGain, trainGain == 1 ? "" : "s" );
		ch->train += trainGain;
	}

	while ( !IS_IMMORTAL(ch) && ch->exp >= exp_per_level(ch,ch->pcdata->points) * (ch->level+1) )
	{
		ch->level += 1;
		ch->pcdata->summary[SUM_LEVELS_GAINED] += 1;
		ch->pcdata->summary[SUM_LEVELS_GAINED_EVER] += 1;
		sprintf(buf,"{c$N has attained level %d!",ch->level);
		wiznet(buf,ch,NULL,WIZ_LEVELS,0,0);
		save_char_obj(ch, FALSE, FALSE);
	}
	return;
}



/*
 * Regeneration stuff.
 */
int hit_gain( CHAR_DATA *ch )
{
    int gain;
    int number;
    AFFECT_DATA *af;

    if (ch->in_room == NULL)
	return 0;

    if ( IS_NPC(ch) )
    {
		gain =  5 + ch->level + get_maxhit(ch) / 25;
	 	if (IS_AFFECTED(ch,AFF_REGENERATION))
		    gain *= 2;

		switch(ch->position)
		{
		    default : 		gain /= 2;			break;
		    case POS_SLEEPING: 	gain = 3 * gain/2;		break;
		    case POS_RESTING:  					break;
		    case POS_FIGHTING:	gain /= 3;		 	break;
	 	}
    }
    else
    {
		gain = UMAX(3,get_curr_stat(ch,STAT_CON) + ch->pcdata->rebirth);
		gain += class_table[ch->class].hp_max - 10;
	 	gain *= calc_remort_tier(ch);

		if ((af = affect_find(ch->affected, skill_lookup("restful"))) != NULL)
		gain += af->modifier;

	 	if (IS_AFFECTED(ch,AFF_REGENERATION))
		    gain *= 1.5;

	 	if (is_affected(ch, gsn_treat))
		    gain *= 1.5;

	 	if (IS_AFFECTED2(ch,AFF_BANDAGE))
		    gain *= 1.75;

		if (IS_SET(ch->hist_flags,HIST_BONDED))
			gain += get_curr_stat(ch,STAT_CON) * 20;
		gain += get_curr_stat(ch,STAT_CON);
	 	number = number_percent();
		if (number < get_skill(ch,gsn_fast_healing))
		{
		    gain += number * gain / 100;
		    if (ch->hit < get_maxhit(ch))
				check_improve(ch,gsn_fast_healing,TRUE,8);
		}
		switch ( ch->position )
		{
		    default:	   	gain /= 4;			break;
		    case POS_SLEEPING: 					break;
		    case POS_RESTING:  	gain /= 2;			break;
		    case POS_FIGHTING: 	gain /= 6;			break;
		}

		if ( ch->pcdata->condition[COND_HUNGER]   == 0 )
		    gain /= 2;

		if ( ch->pcdata->condition[COND_THIRST] == 0 )
		    gain /= 2;

    }

    gain = gain * ch->in_room->heal_rate / 100;

    if (ch->on != NULL && ch->on->item_type == ITEM_FURNITURE)
	gain = gain * ch->on->value[3] / 100;

    if ( IS_AFFECTED(ch, AFF_POISON) )
	gain /= 4;

    if (IS_AFFECTED(ch, AFF_PLAGUE))
	gain /= 8;

    if (IS_AFFECTED(ch,AFF_HASTE) || IS_AFFECTED(ch,AFF_SLOW))
	gain /=2 ;

    return UMIN(gain, get_maxhit(ch) - ch->hit);
}



int stam_gain( CHAR_DATA *ch )
{
    int gain;
    int number;

    if (ch->in_room == NULL)
	return 0;

    if ( IS_NPC(ch) )
    {
	gain = 5 + ch->level;
	switch (ch->position)
	{
	    default:		gain /= 2;		break;
	    case POS_SLEEPING:	gain = 3 * gain/2;	break;
   	    case POS_RESTING:				break;
	    case POS_FIGHTING:	gain /= 3;		break;
    	}
    }
    else
    {
	if (IS_SET(ch->hist_flags,HIST_BONDER))
	{
		gain += get_curr_stat(ch,STAT_WIS) + get_curr_stat(ch, STAT_INT) * 10;
	}
	if (IS_SET(ch->hist_flags,HIST_BONDED))
	{
		gain = UMAX( get_curr_stat(ch,STAT_DEX), ch->level);
	}

	gain *= calc_remort_tier(ch);
	gain = (get_curr_stat(ch,STAT_WIS)
	      + get_curr_stat(ch,STAT_INT) + ch->pcdata->rebirth);
	number = number_percent();

	if (number < get_skill(ch,gsn_meditation))
	{
	    gain += number * gain / 100;
	    if (ch->stam < get_maxstam(ch))
	        check_improve(ch,gsn_meditation,TRUE,8);
	}

	switch ( ch->position )
	{
	    default:		gain /= 4;			break;
	    case POS_SLEEPING: 					break;
	    case POS_RESTING:	gain /= 2;			break;
	    case POS_FIGHTING:	gain /= 6;			break;
	}

	if ( ch->pcdata->condition[COND_HUNGER]   == 0 )
	    gain /= 2;

	if ( ch->pcdata->condition[COND_THIRST] == 0 )
	    gain /= 2;
    }

    gain = gain * ch->in_room->mana_rate / 100;

    if (ch->on != NULL && ch->on->item_type == ITEM_FURNITURE)
	gain = gain * ch->on->value[4] / 100;

    if ( IS_AFFECTED( ch, AFF_POISON ) )
	gain /= 4;

    if (IS_AFFECTED(ch, AFF_PLAGUE))
        gain /= 8;

    if (IS_AFFECTED(ch,AFF_HASTE) || IS_AFFECTED(ch,AFF_SLOW))
        gain /=2 ;

    return UMIN(gain, get_maxstam(ch) - ch->stam);
}

void gain_condition( CHAR_DATA *ch, int iCond, int value )
{
    int condition;

    if ( value == 0 || IS_NPC(ch) || IS_IMMORTAL(ch))
	return;
    if (!ch->pcdata)
	    return;
    condition				= ch->pcdata->condition[iCond];
    if (condition == -1)
        return;
    ch->pcdata->condition[iCond]	= URANGE( 0, condition + value, 48 );


	/* update the pk_timer
	if (IS_SET(ch->war_flags,WAR_PK))
	{
		ch->pcdata->pk_timer += 1;
		if (ch->pcdata->pk_timer >= 10)
		{
			ch->pcdata->pk_timer = 0;
			REMOVE_BIT(ch->war_flags,WAR_PK);
			stc("You are no longer player-killable.\n\r",ch);
		}
	}*/

    if ( ch->pcdata->condition[iCond] == 0 )
    {
	switch ( iCond )
	{
	case COND_HUNGER:
	    stc( "{cYou are hungry.\n\r",  ch );
        ch->hit = ch->hit - (ch->hit * 2/100);
        ch->stam = ch->stam - (ch->stam * 2/100);
        break;

	case COND_THIRST:
	    stc( "{cYou are thirsty.\n\r", ch );
        ch->hit = ch->hit - (ch->hit * 2/100);
        ch->stam = ch->stam - (ch->stam * 2/100);
	    break;

	case COND_DRUNK:
	    if ( condition != 0 )
		stc( "{cYou are sober.\n\r", ch );
	    break;
	}
    }

    return;
}



/*
 * Mob autonomous action.
 * This function takes 25% to 35% of ALL Merc cpu time.
 * -- Furey
 */
void mobile_update( void )
{
    CHAR_DATA *ch;
    CHAR_DATA *ch_next;
    EXIT_DATA *pexit;
    int door;

    /* Examine all mobs. */
    for ( ch = char_list; ch != NULL; ch = ch_next )
    {
	ch_next = ch->next;

	if ( !IS_NPC(ch) || ch->in_room == NULL || IS_AFFECTED(ch,AFF_CHARM))
	    continue;

	if (ch->in_room->area->empty && !IS_SET(ch->act,ACT_UPDATE_ALWAYS))
	    continue;

	/* Examine call for special procedure */
	if ( ch->spec_fun != 0 )
	{
	    if ( (*ch->spec_fun) ( ch ) )
		continue;
	}
/*
	if (ch->pIndexData->pShop != NULL)
	{
	    if ((ch->gold * 100 + ch->silver) < ch->pIndexData->wealth)
	    {
		ch->copper_penny += ch->pIndexData->wealth * number_range(1,20)/5000000;
		ch->silver_penny += ch->pIndexData->wealth * number_range(1,20)/50000;
	    }
	}
*/
	/*
	 * Check triggers only if mobile still in default position
	 */
	if ( ch->position == ch->pIndexData->default_pos )
	{
	    /* Delay */
	    if ( HAS_TRIGGER_MOB( ch, TRIG_DELAY)
	    &&   ch->mprog_delay > 0 )
	    {
		if ( --ch->mprog_delay <= 0 )
		{
		    p_percent_trigger( ch, NULL, NULL, NULL, NULL, NULL, TRIG_DELAY );
		    continue;
		}
	    }
	    if ( HAS_TRIGGER_MOB( ch, TRIG_RANDOM) )
	    {
		if( p_percent_trigger( ch, NULL, NULL, NULL, NULL, NULL, TRIG_RANDOM ) )
		continue;
	    }
	}

	/* That's all for sleeping / busy monster, and empty zones */
	if ( ch->position != POS_STANDING )
	    continue;

	/* Scavenge
	if ( IS_SET(ch->act, ACT_SCAVENGER)
	&&   ch->in_room->contents != NULL
	&&   number_bits( 6 ) == 0 )
	{
	    OBJ_DATA *obj;
	    OBJ_DATA *obj_best;
	    int max;

	    max         = 1;
	    obj_best    = 0;
	    for ( obj = ch->in_room->contents; obj; obj = obj->next_content )
	    {
		if ( CAN_WEAR(obj, ITEM_TAKE) && can_loot(ch, obj)
		     && obj->cost > max  && obj->cost > 0)
		{
		    obj_best    = obj;
		    max         = obj->cost;
		}
	    }

	    if ( obj_best )
	    {
		obj_to_char( obj_best, ch );
		do_function( ch, &do_get, obj_best->name );
	    }
	}
*/

	/*Hate*/
    {
        CHAR_DATA *rch;

        for (rch = ch->in_room->people; rch; rch = rch->next_in_room)
        {
			if ( !IS_NPC(rch) && is_hating(ch,rch) )
			{
				do_function( ch, &do_kill, rch->name );
                /*multi_hit( ch, rch, TYPE_UNDEFINED );*/
                break;
		/* this might be safer to turn rch, but that'd crash on rch->next_in_room */
			}
        }
    }

	if ( ch && is_fighting(ch) && ch->advancing == FALSE )
	{
	    if ( !ch->advancing_on->in_room )
		    stop_fighting( ch, ch->advancing_on );

	    if ( ch->advancing_on
	    && ch->advancing_on->in_room != NULL
	    && ch->advancing_on->in_room != ch->in_room )
		    stop_fighting( ch, ch->advancing_on );

		if ( ch->advancing && !ch->advancing_on )
		{
			/*ch->advancing = FALSE;
			ch->advancing_on = NULL;*/
			find_next_victim(ch);
		}

		if ( ch->advancing_on != NULL
		&& ch->in_room != NULL
		&& ch->advancing_on->in_room != NULL )
			ch->advancing_on = NULL;
	}

	/* Wander */
	if ( !IS_SET(ch->act, ACT_SENTINEL)
	&& number_bits(3) == 0
	&& ( door = number_bits( 5 ) ) < MAX_DIR
	&& ( pexit = ch->in_room->exit[door] ) != NULL
	&&   pexit->u1.to_room != NULL
	&&   !IS_SET(pexit->exit_info, EX_CLOSED)
	&&   !IS_SET(pexit->u1.to_room->room_flags, ROOM_NO_MOB)
	&& ( !IS_SET(ch->act, ACT_STAY_AREA)
	||   pexit->u1.to_room->area == ch->in_room->area )
	&& ( !IS_SET(ch->act, ACT_OUTDOORS)
	||   !IS_SET(pexit->u1.to_room->room_flags,ROOM_INDOORS))
	&& ( !IS_SET(ch->act, ACT_INDOORS)
	||   IS_SET(pexit->u1.to_room->room_flags,ROOM_INDOORS)))
	{
		if ( ch->advancing == FALSE && ch->range == RANGE_NONE )
		    move_char( ch, door, FALSE );
	}

	/* mob timers for quests */
	if ( ch->timer == -1 )
		continue;
	if ( ch->timer == 0 )
	{
		act( "$n is returned to the spinning of the Wheel.", ch, NULL, NULL, TO_ROOM );
		extract_char( ch, TRUE );
	}
	/* be careful with ch here, make sure it it still valid */
	/* does this really make sure its still valid? all it does is see if ch has been set to NULL, which it hasn't */
	if ( ch )
	{
		if ( ch->timer > 0 )
			ch->timer--;
	}
	/* end timers */

    }

    return;
}



/*
 * Update the weather.
 */
void weather_update( void )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
    int diff;
    FILE *fp;

    buf[0] = '\0';

	if (!( fp = fopen( TIME_FILE,"w+" ) ) )
	{
		log_string ("creation of new time_file failed");
	}
	else
	{
		int total;
		total = fprintf (fp, "%d %d %d %d",
			time_info.hour,
			time_info.day,
			time_info.month,
			time_info.year);
			if (total<4)
				log_string("failed fprintf to time_file");
			fclose(fp);
	}

    switch ( ++time_info.hour )
    {
    case  5:
	weather_info.sunlight = SUN_LIGHT;

	strcat( buf, "\n\r{wRejoice, you've survived to see a new day begin.{x\n\r" );
    update_birthday ( );
	break;

    case  6:
	weather_info.sunlight = SUN_RISE;
	if (weather_info.sky == SKY_RAINING || weather_info.sky == SKY_LIGHTNING)
	{
		switch( SEASON )
		{
			case 1: /* spring */
			strcat( buf, "{wThe sun rises behind a haze of rain-filled clouds.{x\n\r");
			break;
			case 2: /* summer */
			strcat( buf, "{wThe sun rises behind a haze of rain-filled clouds.{x\n\r");
			break;
			case 3: /* autumn */
			strcat( buf, "{wThe sun rises behind a haze of rain-filled clouds.{x\n\r");
			break;
			case 4: /* winter */
			strcat( buf, "{wThe sun rises behind a haze of snow-filled clouds.{x\n\r");
			break;
		}
	}
	else
		strcat( buf, "{wThe sun rises like a ball of fire in the east.\n\r");
	break;

    case 19:
	weather_info.sunlight = SUN_SET;
	if (weather_info.sky == SKY_RAINING || weather_info.sky == SKY_LIGHTNING)
		switch( SEASON )
		{
			case 1: /* spring */
			strcat( buf, "{wThe spring sun slowly sets behind the clouds.{x\n\r");
			break;
			case 2: /* summer */
			strcat( buf, "{wThe hot summer sun slowly sets behind the clouds.{x\n\r");
			break;
			case 3: /* autumn */
			strcat( buf, "{wThe autumn sun slowly sets behind the clouds.{x\n\r");
			break;
			case 4: /* winter */
			strcat( buf, "{wThe faded winter sun slowly sets behind the clouds.{x\n\r");
			break;
		}
	else
		switch( SEASON )
		{
			case 1: /* spring */
			strcat( buf, "{wThe spring sun slowly disappears in the west.{x\n\r" );
			break;
			case 2: /* summer */
			strcat( buf, "{wThe hot summer sun slowly disappears in the west.{x\n\r" );
			break;
			case 3: /* autumn */
			strcat( buf, "{wThe autumn sun slowly disappears in the west.{x\n\r" );
			break;
			case 4: /* winter */
			strcat( buf, "{wThe faded winter sun slowly disappears in the west.{x\n\r" );
			break;
		}
	break;

    case 20:
	weather_info.sunlight = SUN_DARK;
	if (weather_info.sky == SKY_RAINING || weather_info.sky == SKY_LIGHTNING)
		switch( SEASON )
		{
			case 1: /* spring */
			strcat( buf, "{wA rainy spring night settles in over the land.{x\n\r");
			break;
			case 2: /* summer */
			strcat( buf, "{wA rainy summer night settles in over the land.{x\n\r");
			break;
			case 3: /* autumn */
			strcat( buf, "{wA chill rainy autumn night settles in over the land.{x\n\r");
			break;
			case 4: /* winter */
			strcat( buf, "{wA wet and cold winter night settles in over the land.{x\n\r");
			break;
		}
	else
		switch( SEASON )
		{
			case 1: /* spring */
			strcat( buf, "{wA pleasant spring night settles in over the land.{x\n\r" );
			break;
			case 2: /* summer */
			strcat( buf, "{wA sultry summer night settles in over the land.{x\n\r" );
			break;
			case 3: /* autumn */
			strcat( buf, "{wA brisk autumn night settles in over the land.{x\n\r" );
			break;
			case 4: /* winter */
			strcat( buf, "{wA cold winter night settles in over the land.{x\n\r" );
			break;
		}
	break;

    case 24:
	time_info.hour = 0;
	time_info.day++;

	break;
    }

    if ( time_info.day   >= 35 )
    {
	time_info.day = 0;
	time_info.month++;
    }

    if ( time_info.month >= 13 )
    {
	time_info.month = 0;
	time_info.year++;
    }

    /*
     * Weather change.
     */
    if ( time_info.month >= 6 && time_info.month <= 12 )
	diff = weather_info.mmhg >  985 ? -2 : 2;
    else
	diff = weather_info.mmhg > 1015 ? -2 : 2;

    weather_info.change   += diff * dice(1, 4) + dice(2, 6) - dice(2, 6);
    weather_info.change    = UMAX(weather_info.change, -12);
    weather_info.change    = UMIN(weather_info.change,  12);

    weather_info.mmhg += weather_info.change;
    weather_info.mmhg  = UMAX(weather_info.mmhg,  960);
    weather_info.mmhg  = UMIN(weather_info.mmhg, 1040);

    switch ( weather_info.sky )
    {
    default:
	bug( "Weather_update: bad sky %d.", weather_info.sky );
	weather_info.sky = SKY_CLOUDLESS;
	break;

    case SKY_CLOUDLESS:
	if ( weather_info.mmhg <  990
	|| ( weather_info.mmhg < 1010 && number_bits( 2 ) == 0 ) )
	{
		switch( SEASON )
		{
			case 1: /* spring */
		    strcat( buf, "{wDark purple and black clouds gather in the spring sky.{x\n\r" );
			break;
			case 2: /* summer */
		    strcat( buf, "{wAngry dark purple and black clouds gather in the summer sky.{x\n\r" );
			break;
			case 3: /* autumn */
		    strcat( buf, "{wThick purple and black clouds gather in the autumn sky.{x\n\r" );
			break;
			case 4: /* winter */
		    strcat( buf, "{wThreatening purple and black clouds filled with snow gather in the sky.{x\n\r" );
			break;
		}
	    weather_info.sky = SKY_CLOUDY;
	}
	break;

    case SKY_CLOUDY:
	if ( weather_info.mmhg <  970
	|| ( weather_info.mmhg <  990 && number_bits( 2 ) == 0 ) )
	{
		switch( SEASON )
		{
			case 1: /* spring */
		    strcat( buf, "{wA light rain begins to fall from the spring sky.{x\n\r" );
			break;
			case 2: /* summer */
		    strcat( buf, "{wA sudden summer storm bring a heavy downpour from the summer sky.{x\n\r" );
			break;
			case 3: /* autumn */
		    strcat( buf, "{wA cool shower brings fat raindrops down from the autumn sky.{x\n\r" );
			break;
			case 4: /* winter */
			if ( chance ( 25 ) )
		    	strcat( buf, "{wFreezing sleet falls from angry winter clouds.{x\n\r" );
			else if ( chance ( 25 ) )
		    	strcat( buf, "{wOminous black and green clouds drop thundering clods of hail from the winter sky.{x\n\r" );
			else if ( chance ( 25 ) )
		    	strcat( buf, "{wA soft white blanket of snow falls gently from the winter sky.{x\n\r" );
			else
		    	strcat( buf, "{wGlistening white snowflakes fall thickly from the gray clouds above, swirling through the air.{x\n\r" );
			break;
		}
	    weather_info.sky = SKY_RAINING;
	}

	if ( weather_info.mmhg > 1030 && number_bits( 2 ) == 0 )
	{
	    strcat( buf, "{wThe clouds part and the sky is visible once more.\n\r" );
	    weather_info.sky = SKY_CLOUDLESS;
	}
	break;

    case SKY_RAINING:
	if ( weather_info.mmhg <  970 && number_bits( 2 ) == 0 )
	{
	    strcat( buf, "{wLightning flashes in the sky and thunder booms.\n\r" );
	    weather_info.sky = SKY_LIGHTNING;
	}

	if ( weather_info.mmhg > 1030
	|| ( weather_info.mmhg > 1010 && number_bits( 2 ) == 0 ) )
	{
	    strcat( buf, "{wThe rain finally abates.\n\r" );
	    weather_info.sky = SKY_CLOUDY;
	}
	break;

    case SKY_LIGHTNING:
	if ( weather_info.mmhg > 1010
	|| ( weather_info.mmhg >  990 && number_bits( 2 ) == 0 ) )
	{
	    /*strcat( buf, "{wThe lightning ceases and the thunder quietens.\n\r" );*/
	    weather_info.sky = SKY_RAINING;
	    break;
	}
	break;
    }

    if ( buf[0] != '\0' )
    {
		for ( d = descriptor_list; d != NULL; d = d->next )
		{
		    if ( d->connected == CON_PLAYING
		    &&   IS_OUTSIDE(d->character)
		    &&   IS_AWAKE(d->character) )
		    {
	    	if ( d->character->in_room->sector_type == SECT_WASTE )
		    	continue;
		    else
				stc( buf, d->character );
			}
		}
    }
    return;
}

const char * illumine_1[] =
{
	"    :   '.\\'/.    \n\r '.\\'/.'-=   =-   \n\r -=   =-.'/.\\'    \n\r .'/.\\'.   :      \n\r    :              \n\r"
};
const char * illumine_2[] =
{
	"        :       \n\r     '. ' .'    \n\r     -     -    \n\r     .' . '.    \n\r        :       \n\r"
};
const char * illumine_3[] =
{
	"    .''.    \n\r   _\\)/_   \n\r    /(\\    \n\r     '      \n\r",
};
const char * illumine_4[] =
{
"       .'\'\n\r      :_\\/_:\n\r  .''.: /\\ :\n\r :_\\/_:'.:::.\n\r : /\\ : :::::\n\r  '..'  ':::'\n\r      *n\r",
};
const char * illumine_5[] =
{
"                    .'\'.\n\r  .        *''*    :_\\/_:\n\r _\\(/_  .:.*_\\/_*   : /\\ :\n\r  /)\\   ':'* /\\ * :  '..'.\n\r  ' *''*    * '.\\'/.'\n\r   *_\\/_*     -= o =-\n\r   * /\\ *     .'/.\\'.\n\r    *..*         :\n\r"
};
/*
const char * illumine_6[] =
{
"                                   .''.       ",
"       .''.      .        *''*    :_\/_:     . ",
"      :_\/_:   _\(/_  .:.*_\/_*   : /\ :  .'.:.'.",
"  .''.: /\ :   ./)\   ':'* /\ * :  '..'.  -=:o:=-",
" :_\/_:'.:::.  | ' *''*    * '.\'/.' _\(/_'.':'.'",
" : /\ : :::::  =  *_\/_*     -= o =-  /)\    '  *",
"  '..'  ':::' === * /\ *     .'/.\'.   '._____",
"      *        |   *..*         :       |.   |' "
};
*/
void fireoil_update( void )
{
    OBJ_DATA *obj;
    OBJ_DATA *obj_next;
    CHAR_DATA *vch;
    char buf[MSL];

    for ( obj = object_list; obj != NULL; obj = obj_next )
    {
		obj_next = obj->next;
    	if ( obj->item_type != ITEM_FIREOIL )
		    continue;
	    if ( obj->value[1] == 1 )
    	{
		    if ( obj->value[0] > 0 )
		    {
			    obj->value[0]--;
    		}
    		else
    		{
			    for (vch=obj->in_room->people;vch!=NULL;vch=vch->next_in_room)
			    {
					if ( IS_NPC(vch) && vch->pIndexData->pShop )
						continue;
					if ( saves_spell( vch->level / 2, vch, DAM_NEGATIVE ) )
						continue;
				    sprintf( buf, "%s erupts in thunder and a shower of sparks!\n\r",capitalize(obj->short_descr));
				    stc(buf,vch);
				    switch( number_range( 1, 5 ) )
				    {
						case 1:
						    stc( *illumine_1, vch );
						break;
						case 2:
						    stc( *illumine_2, vch );
						break;
						case 3:
						    stc( *illumine_3, vch );
						break;
						case 4:
						    stc( *illumine_4, vch );
						break;
						case 5:
						    stc( *illumine_5, vch );
						break;
					}
					extract_obj( obj );
			    }
			}
	    }
    }
    return;
}

EVENT_DATA	*events;

#define kill_event \
				if(!ev_next)  {   free_event(ev); return; }  \
				if(ev_last!=NULL) ev_last->next=ev_next;  \
				             else events=ev_next;  \
				free_event(ev);  \
				continue;

/*
 * Handle events.
 */
void event_update(void)
{
   EVENT_DATA *ev = NULL, *ev_next, *ev_last = ev;


   if(!events) return;

   for( ev = events; ev; ev = ev_next)
   {
        ev_next = ev->next;
        if(ev->delay-- <= 0)
        {
            switch(ev->action)
            {
                case ACTION_PRINT:
                  if( ( !ev->args[0]) || (! ev->argv[0] ) )
                  {
                      kill_event
                  }
                  stc( ev->args[0], ev->argv[0] );
                  break;

                case ACTION_FUNCTION:
                  if( !ev->args[0] )
                  {
                      kill_event
                  }
                  do_function(ev->argv[0], ev->do_fun, ev->args[0]);
                  break;

                case ACTION_WAIT:
                  if(!ev->argv[0])
                  {
                      kill_event
                  }
                  WAIT_STATE(ev->to,PULSE_PER_SECOND*ev->argi[0]);
                  break;

                case ACTION_ACT:
                  if(!ev->args[0] || !ev->argv[0])
                  {
                       kill_event
                  }
                  act(ev->args[0], ev->argv[0], ev->argv[1],ev->argv[2],ev->argi[0]);
                  break;
            }

            if(!ev_next)
            {
                 if( (ev != events) && (ev_last != NULL) )
                 {
                      if( ev_last->next == ev )
                         ev_last->next=NULL;
                 }
                 else
                 {
                 if( ev == events)
                    events = NULL;
                 }
                 free_event( ev );
                 return;
            }

            if( ev_last != NULL)
                ev_last->next = ev_next;
            else
                events = ev_next;

            free_event( ev );
            continue;
        } /* end delay */

        ev_last = ev;

   } /* end loop */
return;
}


void idle_check( CHAR_DATA *ch )
{
	/*
 	 * First check to see if a character needs to save and if they can.
	 */
	if ( ch )
	{
		if ( ch->desc != NULL && ch->desc->descriptor % 30 == save_number )
		{
			if ( IS_SET( ch->auto_flags, AUTO_SAVEMESSAGE ) )
				stc( "Autosaving your character...\n\r", ch );
			//save_char_obj( ch );
			save_char_obj(ch, FALSE, FALSE);
		}
	}

	/*
 	 * Now kick out goofy fuckers who sit idle.
	if ( ch )
	{
		if ( ch->timer >= 30 )
		{
			logf( "Extracting %s. Timer exceeded:: %d....\n\r", ch->name, ch->timer );
			extract_char( ch, TRUE );
			return;
	    }
	}
	 */

	/*
 	 * And finaly if someone is linkdead, nuke the bastages.
	if ( ch )
	{
		if ( ch->desc == NULL && !IS_NPC( ch ) )
		{
			logf( "Extracting:: no descriptor", 0 );
			extract_char( ch, TRUE );
		}
	}
	 */
	return;
}
void pc_update( void )
{
    DESCRIPTOR_DATA *d;
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		/* update those in lockers */
		if ( d->connected != CON_PLAYING )
		{
			continue;
		}
		if ( !d->character )
		{
			continue;
		}
		if ( !d->character->pcdata )
		{
			continue;
		}

		/* update anyone in a vault */
		if ( d->character->pcdata->in_vault )
			do_function( d->character, &do_locker, "close" );

	 /* is tired of shaving --SIL */
	/* Everyone is - Rokann
		if(!IS_IMMORTAL(d->character)) 
		{
		    // update those with beards
		    if ( d->character->pcdata->true_sex == SEX_MALE
		    && d->character->pcdata->beard < BEARD_MAX-1
		    && beard_number == 90 )
		    {
			//logf( "Updating %s's beard.", d->character->name );
			d->character->pcdata->beard += 1;
		    }
		    // update those with hair styles
		    if ( d->character->pcdata->true_sex == SEX_FEMALE
		    && d->character->pcdata->hair < HAIR_MAX-1
		    && beard_number == 90 )
		    {
			//logf( "Updating %s's hair.", d->character->name );
			d->character->pcdata->hair += 1;
		    }
		}
*/

		/* update those with addictions */
		if ( d->character->pcdata->addict )
		{
			if ( d->character->pcdata->addict_hours <= 0 )
			{
				d->character->pcdata->addict = FALSE;
				d->character->pcdata->addict_hours = 0;
				stc( "{YYou're no longer an {yaddict{Y!{x\n\r", d->character );
			}
			d->character->pcdata->addict_hours--;
		}

		/* update the bad people in jail */
		/*
		if ( d->character->pcdata->jail_timer > ( d->character->pcdata->warning * 15 )
		&& IS_SET( d->character->penalty_flags,PENAL_JAILED )
		&& d->character->desc != NULL )
		{
			stc("You are released from the stockades.",d->character);
			if ( IS_SET( d->character->penalty_flags,PENAL_JAILED ) )
				REMOVE_BIT( d->character->penalty_flags,PENAL_JAILED );
			if ( IS_SET( d->character->act,PLR_FREEZE ) )
				REMOVE_BIT( d->character->act,PLR_FREEZE );
			d->character->pcdata->jail_timer = 0;
		}
		else if ( jtimer >= 50
		&& IS_SET( d->character->penalty_flags,PENAL_JAILED )
		&& d->character->desc != NULL )
		{
			stc("You are released from the stockades.",d->character);
			if ( IS_SET( d->character->penalty_flags,PENAL_JAILED ) )
				REMOVE_BIT( d->character->penalty_flags,PENAL_JAILED );
			if ( IS_SET( d->character->act,PLR_FREEZE ) )
				REMOVE_BIT( d->character->act,PLR_FREEZE );
			d->character->pcdata->jail_timer = 0;
		}

		else if ( IS_SET( d->character->penalty_flags, PENAL_JAILED ) )
		{
			stc("You are in the stockades as penalty for a crime or policy violation.\n\r",d->character);
			stc("Crimes may include murder of players inside a city, theft and others.\n\r",d->character);
			stc("If you violated a policy you are here because you have been warned\n\r",d->character);
			stc("too many times. The only way out is to wait. No one will release you.\n\r",d->character);
		}
*/
		if ( d->character->pcdata->jail_timer <= 0
		&& IS_SET( d->character->penalty_flags,PENAL_JAILED )
		&& d->character->desc != NULL )
		{
			stc("You are released from the stockades.",d->character);
			if ( IS_SET( d->character->penalty_flags,PENAL_JAILED ) )
				REMOVE_BIT( d->character->penalty_flags,PENAL_JAILED );
			if ( IS_SET( d->character->act,PLR_FREEZE ) )
				REMOVE_BIT( d->character->act,PLR_FREEZE );
			d->character->pcdata->jail_timer = 0;
		}
		else if ( IS_SET( d->character->penalty_flags, PENAL_JAILED ) &&d->character->desc != NULL)
		{
			stc("You are in the stockades as penalty for a crime or policy violation.\n\r",d->character);
			stc("Crimes may include murder of players inside a city, theft and others.\n\r",d->character);
			stc("If you violated a policy you are here because you have been warned\n\r",d->character);
			stc("too many times. The only way out is to wait. No one will release you.\n\r",d->character);
			d->character->pcdata->jail_timer--;
		}
		/* update the little newbie dudes */
		if ( IS_SET( d->character->auto_flags,AUTO_HINTS ) )
		{
			int num = number_range(1,50);
			switch( num )
			{
				/* these help entries have to exist, loaded into aww.are */
				default: break;
				case 1: do_function(d->character, &do_help, "newbie_entry01"); break;
				case 2: do_function(d->character, &do_help, "newbie_entry02"); break;
				case 3: do_function(d->character, &do_help, "newbie_entry03"); break;
				case 4: do_function(d->character, &do_help, "newbie_entry04"); break;
				case 5: do_function(d->character, &do_help, "newbie_entry05"); break;
				case 6: do_function(d->character, &do_help, "newbie_entry06"); break;
			    case 7: do_function(d->character, &do_help, "newbie_entry07"); break;
			    case 8: do_function(d->character, &do_help, "newbie_entry08"); break;
			    case 9: do_function(d->character, &do_help, "newbie_entry09"); break;
			    case 10: do_function(d->character, &do_help, "newbie_entry10"); break;
			    case 11: do_function(d->character, &do_help, "newbie_entry11"); break;
			    case 12: do_function(d->character, &do_help, "newbie_entry12"); break;
			    case 13: do_function(d->character, &do_help, "newbie_entry13"); break;
			    case 14: do_function(d->character, &do_help, "newbie_entry14"); break;
			    case 15: do_function(d->character, &do_help, "newbie_entry15"); break;
			    case 16: do_function(d->character, &do_help, "newbie_entry16"); break;
			    case 17: do_function(d->character, &do_help, "newbie_entry17"); break;
			    case 18: do_function(d->character, &do_help, "newbie_entry18"); break;
			    case 19: do_function(d->character, &do_help, "newbie_entry19"); break;
			    case 20: do_function(d->character, &do_help, "newbie_entry20"); break;
			    case 21: do_function(d->character, &do_help, "newbie_entry21"); break;
			    case 22: do_function(d->character, &do_help, "newbie_entry22"); break;
			    case 23: do_function(d->character, &do_help, "newbie_entry23"); break;
			    case 24: do_function(d->character, &do_help, "newbie_entry24"); break;
			    case 25: do_function(d->character, &do_help, "newbie_entry25"); break;
			}
		}

		/* throw a nifty void message to the char */
		if (is_affected(d->character, gsn_void))
		{
		    if (d->character->hit < d->character->max_hit)
			    stc("{cYou float inside the {wVoid{c, the pain of your wounds far distant.\n\r",d->character);
			else
		    	stc("{cYou float inside the Void.\n\r",d->character);
		}

    	if ( buf_string(d->character->pcdata->buffer)[0] != '\0' )
			stc("You have messages waiting. Type REPLAY to read them.\n\r",d->character);

		if ( IS_SET( d->character->war_flags, WAR_MENTOR )
		&& d->character->pcdata->concentration < 9 )
			d->character->pcdata->concentration++;
		else if ( ( IS_IMMORTAL( d->character ) || IS_SET( d->character->war_flags, WAR_MODERATOR ) )
		&& d->character->pcdata->concentration < 9 )
			d->character->pcdata->concentration = 9;
		else if ( d->character->pcdata->concentration < 3 )
			d->character->pcdata->concentration++;

		/* update the happy campers */
		/* this is broken
		if ( ch->camp_room == ch->in_room || ch->camp_room != NULL )
		{
			mod = get_skill( ch, gsn_camping );
			mod += ( get_curr_stat( ch, STAT_INS ) / 2 );
			mod += ( get_curr_stat( ch, STAT_WIS ) / 2 );
			mod += ( get_curr_stat( ch, STAT_INT ) / 3 );

			if ( get_skill( ch, gsn_tracking ) > 0 )
				mod += get_skill( ch, gsn_tracking );
			if ( get_skill( ch, gsn_search ) > 0 )
			mod += get_skill( ch, gsn_search );
			stc("You break your camp.\n\r", ch );
			act("$n breaks camp.",ch,NULL,NULL,TO_ROOM);
			if ( IS_SET( ch->camp_room->room_flags,ROOM_CAMP ) )
			{
				REMOVE_BIT( ch->camp_room->room_flags, ROOM_CAMP );
				ch->camp_room->heal_rate -= mod;
				ch->camp_room->mana_rate -= mod;
				ch->camp_room = NULL;
				ch->camp_timer = 0;
			}
		}
		*/
		idle_check( d->character );
	}
}
void afk_message( CHAR_DATA *ch )
{
	if (!IS_SET(ch->comm,COMM_AFK) && !IS_IMMORTAL( ch ) )
	{
		int afk_num = number_range( 1, 9 );
		switch( afk_num )
		{
			case 1:
				stc("{W***{c Since you have been idle for so long, you will be placed in {rAFK{c mode.\n\r",ch);
			break;
			case 2:
				stc("{W***{c Because you have been idling for so long, you are being placed in {rAFK{c mode.\n\r",ch);
			break;
			case 3:
				stc("{W***{c You will now go AFK because you have been idle for so long.\n\r",ch);
			break;
			case 4:
				stc("{W***{c You have been idle for so long that you are considered {rAFK{c mode.\n\r",ch);
			break;
			case 5:
				stc("{W***{c Your character has been idle for a long time so you are now {rAFK{c.\n\r",ch);
			break;
			case 6:
				stc("{W***{c *Knock Knock!* Anybody home? Guess not, so away from keyboard we go!\n\r",ch);
			break;
			case 7:
				stc("{W***{c It's kind of hard to play when you're away. AFK mode implemented.\n\r",ch);
			break;
			case 8:
				stc("{W***{c *Tsk Tsk* Idle for so long...\n\r",ch);
			break;
			case 9:
				stc("{W***{c HELLOOo HELLOo HELLoo HELloo HElloo Helloo?\n\r",ch);
			break;
		}
	}
}
/*
 * Update all chars, including mobs.
 */
void char_update( void )
{
	CHAR_DATA *ch, *ch_next, *ach;

//	beard_number++;
	camp_number++;
	jtimer++;
	addictTimer++;
	vtimer++;

	if ( ++vtimer >= 10 )
	{
		vtimer = 0;
	}
/*
	if ( beard_number > 180 )
	{
		beard_number = 0;
	}
*/
	if ( camp_number >= 10 )
	{
		camp_number = 0;
	}
	pc_update();


	for ( ch = char_list; ch != NULL; ch = ch_next )
	{
		ch_next = ch->next;

		if ( ch->position == POS_DEAD )
			raw_kill(ch, ch);

		if ( IS_NPC( ch ) )
		{
			if ( ch->advancing == TRUE )
			{
				if ( ch->advancing_on != NULL )
				{
					ach = ch->advancing_on;
					if ( !ach || !ach->desc )
						ch->advancing_on = NULL;
					if ( ach && ch && ach->in_room != NULL && ch->in_room != NULL )
					{
						if ( ach->in_room != ch->in_room )
						{
							ch->advancing = FALSE;
							if ( check_fighting(ch, ach) )
								stop_fighting(ch, ach);
						}
					}
				}
			}

		        if (!is_fighting(ch))
		        {
/*
		                if (ch->target != NULL)
		                {
		                        ch->aggro--;
		                        if (ch->aggro <= 0)     ch->target = NULL;
		                }
*/
		                if (ch->master != NULL && ch->in_room != ch->master->in_room)
		                {
                		        char_from_room(ch);
		                        char_to_room(ch, ch->master->in_room);
		                        act("$n has arrived.", ch, NULL, NULL, TO_ROOM);
		                }
		        }


		}

		if ( !IS_NPC( ch ) && is_fighting(ch) && ch->advancing == FALSE )
		{
		    if ( is_fighting(ch) && !ch->advancing_on->in_room )
			    stop_all_fighting( ch );

		    if ( is_fighting(ch)
		    && ch->advancing_on->in_room != NULL
		    && ch->advancing_on->in_room != ch->in_room )
			    stop_all_fighting( ch );

			if ( ch->advancing && !ch->advancing_on )
			{
				ch->advancing = FALSE;
				ch->advancing_on = NULL;
			}

			if ( ch->advancing_on != NULL
			&& ch->in_room != NULL
			&& ch->advancing_on->in_room != NULL )
				ch->advancing_on = NULL;
		}

		if ( ch && ch->pcdata )
		{
			if ( ch->pcdata->accept_follower_name != NULL )
			{
				stc( "You give up on your grouping attempt.\n\r", ch );
				ch->pcdata->accept_follower_name = NULL;
			}
		}
	}

    /* update save counter */
    save_number++;

    if (save_number > 29)
	save_number = 0;

    for ( ch = char_list; ch != NULL; ch = ch_next )
    {
		AFFECT_DATA *paf;
		AFFECT_DATA *paf_next;
		AFFECT_DATA *af;

		ch_next = ch->next;

		if ( ch )
		{
			if ( ch->position >= POS_STUNNED )
			{
	            /* check to see if we need to go home */
	            if (IS_NPC(ch) && ch->zone != NULL && ch->zone != ch->in_room->area
	            && ch->desc == NULL &&  !is_fighting(ch)
			    && !IS_AFFECTED(ch,AFF_CHARM) && number_percent() < 5)
	            {
	            	act("{c$n wanders on home.",ch,NULL,NULL,TO_ROOM);
	            	extract_char(ch,TRUE);
	            	continue;
	            }

			    if ( ch->hit  < get_maxhit(ch) )
					ch->hit  += hit_gain(ch);
			    else
					ch->hit = get_maxhit(ch);

			    if ( ch->stam < get_maxstam(ch) )
					ch->stam += stam_gain(ch);
			    else
					ch-> stam = get_maxstam(ch);
			}
			if ( ch->hit < 0 )
			{
			/*	ch->hit -= 1; */
				ch->position = POS_STUNNED;
			}

			if ( ch->position == POS_STUNNED )
			    update_pos( ch );

			if ( !IS_NPC(ch) && !IS_IMMORTAL(ch) )
			{
			    OBJ_DATA *obj;

			    if ( ( obj = get_eq_char( ch, WEAR_LIGHT ) ) != NULL
			    &&   obj->item_type == ITEM_LIGHT
			    &&   obj->value[2] > 0 )
			    {
					if ( --obj->value[2] == 0 && ch->in_room != NULL )
					{
					    --ch->in_room->light;
					    act( "{c$p goes out.", ch, obj, NULL, TO_ROOM );
					    act( "{c$p flickers and goes out.", ch, obj, NULL, TO_CHAR );
					    extract_obj( obj );
					}
				 	else if ( obj->value[2] <= 5 && ch->in_room != NULL)
					    act("{c$p flickers.",ch,obj,NULL,TO_CHAR);
			    }

			    if ( ++ch->timer >= 15 )
			    {
				    if ( ch->was_in_room == NULL && ch->in_room != NULL )
		    		{
			    	    ch->was_in_room = ch->in_room;
			        if ( is_fighting(ch) )
					        stop_all_fighting( ch );
		    		    if (ch->level > 1)
			    	        //save_char_obj( ch );
					save_char_obj(ch, FALSE, FALSE);
			    	    afk_message( ch );
			    	    if ( !IS_SET( ch->comm, COMM_AFK ) )
		                    do_function( ch, &do_afk, "" );
			    	}
	    		}
		    }
		    gain_condition( ch, COND_DRUNK,  -1 );

			for ( paf = ch->affected; paf != NULL; paf = paf_next )
			{
			    paf_next	= paf->next;
			    if ( paf->duration > 0 )
			    {
					paf->duration--;
					if (number_range(0,4) == 0 && paf->level > 0)
						paf->level--;  /* spell strength fades with time */
				}
			    else if ( paf->duration < 0 )
				;
			    else
			    {
					if ( paf_next == NULL
					||   paf_next->type != paf->type
					||   paf_next->duration > 0 )
					{
					    if ( paf->type > 0 && skill_table[paf->type].msg_off )
					    {
							stc( skill_table[paf->type].msg_off, ch );
							stc( "\n\r", ch );
					    }
					}
					affect_remove( ch, paf );
			    }
			}

			if ( (af = affect_find(ch->affected,gsn_plague)) != NULL )
			{
				CHAR_DATA *vch;
				int dam = af->level;

				if (ch->in_room != NULL)
				act("{c$n writhes in agony as plague sores erupt from $s skin.",ch,NULL,NULL,TO_ROOM);
				stc("{cYou writhe in agony from the plague.\n\r",ch);

				af = new_affect();
				af->where	 = TO_AFFECTS;
				af->type      = gsn_poison;
				af->level 	 = dam / 5;
				af->duration  = 2;
				af->location  = APPLY_STR;
				af->modifier  = -2;
				af->bitvector = AFF_POISON;
				affect_join( ch, af );

				for ( vch = ch->in_room->people; vch != NULL; vch = vch->next_in_room)
				{
					if (!saves_spell(dam - 2,vch,DAM_DISEASE)
					&&  !IS_IMMORTAL(vch)
					&&  !IS_AFFECTED(vch,AFF_PLAGUE) && number_bits(4) == 0)
					{
						stc("{rYou feel hot and feverish.{c\n\r",vch);
						act("{c$n shivers and looks very ill.{c",vch,NULL,NULL,TO_ROOM);
					}
				}

				dam = UMIN(ch->level,af->level/5+1);
				ch->stam -= dam;
				damage( ch, ch, dam, gsn_plague,DAM_DISEASE,FALSE);
			}
			
			if ( (af = affect_find(ch->affected,gsn_poison)) != NULL )
			{
				if (af != NULL)
				{
					act( "{c$n shivers and suffers.", ch, NULL, NULL, TO_ROOM );
					stc( "{rYou shiver and suffer.{c\n\r", ch );
					damage(ch,ch,af->level/10 + 1,gsn_poison, DAM_POISON,FALSE);
				}
			}

			if (ch == NULL)	continue;
			update_pos(ch);

			if ( ch->position == POS_DEAD )
				damage( ch, ch, 10, TYPE_UNDEFINED, DAM_NONE,FALSE);

			if (ch == NULL)	continue;

			if ( ch->position == POS_INCAP && number_range(0,1) == 0)
			    damage( ch, ch, 2, TYPE_UNDEFINED, DAM_NONE,FALSE);
			else if ( ch->position == POS_MORTAL )
			    damage( ch, ch, 2, TYPE_UNDEFINED, DAM_NONE,FALSE);
			else	ch->hit++;

			if (ch == NULL)	continue;

			update_pos(ch);

			if (ch == NULL)	continue;

			//ptc(ch,"Your pos is %d\n\r",ch->position);

		}


		/*
	 	 * First check to see if a character needs to save and if they can.

		if ( ch )
		{
			if ( ch->desc != NULL && ch->desc->descriptor % 30 == save_number )
			{
				stc( "Autosaving...\n\r", ch );
				save_char_obj( ch );
			}
		}*/

		/*
	 	 * Now kick out goofy fuckers who sit idle.
		 */
		if ( ch && !IS_NPC(ch) ) /* no sense forcing q3 mobs to do_quit */
		{
			if ( ch->timer >= 30 ) /*|| ( ch->desc == NULL && !IS_NPC( ch ) ) )*/
			{
				logf( "Extracting %s. Timer exceeded or NULL desc...\n\r", ch->name );
				do_function( ch, &do_quit, "" );
				/* Why would the below line have been commented out? -- Dalsor 12/28/2012 */
				extract_char( ch, TRUE );
				continue;
		    }
		}
	}

	return;
}




/*
 * Update all objs.
 * This function is performance sensitive.
 */
void obj_update( void )
{
    OBJ_DATA *obj;
    OBJ_DATA *obj_next;
    AFFECT_DATA *paf, *paf_next;

    for ( obj = object_list; obj != NULL; obj = obj_next )
    {
	CHAR_DATA *rch;
	char *message;

	obj_next = obj->next;
	if ( obj->item_type == ITEM_PORTAL && !IS_SET(obj->extra_flags,ITEM_HAD_TIMER) ) continue;
	/* go through affects and decrement */
        for ( paf = obj->affected; paf != NULL; paf = paf_next )
        {
            paf_next    = paf->next;
            if ( paf->duration > 0 )
            {
                paf->duration--;
                if (number_range(0,4) == 0 && paf->level > 0)
                  paf->level--;  /* spell strength fades with time */
            }
            else if ( paf->duration < 0 )
                ;
            else
            {
                if ( paf_next == NULL
                ||   paf_next->type != paf->type
                ||   paf_next->duration > 0 )
                {
                    if ( paf->type > 0 && skill_table[paf->type].msg_obj )
                    {
			if (obj->carried_by != NULL)
			{
			    rch = obj->carried_by;
			    act(skill_table[paf->type].msg_obj,
				rch,obj,NULL,TO_CHAR);
			}
			if (obj->in_room != NULL
			&& obj->in_room->people != NULL)
			{
			    rch = obj->in_room->people;
			    act(skill_table[paf->type].msg_obj,
				rch,obj,NULL,TO_ALL);
			}
                    }
                }

                affect_remove_obj( obj, paf );
            }
        }

	/*
	 * Oprog triggers!
	 */
	if ( obj->in_room || (obj->carried_by && obj->carried_by->in_room))
	{
	    if ( HAS_TRIGGER_OBJ( obj, TRIG_DELAY )
	      && obj->oprog_delay > 0 )
	    {
	        if ( --obj->oprog_delay <= 0 )
		    p_percent_trigger( NULL, obj, NULL, NULL, NULL, NULL, TRIG_DELAY );
	    }
	    else if ( ((obj->in_room && !obj->in_room->area->empty)
	    	|| obj->carried_by ) && HAS_TRIGGER_OBJ( obj, TRIG_RANDOM ) )
		    p_percent_trigger( NULL, obj, NULL, NULL, NULL, NULL, TRIG_RANDOM );
	 }
	/* Make sure the object is still there before proceeding */
	if ( !obj )
	    continue;

	if ( obj->timer <= 0 || --obj->timer > 0 )
	    continue;

	if ( obj->item_type == ITEM_TREASURECHEST )
	{
		if ( obj->in_obj != NULL )
		continue;
	}
	switch ( obj->item_type )
	{
	default:              message = "{c$p crumbles into dust.";  break;
	case ITEM_FOUNTAIN:   message = "{c$p dries up.";         break;
	case ITEM_CORPSE_NPC: message = "{c$p decays into dust."; break;
	case ITEM_CORPSE_PC:  message = "{c$p decays into dust."; break;
	case ITEM_FOOD:       message = "{c$p decomposes.";	break;
	case ITEM_POTION:     message = "{c$p has evaporated from disuse.";
								break;
	case ITEM_PORTAL:     message = "{c$p fades out of existence."; break;
	case ITEM_CONTAINER:
	    if (CAN_WEAR(obj,ITEM_WEAR_FLOAT))
		if (obj->contains)
		    message =
		"{c$p flickers and vanishes, spilling its contents on the floor.";
		else
		    message = "{c$p flickers and vanishes.";
	    else
		message = "{c$p crumbles into dust.";
	    break;
	}

	if ( obj->carried_by != NULL )
	{
	    if (IS_NPC(obj->carried_by)
	    &&  obj->carried_by->pIndexData->pShop != NULL)
		obj->carried_by->money[3][0] += obj->cost/5;
	    else
	    {
	    	act( message, obj->carried_by, obj, NULL, TO_CHAR );
		if ( obj->wear_loc == WEAR_FLOAT)
		    act(message,obj->carried_by,obj,NULL,TO_ROOM);
	    }
	}
	else if ( obj->in_room != NULL
	&&      ( rch = obj->in_room->people ) != NULL )
	{
	    if (! (obj->in_obj && obj->in_obj->pIndexData->vnum == OBJ_VNUM_PIT
	           && !CAN_WEAR(obj->in_obj,ITEM_TAKE)))
	    {
	    	act( message, rch, obj, NULL, TO_ROOM );
	    	act( message, rch, obj, NULL, TO_CHAR );
	    }
	}

    if ((obj->item_type == ITEM_CORPSE_PC || obj->wear_loc == WEAR_FLOAT)
	&&  obj->contains)
	{   /* save the contents */
     	    OBJ_DATA *t_obj, *next_obj;

	    for (t_obj = obj->contains; t_obj != NULL; t_obj = next_obj)
	    {
		next_obj = t_obj->next_content;
		obj_from_obj(t_obj);

		if (obj->in_obj) /* in another object */
		    obj_to_obj(t_obj,obj->in_obj);

		else if (obj->carried_by)  /* carried */
		    if (obj->wear_loc == WEAR_FLOAT)
			if (obj->carried_by->in_room == NULL)
			    extract_obj(t_obj);
			else
			    obj_to_room(t_obj,obj->carried_by->in_room);
		    else
		    	obj_to_char(t_obj,obj->carried_by);

		else if (obj->in_room == NULL)  /* destroy it */
		    extract_obj(t_obj);

		else /* to a room */
		    obj_to_room(t_obj,obj->in_room);
	    }
	}

	extract_obj( obj );

    }

    return;
}

void aggr_update ( void )
{
     DESCRIPTOR_DATA    *d;
     CHAR_DATA          *wch;
     CHAR_DATA          *ch;
     CHAR_DATA          *ch_next;
     CHAR_DATA          *vch;
     CHAR_DATA          *vch_next;
     CHAR_DATA          *victim;

     /* Loop through world character list */
     for ( d = descriptor_list; d; d = d->next )
     {
          wch = d->character;

          /* Skip those not in the game. */
          /* Note writers had better be careful! */
          if ( d->connected != CON_PLAYING )
               continue;

          if ( !d || !d->character || !wch )
          	continue;

          if ( wch == NULL )
          	continue;

          /* If character is in NULL room, is NPC, is IMM or in empty area, skip */
          /* Also skip if the room is safe, don't need to cycle through mobs to find this out. */
          if ( IS_NPC ( wch ) || IS_IMMORTAL( wch ) || wch->in_room == NULL
               || wch->in_room->area->empty || IS_SET ( wch->in_room->room_flags, ROOM_SAFE ) )
               continue;

          /* Now look for mobs in the same room */
          for ( ch = wch->in_room->people; ch != NULL; ch = ch_next )
          {
               int                 count;

               ch_next = ch->next_in_room;

               if ( (!IS_NPC (ch) || is_fighting(ch)
                    || IS_AFFECTED ( ch, AFF_CALM ) || IS_AFFECTED ( ch, AFF_CHARM )
                    || !IS_AWAKE ( ch ) || (IS_SET ( ch->act, ACT_WIMPY ) && IS_AWAKE ( wch ))
                    || !can_see ( ch, wch )
                    || (number_bits ( 1 ) == 0 ))
                    || !IS_SET ( ch->act, ACT_AGGRESSIVE ))
                    continue;


               /*
                * Ok we have a 'wch' player character and a 'ch' npc aggressor.
                * Now make the aggressor fight a RANDOM pc victim in the room,
                *   giving each 'vch' an equal chance of selection.
                */
               count = 0;
               victim = NULL;
               for ( vch = wch->in_room->people; vch != NULL; vch = vch_next )
               {
                    vch_next = vch->next_in_room;

                    if ( !IS_NPC ( vch ) && !IS_IMMORTAL(vch)
                         /*vch->level < LEVEL_IMMORTAL*/
                         /*&& ch->level >= (vch->level /2)*/
                         && ( !IS_SET ( ch->act, ACT_WIMPY ) || !IS_AWAKE ( vch ) ) &&
                         can_see ( ch, vch )  && ((!IS_SET( ch->act, ACT_UNDEAD )) || (vch->questmob == ch->pIndexData->vnum)))
                    {
                         if ( number_range ( 0, count ) == 0 )
                              victim = vch;
                         count++;
                    }
               }

               if ( victim == NULL )
                    continue;
				/*if ( victim && ch->advancing == FALSE )
					ch->advancing = TRUE;
				if ( victim && ch->advancing_on == NULL )
					ch->advancing_on = victim;
                if ( victim != NULL )
                {
				    ch->advancing = TRUE;
				    ch->advancing_on = victim;
				    ch->range = RANGE_MELEE;

				    victim->advancing = TRUE;
				    victim->advancing_on = ch;
				    victim->range = RANGE_MELEE;
			        set_fighting( ch, victim );
				}*/
				start_extra_fight(ch, victim, RANGE_MELEE);
          }
     }
     return;
}


/*
 * Aggress.
 *
 * for each mortal PC
 *     for each mob in room
 *         aggress on some random PC
 *
 * This function takes 25% to 35% of ALL Merc cpu time.
 * Unfortunately, checking on each PC move is too tricky,
 *   because we don't the mob to just attack the first PC
 *   who leads the party into the room.
 *
 * -- Furey

void aggr_update( void )
{
    CHAR_DATA *wch;
    CHAR_DATA *wch_next;
    CHAR_DATA *ch;
    CHAR_DATA *ch_next;
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    CHAR_DATA *victim;

    for ( wch = char_list; wch != NULL; wch = wch_next )
    {
		wch_next = wch->next;
		if ( IS_NPC(wch)
		||   IS_IMMORTAL(wch)
		||   wch->in_room == NULL
		||   wch->in_room->area->empty)
		    continue;

		for ( ch = wch->in_room->people; ch != NULL; ch = ch_next )
		{
		    int count;

		    ch_next	= ch->next_in_room;

		    if ( !IS_NPC( ch ) )
		    continue;

		    if ( !IS_NPC(ch)
		    ||   !IS_SET(ch->act, ACT_AGGRESSIVE)
		    ||   IS_SET(ch->in_room->room_flags,ROOM_SAFE)
		    ||   IS_AFFECTED(ch,AFF_CALM)
		    ||   ch->fighting != NULL
		    ||   IS_AFFECTED(ch, AFF_CHARM)
		    ||   !IS_AWAKE(ch)
		    ||   ( IS_SET(ch->act, ACT_WIMPY) && IS_AWAKE(wch) )
		    ||   !can_see( ch, wch )
		    ||   number_bits(1) == 0)
		    {
				continue;
			}
		    count	= 0;
		    victim	= NULL;
		    for ( vch = wch->in_room->people; vch != NULL; vch = vch_next )
		    {
				vch_next = vch->next_in_room;

				if ( !IS_NPC(vch)
				&&   ( !IS_SET(ch->act, ACT_WIMPY) || !IS_AWAKE(vch) )
				&&   can_see( ch, vch ) )
				{
				    if ( number_range( 0, count ) == 0 )
						victim = vch;
				    count++;
				}
		    }

	        if (RIDDEN(ch))
		    {
				if (!mount_success(RIDDEN(wch), ch, FALSE))
				{
				    stc("Your mount escapes your control!\n\r", RIDDEN(ch));
				    if ( victim && ch->advancing == FALSE )
				    	ch->advancing = TRUE;
				    if ( victim && ch->advancing_on == NULL )
				    	ch->advancing_on = victim;
                    if ( victim != NULL )
                    {
				        set_fighting( ch, victim );
					    ch->advancing = TRUE;
					    ch->advancing_on = victim;
					    ch->range = RANGE_MELEE;

					    victim->advancing = TRUE;
					    victim->advancing_on = ch;
					    victim->range = RANGE_MELEE;
					}
				}
				else
				{
				    stc("You manage to keep your mount under control.\n\r", RIDDEN(ch));
				}
		    }
		    else
		    {
			    if ( victim && ch->advancing == FALSE )
			    	ch->advancing = TRUE;
			    if ( victim && ch->advancing_on == NULL )
			    	ch->advancing_on = victim;
                if ( victim != NULL )
                {
				    ch->advancing = TRUE;
				    ch->advancing_on = victim;
				    ch->range = RANGE_MELEE;

				    victim->advancing = TRUE;
				    victim->advancing_on = ch;
				    victim->range = RANGE_MELEE;
			        set_fighting( ch, victim );
				}
			}
		}
    }

    return;
}
*/

void update_clocks( void )
{
	DESCRIPTOR_DATA *d;
	OBJ_DATA *clock;
	OBJ_DATA *clock_next;
	CHAR_DATA *ch = NULL;
	char buf[MSL];
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		buf[0] = '\0';
		ch = d->character;
		if ( d->character == NULL )
			continue;
		if ( d->connected == CON_PLAYING )
		{
			for ( clock = ch->carrying; clock != NULL; clock = clock_next )
			{
			    clock_next = clock->next_content;
			    if ( clock->item_type == ITEM_CLOCK )
			    {
					sprintf( buf, "%s chimes %d times softly.", clock->short_descr, time_info.hour );
					act( buf, ch, NULL, NULL, TO_CHAR );
			    	break;
			    }
			}
		}
	}
}

void update_birthday(void)
{

 /* Voltecs player birthday system... - Voltec 98 *
  * Email voltec@cyberdude.com                    */

 /*for (d = descriptor_list; d != NULL; d = d->next)
     {
     if (d->connected == CON_PLAYING &&
         d->character->pcdata->birthday.day == time_info.day &&
         d->character->pcdata->birthday.month == time_info.month )
         {
         sprintf(buf, "%s is %d today! Happy Birthday %s!\n\r",
                 d->character->name, get_age(d->character), d->character->name );
         stc(buf, d->character);
         }
     }
 return;
}*/
return;
}

void olcautosave( void )
{
   AREA_DATA *pArea;

    save_area_list();

    for( pArea = area_first; pArea; pArea = pArea->next )
    {
        /* Save changed areas. */
        if ( IS_SET(pArea->area_flags, AREA_CHANGED) )
        {
            save_area( pArea );
            REMOVE_BIT( pArea->area_flags, AREA_CHANGED );
        }
    }
    return;
}

void ferry_update( void )
{
	DESCRIPTOR_DATA *d;
	DESCRIPTOR_DATA *d_to;

	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if ( d->connected == CON_PLAYING
		&& d->character->in_room != NULL
		&& !is_fighting(d->character) )
		{
#if 0
			/* from Tear to Illian */
			if ( d->character->in_room->vnum == SHIP_ROOM_TEAR_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_TEAR_FIRST));
			stc("\n\rThe ship travels smoothly through the water, leaving Tear behind.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_TEAR_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_TEAR_SECOND));
			stc("\n\rThe ship sails easily through smooth waters.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_TEAR_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_TEAR_THIRD));
			stc("\n\rA thin green line marks the shore in the distance.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_TEAR_THIRD )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_TEAR_LAST));
			stc("\n\rThe ship approaches the docks of Illian.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_TEAR_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_ILLIAN_DOCK));
			stc("\n\rThe ship docks at the port of Illian and readies for the trip to Ebou Dar.\n\r", d->character);
			}
			/* from Illian to Ebou Dar */
			else if ( d->character->in_room->vnum == SHIP_ROOM_ILLIAN_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_ILLIAN_FIRST));
			stc("\n\rThe ship leaves the port of Illian, bound for Ebou Dar.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_ILLIAN_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_ILLIAN_SECOND));
			stc("\n\rA thin green line marks the shore in the distance.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_ILLIAN_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_ILLIAN_THIRD));
			stc("\n\rA tall wave washes over the ship's deck.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_ILLIAN_THIRD )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_ILLIAN_LAST));
			stc("\n\rThe docks of Ebou Dar appear on the horizon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == SHIP_ROOM_ILLIAN_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_EBOU_DOCK));
			stc("\n\rThe ship docks in Ebou Dar and it's cargo is traded off onto a Seafolk raker.\n\r", d->character);
			}
			/* from Ebou Dar to Illian */
			else if ( d->character->in_room->vnum == SHIP_ROOM_EBOU_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_EBOU_FIRST ));
			stc("\n\rThe raker leaves the docks of Ebou Dar, speeding east towards Illian.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == RAKER_ROOM_EBOU_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_EBOU_SECOND ));
			stc("\n\rThe raker cuts through the choppy waves of the Sea of Storms.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == RAKER_ROOM_EBOU_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_EBOU_LAST ));
			stc("\n\rThe raker swiftly approaches the docks of Illian, towards the east.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == RAKER_ROOM_EBOU_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_EBOU_DOCK ));
			stc("\n\rThe raker ports in Illian, and readies it's cargo for Tear.\n\r", d->character);
			}
			/* Illian to Tear */
			else if ( d->character->in_room->vnum == RAKER_ROOM_EBOU_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_ILLIAN_FIRST ));
			stc("\n\rThe raker leaves Illian behind, bound for Tear.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == RAKER_ROOM_ILLIAN_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_ILLIAN_SECOND ));
			stc("\n\rA swift wind speeds the raker towards Tear.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == RAKER_ROOM_ILLIAN_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( RAKER_ROOM_ILLIAN_LAST ));
			stc("\n\rA flight of gulls pass overhead, heading north towards land.\n\r", d->character);
			}
			/* finally, loop back around */
			else if ( d->character->in_room->vnum == RAKER_ROOM_ILLIAN_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( SHIP_ROOM_TEAR_DOCK ));
			stc("\n\rThe raker ports in Tear and it's cargo is traded off onto a sailing ship.\n\r", d->character);
			}
			/* Tear to Aringill */
			else if ( d->character->in_room->vnum == BARGE_ROOM_TEAR_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TEAR_FIRST ));
			stc("\n\rThe barge moves away from the docks, the polesmen pushing it along.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TEAR_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TEAR_SECOND ));
			stc("\n\rThe polesmen steadily manuever the barge up the river.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TEAR_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN_DOCK ));
			stc("\n\rThe barge docks in Aringill.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN_FIRST ));
			stc("\n\rThe leaves the docks of Aringill and heads upriver to Tar Valon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN_SECOND ));
			stc("\n\rThe river's currents push steadily against the barge.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN_THIRD ));
			stc("\n\rThe smoking peak of Dragonmount appears on the horizon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN_THIRD )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN_LAST ));
			stc("\n\rThe barge nears the South Harbor of Tar Valon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TV_DOCK ));
			stc("\n\rThe barge docks in the South Harbor of Tar Valon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TV_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TV_FIRST ));
			stc("\n\rThe barge pushes it's way out into the currents of the river, leaving Tar Valon.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TV_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TV_SECOND ));
			stc("\n\rTar Valon and Dragonmount disappear in the north.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TV_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TV_THIRD ));
			stc("\n\rThe barge picks up speed as it enters the swift currents of the river.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TV_THIRD )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TV_FOURTH ));
			stc("\n\rThe northern docks of Aringill come into view.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_TV_FOURTH )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN2_DOCK ));
			stc("\n\rThe barge docks on the north side of Aringill.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN2_DOCK )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN2_FIRST ));
			stc("\n\rThe barge leaves the docks of Aringill and embarks south.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN2_FIRST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN2_SECOND ));
			stc("\n\rThe barge makes excellent progress, speeding along on the river's currents.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN2_SECOND )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_ARIN2_LAST ));
			stc("\n\rThe docks of Tear appear towards the not so distant south.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == BARGE_ROOM_ARIN2_LAST )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( BARGE_ROOM_TEAR_DOCK ));
			stc("\n\rThe barge docks on one of the many piers in Tear.\n\r", d->character);
			}
			else
#endif
			/* from Ebou Dar to Isle of Madmen */
			if ( d->character->in_room->vnum == 23000 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23001 ));
			stc("\n\rThe Raker sets sail from the docks of Ebou Dar.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23001 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23002 ));
			stc("\n\rThe Raker sets forth for the Sea of Storms.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23002 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23003 ));
			stc("\n\rThe Raker crests the top of a crashing wave.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23003 )
			{
			if ( chance(10) )
			{
			stc("A pirate vessel closes quickly on the Raker, sailors leaning over the bow to heave burning cannisters onto the deck.\n\r",d->character);
			stc("Fire scorches the masts and sails of the Raker even as it turns to speed away.\n\r",d->character);
			stc("You are caught in the flames, fire searing your flesh!\n\r",d->character);
			damage(d->character,d->character,1000,0,DAM_FIRE,FALSE);
			for ( d_to = descriptor_list; d_to != NULL; d_to = d_to->next )
			{
				if ( d_to->connected == CON_PLAYING
				&& d_to->character->in_room != NULL
				&& d_to->character->in_room == d->character->in_room
				&& !is_fighting(d_to->character) )
				{
					stc("A pirate vessel closes quickly on the Raker, sailors leaning over the bow to heave flaming oils onto the deck.\n\r",d->character);
					stc("Fire scorches the mast and sails of the Raker even as it turns to speed away.\n\r",d->character);
					if ( chance( 50 ) )
					{
						stc("You are caught in the flames, fire searing your flesh!\n\r",d->character);
						damage(d_to->character,d_to->character,1000,0,DAM_FIRE,FALSE);
					}
				}
			}
			}
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23004 ));
			stc("\n\rThe Raker sails smoothly through the Sea of Storms.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23004 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23005 ));
			stc("\n\rThe Raker weathers the Sea of Storms with ease.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23005 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23006 ));
			stc("\n\rThe Raker sails smoothly through the Sea of Storms.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23006 )
			{
			if ( chance(10) )
			{
			stc("A pirate vessel closes quickly on the Raker, sailors leaning over the bow to heave flaming oils onto the deck.\n\r",d->character);
			stc("Fire scorches the mast and sails of the Raker even as it turns to speed away.\n\r",d->character);
			stc("You are caught in the flames, fire searing your flesh!\n\r",d->character);
			damage(d->character,d->character,1000,0,DAM_FIRE,FALSE);
			for ( d_to = descriptor_list; d_to != NULL; d_to = d_to->next )
			{
				if ( d_to->connected == CON_PLAYING
				&& d_to->character->in_room != NULL
				&& d_to->character->in_room == d->character->in_room
				&& !is_fighting(d_to->character))
				{
					stc("A pirate vessel closes quickly on the Raker, sailors leaning over the bow to heave flaming oils onto the deck.\n\r",d->character);
					stc("Fire scorches the mast and sails of the Raker even as it turns to speed away.\n\r",d->character);
					if ( chance( 50 ) )
					{
						stc("You are caught in the flames, fire searing your flesh!\n\r",d->character);
						damage(d_to->character,d_to->character,1000,0,DAM_FIRE,FALSE);
					}
				}
			}
			}
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23007 ));
			stc("\n\rA sprays banks against the side of the ship from the Sea of Storms.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23007 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23008 ));
			stc("\n\rThe riggings creak as the ship continues its voyage south.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23008 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23009 ));
			stc("\n\rThe Raker lurches against the rolling waves.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23009 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23010 ));
			stc("\n\rA school of triangle-dorsaled fish leap into the air near the Raker.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23010 )
			{
			if ( chance(10) )
			{
			ptc(d->character,"A pirate vessel closes quickly on the Raker, a %s standing upon the bow, hands upraised.\n\r",
			chance(75) ? "black cloaked man" : "darkly robed woman" );
			stc("Fire rains down from the vessel, scorching the Raker even as it turns to speed away.\n\r",d->character);
			stc("You are caught in the flames, fire searing your flesh!\n\r",d->character);
			damage(d->character,d->character,1000,0,DAM_FIRE,FALSE);
			for ( d_to = descriptor_list; d_to != NULL; d_to = d_to->next )
			{
				if ( d_to->connected == CON_PLAYING
				&& d_to->character->in_room != NULL
				&& d_to->character->in_room == d->character->in_room
				&& !is_fighting(d_to->character) )
				{
					ptc(d->character,
					"A pirate vessel closes quickly on the Raker, a %s standing upon the bow, hands upraised.\n\r",
					chance(75) ? "black cloaked man" : "darkly robed woman" );
					stc("Fire rains down from the vessel, scorching the Raker even as it turns to speed away.\n\r",d_to->character);
					if ( chance( 50 ) )
					{
						stc("You are caught in the flames, fire searing your flesh!\n\r",d_to->character);
						damage(d_to->character,d_to->character,1000,0,DAM_FIRE,FALSE);
					}
				}
			}
			}
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23011 ));
			stc("\n\rThe ocean water undulates next to the great ship.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23011 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23012 ));
			stc("\n\rThe water churns under the force of the storm winds.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23012 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23013 ));
			stc("\n\rDarkened clouds dwarf the Raker.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23013 )
			{
			if ( chance(10) )
			{
			stc("Lightning strikes the main mast of the Raker, sending flaming splinters down upon the deck and crew.\n\r",d->character);
			stc("You are caught in the flaming shrapnel!\n\r",d->character);
			damage(d->character,d->character,1000,0,DAM_FIRE,FALSE);
			for ( d_to = descriptor_list; d_to != NULL; d_to = d_to->next )
			{
				if ( d_to->connected == CON_PLAYING
				&& d_to->character->in_room != NULL
				&& d_to->character->in_room == d->character->in_room
				&& !is_fighting(d_to->character) )
				{
					stc("Lightning strikes the main mast of the Raker, sending flaming splinters down upon the deck and crew.\n\r",d->character);
					if ( chance( 50 ) )
					{
						stc("You are caught in the flaming shrapnel!\n\r",d->character);
						damage(d_to->character,d_to->character,1000,0,DAM_FIRE,FALSE);
					}
				}
			}
			}
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23014 ));
			stc("\n\rHeavy winds buffet the Raker, tossing it to and fro.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23014 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23015 ));
			stc("\n\rThe Raker plows through the furious waves.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23015 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23016 ));
			stc("\n\rThe winds howl ominously through the riggings and a rope snaps as sailors rush to repair the damage.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23016 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23017 ));
			stc("\n\rThe masts creak and groan under the strain of the torturous winds.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23017 )
			{
			if ( chance(10) )
			{
			stc("A rigging snaps under the force of the winds, sending ropes flying like live snakes, whipping and slashing.\n\r",d->character);
			stc("You are caught and constricted by a snapping length of rope!\n\r",d->character);
			damage(d->character,d->character,1000,0,DAM_FIRE,FALSE);
			for ( d_to = descriptor_list; d_to != NULL; d_to = d_to->next )
			{
				if ( d_to->connected == CON_PLAYING
				&& d_to->character->in_room != NULL
				&& d_to->character->in_room == d->character->in_room
				&& !is_fighting(d_to->character) )
				{
					stc("A rigging snaps under the force of the winds, sending ropes flying like live snakes, whipping and slashing.\n\r",d->character);
					if ( chance( 50 ) )
					{
						stc("You are caught and constricted by a snapping length of rope!\n\r",d->character);
						damage(d_to->character,d_to->character,1000,0,DAM_FIRE,FALSE);
					}
				}
			}
			}
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23018 ));
			stc("\n\rCrewmen rush to fish a sailor from out of the water as a violent surge lifts the Raker into the air.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23018 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23019 ));
			stc("\n\rCalmer waters are welcomed by the crewmen who busy themselves repairing damage.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23019 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23020 ));
			stc("\n\rThe last of the repairs are finished by the crew and the Raker sets under full sail.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23020 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23021 ));
			stc("\n\rCrewmen prepare a catch of fish for today's dinner.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23021 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23022 ));
			stc("\n\rA general sense of duty settles over the Raker as the ship sails smoothly.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23022 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23023 ));
			stc("\n\rThe crew chatters expectantly among themselves, the last traces of anxiety gone.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23023 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23024 ));
			stc("\n\rLand appears as a thin line on the horizon to the south and southwest.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23024 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23025 ));
			stc("\n\rSailors unlash the supporting ropes from the landing craft the Raker carries.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23025 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 22804 ));
			stc("\n\rThe Sailmistress hurries the passengers onto the landing craft, ready to be back on the open sea.\n\r", d->character);
			}
#if 0
			/* Carysford to Illian */
			else if ( d->character->in_room->vnum == 23026 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23027 ));
			stc("\n\rA pair of deckhands begin to squabble over a game of dice.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23027 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23028 ));
			stc("\n\rThe riverboat lurches as it moves into an area of rapids.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23028 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23029 ));
			stc("\n\rThe riverboat enters into a heavily forested area and the scent of pine fills the air.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23029 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 23030 ));
			stc("\n\rThe city of Illian appears in the distance. Tall spires and great houses are easily seen.\n\r", d->character);
			}
			else if ( d->character->in_room->vnum == 23030 )
			{
		    char_from_room(d->character);
		    char_to_room(d->character,get_room_index( 5774 ));
			stc("\n\rThe riverboat docks in Illian and you are ushered off as deckhands unload cargo.\n\r", d->character);
			}
#endif
			/* end of the barge loop */
		}
	}
	return;
}

