/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "recycle.h"
#include "tables.h"
#include "war.h"

bool emptyStr( char * argument )
{
        if ( argument == NULL || argument[0] == '\0' )
                return TRUE;

        return FALSE;
}

void show_war_titles( CHAR_DATA *ch )
{
	int i;
	ptc( ch, "  Title               Required Honor Points\n\r" );
	ptc( ch, " -------------------+-----------------------\n\r" );
	for ( i = 0; warTitlesTable[i].title != NULL; i++ )
	{
		ptc( ch, "  %-19s %d\n\r", warTitlesTable[i].title, warTitlesTable[i].honor );
	}
	ptc( ch, " -------------------+-----------------------\n\r" );
	return;
}

int get_unit_strength( CHAR_DATA *ch, char *argument )
{
	int i, x, count = 0, off = 0, def = 0;
	bool found = FALSE;
	for ( x = 0; x < 15; x++ )
	{
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !str_cmp( ch->pcdata->war_footmen[i], argument ) )
			{
				count += ch->pcdata->war_footmen_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !str_cmp( ch->pcdata->war_pikemen[i], argument ) )
			{
				count += ch->pcdata->war_pikemen_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !str_cmp( ch->pcdata->war_archers[i], argument ) )
			{
				count += ch->pcdata->war_archers_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !str_cmp( ch->pcdata->war_cavalry[i], argument ) )
			{
				count += ch->pcdata->war_cavalry_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !str_cmp( ch->pcdata->war_channelers[i], argument ) )
			{
				count += ch->pcdata->war_channelers_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		if ( found )
			return ( ( off + def ) / 2 );
	}
	return ( ( off + def ) / 2 );
}
int new_get_unit_strength( CHAR_DATA *ch, char *argument, int type )
{
	int i;
	/*int x;*/
	int count = 0, off = 0, def = 0;
	/*int footmen[3], pikemen[3], archers[3], cavalry[3], channelers[3];
	bool found = FALSE;*/
	switch( type )
	{
		case 1:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( !str_cmp( ch->pcdata->war_footmen[i], argument ) )
				{
					count += ch->pcdata->war_footmen_num[i];
					off += ch->pcdata->war_unit_offense[i];
					def += ch->pcdata->war_unit_defense[i];
				}
				return ( ( off + def ) / 2 );
			}
		break;
		case 2:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( !str_cmp( ch->pcdata->war_pikemen[i], argument ) )
				{
					count += ch->pcdata->war_pikemen_num[i];
					off += ch->pcdata->war_unit_offense[i];
					def += ch->pcdata->war_unit_defense[i];
				}
				return ( ( off + def ) / 2 );
			}
		break;
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( !str_cmp( ch->pcdata->war_archers[i], argument ) )
				{
					count += ch->pcdata->war_archers_num[i];
					off += ch->pcdata->war_unit_offense[i];
					def += ch->pcdata->war_unit_defense[i];
				}
				return ( ( off + def ) / 2 );
			}
		case 3:
		break;
		case 4:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( !str_cmp( ch->pcdata->war_cavalry[i], argument ) )
				{
					count += ch->pcdata->war_cavalry_num[i];
					off += ch->pcdata->war_unit_offense[i];
					def += ch->pcdata->war_unit_defense[i];
				}
				return ( ( off + def ) / 2 );
			}
		break;
		case 5:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( !str_cmp( ch->pcdata->war_channelers[i], argument ) )
				{
					count += ch->pcdata->war_channelers_num[i];
					off += ch->pcdata->war_unit_offense[i];
					def += ch->pcdata->war_unit_defense[i];
				}
				return ( ( off + def ) / 2 );
			}
		break;
	}
	return ( ( off + def ) / 2 );
}
int count_army( CHAR_DATA *ch, bool return_strength )
{
	int i, x, count = 0, off = 0, def = 0, strength = 0;
	for ( x = 0; x < 15; x++ )
	{
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_footmen[i] ) )
			{
				count += ch->pcdata->war_footmen_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_pikemen[i] ) )
			{
				count += ch->pcdata->war_pikemen_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_archers[i] ) )
			{
				count += ch->pcdata->war_archers_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_cavalry[i] ) )
			{
				count += ch->pcdata->war_cavalry_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_channelers[i] ) )
			{
				count += ch->pcdata->war_channelers_num[i];
				off += ch->pcdata->war_unit_offense[x];
				def += ch->pcdata->war_unit_defense[x];
			}
		}
	}
	if ( return_strength )
	{
		strength = ( off + def ) / 2;
		return strength;
	}
	else
		return count;
}
bool has_color_codes( char *str )
{
	if ( !str || *str == '\0' )
		return FALSE;

	while ( *str != '\0' )
	{
		if ( *str == '{' )
		{
			return TRUE;
		}
		else
			str++;
	}
	return FALSE;
}
bool war_purchase_unit( CHAR_DATA *ch, char *type, char *unitname )
{
	int uType, cost, i;
	bool squad_found = FALSE;

	if ( !str_cmp( type, "footmen" ) )
	{
		uType = 1;
		cost = 1000;
	}
	else if ( !str_cmp( type, "pikemen" ) )
	{
		uType = 2;
		cost = 2500;
	}
	else if ( !str_cmp( type, "archers" ) )
	{
		uType = 3;
		cost = 2000;
	}
	else if ( !str_cmp( type, "cavalry" ) )
	{
		uType = 4;
		cost = 5000;
	}
	else if ( !str_cmp( type, "channelers" ) )
	{
		uType = 5;
		cost = 10000;
	}
	else
	{
		ptc( ch, "%s is not a valid unit type.\n\r", type );
		ptc( ch, "Valid types are Footmen, Pikemen, Archers, Cavalry, and Channelers.\n\r", type );
		ptc( ch, "Purchase what type of unit and name the company what?\n\r" );
		ptc( ch, "Example: war purchase cavalry 'Red Hand'\n\r" );
		return FALSE;
	}
	/* this may be causing a crash - 10.19.2005 -- Dalsor */
	if ( !check_coins( ch, cost, 0, 0 ) )
	{
		ptc( ch, "A squad of %s will cost %s gold.\n\rYou cannot afford that.\n\r", type, cost / 10 );
		return FALSE;
	}
	switch( uType )
	{
		case 1:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( emptyStr( ch->pcdata->war_footmen[i] ) )
				{
					free_string( ch->pcdata->war_footmen[i] );
					ch->pcdata->war_footmen[i] = str_dup( unitname );
					ch->pcdata->war_footmen_num[i] += 100;
					ch->pcdata->war_unit_offense[i] += 10;
					ch->pcdata->war_unit_defense[i] += 10;
					ptc( ch, "You add 100 footmen to your army.\n\r%s are ready for battle!\n\r",
						ch->pcdata->war_footmen[i] );
					squad_found = TRUE;
					break;
				}
				else
				{
					if ( !str_cmp( ch->pcdata->war_footmen[i], unitname ) )
					{
						ch->pcdata->war_footmen_num[i] += 100;
						ch->pcdata->war_unit_offense[i] += 10;
						ch->pcdata->war_unit_defense[i] += 10;
						ptc( ch, "You add 100 footmen to %s!\n\r",
							ch->pcdata->war_footmen[i] );
						squad_found = TRUE;
						break;
					}
				}
			}
		break;
		case 2:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( emptyStr( ch->pcdata->war_pikemen[i] ) )
				{
					free_string( ch->pcdata->war_pikemen[i] );
					ch->pcdata->war_pikemen[i] = str_dup( unitname );
					ch->pcdata->war_pikemen_num[i] += 100;
					ch->pcdata->war_unit_offense[i] += 15;
					ch->pcdata->war_unit_defense[i] += 20;
					ptc( ch, "You add 100 pikemen to your army.\n\r%s are ready for battle!\n\r",
						ch->pcdata->war_pikemen[i] );
					squad_found = TRUE;
					break;
				}
				else
				{
					if ( !str_cmp( ch->pcdata->war_pikemen[i], unitname ) )
					{
						ch->pcdata->war_pikemen_num[i] += 100;
						ch->pcdata->war_unit_offense[i] += 15;
						ch->pcdata->war_unit_defense[i] += 20;
						ptc( ch, "You add 100 pikemen to %s!\n\r",
							ch->pcdata->war_pikemen[i] );
						squad_found = TRUE;
						break;
					}
				}
			}
		break;
		case 3:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( emptyStr( ch->pcdata->war_archers[i] ) )
				{
					free_string( ch->pcdata->war_archers[i] );
					ch->pcdata->war_archers[i] = str_dup( unitname );
					ch->pcdata->war_archers_num[i] += 100;
					ch->pcdata->war_unit_offense[i] += 25;
					ch->pcdata->war_unit_defense[i] += 10;
					ptc( ch, "You add 100 archers to your army.\n\r%s are ready for battle!\n\r",
						ch->pcdata->war_archers[i] );
					squad_found = TRUE;
					break;
				}
				else
				{
					if ( !str_cmp( ch->pcdata->war_archers[i], unitname ) )
					{
						ch->pcdata->war_archers_num[i] += 100;
						ch->pcdata->war_unit_offense[i] += 25;
						ch->pcdata->war_unit_defense[i] += 10;
						ptc( ch, "You add 100 archers to %s!\n\r",
							ch->pcdata->war_archers[i] );
						squad_found = TRUE;
						break;
					}
				}
			}
		break;
		case 4:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( emptyStr( ch->pcdata->war_cavalry[i] ) )
				{
					free_string( ch->pcdata->war_cavalry[i] );
					ch->pcdata->war_cavalry[i] = str_dup( unitname );
					ch->pcdata->war_cavalry_num[i] += 100;
					ch->pcdata->war_unit_offense[i] += 30;
					ch->pcdata->war_unit_defense[i] += 30;
					ptc( ch, "You add 100 cavalry to your army.\n\r%s are ready for battle!\n\r",
						ch->pcdata->war_cavalry[i] );
					squad_found = TRUE;
					break;
				}
				else
				{
					if ( !str_cmp( ch->pcdata->war_cavalry[i], unitname ) )
					{
						ch->pcdata->war_cavalry_num[i] += 100;
						ch->pcdata->war_unit_offense[i] += 30;
						ch->pcdata->war_unit_defense[i] += 30;
						ptc( ch, "You add 100 cavalry to %s!\n\r",
							ch->pcdata->war_cavalry[i] );
						squad_found = TRUE;
						break;
					}
				}
			}
		break;
		case 5:
			for ( i = 0; i < MAX_UNITS; i++ )
			{
				if ( emptyStr( ch->pcdata->war_channelers[i] ) )
				{
					free_string( ch->pcdata->war_channelers[i] );
					ch->pcdata->war_channelers[i] = str_dup( unitname );
					ch->pcdata->war_channelers_num[i] += 1;
					ch->pcdata->war_unit_offense[i] += 50;
					ch->pcdata->war_unit_defense[i] += 30;
					ptc( ch, "You add a channeler to your army.\n\r%s are ready for battle!\n\r",
						ch->pcdata->war_channelers[i] );
					squad_found = TRUE;
					break;
				}
				else
				{
					if ( !str_cmp( ch->pcdata->war_channelers[i], unitname ) )
					{
						ch->pcdata->war_channelers_num[i] += 1;
						ch->pcdata->war_unit_offense[i] += 50;
						ch->pcdata->war_unit_defense[i] += 30;
						ptc( ch, "You add a channeler to %s!\n\r",
							ch->pcdata->war_channelers[i] );
						squad_found = TRUE;
						break;
					}
				}
			}
		break;
	}
	if ( !squad_found )
	{
		ptc( ch, "All divisions are spoken for. Add to an existing division.\n\r" );
		return FALSE;
	}
	else
	{
		deduct_cost( ch, cost, 0 );
		return TRUE;
	}
}
bool has_war_unit_name( CHAR_DATA *ch, char *argument )
{
	bool found = FALSE;
	int i;
	if ( !found )
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_footmen[i] ) && !str_cmp( ch->pcdata->war_footmen[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
	if ( !found )
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_pikemen[i] ) && !str_cmp( ch->pcdata->war_pikemen[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
	if ( !found )
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_archers[i] ) && !str_cmp( ch->pcdata->war_archers[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
	if ( !found )
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_cavalry[i] ) && !str_cmp( ch->pcdata->war_cavalry[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
	if ( !found )
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_channelers[i] ) && !str_cmp( ch->pcdata->war_channelers[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
	if ( found )
		return TRUE;
	else
		return FALSE;
}
char * get_war_unit( CHAR_DATA *ch, CHAR_DATA *enemy, char *argument )
{
	bool found = FALSE;
	if ( ch && enemy == NULL )
	{
		int i;
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( ch->pcdata->war_footmen[i] ) && !str_cmp( ch->pcdata->war_footmen[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
		if ( found )
			return ch->pcdata->war_footmen[i];
		else
			return NULL;
	}
	else if ( !ch && enemy != NULL )
	{
		int i;
		for ( i = 0; i < MAX_UNITS; i++ )
		{
			if ( !emptyStr( enemy->pcdata->war_footmen[i] ) && !str_cmp( enemy->pcdata->war_footmen[i], argument ) )
			{
				found = TRUE;
				break;
			}
		}
		if ( found )
			return enemy->pcdata->war_footmen[i];
		else
			return NULL;
	}
	else
		return NULL;
}
