/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"


extern int truePwr;
extern int trueOverPwr;
extern int ovrPwr;
extern int pwrBonus;
extern int angBonus;
extern char *target_name;


void weave_portal( int sn, int level, CHAR_DATA *ch, void *vo,int target)
{
	ROOM_INDEX_DATA *pRoomIndex = NULL;
    OBJ_DATA *portal;
     DESCRIPTOR_DATA *d_mentor;

	bool can_gate = FALSE;
	int a, numGates = 1;

	if ( IS_NPC(ch) )
		return;
	if ( IS_SET( ch->war_flags, WAR_BATTLE ) )
	{
		stc("You're currently in a battle.\n\r",ch);
		return;
	}
	if ( IS_SET( ch->war_flags, WAR_TOURNEY ) )
	{
		stc("You're currently in a tourney.\n\r",ch);
		return;
	}
    if (IS_SET (ch->pcdata->tag_flags, TAG_PLAYING | TAG_WAITING))
    {
      send_to_char ("Wait till the tag game is over.\n\r", ch);
      return;
    }
	/*stc("The weave fizzles and dies before the portal can be opened.\n\r",ch);
	return;*/
	if ( target_name[0] == '\0' )
	{
	stc("To must specify a memorized room as the location.\n\r",ch);
	return;
	}

	if ( !is_number(target_name) )
	{
		stc("You must specify a memorized location.\n\r",ch);
		return;
	}
	a = atoi(target_name);
	if( a < 0 || a >= MAX_BEACONS )
	{
	stc("Slot number out of range.\n\r", ch );
	return;
	}
	for( a = 0; a < MAX_BEACONS; a++ )
	{
		pRoomIndex = get_room_index( ch->pcdata->beacons[a] );
		if ( a == atoi(target_name) )
		{
		can_gate = TRUE;
		break;
		}
	}
	if (!can_gate)
	{
		stc("You can't gate there.\n\r",ch);
		return;
	}
	if ( truePwr < 10 )
	{
		stc("The One Power escapes your control and the gateway collapses, slicing you in two!\n\r",ch);
	    raw_kill( ch, ch );
		return;
	}
	if ( ch->pcdata && ch->pcdata->allowed == 0 )
    {
		stc( "You are not allowed to leave the school until a Staff member\n\r",ch);
		stc( "has granted you access to the game. You should be approached\n\r",ch);
		stc( "soon by a Mentor. If you are not approached within an hour or\n\r",ch);
		stc( "two, you may ask over OOC, or by sending a Note to Staff.\n\r",ch);
        for ( d_mentor = descriptor_list; d_mentor != NULL; d_mentor = d_mentor->next )
        {
	        if ( d_mentor->connected == CON_PLAYING
            && IS_SET( d_mentor->character->spec_flags,SPEC_MENTOR ) )
	        {
            act("{w({GMentor Alert{w){W::{x {G$N needs verification!{x",
            d_mentor->character,NULL,ch,TO_CHAR);
	        }
	    }
		return;
	}
	if ( true_op_average(ch) < 10 )
	{
		stc("The One Power escapes your control and the gateway collapses, slicing you in two!\n\r",ch);
	    raw_kill( ch, ch );
		return;
	}

    if ( ch->pcdata->in_vault )
    {
      do_function( ch, &do_locker, "close" );
    }
	if ( ch->advancing == TRUE
	|| ch->advancing_on != NULL
	|| ch->range != RANGE_NONE
	|| is_fighting(ch) )
	{
		stc( "You struggle, but you're too close to your enemy fully form the weave.\n\r", ch );
		return;
	}

    portal = create_object(get_obj_index(OBJ_VNUM_PORTAL),0);
    portal->value[0] = numGates + (truePwr / 10);
    /*portal->value[0] = 1 + ch->level / 100;*/
    /*portal->timer = 2 + level / 25;*/
    /*portal->value[3] = pRoomIndex;*/
    portal->value[3] = ch->pcdata->beacons[a];
    portal->timer = 3;
    SET_BIT(portal->extra_flags,ITEM_HAD_TIMER);

    obj_to_room(portal,ch->in_room);

    act("{c$p rises up from the ground.",ch,portal,NULL,TO_ROOM);
    act("{c$p rises up before you.",ch,portal,NULL,TO_CHAR);
}

