/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"
#include "tables.h"

int check_angreal args((CHAR_DATA *ch));
int true_op_average args((CHAR_DATA *ch));
void check_stat_improve args( ( CHAR_DATA *ch, int stat, int power ) );
/*
 * The kludgy global is for spells who want more stuff from command line.
 */
int truePwr;
int trueOverPwr;
int ovrPwr;
int pwrBonus;
int angBonus;


/* combat weaves */

void weave_thunder_blast( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Air, Fire */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
   op_bonus = ch->pcdata->op_fire+ch->pcdata->op_air;
	op_bonus /= 2;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 11 / 9;
    stc("You weave flows of air and fire.\n\r",ch);
    stc( "\n\rYour chest erupts in lancing pain!\n\r", victim );
    act("You hear thunder without a sound, while $N stumbles back, gripping their chest!",ch,NULL,victim,TO_ROOM );
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

void weave_thunder_strike( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Air, Fire */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250,256,264,270,277,285,293,301,309,
    315
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_fire+ch->pcdata->op_air;
	op_bonus /= 2;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 13 / 9;
    stc("You weave flows of air and fire.\n\r",ch);
    stc( "\n\rYour chest erupts in thunderous pain!\n\r", victim );
    act("You hear thunder without a sound, while $N stumbles back, their chest ripped open!",ch,NULL,victim,TO_ROOM );
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

void weave_thunder_lance( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Air, Fire */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250,256,264,270,277,285,293,301,309,
    315,324,333,342,351,360,369,378,392,401,
    410
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_fire+ch->pcdata->op_air;
	op_bonus /= 2;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 15 / 9;
    stc("You weave flows of air and fire.\n\r",ch);
    stc( "\n\rYour body convulses, wracked in burning pain!\n\r", victim );
    act("You hear thunder without a sound, while $N stumbles back, their body convulsing!",ch,NULL,victim,TO_ROOM );
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

void weave_geyser( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Water */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_water;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 8 / 7;

    stc("You weave flows of water\n\r",ch);
    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rA column of water erupts from the ground, smashing into you!\n\r", victim );
	    act("A column of water shoots up and strikes $N!",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rA column of water erupts from the ground, smashing into you as you duck under your shield!\n\r", victim );
	    act("A column of water shoots up and strikes $N as $E ducks under a shield!",ch,NULL,victim,TO_ROOM );
	}

    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

void weave_drown( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Water */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250,255,260,265,270,275,280,285,290,
    295
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_water;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 10 / 9;
    stc("You weave flows of water\n\r",ch);
    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rYour lungs fill with water, you can't breathe!\n\r", victim );
	    act("$N begins to cough and sputter, they seem to be drowning!",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rYour lungs fill with water, you can't breathe!\n\r", victim );
	    act("$N begins to cough and sputter, they seem to be drowning!",ch,NULL,victim,TO_ROOM );
	}
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

/*
void weave_ice_bands( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
     Water
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250,255,260,265,270,275,280,285,290,
    295
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_water;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 10 / 8;
    stc("You weave flows of water\n\r",ch);
    stc( "\n\rYou are encased in bands of ice!!\n\r", victim );
    act("$N is encased in bands of freezing ice!",ch,NULL,victim,TO_ROOM );
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}


void weave_ice_bands( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 10 / 8;
    stc("You weave flows of water\n\r",ch);
    stc( "\n\rYou are encased in bands of ice!!\n\r", victim );
    act("$N is encased in bands of freezing ice!",ch,NULL,victim,TO_ROOM );
    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;

    if ( IS_SET(victim->war_flags, WAR_HELD) )
    {
	send_to_char( "But they are already held in a shield of some kind!\n\r", ch );
	return;
    }

    if ( is_safe(ch, victim) ) return;

	if (saves_spell(level+op_bonus, victim,DAM_ENERGY))
    {
	send_to_char( "You manage to break free!\n\r", victim );
	act("$n manages to escape!",victim,NULL,NULL,TO_ROOM);
	return;
    }
	SET_BIT(victim->war_flags,WAR_HELD);
    send_to_char( "You are held by some bands of freezing ice!\n\r", victim );
    act("$n is immobilized!",victim,NULL,NULL,TO_ROOM);
    return;
}
*/
void weave_fire_bolt( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Fire */
    static const sh_int dam_each[] =
    {
	 0,
	 2,  4,  8, 16, 32,	40, 48, 56, 64, 68,
	72, 76, 80, 84, 88,	92, 96, 100,104,108,
	110,112,114,116,118,120,122,124,126,128,
	130,132,133,134,136,138,140,142,144,146,
	148,150,152,155,158,161,164,167,170,175,
    180,185,190,195,200,206,212,218,225,232,
    239,250,255,260,265,270,275,280,285,290,
    295,300,305,310,315
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_fire;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam +=  op_bonus * 9 /8 ;

    stc("You weave flows of fire.\n\r",ch);
    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rA searing bolt of flame slams into you!\n\r", victim );
	    act("$N gets hit with a bolt of flame!",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rA searing bolt of flame slams into you as you raise your shield to defend!\n\r", victim );
	    act("$N gets hit with a bolt of flame as $E raises a shiel to defend!",ch,NULL,victim,TO_ROOM );
	}

    damage( ch, victim, dam, sn, DAM_HARM ,TRUE);
    return;
}

/* void weave_fire_rain( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
     Fire/Air
    static const sh_int dam_each[] =
    {
	  0,
	  0,   0,   0,   0,   0,	  0,   0,   0,   0,   0,
	  0,   0,   0,   0,  30,	 35,  40,  45,  50,  55,
	 60,  65,  70,  75,  80,	 82,  84,  86,  88,  90,
	 92,  94,  96,  98, 100,	102, 104, 106, 108, 110,
	112, 114, 116, 118, 120,	122, 124, 126, 128, 130
    };
    int dam;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_air+ch->pcdata->op_fire;
	op_bonus /= 2;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    level	= UMIN(level, sizeof(dam_each)/sizeof(dam_each[0]) - 1);
    level	= UMAX(0, level);
    dam		= number_range( dam_each[level] / 2, dam_each[level] * 2 );
    dam     += op_bonus;
    stc("You weave flows of air and fire.\n\r",ch);
    stc( "{cA storm of {w-{R+{w- {rFIRE{x {w-{R+{w-{c crashes down to strike at you!\n\r",victim );
    act("{cA storm of {w-{R+{w- {rFIRE{x {w-{R+{w-{c crashes down on $N!\n\r",ch,NULL,victim,TO_NOTVICT );
    act( "{cYour {w-{R+{w- {rFIRE{x {w-{R+{w-{c crashes down to strike at $N!\n\r",ch,NULL,victim,TO_CHAR );
    if ( saves_spell( level, victim, DAM_FIRE) )
	dam /= 2;
    damage( ch, victim, dam, sn, DAM_FIRE ,TRUE);
    return;
}
*/
void weave_ice_storm( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *vict;
    /* Water, Air */
    int op_bonus = 0;
    int ang_bonus;
    int i = 0;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
	    op_bonus = ch->pcdata->op_water+ch->pcdata->op_air;

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    op_bonus += number_range(op_bonus*10/9,op_bonus*12/9) *3 / 2;
    /*
	stc("This weave is temporarily disabled.\n\r",ch);
	return;
	*/

    stc("You weave flows of water and air.\n\r",ch);
    act("{cSheets of {WIce{c rain down from the sky!", ch, NULL, NULL, TO_ROOM );

	for (vict = ch->in_room->people; vict != NULL && i < 3; vict = vict->next_in_room)
	{
		if (vict == ch)
			continue;
		if (is_same_group (ch, vict))
			continue;
		if ( is_safe( ch, vict ) )
			continue;
		if ( is_fighting(vict) &&	!is_same_group(ch,vict->advancing_on))
			continue;
		if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master == vict )
			continue;
	/*	if (!IS_NPC(ch))
		{
			if (!IS_NPC(vict)
			&& !IS_SET(ch->in_room->room_flags,ROOM_PK)
			&& !IS_SET(vict->in_room->room_flags,ROOM_PK)
			&& !IS_IMMORTAL(ch))
			{
			    stc("{cGo to the Arena if you want to PK.\n\r",ch);
			    continue;
			}
		}*/
		if ( !is_safe_spell(ch,vict,TRUE))
		{
			if (check_fighting(ch, vict) || start_extra_fight(ch, vict, RANGE_LONG))
			{
				i++;
/*				damage( ch,vict,level + dice(4, 10)+op_bonus, sn, DAM_HARM,TRUE); */
				damage( ch,vict,1 + number_range(1,op_bonus+(op_bonus+ch->pcdata->op_air*10)), sn, DAM_HARM,TRUE);
			}
		}
    }
    /*damage( ch,vch,level + dice(2, 8)+op_bonus, sn, DAM_BASH,TRUE);*/
	/*damage( ch,vch,1 + number_range(1,op_bonus+(op_bonus+ch->pcdata->op_air*10)), sn, DAM_HARM,TRUE);*/
    return;
}

void weave_fork_lightning( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *vict;
    /* Fire, Air */
    int op_bonus = 0,i = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_water+ch->pcdata->op_air;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    op_bonus += number_range(op_bonus*9/10,op_bonus*11/10) / 2;
    stc("You weave flows of fire and air.\n\r",ch);

	for (vict = ch->in_room->people; vict != NULL && i<3; vict = vict->next_in_room)
	{
		if (vict == ch)
			continue;
		if (is_same_group (ch, vict))
			continue;
		if ( is_safe( ch, vict ) )
			continue;
		if ( is_fighting(vict) &&	!is_same_group(ch,vict->advancing_on))
			continue;
		if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master == vict )
			continue;
		/*
		if (!IS_NPC(ch))
		{
			if (!IS_NPC(vict)
			&& !IS_SET(ch->in_room->room_flags,ROOM_PK)
			&& !IS_SET(vict->in_room->room_flags,ROOM_PK)
			&& !IS_IMMORTAL(ch))
			{
			    stc("{cGo to the Arena if you want to PK.\n\r",ch);
			    continue;
			}
		}*/
		if ( !is_safe_spell(ch,vict,TRUE))
		{
			if (check_fighting(ch, vict) || start_extra_fight(ch, vict, RANGE_LONG))
			{
				i++;
				if (i!=3 || number_percent() > 50)
				{
					act("Blinding {WLightning{c forks through $n's enemies, striking $N!", ch, NULL, vict, TO_ROOM );
/*					damage( ch,vict,level + dice(4, 10)+op_bonus, sn, DAM_HARM,TRUE); */
					damage( ch,vict,op_bonus + dice(1,op_bonus), sn, DAM_HARM,TRUE);
				}
			}
		}
    }
    return;
}




/* Affect weaves, like large, applied to dex, con, and int */
void weave_bigger( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;
    /* Spirit/Fire/Air/Earth/Water */
    int op_bonus = 0;
    int ang_bonus, modifier;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_air+ch->pcdata->op_earth+ch->pcdata->op_water;
    op_bonus /= 5;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    if ( is_affected( victim, sn ) )
    {
	if (victim == ch)
          stc( "{cYour muscles already swell.\n\r",ch);
	else
          act("{c$N's muscles already swell.",ch,NULL,victim,TO_CHAR);
	return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 25 )
    	modifier = 25;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_STR;
    af.bitvector = AFF_BIGGER;
    affect_to_char( victim, &af );
    if (victim == ch)
    {
    	stc( "{cYour muscles begin to swell!{x\n\r", victim );
	    act( "$n's muscles begin to swell!{x",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows and $N grows bigger!",ch,NULL,victim,TO_CHAR);
    	act( "$N's muscles begin to swell!{x",ch,0,victim,TO_NOTVICT);
    	stc( "{cYour muscles begin to swell!{x\n\r", victim );
	}
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
    return;
}

void weave_large( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;
    /* Spirit/Fire/Air/Earth/Water */
    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_air+ch->pcdata->op_earth+ch->pcdata->op_water;
    op_bonus /= 5;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "{cYou are already larger than life.\n\r",ch);
		else
	          act("{c$N is already larger than life.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 75 )
    	modifier = 75;

    af.where	 = TO_AFFECTS;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_STR;
    af.bitvector = OP_LARGE;
    affect_to_char( victim, &af );
    if (victim == ch)
    {
    	stc( "{cYou begin to grow, your arms and thighs getting thicker and more muscled!{x\n\r", victim );
	    act( "$n begins to grow, $s arms and thighs growing thicker and more muscled!{x",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows, enhancing $N's strength.",ch,NULL,victim,TO_CHAR);
    	act( "$N begins to grow, $S arms and thighs growing thicker and more muscled!{x",ch,0,victim,TO_NOTVICT);
    	stc( "{cYou begin to grow, your arms and thighs getting thicker and more muscled!{x\n\r", victim );
	}
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
    return;
}

void weave_quicken( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_air;
	    op_bonus /= 2;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "{cYou already feel quicker.\n\r",ch);
		else
	          act("{c$N is already quicker.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 25 )
    	modifier = 25;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_DEX;
    af.bitvector = AFF_QUICKEN;
    affect_to_char( victim, &af );
    if (victim == ch)
    {
    	stc( "{cYou feel quicker!{x\n\r", victim );
    	act( "$N suddenly moves more quickly!{x",ch,0,victim,TO_ROOM);
    }
	else
	{
    	stc( "{cYou feel quicker!{x\n\r", victim );
		act( "You weave the flows, making $N quicker!",ch,NULL,victim,TO_CHAR);
    	act( "$N suddenly appears quicker!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

void weave_speed( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_air;
	    op_bonus /= 2;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "{cYou are faster and more coordinated.\n\r",ch);
		else
	          act("{c$N is already faster and more coordinated.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 75 )
    	modifier = 75;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_DEX;
    af.bitvector = AFF_SPEED;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "{cYou feel faster and more coordinated!{x\n\r", victim );
    	act( "$N suddenly appears faster and more coordinated!{x",ch,0,victim,TO_ROOM);
    }
	else
	{
    	stc( "{cYou feel faster and more coordinated!{x\n\r", victim );
		act( "You weave the flows, enhancing $N's speed.",ch,NULL,victim,TO_CHAR);
    	act( "$N suddenly appears faster and more coordinated!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

void weave_innervation( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_air;
	    op_bonus /= 3;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "Your nerves are already on fire.\n\r",ch);
		else
	          act("$N's nerves are already on fire.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 25 )
    	modifier = 25;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_REF;
    af.bitvector = AFF_INNERVATION;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "{cYour nerves feel like they are on fire!{x\n\r", victim );
    	act( "$N suddenly appears to see everything at once!{x",ch,0,victim,TO_NOTVICT);
    }
	else
	{
    	stc( "{cYour nerves feel like they are on fire!{x\n\r", victim );
		act( "You weave the flows, igniting $N's nerves!",ch,NULL,victim,TO_CHAR);
    	act( "$N suddenly appears to see everything at once!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

void weave_panther_reflex( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_air;
	    op_bonus /= 3;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "{cYour muscles feel looser, and everything is in sharp focus.\n\r",ch);
		else
	          act("{c$N is already looser and more focused.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 75 )
    	modifier = 75;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_REF;
    af.bitvector = AFF_PANTHER;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "{cYour muscles feel looser, and everything is in sharp focus!{x\n\r", victim );
    	act( "$N suddenly appears more loose, and $S eyes focus sharply!{x",ch,0,victim,TO_NOTVICT);
    }
	else
	{
    	stc( "{cYour muscles feel looser, and everything is in sharp focus!{x\n\r", victim );
		act( "You weave the flows, enhancing $N's reflex.",ch,NULL,victim,TO_CHAR);
    	act( "$N suddenly appears more loose, and $S eyes focus sharply!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

void weave_fortitude( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_earth;
	    op_bonus /= 2;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "Your body already feels fortified.\n\r",ch);
		else
	          act("$N's body is already fortified.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 25 )
    	modifier = 25;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_CON;
    af.bitvector = AFF_FORTITUDE;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "Your body feels fortified!\n\r", victim );
	    act( "$n's body suddenly appears fortified!",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows, fortifying $N's body.",ch,NULL,victim,TO_CHAR);
    	act( "$N's body suddenly appears fortified!",ch,0,victim,TO_NOTVICT);
    	stc( "Your body feels fortified!\n\r", victim );
	}
    return;
}

void weave_endurance( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_earth;
	    op_bonus /= 2;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "{cYou are already in peak physical condition.\n\r",ch);
		else
	          act("{c$N is already in peak physical condition.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 75 )
    	modifier = 75;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_CON;
    af.bitvector = AFF_ENDURANCE;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "{cYou feel refreshed, ready to run laps around the Waste!{x\n\r", victim );
	    act( "$n looks refreshed, and ready to run laps around the Waste.{x",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows, enhancing $N's endurance.",ch,NULL,victim,TO_CHAR);
    	act( "$N looks refreshed, and ready to run laps around the Waste.{x",ch,0,victim,TO_NOTVICT);
    	stc( "{cYou feel refreshed, ready to run laps around the Waste!{x\n\r", victim );
	}
    return;
}

void weave_sixth_sense( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_earth;
	    op_bonus /= 3;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "Your senses are as heightened as they can be.{x\n\r",ch);
		else
	          act("{c$N's senses are as heightened as they can be.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 25 )
    	modifier = 25;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_INS;
    af.bitvector = AFF_SIXTH_SENSE;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "Your senses feel heightened!{x\n\r", victim );
	    act( "$n seems to become more aware!{x",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows, heightening $N's senses.",ch,NULL,victim,TO_CHAR);
    	stc( "{cYou feel your senses grow more heightened!{x\n\r", victim );
    	act( "$N seems to become more aware!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

void weave_hunters_instinct( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus, modifier;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_earth;
	    op_bonus /= 3;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if ( is_affected( victim, sn ) )
    {
		if (victim == ch)
	          stc( "You are as keen and aware as you can be.{x\n\r",ch);
		else
	          act("{c$N is as keen and aware as $E can be.",ch,NULL,victim,TO_CHAR);
		return;
    }

    modifier = true_op_average(ch) + trueOverPwr;
    if ( modifier > 75 )
    	modifier = 75;

    af.where	 = TO_AFFECTS2;
    af.type      = sn;
    af.level	 = true_op_average(ch);
    af.duration  = op_bonus + op_average(ch);
    af.modifier  = modifier;
    af.location  = APPLY_INS;
    af.bitvector = AFF_INSTINCT;
    affect_to_char( victim, &af );

    if (victim == ch)
    {
    	stc( "{cYou feel more aware of what is going on around you!{x\n\r", victim );
	    act( "$n seems more alert, as $e scans the area for danger!{x",ch,0,0,TO_ROOM);
	}
	else
	{
		act( "You weave the flows, enhancing $N's awareness.",ch,NULL,victim,TO_CHAR);
    	stc( "{cYou feel more aware of what is going on around you!{x\n\r", victim );
    	act( "$N seems more alert, as $E scans the area for danger!{x",ch,0,victim,TO_NOTVICT);
	}
    return;
}

/* Defensive weaves

void weave_fire_shield( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;

    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_air;
    op_bonus /= 3;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    if ( is_affected( victim, sn ) )
    {
	if (victim == ch)
          stc( "{cYou are already surrounded by a fire shield.\n\r",ch);
	else
          act("{c$N is already surrounded by a fire shield.",ch,NULL,victim,TO_CHAR);
	return;
    }
    af.where	 = TO_AFFECTS;
    af.type      = sn;
    af.level	 = ch->level/2;
    af.duration  = ch->level/10 + op_bonus;
    af.modifier  = -20;
    af.location  = APPLY_AC;
    af.bitvector = OP_FSHIELD;
    affect_to_char( victim, &af );
    if (victim == ch)
    {
    	stc( "{cYou are surrounded by a {WS{whi{rel{Rd of{r F{wir{We.{x\n\r", victim );
	    act( "$n is surrounded by a {WS{whi{rel{Rd of{r F{wir{We!",ch,0,0,TO_ROOM);
	}
	else
    	act( "$N is surrounded by a {WS{whi{rel{Rd of{r F{wir{We!",ch,0,victim,TO_ROOM);
    return;
}
*/
void weave_advanced_shield( int sn, int level, CHAR_DATA *ch, void *vo,int target)
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;
    int op_bonus2 = 0;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_earth+ch->pcdata->op_air;
    op_bonus /= 3;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    if ( is_affected( victim, sn ) )
    {
	if (victim == ch)
	  stc( "{cYou are already protected by an advanced shield .\n\r",ch);
	else
	  act("{c$N is already protected by an advanced shield.",ch,NULL,victim,TO_CHAR);
	return;
    }
	op_bonus2 = 20;
	op_bonus += op_bonus2;
    af.where     = TO_AFFECTS;
    af.type      = sn;
    af.level     = level;
    af.duration  = 10 + level + op_bonus;
    af.location  = APPLY_AC;
    af.modifier  = -op_bonus *2;
    af.bitvector = 0;
    affect_to_char( victim, &af );
    stc("You weave flows of spirit.\n\r",ch);
    act("{c$n is enveloped by a brief flash of light.", victim, NULL, NULL, TO_ROOM );
    stc( "{cYou are enveloped in a brief flash of light.\n\r", victim );
    return;
}

void weave_greater_shield( int sn, int level, CHAR_DATA *ch, void *vo,int target)
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA af;
    int op_bonus2 = 0;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_earth+ch->pcdata->op_air;
    op_bonus /= 3;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
    if ( is_affected( victim, sn ) )
    {
	if (victim == ch)
	  stc( "{cYou are already protected by a greater shield .\n\r",ch);
	else
	  act("{c$N is already protected by an greater shield.",ch,NULL,victim,TO_CHAR);
	return;
    }
	op_bonus2 = 20;
	op_bonus += op_bonus2;
    af.where     = TO_AFFECTS;
    af.type      = sn;
    af.level     = level;
    af.duration  = 10 + level + op_bonus;
    af.location  = APPLY_AC;
    af.modifier  = -op_bonus *3;
    af.bitvector = 0;
    affect_to_char( victim, &af );
    stc("You weave flows of spirit.\n\r",ch);
    act("{c$n is enveloped by a brief flash of light.", victim, NULL, NULL, TO_ROOM );
    stc( "{cYou are enveloped in a brief flash of light.\n\r", victim );
    return;
}


 /* Healing Weaves */

/*
 void weave_cure_deadly( int sn, int level, CHAR_DATA *ch, void *vo,int target)
 {
     CHAR_DATA *victim = (CHAR_DATA *) vo;
     int heal;
     Spirit
     int op_bonus = 0;
     int ang_bonus;
     if (!IS_NPC(ch))
     	ang_bonus = check_angreal(ch);
     else ang_bonus = 0;
     if (!IS_NPC(ch))
     {
     op_bonus = ch->pcdata->op_spirit;
 	}
 	op_bonus += ang_bonus;
 	op_bonus += pwrBonus;
     heal = dice(1, ch->level) + level + op_bonus;
     victim->hit = UMIN( victim->hit + heal, victim->max_hit );
     update_pos( victim );
     stc( "{cYou feel better!\n\r", victim );
     if ( ch != victim )
 	stc( "{cOk.\n\r", ch );
 	check_healing(ch,victim);
     return;
 } */

void weave_barrier( int sn, int level, CHAR_DATA *ch, void *vo,int target)
{
    CHAR_DATA *victim;

    /* Air, Earth */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_air+ch->pcdata->op_earth;
    op_bonus /=2;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;
	if (IS_NPC(victim) || IS_NPC(ch))
	{ stc ("{cNot on NPC's.\n\r",ch);return;}

    if ( victim->pcdata->char_barrier > 0 )
    {
	if (victim == ch)
          stc( "{cYou are already protected by a barrier.\n\r",ch);
	else
          act("{c$N is already protected by a barrier.",ch,NULL,victim,TO_CHAR);
	return;
    }

    if ( ch != victim )
    {
		victim->pcdata->char_barrier = level * 10 + op_bonus;
		SET_BIT(victim->op_flags, OP_BARRIER);
        act("{cYou weave a barrier around $N.",ch,NULL,victim,TO_CHAR);
        act( "{c$n weaves a barrier around you.",ch,NULL,victim,TO_VICT);
	}
	else if ( ch == victim )
	{
		ch->pcdata->char_barrier = level * 10 + op_bonus;
		SET_BIT(ch->op_flags, OP_BARRIER);
	    stc( "{cYou feel a barrier spring up around you!\n\r", victim );
	}
	else
		stc( "Woah, the victim got screwed up somehow. Report this as a bug.\n\r", ch );

    return;
}
void weave_infuse( int sn, int level, CHAR_DATA *ch, void *vo, int target)
{
    OBJ_DATA *obj;
    AFFECT_DATA *af;
    /* Fire,Earth */
    int op_bonus = 0, ang_bonus, check = 0, total = 0, mat, max = 75, mod;
    char sh_namer[MSL];
    char lo_namer[MSL];
    bool found = FALSE;
    sh_namer[0] = '\0';
    lo_namer[0] = '\0';
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    	op_bonus += ch->pcdata->op_fire+ch->pcdata->op_earth;
	    op_bonus /= 2;
    }
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    if (target == TARGET_OBJ)
    {
		obj = (OBJ_DATA *) vo;
		if ( obj == NULL )
		{
		    stc("The object is NULL.\n\r",ch);
		    return;
		}
		for ( mat = 0; mat < max-1; mat++ )
		{
			if ( !str_cmp( obj->material, material_table[mat].name ) )
			{
				found = TRUE;
				break;
			}
		}
		if ( !found )
		{
		    stc("Somehow, this item does not have a valid material.\n\r",ch);
		    return;
		}
		if ( ch->questpoints < 750 )
		{
		    stc("You dont have enough power to put into the weave.\n\r",ch);
		    stc("It costs 750 quest points to infuse an item.\n\r",ch);
		    return;
		}
		ch->questpoints -= 750;
   		act("You focus intently on $t.",ch,obj->short_descr,NULL,TO_CHAR);
   		act("$n focuses intently on $t",ch,obj->short_descr,NULL,TO_ROOM);
		check = number_percent();
		if ( pwrBonus > ch->level / 10 )
		{
			check += pwrBonus - ( ch->level / 10 );
		}
		total = get_skill( ch, sn ) / 10;
		total += op_bonus;
		level /= 10;
		total += level;
		if ( total >= 95 )
		{
			total = 95 + number_range( total / 9, total / 10 );
		}
		ptc( ch, "Check is %d. Total is %d.\n\r", check, total );
		stc("If check is greater than total, poof goes the item.\n\r",ch);
		if ( check > total )
		{
    		act("$t glows as it is infused with the One Power until it shatters under the strain!",
   				ch,obj->short_descr,NULL,TO_CHAR);
   			act("$t glows as it is infused with the One Power until it shatters under the strain!",
   				ch,obj->short_descr,NULL,TO_ROOM);
   			extract_obj( obj );
	    	return;
		}
	    if (!IS_NPC(ch))
	    	ang_bonus = check_angreal(ch);
	    else ang_bonus = 0;
	    op_bonus = pwrBonus;
	    mod = op_bonus;
	    if ( mod > material_table[mat].maxAff )
	    	mod = material_table[mat].maxAff;
	    if ( op_bonus <= 0 )
	    	op_bonus = 1;
	    if ( op_bonus > 25 )
	    	op_bonus = 25 + ( op_bonus / 10 );
		if ( obj->value[4] == WEAPON_INFUSE_STR )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_STR;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_STR;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_CON )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_CON;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_CON;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_DEX )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_DEX;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_DEX;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_INT )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_INT;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_INT;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_WIS )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_WIS;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_WIS;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_REF )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_REF;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_REF;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_CHA )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_CHA;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_CHA;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_INS )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_INS;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_INS;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_HR )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_HITROLL;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_HR;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		obj->short_descr = str_dup( sh_namer );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		if ( obj->value[4] == WEAPON_INFUSE_DR )
		{
	    	af             =   new_affect();
    		af->location   =   APPLY_DAMROLL;
		    af->modifier   =   mod;
    		af->where	   =   TO_OBJECT;
		    af->type       =   -1;
	    	af->duration   =   -1;
	    	af->bitvector  =   0;
    		af->level      =   1;
		    af->next       =   obj->affected;
    		obj->affected  =   af;
    		obj->value[4] -=   WEAPON_INFUSE_DR;

    		sprintf( sh_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->short_descr );
    		sprintf( lo_namer, "{b({WP{wower {WW{wrought{b){x %s", obj->description );
    		free_string( obj->short_descr );
    		obj->short_descr = str_dup( sh_namer );
    		free_string( obj->description );
    		obj->description = str_dup( lo_namer );

    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_CHAR);
    		act("$t glows brightly as it is infused with the One Power!",ch,obj->short_descr,NULL,TO_ROOM);
			return;
		}
		else
		{
		    stc("A valid infusion type was not found.\n\r",ch);
		    return;
		}
	}
	else
    {
	    stc("Only on objects prepared for infusion.\n\r",ch);
	    return;
    }
    return;
}
