/**************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "magic.h"
#include "recycle.h"
#include "tables.h"
#include "lookup.h"

/* Summon Dark Hound */
void weave_summon_darkhound( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
//	CHAR_DATA *gch;
	CHAR_DATA *darkhound = NULL;
//	AFFECT_DATA af;
	char buf[MSL];
	int i = 0;
//	bool got = FALSE;

	if (ch->clan != clan_lookup("dreadlord")
	&& ch->race != race_lookup("Fade")
	&& ch->clan != clan_lookup("chosen"))
	{
		stc("Only Dreadlords can use this weave.\n\r",ch);
		return ;
	}

	send_to_char("You attempt to summon a darkhound.\n\r",ch);
	act("$n attempts to summon a darkhound.",ch,NULL,NULL,TO_ROOM);

	if (ch->pet != NULL)
	{
	    send_to_char("You already have a companion.\n\r",ch);
	    return;
	}

/*
	for (gch = char_list; gch != NULL; gch = gch->next)
	{
		if (IS_NPC(gch) && IS_AFFECTED(gch,AFF_CHARM) && gch->master == ch
		&& ( gch->pIndexData->vnum == MOB_VNUM_DARKHOUND ) )
		{
		    send_to_char("You cannot handle more than one Darkhound.\n\r",ch);
		    return;
		}
	}
*/
	darkhound = create_mobile( get_mob_index(MOB_VNUM_DARKHOUND) );

	for (i = 0; i < MAX_STATS; i ++)
		darkhound->perm_stat[i] = UMIN(10,15 + ch->level/10);

	darkhound->max_hit = IS_NPC(ch)? URANGE(ch->max_hit,1 * ch->max_hit,20000) : UMIN( (10 * ch->pcdata->perm_hit) + 4000, 30000);
	darkhound->max_stam = IS_NPC(ch)? ch->max_stam : ch->pcdata->perm_mana;

	darkhound->hit = darkhound->max_hit;
	darkhound->stam = darkhound->max_stam;
	darkhound->level = ch->level;
	for (i=0; i < 3; i++)
		darkhound->armor[i] = interpolate(darkhound->level,100,-100);
	darkhound->armor[3] = interpolate(darkhound->level,100,0);
	/* darkhound->gold = 0; */
	darkhound->timer = 0;
	darkhound->damage[DICE_NUMBER] = 2;
	darkhound->damage[DICE_TYPE] = 75;
	darkhound->damage[DICE_BONUS] = ch->level / 2 + 10;
	sprintf( buf, "%sI belong to %s is seen on the darkhound's studded collar.\n\r",
	darkhound->description, ch->name );
	free_string( darkhound->description );
	darkhound->description = str_dup( buf );

	char_to_room(darkhound,ch->in_room);
	send_to_char("You summon a darkdound!\n\r",ch);
	act("$n summons an darkhound!",ch,NULL,NULL,TO_ROOM);

	SET_BIT(darkhound->affected_by, AFF_CHARM);
	darkhound->master = darkhound->leader = ch;
	ch->pet = darkhound;
	return;
}

/* Spirit of Wind */
void weave_spirit_of_wind( int sn, int level, CHAR_DATA *ch, void *vo,
int target )
{
	CHAR_DATA *gch;
	CHAR_DATA *spirit = NULL;
	AFFECT_DATA af;
	char buf[MAX_STRING_LENGTH];
	int i = 0;
	bool got = FALSE;

	if (ch->race != race_lookup("aiel"))
	{
		stc("Only Aiel can use this weave.\n\r",ch);
		return ;
	}
	send_to_char("You call upong the ancients and summon a wind spirit.\n\r",ch);
	act("$n attempts to call upon a wind spirit.",ch,NULL,NULL,TO_ROOM);

	for (gch = char_list; gch != NULL; gch = gch->next)
	{
		if (IS_NPC(gch) && IS_AFFECTED(gch,AFF_CHARM) && gch->master == ch
		&& ( gch->pIndexData->vnum == MOB_VNUM_WIND ) )
		{
			send_to_char("You cannot handle more than one wind spirit.\n\r",ch);
			return;
		}

		spirit = create_mobile( get_mob_index(MOB_VNUM_WIND) );
		for (i = 0; i < MAX_STATS; i ++)
			spirit->perm_stat[i] = UMIN(10,15 + ch->level/10);
		spirit->max_hit = IS_NPC(ch)? URANGE(ch->max_hit,1 * ch->max_hit,20000)
		: UMIN( (10 * ch->pcdata->perm_hit) + 4000, 30000);
		spirit->max_stam = IS_NPC(ch)? ch->max_stam : ch->pcdata->perm_mana;

		spirit->hit = spirit->max_hit;
		spirit->stam = spirit->max_stam;
		spirit->level = ch->level;
		for (i=0; i < 3; i++)
			spirit->armor[i] = interpolate(spirit->level,100,-100);
		spirit->armor[3] = interpolate(spirit->level,100,0);
/*		spirit->gold = 0; */
		spirit->timer = 0;
		spirit->damage[DICE_NUMBER] = 2;
		spirit->damage[DICE_TYPE] = 50;
		spirit->damage[DICE_BONUS] = ch->level / 2 + 10;
		sprintf( buf, "%sSays my master is %s.\n\r",
		spirit->description, ch->name );
		free_string( spirit->description );
		spirit->description = str_dup( buf );
		got = TRUE;
	}

	if ( got )
	{
		char_to_room(spirit,ch->in_room);
		send_to_char("You call upon the Spirit of the Wind!\n\r",ch);
		act("$n calls upon the Spirit of the Wind!",ch,NULL,NULL,TO_ROOM);

		af.where		= TO_AFFECTS;
		af.type               = sn;
		af.level              = level;
		af.duration           = 30;
		af.bitvector          = 0;
		af.modifier           = 0;
		af.location           = APPLY_NONE;
		affect_to_char(ch, &af);

		SET_BIT(spirit->affected_by, AFF_CHARM);
		spirit->master = spirit->leader = ch;
	}
}
