/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"

int op_average args( ( CHAR_DATA *ch ) );
int check_angreal_bonus args( ( CHAR_DATA *ch ) );
int check_angreal args( ( CHAR_DATA *ch ) );
void check_stat_improve args( ( CHAR_DATA *ch, int stat, int power ) );
extern int pwrBonus;
extern int ovrPwr;
extern int angBonus;
/*char *target_name; */
bool check_blind             args( ( CHAR_DATA *ch ) );
int calc_weave_damage( CHAR_DATA *ch, int sn, int ang_bonus );

bool is_linked_group( CHAR_DATA *ach, CHAR_DATA *bch )
{
    if ( ach == NULL || bch == NULL)
	return FALSE;

	if ( IS_NPC( ach ) || IS_NPC( bch ) )
	return FALSE;

	if ( !ach->pcdata || !bch->pcdata )
	return FALSE;

    if ( ach->pcdata->link_leader != NULL ) ach = ach->pcdata->link_leader;
    if ( bch->pcdata->link_leader != NULL ) bch = bch->pcdata->link_leader;
    return ach == bch;
}

void weave_knit_flesh( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int healnum;
    /* Spirit/Fire/Earth/Water */
    int op_bonus = 0;
    int ang_bonus;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_earth+ch->pcdata->op_water;
    op_bonus /= 4;
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

	healnum = ch->level;
    healnum += int_app[get_curr_stat(ch,STAT_INT)].op_focus * 3;
    healnum += cha_app[get_curr_stat(ch,STAT_CHA)].persuasion * 5;
    healnum += wis_app[get_curr_stat(ch,STAT_WIS)].op_will * 3;
    healnum += op_bonus;
    healnum *= 3;
    healnum /= 2;

    if ( !IS_NPC( ch ) )
	    healnum += ch->pcdata->learned[sn] * 3;
    if (IS_SET(ch->ajah_flags,AJAH_YELLOW) || ch->clan == clan_lookup("kin"))
    	healnum += ch->level/2;
    victim->hit = UMIN( victim->hit + healnum, victim->max_hit);
    update_pos( victim );
    if ( victim != ch )
    {
		act( "{cYou weave flows of the One Power, Healing $N's wounds.",ch,0,victim,TO_CHAR );
	    act("{c$n takes your head between $s hands. Fingers of ice and fire shoot up your spine.",ch,NULL,victim,TO_VICT);
	    stc( "{cA warm feeling fills your body.\n\r", victim );
	    act("{c$n takes $N's head between $s hands. $N shivers violently.",ch,NULL,victim,TO_ROOM);
	}
	else {
	    stc( "{cAs you draw upon the True Source, a warm feeling fills your body.\n\r", victim );
	}
	check_healing(ch,victim);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
    return;
}

void weave_delve( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    char buf[MSL];
	int percent1;
	int percent2;

    buf[0] = '\0';

	if ( !victim || IS_NPC( ch ) )
		return;

	if ( IS_NPC( victim ) )
	{
		stc( "Not on them.\n\r", ch );
		return;
	}

	percent1 = victim->hit * 100 / victim->max_hit;
	percent2 = victim->stam * 100 / victim->max_stam;

	if ( percent1 == 100 )
		act( "$N is in excellent physical shape.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent1 >= 65 )
		act( "$N has a few nicks and scrapes.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent1 >= 25 && percent1 < 65 )
		act( "$N is bleeding from several open wounds.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent1 >= 25 && percent1 < 65 )
		act( "$N looks like a walking corpse.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent1 <= 0 )
		act( "$N is mortally wounded, and will die soon if not aided.\n\r", ch, NULL, victim, TO_CHAR );

	if ( percent2 == 100 )
		act( "$N's mind is fresh and ready.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent2 >= 85 )
		act( "$N appears a little mentally strained.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent2 >= 65 && percent2 < 85 )
		act( "$N suffers from dark circles under $S eyes.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent2 >= 45 && percent2 < 65 )
		act( "$N suffers from a pounding headache.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent2 >= 30 && percent2 < 45 )
		act( "$N sways from mental fatigue.\n\r", ch, NULL, victim, TO_CHAR );
	else if ( percent2 >= 15 && percent2 < 30 )
		act( "$N can barely keep from collapsing from mental strain.\n\r", ch, NULL, victim, TO_CHAR );
	else
		act( "$N's mind is ready to burst like a rotten grape.\n\r", ch, NULL, victim, TO_CHAR );

	if ( IS_AFFECTED( victim, AFF_POISON ) )
		act ( "$N suffers from a physically debilitating poison.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_PLAGUE ) )
		act ( "$N suffers from a deadly plague.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_CURSE ) )
		act ( "$N has been afflicted with a supernatural curse.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_BLIND ) )
		act ( "$N has lost sight in both eyes.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_CHARM ) )
		act ( "$N's mind has been dominated by a supernatural force.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_CALM ) )
		act ( "$N's mind has been calmed.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_WEAKEN ) )
		act ( "$N suffers from a weakness of bone and muscle.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_REGENERATION ) )
		act ( "$N's body and mind are in a regenerative state.", ch, NULL, victim, TO_CHAR );

    if ( IS_AFFECTED( victim, AFF_SLOW ) )
		act ( "$N's mind appears to function only feebly slow.", ch, NULL, victim, TO_CHAR );

    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}
void weave_refresh( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int op_bonus = 0;
    int ang_bonus, heal;

	if ( !victim || IS_NPC( ch ) )
		return;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

	if ( IS_NPC( victim ) )
	{
		stc( "Not on them.\n\r", ch );
		return;
	}
	if ( victim->stam >= victim->max_stam )
	{
		stc( "They do not need to be refreshed.\n\r", ch );
		return;
	}
    heal = ch->level + int_app[get_curr_stat(ch,STAT_INT)].op_focus *11/9;

    victim->stam = UMIN( victim->stam + heal, victim->max_stam);
    update_pos( victim );
    if ( victim != ch )
    {
		act( "{cYou weave flows of the One Power, Refreshing $N's body.",ch,0,victim,TO_CHAR );
	    act("{c$n takes your head between $s hands. Fingers of fire and ice tickle your spine.",ch,NULL,victim,TO_VICT);
	    stc( "{cA warm feeling fills your body and you feel Refreshed.\n\r", victim );
	    act("{c$n takes $N's head between $S hands. $N appears relieved and Refreshed.",ch,NULL,victim,TO_ROOM);
	}

    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}
void weave_weavesight( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    AFFECT_DATA *paf;
    char buf[MSL];
    int op_bonus = 0;
    int ang_bonus;

    buf[0] = '\0';

	if ( !victim || IS_NPC( ch ) )
		return;

    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit;
	}

	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

	if ( IS_NPC( victim ) )
	{
		stc( "Not on them.\n\r", ch );
		return;
	}
    if ( victim->affected != NULL )
    {
		stc( "You see flows of:\n\r", ch );
		if ( victim->pcdata->char_barrier > 0 )
		{
	    	if ( IS_SET(victim->op_flags, OP_BARRIER) && victim->pcdata->char_barrier > 0 )
	    	stc( "Weave: Barrier\n\r", ch );
		}
		for ( paf = victim->affected; paf != NULL; paf = paf->next )
		{
			/*if ( skill_table[paf->type].spell_fun == spell_null )
				continue;
		    if (paf_last != NULL && paf->type == paf_last->type)*/
	    	ptc( ch, "Weave: %s\n\r", skill_table[paf->type].name );
		}
	}
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}

void do_link( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim, *gch;
	int count = 0, men = 0, women = 0;
	bool found = FALSE;
	char arg[MIL];

	argument = one_argument( argument, arg );

	if ( !IS_SET( ch->op_flags, OP_CHANNELER ) )
	{
		stc( "That would be pointless.\n\r", ch );
		return;
	}

	if ( arg[0] == '\0' )
	{
		for ( gch = char_list; gch != NULL; gch = gch->next )
		{
		    if ( is_linked_group( gch, ch ) )
		    {
				int op_perc = 0;
				op_perc = gch->stam * 100 / get_maxstam(gch);

				ptc( ch,"{b[{w%-16s {wOP: {W%s%3d%{w AVG: {W%d{x\n\r",
				    capitalize( PERS(gch, ch) ),
				    op_perc >= 65 ? "{g" : op_perc >= 25 ? "{y" : "{r",
				    op_perc,
				    op_average( gch ) );
			}
		}
		return;
	}
	if ( ( victim = get_char_room( ch,NULL, arg ) ) == NULL )
	{
		stc( "Who do you want to link with?\n\r", ch );
		return;
	}

	if ( victim->leader != ch )
	{
		stc( "You're not the group leader.\n\r", ch );
		return;
	}

	if ( !IS_SET( victim->op_flags, OP_CHANNELER ) )
	{
		stc( "That would be pointless.\n\r", ch );
		return;
	}

    for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
    {
		if ( gch != ch && is_same_group(gch,ch) && !IS_AFFECTED(gch,AFF_CHARM) )
		{
			if ( victim == gch )
			{
				found = TRUE;
				break;
			}
		}
	}
	if ( !found )
	{
		stc( "Who do you want to link with?\n\r", ch );
		stc( "The person must be part of your group.\n\r", ch );
		return;
	}
	if ( is_linked_group( victim, ch ) )
	{
		stc( "This person is already linked with you.\n\r", ch );
		return;
	}

	if ( ch->sex == SEX_MALE )
		men += 1;
	if ( ch->sex == SEX_FEMALE )
		women += 1;

    for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
    {
		if ( gch != ch && is_same_group(gch,ch) && !IS_AFFECTED(gch,AFF_CHARM) )
		{
			if ( is_linked_group( ch, gch ) )
			{
				if ( gch->sex == SEX_MALE )
					men += 1;
				if ( gch->sex == SEX_FEMALE )
					women += 1;
				count++;
				break;
			}
		}
	}
	if ( ch->sex == SEX_MALE && victim->sex == SEX_MALE && women <= 4 )
	{
		stc( "There must be at least one more woman in the circle.\n\r", ch );
		return;
	}
	if ( victim->sex == SEX_FEMALE && count >= 13 && men <= 1 )
	{
		stc( "There must be at least one more man in the circle.\n\r", ch );
		return;
	}
	if ( victim->sex == SEX_FEMALE && count >= 28 && men <= 2 )
	{
		stc( "There must be at least one more man in the circle.\n\r", ch );
		return;
	}
	ptc( ch, "%s is added to the circle.\n\r", victim->name );
	victim->pcdata->link_leader = ch;
	return;
}

/*
 * Extended weaves, sorted by gain order.
 * Ie, you must have the previous weave
 * in order to gain the preceeding.
 *
 */

/*
weaves.c

say Name                  Remort     Exp
say ----                  ------     ---
say Reign of Terror       3          100 *
say Reign of Justice      4          125 *
say Reign of Blood        5          150 *
say Reign of Power        6          200 *
say Reign of Death        8          220 *

say Spin the Wheel        10         200 * reconnects to the source

say Tower of Defense      13         25  *
say Tower of Mind         15         50  *
say Tower of War          17         75  *
say Tower of Justice      19         150 *
say Tower of Power        21         225 *

say Delve                 5          90

say Eavesdrop             3          60

say Ravage                3          70
say Massacre              3          95
say Fire Lance            3          105
say Shock                 0          6
say Cold Blast            0          85
say Frost Strike          0          230
say Plague                0          250
say Rend Flesh            0          175
say Explode               0          195
say Water Blast           0          68
say Shrivel               1          95
say Deception             0          160
say Item Lore             0          140
say Weapon Lore           0          145
say Warriors Pride        3          170
*/


/* Reign weaves.
 * Reign of Terror, Reign of Justice, Reign of Blood
 * Reign of Power, Reign of Death
 */

void weave_reign_of_terror( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int dam = 1;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_earth;
	dam = get_skill(ch,sn);
	dam += ( ch->pcdata->rebirth * 100 );
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
	dam += ( op_bonus * 2 );

    stc( "\n\rA great fright enters your mind, leaving you shivering with fear!\n\r", victim );
    act("\n\rA look of awe and fear appears on $N's face.\n\r",ch,NULL,victim,TO_ROOM );

    /*if ( !saves_spell( level, victim, DAM_ENERGY) )
		WAIT_STATE( victim, skill_table[sn].beats * 3 );*/
    if ( saves_spell( level, victim, DAM_ENERGY) )
    	dam /= 3;

    damage( ch, victim, dam, sn, DAM_ENERGY ,TRUE);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}
void weave_reign_of_justice( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int dam = 1;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_air;
	dam = get_skill(ch,sn);
	dam += ( ch->pcdata->rebirth * 150 );
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;

	dam += ( op_bonus * 2 );

    stc( "\n\rA leaning balance appears before your eyes.\n\r", victim );
    act("\n\r$N appears locked in a trial of self.\n\r",ch,NULL,victim,TO_ROOM );
    /*if ( !saves_spell( level, victim, DAM_ENERGY) )
		WAIT_STATE( victim, skill_table[sn].beats * 3 );*/
    if ( saves_spell( level, victim, DAM_ENERGY) )
    	dam /= 4;
    damage( ch, victim, dam, sn, DAM_ENERGY ,TRUE);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}
void weave_reign_of_blood( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int dam = 1;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_water;
	dam = get_skill(ch,sn);
	dam += ( ch->pcdata->rebirth * 200 );
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
	dam += ( op_bonus * 2 );

    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rA leaning balance appears before your eyes.\n\r", victim );
	    act("\n\r$N appears locked in a trial of self.\n\r",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rA leaning balance appears before your eyes.\n\r", victim );
	    act("\n\r$N appears locked in a trial of self.\n\r",ch,NULL,victim,TO_ROOM );
	}
    /*if ( !saves_spell( level, victim, DAM_ENERGY) )
		WAIT_STATE( victim, skill_table[sn].beats * 3 );*/
    if ( saves_spell( level, victim, DAM_ENERGY) )
    	dam /= 4;
    damage( ch, victim, dam, sn, DAM_ENERGY ,TRUE);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}
void weave_reign_of_power( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int dam = 1;
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    {
    op_bonus = (ch->pcdata->op_spirit * 2);
	dam = get_skill(ch,sn);
	dam += ( ch->pcdata->rebirth * 250 );
	}
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
	dam += ( op_bonus * 2 );

    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rA leaning balance appears before your eyes.\n\r", victim );
	    act("\n\r$N appears locked in a trial of self.\n\r",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rA leaning balance appears before your eyes.\n\r", victim );
	    act("\n\r$N appears locked in a trial of self.\n\r",ch,NULL,victim,TO_ROOM );
	}
    /*if ( !saves_spell( level, victim, DAM_ENERGY) )
		WAIT_STATE( victim, skill_table[sn].beats * 3 );*/
    if ( saves_spell( level, victim, DAM_ENERGY) )
    	dam /= 2;
    damage( ch, victim, dam, sn, DAM_ENERGY ,TRUE);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}

/* FIXME  these weaves are called wrong in sklist.c
 * unchange for now until the new calc_weave_damage
 * is corrected/checked/etced
 * */
void weave_reign_of_death( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    int dam = 1;
//    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    ang_bonus += pwrBonus;
/*
    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_water;
		dam = get_skill(ch,sn);
		dam += ( ch->pcdata->rebirth * 500 );
	}
	op_bonus *= 2;
	op_bonus += ang_bonus;
	op_bonus += pwrBonus;
	dam += ( op_bonus * 2 );
*/
	dam = calc_weave_damage( ch, sn, ang_bonus );
    if ( get_eq_char( victim,WEAR_SHIELD ) == NULL )
    {
	    stc( "\n\rYour veins bulge as a force blocks the oxygen to your brain.\n\r", victim );
	    act("\n\r$N's veins bulge outwards until they look as if they will burst!\n\r",ch,NULL,victim,TO_ROOM );
	}
	else
	{
		dam /= 2;
	    stc( "\n\rYour veins bulge as a force blocks the oxygen to your brain.\n\r", victim );
	    act("\n\r$N's veins bulge outwards until they look as if they will burst!\n\r",ch,NULL,victim,TO_ROOM );
	}
    /*if ( !saves_spell( level, victim, DAM_ENERGY) )
		WAIT_STATE( victim, skill_table[sn].beats * 3 );*/
    if ( saves_spell( level, victim, DAM_ENERGY) )
    	dam /= 1.5;
    damage( ch, victim, dam, sn, DAM_ENERGY ,TRUE);
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	return;
}

void weave_tower_of_defense( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
	CHAR_DATA *victim;
    AFFECT_DATA af;

    /* Spirit */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_spirit;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;

    if ( IS_NPC(ch) || IS_NPC(victim) )
	{
		stc("Not on that victim.\n\r",ch);
		return;
	}
    if (is_affected(victim, sn))
    	return;
	if ( victim->pcdata->rebirth < 0 && victim == ch )
	{
		stc("You can't weave the flows upon yourself at this low tier.\n\r",ch);
		return;
	}
	else if ( victim->pcdata->rebirth < 0 )
	{
		stc("You can't weave the flows upon them when they are at such a low tier.\n\r",ch);
		return;
	}
	else
	{
	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level	 = ch->pcdata->rebirth * 5 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 5 + op_bonus;
	    af.location  = APPLY_HITROLL;
	    af.modifier  = ((ch->pcdata->rebirth / 5) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level     = ch->pcdata->rebirth * 5 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 5 + op_bonus;
	    af.location  = APPLY_AC;
	    af.modifier  = -((ch->pcdata->rebirth / 5) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    stc( "{cYou weave a {BTo{bw{Ber {cof {BDe{bfen{Bse.{x\n\r", ch );
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphanous cloud of purple and green.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphanous cloud of purple and green.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphanous cloud of purple and green.",ch,NULL,victim,TO_NOTVICT);
		}
	    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	    return;
	}
}
void weave_tower_of_mind( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
	CHAR_DATA *victim;
    AFFECT_DATA af;

    /* Spirit */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_spirit;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;

    if ( IS_NPC(ch) || IS_NPC(victim) )
	{
		stc("Not on that victim.\n\r",ch);
		return;
	}
    if (is_affected(victim, sn))
    	return;
	if ( victim->pcdata->rebirth < 0 && victim == ch )
	{
		stc("You can't weave the flows upon yourself at this low tier.\n\r",ch);
		return;
	}
	else if ( victim->pcdata->rebirth < 0 )
	{
		stc("You can't weave the flows upon them when they are at such a low tier.\n\r",ch);
		return;
	}
	else
	{
	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level	 = ch->pcdata->rebirth * 6 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 6 + op_bonus;
	    af.location  = APPLY_HITROLL;
	    af.modifier  = ((ch->pcdata->rebirth / 4) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level     = ch->pcdata->rebirth * 6 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 6 + op_bonus;
	    af.location  = APPLY_AC;
	    af.modifier  = -((ch->pcdata->rebirth / 4) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    stc( "{cYou weave a {BTo{bw{Ber {cof {BM{bin{Bd.{x\n\r", ch );
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphanous cloud of purple and red.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphanous cloud of purple and red.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphanous cloud of purple and red.",ch,NULL,victim,TO_NOTVICT);
		}

	    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	    return;
	}
}
void weave_tower_of_war( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
	CHAR_DATA *victim;
    AFFECT_DATA af;

    /* Spirit */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_spirit;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;

    if ( IS_NPC(ch) || IS_NPC(victim) )
	{
		stc("Not on that victim.\n\r",ch);
		return;
	}
    if (is_affected(victim, sn))
    	return;
	if ( victim->pcdata->rebirth < 0 && victim == ch )
	{
		stc("You can't weave the flows upon yourself at this low tier.\n\r",ch);
		return;
	}
	else if ( victim->pcdata->rebirth < 0 )
	{
		stc("You can't weave the flows upon them when they are at such a low tier.\n\r",ch);
		return;
	}
	else
	{
	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level	 = ch->pcdata->rebirth * 7 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 7 + op_bonus;
	    af.location  = APPLY_HITROLL;
	    af.modifier  = ((ch->pcdata->rebirth / 3) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level     = ch->pcdata->rebirth * 7 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 7 + op_bonus;
	    af.location  = APPLY_AC;
	    af.modifier  = -((ch->pcdata->rebirth / 3) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

        act("{cYou weave a {BTo{bw{Ber {cof {BW{ba{BR.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphanous cloud of purple and black.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphanous cloud of purple and black.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphanous cloud of purple and black.",ch,NULL,victim,TO_NOTVICT);
		}

	    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	    return;
	}
}
void weave_tower_of_justice( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
	CHAR_DATA *victim;
    AFFECT_DATA af;

    /* Spirit */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_spirit;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;

    if ( IS_NPC(ch) || IS_NPC(victim) )
	{
		stc("Not on that victim.\n\r",ch);
		return;
	}
    if (is_affected(victim, sn))
    	return;
	if ( victim->pcdata->rebirth < 0 && victim == ch )
	{
		stc("You can't weave the flows upon yourself at this low tier.\n\r",ch);
		return;
	}
	else if ( victim->pcdata->rebirth < 0 )
	{
		stc("You can't weave the flows upon them when they are at such a low tier.\n\r",ch);
		return;
	}
	else
	{
	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level	 = ch->pcdata->rebirth * 8 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 8 + op_bonus;
	    af.location  = APPLY_HITROLL;
	    af.modifier  = ((ch->pcdata->rebirth / 2) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level     = ch->pcdata->rebirth * 8 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 8 + op_bonus;
	    af.location  = APPLY_AC;
	    af.modifier  = -((ch->pcdata->rebirth / 2) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

        act("{cYou weave a {BTo{bw{Ber {cof {BJu{bsti{Bce.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphanous cloud of purple and gray.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphanous cloud of purple and gray.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphanous cloud of purple and gray.",ch,NULL,victim,TO_NOTVICT);
		}

	    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	    return;
	}
}
void weave_tower_of_power( int sn, int level, CHAR_DATA *ch, void *vo, int target )
{
	CHAR_DATA *victim;
    AFFECT_DATA af;

    /* Spirit */
    int op_bonus = 0;
    int ang_bonus;
    if (!IS_NPC(ch))
    	ang_bonus = check_angreal(ch);
    else ang_bonus = 0;
    if (!IS_NPC(ch))
    op_bonus += ch->pcdata->op_spirit;
    op_bonus += ang_bonus;
	op_bonus += pwrBonus;

    /* character target */
    victim = (CHAR_DATA *) vo;

    if ( IS_NPC(ch) || IS_NPC(victim) )
	{
		stc("Not on that victim.\n\r",ch);
		return;
	}
    if (is_affected(victim, sn))
    	return;
	if ( victim->pcdata->rebirth < 0 && victim == ch )
	{
		stc("You can't weave the flows upon yourself at this low tier.\n\r",ch);
		return;
	}
	else if ( victim->pcdata->rebirth < 0 )
	{
		stc("You can't weave the flows upon them when they are at such a low tier.\n\r",ch);
		return;
	}
	else
	{
	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level	 = ch->pcdata->rebirth * 9 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 9 + op_bonus;
	    af.location  = APPLY_HITROLL;
	    af.modifier  = ((ch->pcdata->rebirth) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

	    af.where     = TO_AFFECTS;
	    af.type      = sn;
	    af.level     = ch->pcdata->rebirth * 9 + op_bonus;
	    af.duration  = ch->pcdata->rebirth * 9 + op_bonus;
	    af.location  = APPLY_AC;
	    af.modifier  = -((ch->pcdata->rebirth) + op_bonus);
	    af.bitvector = 0;
	    affect_to_char( victim, &af );

        act("{cYou weave a {BTo{bw{Ber {cof {BPo{bw{Ber.{x",ch,NULL,victim,TO_CHAR);
		if ( victim == ch )
		{
		    act("For a moment, $n is surrounded by a diaphanous cloud of purple and white.",ch,NULL,victim,TO_ROOM);
		}
		else
		{
		    act("For a moment, you are surrounded by a diaphanous cloud of purple and white.",ch,NULL,victim,TO_VICT);
		    act("For a moment, $N is surrounded by a diaphanous cloud of purple and white.",ch,NULL,victim,TO_NOTVICT);
		}

	    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
	    return;
	}
}

void weave_spinning_the_wheel( int sn, int level, CHAR_DATA *ch, void *vo,int target )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    /* Spirit/Fire/Earth/Water/Air */
    int op_bonus = 0;
    int oldFire, oldSpirit, oldEarth, oldAir, oldWater;

    if (!IS_NPC(ch))
    {
	    op_bonus = ch->pcdata->op_spirit+ch->pcdata->op_fire+ch->pcdata->op_earth+ch->pcdata->op_water+ch->pcdata->op_air;
	    op_bonus /= 5;
	}

	if ( !victim )
    {
		stc( "Who?\n\r", ch );
		return;
	}
	if (IS_NPC(victim) || !victim->pcdata)
	{
		stc( "You can't weave that on them.\n\r", ch);
		return;
	}

    if ( victim != ch )
    {
		if ( victim->pcdata->burnout < 100 && !IS_SET( victim->op_flags,OP_CHANNELER ) )
	    {
			stc( "You were unable to find the threads to reconnect them.\n\r", ch );
			return;
		}
		if ( victim->pcdata->burnout < 100 && IS_SET( victim->op_flags,OP_CHANNELER ) )
	    {
			stc( "The threads writhe in your grasp, and you are unable to control them.\n\r", ch );
			return;
		}

		if ( victim->pcdata->burnout >= 100 && !IS_SET( victim->op_flags,OP_CHANNELER ) )
			stc( "Delving deeply, you find the threads lie severed.\n\r", ch );

		act( "{cYou weave flows of the One Power, searching for the severed threads.",ch,0,victim,TO_CHAR );
	    act("{c$n takes your head between $s hands, probing your mind and spirit.",ch,NULL,victim,TO_VICT);
	    stc( "{cA warm feeling fills your body.\n\r", victim );
	    act("{c$n takes $N's head between $s hands. $N's mouth drops open and $S face turns deathly pale.",ch,NULL,victim,TO_NOTVICT);
	    if ( number_percent() >= ( ch->pcdata->learned[sn] / 4 ) )
	    {
			stc( "You were unable to reconnect the threads.\n\r", ch );
			return;
		}
		else
		{
		    oldFire =   number_range(victim->pcdata->op_fire -2, victim->pcdata->op_fire +1 );
		    if ( oldFire <= 0 ) oldFire = 1;
		    oldSpirit = number_range(victim->pcdata->op_spirit -2, victim->pcdata->op_spirit +1);
		    if ( oldSpirit <= 0 ) oldSpirit = 1;
		    oldEarth =  number_range(victim->pcdata->op_earth -2, victim->pcdata->op_earth +1);
		    if ( oldEarth <= 0 ) oldEarth = 1;
		    oldAir =    number_range(victim->pcdata->op_air -2, victim->pcdata->op_air +1);
		    if ( oldAir <= 0 ) oldAir = 1;
		    oldWater =  number_range(victim->pcdata->op_water -2, victim->pcdata->op_water +1);
		    if ( oldWater <= 0 ) oldWater = 1;
		    stc( "The Wheel turns again, and you can sense the One Power in your mind.\n\r", victim );
			stc( "You connect the threads one at a time, and with the last one, sense the One Power flow again.\n\r", ch );
		    victim->pcdata->op_fire = oldFire;
		    victim->pcdata->op_spirit = oldSpirit;
		    victim->pcdata->op_earth = oldEarth;
		    victim->pcdata->op_air = oldAir;
		    victim->pcdata->op_water = oldWater;
		    SET_BIT( victim->op_flags,OP_CHANNELER );
		    victim->pcdata->burnout -= ch->pcdata->learned[sn];
		    if ( victim->pcdata->burnout <= 0 )
		    	victim->pcdata->burnout = 1;
		}
	}
	else
	{
	    stc( "You cannot weave these flows upon yourself.\n\r", victim );
	    return;
	}
    check_stat_improve( ch, skill_table[sn].sphere, pwrBonus );
    return;
}
