/***************************************************************************

                      _____  __      __  __      __
                     /  _  \/  \    /  \/  \    /  \
                    /  /_\  \   \/\/   /\   \/\/   /
                   /    |    \        /  \        /
                   \____|__  /\__/\  /    \__/\  /
                           \/      \/          \/

    As the Wheel Weaves based on ROM 2.4. Original code by Dalsor.
    See changes.log for a list of changes from the original ROM code.
    Credits for code created by other authors have been left
 	intact at the head of each function.

    Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
    Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.

    Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael
    Chastain, Michael Quan, and Mitchell Tse.

    In order to use any part of this Merc Diku Mud, you must comply with
    both the original Diku license in 'license.doc' as well the Merc
    license in 'license.txt'.  In particular, you may not remove either of
    these copyright notices.

    Much time and thought has gone into this software and you are
    benefitting.  We hope that you share your changes too.  What goes
    around, comes around.

	ROM 2.4 is copyright 1993-1998 Russ Taylor
	ROM has been brought to you by the ROM consortium
	    Russ Taylor (rtaylor@hypercube.org)
	    Gabrielle Taylor (gtaylor@hypercube.org)
	    Brian Moore (zump@rom.org)
	By using this code, you have agreed to follow the terms of the
	ROM license, in the file Rom24/doc/rom.license

 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "aww.h"
#include "interp.h"
#include "magic.h"
#include "recycle.h"

int sort_skill_by_alpha(const void *askill, const void *bskill )
{
	struct sort_skill_struct aaskill;
	struct sort_skill_struct bbskill;
	aaskill = *(struct sort_skill_struct *) askill;
	bbskill = *(struct sort_skill_struct *) bskill;
	return strcmp(aaskill.name,bbskill.name);
}
void do_sklist(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    int sn = 0;
	int col;
	int num_skills;
    	BUFFER *output;
	struct sort_skill_struct sort_skill[MAX_SKILL];
	num_skills=0;
    	output = new_buf();

    if (IS_NPC(ch))
	return;

	col = 0;

	add_buf(output,"\n\rSkills that you have learned will show in green letters.\n\r\n\r");

	add_buf(output,"This list will show all the possible skills. You may or may not\n\r");
	add_buf(output,"be able to learn these skills depending on how many times you\n\r");
	add_buf(output,"have been reborn, how many trains you have, and if you have the\n\r");
	add_buf(output,"pre-requisite skills.\n\r\n\r");

	add_buf(output,"You may see the percent you have learned in a skill by typing Practice.\n\r");
	add_buf(output,"See also: Gain List.\n\r\n\r");

    add_buf(output,"\n\rSkill Name         Lives Cost Skill Name         Lives Cost \n\r\n\r");
    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL)
            break;

        if (skill_table[sn].rating[ch->class] > 0
		&&  skill_table[sn].spell_fun == spell_null)
        {
		sort_skill[num_skills].name = skill_table[sn].name;
		sort_skill[num_skills].remort_only = skill_table[sn].remort_only;
		sort_skill[num_skills].rating = skill_table[sn].rating[ch->class];
		sort_skill[num_skills].learned = ch->pcdata->learned[sn];
	    num_skills++;
        }


    }
	qsort(sort_skill,num_skills,sizeof(struct sort_skill_struct),sort_skill_by_alpha);
    for (sn = 0; sn < num_skills; sn++)
    {

            sprintf(buf,"%s%-18s{c %-5d %-5d",
	      sort_skill[sn].learned?"{g":"{c",
              sort_skill[sn].name,
              sort_skill[sn].remort_only,
              sort_skill[sn].rating);
	    add_buf(output,buf);
            if (++col % 2 == 0)
		add_buf(output,"{c\n\r");

    }
    if (col % 2 != 0)
		add_buf(output,"{c\n\r");

    page_to_char( buf_string(output), ch );
    free_buf(output);
	return;
#if 0	
    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL)
            break;

        if (skill_table[sn].rating[ch->class] > 0
		&&  skill_table[sn].spell_fun == spell_null
		&& ch->pcdata->learned[sn])
        {
            sprintf(buf,"{g%-18s{c %-5d %-5d",
              skill_table[sn].name,
              skill_table[sn].remort_only,
              skill_table[sn].rating[ch->class]);
	    add_buf(output,buf);
            if (++col % 2 == 0)
		add_buf(output,"{c\n\r");
        }

        if (skill_table[sn].rating[ch->class] > 0
		&&  skill_table[sn].spell_fun == spell_null
		&& !ch->pcdata->learned[sn])
        {
            sprintf(buf,"{c%-18s %-5d %-5d",
              skill_table[sn].name,
              skill_table[sn].remort_only,
              skill_table[sn].rating[ch->class]);
	    add_buf(output,buf);
            if (++col % 2 == 0)
		add_buf(output,"{c\n\r");
        }

    }
    if (col % 2 != 0)
	add_buf(output,"{c\n\r");
    page_to_char( buf_string(output), ch );
    free_buf(output);

	return;
#endif
}

void do_wvlist(CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];
    int sn = 0;
	int col;
	int num_weaves;
    	BUFFER *output;
	struct sort_skill_struct sort_skill[MAX_SKILL];
	num_weaves=0;
    	output = new_buf();
	

    if (IS_NPC(ch))
	return;

	col = 0;

	add_buf(output,"\n\rWeaves that you have learned will show in green letters.\n\r\n\r");

	add_buf(output,"be able to be taught these weaves depending on how many times you\n\r");
	add_buf(output,"have been reborn, how many trains you have, and if you have the\n\r");
	add_buf(output,"pre-requisite weaves.\n\r\n\r");

	add_buf(output,"You may see the percent you have learned in a weave by typing Practice.\n\r\n\r");

    add_buf(output,"\n\rSkill Name         Lives Cost Skill Name         Lives Cost \n\r\n\r");
    for (sn = 0; sn < MAX_SKILL; sn++)
    {
        if (skill_table[sn].name == NULL)
            break;

        if (skill_table[sn].rating[ch->class] > 0
		&&  skill_table[sn].spell_fun != spell_null)
        {
		sort_skill[num_weaves].name = skill_table[sn].name;
		sort_skill[num_weaves].remort_only = skill_table[sn].remort_only;
		sort_skill[num_weaves].rating = skill_table[sn].rating[ch->class];
		sort_skill[num_weaves].learned = ch->pcdata->learned[sn];
	    num_weaves++;
        }


    }
	qsort(sort_skill,num_weaves,sizeof(struct sort_skill_struct),sort_skill_by_alpha);
    for (sn = 0; sn < num_weaves; sn++)
    {

            sprintf(buf,"%s%-18s{c %-5d %-5d",
	      sort_skill[sn].learned?"{g":"{c",
              sort_skill[sn].name,
              sort_skill[sn].remort_only,
              sort_skill[sn].rating);
	    add_buf(output,buf);
            if (++col % 2 == 0)
		add_buf(output,"{c\n\r");

    }
    if (col % 2 != 0)
		add_buf(output,"{c\n\r");

    page_to_char( buf_string(output), ch );
    free_buf(output);
	return;
}
